﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Contabilidad;
using System.Data;


namespace Azteca.Web.Controllers.Contabilidad
{
    [Route("api/contabilidad/cfd-certificados")]
    public class CFDCertificadosController : CatalogController<CFDCertificadoFacade, CFDCertificadoService, CFDCertificadoInfo>
    {
        public CFDCertificadosController()
            : base(new CFDCertificadoFacade())
        {

        }

        [HttpGet]
        [Route("vigencias")]
        public DataTable LoadVigencias(int idEmpresa)
        {
            try
            {
                DataTable dtResult = Facade.LoadVigencias(SessionID, idEmpresa);
                return dtResult;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
        }

    }
}