﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Contabilidad;
using System.Data;


namespace Azteca.Web.Controllers.Contabilidad
{
    [Route("api/contabilidad/cfdseries")]
    public class CFDSeriesController : CatalogController<SerieFiscalFacade, SerieFiscalService, SerieFiscalInfo>
    {
        public CFDSeriesController()
            :base(new SerieFiscalFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadList(int IdEmpresa)
        {
            DataTable dtRet = new DataTable();

            try
            {
                SerieFiscalFacade Facade = new SerieFiscalFacade();
                dtRet = Facade.LoadList(SessionID, IdEmpresa);
            }
            catch (Exception ex)
            {
                HandleException("Mensaje de error", ex);
            }
            return dtRet;
        }

    }
}