﻿using Azteca.Business.Contabilidad;
using Azteca.Kernel.Search;
using Azteca.Web.Controllers.Kernel;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Onili2Web.Controllers.Accounting
{

    [Route("api/contabilidad/cancelaciones")]
    public class CancelacionSolicitudController : BaseController
    {

        [HttpPost]
        [Route("search")]
        public SearchResult Search(int idBranch, [FromBody] SearchRequest request)
        {
            try
            {
                SearchResult Result = new SearchResult();
                if (request != null)
                {
                    int pageIndex = 0;
                    if (request.Paged) pageIndex = request.PageIndex + 1;//Search manager inicia la paginación desde 1, los view desde 0
                                                                         //
                    CancelacionSolicitudFacade Facade = new CancelacionSolicitudFacade();
                    Result.TotalRows = Facade.GetTotalRecords(this.SessionID, idBranch, request.Conditions);
                    Result.Rows = Facade.Search(this.SessionID, idBranch, request.Conditions, request.Order, pageIndex, request.PageSize);
                }
                else
                {
                    CancelacionSolicitudFacade Facade = new CancelacionSolicitudFacade();
                    Result.TotalRows = Facade.GetTotalRecords(this.SessionID, idBranch, null);
                    Result.Rows = Facade.Search(this.SessionID, idBranch, null, null, 1, 20);
                }
                return Result;
            }
            catch (Exception ex)
            {
                HandleException("Error al ejecutar la búsqueda.", ex);
                return null;
            }
        }


        [HttpPost]
        [Route("download-peticion-pendiente")]
        public bool DownloadPeticionesPendientes(int idCompany)
        {
            try
            {
                CancelacionSolicitudFacade Fac = new CancelacionSolicitudFacade();
                Fac.DownloadPeticionesPendientes(this.SessionID, idCompany);
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                
            }
            return false;
        }

        [HttpPost]
        [Route("download-peticion-pendiente-async")]
        public string DownloaPeticionesPendientesAsync(int idCompany)
        {
            try
            {
                CancelacionSolicitudFacade Fac = new CancelacionSolicitudFacade();
                Fac.DownloadPeticionesPendientesAsync(this.SessionID, idCompany);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpPost]
        [Route("aceptar-rechazar")]
        public bool AceptarRechazarSolicitud(int idSucursal, bool aceptar, int idCancelacionSolicitud)
        {
            try
            {
                CancelacionSolicitudFacade Fac = new CancelacionSolicitudFacade();
                Fac.AceptarRechazarSolicitud(this.SessionID, idSucursal, aceptar, idCancelacionSolicitud);
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return false;
        }

    }
}
