﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Contabilidad;

namespace Azteca.Web.Controllers.Contabilidad
{
    [Route("api/contabilidad/comprobante-cancelacion")]
    public class ComprobanteCancelacionController: DocumentController<ComprobanteCancelacionInfo, ComprobanteCancelacionDetail, ComprobanteCancelacionService, ComprobanteCancelacionFacade>
    {
        public ComprobanteCancelacionController()
            :base(new ComprobanteCancelacionFacade())
        {

        }

        [HttpPost]
        [Route("evaluar-proceso")]
        public bool EvaluarProceso(string idComprobanteCancelacion)
        {
            try
            {
                Facade.EvaluarProceso(this.SessionID, idComprobanteCancelacion);
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return false;
        }

        [HttpGet]
        [Route("propage-event")]
        public bool PropageEvent(int identity)
        {
            try
            {
                Azteca.Kernel.Notification.Broadcast.PropageAction(identity);
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return false;
        }

    }
}
