﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Contabilidad;
using System.Data;


namespace Azteca.Web.Controllers.Contabilidad
{
    [Route("api/contabilidad/contribuyentes")]
    public class ContribuyentesController : CatalogController<ContribuyenteFacade, ContribuyenteService, ContribuyenteInfo>
    {
        public ContribuyentesController()
            :base(new ContribuyenteFacade())
        {

        }
		
        [HttpGet]
        [Route("consultar-rfc-inscrito")]
        public bool ConsultarRfcInscrito(int idContribuyente)
        {
            try
            {
                Facade = new ContribuyenteFacade();
                return Facade.ConsultaRfcInscrito(this.SessionID, idContribuyente);
            }
            catch(Exception ex)
            {
                HandleException("Mensaje de error", ex);
                return false;
            }
        }

        [HttpGet]
        [Route("in-lista-negra-efo")]
        public bool ConsultarRfcInscrito(string RFC, int IdEmpresa)
        {
            try
            {
                Facade = new ContribuyenteFacade();
                return Facade.InListaNegraEFO(this.SessionID, RFC, IdEmpresa);
            }
            catch (Exception ex)
            {
                HandleException("Mensaje de error", ex);
                return false;
            }
        }

        [HttpGet]
        [Route("load-usos-cfdi")]
        public DataTable LoadList(int IdEmpresa)
        {
            DataTable dtRet = new DataTable();

            try
            {
                ContribuyenteFacade Facade = new ContribuyenteFacade();
                dtRet = Facade.LoadUsosCFDI(SessionID, IdEmpresa);
            }
            catch (Exception ex)
            {
                HandleException("Mensaje de error", ex);
            }
            return dtRet;
        }

    }
}