﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Contabilidad;
using System.Data;
using Azteca.Kernel.Security;

namespace Azteca.Web.Controllers.Contabilidad
{
    [Route("api/contabilidad/cuentas-bancarias")]
    public class CuentasBancariasController : CatalogController<CuentaBancariaFacade, CuentaBancariaService, CuentaBancariaInfo>
    {
        public CuentasBancariasController()
            :base(new CuentaBancariaFacade())
        {

        }

        [HttpGet]
        [Route("load-list-by-user")]
        public DataTable LoadListByUser(int IdSucursal)
        {
            {
                DataTable dtRet = new DataTable();
                try
                {                    
                    dtRet = Facade.LoadListByUser(SessionID, IdSucursal);
                }
                catch (Exception ex)
                {
                    HandleException(ex);
                }
                return dtRet;
            }
        }

        [HttpGet]
        [Route("members")]
        public List<UsuarioItem> GetMembers(int idCuentaBancaria)
        {
            try
            {
                List<UsuarioItem> Users = Azteca.Kernel.Common.DataTableUtils.ToList<UsuarioItem>(Facade.LoadAccesos(SessionID, idCuentaBancaria));
                return Users;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
        }

        [HttpPost]
        [Route("add-members")]
        public void AddMembers(int idCuentaBancaria, [FromBody] List<UsuarioItem> users)
        {
            try
            {
                users.ForEach(user =>
                {
                    Facade.InsertarAcceso(SessionID, idCuentaBancaria, user.ID);
                });
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }

        [HttpDelete]
        [Route("remove-member")]
        public void DeleteMember(int idCuentaBancaria, int idUser)
        {
            try
            {
                Facade.RemoverAcceso(SessionID, idCuentaBancaria, idUser);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }



    }
}