﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Business.Contabilidad;
using System.Data;

namespace Azteca.Web.Controllers.Contabilidad
{
    [Route("api/contabilidad/cuentas")]
    public class CuentasController : Azteca.Web.Controllers.Kernel.HierarchyController<CuentaFacade, CuentaService, CuentaInfo>
    {
        public CuentasController()
            :base(new CuentaFacade())
        {

        }

        [HttpGet]
        [Route("load-tipos")]
        public DataTable LoadList(int IdEmpresa)
        {
            DataTable dtRet = new DataTable();

            try
            {
                CuentaFacade Facade = new CuentaFacade();
                dtRet = Facade.CargarTipos(SessionID, IdEmpresa);
            }
            catch (Exception ex)
            {
                HandleException("Mensaje de error", ex);
            }
            return dtRet;
        }

    }
}
