﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Contabilidad;
using System.Data;


namespace Azteca.Web.Controllers.Contabilidad
{
    [Route("api/contabilidad/ejercicios-tipos")]
    public class EjerciciosTiposController : CatalogController<EjercicioTipoFacade, EjercicioTipoService, EjercicioTipoInfo>
    {
        public EjerciciosTiposController()
            :base(new EjercicioTipoFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadList(int IdSucursal)
        {
            DataTable dtRet = new DataTable();

            try
            {
                dtRet = Facade.LoadList(SessionID, IdSucursal);
            }
            catch (Exception ex)
            {
                HandleException("Mensaje de error", ex);
            }
            return dtRet;
        }

    }
}