﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Contabilidad;
using System.Data;


namespace Azteca.Web.Controllers.Contabilidad
{
    [Route("api/contabilidad/formas-pago")]
    public class FormasPagoController : CatalogController<FormaPagoFacade, FormaPagoService, FormaPagoInfo>
    {
        public FormasPagoController()
            :base(new FormaPagoFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadList(int idSucursal)
        {
            DataTable dtRet = new DataTable();

            try
            {
                FormaPagoFacade Facade = new FormaPagoFacade();
                dtRet = Facade.LoadList(SessionID, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar las Formas de Pago.", ex);
            }
            return dtRet;
        }

        /*
        [HttpGet]
        [Route("action-name")]
        public void SampleMethod(int arg)
        {
            try
            {
                
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
        }
		*/

    }
}