﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Web.Controllers.Contabilidad;
using System.Data;
using Azteca.Business.Contabilidad;
using Azteca.Kernel.Business;

namespace Azteca.Web.Controllers.Contabilidad
{
    [Route("api/contabilidad/lista-negra")]
    public class ListaNegraController : CatalogController<ListaNegraFacade, ListaNegraService, ListaNegraInfo>
    {
        public ListaNegraController()
            : base(new ListaNegraFacade())
        {

        }

        [HttpPost]
        [Route("lista-negra-file")]
        public bool ListaNegraFromFile(int idEmpresa,int idSucursal,[FromBody] FileInfo file)
        {
            try
            {
                string content = System.Text.Encoding.UTF8.GetString(file.Content);
                Facade.ListaNegraFromFile(SessionID, content, idEmpresa, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return false;
            }
            return true;


        }

        [HttpPost]
        [Route("permitir-efo")]
        public bool PermitirEFO(int IdListaNegra, int IdUsuario, int IdEmpresa, bool Status)
        {
            try
            {
                Facade.PermitirEFO(SessionID, IdListaNegra, IdUsuario, IdEmpresa, Status);
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return false;
            }
            return true;
        }


        [HttpPost]
        [Route("eliminar-firmas")]
        public void EliminarFirmas()
        {
            try
            {
                Facade.EliminarFirmas(SessionID);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }
    }
}