﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Contabilidad;

namespace Azteca.Web.Controllers.Contabilidad
{
    [Route("api/contabilidad/notas")]
    public class NotasController: DocumentController<NotaInfo, NotaDetail, NotaService, NotaFacade>
    {
        public NotasController()
            :base(new NotaFacade())
        {

        }     
        

        [HttpGet]
        [Route("listar-comprobantes")]
        public List<NotaRelaciones> ListarComprobantes(string idNota)
        {
            List<NotaRelaciones> dtRet = null;

            try
            {
                NotaFacade Facade = new NotaFacade();
                dtRet = Facade.ListarComprobantes(SessionID, idNota);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener comprobantes", ex);
            }
            return dtRet;
        }

        [HttpPost]
        [Route("agregar-comprobante")]
        public void AgregarComprobante(string idNota, string idComprobanteFiscal, string uuid, decimal total, string serie, long folio)
        {
            try
            {
                NotaFacade Facade = new NotaFacade();
                Facade.AgregarComprobante(SessionID, idNota, idComprobanteFiscal, uuid, total, serie, folio);
            }
            catch(Exception ex)
            {
                HandleException("Error al guardar comprobante", ex);
            }
        }

        [HttpDelete]
        [Route("eliminar-comprobante")]
        public void EliminarComprobante(int idNotaRelacion)
        {
            try
            {
                NotaFacade Facade = new NotaFacade();
                Facade.EliminarComprobante(SessionID,idNotaRelacion);
            }
            catch(Exception ex)
            {
                HandleException("Error al eliminar comprobante", ex);
            }
        }


        [HttpPost]
        [Route("update-nota")]
        public NotaInfo UpdateNota([FromBody] NotaInfo document)
        {
            try
            {
                NotaInfo RetInfo = Facade.Update(SessionID, document);
                return RetInfo;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
        }
    }
}
