﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Contabilidad;

namespace Azteca.Web.Controllers.Contabilidad
{
    [Route("api/contabilidad/periodos")]
    public class PeriodosController: DocumentController<PeriodoInfo, PeriodoDetail, PeriodoService, PeriodoFacade>
    {
        public PeriodosController()
            :base(new PeriodoFacade())
        {

        }

        [HttpGet]
        [Route("search-periodos")]
        public List<PeriodoItem > SearchKeyword(int idBranch, string keyword)
        {
            List<PeriodoItem> dtRet = null;
            try
            {
                PeriodoFacade Facade = new PeriodoFacade();
                dtRet = Facade.SearchPeriodos(SessionID, idBranch, keyword);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener la lista de periodos", ex);
            }
            return dtRet;
        }


    }
}
