﻿using Azteca.Business.Contabilidad;
using Azteca.Kernel.Search;
using Azteca.Web.Controllers.Kernel;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Azteca.Web.Controllers.Contabilidad
{

    [Route("api/accounting/poliza-perfil")]
    public class PolizasPerfilesController : CatalogController<PolizaPerfilFacade, PolizaPerfilService, PolizaPerfilInfo>
    {

        [HttpPost]
        [Route("search-perfil-by-usuario")]
        public SearchResult SearchPerfiByUsuario(int idBranch, [FromBody] SearchRequest request)
        {
            try
            {
                SearchResult Result = new SearchResult();
                if (request != null)
                {
                    int pageIndex = 0;
                    if (request.Paged) pageIndex = request.PageIndex + 1;//Search manager inicia la paginación desde 1, los view desde 0
                                                                         //
                    Facade = new PolizaPerfilFacade();
                    Result.TotalRows = Facade.GetTotalRecordsPerfilByUsaurio(this.SessionID, idBranch, request.Conditions);
                    Result.Rows = Facade.SearchPerfilByUsaurio(this.SessionID, idBranch, request.Conditions, request.Order, pageIndex, request.PageSize);
                }
                else
                {
                    Facade = new PolizaPerfilFacade();
                    Result.TotalRows = Facade.GetTotalRecordsPerfilByUsaurio(this.SessionID, idBranch, null);
                    Result.Rows = Facade.SearchPerfilByUsaurio(this.SessionID, idBranch, null, null, 1, 20);
                }
                return Result;
            }
            catch (Exception ex)
            {
                HandleException("Error al ejecutar la búsqueda.", ex);
                return null;
            }
        }

    }
}
