﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Contabilidad;
using System.Data;


namespace Azteca.Web.Controllers.Contabilidad
{
    [Route("api/contabilidad/retenciones")]
    public class RetencionesController : CatalogController<RetencionFacade, RetencionService, RetencionInfo>
    {
        public RetencionesController()
            :base(new RetencionFacade())
        {

        }

        [HttpGet]
        [Route("load-tipos")]
        public DataTable LoadList(int IdEmpresa)
        {
            DataTable dtRet = new DataTable();

            try
            {
                RetencionFacade Facade = new RetencionFacade();
                dtRet = Facade.LoadTipos(SessionID, IdEmpresa);
            }
            catch (Exception ex)
            {
                HandleException("Mensaje de error", ex);
            }
            return dtRet;
        }

    }
}