﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Contabilidad;
using System.Data;


namespace Azteca.Web.Controllers.Contabilidad
{
    [Route("api/contabilidad/riesgos-puestos")]
    public class RiesgosPuestosController : CatalogController<RiesgoPuestoFacade, RiesgoPuestoService, RiesgoPuestoInfo>
    {
        public RiesgosPuestosController()
            :base(new RiesgoPuestoFacade())
        {

        }

		
        [HttpGet]
        [Route("get-riesgo-puesto-cbo")]
        public DataTable GetRiesgoPuestoCBO(int idSucursal)
        {
            try
            {
                Facade = new RiesgoPuestoFacade();
                return Facade.GetRiesgoPuestoCBO(this.SessionID, idSucursal);
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
            return null;
        }
		

    }
}