﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Credito;

namespace Azteca.Web.Controllers.Credito
{
    [Route("api/credito/anticipos")]
    public class AnticiposController: DocumentController<AnticipoInfo, AnticipoDetail, AnticipoService, AnticipoFacade>
    {
        public AnticiposController()
            :base(new AnticipoFacade())
        {

        }

        [HttpGet]
        [Route("search-anticipos")]
        public List<AnticipoItem> SearchKeyword(int idBranch, string keyword)
        {
            List<AnticipoItem> dtRet = null;
            try
            {
                AnticipoFacade Facade = new AnticipoFacade();
                dtRet = Facade.SearchAnticipos(SessionID, idBranch, keyword);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener la lista de anticipos", ex);
            }
            return dtRet;
        }

    }
}
