﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Credito;
using System.Data;


namespace Azteca.Web.Controllers.Credito
{
    [Route("api/credito/cobros-tipos")]
    public class CobrosTiposController : CatalogController<CobroTipoFacade, CobroTipoService, CobroTipoInfo>
    {
        public CobrosTiposController()
            :base(new CobroTipoFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadList(int idBranch, bool todos)
        {
            DataTable dtRet = new DataTable();
            try
            {
                CobroTipoFacade Facade = new CobroTipoFacade();
                dtRet = Facade.LoadList(SessionID,idBranch, todos);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return dtRet;
        }


    }
}
