﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Credito;
using System.Data;
using Azteca.Kernel.General;

namespace Azteca.Web.Controllers.Credito
{
    [Route("api/credito/conceptos")]
    public class ConceptosController : CatalogController<ConceptoFacade, ConceptoService, ConceptoInfo>
    {
        public ConceptosController()
            : base(new ConceptoFacade())
        {

        }

        [HttpGet]
        [Route("get-conceptos")]
        public DataTable GetConceptos()
        {
            DataTable dtRet = new DataTable();

            try
            {
                ConceptoFacade Facade = new ConceptoFacade();
                dtRet = Facade.GetConceptos(SessionID);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar los conceptos.", ex);
            }
            return dtRet;
        }
    }
}