﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Credito;
using System.Data;

namespace Azteca.Web.Controllers.Credito
{
    [Route("api/credito/depositos")]
    public class DepositosController: DocumentController<DepositoInfo, DepositoDetail, DepositoService, DepositoFacade>
    {
        public DepositosController()
            :base(new DepositoFacade())
        {

        }

        [HttpGet]
        [Route("search-depositos")]
        public List<DepositoItem> SearchKeyword(int idBranch, string keyword)
        {
            List<DepositoItem> dtRet = null;
            try
            {                
                dtRet = Facade.SearchDepositos(SessionID, idBranch, keyword);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener la lista de depositos", ex);
            }
            return dtRet;
        }

    }
}
