﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Credito;
using System.Data;


namespace Azteca.Web.Controllers.Credito
{
    [Route("api/credito/depositos-tipos")]
    public class DepositosTiposController : CatalogController<DepositoTipoFacade, DepositoTipoService, DepositoTipoInfo>
    {
        public DepositosTiposController()
            :base(new DepositoTipoFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadList(int idBranch)
        {
            DataTable dtRet = new DataTable();
            try
            {
                dtRet = Facade.LoadList(SessionID, idBranch);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return dtRet;
        }


    }
}