﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Credito;
using System.Data;
using Azteca.Kernel.General;

namespace Azteca.Web.Controllers.Credito
{
    [Route("api/credito/deudores")]
    public class DeudoresController : CatalogController<DeudorFacade, DeudorService, DeudorInfo>
    {
        public DeudoresController()
            :base(new DeudorFacade())
        {

        }

        [HttpGet]
        [Route("load-bloqueados")]
        public List<DeudorItem> LoadBloqueados(int idEmpresa, DateTime fecha)
        {

            List<DeudorItem> vRet = null;
            try
            {
                DeudorFacade Facade = new DeudorFacade();
                vRet = Facade.LoadBloqueados(SessionID, idEmpresa, fecha);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener la lista de empleados bloqueados", ex);
            }

            return vRet;
        }

        [HttpPost]
        [Route("desbloquear")]
        public void Reprocesar(int IdDeudor, DateTime Fecha)
        {
            try
            {
                Facade.Desbloquear(SessionID, IdDeudor, Fecha);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }

    }
}