﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Credito;

namespace Azteca.Web.Controllers.Credito
{
    [Route("api/credito/facturas")]
    public class FacturasController: DocumentController<FacturaInfo, FacturaDetail, FacturaService, FacturaFacade>
    {
        public FacturasController()
            :base(new FacturaFacade())
        {

        }

        [HttpGet]
        [Route("search-facturas")]
        public List<FacturaItem> SearchKeyword(int idBranch, string keyword, int idDeudor, int idGrupoDeudor)
        {
            List<FacturaItem> dtRet = null;
            try
            {
                FacturaFacade Facade = new FacturaFacade();
                
                dtRet = Facade.SearchFacturas(SessionID, idBranch, keyword, idDeudor, idGrupoDeudor);
                
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener la lista de facturas", ex);
            }
            return dtRet;
        }


    }
}
