﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Credito;
using System.Data;


namespace Azteca.Web.Controllers.Credito
{
    [Route("api/credito/formaspago")]
    public class FormasPagoController : CatalogController<FormaPagoFacade, FormaPagoService, FormaPagoInfo>
    {
        public FormasPagoController()
            :base(new FormaPagoFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadList(int idSucursal)
        {
            DataTable dtRet = new DataTable();

            try
            {
                FormaPagoFacade Facade = new FormaPagoFacade();
                dtRet = Facade.LoadList(SessionID, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar las Formas de Pago.", ex);
            }
            return dtRet;
        }

    }
}