﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Credito;
using System.Data;


namespace Azteca.Web.Controllers.Credito
{
    [Route("api/credito/grupos-deudores")]
    public class GruposDeudoresController : CatalogController<GrupoDeudorFacade, GrupoDeudorService, GrupoDeudorInfo>
    {
        public GruposDeudoresController()
            :base(new GrupoDeudorFacade())
        {

        }

        [HttpGet]
        [Route("get-grupo-deudor")]
        public DataTable GetGrupoDeudor()
        {
            DataTable dtRet = new DataTable();

            try
            {
                GrupoDeudorFacade Facade = new GrupoDeudorFacade();
                dtRet = Facade.GetGrupoDeudor(SessionID);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar los grupo deudores.", ex);
            }
            return dtRet;
        }

        [HttpGet]
        [Route("list-deudores")]
        public List<DeudorItem> DeudoresList(int idGrupoDeudor)
        {
            List<DeudorItem> lstRet = new List<DeudorItem>();
            try
            {
                GrupoDeudorFacade facade = new GrupoDeudorFacade();
                lstRet = facade.DeudoresLST(SessionID, idGrupoDeudor);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar los deudores del grupo deudor.", ex);
            }
            return lstRet;
        }

    }
}