﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Credito;
using System.Data;


namespace Azteca.Web.Controllers.Credito
{
    [Route("api/credito/notas-tipos")]
    public class NotasTiposController : CatalogController<NotaTipoFacade, NotaTipoService, NotaTipoInfo>
    {
        public NotasTiposController()
            :base(new NotaTipoFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadList(int IdSucursal)
        {
            {
                DataTable dtRet = new DataTable();
                try
                {
                    NotaTipoFacade Facade = new NotaTipoFacade();
                    dtRet = Facade.LoadList(SessionID, IdSucursal);
                }
                catch (Exception ex)
                {
                    HandleException(ex);
                }
                return dtRet;
            }
        }


        [HttpGet]
        [Route("load-conceptos-list")]
        public DataTable LoadConceptosList(int IdSucursal, int idNotaTipo)
        {
            {
                DataTable dtRet = new DataTable();
                try
                {
                    NotaTipoFacade Facade = new NotaTipoFacade();
                    dtRet = Facade.LoadConceptosList(SessionID, IdSucursal,idNotaTipo);
                }
                catch (Exception ex)
                {
                    HandleException(ex);
                }
                return dtRet;
            }
        }


    }
}