﻿using Azteca.Web.Controllers.Kernel;
using ConsorcioAga.Custom.ClientService;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;

namespace Azteca.Web.Controllers.Client
{

    [Route("api/custom/aga/client-service")]
    public class ClientServiceController : BaseController
    {
        
        [HttpGet]
        [Route("load-tareas")]
        public List<JobClientServiceInfo> LoadTareas(string deviceName, string ipAddress)
        {
            try
            {
                ConsorcioAga.Custom.ClientService.ClientFacade Fac = new ConsorcioAga.Custom.ClientService.ClientFacade();
                return Fac.LoadTareas(this.SessionID, deviceName);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener listado de tareas", ex);
            }
            return null;
        }

        [HttpGet]
        [Route("enqueue-comprobante")]
        public bool EnqueueComprobante(string serie, int folio, int idServidorSmpt, string correo)
        {
            try
            {
                ConsorcioAga.Custom.ClientService.ClientFacade Fac = new ConsorcioAga.Custom.ClientService.ClientFacade();
                Fac.EnqueueComprobante(this.SessionID, serie, folio, idServidorSmpt, correo);
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return false;
            }
        }

        [HttpPost]
        [Route("update-job")]
        public bool UpdateJob([FromBody] JobClientServiceInfo info)
        {
            try
            {
                ConsorcioAga.Custom.ClientService.ClientFacade Fac = new ConsorcioAga.Custom.ClientService.ClientFacade();
                Fac.UpdateJob(this.SessionID, info);
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return false;
            }
        }

        [HttpGet]
        [Route("test-update-job")]
        public bool TestUpdateJob(string deviceName, string ipAddress)
        {
            try
            {
                ConsorcioAga.Custom.ClientService.ClientFacade Fac = new ConsorcioAga.Custom.ClientService.ClientFacade();
                List<JobClientServiceInfo> tasks = Fac.LoadTareas(this.SessionID, deviceName);
                foreach (JobClientServiceInfo task in tasks)
                {
                    Fac.UpdateJob(this.SessionID, task);
                }   
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return false;
            }
        }

    }
}
