﻿using Azteca.Kernel.Search;
using Azteca.Web.Controllers.Kernel;
using ConsorcioAga.Custom.Credito;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Azteca.Web.Controllers.Credito
{

    [Route("api/custom/aga/credito/cobranza")]
    public class CobranzaController : BaseController
    {

        [HttpPost]
        [Route("search-jobs")]
        public SearchResult SearchJobs(int idBranch, [FromBody] SearchRequest request)
        {
            try
            {
                SearchResult Result = new SearchResult();
                if (request != null)
                {
                    int pageIndex = 0;
                    if (request.Paged) pageIndex = request.PageIndex + 1;//Search manager inicia la paginación desde 1, los view desde 0
                                                                         //
                    ConsorcioAga.Custom.Credito.CobranzaFacade Facade = new ConsorcioAga.Custom.Credito.CobranzaFacade();
                    Result.TotalRows = Facade.GetTotalRecorsJobs(this.SessionID, idBranch, request.Conditions);
                    Result.Rows = Facade.SearchJobs(this.SessionID, idBranch, request.Conditions, request.Order, pageIndex, request.PageSize);
                }
                else
                {
                    ConsorcioAga.Custom.Credito.CobranzaFacade Facade = new ConsorcioAga.Custom.Credito.CobranzaFacade();
                    Result.TotalRows = Facade.GetTotalRecorsJobs(this.SessionID, idBranch, null);
                    Result.Rows = Facade.SearchJobs(this.SessionID, idBranch, null, null, 1, 20);
                }
                return Result;
            }
            catch (Exception ex)
            {
                HandleException("Error al ejecutar la búsqueda.", ex);
                return null;
            }
        }

        [HttpPost]
        [Route("update-cobranza-formato")]
        public bool UpdateCobranzaFormato([FromBody] CobranzaFormatoInfo info)
        {
            try
            {
                CobranzaFacade CobranzaFac = new CobranzaFacade();
                CobranzaFac.UpdateCobranza(this.SessionID, info);
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return false;
        }

    }
}
