﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Kernel.Search;

namespace Azteca.Web.Controllers.Credito
{
    [Route("api/custom/aga/credito/cuentasPorCobrar")]
    public class CuentasPorCobrarController : BaseController
    {

        [HttpGet]
        [Route("importar-ventas")]
        public void facturar(string codigoSucursal, int idSucursal, DateTime fechaCobro, string origen)
        {
            try
            {
                ConsorcioAga.Custom.Pixcua.PedidoFacade PedidoFac = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                //PedidoFac.ImportarVentas(SessionID, fechaCobro, codigoSucursal, idSucursal, origen);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }

        [HttpGet]
        [Route("importar-saldos")]
        public void ImportarSaldos(int IdEmpresa)
        {
            try
            {
                ConsorcioAga.Custom.Pixcua.PedidoFacade PedidoFac = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                PedidoFac.ImportarSaldos(SessionID, IdEmpresa);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }

        [HttpPost]
        [Route("importar-saldos-recalcular")]
        public void ImportarSaldosRecalcular(int idEmpresa)
        {
            try
            {
                ConsorcioAga.Custom.Pixcua.PedidoFacade PedidoFac = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                PedidoFac.ImportarSaldosRecalcular(SessionID, idEmpresa);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }


        [HttpPost]
        [Route("search-pedidos-cliente")]
        public SearchResult SearchPedidoCliente(int idBranch, [FromBody] SearchRequest request)
        {
            try
            {
                SearchResult Result = new SearchResult();
                if (request != null)
                {
                    int pageIndex = 0;
                    if (request.Paged) pageIndex = request.PageIndex + 1;//Search manager inicia la paginación desde 1, los view desde 0
                                                                         //
                    ConsorcioAga.Custom.Pixcua.PedidoFacade Facade = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                    Result.TotalRows = Facade.GetTotalRecordsPedidoCliente(this.SessionID, idBranch, request.Conditions);
                    Result.Rows = Facade.SearchPedidoCliente(this.SessionID, idBranch, request.Conditions, request.Order, pageIndex, request.PageSize);
                }
                else
                {
                    ConsorcioAga.Custom.Pixcua.PedidoFacade Facade = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                    Result.TotalRows = Facade.GetTotalRecordsPedidoCliente(this.SessionID, idBranch, null);
                    Result.Rows = Facade.SearchPedidoCliente(this.SessionID, idBranch, null, null,1, 20);
                }
                return Result;
            }
            catch (Exception ex)
            {
                HandleException("Error al ejecutar la búsqueda.", ex);
                return null;
            }
        }

        [HttpPost]
        [Route("generar-cuenta-por-cobrar")]
        public bool GenerarCxCPedido(string idPedidoTit, int idSucursal, string codigoSucursal, string origen, bool refacturar)
        {
            try
            {
                ConsorcioAga.Custom.Pixcua.PedidoFacade Facade = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                Facade.GenerarCxCPedido(this.SessionID, idPedidoTit, codigoSucursal, idSucursal, origen, refacturar, false);

                return true;
            }
            catch (Exception ex)
            {
                HandleException("Error al ejecutar la búsqueda.", ex);
                return false;
            }
        }
        
        [HttpPost]
        [Route("generar-cuenta-por-cobrar-fecha")]
        public string  GenerarCxCPedido(string idPedidoTit, int idSucursal, string codigoSucursal, string origen, bool refacturar,string fecha)
        {
            try
            {
                ConsorcioAga.Custom.Pixcua.PedidoFacade Facade = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                Facade.GenerarCxCPedido(this.SessionID, idPedidoTit, codigoSucursal, idSucursal, origen, refacturar, false, DateTime.SpecifyKind(Convert.ToDateTime(fecha), DateTimeKind.Utc));

                //Se regresa la nueva referencia de la nueva cuenta por cobrar
                return Facade.GetReferencia(this.SessionID,idPedidoTit);
            }
            catch (Exception ex)
            {
                HandleException("Error: al generar la cuenta por cobrar.", ex);
                return "Error: al generar la cuenta por cobrar. "+ ex.Message;
            }
        }
        
        [HttpGet]
        [Route("generar-impresion")]
        public byte[] GenerarImpresion(string idComprobanteTit)
        {
            try
            {
                ConsorcioAga.Custom.Pixcua.PedidoFacade Facade = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                return Facade.GenerarImpresion(this.SessionID, idComprobanteTit);
            }
            catch (Exception ex)
            {
                HandleException("Error al generar la impresión del pedido.", ex);
            }
            return null;
        }

        [HttpGet]
        [Route("generar-impresion-pedido")]
        public byte[] GenerarImpresionByPedido(string idPedidoTit, DateTime fecha, string origen)
        {
            try
            {
                ConsorcioAga.Custom.Pixcua.PedidoFacade Facade = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                return Facade.GenerarImpresionByPedido(this.SessionID, idPedidoTit, fecha, origen);
            }
            catch (Exception ex)
            {
                HandleException("Error al generar la impresión del pedido.", ex);
            }
            return null;
        }


        [HttpGet]
        [Route("get-comprobante-xml")]
        public string GetPedidoComprobanteXml(string idPedidoTit, DateTime fecha, string origen)
        {
            try
            {
                ConsorcioAga.Custom.Pixcua.PedidoFacade Facade = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                return Facade.GetPedidoComprobanteXml(this.SessionID, idPedidoTit, fecha, origen);
            }
            catch (Exception ex)
            {
                HandleException("Error al generar la impresión del pedido.", ex);
            }
            return null;
        }

        [HttpPost]
        [Route("cancelar-cuenta-por-cobrar")]
        public bool CancelarCuentaPorCobrar(string idPedidoTit, DateTime fecha, string origen)
        {
            try
            {
                ConsorcioAga.Custom.Pixcua.PedidoFacade Facade = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                Facade.CancelarCuentaPorCobrar(this.SessionID, idPedidoTit, fecha, origen);
                return true;
            }
            catch (Exception ex)
            {
                HandleException("Error al cancelar la cuenta por cobrar.", ex);
            }
            return false;
        }

        [HttpPost]
        [Route("cancelar-cuenta-por-cobrar-refacturacion")]
        public bool CancelarCuentaPorCobrarRefacturacion(string idPedidoTit, DateTime fecha)
        {
            try
            {
                ConsorcioAga.Custom.Pixcua.PedidoFacade Facade = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                Facade.CancelarCuentaPorCobrarRefacturacion(this.SessionID, idPedidoTit, fecha);
                return true;
            }
            catch (Exception ex)
            {
                HandleException("Error al cancelar la cuenta por cobrar.", ex);
            }
            return false;
        }

        [HttpPost]
        [Route("cancelar-cuenta-por-cobrar-by-id")]
        public bool CancelarCuentaPorCobrarByID(string idCuentaPorCobrar)
        {
            try
            {
                ConsorcioAga.Custom.Pixcua.PedidoFacade Facade = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                Facade.CancelarCuentaPorCobrar(this.SessionID, idCuentaPorCobrar);
                return true;
            }
            catch (Exception ex)
            {
                HandleException("Error al cancelar la cuenta por cobrar.", ex);
            }
            return false;
        }

        [HttpPost]
        [Route("generar-abono")]
        public bool GenerarAbono(int idSucursal, string codigoSucursal, string idPedidoTit, DateTime fechaPedido, string origen, decimal abono, DateTime fechaAbono, string idCuentaPorCobrarTit)
        {
            try
            {
                ConsorcioAga.Custom.Pixcua.PedidoFacade Facade = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                Facade.GenerarAbono(this.SessionID, idSucursal, codigoSucursal, idPedidoTit, fechaPedido, origen, abono, fechaAbono, idCuentaPorCobrarTit);
                return true;
            }
            catch (Exception ex)
            {
                HandleException("Error al cancelar la cuenta por cobrar.", ex);
            }
            return false;
        }

        [HttpPost]
        [Route("desglosar-abonos")]
        public bool DesglosarAbonos()
        {
            try
            {
                ConsorcioAga.Custom.Pixcua.PedidoFacade Facade = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                Facade.DesglozarAbonos(SessionID);
                return true;
            }
            catch (Exception ex)
            {
                HandleException("Error al intentar desglozar los abonos de la cuenta por cobrar.", ex);
            }
            return false;
        }


        [HttpPost]
        [Route("generar-adenda")]
        public bool GenerarAdenda(string idPedidoTit, DateTime fecha, string origen)
        {
            try
            {
                ConsorcioAga.Custom.Pixcua.PedidoFacade Facade = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                Facade.RegenerarAdenda(this.SessionID, idPedidoTit, fecha, origen);
                return true;
            }
            catch (Exception ex)
            {
                HandleException("Error al generar la adenda.", ex);
            }
            return false;
        }


        [HttpGet]
        [Route("generar-cobranza")]
        public bool GenerarCobranza(int idSucursal, string idCuentaPorCobrarTit)
        {
            try
            {
                ConsorcioAga.Custom.Pixcua.PedidoFacade Facade = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                Facade.GenerarCobranza(this.SessionID, idSucursal, idCuentaPorCobrarTit);
                return true;
            }
            catch (Exception ex)
            {
                HandleException("Error al generar la cobranza", ex);
            }
            return false;
        }

        [HttpPost]
        [Route("sustituir")]
        public bool SustituirComprobante(string idPedidoTit, DateTime fechaPedido, string origen)
        {
            try
            {
                ConsorcioAga.Custom.Pixcua.PedidoFacade Facade = new ConsorcioAga.Custom.Pixcua.PedidoFacade();
                Facade.SustituirComprobante(this.SessionID, idPedidoTit, fechaPedido, origen);
                return true;
            }
            catch (Exception ex)
            {
                HandleException("Error al generar la cobranza", ex);
            }
            return false;
        }
    }

}