﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Azteca.Kernel.BPM;
using Azteca.Kernel.Queue;
using Azteca.Web.Controllers.Kernel;
using Azteca.Web.Controllers.Analytic;
using ConsorcioAga.Custom.Geomarketing;
using Microsoft.AspNetCore.Mvc;
using Azteca.Business.Analytic;
using System.Data;
using Azteca.Data;
using Newtonsoft.Json.Linq;
using Newtonsoft.Json;
using System.Globalization;

namespace Azteca.Web.Controllers.Analytic
{
    [Route("api/custom/aga/geomarketing/reporte")]
    public class ReporteController: BaseController
    {
        [HttpGet]
        [Route("generate-tableinfo")]
        public AsyncTaskInfo generatetableinfo(int idAsyncTask, int idReporTable)
        {
            AsyncTaskInfo resFinal = null;
            try
            {           
                AsyncTaskFacade AsyncTaskFac = new AsyncTaskFacade();
                resFinal = AsyncTaskFac.GetDetail(SessionID, idAsyncTask);                

                ReporteFacade facrepolocal = new ReporteFacade();
                resFinal =  facrepolocal.CustomizedCellsTableInfo(SessionID, resFinal, idReporTable);
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
            return resFinal;
        }



        [HttpGet]
        [Route("get-dias-habiles")]
        public string getdiashabiles()
        {
            string resFinal = null;
            try
            {
                ReporteFacade facrepolocal = new ReporteFacade();
                resFinal = facrepolocal.getDiasHabiles(SessionID);
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
            return resFinal;
        }


        [HttpPost]
        [Route("save-reporte-estadisticas")]
        public bool saveReporteEstadisticas(int IdRuta, string Fecha)
        {
            bool resultado = false;
            try
            {
                ReporteFacade facrepolocal = new ReporteFacade();
                facrepolocal.saveReporteEstadisticas(SessionID, IdRuta, Fecha);
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return false;
            }
            return resultado;
        }




    }
}
