﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Credito;
using System.Data;
using Azteca.Kernel.Security;
using Azteca.Kernel.Business;
using Azteca.Kernel.Queue;


namespace Azteca.Web.Controllers.Credito
{
    [Route("api/custom/aga/credito/mantenimientoCredito")]
    public class CreditoController: BaseController 
    {
        [HttpGet]
        [Route ("contribuyentes-repetidos-listar")]
        public List<ContribuyentesRfcMultiplicado > ListarContribuyentesRfcMultiplicado(int idEmpresa)
        {
            List<ContribuyentesRfcMultiplicado> dtRet = null;
            try
            {
                CreditoFacade Fac = new CreditoFacade();
                dtRet = Fac.ListarContribuyentesRfcMultiplicado(SessionID, idEmpresa);
            }
            catch(Exception ex)
            {
                HandleException("Error al obtener listado de contribuyentes", ex);
            }
            return dtRet;
        }

        [HttpGet]
        [Route("contribuyente-repetido")]
        public List<ContribuyenteRfcMultiplicado> ContribuyenteRfcMultiplicado(string rfc, int idEmpresa)
        {
            List<ContribuyenteRfcMultiplicado> dtRet = null;
            try
            {
                CreditoFacade Fac = new CreditoFacade();
                dtRet = Fac.ContribuyentesRfcMultiplicado(SessionID, rfc, idEmpresa);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener listado de contribuyentes", ex);
            }
            return dtRet;
        }

        [HttpPost]
        [Route("unificar-contribuyentes")]
        public void UnificarContribuyentes(int idContribuyente, int idEmpresa)
        {
            try
            {
                CreditoFacade Fac = new CreditoFacade();
                Fac.UnificarContribuyentes(SessionID, idContribuyente, idEmpresa);
            }
            catch(Exception ex)
            {
                HandleException(ex);
            }
        }

        [HttpGet]
        [Route("async-unificar-contribuyentes")]
        public AsyncTaskInfo AsyncUnificarContribuyentes(int idContribuyente, int idEmpresa)
        {
            AsyncTaskInfo ret = new AsyncTaskInfo();

            try
            {
                CreditoFacade Fac = new CreditoFacade();
                ret = Fac.AsyncUnificarContribuyentes(SessionID, idContribuyente, idEmpresa);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return ret;
        }


    }
}
