﻿using Azteca.Kernel.Security;
using Azteca.Web.Controllers.Kernel;
using Contpaq.Custom.ADD;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Azteca.Web.Controllers.Credito
{

    [Route("api/custom/contpaq/poliza-comprobante")]
    public class PolizaComprobanteController : BaseController
    {

        [HttpPost]
        [Route("importar-comprobante")]
        public bool ImportarComprobante(string idPolizaTit, DateTime fechaPoliza, string origen, int idCompany)
        {
            try
            {
                Contpaq.Custom.PolizaComprobanteFacade PolizaComprobanteFac = new Contpaq.Custom.PolizaComprobanteFacade();
                PolizaComprobanteFac.ImportarComprobante(this.SessionID, idPolizaTit, fechaPoliza, origen, idCompany);
                return true;
            }
            catch (Exception ex)
            {
                HandleException("Error al importar los comprobantes de la póliza.", ex);
            }
            return false;
        }

        [HttpPost]
        [Route("importar-cfdi")]
        public bool ImportarCfdi(string uuid, string origen, string comprobanteOrigen, string tipo, int idCompany)
        {
            try
            {
                Contpaq.Custom.PolizaComprobanteFacade PolizaComprobanteFac = new Contpaq.Custom.PolizaComprobanteFacade();
                PolizaComprobanteFac.ImportarComprobante(this.SessionID, uuid, origen, comprobanteOrigen, tipo, idCompany);
                return true;
            }
            catch (Exception ex)
            {
                HandleException("Error al importar el cfdi.", ex);
            }
            return false;
        }

        [HttpPost]
        [Route("update-asociacion")]
        public bool UpdateAsociacion(string guidEmpresa, [FromBody] List<Asociacion> referencia)
        {
            try
            {
                Contpaq.Custom.PolizaComprobanteFacade PolizaComprobanteFac = new Contpaq.Custom.PolizaComprobanteFacade();
                PolizaComprobanteFac.UpdatePolizaAsociacion(Azteca.Kernel.Server.SystemSession.SessionID, guidEmpresa, Newtonsoft.Json.JsonConvert.SerializeObject(referencia));
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return false;
        }

    }

}
