﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Distribucion;
using System.Data;

namespace Azteca.Web.Controllers.Distribucion
{
    [Route("api/distribution/cargas-fisicas")]
    public class CargasFisicasController: DocumentController<CargaFisicaInfo, CargaFisicaDetail, CargaFisicaService, CargaFisicaFacade>
    {
        public CargasFisicasController()
            :base(new CargaFisicaFacade())
        {

        }   
        
        [HttpGet("get-rutas-reparto")]
        public DataTable GetRutasReparto(int idSucursal, DateTimeOffset fechaIni, DateTimeOffset fechaFin, bool porCargar)
        {
            try
            {
                Facade = new CargaFisicaFacade();
                return Facade.GetRutasReparto(this.SessionID, idSucursal, fechaIni, fechaFin, porCargar);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpGet("get-carga-fisica-doctos")]
        public List<CargaFisicaDetail> GetCargaFisicaDocumentos(int idRutaReparto, DateTimeOffset fechaIni, DateTimeOffset fechaFin, bool porCargar)
        {
            try
            {
                Facade = new CargaFisicaFacade();
                return Facade.GetCargaFisicaDocumentos(this.SessionID, idRutaReparto, fechaIni, fechaFin, porCargar);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpPost("cargar-documentos")]
        public CargaFisicaInfo CargarDocumentos([FromBody] CargaFisicaInfo cargaFisica)
        {
            try
            {
                Facade = new CargaFisicaFacade();
                return Facade.CargarDocumento(this.SessionID, cargaFisica);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpPost("aplicar-carga-documento")]
        public CargaFisicaInfo AplicarCargaDocumento(string idDocumento, string origen)
        {
            try
            {
                Facade = new CargaFisicaFacade();
                return Facade.AplicarCargaDocumento(this.SessionID, idDocumento, origen);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpPost("cancelar-aplicar-carga-documento")]
        public CargaFisicaInfo CancelarAplicarCargaDocumento(string idDocumento, string origen)
        {
            try
            {
                Facade = new CargaFisicaFacade();
                return Facade.CancelarAplicarCargaDocumento(this.SessionID, idDocumento, origen);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

    }
}
