﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Distribucion;
using System.Data;
using Azteca.Kernel.Business;

namespace Azteca.Web.Controllers.Distribucion
{
    [Route("api/distribucion/celulas")]
    public class CelulasController : CatalogController<CelulaFacade, CelulaService, CelulaInfo>
    {
        public CelulasController()
            :base(new CelulaFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadList(int idSucursal)
        {
            DataTable dtRet = new DataTable();

            try
            {                
                dtRet = Facade.LoadList(SessionID, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar la lista de celulas de distribución .", ex);
            }
            return dtRet;
        }

        [HttpPost]
        [Route("area-from-file")]
        public bool AreaFromFile([FromBody] CelulaArea info)
        {
            try
            {
                CelulaFacade Facade = new CelulaFacade();
                Facade.AreaFromFile(this.SessionID, info);
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return false;
        }

        [HttpGet]
        [Route("area-kml")]
        public FileLink GetAreaKml(int IdCelula)
        {
            try
            {
                FileLink FileUri = Facade.GetAreaKml(SessionID, IdCelula);
                return FileUri;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
        }


    }
}