﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Distribucion;
using System.Data;

namespace Azteca.Web.Controllers.Distribucion
{
    [Route("api/distribucion/cobranzas")]
    public class CobranzasController: DocumentController<CobranzaInfo, CobranzaDetail, CobranzaService, CobranzaFacade>
    {
        public CobranzasController()
            :base(new CobranzaFacade())
        {

        }


        [HttpGet("get-rutas-reparto")]
        public DataTable GetRutasReparto(int idSucursal, DateTime fecha)
        {
            try
            {
                Facade = new CobranzaFacade();
                return Facade.GetRutasReparto(this.SessionID, idSucursal, fecha);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpGet("get-cobranza-docto")]
        public CobranzaInfo GetCobranzaDocumento(int idRutaReparto, DateTime fecha)
        {
            try
            {
                Facade = new CobranzaFacade();
                return Facade.GetCobranzaDocumento(this.SessionID, idRutaReparto, fecha);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpPost("enqueue-cobranza")]
        public CobranzaInfo EnqueueCobranza([FromBody] CobranzaInfo cobranza)
        {
            try
            {
                Facade = new CobranzaFacade();
                return Facade.EnqueueCobranza(this.SessionID, cobranza);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }
        
    }
}
