﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Business.Distribucion;
using System.Data;
using Azteca.Kernel.Business;

namespace Azteca.Web.Controllers.Distribucion
{
    [Route("api/distribucion/est-ven")]
    public class EstVenController : Azteca.Web.Controllers.Kernel.HierarchyController<EstVenFacade, EstVenService, EstVenInfo>
    {
        public EstVenController()
            :base(new EstVenFacade())
        {

        }

        [HttpGet]
        [Route("load-list-tipos")]
        public DataTable LoadListTipos(int idSucursal)
        {
            DataTable dtRet = new DataTable();

            try
            {                
                dtRet = Facade.LoadListTipos(SessionID, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar los tipos de Estructuras de Ventas.", ex);
            }
            return dtRet;
        }

    }
}
