﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Distribucion;
using Azteca.Kernel.Business;
using System.Data;


namespace Azteca.Web.Controllers.Distribucion
{
    [Route("api/distribucion/frecuencias")]
    public class FrecuenciasController : CatalogController<FrecuenciaFacade, FrecuenciaService, FrecuenciaInfo>
    {
        public FrecuenciasController()
            :base(new FrecuenciaFacade())
        {

        }

        [HttpPost]
        [Route("area-from-file")]
        public bool AreaFromFile([FromBody] FrecuenciaArea info)
        {
            try
            {
                FrecuenciaFacade Facade = new FrecuenciaFacade();
                Facade.AreaFromFile(this.SessionID, info);
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return false;
        }

        [HttpGet]
        [Route("area-kml")]
        public FileLink GetAreaKml(int IdFrecuencia)
        {
            try
            {
                FileLink FileUri = Facade.GetAreaKml(SessionID, IdFrecuencia);
                return FileUri;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
        }
        /*
        [HttpGet]
        [Route("action-name")]
        public void SampleMethod(int arg)
        {
            try
            {
                
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
        }
		*/

    }
}