﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Distribucion;
using System.Data;


namespace Azteca.Web.Controllers.Distribucion
{
    [Route("api/distribucion/gamas")]
    public class GamasController : CatalogController<GamaFacade, GamaService, GamaInfo>
    {
        public GamasController()
            :base(new GamaFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadList(int idSucursal)
        {
            DataTable dtRet = new DataTable();

            try
            {                
                dtRet = Facade.LoadList(SessionID, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar las Listas de Gamas de articulos.", ex);
            }
            return dtRet;
        }

        [HttpGet]
        [Route("load-productos-list")]
        public DataTable LoadProductosList(int idGama)
        {
            DataTable dtRet = new DataTable();

            try
            {
                dtRet = Facade.LoadProductosList(SessionID, idGama);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar los productos por gama.", ex);
            }
            return dtRet;
        }

        [HttpPost]
        [Route("add-members")]
        public void AddMembers(int idGama, [FromBody] List<ProductosItem> usuarios)
        {
            try
            {
                usuarios.ForEach(producto =>
                {
                    Facade.AddMembers(SessionID, idGama, producto.ID);
                });
            }
            catch (Exception ex)
            {
                HandleException("Error al agregar producto a gama.", ex);
            }
        }

        [HttpDelete]
        [Route("remove-member")]
        public void RemoveMember(int idGama, int idProducto)
        {
            try
            {
                Facade.RemoveMember(SessionID, idGama, idProducto);
            }
            catch (Exception ex)
            {
                HandleException("Error al quitar el producto del gama.", ex);
            }
        }

    }
}