﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Distribucion;
using System.Data;


namespace Azteca.Web.Controllers.Distribucion
{
    [Route("api/distribucion/gruposbeneficios")]
    public class GruposBeneficiosController : CatalogController<GrupoBeneficiosFacade, GrupoBeneficiosService, GrupoBeneficiosInfo>
    {
        public GruposBeneficiosController()
            :base(new GrupoBeneficiosFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadList(int idSucursal)
        {
            DataTable dtRet = new DataTable();

            try
            {                
                dtRet = Facade.LoadList(SessionID, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar las Listas de Grupos de Beneficio.", ex);
            }
            return dtRet;
        }

    }
}