﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Distribucion;

namespace Azteca.Web.Controllers.Distribucion
{
    [Route("api/distribucion/pedidos")]
    public class PedidosController: DocumentController<PedidoInfo, PedidoDetail, PedidoService, PedidoFacade>
    {
        public PedidosController()
            :base(new PedidoFacade())
        {

        }

        [HttpPost]
        [Route("encolar-pedidos-dispositivo")]
        public void EncolarPedidosDispositivo([FromBody]RutaDescargaInfo Paquete)
        {
             //
            try
            {
                DateTime Fecha = DateTime.Now;
                Facade.EncolarPedidosDispositivo(SessionID, Paquete.IdRuta, Paquete.Fecha, Paquete.Pedidos);                
             
            }
            catch (Exception ex)
            {
                HandleException(ex);
                
            }
        }

    }

    [JsonObject(MemberSerialization.OptOut)]
    public class RutaDescargaInfo
    {        
        public int IdRuta { get; set; }
        public DateTime Fecha { get; set; }
        public string Pedidos { get; set; }
    }

}
