﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Distribucion;
using Azteca.Kernel.Geolocation;
using System.Data;


namespace Onili2Web.Controllers.Distribution
{
    [Route("api/distribucion/territories")]
    public class TerritoriesController: BaseController
    {
        TerritoryFacade Facade = new TerritoryFacade();

        [HttpPost]
        [Route("customers")]
        public List<ClienteItem> GetCustomers([FromBody] List<Position> path)
        {
            try
            {
                List<ClienteItem> RetCustomers = Facade.GetClientes(SessionID, path);
                return RetCustomers;
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener la lista de clientes dentro del polígono", ex);
                return null;
            }
        }

        [HttpPost]
        [Route("calculate-zones")]
        public List<CelulaInfo> CalculateZones([FromBody] TerritoryOptions options)
        {
            try
            {
                List<CelulaInfo> Zones = Facade.CalculateZones(SessionID, options);
                return Zones;
            }
            catch (Exception ex)
            {
                HandleException("Error al calcular las zonas del territorio", ex);
                return null;
            }
        }

        [HttpPost]
        [Route("clusters")]
        public ClusteringResult GetClusters([FromBody] TerritoryOptions options)
        {
            try
            {
                ClusteringResult Result = Facade.GetClusters(SessionID, options);
                return Result;
            }
            catch (Exception ex)
            {
                HandleException("Error al calcular los clusters.", ex);
                return null;
            }
        }

    }
}
