﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Distribucion;

namespace Azteca.Web.Controllers.Distribucion
{
    [Route("api/distribucion/vales-pagos")]
    public class ValesPagosController: DocumentController<ValePagoInfo, ValePagoDetail, ValePagoService, ValePagoFacade>
    {
        public ValesPagosController()
            :base(new ValePagoFacade())
        {

        }        
         
        [HttpGet]
        [Route("get-pendientes")]
        public List<ValePagoPendiente> Pendientes(DateTime fechaIni, DateTime fechaFin, string filtro, int idSucursal)
        {
            try
            {
                Facade = new ValePagoFacade();
                return Facade.Pendientes(this.SessionID, fechaIni, fechaFin, filtro, idSucursal);
            }
            catch(Exception ex)
            {
                HandleException(ex);
            }
            return null;

        }
    }
}
