﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Inventario;
using System.Data;


namespace Azteca.Web.Controllers.Inventario
{
    [Route("api/inventario/meta-almacenes")]
    public class MetaAlmacenesController : CatalogController<MetaAlmacenFacade, MetaAlmacenService, MetaAlmacenInfo>
    {
        public MetaAlmacenesController()
            :base(new MetaAlmacenFacade())
        {

        }

        [HttpGet]
        [Route("metaalmacenes-sucursales-load")]
        public List<MetaAlmacenSucursalItem> LoadMetaAlmacenesSucursales(int idMetaAlmacen, int idEmpresa)
        {
            try
            {
                List<MetaAlmacenSucursalItem> lstRet = Facade.LoadMetaAlmacenesSucursales(SessionID, idMetaAlmacen, idEmpresa);
                return lstRet;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
        }


        [HttpPost]
        [Route("add-almacen")]
        public bool AddAlmacen(int idMetaAlmacen,int idSucursal,int idAlmacen)
        {
            try
            {
                Facade.AddAlmacen(SessionID, idMetaAlmacen, idSucursal, idAlmacen);
                return true;
            }
            catch(Exception ex)
            {
                HandleException(ex);
                return false;
            }

        }


    }
}