﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Business.Inventario;
using System.Data;

namespace Azteca.Web.Controllers.Inventario
{
    [Route("api/inventario/ubicaciones")]
    public class UbicacionesController : Azteca.Web.Controllers.Kernel.HierarchyController<UbicacionFacade, UbicacionService, UbicacionInfo>
    {
        public UbicacionesController()
            :base(new UbicacionFacade())
        {

        }

        [HttpGet]
        [Route("load-jerarquia")]
        public List<UbicacionInfo> loadJerarquia(int idSucursal, int idAlmacen)
        {
            try
            {
                //List<UbicacionInfo> Nodes = Azteca.Kernel.Common.DataTableUtils.ToList<UbicacionInfo>(Facade.LoadJerarquia(SessionID, idSucursal, idAlmacen));
                List<UbicacionInfo> Nodes = (Facade.LoadJerarquia(SessionID, idSucursal, idAlmacen));
                return Nodes;
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar los nodos de la jerarquía", ex);
                return null;
            }
        }

        [HttpGet]
        [Route("search-by-almacen")]
        public DataTable SearchByAlmacen(int idAlmacen, string keyword)
        {
            try
            {
                if (keyword != null && keyword != string.Empty)
                {
                    DataTable dtResult = Facade.SearchByAlmacen(SessionID, idAlmacen, keyword);
                    return dtResult;
                }
                else
                {
                    return new DataTable();
                }
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
        }

    }
}
