﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Inventario;
using System.Data;


namespace Azteca.Web.Controllers.Inventario
{
    [Route("api/inventario/unidades-medida")]
    public class UnidadesMedidaController : CatalogController<UnidadMedidaFacade, UnidadMedidaService, UnidadMedidaInfo>
    {
        public UnidadesMedidaController()
            :base(new UnidadMedidaFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadList(int idUnidadMedidaTipo)
        {
            DataTable dtRet = new DataTable();

            try
            {
                UnidadMedidaFacade Facade = new UnidadMedidaFacade();
                dtRet = Facade.LoadList(SessionID, idUnidadMedidaTipo);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar las unidades de medida.", ex);
            }
            return dtRet;
        }

    }
}