﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using Azteca.Kernel.Business;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/aplicaciones")]
    public class AplicacionesController : CatalogController<AplicacionFacade, AplicacionService, AplicacionInfo>
    {
        public AplicacionesController()
            :base(new AplicacionFacade())
        {

        }

        [HttpGet]
        [Route("get-link-version")]
        public string LoadLinkVersion(int idVersion)
        {
            try
            {
                return Facade.LoadLinkVersion(SessionID, idVersion);
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
            return null;
        }

        [HttpGet]
        [Route("get-link-version-qr")]
        public string LoadLinkVersionQr(int idVersion)
        {
            try
            {
                return Facade.LoadLinkVersionQr(SessionID, idVersion);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpPost]
        [Route("get-file-configuraciones-qr")]
        public FileLink LoadFileConfoguracionesQr(string key, [FromBody] List<AplicacionConfiguracionItem> configuraciones)
        {
            try
            {

                FileLink fRet = Facade.LoadFileConfiguracionesQr(SessionID, key, configuraciones);
                return fRet;

            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
          
        }


    }
}