﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/configuraciones")]
    public class ConfiguracionesController : CatalogController<ConfiguracionFacade, ConfiguracionService, ConfiguracionInfo>
    {
        public ConfiguracionesController()
            :base(new ConfiguracionFacade())
        {

        }

        [HttpGet]
        [Route("search-configuracion")]
        public List<ConfiguracionItem> SearchKeyword(int idBranch, string keyword, string tipo)
        {
            List<ConfiguracionItem> dtRet = null;
            try
            {
                ConfiguracionFacade Facade = new ConfiguracionFacade();
                dtRet = Facade.BuscarConfiguraciones(SessionID, idBranch, keyword, tipo);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener listado de configuraciones", ex);
            }
            return dtRet;
        }


        /*
        [HttpGet]
        [Route("action-name")]
        public void SampleMethod(int arg)
        {
            try
            {
                
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
        }
		*/

    }
}