﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Business.Mantenimiento;
using System.Data;

namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/despiece")]
    public class DespieceController : Azteca.Web.Controllers.Kernel.HierarchyController<DespieceFacade, DespieceService, DespieceInfo>
    {
        public DespieceController()
            :base(new DespieceFacade())
        {

        }

        [HttpGet]
        [Route("load-piezas")]
        public List<DespieceInfo> LoadPiezas(int idEmpresa, int idPadre, int idEquipoGrupo)
        {
            List<DespieceInfo> dtRet = null;

            try
            {
                DespieceFacade Facade = new DespieceFacade();
                dtRet = Facade.LoadPiezas(SessionID,idEmpresa,idPadre, idEquipoGrupo);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener el listado de piezas", ex);
            }
            return dtRet;
        }

    }
}
