﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using System.Data;
using Azteca.Web.Controllers.Kernel;
using ConsorcioAga.Custom.Distribucion;
using Azteca.Business.Mantenimiento.Catalogos.Models;
using Azteca.Business.Mantenimiento.Catalogos.Facades;

namespace Onili2Web.Controllers.Maintenance
{
    [Route("api/maintenance/configuraciones-dispositivos")]
    public class DispositivosConfigController: BaseController
    {
        protected IDbConnection Connection;
        protected IDbTransaction Transaction;

        /// <summary>
        /// Obtiene información de clasificaciones para configuraciones.
        /// </summary>
        [HttpGet]
        [Route("get-clasificacionesgrupos")]
        public DataTable ConsultaReestructuraTitulo(string dispositivo)
        {
            DataTable dt;
            try
            {
                DispositivosConfiguracionFacade facade = new DispositivosConfiguracionFacade();
                dt = facade.DispositivosConfiguracionGET(dispositivo);
                return dt;
                //return facade.ReestructuraTituloGET();
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }




        /// <summary>
        /// Obtiene información de clasificaciones para configuraciones.
        /// </summary>
        [HttpGet]
        [Route("send-notificaciones")]
        public bool EnviaNotificaciones(string dispositivo)
        {
            bool resultado;
            try
            {
                DispositivosConfiguracionFacade facade = new DispositivosConfiguracionFacade();
                resultado = facade.EnviaNotificacion(dispositivo);
                return resultado;
                //return facade.ReestructuraTituloGET();
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return false;
        }




    }
}
