﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/equipos-informatica-tipos")]
    public class EquiposInformaticaTiposController : CatalogController<EquipoInformaticaTipoFacade, EquipoInformaticaTipoService, EquipoInformaticaTipoInfo>
    {
        public EquiposInformaticaTiposController()
            :base(new EquipoInformaticaTipoFacade())
        {

        }

        [HttpGet]
        [Route("load-tipos")]
        public List<EquipoInformaticaTipoItem> searchKeyword(string idOrden)
        {
            List<EquipoInformaticaTipoItem> dtRet = null;
            try
            {
                EquipoInformaticaTipoFacade Facade = new EquipoInformaticaTipoFacade();
                dtRet = Facade.LoadList(SessionID);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener listado de tipos de equipos", ex);
            }
            return dtRet;
        }


    }
}