﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using Azteca.Kernel.Business;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/licencias")]
    public class LicenciasController : CatalogController<LicenciaFacade, LicenciaService, LicenciaInfo>
    {
        public LicenciasController()
            :base(new LicenciaFacade())
        {

        }

        [HttpGet]
        [Route("load-documentos")]
        public List<Documento> LoadDocumentos(int idLicencia)
        {
            List<Documento> dtRet = null;

            try
            {
                LicenciaFacade Facade = new LicenciaFacade();
                dtRet = Facade.LoadDocumentos(SessionID, idLicencia);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener documentos de la licencia de software", ex);
            }
            return dtRet;
        }

        [HttpPost]
        [Route("agregar-documento")]
        public void AgregarDocumento(int idLicencia, int idTipoDocumento, [FromBody] FileInfo documento)
        {
            try
            {
                LicenciaFacade Facade = new LicenciaFacade();
                Facade.AgregarDocumento(SessionID, idLicencia, idTipoDocumento, documento);
            }
            catch (Exception ex)
            {
                HandleException("Error al guardar documento de la licencia de software", ex);
            }
        }

        [HttpDelete]
        [Route("eliminar-documento")]
        public void EliminarDocumento(int idLicencia, int idTipoDocumento, Guid idArchivo)
        {
            try
            {
                LicenciaFacade Facade = new LicenciaFacade();
                Facade.EliminarDocumento(SessionID, idLicencia, idTipoDocumento, idArchivo);
            }
            catch (Exception ex)
            {
                HandleException("Error al eliminar documento de la licencia de software", ex);
            }
        }

        /*
        [HttpGet]
        [Route("action-name")]
        public void SampleMethod(int arg)
        {
            try
            {
                
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
        }
		*/

    }
}