﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/llantas")]
    public class LlantasController : CatalogController<LlantaFacade, LlantaService, LlantaInfo>
    {
        public LlantasController()
            :base(new LlantaFacade())
        {

        }

        [HttpGet]
        [Route("search-llantas")]
        public List<LlantaItem> SearchKeyword(int idBranch, string keyword, bool sinVehiculo)
        {
            List<LlantaItem> lstRet = null;
            try
            {
                LlantaFacade Facade = new LlantaFacade();
                lstRet = Facade.BuscarLlantas(SessionID, idBranch, keyword, sinVehiculo);
            }
            catch(Exception ex)
            {
                HandleException("Error al obtener llantas", ex);
            }
            return lstRet;
        }
		/*
        [HttpGet]
        [Route("action-name")]
        public void SampleMethod(int arg)
        {
            try
            {
                
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
        }
		*/

    }
}