﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/llantas-posiciones")]
    public class LlantasPosicionesController : CatalogController<LlantaPosicionFacade, LlantaPosicionService, LlantaPosicionInfo>
    {
        public LlantasPosicionesController()
            :base(new LlantaPosicionFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public List<LlantaPosicionItem> LoadList(int idSucursal)
        {
            
            List<LlantaPosicionItem> lstRet = new List<LlantaPosicionItem>();
            try
            {
                LlantaPosicionFacade Facade = new LlantaPosicionFacade();
                lstRet = Facade.LoadList(SessionID, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar las posiciones de las llantas.", ex);
            }
            return lstRet;
        }

    }
}