﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/localizaciones-tipos")]
    public class LocalizacionesTiposController : CatalogController<LocalizacionTipoFacade, LocalizacionTipoService, LocalizacionTipoInfo>
    {
        public LocalizacionesTiposController()
            :base(new LocalizacionTipoFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public List<LocalizacionTipoItem> LoadList(int idSucursal)
        {

            List<LocalizacionTipoItem> lstRet = new List<LocalizacionTipoItem>();
            try
            {
                LocalizacionTipoFacade Facade = new LocalizacionTipoFacade();
                lstRet = Facade.LoadList(SessionID, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar los tipos de localización.", ex);
            }
            return lstRet;
        }


        /*
        [HttpGet]
        [Route("action-name")]
        public void SampleMethod(int arg)
        {
            try
            {
                
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
        }
		*/

    }
}