﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;

namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/maintenance/marcas")]
    public class MarcasController:CatalogController<MarcaFacade,MarcaService,MarcaInfo>
    {
        public MarcasController()
            :base(new MarcaFacade())
        {

        }

        [HttpGet]
        [Route("search-marca")]
        public List<MarcaItem> SearchKeyword(int idBranch, string keyword, int idServicioTipo)
        {
            List<MarcaItem> dtRet = null;
            try
            {
                MarcaFacade Facade = new MarcaFacade();
                dtRet = Facade.BuscarMarcas(SessionID, idBranch, keyword, idServicioTipo);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener listado de marcas", ex);
            }
            return dtRet;
        }


        [HttpGet]
        [Route("save-submarca")]
        public void SaveSubMarcas(int idSubMarca, string nombre,  int idMarca, int idCuenta)
        {

            MarcaFacade MarcaFac = new MarcaFacade();

            try
            {
                MarcaFac.SaveSubMarcas(SessionID, idSubMarca, nombre, idMarca, idCuenta);
            }
            catch(Exception ex)
            {
                HandleException("Error al guardar la submarca", ex);                
            }
        }

        [HttpGet]
        [Route("delete-submarca")]
        public void DeleteSubMarca(int idSubMarca)
        {
            MarcaFacade MarcaFac = new MarcaFacade();

            try
            {
                MarcaFac.DeleteSubMarcas(SessionID, idSubMarca);
            }
            catch(Exception ex)
            {
                HandleException("Error al eliminar la submarca", ex);
            }
        }
        

    }
}
