﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;

namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/ordenes")]
    public class OrdenesController: DocumentController<OrdenInfo, OrdenDetail, OrdenService, OrdenFacade>
    {
        public OrdenesController()
            :base(new OrdenFacade())
        {

        }        

        [HttpPost]
        [Route("asignar-recurso")]
        public void AsignarRecurso(string idOrden, int idRecurso)
        {
            try
            {
                OrdenFacade Facade = new OrdenFacade();
                Facade.AsignarRecurso(SessionID, idOrden, idRecurso);
            }
            catch(Exception ex)
            {
                HandleException("Error al asignar recurso", ex);
            }
        }

        [HttpGet]
        [Route("list-recursos")]
        public List<RecursoItem> ListRecursos(string idOrden)
        {
            List<RecursoItem> dtRet = null;
            try
            {
                OrdenFacade Facade = new OrdenFacade();
                dtRet = Facade.Recursos(SessionID, idOrden);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener listado de recursos", ex);
            }
            return dtRet;
        }

        [HttpDelete]
        [Route("desasignar-recurso")]
        public void DesasignarRecurso(string idOrden, int idRecurso)
        {
            try
            {
                OrdenFacade Facade = new OrdenFacade();
                Facade.DesasignarRecurso(SessionID, idOrden, idRecurso);
            }
            catch (Exception ex)
            {
                HandleException("Error al desasignar recurso", ex);
            }
        }



    }
}
