﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/politicas")]
    public class PoliticasController : CatalogController<PoliticaFacade, PoliticaService, PoliticaInfo>
    {
        public PoliticasController()
            :base(new PoliticaFacade())
        {

        }

        [HttpGet]
        [Route("search-politica")]
        public List<PoliticaItem> SearchKeyword(int idBranch, string keyword, string tipo)
        {
            List<PoliticaItem> dtRet = null;
            try
            {
                PoliticaFacade Facade = new PoliticaFacade();
                dtRet = Facade.BuscarPoliticas(SessionID, idBranch, keyword, tipo);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener listado de políticas", ex);
            }
            return dtRet;
        }

        /*
        [HttpGet]
        [Route("action-name")]
        public void SampleMethod(int arg)
        {
            try
            {
                
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
        }
		*/

    }
}