﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/propietarios")]
    public class PropietariosController : CatalogController<PropietarioFacade, PropietarioService, PropietarioInfo>
    {
        public PropietariosController()
            :base(new PropietarioFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public List<PropietarioItem> LoadList(int idSucursal)
        {

            List<PropietarioItem> lstRet = new List<PropietarioItem>();
            try
            {

                PropietarioFacade Facade = new PropietarioFacade();
                lstRet = Facade.LoadList(SessionID, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar los propietarios.", ex);
            }
            return lstRet;
        }

        /*
        [HttpGet]
        [Route("action-name")]
        public void SampleMethod(int arg)
        {
            try
            {
                
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
        }
		*/

    }
}