﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/recursos")]
    public class RecursosController : CatalogController<RecursoFacade, RecursoService, RecursoInfo>
    {
        public RecursosController()
            :base(new RecursoFacade())
        {

        }


        [HttpGet]
        [Route("search-recurso")]
        public List<RecursoItem> searchKeyword(int idBranch, string keyword, Int32 idServicioTipo)
        {
            List<RecursoItem> dtRet = null;
            try
            {
                RecursoFacade Facade = new RecursoFacade();
                dtRet = Facade.BuscarRecursos(SessionID, idBranch, keyword, idServicioTipo);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener listado de recursos", ex);
            }
            return dtRet;
        }




    }
}