﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/redes-telefonicas")]
    public class RedesTelefonicasController : CatalogController<RedTelefonicaFacade, RedTelefonicaService, RedTelefonicaInfo>
    {
        public RedesTelefonicasController()
            :base(new RedTelefonicaFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public List<RedTelefonicaItem> LoadList(int idSucursal)
        {

            List<RedTelefonicaItem> lstRet = new List<RedTelefonicaItem>();
            try
            {

                RedTelefonicaFacade Facade = new RedTelefonicaFacade();
                lstRet = Facade.LoadList(SessionID, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar las redes telefónicas.", ex);
            }
            return lstRet;
        }

        /*
        [HttpGet]
        [Route("action-name")]
        public void SampleMethod(int arg)
        {
            try
            {
                
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
        }
		*/

    }
}