﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/sistemas-operativos")]
    public class SistemasOperativosController : CatalogController<SistemaOperativoFacade, SistemaOperativoService, SistemaOperativoInfo>
    {
        public SistemasOperativosController()
            :base(new SistemaOperativoFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public List<SistemaOperativoItem> LoadList(int idSucursal)
        {

            List<SistemaOperativoItem> lstRet = new List<SistemaOperativoItem>();
            try
            {

                SistemaOperativoFacade Facade = new SistemaOperativoFacade();
                lstRet = Facade.LoadList(SessionID, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar los sistemas operativos.", ex);
            }
            return lstRet;
        }

        /*
        [HttpGet]
        [Route("action-name")]
        public void SampleMethod(int arg)
        {
            try
            {
                
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
        }
		*/

    }
}