﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/softwares")]
    public class SoftwaresController : CatalogController<SoftwareFacade, SoftwareService, SoftwareInfo>
    {
        public SoftwaresController()
            :base(new SoftwareFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public List<SoftwareItem> LoadList(int idSucursal)
        {

            List<SoftwareItem> lstRet = new List<SoftwareItem>();
            try
            {

                SoftwareFacade Facade = new SoftwareFacade();
                lstRet = Facade.LoadList(SessionID, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar los softwares.", ex);
            }
            return lstRet;
        }

        /*
        [HttpGet]
        [Route("action-name")]
        public void SampleMethod(int arg)
        {
            try
            {
                
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
        }
		*/

    }
}