﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/talleres")]
    public class TalleresController : CatalogController<TallerFacade, TallerService, TallerInfo>
    {
        public TalleresController()
            :base(new TallerFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public List<TallerItem> LoadList(int idSucursal, int idTipoServicio)
        {
            List<TallerItem> dtRet = null;

            try
            {
                TallerFacade Facade = new TallerFacade();
                dtRet = Facade.LoadList(SessionID, idTipoServicio, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener talleres", ex);
            }
            return dtRet;
        }

    }
}