﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/tipos-combustible")]
    public class TiposCombustibleController : CatalogController<TipoCombustibleFacade, TipoCombustibleService, TipoCombustibleInfo>
    {
        public TiposCombustibleController()
            :base(new TipoCombustibleFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public List<TipoCombustibleItem> LoadList()
        {

            List<TipoCombustibleItem> lstRet = new List<TipoCombustibleItem>();
            try
            {
                TipoCombustibleFacade Facade = new TipoCombustibleFacade();
                lstRet = Facade.LoadList(SessionID);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar los tipos de combustible.", ex);
            }
            return lstRet;
        }

        /*
        [HttpGet]
        [Route("action-name")]
        public void SampleMethod(int arg)
        {
            try
            {
                
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
        }
		*/

    }
}