﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/tipos-licencias")]
    public class TiposLicenciasController : CatalogController<TipoLicenciaFacade, TipoLicenciaService, TipoLicenciaInfo>
    {
        public TiposLicenciasController()
            :base(new TipoLicenciaFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public List<TipoLicenciaItem> LoadList(int idSucursal)
        {

            List<TipoLicenciaItem> lstRet = new List<TipoLicenciaItem>();
            try
            {

                TipoLicenciaFacade Facade = new TipoLicenciaFacade();
                lstRet = Facade.LoadList(SessionID, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar los tipos de licencia.", ex);
            }
            return lstRet;
        }


        /*
        [HttpGet]
        [Route("action-name")]
        public void SampleMethod(int arg)
        {
            try
            {
                
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
        }
		*/

    }
}