﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/tipos-ordenes")]
    public class TiposOrdenesController : CatalogController<TipoOrdenFacade, TipoOrdenService, TipoOrdenInfo>
    {
        public TiposOrdenesController()
            :base(new TipoOrdenFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadList(int arg)
        {
            DataTable dtRet = new DataTable();

            try
            {
                TipoOrdenFacade Facade = new TipoOrdenFacade();
                dtRet = Facade.LoadList(SessionID);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener los tipos de orden", ex);
            }
            return dtRet;
        }


    }
}