﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;
using Azteca.Kernel.Security;

namespace Azteca.Web.Controllers.Maintenance
{
    [Route("api/mantenimiento/servicios-tipos")]
    public class TiposServicioController:CatalogController<TipoServicioFacade,TipoServicioService, TipoServicioInfo>
    {
        public TiposServicioController()
            :base(new TipoServicioFacade())
        { }

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadList(int arg)
        {
            DataTable dtRet = new DataTable();

            try
            {
                TipoServicioFacade Facade = new TipoServicioFacade();
                dtRet = Facade.LoadList(SessionID);
            }
            catch (Exception ex)
            {
                HandleException("Mensaje de error", ex);                
            }
            return dtRet;
        }


        [HttpGet]
        [Route("load-access-users-list")]
        public DataTable LoadTipoServicioAccess(int idTipoServicio)
        {
            DataTable dtRet = new DataTable();

            try
            {
                TipoServicioFacade Facade = new TipoServicioFacade();
                dtRet = Facade.LoadTipoServicioAccess(SessionID, idTipoServicio);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar los usuarios por tipo de servicio.", ex);
            }
            return dtRet;
        }


        [HttpDelete]
        [Route("remove-member")]
        public void RemoveMember(int idTipoServicio, int idUsuario)
        {
            try
            {
                Facade.RemoveUser(SessionID, idTipoServicio, idUsuario);
            }
            catch (Exception ex)
            {
                HandleException("Error al quitar el usuario del tipo de servicio.", ex);
            }
        }

        [HttpPost]
        [Route("add-members")]
        public void AddMembers(int idTipoServicio, [FromBody] List<UsuarioItem> usuarios)
        {
            try
            {
                usuarios.ForEach(user =>
                {
                    Facade.AddUser(SessionID, idTipoServicio, user.ID);
                });
            }
            catch (Exception ex)
            {
                HandleException("Error al agregar miembros al tipo de servicio.", ex);
            }
        }


    }
}
