﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Mantenimiento;
using System.Data;


namespace Azteca.Web.Controllers.Mantenimiento
{
    [Route("api/mantenimiento/tipostransmision")]
    public class TiposTransmisionController : CatalogController<TipoTransmisionFacade, TipoTransmisionService, TipoTransmisionInfo>
    {
        public TiposTransmisionController()
            :base(new TipoTransmisionFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadList(int idEmpresa)
        {
            DataTable dtRet = new DataTable();

            try
            {
                TipoTransmisionFacade Facade = new TipoTransmisionFacade();
                dtRet = Facade.LoadList(SessionID, idEmpresa);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener tipos de transmision", ex);
            }
            return dtRet;
        }

    }
}