﻿using System;
using System.Collections.Generic;
//using System.Linq;
//using System.Net;
//using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Produccion;
using System.Data;
using Azteca.Kernel.General;
//using Microsoft.Reporting.WebForms;

namespace Azteca.Web.Controllers.Produccion
{
    [Route("api/produccion/explosiones")]
    public class ExplosionesController : CatalogController<ExplosionFacade, ExplosionService, ExplosionInfo>
    {
        public ExplosionesController()
            :base(new ExplosionFacade())
        {
            
        }

        [HttpGet]
        [Route("printComparativo")]
        public byte[] printComparativo(Int32 IdSucursal, DateTime FechaIni, DateTime FechaFin)
        {
            byte[] result = null;
            try
            {
                Azteca.Kernel.Security.SucursalFacade SucursalFac = new Azteca.Kernel.Security.SucursalFacade();
                DataTable SysInfo = SucursalFac.GetReportParameters(SessionID, IdSucursal);

                ExplosionFacade ExplosionFac = new ExplosionFacade();
                DataTable ComparativoTable = ExplosionFac.LoadComparativo(this.SessionID, IdSucursal, FechaIni, FechaFin);                               
                /*
                //obtenemos el archivo                
                FormatoFacade FormatFac = new FormatoFacade();
                FormatoInfo FormatoInf = FormatFac.GetDetail(this.SessionID, IdSucursal, "PROD_INF_COMP", true);

                System.Text.UTF8Encoding Encorer = new System.Text.UTF8Encoding(false);
                string formato = Encorer.GetString(FormatoInf.Archivo.Content);

                System.IO.StringReader reader = new System.IO.StringReader(formato);
                */
                Microsoft.Reporting.WebForms.LocalReport report = new Microsoft.Reporting.WebForms.LocalReport();
                //report.LoadReportDefinition(reader);
                report.ReportPath = "C:\\Desarrollo\\Onili2\\src\\business\\Azteca.Produccion\\Reportes\\ExplosionesComparativo.rdlc";

                //Establecemos los origenes de datos del reporte
                report.DataSources.Add(new Microsoft.Reporting.WebForms.ReportDataSource("Comparativo", ComparativoTable ));
                report.DataSources.Add(new Microsoft.Reporting.WebForms.ReportDataSource("SystemInfo", SysInfo));

                //Agregamos los parametros que se envian al reporte
                List<Microsoft.Reporting.WebForms.ReportParameter> Parametros = new List<Microsoft.Reporting.WebForms.ReportParameter>();
                Parametros.Add(new Microsoft.Reporting.WebForms.ReportParameter("FechaIni", FechaIni.ToShortDateString()));
                Parametros.Add(new Microsoft.Reporting.WebForms.ReportParameter("FechaFin", FechaFin.ToShortDateString()));
                report.SetParameters(Parametros);

                //se genera la imagen del reporte
                result = Azteca.Web.Report.ReportRenderer.Render(report, Report.FormatReport.PDF);
            }
            catch (Exception ex)
            {
                HandleException("Problemas al generar el informe", ex);
            }
            return result;
        }


        [HttpGet]
        [Route("load-insumos-conversion")]
        public List<InsumoConversion> LoadInsumosConversion(int IdSucursal)
        {
            List<InsumoConversion> dtRet = new List<InsumoConversion>();

            try
            {
                dtRet = Facade.InsumosConversionList(SessionID, IdSucursal);
                //dtRet = Azteca.Kernel.Common.DataTableUtils.ToList<InsumoConversion>(insumosTable);
            }
            catch (Exception ex)
            {
                HandleException("Mensaje de error", ex);
            }
            return dtRet;
        }

        [HttpPost]
        [Route("save-insumos-conversion")]
        public Boolean SaveInsumosConversion([FromBody] List<InsumoConversion> conversiones)
        {
            try
            {
                return Facade.SaveInsumosConversion(SessionID, conversiones);                
            }
            catch (Exception ex)
            {
                HandleException("Error al guardar la información", ex);
                return false;
            }
        }


    }
}