﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Compras;
using System.Data;
using Azteca.Kernel.Security;

namespace Azteca.Web.Controllers.Compras
{
    [Route("api/compras/centros-costo")]
    public class CentrosCostoController : CatalogController<CentroCostoFacade, CentroCostoService, CentroCostoInfo>
    {
        public CentrosCostoController()
            :base(new CentroCostoFacade())
        {

        }

        /*
        [HttpGet]
        [Route("action-name")]
        public void SampleMethod(int arg)
        {
            try
            {
                
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
        }
		*/

        #region "Accesos"

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadListByUser(int IdSucursal, string type, int id)
        {
            {
                DataTable dtRet = new DataTable();
                try
                {
                    dtRet = Facade.LoadList(SessionID, IdSucursal, type, id);
                }
                catch (Exception ex)
                {
                    HandleException(ex);
                }
                return dtRet;
            }
        }

        [HttpGet]
        [Route("members")]
        public List<UsuarioItem> GetMembers(int idCentroCosto)
        {
            try
            {
                List<UsuarioItem> Users = Azteca.Kernel.Common.DataTableUtils.ToList<UsuarioItem>(Facade.LoadCentralAccesos(SessionID, idCentroCosto));
                return Users;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
        }

        [HttpPost]
        [Route("add-members")]
        public void AddMembers(int idCentroCosto, [FromBody] List<UsuarioItem> users)
        {
            try
            {
                users.ForEach(user =>
                {
                    Facade.InsertaAcceso(SessionID, idCentroCosto, user.ID);
                });
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }

        [HttpDelete]
        [Route("remove-member")]
        public void DeleteMember(int idCentroCosto, int idUser)
        {
            try
            {
                Facade.RemoverAcceso(SessionID, idCentroCosto, idUser);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }

        #endregion

    }
}