﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Compras;
using System.Data;
using Azteca.Kernel.Security;


namespace Azteca.Web.Controllers.Compras
{
    [Route("api/compras/centros-recepcion")]
    public class CentrosRecepcionController : CatalogController<CentroRecepcionFacade, CentroRecepcionService, CentroRecepcionInfo>
    {
        public CentrosRecepcionController()
            :base(new CentroRecepcionFacade())
        {

        }


        #region "Accesos"

        [HttpGet]
        [Route("load-list-by-departamento")]
        public DataTable LoadListByDepartamentoUser(int IdDepartamento, int IdSucursal)
        {
            {
                DataTable dtRet = new DataTable();
                try
                {
                    dtRet = Facade.LoadListByDepartamentoUser(SessionID, IdDepartamento, IdSucursal);
                }
                catch (Exception ex)
                {
                    HandleException(ex);
                }
                return dtRet;
            }
        }

        [HttpGet]
        [Route("members")]
        public List<UsuarioItem> GetMembers(int idCentroRecepcion)
        {
            try
            {
                List<UsuarioItem> Users = Azteca.Kernel.Common.DataTableUtils.ToList<UsuarioItem>(Facade.LoadAccess(SessionID, idCentroRecepcion));
                return Users;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
        }

        [HttpPost]
        [Route("add-members")]
        public void AddMembers(int idCentroRecepcion, [FromBody] List<UsuarioItem> users)
        {
            try
            {
                users.ForEach(user =>
                {
                    Facade.AddUser(SessionID, idCentroRecepcion, user.ID);
                });
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }

        [HttpDelete]
        [Route("remove-member")]
        public void DeleteMember(int idCentroRecepcion, int idUser)
        {
            try
            {
                Facade.RemoveUser(SessionID, idCentroRecepcion, idUser);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }

        #endregion



    }
}