﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Compras;

namespace Azteca.Web.Controllers.Compras
{
    [Route("api/compras/costos-presupuestos")]
    public class CostosPresupuestosController: DocumentController<CostoPresupuestoInfo, CostoPresupuestoDetail, CostoPresupuestoService, CostoPresupuestoFacade>
    {
        public CostosPresupuestosController()
            :base(new CostoPresupuestoFacade())
        {

        }

        [HttpGet]
        [Route("detalle-new")]
        public List<CostoPresupuestoDetail> LoadDetailNew(string idPresupuesto)
        {
            try
            {
                Facade = new CostoPresupuestoFacade();
                return Facade.DetailNew(this.SessionID, idPresupuesto);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }


    }
}
