﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Compras;

namespace Azteca.Web.Controllers.Compras
{
    [Route("api/compras/gastos")]
    public class GastosController: DocumentController<GastoInfo, GastoDetail, GastoService, GastoFacade>
    {
        public GastosController()
            :base(new GastoFacade())
        {

        }        
          
        [HttpGet]
        [Route("detalle-new")]
        public List<GastoDetail> LoadDetailNew(string idPresupuesto)
        {
            try
            {
                Facade = new GastoFacade();
                return Facade.DetailNew(this.SessionID, idPresupuesto);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpPost]
        [Route("comprobantes-update")]
        public Boolean ComprobantesUpdate(string idGasto, [FromBody] GastoInfo gasto)
        {
            try
            {
                Facade.UpdateComprobantes(SessionID, gasto);
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return false;
            }

        }

    }
}
