﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Compras;
using System.Data;


namespace Azteca.Web.Controllers.Compras
{
    [Route("api/compras/gastos-tipos")]
    public class GastosTiposController : CatalogController<GastoTipoFacade, GastoTipoService, GastoTipoInfo>
    {
        public GastosTiposController()
            :base(new GastoTipoFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public List<GastoTipoItem> LoadList(int IdSucursal)
        {
            {
                List<GastoTipoItem> lstRet = new List<GastoTipoItem>();
                try
                {
                    lstRet = Facade.LoadList(SessionID, IdSucursal);
                }
                catch (Exception ex)
                {
                    HandleException(ex);
                }
                return lstRet;
            }
        }

        /*
        [HttpGet]
        [Route("action-name")]
        public void SampleMethod(int arg)
        {
            try
            {
                
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
        }
		*/

    }
}