﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Compras;

namespace Azteca.Web.Controllers.Compras
{
    [Route("api/compras/notas")]
    public class NotasController: DocumentController<NotaInfo, NotaDetail, NotaService, NotaFacade>
    {
        public NotasController()
            :base(new NotaFacade())
        {

        }

        [HttpGet]
        [Route("detalle-new")]
        public List<NotaDetail> LoadDetailNew(int idProveedor)
        {
            try
            {
                Facade = new NotaFacade();
                return Facade.DetailNew(this.SessionID, idProveedor);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }



    }
}
