﻿using Azteca.Web.Controllers.Kernel;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using Azteca.Business.Compras;

namespace Azteca.Web.Controllers.Compras
{
    [Route("api/compras/proveedores-tipos")]
    public class ProveedoresTiposController: CatalogController<ProveedorTipoFacade, ProveedorTipoService, ProveedorTipoInfo>
    {
        public ProveedoresTiposController()
            : base(new ProveedorTipoFacade())
        {

        }
        [HttpGet]
        [Route("load-list")]
        public DataTable LoadList(int idSucursal)
        {
            DataTable dtProveedoresTipos = new DataTable();
            try
            {
                dtProveedoresTipos = Facade.LoadList(SessionID, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return dtProveedoresTipos;
        }
    }
}
