﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Compras;

namespace Azteca.Web.Controllers.Compras
{
    [Route("api/compras/recepciones")]
    public class RecepcionesController: DocumentController<RecepcionInfo, RecepcionDetail, RecepcionService, RecepcionFacade>
    {
        public RecepcionesController()
            :base(new RecepcionFacade())
        {

        }

        [HttpPost]
        [Route("save")]
        public RecepcionInfo Save([FromBody] JObject recepcionJson)
        {
            try
            {
                RecepcionInfo Recepcion = Facade.Deserialize(SessionID, recepcionJson);
                RecepcionInfo UpdatedRecepcion = Facade.SaveAndActive(SessionID, Recepcion);
                return UpdatedRecepcion;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
        }

        [HttpGet]
        [Route("pdf-recepcion")]
        public FileLink GenerarPdfRecepcion(string idRecepcion)
        {
            try
            {
                FileLink FileUri = Facade.GenerarPdf(SessionID, idRecepcion);
                return FileUri;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
        }


    }
}
