﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Compras;

namespace Azteca.Web.Controllers.Compras
{
    [Route("api/compras/recepciones-sin-o-c")]
    public class RecepcionesSinOCController: DocumentController<RecepcionSinOCInfo, RecepcionSinOCDetail, RecepcionSinOCService, RecepcionSinOCFacade>
    {
        public RecepcionesSinOCController()
            :base(new RecepcionSinOCFacade())
        {

        }

        [HttpPost]
        [Route("save")]
        public RecepcionSinOCInfo Save([FromBody] JObject recepcionJson)
        {
            try
            {
                RecepcionSinOCInfo Recepcion = Facade.Deserialize(SessionID, recepcionJson);
                RecepcionSinOCInfo UpdatedRecepcion = Facade.Update(SessionID, Recepcion);
                return UpdatedRecepcion;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
        }

    }
}
