﻿using Azteca.Business.RH;
using Azteca.Kernel.Search;
using Azteca.Web.Controllers.Kernel;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;

namespace Onili2Web.Controllers.RH
{

    [Route("api/rh/autorizacion")]
    public class AutorizacionController : BaseController
    {

        [HttpPost]
        [Route("search")]
        public SearchResult SearchPedidoCliente(int idBranch, [FromBody] SearchRequest request)
        {
            try
            {
                SearchResult Result = new SearchResult();
                if (request != null)
                {
                    int pageIndex = 0;
                    if (request.Paged) pageIndex = request.PageIndex + 1;//Search manager inicia la paginación desde 1, los view desde 0
                                                                         //
                    FiniquitoAutorizacionFacade Facade = new FiniquitoAutorizacionFacade();
                    Result.TotalRows = Facade.GetTotalRecordsAutorizacion(this.SessionID, idBranch, request.Conditions);
                    Result.Rows = Facade.SearchAutorizacion(this.SessionID, idBranch, request.Conditions, request.Order, pageIndex, request.PageSize);
                }
                else
                {
                    FiniquitoAutorizacionFacade Facade = new FiniquitoAutorizacionFacade();
                    Result.TotalRows = Facade.GetTotalRecordsAutorizacion(this.SessionID, idBranch, null);
                    Result.Rows = Facade.SearchAutorizacion(this.SessionID, idBranch, null, null, 1, 20);
                }
                return Result;
            }
            catch (Exception ex)
            {
                HandleException("Error al ejecutar la búsqueda.", ex);
                return null;
            }
        }

        [HttpGet]
        [Route("get-detail")]
        public FiniquitoAutorizacionInfo GetDetail(int idFiniquitoAutorizacion)
        {
            try
            {
                FiniquitoAutorizacionFacade FiniquitoAutorizacionFac = new FiniquitoAutorizacionFacade();
                return FiniquitoAutorizacionFac.GetDetailFiniquitoAutorizacion(this.SessionID, idFiniquitoAutorizacion);
                
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar la información.", ex);
                return null;
            }
        }


        [HttpPost]
        [Route("update")]
        public bool Update(int idBranch, [FromBody] FiniquitoAutorizacionInfo info)
        {
            try
            {
                FiniquitoAutorizacionFacade FiniquitoAutorizacionFac = new FiniquitoAutorizacionFacade();
                FiniquitoAutorizacionFac.UpdateFiniquitoAutorizacion(this.SessionID, info);
                return true;
            }
            catch (Exception ex)
            {
                HandleException("Error al actualizar la información.", ex);
                return false;
            }
        }

        [HttpPost]
        [Route("delete")]
        public bool Delete(int idFiniquitoAutorizacion)
        {
            try
            {
                FiniquitoAutorizacionFacade FiniquitoAutorizacionFac = new FiniquitoAutorizacionFacade();
                FiniquitoAutorizacionFac.DeleteFiniquitoAutorizacion(this.SessionID, idFiniquitoAutorizacion);
                return true;
            }
            catch (Exception ex)
            {
                HandleException("Error al eliminar la información.", ex);
                return false;
            }
        }


        [HttpGet]
        [Route("load-clases-nominas")]
        public DataTable LoadClaseNomina()
        {
            try
            {
                FiniquitoAutorizacionFacade FiniquitoAutorizacionFac = new FiniquitoAutorizacionFacade();
                return FiniquitoAutorizacionFac.LoadClasesNomina(this.SessionID);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar la información.", ex);
                return null;
            }
        }


        [HttpGet]
        [Route("load-personas-autorizan")]
        public DataTable LoadFiniquitosAutoriza()
        {
            try
            {
                FiniquitoAutorizacionFacade FiniquitoAutorizacionFac = new FiniquitoAutorizacionFacade();
                return FiniquitoAutorizacionFac.LoadFiniquitosAutoriza(this.SessionID);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar la información.", ex);
                return null;
            }
        }

    }
}
