﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.RH;
using System.Data;


namespace Azteca.Web.Controllers.RH
{
    [Route("api/rh/clases-nominas")]
    public class ClasesNominasController : CatalogController<ClaseNominaFacade, ClaseNominaService, ClaseNominaInfo>
    {
        public ClasesNominasController()
            :base(new ClaseNominaFacade())
        {

        }

        [HttpGet]
        [Route("get-rangos-vacacionales")]
        public List<RangoVacacionalItem> GetRangosVacacionales(int IdClaseNomina)
        {
            try
            {
                return Facade.GetRangosVacacionales(SessionID, IdClaseNomina);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpPost]
        [Route("save-rangos-vacacionales")]
        public bool SaveRangosVacacionales([FromBody] List<RangoVacacionalItem> Rangos)
        {
            try
            {
                Facade = new ClaseNominaFacade();
                Facade.SaveRangosVacacionales(this.SessionID, Rangos);
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return false;
            }
        }

    }
}