﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using Azteca.Business.RH;
using Azteca.Business.RH.Catalogos.Facades;
using Azteca.Business.RH.Catalogos.Models;
using Azteca.Business.RH.Catalogos.Services;
using Azteca.Web.Controllers.Kernel;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;

namespace Azteca.Web.Controllers.RH
{
    [Route("api/rh/consultaasistenciaempleados")]
    public class ConsultaAsistenciaEmpleadosController : CatalogController<ConsultaAsistenciaEmpleadoFacade, ConsultaAsistenciaEmpleado, ConsultaAsistenciaEmpleadoInfo>
    {
        public ConsultaAsistenciaEmpleadosController()
       : base(new ConsultaAsistenciaEmpleadoFacade())
        {

        }
        [HttpGet]
        [Route("cargar-asistencias-empleados")]
        public DataTable CargarAsistenciasEmpleado(string Codigo, DateTime fechaInicial, DateTime fechaFinal)
        {
            DataTable dtResult = null;
            try
            {
                dtResult = Facade.LoadList(this.SessionID, Codigo,fechaInicial, fechaFinal);
            }
            catch (Exception ex)
            {
                HandleException("Error al cargar la información del empleado", ex);
            }
            return dtResult;
        }
    }
}