﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Business.Contabilidad;
using System.Data;
using Azteca.Business.RH;

namespace Azteca.Web.Controllers.RH
{
    [Route("api/rh/departamento")]
    public class DepartamentoController : Azteca.Web.Controllers.Kernel.HierarchyController<DepartamentoFacade, DepartamentoService, DepartamentoInfo>
    {
        public DepartamentoController()
            : base(new DepartamentoFacade())
        {

        }

        [HttpGet]
        [Route("load-accesos")]
        public List<DepartamentoAcceso> LoadAccesos(int idUsuario)
        {
            try
            {
                Facade = new DepartamentoFacade();
                return Facade.LoadAccesos(this.SessionID, idUsuario);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpPost]
        [Route("update-accesos")]
        public bool UpdateAccesos(int idUsuario, [FromBody] List<DepartamentoAcceso> departamentosAccesos)
        {
            try
            {

                Facade.AccesosUpdate(SessionID, idUsuario,departamentosAccesos);
                return true; 

            }
            catch (Exception ex)
            {
                HandleException(ex);
                return false;
            }

        }

        [HttpGet]
        [Route("search-keyword-with-access")]
        public List<DepartamentoItem> SearchKeywordWithAccess(int idBranch, string keyword)
        {
            List<DepartamentoItem> dtRet = null;
            try
            {
                DepartamentoFacade Facade = new DepartamentoFacade();
                dtRet = Facade.SearchKeyWordWithAccess(SessionID, idBranch, keyword);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener listado de departamentos", ex);
            }
            return dtRet;
        }

        [HttpGet]
        [Route("nodes-with-access")]
        public List<DepartamentoInfo> NodesWithAccess(int idBranch)
        {
            List<DepartamentoInfo> lstRet = null;
            try
            {
                DepartamentoFacade Facade = new DepartamentoFacade();
                lstRet = Facade.NodesWithAccess(SessionID, idBranch);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener listado de nodos con accesos", ex);
            }
            return lstRet;

        }

    }
}
