﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.RH;
using System.Data;


namespace Azteca.Web.Controllers.RH
{
    [Route("api/rh/dispositivos-nixtla")]
    public class DispositivosNixtlaController : CatalogController<DispositivoNixtlaFacade, DispositivoNixtlaService, DispositivoNixtlaInfo>
    {
        public DispositivosNixtlaController()
            : base(new DispositivoNixtlaFacade())
        {

        }


        [HttpPost]
        [Route("update-transaction")]
        public bool UpdateTransaccion(string imei, string codEmpleado, DateTime fecha, DateTime hora, decimal lat, decimal lng)
        {
            try
            {
                DispositivoNixtlaFacade Fac = new DispositivoNixtlaFacade();
                Fac.UpdateTransaccion(this.SessionID, imei, codEmpleado, fecha, hora, lat, lng);
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return false;
            }
        }

        [HttpGet]
        [Route("load-posiciones")]
        public DataTable LoadPosiciones(Guid sessionID, string imei, string codEmpleado)
        {
            try
            {
                DispositivoNixtlaFacade Fac = new DispositivoNixtlaFacade();
                return Fac.LoadPosiciones(this.SessionID, imei, codEmpleado);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

    }
}