﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.RH;
using System.Data;


namespace Azteca.Web.Controllers.RH
{
    [Route("api/rh/documentos-tipos")]
    public class DocumentosTiposController : CatalogController<DocumentoTipoFacade, DocumentoTipoService, DocumentoTipoInfo>
    {
        public DocumentosTiposController()
            :base(new DocumentoTipoFacade())
        {

        }

        [HttpGet]
        [Route("search-tipo-documento")]
        public List<DocumentoTipoInfo> SearchKeyword(string proceso, string keyWord, int idBranch)
        {
            List<DocumentoTipoInfo> dtRet = null;
            try
            {
                DocumentoTipoFacade Facade = new DocumentoTipoFacade();
                dtRet = Facade.BuscarDocumentoTipo(SessionID, proceso, idBranch, keyWord);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener listado de equipos", ex);
            }
            return dtRet;
        }
    }
}