﻿using Azteca.Business.RH;
using Azteca.Kernel.Search;
using Azteca.Web.Controllers.Kernel;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Azteca.Web.Controllers.RH
{

    [Route("api/rh/evaluacion-kardex")]
    public class EvaluacionKardexController : BaseController
    {

        [HttpGet]
        [Route("get-detail")]
        public EvaluacionKardexInfo GetDetail(int identity)
        {
            try
            {
                EvaluacionKardexFacade Facade = new EvaluacionKardexFacade();
                return Facade.GetDetail(this.SessionID, identity);
            }
            catch (Exception ex)
            {
                HandleException("Error al consultar la evaluación del kardex.", ex);
                return null;
            }
        }

        [HttpPost]
        [Route("update")]
        public EvaluacionKardexInfo Update([FromBody] EvaluacionKardexInfo info)
        {
            try
            {
                EvaluacionKardexFacade Facade = new EvaluacionKardexFacade();
                return Facade.Update(this.SessionID, info);
            }
            catch (Exception ex)
            {
                HandleException("Error al actualizar la información.", ex);
                return null;
            }
        }

        [HttpPost]
        [Route("search")]
        public SearchResult Search(int idBranch, [FromBody] SearchRequest request)
        {
            try
            {
                SearchResult Result = new SearchResult();
                if (request != null)
                {
                    int pageIndex = 0;
                    if (request.Paged) pageIndex = request.PageIndex + 1;//Search manager inicia la paginación desde 1, los view desde 0
                                                                         //
                    EvaluacionKardexFacade Facade = new EvaluacionKardexFacade();
                    Result.TotalRows = Facade.GetTotalRecords(this.SessionID, idBranch, request.Conditions);
                    Result.Rows = Facade.Search(this.SessionID, idBranch, request.Conditions, request.Order, pageIndex, request.PageSize);
                }
                else
                {
                    EvaluacionKardexFacade Facade = new EvaluacionKardexFacade();
                    Result.TotalRows = Facade.GetTotalRecords(this.SessionID, idBranch, null);
                    Result.Rows = Facade.Search(this.SessionID, idBranch, null, null, 1, 20);
                }
                return Result;
            }
            catch (Exception ex)
            {
                HandleException("Error al ejecutar la búsqueda.", ex);
                return null;
            }
        }

    }

}
