﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.RH;
using System.Data;

namespace Azteca.Web.Controllers.RH
{
    [Route("api/rh/fichas-tit")]
    public class FichasTitController: DocumentController<FichasTitInfo, FichasTitDetail, FichasTitService, FichasTitFacade>
    {
        public FichasTitController()
            :base(new FichasTitFacade())
        {

        }

        [HttpGet]
        [Route("empleado-info-ADAM")]
        public DataTable EmpleadoInfoADAM(int idSucursal,string codigoEmpleado)
        {
            try
            {
                Facade = new FichasTitFacade();
                return Facade.EmpleadoInfoADAM(this.SessionID, codigoEmpleado,idSucursal);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpPost]
        [Route("deactivate")]
        public void Deactivate(string idFichaTit)
        {
            try
            {
                Facade = new FichasTitFacade();
                Facade.Deactivate(this.SessionID,idFichaTit);
                
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }

        [HttpGet]
        [Route("get-cuenta-empleado")]
        public int GetCuentaEmpleado(string idFichaTit)
        {
            try
            {
                Facade = new FichasTitFacade();
                return Facade.GetCuentaEmpleado(this.SessionID, idFichaTit);
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return 0;
            }
        }
        
        [HttpPost]
        [Route("armar-cuentas")]
        public void ArmarCuentas(string IdFichaTit)
        {
            try
            {
                Facade = new FichasTitFacade();
                Facade.ArmarCuenta(this.SessionID, IdFichaTit);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }
    }
}
