﻿using Azteca.Business.RH;
using Azteca.Kernel.Search;
using Azteca.Web.Controllers.Kernel;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;

namespace Azteca.Web.Controllers.RH
{
    [Route("api/rh/interfaz-adam")]
    public class InterfazAdamController : BaseController
    {

        [HttpPost]
        [Route("search")]
        public SearchResult Search(int idBranch, [FromBody] SearchRequest request)
        {
            try
            {
                SearchResult Result = new SearchResult();
                if (request != null)
                {
                    int pageIndex = 0;
                    if (request.Paged) pageIndex = request.PageIndex + 1;//Search manager inicia la paginación desde 1, los view desde 0
                                                                         //
                    InterfazAdamFacade Facade = new InterfazAdamFacade();
                    Result.TotalRows = Facade.GetTotalRecords(this.SessionID, idBranch, request.Conditions);
                    Result.Rows = Facade.Search(this.SessionID, idBranch, request.Conditions, request.Order, pageIndex, request.PageSize);
                }
                else
                {
                    InterfazAdamFacade Facade = new InterfazAdamFacade();
                    Result.TotalRows = Facade.GetTotalRecords(this.SessionID, idBranch, null);
                    Result.Rows = Facade.Search(this.SessionID, idBranch, null, null, 1, 20);
                }
                return Result;
            }
            catch (Exception ex)
            {
                HandleException("Error al ejecutar la búsqueda.", ex);
                return null;
            }
        }

        [HttpGet]
        [Route("get-employes")]
        public DataTable GetEmpleadosInterfazar(DateTime fechaIni, DateTime fechaFin, int idDepartamento, int idEmpresaAdam, int idSucursal, int idEmpresa)
        {
            try
            {
                InterfazAdamFacade interfazAdamFacade = new InterfazAdamFacade();
                return interfazAdamFacade.GetEmpleadosInterfazar(SessionID, fechaIni, fechaFin, idDepartamento, idEmpresaAdam, idSucursal, idEmpresa);
            }
            catch (Exception ex)
            {
                HandleException("Error al ejecutar la búsqueda.", ex);
                return null;
            }
        }

        [HttpPost]
        [Route("update")]
        public InterfazAdamInfo Update([FromBody] InterfazAdamInfo info)
        {
            try
            {
                InterfazAdamFacade interfazAdamFacade = new InterfazAdamFacade();
                return interfazAdamFacade.Update(SessionID, info);
            }
            catch (Exception ex)
            {
                HandleException("Error al actualizar la información.", ex);
                return null;
            }
        }

        [HttpGet]
        [Route("get-detail")]
        public InterfazAdamInfo GetDetail(int idInterfazAdam)
        {
            try
            {
                InterfazAdamFacade facade = new InterfazAdamFacade();
                return facade.GetDetail(SessionID, idInterfazAdam);
            }
            catch (Exception ex)
            {
                HandleException("Error al actualizar la información.", ex);
                return null;
            }
        }
    }
}
