﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.RH;

namespace Azteca.Web.Controllers.RH
{
    [Route("api/rh/nominas")]
    public class NominasController: DocumentController<NominaInfo, NominaDetail, NominaService, NominaFacade>
    {
        public NominasController()
            :base(new NominaFacade())
        {

        } 

        [HttpPost]
        [Route("calcular-nomina")]
        public bool CalcularNomina(string idNomina)
        {
            try
            {
                Facade = new NominaFacade();
                Facade.EnqueueCalcular(this.SessionID, idNomina);
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return false;
        }

        [HttpPost]
        [Route("timbrar-nomina")]
        public bool TimbrarNomina(string idNomina)
        {
            try
            {
                Facade = new NominaFacade();
                Facade.EnqueueTimbrar(this.SessionID, idNomina);
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return false;
        }

    }
}
