﻿using Azteca.Business.RH;
using Azteca.Business.RH.Tiempo.Facades;
using Azteca.Web.Controllers.Kernel;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;

namespace Azteca.Web.Controllers.RH
{

    [Route("api/rh/periodos-trabajo")]
    public class PeriodoTrabajoController : BaseController
    {

        [HttpGet]
        [Route("get-periodo-trabajo")]
        public List<PeriodoTrabajoInfo> GetPeriodoTrabajo(int idEmpleado, DateTime fechaIni, DateTime fechaFin)
        {
            try
            {
                PeriodoTrabajoFacade PeriodoTrabajoFac = new PeriodoTrabajoFacade();
                return PeriodoTrabajoFac.GetPeriodoTrabajo(this.SessionID, idEmpleado, fechaIni, fechaFin);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpPost]
        [Route("update-periodo-turno-horario")]
        public bool UpdatePeriodoTurnoHorario([FromBody] List<PeriodoTrabajoInfo> periodos)
        {
            try
            {
                PeriodoTrabajoFacade PeriodoTrabajoFac = new PeriodoTrabajoFacade();
                PeriodoTrabajoFac.UpdatePeriodoTurnoHorario(this.SessionID, periodos);
                return true;
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return false;
        }

        [HttpGet]
        [Route("get-periodo-trabajo-fecha")]
        public DataTable GetPeriodoTrabajoFecha(int idSucursal,DateTime fecha)
        {
            DataTable dt = null;
            try
            {
                PeriodoTrabajoFacade facade = new PeriodoTrabajoFacade();
                dt = facade.GetPeriodoTrabajoFecha(SessionID, idSucursal, fecha);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return dt;
        }

        [HttpPost]
        [Route("update-periodo-turno-horario-fecha")]
        public void UpdatePeriodoFecha(DateTime fecha, [FromBody] DataTable empleados)
        {
            try
            {
                PeriodoTrabajoFacade facade = new PeriodoTrabajoFacade();
                facade.UpdatePeriodoFecha(SessionID, fecha, empleados);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }

    }

}
