﻿


using Azteca.Business.RH;
using Azteca.Business.RH.Tiempo;
using Azteca.Web.Controllers.Kernel;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;



namespace Azteca.Web.Controllers.RH
{

    [Route("api/rh/periodos-vacacionales")]
    public class PeriodosVacacionalesController : BaseController
    {

        [HttpGet]
        [Route("obtener")]
        public PeriodoVacacionalInfo Obtener(int IdEmpleado, int IdRangoVacacional)
        {
            try
            {                
                PeriodoVacacionalFacade PeriodoFac = new PeriodoVacacionalFacade();
                return PeriodoFac.Obtener(this.SessionID, IdEmpleado, IdRangoVacacional);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpGet]
        [Route("obtener-generar")]
        public PeriodoVacacionalInfo Generar(int IdEmpleado, int IdRangoVacacional, bool Regenerar, bool Manual)
        {
            try
            {
                PeriodoVacacionalFacade PeriodoFac = new PeriodoVacacionalFacade();
                return PeriodoFac.Generar(this.SessionID, IdEmpleado, IdRangoVacacional, Regenerar, Manual);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpGet]
        [Route("obtener-generar-by-fechas")]
        public List<PeriodoVacacionalInfo> Generar(int IdEmpleado, DateTime FechaIni, DateTime FechaFin, bool Regenerar, bool Manual)
        {
            try
            {
                PeriodoVacacionalFacade PeriodoFac = new PeriodoVacacionalFacade();
                return PeriodoFac.Generar(this.SessionID, IdEmpleado, FechaIni, FechaFin, Regenerar, Manual);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }



    }

}