﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.RH;

namespace Azteca.Web.Controllers.RH
{
    [Route("api/rh/recibos-nominas")]
    public class RecibosNominasController: DocumentController<ReciboNominaInfo, ReciboNominaDetail, ReciboNominaService, ReciboNominaFacade>
    {
        public RecibosNominasController()
            :base(new ReciboNominaFacade())
        {

        }

        [HttpGet("get-xml-recibo")]
        public string GetXmlRecibo(string idReciboNomina)
        {
            try
            {
                ReciboNominaFacade Fac = new ReciboNominaFacade();
                return Fac.GetXmlRecibo(this.SessionID, idReciboNomina);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return string.Empty;
        }

        [HttpGet("print-recibo-pdf")]
        public byte[] GenerarPDF(string idReciboNomina)
        {
            try
            {
                ReciboNominaFacade Fac = new ReciboNominaFacade();
                return Fac.GenerarPDF(this.SessionID, idReciboNomina);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpGet("print-recibo-pdf-base64")]
        public string GenerarPDF_Base64(string idReciboNominaAdam)
        {
            try
            {
                ReciboNominaFacade Fac = new ReciboNominaFacade();
                byte[] result = Fac.GenerarPDF(this.SessionID, idReciboNominaAdam);
                return Convert.ToBase64String(result);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

        [HttpGet("get-error-timbrado")]
        public string GetErrorTimbrado(string idReciboNomina)
        {
            try
            {
                ReciboNominaFacade Fac = new ReciboNominaFacade();
                return Fac.GetErrorTimbrado(this.SessionID, idReciboNomina);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

    }
}
