﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.RH;

namespace Azteca.Web.Controllers.RH
{
    [Route("api/rh/solicitudes-vacacionales")]
    public class SolicitudesVacacionalesController: DocumentController<SolicitudVacacionalInfo, SolicitudVacacionalDetail, SolicitudVacacionalService, SolicitudVacacionalFacade>
    {
        public SolicitudesVacacionalesController()
            :base(new SolicitudVacacionalFacade())
        {

        }

        [HttpGet]
        [Route("calcular-rango-vacacional")]
        public List<SolicitudVacacionalDetail> CalcularRangoVacacional(int IdEmpleado, DateTime FechaIni, DateTime FechaFin, int IdSucursal, bool Regenerar, bool Manual)
        {
            try
            {
                SolicitudVacacionalFacade Fac = new SolicitudVacacionalFacade();
                return Fac.CalcularRangoVacacional(this.SessionID, IdEmpleado, FechaIni, FechaFin, IdSucursal, Regenerar, Manual);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return null;
        }

    }
}
