﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.RH;
using System.Data;


namespace Azteca.Web.Controllers.RH
{
    [Route("api/rh/tipos-descuentos")]
    public class TiposDescuentosController : CatalogController<TiposDescuentosFacade, TiposDescuentosService, TiposDescuentosInfo>
    {
        public TiposDescuentosController()
            :base(new TiposDescuentosFacade())
        {

        }

        [HttpGet]
        [Route("search-descuento")]
        public List<TiposDescuentoItem> SearchKeyword(string tipo,string keyWord,int idBranch)
        {
            List<TiposDescuentoItem> dtRet = null;
            try
            {
                TiposDescuentosFacade Facade = new TiposDescuentosFacade();
                dtRet = Facade.BuscarTiposDescuentos(SessionID, tipo, idBranch, keyWord);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener listado de equipos", ex);
            }
            return dtRet;
        }

        [HttpGet]
        [Route("descuento-empleado")]
        public DataTable InfoDescuentosEmpleadoADAM(int idEmpleado,int idSucursal)
        {
            DataTable dtRet = null;
            try
            {
                TiposDescuentosFacade Facade = new TiposDescuentosFacade();
                dtRet = Facade.InfoDescuentosEmpleadoADAM(SessionID, idEmpleado, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException("Error al obtener listado de equipos", ex);
            }
            return dtRet;
        }
        /*
        [HttpGet]
        [Route("action-name")]
        public void SampleMethod(int arg)
        {
            try
            {
                
            }
            catch(Exception ex)
            {
                HandleException(ex);                
            }
        }
		*/

    }
}