﻿using Azteca.Business.RH;
using Azteca.Web.Controllers.Kernel;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;

namespace Azteca.Web.Controllers.RH
{
    [Route("api/rh/turno")]
    public class TurnoController : CatalogController<TurnoFacade, TurnoService, TurnoInfo>
    {

        public TurnoController()
            : base(new TurnoFacade())
        {

        }

        [HttpGet]
        [Route("get-empleados-by-turno")]
        public DataTable GetEmpleadosByTurno(int idTurno, int idSucursal)
        {
            DataTable dt = null;
            try
            {
                TurnoFacade facade = new TurnoFacade();
                dt = facade.GetEmpleadosByTurno(SessionID, idTurno, idSucursal);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
            return dt;
        }

        [HttpPost]
        [Route("add-turno-empleados")]
        public void AddTurnoEmpleado(int idTurno, [FromBody] EmpleadoItem[] empleados)
        {
            try
            {
                TurnoFacade facade = new TurnoFacade();
                facade.AddTurnoEmpleado(SessionID, idTurno, empleados);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }

        [HttpPost]
        [Route("remove-turno-empleado")]
        public void RemoveTurnoEmpleado(int idEmpleado)
        {
            try
            {
                TurnoFacade facade = new TurnoFacade();
                facade.RemoveTurnoEmpleado(SessionID, idEmpleado);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }
    }
}
