﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Azteca.Kernel.Business;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Ventas;

namespace Azteca.Web.Controllers.Ventas
{
    [Route("api/ventas/devoluciones")]
    public class DevolucionesController: DocumentController<DevolucionInfo, DevolucionDetail, DevolucionService, DevolucionFacade>
    {
        public DevolucionesController()
            :base(new DevolucionFacade())
        {

        }

        [HttpPost]
        [Route("save")]
        public DevolucionInfo Save([FromBody] JObject devolucionJson)
        {
            try
            {
                DevolucionInfo Devolucion = Facade.Deserialize(SessionID, devolucionJson);
                DevolucionInfo UpdatedDevolucion = Facade.Update(SessionID, Devolucion);
                return UpdatedDevolucion;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
        }


    }
}
