﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Ventas;
using System.Data;


namespace Azteca.Web.Controllers.Ventas
{
    [Route("api/ventas/zonasventa")]
    public class ZonasVentaController : CatalogController<ZonaVentaFacade, ZonaVentaService, ZonaVentaInfo>
    {
        public ZonasVentaController()
            :base(new ZonaVentaFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadList(int IdEmpresa)
        {
            DataTable dtRet = new DataTable();

            try
            {
                ZonaVentaFacade Facade = new ZonaVentaFacade();
                dtRet = Facade.LoadList(SessionID, IdEmpresa);
            }
            catch (Exception ex)
            {
                HandleException("Mensaje de error", ex);
            }
            return dtRet;
        }

    }
}