﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Tesoreria;
using System.Data;
using Azteca.Kernel.Security;

namespace Azteca.Web.Controllers.Tesoreria
{
    [Route("api/tesoreria/cajas")]
    public class CajasController : CatalogController<CajaFacade, CajaService, CajaInfo>
    {
        public CajasController()
            :base(new CajaFacade())
        {

        }

        [HttpGet]
        [Route("load-list")]
        public DataTable LoadListByUser(int IdSucursal)
        {
            {
                DataTable dtRet = new DataTable();
                try
                {
                    CajaFacade Facade = new CajaFacade();
                    dtRet = Facade.LoadListByUser(SessionID, IdSucursal);
                }
                catch (Exception ex)
                {
                    HandleException(ex);
                }
                return dtRet;
            }
        }

        [HttpGet]
        [Route("members")]
        public List<UsuarioItem> GetMembers(int idCaja)
        {
            try
            {
                List<UsuarioItem> Users = Azteca.Kernel.Common.DataTableUtils.ToList<UsuarioItem>(Facade.LoadCajasAccesos(SessionID, idCaja));
                return Users;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
        }

        [HttpPost]
        [Route("add-members")]
        public void AddMembers(int idCaja, [FromBody] List<UsuarioItem> users)
        {
            try
            {
                users.ForEach(user =>
                {
                    Facade.InsertarAcceso(SessionID, idCaja, user.ID);
                });
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }

        [HttpDelete]
        [Route("remove-member")]
        public void DeleteMember(int idCaja, int idUser)
        {
            try
            {
                Facade.RemoverAcceso(SessionID, idCaja, idUser);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }

    }
}