﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Azteca.Web.Controllers.Kernel;
using Azteca.Business.Tesoreria;
using System.Data;
using Azteca.Kernel.Security;


namespace Azteca.Web.Controllers.Tesoreria
{
    [Route("api/tesoreria/operaciones-tipos")]
    public class OperacionesTiposController : CatalogController<OperacionTipoFacade, OperacionTipoService, OperacionTipoInfo>
    {
        public OperacionesTiposController()
            :base(new OperacionTipoFacade())
        {

        }

        [HttpGet]
        [Route("load-list-by-user")]
        public DataTable LoadListByUser(int IdSucursal)
        {
            {
                DataTable dtRet = new DataTable();
                try
                {
                    OperacionTipoFacade Facade = new OperacionTipoFacade();
                    dtRet = Facade.LoadListByUser(SessionID, IdSucursal);
                }
                catch (Exception ex)
                {
                    HandleException(ex);
                }
                return dtRet;
            }
        }

        [HttpGet]
        [Route("members")]
        public List<UsuarioItem> GetMembers(int idOperacionTipo)
        {
            try
            {
                List<UsuarioItem> Users = Azteca.Kernel.Common.DataTableUtils.ToList<UsuarioItem>(Facade.LoadAccesos(SessionID, idOperacionTipo));
                return Users;
            }
            catch (Exception ex)
            {
                HandleException(ex);
                return null;
            }
        }

        [HttpPost]
        [Route("add-members")]
        public void AddMembers(int idOperacionTipo, [FromBody] List<UsuarioItem> users)
        {
            try
            {
                users.ForEach(user =>
                {
                    Facade.InsertarAcceso(SessionID, idOperacionTipo, user.ID);
                });
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }

        [HttpDelete]
        [Route("remove-member")]
        public void DeleteMember(int idOperacionTipo, int idUser)
        {
            try
            {
                Facade.RemoverAcceso(SessionID, idOperacionTipo, idUser);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }

    }
}