"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var search_1 = require("framework3/search");
//Features
var banco_service_1 = require("../services/banco.service");
var banco_1 = require("../models/banco");
var cuenta_bancaria_service_1 = require("../services/cuenta-bancaria.service");
var wijmo_1 = require("wijmo/wijmo");
var BancosEditor = /** @class */ (function (_super) {
    __extends(BancosEditor, _super);
    //
    function BancosEditor(router, route, formBuilder, changeDetector, context, location, bancoService, cuentaBancariaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.bancoService = bancoService;
        _this.cuentaBancariaService = cuentaBancariaService;
        _this.banco = new banco_1.BancoInfo();
        _this.cuentasBancarias = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'codigoFiscal': ['', forms_1.Validators.required],
            'cuenta': ['']
        });
        return _this;
    }
    BancosEditor_1 = BancosEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    BancosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    BancosEditor.prototype.onCreatingItem = function () {
    };
    BancosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.bancoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.banco = info;
            _this.loadCuentasBancarias();
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    BancosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.bancoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.banco = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    BancosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.bancoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.banco = info;
            _this.loadCuentasBancarias();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    BancosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.bancoService.update(this.banco)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.banco.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.banco = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    BancosEditor.prototype.loadCuentasBancarias = function () {
        var _this = this;
        var request = new search_1.SearchRequest();
        request.paged = false;
        //Agregar condición de empresa actual
        var condicion = { field: "IdBanco", operator: "=", valueType: "int", value: this.banco.identity.toString() };
        request.conditions.push(condicion);
        //
        this.context.app.showSpinner();
        this.cuentaBancariaService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.cuentasBancarias = response.rows;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    BancosEditor.prototype.onSelectedTab = function (arg) {
        wijmo_1.Control.invalidateAll();
    };
    var BancosEditor_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], BancosEditor.prototype, "cuentasBancarias", void 0);
    BancosEditor = BancosEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-banco-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Banco'\"\n                                 [info]=\"banco\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"banco.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"banco.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\" (select)=\"onSelectedTab($event)\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'C&oacute;digo Fiscal:'\">\n                                          <az-textbox formControlName=\"codigoFiscal\" [(ngModel)]=\"banco.codigoFiscal\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"cuenta\" [(ngModel)]=\"banco.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                          </tab>\n                          <tab heading=\"Cuentas Bancarias\" (select)=\"onSelectedTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <contabilidad-cuentas-bancarias-manager [name]=\"'cuentasBancarias'\"\n                                                                       [cuentasBancarias]=\"cuentasBancarias\"\n                                                                       [idBanco]=\"banco.identity\"\n                                                                       (refreshListParent)=\"loadCuentasBancarias()\">\n                                      </contabilidad-cuentas-bancarias-manager>\n                                  </div>\n                              </div>\n                          </tab>\n\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return BancosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: banco_service_1.BancoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, banco_service_1.BancoService, cuenta_bancaria_service_1.CuentaBancariaService])
    ], BancosEditor);
    return BancosEditor;
}(editors_1.CatalogEditor));
exports.BancosEditor = BancosEditor;
