import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { CFDCertificadoService } from '../services/cfd-certificado.service';
import { CFDCertificadoInfo } from '../models/cfd-certificado';
import { SerieFiscalService } from '../services/serie-fiscal.service';
import { SerieFiscalItem } from '../models/serie-fiscal';
export declare class CFDCertificadosEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private cFDCertificadoService;
    private serieFiscalService;
    cfdCertificado: CFDCertificadoInfo;
    series: SerieFiscalItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, cFDCertificadoService: CFDCertificadoService, serieFiscalService: SerieFiscalService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onSelectedTab(arg: any): void;
    loadSeries(): void;
}
