"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var serie_fiscal_service_1 = require("../services/serie-fiscal.service");
var serie_fiscal_1 = require("../models/serie-fiscal");
var CFDSeriesEditor = /** @class */ (function (_super) {
    __extends(CFDSeriesEditor, _super);
    //
    function CFDSeriesEditor(router, route, formBuilder, changeDetector, context, location, serieFiscalService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.serieFiscalService = serieFiscalService;
        _this.seriefiscal = new serie_fiscal_1.SerieFiscalInfo();
        _this.catalogForm = formBuilder.group({
            'serie': ['', forms_1.Validators.required],
            'ultimoFolio': ['']
        });
        return _this;
    }
    CFDSeriesEditor_1 = CFDSeriesEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    CFDSeriesEditor.prototype.onConfigureCatalog = function (options) {
        var _this = this;
        this.route.params.forEach(function (params) {
            _this.IdCFDCertificado = +params['IdCFDCertificado'];
        });
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    CFDSeriesEditor.prototype.onCreatingItem = function () {
        this.seriefiscal.IdCFDCertificado = this.IdCFDCertificado;
    };
    CFDSeriesEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.serieFiscalService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.seriefiscal = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CFDSeriesEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.serieFiscalService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.seriefiscal = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CFDSeriesEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.serieFiscalService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.seriefiscal = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CFDSeriesEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.serieFiscalService.update(this.seriefiscal)
            .then(function (info) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.seriefiscal.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.seriefiscal = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CFDSeriesEditor.prototype.onCancelingEdit = function () {
        this.location.back();
    };
    var CFDSeriesEditor_1;
    CFDSeriesEditor = CFDSeriesEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-cfdseries-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Serie Fiscal'\"\n                                 [info]=\"seriefiscal\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'Serie:'\">\n                          <catalog-code formControlName=\"serie\" [(ngModel)]=\"seriefiscal.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Ultimo Folio:'\">\n                          <az-input-number formControlName=\"ultimoFolio\" [(ngModel)]=\"seriefiscal.ultimoFolio\"></az-input-number>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <!--<div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Tab1\">\n\n\t\t\t\t\t\t\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n\n                                      <azteca-form-field [label]=\"'Sample:'\">\n                                          <az-textbox formControlName=\"field\" [(ngModel)]=\"catalog.field\"></az-textbox>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n\t\t\t\t\t\t\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>-->\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CFDSeriesEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: serie_fiscal_service_1.SerieFiscalService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, serie_fiscal_service_1.SerieFiscalService])
    ], CFDSeriesEditor);
    return CFDSeriesEditor;
}(editors_1.CatalogEditor));
exports.CFDSeriesEditor = CFDSeriesEditor;
