import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { ToolbarButton } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs, TrackableCollection } from 'framework3/editors';
import { DomicilioInfo } from 'framework3/general';
import { ContribuyenteService } from '../services/contribuyente.service';
import { ContribuyenteInfo, UsoCFDIItem } from '../models/contribuyente';
import { ComprobanteCorreo } from '../models/comprobante-correo';
import { ComprobantesCorreoEditor } from '../components/comprobante-correo.editor';
export declare class ContribuyentesEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private contribuyenteService;
    contribuyente: ContribuyenteInfo;
    usosCFDI: UsoCFDIItem[];
    comprobantesCorreosCollection: TrackableCollection;
    comprobanteCorreoDialog: ComprobantesCorreoEditor;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, contribuyenteService: ContribuyenteService);
    ngAfterViewChecked(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadUsosCFDI(): void;
    domicilioChanged(domicilio: DomicilioInfo): void;
    onSelectTab(args: any): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onAgregarComprobanteCorreo(args: ComprobanteCorreo): void;
    onRemoveItem(item: any): void;
}
