"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Features
var contribuyente_service_1 = require("../services/contribuyente.service");
var contribuyente_1 = require("../models/contribuyente");
var comprobante_correo_editor_1 = require("../components/comprobante-correo.editor");
var ContribuyentesEditor = /** @class */ (function (_super) {
    __extends(ContribuyentesEditor, _super);
    //
    function ContribuyentesEditor(router, route, formBuilder, changeDetector, context, location, contribuyenteService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.contribuyenteService = contribuyenteService;
        _this.contribuyente = new contribuyente_1.ContribuyenteInfo();
        _this.usosCFDI = [];
        _this.comprobantesCorreosCollection = new editors_1.TrackableCollection();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'rfc': ['', forms_1.Validators.required],
            'razonSocial': ['', forms_1.Validators.required],
            'domicilio': [''],
            'correo': [''],
            'cuenta': [''],
            'idUsoCFDI': [0]
        });
        return _this;
    }
    ContribuyentesEditor_1 = ContribuyentesEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ContribuyentesEditor.prototype.ngAfterViewChecked = function () {
        this.comprobantesCorreosCollection.sourceCollection = this.contribuyente.comprobantesCorreos;
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ContribuyentesEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.loadUsosCFDI();
    };
    ContribuyentesEditor.prototype.onCreatingItem = function () {
    };
    ContribuyentesEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.contribuyenteService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.contribuyente = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContribuyentesEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.contribuyenteService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.contribuyente = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContribuyentesEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.contribuyenteService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.contribuyente = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContribuyentesEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.contribuyenteService.update(this.contribuyente)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.contribuyente = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContribuyentesEditor.prototype.loadUsosCFDI = function () {
        var _this = this;
        this.contribuyenteService.loadUsosCFDI(this.context.app.defaultCompany.identity)
            .then(function (usos) { return _this.usosCFDI = usos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContribuyentesEditor.prototype.domicilioChanged = function (domicilio) {
        this.contribuyente.domicilio = domicilio;
    };
    ContribuyentesEditor.prototype.onSelectTab = function (args) {
        if (args.heading) {
            wijmo_1.Control.invalidateAll();
        }
    };
    //Correos
    ContribuyentesEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.comprobanteCorreoDialog.show();
        }
    };
    ContribuyentesEditor.prototype.onAgregarComprobanteCorreo = function (args) {
        var _this = this;
        var comprobanteExists = false;
        this.contribuyente.comprobantesCorreos.forEach(function (comproMail) {
            if (comproMail.idComprobanteTipo == args.idComprobanteTipo && comproMail.state != 'DELETED') {
                _this.showAlert("El tipo de comprobante ya fue agregado", "danger");
                comprobanteExists = true;
            }
        });
        if (!comprobanteExists) {
            this.contribuyente.comprobantesCorreos.push(args);
            this.comprobantesCorreosCollection.refresh();
        }
    };
    ContribuyentesEditor.prototype.onRemoveItem = function (item) {
        this.comprobantesCorreosCollection.remove(item);
        this.comprobantesCorreosCollection.refresh();
    };
    var ContribuyentesEditor_1;
    __decorate([
        core_1.ViewChild(comprobante_correo_editor_1.ComprobantesCorreoEditor),
        __metadata("design:type", comprobante_correo_editor_1.ComprobantesCorreoEditor)
    ], ContribuyentesEditor.prototype, "comprobanteCorreoDialog", void 0);
    ContribuyentesEditor = ContribuyentesEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-contribuyentes-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Contribuyente'\"\n                                 [info]=\"contribuyente\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-6 col-md-5\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"contribuyente.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n\n                          <tab heading=\"Datos Fiscales\" (select)=\"onSelectTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-6 col-md-5\">\n                                      <azteca-form-field [label]=\"'RFC:'\">\n                                          <az-textbox formControlName=\"rfc\" [(ngModel)]=\"contribuyente.rfc\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-6 col-md-5\">\n                                      <azteca-form-field [label]=\"'Correo electronico:'\">\n                                          <az-textbox formControlName=\"correo\" [(ngModel)]=\"contribuyente.correo\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Raz\u00F3n Social:'\">\n                                          <az-textbox formControlName=\"razonSocial\" [(ngModel)]=\"contribuyente.razonSocial\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Uso de CFDI:'\">\n                                          <az-combobox formControlName=\"idUsoCFDI\"\n                                                       [(ngModel)]=\"contribuyente.idUsoCFDI\"\n                                                       [items]=\"usosCFDI\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"cuenta\" [(ngModel)]=\"contribuyente.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <tab heading=\"Domicilio Fiscal\" (select)=\"onSelectTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"''\">\n                                          <general-domicilio-editor formControlName=\"domicilio\"\n                                                                    [(ngModel)]=\"contribuyente.domicilio\"\n                                                                    (valueChanged)=\"domicilioChanged($event)\"\n                                                                    [cruceUnoVisible]=\"false\"\n                                                                    [cruceDosVisible]=\"false\">\n\n                                          </general-domicilio-editor>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </tab>\n\n                          <tab heading=\"Correos por comprobante\" (select)=\"onSelectTab($event)\">\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar Correo/Comprobante'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <wj-flex-grid #gridCorreos style=\"height:550px\"\n                                            [itemsSource]=\"comprobantesCorreosCollection\">\n\n                                  <wj-flex-grid-column [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveItem(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-trash\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n\n                                  <wj-flex-grid-column [header]=\"'Comprobante'\" [binding]=\"'comprobanteTipo'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'correo'\" [binding]=\"'correo'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </tab>\n\n                      </tabset>\n                  </div>\n              </div>\n\n\n          </azteca-catalog-editor>\n\n          <accounting-comprobante-correo (dataUpdater)=\"onAgregarComprobanteCorreo($event)\">\n\n          </accounting-comprobante-correo>\n\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ContribuyentesEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: contribuyente_service_1.ContribuyenteService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, contribuyente_service_1.ContribuyenteService])
    ], ContribuyentesEditor);
    return ContribuyentesEditor;
}(editors_1.CatalogEditor));
exports.ContribuyentesEditor = ContribuyentesEditor;
