import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { MenuItem } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { FormatoTipoService, FormatoItem } from 'framework3/general';
import { CuentaBancariaService } from '../services/cuenta-bancaria.service';
import { CuentaBancariaInfo } from '../models/cuenta-bancaria';
export declare class CuentasBancariasEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private cuentaBancariaService;
    private formatoTipoService;
    cuentaBancaria: CuentaBancariaInfo;
    idBanco: number;
    formatosImpresion: FormatoItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, cuentaBancariaService: CuentaBancariaService, formatoTipoService: FormatoTipoService);
    loadFormatosImpresion(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onCancelingEdit(): void;
    onMenuItemClick(option: MenuItem): void;
}
