"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var general_1 = require("framework3/general");
//Features
var cuenta_bancaria_service_1 = require("../services/cuenta-bancaria.service");
var cuenta_bancaria_1 = require("../models/cuenta-bancaria");
var CuentasBancariasEditor = /** @class */ (function (_super) {
    __extends(CuentasBancariasEditor, _super);
    //
    function CuentasBancariasEditor(router, route, formBuilder, changeDetector, context, location, cuentaBancariaService, formatoTipoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.cuentaBancariaService = cuentaBancariaService;
        _this.formatoTipoService = formatoTipoService;
        _this.cuentaBancaria = new cuenta_bancaria_1.CuentaBancariaInfo();
        _this.formatosImpresion = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'cuenta': ['', forms_1.Validators.required],
            'clabe': ['', forms_1.Validators.required],
            'idFormato': [''],
            'idCuenta': [''],
        });
        return _this;
    }
    CuentasBancariasEditor_1 = CuentasBancariasEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    CuentasBancariasEditor.prototype.loadFormatosImpresion = function () {
        var _this = this;
        this.formatoTipoService.loadFormatos('CHECKS', this.context.app.defaultCompany.identity)
            .then(function (formatos) {
            _this.formatosImpresion = formatos;
            _this.formatosImpresion.unshift({ id: 0, nombre: '[NINGUNO]', activo: true, codigo: '' });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    CuentasBancariasEditor.prototype.onConfigureCatalog = function (options) {
        var _this = this;
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.route.params.forEach(function (params) {
            _this.idBanco = +params['idBanco'];
        });
        this.loadFormatosImpresion();
        this.cuentaBancaria.idBanco = this.idBanco;
    };
    CuentasBancariasEditor.prototype.onCreatingItem = function () {
        this.cuentaBancaria.idBanco = this.idBanco;
    };
    CuentasBancariasEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.cuentaBancariaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cuentaBancaria = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasBancariasEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.cuentaBancariaService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cuentaBancaria = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasBancariasEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.cuentaBancariaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cuentaBancaria = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasBancariasEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.cuentaBancariaService.update(this.cuentaBancaria)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.cuentaBancaria.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.location.back();
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.cuentaBancaria = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasBancariasEditor.prototype.onCancelingEdit = function () {
        this.location.back();
    };
    CuentasBancariasEditor.prototype.onMenuItemClick = function (option) {
        if (option.name == 'USERS') {
            this.router.navigate(['members'], { relativeTo: this.route });
        }
    };
    var CuentasBancariasEditor_1;
    CuentasBancariasEditor = CuentasBancariasEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-cuenta-bancaria-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'CuentaBancaria'\"\n                                 [info]=\"cuentaBancaria\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Miembros'\" [smallText]=\"'editar usuarios miembro'\"></azteca-menu-item>\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"cuentaBancaria.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"cuentaBancaria.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n\n                          <tab heading=\"Generales\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'Numero Cuenta:'\">\n                                          <az-textbox formControlName=\"cuenta\" [(ngModel)]=\"cuentaBancaria.cuenta\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'CLABE:'\">\n                                          <az-textbox formControlName=\"clabe\" [(ngModel)]=\"cuentaBancaria.clabe\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'Formato impresi\u00F3n:'\">\n                                          <az-combobox formControlName=\"idFormato\" [(ngModel)]=\"cuentaBancaria.idFormato\" [items]=\"formatosImpresion\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <azteca-form-field [label]=\"'Cuenta Contable:'\">\n                                  <accounting-cuenta-selector formControlName=\"idCuenta\" [(ngModel)]=\"cuentaBancaria.idCuenta\"></accounting-cuenta-selector>\n                              </azteca-form-field>\n\n                          </tab>\n\n                      </tabset>\n                  </div>\n              </div>\n\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CuentasBancariasEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: cuenta_bancaria_service_1.CuentaBancariaService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, cuenta_bancaria_service_1.CuentaBancariaService, general_1.FormatoTipoService])
    ], CuentasBancariasEditor);
    return CuentasBancariasEditor;
}(editors_1.CatalogEditor));
exports.CuentasBancariasEditor = CuentasBancariasEditor;
