import { EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogManager } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { MenuItem } from 'framework3/controls';
import { CuentaBancariaService } from '../services/cuenta-bancaria.service';
import { CuentaBancariaItem } from '../models/cuenta-bancaria';
export declare class CuentasBancariasManager extends CatalogManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private cuentaBancariaService;
    cuentasBancarias: CuentaBancariaItem[];
    idBanco: number;
    refreshListParent: EventEmitter<void>;
    constructor(context: Context, router: Router, route: ActivatedRoute, cuentaBancariaService: CuentaBancariaService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
    onMenuItemClick(option: MenuItem): void;
}
