"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var cuenta_bancaria_service_1 = require("../services/cuenta-bancaria.service");
var CuentasBancariasManager = /** @class */ (function (_super) {
    __extends(CuentasBancariasManager, _super);
    //    
    function CuentasBancariasManager(context, router, route, cuentaBancariaService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.cuentaBancariaService = cuentaBancariaService;
        _this.cuentasBancarias = [];
        _this.refreshListParent = new core_1.EventEmitter();
        return _this;
    }
    CuentasBancariasManager_1 = CuentasBancariasManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    CuentasBancariasManager.prototype.onConfigureCatalog = function (options) {
        //this.manager.serverSide = options.busquedasServidor;
        //this.manager.pageSize = options.tamanioPagina;        
        //this.refreshList();
        this.applyPolicies();
    };
    CuentasBancariasManager.prototype.doSearch = function (request) {
        //this.context.app.showSpinner();
        //this.cuentaBancariaService.search(this.context.app.defaultSite.identity, request)
        //    .then(response => {
        //        this.context.app.hideSpinner();
        //        //
        //        this.cuentasBancarias = response.rows;
        //        this.totalRows = response.totalRows;
        //        this.pageIndex = request.pageIndex;                                
        //    })
        //    .catch(error => this.handleError(error));
    };
    CuentasBancariasManager.prototype.onAddingItem = function () {
        this.router.navigate(['accounting/cuentas-bancarias', this.process.id, this.idBanco, 0]);
    };
    CuentasBancariasManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    CuentasBancariasManager.prototype.onEditingItem = function (item) {
        this.router.navigate(['accounting/cuentas-bancarias', this.process.id, this.idBanco, item.id]);
    };
    CuentasBancariasManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.cuentaBancariaService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
            _this.refreshListParent.emit();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasBancariasManager.prototype.onCloningItem = function (item) {
        this.router.navigate(['accounting/cuentas-bancarias', this.process.id, this.idBanco, 0, { cloneId: item.id }]);
    };
    CuentasBancariasManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.cuentaBancariaService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
            _this.refreshListParent.emit();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasBancariasManager.prototype.onMenuItemClick = function (option) {
        if (option.name == 'USERS') {
            this.router.navigate([this.manager.currentItem.id.toString() + '/members'], { relativeTo: this.route });
        }
    };
    var CuentasBancariasManager_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], CuentasBancariasManager.prototype, "cuentasBancarias", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CuentasBancariasManager.prototype, "idBanco", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], CuentasBancariasManager.prototype, "refreshListParent", void 0);
    CuentasBancariasManager = CuentasBancariasManager_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-cuentas-bancarias-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Contabilidad - Cuentas Bancarias</div>\n          <div class=\"card-block\">\n\n              <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                                      (addingItem)=\"onAddingItem()\"\n                                      (viewingItem)=\"onViewingItem($event)\"\n                                      (editingItem)=\"onEditingItem($event)\"\n                                      (deletingItem)=\"onDeletingItem($event)\"\n                                      (cloningItem)=\"onCloningItem($event)\"\n                                      (changingItemState)=\"onChangingItemState($event)\"\n                                      (configureCatalog)=\"onConfigureCatalog($event)\"\n                                      [enabled]=\"enabled\"\n                                      [allowNew]=\"allowNew\"\n                                      [allowView]=\"allowView\"\n                                      [allowEdit]=\"allowEdit\"\n                                      [allowDelete]=\"allowDelete\"\n                                      [allowClone]=\"allowClone\"\n                                      [allowChangeState]=\"allowChangeState\"\n                                      [allowAudit]=\"allowAudit\"\n                                      [catalogList]=\"cuentasBancarias\"\n                                      [totalRows]=\"totalRows\"\n                                      [pageIndex]=\"pageIndex\"\n                                      [standAlone]=\"false\"\n                                      [serverSide]=\"false\"\n                                      (menuItemClick)=\"onMenuItemClick($event)\">\n            \n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Miembros'\" [smallText]=\"'editar usuarios miembro'\"></azteca-menu-item>\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Cuenta'\" [binding]=\"'cuenta'\" [width]=\"'60*'\"></azteca-grid-column>\n\n              </azteca-catalog-manager>\n\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CuentasBancariasManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: cuenta_bancaria_service_1.CuentaBancariaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, cuenta_bancaria_service_1.CuentaBancariaService])
    ], CuentasBancariasManager);
    return CuentasBancariasManager;
}(editors_1.CatalogManager));
exports.CuentasBancariasManager = CuentasBancariasManager;
