import { ChangeDetectorRef } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { TreeNode } from 'angular-tree-component';
import { Context, HierarchyChanges } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { HierarchyManager } from 'framework3/editors';
import { CuentaInfo, CuentaTipoItem } from '../models/cuenta';
import { CuentaService } from '../services/cuenta.service';
import { DivisaItem } from '../models/divisa';
import { DivisaService } from '../services/divisa.service';
import { SegmentoNegocioService } from '../services/segmento-negocio.service';
import { SegmentoNegocioItem } from '../models/segmento-negocio';
export declare class CuentasManager extends HierarchyManager {
    protected context: Context;
    protected changeDetector: ChangeDetectorRef;
    private formBuilder;
    private cuentaService;
    private divisaService;
    protected router: Router;
    protected route: ActivatedRoute;
    private segmentoNegocioService;
    cuentas: CuentaInfo[];
    cuentaEdicion: CuentaInfo;
    currentNode: TreeNode;
    currentParent: TreeNode;
    cuentasTipo: CuentaTipoItem[];
    divisas: DivisaItem[];
    segmentosNegocio: SegmentoNegocioItem[];
    constructor(context: Context, changeDetector: ChangeDetectorRef, formBuilder: FormBuilder, cuentaService: CuentaService, divisaService: DivisaService, router: Router, route: ActivatedRoute, segmentoNegocioService: SegmentoNegocioService);
    loadHierarchy(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onNodesChanged(cuentas: CuentaInfo[]): void;
    onCurrentNodeChanged(node: TreeNode): void;
    onCreatingNode(parentNode: TreeNode): void;
    onEditingNode(node: TreeNode): void;
    onSavingNode(): void;
    onDeletingNode(node: TreeNode): void;
    onSavingHierarchy(changes: HierarchyChanges<CuentaInfo>): void;
    loadCuentastipos(): void;
    loadDivisas(): void;
    loadSegmentosNegocio(): void;
}
