"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
//
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var controls_1 = require("framework3/controls");
//
var cuenta_1 = require("../models/cuenta");
var cuenta_service_1 = require("../services/cuenta.service");
var divisa_service_1 = require("../services/divisa.service");
var segmento_negocio_service_1 = require("../services/segmento-negocio.service");
var CuentasManager = /** @class */ (function (_super) {
    __extends(CuentasManager, _super);
    function CuentasManager(context, changeDetector, formBuilder, cuentaService, divisaService, router, route, segmentoNegocioService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.context = context;
        _this.changeDetector = changeDetector;
        _this.formBuilder = formBuilder;
        _this.cuentaService = cuentaService;
        _this.divisaService = divisaService;
        _this.router = router;
        _this.route = route;
        _this.segmentoNegocioService = segmentoNegocioService;
        _this.cuentas = [];
        _this.cuentaEdicion = new cuenta_1.CuentaInfo();
        //
        _this.cuentasTipo = [];
        _this.divisas = [];
        _this.segmentosNegocio = [];
        _this.nodeForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idCuentaTipo': [0, controls_1.AztecaValidators.selected],
            'idCategoriaFlujo': [0],
            'idDivisa': [0],
            'idSegmentoNegocio': [0],
            'afectable': [false],
            'agrupadorSAT': ['']
        });
        return _this;
    }
    CuentasManager_1 = CuentasManager;
    ////////////////////// METODOS //////////////////////////////////////////////
    CuentasManager.prototype.loadHierarchy = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.cuentaService.loadHierarchy(this.context.app.defaultCompany.identity, 0)
            .then(function (nodes) {
            _this.context.app.hideSpinner();
            _this.cuentas = nodes;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //////////////////// HANDLERS //////////////////////////////////////
    CuentasManager.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.loadHierarchy();
        //Hacer llamadas de carga inicial de datos aquí
        this.loadCuentastipos();
        //this.loadDivisas();
        this.loadSegmentosNegocio();
    };
    CuentasManager.prototype.onNodesChanged = function (cuentas) {
        this.cuentas = cuentas;
    };
    CuentasManager.prototype.onCurrentNodeChanged = function (node) {
        this.currentNode = node;
    };
    CuentasManager.prototype.onCreatingNode = function (parentNode) {
        this.cuentaEdicion = new cuenta_1.CuentaInfo(); //Crear nueva instancia para evitar que reset modifique la información del último nodo en edición
        this.nodeForm.reset();
        this.cuentaEdicion = new cuenta_1.CuentaInfo(); //Se vuelve a crear instancia para evitar valores nulos creados por reset
        //Inicializar valores del nodo
        this.cuentaEdicion.idBranch = this.context.app.defaultSite.identity;
        this.cuentaEdicion.idCompany = this.context.app.defaultCompany.identity;
        //
        this.currentParent = parentNode;
        this.showEditor();
    };
    CuentasManager.prototype.onEditingNode = function (node) {
        //this.cuentaEdicion = this.cuentas.find(x => x.identity = node.data.identity)
        this.cuentaEdicion = this.cuentaService.copy(node.data);
        this.showEditor();
    };
    CuentasManager.prototype.onSavingNode = function () {
        //Si es un nuevo nodo
        if (this.cuentaEdicion.clientID == 0) {
            this.addNode(this.cuentaEdicion, this.currentParent);
        }
        //Si se estaba editando un nodo existente
        else {
            this.updateNode(this.cuentaEdicion);
        }
        this.cuentaEdicion = new cuenta_1.CuentaInfo();
        this.hideEditor();
    };
    CuentasManager.prototype.onDeletingNode = function (node) {
        this.deleteNode(node);
    };
    CuentasManager.prototype.onSavingHierarchy = function (changes) {
        var _this = this;
        this.context.app.showSpinner();
        this.cuentaService.saveHierarchy(changes)
            .then(function (cuentas) {
            _this.cuentas = cuentas;
            _this.reset();
            _this.context.app.hideSpinner();
            _this.showAlert('Los cambios han sido guardados con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasManager.prototype.loadCuentastipos = function () {
        var _this = this;
        this.cuentaService.loadTipos(this.context.app.defaultCompany.identity.toString())
            .then(function (tipos) { return _this.cuentasTipo = tipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasManager.prototype.loadDivisas = function () {
        var _this = this;
        this.divisaService.loadList(this.context.app.defaultCompany.identity)
            .then(function (divisas) { return _this.divisas = divisas; })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasManager.prototype.loadSegmentosNegocio = function () {
        var _this = this;
        this.segmentoNegocioService.loadList(this.context.app.defaultCompany.identity)
            .then(function (items) { return _this.segmentosNegocio = items; })
            .catch(function (error) { return _this.handleError(error); });
    };
    var CuentasManager_1;
    CuentasManager = CuentasManager_1 = __decorate([
        core_1.Component({
            selector: 'accounting-cuentas-manager',
            template: "\n      <azteca-hierarchy-manager (configureCatalog)=\"onConfigureCatalog($event)\"\n                                (currentNodeChanged)=\"onCurrentNodeChanged($event)\"\n                                (creatingNode)=\"onCreatingNode($event)\"\n                                (editingNode)=\"onEditingNode($event)\"\n                                (savingNode)=\"onSavingNode()\"\n                                (deletingNode)=\"onDeletingNode($event)\"\n                                (savingHierarchy)=\"onSavingHierarchy($event)\"\n                                (nodesChanged)=\"onNodesChanged($event)\"\n                                [title]=\"'Administraci\u00F3n de cuentas'\"\n                                [validForm]=\"nodeForm.valid\"\n                                [currentNode]=\"currentNode\"\n                                [displayField]=\"cuentaNombre\"\n                                [nodes]=\"cuentas\">\n\n          <!------------------- Menu de acciones adicionales --------------------->\n      \t<!--\n          <azteca-menu-item [name]=\"'OPT1'\" [icon]=\"'glyphicon glyphicon-cog'\" [text]=\"'Opci\u00F3n1'\" [smallText]=\"'descripci\u00F3n de opci\u00F3n'\"></azteca-menu-item>\n      \t-->\n\n          <!------------------- Formulario de edici\u00F3n  --------------------->\n          <form [formGroup]=\"nodeForm\">\n              <div class=\"row\">\n\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"cuentaEdicion.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <label class=\"control-label\">Ruta:</label>\n                      <az-label [text]=\"cuentaEdicion.namedPath\"></az-label>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"cuentaEdicion.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Tipo:'\">\n                          <az-combobox formControlName=\"idCuentaTipo\"\n                                       [(ngModel)]=\"cuentaEdicion.idCuentaTipo\"\n                                       [items]=\"cuentasTipo\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\">\n                          </az-combobox>\n                      </azteca-form-field>\n\n                      <az-checkbox formControlName=\"afectable\" [label]=\"'Afectable'\" [(ngModel)]=\"cuentaEdicion.afectable\"></az-checkbox>\n\n                      <azteca-form-field [label]=\"'Categoria de Flujo:'\">\n                          <accounting-flujo-selector formControlName=\"idCategoriaFlujo\" [(ngModel)]=\"cuentaEdicion.idCategoriaFlujo\"></accounting-flujo-selector>\n                      </azteca-form-field>\n\n                \n                      <azteca-form-field [label]=\"'Divisa:'\">\n                          <accounting-divisas-selector formControlName=\"idDivisa\" [(ngModel)]=\"cuentaEdicion.idDivisa\"></accounting-divisas-selector>\n                      </azteca-form-field>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-10\">\n                              <tabset>\n                                  <tab heading=\"General\">\n                                      <azteca-form-field [label]=\"'Segmento de negocio:'\">\n                                          <az-combobox formControlName=\"idSegmentoNegocio\"\n                                                       [(ngModel)]=\"cuentaEdicion.idSegmentoNegocio\"\n                                                       [items]=\"segmentosNegocio\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </tab>\n                              </tabset>\n                          </div>\n                      </div>\n\n\n                      <azteca-form-field [label]=\"'Agrupador SAT:'\">\n                          <az-textbox formControlName=\"agrupadorSAT\" [(ngModel)]=\"cuentaEdicion.agrupadorSAT\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n          </form>\n\n      </azteca-hierarchy-manager>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CuentasManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: cuenta_service_1.CuentaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, core_1.ChangeDetectorRef, forms_1.FormBuilder,
            cuenta_service_1.CuentaService, divisa_service_1.DivisaService, router_1.Router, router_1.ActivatedRoute,
            segmento_negocio_service_1.SegmentoNegocioService])
    ], CuentasManager);
    return CuentasManager;
}(editors_1.HierarchyManager));
exports.CuentasManager = CuentasManager;
