import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { EnsambladoService } from 'framework3/core/services/ensamblado.service';
import { DocumentTypeService } from 'framework3/core/services/document-type.service';
import { EnsambladoItem } from 'framework3/core/models/ensamblado';
import { EsquemaService } from '../services/esquema.service';
import { EsquemaInfo } from '../models/esquema';
export declare class EsquemasEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private esquemaService;
    private ensambladoSvc;
    private documentTypeSvc;
    esquema: EsquemaInfo;
    origenes: {
        "id": string;
        "nombre": string;
    }[];
    ensamblados: EnsambladoItem[];
    documentsTypes: any[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, esquemaService: EsquemaService, ensambladoSvc: EnsambladoService, documentTypeSvc: DocumentTypeService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    cargarEnsamblados(): void;
    cargarDocumentsTypes(): void;
}
