"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var ensamblado_service_1 = require("framework3/core/services/ensamblado.service");
var document_type_service_1 = require("framework3/core/services/document-type.service");
//Features
var esquema_service_1 = require("../services/esquema.service");
var esquema_1 = require("../models/esquema");
var EsquemasEditor = /** @class */ (function (_super) {
    __extends(EsquemasEditor, _super);
    //
    function EsquemasEditor(router, route, formBuilder, changeDetector, context, location, esquemaService, ensambladoSvc, documentTypeSvc) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.esquemaService = esquemaService;
        _this.ensambladoSvc = ensambladoSvc;
        _this.documentTypeSvc = documentTypeSvc;
        _this.esquema = new esquema_1.EsquemaInfo();
        _this.origenes = [{ "id": "D", "nombre": "Documento" }, { "id": "C", "nombre": "Clase" }];
        _this.ensamblados = [];
        _this.documentsTypes = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'origen': ['', forms_1.Validators.required],
            'documentType': [''],
            'ensamblado': [''],
            'clase': ['']
        });
        return _this;
    }
    EsquemasEditor_1 = EsquemasEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    EsquemasEditor.prototype.onConfigureCatalog = function (options) {
        var _this = this;
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        setTimeout(function (_) {
            _this.cargarEnsamblados();
            _this.cargarDocumentsTypes();
        });
    };
    EsquemasEditor.prototype.onCreatingItem = function () {
    };
    EsquemasEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.esquemaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.esquema = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EsquemasEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.esquemaService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.esquema = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EsquemasEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.esquemaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.esquema = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EsquemasEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.esquemaService.update(this.esquema)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.esquema.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.esquema = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////////////// METODOS ///////////////////////////////////////
    EsquemasEditor.prototype.cargarEnsamblados = function () {
        var _this = this;
        this.ensambladoSvc.loadList()
            .then(function (ensamblados) {
            _this.ensamblados = ensamblados;
            _this.ensamblados.unshift({ id: 0, codigo: '', nombre: '[NINGUNO]', activo: true });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EsquemasEditor.prototype.cargarDocumentsTypes = function () {
        var _this = this;
        this.documentTypeSvc.loadList()
            .then(function (result) {
            _this.documentsTypes = result;
            _this.documentsTypes.unshift({ id: 0, nombre: '[NINGUNO]' });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var EsquemasEditor_1;
    EsquemasEditor = EsquemasEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-esquema-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Esquema'\"\n                                 [info]=\"esquema\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"esquema.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"esquema.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n\n                                      <azteca-form-field [label]=\"'Origen:'\">\n                                          <az-combobox formControlName=\"origen\"\n                                                       [(ngModel)]=\"esquema.origen\"\n                                                       [items]=\"origenes\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\"></az-combobox>\n                                      </azteca-form-field>\n\n\n                                      <azteca-form-field [label]=\"'Documento:'\">\n                                          <az-combobox formControlName=\"documentType\"\n                                                       [items]=\"ensamblados\" [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [(ngModel)]=\"esquema.idTipoDocumento\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n\n                                      <azteca-form-field [label]=\"'Ensamblado:'\">\n                                          <az-combobox formControlName=\"ensamblado\"\n                                                       [(ngModel)]=\"esquema.idEnsamblado\"\n                                                       [items]=\"ensamblados\" [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Clase:'\">\n                                          <az-textbox formControlName=\"clase\"\n                                                      [(ngModel)]=\"esquema.clase\">\n                                          </az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return EsquemasEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: esquema_service_1.EsquemaService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, esquema_service_1.EsquemaService, ensamblado_service_1.EnsambladoService, document_type_service_1.DocumentTypeService])
    ], EsquemasEditor);
    return EsquemasEditor;
}(editors_1.CatalogEditor));
exports.EsquemasEditor = EsquemasEditor;
