import { ChangeDetectorRef } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { TreeNode } from 'angular-tree-component';
import { Context, HierarchyChanges } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { HierarchyManager } from 'framework3/editors';
import { FlujoInfo } from '../models/flujo';
import { FlujoService } from '../services/flujo.service';
export declare class FlujoManager extends HierarchyManager {
    protected context: Context;
    protected changeDetector: ChangeDetectorRef;
    private formBuilder;
    private flujoService;
    protected router: Router;
    protected route: ActivatedRoute;
    flujo: FlujoInfo[];
    flujoEdicion: FlujoInfo;
    currentNode: TreeNode;
    currentParent: TreeNode;
    constructor(context: Context, changeDetector: ChangeDetectorRef, formBuilder: FormBuilder, flujoService: FlujoService, router: Router, route: ActivatedRoute);
    loadHierarchy(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onNodesChanged(flujo: FlujoInfo[]): void;
    onCurrentNodeChanged(node: TreeNode): void;
    onCreatingNode(parentNode: TreeNode): void;
    onEditingNode(node: TreeNode): void;
    onSavingNode(): void;
    onDeletingNode(node: TreeNode): void;
    onSavingHierarchy(changes: HierarchyChanges<FlujoInfo>): void;
}
