import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { ImpuestoService } from '../services/impuesto.service';
import { ImpuestoInfo, ImpuestoTipoItem } from '../models/impuesto';
export declare class ImpuestosEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private impuestoService;
    impuesto: ImpuestoInfo;
    impuestosTipo: ImpuestoTipoItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, impuestoService: ImpuestoService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadTipos(): void;
}
