import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogManager } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { ListaNegraService } from '../services/lista-negra.service';
import { ListaNegraItem } from '../models/lista-negra';
import { ModalDirective } from 'ngx-bootstrap';
import { MenuItem } from 'framework3/controls';
import { FileInfo } from 'framework3/general';
export declare class ListaNegraManager extends CatalogManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private listaNegraService;
    file: FileInfo;
    textMenu: string;
    currentItem: CatalogItem;
    listaNegra: ListaNegraItem[];
    dialogFile: ModalDirective;
    constructor(context: Context, router: Router, route: ActivatedRoute, listaNegraService: ListaNegraService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
    onCurrentItemChanged(item: CatalogItem): void;
    onMenuItemClick(option: MenuItem): void;
    onSelectFile(): void;
}
