"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var lista_negra_service_1 = require("../services/lista-negra.service");
var ngx_bootstrap_1 = require("ngx-bootstrap");
var general_1 = require("framework3/general");
var ListaNegraManager = /** @class */ (function (_super) {
    __extends(ListaNegraManager, _super);
    //    
    function ListaNegraManager(context, router, route, listaNegraService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.listaNegraService = listaNegraService;
        _this.file = new general_1.FileInfo();
        _this.textMenu = '';
        _this.currentItem = null;
        _this.listaNegra = [];
        return _this;
    }
    ListaNegraManager_1 = ListaNegraManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ListaNegraManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
        this.refreshList();
        this.applyPolicies();
    };
    ListaNegraManager.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.listaNegraService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.listaNegra = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ListaNegraManager.prototype.onAddingItem = function () {
        this.router.navigate([0], { relativeTo: this.route });
    };
    ListaNegraManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    ListaNegraManager.prototype.onEditingItem = function (item) {
        this.router.navigate([item.id], { relativeTo: this.route });
    };
    ListaNegraManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.listaNegraService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ListaNegraManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    ListaNegraManager.prototype.onChangingItemState = function (item) {
        this.showAlert('Acción no permitida', 'success');
        //this.listaNegraService.changeStatus(item.id, !item.activo)
        //    .then(success => {
        //        this.refreshList();
        //        this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');                
        //    })
        //    .catch(error => this.handleError(error));
    };
    ListaNegraManager.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
        if (item.activo)
            this.textMenu = 'Bloquear EFO';
        else
            this.textMenu = 'Permitir EFO';
    };
    ListaNegraManager.prototype.onMenuItemClick = function (option) {
        var _this = this;
        if (option.name == "UPLOADFILE") {
            this.dialogFile.config.backdrop = false;
            this.dialogFile.show();
        }
        else if (option.name == "PERMITTED") {
            this.listaNegraService.permitirEFO(this.currentItem.id, this.context.session.user.identity, this.context.app.defaultCompany.idCompany, !this.currentItem.activo)
                .then(function (success) {
                _this.refreshList();
                _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == 'DELETEFILE') {
            this.context.app.showSpinner();
            this.listaNegraService.eliminarFirmas()
                .then(function (success) {
                _this.context.app.hideSpinner();
                _this.showAlert("Se eliminaron las imagenes", 'success');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    ListaNegraManager.prototype.onSelectFile = function () {
        var _this = this;
        if (this.file.extension == 'csv') {
            this.context.app.showSpinner();
            this.listaNegraService.listaFromFile(this.file, this.context.app.defaultCompany.idCompany, this.context.app.defaultCompany.idBranch)
                .then(function (success) {
                _this.context.app.hideSpinner();
                _this.dialogFile.hide();
                _this.refreshList();
                _this.showAlert("Se insertaron correctamente", 'success');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.showAlert('Tiene que ser un archivo CSV', 'error');
        }
    };
    var ListaNegraManager_1;
    __decorate([
        core_1.ViewChild('dialogFile'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ListaNegraManager.prototype, "dialogFile", void 0);
    ListaNegraManager = ListaNegraManager_1 = __decorate([
        core_1.Component({
            selector: 'azteca.business.contabilidad-lista-negra-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Lista Negra</div>\n          <div class=\"card-block\">\n\n              <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                                      (addingItem)=\"onAddingItem()\"\n                                      (viewingItem)=\"onViewingItem($event)\"\n                                      (editingItem)=\"onEditingItem($event)\"\n                                      (deletingItem)=\"onDeletingItem($event)\"\n                                      (cloningItem)=\"onCloningItem($event)\"\n                                      (changingItemState)=\"onChangingItemState($event)\"\n                                      (configureCatalog)=\"onConfigureCatalog($event)\"\n                                      (menuItemClick)=\"onMenuItemClick($event)\"\n                                      (currentItemChanged)=\"onCurrentItemChanged($event)\"\n                                      [enabled]=\"enabled\"\n                                      [allowNew]=\"allowNew\"\n                                      [allowView]=\"allowView\"\n                                      [allowEdit]=\"allowEdit\"\n                                      [allowDelete]=\"allowDelete\"\n                                      [allowClone]=\"allowClone\"\n                                      [allowChangeState]=\"allowChangeState\"\n                                      [allowAudit]=\"allowAudit\"\n                                      [catalogList]=\"listaNegra\"\n                                      [totalRows]=\"totalRows\"\n                                      [pageIndex]=\"pageIndex\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'UPLOADFILE'\" [icon]=\"'glyphicon glyphicon-open'\" [text]=\"'Subir Listado'\" [smallText]=\"'Subir el listado de EFO\u00B4s y EDO\u00B4s'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'PERMITTED'\" [icon]=\"'glyphicon glyphicon-ok'\" [text]=\"textMenu\" [smallText]=\"'Permitir el uso del RFC para Gastos y OC'\"></azteca-menu-item>\n                  <!--<azteca-menu-item [name]=\"'DELETEFILE'\" [icon]=\"'glyphicon glyphicon-open'\" [text]=\"'Eliminar fimras'\" [smallText]=\"'eliminar firmas temporal'\"></azteca-menu-item>-->\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n\n              </azteca-catalog-manager>\n\n          </div>\n      </div>\n\n\n      <div bsModal #dialogFile=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\">Selecciona el archivo con el listado</h4>\n                  </div>\n                  <div class=\"modal-body\">\n                      <azteca-file-box  [(ngModel)]=\"file\" ></azteca-file-box>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialogFile.hide()\">Cancelar</button>\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onSelectFile()\" [disabled]=\"(fileSelected == '')\">Aceptar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ListaNegraManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: lista_negra_service_1.ListaNegraService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, lista_negra_service_1.ListaNegraService])
    ], ListaNegraManager);
    return ListaNegraManager;
}(editors_1.CatalogManager));
exports.ListaNegraManager = ListaNegraManager;
