"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var pac_service_1 = require("../services/pac.service");
var pac_1 = require("../models/pac");
var PACsEditor = /** @class */ (function (_super) {
    __extends(PACsEditor, _super);
    //
    function PACsEditor(router, route, formBuilder, changeDetector, context, location, pACService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.pACService = pACService;
        _this.pac = new pac_1.PACInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'clase': ['', forms_1.Validators.required],
            'ensamblado': ['', forms_1.Validators.required],
            'usuario': ['', forms_1.Validators.required],
            'password': ['', forms_1.Validators.required],
            'urlLogin': [''],
            'urlTimbrado': [''],
            'urlCancelacion': ['']
        });
        return _this;
    }
    PACsEditor_1 = PACsEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS //////////////////////////////////////
    PACsEditor.prototype.onConfigureCatalog = function (options) {
        //this.autogeneratedCode = options.codigoAutogenerado;
    };
    PACsEditor.prototype.onCreatingItem = function () {
    };
    PACsEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.pACService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.pac = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PACsEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.pACService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.pac = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PACsEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.pACService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.pac = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PACsEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.pACService.update(this.pac)
            .then(function (info) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.pac.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.pac = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var PACsEditor_1;
    PACsEditor = PACsEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-pacs-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'PAC'\"\n                                 [info]=\"pac\"\n                                 [valid]=\"valid\"                           \n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"pac.code\" [automatic]=\"true\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"pac.nombre\" [enabled]=\"false\"></az-textbox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Configuraci\u00F3n\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n\n                                      <azteca-form-field [label]=\"'Usuario:'\">\n                                          <az-textbox formControlName=\"usuario\" [(ngModel)]=\"pac.usuario\"></az-textbox>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Contrase\u00F1a:'\">\n                                          <az-password formControlName=\"password\" [(ngModel)]=\"pac.password\"></az-password>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Url autenticaci\u00F3n:'\">\n                                          <az-textbox formControlName=\"urlLogin\" [(ngModel)]=\"pac.urlLogin\"></az-textbox>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Url Timbrado:'\">\n                                          <az-textbox formControlName=\"urlTimbrado\" [(ngModel)]=\"pac.urlTimbrado\"></az-textbox>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Url Cancelaci\u00F3n:'\">\n                                          <az-textbox formControlName=\"urlCancelacion\" [(ngModel)]=\"pac.urlCancelacion\"></az-textbox>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n                          </tab>\n                          <tab heading=\"Controlador\">\n                              <azteca-form-field [label]=\"'Clase:'\">\n                                  <az-textbox formControlName=\"clase\" [(ngModel)]=\"pac.clase\"></az-textbox>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Ensamblado:'\">\n                                  <az-textbox formControlName=\"ensamblado\" [(ngModel)]=\"pac.ensamblado\"></az-textbox>\n                              </azteca-form-field>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return PACsEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: pac_service_1.PACService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, pac_service_1.PACService])
    ], PACsEditor);
    return PACsEditor;
}(editors_1.CatalogEditor));
exports.PACsEditor = PACsEditor;
