"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var pac_service_1 = require("../services/pac.service");
var PACsManager = /** @class */ (function (_super) {
    __extends(PACsManager, _super);
    //    
    function PACsManager(router, route, context, pACService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.router = router;
        _this.route = route;
        _this.context = context;
        _this.pACService = pACService;
        _this.pacs = [];
        return _this;
    }
    PACsManager_1 = PACsManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    PACsManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
        this.refreshList();
    };
    PACsManager.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.pACService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.pacs = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PACsManager.prototype.onAddingItem = function () {
        //this.router.navigate([0], { relativeTo: this.route });
    };
    PACsManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    PACsManager.prototype.onEditingItem = function (item) {
        this.router.navigate([item.id], { relativeTo: this.route });
    };
    PACsManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.pACService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PACsManager.prototype.onCloningItem = function (item) {
        //this.router.navigate([0, {cloneId: item.id}], { relativeTo: this.route });
    };
    PACsManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.pACService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var PACsManager_1;
    PACsManager = PACsManager_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-pacs-manager',
            template: "\n      <az-panel [header]=\"'Proveedores autorizados de certificaci\u00F3n (PAC)'\">\n\n          <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                                  (addingItem)=\"onAddingItem()\"\n                                  (viewingItem)=\"onViewingItem($event)\"\n                                  (editingItem)=\"onEditingItem($event)\"\n                                  (deletingItem)=\"onDeletingItem($event)\"\n                                  (cloningItem)=\"onCloningItem($event)\"\n                                  (changingItemState)=\"onChangingItemState($event)\"\n                                  (configureCatalog)=\"onConfigureCatalog($event)\"\n                                  [enabled]=\"enabled\"\n                                  [allowNew]=\"false\"\n                                  [allowView]=\"allowView\"\n                                  [allowEdit]=\"allowEdit\"\n                                  [allowDelete]=\"false\"\n                                  [allowClone]=\"false\"\n                                  [allowChangeState]=\"allowChangeState\"\n                                  [catalogList]=\"pacs\"\n                                  [totalRows]=\"totalRows\"\n                                  [pageIndex]=\"pageIndex\">\n\n\n              <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n              <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n              <azteca-grid-column [header]=\"'Url Timbrado'\" [binding]=\"'urlTimbrado'\" [width]=\"'60*'\"></azteca-grid-column>\n        \n\n          </azteca-catalog-manager>\n\n      </az-panel>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return PACsManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: pac_service_1.PACService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, core_2.Context, pac_service_1.PACService])
    ], PACsManager);
    return PACsManager;
}(editors_1.CatalogManager));
exports.PACsManager = PACsManager;
