import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogManager } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { MenuItem } from 'framework3/controls';
import { PlantillaComprobanteService } from '../services/plantilla-comprobante.service';
import { PlantillaComprobanteItem } from '../models/plantilla-comprobante';
export declare class PlantillasComprobantesManager extends CatalogManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private plantillaComprobanteService;
    plantillasComprobantes: PlantillaComprobanteItem[];
    constructor(context: Context, router: Router, route: ActivatedRoute, plantillaComprobanteService: PlantillaComprobanteService);
    onConfigureCatalog(options: CatalogOptions): void;
    onMenuItemClick(option: MenuItem): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
}
