"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var sucursal_service_1 = require("../services/sucursal.service");
var SucursalesManager = /** @class */ (function (_super) {
    __extends(SucursalesManager, _super);
    function SucursalesManager(router, route, context, sucursalService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.router = router;
        _this.route = route;
        _this.context = context;
        _this.sucursalService = sucursalService;
        _this.sucursales = [];
        _this.refreshListParent = new core_1.EventEmitter();
        return _this;
    }
    SucursalesManager_1 = SucursalesManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    SucursalesManager.prototype.onConfigureCatalog = function (options) {
        //this.manager.serverSide = options.busquedasServidor;
        //this.manager.pageSize = options.tamanioPagina;        
        //this.refreshList();
    };
    SucursalesManager.prototype.doSearch = function (request) {
        //this.context.app.showSpinner();
        //this.sucursalService.search(this.context.app.defaultSite.identity, request)
        //    .then(response => {
        //        this.context.app.hideSpinner();
        //        //
        //        this.sucursales = response.rows;
        //        this.totalRows = response.totalRows;
        //        this.pageIndex = request.pageIndex;                                
        //    })
        //    .catch(error => this.handleError(error));
    };
    SucursalesManager.prototype.onAddingItem = function () {
        this.router.navigate(['accounting/sucursales-contabilidad', this.process.id, this.idEmpresa, 0]);
    };
    SucursalesManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    SucursalesManager.prototype.onEditingItem = function (item) {
        this.router.navigate(['accounting/sucursales-contabilidad', this.process.id, this.idEmpresa, item.id]);
    };
    SucursalesManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.sucursalService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
            _this.refreshListParent.emit();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesManager.prototype.onCloningItem = function (item) {
        this.router.navigate(['accounting/sucursales-contabilidad', this.process.id, this.idEmpresa, 0, { cloneId: item.id }]);
    };
    SucursalesManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.sucursalService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
            _this.refreshListParent.emit();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var SucursalesManager_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], SucursalesManager.prototype, "sucursales", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], SucursalesManager.prototype, "idEmpresa", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], SucursalesManager.prototype, "refreshListParent", void 0);
    SucursalesManager = SucursalesManager_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-sucursales-manager',
            template: "\n      <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                              (addingItem)=\"onAddingItem()\"\n                              (viewingItem)=\"onViewingItem($event)\"\n                              (editingItem)=\"onEditingItem($event)\"\n                              (deletingItem)=\"onDeletingItem($event)\"\n                              (cloningItem)=\"onCloningItem($event)\"\n                              (changingItemState)=\"onChangingItemState($event)\"\n      \t\t\t\t\t\t(configureCatalog)=\"onConfigureCatalog($event)\"\n                              [enabled]=\"enabled\"\n                              [allowNew]=\"allowNew\"\n                              [allowView]=\"allowView\"\n                              [allowEdit]=\"allowEdit\"\n                              [allowDelete]=\"allowDelete\"\n                              [allowClone]=\"allowClone\"\n                              [allowChangeState]=\"allowChangeState\"\n                              [catalogList]=\"sucursales\"\n                              [totalRows]=\"totalRows\"\n                              [pageSize]=\"20\"\n                              [standAlone]=\"false\"\n                              [serverSide]=\"false\">\n\n    \n          <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'2*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'3*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Domicilio'\" [binding]=\"'domicilio'\" [width]=\"'3*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Colonia'\" [binding]=\"'colonia'\" [width]=\"'2*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Poblaci\u00F3n'\" [binding]=\"'poblacion'\" [width]=\"'2*'\"></azteca-grid-column>\n    \n\n      </azteca-catalog-manager>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return SucursalesManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: sucursal_service_1.SucursalService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, core_2.Context, sucursal_service_1.SucursalService])
    ], SucursalesManager);
    return SucursalesManager;
}(editors_1.CatalogManager));
exports.SucursalesManager = SucursalesManager;
