"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Angular
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Framework 3
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var comprobante_correo_1 = require("../models/comprobante-correo");
var ComprobantesCorreoEditor = /** @class */ (function (_super) {
    __extends(ComprobantesCorreoEditor, _super);
    function ComprobantesCorreoEditor(context, formBuilder, router, route, changeDetectorRef) {
        var _this = _super.call(this, context, router, route, changeDetectorRef) || this;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.router = router;
        _this.route = route;
        _this.changeDetectorRef = changeDetectorRef;
        _this.tiposComprobantes = [
            { "id": 1, "name": "Ingreso" },
            { "id": 2, "name": "Egreso" },
            { "id": 3, "name": "Traslado" },
            { "id": 4, "name": "Nómina" },
            { "id": 5, "name": "Pago" }
        ];
        //Inputs
        _this.data = new comprobante_correo_1.ComprobanteCorreo();
        //Outputs
        _this.dataUpdater = new core_1.EventEmitter();
        _this.editorForm = formBuilder.group({
            'idComprobanteTipo': ['', controls_1.AztecaValidators.selected],
            'correo': ['', forms_1.Validators.required],
        });
        return _this;
    }
    ComprobantesCorreoEditor_1 = ComprobantesCorreoEditor;
    ComprobantesCorreoEditor.prototype.onTipoComprobanteChange = function (id) {
        this.data.comprobanteTipo = this.tiposComprobantes.find(function (item) { return item.id == id; }).name;
    };
    ComprobantesCorreoEditor.prototype.show = function () {
        var _this = this;
        this.data = new comprobante_correo_1.ComprobanteCorreo();
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) { return _this.editorForm.reset(); });
        wijmo_1.Control.invalidateAll();
    };
    ComprobantesCorreoEditor.prototype.onUpdate = function () {
        this.dataUpdater.emit(this.data);
        this.dialog.hide();
    };
    var ComprobantesCorreoEditor_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", comprobante_correo_1.ComprobanteCorreo)
    ], ComprobantesCorreoEditor.prototype, "data", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ComprobantesCorreoEditor.prototype, "dataUpdater", void 0);
    __decorate([
        core_1.ViewChild('dialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ComprobantesCorreoEditor.prototype, "dialog", void 0);
    ComprobantesCorreoEditor = ComprobantesCorreoEditor_1 = __decorate([
        core_1.Component({
            selector: 'accounting-comprobante-correo',
            template: "\n      <form [formGroup]=\"editorForm\">\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h4 class=\"modal-title\">Asignaci\u00F3n de Correos</h4>\n                      </div>\n                      <div class=\"modal-body\">\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-lg-6\">\n                                  <azteca-form-field [label]=\"'Tipo de comprobante:'\">\n                                      <az-combobox formControlName=\"idComprobanteTipo\"\n                                                   [(ngModel)]=\"data.idComprobanteTipo\"\n                                                   [items]=\"tiposComprobantes\"\n                                                   [valueMember]=\"'id'\"\n                                                   [displayMember]=\"'name'\"\n                                                   (selectedItemChanged)=\"onTipoComprobanteChange($event)\">\n                                      </az-combobox>\n                                  </azteca-form-field>\n                              </div>\n\n                              <div class=\"col-12 col-lg-6\">\n                                  <azteca-form-field [label]=\"'Correo:'\">\n                                      <az-textbox formControlName=\"correo\" [(ngModel)]=\"data.correo\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                      </div>\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Cancelar</button>\n                      </div>\n                  </div>\n              </div>\n          </div>\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ComprobantesCorreoEditor_1; })
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute,
            core_1.ChangeDetectorRef])
    ], ComprobantesCorreoEditor);
    return ComprobantesCorreoEditor;
}(editors_1.CatalogEditor));
exports.ComprobantesCorreoEditor = ComprobantesCorreoEditor;
