"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
//
//import { Context, SucursalItem, SucursalService } from '../../../core';
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
var comprobante_fiscal_service_1 = require("../services/comprobante-fiscal.service");
//
var ComprobantesListComponent = /** @class */ (function (_super) {
    __extends(ComprobantesListComponent, _super);
    function ComprobantesListComponent(context, comprobanteFiscalService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.comprobanteFiscalService = comprobanteFiscalService;
        //Inputs    
        _this.idContribuyente = 0;
        _this.idComprobanteTipo = 0;
        _this.Activos = false;
        _this.sinReferencia = false;
        _this.pageIndex = 0;
        _this.pageSize = 15;
        _this.startPeriod = 15;
        return _this;
    }
    ComprobantesListComponent.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        //Si se especificó status, agregar filtro
        if (this.idContribuyente != 0) {
            var condition = { field: 'IdContribuyente', operator: '=', valueType: 'int', value: this.idContribuyente };
            request.conditions.push(condition);
        }
        //Si se especificó el tipo de comprobante, agregar filtro
        if (this.idComprobanteTipo != 0) {
            var condition = { field: 'IdComprobanteTipo', operator: '=', valueType: 'int', value: this.idComprobanteTipo };
            request.conditions.push(condition);
        }
        //Si se especificó status, agregar filtro
        if (this.Activos) {
            var condition = { field: 'Cancelado', operator: '=', valueType: 'bool', value: 0 };
            request.conditions.push(condition);
        }
        //Si solo se quieren los que no tienen referencia
        if (this.sinReferencia) {
            var condition = { field: 'IdDocumento', operator: '=', valueType: 'string', value: '' };
            request.conditions.push(condition);
        }
        this.comprobanteFiscalService.search(this.context.app.defaultSite.identity, request)
            .then(function (result) {
            _this.comprobantes = result.rows;
            //this.totalRows = result.totalRows; //se habilita cuando se agregue el extends a DocumentListDialog
            _this.pageIndex = request.pageIndex;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesListComponent.prototype.onSelectedItemsChanged = function (selecteItems) {
        this.selectedItemsChanged.emit(selecteItems);
    };
    ComprobantesListComponent.prototype.onSelectedItemChanged = function (item) {
        if (item != null) {
            this.selectedItemChanged.emit(item);
        }
    };
    //se borra cuando se agregue el extends a DocumentListDialog
    ComprobantesListComponent.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ComprobantesListComponent.prototype, "idContribuyente", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ComprobantesListComponent.prototype, "idComprobanteTipo", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ComprobantesListComponent.prototype, "Activos", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ComprobantesListComponent.prototype, "sinReferencia", void 0);
    ComprobantesListComponent = __decorate([
        core_1.Component({
            selector: 'accounting-comprobantes-list',
            template: "\n      <document-list-dialog (searchRequested)=\"onSearchRequested($event)\"\n                            (selectedItemsChanged)=\"onSelectedItemsChanged($event)\"\n                            (selectedItemChanged)=\"onSelectedItemChanged($event)\"\n                            [documentList]=\"comprobantes\"\n                            [excludedItems]=\"excludedItems\"\n                            [multiSelect]=\"multiSelect\"\n                            [serverSide]=\"serverSide\"\n                            [pageSize]=\"pageSize\"\n                            [pageIndex]=\"pageIndex\"\n                            [startPeriod]=\"startPeriod\"\n                            [title]=\"'Comprobantes Fiscales'\">\n          <!--[totalRows]=\"totalRows\"-->\n\n          <azteca-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"100\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"100\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'RFC'\" [binding]=\"'rfcEmisor'\" [width]=\"'20*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Emisor'\" [binding]=\"'nombreEmisor'\" [width]=\"250\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'RFC'\" [binding]=\"'rfcReceptor'\" [width]=\"'20*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Receptor'\" [binding]=\"'nombreReceptor'\" [width]=\"250\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"150\" format=\"c\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"'20*'\"></azteca-grid-column>\n\n      </document-list-dialog> \n    "
        })
        //cambiar el extends
        ,
        __metadata("design:paramtypes", [core_2.Context, comprobante_fiscal_service_1.ComprobanteFiscalService])
    ], ComprobantesListComponent);
    return ComprobantesListComponent;
}(search_1.DocumentListDialog));
exports.ComprobantesListComponent = ComprobantesListComponent;
