import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { BaseComponent, Context, CatalogItem, PolicyInfo, UsuarioItem } from 'framework3/core';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { UsuariosListComponent } from 'framework3/security';
import { CuentaBancariaService } from '../services/cuenta-bancaria.service';
import { CuentaBancariaInfo } from '../models/cuenta-bancaria';
export declare class CuentaBancariaMiembrosComponent extends BaseComponent {
    private context;
    private cuentaBancariaService;
    private router;
    private route;
    private location;
    title: string;
    usuarios: UsuarioItem[];
    idCuentaBancaria: number;
    cuentaBancaria: CuentaBancariaInfo;
    currentItem: CatalogItem;
    usuariosDialog: UsuariosListComponent;
    alerts: AlertsBarComponent;
    constructor(context: Context, cuentaBancariaService: CuentaBancariaService, router: Router, route: ActivatedRoute, location: Location);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadCuentaBancaria(): void;
    refreshList(): void;
    onCurrentItemChanged(item: CatalogItem): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onSelectedUsersChanged(newUsers: UsuarioItem[]): void;
    onRemoveUser(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
