import { ChangeDetectorRef, EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormGroup, FormBuilder } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { Context } from 'framework3/core';
import { CatalogEditor } from 'framework3/editors';
import { ImpuestoAsignacionInfo } from '../models/impuesto-asignacion';
import { ImpuestoInfo } from '../models/impuesto';
import { ImpuestosSelectorComponent } from '../controls/impuestos-selector.component';
export declare class ImpuestosAsignacionEditor extends CatalogEditor {
    protected context: Context;
    private formBuilder;
    protected router: Router;
    protected route: ActivatedRoute;
    protected changeDetectorRef: ChangeDetectorRef;
    editorForm: FormGroup;
    tiposFactor: {
        id: number;
        name: string;
    }[];
    tiposCalculo: {
        id: number;
        name: string;
    }[];
    tiposAplicacion: {
        id: number;
        nombre: string;
    }[];
    data: ImpuestoAsignacionInfo;
    dataUpdater: EventEmitter<ImpuestoAsignacionInfo>;
    dialog: ModalDirective;
    selectorImpuestos: ImpuestosSelectorComponent;
    constructor(context: Context, formBuilder: FormBuilder, router: Router, route: ActivatedRoute, changeDetectorRef: ChangeDetectorRef);
    onTipoCalculoChange(): void;
    show(): void;
    onUpdate(): void;
    onItemChanged(args: ImpuestoInfo): void;
}
