"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Angular
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Framework 3
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var impuesto_asignacion_1 = require("../models/impuesto-asignacion");
var impuestos_selector_component_1 = require("../controls/impuestos-selector.component");
var ImpuestosAsignacionEditor = /** @class */ (function (_super) {
    __extends(ImpuestosAsignacionEditor, _super);
    function ImpuestosAsignacionEditor(context, formBuilder, router, route, changeDetectorRef) {
        var _this = _super.call(this, context, router, route, changeDetectorRef) || this;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.router = router;
        _this.route = route;
        _this.changeDetectorRef = changeDetectorRef;
        _this.tiposFactor = [
            { "id": 1, "name": "Tasa" },
            { "id": 2, "name": "Cuota" }
        ];
        _this.tiposCalculo = [
            { "id": 1, "name": "Base" },
            { "id": 2, "name": "Cascada" }
        ];
        _this.tiposAplicacion = [
            { id: 1, nombre: 'Traslado' },
            { id: 2, nombre: 'Retención' }
        ];
        //Inputs
        _this.data = new impuesto_asignacion_1.ImpuestoAsignacionInfo();
        //Outputs
        _this.dataUpdater = new core_1.EventEmitter();
        _this.editorForm = formBuilder.group({
            'impuestos': ['', controls_1.AztecaValidators.selected],
            'valorTasa': [1],
            'valorCuota': [1],
            'base': [1],
            'tipoCalculo': [0, controls_1.AztecaValidators.selected],
            'ordenCalculo': [1],
            'tipoAplicacion': [0]
        });
        return _this;
    }
    ImpuestosAsignacionEditor_1 = ImpuestosAsignacionEditor;
    ImpuestosAsignacionEditor.prototype.onTipoCalculoChange = function () {
        if (this.editorForm.controls.tipoCalculo.value == 1) {
            this.data.tipoCalculo = 'B';
            this.data.ordenCalculo = 1;
        }
        else
            this.data.tipoCalculo = 'C';
        this.data.ordenCalculo = 2;
    };
    ImpuestosAsignacionEditor.prototype.show = function () {
        var _this = this;
        this.data = new impuesto_asignacion_1.ImpuestoAsignacionInfo();
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) { return _this.editorForm.reset(); });
        wijmo_1.Control.invalidateAll();
    };
    ImpuestosAsignacionEditor.prototype.onUpdate = function () {
        if (this.editorForm.controls['tipoAplicacion'].value == 1) {
            this.data.tipoAplicacion = 'T';
        }
        else {
            this.data.tipoAplicacion = 'R';
        }
        this.dataUpdater.emit(this.data);
        this.dialog.hide();
    };
    ImpuestosAsignacionEditor.prototype.onItemChanged = function (args) {
        this.data.impuesto = args;
        if (!args.rango) {
            this.data.tasaOCuota = args.valorFijo;
        }
        else {
            this.data.tasaOCuota = 0;
            this.data.base = 0;
        }
        this.tiposAplicacion = [];
        if (this.data.impuesto.traslado)
            this.tiposAplicacion.push({ id: 1, nombre: 'Traslado' });
        if (this.data.impuesto.retencion)
            this.tiposAplicacion.push({ id: 2, nombre: 'Retencion' });
        if (args.factor == 'C')
            this.editorForm.controls.base.setValidators(forms_1.Validators.min(0.01));
        else
            this.editorForm.controls.base.clearValidators();
    };
    var ImpuestosAsignacionEditor_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", impuesto_asignacion_1.ImpuestoAsignacionInfo)
    ], ImpuestosAsignacionEditor.prototype, "data", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ImpuestosAsignacionEditor.prototype, "dataUpdater", void 0);
    __decorate([
        core_1.ViewChild('dialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ImpuestosAsignacionEditor.prototype, "dialog", void 0);
    __decorate([
        core_1.ViewChild('selectorImpuestos'),
        __metadata("design:type", impuestos_selector_component_1.ImpuestosSelectorComponent)
    ], ImpuestosAsignacionEditor.prototype, "selectorImpuestos", void 0);
    ImpuestosAsignacionEditor = ImpuestosAsignacionEditor_1 = __decorate([
        core_1.Component({
            selector: 'accounting-impuesto-asignacion',
            template: "\n      <form [formGroup]=\"editorForm\">\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h4 class=\"modal-title\">Asignaci\u00F3n de Impuestos</h4>\n                      </div>\n                      <div class=\"modal-body\">\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Impuesto:'\">\n                                      <accounting-impuestos-selector formControlName=\"impuestos\"\n                                                                     [(ngModel)]=\"data.idImpuesto\"\n                                                                     [traslado]=\"true\"\n                                                                     [retencion]=\"true\"\n                                                                     [showListButton]=\"true\"\n                                                                     (selectedItemChanged)=\"onItemChanged($event)\"\n                                                                     #selectorImpuestos>\n                                      </accounting-impuestos-selector>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-12 col-lg-6\" *ngIf=\"data.impuesto.factor=='T' && data.idImpuesto > 0\">\n                                  <azteca-form-field [label]=\"'Tasa:'\">\n                                      <az-input-number formControlName=\"valorTasa\" [(ngModel)]=\"data.tasaOCuota\" [format]=\"'P2'\" [enabled]=\"data.impuesto.rango\" [min]=\"data.impuesto.valorMinimo\" [max]=\"data.impuesto.valorMaximo\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                              <div class=\"col-12 col-lg-6\" *ngIf=\"data.impuesto.factor=='C' && data.idImpuesto > 0\">\n                                  <azteca-form-field [label]=\"'Cuota:'\">\n                                      <az-input-number formControlName=\"valorCuota\" [(ngModel)]=\"data.tasaOCuota\" [format]=\"'N2'\" [enabled]=\"data.impuesto.rango\" [min]=\"data.impuesto.valorMinimo\" [max]=\"data.impuesto.valorMaximo\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                              <div class=\"col-12 col-lg-6\" *ngIf=\"data.impuesto.factor=='C' && data.idImpuesto > 0\">\n                                  <azteca-form-field [label]=\"'Base:'\">\n                                      <az-input-number formControlName=\"base\" [(ngModel)]=\"data.base\" [format]=\"'N2'\" [enabled]=\"data.impuesto.rango\" [min]=\"0.01\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-12 col-lg-6\">\n                                  <azteca-form-field [label]=\"'Tipo de aplicaci\u00F3n:'\">\n                                      <az-combobox formControlName=\"tipoAplicacion\"\n                                                   [(ngModel)]=\"data.tipoAplicacion\"\n                                                   [items]=\"tiposAplicacion\"\n                                                   [valueMember]=\"'id'\"\n                                                   [displayMember]=\"'nombre'\"></az-combobox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-12 col-lg-6\">\n                                  <azteca-form-field [label]=\"'Tipo de c\u00E1lculo:'\">\n                                      <az-combobox formControlName=\"tipoCalculo\"\n                                                   [items]=\"tiposCalculo\"\n                                                   [valueMember]=\"'id'\"\n                                                   [displayMember]=\"'name'\"\n                                                   (change)=\"onTipoCalculoChange()\">\n                                      </az-combobox>\n                                  </azteca-form-field>\n                              </div>\n                              <div class=\"col-12 col-lg-6\" *ngIf=\"editorForm.controls.tipoCalculo.value===2\">\n                                  <azteca-form-field [label]=\"'Orden de c\u00E1lculo:'\">\n                                      <az-input-number formControlName=\"ordenCalculo\" [(ngModel)]=\"data.ordenCalculo\" [min]=\"1\" integer=\"true\" [max]=\"2\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                      </div>\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Cancelar</button>\n                      </div>\n                  </div>\n              </div>\n          </div>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ImpuestosAsignacionEditor_1; })
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute,
            core_1.ChangeDetectorRef])
    ], ImpuestosAsignacionEditor);
    return ImpuestosAsignacionEditor;
}(editors_1.CatalogEditor));
exports.ImpuestosAsignacionEditor = ImpuestosAsignacionEditor;
