"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("framework3/core");
var forms_1 = require("@angular/forms");
var mapa_distribucion_service_1 = require("../services/mapa-distribucion.service");
var MapaDistribucionCodeEditor = /** @class */ (function () {
    function MapaDistribucionCodeEditor(context, builder, mapDistribucionSvc) {
        var _this = this;
        this.context = context;
        this.builder = builder;
        this.mapDistribucionSvc = mapDistribucionSvc;
        this.idEsquema = 0;
        this.statement = "";
        this.code = "";
        this.nodes = [];
        this.actionMapping = {
            mouse: {
                dblClick: function (tree, node, event) {
                    _this.code = node.data.path;
                }
            }
        };
        this.treeOptions = {
            displayField: 'name', allowDrag: false, actionMapping: this.actionMapping,
            getChildren: (function (node) {
                //return this.parent.loadChildren(node.data);
                return _this.mapDistribucionSvc.getElementChildrens(node.data);
            })
        };
        this.formGroup = builder.group({
            'esquema': [''],
            'statement': ['']
        });
    }
    //  Methods
    MapaDistribucionCodeEditor.prototype.onSelectedEsquema = function (esquema) {
        var _this = this;
        this.context.app.showSpinner();
        this.mapDistribucionSvc.getElementByEsquma(esquema.identity)
            .then(function (result) {
            _this.nodes = result;
            _this.context.app.hideSpinner();
        }).catch(function (error) {
            console.log(error);
            _this.context.app.hideSpinner();
        });
    };
    //Tree events
    MapaDistribucionCodeEditor.prototype.onTreeUpdated = function () {
    };
    MapaDistribucionCodeEditor = __decorate([
        core_1.Component({
            selector: 'accounting-mapa-distribucion-editor',
            template: "\n      <form [formGroup]=\"formGroup\">\n\n          <h1>Distribucion</h1>\n\n          <div class=\"row\">\n              <div class=\"col-12 col-md-10\">\n                  <azteca-form-field [label]=\"'Esquema:'\">\n                      <accounting-esquema-selector formControlName=\"esquema\"\n                                                   [(ngModel)]=\"idEsquema\"\n                                                   (selectedItemChanged)=\"onSelectedEsquema($event)\">\n                      </accounting-esquema-selector>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12 col-md-4\">\n                  <div style=\"height:500px;overflow:auto\">\n                      <tree-root [nodes]=\"nodes\"\n                                 [options]=\"treeOptions\">\n                          <ng-template #loadingTemplate>\n                              Cargando, por favor espere...\n                          </ng-template>\n                      </tree-root>\n                  </div>\n              </div>\n\n              <div class=\"col-12 col-md-8\">\n\n                  <h5>Expresi&oacute;n</h5>\n                  <code>{{code}}</code>\n\n                  <az-code-editor formControlName=\"statement\"\n                                  [language]=\"'csharp'\"\n                                  [theme]=\"'chrome'\"\n                                  [(ngModel)]=\"statement\">\n                  </az-code-editor>\n              </div>\n\n          </div>\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, mapa_distribucion_service_1.MapaDistribucionService])
    ], MapaDistribucionCodeEditor);
    return MapaDistribucionCodeEditor;
}());
exports.MapaDistribucionCodeEditor = MapaDistribucionCodeEditor;
