import { EventEmitter, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormGroup } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, PolicyInfo } from 'framework3/core';
import { AlertsBarComponent } from 'framework3/controls';
import { CatalogEditor } from 'framework3/editors';
import { TipoCambioItem } from '../models/divisa';
import { DivisaService } from '../services/divisa.service';
import { DivisasSelectorComponent } from '../controls/divisas-selector.component';
export declare class TipoCambioEditorComponent extends CatalogEditor {
    private divisaService;
    protected context: Context;
    private formBuilder;
    protected router: Router;
    protected route: ActivatedRoute;
    protected changeDetector: ChangeDetectorRef;
    editorForm: FormGroup;
    info: TipoCambioItem;
    tipoFormato: String;
    data: TipoCambioItem;
    nuevoFlag: Boolean;
    dataUpdated: EventEmitter<TipoCambioItem>;
    dialog: ModalDirective;
    alerts: AlertsBarComponent;
    selectorDivisas: DivisasSelectorComponent;
    constructor(divisaService: DivisaService, context: Context, formBuilder: FormBuilder, router: Router, route: ActivatedRoute, changeDetector: ChangeDetectorRef);
    show(): void;
    onSelectedItemChanged(args: any): void;
    onUpdate(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
