"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var divisa_1 = require("../models/divisa");
var divisa_service_1 = require("../services/divisa.service");
var divisas_selector_component_1 = require("../controls/divisas-selector.component");
var TipoCambioEditorComponent = /** @class */ (function (_super) {
    __extends(TipoCambioEditorComponent, _super);
    function TipoCambioEditorComponent(divisaService, context, formBuilder, router, route, changeDetector) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.divisaService = divisaService;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.router = router;
        _this.route = route;
        _this.changeDetector = changeDetector;
        _this.info = new divisa_1.TipoCambioItem();
        _this.tipoFormato = '';
        //Inputs
        _this.data = new divisa_1.TipoCambioItem();
        _this.nuevoFlag = new Boolean();
        //outputs
        _this.dataUpdated = new core_1.EventEmitter();
        _this.editorForm = formBuilder.group({
            'divisa': ['', controls_1.AztecaValidators.selected],
            'compra': ['', forms_1.Validators.required],
            'venta': ['', forms_1.Validators.required],
            'otro': ['', forms_1.Validators.required]
        });
        return _this;
    }
    TipoCambioEditorComponent_1 = TipoCambioEditorComponent;
    TipoCambioEditorComponent.prototype.show = function () {
        var _this = this;
        this.info = new divisa_1.TipoCambioItem();
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) {
            _this.editorForm.reset();
            _this.info = _this.data;
            _this.data = new divisa_1.TipoCambioItem();
        });
        wijmo_1.Control.invalidateAll();
    };
    TipoCambioEditorComponent.prototype.onSelectedItemChanged = function (args) {
        if (args != null)
            this.tipoFormato = 'n' + args.decimales.toString();
    };
    TipoCambioEditorComponent.prototype.onUpdate = function () {
        var _this = this;
        this.divisaService.getDetailByEmpresa(this.context.app.defaultCompany.identity)
            .then(function (divisa) {
            _this.info.idDivisaDestino = divisa.identity;
            _this.info.divisaDestino = divisa.nombre;
            _this.info.divisaOrigen = _this.selectorDivisas.displayValue;
            _this.dataUpdated.emit(_this.info);
            _this.dialog.hide();
        });
    };
    TipoCambioEditorComponent.prototype.applyPolicy = function (policy) {
    };
    TipoCambioEditorComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    var TipoCambioEditorComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", divisa_1.TipoCambioItem)
    ], TipoCambioEditorComponent.prototype, "data", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], TipoCambioEditorComponent.prototype, "nuevoFlag", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], TipoCambioEditorComponent.prototype, "dataUpdated", void 0);
    __decorate([
        core_1.ViewChild('dialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], TipoCambioEditorComponent.prototype, "dialog", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], TipoCambioEditorComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('selectorDivisas'),
        __metadata("design:type", divisas_selector_component_1.DivisasSelectorComponent)
    ], TipoCambioEditorComponent.prototype, "selectorDivisas", void 0);
    TipoCambioEditorComponent = TipoCambioEditorComponent_1 = __decorate([
        core_1.Component({
            selector: 'inventario-tipos-cambio-editor',
            template: "\n      <form [formGroup]=\"editorForm\">\n\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h4 class=\"modal-title\">Tipo de Cambio</h4>\n                      </div>\n\n                      <div class=\"modal-body\">\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Divisa origen:'\">\n                                      <azteca-form-field [label]=\"Divisa\">\n                                          <accounting-divisas-selector formControlName=\"divisa\" [(ngModel)]=\"info.idDivisaOrigen\" [showListButton]=\"false\" [enabled]=\"nuevoFlag\" (selectedItemChanged)=\"onSelectedItemChanged($event)\" #selectorDivisas></accounting-divisas-selector>\n                                      </azteca-form-field>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-lg-4\">\n                                  <azteca-form-field [label]=\"'Precio Compra:'\">\n                                      <az-input-number formControlName=\"compra\" decimal=\"True\" [(ngModel)]=\"info.precioCompra\" [min]=\"0\" [format]=\"tipoFormato\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n\n                              <div class=\"col-12 col-lg-4\">\n                                  <azteca-form-field [label]=\"'Precio Venta:'\">\n                                      <az-input-number formControlName=\"venta\" decimal=\"True\" [(ngModel)]=\"info.precioVenta\" [min]=\"0\" [format]=\"tipoFormato\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n\n                              <div class=\"col-12 col-lg-4\">\n                                  <azteca-form-field [label]=\"'Otro:'\">\n                                      <az-input-number formControlName=\"otro\" decimal=\"True\" [(ngModel)]=\"info.precioOtro\" [min]=\"0\" [format]=\"tipoFormato\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n\n\n                          </div>\n\n                      </div> <!--Modal Body-->\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Atr\u00E1s</button>\n                      </div> <!--Modal Footer-->\n\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div><!--Modal directive-->\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return TipoCambioEditorComponent_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: divisa_service_1.DivisaService
                }
            ]
        }),
        __metadata("design:paramtypes", [divisa_service_1.DivisaService, core_2.Context, forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute,
            core_1.ChangeDetectorRef])
    ], TipoCambioEditorComponent);
    return TipoCambioEditorComponent;
}(editors_1.CatalogEditor));
exports.TipoCambioEditorComponent = TipoCambioEditorComponent;
