"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//
var core_3 = require("framework3/core");
var editors_1 = require("framework3/editors");
var divisa_service_1 = require("../services/divisa.service");
var tipos_cambio_editor_component_1 = require("../components/tipos-cambio-editor.component");
var TipoCambioComponent = /** @class */ (function (_super) {
    __extends(TipoCambioComponent, _super);
    //
    function TipoCambioComponent(context, divisaService, grupoService, router, route, location) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.divisaService = divisaService;
        _this.grupoService = grupoService;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.tipCamCollection = new editors_1.TrackableCollection();
        _this.nuevoFlag = new Boolean();
        _this.data = [];
        return _this;
    }
    //////////////////// METODOS /////////////////////////////////////////////////////////
    TipoCambioComponent.prototype.loadTiposCambio = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.divisaService.loadTiposCambio(this.context.app.defaultCompany.identity)
            .then(function (tiposCambio) {
            _this.data = tiposCambio;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //////////////////// HANDLERS /////////////////////////////////////////////////////////
    TipoCambioComponent.prototype.ngOnInit = function () {
        this.loadTiposCambio();
    };
    TipoCambioComponent.prototype.ngAfterViewChecked = function () {
        this.tipCamCollection.sourceCollection = this.data;
    };
    TipoCambioComponent.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    TipoCambioComponent.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'SAVE') {
            this.guardarTiposCambio();
        }
        if (button.name == 'ADD') {
            this.tipoCambioEditarDialog.show();
            this.tipoCambioEditarDialog.nuevoFlag = true;
            this.nuevoFlag = true;
        }
        if (button.name == 'CLOSE') {
            this.location.back();
        }
    };
    TipoCambioComponent.prototype.guardarTiposCambio = function () {
        var _this = this;
        this.divisaService.updateTiposCambio(this.data)
            .then(function (_) { return _this.loadTiposCambio(); });
    };
    TipoCambioComponent.prototype.onEditItem = function (tipoCambioItem) {
        this.tipoCambioEditarDialog.show();
        this.tipoCambioEditarDialog.data = tipoCambioItem;
        this.tipoCambioEditarDialog.nuevoFlag = false;
        this.nuevoFlag = false;
    };
    TipoCambioComponent.prototype.actualizarTipoCambio = function (args) {
        var _this = this;
        var impuestoExists = false;
        if (this.nuevoFlag == true) {
            this.data.forEach(function (tipoCambio) {
                if (tipoCambio.idDivisaOrigen == args.idDivisaOrigen) {
                    _this.alerts.showAlert("La divisa ya fue agregada", "información");
                    impuestoExists = true;
                }
            });
            if (!impuestoExists) {
                args.idEmpresa = this.context.app.defaultCompany.identity;
                args.empresa = this.context.app.defaultCompany.nombre;
                this.data.push(args);
                this.tipCamCollection.refresh();
            }
        }
        else {
            this.data.forEach(function (tipoCambio) {
                if (tipoCambio.idDivisaOrigen == args.idDivisaOrigen) {
                    if (tipoCambio.state == undefined) {
                        tipoCambio.state = 'CHANGED';
                    }
                    tipoCambio.precioCompra = args.precioCompra;
                    tipoCambio.precioVenta = args.precioVenta;
                    tipoCambio.precioOtro = args.precioOtro;
                }
            });
            this.tipCamCollection.refresh();
        }
    };
    TipoCambioComponent.prototype.applyPolicy = function (policy) {
    };
    TipoCambioComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(tipos_cambio_editor_component_1.TipoCambioEditorComponent),
        __metadata("design:type", tipos_cambio_editor_component_1.TipoCambioEditorComponent)
    ], TipoCambioComponent.prototype, "tipoCambioEditarDialog", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], TipoCambioComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], TipoCambioComponent.prototype, "data", void 0);
    TipoCambioComponent = __decorate([
        core_1.Component({
            selector: 'articulos-tipos-cambio.component',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-md-10\">\n              <az-panel [header]=\"title\">\n                  <alerts-bar></alerts-bar>\n                  <!--Toolbar Principal-->\n                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                      <az-toolbar-button [name]=\"'SAVE'\" [type]=\"'primary'\" [text]=\"'Guardar'\" [icon]=\"'glyphicon glyphicon-ok'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Regresar'\" [icon]=\"'glyphicon glyphicon-circle-arrow-left'\"></az-toolbar-button>\n                  </az-toolbar>\n\n                  <wj-flex-grid #gridTiposCambio style=\"height:550px\"\n                                [itemsSource]=\"tipCamCollection\">\n\n                      <wj-flex-grid-column [width]=\"55\" [isReadOnly]=\"true\">\n                          <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                              <button type=\"button\" class=\"btn btn-default\" (click)=\"onEditItem(cell.item)\">\n                                  <span class=\"glyphicon glyphicon-edit\"></span>\n                              </button>\n                          </ng-template>\n                      </wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Empresa'\" [binding]=\"'empresa'\" [width]=\"'12*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Divisa Origen'\" [binding]=\"'divisaOrigen'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Divisa Destino'\" [binding]=\"'divisaDestino'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Precio Compra'\" [binding]=\"'precioCompra'\" [width]=\"'10*'\" [isReadOnly]=\"true\" format=\"n4\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Precio Venta'\" [binding]=\"'precioVenta'\" [width]=\"'10*'\" [isReadOnly]=\"true\" format=\"n4\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Otro'\" [binding]=\"'precioOtro'\" [width]=\"'10*'\" [isReadOnly]=\"true\" format=\"n4\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Last Update'\" [binding]=\"'lastUpdate'\" [width]=\"'11*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  </wj-flex-grid>\n\n              </az-panel>\n          </div>\n      </div>\n\n      <inventario-tipos-cambio-editor (dataUpdated)=\"actualizarTipoCambio($event)\">\n\n      </inventario-tipos-cambio-editor>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, divisa_service_1.DivisaService, core_3.GrupoService, router_1.Router, router_1.ActivatedRoute,
            common_1.Location])
    ], TipoCambioComponent);
    return TipoCambioComponent;
}(core_2.BaseComponent));
exports.TipoCambioComponent = TipoCambioComponent;
