"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Angular
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Framework 3
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
//Reactive
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var operators_2 = require("rxjs/operators");
//Features
var impuesto_1 = require("../models/impuesto");
var impuesto_service_1 = require("../services/impuesto.service");
var ImpuestosSelectorComponent = /** @class */ (function (_super) {
    __extends(ImpuestosSelectorComponent, _super);
    function ImpuestosSelectorComponent(context, impuestoService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.impuestoService = impuestoService;
        _this.selectedItem = new impuesto_1.ImpuestoInfo();
        //Inputs
        _this.traslado = true;
        _this.retencion = true;
        //Outputs
        _this.selectedItemChanged = new core_1.EventEmitter();
        _this.keywordSearchSource = rxjs_1.Observable.create(function (observer) {
            observer.next(_this.innerSelector.displayValue);
        })
            .pipe(operators_1.mergeMap(function (keyword) { return _this.findImpuestos(keyword); }));
        return _this;
    }
    ImpuestosSelectorComponent_1 = ImpuestosSelectorComponent;
    ImpuestosSelectorComponent.prototype.loadItem = function (itemID) {
        var _this = this;
        if (itemID > 0) {
            this.impuestoService.getDetailByID(itemID)
                .then(function (info) {
                _this.selectedItem = info;
                _this.displayValue = info.code + '-' + info.nombre;
                _this.selectedItemChanged.emit(info);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.selectedItem = null;
            this.displayValue = "";
        }
    };
    ImpuestosSelectorComponent.prototype.doSearch = function (request) {
        var _this = this;
        if (!this.traslado || !this.retencion) {
            var condicionTraslado = { field: "traslado", operator: "=", valueType: "boolean", value: this.traslado };
            var condicionRetencion = { field: "retencion", operator: "=", valueType: "boolean", value: this.retencion };
            request.conditions.push(condicionTraslado);
            request.conditions.push(condicionRetencion);
        }
        this.context.app.showSpinner();
        this.impuestoService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            _this.impuestos = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(Error); });
    };
    ImpuestosSelectorComponent.prototype.findImpuestos = function (keyword) {
        var _this = this;
        return this.impuestoService.searchKeywordImpuestos(this.context.app.defaultSite.identity, keyword)
            .pipe(operators_2.map(function (impuestos) {
            return impuestos.filter(function (impuesto) { return impuesto.traslado == _this.traslado || impuesto.retencion == _this.retencion; });
        }));
    };
    ImpuestosSelectorComponent.prototype.onKeywordSearch = function (keyword) {
        this.markUnselected();
    };
    var ImpuestosSelectorComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ImpuestosSelectorComponent.prototype, "traslado", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ImpuestosSelectorComponent.prototype, "retencion", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ImpuestosSelectorComponent.prototype, "selectedItemChanged", void 0);
    ImpuestosSelectorComponent = ImpuestosSelectorComponent_1 = __decorate([
        core_1.Component({
            selector: 'accounting-impuestos-selector',
            template: "\n      <azteca-catalog-selector [catalogList]=\"impuestos\"\n                               [dialogTitle]=\"'Impuestos de Art\u00EDculo'\"\n                               [displayValue]=\"displayValue\"\n                               [serverSide]=\"true\"\n                               [selectedItem]=\"selectedItem\"\n                               [pageIndex]=\"pageIndex\"\n                               [pageSize]=\"pageSize\"\n                               [totalRows]=\"totalRows\"\n                               [enabled]=\"enabled\"\n                               [visible]=\"visible\"\n                               [dataSource]=\"keywordSearchSource\"\n                               [showListButton]=\"showListButton\"\n                               (selectedItemChanged)=\"itemChangedHandler($event)\"\n                               (keywordSearch)=\"onKeywordSearch($event)\"\n                               (searchRequested)=\"doSearch($event)\">\n\n          <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'30*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Clave SAT'\" [binding]=\"'claveSAT'\" [width]=\"'10*'\"></azteca-grid-column>\n\n      </azteca-catalog-selector>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent,
                    useExisting: core_1.forwardRef(function () { return ImpuestosSelectorComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return ImpuestosSelectorComponent_1; }),
                    multi: true
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, impuesto_service_1.ImpuestoService])
    ], ImpuestosSelectorComponent);
    return ImpuestosSelectorComponent;
}(search_1.CatalogSelector));
exports.ImpuestosSelectorComponent = ImpuestosSelectorComponent;
