"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Angular
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Framework 3
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
//
var moment = require("moment");
//Reactive
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
//Features
var periodo_1 = require("../models/periodo");
var periodo_service_1 = require("../services/periodo.service");
var common_1 = require("@angular/common");
var PeriodosSelectorComponent = /** @class */ (function (_super) {
    __extends(PeriodosSelectorComponent, _super);
    function PeriodosSelectorComponent(context, periodoService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.periodoService = periodoService;
        _this.selectedItem = new periodo_1.PeriodoInfo();
        //Outputs
        _this.selectedItemChanged = new core_1.EventEmitter();
        //inputs
        _this.idEjercicioTipo = 0;
        _this.keywordSearchSource = rxjs_1.Observable.create(function (observer) {
            observer.next(_this.innerSelector.displayValue);
        })
            .pipe(operators_1.mergeMap(function (keyword) { return _this.findPeriodos(keyword); }));
        return _this;
    }
    PeriodosSelectorComponent_1 = PeriodosSelectorComponent;
    //loadItem(itemID: number) {
    //    if (itemID > 0) {
    //        this.periodoService.getDetail(itemID.toString())
    //            .then(info => {
    //                this.selectedItem = info;
    //                console.log(JSON.stringify(info));
    //                this.displayValue =   formatDate(info.fechaIni, 'dd/MM/yyyy', 'es') + " - " + formatDate(info.fechaFin, 'dd/MM/yyyy', 'es')
    //                this.selectedItemChanged.emit(info);
    //            })
    //            .catch(error => this.handleError(error));
    //    }
    //    else {
    //        this.selectedItem = null;
    //        this.displayValue = "";
    //    }
    //}
    PeriodosSelectorComponent.prototype.loadItem = function (itemID) {
        var _this = this;
        if (itemID != '') {
            this.periodoService.getDetail(itemID)
                .then(function (info) {
                _this.selectedItem = info;
                _this.displayValue = common_1.formatDate(info.fechaIni, 'dd/MM/yyyy', 'es') + " - " + common_1.formatDate(info.fechaFin, 'dd/MM/yyyy', 'es');
                _this.selectedItemChanged.emit(_this.selectedItem);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.selectedItem = null;
            this.displayValue = "";
            this.selectedItemChanged.emit(null);
        }
    };
    PeriodosSelectorComponent.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        request.conditions.filter(function (item) { return item.field == "fechaCreacion"; }).forEach(function (fecha) {
            fecha.field = "FechaIni";
            //modificar esto desde el endPeriod cuando se actualice el framework
            if (fecha.operator = "<=")
                fecha.value = moment().add(90, 'day').toDate();
        });
        if (this.idEjercicioTipo && this.idEjercicioTipo > 0) {
            var condition = { field: 'IdEjercicioTipo', operator: '=', valueType: 'int', value: this.idEjercicioTipo };
            request.conditions.push(condition);
        }
        //let condiciones: SearchCondition = { field: "fechaIni", operator: "=", valueType: "date", value: this.f.toString() };
        //request.conditions.push(condiciones);
        this.periodoService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.periodos = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodosSelectorComponent.prototype.findPeriodos = function (keyword) {
        return this.periodoService.searchKeyword(this.context.app.defaultSite.identity, keyword);
    };
    PeriodosSelectorComponent.prototype.onKeywordSearch = function (keyword) {
        this.markUnselected();
    };
    var PeriodosSelectorComponent_1;
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], PeriodosSelectorComponent.prototype, "selectedItemChanged", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], PeriodosSelectorComponent.prototype, "idEjercicioTipo", void 0);
    PeriodosSelectorComponent = PeriodosSelectorComponent_1 = __decorate([
        core_1.Component({
            selector: 'accounting-periodos-selector',
            template: "\n      <azteca-document-selector [displayValue]=\"displayValue\"\n                                [selectedItem]=\"selectedItem\"\n                                [pageSize]=\"pageSize\"\n                                [enabled]=\"enabled\"\n                                [visible]=\"visible\"\n                                [dataSource]=\"keywordSearchSource\"\n                                [documentList]=\"periodos\"\n                                (selectedItemChanged)=\"itemChangedHandler($event)\"\n                                (keywordSearch)=\"onKeywordSearch($event)\"\n                                (searchRequested)=\"doSearch($event)\"\n                                [startPeriod]=\"90\">\n\n          <azteca-grid-column [header]=\"'Ejercicio'\" [binding]=\"'ejercicio'\" [width]=\"'10*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Mes'\" [binding]=\"'mes'\" [width]=\"'30*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Apertura'\" [binding]=\"'fechaApertura'\" [width]=\"'10*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Cierre'\" [binding]=\"'fechaCierre'\" [width]=\"'10*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"'30*'\"></azteca-grid-column>\n  \n      </azteca-document-selector>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent,
                    useExisting: core_1.forwardRef(function () { return PeriodosSelectorComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return PeriodosSelectorComponent_1; }),
                    multi: true
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, periodo_service_1.PeriodoService])
    ], PeriodosSelectorComponent);
    return PeriodosSelectorComponent;
}(search_1.DocumentSelector));
exports.PeriodosSelectorComponent = PeriodosSelectorComponent;
