"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Angular
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Framework 3
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
//Reactive
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var operators_2 = require("rxjs/operators");
//Features
var retencion_1 = require("../models/retencion");
var retencion_service_1 = require("../services/retencion.service");
var RetencionesSelectorComponent = /** @class */ (function (_super) {
    __extends(RetencionesSelectorComponent, _super);
    function RetencionesSelectorComponent(context, service) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.service = service;
        _this.selectedItem = new retencion_1.RetencionInfo();
        //Inputs
        _this.variable = true;
        _this.local = true;
        //Outputs
        _this.selectedItemChanged = new core_1.EventEmitter();
        _this.keywordSearchSource = rxjs_1.Observable.create(function (observer) {
            observer.next(_this.innerSelector.displayValue);
        })
            .pipe(operators_1.mergeMap(function (keyword) { return _this.findRetenciones(keyword); }));
        return _this;
    }
    RetencionesSelectorComponent_1 = RetencionesSelectorComponent;
    RetencionesSelectorComponent.prototype.loadItem = function (itemID) {
        var _this = this;
        if (itemID > 0) {
            this.service.getDetailByID(itemID)
                .then(function (info) {
                _this.selectedItem = info;
                _this.displayValue = info.code + '-' + info.nombre;
                _this.selectedItemChanged.emit(info);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.selectedItem = null;
            this.displayValue = "";
        }
    };
    RetencionesSelectorComponent.prototype.doSearch = function (request) {
        var _this = this;
        var condicionVariable = { field: "variable", operator: "=", valueType: "boolean", value: this.variable };
        var condicionLocal = { field: "local", operator: "=", valueType: "boolean", value: this.local };
        request.conditions.push(condicionVariable);
        request.conditions.push(condicionLocal);
        this.context.app.showSpinner();
        this.service.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            _this.retenciones = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(Error); });
    };
    RetencionesSelectorComponent.prototype.findRetenciones = function (keyword) {
        var _this = this;
        return this.service.searchKeywordRetenciones(this.context.app.defaultSite.identity, keyword)
            .pipe(operators_2.map(function (retenciones) {
            return retenciones.filter(function (retencion) { return retencion.variable == _this.variable || retencion.local == _this.local; });
        }));
    };
    RetencionesSelectorComponent.prototype.onKeywordSearch = function (keyword) {
        this.markUnselected();
    };
    var RetencionesSelectorComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], RetencionesSelectorComponent.prototype, "variable", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], RetencionesSelectorComponent.prototype, "local", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], RetencionesSelectorComponent.prototype, "selectedItemChanged", void 0);
    RetencionesSelectorComponent = RetencionesSelectorComponent_1 = __decorate([
        core_1.Component({
            selector: 'accounting-retenciones-selector',
            template: "\n      <azteca-catalog-selector [catalogList]=\"retenciones\"\n                               [dialogTitle]=\"'Retenciones'\"\n                               [displayValue]=\"displayValue\"\n                               [serverSide]=\"true\"\n                               [selectedItem]=\"selectedItem\"\n                               [pageIndex]=\"pageIndex\"\n                               [pageSize]=\"pageSize\"\n                               [totalRows]=\"totalRows\"\n                               [enabled]=\"enabled\"\n                               [visible]=\"visible\"\n                               [dataSource]=\"keywordSearchSource\"\n                               [showListButton]=\"showListButton\"\n                               (selectedItemChanged)=\"itemChangedHandler($event)\"\n                               (keywordSearch)=\"onKeywordSearch($event)\"\n                               (searchRequested)=\"doSearch($event)\">\n\n          <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'30*'\"></azteca-grid-column>\n\n      </azteca-catalog-selector>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent,
                    useExisting: core_1.forwardRef(function () { return RetencionesSelectorComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return RetencionesSelectorComponent_1; }),
                    multi: true
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, retencion_service_1.RetencionService])
    ], RetencionesSelectorComponent);
    return RetencionesSelectorComponent;
}(search_1.CatalogSelector));
exports.RetencionesSelectorComponent = RetencionesSelectorComponent;
