"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
//
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
var poliza_perfil_service_1 = require("../services/poliza-perfil.service");
var PolizaPerfilListComponent = /** @class */ (function (_super) {
    __extends(PolizaPerfilListComponent, _super);
    function PolizaPerfilListComponent(context, service) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.service = service;
        _this.searchByUser = false;
        return _this;
    }
    PolizaPerfilListComponent.prototype.onSearchRequested = function (request) {
        var _this = this;
        if (this.searchByUser) {
            this.service.searchPerfilByUsuario(this.context.app.defaultSite.identity, request)
                .then(function (result) {
                _this.polizasPerfil = result.rows;
                _this.totalRows = result.totalRows;
                _this.pageIndex = request.pageIndex;
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.service.search(this.context.app.defaultSite.identity, request)
                .then(function (result) {
                _this.polizasPerfil = result.rows;
                _this.totalRows = result.totalRows;
                _this.pageIndex = request.pageIndex;
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    PolizaPerfilListComponent.prototype.onSelectedItemsChanged = function (selectedGroups) {
        this.selectedItemsChanged.emit(selectedGroups);
    };
    PolizaPerfilListComponent.prototype.onSelectedItemChanged = function (group) {
        this.selectedItemChanged.emit(group);
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], PolizaPerfilListComponent.prototype, "searchByUser", void 0);
    PolizaPerfilListComponent = __decorate([
        core_1.Component({
            selector: 'accounting-poliza-perfil-list',
            template: "\n      <catalog-list-dialog (searchRequested)=\"onSearchRequested($event)\"\n                           (selectedItemsChanged)=\"onSelectedItemsChanged($event)\"\n                           (selectedItemChanged)=\"onSelectedItemChanged($event)\"\n                           [catalogList]=\"polizasPerfil\"\n                           [excludedItems]=\"excludedItems\"\n                           [multiSelect]=\"multiSelect\"\n                           [serverSide]=\"serverSide\"\n                           [pageSize]=\"pageSize\"\n                           [totalRows]=\"totalRows\"\n                           [pageIndex]=\"pageIndex\"\n                           [title]=\"'Perfil Polizas'\">\n\n          <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'20*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Tipo Poliza'\" [binding]=\"'polizaTipo'\" [width]=\"'60*'\"></azteca-grid-column>\n\n\n      </catalog-list-dialog>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, poliza_perfil_service_1.PolizaPerfilService])
    ], PolizaPerfilListComponent);
    return PolizaPerfilListComponent;
}(search_1.CatalogListDialog));
exports.PolizaPerfilListComponent = PolizaPerfilListComponent;
