import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { ComprobanteCancelacionInfo } from '../models/comprobante-cancelacion';
import { ComprobanteFiscalItem } from '../models/comprobante-fiscal';
import { ComprobanteCancelacionService } from '../services/comprobante-cancelacion.service';
import { ComprobanteFiscalService } from '../services/comprobante-fiscal.service';
import { ModalDirective } from 'ngx-bootstrap/modal/modal.directive';
export declare class ComprobantesCancelacionesEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private ejercicioService;
    private comprobanteFiscalSvc;
    comprobanteCancelacion: ComprobanteCancelacionInfo;
    detailsList: EditableListComponent;
    comprobantesList: ModalDirective;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, ejercicioService: ComprobanteCancelacionService, comprobanteFiscalSvc: ComprobanteFiscalService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onComprobanteSelected(comprobanteItem: ComprobanteFiscalItem): void;
}
