"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var comprobante_cancelacion_1 = require("../models/comprobante-cancelacion");
var comprobante_cancelacion_service_1 = require("../services/comprobante-cancelacion.service");
var comprobante_fiscal_service_1 = require("../services/comprobante-fiscal.service");
var modal_directive_1 = require("ngx-bootstrap/modal/modal.directive");
var ComprobantesCancelacionesEditor = /** @class */ (function (_super) {
    __extends(ComprobantesCancelacionesEditor, _super);
    function ComprobantesCancelacionesEditor(context, router, route, location, formBuilder, documentTypeService, ejercicioService, comprobanteFiscalSvc) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.ejercicioService = ejercicioService;
        _this.comprobanteFiscalSvc = comprobanteFiscalSvc;
        _this.comprobanteCancelacion = new comprobante_cancelacion_1.ComprobanteCancelacionInfo();
        _this.documentForm = formBuilder.group({});
        return _this;
    }
    ComprobantesCancelacionesEditor_1 = ComprobantesCancelacionesEditor;
    ComprobantesCancelacionesEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
    };
    ComprobantesCancelacionesEditor.prototype.onCreatingDocument = function () {
    };
    ComprobantesCancelacionesEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.ejercicioService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.comprobanteCancelacion = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesCancelacionesEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.ejercicioService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.comprobanteCancelacion = doc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesCancelacionesEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.ejercicioService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.comprobanteCancelacion = doc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesCancelacionesEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.ejercicioService.update(this.comprobanteCancelacion)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.comprobanteCancelacion.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.comprobanteCancelacion = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesCancelacionesEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.ejercicioService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesCancelacionesEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.ejercicioService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesCancelacionesEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.comprobanteCancelacion.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// COMPROBANTES /////////////////////////
    ComprobantesCancelacionesEditor.prototype.onAddingDetail = function () {
        //this.comprobantesList.config.backdrop = false;
        this.comprobantesList.show();
    };
    ComprobantesCancelacionesEditor.prototype.onComprobanteSelected = function (comprobanteItem) {
        var _this = this;
        this.comprobanteFiscalSvc.getDetail(comprobanteItem.id)
            .then(function (item) {
            //this.comprobante = item
            //this.comprobantesList.hide;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var ComprobantesCancelacionesEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], ComprobantesCancelacionesEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('comprobantesList'),
        __metadata("design:type", modal_directive_1.ModalDirective)
    ], ComprobantesCancelacionesEditor.prototype, "comprobantesList", void 0);
    ComprobantesCancelacionesEditor = ComprobantesCancelacionesEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-comprobante-cancelacion-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                  [title]=\"'Comprobantes'\"\n                                  [document]=\"comprobanteCancelacion\"\n                                  [valid]=\"valid\"\n                                  (configureDocument)=\"onConfigureDocument($event)\"\n                                  (creatingDocument)=\"onCreatingDocument()\"\n                                  (viewingDocument)=\"onViewingDocument($event)\"\n                                  (cloningDocument)=\"onCloningDocument($event)\"\n                                  (savingDocument)=\"onSavingDocument($event)\"\n                                  (loadingDocument)=\"onLoadingDocument($event)\"\n                                  (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                  (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                  (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <tabset>\n\n                          <tab heading=\"Comprobante Fiscal\" (select)=\"onTabSelected($event)\">\n\n                              <azteca-editable-list #detailsList\n                                                    (addingItem)=\"onAddingDetail()\"\n                                                    (editingItem)=\"onEditingDetail($event)\"\n                                                    (deletingItem)=\"onDeletingDetail($event)\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    [listItems]=\"comprobanteCancelacion.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'ADD'\" [icon]=\"'glyphicon glyphicon-plus'\" [text]=\"'Agregar'\" [smallText]=\"'agregar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'ASOC'\" [icon]=\"'glyphicon glyphicon-list'\" [text]=\"'Asociaciones'\" [smallText]=\"'comprobantes asociados'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'Comprobante'\" [binding]=\"'idComprobante'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaComprobante'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'UUID'\" [binding]=\"'uuid'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n\n                              </azteca-editable-list>\n\n                          </tab>\n\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n\n      <accounting-comprobantes-list #comprobantesList\n                                    (selectedItemChanged)=\"onComprobanteSelected($event)\"\n                                    [idContribuyente]=\"0\"\n                                    [idComprobanteTipo]=\"1\"\n                                    [Activos]=\"true\"\n                                    [sinReferencia]=\"true\">\n      </accounting-comprobantes-list>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ComprobantesCancelacionesEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: comprobante_cancelacion_service_1.ComprobanteCancelacionService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            comprobante_cancelacion_service_1.ComprobanteCancelacionService,
            comprobante_fiscal_service_1.ComprobanteFiscalService])
    ], ComprobantesCancelacionesEditor);
    return ComprobantesCancelacionesEditor;
}(editors_1.DocumentEditor));
exports.ComprobantesCancelacionesEditor = ComprobantesCancelacionesEditor;
