import { Router, ActivatedRoute } from '@angular/router';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, DocumentItem } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { MenuItem } from 'framework3/controls';
import { ComprobanteCancelacionItem } from '../models/comprobante-cancelacion';
import { ComprobanteCancelacionService } from '../services/comprobante-cancelacion.service';
import { ComprobanteFiscalInfo } from '../models/comprobante-fiscal';
import { ComprobanteFiscalService } from '../services/comprobante-fiscal.service';
export declare class ComprobantesCancelacionesManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private comprobanteCancelacionService;
    private comprobanteFiscalService;
    comprobantesCancelaciones: ComprobanteCancelacionItem[];
    currentComprobante: ComprobanteFiscalInfo;
    viewDialog: ModalDirective;
    constructor(context: Context, router: Router, route: ActivatedRoute, comprobanteCancelacionService: ComprobanteCancelacionService, comprobanteFiscalService: ComprobanteFiscalService);
    onConfigureDocument(): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onMenuItemClick(option: MenuItem): void;
}
