"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var comprobante_cancelacion_service_1 = require("../services/comprobante-cancelacion.service");
var comprobante_fiscal_1 = require("../models/comprobante-fiscal");
var comprobante_fiscal_service_1 = require("../services/comprobante-fiscal.service");
var ComprobantesCancelacionesManager = /** @class */ (function (_super) {
    __extends(ComprobantesCancelacionesManager, _super);
    function ComprobantesCancelacionesManager(context, router, route, comprobanteCancelacionService, comprobanteFiscalService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.comprobanteCancelacionService = comprobanteCancelacionService;
        _this.comprobanteFiscalService = comprobanteFiscalService;
        _this.currentComprobante = new comprobante_fiscal_1.ComprobanteFiscalInfo();
        return _this;
    }
    ComprobantesCancelacionesManager_1 = ComprobantesCancelacionesManager;
    ComprobantesCancelacionesManager.prototype.onConfigureDocument = function () {
        this.refreshList();
        this.applyPolicies();
    };
    ComprobantesCancelacionesManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteCancelacionService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.comprobantesCancelaciones = response.rows;
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesCancelacionesManager.prototype.onAddingItem = function () {
        this.router.navigate(['0'], { relativeTo: this.route });
    };
    ComprobantesCancelacionesManager.prototype.onViewingItem = function (document) {
        this.router.navigate([document.id, { readonly: true }], { relativeTo: this.route });
    };
    ComprobantesCancelacionesManager.prototype.onEditingItem = function (document) {
        this.router.navigate([document.id], { relativeTo: this.route });
    };
    ComprobantesCancelacionesManager.prototype.onDeletingItem = function (document) {
        var _this = this;
        this.comprobanteCancelacionService.delete(document.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El documento ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesCancelacionesManager.prototype.onCloningItem = function (document) {
        this.router.navigate([0, { cloneId: document.id }], { relativeTo: this.route });
    };
    ComprobantesCancelacionesManager.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteCancelacionService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesCancelacionesManager.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteCancelacionService.previousStep(document.id, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesCancelacionesManager.prototype.onMenuItemClick = function (option) {
        var _this = this;
        if (option.name == 'EVALUAR') {
            this.context.app.showSpinner();
            this.comprobanteCancelacionService.evaluarProceso(this.manager.currentDocument.id)
                .then(function (lote) {
                _this.context.app.hideSpinner();
                _this.refreshList();
                _this.showAlert("Se ha evaluado la solicitud de cancelación", "success");
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == 'OPEN') {
            this.context.app.showSpinner();
            var idDocument = this.manager.currentDocument.id;
            var idComprobante = "";
            this.comprobantesCancelaciones.forEach(function (item) {
                if (item.id == idDocument) {
                    idComprobante = item.idComprobante;
                }
            });
            this.comprobanteFiscalService.getDetail(idComprobante)
                .then(function (comprobante) {
                _this.currentComprobante = comprobante;
                _this.context.app.hideSpinner();
                _this.viewDialog.config.backdrop = false;
                _this.viewDialog.show();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    var ComprobantesCancelacionesManager_1;
    __decorate([
        core_1.ViewChild('viewDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ComprobantesCancelacionesManager.prototype, "viewDialog", void 0);
    ComprobantesCancelacionesManager = ComprobantesCancelacionesManager_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-comprobantes-cancelaciones-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Documentos pendientes de autorizar cancelaci&oacute;n</div>\n          <div class=\"card-block\">\n              <azteca-document-manager (searchRequested)=\"onSearchRequested($event)\"\n                                       (addingItem)=\"onAddingItem()\"\n                                       (viewingItem)=\"onViewingItem($event)\"\n                                       (editingItem)=\"onEditingItem($event)\"\n                                       (deletingItem)=\"onDeletingItem($event)\"\n                                       (cloningItem)=\"onCloningItem($event)\"\n                                       (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                       (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                       (configureDocument)=\"onConfigureDocument($event)\"\n                                       (menuItemClick)=\"onMenuItemClick($event)\"\n                                       [enabled]=\"enabled\"\n                                       [allowNew]=\"true\"\n                                       [allowView]=\"true\"\n                                       [allowEdit]=\"true\"\n                                       [allowDelete]=\"false\"\n                                       [allowClone]=\"false\"\n                                       [allowNext]=\"false\"\n                                       [allowPrevious]=\"false\"\n                                       [allowAudit]=\"false\"\n                                       [filterGroups]=\"filterGroups\"\n                                       [documentList]=\"comprobantesCancelaciones\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'EVALUAR'\" [icon]=\"'glyphicon glyphicon-transfer'\" [text]=\"'Evaluar cancelaci\u00F3n'\" [smallText]=\"'Evaluar cancelaci\u00F3n'\"></azteca-menu-item>\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"200\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"180\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"80\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"80\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Comprobante'\" [binding]=\"'idComprobante'\" [width]=\"160\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaComprobante'\" [width]=\"160\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Emisor'\" [binding]=\"'rfcEmisor'\" [width]=\"80\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Emite'\" [binding]=\"'nombreEmisor'\" [width]=\"320\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Receptor'\" [binding]=\"'rfcReceptor'\" [width]=\"80\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"80\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Estatus'\" [binding]=\"'status'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"'10*'\"></azteca-grid-column>\n\n              </azteca-document-manager>\n          </div>\n      </div>\n\n      <div bsModal #viewDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\"></h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"viewDialog.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <accounting-comprobante-viewer [comprobante]=\"currentComprobante\"></accounting-comprobante-viewer>\n                  </div> <!--Modal Body-->\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ComprobantesCancelacionesManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: comprobante_cancelacion_service_1.ComprobanteCancelacionService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute,
            comprobante_cancelacion_service_1.ComprobanteCancelacionService, comprobante_fiscal_service_1.ComprobanteFiscalService])
    ], ComprobantesCancelacionesManager);
    return ComprobantesCancelacionesManager;
}(editors_1.DocumentManager));
exports.ComprobantesCancelacionesManager = ComprobantesCancelacionesManager;
