"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("framework3/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var controls_1 = require("framework3/controls");
var ComprobantesLoaderComponent = /** @class */ (function (_super) {
    __extends(ComprobantesLoaderComponent, _super);
    function ComprobantesLoaderComponent(context, router, route, formBuilder, procesoSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.procesoSvc = procesoSvc;
        _this.sentidos = [];
        _this.cargando = false;
        _this.form = formBuilder.group({
            'sentido': ['', forms_1.Validators.required],
        });
        _this.sentidos =
            [
                { "id": "E", "nombre": "Emitidos" },
                { "id": "R", "nombre": "Recibidos" },
                { "id": "ER", "nombre": "Ambos" }
            ];
        return _this;
    }
    ComprobantesLoaderComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.procesoSvc.getDetailByCode(this.context.app.defaultCompany.idBranch, 'ACC_CFDIS')
            .then(function (proc) {
            _this.rutaComprobantes = proc.url;
            _this.procesoSvc.getDetailByCode(_this.context.app.defaultCompany.idBranch, 'ACC_CFLOADER')
                .then(function (procc) {
                _this.idLoader = procc.identity;
            })
                .catch(function (error) { return _this.handleError(error); });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesLoaderComponent.prototype.selectedSentido = function (item) {
        this.sentido = item;
    };
    ComprobantesLoaderComponent.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            if (this.sentido == 'ER') {
                this.router.navigate([this.rutaComprobantes + '/' + this.idLoader.toString()]);
            }
            else {
                this.router.navigate([this.rutaComprobantes + '/' + this.idLoader.toString() + '/' + this.sentido]);
            }
        }
    };
    ComprobantesLoaderComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.cargando = false;
        this.alerts.showAlert(message, 'danger');
    };
    //Implementacion de politicas
    ComprobantesLoaderComponent.prototype.applyPolicy = function (policy) {
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ComprobantesLoaderComponent.prototype, "alerts", void 0);
    ComprobantesLoaderComponent = __decorate([
        core_1.Component({
            selector: 'accounting-comprobantes-loader',
            template: "\n      <form [formGroup]=\"form\">\n\n          <div class=\"row\">\n              <div class=\"col-3 col-md-3\">\n                  <azteca-form-field [label]=\"'Sentido de los comprobantes:'\">\n                      <az-combobox #cboSentido\n                                   formControlName=\"sentido\"\n                                   [(ngModel)]=\"sentido\"\n                                   (selectedItemChanged)=\"selectedSentido($event)\"\n                                   [items]=\"sentidos\"\n                                   [displayMember]=\"'nombre'\"\n                                   [valueMember]=\"'id'\">\n                      </az-combobox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n              <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Continuar'\" [toolTip]=\"'Continuar'\" [icon]=\"'glyphicon glyphicon-play'\" [enabled]=\"true\"></az-toolbar-button>\n          </az-toolbar>\n\n\n      </form>\n    ",
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_2.ProcesoService])
    ], ComprobantesLoaderComponent);
    return ComprobantesLoaderComponent;
}(core_2.ProcessComponent));
exports.ComprobantesLoaderComponent = ComprobantesLoaderComponent;
