"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Locales
var ejercicio_1 = require("../models/ejercicio");
var ejercicio_service_1 = require("../services/ejercicio.service");
var ejercicio_tipo_service_1 = require("../services/ejercicio-tipo.service");
var moment = require("moment");
var EjerciciosEditor = /** @class */ (function (_super) {
    __extends(EjerciciosEditor, _super);
    function EjerciciosEditor(context, router, route, location, formBuilder, documentTypeService, ejercicioService, ejercicioTipoService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.ejercicioService = ejercicioService;
        _this.ejercicioTipoService = ejercicioTipoService;
        _this.ejercicio = new ejercicio_1.EjercicioInfo();
        _this.ejerciciosTipos = [];
        _this.documentForm = formBuilder.group({
            'nombre': ['', forms_1.Validators.required],
            'fechaIni': ['', forms_1.Validators.required],
            'fechaFin': ['', forms_1.Validators.required],
            'idEjercicioTipo': [0, controls_1.AztecaValidators.selected],
        });
        return _this;
    }
    EjerciciosEditor_1 = EjerciciosEditor;
    EjerciciosEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
        this.loadEjerciciosTipos();
    };
    EjerciciosEditor.prototype.onCreatingDocument = function () {
    };
    EjerciciosEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.ejercicioService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.ejercicio = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EjerciciosEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.ejercicioService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.ejercicio = doc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EjerciciosEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.ejercicioService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.ejercicio = doc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EjerciciosEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.ejercicio.idEmpresa = this.context.app.defaultCompany.identity;
        this.ejercicio.fechaIni = moment(this.ejercicio.fechaIni).startOf('day').toDate();
        this.ejercicio.fechaFin = moment(this.ejercicio.fechaFin).startOf('day').toDate();
        this.ejercicioService.update(this.ejercicio)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.ejercicio.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.ejercicio = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EjerciciosEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.ejercicioService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EjerciciosEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.ejercicioService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EjerciciosEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.ejercicio.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    //
    EjerciciosEditor.prototype.loadEjerciciosTipos = function () {
        var _this = this;
        this.ejercicioTipoService.loadList(this.context.app.defaultSite.identity)
            .then(function (tipos) { return _this.ejerciciosTipos = tipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    var EjerciciosEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], EjerciciosEditor.prototype, "detailsList", void 0);
    EjerciciosEditor = EjerciciosEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-ejercicios-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                  [title]=\"'Ejercicios'\"\n                                  [document]=\"ejercicio\"\n                                  [valid]=\"valid\"\n                                  (configureDocument)=\"onConfigureDocument($event)\"\n                                  (creatingDocument)=\"onCreatingDocument()\"\n                                  (viewingDocument)=\"onViewingDocument($event)\"\n                                  (cloningDocument)=\"onCloningDocument($event)\"\n                                  (savingDocument)=\"onSavingDocument($event)\"\n                                  (loadingDocument)=\"onLoadingDocument($event)\"\n                                  (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                  (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                  (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-6\">\n                                      <azteca-form-field [label]=\"'Nombre:'\">\n                                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"ejercicio.nombre\" [enabled]=\"ejercicio.status!=0\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-6\">\n                                      <azteca-form-field [label]=\"'Tipo:'\">\n                                          <az-combobox formControlName=\"idEjercicioTipo\"\n                                                       [(ngModel)]=\"ejercicio.idEjercicioTipo\"\n                                                       [items]=\"ejerciciosTipos\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-6\">\n                                      <label class=\"control-label\">Fecha Inicial:</label>\n                                      <az-input-date formControlName=\"fechaIni\" [(ngModel)]=\"ejercicio.fechaIni\" [enabled]=\"ejercicio.status!=0\"></az-input-date>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-6\">\n                                      <label class=\"control-label\">Fecha Final:</label>\n                                      <az-input-date formControlName=\"fechaFin\" [(ngModel)]=\"ejercicio.fechaFin\" [enabled]=\"ejercicio.status!=0\"></az-input-date>\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <tab heading=\"Periodos\" (select)=\"onTabSelected($event)\" [disabled]=\"ejercicio.identity==''\">\n                              <contabilidad-periodos-manager \n                                                             [enabled]=\"ejercicio.estatus=='A' && ejercicio.status==2\" \n                                                             [idEjercicio]=\"ejercicio.identity\">\n\n                              </contabilidad-periodos-manager>\n                          </tab>\n\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"ejercicio.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return EjerciciosEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: ejercicio_service_1.EjercicioService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            ejercicio_service_1.EjercicioService,
            ejercicio_tipo_service_1.EjercicioTipoService])
    ], EjerciciosEditor);
    return EjerciciosEditor;
}(editors_1.DocumentEditor));
exports.EjerciciosEditor = EjerciciosEditor;
