"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var ficha_1 = require("../models/ficha");
var ficha_detail_1 = require("../models/ficha-detail");
var ficha_service_1 = require("../services/ficha.service");
var fichas_detail_editor_1 = require("./parts/fichas-detail.editor");
var FichasEditor = /** @class */ (function (_super) {
    __extends(FichasEditor, _super);
    function FichasEditor(context, router, route, location, formBuilder, documentTypeService, fichaService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.fichaService = fichaService;
        _this.ficha = new ficha_1.FichaInfo();
        //
        _this.afectadores = [];
        _this.documentForm = formBuilder.group({
            'cuenta': [0],
            'afectador': ['', forms_1.Validators.required],
            'observaciones': ['', forms_1.Validators.required],
            'importe': [0, forms_1.Validators.required],
            'afectacion': ['', forms_1.Validators.required],
        });
        _this.afectadores =
            [
                { "id": "C", "nombre": "Cargo" },
                { "id": "A", "nombre": "Abono" }
            ];
        return _this;
    }
    FichasEditor_1 = FichasEditor;
    FichasEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
    };
    FichasEditor.prototype.onCreatingDocument = function () {
    };
    FichasEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.fichaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.ficha = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FichasEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.fichaService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.ficha = doc;
            _this.detailsEditor.clientIndexStart = _this.ficha.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FichasEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.fichaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.ficha = doc;
            _this.detailsEditor.clientIndexStart = _this.ficha.details.length;
            if (_this.ficha.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FichasEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.fichaService.update(this.ficha)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.ficha.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.ficha = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FichasEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.fichaService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FichasEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.fichaService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FichasEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.ficha.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    /*
    selectedAfectador(afectador) {
    }
    */
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    FichasEditor.prototype.onAddingDetail = function () {
        this.detailsEditor.detail = new ficha_detail_1.FichaDetail();
        this.detailsEditor.show();
    };
    FichasEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    FichasEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    FichasEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.ficha.details = updatedDetails;
    };
    FichasEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    var FichasEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], FichasEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", fichas_detail_editor_1.FichaDetailEditor)
    ], FichasEditor.prototype, "detailsEditor", void 0);
    FichasEditor = FichasEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-fichas-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'Fichas'\"\n                                         [document]=\"ficha\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-5 col-md-3\">\n                                      <azteca-form-field [label]=\"'Fecha Afectaci\u00F3n:'\">\n                                          <az-input-date formControlName=\"afectacion\" [(ngModel)]=\"ficha.fechaAfectacion\"></az-input-date>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-8 col-md-5\">\n                                      <azteca-form-field [label]=\"'Afectador:'\">\n                                          <az-combobox formControlName=\"afectador\"\n                                                       [(ngModel)]=\"ficha.tipoAfectacion\"\n                                                       [items]=\"afectadores\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-8 col-md-5\">\n                                      <azteca-form-field [label]=\"'Importe:'\">\n                                          <az-input-number formControlName=\"importe\" [(ngModel)]=\"ficha.importe\" format=\"N2\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-md-10\">\n                                          <azteca-form-field [label]=\"'Cuenta:'\">\n                                              <accounting-cuenta-selector formControlName=\"cuenta\" [(ngModel)]=\"ficha.idCuentaAfectacion\"></accounting-cuenta-selector>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-md-10\">\n                                          <azteca-form-field [label]=\"'Observaciones:'\">\n                                              <az-textarea formControlName=\"observaciones\" [(ngModel)]=\"ficha.observaciones\"></az-textarea>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n                          </tab>\n\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <contabilidad-fichas-detail-editor #detailsEditor                                     \n                                           (savingItem)=\"onSavingDetail($event)\">\n\n      </contabilidad-fichas-detail-editor>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return FichasEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: ficha_service_1.FichaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            ficha_service_1.FichaService])
    ], FichasEditor);
    return FichasEditor;
}(editors_1.DocumentEditor));
exports.FichasEditor = FichasEditor;
