"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var nota_1 = require("../models/nota");
var nota_detail_1 = require("../models/nota-detail");
var nota_relaciones_1 = require("../models/nota-relaciones");
var nota_service_1 = require("../services/nota.service");
var notas_detail_editor_1 = require("./parts/notas-detail.editor");
var divisa_service_1 = require("../services/divisa.service");
var divisa_1 = require("../models/divisa");
var forma_pago_service_1 = require("../services/forma-pago.service");
var accounting_1 = require("../../accounting");
var contribuyente_service_1 = require("../services/contribuyente.service");
var NotasEditor = /** @class */ (function (_super) {
    __extends(NotasEditor, _super);
    function NotasEditor(context, router, route, location, formBuilder, documentTypeService, notaService, formaPagoService, divisaService, contribuyenteService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.notaService = notaService;
        _this.formaPagoService = formaPagoService;
        _this.divisaService = divisaService;
        _this.contribuyenteService = contribuyenteService;
        _this.nota = new nota_1.NotaInfo();
        _this.divisaInfo = new divisa_1.DivisaInfo();
        _this.formasPago = [];
        _this.usosCFDI = [];
        _this.comprobantes = [];
        _this.currentComprobante = new nota_relaciones_1.NotaRelaciones();
        _this.comprobantesCollection = new wijmo_1.CollectionView();
        _this.divisaDefault = 0;
        _this.documentForm = formBuilder.group({
            'contribuyente': [0, forms_1.Validators.required],
            'divisa': [0, forms_1.Validators.required],
            'observaciones': ['', forms_1.Validators.required],
            'comprobante': [''],
            'idFormaPago': [0, forms_1.Validators.required],
            'idUsoCFDI': [0, forms_1.Validators.required],
        });
        return _this;
    }
    NotasEditor_1 = NotasEditor;
    NotasEditor.prototype.onConfigureDocument = function (docType) {
        this.loadFormasPago();
        this.applyPolicies();
        this.getDivisaDefault();
        this.loadUsosCFDI();
    };
    NotasEditor.prototype.onCreatingDocument = function () {
        var _this = this;
        this.notaService.create().then(function (doc) {
            _this.nota = doc;
            _this.nota.idSucursal = _this.context.app.defaultSite.identity;
            console.log("Creandon documebti");
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.nota = doc;
            _this.listComprobantes();
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.notaService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.nota = doc;
            _this.detailsEditor.clientIndexStart = _this.nota.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.nota = doc;
            _this.listComprobantes();
            _this.detailsEditor.clientIndexStart = _this.nota.details.length;
            if (_this.nota.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.nota.origen = 'M';
        this.notaService.updateNota(this.nota)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.nota.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.nota = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.nota.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    NotasEditor.prototype.onAddingDetail = function () {
        this.detailsEditor.detail = new nota_detail_1.NotaDetail();
        this.detailsEditor.show();
    };
    NotasEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    NotasEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    NotasEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.nota.details = updatedDetails;
    };
    NotasEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    NotasEditor.prototype.loadFormasPago = function () {
        var _this = this;
        this.formaPagoService.loadList(this.context.app.defaultSite.identity)
            .then(function (formas) { return _this.formasPago = formas; })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.listComprobantes = function () {
        var _this = this;
        this.notaService.ListarComprobantes(this.nota.identity)
            .then(function (recs) {
            _this.comprobantes = recs;
            _this.comprobantesCollection.sourceCollection = _this.comprobantes;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.asignarComprobante = function (comprobante) {
        var rel = new nota_relaciones_1.NotaRelaciones;
        rel.folio = +comprobante.folio;
        rel.serie = comprobante.serie;
        rel.total = comprobante.total;
        rel.uuid = comprobante.timbreFiscal.uuid;
        var newRel = this.nota.relaciones.slice();
        newRel.push(rel);
        this.nota.relaciones = newRel;
        this.comprobantesCollection.sourceCollection = newRel;
        this.comprobantesCollection.refresh;
        /*
                this.notaService.AgregarComprobante(this.nota.identity, comprobante.identity, uuid)
                    .then(r => {
                        this.listComprobantes();
                    })
                    .catch(error => this.handleError(error));
        */
    };
    NotasEditor.prototype.getDivisaDefault = function () {
        var _this = this;
        this.divisaService.getDetailByEmpresa(this.context.app.defaultCompany.identity)
            .then(function (r) {
            _this.nota.idDivisa = r.identity;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.asignarComprobante(this.selectorComprobante.selectedItem);
        }
    };
    NotasEditor.prototype.onMenuComprobantesClicked = function (menu, args) {
        var _this = this;
        if (menu.selectedIndex == 0) {
            //Eliminar
            this.comprobantes = this.comprobantesCollection.currentItem;
            this.notaService.EliminarComprobante(this.comprobantesCollection.currentItem.idNotaRelacion)
                .then(function (r) {
                _this.comprobantesCollection.remove(_this.comprobantes);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    NotasEditor.prototype.loadUsosCFDI = function () {
        var _this = this;
        this.contribuyenteService.loadUsosCFDI(this.context.app.defaultCompany.identity)
            .then(function (usos) { return _this.usosCFDI = usos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onContribuyenteSelected = function (contribuyente) {
        this.nota.idUsoCFDI = contribuyente.idUsoCFDI;
    };
    var NotasEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], NotasEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", notas_detail_editor_1.NotaDetailEditor)
    ], NotasEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild('selectorComprobante'),
        __metadata("design:type", accounting_1.ComprobanteFiscalSelectorComponent)
    ], NotasEditor.prototype, "selectorComprobante", void 0);
    __decorate([
        core_1.ViewChild('selectorContribuyente'),
        __metadata("design:type", accounting_1.ContribuyenteSelectorComponent)
    ], NotasEditor.prototype, "selectorContribuyente", void 0);
    NotasEditor = NotasEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-notas-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'Notas'\"\n                                         [document]=\"nota\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n                              <azteca-form-field [label]=\"'Seleccionar contribuyente:'\">\n                                  <azteca-form-field [label]=\"Contribuyente\">\n                                      <contabilidad-contribuyente-selector formControlName=\"contribuyente\" [(ngModel)]=\"nota.idContribuyente\" (itemSelected)=\"onContribuyenteSelected($event)\" #selectorContribuyente ></contabilidad-contribuyente-selector>\n                                  </azteca-form-field>\n                              </azteca-form-field>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Uso de CFDI:'\">\n                                          <az-combobox formControlName=\"idUsoCFDI\"\n                                                       [(ngModel)]=\"nota.idUsoCFDI\"\n                                                       [items]=\"usosCFDI\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                              <azteca-form-field [label]=\"'Seleccionar divisa:'\">\n                                  <azteca-form-field [label]=\"Divisa\">\n                                      <accounting-divisas-selector formControlName=\"divisa\" [(ngModel)]=\"nota.idDivisa\"></accounting-divisas-selector>\n                                  </azteca-form-field>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Forma de Pago:'\">\n                                  <az-combobox formControlName=\"idFormaPago\"\n                                               [(ngModel)]=\"nota.idFormaPago\"\n                                               [items]=\"formasPago\"\n                                               [displayMember]=\"'nombre'\"\n                                               [valueMember]=\"'id'\">\n                                  </az-combobox>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Observaciones:'\">\n                                  <az-textarea formControlName=\"observaciones\" [(ngModel)]=\"nota.observaciones\"></az-textarea>\n                              </azteca-form-field>\n\n\n                          </tab>\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list   #detailsList\n                                                      (addingItem)=\"onAddingDetail()\"\n                                                      (editingItem)=\"onEditingDetail($event)\"\n                                                      (deletingItem)=\"onDeletingDetail($event)\"\n                                                      (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                      [listItems]=\"nota.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                                   <!-- COLUMNAS DEL GRID-->\n      \t\t\t\t\t\t\t<!-- Columnas de Ejemplo-->\n                                  <azteca-grid-column [header]=\"'Concepto'\" [binding]=\"'concepto'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></azteca-grid-column>                            \n\t\t\t\t\t\t\t\n\n                              </azteca-editable-list>\n                          </tab>\n                          <tab heading=\"Comprobantes fiscales\" (select)=\"onTabSelected($event)\">\n\n                        \n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'Agregar comprobante:'\">\n                                          <azteca-form-field [label]=\"Comprobante\">\n                                              <accounting-comprobante-fiscal-selector formControlName=\"comprobante\" [idContribuyente]=\"nota.idContribuyente\" #selectorComprobante> </accounting-comprobante-fiscal-selector>\n                                          </azteca-form-field>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar comprobante'\" [icon]=\"'glyphicon glyphicon-plus'\" [enabled]=\"true\"></az-toolbar-button>\n                              </az-toolbar>\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <wj-flex-grid #grid style=\"height:550px\"\n                                                    [itemsSource]=\"comprobantesCollection\"\n                                                    [wjContextMenu]=\"ctxMenuComprobantes\"\n                                                    [isReadOnly]=\"true\">\n                                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                                          <wj-flex-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"'10*'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'UUID'\" [binding]=\"'uuid'\" [width]=\"'50*'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"'20*'\"></wj-flex-grid-column>\n\n                                      </wj-flex-grid>\n                                  </div>\n                              </div>\n\n\n                          </tab>\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n\n              <wj-menu #ctxMenuComprobantes (itemClicked)=\"onMenuComprobantesClicked(ctxMenuComprobantes, $event)\" style=\"display:none\">\n                  <wj-menu-item>\n                      <span class=\"glyphicon glyphicon-trash\"></span><b> Eliminar</b>\n                      <br />\n                      <small><i>eliminar comprobante</i></small>\n                  </wj-menu-item>\n              </wj-menu>\n\n\n          </azteca-document-editor>\n      </form>\n\n      <contabilidad-nota-detail-editor #detailsEditor                                     \n                                           (savingItem)=\"onSavingDetail($event)\">\n\n      </contabilidad-nota-detail-editor>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return NotasEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: nota_service_1.NotaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            nota_service_1.NotaService,
            forma_pago_service_1.FormaPagoService,
            divisa_service_1.DivisaService,
            contribuyente_service_1.ContribuyenteService])
    ], NotasEditor);
    return NotasEditor;
}(editors_1.DocumentEditor));
exports.NotasEditor = NotasEditor;
