"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var comprobante_fiscal_service_1 = require("../../services/comprobante-fiscal.service");
var ngx_bootstrap_1 = require("ngx-bootstrap");
var ComprobanteSearch = /** @class */ (function () {
    function ComprobanteSearch(context, formBuilder, comprobanteFiscalService) {
        this.context = context;
        this.formBuilder = formBuilder;
        this.comprobanteFiscalService = comprobanteFiscalService;
        this.serie = "";
        this.folio = "";
        this.consultando = false;
        this.links = [];
        this.form = formBuilder.group({
            'serie': [''],
            'folio': ['']
        });
    }
    ComprobanteSearch.prototype.onClickSearchComprobante = function () {
        this.links.length = 0;
        this.serie = "";
        this.folio = "";
        this.dlgSearch.config.backdrop = false;
        this.dlgSearch.show();
    };
    ComprobanteSearch.prototype.onClickGetComprobante = function () {
        var _this = this;
        this.consultando = true;
        this.comprobanteFiscalService.getComprobanteBySerieFolio(this.serie, this.folio, this.context.app.defaultCompany.identity)
            .then(function (result) {
            _this.consultando = false;
            _this.openPDF(result.identity);
        }).catch(function (error) {
            _this.handleError(error);
        });
    };
    ComprobanteSearch.prototype.openPDF = function (idComprobante) {
        var _this = this;
        this.links.length = 0;
        this.consultando = true;
        //Generar PDF
        this.comprobanteFiscalService.generarPdfTemporal(idComprobante)
            .then(function (pdf) {
            //Descargar xml
            _this.comprobanteFiscalService.getXmlFile(idComprobante)
                .then(function (xml) {
                _this.consultando = false;
                _this.links.push(pdf);
                _this.links.push(xml);
                window.open('/file-server/' + pdf.uri, '_blank');
            })
                .catch(function (error) { return _this.handleError(error); });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobanteSearch.prototype.hideListDialog = function () {
        this.dlgSearch.hide();
    };
    ComprobanteSearch.prototype.handleError = function (error) {
        this.consultando = false;
        console.log(error);
        this.context.app.hideSpinner();
        var errorMessage = this.context.getExceptionMessage(error);
        this.alerts.showAlert(errorMessage, 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ComprobanteSearch.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild("dlgSearch"),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ComprobanteSearch.prototype, "dlgSearch", void 0);
    ComprobanteSearch = __decorate([
        core_1.Component({
            selector: "accounting-comprobante-search",
            template: "\n      <div class=\"input-group\">\n          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickSearchComprobante()\">Comprobante Fiscal</button>\n      </div>\n\n      <div bsModal #dlgSearch=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\">Busqueda comprobante (Serie - Folio)</h4>\n                      <button type=\"button\" class=\"close\" aria-label=\"Close\" (click)=\"hideListDialog()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <form [formGroup]=\"form\">\n                          <!--Barra de alertas-->\n                          <alerts-bar></alerts-bar>\n                          <div class=\"form-group\">\n                              <label for=\"txtSerie\">Serie</label>\n                              <input type=\"text\" class=\"form-control\" formControlName=\"serie\" id=\"txtSerie\" [(ngModel)]=\"serie\" />\n                          </div>\n                          <div class=\"form-group\">\n                              <label for=\"txtFolio\">Folio</label>\n                              <input type=\"text\" class=\"form-control\" formControlName=\"folio\" id=\"txtFolio\" [(ngModel)]=\"folio\" />\n                          </div>\n                          <!--Link PDF y XML-->\n                          <div class=\"btn-group-vertical\">\n                              <a *ngFor=\"let link of links\" [href]=\"'/file-server/' + link.uri\" [download]=\"link.fileName\" class=\"btn btn-success\">\n                                  <span class=\"glyphicon glyphicon-download-alt\"></span> {{link.fileName}}\n                              </a>\n                          </div>\n                          <!--Barra de Progreso-->\n                          <div class=\"progress\" *ngIf=\"consultando\">\n                              <div class=\"progress-bar progress-bar-striped progress-bar-animated\" role=\"progressbar\" aria-valuenow=\"100\" aria-valuemin=\"0\" aria-valuemax=\"100\" style=\"width: 75%\"></div>\n                          </div>\n                          <div class=\"form-group text-right\" *ngIf=\"!consultando\">\n                              <button type=\"button\" class=\"btn btn-primary\" [disabled]=\"! (serie.length > 0 && folio.length > 0)\" (click)=\"onClickGetComprobante()\">Consultar</button>\n                          </div>\n                      </form>\n                  </div><!--Modal Body-->\n              </div> <!--Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal Directive-->\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, comprobante_fiscal_service_1.ComprobanteFiscalService])
    ], ComprobanteSearch);
    return ComprobanteSearch;
}());
exports.ComprobanteSearch = ComprobanteSearch;
