import { FormBuilder, FormGroup } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { CollectionView } from 'wijmo/wijmo';
import { Menu } from 'wijmo/wijmo.input';
import { ModalDirective } from 'ngx-bootstrap';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { Context } from 'framework3/core';
import { PolizaService } from '../../services/poliza.service';
import { AsociacionItem } from '../../models/asociacion';
import { ComprobanteFiscalItem } from '../../models/comprobante-fiscal';
import { ComprobanteFiscalService } from '../../services/comprobante-fiscal.service';
import { ComprobantesListComponent } from '../../components/comprobantes-dialog.component';
export declare class PolizasAsociacionesComponent {
    private formBuilder;
    private context;
    private router;
    private route;
    private polizaService;
    private comprobanteFiscalService;
    editorForm: FormGroup;
    logCollection: CollectionView;
    currentEntry: AsociacionItem;
    alerts: AlertsBarComponent;
    detailsDialog: ModalDirective;
    dlgAsociacionesList: ModalDirective;
    comprobantesList: ComprobantesListComponent;
    idPoliza: string;
    fecha: Date;
    idCuenta: number;
    consecutivo: number;
    addEnabled: boolean;
    constructor(formBuilder: FormBuilder, context: Context, router: Router, route: ActivatedRoute, polizaService: PolizaService, comprobanteFiscalService: ComprobanteFiscalService);
    loadLog(): void;
    mainToolbarClick(button: ToolbarButton): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onRowView(item: AsociacionItem): void;
    handleError(error: any): void;
    show(idPoliza: string, fecha: Date, idCuenta: number, consecutivo: number): void;
    onComprobanteSelected(comprobanteItem: ComprobanteFiscalItem): void;
    onMenuSeleccionadosClicked(menu: Menu, args: any): void;
}
