"use strict";
//Frameworks
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var forms_1 = require("@angular/forms");
//Bootstrap
//Features
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var wijmo_1 = require("wijmo/wijmo");
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var controls_1 = require("framework3/controls");
var core_2 = require("framework3/core");
//
var poliza_service_1 = require("../../services/poliza.service");
var asociacion_1 = require("../../models/asociacion");
var comprobante_fiscal_service_1 = require("../../services/comprobante-fiscal.service");
var comprobantes_dialog_component_1 = require("../../components/comprobantes-dialog.component");
var _ = require("lodash");
var PolizasAsociacionesComponent = /** @class */ (function () {
    function PolizasAsociacionesComponent(formBuilder, context, router, route, polizaService, comprobanteFiscalService) {
        this.formBuilder = formBuilder;
        this.context = context;
        this.router = router;
        this.route = route;
        this.polizaService = polizaService;
        this.comprobanteFiscalService = comprobanteFiscalService;
        this.logCollection = new wijmo_1.CollectionView();
        this.currentEntry = new asociacion_1.AsociacionItem();
        this.addEnabled = true;
        this.editorForm = formBuilder.group({});
    }
    /////////////////////// METODOS ////////////////////////////////////////////////
    PolizasAsociacionesComponent.prototype.loadLog = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.polizaService.loadAsociaciones(this.idPoliza)
            .then(function (log) {
            if (_this.idCuenta > 0) {
                _this.logCollection.sourceCollection = log.filter(function (x) { return x.idCuenta == _this.idCuenta && x.consecutivo == _this.consecutivo; });
            }
            else {
                var result = _(log).groupBy('uuid').transform(function (result, current) {
                    result.push({
                        idComprobante: current[0].idComprobante,
                        uuid: current[0].uuid,
                        serie: current[0].serie,
                        folio: current[0].folio,
                        rfc: current[0].rfc,
                        razonSocial: current[0].razonSocial,
                        subTotal: current[0].subTotal,
                        descuentos: current[0].descuentos,
                        impTrasladados: current[0].impTrasladados,
                        impRetenidos: current[0].impRetenidos,
                        total: current[0].total,
                    });
                }, []).value();
                _this.logCollection.sourceCollection = result; // log;
            }
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    /////////////////////// HANDLERS ///////////////////////////////////////////////
    PolizasAsociacionesComponent.prototype.mainToolbarClick = function (button) {
        if (button.name == 'REFRESH') {
            this.loadLog();
        }
    };
    PolizasAsociacionesComponent.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.comprobantesList.show();
        }
    };
    PolizasAsociacionesComponent.prototype.onRowView = function (item) {
        var _this = this;
        this.currentEntry = item;
        //this.detailsDialog.config.backdrop = false;
        //this.detailsDialog.show();
        //if (option.name == 'PDF') {
        this.context.app.showSpinner();
        this.comprobanteFiscalService.generarPdfTemporal(item.idComprobante)
            .then(function (file) {
            _this.context.app.hideSpinner();
            window.open('/file-server/' + file.uri, '_blank');
        })
            .catch(function (error) { return _this.handleError(error); });
        //}
    };
    PolizasAsociacionesComponent.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    PolizasAsociacionesComponent.prototype.show = function (idPoliza, fecha, idCuenta, consecutivo) {
        this.logCollection = new wijmo_1.CollectionView();
        this.dlgAsociacionesList.config.backdrop = false;
        this.idPoliza = idPoliza;
        this.fecha = fecha;
        this.idCuenta = idCuenta;
        this.consecutivo = consecutivo;
        this.dlgAsociacionesList.show();
        this.loadLog();
    };
    PolizasAsociacionesComponent.prototype.onComprobanteSelected = function (comprobanteItem) {
        var _this = this;
        var comprobanteItemBak = this.comprobantesList.comprobantes.find(function (item) { return item.id == comprobanteItem.id; });
        if (comprobanteItemBak) {
            this.polizaService.addAsociacion(this.idPoliza, this.fecha, this.idCuenta, this.consecutivo, comprobanteItemBak.uuid, 0, 0)
                .then(function (log) {
                _this.loadLog();
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    PolizasAsociacionesComponent.prototype.onMenuSeleccionadosClicked = function (menu, args) {
        var _this = this;
        if (menu.selectedIndex == 0) {
            //Eliminar
            this.polizaService.removeAsociacion(this.idPoliza, this.fecha, this.idCuenta, this.consecutivo, this.logCollection.currentItem.uuid)
                .then(function (log) {
                //this.loadLog();
                _this.logCollection.remove(_this.logCollection.currentItem);
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], PolizasAsociacionesComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('detailsDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], PolizasAsociacionesComponent.prototype, "detailsDialog", void 0);
    __decorate([
        core_1.ViewChild('dlgAsociacionesList'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], PolizasAsociacionesComponent.prototype, "dlgAsociacionesList", void 0);
    __decorate([
        core_1.ViewChild('comprobantesList'),
        __metadata("design:type", comprobantes_dialog_component_1.ComprobantesListComponent)
    ], PolizasAsociacionesComponent.prototype, "comprobantesList", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], PolizasAsociacionesComponent.prototype, "idPoliza", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Date)
    ], PolizasAsociacionesComponent.prototype, "fecha", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], PolizasAsociacionesComponent.prototype, "idCuenta", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], PolizasAsociacionesComponent.prototype, "consecutivo", void 0);
    PolizasAsociacionesComponent = __decorate([
        core_1.Component({
            selector: 'accounting-polizas-asociaciones-component',
            template: "\n\n      <div bsModal #dlgAsociacionesList=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n\n                      <form [formGroup]=\"editorForm\">\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <alerts-bar></alerts-bar>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n\n                              <div class=\"col-12\">\n                                  <az-panel [header]=\"'Comprobantes Fiscales'\">\n\n                                      <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                          <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar un nuevo comprobante'\" [icon]=\"'glyphicon glyphicon-plus'\" [enabled]=\"addEnabled\"></az-toolbar-button>\n                                      </az-toolbar>\n\n                                      <wj-flex-grid style=\"height:550px\" \n                                                    [itemsSource]=\"logCollection\" \n                                                    [isReadOnly]=\"true\"\n                                                    [wjContextMenu]=\"ctxMenuSeleccionados\">\n\n                                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                                          <wj-flex-grid-column [header]=\"''\" [width]=\"50\" [isReadOnly]=\"true\">\n                                              <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                                  <button type=\"button\" class=\"btn btn-default\" (click)=\"onRowView(cell.item)\">\n                                                      <span class=\"glyphicon glyphicon-search\"></span>\n                                                  </button>\n                                              </ng-template>\n                                          </wj-flex-grid-column>\n\n                                          <wj-flex-grid-column [header]=\"'UUID'\" [binding]=\"'uuid'\" [width]=\"90\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"50\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"60\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'RFC'\" [binding]=\"'rfc'\" [width]=\"70\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Raz\u00F3n Social'\" [binding]=\"'razonSocial'\" [width]=\"150\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Subtotal'\" [binding]=\"'subTotal'\" [width]=\"90\" [format]=\"'N2'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Descuentos'\" [binding]=\"'descuentos'\" [width]=\"90\" [format]=\"'N2'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Imp.Tras'\" [binding]=\"'impTrasladados'\" [width]=\"90\" [format]=\"'N2'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Imp.Ret'\" [binding]=\"'impRetenidos'\" [width]=\"90\" [format]=\"'N2'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"90\" [format]=\"'N2'\"></wj-flex-grid-column>\n                                      </wj-flex-grid>\n\n                                      <div class=\"row\">\n                                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"dlgAsociacionesList.hide()\">Cerrar</button>\n                                      </div>\n\n                                  </az-panel>\n\n                              </div> <!--Modal Body-->\n\n                          </div>\n\n                      </form>\n\n\n                      <div bsModal #detailsDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n                          <div class=\"modal-dialog modal-lg\">\n                              <div class=\"modal-content\">\n                                  <div class=\"modal-header\">\n                                      <h4 class=\"modal-title\">Detalles del error</h4>\n                                      <button type=\"button\" class=\"close pull-right\" (click)=\"detailsDialog.hide()\" aria-label=\"Close\">\n                                          <span aria-hidden=\"true\">&times;</span>\n                                      </button>\n                                  </div>\n                                  <div class=\"modal-body\">\n                                      <textarea readonly style=\"height: 500px;\" class=\"form-control\" [value]=\"currentEntry.message\"></textarea>\n                                  </div> <!--Modal Body-->\n                                  <div class=\"modal-footer\">\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"detailsDialog.hide()\">Cerrar</button>\n                                  </div> <!--Modal Footer-->\n\n                              </div> <!-- Modal Content-->\n                          </div> <!--Modal-->\n                      </div> <!--Modal directive-->\n\n                  </div>\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n      <!--DIALOGO DE CARGA DE ALMACEN DIGITAL-->\n      <accounting-comprobantes-list #comprobantesList\n                                    (selectedItemChanged)=\"onComprobanteSelected($event)\"\n                                    [idComprobanteTipo]=\"0\"\n                                    [Activos]=\"true\">\n      </accounting-comprobantes-list>\n\n      <wj-menu #ctxMenuSeleccionados (itemClicked)=\"onMenuSeleccionadosClicked(ctxMenuSeleccionados, $event)\" style=\"display:none\">\n          <wj-menu-item>\n              <span class=\"glyphicon glyphicon-trash\"></span><b> Eliminar</b>\n              <br />\n              <small><i>eliminar registro</i></small>\n          </wj-menu-item>\n      </wj-menu>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, core_2.Context, router_1.Router, router_1.ActivatedRoute,
            poliza_service_1.PolizaService, comprobante_fiscal_service_1.ComprobanteFiscalService])
    ], PolizasAsociacionesComponent);
    return PolizasAsociacionesComponent;
}());
exports.PolizasAsociacionesComponent = PolizasAsociacionesComponent;
