import { Router, ActivatedRoute } from '@angular/router';
import { Context, DocumentItem } from 'framework3/core';
import { MenuItem } from 'framework3/controls';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { PolizaItem } from '../models/poliza';
import { PolizaService } from '../services/poliza.service';
import { PolizasLogComponent } from './parts/polizas-log.component';
import { PolizasAsociacionesComponent } from './parts/polizas-asociaciones.component';
export declare class PolizasManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private polizaService;
    polizasTit: PolizaItem[];
    idPolizaCurrent: string;
    polizaLog: PolizasLogComponent;
    dlgAsociaciones: PolizasAsociacionesComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, polizaService: PolizaService);
    onConfigureDocument(): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    menuItemClick(option: MenuItem): void;
}
