"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var poliza_service_1 = require("../services/poliza.service");
var polizas_log_component_1 = require("./parts/polizas-log.component");
var polizas_asociaciones_component_1 = require("./parts/polizas-asociaciones.component");
var PolizasManager = /** @class */ (function (_super) {
    __extends(PolizasManager, _super);
    function PolizasManager(context, router, route, polizaService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.polizaService = polizaService;
        return _this;
    }
    PolizasManager_1 = PolizasManager;
    PolizasManager.prototype.onConfigureDocument = function () {
        this.refreshList();
        this.applyPolicies();
    };
    PolizasManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.polizaService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.polizasTit = response.rows;
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PolizasManager.prototype.onAddingItem = function () {
        this.router.navigate(['0'], { relativeTo: this.route });
    };
    PolizasManager.prototype.onViewingItem = function (document) {
        this.router.navigate([document.id, { readonly: true }], { relativeTo: this.route });
    };
    PolizasManager.prototype.onEditingItem = function (document) {
        this.router.navigate([document.id], { relativeTo: this.route });
    };
    PolizasManager.prototype.onDeletingItem = function (document) {
        var _this = this;
        this.polizaService.delete(document.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El documento ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PolizasManager.prototype.onCloningItem = function (document) {
        this.router.navigate([0, { cloneId: document.id }], { relativeTo: this.route });
    };
    PolizasManager.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.polizaService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PolizasManager.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.polizaService.previousStep(document.id, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PolizasManager.prototype.menuItemClick = function (option) {
        var _this = this;
        this.idPolizaCurrent = this.manager.currentDocument.id;
        if (option.name == 'Exportar') {
            this.polizaService.marcarExportacion(this.manager.currentDocument.id, -1, '-')
                .then(function (_) {
                _this.context.app.hideSpinner();
                var polizaItem = _this.polizasTit.find(function (item) { return item.id == _this.manager.currentDocument.id; });
                polizaItem.importacionEstatus = 'En Cola';
                var newList = _this.polizasTit.slice();
                _this.polizasTit = newList;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        if (option.name == 'Log') {
            //this.polizaLog.config.backdrop = false;            
            this.polizaLog.show(this.manager.currentDocument.id);
        }
        if (option.name == 'Asociaciones') {
            var poliza = this.manager.documentList.find(function (doc) { return doc.id == _this.manager.currentDocument.id; });
            if (poliza) {
                this.dlgAsociaciones.show(this.manager.currentDocument.id, poliza.fechaSys, 0, 0);
            }
        }
    };
    var PolizasManager_1;
    __decorate([
        core_1.ViewChild('polizasLog'),
        __metadata("design:type", polizas_log_component_1.PolizasLogComponent)
    ], PolizasManager.prototype, "polizaLog", void 0);
    __decorate([
        core_1.ViewChild('dlgAsociaciones'),
        __metadata("design:type", polizas_asociaciones_component_1.PolizasAsociacionesComponent)
    ], PolizasManager.prototype, "dlgAsociaciones", void 0);
    PolizasManager = PolizasManager_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-polizas-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Administrador de Polizas</div>\n          <div class=\"card-body\">\n              <azteca-document-manager (searchRequested)=\"onSearchRequested($event)\"\n                                       (addingItem)=\"onAddingItem()\"\n                                       (viewingItem)=\"onViewingItem($event)\"\n                                       (editingItem)=\"onEditingItem($event)\"\n                                       (deletingItem)=\"onDeletingItem($event)\"\n                                       (cloningItem)=\"onCloningItem($event)\"\n                                       (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                       (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                       (configureDocument)=\"onConfigureDocument($event)\"\n                                       (menuItemClick)=\"menuItemClick($event)\"\n                                       [enabled]=\"enabled\"\n                                       [allowNew]=\"allowNew\"\n                                       [allowView]=\"allowView\"\n                                       [allowEdit]=\"allowEdit\"\n                                       [allowDelete]=\"allowDelete\"\n                                       [allowClone]=\"allowClone\"\n                                       [allowNext]=\"allowNext\"\n                                       [allowPrevious]=\"allowPrevious\"\n                                       [allowAudit]=\"allowAudit\"\n                                       [filterGroups]=\"filterGroups\"\n                                       [documentList]=\"polizasTit\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'Asociaciones'\" [icon]=\"'glyphicon glyphicon-list'\" [text]=\"'Asociaciones'\" [smallText]=\"'comprobantes asociados'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'Exportar'\" [icon]=\"'glyphicon glyphicon-export'\" [text]=\"'Exportar'\" [smallText]=\"'exportar la poliza'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'Log'\" [icon]=\"'glyphicon glyphicon-list'\" [text]=\"'Log de exportaci\u00F3n'\" [smallText]=\"'log de exportaci\u00F3n'\"></azteca-menu-item>\n\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"90\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaAfectacion'\" [width]=\"140\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n\n                  <azteca-grid-column [header]=\"'P\u00E9rfil'\" [binding]=\"'perfil'\" [width]=\"160\"> </azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Tipo'\" [binding]=\"'polizaTipo'\" [width]=\"120\"> </azteca-grid-column>\n\n                  <azteca-grid-column [header]=\"'Cargo'\" [binding]=\"'cargos'\" [width]=\"100\" dataType=\"Number\" format=\"n2\"> </azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Abono'\" [binding]=\"'abonos'\" [width]=\"100\" dataType=\"Number\" format=\"n2\"> </azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Concepto'\" [binding]=\"'concepto'\" [width]=\"160\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Sucursal'\" [binding]=\"'sucursal'\" [width]=\"100\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"160\"></azteca-grid-column>\n\n                  <azteca-grid-column [header]=\"'Exportaci\u00F3n'\" [binding]=\"'importacionEstatus'\" [width]=\"160\"></azteca-grid-column>\n\n              </azteca-document-manager>\n              \n          </div>\n      </div>\n\n\n      <accounting-polizas-log-component #polizasLog [id]=\"idPolizaCurrent\">\n\n      </accounting-polizas-log-component>\n\n      <accounting-polizas-asociaciones-component #dlgAsociaciones [idPoliza]=\"idPolizaCurrent\" [idCuenta]=\"0\">\n\n      </accounting-polizas-asociaciones-component>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return PolizasManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: poliza_service_1.PolizaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, poliza_service_1.PolizaService])
    ], PolizasManager);
    return PolizasManager;
}(editors_1.DocumentManager));
exports.PolizasManager = PolizasManager;
