import { FormGroup, FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { Menu } from "wijmo/wijmo.input";
import { ModalDirective } from "ngx-bootstrap";
import { MenuItem, ToolbarButton, AlertsBarComponent } from "framework3/controls";
import { Context, BaseComponent, PolicyInfo } from 'framework3/core';
import { CancelacionService } from "../services/cancelacion.service";
import { FilterGroup, SearchRequest } from "framework3/search";
import { ComprobanteFiscalInfo } from '../models/comprobante-fiscal';
import { ComprobanteFiscalService } from '../services/comprobante-fiscal.service';
export declare class AdmonCancelacion extends BaseComponent {
    private context;
    private router;
    private route;
    private location;
    private formBuilder;
    private cancelacionSvc;
    private comprobanteFiscalService;
    form: FormGroup;
    filterPanelCollapsed: boolean;
    showFilterPanel: boolean;
    menuItems: MenuItem[];
    filterGroups: FilterGroup[];
    selectedGroup: FilterGroup;
    alertsBar: AlertsBarComponent;
    dlgConfirmacion: ModalDirective;
    viewDialog: ModalDirective;
    request: SearchRequest;
    fechaInicial: Date;
    fechaFinal: Date;
    currentItems: Array<any>;
    currentItem: any;
    totalRows: number;
    pageIndex: number;
    respuesta: boolean;
    currentComprobante: ComprobanteFiscalInfo;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, cancelacionSvc: CancelacionService, comprobanteFiscalService: ComprobanteFiscalService);
    ngAfterViewInit(): void;
    createMenu(): void;
    readonly classGridPanel: string;
    toggleCollapse(): void;
    onMenuItemClicked(menu: Menu, args: any): void;
    optionClick(option: MenuItem): void;
    onParamsToolbar(button: ToolbarButton): void;
    applyPolicy(policy: PolicyInfo): void;
    onCurrentItemChanged(item: any): void;
    searchRequested(request: SearchRequest): void;
    handleError(error: any): void;
    onIsDroppedDown(menu: Menu, args: any): void;
    onValidateMenu(item: any): void;
    getMenuItem(name: string): MenuItem;
    onFilterGroupChanged(group: FilterGroup): void;
    downloadPeticionPendiente(): void;
    refreshList(): void;
    onCancelar(): void;
    onAceptar(): void;
}
