"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var ngx_bootstrap_1 = require("ngx-bootstrap");
var moment = require("moment");
var controls_1 = require("framework3/controls");
var core_2 = require("framework3/core");
var cancelacion_service_1 = require("../services/cancelacion.service");
var search_1 = require("framework3/search");
var comprobante_fiscal_1 = require("../models/comprobante-fiscal");
var comprobante_fiscal_service_1 = require("../services/comprobante-fiscal.service");
var AdmonCancelacion = /** @class */ (function (_super) {
    __extends(AdmonCancelacion, _super);
    function AdmonCancelacion(context, router, route, location, formBuilder, cancelacionSvc, comprobanteFiscalService) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.cancelacionSvc = cancelacionSvc;
        _this.comprobanteFiscalService = comprobanteFiscalService;
        _this.filterPanelCollapsed = false;
        _this.showFilterPanel = true;
        _this.menuItems = [];
        _this.filterGroups = [];
        _this.fechaInicial = new Date();
        _this.fechaFinal = new Date();
        _this.currentItems = new Array();
        _this.totalRows = 0;
        _this.pageIndex = 0;
        _this.respuesta = false;
        _this.currentComprobante = new comprobante_fiscal_1.ComprobanteFiscalInfo();
        _this.form = formBuilder.group({
            'fechaInicial': [],
            'fechaFinal': []
        });
        return _this;
    }
    AdmonCancelacion.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) {
            _this.fechaInicial = moment().subtract(30, 'day').toDate();
            _this.fechaFinal = moment().add(1, 'day').toDate();
            _this.refreshList();
        });
        this.createMenu();
    };
    AdmonCancelacion.prototype.createMenu = function () {
        //Agregar opciones estándar del catálogo
        //<azteca-menu-item [name]="'VIEW_COMPROBANTE'" [icon]="'glyphicon glyphicon-folder-open'" [text]="'Abrir'" [smallText]="'abrir en modo de sólo lectura'"></azteca-menu-item>
        var mnuDownload = { icon: "glyphicon glyphicon-circle-arrow-down", text: "Consultar", name: "DOWNLOAD", smallText: "Consultar pendientes aprobar" };
        var mnuOpen = { icon: "glyphicon glyphicon-circle-arrow-down", text: "Abrir", name: "OPEN", smallText: "abrir en modo de sólo lectura" };
        var mnuAceptar = { icon: "glyphicon glyphicon-ok", text: "Aceptar", name: "ACEPTAR", smallText: "Acteptar solicitud" };
        var mnuCancelar = { icon: "glyphicon glyphicon-remove", text: "Rechazar", name: "RECHAZAR", smallText: "Rechazar solicitud" };
        //
        this.menuItems.push(mnuDownload);
        this.menuItems.push(mnuOpen);
        this.menuItems.push(mnuAceptar);
        this.menuItems.push(mnuCancelar);
        //
        this.menuItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    Object.defineProperty(AdmonCancelacion.prototype, "classGridPanel", {
        /*Permite tomar todo el espacio disponible cuando el panel de filtro no está visible y 75% cuando lo está*/
        get: function () {
            return !this.showFilterPanel || this.filterPanelCollapsed ? 'col-12' : 'col-12 col-lg-9';
        },
        enumerable: true,
        configurable: true
    });
    AdmonCancelacion.prototype.toggleCollapse = function () {
        this.filterPanelCollapsed = !this.filterPanelCollapsed;
    };
    AdmonCancelacion.prototype.onMenuItemClicked = function (menu, args) {
        var item = this.menuItems[menu.selectedIndex];
        this.optionClick(item);
    };
    AdmonCancelacion.prototype.optionClick = function (option) {
        var _this = this;
        if (option.name == "DOWNLOAD") {
            this.downloadPeticionPendiente();
        }
        else if (option.name == "ACEPTAR") {
            this.respuesta = true;
            this.dlgConfirmacion.config.backdrop = false;
            this.dlgConfirmacion.show();
        }
        else if (option.name == "RECHAZAR") {
            this.respuesta = false;
            this.dlgConfirmacion.config.backdrop = false;
            this.dlgConfirmacion.show();
        }
        else if (option.name == 'OPEN') {
            this.context.app.showSpinner();
            this.comprobanteFiscalService.getDetail(this.currentItem.data.idComprobante)
                .then(function (comprobante) {
                _this.currentComprobante = comprobante;
                _this.context.app.hideSpinner();
                _this.viewDialog.config.backdrop = false;
                _this.viewDialog.show();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    AdmonCancelacion.prototype.onParamsToolbar = function (button) {
        if (button.name == 'REFRESH') {
            this.refreshList();
        }
    };
    AdmonCancelacion.prototype.applyPolicy = function (policy) {
    };
    AdmonCancelacion.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    AdmonCancelacion.prototype.searchRequested = function (request) {
        this.request = request;
        this.refreshList();
    };
    AdmonCancelacion.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alertsBar.showAlert(message, 'danger');
    };
    AdmonCancelacion.prototype.onIsDroppedDown = function (menu, args) {
        this.onValidateMenu(this.currentItem);
    };
    AdmonCancelacion.prototype.onValidateMenu = function (item) {
        if (item) {
            var mnuAceptar = this.getMenuItem('ACEPTAR');
            var mnuRechazar = this.getMenuItem('RECHAZAR');
            if (item.estatus != "Pendiente") {
                mnuAceptar.enabled = false;
                mnuRechazar.enabled = false;
            }
        }
    };
    AdmonCancelacion.prototype.getMenuItem = function (name) {
        var retItem = null;
        this.menuItems.forEach(function (item) {
            if (item.name == name) {
                retItem = item;
            }
        });
        return retItem;
    };
    AdmonCancelacion.prototype.onFilterGroupChanged = function (group) {
        this.selectedGroup = group;
    };
    ////////////////////////////////////////
    AdmonCancelacion.prototype.downloadPeticionPendiente = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.cancelacionSvc.downloadPeticionPendiente(this.context.app.defaultCompany.identity).then(function (result) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        }).catch(function (error) { return _this.handleError(error); });
    };
    AdmonCancelacion.prototype.refreshList = function () {
        var _this = this;
        this.context.app.showSpinner();
        if (this.request == null) {
            this.request = new search_1.SearchRequest();
            this.request.pageIndex = 0;
            this.request.pageSize = 20;
            this.request.paged = false;
        }
        var exist = false;
        this.request.conditions.forEach(function (r) {
            if (r.field == "fecha" && r.operator == ">=") {
                exist = true;
                r.value = moment(_this.fechaInicial).format("YYYY-MM-DD") + "T00:00:00-00:00";
            }
            else if (r.field == "fecha" && r.operator == "<=") {
                exist = true;
                r.value = moment(_this.fechaFinal).format("YYYY-MM-DD") + "T00:00:00-00:00";
            }
        });
        if (!exist) {
            var conFechaIni = { field: "fecha", operator: ">=", valueType: "datetime", value: moment(this.fechaInicial).format("YYYY-MM-DD") + "T00:00:00-00:00" };
            var conFechaFin = { field: "fecha", operator: "<=", valueType: "datetime", value: moment(this.fechaFinal).format("YYYY-MM-DD") + "T00:00:00-00:00" };
            this.request.conditions.push(conFechaIni);
            this.request.conditions.push(conFechaFin);
        }
        this.cancelacionSvc.search(this.context.app.defaultSite.identity, this.request)
            .then(function (response) {
            response.rows.forEach(function (r) {
                r['fecha'] = moment(r['fecha']).toDate();
            });
            _this.currentItems = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = _this.request.pageIndex;
            //
            var filterGroup = new search_1.FilterGroup();
            filterGroup.tag = "ALL";
            filterGroup.name = "Todos";
            filterGroup.rowCount = _this.totalRows;
            _this.filterGroups.length = 0;
            _this.filterGroups.push(filterGroup);
            //
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AdmonCancelacion.prototype.onCancelar = function () {
        this.dlgConfirmacion.hide();
    };
    AdmonCancelacion.prototype.onAceptar = function () {
        var _this = this;
        this.dlgConfirmacion.hide();
        this.context.app.showSpinner();
        this.cancelacionSvc.aceptarRechazar(this.context.app.defaultSite.idBranch, this.respuesta, this.currentItem.id)
            .then(function (response) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        }).catch(function (error) { return _this.handleError(error); });
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], AdmonCancelacion.prototype, "alertsBar", void 0);
    __decorate([
        core_1.ViewChild('dlgConfirmacion'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], AdmonCancelacion.prototype, "dlgConfirmacion", void 0);
    __decorate([
        core_1.ViewChild('viewDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], AdmonCancelacion.prototype, "viewDialog", void 0);
    AdmonCancelacion = __decorate([
        core_1.Component({
            selector: 'accounting-admon-cancelacion',
            template: "\n      <!--Pool de alertas-->\n      <alerts-bar></alerts-bar>\n\n      <form [formGroup]=\"form\">\n\n          <div class=\"card\">\n              <div class=\"card-header\">Administraci&oacute;n de solicitudes de cancelaci&oacute;n</div>\n              <div class=\"card-body\">\n                  <!--PANEL DE PERIODO Y RESUMEN DE ESTATUS-->\n                  <div class=\"row\">\n                      <div *ngIf=\"showFilterPanel\" class=\"col-12 col-lg-3\">\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <az-panel [header]=\"'Per\u00EDodo'\">\n                                      <azteca-form-field [label]=\"'Fecha inicial:'\">\n                                          <az-input-date formControlName=\"fechaInicial\" [(ngModel)]=\"fechaInicial\"></az-input-date>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Fecha final:'\">\n                                          <az-input-date formControlName=\"fechaFinal\" [(ngModel)]=\"fechaFinal\"></az-input-date>\n                                      </azteca-form-field>\n\n                                      <br />\n\n                                      <az-toolbar (buttonClick)=\"onParamsToolbar($event)\">\n                                          <az-toolbar-button [name]=\"'REFRESH'\" [type]=\"'primary'\" [text]=\"'Actualizar listado'\" [icon]=\"'glyphicon glyphicon-refresh'\" [enabled]=\"form.valid\"></az-toolbar-button>\n                                      </az-toolbar>\n                                  </az-panel>\n                              </div>\n                              <div class=\"col-12 d-none d-lg-block\">\n                                  <az-panel [header]=\"'Resumen de estados'\" [type]=\"'info'\">\n                                      <!--Falta opciones de los paneles -->\n                                      <document-groups [groups]=\"filterGroups\"\n                                                       [selectedGroup]=\"selectedGroup\"\n                                                       (selectedGroupChanged)=\"onFilterGroupChanged($event)\"></document-groups>\n                                  </az-panel>\n                              </div>\n                          </div> <!--ROW PANEL-->\n                      </div> <!--COL PANEL-->\n\n                      <div [class]=\"classGridPanel\">\n\n                          <!--MEN\u00DA PRINCIPAL-->\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n\n                                  <div class=\"btn-group btn-module-primary\">\n\n                                      <button type=\"button\" class=\"btn btn-default\" [title]=\"(filterPanelCollapsed ? 'Mostrar' : 'Ocultar') + ' panel de filtro'\" (click)=\"toggleCollapse()\">\n                                          <span [class]=\"filterPanelCollapsed ? 'glyphicon glyphicon-chevron-right': 'glyphicon glyphicon-chevron-left'\"></span>\n                                      </button>\n\n\n                                      <wj-menu #menu\n                                               (itemClicked)=\"onMenuItemClicked(menu, $event)\"\n                                               [header]=\"'Opciones'\">\n                                          <wj-menu-item *ngFor=\"let item of menuItems\">\n                                              <div *ngIf=\"item.enabled\">\n                                                  <span [class]=\"item.icon\"></span>\n                                                  <b>{{item.text}}</b>\n                                                  <br>\n                                                  <small><i>{{item.smallText}}</i></small>\n                                              </div>\n                                          </wj-menu-item>\n\n                                      </wj-menu>\n\n                                  </div> <!--TOOLBAR-->\n                              </div> <!--COL MENU-->\n                          </div> <!--ROW MENU-->\n                          <!--GRID DE DOCUMENTOS-->\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n\n                                  <!-- Recibos generados dentro del periodo -->\n                                  <azteca-catalog-list [catalogList]=\"currentItems\"\n                                                       [showRowButton]=\"false\"\n                                                       (currentItemChanged)=\"onCurrentItemChanged($event)\"\n                                                       (searchRequested)=\"searchRequested($event)\"\n                                                       (contextMenuClick)=\"optionClick($event)\"\n                                                       [enabled]=\"true\"\n                                                       [pageSize]=\"100\"\n                                                       [serverSide]=\"false\"\n                                                       [totalRows]=\"totalRows\"\n                                                       [pageIndex]=\"pageIndex\">\n\n                                      <!-- Mapear opciones de men\u00FA de componente padre-->\n                                      <azteca-menu-item *ngFor=\"let item of menuItems\" [name]=\"item.name\" [icon]=\"item.icon\" [text]=\"item.text\" [smallText]=\"item.smallText\" [enabled]=\"item.enabled\"></azteca-menu-item>\n                                      <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'uuid'\" [width]=\"280\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fecha'\" [width]=\"80\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"80\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"80\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Comprobante'\" [binding]=\"'idComprobante'\" [width]=\"160\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaComprobante'\" [width]=\"80\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Emisor'\" [binding]=\"'rfcEmisor'\" [width]=\"80\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Emite'\" [binding]=\"'nombreEmisor'\" [width]=\"320\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Receptor'\" [binding]=\"'rfcReceptor'\" [width]=\"80\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Observaciones'\" [binding]=\"'observaciones'\" [width]=\"80\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"80\"></azteca-grid-column>\n\n                                  </azteca-catalog-list>\n\n                              </div> <!--COL GRID-->\n                          </div> <!--ROW GRID-->\n\n                      </div> <!--COL LIST-->\n                  </div> <!--ROW-->\n\n              </div>\n          </div>\n\n          <!--DIALOGO ACEPTACICON -->\n          <div bsModal #dlgConfirmacion=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n              <div class=\"modal-dialog\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-body\">\n                          <div *ngIf=\"respuesta\">\n                              \u00BFDesea aceptar la solicitud de cancelaci&oacute;n?\n                          </div>\n                          <div *ngIf=\"!respuesta\">\n                              \u00BFDesea rechazar la solicitud de cancelaci&oacute;n?\n                          </div>\n                      </div>\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onCancelar()\">Cancelar</button>\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAceptar()\">Aceptar</button>\n                      </div>\n                  </div>\n              </div>\n          </div>\n\n          <div bsModal #viewDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h4 class=\"modal-title\"></h4>\n                          <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"viewDialog.hide()\">\n                              <span aria-hidden=\"true\">&times;</span>\n                          </button>\n                      </div>\n                      <div class=\"modal-body\">\n                          <accounting-comprobante-viewer [comprobante]=\"currentComprobante\"></accounting-comprobante-viewer>\n                      </div> <!--Modal Body-->\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div> <!--Modal directive-->\n\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, common_1.Location,
            forms_1.FormBuilder, cancelacion_service_1.CancelacionService, comprobante_fiscal_service_1.ComprobanteFiscalService])
    ], AdmonCancelacion);
    return AdmonCancelacion;
}(core_2.BaseComponent));
exports.AdmonCancelacion = AdmonCancelacion;
