import { FormGroup, FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, CatalogItem } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogManager } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { FileInfo } from 'framework3/general/models/file';
import { ComprobanteService } from '../services/comprobante.service';
import { MenuItem } from "framework3/controls";
import { ComparativoComprobantesSAT } from '../models/comprobante';
export declare class ComprobanteMaintenance extends CatalogManager {
    protected router: Router;
    protected route: ActivatedRoute;
    protected context: Context;
    private comprobanteService;
    private formBuilder;
    form: FormGroup;
    formFile: FormGroup;
    companias: Array<any>;
    compania: string;
    fechaInicial: Date;
    fechaFinal: Date;
    tienePoliza: boolean;
    noTienePoliza: boolean;
    existeSiSatNoPixcua: boolean;
    existeNoSatSiPixcua: boolean;
    cancSiSatNoPixcua: boolean;
    cancNoSatSiPixcua: boolean;
    docEmitido: boolean;
    docRecibido: boolean;
    comprobantes: Array<any>;
    selectedFile: FileInfo;
    search: SearchRequest;
    cancelado: boolean;
    editable: false;
    comparativo: ComparativoComprobantesSAT;
    timerInterval: any;
    addComprobanteDialog: ModalDirective;
    constructor(router: Router, route: ActivatedRoute, context: Context, comprobanteService: ComprobanteService, formBuilder: FormBuilder);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
    onFilterGroupChanged(group: any): void;
    hideAddComprobanteDialog(): void;
    addComprobante(): void;
    onMenuItemClick(item: MenuItem): void;
    verificarImportExcel(): void;
    createMenu(): void;
}
