import { Router, ActivatedRoute } from '@angular/router';
import { FormGroup, FormBuilder } from '@angular/forms';
import { CollectionView } from 'wijmo/wijmo';
import { Menu } from 'wijmo/wijmo.input';
import { Context, ProcessComponent, PolicyInfo } from 'framework3/core';
import { ToolbarButton, AlertsBarComponent, DownloadPopupComponent } from 'framework3/controls';
import { ImpuestoService } from '../services/impuesto.service';
import { IEPSPreview } from '../models/ieps-preview';
import { AsyncTaskService } from "framework3/queue/services/async-task.service";
export declare class IepsArchivoGenerador extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    private impuestoService;
    private asyncTaskSvc;
    form: FormGroup;
    previewCollection: CollectionView;
    iepsPreviewList: IEPSPreview[];
    fechaInicial: Date;
    fechaFinal: Date;
    cargando: boolean;
    selectedCollection: CollectionView;
    iepsSelectedList: IEPSPreview[];
    iepsSelectorList: IEPSPreview[];
    seleccionadosCount: number;
    totalIepsSelected: number;
    alerts: AlertsBarComponent;
    downloadPopup: DownloadPopupComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, formBuilder: FormBuilder, impuestoService: ImpuestoService, asyncTaskSvc: AsyncTaskService);
    llenandoIepsPreview(): void;
    generandoIepsFile(): void;
    seleccionarRFC(): void;
    calcularSeleccionados(): void;
    handleError(error: any): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    applyPolicy(policy: PolicyInfo): void;
    onMenuSeleccionadosClicked(menu: Menu, args: any): void;
}
