"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//Locales
var impuesto_service_1 = require("../services/impuesto.service");
var ieps_preview_1 = require("../models/ieps-preview");
var async_task_service_1 = require("framework3/queue/services/async-task.service");
var IepsArchivoGenerador = /** @class */ (function (_super) {
    __extends(IepsArchivoGenerador, _super);
    function IepsArchivoGenerador(context, router, route, formBuilder, impuestoService, asyncTaskSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.impuestoService = impuestoService;
        _this.asyncTaskSvc = asyncTaskSvc;
        _this.previewCollection = new wijmo_1.CollectionView();
        _this.iepsPreviewList = [];
        _this.fechaInicial = new Date();
        _this.fechaFinal = new Date();
        _this.cargando = false;
        _this.selectedCollection = new wijmo_1.CollectionView();
        _this.iepsSelectedList = [];
        _this.iepsSelectorList = [];
        _this.seleccionadosCount = 0;
        _this.totalIepsSelected = 0;
        _this.form = formBuilder.group({
            'fechaInicial': [new Date()],
            'fechaFinal': [new Date()]
        });
        return _this;
    }
    // TODO: AsynTask load
    IepsArchivoGenerador.prototype.llenandoIepsPreview = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.impuestoService.asyncPreviewIeps(this.context.app.defaultCompany.identity, this.fechaInicial, this.fechaFinal)
            .then(function (recs) {
            _this.asyncTaskSvc.subscribeTask(recs.idAsyncTask).subscribe(function (info) {
                //this.graph.asyncTask = info;
                //this.graph.asyncTask.resultJson = JSON.parse(this.graph.asyncTask.result);
                _this.context.app.hideSpinner();
                console.log(info);
                _this.iepsPreviewList = JSON.parse(info.result);
                //this.previewCollection.sourceCollection = JSON.parse(info.result);
                /**************Selector**********************/
                //Ordenandolo
                var iepsPreviewListSorted;
                iepsPreviewListSorted = _this.iepsPreviewList.slice(0);
                iepsPreviewListSorted.sort(function (leftSide, rightSide) {
                    if (leftSide.RFC < rightSide.RFC)
                        return -1;
                    if (leftSide.RFC > rightSide.RFC)
                        return 1;
                    return 0;
                });
                //Sumarizando para grid superior
                var rfcActual = '';
                iepsPreviewListSorted.forEach(function (y) {
                    if (rfcActual != y.RFC) {
                        rfcActual = y.RFC;
                        var grupoRFC = iepsPreviewListSorted.filter(function (subList) { return subList.RFC == rfcActual; });
                        var item = new ieps_preview_1.IEPSPreview;
                        item = grupoRFC[0];
                        var iRfc = new ieps_preview_1.IEPSPreview;
                        iRfc.RFC = item.RFC;
                        iRfc.RazonSocial = item.RazonSocial;
                        iRfc.CondicionesPago = item.CondicionesPago;
                        iRfc.Estado = '';
                        iRfc.CodigoEstado = '';
                        //sumarizando
                        grupoRFC.forEach(function (x) {
                            iRfc.IEPS = iRfc.IEPS + x.IEPS;
                            iRfc.IVA = iRfc.IVA + x.IVA;
                            iRfc.IVA_IEPS = iRfc.IVA_IEPS + x.IVA_IEPS;
                            iRfc.Litros = iRfc.Litros + x.Litros;
                            iRfc.SubTotal = iRfc.SubTotal + x.SubTotal;
                        });
                        var newRfc = _this.iepsSelectorList.slice();
                        newRfc.push(iRfc);
                        _this.iepsSelectorList = newRfc;
                    }
                    _this.previewCollection.sourceCollection = _this.iepsSelectorList;
                });
                /********************************************/
            });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    IepsArchivoGenerador.prototype.generandoIepsFile = function () {
        var _this = this;
        var file;
        this.impuestoService.archivoIeps('', this.fechaInicial, this.fechaFinal, this.iepsSelectedList)
            .then(function (ret) {
            var links = [];
            links.push(ret);
            _this.downloadPopup.show(links);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    IepsArchivoGenerador.prototype.seleccionarRFC = function () {
        var _this = this;
        var item = new ieps_preview_1.IEPSPreview;
        item = this.previewCollection.currentItem;
        var grupoRFC = this.iepsPreviewList.filter(function (subList) { return subList.RFC == item.RFC; });
        grupoRFC.forEach(function (x) {
            var iRfc = new ieps_preview_1.IEPSPreview;
            iRfc.RFC = x.RFC;
            iRfc.RazonSocial = x.RazonSocial;
            iRfc.CondicionesPago = x.CondicionesPago;
            iRfc.Estado = x.Estado;
            iRfc.CodigoEstado = x.CodigoEstado;
            iRfc.IEPS = x.IEPS;
            iRfc.IVA = x.IVA;
            iRfc.IVA_IEPS = x.IVA_IEPS;
            iRfc.Litros = x.Litros;
            iRfc.SubTotal = x.SubTotal;
            var newRfc = _this.iepsSelectedList.slice();
            newRfc.push(iRfc);
            _this.iepsSelectedList = newRfc;
            _this.selectedCollection.sourceCollection = newRfc;
            _this.selectedCollection.refresh;
            _this.calcularSeleccionados();
        });
    };
    ;
    /* antes de la modificacion
    seleccionarRFC() {
        var item: IEPSPreview = new IEPSPreview;
        item = this.previewCollection.currentItem

        var iRfc: IEPSPreview = new IEPSPreview
        iRfc.RFC = item.RFC;
        iRfc.RazonSocial = item.RazonSocial;
        iRfc.CondicionesPago = item.CondicionesPago;
        iRfc.Estado = item.Estado;
        iRfc.CodigoEstado = item.CodigoEstado;
        //sumarizando
        this.iepsPreviewList.forEach(x => {
            if (x.RFC == item.RFC && x.Estado == item.Estado) {
                iRfc.IEPS = iRfc.IEPS + x.IEPS;
                iRfc.IVA = iRfc.IVA + x.IVA;
                iRfc.IVA_IEPS = iRfc.IVA_IEPS + x.IVA_IEPS;
                iRfc.Litros = iRfc.Litros + x.Litros;
                iRfc.SubTotal = iRfc.SubTotal + x.SubTotal;
            }
        });


        var newRfc = this.iepsSelectedList.slice();
        newRfc.push(iRfc);

        this.iepsSelectedList = newRfc;

        this.selectedCollection.sourceCollection = newRfc;
        this.selectedCollection.refresh;

        this.calcularSeleccionados();

    }
    */
    IepsArchivoGenerador.prototype.calcularSeleccionados = function () {
        var _this = this;
        //calculando el total de rfcs distintos seleccionados
        var selectedRfcs = [];
        this.totalIepsSelected = 0;
        this.iepsSelectedList.forEach(function (y) {
            var result = selectedRfcs.filter(function (value) {
                return (value == y.RFC);
            });
            if (result.length == 0) {
                selectedRfcs.push(y.RFC);
            }
            _this.totalIepsSelected = _this.totalIepsSelected + y.IEPS;
        });
        this.seleccionadosCount = selectedRfcs.length;
    };
    IepsArchivoGenerador.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.cargando = false;
        this.alerts.showAlert(message, 'danger');
    };
    IepsArchivoGenerador.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'CONSULTAR') {
            this.llenandoIepsPreview();
        }
        if (button.name == 'GENERAR') {
            this.generandoIepsFile();
        }
        if (button.name == 'SELECCIONAR') {
            this.seleccionarRFC();
        }
    };
    //Implementacion de politicas
    IepsArchivoGenerador.prototype.applyPolicy = function (policy) {
    };
    IepsArchivoGenerador.prototype.onMenuSeleccionadosClicked = function (menu, args) {
        if (menu.selectedIndex == 0) {
            //Eliminar
            //this.iepsSelectedList = this.selectedCollection.currentItem;
            this.selectedCollection.remove(this.selectedCollection.currentItem);
        }
        this.calcularSeleccionados();
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], IepsArchivoGenerador.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild(controls_1.DownloadPopupComponent),
        __metadata("design:type", controls_1.DownloadPopupComponent)
    ], IepsArchivoGenerador.prototype, "downloadPopup", void 0);
    IepsArchivoGenerador = __decorate([
        core_1.Component({
            selector: 'accounting-ieps-archivo-generador',
            template: "\n      <form [formGroup]=\"form\">\n\n          <div class=\"form-inline\">\n              <div class=\"form-group\">\n                  <label for=\"fechaInicial\">Fecha Ini</label>\n                  <az-input-date id=\"fechaInicial\" style=\"padding: .5rem .75rem;\" formControlName=\"fechaInicial\" [(ngModel)]=\"fechaInicial\"></az-input-date>\n              </div>\n              <div class=\"form-group\">\n                  <label for=\"fechaFinal\">Fecha Fin</label>\n                  <az-input-date id=\"fechaFinal\" style=\"padding: .5rem .75rem;\" formControlName=\"fechaFinal\" [(ngModel)]=\"fechaFinal\"></az-input-date>\n              </div>\n\n              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                  <az-toolbar-button [name]=\"'CONSULTAR'\" [type]=\"'primary'\" [text]=\"'Consultar'\" [toolTip]=\"'Consultar'\" [icon]=\"'glyphicon glyphicon-search'\" [enabled]=\"true\"></az-toolbar-button>\n              </az-toolbar>\n\n              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                  <az-toolbar-button [name]=\"'GENERAR'\" [type]=\"'primary'\" [text]=\"'Generar archivo'\" [toolTip]=\"'Generar archivo'\" [icon]=\"'glyphicon glyphicon-save-file'\" [enabled]=\"true\"></az-toolbar-button>\n              </az-toolbar>\n\n\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <wj-flex-grid #grid style=\"height:550px\"\n                                [itemsSource]=\"previewCollection\"\n                                [wjContextMenu]=\"ctxMenuArticulos\"\n                                [isReadOnly]=\"true\">\n                      <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                      <wj-flex-grid-column [header]=\"'RFC'\" [binding]=\"'RFC'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Raz\u00F3n Social'\" [binding]=\"'RazonSocial'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Sub Total'\" [binding]=\"'SubTotal'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'IVA'\" [binding]=\"'IVA'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'IEPS'\" [binding]=\"'IEPS'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'IVA-IEPS'\" [binding]=\"'IVA_IEPS'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Litros'\" [binding]=\"'Litros'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                  </wj-flex-grid>\n              </div>\n          </div>\n\n          <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n              <az-toolbar-button [name]=\"'SELECCIONAR'\" [type]=\"'primary'\" [text]=\"'Agregar RFC'\" [toolTip]=\"'Seleccionar RFC'\" [icon]=\"'glyphicon glyphicon-arrow-down'\" [enabled]=\"true\"></az-toolbar-button>\n          </az-toolbar>\n\n          <label>Contribuyentes seleccionados:</label>\n          <label>{{seleccionadosCount}}</label>\n\n\n          <label>.   Suma de IEPS:</label>\n          <label>{{totalIepsSelected.toLocaleString('es-MX')}}</label>\n\n    \n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <wj-flex-grid #grid style=\"height:200px\"\n                                [itemsSource]=\"selectedCollection\"\n                                [wjContextMenu]=\"ctxMenuSeleccionados\"\n                                [isReadOnly]=\"true\">\n                      <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                      <wj-flex-grid-column [header]=\"'RFC'\" [binding]=\"'RFC'\" [width]=\"'10*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Raz\u00F3n Social'\" [binding]=\"'RazonSocial'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Estado'\" [binding]=\"'Estado'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Sub Total'\" [binding]=\"'SubTotal'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'IVA'\" [binding]=\"'IVA'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'IEPS'\" [binding]=\"'IEPS'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'IVA-IEPS'\" [binding]=\"'IVA_IEPS'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Litros'\" [binding]=\"'Litros'\" [width]=\"'20*'\"></wj-flex-grid-column>\n\n                  </wj-flex-grid>\n              </div>\n          </div>\n\n\n          <download-popup></download-popup>\n\n          <wj-menu #ctxMenuSeleccionados (itemClicked)=\"onMenuSeleccionadosClicked(ctxMenuSeleccionados, $event)\" style=\"display:none\">\n              <wj-menu-item>\n                  <span class=\"glyphicon glyphicon-trash\"></span><b> Eliminar</b>\n                  <br />\n                  <small><i>eliminar registro</i></small>\n              </wj-menu-item>\n          </wj-menu>\n\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder,
            impuesto_service_1.ImpuestoService,
            async_task_service_1.AsyncTaskService])
    ], IepsArchivoGenerador);
    return IepsArchivoGenerador;
}(core_2.ProcessComponent));
exports.IepsArchivoGenerador = IepsArchivoGenerador;
