import { CatalogInfo, CatalogItem } from 'framework3/core';
import { EmpresaInfo as EmpresaSecurity } from 'framework3/core';
import { ContribuyenteInfo } from './contribuyente';
import { IParametrizable } from 'framework3/general/models/parametrizable';
import { ParametroValor } from 'framework3/general/models/parametro-valor';
export declare class EmpresaInfo extends CatalogInfo implements IParametrizable {
    formatoContable: string;
    niveles: number;
    idRegimenFiscal: string;
    idPac: number;
    ejercicioActual: string;
    periodoActual: string;
    idDivisa: number;
    idCuenta: number;
    idContribuyente: number;
    idFormatoIngreso: number;
    idFormatoEgreso: number;
    idFormatoPago: number;
    idFormatoReciboNomina: number;
    idRemitenteComprobantes: number;
    tipoCambio: string;
    empresaBase: EmpresaSecurity;
    contribuyente: ContribuyenteInfo;
    parametros: ParametroValor[];
    constructor();
}
export declare class EmpresaItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
    selected?: boolean;
}
export declare class RegimenFiscalItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    valido: string;
    estatus?: string;
    selected?: boolean;
}
