import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
import { Context, DocumentService, FileLink } from 'framework3/core';
import { LoteImpresionInfo } from 'framework3/printing';
import { ComprobanteFiscalInfo, ComprobanteFiscalItem } from '../models/comprobante-fiscal';
import { ComprobanteFiscalDetail } from '../models/comprobante-fiscal-detail';
import { AddendaItem } from '../models/addenda';
import { EnvioComprobantesItem, ResetComprobantesItem } from '../../credit/components/envio-comprobantes-fiscales.component';
export declare class ComprobanteFiscalService extends DocumentService<ComprobanteFiscalDetail, ComprobanteFiscalInfo> {
    protected http: HttpClient;
    protected context: Context;
    constructor(http: HttpClient, context: Context);
    create(): Promise<ComprobanteFiscalInfo>;
    loadListAddendas(idEmpresa: number): Promise<AddendaItem[]>;
    searchKeyword(idBranch: number, keyword: string, idContribuyente: number): Observable<ComprobanteFiscalItem[]>;
    generarPdfTemporal(idComprobante: string): Promise<FileLink>;
    regenerarPdfTemporal(idComprobante: string): Promise<FileLink>;
    generarPdfTemporalMultiple(comprobantes: Array<string>): Promise<string[]>;
    generarPdfTemporalArr(idComprobante: string[]): Promise<FileLink>;
    getLoteDescarga(idComprobantes: string[]): Promise<LoteImpresionInfo>;
    getLoteExportacion(idComprobantes: string[]): Promise<any>;
    getLoteExportacionStatus(idLote: number): Promise<any>;
    getXml(idComprobanteFiscal: string): Promise<string>;
    getXmlFileArr(idComprobanteFiscal: string[]): Promise<FileLink>;
    getXmlFile(idComprobanteFiscal: string): Promise<FileLink>;
    cancelar(idComprobanteFiscal: string): Promise<string>;
    timbrar(idComprobanteFiscal: string): Promise<any>;
    enviar(idComprobanteFiscal: string, correo: string, mensaje: string): Promise<any>;
    getEnvioFacturas(idEmpresa: number, fechaIni: Date, fechaFin: Date): Promise<EnvioComprobantesItem[]>;
    ComprobantesDestinosList(): Promise<any[]>;
    resetEnvioFacturas(idJob: ResetComprobantesItem[]): Promise<any>;
    validarComprobanteSAT(idComprobante: string): Promise<boolean>;
    getComprobanteBySerieFolio(serie: string, folio: string, idEmpresa: number): Promise<ComprobanteFiscalInfo>;
    protected mapSearchResult(row: any): void;
    protected mapDocument(document: ComprobanteFiscalInfo): void;
    portalClientes(idCliente: number, fechaIni: Date, fechaFin: Date): Promise<any[]>;
    getAddenda(idComprobanteFiscal: string): Promise<string>;
    reemplazaAddenda(idComprobanteFiscal: string, addenda: string[]): Promise<any>;
}
