"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
var moment = require("moment");
//Azteca Framework
var core_2 = require("framework3/core");
//Locales
var comprobante_fiscal_1 = require("../models/comprobante-fiscal");
var ComprobanteFiscalService = /** @class */ (function (_super) {
    __extends(ComprobanteFiscalService, _super);
    function ComprobanteFiscalService(http, context) {
        var _this = _super.call(this, http, context, 'api/contabilidad/comprobantes') || this;
        _this.http = http;
        _this.context = context;
        return _this;
    }
    ComprobanteFiscalService.prototype.create = function () {
        var newDoc = new comprobante_fiscal_1.ComprobanteFiscalInfo();
        return Promise.resolve(newDoc);
    };
    ComprobanteFiscalService.prototype.loadListAddendas = function (idEmpresa) {
        var params = new http_1.HttpParams()
            .set("idEmpresa", idEmpresa.toString());
        return this.apiService.get("load-list-addendas", params)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.searchKeyword = function (idBranch, keyword, idContribuyente) {
        var params = new http_1.HttpParams()
            .set("idBranch", idBranch.toString())
            .set("keyword", keyword)
            .set("idContribuyente", idContribuyente.toString());
        return this.apiService.get("search-comprobantes", params);
    };
    ComprobanteFiscalService.prototype.generarPdfTemporal = function (idComprobante) {
        var params = new http_1.HttpParams()
            .set("idComprobanteFiscal", idComprobante);
        return this.apiService.get("pdf-temporal", params)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.regenerarPdfTemporal = function (idComprobante) {
        var params = new http_1.HttpParams()
            .set("idComprobanteFiscal", idComprobante);
        return this.apiService.get("regenerar-pdf-temporal", params)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.generarPdfTemporalMultiple = function (comprobantes) {
        var params = new http_1.HttpParams();
        return this.apiService.post("pdf-temporal-multiple", params, comprobantes)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.generarPdfTemporalArr = function (idComprobante) {
        var params = new http_1.HttpParams();
        return this.apiService.post("pdf-temporal-arr", params, idComprobante)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.getLoteDescarga = function (idComprobantes) {
        var params = new http_1.HttpParams();
        return this.apiService.post("descargar-lote", params, idComprobantes)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.getLoteExportacion = function (idComprobantes) {
        var params = new http_1.HttpParams();
        return this.apiService.post("exportar-lote", params, idComprobantes)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.getLoteExportacionStatus = function (idLote) {
        var params = new http_1.HttpParams()
            .set("IdLote", idLote.toString());
        return this.apiService.post("exportar-lote-status", params)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.getXml = function (idComprobanteFiscal) {
        var params = new http_1.HttpParams()
            .set("idComprobanteFiscal", idComprobanteFiscal);
        return this.apiService.getText("xml", params)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.getXmlFileArr = function (idComprobanteFiscal) {
        var params = new http_1.HttpParams();
        return this.apiService.post("xml-file-arr", params, idComprobanteFiscal)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.getXmlFile = function (idComprobanteFiscal) {
        var params = new http_1.HttpParams()
            .set("idComprobanteFiscal", idComprobanteFiscal);
        return this.apiService.get("xml-file", params)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.cancelar = function (idComprobanteFiscal) {
        var params = new http_1.HttpParams()
            .set("idComprobanteFiscal", idComprobanteFiscal);
        return this.apiService.getText("cancelar", params)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.timbrar = function (idComprobanteFiscal) {
        var params = new http_1.HttpParams()
            .set("idComprobanteFiscal", idComprobanteFiscal);
        return this.apiService.get("timbrar", params)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.enviar = function (idComprobanteFiscal, correo, mensaje) {
        var params = new http_1.HttpParams()
            .set("idComprobanteFiscal", idComprobanteFiscal)
            .set("correo", correo)
            .set("mensaje", mensaje);
        return this.apiService.get("send", params)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.getEnvioFacturas = function (idEmpresa, fechaIni, fechaFin) {
        var params = new http_1.HttpParams()
            .set("idEmpresa", idEmpresa.toString())
            .set('fechaIni', moment(fechaIni).format())
            .set('fechaFin', moment(fechaFin).format());
        return this.apiService.get("envio-facturas-list", params)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.ComprobantesDestinosList = function () {
        var params = new http_1.HttpParams();
        return this.apiService.get("comprobantes-destino-list", params)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.resetEnvioFacturas = function (idJob) {
        var params = new http_1.HttpParams();
        return this.apiService.post('reset-envio-facturas', params, idJob)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.validarComprobanteSAT = function (idComprobante) {
        var params = new http_1.HttpParams()
            .set("idComprobanteFiscal", idComprobante);
        return this.apiService.get('validar-comprobante-sat', params)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.getComprobanteBySerieFolio = function (serie, folio, idEmpresa) {
        var params = new http_1.HttpParams()
            .set("serie", serie)
            .set("folio", folio)
            .set("idEmpresa", idEmpresa.toString());
        return this.apiService.get("get-comprobante-serie-folio", params)
            .toPromise();
    };
    //Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) en los resultados de búsquedas. Eliminar si no es necesario
    ComprobanteFiscalService.prototype.mapSearchResult = function (row) {
        row.fechaTimbrado = moment(row.fechaTimbrado).toDate();
    };
    //Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) al cargar un documento. Eliminar si no es necesario
    ComprobanteFiscalService.prototype.mapDocument = function (document) {
        document.fecha = moment(document.fecha).toDate();
        document.fechaAfectacion = moment(document.fechaAfectacion).toDate();
        document.timbreFiscal.fecha = moment(document.timbreFiscal.fecha).toDate();
    };
    //Portal de clientes
    ComprobanteFiscalService.prototype.portalClientes = function (idCliente, fechaIni, fechaFin) {
        var params = new http_1.HttpParams()
            .set("idCliente", idCliente.toString())
            .set('fechaIni', moment(fechaIni).format())
            .set('fechaFin', moment(fechaFin).format());
        return this.apiService.get("portal-clientes", params)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.getAddenda = function (idComprobanteFiscal) {
        var params = new http_1.HttpParams()
            .set("idComprobanteFiscal", idComprobanteFiscal);
        return this.apiService.getText("get-addenda", params)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.reemplazaAddenda = function (idComprobanteFiscal, addenda) {
        var params = new http_1.HttpParams()
            .set("idComprobanteFiscal", idComprobanteFiscal);
        return this.apiService.post("reemplazar-addenda", params, addenda)
            .toPromise();
    };
    ComprobanteFiscalService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], ComprobanteFiscalService);
    return ComprobanteFiscalService;
}(core_2.DocumentService));
exports.ComprobanteFiscalService = ComprobanteFiscalService;
