import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { SearchResult, SearchRequest } from 'framework3/search';
import { Context, BaseService } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { FileInfo } from 'framework3/general/models/file';
import { ComparativoComprobantesSAT } from '../models/comprobante';
export declare class ComprobanteService extends BaseService {
    constructor(http: HttpClient, context: Context);
    getOptions(): Promise<CatalogOptions>;
    uploadComprobante(cancelado: boolean, file: FileInfo): Promise<any>;
    search(compania: string, fechaIni: string, fechaFin: string, tienePoliza: boolean, noTienePoliza: boolean, existeSiSatNoPixcua: boolean, existeNoSatSiPixcua: boolean, cancSiSatNoPixcua: boolean, cancNoSatSiPixcua: boolean, docEmitido: boolean, docRecibido: boolean, idBranch: number, request: SearchRequest): Promise<SearchResult>;
    getComprobanteFiscalV32(serie: string, folio: number, fecha: string, uuid: string): Promise<string>;
    getComprativoComprobante(compania: string, fechaIni: string, fechaFin: string, tienePoliza: boolean, noTienePoliza: boolean, existeSiSatNoPixcua: boolean, existeNoSatSiPixcua: boolean, cancSiSatNoPixcua: boolean, cancNoSatSiPixcua: boolean, docEmitido: boolean, docRecibido: boolean, idBranch: number, request: SearchRequest): Promise<ComparativoComprobantesSAT>;
    getProgramacionComparativo(idProgramacion: number): Promise<ComparativoComprobantesSAT>;
}
