import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService, FileLink } from 'framework3/core';
import { ImpuestoInfo, ImpuestoTipoItem, ImpuestoItem } from '../models/impuesto';
import { IEPSPreview } from '../models/ieps-preview';
import { AsyncTaskInfo } from 'framework3/queue/models/async-task';
export declare class ImpuestoService extends CatalogService<ImpuestoInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<ImpuestoInfo>;
    loadTipos(idEmpresa: string): Promise<ImpuestoTipoItem[]>;
    searchKeywordImpuestos(idBranch: number, keyword: string): Observable<ImpuestoItem[]>;
    previewIeps(idEmpresa: number, fechaIni: Date, fechaFin: Date): Promise<IEPSPreview[]>;
    archivoIeps(nombreArchivo: string, fechaIni: Date, fechaFin: Date, rfcs: IEPSPreview[]): Promise<FileLink>;
    asyncPreviewIeps(idEmpresa: number, fechaIni: Date, fechaFin: Date): Promise<AsyncTaskInfo>;
}
