"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
var moment = require("moment");
//Azteca Kernel
var core_2 = require("framework3/core");
//Locales
var impuesto_1 = require("../models/impuesto");
var ImpuestoService = /** @class */ (function (_super) {
    __extends(ImpuestoService, _super);
    function ImpuestoService(http, context) {
        return _super.call(this, http, context, "api/contabilidad/impuestos") || this;
    }
    ImpuestoService.prototype.create = function () {
        return Promise.resolve(new impuesto_1.ImpuestoInfo());
    };
    ImpuestoService.prototype.loadTipos = function (idEmpresa) {
        var params = new http_1.HttpParams()
            .set("idEmpresa", idEmpresa);
        return this.apiService.get("load-tipos", params)
            .toPromise();
    };
    ImpuestoService.prototype.searchKeywordImpuestos = function (idBranch, keyword) {
        var params = new http_1.HttpParams()
            .set('idBranch', idBranch.toString())
            .set('keyword', keyword);
        return this.apiService.get('search-keyword', params);
    };
    ImpuestoService.prototype.previewIeps = function (idEmpresa, fechaIni, fechaFin) {
        var params = new http_1.HttpParams()
            .set("idEmpresa", idEmpresa.toString())
            .set("fechaIni", moment(fechaIni).format())
            .set("fechaFin", moment(fechaFin).format());
        return this.apiService.get('ieps-preview', params)
            .toPromise();
    };
    ImpuestoService.prototype.archivoIeps = function (nombreArchivo, fechaIni, fechaFin, rfcs) {
        var params = new http_1.HttpParams()
            .set("nombreArchivo", nombreArchivo)
            .set("fechaIni", moment(fechaIni).format())
            .set("fechaFin", moment(fechaFin).format());
        return this.apiService.post("file-ieps", params, rfcs)
            .toPromise();
    };
    ImpuestoService.prototype.asyncPreviewIeps = function (idEmpresa, fechaIni, fechaFin) {
        var params = new http_1.HttpParams()
            .set("idEmpresa", idEmpresa.toString())
            .set("fechaIni", moment(fechaIni).format())
            .set("fechaFin", moment(fechaFin).format());
        return this.apiService.get('get-async-ieps-preview', params)
            .toPromise();
    };
    ImpuestoService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], ImpuestoService);
    return ImpuestoService;
}(core_2.CatalogService));
exports.ImpuestoService = ImpuestoService;
