import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, DocumentService } from 'framework3/core';
import { PolizaInfo } from '../models/poliza';
import { PolizaPerfilItem } from '../models/poliza-perfil';
import { PolizaDetail } from '../models/poliza-detail';
import { PolizaLogEntry } from '../models/poliza-log-entry';
import { AsociacionItem } from '../models/asociacion';
import { PolizaTipo } from '../models/poliza-tipo';
export declare class PolizaService extends DocumentService<PolizaDetail, PolizaInfo> {
    protected http: HttpClient;
    protected context: Context;
    constructor(http: HttpClient, context: Context);
    create(): Promise<PolizaInfo>;
    marcarExportacion(idPolizaTit: string, status: number, mensaje: string): Promise<any>;
    loadLog(idPolizaTit: string): Promise<PolizaLogEntry[]>;
    loadAsociaciones(idPolizaTit: string): Promise<AsociacionItem[]>;
    loadPerfilesByLote(idSucursal: number, idUsuario: number): Promise<PolizaPerfilItem[]>;
    loadPerfiles(idSucursal: number, idUsuario: number): Promise<PolizaPerfilItem[]>;
    contabilizarByLote(idSucursal: number, idPerfil: number, fechaIni: Date, fechaFin: Date): Promise<PolizaInfo>;
    getPolizaByPerfil(idSucursal: number, idPerfil: number, fecha: Date): Promise<PolizaInfo>;
    loadContabilizacionByMapa(idSucursal: number, idPerfil: number, fecha: Date): Promise<PolizaInfo>;
    loadPolizaByDocumento(idDocumento: string, idPolizaPerfil: number, idBranch: number): Promise<PolizaInfo>;
    loadPolizaTipo(): Promise<PolizaTipo[]>;
    addAsociacion(idPoliza: string, fechaSys: Date, idCuenta: number, consecutivo: number, uuid: string, idCFDSerie: number, folio: number): Promise<any>;
    removeAsociacion(idPoliza: string, fechaSys: Date, idCuenta: number, consecutivo: number, uuid: string): Promise<any>;
}
