"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var cajero_service_1 = require("../services/cajero.service");
var cajero_1 = require("../models/cajero");
var CajerosEditor = /** @class */ (function (_super) {
    __extends(CajerosEditor, _super);
    //
    function CajerosEditor(router, route, formBuilder, changeDetector, context, location, cajeroService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.cajeroService = cajeroService;
        _this.cajero = new cajero_1.CajeroInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'usuario': ['', forms_1.Validators.required],
            'empleado': ['', forms_1.Validators.required]
        });
        return _this;
    }
    CajerosEditor_1 = CajerosEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    CajerosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    CajerosEditor.prototype.onCreatingItem = function () {
    };
    CajerosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.cajeroService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cajero = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CajerosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.cajeroService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cajero = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CajerosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.cajeroService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cajero = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CajerosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.cajeroService.update(this.cajero)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cajero = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var CajerosEditor_1;
    CajerosEditor = CajerosEditor_1 = __decorate([
        core_1.Component({
            selector: 'credito-cajeros-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Cajero'\"\n                                 [info]=\"cajero\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"cajero.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>                \n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Asignaci\u00F3n\">\n                        \t\t\t\t\t\t\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">                               \n                                      <azteca-form-field [label]=\"'Usuario:'\">\n                                          <usuario-selector formControlName=\"usuario\" [(ngModel)]=\"cajero.idUsuario\"></usuario-selector>\n                                      </azteca-form-field>                               \n                                      <azteca-form-field [label]=\"'Empleado:'\">\n                                          <rh-empleado-selector formControlName=\"empleado\" [(ngModel)]=\"cajero.idEmpleado\"></rh-empleado-selector>\n                                      </azteca-form-field>\n                                 </div>\n                              </div>\n\t\t\t\t\t\t\n\n                          </tab>\n                   \n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CajerosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: cajero_service_1.CajeroService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, cajero_service_1.CajeroService])
    ], CajerosEditor);
    return CajerosEditor;
}(editors_1.CatalogEditor));
exports.CajerosEditor = CajerosEditor;
