import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { ToolbarButton } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs, TrackableCollection } from 'framework3/editors';
import { DeudorService } from '../services/deudor.service';
import { DeudorInfo } from '../models/deudor';
import { GrupoDeudorInfo } from '../models/grupo-deudor';
import { FormaPagoService } from '../services/forma-pago.service';
import { FormaPagoItem } from '../models/forma-pago';
import { GrupoDeudorSelectorComponent } from '../components/grupo-deudores-selector.component';
import { AddendaService } from '../../accounting/services/addenda.service';
import { ComprobanteFiscalService } from '../../accounting/services/comprobante-fiscal.service';
import { ComprobanteCorreo } from '../../accounting/models/comprobante-correo';
import { ComprobantesCorreoEditor } from '../../accounting/components/comprobante-correo.editor';
import { PerfilAutoCobroTipoItem } from '../models/perfil-auto-cobro-tipo';
import { PerfilAutoCobroTipoService } from '../services/perfil-auto-cobro-tipo.service';
import { NotaTipoItem } from '../models/nota-tipo';
import { NotaTipoService } from '../services/nota-tipo.service';
export declare class DeudoresEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private deudorService;
    private formaPagoService;
    private addendaService;
    private comprobanteFiscalService;
    private perfilAutoCobroTipoService;
    private notaTipoSvc;
    deudor: DeudorInfo;
    condicionesPago: {
        id: string;
        nombre: string;
    }[];
    formasPago: FormaPagoItem[];
    adendacbo: {
        id: number;
        nombre: string;
    }[];
    comprobantecbo: {
        id: number;
        nombre: string;
    }[];
    listdomiciliosComprobantes: {
        value: string;
        text: string;
    }[];
    listRazonSocial: {
        value: string;
        text: string;
    }[];
    metodosPago: {
        metodo: string;
    }[];
    comprobantesCorreosCollection: TrackableCollection;
    perfilesAutocobranzaCollection: TrackableCollection;
    idPerfil: number;
    tiposPerfiles: PerfilAutoCobroTipoItem[];
    notaTipos: NotaTipoItem[];
    selInsumo: GrupoDeudorSelectorComponent;
    comprobanteCorreoDialog: ComprobantesCorreoEditor;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, deudorService: DeudorService, formaPagoService: FormaPagoService, addendaService: AddendaService, comprobanteFiscalService: ComprobanteFiscalService, perfilAutoCobroTipoService: PerfilAutoCobroTipoService, notaTipoSvc: NotaTipoService);
    onConfigureCatalog(options: CatalogOptions): void;
    ngOnInit(): void;
    ngAfterViewChecked(): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadFormasPago(): void;
    onGrupoDeudorSelected(grupo: GrupoDeudorInfo): void;
    onSelectTab(args: any): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onAgregarComprobanteCorreo(args: ComprobanteCorreo): void;
    onRemoveItem(item: any): void;
    onRemovePerfil(item: any): void;
    onAgregarPerfil(): void;
    loadNotaTipos(): void;
    onTipoPerfilChanged(args: EditorEventArgs): void;
}
