"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var deudor_service_1 = require("../services/deudor.service");
var deudor_1 = require("../models/deudor");
var forma_pago_service_1 = require("../services/forma-pago.service");
var grupo_deudores_selector_component_1 = require("../components/grupo-deudores-selector.component");
var addenda_service_1 = require("../../accounting/services/addenda.service");
var comprobante_fiscal_service_1 = require("../../accounting/services/comprobante-fiscal.service");
var comprobante_correo_editor_1 = require("../../accounting/components/comprobante-correo.editor");
var deudor_perfil_auto_cobro_1 = require("../models/deudor-perfil-auto-cobro");
var perfil_auto_cobro_tipo_service_1 = require("../services/perfil-auto-cobro-tipo.service");
var nota_tipo_service_1 = require("../services/nota-tipo.service");
var DeudoresEditor = /** @class */ (function (_super) {
    __extends(DeudoresEditor, _super);
    //
    function DeudoresEditor(router, route, formBuilder, changeDetector, context, location, deudorService, formaPagoService, addendaService, comprobanteFiscalService, perfilAutoCobroTipoService, notaTipoSvc) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.deudorService = deudorService;
        _this.formaPagoService = formaPagoService;
        _this.addendaService = addendaService;
        _this.comprobanteFiscalService = comprobanteFiscalService;
        _this.perfilAutoCobroTipoService = perfilAutoCobroTipoService;
        _this.notaTipoSvc = notaTipoSvc;
        _this.deudor = new deudor_1.DeudorInfo();
        _this.condicionesPago = [];
        _this.formasPago = [];
        _this.adendacbo = [];
        _this.comprobantecbo = [];
        _this.listdomiciliosComprobantes = [];
        _this.listRazonSocial = [];
        _this.metodosPago = [];
        _this.comprobantesCorreosCollection = new editors_1.TrackableCollection();
        _this.perfilesAutocobranzaCollection = new editors_1.TrackableCollection();
        _this.tiposPerfiles = [];
        _this.notaTipos = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'condiciones': ['', forms_1.Validators.required],
            'domicilio': [''],
            'limiteCredito': [''],
            'diasCredito': [''],
            'idFormaPago': [''],
            'cuentaPago': [''],
            'cuenta': [''],
            'idGrupoDeudor': [0],
            'facturable': [''],
            'rfc': [''],
            'razonSocial': [''],
            'desgloseIEPS': [''],
            'addenda': [''],
            'gln': [''],
            'glnTienda': [''],
            'glnComprador': [''],
            'numProveedor': [''],
            'comprobanteDestino': [''],
            'domicilioFiscal': [''],
            'domicilioSucursal': [''],
            'razonSocialComprobante': [''],
            'metodoPago': [''],
            'idPerfil': [0],
            'idNotaTipo': [0],
            'adeudoPrestamo': [0],
            'administraSaldo': [false],
        });
        _this.condicionesPago =
            [
                { "id": 'C', "nombre": "Credito" },
                { "id": 'E', "nombre": "Contado" }
            ];
        _this.listdomiciliosComprobantes =
            [
                { "value": "CONTRIBUYENTE", "text": "Domicilio del Contribuyente" },
                { "value": "GRUPO_DEUDOR", "text": "Domicilio del Grupo Deudor" },
                { "value": "DEUDOR", "text": "Domicilio del Cliente" }
            ];
        _this.listRazonSocial =
            [
                { "value": "CONTRIBUYENTE", "text": "Razón social del Contribuyente" },
                { "value": "DEUDOR", "text": "Nombre del Deudor" }
            ];
        _this.metodosPago =
            [
                { "metodo": "PUE" },
                { "metodo": "PPD" }
            ];
        return _this;
    }
    DeudoresEditor_1 = DeudoresEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    DeudoresEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.loadFormasPago();
        this.loadNotaTipos();
    };
    DeudoresEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.addendaService.AddendaList(this.context.app.defaultCompany.identity)
            .then(function (x) { return _this.adendacbo = x; })
            .catch(function (error) { return _this.handleError(error); });
        this.comprobanteFiscalService.ComprobantesDestinosList()
            .then(function (x) { return _this.comprobantecbo = x; })
            .catch(function (error) { return _this.handleError(error); });
        this.perfilAutoCobroTipoService.loadList(this.context.app.defaultCompany.identity)
            .then(function (x) { return _this.tiposPerfiles = x; })
            .catch(function (error) { return _this.handleError(error); });
    };
    DeudoresEditor.prototype.ngAfterViewChecked = function () {
        this.comprobantesCorreosCollection.sourceCollection = this.deudor.comprobantesCorreos;
        this.perfilesAutocobranzaCollection.sourceCollection = this.deudor.perfilesAutoCobro;
    };
    DeudoresEditor.prototype.onCreatingItem = function () {
    };
    DeudoresEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.deudorService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.deudor = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DeudoresEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.deudorService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.deudor = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DeudoresEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.deudorService.getDetailByID(id)
            .then(function (info) {
            console.log(JSON.stringify(info));
            _this.context.app.hideSpinner();
            _this.deudor = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DeudoresEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.deudorService.update(this.deudor)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.deudor = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DeudoresEditor.prototype.loadFormasPago = function () {
        var _this = this;
        this.formaPagoService.loadList(this.context.app.defaultSite.identity)
            .then(function (formas) { return _this.formasPago = formas; })
            .catch(function (error) { return _this.handleError(error); });
    };
    DeudoresEditor.prototype.onGrupoDeudorSelected = function (grupo) {
        this.deudor.contribuyente = grupo.contribuyente;
    };
    DeudoresEditor.prototype.onSelectTab = function (args) {
        if (args.heading) {
            wijmo_1.Control.invalidateAll();
        }
    };
    //Correos
    DeudoresEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.comprobanteCorreoDialog.show();
        }
    };
    DeudoresEditor.prototype.onAgregarComprobanteCorreo = function (args) {
        var _this = this;
        var comprobanteExists = false;
        this.deudor.comprobantesCorreos.forEach(function (comproMail) {
            if (comproMail.idComprobanteTipo == args.idComprobanteTipo && comproMail.state != 'DELETED') {
                _this.showAlert("El tipo de comprobante ya fue agregado", "danger");
                comprobanteExists = true;
            }
        });
        if (!comprobanteExists) {
            this.deudor.comprobantesCorreos.push(args);
            this.comprobantesCorreosCollection.refresh();
        }
    };
    DeudoresEditor.prototype.onRemoveItem = function (item) {
        this.comprobantesCorreosCollection.remove(item);
        this.comprobantesCorreosCollection.refresh();
    };
    DeudoresEditor.prototype.onRemovePerfil = function (item) {
        this.perfilesAutocobranzaCollection.remove(item);
        this.perfilesAutocobranzaCollection.refresh();
    };
    DeudoresEditor.prototype.onAgregarPerfil = function () {
        var _this = this;
        var perfilExists = false;
        this.deudor.perfilesAutoCobro.forEach(function (compro) {
            if (compro.idPerfilAutoCobro == _this.idPerfil && compro.state != 'DELETED') {
                _this.showAlert("El perfil ya fue agregado", "danger");
                perfilExists = true;
            }
        });
        if (!perfilExists) {
            this.perfilAutoCobroTipoService.getDetailByID(this.idPerfil)
                .then(function (perfil) {
                var newP;
                newP = new deudor_perfil_auto_cobro_1.DeudorPerfilAutoCobro();
                newP.idPerfilAutoCobro = perfil.identity;
                newP.perfil = perfil;
                _this.deudor.perfilesAutoCobro.push(newP);
                _this.perfilesAutocobranzaCollection.refresh();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    DeudoresEditor.prototype.loadNotaTipos = function () {
        var _this = this;
        this.notaTipoSvc.loadList(this.context.app.defaultCompany.identity)
            .then(function (tipos) { return _this.notaTipos = tipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    DeudoresEditor.prototype.onTipoPerfilChanged = function (args) {
    };
    var DeudoresEditor_1;
    __decorate([
        core_1.ViewChild('selGrupoDeudor'),
        __metadata("design:type", grupo_deudores_selector_component_1.GrupoDeudorSelectorComponent)
    ], DeudoresEditor.prototype, "selInsumo", void 0);
    __decorate([
        core_1.ViewChild(comprobante_correo_editor_1.ComprobantesCorreoEditor),
        __metadata("design:type", comprobante_correo_editor_1.ComprobantesCorreoEditor)
    ], DeudoresEditor.prototype, "comprobanteCorreoDialog", void 0);
    DeudoresEditor = DeudoresEditor_1 = __decorate([
        core_1.Component({
            selector: 'credito-deudores-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Deudor'\"\n                                 [info]=\"deudor\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"deudor.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"deudor.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onSelectTab($event)\">\n\n                              <az-panel [header]=\"'Condiciones de Cr\u00E9dito'\">\n                                  <div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"''\">\n                                              <az-combobox formControlName=\"condiciones\"\n                                                           [(ngModel)]=\"deudor.condicionesPago\"\n                                                           [items]=\"condicionesPago\"\n                                                           [displayMember]=\"'nombre'\"\n                                                           [valueMember]=\"'id'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'Limite de Cr\u00E9dito:'\">\n                                              <az-input-number formControlName=\"limiteCredito\" [(ngModel)]=\"deudor.limiteCredito\" format=\"'n2'\" [enabled]=\"deudor.condicionesPago=='C'\"></az-input-number>\n                                          </azteca-form-field>\n                                      </div>\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'Dias de Cr\u00E9dito:'\">\n                                              <az-input-number formControlName=\"diasCredito\" [(ngModel)]=\"deudor.diasCredito\" format=\"'n0'\" [enabled]=\"deudor.condicionesPago=='C'\"></az-input-number>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div *ngIf=\"deudor.idGrupoDeudor>0\" > \n                                      <az-checkbox formControlName=\"administraSaldo\" [label]=\"'Administra su propio saldo'\" [(ngModel)]=\"deudor.administraSaldo\"></az-checkbox>\n                                  </div>\n\n                              </az-panel>\n\n                              <div class=\"row\">\n                                  <div class=\"col-5 col-md-4\">\n                                      <azteca-form-field [label]=\"'Forma de Pago:'\">\n                                          <az-combobox formControlName=\"idFormaPago\"\n                                                       [(ngModel)]=\"deudor.idFormaPago\"\n                                                       [items]=\"formasPago\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-5 col-md-4\">\n                                      <azteca-form-field [label]=\"'Cuenta de Pago:'\">\n                                          <az-textbox formControlName=\"cuentaPago\" [(ngModel)]=\"deudor.cuentaPago\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-5 col-md-4\">\n                                      <azteca-form-field [label]=\"'Metodo de Pago:'\">\n                                          <az-combobox formControlName=\"metodoPago\"\n                                                       [(ngModel)]=\"deudor.metodoPago\"\n                                                       [items]=\"metodosPago\"\n                                                       [displayMember]=\"'metodo'\"\n                                                       [valueMember]=\"'metodo'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-5 col-md-4\">\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"cuenta\" [(ngModel)]=\"deudor.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <az-panel [header]=\"'Direcci\u00F3n a Mostrar'\">\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-md-6\">\n                                          <azteca-form-field [label]=\"'Domicilio Fiscal'\">\n                                              <az-combobox formControlName=\"domicilioFiscal\"\n                                                           [(ngModel)]=\"deudor.domicilioComprobante.domicilioFiscal\"\n                                                           [items]=\"listdomiciliosComprobantes\"\n                                                           [displayMember]=\"'text'\"\n                                                           [valueMember]=\"'value'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                      <div class=\"col-12 col-md-6\">\n                                          <azteca-form-field [label]=\"'Domicilio Sucursal'\">\n                                              <az-combobox formControlName=\"domicilioSucursal\"\n                                                           [(ngModel)]=\"deudor.domicilioComprobante.domicilioSucursal\"\n                                                           [items]=\"listdomiciliosComprobantes\"\n                                                           [displayMember]=\"'text'\"\n                                                           [valueMember]=\"'value'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n                              </az-panel>\n                              <az-panel [header]=\"'Raz\u00F3n Social del Comprobante'\">\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-md-6\">\n                                          <azteca-form-field [label]=\"'Raz\u00F3n Social'\">\n                                              <az-combobox formControlName=\"razonSocialComprobante\"\n                                                           [(ngModel)]=\"deudor.razonSocialComprobante.razonSocial\"\n                                                           [items]=\"listRazonSocial\"\n                                                           [displayMember]=\"'text'\"\n                                                           [valueMember]=\"'value'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n                              </az-panel>\n                          </tab>\n\n                          <tab heading=\"Domicilio\" (select)=\"onSelectTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"''\">\n                                          <general-domicilio-editor #domicilio formControlName=\"domicilio\"\n                                                                    [(ngModel)]=\"deudor.domicilio\"\n                                                                    [asentamientoVisible]=\"false\">\n                                          </general-domicilio-editor>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </tab>\n\n                          <tab heading=\"Facturaci\u00F3n\" (select)=\"onSelectTab($event)\">\n                              <div class=\"col-10 col-md-8\">\n                                  <azteca-form-field [label]=\"'Grupo deudor:'\">\n                                      <credit-grupo-deudores-selector #selGrupoDeudor formControlName=\"idGrupoDeudor\" [(ngModel)]=\"deudor.idGrupoDeudor\" ngDefaultControl=\"\" (itemSelected)=\"onGrupoDeudorSelected($event)\"></credit-grupo-deudores-selector>\n                                  </azteca-form-field>\n                              </div>\n\n                              <az-checkbox formControlName=\"facturable\" [label]=\"'Solicita factura'\" [(ngModel)]=\"deudor.facturable\"></az-checkbox>\n\n                              <az-panel [enabled]=\"deudor.facturable\">\n                                  <div class=\"col-4 col-md-4\">\n                                      <azteca-form-field [label]=\"'RFC:'\">\n                                          <az-textbox formControlName=\"rfc\" [(ngModel)]=\"deudor.contribuyente.rfc\" [enabled]=\"deudor.facturable && deudor.idGrupoDeudor==0\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-10 col-md-8\">\n                                      <azteca-form-field [label]=\"'Raz\u00F3n Social:'\">\n                                          <az-textbox formControlName=\"razonSocial\" [(ngModel)]=\"deudor.contribuyente.razonSocial\" [enabled]=\"deudor.facturable && deudor.idGrupoDeudor==0\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-10 col-md-8\">\n                                          <azteca-form-field [label]=\"''\">\n                                              <general-domicilio-editor #domicilioFiscal [enabled]=\"deudor.facturable && deudor.idGrupoDeudor==0\"\n                                                                        formControlName=\"domicilio\"\n                                                                        [(ngModel)]=\"deudor.contribuyente.domicilio\"\n                                                                        [cruceUnoVisible]=\"false\"\n                                                                        [cruceDosVisible]=\"false\">\n\n                                              </general-domicilio-editor>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <az-checkbox formControlName=\"desgloseIEPS\" [label]=\"'Desglosa IEPS'\" [(ngModel)]=\"deudor.desgloseIEPS\"></az-checkbox>\n\n                                  <!--<div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'Addenda:'\">\n                                              <az-combobox formControlName=\"idAddenda\"\n                                                           [(ngModel)]=\"cliente.idComprobanteAddenda\"\n                                                           [items]=\"addendas\"\n                                                           [displayMember]=\"'nombre'\"\n                                                           [valueMember]=\"'id'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>-->\n\n                              </az-panel>\n\n                          </tab>\n\n                          <tab heading=\"Datos Edi\" (select)=\"onSelectTab($event)\">\n                              <az-panel [header]=\"'Datos Edi'\">\n                                  <div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'Addenda'\">\n                                              <az-combobox formControlName=\"addenda\"\n                                                           [(ngModel)]=\"deudor.idComprobanteAddenda\"\n                                                           [items]=\"adendacbo\"\n                                                           [displayMember]=\"'nombre'\"\n                                                           [valueMember]=\"'id'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'GLN:'\">\n                                              <az-textbox formControlName=\"gln\" [(ngModel)]=\"deudor.gln\"></az-textbox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'GLN Tienda:'\">\n                                              <az-textbox formControlName=\"glnTienda\" [(ngModel)]=\"deudor.glnTienda\"></az-textbox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'GLN Comprador:'\">\n                                              <az-textbox formControlName=\"glnComprador\" [(ngModel)]=\"deudor.glnComprador\"></az-textbox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'Numero de Proveedor:'\">\n                                              <az-textbox formControlName=\"numProveedor\" [(ngModel)]=\"deudor.numProveedor\"></az-textbox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'Destino de Envio'\">\n                                              <az-combobox formControlName=\"comprobanteDestino\"\n                                                           [(ngModel)]=\"deudor.idComprobanteDestino\"\n                                                           [items]=\"comprobantecbo\"\n                                                           [displayMember]=\"'nombre'\"\n                                                           [valueMember]=\"'id'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                              </az-panel>\n                          </tab>\n\n                          <tab heading=\"Correos por comprobante\" (select)=\"onSelectTab($event)\">\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar Correo/Comprobante'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <wj-flex-grid #gridCorreos style=\"height:550px\"\n                                            [itemsSource]=\"comprobantesCorreosCollection\">\n\n                                  <wj-flex-grid-column [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveItem(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-trash\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n\n                                  <wj-flex-grid-column [header]=\"'Comprobante'\" [binding]=\"'comprobanteTipo'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'correo'\" [binding]=\"'correo'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </tab>\n\n                          <tab heading=\"Perfiles de autocobranza para adeudos\" (select)=\"onSelectTab($event)\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n\n                                      <azteca-form-field [label]=\"'Tipo de nota de cr\u00E9dito para afectaci\u00F3n de saldo del pr\u00E9stamo:'\">\n                                          <az-combobox formControlName=\"idNotaTipo\"\n                                                       [(ngModel)]=\"deudor.idNotaTipo\"\n                                                       [items]=\"notaTipos\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                  </div>\n                                  <div class=\"col-5 col-md-6\">\n                                      <azteca-form-field [label]=\"'Adeudo del pr\u00E9stamo:'\">\n                                          <az-input-number formControlName=\"adeudoPrestamo\" [(ngModel)]=\"deudor.adeudoPrestamo\" format=\"'n4'\" [enabled]=\"true\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-12\">\n                                      <azteca-form-field [label]=\"'Perfil:'\">\n                                          <az-combobox formControlName=\"idPerfil\"\n                                                       [(ngModel)]=\"idPerfil\"\n                                                       [items]=\"tiposPerfiles\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       (selectedItemChanged)=\"onTipoPerfilChanged($event)\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                      <button type=\"button\" (click)=\"onAgregarPerfil()\">Agregar perfil</button>\n                                  </div>\n                              </div>\n\n\n                                  <wj-flex-grid #gridCorreos style=\"height:550px\"\n                                                [itemsSource]=\"perfilesAutocobranzaCollection\">\n\n                                      <wj-flex-grid-column [width]=\"55\" [isReadOnly]=\"true\">\n                                          <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                              <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemovePerfil(cell.item)\">\n                                                  <span class=\"glyphicon glyphicon-trash\"></span>\n                                              </button>\n                                          </ng-template>\n                                      </wj-flex-grid-column>\n\n                                      <wj-flex-grid-column [header]=\"'Codigo'\" [binding]=\"'perfil.code'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'perfil.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Codigo Referencia'\" [binding]=\"'perfil.codigoReferencia'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Cantidad'\" [binding]=\"'perfil.cantidad'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Afectador'\" [binding]=\"'perfil.afectador'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  </wj-flex-grid>\n\n      </tab>\n\n                      </tabset>\n                  </div>\n              </div>\n\n\n          </azteca-catalog-editor>\n\n          <accounting-comprobante-correo (dataUpdater)=\"onAgregarComprobanteCorreo($event)\">\n\n          </accounting-comprobante-correo>\n\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return DeudoresEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: deudor_service_1.DeudorService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, deudor_service_1.DeudorService, forma_pago_service_1.FormaPagoService, addenda_service_1.AddendaService,
            comprobante_fiscal_service_1.ComprobanteFiscalService, perfil_auto_cobro_tipo_service_1.PerfilAutoCobroTipoService,
            nota_tipo_service_1.NotaTipoService])
    ], DeudoresEditor);
    return DeudoresEditor;
}(editors_1.CatalogEditor));
exports.DeudoresEditor = DeudoresEditor;
