import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { CollectionView } from 'wijmo/wijmo';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs, TrackableCollection } from 'framework3/editors';
import { GrupoDeudorService } from '../services/grupo-deudor.service';
import { GrupoDeudorInfo } from '../models/grupo-deudor';
import { SerieFiscalItem } from '../../accounting/models/serie-fiscal';
import { SerieFiscalService } from '../../accounting/services/serie-fiscal.service';
import { UsoCFDIItem } from '../../accounting/models/contribuyente';
import { ContribuyenteService } from '../../accounting/services/contribuyente.service';
import { PerfilAutoCobroTipoItem } from '../models/perfil-auto-cobro-tipo';
import { PerfilAutoCobroTipoService } from '../services/perfil-auto-cobro-tipo.service';
import { DeudorItem } from '../models/deudor';
import { NotaTipoItem } from '../models/nota-tipo';
import { NotaTipoService } from '../services/nota-tipo.service';
export declare class GruposDeudoresEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private grupoDeudorService;
    private serieFiscalService;
    private contribuyenteService;
    private notaTipoSvc;
    private perfilAutoCobroTipoService;
    grupodeudor: GrupoDeudorInfo;
    series: SerieFiscalItem[];
    usosCFDI: UsoCFDIItem[];
    notaTipos: NotaTipoItem[];
    perfilesAutocobranzaCollection: TrackableCollection;
    idPerfil: number;
    tiposPerfiles: PerfilAutoCobroTipoItem[];
    deudores: DeudorItem[];
    deudoresCollection: CollectionView;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, grupoDeudorService: GrupoDeudorService, serieFiscalService: SerieFiscalService, contribuyenteService: ContribuyenteService, notaTipoSvc: NotaTipoService, perfilAutoCobroTipoService: PerfilAutoCobroTipoService);
    onConfigureCatalog(options: CatalogOptions): void;
    ngOnInit(): void;
    ngAfterViewChecked(): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadSeries(): void;
    loadDeudores(): void;
    loadUsosCFDI(): void;
    loadNotaTipos(): void;
    onSelectTab(args: any): void;
    onRemovePerfil(item: any): void;
    onTipoPerfilChanged(args: EditorEventArgs): void;
    onAgregarPerfil(): void;
}
