"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var grupo_deudor_service_1 = require("../services/grupo-deudor.service");
var grupo_deudor_1 = require("../models/grupo-deudor");
var serie_fiscal_service_1 = require("../../accounting/services/serie-fiscal.service");
var contribuyente_service_1 = require("../../accounting/services/contribuyente.service");
var deudor_perfil_auto_cobro_1 = require("../models/deudor-perfil-auto-cobro");
var perfil_auto_cobro_tipo_service_1 = require("../services/perfil-auto-cobro-tipo.service");
var nota_tipo_service_1 = require("../services/nota-tipo.service");
var GruposDeudoresEditor = /** @class */ (function (_super) {
    __extends(GruposDeudoresEditor, _super);
    //
    function GruposDeudoresEditor(router, route, formBuilder, changeDetector, context, location, grupoDeudorService, serieFiscalService, contribuyenteService, notaTipoSvc, perfilAutoCobroTipoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.grupoDeudorService = grupoDeudorService;
        _this.serieFiscalService = serieFiscalService;
        _this.contribuyenteService = contribuyenteService;
        _this.notaTipoSvc = notaTipoSvc;
        _this.perfilAutoCobroTipoService = perfilAutoCobroTipoService;
        _this.grupodeudor = new grupo_deudor_1.GrupoDeudorInfo();
        _this.series = [];
        _this.usosCFDI = [];
        _this.notaTipos = [];
        _this.perfilesAutocobranzaCollection = new editors_1.TrackableCollection();
        _this.tiposPerfiles = [];
        _this.deudores = [];
        _this.deudoresCollection = new wijmo_1.CollectionView();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'limiteCredito': [''],
            'diasCredito': ['', forms_1.Validators.required],
            'desglosaIEPS': [''],
            'rfc': [''],
            'razonSocial': [''],
            'domicilio': [''],
            'idCFDSerie': [''],
            'cuenta': [''],
            'idUsoCFDI': [0],
            'idNotaTipo': [0],
            'idPerfil': [0],
            'adeudoPrestamo': [0]
        });
        return _this;
    }
    GruposDeudoresEditor_1 = GruposDeudoresEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    GruposDeudoresEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.loadSeries();
        this.loadUsosCFDI();
        this.loadNotaTipos();
    };
    GruposDeudoresEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.perfilAutoCobroTipoService.loadList(this.context.app.defaultCompany.identity)
            .then(function (x) { return _this.tiposPerfiles = x; })
            .catch(function (error) { return _this.handleError(error); });
    };
    GruposDeudoresEditor.prototype.ngAfterViewChecked = function () {
        this.perfilesAutocobranzaCollection.sourceCollection = this.grupodeudor.perfilesAutoCobro;
    };
    GruposDeudoresEditor.prototype.onCreatingItem = function () {
    };
    GruposDeudoresEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.grupoDeudorService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.grupodeudor = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GruposDeudoresEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.grupoDeudorService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.grupodeudor = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GruposDeudoresEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.grupoDeudorService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.grupodeudor = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GruposDeudoresEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.grupoDeudorService.update(this.grupodeudor)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.grupodeudor = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GruposDeudoresEditor.prototype.loadSeries = function () {
        var _this = this;
        this.serieFiscalService.loadList(this.context.app.defaultCompany.identity.toString())
            .then(function (series) { return _this.series = series; })
            .catch(function (error) { return _this.handleError(error); });
    };
    GruposDeudoresEditor.prototype.loadDeudores = function () {
        var _this = this;
        if (this.deudores.length == 0) {
            this.grupoDeudorService.getDeudoresList(this.grupodeudor.identity)
                .then(function (deudores) {
                _this.context.app.hideSpinner();
                _this.deudores = deudores;
                _this.deudoresCollection.sourceCollection = deudores;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    GruposDeudoresEditor.prototype.loadUsosCFDI = function () {
        var _this = this;
        this.contribuyenteService.loadUsosCFDI(this.context.app.defaultCompany.identity)
            .then(function (usos) { return _this.usosCFDI = usos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    GruposDeudoresEditor.prototype.loadNotaTipos = function () {
        var _this = this;
        this.notaTipoSvc.loadList(this.context.app.defaultCompany.identity)
            .then(function (tipos) { return _this.notaTipos = tipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    GruposDeudoresEditor.prototype.onSelectTab = function (args) {
        if (args.heading == 'Deudores del grupo') {
            this.loadDeudores();
            wijmo_1.Control.invalidateAll();
        }
        if (args.heading) {
            wijmo_1.Control.invalidateAll();
        }
    };
    GruposDeudoresEditor.prototype.onRemovePerfil = function (item) {
        this.perfilesAutocobranzaCollection.remove(item);
        this.perfilesAutocobranzaCollection.refresh();
    };
    GruposDeudoresEditor.prototype.onTipoPerfilChanged = function (args) {
    };
    GruposDeudoresEditor.prototype.onAgregarPerfil = function () {
        var _this = this;
        var perfilExists = false;
        this.grupodeudor.perfilesAutoCobro.forEach(function (compro) {
            if (compro.idPerfilAutoCobro == _this.idPerfil && compro.state != 'DELETED') {
                _this.showAlert("El perfil ya fue agregado", "danger");
                perfilExists = true;
            }
        });
        if (!perfilExists) {
            this.perfilAutoCobroTipoService.getDetailByID(this.idPerfil)
                .then(function (perfil) {
                var newP;
                newP = new deudor_perfil_auto_cobro_1.DeudorPerfilAutoCobro();
                newP.idPerfilAutoCobro = perfil.identity;
                newP.perfil = perfil;
                _this.grupodeudor.perfilesAutoCobro.push(newP);
                _this.perfilesAutocobranzaCollection.refresh();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    var GruposDeudoresEditor_1;
    GruposDeudoresEditor = GruposDeudoresEditor_1 = __decorate([
        core_1.Component({
            selector: 'credito-grupos-deudores-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Grupos de Deudores'\"\n                                 [info]=\"grupodeudor\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"grupodeudor.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"grupodeudor.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-8 col-md-6\">\n                                      <azteca-form-field [label]=\"'Limite de Cr\u00E9dito:'\">\n                                          <az-textbox formControlName=\"limiteCredito\" [(ngModel)]=\"grupodeudor.limiteCredito\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-8 col-md-6\">\n                                      <azteca-form-field [label]=\"'Dias de Cr\u00E9dito:'\">\n                                          <az-textbox formControlName=\"diasCredito\" [(ngModel)]=\"grupodeudor.diasCredito\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-8 col-md-6\">\n                                      <azteca-form-field [label]=\"'Desglose de Impuesto IEPS:'\">\n                                          <az-checkbox formControlName=\"desglosaIEPS\" [(ngModel)]=\"grupodeudor.desglosaIeps\"></az-checkbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"cuenta\" [(ngModel)]=\"grupodeudor.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <tab heading=\"Datos Fiscales\">\n                              <div class=\"col-4 col-md-4\">\n                                  <azteca-form-field [label]=\"'RFC:'\">\n                                      <az-textbox formControlName=\"rfc\" [(ngModel)]=\"grupodeudor.contribuyente.rfc\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n\n                              <div class=\"col-10 col-md-8\">\n                                  <azteca-form-field [label]=\"'Raz\u00F3n Social:'\">\n                                      <az-textbox formControlName=\"razonSocial\" [(ngModel)]=\"grupodeudor.contribuyente.razonSocial\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-10 col-md-8\">\n                                      <azteca-form-field [label]=\"''\">\n                                          <general-domicilio-editor formControlName=\"domicilio\"\n                                                                    [(ngModel)]=\"grupodeudor.contribuyente.domicilio\"\n                                                                    [cruceUnoVisible]=\"false\"\n                                                                    [cruceDosVisible]=\"false\">\n\n                                          </general-domicilio-editor>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-8\">\n                                      <azteca-form-field [label]=\"'Uso de CFDI:'\">\n                                          <az-combobox formControlName=\"idUsoCFDI\"\n                                                       [(ngModel)]=\"grupodeudor.contribuyente.idUsoCFDI\"\n                                                       [items]=\"usosCFDI\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"col-6 col-md-5\">\n                                  <azteca-form-field [label]=\"'Serie Fiscal:'\">\n                                      <az-combobox formControlName=\"idCFDSerie\"\n                                                   [(ngModel)]=\"grupodeudor.idCFDSerie\"\n                                                   [items]=\"series\"\n                                                   [displayMember]=\"'nombre'\"\n                                                   [valueMember]=\"'id'\">\n                                      </az-combobox>\n                                  </azteca-form-field>\n                              </div>\n\n                          </tab>\n\n\n                          <tab heading=\"Perfiles de autocobranza para adeudos\" (select)=\"onSelectTab($event)\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n\n                                      <azteca-form-field [label]=\"'Tipo de nota de cr\u00E9dito para afectaci\u00F3n de saldo del pr\u00E9stamo:'\">\n                                          <az-combobox formControlName=\"idNotaTipo\"\n                                                       [(ngModel)]=\"grupodeudor.idNotaTipo\"\n                                                       [items]=\"notaTipos\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                  </div>\n                                  <div class=\"col-5 col-md-6\">\n                                      <azteca-form-field [label]=\"'Adeudo del pr\u00E9stamo:'\">\n                                          <az-input-number formControlName=\"adeudoPrestamo\" [(ngModel)]=\"grupodeudor.adeudoPrestamo\" format=\"'n4'\" [enabled]=\"true\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-12\">\n                                      <azteca-form-field [label]=\"'Perfil:'\">\n                                          <az-combobox formControlName=\"idPerfil\"\n                                                       [(ngModel)]=\"idPerfil\"\n                                                       [items]=\"tiposPerfiles\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       (selectedItemChanged)=\"onTipoPerfilChanged($event)\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                      <button type=\"button\" (click)=\"onAgregarPerfil()\">Agregar perfil</button>\n                                  </div>\n                              </div>\n\n\n                              <wj-flex-grid #gridCorreos style=\"height:550px\"\n                                            [itemsSource]=\"perfilesAutocobranzaCollection\">\n\n                                  <wj-flex-grid-column [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemovePerfil(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-trash\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n\n                                  <wj-flex-grid-column [header]=\"'Codigo'\" [binding]=\"'perfil.code'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'perfil.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Codigo Referencia'\" [binding]=\"'perfil.codigoReferencia'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Cantidad'\" [binding]=\"'perfil.cantidad'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Afectador'\" [binding]=\"'perfil.afectador'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n\n                          </tab>\n\n                          <tab heading=\"Deudores del grupo\" (select)=\"onSelectTab($event)\">\n\n                              <wj-flex-grid #gridDeudores style=\"height:550px\"\n                                            [itemsSource]=\"deudoresCollection\">\n\n                                  <wj-flex-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Adeudo pr\u00E9stamo'\" [binding]=\"'adeudoPrestamo'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n\n                          </tab>\n\n                      </tabset>\n\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return GruposDeudoresEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: grupo_deudor_service_1.GrupoDeudorService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, grupo_deudor_service_1.GrupoDeudorService, serie_fiscal_service_1.SerieFiscalService, contribuyente_service_1.ContribuyenteService,
            nota_tipo_service_1.NotaTipoService, perfil_auto_cobro_tipo_service_1.PerfilAutoCobroTipoService])
    ], GruposDeudoresEditor);
    return GruposDeudoresEditor;
}(editors_1.CatalogEditor));
exports.GruposDeudoresEditor = GruposDeudoresEditor;
