import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { ToolbarButton } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs, TrackableCollection } from 'framework3/editors';
import { NotaTipoService } from '../services/nota-tipo.service';
import { NotaTipoInfo } from '../models/nota-tipo';
import { CobroTipoItem } from '../models/cobro-tipo';
import { CobroTipoService } from '../services/cobro-tipo.service';
import { NotaConceptoSelectorComponent } from '../../accounting/components/nota-concepto-selector.component';
export declare class NotasTiposEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private notaTipoService;
    private cobroTipoService;
    notaTipo: NotaTipoInfo;
    cobroTipos: CobroTipoItem[];
    conceptosCollection: TrackableCollection;
    selectorNotaConcepto: NotaConceptoSelectorComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, notaTipoService: NotaTipoService, cobroTipoService: CobroTipoService);
    loadCobroTipos(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onTabSelected(args: any): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onRemoveItem(item: any): void;
}
