"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var nota_tipo_service_1 = require("../services/nota-tipo.service");
var nota_tipo_1 = require("../models/nota-tipo");
var nota_tipo_concepto_1 = require("../models/nota-tipo-concepto");
var cobro_tipo_service_1 = require("../services/cobro-tipo.service");
var nota_concepto_selector_component_1 = require("../../accounting/components/nota-concepto-selector.component");
var NotasTiposEditor = /** @class */ (function (_super) {
    __extends(NotasTiposEditor, _super);
    //
    function NotasTiposEditor(router, route, formBuilder, changeDetector, context, location, notaTipoService, cobroTipoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.notaTipoService = notaTipoService;
        _this.cobroTipoService = cobroTipoService;
        _this.notaTipo = new nota_tipo_1.NotaTipoInfo();
        _this.cobroTipos = [];
        //conceptosCollection: CollectionView = new CollectionView();
        _this.conceptosCollection = new editors_1.TrackableCollection();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idCobroTipo': [0, forms_1.Validators.required],
            'idNotaConcepto': [0, forms_1.Validators.required],
        });
        return _this;
    }
    NotasTiposEditor_1 = NotasTiposEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    NotasTiposEditor.prototype.loadCobroTipos = function () {
        var _this = this;
        this.cobroTipoService.loadList(this.context.app.defaultSite.identity, false)
            .then(function (tipos) { return _this.cobroTipos = tipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    NotasTiposEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.loadCobroTipos();
    };
    NotasTiposEditor.prototype.onCreatingItem = function () {
    };
    NotasTiposEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaTipoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.notaTipo = info;
            _this.conceptosCollection.sourceCollection = _this.notaTipo.notaTipoConceptos;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasTiposEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.notaTipoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.notaTipo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasTiposEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaTipoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.notaTipo = info;
            _this.conceptosCollection.sourceCollection = _this.notaTipo.notaTipoConceptos;
            _this.conceptosCollection.refresh;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasTiposEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaTipoService.update(this.notaTipo)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.notaTipo.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.notaTipo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasTiposEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    NotasTiposEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            var concepto;
            concepto = this.selectorNotaConcepto.selectedItem;
            var rel = new nota_tipo_concepto_1.NotaTipoConcepto;
            rel.codigoConcepto = concepto.code;
            rel.codigoTipo = this.notaTipo.code;
            rel.idNotaConcepto = concepto.identity;
            rel.idNotaTipo = this.notaTipo.identity;
            rel.nombreConcepto = concepto.nombre;
            rel.nombreTipo = this.notaTipo.nombre;
            var newRel = this.notaTipo.notaTipoConceptos.slice();
            newRel.push(rel);
            this.notaTipo.notaTipoConceptos = newRel;
            this.conceptosCollection.sourceCollection = newRel;
            this.conceptosCollection.refresh;
        }
    };
    NotasTiposEditor.prototype.onRemoveItem = function (item) {
        this.conceptosCollection.remove(item);
        this.conceptosCollection.refresh();
    };
    var NotasTiposEditor_1;
    __decorate([
        core_1.ViewChild('selectorNotaConcepto'),
        __metadata("design:type", nota_concepto_selector_component_1.NotaConceptoSelectorComponent)
    ], NotasTiposEditor.prototype, "selectorNotaConcepto", void 0);
    NotasTiposEditor = NotasTiposEditor_1 = __decorate([
        core_1.Component({
            selector: 'credito-nota-tipo-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'NotaTipo'\"\n                                 [info]=\"notaTipo\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"notaTipo.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"notaTipo.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n\t\t\t\t\t\t\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n\n                                      <azteca-form-field [label]=\"'Tipo de cobro:'\">\n                                          <az-combobox formControlName=\"idCobroTipo\"\n                                                       [(ngModel)]=\"notaTipo.idCobroTipo\"\n                                                       [items]=\"cobroTipos\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n\n\n                          </tab>\n                          <tab heading=\"Conceptos\" (select)=\"onTabSelected($event)\">\n                              <div class=\"row\">\n                                  <azteca-form-field [label]=\"'Seleccionar concepto:'\">\n                                      <azteca-form-field [label]=\"Concepto\">\n                                          <accounting-nota-concepto-selector formControlName=\"idNotaConcepto\" #selectorNotaConcepto (selectedItemChanged)=\"onSelectedItemChanged($event)\"></accounting-nota-concepto-selector>\n                                      </azteca-form-field>\n                                  </azteca-form-field>\n                              </div>\n\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar concepto'\" [icon]=\"'glyphicon glyphicon-plus'\" [enabled]=\"true\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <wj-flex-grid #grid style=\"height:550px\"\n                                                      [itemsSource]=\"conceptosCollection\"\n                                                      [wjContextMenu]=\"ctxMenuConceptos\"\n                                                      [isReadOnly]=\"false\">\n                                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                                          <wj-flex-grid-column [width]=\"55\" [isReadOnly]=\"true\">\n                                              <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                                  <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveItem(cell.item)\">\n                                                      <span class=\"glyphicon glyphicon-trash\"></span>\n                                                  </button>\n                                              </ng-template>\n                                          </wj-flex-grid-column>\n\n\n                                          <wj-flex-grid-column [header]=\"'Codigo'\" [binding]=\"'codigoConcepto'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'nombreConcepto'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      </wj-flex-grid>\n                                  </div>\n                              </div>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return NotasTiposEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: nota_tipo_service_1.NotaTipoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, nota_tipo_service_1.NotaTipoService, cobro_tipo_service_1.CobroTipoService])
    ], NotasTiposEditor);
    return NotasTiposEditor;
}(editors_1.CatalogEditor));
exports.NotasTiposEditor = NotasTiposEditor;
