"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Features
var perfil_auto_cobro_tipo_service_1 = require("../services/perfil-auto-cobro-tipo.service");
var perfil_auto_cobro_tipo_1 = require("../models/perfil-auto-cobro-tipo");
var PerfilesAutoCobrosTiposEditor = /** @class */ (function (_super) {
    __extends(PerfilesAutoCobrosTiposEditor, _super);
    //
    function PerfilesAutoCobrosTiposEditor(router, route, formBuilder, changeDetector, context, location, perfilAutoCobroTipoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.perfilAutoCobroTipoService = perfilAutoCobroTipoService;
        _this.perfilAutoCobroTipo = new perfil_auto_cobro_tipo_1.PerfilAutoCobroTipoInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'sample_field': [''],
            'codigoReferencia': [''],
            'cantidad': [0, forms_1.Validators.required],
            'bSuma': [0],
            'bResta': [0],
            'porcentaje': [0],
        });
        return _this;
    }
    PerfilesAutoCobrosTiposEditor_1 = PerfilesAutoCobrosTiposEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    PerfilesAutoCobrosTiposEditor.prototype.onConfigureCatalog = function (options) {
        this.bSuma = false;
        this.bResta = true;
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    PerfilesAutoCobrosTiposEditor.prototype.onCreatingItem = function () {
    };
    PerfilesAutoCobrosTiposEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.perfilAutoCobroTipoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.perfilAutoCobroTipo = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PerfilesAutoCobrosTiposEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.perfilAutoCobroTipoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.perfilAutoCobroTipo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PerfilesAutoCobrosTiposEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.perfilAutoCobroTipoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            if (info.afectador == 'S') {
                _this.bSuma = true;
                _this.bResta = false;
            }
            else {
                _this.bSuma = false;
                _this.bResta = true;
            }
            _this.perfilAutoCobroTipo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PerfilesAutoCobrosTiposEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        if (this.bSuma)
            this.perfilAutoCobroTipo.afectador = "S";
        if (this.bResta)
            this.perfilAutoCobroTipo.afectador = "R";
        this.perfilAutoCobroTipoService.update(this.perfilAutoCobroTipo)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.perfilAutoCobroTipo.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.perfilAutoCobroTipo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PerfilesAutoCobrosTiposEditor.prototype.onChangeSuma = function (args) {
        this.bResta = false;
        this.perfilAutoCobroTipo.afectador = 'S';
        wijmo_1.Control.invalidateAll();
    };
    PerfilesAutoCobrosTiposEditor.prototype.onChangeResta = function (args) {
        this.bSuma = false;
        this.perfilAutoCobroTipo.afectador = 'R';
        wijmo_1.Control.invalidateAll();
    };
    var PerfilesAutoCobrosTiposEditor_1;
    PerfilesAutoCobrosTiposEditor = PerfilesAutoCobrosTiposEditor_1 = __decorate([
        core_1.Component({
            selector: 'credito-perfil-auto-cobro-tipo-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'PerfilAutoCobroTipo'\"\n                                 [info]=\"perfilAutoCobroTipo\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"perfilAutoCobroTipo.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"perfilAutoCobroTipo.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n\n\n                                      <azteca-form-field [label]=\"'Codigo Referencia:'\">\n                                          <az-textbox formControlName=\"codigoReferencia\" [(ngModel)]=\"perfilAutoCobroTipo.codigoReferencia\"></az-textbox>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Cantidad:'\">\n                                          <az-input-number formControlName=\"cantidad\" [(ngModel)]=\"perfilAutoCobroTipo.cantidad\" format=\"'n4'\"></az-input-number>\n                                          <az-checkbox [label]=\"'Porcentaje'\" formControlName=\"porcentaje\" [(ngModel)]=\"perfilAutoCobroTipo.porcentaje\"></az-checkbox>\n                                      </azteca-form-field>\n\n\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-3 col-md-3\">\n                                      <az-checkbox [label]=\"'Suma +'\" formControlName=\"bSuma\" [(ngModel)]=\"bSuma\" (checkedChanged)=\"onChangeSuma($event)\"></az-checkbox>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-3 col-md-3\">\n                                      <az-checkbox [label]=\"'Resta -'\" formControlName=\"bResta\" [(ngModel)]=\"bResta\" (checkedChanged)=\"onChangeResta($event)\"></az-checkbox>\n                                  </div>\n                              </div>\n\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return PerfilesAutoCobrosTiposEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: perfil_auto_cobro_tipo_service_1.PerfilAutoCobroTipoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, perfil_auto_cobro_tipo_service_1.PerfilAutoCobroTipoService])
    ], PerfilesAutoCobrosTiposEditor);
    return PerfilesAutoCobrosTiposEditor;
}(editors_1.CatalogEditor));
exports.PerfilesAutoCobrosTiposEditor = PerfilesAutoCobrosTiposEditor;
