"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//Locales
var deudor_service_1 = require("../services/deudor.service");
var DeudoresBloqueadosComponent = /** @class */ (function (_super) {
    __extends(DeudoresBloqueadosComponent, _super);
    function DeudoresBloqueadosComponent(context, router, route, formBuilder, deudorService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.deudorService = deudorService;
        _this.collectionView = new wijmo_1.CollectionView();
        _this.form = formBuilder.group({
            'fecha': [new Date()],
        });
        _this.fecha = new Date();
        _this.form.controls['fecha'].valueChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.collectionView.sourceCollection = []; });
        });
        return _this;
    }
    DeudoresBloqueadosComponent.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'CONSULTAR') {
            this.loadBloqueados();
        }
    };
    DeudoresBloqueadosComponent.prototype.loadBloqueados = function () {
        var _this = this;
        this.deudorService.loadBloqueados(this.context.app.defaultCompany.identity, this.fecha)
            .then(function (result) {
            _this.collectionView.sourceCollection = result;
            //this.totalRows = result.totalRows;
            //this.pageIndex = request.pageIndex;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DeudoresBloqueadosComponent.prototype.onMenuSeleccionadosClicked = function (menu, args) {
        var _this = this;
        if (menu.selectedIndex == 0) {
            //Eliminar                     
            var deudor = this.collectionView.currentItem;
            this.deudorService.desbloquear(deudor.id, this.fecha)
                .then(function (result) {
                _this.collectionView.remove(_this.collectionView.currentItem);
                _this.context.app.hideSpinner();
                _this.alerts.showAlert('El deudor ha sido desbloqueado correctamente', 'success');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    //Implementacion de politicas
    DeudoresBloqueadosComponent.prototype.applyPolicy = function (policy) {
    };
    DeudoresBloqueadosComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], DeudoresBloqueadosComponent.prototype, "alerts", void 0);
    DeudoresBloqueadosComponent = __decorate([
        core_1.Component({
            selector: 'credit-deudores-bloqueados',
            template: "\n      <form [formGroup]=\"form\">\n          <alerts-bar></alerts-bar>\n\n          <div class=\"form-inline\">\n              <div class=\"form-group\">\n                  <label for=\"fechaInicial\">Fecha: </label>\n                  <az-input-date id=\"fecha\" style=\"padding: .5rem .75rem;\" formControlName=\"fecha\" [(ngModel)]=\"fecha\"></az-input-date>\n              </div>\n\n              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                  <az-toolbar-button [name]=\"'CONSULTAR'\" [type]=\"'primary'\" [text]=\"'Consultar'\" [toolTip]=\"'Consultar'\" [icon]=\"'glyphicon glyphicon-search'\" [enabled]=\"true\"></az-toolbar-button>\n              </az-toolbar>\n\n              <!--<az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                  <az-toolbar-button [name]=\"'GENERAR'\" [type]=\"'primary'\" [text]=\"'Generar archivo'\" [toolTip]=\"'Generar archivo'\" [icon]=\"'glyphicon glyphicon-save-file'\" [enabled]=\"true\"></az-toolbar-button>\n              </az-toolbar>-->\n\n\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <wj-flex-grid #grid style=\"height:550px\"\n                                [itemsSource]=\"collectionView\"\n                                [wjContextMenu]=\"ctxMenu\"\n                                [isReadOnly]=\"true\">\n                      <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                      <wj-flex-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'40*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Sucursal'\" [binding]=\"'sucursal'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Estatus'\" [binding]=\"'estatus'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                  </wj-flex-grid>\n              </div>\n          </div>\n\n\n          <!--<download-popup></download-popup>-->\n          <wj-menu #ctxMenu (itemClicked)=\"onMenuSeleccionadosClicked(ctxMenu, $event)\" style=\"display:none\">\n              <wj-menu-item>\n                  <span class=\"glyphicon glyphicon-trash\"></span><b> Desbloquear</b>\n                  <br />\n                  <small><i>desbloquear deudor</i></small>\n              </wj-menu-item>\n          </wj-menu>\n\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, deudor_service_1.DeudorService])
    ], DeudoresBloqueadosComponent);
    return DeudoresBloqueadosComponent;
}(core_2.ProcessComponent));
exports.DeudoresBloqueadosComponent = DeudoresBloqueadosComponent;
