import { FormGroup, FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { CollectionView } from 'wijmo/wijmo';
import { AlertsBarComponent, ToolbarButton } from 'framework3/controls';
import { Context } from 'framework3/core';
import { ComprobanteFiscalService } from '../../accounting/services/comprobante-fiscal.service';
import { ModificarAddendaEditor } from '../controls/modificar-addenda.component';
import { CuentaPorCobrarService } from '../services/cuenta-por-cobrar.service';
import { WjFlexGrid } from 'wijmo/wijmo.angular2.grid';
import { Confirmacion } from '../parts/confirmacion.component';
export declare class EnvioComprobantesFiscalesComponent {
    private formBuilder;
    private router;
    private route;
    private context;
    private comprobanteFiscalService;
    private cuentaPorCobrarService;
    form: FormGroup;
    comprobantesDestinosCollection: CollectionView;
    comprobantesList: EnvioComprobantesItem[];
    alertsBar: AlertsBarComponent;
    modificarAddendaDialog: ModificarAddendaEditor;
    gridComprobantes: WjFlexGrid;
    confirma: Confirmacion;
    constructor(formBuilder: FormBuilder, router: Router, route: ActivatedRoute, context: Context, comprobanteFiscalService: ComprobanteFiscalService, cuentaPorCobrarService: CuentaPorCobrarService);
    busquedaComprobantes(): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    modificarAddendaOpenDialog(comprobantes: EnvioComprobantesItem): void;
    mostrarError(error: string): void;
    handleError(error: any): void;
    getStatusColor(status: string): string;
    onModificarAddenda(args: EnvioComprobantesItem): void;
    onReemplazarAddenda(addenda: string): void;
}
export declare class EnvioComprobantesItem {
    id: number;
    idJob: number;
    fechaComprobantes: Date;
    uuid: string;
    serie: string;
    folio: string;
    razonSocial: string;
    status: string;
    completado: boolean;
    modificaAddenda: boolean;
    ordenCompra: string;
    fechaOrdenCompra: Date;
    numRemision: string;
    fechaRemision: Date;
    fechaEntrega: Date;
    idCuentaPorCobrarTit: string;
    selected?: boolean;
    idComprobanteDestino: number;
}
export declare class ResetComprobantesItem {
    idComprobante: string;
    idJob: number;
    idComprobanteDestino: number;
}
