"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Framework
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
var moment = require("moment");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Feature
var controls_1 = require("framework3/controls");
var core_2 = require("framework3/core");
var comprobante_fiscal_service_1 = require("../../accounting/services/comprobante-fiscal.service");
var modificar_addenda_component_1 = require("../controls/modificar-addenda.component");
var cuenta_por_cobrar_service_1 = require("../services/cuenta-por-cobrar.service");
var wijmo_angular2_grid_1 = require("wijmo/wijmo.angular2.grid");
var confirmacion_component_1 = require("../parts/confirmacion.component");
var EnvioComprobantesFiscalesComponent = /** @class */ (function () {
    function EnvioComprobantesFiscalesComponent(formBuilder, router, route, context, comprobanteFiscalService, cuentaPorCobrarService) {
        this.formBuilder = formBuilder;
        this.router = router;
        this.route = route;
        this.context = context;
        this.comprobanteFiscalService = comprobanteFiscalService;
        this.cuentaPorCobrarService = cuentaPorCobrarService;
        this.comprobantesDestinosCollection = new wijmo_1.CollectionView();
        this.comprobantesList = [];
        this.form = this.formBuilder.group({
            'fechaBusquedaInicial': [],
            'fechaBusquedaFinal': []
        });
    }
    EnvioComprobantesFiscalesComponent.prototype.busquedaComprobantes = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobantesDestinosCollection.sourceCollection = [];
        this.comprobantesDestinosCollection.refresh();
        var fechaIni = moment(this.form.controls.fechaBusquedaInicial.value).startOf('day').toDate();
        var fechaFin = moment(this.form.controls.fechaBusquedaFinal.value).endOf('day').toDate();
        this.comprobanteFiscalService.getEnvioFacturas(this.context.app.defaultCompany.identity, fechaIni, fechaFin)
            .then(function (comprobantes) {
            _this.context.app.hideSpinner();
            comprobantes.forEach(function (x) {
                x.selected = false;
                x.fechaComprobantes = moment(x.fechaComprobantes).toDate();
            });
            _this.comprobantesList = comprobantes;
            _this.comprobantesDestinosCollection.sourceCollection = _this.comprobantesList;
            _this.comprobantesDestinosCollection.collectionChanged.addHandler(function (collectionChanged) {
                _this.gridComprobantes.rows.forEach(function (row) {
                    if (row.dataItem['completado'] == true) {
                        row.isReadOnly = false;
                    }
                });
            });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EnvioComprobantesFiscalesComponent.prototype.onToolbarButtonClick = function (button) {
        var _this = this;
        if (button.name == 'SEARCHCOMPROBANTES') {
            this.busquedaComprobantes();
        }
        if (button.name == 'RESENDCOMPROBANTES') {
            try {
                this.context.app.showSpinner();
                var jobs_1 = [];
                this.comprobantesList.filter(function (x) { return x.selected; }).forEach(function (x) {
                    var job = new ResetComprobantesItem();
                    job.idComprobante = x.id.toString();
                    job.idComprobanteDestino = x.idComprobanteDestino;
                    job.idJob = x.idJob;
                    jobs_1.push(job);
                });
                if (jobs_1.length > 0 && jobs_1 != undefined) {
                    this.comprobanteFiscalService.resetEnvioFacturas(jobs_1)
                        .then(function (x) {
                        _this.busquedaComprobantes();
                        _this.alertsBar.showAlert('Se ha reiniciado el proceso de envió correctamente', 'success');
                    })
                        .catch(function (error) { return _this.handleError(error); });
                }
                else {
                    this.alertsBar.showAlert('No se ha seleccionado ningún comprobante', 'info');
                }
            }
            finally {
                this.context.app.hideSpinner();
            }
        }
    };
    EnvioComprobantesFiscalesComponent.prototype.modificarAddendaOpenDialog = function (comprobantes) {
        this.modificarAddendaDialog.data = comprobantes;
        this.modificarAddendaDialog.show();
    };
    EnvioComprobantesFiscalesComponent.prototype.mostrarError = function (error) {
        this.confirma.show(1, error);
    };
    EnvioComprobantesFiscalesComponent.prototype.handleError = function (error) {
        console.error(error);
        var message = this.context.getExceptionMessage(error);
        this.alertsBar.showAlert(message, 'danger');
        this.context.app.hideSpinner();
    };
    EnvioComprobantesFiscalesComponent.prototype.getStatusColor = function (status) {
        if (status == 'Error al enviar')
            return '#ff471a';
        if (status == 'Programado')
            return '#ff9900';
        if (status == 'Enviado')
            return 'green';
    };
    EnvioComprobantesFiscalesComponent.prototype.onModificarAddenda = function (args) {
        var _this = this;
        this.cuentaPorCobrarService.modificarAddenda(args)
            .then(function (x) {
            if (x.length == 1) {
                _this.cuentaPorCobrarService.generarAddendaCustom(x[0].idPedidoTit, x[0].fechaPedido, x[0].origen)
                    .then(function (x) {
                })
                    .catch(function (error) { return _this.handleError(error); });
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EnvioComprobantesFiscalesComponent.prototype.onReemplazarAddenda = function (addenda) {
        var _this = this;
        var addd = [];
        addd[0] = addenda;
        this.comprobanteFiscalService.reemplazaAddenda(this.modificarAddendaDialog.data.id.toString(), addd)
            .then(function (x) {
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], EnvioComprobantesFiscalesComponent.prototype, "alertsBar", void 0);
    __decorate([
        core_1.ViewChild(modificar_addenda_component_1.ModificarAddendaEditor),
        __metadata("design:type", modificar_addenda_component_1.ModificarAddendaEditor)
    ], EnvioComprobantesFiscalesComponent.prototype, "modificarAddendaDialog", void 0);
    __decorate([
        core_1.ViewChild('gridComprobantes'),
        __metadata("design:type", wijmo_angular2_grid_1.WjFlexGrid)
    ], EnvioComprobantesFiscalesComponent.prototype, "gridComprobantes", void 0);
    __decorate([
        core_1.ViewChild(confirmacion_component_1.Confirmacion),
        __metadata("design:type", confirmacion_component_1.Confirmacion)
    ], EnvioComprobantesFiscalesComponent.prototype, "confirma", void 0);
    EnvioComprobantesFiscalesComponent = __decorate([
        core_1.Component({
            selector: 'credit-envio-comprobantes-fiscales',
            template: "\n      <form [formGroup]=\"form\">\n          <alerts-bar></alerts-bar>\n\n          <div class=\"row justify-content-center\">\n              <div class=\"col-12\">\n                  <az-panel [header]=\"''\">\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <label class=\"control-label\">Fecha de Busqueda Inicial:</label>\n                              <az-input-date formControlName=\"fechaBusquedaInicial\"></az-input-date>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <label class=\"control-label\">Fecha de Busqueda Final:</label>\n                              <az-input-date formControlName=\"fechaBusquedaFinal\"></az-input-date>\n                          </div>\n                      </div>\n\n                      <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                          <az-toolbar-button [name]=\"'SEARCHCOMPROBANTES'\" [type]=\"'primary'\" [text]=\"'Actualizar'\" [icon]=\"'glyphicon glyphicon-refresh'\"></az-toolbar-button>\n                          <az-toolbar-button [name]=\"'RESENDCOMPROBANTES'\" [type]=\"'success'\" [text]=\"'Re-programar Envio'\" [icon]=\"'glyphicon glyphicon-send'\"></az-toolbar-button>\n                      </az-toolbar>\n\n                      <div class=\"row\">\n                          <wj-flex-grid #gridComprobantes style=\"height:550px\"\n                                        [itemsSource]=\"comprobantesDestinosCollection\">\n                              <wj-flex-grid-filter></wj-flex-grid-filter>\n\n                              <wj-flex-grid-column [header]=\"' '\" [binding]=\"'selected'\" [width]=\"'3*'\" [isReadOnly]=\"false\" [align]=\"'center'\" [dataType]='Boolean'></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'IdComprobante'\" [binding]=\"'id'\" [width]=\"'13*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'Fecha del Comprobante'\" [binding]=\"'fechaComprobantes'\" [width]=\"'11*'\" [isReadOnly]=\"true\" format=\"dd-MM-yyyy\"></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'UUID'\" [binding]=\"'uuid'\" [width]=\"'22*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"'4*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"'6*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'Codigo Cliente'\" [binding]=\"'codigoCliente'\" [width]=\"'6*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'Razon Social'\" [binding]=\"'razonSocial'\" [width]=\"'25*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'Monto'\" [binding]=\"'monto'\" [width]=\"'6*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'Estatus'\" [binding]=\"'status'\" [width]=\"'10*'\" [isReadOnly]=\"true\">\n                                  <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                      <div [ngStyle]=\"{'background-color': getStatusColor(cell.item.status), 'color': 'white'}\">\n                                          {{cell.item.status}}\n                                      </div>\n                                  </ng-template>\n                              </wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"''\" [width]=\"'11*'\" [isReadOnly]=\"true\" [align]=\"'center'\">\n                                  <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                      <button type=\"button\" class=\"btn btn-outline-secondary btn-sm\" (click)=\"modificarAddendaOpenDialog(cell.item)\" [disabled]=\"false\">Modificar Addenda</button>\n                                  </ng-template>\n                              </wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'IdJob'\" [binding]=\"'idJob'\" [width]=\"'1*'\" [isReadOnly]=\"true\" [visible]=\"false\"></wj-flex-grid-column>\n\n                              <wj-flex-grid-column [header]=\"''\" [width]=\"'11*'\" [isReadOnly]=\"true\" [align]=\"'center'\">\n                                  <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                      <button type=\"button\" class=\"btn btn-info btn-sm\" (click)=\"mostrarError(cell.item.mensajeError)\" [disabled]=\"false\">Ver error</button>\n                                  </ng-template>\n                              </wj-flex-grid-column>\n\n                          </wj-flex-grid>\n                      </div>\n                  </az-panel>\n              </div>\n          </div>\n\n          <!--<modificar-addenda (dataUpdater)=\"onModificarAddenda($event)\">\n\n          </modificar-addenda>-->\n\n          <modificar-addenda (dataUpdater)=\"onReemplazarAddenda($event)\">\n\n          </modificar-addenda>\n\n\n          <confirmacion-err (aceptado)=\"onConfirmar($event)\">    </confirmacion-err>\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute, core_2.Context,
            comprobante_fiscal_service_1.ComprobanteFiscalService, cuenta_por_cobrar_service_1.CuentaPorCobrarService])
    ], EnvioComprobantesFiscalesComponent);
    return EnvioComprobantesFiscalesComponent;
}());
exports.EnvioComprobantesFiscalesComponent = EnvioComprobantesFiscalesComponent;
var EnvioComprobantesItem = /** @class */ (function () {
    function EnvioComprobantesItem() {
    }
    return EnvioComprobantesItem;
}());
exports.EnvioComprobantesItem = EnvioComprobantesItem;
var ResetComprobantesItem = /** @class */ (function () {
    function ResetComprobantesItem() {
    }
    return ResetComprobantesItem;
}());
exports.ResetComprobantesItem = ResetComprobantesItem;
