"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
//
var core_2 = require("framework3/core");
var document_selector_1 = require("framework3/search/models/document-selector");
//
var deposito_1 = require("../models/deposito");
var deposito_service_1 = require("../services/deposito.service");
var DepositosSelectorComponent = /** @class */ (function (_super) {
    __extends(DepositosSelectorComponent, _super);
    function DepositosSelectorComponent(context, depositoService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.depositoService = depositoService;
        _this.selectedItem = new deposito_1.DepositoInfo;
        _this.idWorflowStep = 0;
        //
        _this.selectedItemChanged = new core_1.EventEmitter();
        _this.keywordSearchSource = rxjs_1.Observable.create(function (observer) {
            observer.next(_this.innerSelector.displayValue);
        })
            .pipe(operators_1.mergeMap(function (keyword) { return _this.findAnticipos(keyword); }));
        return _this;
    }
    DepositosSelectorComponent_1 = DepositosSelectorComponent;
    DepositosSelectorComponent.prototype.loadItem = function (itemID) {
        var _this = this;
        if (itemID != '') {
            this.depositoService.getDetail(itemID)
                .then(function (info) {
                _this.selectedItem = info;
                _this.displayValue = info.identity + '-' + info.fechaSys;
                _this.selectedItemChanged.emit(_this.selectedItem);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.selectedItem = null;
            this.displayValue = "";
            this.selectedItemChanged.emit(null);
        }
    };
    DepositosSelectorComponent.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        if (this.idWorflowStep > 0) {
            var condiciones = { field: "idWorkflowStep", operator: "=", valueType: "int", value: this.idWorflowStep.toString() };
            request.conditions.push(condiciones);
        }
        this.depositoService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.depositos = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DepositosSelectorComponent.prototype.findAnticipos = function (keyword) {
        return this.depositoService.searchKeyword(this.context.app.defaultSite.identity, keyword);
    };
    DepositosSelectorComponent.prototype.onKeywordSearch = function (keyword) {
        this.markUnselected();
    };
    var DepositosSelectorComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], DepositosSelectorComponent.prototype, "idWorflowStep", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], DepositosSelectorComponent.prototype, "selectedItemChanged", void 0);
    DepositosSelectorComponent = DepositosSelectorComponent_1 = __decorate([
        core_1.Component({
            selector: 'credit-depositos-selector',
            template: "\n      <azteca-document-selector [displayValue]=\"displayValue\"\n                                [selectedItem]=\"selectedItem\"\n                                [pageSize]=\"pageSize\"\n                                [enabled]=\"enabled\"\n                                [visible]=\"visible\"\n                                [dataSource]=\"keywordSearchSource\"\n                                [documentList]=\"depositos\"\n                                (selectedItemChanged)=\"itemChangedHandler($event)\"\n                                (keywordSearch)=\"onKeywordSearch($event)\"\n                                (searchRequested)=\"doSearch($event)\">\n\n          <azteca-grid-column [header]=\"'ID'\" [binding]=\"'id'\" [width]=\"'3*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'1*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'4*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'monto'\" [width]=\"'2*'\"></azteca-grid-column>\n\n      </azteca-document-selector>\n    ",
            providers: [{
                    provide: core_2.BaseComponent,
                    useExisting: core_1.forwardRef(function () { return DepositosSelectorComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return DepositosSelectorComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [core_2.Context, deposito_service_1.DepositoService])
    ], DepositosSelectorComponent);
    return DepositosSelectorComponent;
}(document_selector_1.DocumentSelector));
exports.DepositosSelectorComponent = DepositosSelectorComponent;
