"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
//
var core_2 = require("framework3/core");
var document_selector_1 = require("framework3/search/models/document-selector");
//
var factura_1 = require("../models/factura");
var factura_service_1 = require("../services/factura.service");
var FacturaSelectorComponent = /** @class */ (function (_super) {
    __extends(FacturaSelectorComponent, _super);
    function FacturaSelectorComponent(context, facturaService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.facturaService = facturaService;
        _this.selectedItem = new factura_1.FacturaInfo;
        _this.idDeudor = 0;
        _this.idGrupoDeudor = 0;
        //
        _this.selectedItemChanged = new core_1.EventEmitter();
        _this.keywordSearchSource = rxjs_1.Observable.create(function (observer) {
            observer.next(_this.innerSelector.displayValue);
        })
            .pipe(operators_1.mergeMap(function (keyword) { return _this.findFacturas(keyword); }));
        return _this;
    }
    FacturaSelectorComponent_1 = FacturaSelectorComponent;
    FacturaSelectorComponent.prototype.loadItem = function (itemID) {
        var _this = this;
        if (itemID != '') {
            this.facturaService.getDetail(itemID)
                .then(function (info) {
                _this.selectedItem = info;
                _this.displayValue = info.comprobante.serie + '-' + info.comprobante.folio;
                _this.selectedItemChanged.emit(_this.selectedItem);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.selectedItem = null;
            this.displayValue = "";
            this.selectedItemChanged.emit(null);
        }
    };
    FacturaSelectorComponent.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        var condiciones = { field: "idDeudor", operator: "=", valueType: "int", value: this.idDeudor.toString() };
        request.conditions.push(condiciones);
        this.facturaService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.factura = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FacturaSelectorComponent.prototype.findFacturas = function (keyword) {
        return this.facturaService.searchKeyword(this.context.app.defaultSite.identity, keyword, this.idDeudor, this.idGrupoDeudor);
    };
    FacturaSelectorComponent.prototype.onKeywordSearch = function (keyword) {
        this.markUnselected();
    };
    var FacturaSelectorComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], FacturaSelectorComponent.prototype, "idDeudor", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], FacturaSelectorComponent.prototype, "idGrupoDeudor", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], FacturaSelectorComponent.prototype, "selectedItemChanged", void 0);
    FacturaSelectorComponent = FacturaSelectorComponent_1 = __decorate([
        core_1.Component({
            selector: 'credit-facturas-selector',
            template: "\n      <azteca-document-selector [displayValue]=\"displayValue\"\n                                [selectedItem]=\"selectedItem\"\n                                [pageSize]=\"pageSize\"\n                                [enabled]=\"enabled\"\n                                [visible]=\"visible\"\n                                [dataSource]=\"keywordSearchSource\"\n                                (selectedItemChanged)=\"itemChangedHandler($event)\"\n                                (keywordSearch)=\"onKeywordSearch($event)\">\n\n      </azteca-document-selector>\n    ",
            providers: [{
                    provide: core_2.BaseComponent,
                    useExisting: core_1.forwardRef(function () { return FacturaSelectorComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return FacturaSelectorComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [core_2.Context, factura_service_1.FacturaService])
    ], FacturaSelectorComponent);
    return FacturaSelectorComponent;
}(document_selector_1.DocumentSelector));
exports.FacturaSelectorComponent = FacturaSelectorComponent;
