"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Angular
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Framework 3
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var envio_comprobantes_fiscales_component_1 = require("../components/envio-comprobantes-fiscales.component");
var comprobante_fiscal_service_1 = require("../../accounting/services/comprobante-fiscal.service");
require("brace/theme/chrome");
require("brace/mode/xml");
require("brace/worker/xml");
var ModificarAddendaEditor = /** @class */ (function (_super) {
    __extends(ModificarAddendaEditor, _super);
    function ModificarAddendaEditor(comprobanteFiscalService, context, formBuilder, router, route, changeDetectorRef) {
        var _this = _super.call(this, context, router, route, changeDetectorRef) || this;
        _this.comprobanteFiscalService = comprobanteFiscalService;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.router = router;
        _this.route = route;
        _this.changeDetectorRef = changeDetectorRef;
        _this.envioComprobantesItem = new envio_comprobantes_fiscales_component_1.EnvioComprobantesItem();
        _this.textAdenda = "";
        //Inputs
        _this.data = new envio_comprobantes_fiscales_component_1.EnvioComprobantesItem();
        _this.dataUpdater = new core_1.EventEmitter();
        _this.editorForm = formBuilder.group({
            'orden': ['', forms_1.Validators.maxLength(32)],
            'fechaOrden': [''],
            'remision': ['', forms_1.Validators.maxLength(32)],
            'fechaRemision': [''],
            'fechaEntrega': [''],
            'addenda': ['']
        });
        return _this;
    }
    ModificarAddendaEditor_1 = ModificarAddendaEditor;
    ModificarAddendaEditor.prototype.show = function () {
        this.dialog.config.backdrop = false;
        this.obtenerAddenda();
        this.dialog.show();
        wijmo_1.Control.invalidateAll();
    };
    ModificarAddendaEditor.prototype.obtenerAddenda = function () {
        var _this = this;
        this.comprobanteFiscalService.getAddenda(this.data.id.toString())
            .then(function (doc) {
            _this.textAdenda = doc.toString();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ModificarAddendaEditor.prototype.onUpdate = function () {
        this.dataUpdater.emit(this.textAdenda);
        this.dialog.hide();
    };
    var ModificarAddendaEditor_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", envio_comprobantes_fiscales_component_1.EnvioComprobantesItem)
    ], ModificarAddendaEditor.prototype, "data", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ModificarAddendaEditor.prototype, "dataUpdater", void 0);
    __decorate([
        core_1.ViewChild('dialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ModificarAddendaEditor.prototype, "dialog", void 0);
    ModificarAddendaEditor = ModificarAddendaEditor_1 = __decorate([
        core_1.Component({
            selector: 'modificar-addenda',
            template: "\n      <form [formGroup]=\"editorForm\">\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h4 class=\"modal-title\">Modificaci\u00F3n de los datos de la addenda</h4>\n                      </div>\n                      <div class=\"modal-body\">\n                          <!--\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field [label]=\"'Orden de compra:'\">\n                      <az-textbox formControlName=\"orden\" [(ngModel)]=\"data.ordenCompra\"></az-textbox>\n                  </azteca-form-field>\n              </div>\n          </div>\n          <div class=\"row\">\n              <div class=\"col-6\">\n                  <label class=\"control-label\">Fecha de la orden de compra:</label>\n                  <az-input-date formControlName=\"fechaOrden\" [(ngModel)]=\"data.fechaOrdenCompra\"></az-input-date>\n              </div>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field [label]=\"'Numero de remisi\u00F3n:'\">\n                      <az-textbox formControlName=\"remision\" [(ngModel)]=\"data.numRemision\"></az-textbox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-6\">\n                  <label class=\"control-label\">Fecha de la remisi\u00F3n:</label>\n                  <az-input-date formControlName=\"fechaRemision\" [(ngModel)]=\"data.fechaRemision\"></az-input-date>\n              </div>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-6\">\n                  <label class=\"control-label\">Fecha de entrega:</label>\n                  <az-input-date formControlName=\"fechaEntrega\" [(ngModel)]=\"data.fechaEntrega\"></az-input-date>\n              </div>\n          </div>\n          -->\n                          <az-code-editor formControlName=\"addenda\" \n                                          [language]=\"'xml'\" \n                                          [theme]=\"'chrome'\" \n                                          [(ngModel)]=\"textAdenda\">\n                          </az-code-editor>\n\n                      </div>\n\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Cancelar</button>\n                      </div>\n                  </div>\n              </div>\n          </div>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ModificarAddendaEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: comprobante_fiscal_service_1.ComprobanteFiscalService
                }
            ]
        }),
        __metadata("design:paramtypes", [comprobante_fiscal_service_1.ComprobanteFiscalService, core_2.Context, forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute,
            core_1.ChangeDetectorRef])
    ], ModificarAddendaEditor);
    return ModificarAddendaEditor;
}(editors_1.CatalogEditor));
exports.ModificarAddendaEditor = ModificarAddendaEditor;
