"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//////////////////////////// Guards //////////////////////////////////
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//////////////////////////// Catalogos ////////////////////////////////
var cajas_manager_1 = require("./catalogs/cajas.manager");
var cajas_editor_1 = require("./catalogs/cajas.editor");
var cajeros_manager_1 = require("./catalogs/cajeros.manager");
var cajeros_editor_1 = require("./catalogs/cajeros.editor");
var grupos_deudores_manager_1 = require("./catalogs/grupos-deudores.manager");
var grupos_deudores_editor_1 = require("./catalogs/grupos-deudores.editor");
var deudores_manager_1 = require("./catalogs/deudores.manager");
var deudores_editor_1 = require("./catalogs/deudores.editor");
var formas_pago_manager_1 = require("./catalogs/formas-pago.manager");
var formas_pago_editor_1 = require("./catalogs/formas-pago.editor");
var empresas_manager_1 = require("./catalogs/empresas.manager");
var empresas_editor_1 = require("./catalogs/empresas.editor");
var sucursales_manager_1 = require("./catalogs/sucursales.manager");
var sucursales_editor_1 = require("./catalogs/sucursales.editor");
var notas_tipos_manager_1 = require("./catalogs/notas-tipos.manager");
var notas_tipos_editor_1 = require("./catalogs/notas-tipos.editor");
var depositos_tipos_manager_1 = require("./catalogs/depositos-tipos.manager");
var depositos_tipos_editor_1 = require("./catalogs/depositos-tipos.editor");
var perfiles_auto_cobros_tipos_manager_1 = require("./catalogs/perfiles-auto-cobros-tipos.manager");
var perfiles_auto_cobros_tipos_editor_1 = require("./catalogs/perfiles-auto-cobros-tipos.editor");
///////////////////////////// Document /////////////////////////////////
var cuentas_por_cobrar_editor_1 = require("./documents/cuentas-por-cobrar.editor");
var cuentas_por_cobrar_manager_1 = require("./documents/cuentas-por-cobrar.manager");
var cobranzas_editor_1 = require("./documents/cobranzas.editor");
var cobranzas_manager_1 = require("./documents/cobranzas.manager");
var anticipos_editor_1 = require("./documents/anticipos.editor");
var anticipos_manager_1 = require("./documents/anticipos.manager");
var notas_editor_1 = require("./documents/notas.editor");
var notas_manager_1 = require("./documents/notas.manager");
var depositos_editor_1 = require("./documents/depositos.editor");
var depositos_manager_1 = require("./documents/depositos.manager");
///////////////////////////// Components /////////////////////////////////
var facturacion_component_1 = require("./documents/parts/facturacion.component");
var envio_comprobantes_fiscales_component_1 = require("./components/envio-comprobantes-fiscales.component");
var deudores_bloqueados_component_1 = require("./components/deudores-bloqueados.component");
//Parts//
var corte_component_1 = require("./parts/corte.component");
var caja_miembros_component_1 = require("./parts/caja-miembros.component");
///////////////////////////// Rutas /////////////////////////////////
var routes = [
    {
        path: '',
        canActivateChild: [core_2.AuthGuard],
        children: [
            { path: 'cajas/:proceso', component: cajas_manager_1.CajasManager },
            { path: 'cajas/:proceso/:id', component: cajas_editor_1.CajasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'cajas/:proceso/:id/members', component: caja_miembros_component_1.CajaMiembrosComponent },
            { path: 'cajeros/:proceso', component: cajeros_manager_1.CajerosManager },
            { path: 'cajeros/:proceso/:id', component: cajeros_editor_1.CajerosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'cortes/:proceso', component: corte_component_1.CorteComponent, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'gruposDeudores/:proceso', component: grupos_deudores_manager_1.GruposDeudoresManager },
            { path: 'gruposDeudores/:proceso/:id', component: grupos_deudores_editor_1.GruposDeudoresEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'deudores/:proceso', component: deudores_manager_1.DeudoresManager },
            { path: 'deudores/:proceso/:id', component: deudores_editor_1.DeudoresEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'formasPago/:proceso', component: formas_pago_manager_1.FormasPagoManager },
            { path: 'formasPago/:proceso/:id', component: formas_pago_editor_1.FormasPagoEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'empresas-credito/:proceso', component: empresas_manager_1.EmpresasManager },
            { path: 'empresas-credito/:proceso/:id', component: empresas_editor_1.EmpresasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'sucursales-credito/:proceso', component: sucursales_manager_1.SucursalesManager },
            { path: 'sucursales-credito/:proceso/:idEmpresa/:id', component: sucursales_editor_1.SucursalesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'envio-comprobantes-fiscales/:proceso', component: envio_comprobantes_fiscales_component_1.EnvioComprobantesFiscalesComponent },
            { path: 'notas-tipos/:proceso', component: notas_tipos_manager_1.NotasTiposManager },
            { path: 'notas-tipos/:proceso/:id', component: notas_tipos_editor_1.NotasTiposEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'depositos-tipos/:proceso', component: depositos_tipos_manager_1.DepositosTiposManager },
            { path: 'depositos-tipos/:proceso/:id', component: depositos_tipos_editor_1.DepositosTiposEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'perfil-auto-cobro-tipo/:proceso', component: perfiles_auto_cobros_tipos_manager_1.PerfilesAutoCobrosTiposManager },
            { path: 'perfil-auto-cobro-tipo/:proceso/:id', component: perfiles_auto_cobros_tipos_editor_1.PerfilesAutoCobrosTiposEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'deudores-bloqueados/:proceso', component: deudores_bloqueados_component_1.DeudoresBloqueadosComponent },
            //DOCUMENTS
            { path: 'cuentasPorCobrar/:proceso', component: cuentas_por_cobrar_manager_1.CuentasPorCobrarManager },
            { path: 'cuentasPorCobrar/:proceso/:id', component: cuentas_por_cobrar_editor_1.CuentasPorCobrarEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'facturacion/:proceso', component: facturacion_component_1.FacturacionComponent },
            { path: 'cobranza/:proceso', component: cobranzas_manager_1.CobranzasManager },
            { path: 'cobranza/:proceso/:id', component: cobranzas_editor_1.CobranzasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'anticipos/:proceso', component: anticipos_manager_1.AnticiposManager },
            { path: 'anticipos/:proceso/:id', component: anticipos_editor_1.AnticiposEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'notas/:proceso', component: notas_manager_1.NotasManager },
            { path: 'notas/:proceso/:id', component: notas_editor_1.NotasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'depositos/:proceso', component: depositos_manager_1.DepositosManager },
            { path: 'depositos/:proceso/:id', component: depositos_editor_1.DepositosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
        ]
    },
];
var CreditRoutingModule = /** @class */ (function () {
    function CreditRoutingModule() {
    }
    CreditRoutingModule = __decorate([
        core_1.NgModule({
            imports: [
                router_1.RouterModule.forChild(routes)
            ],
            exports: [
                router_1.RouterModule
            ]
        })
    ], CreditRoutingModule);
    return CreditRoutingModule;
}());
exports.CreditRoutingModule = CreditRoutingModule;
