"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Locales
var anticipo_1 = require("../models/anticipo");
var anticipo_detail_1 = require("../models/anticipo-detail");
var anticipo_service_1 = require("../services/anticipo.service");
var anticipos_detail_editor_1 = require("./parts/anticipos-detail.editor");
var forma_pago_service_1 = require("../services/forma-pago.service");
var empresa_service_1 = require("../services/empresa.service");
var empresa_1 = require("../models/empresa");
var empresa_service_2 = require("../../accounting/services/empresa.service");
var empresa_2 = require("../../accounting/models/empresa");
var credit_1 = require("../../credit");
var impuesto_service_1 = require("../../accounting/services/impuesto.service");
var impuesto_1 = require("../../accounting/models/impuesto");
var divisa_service_1 = require("../../accounting/services/divisa.service");
var divisa_1 = require("../../accounting/models/divisa");
var AnticiposEditor = /** @class */ (function (_super) {
    __extends(AnticiposEditor, _super);
    function AnticiposEditor(context, router, route, location, formBuilder, documentTypeService, anticipoService, formaPagoService, empresaService, empresaServiceCont, impuestoService, divisaService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.anticipoService = anticipoService;
        _this.formaPagoService = formaPagoService;
        _this.empresaService = empresaService;
        _this.empresaServiceCont = empresaServiceCont;
        _this.impuestoService = impuestoService;
        _this.divisaService = divisaService;
        _this.anticipo = new anticipo_1.AnticipoInfo();
        _this.empresa = new empresa_1.EmpresaInfo();
        _this.divisa = new divisa_1.DivisaInfo();
        _this.empresaCont = new empresa_2.EmpresaInfo();
        _this.impuesto = new impuesto_1.ImpuestoInfo();
        _this.formasPago = [];
        _this.busquedaTipos = [];
        _this.documentForm = formBuilder.group({
            'busqueda': ['', forms_1.Validators.required],
            'idDeudor': [0],
            'idGrupoDeudor': [0],
            'importe': [0, forms_1.Validators.required],
            'importeImpuesto': [0],
            'baseImpuesto': [0],
            'concepto': ['Anticipo del bien o servicio', forms_1.Validators.required],
            'idCaja': [0],
            'idFormaPago': [0, forms_1.Validators.required],
            'idBanco': [0],
            'cuenta': ['', forms_1.Validators.required]
        });
        _this.documentForm.controls.importe.valueChanges.subscribe(function (value) {
            _this.onImporteChanged(value);
        });
        _this.busquedaTipos =
            [
                { "id": "G", "nombre": "Grupo Deudor" },
                { "id": "D", "nombre": "Deudor" }
            ];
        return _this;
    }
    AnticiposEditor_1 = AnticiposEditor;
    AnticiposEditor.prototype.selectedBusqueda = function (item) {
        this.tipoBusqueda = item;
    };
    AnticiposEditor.prototype.onGrupoDeudorSelected = function (grupo) {
        this.idGrupoDeudor = grupo.identity;
    };
    AnticiposEditor.prototype.onDeudorSelected = function (deudor) {
        this.idDeudor = deudor.identity;
    };
    AnticiposEditor.prototype.onConfigureDocument = function (docType) {
        this.anticipo.concepto = 'Anticipo del bien o servicio';
        this.loadFormasPago();
        this.loadEmpresa();
        this.loadEmpresaCont();
        this.applyPolicies();
    };
    AnticiposEditor.prototype.onCreatingDocument = function () {
    };
    AnticiposEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.anticipoService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.anticipo = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AnticiposEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.anticipoService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.anticipo = doc;
            _this.detailsEditor.clientIndexStart = _this.anticipo.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AnticiposEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.anticipoService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.anticipo = doc;
            if (_this.anticipo.idDeudor > 0) {
                _this.tipoBusqueda = 'D';
            }
            if (_this.anticipo.idGrupoDeudor > 0) {
                _this.tipoBusqueda = 'G';
            }
            _this.detailsEditor.clientIndexStart = _this.anticipo.details.length;
            if (_this.anticipo.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AnticiposEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.anticipo.idCorte = this.selectorCaja.selectedItem.idCorteActual;
        this.anticipo.idImpuesto = this.empresa.idImpuestoAnticipos;
        this.anticipo.tasaOCuota = this.empresa.tasaOCuotaAnticipos;
        this.anticipo.tipoFactor = this.impuesto.factor;
        this.anticipoService.update(this.anticipo)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.anticipo.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.anticipo = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AnticiposEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.anticipoService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AnticiposEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.anticipoService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AnticiposEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.anticipo.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    AnticiposEditor.prototype.onAddingDetail = function () {
        this.detailsEditor.detail = new anticipo_detail_1.AnticipoDetail();
        this.detailsEditor.show();
    };
    AnticiposEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    AnticiposEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    AnticiposEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.anticipo.details = updatedDetails;
    };
    AnticiposEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    AnticiposEditor.prototype.loadFormasPago = function () {
        var _this = this;
        this.formaPagoService.loadList(this.context.app.defaultSite.identity)
            .then(function (formas) { return _this.formasPago = formas; })
            .catch(function (error) { return _this.handleError(error); });
    };
    AnticiposEditor.prototype.onImporteChanged = function (importe) {
        if (this.impuesto.factor == 'T') {
            this.anticipo.importeImpuesto = (importe * this.empresa.tasaOCuotaAnticipos) / (1 + this.empresa.tasaOCuotaAnticipos);
            this.sImporteImpuesto = this.anticipo.importeImpuesto.toString();
            this.anticipo.baseImpuesto = importe * (1 - this.empresa.tasaOCuotaAnticipos / (1 + this.empresa.tasaOCuotaAnticipos));
        }
        if (this.impuesto.factor == 'M') {
            this.anticipo.importeImpuesto = this.empresa.tasaOCuotaAnticipos;
            this.anticipo.baseImpuesto = importe - this.empresa.tasaOCuotaAnticipos;
        }
    };
    AnticiposEditor.prototype.loadEmpresa = function () {
        var _this = this;
        this.empresaService.getDetailByID(this.context.app.defaultCompany.idCompany)
            .then(function (doc) {
            _this.empresa = doc;
            _this.loadImpuesto(_this.empresa.idImpuestoAnticipos);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AnticiposEditor.prototype.loadDivisa = function (idDivisa) {
        var _this = this;
        this.divisaService.getDetailByID(idDivisa)
            .then(function (doc) {
            _this.divisa = doc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AnticiposEditor.prototype.loadEmpresaCont = function () {
        var _this = this;
        this.empresaServiceCont.getDetailByID(this.context.app.defaultCompany.idCompany)
            .then(function (doc) {
            _this.empresaCont = doc;
            _this.loadDivisa(_this.empresaCont.idDivisa);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AnticiposEditor.prototype.loadImpuesto = function (idImpuesto) {
        var _this = this;
        this.impuestoService.getDetailByID(idImpuesto)
            .then(function (doc) {
            _this.impuesto = doc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var AnticiposEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], AnticiposEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", anticipos_detail_editor_1.AnticipoDetailEditor)
    ], AnticiposEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild('selectorCaja'),
        __metadata("design:type", credit_1.CajasSelectorComponent)
    ], AnticiposEditor.prototype, "selectorCaja", void 0);
    __decorate([
        core_1.ViewChild('cboSegmento'),
        __metadata("design:type", controls_1.AzComboboxComponent)
    ], AnticiposEditor.prototype, "cboSegmento", void 0);
    AnticiposEditor = AnticiposEditor_1 = __decorate([
        core_1.Component({
            selector: 'credito-anticipos-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'Anticipos'\"\n                                         [document]=\"anticipo\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-10 col-md-8\">\n                                      <azteca-form-field [label]=\"'Aplica a:'\">\n                                          <az-combobox #cboSegmento\n                                                       formControlName=\"busqueda\"\n                                                       (selectedItemChanged)=\"selectedBusqueda($event)\"\n                                                       [items]=\"busquedaTipos\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-10 col-md-8\">\n                                      <azteca-form-field [label]=\"'Grupo deudor:'\" *ngIf=\"tipoBusqueda=='G'\">\n                                          <credit-grupo-deudores-selector formControlName=\"idGrupoDeudor\" [(ngModel)]=\"anticipo.idGrupoDeudor\" ngDefaultControl=\"\" (itemSelected)=\"onGrupoDeudorSelected($event)\"></credit-grupo-deudores-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-10 col-md-8\">\n                                      <azteca-form-field [label]=\"'Deudor:'\" *ngIf=\"tipoBusqueda=='D'\">\n                                          <credit-deudores-selector formControlName=\"idDeudor\" [(ngModel)]=\"anticipo.idDeudor\" ngDefaultControl=\"\" (itemSelected)=\"onDeudorSelected($event)\"></credit-deudores-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-5 col-md-4\">\n                                      <azteca-form-field [label]=\"'Forma de Pago:'\">\n                                          <az-combobox formControlName=\"idFormaPago\"\n                                                       [(ngModel)]=\"anticipo.idFormaPago\"\n                                                       [items]=\"formasPago\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-4\">\n                                              <azteca-form-field [label]=\"'Seleccionar banco:'\">\n                                                  <azteca-form-field [label]=\"Banco\">\n                                                      <accounting-banco-selector formControlName=\"idBanco\" [(ngModel)]=\"anticipo.idBanco\"></accounting-banco-selector>\n                                                  </azteca-form-field>\n                                              </azteca-form-field>\n                                          </div>\n                                          <div class=\"col-12 col-md-4\">\n                                              <azteca-form-field [label]=\"'Cuenta bancaria:'\">\n                                                  <az-textbox formControlName=\"cuenta\" [(ngModel)]=\"anticipo.cuenta\"></az-textbox>\n                                              </azteca-form-field>\n                                          </div>\n\n                                          <div class=\"col-12 col-md-4\">\n                                              <azteca-form-field [label]=\"'Seleccionar la caja:'\">\n                                                  <azteca-form-field [label]=\"Caja\">\n                                                      <credit-cajas-selector formControlName=\"idCaja\" [(ngModel)]=\"anticipo.idCaja\" #selectorCaja></credit-cajas-selector>\n                                                  </azteca-form-field>\n                                              </azteca-form-field>\n                                          </div>\n\n                                       </div>\n                                  </div>\n                               </div>\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-md-10\">\n                                          <div class=\"row\">\n                                              <div class=\"col-12 col-md-4\">\n                                                  <azteca-form-field [label]=\"'Importe:'\">\n                                                      <az-input-number formControlName=\"importe\" [(ngModel)]=\"anticipo.importe\" format=\"'n2'\"></az-input-number>\n                                                  </azteca-form-field>\n                                              </div>\n                                              <div class=\"col-12 col-md-4\">\n                                                  <azteca-form-field [label]=\"'Impuesto:'\">\n                                                      <az-input-number formControlName=\"importeImpuesto\" [(ngModel)]=\"anticipo.importeImpuesto\" format=\"'n2'\" [enabled]=\"false\"></az-input-number>\n                                                  </azteca-form-field>\n                                              </div>\n                                              <div class=\"col-12 col-md-4\">\n                                                  <azteca-form-field [label]=\"'Base impuesto:'\">\n                                                      <az-input-number formControlName=\"baseImpuesto\" [(ngModel)]=\"anticipo.baseImpuesto\" format=\"'n2'\" [enabled]=\"false\"></az-input-number>\n                                                  </azteca-form-field>\n                                              </div>\n                                          </div>\n                                      </div>\n                                  </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Concepto:'\">\n                                          <az-textbox formControlName=\"concepto\" [(ngModel)]=\"anticipo.concepto\" [enabled]=\"false\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n      </tab>\n\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <credito-anticipo-detail-editor #detailsEditor                                     \n                                           (savingItem)=\"onSavingDetail($event)\">\n\n      </credito-anticipo-detail-editor>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return AnticiposEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: anticipo_service_1.AnticipoService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            anticipo_service_1.AnticipoService,
            forma_pago_service_1.FormaPagoService,
            empresa_service_1.EmpresaService,
            empresa_service_2.EmpresaService,
            impuesto_service_1.ImpuestoService,
            divisa_service_1.DivisaService])
    ], AnticiposEditor);
    return AnticiposEditor;
}(editors_1.DocumentEditor));
exports.AnticiposEditor = AnticiposEditor;
