import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { CollectionView } from 'wijmo/wijmo';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { CobranzaInfo } from '../models/cobranza';
import { CobranzaDetail } from '../models/cobranza-detail';
import { CobranzaService } from '../services/cobranza.service';
import { CajaService } from '../services/caja.service';
import { CajaItem } from '../models/caja';
import { CobroTipoItem } from '../models/cobro-tipo';
import { CobroTipoService } from '../services/cobro-tipo.service';
import { CobranzaComponent } from '../parts/cobranza.component';
import { CobranzaFormaPagoDetail } from '../models/forma-pago-detail';
import { CobranzaDetailEditor } from './parts/cobranzas-detail.editor';
import { DepositoInfo } from '../models/deposito';
import { DepositoService } from '../services/deposito.service';
import { CuentaPorCobrarService } from '../services/cuenta-por-cobrar.service';
import { ModalDirective } from 'ngx-bootstrap';
export declare class CobranzasEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private cobranzaService;
    private cajaService;
    private cobroTipoService;
    private depositoService;
    private cuentasPorCobrarService;
    cobranza: CobranzaInfo;
    cajas: CajaItem[];
    cobrosTipos: CobroTipoItem[];
    acumulado: number;
    cuentasXCobrar: CollectionView;
    documentType: DocumentTypeInfo;
    argsEditorEvent: EditorEventArgs;
    argsCurrentDocument: WorkflowEventArgs;
    idDeudorDefault: number;
    idCuentaBeneficiario: number;
    deposito: DepositoInfo;
    formato: string;
    decimales: number;
    detailsList: EditableListComponent;
    detailsEditor: CobranzaDetailEditor;
    alerts: AlertsBarComponent;
    dialogDecimales: ModalDirective;
    dlgCobranza: CobranzaComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, cobranzaService: CobranzaService, cajaService: CajaService, cobroTipoService: CobroTipoService, depositoService: DepositoService, cuentasPorCobrarService: CuentaPorCobrarService);
    validateMontos(): string;
    validateMontos2(): string;
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: CobranzaDetail): void;
    onDeletingDetail(detail: CobranzaDetail): void;
    onSavingDetail(detail: CobranzaDetail): void;
    onDetailsLoaded(details: CobranzaDetail[]): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    cellEditEndingHandler(sender: any, e: any): void;
    onCellEditEnded(flex: any, e: any): void;
    keydown(grid: any, args: any, cell: any): void;
    loadCajas(): void;
    loadCobrosTipos(): void;
    calcularAcumulado(): void;
    showAlert(message: string, type: string): void;
    cobroAceptado(formasPagoCobro: CobranzaFormaPagoDetail): void;
    getStatusColor(vencimiento: Date): string;
    getStatusColorCancelacion(cancelacionPendinte: boolean): string;
    getCuentaBeneficiario(idDeposito: string): void;
    assignFormat(): void;
}
