"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Locales
var cobranza_1 = require("../models/cobranza");
var cobranza_detail_1 = require("../models/cobranza-detail");
var cobranza_service_1 = require("../services/cobranza.service");
var caja_service_1 = require("../services/caja.service");
var cobro_tipo_service_1 = require("../services/cobro-tipo.service");
//Cobranza
var cobranza_component_1 = require("../parts/cobranza.component");
var cobranzas_detail_editor_1 = require("./parts/cobranzas-detail.editor");
var deposito_1 = require("../models/deposito");
var deposito_service_1 = require("../services/deposito.service");
var cuenta_por_cobrar_service_1 = require("../services/cuenta-por-cobrar.service");
var ngx_bootstrap_1 = require("ngx-bootstrap");
var CobranzasEditor = /** @class */ (function (_super) {
    __extends(CobranzasEditor, _super);
    function CobranzasEditor(context, router, route, location, formBuilder, documentTypeService, cobranzaService, cajaService, cobroTipoService, depositoService, cuentasPorCobrarService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.cobranzaService = cobranzaService;
        _this.cajaService = cajaService;
        _this.cobroTipoService = cobroTipoService;
        _this.depositoService = depositoService;
        _this.cuentasPorCobrarService = cuentasPorCobrarService;
        _this.cobranza = new cobranza_1.CobranzaInfo();
        _this.cajas = [];
        _this.cobrosTipos = [];
        _this.acumulado = 0;
        _this.cuentasXCobrar = new wijmo_1.CollectionView();
        _this.idCuentaBeneficiario = 0;
        _this.deposito = new deposito_1.DepositoInfo();
        _this.formato = "C2";
        _this.decimales = 2;
        _this.documentForm = formBuilder.group({
            'caja': ['', forms_1.Validators.required],
            'idCobroTipo': ['', forms_1.Validators.required],
            'referenciaAlf': [''],
            'referenciaNum': [''],
            'observaciones': [''],
            //'monto': [''],
            'monto': ['0', function (_) { return _this.validateMontos(); }],
            'acumulado': ['0', function (_) { return _this.validateMontos2(); }]
        });
        return _this;
    }
    CobranzasEditor_1 = CobranzasEditor;
    CobranzasEditor.prototype.validateMontos = function () {
        console.log(this.cobranza.total + " " + this.acumulado);
        if (Math.abs(this.cobranza.total - this.acumulado) <= 0.001 && this.acumulado > 0)
            return null;
        else
            return 'No coincide el monto deseado con el monto acumulado.';
    };
    CobranzasEditor.prototype.validateMontos2 = function () {
        console.log(this.cobranza.total + " " + this.acumulado);
        if (Math.abs(this.cobranza.total - this.acumulado) <= 0.001 && this.acumulado > 0)
            return null;
        else
            return 'No coincide el monto deseado con el monto acumulado.';
    };
    CobranzasEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
        this.loadCajas();
        this.loadCobrosTipos();
        this.documentType = docType;
        this.deposito = new deposito_1.DepositoInfo();
    };
    CobranzasEditor.prototype.onCreatingDocument = function () {
        this.cobranza.fechaAfectacion = new Date();
    };
    CobranzasEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.cobranzaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.cobranza = doc;
            _this.cuentasXCobrar.sourceCollection = _this.cobranza.details;
            _this.calcularAcumulado();
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.cobranzaService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.cobranza = doc;
            _this.detailsEditor.clientIndexStart = _this.cobranza.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.cobranzaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.cobranza = doc;
            _this.cuentasXCobrar.sourceCollection = _this.cobranza.details;
            _this.calcularAcumulado();
            _this.detailsEditor.clientIndexStart = _this.cobranza.details.length;
            if (_this.cobranza.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        if (this.cuentasXCobrar.sourceCollection.filter(function (search) { return search.state == "MODIFIED" && search.cancelacionPendiente == true && search.importe > 0; }).length == 0) {
            this.context.app.showSpinner();
            this.cobranza.details = this.cuentasXCobrar.sourceCollection;
            if (this.cobranza.idCobroTipo == 0 || this.cobranza.idCobroTipo == undefined)
                this.cobranza.idCobroTipo = 1;
            var CuentasXCobrar = [];
            for (var _i = 0, _a = this.cuentasXCobrar.sourceCollection.filter(function (search) { return search.state == "MODIFIED"; }); _i < _a.length; _i++) {
                var cxc = _a[_i];
                CuentasXCobrar.push(cxc.idCuentaPorCobrarTit);
            }
            this.cuentasPorCobrarService.verficarComprobanteTimbrado(CuentasXCobrar)
                .then(function (Timbrado) {
                if (Timbrado) {
                    _this.argsEditorEvent = args;
                    //this.context.app.hideSpinner();
                    _this.cobranzaService.update(_this.cobranza)
                        .then(function (updatedDoc) {
                        _this.context.app.hideSpinner();
                        //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
                        _this.reset();
                        _this.cobranza = updatedDoc;
                        _this.editor.document = updatedDoc;
                        _this.editor.nextStep();
                    })
                        .catch(function (error) { return _this.handleError(error); });
                }
                else {
                    _this.context.app.hideSpinner();
                    _this.showAlert("Error: No se puede aplicar cobros a comprobantes no timbrados", "danger");
                }
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else
            this.showAlert("La cobranza tiene comprobantes que estan con una cancelación pendiente", "danger");
    };
    CobranzasEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.argsCurrentDocument = args;
        args.step.activities.forEach(function (activity) {
            if (activity.tag == 'APPLY') {
                if (_this.cobranza.idDeposito.trim() != '') //Si proviene de un deposito, nos traemos la cuenta a la que se deposito
                    _this.getCuentaBeneficiario(_this.cobranza.idDeposito);
                else {
                    _this.dlgCobranza.setCxC(_this.cuentasXCobrar.sourceCollection.filter(function (x) { return x.importe > 0; }));
                    _this.dlgCobranza.showSinCaja(_this.cobranza.total, _this.cobranza.idCaja, _this.idDeudorDefault);
                }
            }
            else {
                _this.context.app.showSpinner();
                _this.cobranzaService.nextStep(args.document.id, args.step.idWorkflowStep, null)
                    .then(function (_) {
                    _this.context.app.hideSpinner();
                    //Volver a cargar documento
                    _this.onViewingDocument(args.document.id);
                })
                    .catch(function (error) { return _this.handleError(error); });
            }
        });
    };
    CobranzasEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.cobranzaService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.cobranza.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    CobranzasEditor.prototype.onAddingDetail = function () {
        //this.detailsEditor.detail = new CobranzaDetail();
        //this.detailsEditor.show();
    };
    CobranzasEditor.prototype.onEditingDetail = function (detail) {
        //this.detailsEditor.detail = detail;
        //this.detailsEditor.show();
    };
    CobranzasEditor.prototype.onDeletingDetail = function (detail) {
        //this.detailsList.deleteItem(detail);
    };
    //onListItemsUpdated(updatedDetails: CobranzaDetail[]) {
    //    if (this.detailsEditor.anticipo.identity != '') {
    //        this.anticipo = this.detailsEditor.anticipo;
    //        this.cobranza.total = this.anticipo.importe;
    //        this.cobranza.idAnticipo = this.anticipo.identity;
    //        this.cobranza.fechaAnticipo = this.anticipo.fechaSys;
    //    }
    //    this.cobranza.details = updatedDetails;
    //    this.detailsList.listItems = updatedDetails;        
    //    this.cuentasXCobrar.sourceCollection = updatedDetails;
    //}
    CobranzasEditor.prototype.onSavingDetail = function (detail) {
        //this.detailsList.updateItem(detail);
    };
    CobranzasEditor.prototype.onDetailsLoaded = function (details) {
        this.acumulado = 0;
        if (this.detailsEditor.deposito.identity != '') {
            this.deposito = this.detailsEditor.deposito;
            this.cobranza.total = this.deposito.monto;
            this.cobranza.idDeposito = this.deposito.identity;
            this.cobranza.fechaDeposito = this.deposito.fechaSys;
        }
        if (details.length > 0)
            this.idDeudorDefault = details[0].idDeudor;
        var detailsOrder = details;
        this.detailsList.listItems = detailsOrder;
        this.cobranza.details = detailsOrder;
        this.cuentasXCobrar.sourceCollection = detailsOrder;
    };
    CobranzasEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.detailsEditor.detail = new cobranza_detail_1.CobranzaDetail();
            this.detailsEditor.show();
        }
        else if (button.name = 'DECIMALES') {
            this.dialogDecimales.config.backdrop = false;
            this.dialogDecimales.show();
        }
    };
    //onImporteCheck(item: CobranzaDetail)
    //{  
    //    let condicionPago = this.cobranza.details.find(search => search.importe > 0 && search.condicionesPago != item.condicionesPago);
    //    if (condicionPago == undefined) {
    //        let tempCXC: CobranzaDetail[] = this.cuentasXCobrar.sourceCollection.slice();
    //        item.importe = item.saldo;
    //        item.state = "MODIFIED";                                   
    //        this.cuentasXCobrar.sourceCollection = tempCXC;   
    //        //this.cuentasXCobrar.refresh();
    //        setTimeout(_ => this.calcularAcumulado());  
    //    }
    //    else
    //        this.showAlert("No puede mezclar documentos de diferentes condiciones de pago[Credito/Contado]","danger")
    //}
    CobranzasEditor.prototype.cellEditEndingHandler = function (sender, e) {
        var _this = this;
        var cxc = sender.rows[e.row].dataItem;
        var flex = sender, oldVal = flex.getCellData(e.row, e.col), newVal = flex.activeEditor.value;
        var condicionPago = this.cuentasXCobrar.sourceCollection.find(function (search) { return search.importe > 0 && search.condicionesPago != cxc.condicionesPago; });
        if (condicionPago == undefined)
            setTimeout(function (_) { return _this.calcularAcumulado(); });
        else {
            e.cancel = true;
            this.showAlert("No puede mezclar documentos de diferentes condiciones de pago[Credito/Contado]", "danger");
        }
        if (newVal > cxc.saldo) {
            this.showAlert("No puede abonar un importe mayor al saldo del documento", "danger");
            e.cancel = true;
            cxc.importe = cxc.saldo;
        }
        if (!isNaN(newVal)) // returns true if NaN, otherwise false            
            cxc.saldoFin = cxc.saldo - newVal;
        else //proviene del keydown ya que activaron el beginEdit
            e.cancel = true;
        cxc.state = "MODIFIED";
    };
    CobranzasEditor.prototype.onCellEditEnded = function (flex, e) {
        var _this = this;
        this.cuentasXCobrar.refresh();
        var Total = this.cobranza.total;
        this.cobranza.total = Total;
        setTimeout(function (_) { return _this.calcularAcumulado(); });
    };
    CobranzasEditor.prototype.keydown = function (grid, args, cell) {
        var _this = this;
        if (args.keyCode == 13) {
            var cxc = grid.rows[grid.selection.row].dataItem;
            if (this.acumulado == undefined)
                this.acumulado == 0;
            var disponible = this.cobranza.total - this.acumulado;
            if (disponible < 0 || disponible == undefined || isNaN(disponible))
                disponible = 0;
            if (disponible > cxc.saldo)
                cxc.importe = cxc.saldo;
            else
                cxc.importe = disponible;
            cxc.saldoFin = cxc.saldo - cxc.importe;
            cxc.state = "MODIFIED";
            //let total: number = this.cobranza.total+1;
            //this.cobranza.total = total-1;
            //this.documentForm.get('monto').markAsPristine();
            //this.documentForm.get('monto').markAsPending();
            this.detailsList.refresh();
            this.documentForm.get('monto').updateValueAndValidity();
            setTimeout(function (_) { return _this.calcularAcumulado(); });
        }
    };
    CobranzasEditor.prototype.loadCajas = function () {
        var _this = this;
        this.cajaService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (cajas) { return _this.cajas = cajas; })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasEditor.prototype.loadCobrosTipos = function () {
        var _this = this;
        this.cobroTipoService.loadList(this.context.app.defaultSite.identity, false)
            .then(function (cobrosTipos) { return _this.cobrosTipos = cobrosTipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasEditor.prototype.calcularAcumulado = function () {
        this.acumulado = this.cobranza.details
            .map(function (c) { return c.importe; })
            .reduce(function (sum, current) { return sum + current; });
        this.documentForm.get('monto').updateValueAndValidity();
    };
    CobranzasEditor.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    CobranzasEditor.prototype.cobroAceptado = function (formasPagoCobro) {
        var _this = this;
        var cobro = { formasPago: formasPagoCobro };
        this.context.app.showSpinner();
        this.cobranzaService.nextStep(this.editor.document.identity, this.argsCurrentDocument.step.idWorkflowStep, cobro)
            .then(function (_) {
            _this.context.app.hideSpinner();
            //this.refreshList();
            _this.dlgCobranza.clear();
            _this.onViewingDocument(_this.editor.document.identity);
            if (!_this.argsEditorEvent.closeEditor && _this.cobranza.identity == '') {
                _this.router.navigate(['../', _this.editor.document.identity], { relativeTo: _this.route });
            }
            else {
                if (_this.argsEditorEvent.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //itemFormatter = (cell, item) => {
    //    cell.style.color = "red";
    //}
    CobranzasEditor.prototype.getStatusColor = function (vencimiento) {
        var venc = new Date(vencimiento);
        var today = new Date();
        if (today < venc)
            return '#298A08';
        else
            return 'orangered';
    };
    CobranzasEditor.prototype.getStatusColorCancelacion = function (cancelacionPendinte) {
        if (!cancelacionPendinte)
            return '#298A08';
        else
            return 'orangered';
    };
    //itemFormatter = (panel, r, c, cell) => {
    //    if (panel.cellType === CellType.Cell) {
    //        const col: ColumnDefinition = this.columns[c];
    //        if (col.visible === true && col.colorBackground) {
    //            cell.style.backgroundColor = col.colorBackground;
    //        }
    //    }
    //};
    CobranzasEditor.prototype.getCuentaBeneficiario = function (idDeposito) {
        var _this = this;
        this.depositoService.getDetail(idDeposito)
            .then(function (deposito) {
            _this.idCuentaBeneficiario = deposito.idCuentaBancaria;
            _this.dlgCobranza.setCxC(_this.cuentasXCobrar.sourceCollection.filter(function (x) { return x.importe > 0; }));
            _this.dlgCobranza.showSinCaja(_this.cobranza.total, _this.cobranza.idCaja, _this.idDeudorDefault);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasEditor.prototype.assignFormat = function () {
        this.formato = 'C' + this.decimales.toString();
        this.dialogDecimales.hide();
        this.calcularAcumulado();
    };
    var CobranzasEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], CobranzasEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", cobranzas_detail_editor_1.CobranzaDetailEditor)
    ], CobranzasEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], CobranzasEditor.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('dialogDecimales'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], CobranzasEditor.prototype, "dialogDecimales", void 0);
    __decorate([
        core_1.ViewChild('dlgCobranza'),
        __metadata("design:type", cobranza_component_1.CobranzaComponent)
    ], CobranzasEditor.prototype, "dlgCobranza", void 0);
    CobranzasEditor = CobranzasEditor_1 = __decorate([
        core_1.Component({
            selector: 'credito-cobranzas-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n    \n          <alerts-bar></alerts-bar>\n\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'CobranzasTit'\"\n                                         [document]=\"cobranza\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n                        \n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Referencia Alfanumerica:'\">\n                                          <az-textbox formControlName=\"referenciaAlf\" [(ngModel)]=\"cobranza.referenciaAlf\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Referencia Numerica:'\">\n                                          <az-textbox formControlName=\"referenciaNum\" [(ngModel)]=\"cobranza.referenciaNum\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-12\">\n                                      <azteca-form-field [label]=\"'Observaciones:'\">\n                                          <az-textbox formControlName=\"observaciones\" [(ngModel)]=\"cobranza.observaciones\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\t\n\n                          </tab>\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                        \n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'DECIMALES'\" [type]=\"'primary'\" [text]=\"'Cant. Decimales'\" [toolTip]=\"'Cantidad de decimales a mostrar'\" [icon]=\"'glyphicon glyphicon-sound-5-1'\" [enabled]=\"true\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Caja'\">\n                                          <az-combobox formControlName=\"caja\"\n                                                       [(ngModel)]=\"cobranza.idCaja\"\n                                                       [items]=\"cajas\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Tipo de cobro:'\">\n                                          <az-combobox formControlName=\"idCobroTipo\"\n                                                       [(ngModel)]=\"cobranza.idCobroTipo\"\n                                                       [items]=\"cobrosTipos\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                            \n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Monto:'\">\n                                          <az-input-number formControlName=\"monto\" [(ngModel)]=\"cobranza.total\" format=\"{{formato}}\" [enabled]=\"cobranza.identity=='' && deposito.identity==''\"></az-input-number>\n                                          <!--&& acumulado >0-->\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Capturado:'\">\n                                          <az-input-number formControlName=\"acumulado\" [(ngModel)]=\"acumulado\" format=\"{{formato}}\" [enabled]=\"false\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar documentos a la cobranza'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <wj-flex-grid #detailsList style=\"height:550px\"\n                                                    (dataLoaded)=\"onListItemsUpdated($event)\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    (cellEditEnding)=\"cellEditEndingHandler(detailsList, $event)\"\n                                                    (cellEditEnded)=\"onCellEditEnded(detailsList, $event, cell)\"\n                                                    [itemsSource]=\"cuentasXCobrar\"\n                                                    (keydown)=\"keydown(detailsList, $event)\"\n                                                    >\n\n                                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                                          <wj-flex-grid-column [header]=\"'Ref CXC'\" [binding]=\"'idCuentaPorCobrarTit'\" [width]=\"140\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Ref Origen'\" [binding]=\"'idDocumentoRef'\" [width]=\"140\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCuentaPorCobrar'\" [width]=\"100\" [isReadOnly]=\"true\"  dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Deudor'\" [binding]=\"'deudor'\" [width]=\"200\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"80\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Folio'\" [binding]=\"'folioFactura'\" [width]=\"100\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Vencimiento'\" [binding]=\"'vencimiento'\" [width]=\"100\" [isReadOnly]=\"true\">\n                                              <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                                  <div [ngStyle]=\"{'background-color': getStatusColor(cell.item.vencimiento), 'color': 'white'}\">\n                                                      {{cell.item.vencimiento}}\n                                                  </div>\n                                              </ng-template>\n                                          </wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Cond.Pago'\" [binding]=\"'condicionesPagoText'\" [width]=\"100\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"100\" dataType=\"Number\" format=\"{{formato}}\" [isReadOnly]=\"true\"> </wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Saldo'\" [binding]=\"'saldo'\" [width]=\"100\" dataType=\"Number\" format=\"{{formato}}\" [isReadOnly]=\"true\"> </wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Cobro'\" [binding]=\"'importe'\" [width]=\"100\" dataType=\"Number\" format=\"{{formato}}\"  [isReadOnly]=\"false\">                                        \n                                               <!--<ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                                  <input id=\"cobro\" type=\"text\" name=\"cobro\" ng-model=\"cell.item.importe\" (keyPress)=\"importeKeyPress(cell.item, $event)\">\n                                              </ng-template>-->\n                                          </wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Saldo Fin'\" [binding]=\"'saldoFin'\" [width]=\"100\" dataType=\"Number\" format=\"C\" [isReadOnly]=\"true\"> </wj-flex-grid-column>\n\n                                          <wj-flex-grid-column [header]=\"'Cancelaci\u00F3n'\" [binding]=\"'cancelacionPendiente'\" [width]=\"100\" [isReadOnly]=\"true\">\n                                              <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                                  <div *ngIf=\"cell.item.cancelacionPendiente\" [ngStyle]=\"{'background-color': getStatusColorCancelacion(cell.item.cancelacionPendiente), 'color': 'white'}\">\n                                                      Cancelaci\u00F3n Pendiente\n                                                  </div>\n                                                  <div *ngIf=\"!cell.item.cancelacionPendiente\" [ngStyle]=\"{'background-color': getStatusColorCancelacion(cell.item.cancelacionPendiente), 'color': 'white'}\">\n                                                      Sin Petici\u00F3n\n                                                  </div>\n                                              </ng-template>\n                                          </wj-flex-grid-column>\n                                          <!--<wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                              <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                                  <button type=\"button\" class=\"btn btn-default\" (click)=\"onImporteCheck(cell.item, $event)\">\n                                                      <span class=\"glyphicon glyphicon-check\"></span>\n                                                  </button>\n                                              </ng-template>\n                                          </wj-flex-grid-column>-->\n\n                                      </wj-flex-grid>\n                                  </div>\n                              </div>                        \n\n\n                              <!--<azteca-editable-list #detailsList\n                                                      (addingItem)=\"onAddingDetail()\"\n                                                      (editingItem)=\"onEditingDetail($event)\"\n                                                      (deletingItem)=\"onDeletingDetail($event)\"\n                                                      (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                      [listItems]=\"cobranza.details\">\n\n                                   \n                                          <azteca-grid-column [header]=\"'Ref CXC'\" [binding]=\"'idCuentaPorCobrarTit'\" [width]=\"130\"></azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Ref Origen'\" [binding]=\"'idDocumentoRef'\" [width]=\"130\"></azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCuentaPorCobrar'\" [width]=\"100\"></azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Deudor'\" [binding]=\"'deudor'\" [width]=\"200\"></azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"80\"></azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'folioFactura'\" [width]=\"100\"></azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Vencimiento'\" [binding]=\"'vencimiento'\" [width]=\"100\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Cond.Pago'\" [binding]=\"'condicionesPagoText'\" [width]=\"100\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Saldo'\" [binding]=\"'saldo'\" [width]=\"100\" dataType=\"Number\" format=\"n2\"> </azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Cobro'\" [binding]=\"'importe'\" [width]=\"100\" dataType=\"Number\" format=\"n2\"> </azteca-grid-column>\n                                          <azteca-grid-column [header]=\"\" [binding]=\"'folioFactura'\" [width]=\"50\" dataType=\"Boolean\"></azteca-grid-column>\n                              </azteca-editable-list>-->\n                          </tab>\n\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"cobranza.identity==''\" >\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <credito-cobranza-detail-editor #detailsEditor                                     \n                                           (savingItem)=\"onSavingDetail($event)\"                                     \n                                           (dataLoaded)=\"onDetailsLoaded($event)\"  \n                                           [depositosVisible]=\"true\">\n\n      </credito-cobranza-detail-editor>\n\n\n      <credit-cobranza #dlgCobranza \n                      (cobroAcceptado)=\"cobroAceptado($event)\"\n                      [idCuentaBeneficiario]=\"idCuentaBeneficiario\">\n\n      </credit-cobranza>\n\n\n      <div bsModal #dialogDecimales=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\">Cantidad de decimales a mostrar</h4>\n                  </div>\n                  <div class=\"modal-body\">\n                      <az-input-number [(ngModel)]=\"decimales\" format=\"n\" [enabled]=\"true\"></az-input-number>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button class=\"btn btn-primary\" type=\"button\" (click)=\"assignFormat()\">Aceptar</button>\n                      <button class=\"btn btn-danger\" type=\"button\" (click)=\"dialogDecimales.hide()\">Cancelar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CobranzasEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: cobranza_service_1.CobranzaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            cobranza_service_1.CobranzaService,
            caja_service_1.CajaService,
            cobro_tipo_service_1.CobroTipoService, deposito_service_1.DepositoService, cuenta_por_cobrar_service_1.CuentaPorCobrarService])
    ], CobranzasEditor);
    return CobranzasEditor;
}(editors_1.DocumentEditor));
exports.CobranzasEditor = CobranzasEditor;
