import { Router, ActivatedRoute } from '@angular/router';
import { Context, DocumentItem } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { MenuItem, DownloadPopupComponent } from 'framework3/controls';
import { ModalDirective } from 'ngx-bootstrap';
import { CobranzaItem } from '../models/cobranza';
import { CobranzaService } from '../services/cobranza.service';
import { DepositoService } from '../services/deposito.service';
import { PolizaInfo, PolizaPerfilListComponent, PolizaPerfilItem, PolizaService } from '../../accounting';
import { CobranzaComponent } from '../parts/cobranza.component';
import { CobranzaFormaPagoDetail } from '../models/forma-pago-detail';
export declare class CobranzasManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private cobranzaService;
    private depositoService;
    private polizaSvc;
    cobranzasTit: CobranzaItem[];
    argsCurrentDocument: WorkflowEventArgs;
    idCuentaBeneficiario: number;
    currentPoliza: PolizaInfo;
    dlgCobranza: CobranzaComponent;
    dlgPolizaViewer: ModalDirective;
    downloadPopup: DownloadPopupComponent;
    dlgPolizaPerfil: PolizaPerfilListComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, cobranzaService: CobranzaService, depositoService: DepositoService, polizaSvc: PolizaService);
    onConfigureDocument(): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    cobroAceptado(formasPagoCobro: CobranzaFormaPagoDetail): void;
    onMenuItemClick(option: MenuItem): void;
    getStatusColor(uuid: string): string;
    getCuentaBeneficiario(cobranza: CobranzaItem): void;
    getTimbradoColor(folio: number, timbrado: boolean): string;
    onSelectedPolizaPerfil(item: PolizaPerfilItem): void;
    onClickGuardar(): void;
}
