"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var controls_1 = require("framework3/controls");
// Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
var cobranza_service_1 = require("../services/cobranza.service");
var deposito_service_1 = require("../services/deposito.service");
var accounting_1 = require("../../accounting");
//TODO.ALEX. Mover a donde se vaya a desplegar el cobro
var cobranza_component_1 = require("../parts/cobranza.component");
//
var CobranzasManager = /** @class */ (function (_super) {
    __extends(CobranzasManager, _super);
    function CobranzasManager(context, router, route, cobranzaService, depositoService, polizaSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.cobranzaService = cobranzaService;
        _this.depositoService = depositoService;
        _this.polizaSvc = polizaSvc;
        _this.idCuentaBeneficiario = 0;
        _this.currentPoliza = new accounting_1.PolizaInfo();
        return _this;
    }
    CobranzasManager_1 = CobranzasManager;
    CobranzasManager.prototype.onConfigureDocument = function () {
        this.refreshList();
        this.applyPolicies();
    };
    CobranzasManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.cobranzaService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.cobranzasTit = response.rows;
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasManager.prototype.onAddingItem = function () {
        this.router.navigate(['0'], { relativeTo: this.route });
    };
    CobranzasManager.prototype.onViewingItem = function (document) {
        this.router.navigate([document.id, { readonly: true }], { relativeTo: this.route });
    };
    CobranzasManager.prototype.onEditingItem = function (document) {
        this.router.navigate([document.id], { relativeTo: this.route });
    };
    CobranzasManager.prototype.onDeletingItem = function (document) {
        var _this = this;
        this.cobranzaService.delete(document.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El documento ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasManager.prototype.onCloningItem = function (document) {
        this.router.navigate([0, { cloneId: document.id }], { relativeTo: this.route });
    };
    CobranzasManager.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.argsCurrentDocument = args;
        var cobranza = this.cobranzasTit.find(function (doc) { return doc.id == args.document.id; });
        console.log(JSON.stringify(args) + " " + JSON.stringify(cobranza));
        this.context.app.showSpinner();
        this.cobranzaService.getDetail(cobranza.id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.dlgCobranza.setCxC(doc.details.filter(function (x) { return x.importe > 0; }));
            if (cobranza.idDeposito.trim() != '')
                _this.getCuentaBeneficiario(cobranza);
            else
                _this.dlgCobranza.showSinCaja(cobranza.total, cobranza.idCaja, cobranza.idDeudorDefault);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasManager.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.cobranzaService.previousStep(document.id, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasManager.prototype.cobroAceptado = function (formasPagoCobro) {
        var _this = this;
        var cobro = { formasPago: formasPagoCobro };
        this.context.app.showSpinner();
        this.cobranzaService.nextStep(this.argsCurrentDocument.document.id, this.argsCurrentDocument.step.idWorkflowStep, cobro)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
            _this.dlgCobranza.clear();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasManager.prototype.onMenuItemClick = function (option) {
        var _this = this;
        if (option.name == 'PDF') {
            this.context.app.showSpinner();
            this.cobranzaService.generarPdfFactura(this.manager.currentDocument.id)
                .then(function (file) {
                _this.context.app.hideSpinner();
                window.open('/file-server/' + file.uri, '_blank');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == "DOWNLOAD") {
            this.context.app.showSpinner();
            //Generar PDF
            this.cobranzaService.generarPdfFactura(this.manager.currentDocument.id)
                .then(function (pdf) {
                //Descargar xml
                _this.cobranzaService.getXmlFactura(_this.manager.currentDocument.id)
                    .then(function (xml) {
                    _this.context.app.hideSpinner();
                    var links = [];
                    links.push(pdf);
                    links.push(xml);
                    _this.downloadPopup.show(links);
                })
                    .catch(function (error) { return _this.handleError(error); });
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == "SUSTITUIR") {
            this.context.app.showSpinner();
            this.cobranzaService.sustituir(this.manager.currentDocument.id)
                .then(function (_) {
                _this.context.app.hideSpinner();
                _this.manager.showAlert('El comprobante de pago se ha sustituido con éxito', 'success');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == "CONTABILIZAR") {
            this.dlgPolizaPerfil.show();
        }
    };
    CobranzasManager.prototype.getStatusColor = function (uuid) {
        if (uuid != '')
            return '#298A08';
        else
            return 'orangered';
    };
    CobranzasManager.prototype.getCuentaBeneficiario = function (cobranza) {
        var _this = this;
        this.depositoService.getDetail(cobranza.idDeposito)
            .then(function (deposito) {
            _this.idCuentaBeneficiario = deposito.idCuentaBancaria;
            _this.dlgCobranza.showSinCaja(cobranza.total, cobranza.idCaja, cobranza.idDeudorDefault);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasManager.prototype.getTimbradoColor = function (folio, timbrado) {
        if (folio == 0)
            return '';
        else if (timbrado)
            return '#298A08';
        else
            return 'orangered';
        //let venc = new Date(vencimiento);
        //let today = new Date();
        //if (today < venc)
        //    return '#298A08';
        //else
        //    return 'orangered';        
    };
    CobranzasManager.prototype.onSelectedPolizaPerfil = function (item) {
        var _this = this;
        this.context.app.showSpinner();
        this.polizaSvc.loadPolizaByDocumento(this.manager.currentDocument.id, item.id, this.context.app.defaultSite.identity)
            .then(function (result) {
            _this.currentPoliza = result;
            _this.context.app.hideSpinner();
            _this.dlgPolizaViewer.config.backdrop = false;
            _this.dlgPolizaViewer.show();
        }).catch(function (error) { return _this.handleError(error); });
    };
    CobranzasManager.prototype.onClickGuardar = function () {
        var _this = this;
        this.context.app.showSpinner();
        if (this.currentPoliza.idPolizaOrigen == 0)
            this.currentPoliza.idPolizaOrigen = 1; //Manual
        this.polizaSvc.update(this.currentPoliza)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            _this.dlgPolizaViewer.hide();
            _this.manager.showAlert('La poliza ha sido registrada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var CobranzasManager_1;
    __decorate([
        core_1.ViewChild('dlgCobranza'),
        __metadata("design:type", cobranza_component_1.CobranzaComponent)
    ], CobranzasManager.prototype, "dlgCobranza", void 0);
    __decorate([
        core_1.ViewChild('viewDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], CobranzasManager.prototype, "dlgPolizaViewer", void 0);
    __decorate([
        core_1.ViewChild(controls_1.DownloadPopupComponent),
        __metadata("design:type", controls_1.DownloadPopupComponent)
    ], CobranzasManager.prototype, "downloadPopup", void 0);
    __decorate([
        core_1.ViewChild(accounting_1.PolizaPerfilListComponent),
        __metadata("design:type", accounting_1.PolizaPerfilListComponent)
    ], CobranzasManager.prototype, "dlgPolizaPerfil", void 0);
    CobranzasManager = CobranzasManager_1 = __decorate([
        core_1.Component({
            selector: 'credito-cobranzas-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Cobranzas</div>\n          <div class=\"card-body\">\n\n              <accounting-comprobante-search></accounting-comprobante-search>\n\n              <azteca-document-manager (searchRequested)=\"onSearchRequested($event)\"\n                                       (addingItem)=\"onAddingItem()\"\n                                       (viewingItem)=\"onViewingItem($event)\"\n                                       (editingItem)=\"onEditingItem($event)\"\n                                       (deletingItem)=\"onDeletingItem($event)\"\n                                       (cloningItem)=\"onCloningItem($event)\"\n                                       (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                       (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                       (configureDocument)=\"onConfigureDocument($event)\"\n                                       (menuItemClick)=\"onMenuItemClick($event)\"\n                                       [startPeriod]=\"'2'\"\n                                       [enabled]=\"enabled\"\n                                       [allowNew]=\"allowNew\"\n                                       [allowView]=\"allowView\"\n                                       [allowEdit]=\"allowEdit\"\n                                       [allowDelete]=\"allowDelete\"\n                                       [allowClone]=\"allowClone\"\n                                       [allowNext]=\"allowNext\"\n                                       [allowPrevious]=\"allowPrevious\"\n                                       [allowAudit]=\"allowAudit\"\n                                       [filterGroups]=\"filterGroups\"\n                                       [documentList]=\"cobranzasTit\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'PDF'\" [icon]=\"'glyphicon glyphicon-print'\" [text]=\"'Imprimir Comprobante'\" [smallText]=\"'generar pdf del comprobante de pago'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'DOWNLOAD'\" [icon]=\"'glyphicon glyphicon-save'\" [text]=\"'Descargar Comprobante'\" [smallText]=\"'descargar xml y pdf'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'CONTABILIZAR'\" [icon]=\"'glyphicon glyphicon-usd'\" [text]=\"'Contabilizar factura'\" [smallText]=\"'generar poliza de factura'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'SUSTITUIR'\" [icon]=\"'glyphicon glyphicon-usd'\" [text]=\"'Sustituir'\" [smallText]=\"'sustituir el comprobante de pago'\"></azteca-menu-item>\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"170\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"130\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Condiciones'\" [binding]=\"'condicionesPago'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Ref. Alf.'\" [binding]=\"'referenciaAlf'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Ref. Num.'\" [binding]=\"'referenciaNum'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Monto'\" [binding]=\"'total'\" [width]=\"100\" dataType=\"Number\" format=\"n2\"> </azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Observaciones'\" [binding]=\"'observaciones'\" [width]=\"'30*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"'3*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"'4*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Timbrado'\" [binding]=\"'timbrado'\" [width]=\"45\" dataType=\"Boolean\">\n                      <!--<ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                  <div [ngStyle]=\"{'background-color': getTimbradoColor(cell.item.folio, cell.item.timbrado), 'color': 'white'}\">\n                      {{cell.item.timbradoText}}\n                  </div>\n              </ng-template>-->\n                  </azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"'10*'\"></azteca-grid-column>\n\n\n              </azteca-document-manager>\n          </div>\n      </div>\n\n\n      <credit-cobranza #dlgCobranza\n                       (cobroAcceptado)=\"cobroAceptado($event)\"\n                       [idCuentaBeneficiario]=\"idCuentaBeneficiario\">\n      </credit-cobranza>\n\n      <download-popup></download-popup>\n\n\n      <!-- Perfil de poliza para contabilizar la venta -->\n      <accounting-poliza-perfil-list [searchByUser]=\"true\" (selectedItemChanged)=\"onSelectedPolizaPerfil($event)\"></accounting-poliza-perfil-list>\n\n      <!-- Visualizar poliza -->\n      <div bsModal #viewDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\">P&oacute;liza</h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"viewDialog.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <accounting-poliza-viewer [poliza]=\"currentPoliza\"></accounting-poliza-viewer>\n                  </div> <!--Modal Body-->\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-default\" data-dismiss=\"modal\" (click)=\"viewDialog.hide()\">Cancelar</button>\n                      <button type=\"button\" class=\"btn btn-primary\" data-dismiss=\"modal\" (click)=\"onClickGuardar()\">Guardar</button>\n                  </div>\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CobranzasManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: cobranza_service_1.CobranzaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, cobranza_service_1.CobranzaService, deposito_service_1.DepositoService, accounting_1.PolizaService])
    ], CobranzasManager);
    return CobranzasManager;
}(editors_1.DocumentManager));
exports.CobranzasManager = CobranzasManager;
