import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { DepositoInfo } from '../models/deposito';
import { DepositoDetail } from '../models/deposito-detail';
import { DepositoTipoItem } from '../models/deposito-tipo';
import { DepositoTipoService } from '../services/deposito-tipo.service';
import { DepositoService } from '../services/deposito.service';
import { DepositoDetailEditor } from './parts/depositos-detail.editor';
import { CuentaBancariaItem } from '../../accounting/models/cuenta-bancaria';
import { CuentaBancariaService } from '../../accounting/services/cuenta-bancaria.service';
export declare class DepositosEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private depositoService;
    private depositoTipoService;
    private cuentaBancariaService;
    deposito: DepositoInfo;
    depositosTipos: DepositoTipoItem[];
    cuentasBancarias: CuentaBancariaItem[];
    tipoOrdenante: string;
    tiposOrdenantes: {
        id: string;
        nombre: string;
    }[];
    detailsList: EditableListComponent;
    detailsEditor: DepositoDetailEditor;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, depositoService: DepositoService, depositoTipoService: DepositoTipoService, cuentaBancariaService: CuentaBancariaService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: DepositoDetail): void;
    onDeletingDetail(detail: DepositoDetail): void;
    onListItemsUpdated(updatedDetails: DepositoDetail[]): void;
    onSavingDetail(detail: DepositoDetail): void;
    loadDepositosTipos(): void;
    loadCuentasBancarias(): void;
    selectedOrdenante(item: any): void;
}
