"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var deposito_1 = require("../models/deposito");
var deposito_detail_1 = require("../models/deposito-detail");
var deposito_tipo_service_1 = require("../services/deposito-tipo.service");
var deposito_service_1 = require("../services/deposito.service");
var depositos_detail_editor_1 = require("./parts/depositos-detail.editor");
var cuenta_bancaria_service_1 = require("../../accounting/services/cuenta-bancaria.service");
var DepositosEditor = /** @class */ (function (_super) {
    __extends(DepositosEditor, _super);
    function DepositosEditor(context, router, route, location, formBuilder, documentTypeService, depositoService, depositoTipoService, cuentaBancariaService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.depositoService = depositoService;
        _this.depositoTipoService = depositoTipoService;
        _this.cuentaBancariaService = cuentaBancariaService;
        _this.deposito = new deposito_1.DepositoInfo();
        _this.depositosTipos = [];
        _this.cuentasBancarias = [];
        _this.tiposOrdenantes = [];
        _this.documentForm = formBuilder.group({
            'idDepositoTipo': ['', forms_1.Validators.required],
            'idCuentaBancaria': ['', forms_1.Validators.required],
            'ordenante': ['', forms_1.Validators.required],
            'idGrupoDeudor': [''],
            'idDeudor': [''],
            'monto': ['', forms_1.Validators.required],
            'observaciones': [''],
        });
        _this.tiposOrdenantes =
            [
                { "id": "G", "nombre": "Grupo Deudor" },
                { "id": "D", "nombre": "Deudor" },
            ];
        return _this;
    }
    DepositosEditor_1 = DepositosEditor;
    DepositosEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
        this.loadDepositosTipos();
        this.loadCuentasBancarias();
    };
    DepositosEditor.prototype.onCreatingDocument = function () {
    };
    DepositosEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.depositoService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.deposito = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DepositosEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.depositoService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.deposito = doc;
            _this.detailsEditor.clientIndexStart = _this.deposito.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DepositosEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.depositoService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.tipoOrdenante = doc.idDeudor > 0 ? 'D' : 'G';
            _this.deposito = doc;
            _this.detailsEditor.clientIndexStart = _this.deposito.details.length;
            if (_this.deposito.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DepositosEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.deposito.fechaAfectacion = new Date();
        this.depositoService.update(this.deposito)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.deposito.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.deposito = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DepositosEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        if (args.step.tag == 'APPLY') {
            this.context.app.hideSpinner();
            this.showAlert('El documento solo se aplica desglosando el cobro en el proceso de cobranza', 'warning');
        }
        else {
            this.depositoService.nextStep(args.document.id, args.step.idWorkflowStep, null)
                .then(function (_) {
                //Volver a cargar documento
                _this.onViewingDocument(args.document.id);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    DepositosEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        if (document.workflowStep == 'APPLY') {
            this.context.app.hideSpinner();
            this.showAlert('El documento en estatus aplicado solo puede ser cancelado en el proceso de cobranza', 'warning');
        }
        else
            this.depositoService.previousStep(document.id, null)
                .then(function (_) {
                //Volver a cargar documento
                _this.onViewingDocument(document.id);
            })
                .catch(function (error) { return _this.handleError(error); });
    };
    DepositosEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.deposito.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    DepositosEditor.prototype.onAddingDetail = function () {
        this.detailsEditor.detail = new deposito_detail_1.DepositoDetail();
        this.detailsEditor.show();
    };
    DepositosEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    DepositosEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    DepositosEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.deposito.details = updatedDetails;
    };
    DepositosEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    ///////
    DepositosEditor.prototype.loadDepositosTipos = function () {
        var _this = this;
        this.depositoTipoService.loadList(this.context.app.defaultSite.identity)
            .then(function (depositosTipos) { return _this.depositosTipos = depositosTipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    DepositosEditor.prototype.loadCuentasBancarias = function () {
        var _this = this;
        this.cuentaBancariaService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (cuentasBeneficiario) {
            _this.cuentasBancarias = cuentasBeneficiario;
        })
            .catch(function (error) { return _this.showAlert(error, 'danger'); });
    };
    DepositosEditor.prototype.selectedOrdenante = function (item) {
        this.tipoOrdenante = item;
    };
    var DepositosEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], DepositosEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", depositos_detail_editor_1.DepositoDetailEditor)
    ], DepositosEditor.prototype, "detailsEditor", void 0);
    DepositosEditor = DepositosEditor_1 = __decorate([
        core_1.Component({
            selector: 'credito-depositos-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'Depositos'\"\n                                         [document]=\"deposito\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Tipo de Deposito:'\">\n                                          <az-combobox formControlName=\"idDepositoTipo\"\n                                                       [(ngModel)]=\"deposito.idDepositoTipo\"\n                                                       [items]=\"depositosTipos\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-4\">\n                                      <azteca-form-field [label]=\"'#Cuenta Bancaria'\">\n                                          <az-combobox #cboCuentasBancarias\n                                                       formControlName=\"idCuentaBancaria\"\n                                                       [(ngModel)]=\"deposito.idCuentaBancaria\"\n                                                       [items]=\"cuentasBancarias\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Monto:'\">\n                                          <az-input-number formControlName=\"monto\" [(ngModel)]=\"deposito.monto\" format=\"'n2'\"></az-input-number>                                    \n                                      </azteca-form-field>\n                                  </div>\n\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-12\">\n                                      <azteca-form-field [label]=\"'Observaciones:'\">\n                                          <az-textbox formControlName=\"observaciones\" [(ngModel)]=\"deposito.observaciones\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <az-panel [header]=\"'Ordenante'\" type=\"success\">\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-md-6\">\n                                          <azteca-form-field [label]=\"'Ordenante:'\">\n                                              <az-combobox formControlName=\"ordenante\"\n                                                           [(ngModel)]=\"tipoOrdenante\"\n                                                           (selectedItemChanged)=\"selectedOrdenante($event)\"\n                                                           [items]=\"tiposOrdenantes\"\n                                                           [displayMember]=\"'nombre'\"\n                                                           [valueMember]=\"'id'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-md-6\">\n                                          <azteca-form-field [label]=\"'Grupo deudor:'\" *ngIf=\"tipoOrdenante=='G'\">\n                                              <credit-grupo-deudores-selector formControlName=\"idGrupoDeudor\" [(ngModel)]=\"deposito.idGrupoDeudor\" ngDefaultControl=\"\" (itemSelected)=\"onGrupoDeudorSelected($event)\"></credit-grupo-deudores-selector>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-md-6\">\n                                          <azteca-form-field [label]=\"'Deudor:'\" *ngIf=\"tipoOrdenante=='D'\">\n                                              <credit-deudores-selector formControlName=\"idDeudor\" [(ngModel)]=\"deposito.idDeudor\" ngDefaultControl=\"\" (itemSelected)=\"onDeudorSelected($event)\"></credit-deudores-selector>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n                              </az-panel>\n\n                          </tab>\n\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\" *ngIf=\"false\">\n                              <azteca-editable-list   #detailsList\n                                                      (addingItem)=\"onAddingDetail()\"\n                                                      (editingItem)=\"onEditingDetail($event)\"\n                                                      (deletingItem)=\"onDeletingDetail($event)\"\n                                                      (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                      [listItems]=\"deposito.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n      \t\t\t\t\t\t\t<!-- Columnas de Ejemplo\n                                  <azteca-grid-column [header]=\"'Art\u00EDculo'\" [binding]=\"'articulo'\" [width]=\"'30*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'U.M.'\" [binding]=\"'unidad'\" [width]=\"'10*'\" [isReadOnly]=\"false\"></azteca-grid-column>                            \n      \t\t\t\t\t\t\t-->\n\n                              </azteca-editable-list>\n                          </tab>\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"deposito.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n                  </div>              \n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <credito-deposito-detail-editor #detailsEditor                                     \n                                           (savingItem)=\"onSavingDetail($event)\">\n\n      </credito-deposito-detail-editor>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return DepositosEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: deposito_service_1.DepositoService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            deposito_service_1.DepositoService, deposito_tipo_service_1.DepositoTipoService, cuenta_bancaria_service_1.CuentaBancariaService])
    ], DepositosEditor);
    return DepositosEditor;
}(editors_1.DocumentEditor));
exports.DepositosEditor = DepositosEditor;
