"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var deposito_service_1 = require("../services/deposito.service");
var DepositosManager = /** @class */ (function (_super) {
    __extends(DepositosManager, _super);
    function DepositosManager(context, router, route, depositoService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.depositoService = depositoService;
        return _this;
    }
    DepositosManager_1 = DepositosManager;
    DepositosManager.prototype.onConfigureDocument = function () {
        this.refreshList();
        this.applyPolicies();
    };
    DepositosManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.depositoService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.depositos = response.rows;
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DepositosManager.prototype.onAddingItem = function () {
        this.router.navigate(['0'], { relativeTo: this.route });
    };
    DepositosManager.prototype.onViewingItem = function (document) {
        this.router.navigate([document.id, { readonly: true }], { relativeTo: this.route });
    };
    DepositosManager.prototype.onEditingItem = function (document) {
        this.router.navigate([document.id], { relativeTo: this.route });
    };
    DepositosManager.prototype.onDeletingItem = function (document) {
        var _this = this;
        this.depositoService.delete(document.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El documento ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DepositosManager.prototype.onCloningItem = function (document) {
        this.router.navigate([0, { cloneId: document.id }], { relativeTo: this.route });
    };
    DepositosManager.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        if (args.step.tag == 'APPLY') {
            this.context.app.hideSpinner();
            this.showAlert('El documento solo se aplica desglosando el cobro en el proceso de cobranza', 'warning');
        }
        else {
            this.depositoService.nextStep(args.document.id, args.step.idWorkflowStep, null)
                .then(function (_) {
                _this.context.app.hideSpinner();
                _this.refreshList();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    DepositosManager.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        if (document.workflowStep == 'APPLY') {
            this.context.app.hideSpinner();
            this.showAlert('El documento en estatus aplicado solo puede ser cancelado en el proceso de cobranza', 'warning');
        }
        else
            this.depositoService.previousStep(document.id, null)
                .then(function (_) {
                _this.context.app.hideSpinner();
                _this.refreshList();
            })
                .catch(function (error) { return _this.handleError(error); });
    };
    var DepositosManager_1;
    DepositosManager = DepositosManager_1 = __decorate([
        core_1.Component({
            selector: 'credito-depositos-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Depositos</div>\n          <div class=\"card-block\">\n              <azteca-document-manager (searchRequested)=\"onSearchRequested($event)\"\n                                       (addingItem)=\"onAddingItem()\"\n                                       (viewingItem)=\"onViewingItem($event)\"\n                                       (editingItem)=\"onEditingItem($event)\"\n                                       (deletingItem)=\"onDeletingItem($event)\"\n                                       (cloningItem)=\"onCloningItem($event)\"\n                                       (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                       (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                       (configureDocument)=\"onConfigureDocument($event)\"\n                                       [enabled]=\"enabled\"\n                                       [allowNew]=\"allowNew\"\n                                       [allowView]=\"allowView\"\n                                       [allowEdit]=\"allowEdit\"\n                                       [allowDelete]=\"allowDelete\"\n                                       [allowClone]=\"allowClone\"\n                                       [allowNext]=\"allowNext\"\n                                       [allowPrevious]=\"allowPrevious\"\n                                       [allowAudit]=\"allowAudit\"\n                                       [filterGroups]=\"filterGroups\"\n                                       [documentList]=\"depositos\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"200\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"180\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Cuenta Bancaria'\" [binding]=\"'cuentaBancaria'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Ordenante'\" [binding]=\"'nombre'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'monto'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Estatus'\" [binding]=\"'status'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"'10*'\"></azteca-grid-column>\n\n              </azteca-document-manager>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return DepositosManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: deposito_service_1.DepositoService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, deposito_service_1.DepositoService])
    ], DepositosManager);
    return DepositosManager;
}(editors_1.DocumentManager));
exports.DepositosManager = DepositosManager;
