import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { CollectionView } from 'wijmo/wijmo';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { ToolbarButton, AzComboboxComponent } from 'framework3/controls';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { NotaInfo } from '../models/nota';
import { NotaDetail } from '../../accounting/models/nota-detail';
import { NotaService } from '../services/nota.service';
import { NotaDetailEditor } from '../../credit/documents/parts/notas-detail.editor';
import { DivisaService } from '../../accounting/services/divisa.service';
import { FormaPagoService } from '../../accounting/services/forma-pago.service';
import { FormaPagoItem } from '../../accounting/models/forma-pago';
import { ContribuyenteService } from '../../accounting/services/contribuyente.service';
import { UsoCFDIItem } from '../../accounting/models/contribuyente';
import { NotaTipoItem } from '../models/nota-tipo';
import { NotaTipoService } from '../services/nota-tipo.service';
import { CobranzaDetail } from '../models/cobranza-detail';
import { CobranzaDetailEditor } from './parts/cobranzas-detail.editor';
import { CobranzaInfo } from '../models/cobranza';
import { ModalDirective } from 'ngx-bootstrap';
export declare class NotasEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private notaService;
    private formaPagoService;
    private divisaService;
    private contribuyenteService;
    private notaTipoSvc;
    nota: NotaInfo;
    formasPago: FormaPagoItem[];
    version3p3: boolean;
    version3p2: boolean;
    usosCFDI: UsoCFDIItem[];
    notaTipos: NotaTipoItem[];
    acumulado: number;
    sumaDetalle: number;
    formato: string;
    decimales: number;
    idDeudorDefault: number;
    cobranza: CobranzaInfo;
    cuentasXCobrar: CollectionView;
    detailsList: EditableListComponent;
    detailsEditor: NotaDetailEditor;
    cobranzaDetailsEditor: CobranzaDetailEditor;
    cboAplica: AzComboboxComponent;
    dialogDecimales: ModalDirective;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, notaService: NotaService, formaPagoService: FormaPagoService, divisaService: DivisaService, contribuyenteService: ContribuyenteService, notaTipoSvc: NotaTipoService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: NotaDetail): void;
    onDeletingDetail(detail: NotaDetail): void;
    onDetailsLoaded(details: NotaDetail[]): void;
    onListItemsUpdated(updatedDetails: NotaDetail[]): void;
    onSavingDetail(detail: NotaDetail): void;
    loadFormasPago(): void;
    asignarCobranza(cPc: CobranzaDetail): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onDetailsCobranzaLoaded(details: CobranzaDetail[]): void;
    getStatusColor(vencimiento: Date): string;
    keydown(grid: any, args: any, cell: any): void;
    calcularAcumulado(): void;
    validateMontos(): string;
    validateMontos2(): string;
    calcularMonto(): void;
    cellEditEndingHandler(sender: any, e: any): void;
    onCellEditEnded(flex: any, e: any): void;
    getDivisaDefault(): void;
    loadUsosCFDI(): void;
    loadNotaTipos(): void;
    assignFormat(): void;
    getStatusColorCancelacion(cancelacionPendinte: boolean): string;
}
