"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Locales
var nota_1 = require("../models/nota");
var nota_relaciones_1 = require("../models/nota-relaciones");
var nota_detail_1 = require("../../accounting/models/nota-detail");
var nota_service_1 = require("../services/nota.service");
//import { NotaDetailEditor } from '../../accounting/documents/parts/notas-detail.editor';
var notas_detail_editor_1 = require("../../credit/documents/parts/notas-detail.editor");
var divisa_service_1 = require("../../accounting/services/divisa.service");
var forma_pago_service_1 = require("../../accounting/services/forma-pago.service");
var contribuyente_service_1 = require("../../accounting/services/contribuyente.service");
var nota_tipo_service_1 = require("../services/nota-tipo.service");
//Cobranza
var cobranza_detail_1 = require("../models/cobranza-detail");
var cobranzas_detail_editor_1 = require("./parts/cobranzas-detail.editor");
var cobranza_1 = require("../models/cobranza");
var ngx_bootstrap_1 = require("ngx-bootstrap");
var NotasEditor = /** @class */ (function (_super) {
    __extends(NotasEditor, _super);
    function NotasEditor(context, router, route, location, formBuilder, documentTypeService, notaService, formaPagoService, divisaService, contribuyenteService, notaTipoSvc) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.notaService = notaService;
        _this.formaPagoService = formaPagoService;
        _this.divisaService = divisaService;
        _this.contribuyenteService = contribuyenteService;
        _this.notaTipoSvc = notaTipoSvc;
        _this.nota = new nota_1.NotaInfo();
        _this.formasPago = [];
        _this.usosCFDI = [];
        _this.notaTipos = [];
        //Cobranza
        _this.acumulado = 0;
        _this.sumaDetalle = 0;
        _this.formato = "C2";
        _this.decimales = 2;
        _this.cobranza = new cobranza_1.CobranzaInfo();
        _this.cuentasXCobrar = new wijmo_1.CollectionView();
        _this.documentForm = formBuilder.group({
            'divisa': [0, forms_1.Validators.required],
            'idFormaPago': [0, forms_1.Validators.required],
            'observaciones': ['', forms_1.Validators.required],
            'idUsoCFDI': [0, forms_1.Validators.required],
            'idNotaTipo': [0, forms_1.Validators.required],
            'monto': ['0', function (_) { return _this.validateMontos(); }],
            'acumulado': ['0', function (_) { return _this.validateMontos2(); }]
        });
        return _this;
    }
    NotasEditor_1 = NotasEditor;
    NotasEditor.prototype.onConfigureDocument = function (docType) {
        this.loadFormasPago();
        this.applyPolicies();
        this.getDivisaDefault();
        this.loadUsosCFDI();
        this.loadNotaTipos();
    };
    NotasEditor.prototype.onCreatingDocument = function () {
    };
    NotasEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.nota = doc;
            _this.detailsEditor.clientIndexStart = _this.nota.details.length;
            //this.calcularAcumulado();
            _this.setReadonlyMode();
            _this.cuentasXCobrar.sourceCollection = _this.nota.relaciones;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.notaService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.nota = doc;
            _this.detailsEditor.clientIndexStart = _this.nota.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.nota = doc;
            //this.calcularAcumulado();
            _this.detailsEditor.clientIndexStart = _this.nota.details.length;
            if (_this.nota.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
            _this.cuentasXCobrar.sourceCollection = _this.nota.relaciones;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        if (this.cuentasXCobrar.sourceCollection.filter(function (search) { return search.state == "MODIFIED" && search.cancelacionPendiente == true && search.importe > 0; }).length == 0) {
            this.context.app.showSpinner();
            this.cobranza.details.forEach(function (detail) {
                if (detail.importe > 0) {
                    _this.asignarCobranza(detail);
                }
            });
            if (this.cobranzaDetailsEditor.tipoBusqueda == 'D') {
                this.nota.idDeudor = this.cobranzaDetailsEditor.idDeudor;
                this.nota.idGrupoDeudor = 0;
            }
            if (this.cobranzaDetailsEditor.tipoBusqueda == 'G') {
                this.nota.idGrupoDeudor = this.cobranzaDetailsEditor.idGrupoDeudor;
                this.nota.idDeudor = 0;
            }
            this.notaService.update(this.nota)
                .then(function (updatedDoc) {
                _this.notaService.nextStep(updatedDoc.identity, 1, '')
                    .then(function (n) {
                    _this.context.app.hideSpinner();
                    //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
                    _this.reset();
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                    /*
                    if (!args.closeEditor && this.nota.identity == '') {
                        this.router.navigate(['../', updatedDoc.identity], { relativeTo: this.route });
                    }
                    else {
                        if (args.closeEditor)
                            this.router.navigate(['../'], { relativeTo: this.route });
                        else
                            this.showAlert('La información ha sido actualizada con éxito', 'success');
                    }
                    */
                    _this.nota = updatedDoc;
                })
                    .catch(function (error) { return _this.handleError(error); });
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else
            this.showAlert("La nota tiene comprobantes que estan con una cancelación pendiente", "danger");
    };
    NotasEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.nota.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    NotasEditor.prototype.onAddingDetail = function () {
        this.detailsEditor.detail = new nota_detail_1.NotaDetail();
        this.detailsEditor.idNotaTipo = this.nota.idNotaTipo;
        this.detailsEditor.show();
    };
    NotasEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.idNotaTipo = this.nota.idNotaTipo;
        this.detailsEditor.show();
    };
    NotasEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    NotasEditor.prototype.onDetailsLoaded = function (details) {
    };
    NotasEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.nota.notaBase.details = updatedDetails;
    };
    NotasEditor.prototype.onSavingDetail = function (detail) {
        var _this = this;
        this.detailsList.updateItem(detail);
        //this.sumaDetalle = 345;
        setTimeout(function (_) { return _this.calcularMonto(); });
        setTimeout(function (_) { return _this.calcularAcumulado(); });
    };
    NotasEditor.prototype.loadFormasPago = function () {
        var _this = this;
        this.formaPagoService.loadList(this.context.app.defaultSite.identity)
            .then(function (formas) { return _this.formasPago = formas; })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.asignarCobranza = function (cPc) {
        var rel = new nota_relaciones_1.NotaRelaciones;
        rel.idCuentaPorCobrar = cPc.idCuentaPorCobrarTit;
        rel.idNotaRelacion = 0;
        rel.saldoInicial = cPc.saldo;
        rel.importe = cPc.importe;
        rel.saldoFinal = cPc.saldo;
        var newRel = this.nota.relaciones.slice();
        newRel.push(rel);
        this.nota.relaciones = newRel;
    };
    NotasEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            //this.detailsEditor.detail = new CobranzaDetail();
            //this.detailsEditor.show();
            this.cobranzaDetailsEditor.detail = new cobranza_detail_1.CobranzaDetail();
            this.cobranzaDetailsEditor.show();
        }
        else if (button.name == 'DECIMALES') {
            this.dialogDecimales.config.backdrop = false;
            this.dialogDecimales.show();
        }
    };
    //Cobranza//Init
    NotasEditor.prototype.onDetailsCobranzaLoaded = function (details) {
        this.acumulado = 0;
        if (details.length > 0)
            this.idDeudorDefault = details[0].idDeudor;
        var detailsOrder = details;
        //this.detailsList.listItems = detailsOrder;
        this.cobranza.details = detailsOrder;
        this.cuentasXCobrar.sourceCollection = detailsOrder;
    };
    NotasEditor.prototype.getStatusColor = function (vencimiento) {
        var venc = new Date(vencimiento);
        var today = new Date();
        if (today < venc)
            return '#298A08';
        else
            return 'orangered';
    };
    NotasEditor.prototype.keydown = function (grid, args, cell) {
        var _this = this;
        if (args.keyCode == 13) {
            var cxc = grid.rows[grid.selection.row].dataItem;
            if (this.acumulado == undefined)
                this.acumulado == 0;
            var disponible = this.cobranza.total - this.acumulado;
            if (disponible < 0 || disponible == undefined || isNaN(disponible))
                disponible = 0;
            if (disponible > cxc.saldo)
                cxc.importe = cxc.saldo;
            else
                cxc.importe = disponible;
            cxc.state = "MODIFIED";
            //let total: number = this.cobranza.total+1;
            //this.cobranza.total = total-1;
            //this.documentForm.get('monto').markAsPristine();
            //this.documentForm.get('monto').markAsPending();
            this.detailsList.refresh();
            this.documentForm.get('monto').updateValueAndValidity();
            setTimeout(function (_) { return _this.calcularAcumulado(); });
        }
    };
    NotasEditor.prototype.calcularAcumulado = function () {
        if (this.cobranza.details.length > 0) {
            this.acumulado = this.cobranza.details
                .map(function (c) { return c.importe; })
                .reduce(function (sum, current) { return sum + current; });
            this.acumulado = Number(this.acumulado.toFixed(this.decimales));
            this.documentForm.get('acumulado').updateValueAndValidity();
        }
    };
    NotasEditor.prototype.validateMontos = function () {
        if (this.cobranza.total == this.acumulado && this.acumulado > 0)
            return null;
        else
            return 'No coincide el monto deseado con el monto acumulado.';
    };
    NotasEditor.prototype.validateMontos2 = function () {
        if (this.cobranza.total == this.acumulado && this.acumulado > 0)
            return null;
        else
            return 'No coincide el monto deseado con el monto acumulado.';
    };
    NotasEditor.prototype.calcularMonto = function () {
        if (this.nota.notaBase.details.length > 0) {
            this.sumaDetalle = this.nota.notaBase.details
                .map(function (c) { return c.importe; })
                .reduce(function (sum, current) { return sum + current; });
            this.cobranza.total = this.sumaDetalle;
            this.documentForm.get('monto').updateValueAndValidity();
        }
    };
    NotasEditor.prototype.cellEditEndingHandler = function (sender, e) {
        var _this = this;
        var cxc = sender.rows[e.row].dataItem;
        var flex = sender, oldVal = flex.getCellData(e.row, e.col), newVal = flex.activeEditor.value;
        var condicionPago = this.cuentasXCobrar.sourceCollection.find(function (search) { return search.importe > 0 && search.condicionesPago != cxc.condicionesPago; });
        if (condicionPago == undefined)
            setTimeout(function (_) { return _this.calcularAcumulado(); });
        else {
            e.cancel = true;
            this.showAlert("No puede mezclar documentos de diferentes condiciones de pago[Credito/Contado]", "danger");
        }
        if (newVal > cxc.saldo) {
            this.showAlert("No puede abonar un importe mayor al saldo del documento", "danger");
            e.cancel = true;
            cxc.importe = cxc.saldo;
        }
        cxc.state = "MODIFIED";
    };
    NotasEditor.prototype.onCellEditEnded = function (flex, e) {
        var _this = this;
        this.cuentasXCobrar.refresh();
        var Total = this.cobranza.total;
        this.cobranza.total = Total;
        setTimeout(function (_) { return _this.calcularAcumulado(); });
        setTimeout(function (_) { return _this.calcularMonto(); });
    };
    //Cobranza//End
    NotasEditor.prototype.getDivisaDefault = function () {
        var _this = this;
        this.divisaService.getDetailByEmpresa(this.context.app.defaultCompany.identity)
            .then(function (r) {
            _this.nota.notaBase.idDivisa = r.identity;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.loadUsosCFDI = function () {
        var _this = this;
        this.contribuyenteService.loadUsosCFDI(this.context.app.defaultCompany.identity)
            .then(function (usos) { return _this.usosCFDI = usos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.loadNotaTipos = function () {
        var _this = this;
        this.notaTipoSvc.loadList(this.context.app.defaultCompany.identity)
            .then(function (tipos) { return _this.notaTipos = tipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.assignFormat = function () {
        this.formato = 'C' + this.decimales.toString();
        this.dialogDecimales.hide();
        this.calcularAcumulado();
        this.calcularMonto();
    };
    NotasEditor.prototype.getStatusColorCancelacion = function (cancelacionPendinte) {
        if (!cancelacionPendinte)
            return '#298A08';
        else
            return 'orangered';
    };
    var NotasEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], NotasEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", notas_detail_editor_1.NotaDetailEditor)
    ], NotasEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild('cobranzaDetailsEditor'),
        __metadata("design:type", cobranzas_detail_editor_1.CobranzaDetailEditor)
    ], NotasEditor.prototype, "cobranzaDetailsEditor", void 0);
    __decorate([
        core_1.ViewChild('cboAplica'),
        __metadata("design:type", controls_1.AzComboboxComponent)
    ], NotasEditor.prototype, "cboAplica", void 0);
    __decorate([
        core_1.ViewChild('dialogDecimales'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], NotasEditor.prototype, "dialogDecimales", void 0);
    NotasEditor = NotasEditor_1 = __decorate([
        core_1.Component({
            selector: 'credito-notas-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'Notas'\"\n                                         [document]=\"nota\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n                              <div class=\"row\">\n\n                                  <div class=\"col-md-8 col-md-8\">\n\n                                      <azteca-form-field [label]=\"'Tipo de nota:'\">\n                                          <az-combobox formControlName=\"idNotaTipo\"\n                                                       [(ngModel)]=\"nota.idNotaTipo\"\n                                                       [items]=\"notaTipos\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [enabled]=\"nota.idNotaTipo==0\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Uso de CFDI:'\">\n                                          <az-combobox formControlName=\"idUsoCFDI\"\n                                                       [(ngModel)]=\"nota.notaBase.idUsoCFDI\"\n                                                       [items]=\"usosCFDI\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <azteca-form-field [label]=\"'Seleccionar divisa:'\">\n                                  <azteca-form-field [label]=\"Divisa\">\n                                      <accounting-divisas-selector formControlName=\"divisa\" [(ngModel)]=\"nota.notaBase.idDivisa\"></accounting-divisas-selector>\n                                  </azteca-form-field>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Forma de Pago:'\">\n                                  <az-combobox formControlName=\"idFormaPago\"\n                                               [(ngModel)]=\"nota.notaBase.idFormaPago\"\n                                               [items]=\"formasPago\"\n                                               [displayMember]=\"'nombre'\"\n                                               [valueMember]=\"'id'\">\n                                  </az-combobox>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Observaciones:'\">\n                                  <az-textarea formControlName=\"observaciones\" [(ngModel)]=\"nota.notaBase.observaciones\"></az-textarea>\n                              </azteca-form-field>\n\n\n                          </tab>\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list   #detailsList\n                                                      (addingItem)=\"onAddingDetail()\"\n                                                      (editingItem)=\"onEditingDetail($event)\"\n                                                      (deletingItem)=\"onDeletingDetail($event)\"\n                                                      (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                      [listItems]=\"nota.notaBase.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <!-- Columnas de Ejemplo-->\n                                  <azteca-grid-column [header]=\"'Concepto'\" [binding]=\"'concepto'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'10*'\" [isReadOnly]=\"true\" format=\"{{formato}}\"></azteca-grid-column>\n\n                              </azteca-editable-list>\n                          </tab>\n\n                          <tab heading=\"Comprobantes fiscales\" (select)=\"onTabSelected($event)\">\n\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar comprobante'\" [icon]=\"'glyphicon glyphicon-plus'\" [enabled]=\"true\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'DECIMALES'\" [type]=\"'primary'\" [text]=\"'Cant. Decimales'\" [toolTip]=\"'Cantidad de decimales a mostrar'\" [icon]=\"'glyphicon glyphicon-sound-5-1'\" [enabled]=\"true\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-4\">\n                                              <azteca-form-field [label]=\"'Monto:'\">\n                                                  <az-input-number formControlName=\"monto\" [(ngModel)]=\"sumaDetalle\" format=\"{{formato}}\" [enabled]=\"false\"></az-input-number>\n                                              </azteca-form-field>\n                                          </div>\n                                          <div class=\"col-12 col-md-4\">\n                                              <azteca-form-field [label]=\"'Capturado:'\">\n                                                  <az-input-number formControlName=\"acumulado\" [(ngModel)]=\"acumulado\" format=\"{{formato}}\" [enabled]=\"false\"></az-input-number>\n                                              </azteca-form-field>\n                                          </div>\n                                      </div>\n                                  </div>\n                              </div>\n\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <wj-flex-grid #detailsList style=\"height:550px\"\n                                                    (dataLoaded)=\"onListItemsUpdated($event)\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    (cellEditEnding)=\"cellEditEndingHandler(detailsList, $event)\"\n                                                    (cellEditEnded)=\"onCellEditEnded(detailsList, $event, cell)\"\n                                                    [itemsSource]=\"cuentasXCobrar\"\n                                                    (keydown)=\"keydown(detailsList, $event)\">\n\n                                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                                          <wj-flex-grid-column [header]=\"'Ref CXC'\" [binding]=\"'idCuentaPorCobrar'\" [width]=\"'14*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Ref Origen'\" [binding]=\"'idDocumentoRef'\" [width]=\"'14*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCuentaPorCobrar'\" [width]=\"'10*'\" [isReadOnly]=\"true\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Deudor'\" [binding]=\"'deudor'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"'8*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Folio'\" [binding]=\"'folioFactura'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Vencimiento'\" [binding]=\"'vencimiento'\" [width]=\"'10*'\" [isReadOnly]=\"true\">\n                                              <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                                  <div [ngStyle]=\"{'background-color': getStatusColor(cell.item.vencimiento), 'color': 'white'}\">\n                                                      {{cell.item.vencimiento}}\n                                                  </div>\n                                              </ng-template>\n                                          </wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Cond.Pago'\" [binding]=\"'condicionesPagoText'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Saldo'\" [binding]=\"'saldo'\" [width]=\"'10*'\" dataType=\"Number\" format=\"{{formato}}\" [isReadOnly]=\"true\"> </wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Cobro'\" [binding]=\"'importe'\" [width]=\"'10*'\" dataType=\"Number\" format=\"{{formato}}\" [isReadOnly]=\"condicionesPago == 'E'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Cancelaci\u00F3n'\" [binding]=\"'cancelacionPendiente'\" [width]=\"100\" [isReadOnly]=\"true\">\n                                              <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                                  <div *ngIf=\"cell.item.cancelacionPendiente\" [ngStyle]=\"{'background-color': getStatusColorCancelacion(cell.item.cancelacionPendiente), 'color': 'white'}\">\n                                                      Cancelaci\u00F3n Pendiente\n                                                  </div>\n                                                  <div *ngIf=\"!cell.item.cancelacionPendiente\" [ngStyle]=\"{'background-color': getStatusColorCancelacion(cell.item.cancelacionPendiente), 'color': 'white'}\">\n                                                      Sin Petici\u00F3n\n                                                  </div>\n                                              </ng-template>\n                                          </wj-flex-grid-column>\n                                      </wj-flex-grid>\n                                  </div>\n                              </div>\n\n\n                          </tab>\n\n                              <tab heading=\"Historial\" (select)=\"onTabSelected($event)\">\n                                  <document-history [history]=\"history\"></document-history>\n                              </tab>\n                 </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <credito-nota-detail-editor #detailsEditor            \n                                  [formato] =\"formato\"\n                                  (savingItem)=\"onSavingDetail($event)\"\n                                  (dataLoaded)=\"onDetailsLoaded($event)\">\n\n      </credito-nota-detail-editor>\n\n      <credito-cobranza-detail-editor #cobranzaDetailsEditor\n                                      (savingItem)=\"onSavingCobranzaDetail($event)\"\n                                      (dataLoaded)=\"onDetailsCobranzaLoaded($event)\">\n      </credito-cobranza-detail-editor>\n\n      <div bsModal #dialogDecimales=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\">Cantidad de decimales a mostrar</h4>\n                  </div>\n                  <div class=\"modal-body\">\n                      <az-input-number [(ngModel)]=\"decimales\" format=\"n\" [enabled]=\"true\"></az-input-number>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button class=\"btn btn-primary\" type=\"button\" (click)=\"assignFormat()\">Aceptar</button>\n                      <button class=\"btn btn-danger\" type=\"button\" (click)=\"dialogDecimales.hide()\">Cancelar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return NotasEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: nota_service_1.NotaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            nota_service_1.NotaService,
            forma_pago_service_1.FormaPagoService,
            divisa_service_1.DivisaService,
            contribuyente_service_1.ContribuyenteService,
            nota_tipo_service_1.NotaTipoService])
    ], NotasEditor);
    return NotasEditor;
}(editors_1.DocumentEditor));
exports.NotasEditor = NotasEditor;
