"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var moment = require("moment");
//Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var controls_1 = require("framework3/controls");
//Locales
var cobranza_detail_1 = require("../../models/cobranza-detail");
var cobranza_service_1 = require("../../services/cobranza.service");
var deposito_1 = require("../../models/deposito");
var CobranzaDetailEditor = /** @class */ (function (_super) {
    __extends(CobranzaDetailEditor, _super);
    function CobranzaDetailEditor(context, builder, cobranzaService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.builder = builder;
        _this.cobranzaService = cobranzaService;
        //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
        _this.detailCopy = new cobranza_detail_1.CobranzaDetail();
        //Objeto original que se editará
        _this.detail = new cobranza_detail_1.CobranzaDetail();
        _this.depositosVisible = false;
        _this.details = [];
        _this.dataLoaded = new core_1.EventEmitter();
        _this.busquedaTipos = [];
        _this.fechasFiltro = [];
        _this.fechaSearch = 'F';
        _this.deposito = new deposito_1.DepositoInfo();
        _this.form = builder.group({
            'busqueda': ['', forms_1.Validators.required],
            'idGrupoDeudor': [''],
            'idDeudor': [''],
            'idDeposito': [''],
            'idContribuyente': [''],
            'fechaIni': [new Date()],
            'fechaFin': [new Date()],
            'fechaBusqueda': ['', forms_1.Validators.required],
        });
        _this.form.controls['busqueda'].valueChanges.subscribe(function (value) {
            if (value == 'G') {
                _this.form.controls['idGrupoDeudor'].setValidators(controls_1.AztecaValidators.selected);
            }
            else {
                _this.form.controls['idGrupoDeudor'].setValidators(null);
            }
            if (value == 'D') {
                _this.form.controls['idDeudor'].setValidators(controls_1.AztecaValidators.selected);
            }
            else {
                _this.form.controls['idDeudor'].setValidators(null);
            }
            if (value == 'C') {
                _this.form.controls['idContribuyente'].setValidators(controls_1.AztecaValidators.selected);
            }
            else {
                _this.form.controls['idContribuyente'].setValidators(null);
            }
            if (value == 'X') {
                _this.form.controls['idDeposito'].setValidators(controls_1.AztecaValidators.selected);
            }
            else {
                _this.form.controls['idDeposito'].setValidators(null);
            }
            _this.form.updateValueAndValidity();
        });
        _this.busquedaTipos =
            [
                { "id": "G", "nombre": "Grupo Deudor" },
                { "id": "D", "nombre": "Deudor" },
            ];
        if (_this.depositosVisible)
            _this.busquedaTipos.push({ "id": "X", "nombre": "Deposito" });
        _this.fechasFiltro =
            [
                { "id": "F", "nombre": "Factura" },
                { "id": "V", "nombre": "Vencimiento" }
            ];
        _this.fechaSearch = "F";
        _this.fechaIni = moment().subtract(3, 'months').toDate();
        _this.fechaFin = moment().add(2, 'week').toDate();
        return _this;
    }
    /////////////////// METODOS ///////////////////////////////
    /////////////////// HANDLERS //////////////////////////////
    CobranzaDetailEditor.prototype.onCreatingItem = function () {
        this.fechaSearch = "F";
        this.deposito = new deposito_1.DepositoInfo();
        this.idDeposito = '';
        this.form.reset({ sample: '' });
        this.form.markAsPristine();
        this.fechaIni = moment().subtract(3, 'months').toDate();
        this.fechaFin = moment().add(2, 'week').toDate();
        this.fechaSearch = "F";
        this.form.get('fechaBusqueda').setValue("F");
        if (this.depositosVisible)
            this.busquedaTipos.push({ "id": "X", "nombre": "Deposito" });
    };
    CobranzaDetailEditor.prototype.onLoadingItem = function (detail) {
        this.detailCopy = this.copyItem(this.detail);
        if (this.depositosVisible)
            this.busquedaTipos.push({ "id": "X", "nombre": "Deposito" });
    };
    CobranzaDetailEditor.prototype.onUpdatingItem = function (detail) {
        //if (this.detailCopy._clientID == 0) {
        //    this.detailCopy._clientID = this.createClientID();
        //}
        //else {
        //    this.detailCopy.state = ChangeState.MODIFIED;
        //}
        //this.savingItem.emit(this.detailCopy);
        if (this.deposito.idDeudor > 0) {
            this.idDeudor = this.deposito.idDeudor;
        }
        if (this.deposito.idGrupoDeudor > 0) {
            this.idGrupoDeudor = this.deposito.idGrupoDeudor;
        }
        if (this.tipoBusqueda == "G" || this.deposito.idGrupoDeudor > 0)
            this.loadCxCbyGrupoDeudor();
        else if (this.tipoBusqueda == "D" || this.deposito.idDeudor > 0)
            this.loadCxCbyDeudor();
        else if (this.tipoBusqueda == "C")
            this.loadCxCbyRFC();
    };
    CobranzaDetailEditor.prototype.loadCxCbyGrupoDeudor = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.cobranzaService.loadCxCByGrupoDeudor(moment(this.fechaIni).format(), moment(this.fechaFin).format(), this.idGrupoDeudor, this.fechaSearch)
            .then(function (cxc) {
            _this.context.app.hideSpinner();
            //this.details = cxc;
            _this.dataLoaded.emit(cxc);
        })
            .catch(function (error) { return _this.showAlert(error.message, 'danger'); });
    };
    CobranzaDetailEditor.prototype.loadCxCbyDeudor = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.cobranzaService.loadCxCByDeudor(moment(this.fechaIni).format(), moment(this.fechaFin).format(), this.idDeudor, this.fechaSearch)
            .then(function (cxc) {
            _this.context.app.hideSpinner();
            //this.details = cxc;
            _this.dataLoaded.emit(cxc);
        })
            .catch(function (error) { return _this.showAlert(error.message, 'danger'); });
    };
    CobranzaDetailEditor.prototype.loadCxCbyRFC = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.cobranzaService.loadCxCByRFC(moment(this.fechaIni).format(), moment(this.fechaFin).format(), this.rfc)
            .then(function (cxc) {
            _this.context.app.hideSpinner();
            //this.details = cxc;
            _this.dataLoaded.emit(cxc);
        })
            .catch(function (error) { return _this.showAlert(error.message, 'danger'); });
    };
    CobranzaDetailEditor.prototype.selectedBusqueda = function (item) {
        this.tipoBusqueda = item;
        this.fechaSearch = "F";
    };
    CobranzaDetailEditor.prototype.onGrupoDeudorSelected = function (grupo) {
        this.idGrupoDeudor = grupo.identity;
    };
    CobranzaDetailEditor.prototype.onDeudorSelected = function (deudor) {
        this.idDeudor = deudor.identity;
    };
    CobranzaDetailEditor.prototype.onContribuyenteSelected = function (contribuyente) {
        this.rfc = contribuyente.rfc;
    };
    CobranzaDetailEditor.prototype.onDepositoSelected = function (deposito) {
        this.deposito = deposito;
    };
    CobranzaDetailEditor.prototype.showAlert = function (message, type) {
        this.context.app.hideSpinner();
        this.alerts.showAlert(message, type);
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", cobranza_detail_1.CobranzaDetail)
    ], CobranzaDetailEditor.prototype, "detail", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], CobranzaDetailEditor.prototype, "depositosVisible", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], CobranzaDetailEditor.prototype, "dataLoaded", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], CobranzaDetailEditor.prototype, "alerts", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], CobranzaDetailEditor.prototype, "deposito", void 0);
    CobranzaDetailEditor = __decorate([
        core_1.Component({
            selector: 'credito-cobranza-detail-editor',
            template: "\n      <form [formGroup]=\"form\">\n    \n          <alerts-bar></alerts-bar>\n\n          <azteca-basic-editor [item]=\"detail\"\n                               [dirty]=\"dirty\"\n                               [valid]=\"valid\"\n                               (creatingItem)=\"onCreatingItem()\"\n                               (loadingItem)=\"onLoadingItem($event)\"\n                               (updatingItem)=\"onUpdatingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-6\">\n                      <azteca-form-field [label]=\"'Busqueda de documentos por:'\">\n                          <az-combobox #cboSegmento\n                                       formControlName=\"busqueda\"\n                                       (selectedItemChanged)=\"selectedBusqueda($event)\"\n                                       [items]=\"busquedaTipos\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\">\n                          </az-combobox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-10 col-md-8\">\n                      <azteca-form-field [label]=\"'Grupo deudor:'\" *ngIf=\"tipoBusqueda=='G'\">\n                          <credit-grupo-deudores-selector formControlName=\"idGrupoDeudor\" [(ngModel)]=\"idGrupoDeudor\" ngDefaultControl=\"\" (itemSelected)=\"onGrupoDeudorSelected($event)\"></credit-grupo-deudores-selector>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-10 col-md-8\">\n                      <azteca-form-field [label]=\"'Deudor:'\" *ngIf=\"tipoBusqueda=='D'\">\n                          <credit-deudores-selector formControlName=\"idDeudor\" [(ngModel)]=\"idDeudor\" ngDefaultControl=\"\" (itemSelected)=\"onDeudorSelected($event)\"></credit-deudores-selector>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-10 col-md-8\">\n                      <azteca-form-field [label]=\"'Contribuyente:'\" *ngIf=\"tipoBusqueda=='C'\">\n                          <contabilidad-contribuyente-selector formControlName=\"idContribuyente\" [(ngModel)]=\"id\" ngDefaultControl=\"\" (itemSelected)=\"onContribuyenteSelected($event)\"></contabilidad-contribuyente-selector>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-10 col-md-8\">\n                      <azteca-form-field [label]=\"'Anticipo:'\" *ngIf=\"tipoBusqueda=='A'\">\n                          <credit-anticipo-selector formControlName=\"idAnticipo\" [(ngModel)]=\"idAnticipo\" ngDefaultControl=\"\" (selectedItemChanged)=\"onAnticipoSelected($event)\"></credit-anticipo-selector>\n                      </azteca-form-field>\n                  </div>\n              </div>\n              <div class=\"row\">\n                  <div class=\"col-10 col-md-8\">\n                      <azteca-form-field [label]=\"'Deposito:'\" *ngIf=\"tipoBusqueda=='X'\">\n                          <credit-depositos-selector formControlName=\"idDeposito\" [(ngModel)]=\"idDeposito\" ngDefaultControl=\"\" (selectedItemChanged)=\"onDepositoSelected($event)\"></credit-depositos-selector>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <az-panel [header]=\"'Rango de Fechas'\">\n                  <div class=\"row\">\n                      <div class=\"col-12 col-md-6\">\n                          <azteca-form-field [label]=\"'Filtra por la fecha de:'\">\n                              <az-combobox #cboRango\n                                           formControlName=\"fechaBusqueda\"\n                                           [(ngModel)]=\"fechaSearch\"\n                                           [items]=\"fechasFiltro\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'id'\">\n                              </az-combobox>\n                          </azteca-form-field>\n                      </div>\n                  </div>\n\n                  <div class=\"row\">\n                      <div class=\"col-12 col-md-6\">\n                          <azteca-form-field [label]=\"'Fecha Inicial:'\">\n                              <az-input-date-time [(ngModel)]=\"fechaIni\" formControlName=\"fechaIni\" format='dd-MM-yyyy'></az-input-date-time>\n                          </azteca-form-field>\n                      </div>\n\n                      <div class=\"col-12 col-md-6\">\n                          <azteca-form-field [label]=\"'Fecha Final:'\">\n                              <az-input-date-time [(ngModel)]=\"fechaFin\" formControlName=\"fechaFin\" format='dd-MM-yyyy'></az-input-date-time>\n                          </azteca-form-field>\n                      </div>\n                  </div>\n              </az-panel>\n\n          </azteca-basic-editor>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, cobranza_service_1.CobranzaService])
    ], CobranzaDetailEditor);
    return CobranzaDetailEditor;
}(editors_1.BasicEditor));
exports.CobranzaDetailEditor = CobranzaDetailEditor;
