import { Router } from '@angular/router';
import { FormBuilder, FormGroup } from '@angular/forms';
import { Context } from 'framework3/core';
import { AlertsBarComponent, ToolbarButton } from 'framework3/controls';
import { ContentViewerComponent } from 'framework3/controls/components/content-viewer.component';
import { CuentaPorCobrarService } from '../../services/cuenta-por-cobrar.service';
import { CuentaPorCobrarItem } from '../../models/cuenta-por-cobrar';
export declare class FacturacionComponent {
    private formBuilder;
    private router;
    private cuentaPorCobrarService;
    private context;
    editorForm: FormGroup;
    idGrupoDeudor: number;
    idDeudor: number;
    fechaIni: Date;
    fechaFin: Date;
    cxc: CuentaPorCobrarItem[];
    subtotal: number;
    descuentos: number;
    impuestosTrasladados: number;
    impuestosRetenidos: number;
    total: number;
    detailMode: string;
    detailModeMulti: string;
    series: {
        serie: string;
        total: number;
    }[];
    busquedaTipos: {
        id: string;
        nombre: string;
    }[];
    tipoBusqueda: string;
    private _CacheContribuyentes;
    private _CacheCondiciones;
    private _CacheDeudores;
    private _CacheOrigenes;
    private _CacheCXC;
    alerts: AlertsBarComponent;
    reportViewer: ContentViewerComponent;
    constructor(formBuilder: FormBuilder, router: Router, cuentaPorCobrarService: CuentaPorCobrarService, context: Context);
    onParamsToolbar(button: ToolbarButton): void;
    reset(): void;
    fillCxC(cxc: any): void;
    getContribuyentes(serie: any): any;
    getCondiciones(contribuyente: any): any;
    getDeudores(condiciones: any): any;
    getOrigenes(deudores: any): any;
    getCxC(origen: any): any;
    cellEditEndingHandler(flex: any, e: any): void;
    onCellEditEnded(flex: any, row: any): void;
    calcularAcumulado(): void;
    onAccept(): void;
    showAlert(message: string, type: string): void;
    handleError(error: any): void;
    onGrupoDeudorSelected(grupoDeudor: any): void;
    onDeudorSelected(deudor: any): void;
}
