"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var content_viewer_component_1 = require("framework3/controls/components/content-viewer.component");
//Features
//import { SerieFiscalItem } from '../../../accounting/models/serie-fiscal';
//import { ContribuyenteItem } from '../../../accounting/models/contribuyente';
var cuenta_por_cobrar_service_1 = require("../../services/cuenta-por-cobrar.service");
var moment = require("moment");
var _ = require("lodash");
var wjcGridDetail = require("wijmo/wijmo.grid.detail");
var wjcCore = require("wijmo/wijmo");
//import * as wjcGrid from 'wijmo/wijmo.grid';
var FacturacionComponent = /** @class */ (function () {
    function FacturacionComponent(formBuilder, router, cuentaPorCobrarService, context) {
        this.formBuilder = formBuilder;
        this.router = router;
        this.cuentaPorCobrarService = cuentaPorCobrarService;
        this.context = context;
        this.idDeudor = 0;
        this.cxc = [];
        this.detailMode = wjcGridDetail.DetailVisibilityMode[wjcGridDetail.DetailVisibilityMode.ExpandSingle];
        this.detailModeMulti = wjcGridDetail.DetailVisibilityMode[wjcGridDetail.DetailVisibilityMode.ExpandMulti];
        this.series = [];
        this.busquedaTipos = [];
        this.tipoBusqueda = 'D';
        this._CacheContribuyentes = {};
        this._CacheCondiciones = {};
        this._CacheDeudores = {};
        this._CacheOrigenes = {};
        this._CacheCXC = {};
        this.editorForm = formBuilder.group({
            'fechaIni': [0, forms_1.Validators.required],
            'fechaFin': [0, forms_1.Validators.required],
            'busqueda': ["D"],
            'idGrupoDeudor': [0],
            'idDeudor': [0],
            'subtotal': [0],
            'descuentos': [0],
            'impuestosTrasladados': [0],
            'impuestosRetenidos': [0],
            'total': [0, forms_1.Validators.required],
        });
        this.fechaIni = moment().subtract(2, 'week').toDate();
        //this.fechaFin = moment().add(2, 'week').toDate();
        this.busquedaTipos =
            [
                { "id": "G", "nombre": "Grupo Deudor" },
                { "id": "D", "nombre": "Deudor" },
            ];
    }
    FacturacionComponent.prototype.onParamsToolbar = function (button) {
        var _this = this;
        this.context.app.showSpinner();
        if (button.name == 'REFRESH') {
            var idActor = this.idDeudor;
            if (this.tipoBusqueda == 'G')
                idActor = this.idGrupoDeudor;
            this.cuentaPorCobrarService.loadFacturacionPendiente(this.context.app.defaultSite.identity, this.tipoBusqueda, idActor, this.fechaIni, this.fechaFin)
                .then(function (cxc) {
                _this.context.app.hideSpinner();
                _this.fillCxC(cxc);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    FacturacionComponent.prototype.reset = function () {
        this.cxc = [];
        this.series = [];
        this._CacheContribuyentes = {};
        this._CacheCondiciones = {};
        this._CacheDeudores = {};
        this._CacheOrigenes = {};
        this._CacheCXC = {};
        this.subtotal = 0;
        this.descuentos = 0;
        this.impuestosTrasladados = 0;
        this.impuestosRetenidos = 0;
        this.total = 0;
    };
    FacturacionComponent.prototype.fillCxC = function (cxc) {
        var _this = this;
        var total = 0;
        this.reset();
        this.cxc = cxc;
        var series = _.chain(cxc).map('serie').uniq().value();
        series.forEach(function (serie) {
            total = 0;
            _this.cxc.forEach(function (item) {
                if (item.serie == serie) {
                    total = total + item.total;
                }
            });
            _this.series.push({ 'serie': serie, 'total': total });
        });
    };
    FacturacionComponent.prototype.getContribuyentes = function (serie) {
        var _this = this;
        var total = 0;
        var contribuyentes = [];
        var view = this._CacheContribuyentes[serie.serie];
        if (!view) {
            view = new wjcCore.CollectionView(this.cxc);
            view.filter = function (item) {
                return item.serie == serie.serie;
            };
            var contribuyentesUniques = _.chain(view.sourceCollection).map('contribuyente').uniq().value();
            contribuyentesUniques.forEach(function (contribuyente) {
                total = 0;
                _this.cxc.forEach(function (item) {
                    if (item.serie == serie.serie && item.contribuyente == contribuyente)
                        total = total + item.total;
                });
                if (total != 0)
                    contribuyentes.push({ 'serie': serie.serie, 'contribuyente': contribuyente, 'total': total });
            });
            this._CacheContribuyentes[serie.serie] = contribuyentes;
            view = contribuyentes;
        }
        return view;
    };
    FacturacionComponent.prototype.getCondiciones = function (contribuyente) {
        var _this = this;
        var total = 0;
        var condicionesPago = [];
        var idCache = contribuyente.serie + '|' + contribuyente.contribuyente;
        var view = this._CacheCondiciones[idCache];
        if (!view) {
            view = new wjcCore.CollectionView(this.cxc);
            view.filter = function (item) {
                return item.serie == contribuyente.serie && item.contribuyente == contribuyente.contribuyente;
            };
            var condiciones = _.chain(view.sourceCollection).map('condicionesPago').uniq().value();
            condiciones.forEach(function (condicion) {
                total = 0;
                _this.cxc.forEach(function (item) {
                    if (item.serie == contribuyente.serie && item.contribuyente == contribuyente.contribuyente && item.condicionesPago == condicion)
                        total = total + item.total;
                });
                if (total != 0)
                    condicionesPago.push({ 'serie': contribuyente.serie, 'contribuyente': contribuyente.contribuyente, 'condicionesPago': condicion, 'total': total });
            });
            this._CacheCondiciones[idCache] = condicionesPago;
            view = condicionesPago;
        }
        return view;
    };
    FacturacionComponent.prototype.getDeudores = function (condiciones) {
        var _this = this;
        var total = 0;
        var deudores = [];
        var idCache = condiciones.serie + '|' + condiciones.contribuyente + '|' + condiciones.condicionesPago;
        var view = this._CacheDeudores[idCache];
        if (!view) {
            view = new wjcCore.CollectionView(this.cxc);
            view.filter = function (item) {
                return item.serie == condiciones.serie && item.contribuyente == condiciones.contribuyente && item.condicionesPago == condiciones.condicionesPago;
            };
            var deudoreUniques = _.chain(view.sourceCollection).map('codigoDeudor').uniq().value();
            deudoreUniques.forEach(function (codigoDeudor) {
                total = 0;
                _this.cxc.forEach(function (item) {
                    if (item.serie == condiciones.serie && item.contribuyente == condiciones.contribuyente && item.condicionesPago == condiciones.condicionesPago && item.codigoDeudor == codigoDeudor)
                        total = total + item.total;
                });
                if (total != 0) {
                    var deudor = _this.cxc.find(function (item) { return item.codigoDeudor == codigoDeudor; }).deudor;
                    deudores.push({ 'serie': condiciones.serie, 'contribuyente': condiciones.contribuyente, 'condicionesPago': condiciones.condicionesPago, 'codigoDeudor': codigoDeudor, 'deudor': deudor, 'total': total });
                }
            });
            this._CacheDeudores[idCache] = deudores;
            view = deudores;
        }
        return view;
    };
    FacturacionComponent.prototype.getOrigenes = function (deudores) {
        var _this = this;
        var total = 0;
        var origenes = [];
        var idCache = deudores.serie + '|' + deudores.contribuyente + '|' + deudores.condicionesPago + '|' + deudores.codigoDeudor;
        var view = this._CacheOrigenes[idCache];
        if (!view) {
            view = new wjcCore.CollectionView(this.cxc);
            view.filter = function (item) {
                return item.serie == deudores.serie && item.contribuyente == deudores.contribuyente && item.condicionesPago == deudores.condicionesPago && item.codigoDeudor == deudores.codigoDeudor;
            };
            var origenesUniques = _.chain(view.sourceCollection).map('origen').uniq().value();
            origenesUniques.forEach(function (origen) {
                total = 0;
                _this.cxc.forEach(function (item) {
                    if (item.serie == deudores.serie && item.contribuyente == deudores.contribuyente && item.condicionesPago == deudores.condicionesPago && item.codigoDeudor == deudores.codigoDeudor && item.origen == origen)
                        total = total + item.total;
                });
                if (total != 0)
                    origenes.push({ 'serie': deudores.serie, 'contribuyente': deudores.contribuyente, 'condicionesPago': deudores.condicionesPago, 'codigoDeudor': deudores.codigoDeudor, 'origen': origen, 'total': total });
            });
            this._CacheOrigenes[idCache] = origenes;
            view = origenes;
        }
        return view;
    };
    FacturacionComponent.prototype.getCxC = function (origen) {
        var total = 0;
        var idCache = origen.serie + '|' + origen.contribuyente + '|' + origen.condicionesPago + '|' + origen.codigoDeudor + ' | ' + origen.origen;
        var view = this._CacheCXC[idCache];
        if (!view) {
            view = new wjcCore.CollectionView(this.cxc);
            view.filter = function (item) {
                return item.serie == origen.serie && item.contribuyente == origen.contribuyente && item.condicionesPago == origen.condicionesPago && item.codigoDeudor == origen.codigoDeudor && item.origen == origen.origen;
            };
            this._CacheCXC[idCache] = view._view;
            view = view._view;
        }
        return view;
    };
    FacturacionComponent.prototype.cellEditEndingHandler = function (flex, e) {
        var cxc = flex.rows[e.row].dataItem;
        var validarSerie = this.cxc.find(function (search) { return search.sel == true && search.serie != cxc.serie; });
        if (validarSerie != undefined) {
            e.cancel = true;
            this.showAlert("No puede mezclar documentos de diferentes series", "danger");
        }
        var validarContribuyente = this.cxc.find(function (search) { return search.sel == true && search.contribuyente != cxc.contribuyente; });
        if (validarContribuyente != undefined) {
            e.cancel = true;
            this.showAlert("No puede mezclar documentos de diferentes contribuyentes", "danger");
        }
        var validarCondicionesPago = this.cxc.find(function (search) { return search.sel == true && search.condicionesPago != cxc.condicionesPago; });
        if (validarCondicionesPago != undefined) {
            e.cancel = true;
            this.showAlert("No puede mezclar documentos de diferentes condiciones de pago[Credito/Contado]", "danger");
        }
        this.calcularAcumulado();
    };
    FacturacionComponent.prototype.onCellEditEnded = function (flex, row) {
        this.calcularAcumulado();
    };
    FacturacionComponent.prototype.calcularAcumulado = function () {
        var view = new wjcCore.CollectionView(this.cxc);
        view.filter = function (item) {
            return item.sel == true;
        };
        this.subtotal = view._view
            .map(function (c) { return c.subtotal; })
            .reduce(function (sum, current) { return sum + current; });
        this.descuentos = view._view
            .map(function (c) { return c.descuentos; })
            .reduce(function (sum, current) { return sum + current; });
        this.impuestosTrasladados = view._view
            .map(function (c) { return c.impuestosTrasladados; })
            .reduce(function (sum, current) { return sum + current; });
        this.impuestosRetenidos = view._view
            .map(function (c) { return c.impuestosRetenidos; })
            .reduce(function (sum, current) { return sum + current; });
        this.total = view._view
            .map(function (c) { return c.total; })
            .reduce(function (sum, current) { return sum + current; });
    };
    FacturacionComponent.prototype.onAccept = function () {
        var _this = this;
        var view = new wjcCore.CollectionView(this.cxc);
        view.filter = function (item) {
            return item.sel == true;
        };
        var item = this.cxc.find(function (item) { return item.sel == true; });
        if (item != null)
            this.cuentaPorCobrarService.GeneraFactura(item.idCFDSerie, this.context.app.defaultSite.identity, item.idContribuyente, view._view)
                .then(function (_) {
                _this.showAlert('Se ha generado la factura', 'success');
                _this.reset();
            })
                .catch(function (error) { return _this.handleError(error); });
    };
    FacturacionComponent.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    FacturacionComponent.prototype.handleError = function (error) {
        console.error(error);
        this.alerts.showAlert(error.tostring(), 'danger');
    };
    FacturacionComponent.prototype.onGrupoDeudorSelected = function (grupoDeudor) {
    };
    FacturacionComponent.prototype.onDeudorSelected = function (deudor) {
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], FacturacionComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild(content_viewer_component_1.ContentViewerComponent),
        __metadata("design:type", content_viewer_component_1.ContentViewerComponent)
    ], FacturacionComponent.prototype, "reportViewer", void 0);
    FacturacionComponent = __decorate([
        core_1.Component({
            selector: 'credit-facturacion-component',
            template: "\n      <div class=\"row justify-content-center\">\n          <div class=\"col-12 col-md-11 col-lg-11\">\n              <form [formGroup]=\"editorForm\">\n\n                  <az-panel [header]=\"'Facturaci\u00F3n consolidada'\">\n    \n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-4\">\n                              <azteca-form-field [label]=\"'Busqueda de documentos por:'\">\n                                  <az-combobox \n                                               formControlName=\"busqueda\"\n                                               [items]=\"busquedaTipos\"\n                                               [displayMember]=\"'nombre'\"\n                                               [valueMember]=\"'id'\"\n                                               [(ngModel)]=\"tipoBusqueda\">\n                                  </az-combobox>\n                              </azteca-form-field>\n                          </div>\n                          <!--(selectedItemChanged)=\"selectedBusqueda($event)\"-->\n\n                          <div class=\"col-12 col-md-4\">\n                              <azteca-form-field [label]=\"'Grupo deudor:'\" *ngIf=\"tipoBusqueda=='G'\">\n                                  <credit-grupo-deudores-selector formControlName=\"idGrupoDeudor\" [(ngModel)]=\"idGrupoDeudor\" ngDefaultControl=\"\" (itemSelected)=\"onGrupoDeudorSelected($event)\"></credit-grupo-deudores-selector>\n                              </azteca-form-field>\n                          </div>\n\n\n\n                          <div class=\"col-12 col-md-4\">\n                              <azteca-form-field [label]=\"'Deudor:'\" *ngIf=\"tipoBusqueda=='D'\">\n                                  <credit-deudores-selector formControlName=\"idDeudor\" [(ngModel)]=\"idDeudor\" ngDefaultControl=\"\" (itemSelected)=\"onDeudorSelected($event)\"></credit-deudores-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n                \n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-4\">\n                              <azteca-form-field [label]=\"'Fecha Inicial:'\">\n                                  <az-input-date formControlName=\"fechaIni\" [(ngModel)]=\"fechaIni\"></az-input-date>\n                              </azteca-form-field>\n                          </div>\n\n                          <div class=\"col-12 col-md-4\">\n                              <azteca-form-field [label]=\"'Fecha Final:'\">\n                                  <az-input-date formControlName=\"fechaFin\" [(ngModel)]=\"fechaFin\"></az-input-date>\n                              </azteca-form-field>\n                          </div>\n\n                          <!--<div class=\"col-12 col-md-4\">\n                              <azteca-form-field [label]=\"'Filtrar por deudor (opcional):'\">\n                                  <credit-deudores-selector formControlName=\"deudor\" [(ngModel)]=\"idDeudor\"></credit-deudores-selector>\n                              </azteca-form-field>\n                          </div>-->\n\n                          <az-toolbar (buttonClick)=\"onParamsToolbar($event)\">\n                              <az-toolbar-button [name]=\"'REFRESH'\" [type]=\"'primary'\" [text]=\"'Actualizar listado'\" [icon]=\"'glyphicon glyphicon-refresh'\"></az-toolbar-button>\n                          </az-toolbar>\n\n                      </div>\n\n                      <alerts-bar></alerts-bar>\n\n                      <wj-flex-grid [allowDragging]=\"'Both'\" style=\"height:700px\"\n                                    [itemsSource]=\"series\">\n                          <wj-flex-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"'10*'\"></wj-flex-grid-column> <!-- Agrupar porseries-->\n                          <wj-flex-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"'90*'\"></wj-flex-grid-column>\n\n                          <!-- Anidar por contribuyentes-->\n                          <ng-template wjFlexGridDetail [maxHeight]=\"800\" [detailVisibilityMode]=\"detailMode\" let-item=\"item\" [isAnimated]=\"true\">\n                              <wj-flex-grid [itemsSource]=\"getContribuyentes(item)\" style=\"height:600px\">\n\n                                  <wj-flex-grid-column [header]=\"'Contribuyente'\" [binding]=\"'contribuyente'\" [width]=\"'30*'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"'70*'\"></wj-flex-grid-column>\n\n                                  <!-- Anidar por Condiciones de pago-->\n                                  <ng-template wjFlexGridDetail [maxHeight]=\"800\" [detailVisibilityMode]=\"detailMode\" let-item=\"item\" [isAnimated]=\"true\">\n                                      <wj-flex-grid [itemsSource]=\"getCondiciones(item)\" style=\"height:500px\">\n\n                                          <wj-flex-grid-column [header]=\"'Condiciones Pago'\" [binding]=\"'condicionesPago'\" [width]=\"'30*'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"'70*'\"></wj-flex-grid-column>\n\n                                          <!-- Anidar por Deudores-->\n                                          <ng-template wjFlexGridDetail [maxHeight]=\"800\" [detailVisibilityMode]=\"detailModeMulti\" let-item=\"item\" [isAnimated]=\"true\">\n                                              <wj-flex-grid [itemsSource]=\"getDeudores(item)\" style=\"height:400px\">\n\n                                                  <wj-flex-grid-column [header]=\"'Codigo Deudor'\" [binding]=\"'codigoDeudor'\" [width]=\"'15*'\"></wj-flex-grid-column>\n                                                  <wj-flex-grid-column [header]=\"'Deudor'\" [binding]=\"'deudor'\" [width]=\"'40*'\"></wj-flex-grid-column>\n                                                  <wj-flex-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"'45*'\"></wj-flex-grid-column>\n\n                                                  <!-- Anidar por Origenes-->\n                                                  <ng-template wjFlexGridDetail [maxHeight]=\"800\" [detailVisibilityMode]=\"detailModeMulti\" let-item=\"item\" [isAnimated]=\"true\">\n                                                      <wj-flex-grid [itemsSource]=\"getOrigenes(item)\" style=\"height:300px\">\n\n                                                          <wj-flex-grid-column [header]=\"'Origen'\" [binding]=\"'origen'\" [width]=\"'30*'\"></wj-flex-grid-column>\n                                                          <wj-flex-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"'70*'\"></wj-flex-grid-column>\n\n                                                          <!-- Listar las CXC-->\n                                                          <ng-template wjFlexGridDetail [maxHeight]=\"800\" [detailVisibilityMode]=\"detailModeMulti\" let-item=\"item\" [isAnimated]=\"true\">\n                                                              <wj-flex-grid #grdCxC [itemsSource]=\"getCxC(item)\" style=\"height:200px\"\n                                                                            (cellEditEnding)=\"cellEditEndingHandler(grdCxC, $event)\"\n                                                                            (cellEditEnded)=\"onCellEditEnded(grdCxC, $event)\">\n                                                                  <wj-flex-grid-column [header]=\"''\" [binding]=\"'sel'\" [width]=\"30\"></wj-flex-grid-column>\n                                                                  <wj-flex-grid-column [header]=\"'Cuenta por Cobrar'\" [binding]=\"'id'\" [width]=\"130\"></wj-flex-grid-column>\n                                                                  <wj-flex-grid-column [header]=\"'Fecha'\" [binding]=\"'fecha'\" [width]=\"90\"></wj-flex-grid-column>                                                            \n                                                                  <wj-flex-grid-column [header]=\"'Subtotal'\" [binding]=\"'subtotal'\" [width]=\"90\" dataType=\"Number\"></wj-flex-grid-column>\n                                                                  <wj-flex-grid-column [header]=\"'Descuentos'\" [binding]=\"'descuentos'\" [width]=\"90\" dataType=\"Number\"></wj-flex-grid-column>\n                                                                  <wj-flex-grid-column [header]=\"'Imp.Trasladados'\" [binding]=\"'impuestosTrasladados'\" [width]=\"90\" dataType=\"Number\"></wj-flex-grid-column>\n                                                                  <wj-flex-grid-column [header]=\"'Imp.Retenidos'\" [binding]=\"'impuestosRetenidos'\" [width]=\"90\" dataType=\"Number\"></wj-flex-grid-column>\n                                                                  <wj-flex-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"90\" dataType=\"Number\"></wj-flex-grid-column>\n                                                              </wj-flex-grid>\n                                                          </ng-template>\n\n                                                      </wj-flex-grid>\n                                                  </ng-template>\n\n                                              </wj-flex-grid>\n                                          </ng-template>\n\n                                      </wj-flex-grid>\n                                  </ng-template>\n                              </wj-flex-grid>\n                          </ng-template>\n                      </wj-flex-grid>\n\n\n                      <div class=\"modal-footer\">\n                          <div class=\"row\">\n                              <div class=\"col-12 col-md-2\">\n                                  <azteca-form-field [label]=\"'Subtotal'\">\n                                      <az-input-number formControlName=\"subtotal\" [(ngModel)]=\"subtotal\" format=\"N2\" [enabled]=\"false\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                              <div class=\"col-12 col-md-2\">\n                                  <azteca-form-field [label]=\"'Descuento'\">\n                                      <az-input-number formControlName=\"descuentos\" [(ngModel)]=\"descuentos\" format=\"N2\" [enabled]=\"false\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                              <div class=\"col-12 col-md-2\">\n                                  <azteca-form-field [label]=\"'Imp.Tras.'\">\n                                      <az-input-number formControlName=\"impuestosTrasladados\" [(ngModel)]=\"impuestosTrasladados\" format=\"N2\" [enabled]=\"false\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                              <div class=\"col-12 col-md-2\">\n                                  <azteca-form-field [label]=\"'Imp.Ret.'\">\n                                      <az-input-number formControlName=\"impuestosRetenidos\" [(ngModel)]=\"impuestosRetenidos\" format=\"N2\" [enabled]=\"false\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                              <div class=\"col-12 col-md-2\">\n                                  <azteca-form-field [label]=\"'Total.'\">\n                                      <az-input-number formControlName=\"total\" [(ngModel)]=\"total\" format=\"N2\" [enabled]=\"false\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                              <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAccept()\" [disabled]=\"!editorForm.valid\">Generar</button>\n                          </div>\n\n                      </div> <!--Modal Footer-->\n\n                  </az-panel>\n\n                  <azteca-content-viewer></azteca-content-viewer>\n              </form>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, router_1.Router, cuenta_por_cobrar_service_1.CuentaPorCobrarService, core_2.Context])
    ], FacturacionComponent);
    return FacturacionComponent;
}());
exports.FacturacionComponent = FacturacionComponent;
