import { EventEmitter } from '@angular/core';
import { Router } from '@angular/router';
import { FormBuilder, FormGroup } from '@angular/forms';
import { Context } from 'framework3/core';
import { AlertsBarComponent, ToolbarButton } from 'framework3/controls';
import { CatalogOptions } from 'framework3/custom';
import { FlexGrid } from 'wijmo/wijmo.grid';
import { Menu } from 'wijmo/wijmo.input';
import { CollectionView } from 'wijmo/wijmo';
import { CorteItem } from '../models/caja';
import { CajaService } from '../services/caja.service';
import { CajerosListComponent } from '../dialogs/cajeros-list.component';
import { CorteHistoricoComponent } from '../parts/corte-historico.component';
export declare class CorteComponent {
    private formBuilder;
    private router;
    private context;
    private cajaService;
    editorForm: FormGroup;
    catalogOptions: CatalogOptions;
    cortes: CollectionView;
    idCajero: number;
    alerts: AlertsBarComponent;
    cajerosDialog: CajerosListComponent;
    corteHistoricoDialog: CorteHistoricoComponent;
    contextMenuOpen: EventEmitter<CorteItem>;
    currentItem: CorteItem;
    constructor(formBuilder: FormBuilder, router: Router, context: Context, cajaService: CajaService);
    gridCortesInitialized(sender: FlexGrid, args: any): void;
    mainToolbarHandler(button: ToolbarButton): void;
    loadCortes(): void;
    onMenuItemClicked(menu: Menu, args: any): void;
    onSelectedCajeroChanged(arg: any): void;
    handleError(error: any): void;
    showAlert(message: string, type: string): void;
    showHistoricoCortes(idCaja: number): void;
}
