"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var custom_1 = require("framework3/custom");
//Wijmo
var wijmo_grid_1 = require("wijmo/wijmo.grid");
var wijmo_1 = require("wijmo/wijmo");
var caja_service_1 = require("../services/caja.service");
var cajeros_list_component_1 = require("../dialogs/cajeros-list.component");
var corte_historico_component_1 = require("../parts/corte-historico.component");
var CorteComponent = /** @class */ (function () {
    function CorteComponent(formBuilder, router, context, cajaService) {
        this.formBuilder = formBuilder;
        this.router = router;
        this.context = context;
        this.cajaService = cajaService;
        this.catalogOptions = new custom_1.CatalogOptions();
        this.cortes = new wijmo_1.CollectionView();
        this.contextMenuOpen = new core_1.EventEmitter();
        this.currentItem = null;
        this.editorForm = formBuilder.group({});
    }
    ///////////// SUBPRODUCTOS///////////////////////
    CorteComponent.prototype.gridCortesInitialized = function (sender, args) {
        var _this = this;
        var self = this;
        //Agregar manejador para menú contextual        
        sender.addEventListener(sender.hostElement, "contextmenu", function (e) {
            var ht = sender.hitTest(e);
            sender.select(new wijmo_grid_1.CellRange(ht.row, ht.col), true);
            self.contextMenuOpen.emit(self.currentItem);
        });
        this.cortes.currentChanged.addHandler(function (args) {
            var row = self.cortes.currentItem;
            if (row != null)
                _this.currentItem = { idCorte: row.idCorte, idCaja: row.idCaja, caja: row.caja, cajero: row.cajero, horaApertura: row.horaApertura, horaCierre: row.horaCierre, activo: row.activo, estatus: row.estatus /*, data: row*/ };
            else
                _this.currentItem = null;
            //
            //self.currentItemChanged.emit(self.currentItem);
        }, self);
    };
    CorteComponent.prototype.mainToolbarHandler = function (button) {
        if (button.name == "REFRESH") {
            this.loadCortes();
        }
    };
    CorteComponent.prototype.loadCortes = function () {
        var _this = this;
        this.cajaService.loadCortes(this.context.app.defaultSite.identity)
            .then(function (cortes) { return _this.cortes.sourceCollection = cortes; })
            .catch(function (error) { return _this.showAlert(error.message, "danger"); });
    };
    CorteComponent.prototype.onMenuItemClicked = function (menu, args) {
        var _this = this;
        //this.currentCorte = this.cortes.currentItem;
        if (menu.selectedIndex == 0) {
            if (this.currentItem.idCorte == null || this.currentItem.idCorte == undefined || this.currentItem.idCorte == '00000000-0000-0000-0000-000000000000') {
                //seleccionar el cajero asignado
                this.cajerosDialog.show();
            }
            else
                this.showAlert("La caja ya tiene un corte abierto", "danger");
        }
        if (menu.selectedIndex == 1) {
            //Cerrar
            this.cajaService.cerrar(this.currentItem.idCorte)
                .then(function (cajas) {
                _this.loadCortes();
                _this.showAlert("Se realizo el cierre de corte de caja", "success");
            })
                .catch(function (error) { return _this.showAlert(error.message, "danger"); });
        }
        if (menu.selectedIndex == 3) {
            //Historico
            this.showHistoricoCortes(this.currentItem.idCaja);
        }
    };
    CorteComponent.prototype.onSelectedCajeroChanged = function (arg) {
        var _this = this;
        this.cajaService.abrir(this.currentItem.idCaja, arg.id)
            .then(function (_) {
            _this.loadCortes();
            _this.showAlert("Se realizo la apertura del corte de caja", "success");
        })
            .catch(function (error) { return _this.showAlert(error.message, "danger"); });
    };
    CorteComponent.prototype.handleError = function (error) {
        console.error(error);
    };
    CorteComponent.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    CorteComponent.prototype.showHistoricoCortes = function (idCaja) {
        this.corteHistoricoDialog.show(idCaja);
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], CorteComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild(cajeros_list_component_1.CajerosListComponent),
        __metadata("design:type", cajeros_list_component_1.CajerosListComponent)
    ], CorteComponent.prototype, "cajerosDialog", void 0);
    __decorate([
        core_1.ViewChild(corte_historico_component_1.CorteHistoricoComponent),
        __metadata("design:type", corte_historico_component_1.CorteHistoricoComponent)
    ], CorteComponent.prototype, "corteHistoricoDialog", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], CorteComponent.prototype, "contextMenuOpen", void 0);
    CorteComponent = __decorate([
        core_1.Component({
            selector: 'corte-component',
            template: "\n      <div class=\"row justify-content-center\">\n          <div class=\"col-12 col-md-10 col-lg-8\">\n              <form [formGroup]=\"editorForm\">\n\n                  <alerts-bar></alerts-bar>\n\n                  <az-panel [header]=\"'Cortes de Caja'\">\n                      <az-toolbar (buttonClick)=\"mainToolbarHandler($event)\" (menuItemClick)=\"selectAction($event)\" (openingMenu)=\"onOpeningMenu($event)\">\n                          <az-toolbar-button [name]=\"'REFRESH'\" [type]=\"'primary'\" [text]=\"'Actualizar'\" [icon]=\"'glyphicon glyphicon-refresh'\" [class]=\"'d-none d-lg-block'\"></az-toolbar-button>\n                      </az-toolbar>\n\n                      <div class=\"row\">\n                          <div class=\"col-12\">\n                              <wj-flex-grid #gridCortes style=\"height:550px\"\n                                            [itemsSource]=\"cortes\"\n                                            (initialized)=\"gridCortesInitialized(gridCortes, $event)\"\n                                            [wjContextMenu]=\"ctxMenuCortes\">\n\n                                  <!--<wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\">\n                                              <span class=\"glyphicon glyphicon-pencil\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>-->\n                                  <wj-flex-grid-column [header]=\"'Caja'\" [binding]=\"'nombre'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Cajero'\" [binding]=\"'cajero'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Apertura'\" [binding]=\"'horaApertura'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Cierre'\" [binding]=\"'HoraCierre'\" [width]=\"'15*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </div>\n                      </div>\n\n                  </az-panel>\n\n                  <wj-menu #ctxMenuCortes (itemClicked)=\"onMenuItemClicked(ctxMenuCortes, $event)\" style=\"display:none\">\n                      <wj-menu-item>\n                          <span class=\"glyphicon glyphicon-ok-sign\"></span><b>Abrir</b>\n                          <br />\n                          <small><i>Abrir corte a la caja seleccionada</i></small>\n                      </wj-menu-item>                \n                      <wj-menu-item>\n                          <span class=\"glyphicon glyphicon-remove-sign\"></span><b>Cerrar</b>\n                          <br />\n                          <small><i>Cerrar Corte de la caja seleccionada</i></small>\n                      </wj-menu-item>\n                      <wj-menu-separator></wj-menu-separator>\n                      <wj-menu-item>\n                          <span class=\"glyphicon glyphicon-print\"></span><b>Historial</b>\n                          <br />\n                          <small><i>Historial de cortes</i></small>\n                      </wj-menu-item>\n                  </wj-menu>\n\n              </form>\n          </div>\n      </div>\n\n      <credit-cajeros-list (selectedItemChanged)=\"onSelectedCajeroChanged($event)\"                        \n                           [multiSelect]=\"false\">\n      </credit-cajeros-list>\n\n      <credit-corte-historico-component>\n      </credit-corte-historico-component>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, router_1.Router, core_2.Context, caja_service_1.CajaService])
    ], CorteComponent);
    return CorteComponent;
}());
exports.CorteComponent = CorteComponent;
