import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService, FileLink } from 'framework3/core';
import { CajaInfo, CajaItem, CorteItem } from '../models/caja';
import { UsuarioItem } from 'framework3/core';
export declare class CajaService extends CatalogService<CajaInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<CajaInfo>;
    loadList(idSucursal: number): Promise<CajaItem[]>;
    loadListByUser(idSucursal: number): Promise<CajaItem[]>;
    getMembers(idCaja: number): Promise<UsuarioItem[]>;
    addMembers(idCaja: number, users: UsuarioItem[]): Promise<any>;
    removeMember(idCaja: number, idUser: number): Promise<any>;
    loadCortes(idSucursal: number): Promise<CorteItem[]>;
    abrir(idCaja: number, idCajero: number): Promise<any>;
    cerrar(idCorte: string): Promise<any>;
    loadCortesHistorico(idCaja: number, fechaIni: Date, fechaFin: Date): Promise<CorteItem[]>;
    generarPdfCorte(idCorte: string): Promise<FileLink>;
}
