import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
import { Context, DocumentService } from 'framework3/core';
import { CuentaPorCobrarInfo, CuentaPorCobrarItem } from '../models/cuenta-por-cobrar';
import { EnvioComprobantesItem } from '../../credit/components/envio-comprobantes-fiscales.component';
import { CuentaPorCobrarDetail } from '../models/cuenta-por-cobrar-detail';
export declare class CuentaPorCobrarService extends DocumentService<CuentaPorCobrarDetail, CuentaPorCobrarInfo> {
    protected http: HttpClient;
    protected context: Context;
    constructor(http: HttpClient, context: Context);
    create(): Promise<CuentaPorCobrarInfo>;
    loadFacturacionPendiente(idSucursal: number, tipoActor: string, idActor: number, fechaIni: Date, fechaFin: Date): Promise<CuentaPorCobrarItem[]>;
    GeneraFactura(idCFDSerie: number, idSucursal: number, idContribuyente: number, cxc: CuentaPorCobrarItem[]): Promise<CuentaPorCobrarItem>;
    searchKeyword(idBranch: number, keyword: string, idDeudor: number, idGrupoDeudor: number): Observable<CuentaPorCobrarItem[]>;
    modificarAddenda(data: EnvioComprobantesItem): Promise<any>;
    generarAddendaCustom(idPedidoTit: string, fecha: string, origen: string): Promise<any>;
    requerirCancelacion(idCuentaPorCobrar: string): Promise<string>;
    verficarComprobanteTimbrado(idCuentasPorCobrarTit: string[]): Promise<any>;
}
