"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
//Azteca Framework
var core_2 = require("framework3/core");
//Locales
var cuenta_por_cobrar_1 = require("../models/cuenta-por-cobrar");
var moment = require("moment");
var CuentaPorCobrarService = /** @class */ (function (_super) {
    __extends(CuentaPorCobrarService, _super);
    function CuentaPorCobrarService(http, context) {
        var _this = _super.call(this, http, context, 'api/credito/cuentas-por-cobrar-tit') || this;
        _this.http = http;
        _this.context = context;
        return _this;
    }
    CuentaPorCobrarService.prototype.create = function () {
        var newDoc = new cuenta_por_cobrar_1.CuentaPorCobrarInfo();
        return Promise.resolve(newDoc);
    };
    CuentaPorCobrarService.prototype.loadFacturacionPendiente = function (idSucursal, tipoActor, idActor, fechaIni, fechaFin) {
        var params = new http_1.HttpParams()
            .set('IdSucursal', idSucursal.toString())
            .set('TipoActor', tipoActor)
            .set('IdActor', idActor.toString())
            .set('FechaIni', moment(fechaIni).format())
            .set('FechaFin', moment(fechaFin).format());
        return this.apiService.get('load-facturacion-pendiente', params)
            .toPromise();
    };
    CuentaPorCobrarService.prototype.GeneraFactura = function (idCFDSerie, idSucursal, idContribuyente, cxc) {
        var codigoMetodoPago = '';
        var cuentaBanco = '';
        var params = new http_1.HttpParams()
            .set('IdCFDSerie', idCFDSerie.toString())
            .set('CodigoMetodoPago', codigoMetodoPago)
            .set('CuentaBanco', cuentaBanco)
            .set('IdSucursal', idSucursal.toString())
            .set('IdContribuyente', idContribuyente.toString());
        return this.apiService.post('genera-factura', params, cxc)
            .toPromise();
    };
    CuentaPorCobrarService.prototype.searchKeyword = function (idBranch, keyword, idDeudor, idGrupoDeudor) {
        var params = new http_1.HttpParams()
            .set("idBranch", idBranch.toString())
            .set("keyword", keyword)
            .set("idDeudor", idDeudor.toString())
            .set("idGrupoDeudor", idGrupoDeudor.toString());
        return this.apiService.get("search-cpc", params);
    };
    CuentaPorCobrarService.prototype.modificarAddenda = function (data) {
        var fechaOrdenCompra = moment(data.fechaOrdenCompra).startOf('day').toDate();
        var fechaRemision = moment(data.fechaRemision).startOf('day').toDate();
        var fechaEntrega = moment(data.fechaEntrega).startOf('day').toDate();
        var params = new http_1.HttpParams()
            .set("IdCuentaPorCobrar", data.idCuentaPorCobrarTit)
            .set("OrdenCompra", data.ordenCompra)
            .set("FechaOrdenCompra", moment(fechaOrdenCompra).format())
            .set("NumRemision", data.numRemision)
            .set("FechaRemision", moment(fechaRemision).format())
            .set("FechaEntrega", moment(fechaEntrega).format());
        return this.apiService.post('modificar-addenda', params, data)
            .toPromise();
    };
    CuentaPorCobrarService.prototype.generarAddendaCustom = function (idPedidoTit, fecha, origen) {
        var apiCustom = new core_2.WebService(this.http, 'api/custom/aga/credito/cuentasPorCobrar', this.context);
        //
        var params = new http_1.HttpParams()
            .set("idPedidoTit", idPedidoTit)
            .set("fecha", fecha)
            .set('origen', origen);
        //
        return apiCustom.post('generar-adenda', params, null)
            .toPromise();
    };
    CuentaPorCobrarService.prototype.requerirCancelacion = function (idCuentaPorCobrar) {
        var params = new http_1.HttpParams()
            .set("idCuentaPorCobrar", idCuentaPorCobrar);
        return this.apiService.post('requerir-cancelacion', params, null)
            .toPromise();
    };
    CuentaPorCobrarService.prototype.verficarComprobanteTimbrado = function (idCuentasPorCobrarTit) {
        var params = new http_1.HttpParams();
        return this.apiService.post('verifica-comprobante-timbrado', params, idCuentasPorCobrarTit)
            .toPromise();
    };
    CuentaPorCobrarService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], CuentaPorCobrarService);
    return CuentaPorCobrarService;
}(core_2.DocumentService));
exports.CuentaPorCobrarService = CuentaPorCobrarService;
