import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService } from 'framework3/core';
import { ClasificacionItem } from 'framework3/general';
import { ReporteInfo } from '../models/reporte';
export declare class ReporteService extends CatalogService<ReporteInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<ReporteInfo>;
    printAbonos(fechaIni: Date, fechaFin: Date, tipoAbono: number): Promise<string>;
    printAntiguedadSaldos(idSucursal: number, fechaIni: Date, fechaFin: Date, rango: number): Promise<string>;
    printAntiguedadSaldosDetallado(idSucursal: number, fechaIni: Date, fechaFin: Date, rango: number): Promise<string>;
    printCobranzaImpuestos(fechaIni: Date, fechaFin: Date): Promise<string>;
    printComportamiento(fechaIni: Date, fechaFin: Date, cadenaTipo: number): Promise<string>;
    printControlInventarioEfectoIEPS(fechaIni: Date, fechaFin: Date, aplicaIEPS: number): Promise<string>;
    printCreditosOtogados(fechaIni: Date, fechaFin: Date): Promise<string>;
    printEstructuraClientesCadenas(idRegion: number): Promise<string>;
    loadClasificacionesList(): Promise<ClasificacionItem[]>;
    printEstructuraClasificaciones(idClasificacion: number): Promise<string>;
    printFacturasCredito(fechaIni: Date, fechaFin: Date, idSucursal: number, ruta: string, cliente: string, cadena: string, activas: number): Promise<string>;
    printHistoricoSaldos(fecha: Date): Promise<string>;
    printSaldosCredito(): Promise<string>;
}
