"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var almacen_service_1 = require("../services/almacen.service");
var AlmacenesManager = /** @class */ (function (_super) {
    __extends(AlmacenesManager, _super);
    //    
    function AlmacenesManager(router, route, context, almacenService, location) {
        var _this = _super.call(this, context, router, route) || this;
        _this.router = router;
        _this.route = route;
        _this.context = context;
        _this.almacenService = almacenService;
        _this.location = location;
        _this.almacenes = [];
        _this.route.params.subscribe(function (params) {
            _this.idArea = +params['idArea'];
        });
        return _this;
    }
    AlmacenesManager_1 = AlmacenesManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    AlmacenesManager.prototype.loadAlmacenes = function () {
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    AlmacenesManager.prototype.ngOnInit = function () {
        this.loadAlmacenes();
    };
    AlmacenesManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
        this.refreshList();
    };
    AlmacenesManager.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        var condition = { field: 'idArea', operator: '=', valueType: 'int', value: this.idArea };
        request.conditions.push(condition);
        this.almacenService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.almacenes = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AlmacenesManager.prototype.onAddingItem = function () {
        this.router.navigate([0], { relativeTo: this.route });
    };
    AlmacenesManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    AlmacenesManager.prototype.onEditingItem = function (item) {
        this.router.navigate([item.id], { relativeTo: this.route });
    };
    AlmacenesManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.almacenService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AlmacenesManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    AlmacenesManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.almacenService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AlmacenesManager.prototype.onMenuItemClick = function (item, selectedItem) {
        if (item.name == 'USERS') {
            this.router.navigate(['inventory/almacenes-usuarios/' + this.process.id + '/' + this.manager.currentItem.id.toString()]);
        }
        else if (item.name == 'ALLOWARTICLES') {
            this.router.navigate(['inventory/almacenes-clasificaciones-articulos/' + this.process.id + '/' + this.manager.currentItem.id.toString()]);
        }
        else if (item.name == 'LOCATIONS') {
            this.router.navigate(['inventory/ubicaciones/' + this.process.id + '/' + this.manager.currentItem.id.toString()]);
        }
        else if (item.name == 'EXISTENCES') {
            this.router.navigate(['inventory/almacenes-existencias/' + this.process.id + '/' + this.manager.currentItem.id.toString()]);
        }
        else if (item.name == 'STOCK') {
            this.router.navigate(['inventory/almacenes-stock/' + this.process.id + '/' + this.manager.currentItem.id.toString()]);
        }
        else if (item.name == 'PROVISION') {
            this.router.navigate(['inventory/almacenes-provisiones/' + this.process.id + '/' + this.manager.currentItem.id.toString()]);
        }
    };
    AlmacenesManager.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'CLOSE') {
            this.location.back();
        }
    };
    var AlmacenesManager_1;
    AlmacenesManager = AlmacenesManager_1 = __decorate([
        core_1.Component({
            selector: 'inventario-almacenes-manager',
            template: "\n\n      <div class=\"card\">\n          <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n              <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Regresar'\" [icon]=\"'glyphicon glyphicon-circle-arrow-left'\"></az-toolbar-button>\n          </az-toolbar>\n\n          <div class=\"card-block\">\n              <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                                      (addingItem)=\"onAddingItem()\"\n                                      (viewingItem)=\"onViewingItem($event)\"\n                                      (editingItem)=\"onEditingItem($event)\"\n                                      (deletingItem)=\"onDeletingItem($event)\"\n                                      (cloningItem)=\"onCloningItem($event)\"\n                                      (changingItemState)=\"onChangingItemState($event)\"\n                                      (configureCatalog)=\"onConfigureCatalog($event)\"\n                                      (menuItemClick)=\"onMenuItemClick($event)\"\n                                      [enabled]=\"enabled\"\n                                      [allowNew]=\"allowNew\"\n                                      [allowView]=\"allowView\"\n                                      [allowEdit]=\"allowEdit\"\n                                      [allowDelete]=\"allowDelete\"\n                                      [allowClone]=\"allowClone\"\n                                      [allowChangeState]=\"allowChangeState\"\n                                      [catalogList]=\"almacenes\"\n                                      [totalRows]=\"totalRows\"\n                                      [pageIndex]=\"pageIndex\">\n\n\n                  <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Usuarios'\" [smallText]=\"'configuraci\u00F3n de usuarios'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'LOCATIONS'\" [icon]=\"'glyphicon glyphicon-globe'\" [text]=\"'Ubicaciones'\" [smallText]=\"'configuraci\u00F3n de ubicaciones del almacen'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'ALLOWARTICLES'\" [icon]=\"'glyphicon glyphicon-check'\" [text]=\"'Art. Permitidos'\" [smallText]=\"'configuraci\u00F3n de los articulos permitidos'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'EXISTENCES'\" [icon]=\"'glyphicon glyphicon-edit'\" [text]=\"'Existencias'\" [smallText]=\"'configuraci\u00F3n de existencias'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'STOCK'\" [icon]=\"'glyphicon glyphicon-share'\" [text]=\"'Stock'\" [smallText]=\"'configuraci\u00F3n de stock'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'PROVISION'\" [icon]=\"'glyphicon glyphicon-sort'\" [text]=\"'Almcan\u00E9n de provisi\u00F3n'\" [smallText]=\"'almcan\u00E9nes de provisi\u00F3n'\"></azteca-menu-item>\n\n                  <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n\n\n              </azteca-catalog-manager>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return AlmacenesManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: almacen_service_1.AlmacenService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, core_2.Context, almacen_service_1.AlmacenService, common_1.Location])
    ], AlmacenesManager);
    return AlmacenesManager;
}(editors_1.CatalogManager));
exports.AlmacenesManager = AlmacenesManager;
