"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var area_service_1 = require("../services/area.service");
var area_1 = require("../models/area");
var AreasEditor = /** @class */ (function (_super) {
    __extends(AreasEditor, _super);
    //
    function AreasEditor(router, route, formBuilder, changeDetector, context, location, areaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.areaService = areaService;
        _this.area = new area_1.AreaInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'sample_field': ['']
        });
        return _this;
    }
    AreasEditor_1 = AreasEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    AreasEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    AreasEditor.prototype.onCreatingItem = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.areaService.LoadTurnos(0)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.area.turnos = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AreasEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.areaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.area = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AreasEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.areaService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.area = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AreasEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.areaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.area = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AreasEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        //guardar la información del area
        this.areaService.update(this.area)
            .then(function (info) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.area.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.area = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AreasEditor.prototype.onMenuItemClick = function (item) {
        if (item.name == 'WAREHOUSE') {
            this.router.navigate(['inventory/almacenes/' + this.process.id + '/' + this.area.identity.toString()]);
        }
        else if (item.name == 'USERS') {
            this.router.navigate(['inventory/areas-usuarios/' + this.process.id + '/' + this.area.identity.toString()]);
        }
        /*else if (item.name == 'SHIFT') {

        }*/
    };
    var AreasEditor_1;
    AreasEditor = AreasEditor_1 = __decorate([
        core_1.Component({
            selector: 'inventario-areas-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Area'\"\n                                 [info]=\"area\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'WAREHOUSE'\" [icon]=\"'glyphicon glyphicon-home'\" [text]=\"'Almacenes'\" [smallText]=\"'configuraci\u00F3n de almacenes'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Usuarios'\" [smallText]=\"'configuraci\u00F3n de usuarios'\"></azteca-menu-item>\n              <!--azteca-menu-item [name]=\"'SHIFT'\" [icon]=\"'glyphicon glyphicon-time'\" [text]=\"'Turnos'\" [smallText]=\"'asignar turnos'\"></!--azteca-menu-item>-->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"area.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"area.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                      <label>Turnos</label>\n\n                      <az-checkbox *ngFor=\"let turno of area.turnos\" [label]=\"turno.nombre\" [(ngModel)]=\"turno.selected\" [ngModelOptions]=\"{standalone: true}\"></az-checkbox>\n\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return AreasEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: area_service_1.AreaService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, area_service_1.AreaService])
    ], AreasEditor);
    return AreasEditor;
}(editors_1.CatalogEditor));
exports.AreasEditor = AreasEditor;
