import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogManager } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { ArticuloStockService } from '../services/articulo-stock.service';
import { ArticuloStockItem } from '../models/articulo-stock';
import { MenuItem } from "framework3/controls";
export declare class ArticulosStockManager extends CatalogManager {
    protected router: Router;
    protected route: ActivatedRoute;
    protected context: Context;
    private articuloStockService;
    articulosstock: ArticuloStockItem[];
    constructor(router: Router, route: ActivatedRoute, context: Context, articuloStockService: ArticuloStockService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
    onMenuItemClick(item: MenuItem): void;
}
