"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var articulo_stock_service_1 = require("../services/articulo-stock.service");
var ArticulosStockManager = /** @class */ (function (_super) {
    __extends(ArticulosStockManager, _super);
    //    
    function ArticulosStockManager(router, route, context, articuloStockService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.router = router;
        _this.route = route;
        _this.context = context;
        _this.articuloStockService = articuloStockService;
        return _this;
    }
    ArticulosStockManager_1 = ArticulosStockManager;
    ArticulosStockManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
        this.refreshList();
    };
    ArticulosStockManager.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.articuloStockService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.articulosstock = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosStockManager.prototype.onAddingItem = function () {
        this.router.navigate([0], { relativeTo: this.route });
    };
    ArticulosStockManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    ArticulosStockManager.prototype.onEditingItem = function (item) {
        this.router.navigate([item.id], { relativeTo: this.route });
    };
    ArticulosStockManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.articuloStockService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosStockManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    ArticulosStockManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.articuloStockService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosStockManager.prototype.onMenuItemClick = function (item) {
        if (item.name == 'CONFIG') {
            this.router.navigate(['inventory/articulos-stock-configuracion/' + this.process.id + '/' + this.manager.currentItem.id.toString()]);
        }
        else if (item.name == 'PICS') {
            this.router.navigate(['inventory/articulos-fotografias/' + this.process.id + '/' + this.manager.currentItem.id.toString()]);
        }
        else if (item.name == 'STOCK') {
            this.router.navigate(['inventory/articulos-existencias/' + this.process.id + '/' + this.manager.currentItem.id.toString()]);
        }
    };
    var ArticulosStockManager_1;
    ArticulosStockManager = ArticulosStockManager_1 = __decorate([
        core_1.Component({
            selector: 'inventory-articulos-stock-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Inventario - Art\u00EDculos</div>\n          <div class=\"card-body\">\n              <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                                      (addingItem)=\"onAddingItem()\"\n                                      (viewingItem)=\"onViewingItem($event)\"\n                                      (editingItem)=\"onEditingItem($event)\"\n                                      (deletingItem)=\"onDeletingItem($event)\"\n                                      (cloningItem)=\"onCloningItem($event)\"\n                                      (changingItemState)=\"onChangingItemState($event)\"\n                                      (configureCatalog)=\"onConfigureCatalog($event)\"\n                                      (menuItemClick)=\"onMenuItemClick($event)\"\n                                      [enabled]=\"enabled\"\n                                      [allowNew]=\"allowNew\"\n                                      [allowView]=\"allowView\"\n                                      [allowEdit]=\"allowEdit\"\n                                      [allowDelete]=\"allowDelete\"\n                                      [allowClone]=\"allowClone\"\n                                      [allowChangeState]=\"allowChangeState\"\n                                      [catalogList]=\"articulosstock\"\n                                      [totalRows]=\"totalRows\"\n                                      [pageIndex]=\"pageIndex\">\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'CONFIG'\" [icon]=\"'glyphicon glyphicon-cog'\" [text]=\"'Configuraci\u00F3n de stock'\" [smallText]=\"'configuraci\u00F3n a nivel almac\u00E9n'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'PICS'\" [icon]=\"'glyphicon glyphicon-picture'\" [text]=\"'Fotos'\" [smallText]=\"'fotos del art\u00EDculo'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'STOCK'\" [icon]=\"'glyphicon glyphicon-tasks'\" [text]=\"'Existencias'\" [smallText]=\"'consultar existencias'\"></azteca-menu-item>\n\n                  <!------------------- Columnas --------------------->\n                  <azteca-grid-column [header]=\"'ID'\" [binding]=\"'id'\" dataType=\"Number\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n            \n\n              </azteca-catalog-manager>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ArticulosStockManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: articulo_stock_service_1.ArticuloStockService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, core_2.Context, articulo_stock_service_1.ArticuloStockService])
    ], ArticulosStockManager);
    return ArticulosStockManager;
}(editors_1.CatalogManager));
exports.ArticulosStockManager = ArticulosStockManager;
