"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var concepto_service_1 = require("../services/concepto.service");
var concepto_1 = require("../models/concepto");
var ConceptosEditor = /** @class */ (function (_super) {
    __extends(ConceptosEditor, _super);
    //
    function ConceptosEditor(router, route, formBuilder, changeDetector, context, location, conceptoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.conceptoService = conceptoService;
        _this.concepto = new concepto_1.ConceptoInfo();
        _this.clasificadores = [];
        _this.tipos = [{ id: '', nombre: '[Seleccione tipo]' }, { id: 'E', nombre: 'Entrada' }, { id: 'S', nombre: 'Salida' }, { id: 'T', nombre: 'Traspaso' }];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'tipo': ['', forms_1.Validators.required],
            'diasVigencia': [0],
            'requiereApartado': [false],
            'requiereTransporte': [false],
            'consumirReserva': [false],
            'diasCancelacion': [0],
            'clasificaciones': [[], controls_1.AztecaValidators.validClasifications]
        });
        return _this;
    }
    ConceptosEditor_1 = ConceptosEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ConceptosEditor.prototype.loadClasificadores = function () {
        var _this = this;
        this.conceptoService.loadClassifiers(this.context.app.defaultSite.identity)
            .then(function (clasificadores) { return _this.clasificadores = clasificadores; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ConceptosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.loadClasificadores();
        this.applyPolicies();
    };
    ConceptosEditor.prototype.onCreatingItem = function () {
    };
    ConceptosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.conceptoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.concepto = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.conceptoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.concepto = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.conceptoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.concepto = info;
            if (info.automatico)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.conceptoService.update(this.concepto)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.concepto.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.concepto = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosEditor.prototype.onTabSelect = function (args) {
        if (args.heading) {
            wijmo_1.Control.invalidateAll();
        }
    };
    ConceptosEditor.prototype.onMenuItemClick = function (option) {
        if (option.name == 'USERS') {
            this.router.navigate(['users'], { relativeTo: this.route });
        }
    };
    var ConceptosEditor_1;
    ConceptosEditor = ConceptosEditor_1 = __decorate([
        core_1.Component({
            selector: 'inventario-concepto-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Editar concepto de movimientos'\"\n                                 [info]=\"concepto\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Accesos'\" [smallText]=\"'usuarios con acceso'\"></azteca-menu-item>\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"concepto.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"concepto.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <!--GENERALES-->\n                          <tab heading=\"Generales\">\t\t\t\t\t\t\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'Tipo:'\">\n                                          <az-combobox formControlName=\"tipo\" \n                                                       [(ngModel)]=\"concepto.tipo\" \n                                                       [items]=\"tipos\" \n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>                            \n                              </div>\t\t\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Plazo para terminar su flujo de trabajo (d\u00EDas):'\">\n                                          <az-input-number formControlName=\"diasVigencia\" [(ngModel)]=\"concepto.diasVigencia\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Plazo de cancelaci\u00F3n (d\u00EDas):'\">\n                                          <az-input-number formControlName=\"diasCancelacion\" [(ngModel)]=\"concepto.diasCancelacion\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-4\">\n                                      <az-checkbox formControlName=\"requiereApartado\" [(ngModel)]=\"concepto.requiereApartado\" [label]=\"'Requiere apartado'\"></az-checkbox>\n                                  </div>\n                                  <div class=\"col-12 col-lg-4\">\n                                      <az-checkbox formControlName=\"requiereTransporte\" [(ngModel)]=\"concepto.requiereTransporte\" [label]=\"'Require transporte'\"></az-checkbox>\n                                  </div>\n                                  <div class=\"col-12 col-lg-4\">\n                                      <az-checkbox formControlName=\"consumirReserva\" [(ngModel)]=\"concepto.consumirReserva\" [label]=\"'Consume producto reservado cuando el almac\u00E9n de salida lo maneje'\"></az-checkbox>\n                                  </div>\n                            \n                              </div>\n                          </tab>\n\n                          <!--CLASIFICACIONES-->\n                          <tab heading=\"Clasificaciones\" (select)=\"onTabSelect($event)\">\n                              <az-clasificaciones-editor formControlName=\"clasificaciones\" [(ngModel)]=\"concepto.clasificaciones\" [clasificadores]=\"clasificadores\">\n                              </az-clasificaciones-editor>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ConceptosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: concepto_service_1.ConceptoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, concepto_service_1.ConceptoService])
    ], ConceptosEditor);
    return ConceptosEditor;
}(editors_1.CatalogEditor));
exports.ConceptosEditor = ConceptosEditor;
