import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { ToolbarButton, AzComboboxComponent } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { MetaAlmacenService } from '../services/meta-almacen.service';
import { MetaAlmacenInfo } from '../models/meta-almacen';
import { CollectionView } from 'wijmo/wijmo';
import { AreaItem } from '../models/area';
import { AlmacenItem } from '../models/almacen';
import { AreaService } from '../services/area.service';
import { AlmacenService } from '../services/almacen.service';
export declare class MetaAlmacenesEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private metaAlmacenService;
    private areaService;
    private almacenService;
    metaAlmacen: MetaAlmacenInfo;
    idArea: number;
    idAlmacen: number;
    areas: AreaItem[];
    almacenes: AlmacenItem[];
    almacenesCollection: CollectionView;
    cboAreas: AzComboboxComponent;
    cboAlmacenes: AzComboboxComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, metaAlmacenService: MetaAlmacenService, areaService: AreaService, almacenService: AlmacenService);
    private loadAreas;
    private loadAlmacenes;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onConfirmar(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onRemoveItem(args: EditorEventArgs): void;
    onToolbarButtonClick(button: ToolbarButton): void;
}
