"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var meta_almacen_service_1 = require("../services/meta-almacen.service");
var meta_almacen_1 = require("../models/meta-almacen");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
var area_service_1 = require("../services/area.service");
var almacen_service_1 = require("../services/almacen.service");
//import { AsignarAlmacen } from '../parts/almacen-asignar.component';
var MetaAlmacenesEditor = /** @class */ (function (_super) {
    __extends(MetaAlmacenesEditor, _super);
    //
    function MetaAlmacenesEditor(router, route, formBuilder, changeDetector, context, location, metaAlmacenService, areaService, almacenService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.metaAlmacenService = metaAlmacenService;
        _this.areaService = areaService;
        _this.almacenService = almacenService;
        _this.metaAlmacen = new meta_almacen_1.MetaAlmacenInfo();
        _this.areas = [];
        _this.almacenes = [];
        _this.almacenesCollection = new wijmo_1.CollectionView();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idArea': [0],
            'idAlmacen': [0]
        });
        return _this;
    }
    MetaAlmacenesEditor_1 = MetaAlmacenesEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    MetaAlmacenesEditor.prototype.loadAreas = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.areaService.loadListByUser(this.context.app.defaultSite.identity, this.context.session.user.identity)
            .then(function (areas) {
            _this.areas = areas;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    MetaAlmacenesEditor.prototype.loadAlmacenes = function (idArea) {
        var _this = this;
        this.idAlmacen = 0;
        this.context.app.showSpinner();
        this.almacenService.loadListByUser(idArea, this.context.session.user.identity)
            .then(function (almacenes) {
            _this.almacenes = almacenes.filter(function (almacen) { return almacen.salida; });
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    MetaAlmacenesEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.loadAreas();
    };
    MetaAlmacenesEditor.prototype.onCreatingItem = function () {
        var _this = this;
        this.metaAlmacenService.getMetaAlmacenesSucursales(0, this.context.app.defaultCompany.identity)
            .then(function (almacenes) {
            _this.metaAlmacen.almacenesSucursal = almacenes;
            _this.almacenesCollection.sourceCollection = _this.metaAlmacen.almacenesSucursal;
            _this.almacenesCollection.refresh;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    MetaAlmacenesEditor.prototype.onConfirmar = function () {
    };
    MetaAlmacenesEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.metaAlmacenService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.metaAlmacen = info;
            _this.almacenesCollection.sourceCollection = _this.metaAlmacen.almacenesSucursal;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    MetaAlmacenesEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.metaAlmacenService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.metaAlmacen = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    MetaAlmacenesEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.metaAlmacenService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.metaAlmacen = info;
            _this.almacenesCollection.sourceCollection = _this.metaAlmacen.almacenesSucursal;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    MetaAlmacenesEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.metaAlmacenService.update(this.metaAlmacen)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.metaAlmacen.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    MetaAlmacenesEditor.prototype.onRemoveItem = function (args) {
        var currentSucursal = this.almacenesCollection.currentItem;
        currentSucursal.idAlmacen = 0;
        currentSucursal.idArea = 0;
        currentSucursal.nombreAlmacen = '';
        currentSucursal.nombreArea = '';
        wijmo_1.Control.invalidateAll();
    };
    MetaAlmacenesEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            var currentSucursal = this.almacenesCollection.currentItem;
            currentSucursal.idAlmacen = this.idAlmacen;
            currentSucursal.idArea = this.idArea;
            currentSucursal.nombreAlmacen = this.cboAlmacenes.selectedItem.nombre;
            currentSucursal.nombreArea = this.cboAreas.selectedItem.nombre;
            wijmo_1.Control.invalidateAll();
        }
    };
    var MetaAlmacenesEditor_1;
    __decorate([
        core_1.ViewChild('cboAreas'),
        __metadata("design:type", controls_1.AzComboboxComponent)
    ], MetaAlmacenesEditor.prototype, "cboAreas", void 0);
    __decorate([
        core_1.ViewChild('cboAlmacenes'),
        __metadata("design:type", controls_1.AzComboboxComponent)
    ], MetaAlmacenesEditor.prototype, "cboAlmacenes", void 0);
    MetaAlmacenesEditor = MetaAlmacenesEditor_1 = __decorate([
        core_1.Component({
            selector: 'inventario-meta-almacen-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'MetaAlmacen'\"\n                                 [info]=\"metaAlmacen\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"metaAlmacen.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"metaAlmacen.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Almacenes\">\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-4\">\n                                      <azteca-form-field [label]=\"'\u00C1rea:'\">\n                                          <az-combobox #cboAreas\n                                                       formControlName=\"idArea\"\n                                                       [(ngModel)]=\"idArea\"\n                                                       [items]=\"areas\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       (selectedItemChanged)=\"loadAlmacenes($event)\"></az-combobox>\n                                      </azteca-form-field>\n\n\n                                      <azteca-form-field [label]=\"'Almac\u00E9n:'\">\n                                          <az-combobox #cboAlmacenes\n                                                       formControlName=\"idAlmacen\" [(ngModel)]=\"idAlmacen\" [items]=\"almacenes\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                                      </azteca-form-field>\n\n                                      <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                          <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Asignar'\" [toolTip]=\"'Asignar almac\u00E9n'\" [icon]=\"'glyphicon glyphicon-arrow-right'\" [enabled]=\"true\"></az-toolbar-button>\n                                      </az-toolbar>\n\n                                  </div>\n                                  <div class=\"col-8\">\n                                      <wj-flex-grid #grid style=\"height:550px\"\n                                                    [itemsSource]=\"almacenesCollection\"\n                                                    [wjContextMenu]=\"ctxMenuAlmacenes\"\n                                                    [isReadOnly]=\"false\">\n                                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n\n                                          <wj-flex-grid-column [width]=\"55\" [isReadOnly]=\"true\">\n                                              <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                                  <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveItem(cell.item)\">\n                                                      <span class=\"glyphicon glyphicon-remove-sign\"></span>\n                                                  </button>\n                                              </ng-template>\n                                          </wj-flex-grid-column>\n\n                                          <wj-flex-grid-column [header]=\"'Sucursal'\" [binding]=\"'nombreSucursal'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Almacen'\" [binding]=\"'nombreAlmacen'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Area'\" [binding]=\"'nombreArea'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      </wj-flex-grid>\n                                  </div>\n                              </div>\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n\n\n          </azteca-catalog-editor>\n\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return MetaAlmacenesEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: meta_almacen_service_1.MetaAlmacenService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, meta_almacen_service_1.MetaAlmacenService, area_service_1.AreaService, almacen_service_1.AlmacenService])
    ], MetaAlmacenesEditor);
    return MetaAlmacenesEditor;
}(editors_1.CatalogEditor));
exports.MetaAlmacenesEditor = MetaAlmacenesEditor;
