import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { UnidadMedidaTipoService } from '../services/unidad-medida-tipo.service';
import { UnidadMedidaTipoInfo } from '../models/unidad-medida-tipo';
import { UnidadMedidaItem } from '../models/unidad-medida';
import { UnidadMedidaService } from '../services/unidad-medida.service';
export declare class UnidadesMedidaTipoEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private unidadMedidaTipoService;
    private unidadMedidaService;
    unidadMedidaTipo: UnidadMedidaTipoInfo;
    unidadesMedida: UnidadMedidaItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, unidadMedidaTipoService: UnidadMedidaTipoService, unidadMedidaService: UnidadMedidaService);
    loadUnidadesMedida(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onUnidadesUpdated(): void;
}
