import { EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogManager } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { UnidadMedidaService } from '../services/unidad-medida.service';
import { UnidadMedidaItem } from '../models/unidad-medida';
export declare class UnidadesMedidaManager extends CatalogManager {
    protected router: Router;
    protected route: ActivatedRoute;
    protected context: Context;
    private unidadMedidaService;
    idTipoUnidad: number;
    unidadesMedida: UnidadMedidaItem[];
    listUpdated: EventEmitter<void>;
    constructor(router: Router, route: ActivatedRoute, context: Context, unidadMedidaService: UnidadMedidaService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
}
