"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var stock_1 = require("../models/stock");
var almacen_service_1 = require("../services/almacen.service");
var articulo_stock_service_1 = require("../services/articulo-stock.service");
var inventory_1 = require("../../inventory");
var AlmacenEditarStock = /** @class */ (function (_super) {
    __extends(AlmacenEditarStock, _super);
    function AlmacenEditarStock(almacenService, context, formBuilder, router, route, changeDetector, articulosStockService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.almacenService = almacenService;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.router = router;
        _this.route = route;
        _this.changeDetector = changeDetector;
        _this.articulosStockService = articulosStockService;
        _this.articulosStock = new stock_1.StockInfo();
        _this.tiposInventariocbo = [];
        _this.tiposValuacioncbo = [
            { "id": "N", "name": "Ninguno" },
            { "id": "F", "name": "PEPS" },
            { "id": "L", "name": "UEPS" }
        ];
        //Inputs
        _this.data = new stock_1.StockInfo();
        //outputs
        _this.dataUpdated = new core_1.EventEmitter();
        _this.editorForm = formBuilder.group({
            'articulo': ['', controls_1.AztecaValidators.selected],
            'stockMinimo': [''],
            'stockMaximo': [''],
            'puntoReorden': [''],
            'reserva': [0],
            'ubicaciones': [''],
            'tiposInventario': [0, controls_1.AztecaValidators.selected],
            'controlSerie': [''],
            'controlLotes': [''],
            'controlCaducidad': [''],
            'tiposValuacion': [0, controls_1.AztecaValidators.selected]
        });
        _this.editorForm.controls['controlLotes'].valueChanges.subscribe(function (value) {
            if (value == true) {
                _this.editorForm.controls['tiposValuacion'].setValidators(forms_1.Validators.required);
            }
            else {
                _this.editorForm.controls['tiposValuacion'].setValidators(forms_1.Validators.nullValidator);
                _this.editorForm.controls['tiposValuacion'].setValue('');
            }
            _this.editorForm.updateValueAndValidity();
        });
        return _this;
    }
    AlmacenEditarStock_1 = AlmacenEditarStock;
    AlmacenEditarStock.prototype.show = function () {
        var _this = this;
        this.articulosStock = new stock_1.StockInfo();
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) {
            _this.editorForm.reset();
            _this.articulosStock = _this.data;
            _this.data = new stock_1.StockInfo();
        });
        wijmo_1.Control.invalidateAll();
    };
    AlmacenEditarStock.prototype.ngOnInit = function () {
        var _this = this;
        this.loadTiposInventario();
        this.route.params.forEach(function (param) {
            _this.idAlmacen = +param['idAlmacen'];
        });
    };
    AlmacenEditarStock.prototype.loadTiposInventario = function () {
        var _this = this;
        this.articulosStockService.loadList()
            .then(function (tipos) { return _this.tiposInventariocbo = tipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    AlmacenEditarStock.prototype.onUpdate = function () {
        this.dataUpdated.emit(this.articulosStock);
        this.dialog.hide();
    };
    AlmacenEditarStock.prototype.applyPolicy = function (policy) {
    };
    AlmacenEditarStock.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    var AlmacenEditarStock_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", stock_1.StockInfo)
    ], AlmacenEditarStock.prototype, "data", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], AlmacenEditarStock.prototype, "dataUpdated", void 0);
    __decorate([
        core_1.ViewChild('dialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], AlmacenEditarStock.prototype, "dialog", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], AlmacenEditarStock.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('selectorArticulo'),
        __metadata("design:type", inventory_1.ArticuloStockSelectorComponent)
    ], AlmacenEditarStock.prototype, "selectorArticulo", void 0);
    AlmacenEditarStock = AlmacenEditarStock_1 = __decorate([
        core_1.Component({
            selector: 'inventario-almacen-editar-stock',
            template: "\n      <form [formGroup]=\"editorForm\">\n\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h4 class=\"modal-title\">Agregar Articulo</h4>\n                      </div>\n\n                      <div class=\"modal-body\">\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Articulo:'\">\n                                      <azteca-form-field [label]=\"Articulo\">\n                                          <inventory-articulo-stock-selector formControlName=\"articulo\" [(ngModel)]=\"articulosStock.idArticuloStock\" [showListButton]=\"false\" #selectorArticulo></inventory-articulo-stock-selector>\n                                      </azteca-form-field>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-lg-4\">\n                                  <azteca-form-field [label]=\"'Stock Minimo:'\">\n                                      <az-input-number formControlName=\"stockMinimo\" decimal=\"True\" [(ngModel)]=\"articulosStock.stockMinimo\" [min]=\"0\" [max]=\"articulosStock.stockMaximo\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n\n\n\n                              <div class=\"col-12 col-lg-4\">\n                                  <azteca-form-field [label]=\"'Stock M\u00E1ximo:'\">\n                                      <az-input-number formControlName=\"stockMaximo\" decimal=\"True\" [(ngModel)]=\"articulosStock.stockMaximo\" [min]=\"0\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                    \n                          <div class=\"row\">\n                              <div class=\"col-12 col-lg-4\">\n                                  <azteca-form-field [label]=\"'Punto reorden:'\">\n                                      <az-input-number formControlName=\"puntoReorden\" decimal=\"True\" [(ngModel)]=\"articulosStock.puntoReorden\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                              <div class=\"col-12 col-lg-4\">\n                                  <azteca-form-field [label]=\"'Reserva:'\">\n                                      <az-input-number formControlName=\"reserva\" decimal=\"True\" [(ngModel)]=\"articulosStock.reserva\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                    \n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Ubicacion:'\">\n                                      <azteca-form-field [label]=\"Ubicacion\">\n                                          <inventory-ubicaciones-selector formControlName=\"ubicaciones\" [(ngModel)]=\"articulosStock.idUbicacion\" [showListButton]=\"false\" [idAlmacen]=\"idAlmacen\" #selectorUbicacion></inventory-ubicaciones-selector>\n                                      </azteca-form-field>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <azteca-form-field [label]=\"'Tipo de Inventario:'\">\n                              <az-combobox formControlName=\"tiposInventario\"\n                                           [(ngModel)]=\"articulosStock.idTipoInventario\"\n                                           [items]=\"tiposInventariocbo\"\n                                           [displayMember]=\"'descripcion'\"\n                                           [valueMember]=\"'idTipoInventario'\">\n                              </az-combobox>\n                          </azteca-form-field>\n\n                          <div>\n                              <az-checkbox [label]=\"'Habilitar control por n\u00FAmero de serie'\" formControlName=\"controlSerie\" [(ngModel)]=\"articulosStock.manejaSeries\"></az-checkbox>\n\n                              <az-checkbox [label]=\"'Requiere control por lotes'\" formControlName=\"controlLotes\" [(ngModel)]=\"articulosStock.manejaLotes\"></az-checkbox>\n                        \n                              <az-checkbox [label]=\"'Requiere control de fechas de caducidad'\" formControlName=\"controlCaducidad\" [(ngModel)]=\"articulosStock.manejaCaducidad\"></az-checkbox>\n                          </div>\n\n                          <azteca-form-field [label]=\"'M\u00E9todo Valuaci\u00F3n:'\" *ngIf=\"articulosStock.manejaLotes\">\n                              <az-combobox formControlName=\"tiposValuacion\"\n                                           [(ngModel)]=\"articulosStock.metodoValuacion\"\n                                           [items]=\"tiposValuacioncbo\"\n                                           [displayMember]=\"'name'\"\n                                           [valueMember]=\"'id'\">\n                              </az-combobox>\n                          </azteca-form-field>\n\n                      </div> <!--Modal Body-->\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Cancelar</button>\n                      </div> <!--Modal Footer-->\n\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div><!--Modal directive-->\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return AlmacenEditarStock_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: almacen_service_1.AlmacenService
                }
            ]
        }),
        __metadata("design:paramtypes", [almacen_service_1.AlmacenService, core_2.Context, forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute,
            core_1.ChangeDetectorRef, articulo_stock_service_1.ArticuloStockService])
    ], AlmacenEditarStock);
    return AlmacenEditarStock;
}(editors_1.CatalogEditor));
exports.AlmacenEditarStock = AlmacenEditarStock;
