import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { BaseComponent, Context, CatalogItem } from 'framework3/core';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { PolicyInfo, GrupoService } from 'framework3/core';
import { TrackableCollection } from 'framework3/editors';
import { AlmacenListComponent } from '../dialogs/almacenes-list.component';
import { AlmacenService } from '../services/almacen.service';
import { AlmacenProvisionItem } from '../models/almacen';
export declare class AlmacenProvisionesComponent extends BaseComponent {
    private context;
    private almacenService;
    private grupoService;
    private router;
    private route;
    private location;
    almacenes: AlmacenProvisionItem[];
    idAlmacen: number;
    currentItem: CatalogItem;
    almacenesCollection: TrackableCollection;
    almacenesDialog: AlmacenListComponent;
    alerts: AlertsBarComponent;
    constructor(context: Context, almacenService: AlmacenService, grupoService: GrupoService, router: Router, route: ActivatedRoute, location: Location);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadAlmacen(): void;
    refreshList(): void;
    onCurrentItemChanged(item: CatalogItem): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onSelectedUsersChanged(newAlmacenes: AlmacenProvisionItem[]): void;
    onRemoveUser(item: any): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
