"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//
var core_3 = require("framework3/core");
var editors_1 = require("framework3/editors");
var usuarios_list_component_1 = require("framework3/security/components/dialogs/usuarios-list.component");
var almacen_service_1 = require("../services/almacen.service");
var AlmacenUsuariosComponent = /** @class */ (function (_super) {
    __extends(AlmacenUsuariosComponent, _super);
    //
    function AlmacenUsuariosComponent(context, almacenService, grupoService, router, route, location) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.almacenService = almacenService;
        _this.grupoService = grupoService;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.usuariosCollection = new editors_1.TrackableCollection();
        return _this;
    }
    AlmacenUsuariosComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idAlmacen = +param['idAlmacen'];
        });
    };
    AlmacenUsuariosComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.refreshList(); });
        setTimeout(function (_) { return _this.loadAlmacen(); });
    };
    //////////////////// METODOS /////////////////////////////////////////////////////////
    /*loadGrupo() {
        this.grupoService.getDetailByID(1)
            .then(grupo => this.grupo = grupo)
            .catch(error => this.handleError(error));
    }*/
    AlmacenUsuariosComponent.prototype.loadAlmacen = function () {
        var _this = this;
        this.almacenService.LoadAccessUsersList(this.idAlmacen)
            .then(function (usuarios) { return _this.usuarios = usuarios; })
            .catch(function (error) { return _this.handleError(error); });
    };
    AlmacenUsuariosComponent.prototype.refreshList = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.almacenService.LoadAccessUsersList(this.idAlmacen)
            .then(function (usuarios) {
            _this.usuarios = usuarios;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AlmacenUsuariosComponent.prototype.saveUserList = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.almacenService.updateMembers(this.idAlmacen, this.usuarios)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('Los cambios han sido agregados con éxito.', 'success');
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //////////////////// HANDLERS /////////////////////////////////////////////////////////
    AlmacenUsuariosComponent.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    AlmacenUsuariosComponent.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'SAVE') {
            this.saveUserList();
        }
        if (button.name == 'ADD') {
            this.usuariosDialog.show();
        }
        if (button.name == 'REFRESH') {
            this.refreshList();
        }
        if (button.name == 'CLOSE') {
            this.location.back();
        }
    };
    AlmacenUsuariosComponent.prototype.onSelectedUsersChanged = function (newUsers) {
        var _this = this;
        this.almacenService.addMembers(this.idAlmacen, newUsers)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('Los usuarios han sido agregados con éxito.', 'success');
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AlmacenUsuariosComponent.prototype.onRemoveUser = function (item) {
        var _this = this;
        this.context.app.showSpinner();
        var thisitem = item;
        this.almacenService.removeMember(this.idAlmacen, item.id)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.usuarios = _this.usuarios.filter(function (item) { return item.id != thisitem.id; });
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AlmacenUsuariosComponent.prototype.applyPolicy = function (policy) {
    };
    AlmacenUsuariosComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(usuarios_list_component_1.UsuariosListComponent),
        __metadata("design:type", usuarios_list_component_1.UsuariosListComponent)
    ], AlmacenUsuariosComponent.prototype, "usuariosDialog", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], AlmacenUsuariosComponent.prototype, "alerts", void 0);
    AlmacenUsuariosComponent = __decorate([
        core_1.Component({
            selector: 'inventario-area-usuarios',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-md-10\">\n              <az-panel [header]=\"title\">\n                  <alerts-bar></alerts-bar>\n                  <!--Toolbar Principal-->\n                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                      <az-toolbar-button [name]=\"'SAVE'\" [type]=\"'primary'\" [text]=\"'Guardar'\" [icon]=\"'glyphicon glyphicon-floppy-disk'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar Usuarios'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'REFRESH'\" [text]=\"'Actualizar'\" [icon]=\"'glyphicon glyphicon-refresh'\" [class]=\"'d-none d-lg-block'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Regresar'\" [icon]=\"'glyphicon glyphicon-circle-arrow-left'\"></az-toolbar-button>\n                  </az-toolbar>\n            \n                  <wj-flex-grid #gridUsuarios style=\"height:550px\"\n                                [itemsSource]=\"usuarios\">\n\n                      <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                          <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                              <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveUser(cell.item)\">\n                                  <span class=\"glyphicon glyphicon-trash\"></span>\n                              </button>\n                          </ng-template>\n                      </wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Usuario'\" [binding]=\"'codigo'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>                \n                      <wj-flex-grid-column [header]=\"'Entrada'\" [binding]=\"'entrada'\" [width]=\"'10*'\" [isReadOnly]=\"false\" dataType=\"Boolean\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Salida'\" [binding]=\"'salida'\" [width]=\"'10*'\" [isReadOnly]=\"false\" dataType=\"Boolean\"></wj-flex-grid-column>\n                  </wj-flex-grid>\n          \n              </az-panel>\n          </div>\n      </div>\n\n      <security-usuarios-list (selectedItemsChanged)=\"onSelectedUsersChanged($event)\"\n                              [excludedItems]=\"usuarios\"\n                              [multiSelect]=\"true\">\n\n      </security-usuarios-list>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, almacen_service_1.AlmacenService, core_3.GrupoService, router_1.Router, router_1.ActivatedRoute,
            common_1.Location])
    ], AlmacenUsuariosComponent);
    return AlmacenUsuariosComponent;
}(core_2.BaseComponent));
exports.AlmacenUsuariosComponent = AlmacenUsuariosComponent;
