import { EventEmitter, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormGroup } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, PolicyInfo } from 'framework3/core';
import { AlertsBarComponent } from 'framework3/controls';
import { CatalogEditor } from 'framework3/editors';
import { StockInfo } from '../models/stock';
import { TiposInventarioItem } from '../models/tipo-inventario';
import { AlmacenService } from '../services/almacen.service';
import { ArticuloStockService } from '../services/articulo-stock.service';
import { AlmacenesSelectorComponent } from '../controls/almacenes-selector.component';
export declare class ArticulosEditarStock extends CatalogEditor {
    private almacenService;
    protected context: Context;
    private formBuilder;
    protected router: Router;
    protected route: ActivatedRoute;
    protected changeDetector: ChangeDetectorRef;
    private articulosStockService;
    editorForm: FormGroup;
    articulosStock: StockInfo;
    tiposInventariocbo: TiposInventarioItem[];
    tiposValuacioncbo: {
        id: string;
        name: string;
    }[];
    data: StockInfo;
    dataUpdated: EventEmitter<StockInfo>;
    dialog: ModalDirective;
    alerts: AlertsBarComponent;
    selectorAlmacen: AlmacenesSelectorComponent;
    constructor(almacenService: AlmacenService, context: Context, formBuilder: FormBuilder, router: Router, route: ActivatedRoute, changeDetector: ChangeDetectorRef, articulosStockService: ArticuloStockService);
    show(): void;
    ngOnInit(): void;
    loadTiposInventario(): void;
    onUpdate(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
