"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//
var core_3 = require("framework3/core");
var editors_1 = require("framework3/editors");
var clasificaciones_articulos_list_component_1 = require("./clasificaciones-articulos-list.component");
var almacen_service_1 = require("../services/almacen.service");
var ArticulosPermitidosComponent = /** @class */ (function (_super) {
    __extends(ArticulosPermitidosComponent, _super);
    //
    function ArticulosPermitidosComponent(context, almacenService, grupoService, router, route, location) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.almacenService = almacenService;
        _this.grupoService = grupoService;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.articulosPermitidos = [];
        _this.usuariosCollection = new editors_1.TrackableCollection();
        return _this;
    }
    ArticulosPermitidosComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idAlmacen = +param['idAlmacen'];
        });
    };
    ArticulosPermitidosComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.loadArticulosPermitidos(); });
    };
    //////////////////// METODOS /////////////////////////////////////////////////////////
    ArticulosPermitidosComponent.prototype.loadArticulosPermitidos = function () {
        var _this = this;
        this.almacenService.LoadClasificacionesPermitidas(this.idAlmacen)
            .then(function (articulosPermitidos) {
            _this.articulosPermitidos = articulosPermitidos;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosPermitidosComponent.prototype.actualizarClasificaciones = function (data) {
        var _this = this;
        this.context.app.showSpinner();
        this.almacenService.updateClasificacionesArticulos(this.idAlmacen, data)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('Los cambios han sido agregados con éxito.', 'success');
            _this.loadArticulosPermitidos();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //////////////////// HANDLERS /////////////////////////////////////////////////////////
    ArticulosPermitidosComponent.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    ArticulosPermitidosComponent.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.articulosPermitidosDialog.show();
        }
        if (button.name == 'REFRESH') {
            this.loadArticulosPermitidos();
        }
        if (button.name == 'CLOSE') {
            this.location.back();
        }
    };
    ArticulosPermitidosComponent.prototype.onRemoveClasificacion = function (item) {
        var _this = this;
        this.context.app.showSpinner();
        var thisitem = item;
        this.almacenService.removeClasificacionesArticulos(this.idAlmacen, item.idClasificacion)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.articulosPermitidos = _this.articulosPermitidos.filter(function (item) { return item.idClasificacion != thisitem.idClasificacion; });
            _this.loadArticulosPermitidos();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosPermitidosComponent.prototype.applyPolicy = function (policy) {
    };
    ArticulosPermitidosComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(clasificaciones_articulos_list_component_1.ClasificacionesArticulosComponent),
        __metadata("design:type", clasificaciones_articulos_list_component_1.ClasificacionesArticulosComponent)
    ], ArticulosPermitidosComponent.prototype, "articulosPermitidosDialog", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ArticulosPermitidosComponent.prototype, "alerts", void 0);
    ArticulosPermitidosComponent = __decorate([
        core_1.Component({
            selector: 'inventario-articulos-permitidos',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-md-10\">\n              <az-panel [header]=\"title\">\n                  <alerts-bar></alerts-bar>\n                  <!--Toolbar Principal-->\n                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                      <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar Clasificaciones'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'REFRESH'\" [text]=\"'Actualizar'\" [icon]=\"'glyphicon glyphicon-refresh'\" [class]=\"'d-none d-lg-block'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Regresar'\" [icon]=\"'glyphicon glyphicon-circle-arrow-left'\"></az-toolbar-button>\n                  </az-toolbar>\n            \n                  <wj-flex-grid #gridArticulosPermitidos style=\"height:550px\"\n                                [itemsSource]=\"articulosPermitidos\">\n\n                      <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                          <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                              <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveClasificacion(cell.item)\">\n                                  <span class=\"glyphicon glyphicon-trash\"></span>\n                              </button>\n                          </ng-template>\n                      </wj-flex-grid-column>\n\n\n                      <wj-flex-grid-column [header]=\"'Grupo'\" [binding]=\"'grupo'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Clasificaci\u00F3n'\" [binding]=\"'clasificacion'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  </wj-flex-grid>\n          \n              </az-panel>\n          </div>\n      </div>\n\n      <inventario-clasificaciones-articulos\n                                      (dataUpdated)=\"actualizarClasificaciones($event)\">\n                                      (selectedItemsChanged)=\"onSelectedArtChanged($event)\"\n                                      [excludedItems]=\"articulospermitidos\"\n                                      [multiSelect]=\"true\">\n\n      </inventario-clasificaciones-articulos>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, almacen_service_1.AlmacenService, core_3.GrupoService, router_1.Router, router_1.ActivatedRoute,
            common_1.Location])
    ], ArticulosPermitidosComponent);
    return ArticulosPermitidosComponent;
}(core_2.BaseComponent));
exports.ArticulosPermitidosComponent = ArticulosPermitidosComponent;
