import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { BaseComponent, Context, CatalogItem, PolicyInfo, UsuarioItem } from 'framework3/core';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { UsuariosListComponent } from 'framework3/security';
import { ConceptoInfo } from '../models/concepto';
import { ConceptoService } from '../services/concepto.service';
export declare class ConceptoUsuariosComponent extends BaseComponent {
    private context;
    private conceptoService;
    private router;
    private route;
    private location;
    usuarios: UsuarioItem[];
    idConcepto: number;
    concepto: ConceptoInfo;
    currentItem: CatalogItem;
    readonly title: string;
    usuariosDialog: UsuariosListComponent;
    alerts: AlertsBarComponent;
    constructor(context: Context, conceptoService: ConceptoService, router: Router, route: ActivatedRoute, location: Location);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadConcepto(): void;
    refreshList(): void;
    onCurrentItemChanged(item: CatalogItem): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onSelectedUsersChanged(newUsers: UsuarioItem[]): void;
    onRemoveUser(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
