"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Framework3
var core_2 = require("framework3/core");
var stock_1 = require("../models/stock");
var unidad_medida_1 = require("../models/unidad-medida");
var articulo_stock_service_1 = require("../services/articulo-stock.service");
var ArticuloLotesComponent = /** @class */ (function () {
    function ArticuloLotesComponent(context, articuloService) {
        var _this = this;
        this.context = context;
        this.articuloService = articuloService;
        this.lotes = [];
        this.collectionView = new wijmo_1.CollectionView();
        /////////// INPUTS
        this.idAlmacen = 0;
        this.idArticuloStock = 0;
        this.height = 250;
        /////////// OUTPUTS
        this.lotesChange = new core_1.EventEmitter();
        this.error = new core_1.EventEmitter();
        this.collectionView.collectionChanged.addHandler(function (sender, args) {
            if (args.action == wijmo_1.NotifyCollectionChangedAction.Change && args.item != null) {
                _this.lotesChange.emit(_this.lotes);
            }
        });
    }
    ArticuloLotesComponent.prototype.ngOnChanges = function (changes) {
        if (changes['idAlmacen'] || changes['idArticuloStock'] || changes['unidadMedida']) {
            if (this.idAlmacen > 0 && this.unidadMedida && this.idArticuloStock > 0) {
                this.loadLotes();
            }
        }
    };
    /////////// METHODS
    ArticuloLotesComponent.prototype.loadLotes = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.articuloService.loadExistenciasLote(this.idArticuloStock, this.idAlmacen)
            .then(function (lotes) {
            _this.lotes = lotes;
            _this.collectionView.sourceCollection = _this.lotes;
            _this.lotesChange.emit(_this.lotes);
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticuloLotesComponent.prototype.count = function () {
        return this.lotes.length;
    };
    ArticuloLotesComponent.prototype.quantityFormat = function () {
        if (this.unidadMedida && !this.unidadMedida.paquete && this.unidadMedida.fraccionable) {
            return 'n3';
        }
        else {
            return null;
        }
    };
    /////////// HANDLERS
    ArticuloLotesComponent.prototype.handleError = function (error) {
        console.log(error);
        this.error.emit(error);
        this.context.app.hideSpinner();
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ArticuloLotesComponent.prototype, "idAlmacen", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ArticuloLotesComponent.prototype, "idArticuloStock", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", unidad_medida_1.UnidadMedidaInfo)
    ], ArticuloLotesComponent.prototype, "unidadMedida", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", stock_1.StockInfo)
    ], ArticuloLotesComponent.prototype, "stockConfig", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ArticuloLotesComponent.prototype, "height", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloLotesComponent.prototype, "lotesChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloLotesComponent.prototype, "error", void 0);
    ArticuloLotesComponent = __decorate([
        core_1.Component({
            selector: 'inventory-articulo-lotes',
            template: "\n      <wj-flex-grid [ngStyle]=\"{'height.px': height }\" [itemsSource]=\"collectionView\">       \n          <wj-flex-grid-column [header]=\"'Lote'\" [binding]=\"'id'\" [width]=\"60\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n          <wj-flex-grid-column [header]=\"'Costo'\" [binding]=\"'costo'\" [width]=\"70\" [isReadOnly]=\"true\" [format]=\"'C'\"></wj-flex-grid-column>\n          <wj-flex-grid-column [header]=\"'Caducidad'\" [binding]=\"'fechaCaducidad'\" [width]=\"'10*'\" [isReadOnly]=\"true\" [visible]=\"stockConfig && stockConfig.manejaCaducidad\"></wj-flex-grid-column>\n          <wj-flex-grid-column [header]=\"'Disponible'\" [binding]=\"'cantidadDisponible'\" [width]=\"'15*'\" [isReadOnly]=\"true\" [format]=\"quantityFormat()\"></wj-flex-grid-column>\n          <wj-flex-grid-column [header]=\"'Disponible U.'\" [binding]=\"'unidadesDisponible'\" [width]=\"'15*'\" [isReadOnly]=\"true\" [visible]=\"unidadMedida && unidadMedida.paquete\"></wj-flex-grid-column>\n          <wj-flex-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [width]=\"'20*'\" dataType=\"Number\"></wj-flex-grid-column>\n          <wj-flex-grid-column [header]=\"'Unidades'\" [binding]=\"'unidades'\" [width]=\"'20*'\" dataType=\"Number\" [visible]=\"unidadMedida && unidadMedida.paquete\"></wj-flex-grid-column>\n      </wj-flex-grid>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, articulo_stock_service_1.ArticuloStockService])
    ], ArticuloLotesComponent);
    return ArticuloLotesComponent;
}());
exports.ArticuloLotesComponent = ArticuloLotesComponent;
