"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
//
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
var articulo_stock_service_1 = require("../services/articulo-stock.service");
var ArticuloStockAutocompleteCellComponent = /** @class */ (function (_super) {
    __extends(ArticuloStockAutocompleteCellComponent, _super);
    //Inputs
    function ArticuloStockAutocompleteCellComponent(context, articuloStockService) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.articuloStockService = articuloStockService;
        return _this;
    }
    ArticuloStockAutocompleteCellComponent_1 = ArticuloStockAutocompleteCellComponent;
    ArticuloStockAutocompleteCellComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.itemsSourceHandler = function (keyword, max, callback) { return _this.searchKeyword(keyword, max, callback); };
    };
    ArticuloStockAutocompleteCellComponent.prototype.searchKeyword = function (keyword, max, callback) {
        if (keyword && keyword != '') {
            this.articuloStockService.searchKeyword(this.context.app.defaultSite.identity, keyword)
                .toPromise()
                .then(function (items) { return callback(items); })
                .catch(function (_) { return callback(null); });
        }
        else {
            callback(null);
        }
    };
    var ArticuloStockAutocompleteCellComponent_1;
    ArticuloStockAutocompleteCellComponent = ArticuloStockAutocompleteCellComponent_1 = __decorate([
        core_1.Component({
            selector: 'inventory-articulo-stock-autocomplete-cell',
            template: "\n      <azteca-autocomplete-cell [cell]=\"cell\"\n                                [itemsSourceHandler]=\"itemsSourceHandler\"\n                                [maxItems]=\"maxItems\"\n                                [minLength]=\"minLength\"\n                                [displayMember]=\"displayMember\"\n                                [valueMember]=\"valueMember\"\n                                (selectedItemChanged)=\"onSelectedItemChanged($event)\">\n      </azteca-autocomplete-cell>\n    ",
            providers: [{
                    provide: core_2.BaseComponent,
                    useExisting: core_1.forwardRef(function () { return ArticuloStockAutocompleteCellComponent_1; })
                }]
        }),
        __metadata("design:paramtypes", [core_2.Context, articulo_stock_service_1.ArticuloStockService])
    ], ArticuloStockAutocompleteCellComponent);
    return ArticuloStockAutocompleteCellComponent;
}(search_1.AutocompleteCell));
exports.ArticuloStockAutocompleteCellComponent = ArticuloStockAutocompleteCellComponent;
