import { EventEmitter, SimpleChange, ChangeDetectorRef } from '@angular/core';
import { FormBuilder, ControlValueAccessor } from '@angular/forms';
import { BaseControl } from 'framework3/controls';
import { StockInfo } from '../models/stock';
import { UnidadMedidaItem } from '../models/unidad-medida';
import { UbicacionInfo } from '../models/ubicacion';
import { QuantityInputComponent } from '../controls/quantity-input.component';
export declare class ArticuloStockEntradaComponent extends BaseControl implements ControlValueAccessor {
    private formBuilder;
    private cdRef;
    private form;
    private selectedUM;
    stockConfig: StockInfo;
    idAlmacen: number;
    unidadesMedida: UnidadMedidaItem[];
    cantidad: number;
    unidades: number;
    idUnidadMedida: number;
    costoUnitario: number;
    numeroSerie: string;
    fechaCaducidad: Date;
    idUbicacion: number;
    costoEnabled: boolean;
    unidadMedidaEnabled: boolean;
    enabledCantidad: boolean;
    cantidadChange: EventEmitter<number>;
    unidadesChange: EventEmitter<number>;
    unidadMedidaChange: EventEmitter<number>;
    costoUnitarioChange: EventEmitter<number>;
    numeroSerieChange: EventEmitter<string>;
    fechaCaducidadChange: EventEmitter<Date>;
    idUbicacionChange: EventEmitter<number>;
    validChange: EventEmitter<boolean>;
    fechaHoy: Date;
    quantity: QuantityInputComponent;
    private readonly valid;
    constructor(formBuilder: FormBuilder, cdRef: ChangeDetectorRef);
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChange): void;
    setCurrentUnidad(idUnidadMedida: number): void;
    onUnidadMedidaChanged(idUnidadMedida: number): void;
    onCantidadChange(cantidad: number): void;
    onUnidadesChange(unidades: number): void;
    onCostoChange(costo: number): void;
    onNumSerieChange(numSerie: string): void;
    onFechaCaducidadChange(fecha: Date): void;
    onUbicacionChange(ubicacion: UbicacionInfo): void;
    writeValue(value: any): void;
    propagateChange: (_: any) => void;
    registerOnChange(fn: any): void;
    registerOnTouched(): void;
}
