"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//
var wijmo_1 = require("wijmo/wijmo");
//
var controls_1 = require("framework3/controls");
//
var stock_1 = require("../models/stock");
var metodo_valuacion_1 = require("../models/metodo-valuacion");
var quantity_input_component_1 = require("./quantity-input.component");
var quantity_label_component_1 = require("./quantity-label.component");
var articulo_series_component_1 = require("./articulo-series.component");
var articulo_lotes_component_1 = require("./articulo-lotes.component");
var ArticuloStockSalidaComponent = /** @class */ (function (_super) {
    __extends(ArticuloStockSalidaComponent, _super);
    function ArticuloStockSalidaComponent(formBuilder) {
        var _this = _super.call(this) || this;
        _this.formBuilder = formBuilder;
        _this.costoUnitario = '$0.00';
        _this.disponible = '0';
        _this.idArticuloStock = 0;
        _this.idAlmacen = 0;
        _this.unidadesMedida = [];
        _this.cantidad = 0;
        _this.unidades = 0;
        _this.idUnidadMedida = 0;
        /////////// OUTPUS
        _this.cantidadChange = new core_1.EventEmitter();
        _this.unidadesChange = new core_1.EventEmitter();
        _this.idUnidadMedidaChange = new core_1.EventEmitter();
        _this.validChange = new core_1.EventEmitter();
        _this.lotesChange = new core_1.EventEmitter();
        _this.seriesChange = new core_1.EventEmitter();
        _this.propagateChange = function (_) { };
        //
        _this.form = formBuilder.group({
            'idUnidadMedida': [0],
        });
        //Suscribirse a cambios en la unidad de medida ya que esta determina varios comportamientos en los campos y validaciones
        _this.form.controls['idUnidadMedida'].valueChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.setCurrentUnidad(value); });
        });
        return _this;
    }
    Object.defineProperty(ArticuloStockSalidaComponent.prototype, "valid", {
        get: function () {
            var validControls = true;
            if (this.quantity && this.showQuantity() && this.quantity.total <= 0) {
                validControls = false;
            }
            if (this.seriesControl && this.showSeries() && this.seriesControl.count() <= 0) {
                validControls = false;
            }
            if (this.lotesControl && this.showLotes() && this.lotesControl.count() <= 0) {
                validControls = false;
            }
            return this.form.valid && validControls;
        },
        enumerable: true,
        configurable: true
    });
    ArticuloStockSalidaComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.form.statusChanges.subscribe(function (_) {
            setTimeout(function (_) { return _this.validChange.emit(_this.valid); });
        });
    };
    ArticuloStockSalidaComponent.prototype.ngOnChanges = function (changes) {
        var _this = this;
        var controlUnidadMedida = this.form.controls['idUnidadMedida'];
        if (changes['idUnidadMedida']) {
            if (this.stockConfig && this.stockConfig.manejaLotes && this.stockConfig.metodoValuacion == metodo_valuacion_1.MetodoValuacion.NINGUNO) {
                setTimeout(function (_) { return _this.setCurrentUnidad(_this.idUnidadMedida); });
            }
            else {
                controlUnidadMedida.setValue(this.idUnidadMedida);
            }
        }
        if (changes['unidadesMedida']) {
            setTimeout(function (_) { return _this.setCurrentUnidad(_this.idUnidadMedida); });
        }
        if (this.stockConfig && changes['stockConfig']) {
            //Establecer validadores dependiendo de las opciones del stock
            //Series
            if (this.stockConfig.manejaSeries) {
                if (this.seriesControl) {
                    this.seriesControl.clear();
                }
                controlUnidadMedida.setValidators(null);
            }
            else {
                controlUnidadMedida.setValidators(controls_1.AztecaValidators.selected);
            }
            this.form.updateValueAndValidity();
        }
    };
    /////////// METHODS
    ArticuloStockSalidaComponent.prototype.setCurrentUnidad = function (idUnidadMedida) {
        this.selectedUM = this.unidadesMedida.find(function (u) { return u.id == idUnidadMedida; });
        if (this.quantity) {
            this.quantity.unidadMedida = this.selectedUM;
        }
        //Actualizar valor de existencia disponible y el costo unitario basado en la unidad de medida seleccionada
        if (this.stockConfig && this.selectedUM) {
            this.disponible = (this.stockConfig.disponible / this.selectedUM.factor).toString();
            this.quantityLbl.Show(+this.disponible, this.selectedUM);
            this.costoUnitario = wijmo_1.Globalize.formatNumber((this.stockConfig.costoPromedio * this.selectedUM.factor), 'c');
            if (this.idUnidadMedida == 0 || this.form.controls['idUnidadMedida'].value != this.idUnidadMedida) {
                this.form.controls['idUnidadMedida'].setValue(this.selectedUM.id);
            }
        }
        this.validChange.emit(this.valid);
    };
    ArticuloStockSalidaComponent.prototype.showQuantity = function () {
        if (this.stockConfig) {
            if (this.stockConfig.manejaLotes) {
                if (this.stockConfig.metodoValuacion == metodo_valuacion_1.MetodoValuacion.NINGUNO || this.stockConfig.metodoValuacion == '') {
                    return false;
                }
                else {
                    return true;
                }
            }
            else {
                if (this.stockConfig.manejaSeries) {
                    return false;
                }
                else {
                    return true;
                }
            }
        }
        else {
            return false;
        }
    };
    ArticuloStockSalidaComponent.prototype.showSeries = function () {
        if (this.stockConfig) {
            if (this.stockConfig.manejaSeries) {
                //Si está controlado por series, revisar que además no esté controlado por lotes y algún método de valuación
                if (!this.stockConfig.manejaLotes || (this.stockConfig.metodoValuacion == metodo_valuacion_1.MetodoValuacion.NINGUNO || this.stockConfig.metodoValuacion == '')) {
                    return true;
                }
                else {
                    return false;
                }
            }
            else {
                return false;
            }
        }
        else {
            return false;
        }
    };
    ArticuloStockSalidaComponent.prototype.showLotes = function () {
        if (this.stockConfig) {
            if (this.stockConfig.manejaLotes && !this.stockConfig.manejaSeries && (this.stockConfig.metodoValuacion == metodo_valuacion_1.MetodoValuacion.NINGUNO || this.stockConfig.metodoValuacion == '')) {
                return true;
            }
            else {
                return false;
            }
        }
        else {
            return false;
        }
    };
    /////////// HANDLERS
    ArticuloStockSalidaComponent.prototype.onCantidadChange = function (cantidad) {
        this.cantidadChange.emit(cantidad);
        this.validChange.emit(this.valid);
    };
    ArticuloStockSalidaComponent.prototype.onUnidadesChange = function (unidades) {
        this.unidadesChange.emit(unidades);
        this.validChange.emit(this.valid);
    };
    ArticuloStockSalidaComponent.prototype.onLotesChange = function (lotes) {
        this.lotesChange.emit(lotes);
        this.validChange.emit(this.valid);
    };
    ArticuloStockSalidaComponent.prototype.onSeriesChange = function (series) {
        this.seriesChange.emit(series);
        this.validChange.emit(this.valid);
    };
    //Implementación de control value accesor
    ArticuloStockSalidaComponent.prototype.writeValue = function (value) {
    };
    ArticuloStockSalidaComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    ArticuloStockSalidaComponent.prototype.registerOnTouched = function () { };
    __decorate([
        core_1.Input(),
        __metadata("design:type", stock_1.StockInfo)
    ], ArticuloStockSalidaComponent.prototype, "stockConfig", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ArticuloStockSalidaComponent.prototype, "idArticuloStock", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ArticuloStockSalidaComponent.prototype, "idAlmacen", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], ArticuloStockSalidaComponent.prototype, "unidadesMedida", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ArticuloStockSalidaComponent.prototype, "cantidad", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ArticuloStockSalidaComponent.prototype, "unidades", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ArticuloStockSalidaComponent.prototype, "idUnidadMedida", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockSalidaComponent.prototype, "cantidadChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockSalidaComponent.prototype, "unidadesChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockSalidaComponent.prototype, "idUnidadMedidaChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockSalidaComponent.prototype, "validChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockSalidaComponent.prototype, "lotesChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockSalidaComponent.prototype, "seriesChange", void 0);
    __decorate([
        core_1.ViewChild(quantity_input_component_1.QuantityInputComponent),
        __metadata("design:type", quantity_input_component_1.QuantityInputComponent)
    ], ArticuloStockSalidaComponent.prototype, "quantity", void 0);
    __decorate([
        core_1.ViewChild(quantity_label_component_1.QuantityLabelComponent),
        __metadata("design:type", quantity_label_component_1.QuantityLabelComponent)
    ], ArticuloStockSalidaComponent.prototype, "quantityLbl", void 0);
    __decorate([
        core_1.ViewChild(articulo_series_component_1.ArticuloSeriesComponent),
        __metadata("design:type", articulo_series_component_1.ArticuloSeriesComponent)
    ], ArticuloStockSalidaComponent.prototype, "seriesControl", void 0);
    __decorate([
        core_1.ViewChild(articulo_lotes_component_1.ArticuloLotesComponent),
        __metadata("design:type", articulo_lotes_component_1.ArticuloLotesComponent)
    ], ArticuloStockSalidaComponent.prototype, "lotesControl", void 0);
    ArticuloStockSalidaComponent = __decorate([
        core_1.Component({
            selector: 'inventory-articulo-stock-salida',
            template: "\n      <form [formGroup]=\"form\">\n\n          <!--La unidad de medida no sera visible si se requiere el manejo de numeros de serie-->\n          <div *ngIf=\"stockConfig && !stockConfig.manejaSeries\" class=\"row\">\n              <div class=\"col-12\" *ngIf=\"stockConfig && (!stockConfig.manejaLotes || stockConfig.metodoValuacion != 'N')\">\n                  <azteca-form-field [label]=\"'Unidad de medida:'\">\n                      <az-combobox formControlName=\"idUnidadMedida\"\n                                   [(ngModel)]=\"idUnidadMedida\"\n                                   [items]=\"unidadesMedida\"\n                                   [valueMember]=\"'id'\"\n                                   [displayMember]=\"'nombre'\">\n                      </az-combobox>\n                  </azteca-form-field>\n              </div>\n\n              <div class=\"col-12\" *ngIf=\"stockConfig && stockConfig.manejaLotes && stockConfig.metodoValuacion == 'N'\">\n                  <label class=\"control-label\">Unidad de medida:</label>\n                  <az-label [text]=\"selectedUM ? selectedUM.nombre : ''\"></az-label>\n                  <br />\n              </div>\n          </div>\n          <div class=\"row\">\n              <div *ngIf=\"showQuantity()\" class=\"col-12 col-lg-6\">\n                  <inventory-quantity-input #quantity\n                                            [cantidad]=\"cantidad\"\n                                            [unidades]=\"unidades\"\n                                            [unidadMedida]=\"selectedUM\"\n                                            (cantidadChange)=\"onCantidadChange($event)\"\n                                            (unidadesChange)=\"onUnidadesChange($event)\">\n                  </inventory-quantity-input>\n              </div>\n\n              <div class=\"col-12 col-lg-6\" *ngIf=\"stockConfig && !stockConfig.manejaSeries && (!stockConfig.manejaLotes || stockConfig.metodoValuacion != 'N')\">\n                  <label class=\"control-label\">Costo unitario:</label>\n                  <az-label [text]=\"costoUnitario\"></az-label>\n              </div>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12 col-lg-6\" *ngIf=\"stockConfig && (!stockConfig.manejaLotes || stockConfig.metodoValuacion != 'N')\">\n                  <label class=\"control-label\">Disponible:</label>\n                  <div *ngIf=\"showQuantity()\" class=\"col-12 col-lg-6\">\n                      <inventory-quantity-label #quantityLbl>\n                      </inventory-quantity-label>\n                  </div>\n              </div>\n\n\n\n              <div *ngIf=\"stockConfig && !stockConfig.manejaSeries && (!stockConfig.manejaLotes || stockConfig.metodoValuacion != 'N')\" class=\"col-12 col-lg-6\">\n                  <label class=\"control-label\">Ubicaci\u00F3n:</label>\n                  <az-label [text]=\"stockConfig ? stockConfig.ubicacion : ''\"></az-label>\n              </div>\n          </div>\n\n          <div class=\"row\" *ngIf=\"showLotes()\">\n              <div class=\"col-12\">\n                  <inventory-articulo-lotes [idAlmacen]=\"idAlmacen\"\n                                            [idArticuloStock]=\"idArticuloStock\"\n                                            [stockConfig]=\"stockConfig\"\n                                            [unidadMedida]=\"selectedUM\"\n                                            [height]=\"250\"\n                                            (lotesChange)=\"onLotesChange($event)\">\n                  </inventory-articulo-lotes>\n              </div>\n          </div>\n\n          <div class=\"row\" *ngIf=\"showSeries()\">\n              <div class=\"col-12\">\n                  <br />\n                  <inventario-articulo-series #seriesControl\n                                              [idAlmacen]=\"idAlmacen\"\n                                              [idArticuloStock]=\"idArticuloStock\"\n                                              (seriesChange)=\"onSeriesChange($event)\">\n                  </inventario-articulo-series>\n              </div>\n          </div>\n\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder])
    ], ArticuloStockSalidaComponent);
    return ArticuloStockSalidaComponent;
}(controls_1.BaseControl));
exports.ArticuloStockSalidaComponent = ArticuloStockSalidaComponent;
