"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
//
var core_2 = require("framework3/core");
var index_1 = require("framework3/search/index"); //'../../search/index';
//
var articulo_stock_1 = require("../models/articulo-stock");
var articulo_stock_service_1 = require("../services/articulo-stock.service");
var ArticuloStockSelectorComponent = /** @class */ (function (_super) {
    __extends(ArticuloStockSelectorComponent, _super);
    //
    function ArticuloStockSelectorComponent(context, articuloStockService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.articuloStockService = articuloStockService;
        _this.selectedItem = new articulo_stock_1.ArticuloStockInfo;
        //
        _this.selectedItemChanged = new core_1.EventEmitter();
        _this.keywordSearchSource = rxjs_1.Observable.create(function (observer) {
            observer.next(_this.innerSelector.displayValue);
        })
            .pipe(operators_1.mergeMap(function (keyword) { return _this.findArticulosStock(keyword); }));
        return _this;
    }
    ArticuloStockSelectorComponent_1 = ArticuloStockSelectorComponent;
    ArticuloStockSelectorComponent.prototype.loadItem = function (itemID) {
        var _this = this;
        if (itemID > 0) {
            this.articuloStockService.getDetailByID(itemID)
                .then(function (info) {
                _this.selectedItem = info;
                _this.displayValue = info.code + ' - ' + info.nombre;
                _this.selectedItemChanged.emit(info);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.selectedItem = null;
            this.displayValue = '';
            this.selectedItemChanged.emit(null);
        }
    };
    ArticuloStockSelectorComponent.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.articuloStockService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.articulosstock = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticuloStockSelectorComponent.prototype.findArticulosStock = function (keyword) {
        return this.articuloStockService.searchKeyword2(this.context.session.user.identity, this.context.app.defaultSite.identity, keyword);
    };
    ArticuloStockSelectorComponent.prototype.onKeywordSearch = function (keyword) {
        this.markUnselected();
    };
    var ArticuloStockSelectorComponent_1;
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockSelectorComponent.prototype, "selectedItemChanged", void 0);
    ArticuloStockSelectorComponent = ArticuloStockSelectorComponent_1 = __decorate([
        core_1.Component({
            selector: 'inventory-articulo-stock-selector',
            template: "\n      <azteca-catalog-selector [catalogList]=\"articulosstock\"\n                               [dialogTitle]=\"'Articulos'\"\n                               [displayValue]=\"displayValue\"\n                               [serverSide]=\"true\"\n                               [selectedItem]=\"selectedItem\"\n                               [pageIndex]=\"pageIndex\"\n                               [pageSize]=\"pageSize\"\n                               [totalRows]=\"totalRows\"\n                               [enabled]=\"enabled\"\n                               [visible]=\"visible\"\n                               [dataSource]=\"keywordSearchSource\"\n                               [showListButton]=\"showListButton\"\n                               (selectedItemChanged)=\"itemChangedHandler($event)\"\n                               (keywordSearch)=\"onKeywordSearch($event)\"\n                               (searchRequested)=\"doSearch($event)\">\n\n          <azteca-grid-column [header]=\"'ID'\" [binding]=\"'id'\" [dataType]=\"Number\" [width]=\"'1*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'2*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'3*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'U.M.'\" [binding]=\"'unidadMedida'\" [width]=\"'2*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'C\u00F3digo Barras'\" [binding]=\"'gtin'\" [width]=\"'3*'\"></azteca-grid-column>\n    \n\n      </azteca-catalog-selector>\n    ",
            providers: [{
                    provide: core_2.BaseComponent,
                    useExisting: core_1.forwardRef(function () { return ArticuloStockSelectorComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return ArticuloStockSelectorComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [core_2.Context, articulo_stock_service_1.ArticuloStockService])
    ], ArticuloStockSelectorComponent);
    return ArticuloStockSelectorComponent;
}(index_1.CatalogSelector));
exports.ArticuloStockSelectorComponent = ArticuloStockSelectorComponent;
