"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
//Framework3
var controls_1 = require("framework3/controls");
var inventory_1 = require("../../inventory");
var QuantityLabelComponent = /** @class */ (function (_super) {
    __extends(QuantityLabelComponent, _super);
    function QuantityLabelComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(QuantityLabelComponent.prototype, "quantityFormat", {
        //Formato del campo cantidad, cuando la UM sea piezas el formato sera entero, en caso contrario se permitiran decimales
        get: function () {
            if (this.unidadMedida && this.unidadMedida.fraccionable) {
                return null;
            }
            else {
                return 'n0';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(QuantityLabelComponent.prototype, "quantityClass", {
        get: function () {
            if (this.unidadMedida && this.unidadMedida.paquete) {
                return 'col-12 col-lg-6';
            }
            else {
                return 'col-12';
            }
        },
        enumerable: true,
        configurable: true
    });
    QuantityLabelComponent.prototype.Show = function (cantidad, unidadMedida) {
        var _this = this;
        this.cantidad = cantidad;
        this.unidadMedida = unidadMedida;
        setTimeout(function (_) { return _this.setInfo(); }, 1000);
    };
    QuantityLabelComponent.prototype.setInfo = function () {
        var paquete = new inventory_1.Empaquetado(this.cantidad, this.unidadMedida.factor);
        if (this.lblCantidad)
            this.lblCantidad.text = "";
        if (this.lblUnidades)
            this.lblUnidades.text = "";
        if (this.unidadMedida && this.unidadMedida.fraccionable) {
            this.lblCantidad.text = paquete.cantidad.toString();
        }
        else {
            this.lblCantidad.text = paquete.paquetes.toFixed(0).toString();
        }
        if (this.lblUnidades)
            this.lblUnidades.text = paquete.unidades.toFixed(0).toString();
    };
    __decorate([
        core_1.ViewChild('lblCantidad'),
        __metadata("design:type", controls_1.AzLabelComponent)
    ], QuantityLabelComponent.prototype, "lblCantidad", void 0);
    __decorate([
        core_1.ViewChild('lblUnidades'),
        __metadata("design:type", controls_1.AzLabelComponent)
    ], QuantityLabelComponent.prototype, "lblUnidades", void 0);
    QuantityLabelComponent = __decorate([
        core_1.Component({
            selector: 'inventory-quantity-label',
            template: "\n          <div class=\"row\">\n              <div [class]=\"quantityClass\">\n                  <label class=\"form-control-label\">Cantidad:</label>\n                  <az-label #lblCantidad [text] =\" \"></az-label>\n              </div>\n              <div class=\"col-12 col-lg-6\" *ngIf=\"unidadMedida && unidadMedida.paquete && unidadMedida.factor > 1\">\n                  <label class=\"form-control-label\">Unidades:</label>\n                  <az-label #lblUnidades [text]=\" \"></az-label>\n              </div>\n          </div>\n    "
        })
    ], QuantityLabelComponent);
    return QuantityLabelComponent;
}(controls_1.BaseControl));
exports.QuantityLabelComponent = QuantityLabelComponent;
