import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { ConceptoItem } from '../models/concepto';
import { AlmacenService } from '../services/almacen.service';
import { ConceptoService } from '../services/concepto.service';
import { EntradaService } from '../services/entrada.service';
import { EntradaInfo } from '../models/entrada';
import { EntradaDetail } from '../models/entrada-detail';
import { EntradaDetailEditor } from './parts/entrada-detail.editor';
import { DetailQuantityEditor } from './parts/detail-quantity.editor';
export declare class EntradasEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private entradaService;
    private almacenService;
    private conceptoService;
    entrada: EntradaInfo;
    conceptos: ConceptoItem[];
    detailsList: EditableListComponent;
    detailsEditor: EntradaDetailEditor;
    quantityEditor: DetailQuantityEditor;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, entradaService: EntradaService, almacenService: AlmacenService, conceptoService: ConceptoService);
    loadAlmacenInfo(): void;
    loadConceptos(): void;
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: EntradaDetail): void;
    onDeletingDetail(detail: EntradaDetail): void;
    onListItemsUpdated(updatedDetails: EntradaDetail[]): void;
    onSavingDetail(detail: EntradaDetail): void;
}
