"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Framework3
var core_2 = require("framework3/core");
var empaquetado_1 = require("../../models/empaquetado");
var DetailQuantityEditor = /** @class */ (function () {
    function DetailQuantityEditor(context) {
        this.context = context;
        /////////// INPUTS
        this.cantidad = 0;
        this.unidades = 0;
        /////////// OUTPUS
        this.updateQuantity = new core_1.EventEmitter();
    }
    /////////// METHODS
    DetailQuantityEditor.prototype.show = function () {
        this.dialog.config.backdrop = false;
        this.dialog.show();
    };
    /////////// HANDLERS
    DetailQuantityEditor.prototype.onCantidadChange = function (cantidad) {
        this.cantidad = cantidad;
    };
    DetailQuantityEditor.prototype.onUnidadesChange = function (unidades) {
        this.unidades = unidades;
    };
    DetailQuantityEditor.prototype.onUpdate = function () {
        var result;
        if (this.unidadMedida.paquete) {
            result = new empaquetado_1.Empaquetado(this.cantidad, this.unidadMedida.factor, this.unidades);
        }
        else {
            result = this.cantidad;
        }
        this.updateQuantity.emit(result);
        this.dialog.hide();
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], DetailQuantityEditor.prototype, "cantidad", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], DetailQuantityEditor.prototype, "unidades", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DetailQuantityEditor.prototype, "unidadMedida", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], DetailQuantityEditor.prototype, "updateQuantity", void 0);
    __decorate([
        core_1.ViewChild(ngx_bootstrap_1.ModalDirective),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], DetailQuantityEditor.prototype, "dialog", void 0);
    DetailQuantityEditor = __decorate([
        core_1.Component({
            selector: 'inventario-detail-quantity',
            template: "\n      <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"mySmallModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-sm\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5>Editar cantidades</h5>\n                  </div>\n                  <div class=\"modal-body\">\n                      <inventory-quantity-input #quantity\n                                                [cantidad]=\"cantidad\"\n                                                [unidades]=\"unidades\"\n                                                (cantidadChange)=\"onCantidadChange($event)\"\n                                                (unidadesChange)=\"onUnidadesChange($event)\"\n                                                [unidadMedida]=\"unidadMedida\">\n                      </inventory-quantity-input>\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"quantity <= 0\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Cancelar</button>\n                  </div> <!--Modal Footer-->\n\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context])
    ], DetailQuantityEditor);
    return DetailQuantityEditor;
}());
exports.DetailQuantityEditor = DetailQuantityEditor;
