"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Framework
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var area_service_1 = require("../../services/area.service");
var almacen_service_1 = require("../../services/almacen.service");
var NuevaTransferenciaComponent = /** @class */ (function () {
    function NuevaTransferenciaComponent(formBuilder, router, route, context, areaService, almacenService, sucursalService) {
        var _this = this;
        this.formBuilder = formBuilder;
        this.router = router;
        this.route = route;
        this.context = context;
        this.areaService = areaService;
        this.almacenService = almacenService;
        this.sucursalService = sucursalService;
        this.valid = false;
        this.areas = [];
        this.almacenes = [];
        this.sucursales = [];
        this.form = formBuilder.group({
            'idArea': [0],
            'idAlmacen': [0, controls_1.AztecaValidators.selected],
            'idSucursal': [0, controls_1.AztecaValidators.selected]
        });
        //
        this.form.statusChanges.subscribe(function (_) { return setTimeout(function (_) { return _this.valid = _this.form.valid; }); });
    }
    NuevaTransferenciaComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) {
            _this.loadAreas();
            _this.loadSucursales();
        });
    };
    /////////// METHODS
    NuevaTransferenciaComponent.prototype.loadAreas = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.areaService.loadListByUser(this.context.app.defaultSite.identity, this.context.session.user.identity)
            .then(function (areas) {
            _this.areas = areas;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NuevaTransferenciaComponent.prototype.loadSucursales = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.sucursalService.loadListByUserCompany(this.context.session.user.idBranch, this.context.session.user.identity)
            .then(function (sucursales) {
            _this.sucursales = sucursales;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NuevaTransferenciaComponent.prototype.loadAlmacenes = function (idArea) {
        var _this = this;
        this.idAlmacen = 0;
        this.context.app.showSpinner();
        this.almacenService.loadListByUser(idArea, this.context.session.user.identity)
            .then(function (almacenes) {
            _this.almacenes = almacenes.filter(function (almacen) { return almacen.salida; });
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    /////////// HANDLERS
    NuevaTransferenciaComponent.prototype.onToolbarClick = function (button) {
        if (button.name == 'OK') {
            this.router.navigate(['../', '0', { idAlmacen: this.idAlmacen, idSucursal: this.idSucursal }], { relativeTo: this.route });
        }
        else if (button.name == 'CANCEL') {
            this.router.navigate(['../'], { relativeTo: this.route });
        }
    };
    NuevaTransferenciaComponent.prototype.handleError = function (error) {
        console.log(error);
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alertsBar.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], NuevaTransferenciaComponent.prototype, "alertsBar", void 0);
    NuevaTransferenciaComponent = __decorate([
        core_1.Component({
            selector: 'inventory-nueva-transferencia',
            template: "\n      <form [formGroup]=\"form\">\n          <az-panel [header]=\"'Nueva transferencia entre sucursales - Almac\u00E9n origen'\">\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-8\">\n                      <alerts-bar></alerts-bar>\n                      <az-toolbar (buttonClick)=\"onToolbarClick($event)\">\n                          <az-toolbar-button [name]=\"'OK'\" [type]=\"'primary'\" [text]=\"'Aceptar'\" [icon]=\"'glyphicon glyphicon-ok'\" [enabled]=\"valid\"></az-toolbar-button>\n                          <az-toolbar-button [name]=\"'CANCEL'\" [text]=\"'Cancelar'\" [icon]=\"'glyphicon glyphicon-remove'\"></az-toolbar-button>\n                      </az-toolbar>\n\n                      <azteca-form-field [label]=\"'\u00C1rea:'\">\n                          <az-combobox formControlName=\"idArea\"\n                                       [(ngModel)]=\"idArea\"\n                                       [items]=\"areas\"\n                                       [valueMember]=\"'id'\"\n                                       [displayMember]=\"'nombre'\"\n                                       (selectedItemChanged)=\"loadAlmacenes($event)\"></az-combobox>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Almac\u00E9n:'\">\n                          <az-combobox formControlName=\"idAlmacen\" [(ngModel)]=\"idAlmacen\" [items]=\"almacenes\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Sucursal destino:'\">\n                          <az-combobox formControlName=\"idSucursal\" [(ngModel)]=\"idSucursal\" [items]=\"sucursales\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                      </azteca-form-field>\n\n\n                  </div>\n              </div>\n          </az-panel>\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute,
            core_2.Context, area_service_1.AreaService, almacen_service_1.AlmacenService, core_2.SucursalService])
    ], NuevaTransferenciaComponent);
    return NuevaTransferenciaComponent;
}());
exports.NuevaTransferenciaComponent = NuevaTransferenciaComponent;
