import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { SalidaInfo } from '../models/salida';
import { SalidaDetail } from '../models/salida-detail';
import { SalidaService } from '../services/salida.service';
import { SalidaDetailEditor } from './parts/salida-detail.editor';
import { DetailQuantityEditor } from './parts/detail-quantity.editor';
import { ConceptoItem } from '../models/concepto';
import { AlmacenService } from '../services/almacen.service';
import { ConceptoService } from '../services/concepto.service';
export declare class SalidasEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private salidaService;
    private almacenService;
    private conceptoService;
    salida: SalidaInfo;
    conceptos: ConceptoItem[];
    detailsList: EditableListComponent;
    detailsEditor: SalidaDetailEditor;
    quantityEditor: DetailQuantityEditor;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, salidaService: SalidaService, almacenService: AlmacenService, conceptoService: ConceptoService);
    loadAlmacenInfo(): void;
    loadConceptos(): void;
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: SalidaDetail): void;
    onDeletingDetail(detail: SalidaDetail): void;
    onListItemsUpdated(updatedDetails: SalidaDetail[]): void;
    onSavingDetail(detail: SalidaDetail): void;
    onSavingDetails(details: SalidaDetail[]): void;
    onUpdateQuantity(value: any): void;
}
