"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Inventario
var salida_1 = require("../models/salida");
var salida_detail_1 = require("../models/salida-detail");
var salida_service_1 = require("../services/salida.service");
var salida_detail_editor_1 = require("./parts/salida-detail.editor");
var detail_quantity_editor_1 = require("./parts/detail-quantity.editor");
//
var almacen_service_1 = require("../services/almacen.service");
var concepto_service_1 = require("../services/concepto.service");
var SalidasEditor = /** @class */ (function (_super) {
    __extends(SalidasEditor, _super);
    function SalidasEditor(context, router, route, location, formBuilder, documentTypeService, salidaService, almacenService, conceptoService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.salidaService = salidaService;
        _this.almacenService = almacenService;
        _this.conceptoService = conceptoService;
        _this.salida = new salida_1.SalidaInfo();
        _this.conceptos = [];
        _this.documentForm = formBuilder.group({
            'idConcepto': [0, forms_1.Validators.required],
            'flete': [0],
            'observaciones': ['']
        });
        return _this;
    }
    SalidasEditor_1 = SalidasEditor;
    ////////// METODOS
    SalidasEditor.prototype.loadAlmacenInfo = function () {
        var _this = this;
        this.almacenService.getDetailByID(this.salida.idAlmacen)
            .then(function (almacen) { return _this.salida.almacen = almacen; })
            .catch(function (error) { return _this.handleError(error); });
    };
    SalidasEditor.prototype.loadConceptos = function () {
        var _this = this;
        this.conceptoService.loadListByUser(this.context.app.defaultCompany.identity, this.context.session.user.identity, 'S')
            .then(function (conceptos) { return _this.conceptos = conceptos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ////////// HANDLERS
    SalidasEditor.prototype.onConfigureDocument = function (docType) {
        var _this = this;
        this.applyPolicies();
        //
        setTimeout(function (_) { return _this.loadConceptos(); });
    };
    SalidasEditor.prototype.onCreatingDocument = function () {
        var _this = this;
        //Obtener almacen especificado en el dialogo de nueva entrada
        this.route.params.forEach(function (params) {
            if (params['idAlmacen']) {
                _this.salida.idAlmacen = +params['idAlmacen'];
            }
        });
        if (this.salida.idAlmacen > 0) {
            this.loadAlmacenInfo();
        }
        else {
            this.showAlert('No se ha especificado un almacén destino', 'warning');
        }
    };
    SalidasEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.salidaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.salida = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SalidasEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.salidaService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.salida = doc;
            _this.detailsEditor.clientIndexStart = _this.salida.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SalidasEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.salidaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.salida = doc;
            _this.detailsEditor.clientIndexStart = _this.salida.details.length;
            if (_this.salida.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SalidasEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.salidaService.update(this.salida)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.salida.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.salida = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SalidasEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.salidaService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SalidasEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.salidaService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SalidasEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.salida.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    SalidasEditor.prototype.onAddingDetail = function () {
        this.detailsEditor.detail = new salida_detail_1.SalidaDetail();
        this.detailsEditor.show();
    };
    SalidasEditor.prototype.onEditingDetail = function (detail) {
        if (!detail.stock.manejaSeries) {
            this.quantityEditor.unidadMedida = detail.unidadMedida;
            this.quantityEditor.cantidad = detail.cantidad;
            this.quantityEditor.unidades = detail.unidades;
            this.quantityEditor.show();
        }
    };
    SalidasEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    SalidasEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.salida.details = updatedDetails;
    };
    SalidasEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    SalidasEditor.prototype.onSavingDetails = function (details) {
        this.detailsList.updateItems(details);
    };
    SalidasEditor.prototype.onUpdateQuantity = function (value) {
        var detail = this.detailsList.currentItem;
        if (detail.unidadMedida.paquete) {
            var cantidad = value;
            detail.cantidad = cantidad.paquetes;
            detail.unidades = cantidad.unidades;
        }
        else {
            detail.cantidad = value;
        }
        this.detailsList.updateItem(detail);
    };
    var SalidasEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], SalidasEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", salida_detail_editor_1.SalidaDetailEditor)
    ], SalidasEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild(detail_quantity_editor_1.DetailQuantityEditor),
        __metadata("design:type", detail_quantity_editor_1.DetailQuantityEditor)
    ], SalidasEditor.prototype, "quantityEditor", void 0);
    SalidasEditor = SalidasEditor_1 = __decorate([
        core_1.Component({
            selector: 'inventario-salidas-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'Editar salida de almac\u00E9n'\"\n                                         [document]=\"salida\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <tabset>\n\n                          <!--GENERALES-->\n                          <tab heading=\"Generales\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-10\">\n                                      <label class=\"control-label\">Almac\u00E9n:</label>\n                                      <az-label [text]=\"salida.almacen.nombre\"></az-label>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'Concepto:'\">\n                                          <az-combobox formControlName=\"idConcepto\" [(ngModel)]=\"salida.idConcepto\" [items]=\"conceptos\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'Flete:'\">\n                                          <az-input-number formControlName=\"flete\" [(ngModel)]=\"salida.flete\" format=\"c\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <!--DETALLE-->\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list   #detailsList\n                                                      (addingItem)=\"onAddingDetail()\"\n                                                      (editingItem)=\"onEditingDetail($event)\"\n                                                      (deletingItem)=\"onDeletingDetail($event)\"\n                                                      (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                      [listItems]=\"salida.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'Descripci\u00F3n'\" [binding]=\"'articuloStock.nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'U.M.'\" [binding]=\"'unidadMedida.nombre'\" [width]=\"'30*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [width]=\"'20*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Unidades'\" [binding]=\"'unidades'\" [width]=\"'20*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Lote'\" [binding]=\"'idLote'\" [width]=\"80\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Num. Serie'\" [binding]=\"'numeroSerie'\" [width]=\"'40*'\"></azteca-grid-column>\n\n                              </azteca-editable-list>\n                          </tab>\n\n                          <!--HISTORIAL-->\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"salida.identity == ''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n                      <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'articuloStock.code'\" [width]=\"'30*'\"></azteca-grid-column>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <inventario-salida-detail-editor #detailsEditor\n                                       [idAlmacen]=\"salida.idAlmacen\"\n                                       (savingItem)=\"onSavingDetail($event)\"\n                                       (savingItems)=\"onSavingDetails($event)\">\n\n      </inventario-salida-detail-editor>\n\n      <inventario-detail-quantity (updateQuantity)=\"onUpdateQuantity($event)\">\n\n      </inventario-detail-quantity>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return SalidasEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: salida_service_1.SalidaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            salida_service_1.SalidaService,
            almacen_service_1.AlmacenService,
            concepto_service_1.ConceptoService])
    ], SalidasEditor);
    return SalidasEditor;
}(editors_1.DocumentEditor));
exports.SalidasEditor = SalidasEditor;
