import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo, SucursalService } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { TransferenciaInfo } from '../models/transferencia';
import { TransferenciaDetail } from '../models/transferencia-detail';
import { TransferenciaService } from '../services/transferencia.service';
import { TransferenciaDetailEditor } from './parts/transferencias-tit-detail.editor';
import { TrensferenciaAceptarComponent } from '../parts/transferencia-aceptar.component';
import { AreaInfo } from '../models/area';
import { AlmacenService } from '../services/almacen.service';
export declare class TransferenciasTitEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private transferenciaService;
    private almacenService;
    private sucursalService;
    transferencia: TransferenciaInfo;
    areaOrigen: AreaInfo;
    argsCurrentDocument: WorkflowEventArgs;
    detailsList: EditableListComponent;
    detailsEditor: TransferenciaDetailEditor;
    dlgTransferenciaAceptar: TrensferenciaAceptarComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, transferenciaService: TransferenciaService, almacenService: AlmacenService, sucursalService: SucursalService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: TransferenciaDetail): void;
    onDeletingDetail(detail: TransferenciaDetail): void;
    onListItemsUpdated(updatedDetails: TransferenciaDetail[]): void;
    onSavingDetail(detail: TransferenciaDetail): void;
    onSavingDetails(details: TransferenciaDetail[]): void;
    onUpdateQuantity(value: any): void;
    loadAlmacenInfo(): void;
    loadSucursalInfo(): void;
}
