"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var transferencia_1 = require("../models/transferencia");
var transferencia_detail_1 = require("../models/transferencia-detail");
var transferencia_service_1 = require("../services/transferencia.service");
var transferencias_tit_detail_editor_1 = require("./parts/transferencias-tit-detail.editor");
var transferencia_aceptar_component_1 = require("../parts/transferencia-aceptar.component");
var area_1 = require("../models/area");
var almacen_service_1 = require("../services/almacen.service");
var TransferenciasTitEditor = /** @class */ (function (_super) {
    __extends(TransferenciasTitEditor, _super);
    function TransferenciasTitEditor(context, router, route, location, formBuilder, documentTypeService, transferenciaService, almacenService, sucursalService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.transferenciaService = transferenciaService;
        _this.almacenService = almacenService;
        _this.sucursalService = sucursalService;
        _this.transferencia = new transferencia_1.TransferenciaInfo();
        _this.areaOrigen = new area_1.AreaInfo();
        _this.documentForm = formBuilder.group({
            'idAreaOrigen': [0],
            'idAlmacenOrigen': [0],
            'observaciones': ['', forms_1.Validators.required],
        });
        return _this;
    }
    TransferenciasTitEditor_1 = TransferenciasTitEditor;
    TransferenciasTitEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
    };
    TransferenciasTitEditor.prototype.onCreatingDocument = function () {
        var _this = this;
        //Obtener almacen especificado en el dialogo de nueva entrada
        this.route.params.forEach(function (params) {
            if (params['idAlmacen']) {
                _this.transferencia.idAlmacenOrigen = +params['idAlmacen'];
            }
            if (params['idSucursal']) {
                _this.transferencia.idSucursalDestino = +params['idSucursal'];
            }
        });
        if (this.transferencia.idAlmacenOrigen > 0) {
            this.loadAlmacenInfo();
            this.loadSucursalInfo();
        }
        else {
            this.showAlert('No se ha especificado un almacén destino', 'warning');
        }
    };
    TransferenciasTitEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.transferenciaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.transferencia = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TransferenciasTitEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.transferenciaService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.transferencia = doc;
            _this.detailsEditor.clientIndexStart = _this.transferencia.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TransferenciasTitEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.transferenciaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.transferencia = doc;
            _this.detailsEditor.clientIndexStart = _this.transferencia.details.length;
            if (_this.transferencia.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TransferenciasTitEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.transferenciaService.update(this.transferencia)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.transferencia.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.transferencia = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TransferenciasTitEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.argsCurrentDocument = args;
        args.step.activities.forEach(function (activity) {
            if (activity.tag == 'ACEPTAR') {
                _this.dlgTransferenciaAceptar.showAceptar(_this.transferencia.idSucursalDestino);
            }
            else {
                _this.context.app.showSpinner();
                _this.transferenciaService.nextStep(args.document.id, args.step.idWorkflowStep, null)
                    .then(function (_) {
                    //Volver a cargar documento
                    _this.onViewingDocument(args.document.id);
                })
                    .catch(function (error) { return _this.handleError(error); });
            }
        });
    };
    TransferenciasTitEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.transferenciaService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TransferenciasTitEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.transferencia.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    TransferenciasTitEditor.prototype.onAddingDetail = function () {
        this.detailsEditor.detail = new transferencia_detail_1.TransferenciaDetail();
        this.detailsEditor.show();
    };
    TransferenciasTitEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    TransferenciasTitEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    TransferenciasTitEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.transferencia.details = updatedDetails;
    };
    TransferenciasTitEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    TransferenciasTitEditor.prototype.onSavingDetails = function (details) {
        this.detailsList.updateItems(details);
    };
    TransferenciasTitEditor.prototype.onUpdateQuantity = function (value) {
        var detail = this.detailsList.currentItem;
        if (detail.unidadMedida.paquete) {
            var cantidad = value;
            detail.cantidad = cantidad.paquetes;
            detail.unidades = cantidad.unidades;
        }
        else {
            detail.cantidad = value;
        }
        this.detailsList.updateItem(detail);
    };
    ///////////////// METODOS
    TransferenciasTitEditor.prototype.loadAlmacenInfo = function () {
        var _this = this;
        this.almacenService.getDetailByID(this.transferencia.idAlmacenOrigen)
            .then(function (almacen) { return _this.transferencia.almacenOrigen = almacen; })
            .catch(function (error) { return _this.handleError(error); });
    };
    TransferenciasTitEditor.prototype.loadSucursalInfo = function () {
        var _this = this;
        this.sucursalService.getDetailByID(this.transferencia.idSucursalDestino)
            .then(function (sucursal) { return _this.transferencia.sucursalDestino = sucursal; })
            .catch(function (error) { return _this.handleError(error); });
    };
    var TransferenciasTitEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], TransferenciasTitEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", transferencias_tit_detail_editor_1.TransferenciaDetailEditor)
    ], TransferenciasTitEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild('dlgTransferenciaAceptar'),
        __metadata("design:type", transferencia_aceptar_component_1.TrensferenciaAceptarComponent)
    ], TransferenciasTitEditor.prototype, "dlgTransferenciaAceptar", void 0);
    TransferenciasTitEditor = TransferenciasTitEditor_1 = __decorate([
        core_1.Component({
            selector: 'inventario-transferencias-tit-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                  [title]=\"'TransferenciasTit'\"\n                                  [document]=\"transferencia\"\n                                  [valid]=\"valid\"\n                                  (configureDocument)=\"onConfigureDocument($event)\"\n                                  (creatingDocument)=\"onCreatingDocument()\"\n                                  (viewingDocument)=\"onViewingDocument($event)\"\n                                  (cloningDocument)=\"onCloningDocument($event)\"\n                                  (savingDocument)=\"onSavingDocument($event)\"\n                                  (loadingDocument)=\"onLoadingDocument($event)\"\n                                  (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                  (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-6 col-md-5\">\n                                      <label class=\"control-label\">Almac\u00E9n Origen:</label>\n                                      <az-label [text]=\"transferencia.almacenOrigen.nombre\"></az-label>\n                                  </div>\n\n                                  <div class=\"col-6 col-md-5\">\n                                      <label class=\"control-label\">Sucursal destino:</label>\n                                      <az-label [text]=\"transferencia.sucursalDestino.nombre\"></az-label>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Observaciones:'\">\n                                          <az-textarea formControlName=\"observaciones\" [(ngModel)]=\"transferencia.observaciones\"></az-textarea>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                          </tab>\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #detailsList\n                                                    (addingItem)=\"onAddingDetail()\"\n                                                    (editingItem)=\"onEditingDetail($event)\"\n                                                    (deletingItem)=\"onDeletingDetail($event)\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    [listItems]=\"transferencia.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'articuloStock.nombre'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Descripci\u00F3n'\" [binding]=\"'articuloStock.nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'U.M.'\" [binding]=\"'unidadMedida.nombre'\" [width]=\"'30*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [width]=\"'20*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Unidades'\" [binding]=\"'unidades'\" [width]=\"'20*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Lote'\" [binding]=\"'idLote'\" [width]=\"80\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Num. Serie'\" [binding]=\"'numSerie'\" [width]=\"'40*'\"></azteca-grid-column>\n\n                              </azteca-editable-list>\n                          </tab>\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"transferencia.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <inventario-transferencia-detail-editor #detailsEditor\n                                              [idAlmacen]=\"transferencia.idAlmacenOrigen\"\n                                              (savingItem)=\"onSavingDetail($event)\"\n                                              (savingItems)=\"onSavingDetails($event)\">\n\n      </inventario-transferencia-detail-editor>\n\n      <inventory-transferencia-aceptar #dlgTransferenciaAceptar>\n\n\n      </inventory-transferencia-aceptar>\n\n\n      <inventario-detail-quantity (updateQuantity)=\"onUpdateQuantity($event)\">\n\n      </inventario-detail-quantity>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return TransferenciasTitEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: transferencia_service_1.TransferenciaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            transferencia_service_1.TransferenciaService,
            almacen_service_1.AlmacenService,
            core_2.SucursalService])
    ], TransferenciasTitEditor);
    return TransferenciasTitEditor;
}(editors_1.DocumentEditor));
exports.TransferenciasTitEditor = TransferenciasTitEditor;
