import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { TraspasoInfo } from '../models/traspaso';
import { TraspasoDetail } from '../models/traspaso-detail';
import { TraspasoService } from '../services/traspaso.service';
import { TraspasoDetailEditor } from './parts/traspasos-tit-detail.editor';
import { AreaInfo } from '../models/area';
import { ConceptoItem } from '../models/concepto';
import { ConceptoService } from '../services/concepto.service';
export declare class TraspasosTitEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private conceptoService;
    private traspasoService;
    traspaso: TraspasoInfo;
    areaOrigen: AreaInfo;
    areaDestino: AreaInfo;
    conceptosItems: ConceptoItem[];
    detailsList: EditableListComponent;
    detailsEditor: TraspasoDetailEditor;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, conceptoService: ConceptoService, traspasoService: TraspasoService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: TraspasoDetail): void;
    onDeletingDetail(detail: TraspasoDetail): void;
    onListItemsUpdated(updatedDetails: TraspasoDetail[]): void;
    onSavingDetail(detail: TraspasoDetail): void;
    onSavingDetails(details: TraspasoDetail[]): void;
    onUpdateQuantity(value: any): void;
    onAreaOrigenChanged(area: AreaInfo): void;
    onAreaDestinoChanged(area: AreaInfo): void;
}
