"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var traspaso_1 = require("../models/traspaso");
var traspaso_detail_1 = require("../models/traspaso-detail");
var traspaso_service_1 = require("../services/traspaso.service");
var traspasos_tit_detail_editor_1 = require("./parts/traspasos-tit-detail.editor");
var area_1 = require("../models/area");
var concepto_service_1 = require("../services/concepto.service");
var TraspasosTitEditor = /** @class */ (function (_super) {
    __extends(TraspasosTitEditor, _super);
    function TraspasosTitEditor(context, router, route, location, formBuilder, documentTypeService, conceptoService, traspasoService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.conceptoService = conceptoService;
        _this.traspasoService = traspasoService;
        _this.traspaso = new traspaso_1.TraspasoInfo();
        _this.areaOrigen = new area_1.AreaInfo();
        _this.areaDestino = new area_1.AreaInfo();
        _this.conceptosItems = [];
        _this.documentForm = formBuilder.group({
            'idAreaOrigen': [0],
            'idAlmacenOrigen': [0],
            'idAreaDestino': [0],
            'idAlmacenDestino': [0],
            'idConcepto': [0, forms_1.Validators.required],
            'observaciones': ['', forms_1.Validators.required],
        });
        return _this;
    }
    TraspasosTitEditor_1 = TraspasosTitEditor;
    TraspasosTitEditor.prototype.onConfigureDocument = function (docType) {
        var _this = this;
        this.applyPolicies();
        this.conceptoService.loadListByUser(this.context.app.defaultCompany.identity, this.context.session.user.identity, 'T')
            .then(function (conceptos) {
            _this.conceptosItems = conceptos;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TraspasosTitEditor.prototype.onCreatingDocument = function () {
    };
    TraspasosTitEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.traspasoService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.traspaso = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TraspasosTitEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.traspasoService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.traspaso = doc;
            _this.detailsEditor.clientIndexStart = _this.traspaso.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TraspasosTitEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.traspasoService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.traspaso = doc;
            _this.detailsEditor.clientIndexStart = _this.traspaso.details.length;
            if (_this.traspaso.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TraspasosTitEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.traspasoService.update(this.traspaso)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.traspaso.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.traspaso = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TraspasosTitEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.traspasoService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TraspasosTitEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.traspasoService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TraspasosTitEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.traspaso.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    TraspasosTitEditor.prototype.onAddingDetail = function () {
        this.detailsEditor.detail = new traspaso_detail_1.TraspasoDetail();
        this.detailsEditor.show();
    };
    TraspasosTitEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    TraspasosTitEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    TraspasosTitEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.traspaso.details = updatedDetails;
    };
    TraspasosTitEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    TraspasosTitEditor.prototype.onSavingDetails = function (details) {
        this.detailsList.updateItems(details);
    };
    TraspasosTitEditor.prototype.onUpdateQuantity = function (value) {
        var detail = this.detailsList.currentItem;
        if (detail.unidadMedida.paquete) {
            var cantidad = value;
            detail.cantidad = cantidad.paquetes;
            detail.unidades = cantidad.unidades;
        }
        else {
            detail.cantidad = value;
        }
        this.detailsList.updateItem(detail);
    };
    //////////////////IMPLEMENTACION/////////////////////////
    TraspasosTitEditor.prototype.onAreaOrigenChanged = function (area) {
        this.areaOrigen = area;
    };
    TraspasosTitEditor.prototype.onAreaDestinoChanged = function (area) {
        this.areaDestino = area;
    };
    var TraspasosTitEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], TraspasosTitEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", traspasos_tit_detail_editor_1.TraspasoDetailEditor)
    ], TraspasosTitEditor.prototype, "detailsEditor", void 0);
    TraspasosTitEditor = TraspasosTitEditor_1 = __decorate([
        core_1.Component({
            selector: 'inventario-traspasos-tit-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'TraspasosTit'\"\n                                         [document]=\"traspaso\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n                              <azteca-form-field [label]=\"'Origen:'\">\n                                  <div class=\"row\">\n\n                                      <div class=\"col-6 col-md-5\">\n                                          <azteca-form-field [label]=\"'Area:'\">\n                                              <inventory-area-selector formControlName=\"idAreaOrigen\" [(ngModel)]=\"areaOrigen.identity\" ngDefaultControl=\"\" (selectedItemChanged)=\"onAreaOrigenChanged($event)\" [enabled]=\"traspaso.idAlmacenOrigen==0 || traspaso.idAlmacenDestino==0\"></inventory-area-selector>\n                                          </azteca-form-field>\n                                      </div>\n\n                                      <div class=\"col-6 col-md-5\">\n                                          <azteca-form-field [label]=\"'Almacen:'\">\n                                              <inventory-almacenes-selector formControlName=\"idAlmacenOrigen\" [(ngModel)]=\"traspaso.idAlmacenOrigen\" ngDefaultControl=\"\" area=\"areaOrigen.identity\" [enabled]=\"traspaso.idAlmacenOrigen==0 || traspaso.idAlmacenDestino==0\"></inventory-almacenes-selector>\n                                          </azteca-form-field>\n                                      </div>\n\n                                  </div>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Destino:'\">\n                                  <div class=\"row\">\n\n                                      <div class=\"col-6 col-md-5\">\n                                          <azteca-form-field [label]=\"'Area:'\">\n                                              <inventory-area-selector formControlName=\"idAreaDestino\" [(ngModel)]=\"areaOrigen.identity\" ngDefaultControl=\"\" (selectedItemChanged)=\"onAreaDestinoChanged($event)\" [enabled]=\"traspaso.idAlmacenOrigen==0 || traspaso.idAlmacenDestino==0\"></inventory-area-selector>\n                                          </azteca-form-field>\n                                      </div>\n\n                                      <div class=\"col-6 col-md-5\">\n                                          <azteca-form-field [label]=\"'Almacen:'\">\n                                              <inventory-almacenes-selector formControlName=\"idAlmacenDestino\" [(ngModel)]=\"traspaso.idAlmacenDestino\" ngDefaultControl=\"\" area=\"areaDestino.identity\" [enabled]=\"traspaso.idAlmacenOrigen==0 || traspaso.idAlmacenDestino==0\"></inventory-almacenes-selector>\n                                          </azteca-form-field>\n                                      </div>\n\n                                  </div>\n\n                              </azteca-form-field>\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-6 col-md-5\">\n                                      <label>Total Cantidad:   </label>\n                                      <label>{{traspaso.totalCantidad}}</label>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-6 col-md-5\">\n                                      <label>Total Flete:   </label>\n                                      <label>{{traspaso.flete}}</label>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-6 col-md-5\">\n                                      <label>Total Costo:   </label>\n                                      <label>{{traspaso.totalCosto}}</label>\n                                  </div>\n                              </div>\n\n\n\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-md-6\">\n                                          <azteca-form-field [label]=\"'Concepto:'\">\n                                              <az-combobox formControlName=\"idConcepto\"\n                                                           [(ngModel)]=\"traspaso.idConcepto\"\n                                                           [items]=\"conceptosItems\"\n                                                           [valueMember]=\"'id'\"\n                                                           [displayMember]=\"'nombre'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-md-6\">\n                                          <azteca-form-field [label]=\"'Observaciones:'\">\n                                              <az-textarea formControlName=\"observaciones\" [(ngModel)]=\"traspaso.observaciones\"></az-textarea>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n      </tab>  \n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #detailsList\n                                                    (addingItem)=\"onAddingDetail()\"\n                                                    (editingItem)=\"onEditingDetail($event)\"\n                                                    (deletingItem)=\"onDeletingDetail($event)\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    [listItems]=\"traspaso.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'articuloStock.nombre'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Descripci\u00F3n'\" [binding]=\"'articuloStock.nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'U.M.'\" [binding]=\"'unidadMedida.nombre'\" [width]=\"'30*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [width]=\"'20*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Unidades'\" [binding]=\"'unidades'\" [width]=\"'20*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Lote'\" [binding]=\"'idLote'\" [width]=\"80\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Num. Serie'\" [binding]=\"'numSerie'\" [width]=\"'40*'\"></azteca-grid-column>\n\n\n                              </azteca-editable-list>\n                          </tab>\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"traspaso.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <inventario-traspaso-detail-editor #detailsEditor\n                                         [idAlmacen]=\"traspaso.idAlmacenOrigen\"\n                                         (savingItem)=\"onSavingDetail($event)\"\n                                          (savingItems)=\"onSavingDetails($event)\">\n\n      </inventario-traspaso-detail-editor>\n\n      <inventario-detail-quantity (updateQuantity)=\"onUpdateQuantity($event)\">\n\n      </inventario-detail-quantity>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return TraspasosTitEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: traspaso_service_1.TraspasoService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            concepto_service_1.ConceptoService,
            traspaso_service_1.TraspasoService])
    ], TraspasosTitEditor);
    return TraspasosTitEditor;
}(editors_1.DocumentEditor));
exports.TraspasosTitEditor = TraspasosTitEditor;
