"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
var articulo_stock_service_1 = require("../services/articulo-stock.service");
var ArticuloCostoEstandar = /** @class */ (function (_super) {
    __extends(ArticuloCostoEstandar, _super);
    function ArticuloCostoEstandar(context, router, route, formBuilder, articuloService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.articuloService = articuloService;
        _this.articulosCostoEstandar = [];
        _this.articulosCollection = new editors_1.TrackableCollection();
        _this.form = formBuilder.group({
            'fechaInicial': [new Date()],
            'fechaFinal': [new Date()]
        });
        return _this;
    }
    ArticuloCostoEstandar.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'CONSULTAR') {
            this.llenaListado();
        }
        if (button.name == 'GUARDAR') {
            this.guardar();
        }
    };
    ArticuloCostoEstandar.prototype.llenaListado = function () {
        var _this = this;
        this.articuloService.loadCostoEstandarList(this.context.app.defaultSite.identity)
            .then(function (ret) {
            _this.articulosCollection.sourceCollection = ret;
            _this.articulosCostoEstandar = ret;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticuloCostoEstandar.prototype.guardar = function () {
        var _this = this;
        this.articuloService.costosEstandarUpdate(this.articulosCostoEstandar).then(function (_) {
            _this.alerts.showAlert("Información guardada correctamente", 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //Implementacion de politicas
    ArticuloCostoEstandar.prototype.applyPolicy = function (policy) {
    };
    ArticuloCostoEstandar.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ArticuloCostoEstandar.prototype, "alerts", void 0);
    ArticuloCostoEstandar = __decorate([
        core_1.Component({
            selector: 'inventory-articulos-costo-estandar',
            template: "\n      <form [formGroup]=\"form\">\n          <div class=\"form-inline\">\n              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                  <az-toolbar-button [name]=\"'CONSULTAR'\" [type]=\"'primary'\" [text]=\"'Consultar'\" [toolTip]=\"'Consultar'\" [icon]=\"'glyphicon glyphicon-search'\" [enabled]=\"true\"></az-toolbar-button>\n              </az-toolbar>\n\n              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                  <az-toolbar-button [name]=\"'GUARDAR'\" [type]=\"'primary'\" [text]=\"'Guardar'\" [toolTip]=\"'Guardar'\" [icon]=\"'glyphicon glyphicon-save-file'\" [enabled]=\"true\"></az-toolbar-button>\n              </az-toolbar>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <wj-flex-grid #grid style=\"height:550px\"\n                                [itemsSource]=\"articulosCollection\"\n                                [wjContextMenu]=\"ctxMenuArticulos\">\n                      <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                      <wj-flex-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'5*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Descripcion'\" [binding]=\"'nombre'\" [width]=\"'25*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Costo estandar'\" [binding]=\"'costoEstandar'\" [width]=\"'10*'\"></wj-flex-grid-column>\n                  </wj-flex-grid>\n              </div>\n          </div>\n\n\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder,
            articulo_stock_service_1.ArticuloStockService])
    ], ArticuloCostoEstandar);
    return ArticuloCostoEstandar;
}(core_2.ProcessComponent));
exports.ArticuloCostoEstandar = ArticuloCostoEstandar;
