import { CatalogInfo, CatalogItem } from 'framework3/core';
import { TrackableItem } from 'framework3/editors';
import { ClasificacionValor, IClasificable } from 'framework3/general';
export declare class AlmacenInfo extends CatalogInfo implements IClasificable {
    nombre: string;
    idArea: number;
    permiteNegativos: boolean;
    reqCapturaFisico: boolean;
    restriccionAccesos: boolean;
    restriccionArticulos: boolean;
    idCuenta: number;
    clasificaciones: ClasificacionValor[];
    constructor();
}
export declare class AlmacenItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    idArea: number;
    entrada: boolean;
    salida: boolean;
    activo: boolean;
    estatus?: string;
    selected?: boolean;
}
export declare class AlmacenUsuarioInfo extends CatalogInfo {
    idAlmacen: number;
    idUsuario: number;
    entrada: boolean;
    salida: boolean;
    constructor();
}
export declare class AlmacenUsuarioItem extends TrackableItem implements CatalogItem {
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
    selected?: boolean;
    entrada: boolean;
    salida: boolean;
}
export declare class AlmacenProvisionItem extends TrackableItem implements CatalogItem {
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
    selected?: boolean;
}
export declare class ClasificacionesArticulosItem {
    selected: boolean;
    idGrupoClasificaciones: number;
    idClasificacion: number;
    grupo: string;
    clasificacion: string;
    valor: string;
    referencia: string;
}
export declare class Existencias {
    id: number;
    codigo: string;
    nombre: string;
    disponible: number;
    apartado: number;
    existencia: number;
    transito: number;
}
