import { CatalogInfo, CatalogItem } from 'framework3/core';
import { ClasificacionValor, IClasificable } from 'framework3/general';
import { UnidadMedidaInfo } from './unidad-medida';
export declare class ArticuloStockInfo extends CatalogInfo implements IClasificable {
    nombre: string;
    descripcion: string;
    idUnidadMedida: number;
    idCategoriaFiscal: number;
    stockMax: number;
    stockMin: number;
    puntoReorden: number;
    ultimoCosto: number;
    costoPromedio: number;
    orden: number;
    gtin: string;
    manejaSeries: boolean;
    manejaCaducidad: boolean;
    metodoValuacion: string;
    manejaLotes: boolean;
    origen: string;
    idCuenta: number;
    unidadMedida: UnidadMedidaInfo;
    clasificaciones: ClasificacionValor[];
    constructor();
}
export declare class ArticuloStockItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    UnidadMedidaInfo: string;
    unidadMedida: UnidadMedidaInfo;
    gtin: string;
    activo: boolean;
    estatus?: string;
    selected: boolean;
    constructor();
}
export declare class ArticulosFotografia {
    idArchivo: string;
    fecha: Date;
    descripcion: string;
    uri: string;
    archivo: string;
    constructor();
}
