"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//
var core_2 = require("framework3/core");
var base_control_1 = require("framework3/controls/models/base-control");
var articulo_stock_1 = require("../models/articulo-stock");
var metodo_valuacion_1 = require("../models/metodo-valuacion");
var ArticuloStockControlesComponent = /** @class */ (function (_super) {
    __extends(ArticuloStockControlesComponent, _super);
    //
    function ArticuloStockControlesComponent(formBuilder) {
        var _this = _super.call(this) || this;
        _this.formBuilder = formBuilder;
        _this.metodosValuacion = metodo_valuacion_1.MetodoValuacion.list;
        //Inputs
        _this.articuloStock = new articulo_stock_1.ArticuloStockInfo();
        //Outputs
        _this.articuloStockChange = new core_1.EventEmitter();
        _this.validChange = new core_1.EventEmitter();
        //Campos privados para enlazar a UI
        _this.manejaSeries = false;
        _this.manejaLotes = false;
        _this.manejaCaducidad = false;
        _this.metodoValuacion = '';
        _this.propagateChange = function (_) { };
        _this.form = formBuilder.group({
            'manejaSeries': [false],
            'manejaLotes': [false],
            'manejaCaducidad': [false],
            'metodoValuacion': ['']
        });
        //Hacer requerido el método de valuación sólo cuando se manejen lotes
        _this.form.controls['manejaLotes'].valueChanges.subscribe(function (value) {
            if (value == true) {
                _this.form.controls['metodoValuacion'].setValidators(forms_1.Validators.required);
            }
            else {
                _this.form.controls['metodoValuacion'].setValue('');
                _this.form.controls['metodoValuacion'].setValidators(null);
            }
            _this.form.controls['metodoValuacion'].updateValueAndValidity();
        });
        return _this;
    }
    ArticuloStockControlesComponent_1 = ArticuloStockControlesComponent;
    Object.defineProperty(ArticuloStockControlesComponent.prototype, "valid", {
        //Indica si la información de la forma es válida
        get: function () {
            return this.form.valid;
        },
        enumerable: true,
        configurable: true
    });
    ArticuloStockControlesComponent.prototype.ngOnChanges = function (changes) {
        if (changes['persona']) {
            this.updateArticuloStockControles();
        }
    };
    ArticuloStockControlesComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.form.statusChanges.subscribe(function (_) {
            _this.validChange.emit(_this.form.valid);
        });
    };
    //////////////////////////////// METODOS ////////////////////////////////////////
    ArticuloStockControlesComponent.prototype.updateArticuloStockControles = function () {
        this.metodoValuacion = this.articuloStock.metodoValuacion;
    };
    ArticuloStockControlesComponent.prototype.notifiyChange = function () {
        var newArticuloStock = JSON.parse(JSON.stringify(this.articuloStock));
        newArticuloStock.manejaSeries = this.articuloStock.manejaSeries;
        newArticuloStock.manejaLotes = this.articuloStock.manejaLotes;
        newArticuloStock.manejaCaducidad = this.articuloStock.manejaCaducidad;
        newArticuloStock.metodoValuacion = this.articuloStock.metodoValuacion;
        //
        this.articuloStockChange.emit(newArticuloStock);
        this.propagateChange(newArticuloStock);
    };
    //////////////////////////////// HANDLERS ////////////////////////////////////////
    ArticuloStockControlesComponent.prototype.onSerieCheckChange = function (args) {
        this.notifiyChange();
    };
    ArticuloStockControlesComponent.prototype.onLotesCheckChange = function (args) {
        if (args.target.checked == false) {
            this.articuloStock.metodoValuacion = 'N';
        }
        this.notifiyChange();
    };
    ArticuloStockControlesComponent.prototype.onCaducidadCheckChange = function (args) {
        this.notifiyChange();
    };
    ArticuloStockControlesComponent.prototype.onMetodoValuacionChange = function (args) {
        this.articuloStock.metodoValuacion = this.form.controls.metodoValuacion.value;
        this.notifiyChange();
    };
    //////////////////////////////// CONTROL VALUE ACCESOR ////////////////////////////////////////
    ArticuloStockControlesComponent.prototype.writeValue = function (value) {
        //this.articuloStock = value;
        this.updateArticuloStockControles();
    };
    ArticuloStockControlesComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    ArticuloStockControlesComponent.prototype.registerOnTouched = function () {
    };
    var ArticuloStockControlesComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", articulo_stock_1.ArticuloStockInfo)
    ], ArticuloStockControlesComponent.prototype, "articuloStock", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockControlesComponent.prototype, "articuloStockChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockControlesComponent.prototype, "validChange", void 0);
    ArticuloStockControlesComponent = ArticuloStockControlesComponent_1 = __decorate([
        core_1.Component({
            selector: 'articulos-stock-controles',
            template: "\n      <form [formGroup]=\"form\">\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <az-checkbox [label]=\"'Requiere control por n\u00FAmero de serie'\"\n                               formControlName=\"manejaSeries\"\n                               [checked]=\"articuloStock.manejaSeries\"\n                               [(ngModel)]=\"articuloStock.manejaSeries\"\n                               (change)=\"onSerieCheckChange($event)\">\n\n                  </az-checkbox>\n              </div>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <az-checkbox [label]=\"'Requiere control por lotes'\"\n                               formControlName=\"manejaLotes\"\n                               [checked]=\"articuloStock.manejaLotes\"\n                               [(ngModel)]=\"articuloStock.manejaLotes\"\n                               (change)=\"onLotesCheckChange($event)\">\n\n                  </az-checkbox>\n              </div>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <az-checkbox [label]=\"'Requiere control de fechas de caducidad'\"\n                               formControlName=\"manejaCaducidad\"\n                               [checked]=\"articuloStock.manejaCaducidad\"\n                               [(ngModel)]=\"articuloStock.manejaCaducidad\"\n                               (change)=\"onCaducidadCheckChange($event)\">\n\n                  </az-checkbox>\n              </div>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12\" *ngIf=\"articuloStock.manejaLotes\">\n                  <azteca-form-field [label]=\"'M\u00E9todo de valuaci\u00F3n de inventario:'\">\n                      <az-combobox formControlName=\"metodoValuacion\"\n                                   [items]=\"metodosValuacion\"\n                                   [valueMember]=\"'id'\"\n                                   [displayMember]=\"'nombre'\"\n                                   [(ngModel)]=\"articuloStock.metodoValuacion\"\n                                   (change)=\"onMetodoValuacionChange($event)\">\n\n                      </az-combobox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ArticuloStockControlesComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR, useExisting: core_1.forwardRef(function () { return ArticuloStockControlesComponent_1; }), multi: true
                }
            ],
            styles: [
                '.ng-valid-component { border-left: 1px solid #ccc!important;}'
            ]
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder])
    ], ArticuloStockControlesComponent);
    return ArticuloStockControlesComponent;
}(base_control_1.BaseControl));
exports.ArticuloStockControlesComponent = ArticuloStockControlesComponent;
