"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var base_control_1 = require("framework3/controls/models/base-control");
var articulo_stock_1 = require("../models/articulo-stock");
var ArticuloStockGeneralComponent = /** @class */ (function (_super) {
    __extends(ArticuloStockGeneralComponent, _super);
    //
    function ArticuloStockGeneralComponent(formBuilder) {
        var _this = _super.call(this) || this;
        _this.formBuilder = formBuilder;
        //Inputs
        _this.articuloStock = new articulo_stock_1.ArticuloStockInfo();
        //Outputs
        _this.articuloStockChange = new core_1.EventEmitter();
        _this.validChange = new core_1.EventEmitter();
        _this.propagateChange = function (_) { };
        _this.form = formBuilder.group({
            'idCategoriaFiscal': [0, controls_1.AztecaValidators.selected],
            'gtin': [''],
            'descripcion': ['']
        });
        return _this;
    }
    ArticuloStockGeneralComponent_1 = ArticuloStockGeneralComponent;
    Object.defineProperty(ArticuloStockGeneralComponent.prototype, "valid", {
        //Indica si la información de la forma es válida
        get: function () {
            return this.form.valid;
        },
        enumerable: true,
        configurable: true
    });
    ArticuloStockGeneralComponent.prototype.ngOnChanges = function (changes) {
    };
    ArticuloStockGeneralComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.form.statusChanges.subscribe(function (_) {
            _this.validChange.emit(_this.form.valid);
        });
    };
    //////////////////////////////// METODOS ////////////////////////////////////////
    ArticuloStockGeneralComponent.prototype.notifiyChange = function () {
        var newArticuloStock = JSON.parse(JSON.stringify(this.articuloStock));
        newArticuloStock.idCategoriaFiscal = this.articuloStock.idCategoriaFiscal;
        newArticuloStock.gtin = this.articuloStock.gtin;
        newArticuloStock.descripcion = this.articuloStock.descripcion;
        //
        this.articuloStockChange.emit(newArticuloStock);
        this.propagateChange(newArticuloStock);
    };
    //////////////////////////////// HANDLERS ////////////////////////////////////////
    ArticuloStockGeneralComponent.prototype.onCategoriaFiscalChanged = function (args) {
        this.notifiyChange();
    };
    ArticuloStockGeneralComponent.prototype.onGtinChanged = function (args) {
        this.notifiyChange();
    };
    ArticuloStockGeneralComponent.prototype.onDescripcionChanged = function (args) {
        this.notifiyChange();
    };
    //////////////////////////////// CONTROL VALUE ACCESOR ////////////////////////////////////////
    ArticuloStockGeneralComponent.prototype.writeValue = function (value) {
        //this.articuloStock = value;
    };
    ArticuloStockGeneralComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    ArticuloStockGeneralComponent.prototype.registerOnTouched = function () {
    };
    var ArticuloStockGeneralComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", articulo_stock_1.ArticuloStockInfo)
    ], ArticuloStockGeneralComponent.prototype, "articuloStock", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockGeneralComponent.prototype, "articuloStockChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockGeneralComponent.prototype, "validChange", void 0);
    ArticuloStockGeneralComponent = ArticuloStockGeneralComponent_1 = __decorate([
        core_1.Component({
            selector: 'articulos-stock-general',
            template: "\n      <form [formGroup]=\"form\">\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field [label]=\"'Categoria Fiscal'\">\n                      <accounting-articulo-categoria-fiscal-selector formControlName=\"idCategoriaFiscal\"\n                                                                     [(ngModel)]=\"articuloStock.idCategoriaFiscal\"\n                                                                     (change)=\"onCategoriaFiscalChanged($event)\"\n                                                                     #selectorCategoriaFiscal>\n                      </accounting-articulo-categoria-fiscal-selector>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field [label]=\"'GTIN:'\">\n                      <az-textbox formControlName=\"gtin\" [(ngModel)]=\"articuloStock.gtin\" (change)=\"onGtinChanged($event)\"></az-textbox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field [label]=\"'Descripci\u00F3n:'\">\n                      <az-textarea formControlName=\"descripcion\" [(ngModel)]=\"articuloStock.descripcion\" (change)=\"onDescripcionChanged($event)\"></az-textarea>\n                  </azteca-form-field>\n              </div>\n          </div>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ArticuloStockGeneralComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR, useExisting: core_1.forwardRef(function () { return ArticuloStockGeneralComponent_1; }), multi: true
                }
            ],
            styles: [
                '.ng-valid-component { border-left: 1px solid #ccc!important;}'
            ]
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder])
    ], ArticuloStockGeneralComponent);
    return ArticuloStockGeneralComponent;
}(base_control_1.BaseControl));
exports.ArticuloStockGeneralComponent = ArticuloStockGeneralComponent;
