"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var ngx_bootstrap_1 = require("ngx-bootstrap");
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var area_service_1 = require("../services/area.service");
var almacen_service_1 = require("../services/almacen.service");
var TrensferenciaAceptarComponent = /** @class */ (function () {
    function TrensferenciaAceptarComponent(formBuilder, context, router, route, areaService, almacenService) {
        this.formBuilder = formBuilder;
        this.context = context;
        this.router = router;
        this.route = route;
        this.areaService = areaService;
        this.almacenService = almacenService;
        this.areas = [];
        this.almacenes = [];
        this.transferenciaAceptada = new core_1.EventEmitter();
        this.editorForm = formBuilder.group({
            'idArea': [0, forms_1.Validators.required],
            'idAlmacen': [0, forms_1.Validators.required]
        });
    }
    TrensferenciaAceptarComponent.prototype.loadAreas = function (idSucursalDestino) {
        var _this = this;
        this.context.app.showSpinner();
        this.areaService.loadListByUser(idSucursalDestino, this.context.session.user.identity)
            .then(function (areas) {
            _this.areas = areas;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.showAlert(error.message, 'danger'); });
    };
    TrensferenciaAceptarComponent.prototype.loadAlmacenes = function (idArea) {
        var _this = this;
        this.idAlmacen = 0;
        this.context.app.showSpinner();
        this.almacenService.loadListByUser(idArea, this.context.session.user.identity)
            .then(function (almacenes) {
            _this.almacenes = almacenes.filter(function (almacen) { return almacen.salida; });
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.showAlert(error.message, 'danger'); });
    };
    TrensferenciaAceptarComponent.prototype.showAceptar = function (idSucursalDestino) {
        this.dlgTransferenciaAceptar.config.backdrop = false;
        this.loadAreas(idSucursalDestino);
        this.dlgTransferenciaAceptar.show();
    };
    TrensferenciaAceptarComponent.prototype.accept = function () {
        this.transferenciaAceptada.emit(this.idAlmacen);
        this.dlgTransferenciaAceptar.hide();
    };
    TrensferenciaAceptarComponent.prototype.discardChanges = function () {
        this.dlgTransferenciaAceptar.hide();
    };
    TrensferenciaAceptarComponent.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], TrensferenciaAceptarComponent.prototype, "transferenciaAceptada", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], TrensferenciaAceptarComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('dlgTransferenciaAceptar'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], TrensferenciaAceptarComponent.prototype, "dlgTransferenciaAceptar", void 0);
    TrensferenciaAceptarComponent = __decorate([
        core_1.Component({
            selector: 'inventory-transferencia-aceptar',
            template: "\n      <div bsModal #dlgTransferenciaAceptar=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n\n                      <form [formGroup]=\"editorForm\">\n                          <div class=\"row\">\n                              <div class=\"col-md-12\">\n                                  <alerts-bar></alerts-bar>\n                                  <div class=\"row\">\n                                      <div class=\"col-md-12\">\n                                          <azteca-form-field [label]=\"'Seleccionar almacen destino:'\">\n                                              <div class=\"row\">\n                                                  <div class=\"col-md-12\">\n                                                      <azteca-form-field [label]=\"'\u00C1rea:'\">\n                                                          <az-combobox formControlName=\"idArea\"\n                                                                       [(ngModel)]=\"idArea\"\n                                                                       [items]=\"areas\"\n                                                                       [valueMember]=\"'id'\"\n                                                                       [displayMember]=\"'nombre'\"\n                                                                       (selectedItemChanged)=\"loadAlmacenes($event)\"></az-combobox>\n                                                      </azteca-form-field>\n                                                  </div>\n                                              </div>\n                                              <div class=\"row\">\n                                                  <div class=\"col-md-12\">\n                                                      <azteca-form-field [label]=\"'Almac\u00E9n:'\">\n                                                          <az-combobox formControlName=\"idAlmacen\" [(ngModel)]=\"idAlmacen\" [items]=\"almacenes\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                                                      </azteca-form-field>\n                                                  </div>\n                                              </div>\n                                          </azteca-form-field>\n\n                                          <div class=\"row\">\n                                              <div class=\"col-md-12\">\n                                                  <div class=\"modal-footer\">\n                                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"accept()\">Aceptar</button>\n                                                      <button type=\"button\" class=\"btn btn-default\" (click)=\"discardChanges()\">Descartar</button>\n                                                  </div>\n                                              </div>\n                                          </div>\n                                      </div>\n                                  </div>\n                              </div>\n                          </div>\n                      </form>\n\n                  </div>\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, core_2.Context, router_1.Router, router_1.ActivatedRoute, area_service_1.AreaService, almacen_service_1.AlmacenService])
    ], TrensferenciaAceptarComponent);
    return TrensferenciaAceptarComponent;
}());
exports.TrensferenciaAceptarComponent = TrensferenciaAceptarComponent;
