import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService } from 'framework3/core';
import { AlmacenInfo, AlmacenItem, AlmacenUsuarioItem, ClasificacionesArticulosItem, Existencias, AlmacenProvisionItem } from '../models/almacen';
import { StockInfo } from '../models/stock';
export declare class AlmacenService extends CatalogService<AlmacenInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<AlmacenInfo>;
    LoadAccessUsersList(idAlmacen: number): Promise<AlmacenUsuarioItem[]>;
    addMembers(idAlmacen: number, usuarios: AlmacenUsuarioItem[]): Promise<any>;
    updateMembers(idAlmacen: number, usuarios: AlmacenUsuarioItem[]): Promise<any>;
    removeMember(idAlmacen: number, idUsuario: number): Promise<any>;
    loadList(idArea: number): Promise<AlmacenItem[]>;
    loadListByUser(idArea: number, idUsuario: number): Promise<AlmacenItem[]>;
    LoadClasificacionesArticulos(): Promise<ClasificacionesArticulosItem[]>;
    LoadClasificacionesPermitidas(idAlmacen: number): Promise<ClasificacionesArticulosItem[]>;
    updateClasificacionesArticulos(idAlmacen: number, data: ClasificacionesArticulosItem[]): Promise<any>;
    removeClasificacionesArticulos(idAlmacen: number, idClasificacion: number): Promise<any>;
    loadExistencias(idAlmacen: number): Promise<Existencias[]>;
    loadExistenciasbyArt(idArticuloStock: number, idSucursal: number): Promise<Existencias[]>;
    loadStock(idAlmacen: number, idArticuloStock: number): Promise<StockInfo>;
    loadStockAlmacen(idAlmacen: number): Promise<StockInfo[]>;
    loadStockArticulo(idArticulo: number, idSucursal: number): Promise<StockInfo[]>;
    updateStockByArticulo(idArticulo: number, data: StockInfo): Promise<any>;
    updateStock(idAlmacen: number, data: StockInfo): Promise<any>;
    searchKeywordAlmacenes(idBranch: number, keyword: string): Observable<AlmacenItem[]>;
    LoadAlmacenesProvision(idAlmacen: number): Promise<AlmacenProvisionItem[]>;
    addAlmacenesProvision(idAlmacen: number, almacenes: AlmacenProvisionItem[]): Promise<any>;
    removeAlmacenProvision(idAlmacen: number, idAlmacenProvision: number): Promise<any>;
}
