"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
//Azteca Kernel
var core_2 = require("framework3/core");
//Locales
var area_1 = require("../models/area");
var AreaService = /** @class */ (function (_super) {
    __extends(AreaService, _super);
    function AreaService(http, context) {
        return _super.call(this, http, context, "api/inventario/areas") || this;
    }
    AreaService.prototype.create = function () {
        return Promise.resolve(new area_1.AreaInfo());
    };
    AreaService.prototype.loadList = function (idSucursal) {
        var params = new http_1.HttpParams()
            .append("idSucursal", idSucursal.toString());
        return this.apiService.get("load-list", params)
            .toPromise();
    };
    AreaService.prototype.loadListByUser = function (idSucursal, idUsuario) {
        var params = new http_1.HttpParams()
            .append("idSucursal", idSucursal.toString())
            .append("idUsuario", idUsuario.toString());
        return this.apiService.get("load-list-by-user", params)
            .toPromise();
    };
    AreaService.prototype.loadAlmacenes = function (idArea) {
        var params = new http_1.HttpParams()
            .append("idArea", idArea.toString());
        return this.apiService.get("load-almacenes", params)
            .toPromise();
    };
    AreaService.prototype.loadAlmacenesByUser = function (idArea, idUsuario) {
        var params = new http_1.HttpParams()
            .append("idArea", idArea.toString())
            .append("idUsuario", idUsuario.toString());
        return this.apiService.get("load-almacenes-by-user", params)
            .toPromise();
    };
    AreaService.prototype.LoadAccessUsersList = function (idArea) {
        var params = new http_1.HttpParams()
            .append("idArea", idArea.toString());
        return this.apiService.get("load-access-users-list", params)
            .toPromise();
    };
    ///////////////////////////// Turnos ////////////////////////////////////////////////
    AreaService.prototype.getMembers = function (idGrupo) {
        var params = new http_1.HttpParams()
            .set('idGrupo', idGrupo.toString());
        return this.apiService.get('get-members', params)
            .toPromise();
    };
    AreaService.prototype.addMembers = function (idArea, usuarios) {
        var params = new http_1.HttpParams()
            .set('idArea', idArea.toString());
        return this.apiService.post('add-members', params, usuarios)
            .toPromise();
    };
    AreaService.prototype.removeMember = function (idArea, idUsuario) {
        var params = new http_1.HttpParams()
            .set('idArea', idArea.toString())
            .set('idUsuario', idUsuario.toString());
        return this.apiService.delete('remove-member', params)
            .toPromise();
    };
    AreaService.prototype.LoadTurnos = function (idArea) {
        var params = new http_1.HttpParams()
            .set('idArea', idArea.toString());
        return this.apiService.get('load-turnos', params)
            .toPromise();
    };
    /*SaveTurnos(idArea: number, usuarios: AreaUsuarioItem[]): Promise<any> {
        let params: URLSearchParams = new URLSearchParams();
        params.set('idArea', idArea.toString());
        return this.apiService.postData('add-members', params, usuarios)
            .toPromise();
    }*/
    ///////////////////////////// Turnos ////////////////////////////////////////////////
    AreaService.prototype.LoadCorte = function (idCorte) {
        var params = new http_1.HttpParams()
            .set('idCorte', idCorte);
        return this.apiService.get('load-corte', params)
            .toPromise();
    };
    AreaService.prototype.LoadCorteActual = function (idArea) {
        var params = new http_1.HttpParams()
            .set('idArea', idArea.toString());
        return this.apiService.get('load-corte-actual', params)
            .toPromise();
    };
    AreaService.prototype.AbrirCorte = function (idArea, idTurno, idUsuario) {
        var params = new http_1.HttpParams()
            .set('idArea', idArea.toString())
            .set('idTurno', idTurno.toString())
            .set('idUsuario', idUsuario.toString());
        return this.apiService.get('abrir-corte', params)
            .toPromise();
    };
    AreaService.prototype.CerrarCorte = function (idCorte, ajustarInventario, idUsuario) {
        var params = new http_1.HttpParams()
            .set('idCorte', idCorte)
            .set('ajustarInventario', ajustarInventario.toString())
            .set('idUsuario', idUsuario.toString());
        return this.apiService.delete('cerrar-corte', params)
            .toPromise();
    };
    AreaService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], AreaService);
    return AreaService;
}(core_2.CatalogService));
exports.AreaService = AreaService;
