import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogItem, CatalogService } from 'framework3/core';
import { ArticuloStockInfo, ArticulosFotografia } from '../models/articulo-stock';
import { LoteInfo } from '../models/lote';
import { SerieInfo } from '../models/serie';
import { TiposInventarioItem } from '../models/tipo-inventario';
import { ArticuloCostoEstandar } from '../models/articulo-costo-estandar';
export declare class ArticuloStockService extends CatalogService<ArticuloStockInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<ArticuloStockInfo>;
    loadList(): Promise<TiposInventarioItem[]>;
    loadFotografias(idArticuloStock: number): Promise<ArticulosFotografia[]>;
    loadCostoEstandarList(idSucursal: number): Promise<ArticuloCostoEstandar[]>;
    costosEstandarUpdate(articulosCostoEstandar: ArticuloCostoEstandar[]): Promise<any>;
    agregarFotografia(idArticuloStock: number, articulosFotografia: ArticulosFotografia): Promise<any>;
    eliminarFotografia(idArticuloStock: number, idArchivo: string): Promise<any>;
    loadExistenciasLote(idArticuloStock: number, idAlmacen: number): Promise<LoteInfo[]>;
    loadExistenciasSerie(idArticuloStock: number, idAlmacen: number): Promise<SerieInfo[]>;
    getSerieInfo(idArticuloStock: number, idAlmacen: number, numeroSerie: string): Promise<SerieInfo>;
    searchKeyword2(idUsuario: number, idBranch: number, keyword: string): Observable<CatalogItem[]>;
}
