"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
var moment = require("moment");
//Azteca Framework
var core_2 = require("framework3/core");
//Locales
var traspaso_1 = require("../models/traspaso");
var empaquetado_1 = require("../models/empaquetado");
var TraspasoService = /** @class */ (function (_super) {
    __extends(TraspasoService, _super);
    function TraspasoService(http, context) {
        var _this = _super.call(this, http, context, 'api/inventario/traspasos-tit') || this;
        _this.http = http;
        _this.context = context;
        return _this;
    }
    TraspasoService.prototype.create = function () {
        var newDoc = new traspaso_1.TraspasoInfo();
        return Promise.resolve(newDoc);
    };
    TraspasoService.prototype.update = function (info) {
        //Si no tiene asignado la empresa y sucursal, asignar la actual
        if (info.idSucursal == 0)
            info.idSucursal = this.context.app.defaultSite.identity;
        //Actualizar campo de cantidad basado en las propiedades auxiliares
        info.details.forEach(function (detail) {
            if (detail.unidadMedida.paquete && detail.unidadMedida.factor > 1) {
                var cantidad = new empaquetado_1.Empaquetado(detail.cantidad, detail.unidadMedida.factor, detail.unidades);
                detail.cantidad = cantidad.toDecimal();
                detail.cantidadEnviada = cantidad.toDecimal();
            }
        });
        //
        var Promise = _super.prototype.update.call(this, info);
        //Actualizar detalle del paquete retornado (actualizado)
        Promise.then(function (salida) {
            salida.details.forEach(function (detail) {
                if (detail.articuloStock.unidadMedida.paquete && detail.articuloStock.unidadMedida.factor > 1) {
                    var cantidad = new empaquetado_1.Empaquetado(detail.cantidad, detail.unidadMedida.factor, detail.unidades);
                    detail.cantidad = cantidad.paquetes;
                    detail.unidades = cantidad.unidades;
                }
                if (!detail.stock.manejaCaducidad) {
                    detail.fechaCaducidad = null;
                }
            });
        });
        return Promise;
    };
    TraspasoService.prototype.mapDocument = function (document) {
        document.details.forEach(function (detail) {
            detail.fechaCaducidad = moment(detail.fechaCaducidad).toDate();
            //Determinar si no existe fecha de caducidad
            if (!detail.stock.manejaCaducidad) {
                detail.fechaCaducidad = null;
            }
            //Si la unidad de medida es un paquete, separar unidades
            if (detail.unidadMedida.paquete && detail.unidadMedida.factor > 1) {
                var cantidad = new empaquetado_1.Empaquetado(detail.cantidadEnviada, detail.unidadMedida.factor);
                detail.cantidad = cantidad.paquetes;
                detail.unidades = cantidad.unidades;
            }
            else {
                detail.unidades = 0;
            }
        });
    };
    TraspasoService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], TraspasoService);
    return TraspasoService;
}(core_2.DocumentService));
exports.TraspasoService = TraspasoService;
