import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { ToolbarButton } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs, TrackableCollection } from 'framework3/editors';
import { ImpuestoAsignacionInfo } from '../../accounting/models/impuesto-asignacion';
import { ImpuestosAsignacionEditor } from '../../accounting/components/impuesto-asignacion.editor';
import { ArticuloService } from '../services/articulo.service';
import { ArticuloInfo } from '../models/articulo';
import { UnidadMedidaService } from '../../inventory/services/unidad-medida.service';
import { UnidadMedidaItem } from '../../inventory/models/unidad-medida';
import { UnidadMedidaTipoService } from '../../inventory/services/unidad-medida-tipo.service';
import { UnidadMedidaTipoItem } from '../../inventory/models/unidad-medida-tipo';
import { FormControl } from '@angular/forms/src/model';
import { ProductoProveedorComponent } from '../components/producto-proveedor.component';
import { ArticuloImpuestoComponent } from '../components/articulo-impuesto.component';
export declare class ArticulosEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private articuloService;
    private unidadMedidaService;
    private tipoUnidadService;
    articulo: ArticuloInfo;
    tiposUnidad: UnidadMedidaTipoItem[];
    unidadesMedida: UnidadMedidaItem[];
    svcImpCollection: TrackableCollection;
    proceso: number;
    tabControl: string;
    formCtrlMetodoValuacion: FormControl;
    servicioImpuestosDialog: ImpuestosAsignacionEditor;
    proveedorProducto: ProductoProveedorComponent;
    articuloImpuestos: ArticuloImpuestoComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, articuloService: ArticuloService, unidadMedidaService: UnidadMedidaService, tipoUnidadService: UnidadMedidaTipoService);
    ngOnInit(): void;
    loadTiposUnidad(): void;
    onTipoUnidadChanged(idTipoUnidad: any): void;
    loadUnidadesMedida(idTipoUnidad: number): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onAgregarProveedor(): void;
    refreshControls(control: string): void;
    ngAfterViewChecked(): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onAgregarImpuesto(args: ImpuestoAsignacionInfo): void;
    onRemoveItem(item: any): void;
    controlSeries(): void;
    manejaSeriesChecked(): void;
}
