"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var impuesto_asignacion_editor_1 = require("../../accounting/components/impuesto-asignacion.editor");
//Features
var articulo_service_1 = require("../services/articulo.service");
var articulo_1 = require("../models/articulo");
var unidad_medida_service_1 = require("../../inventory/services/unidad-medida.service");
var unidad_medida_tipo_service_1 = require("../../inventory/services/unidad-medida-tipo.service");
var producto_proveedor_component_1 = require("../components/producto-proveedor.component");
var articulo_impuesto_component_1 = require("../components/articulo-impuesto.component");
var ArticulosEditor = /** @class */ (function (_super) {
    __extends(ArticulosEditor, _super);
    //
    function ArticulosEditor(router, route, formBuilder, changeDetector, context, location, articuloService, unidadMedidaService, tipoUnidadService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.articuloService = articuloService;
        _this.unidadMedidaService = unidadMedidaService;
        _this.tipoUnidadService = tipoUnidadService;
        _this.articulo = new articulo_1.ArticuloInfo();
        _this.tiposUnidad = [];
        _this.unidadesMedida = [];
        _this.svcImpCollection = new editors_1.TrackableCollection();
        _this.proceso = 0;
        _this.tabControl = "";
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idCuenta': [''],
            'idFlujo': [''],
            'gtin': [''],
            'idTipoUnidad': [0, forms_1.Validators.required],
            'idUnidadMedida': [0, forms_1.Validators.required],
            'manejaSeries': [''],
            'manejaLotes': [''],
            'manejaCaducidad': [''],
            'metodoValuacion': [''],
            'descripcion': [''],
            'impuestos': [[]]
        });
        _this.formCtrlMetodoValuacion = _this.catalogForm.controls['metodoValuacion'];
        return _this;
    }
    ArticulosEditor_1 = ArticulosEditor;
    ArticulosEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.proceso = +param['proceso'];
        });
        this.formCtrlMetodoValuacion.valueChanges.subscribe(function (value) {
            _this.articulo.articuloStock.metodoValuacion = value;
        });
    };
    ///////////////////////// METODOS ///////////////////////////////////////
    ArticulosEditor.prototype.loadTiposUnidad = function () {
        var _this = this;
        this.tipoUnidadService.loadList()
            .then(function (tipos) { return _this.tiposUnidad = tipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosEditor.prototype.onTipoUnidadChanged = function (idTipoUnidad) {
        this.loadUnidadesMedida(idTipoUnidad);
    };
    ArticulosEditor.prototype.loadUnidadesMedida = function (idTipoUnidad) {
        var _this = this;
        this.unidadMedidaService.loadList(idTipoUnidad)
            .then(function (unidades) { return _this.unidadesMedida = unidades; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ArticulosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.loadTiposUnidad();
    };
    ArticulosEditor.prototype.onCreatingItem = function () {
        this.formCtrlMetodoValuacion.setValue(this.articulo.articuloStock.metodoValuacion);
        this.articulo.impuestos = [];
        this.svcImpCollection.sourceCollection = this.articulo.impuestos;
    };
    ArticulosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.articuloService.getDetailByID(id)
            .then(function (info) {
            _this.articulo = info;
            _this.loadUnidadesMedida(_this.articulo.articuloStock.unidadMedida.idUnidadMedidaTipo);
            _this.loadTiposUnidad();
            _this.formCtrlMetodoValuacion.setValue(_this.articulo.articuloStock.metodoValuacion);
            _this.context.app.hideSpinner();
            _this.setReadonlyMode();
            _this.proveedorProducto.setReadOnly();
            _this.articuloImpuestos.readOnly = true;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.articuloService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.articulo = info;
            _this.loadTiposUnidad();
            _this.formCtrlMetodoValuacion.setValue(_this.articulo.articuloStock.metodoValuacion);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.articuloService.getDetailByID(id)
            .then(function (info) {
            _this.articulo = info;
            _this.loadUnidadesMedida(_this.articulo.articuloStock.unidadMedida.idUnidadMedidaTipo);
            _this.loadTiposUnidad();
            _this.formCtrlMetodoValuacion.setValue(_this.articulo.articuloStock.metodoValuacion);
            _this.context.app.hideSpinner();
            _this.controlSeries();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.articuloService.update(this.articulo)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.articulo.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.articulo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosEditor.prototype.onAgregarProveedor = function () {
        this.router.navigate(['purchasing/proveedor-articulo', this.proceso, 0, 0, this.articulo.identity, 0, 1, 0, 1]);
    };
    ArticulosEditor.prototype.refreshControls = function (control) {
        if (this.tabControl != control) {
            this.tabControl = control;
            wijmo.Control.invalidateAll();
        }
    };
    /*------------------------------------------ IMPUESTOS ----------------------------------*/
    ArticulosEditor.prototype.ngAfterViewChecked = function () {
        this.svcImpCollection.sourceCollection = this.articulo.impuestos;
    };
    ArticulosEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.servicioImpuestosDialog.show();
        }
    };
    ArticulosEditor.prototype.onAgregarImpuesto = function (args) {
        var _this = this;
        var impuestoExists = false;
        this.articulo.impuestos.forEach(function (servicioImp) {
            if (servicioImp.idImpuesto == args.idImpuesto && servicioImp.state != 'DELETED') {
                _this.showAlert("El impuesto ya fue agregado", "información");
                impuestoExists = true;
            }
        });
        if (!impuestoExists) {
            this.articulo.impuestos.push(args);
            this.svcImpCollection.refresh();
        }
    };
    ArticulosEditor.prototype.onRemoveItem = function (item) {
        this.articulo.impuestos.forEach(function (x) {
            if (x.idImpuesto == item.idImpuesto)
                x.state = 'DELETED';
        });
        this.svcImpCollection.remove(item);
        this.svcImpCollection.refresh();
    };
    ArticulosEditor.prototype.controlSeries = function () {
        if (this.articulo.articuloStock.manejaSeries) {
            this.catalogForm.controls['idTipoUnidad'].clearValidators();
            this.catalogForm.controls['idTipoUnidad'].updateValueAndValidity();
            //this.catalogForm.controls['idUnidadMedidaCompra'].clearValidators();
            //this.catalogForm.controls['idUnidadMedidaCompra'].updateValueAndValidity();
            this.catalogForm.controls['idUnidadMedida'].clearValidators();
            this.catalogForm.controls['idUnidadMedida'].updateValueAndValidity();
        }
        else {
            this.catalogForm.controls['idTipoUnidad'].validator = forms_1.Validators.required;
            this.catalogForm.controls['idTipoUnidad'].updateValueAndValidity();
            //this.catalogForm.controls['idUnidadMedidaCompra'].validator = Validators.required;
            //this.catalogForm.controls['idUnidadMedidaCompra'].updateValueAndValidity();
            this.catalogForm.controls['idUnidadMedida'].validator = forms_1.Validators.required;
            this.catalogForm.controls['idUnidadMedida'].updateValueAndValidity();
        }
    };
    ArticulosEditor.prototype.manejaSeriesChecked = function () {
        this.controlSeries();
    };
    var ArticulosEditor_1;
    __decorate([
        core_1.ViewChild(impuesto_asignacion_editor_1.ImpuestosAsignacionEditor),
        __metadata("design:type", impuesto_asignacion_editor_1.ImpuestosAsignacionEditor)
    ], ArticulosEditor.prototype, "servicioImpuestosDialog", void 0);
    __decorate([
        core_1.ViewChild(producto_proveedor_component_1.ProductoProveedorComponent),
        __metadata("design:type", producto_proveedor_component_1.ProductoProveedorComponent)
    ], ArticulosEditor.prototype, "proveedorProducto", void 0);
    __decorate([
        core_1.ViewChild(articulo_impuesto_component_1.ArticuloImpuestoComponent),
        __metadata("design:type", articulo_impuesto_component_1.ArticuloImpuestoComponent)
    ], ArticulosEditor.prototype, "articuloImpuestos", void 0);
    ArticulosEditor = ArticulosEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-articulo-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Articulo'\"\n                                 [info]=\"articulo\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"articulo.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"articulo.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n\n                              <azteca-form-field [label]=\"'Cuenta:'\">\n                                  <accounting-cuenta-selector formControlName=\"idCuenta\" [(ngModel)]=\"articulo.idCuenta\"></accounting-cuenta-selector>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Categor&iacute;a de Flujo:'\">\n                                  <accounting-flujo-selector formControlName=\"idFlujo\" [(ngModel)]=\"articulo.idFlujo\"></accounting-flujo-selector>\n                              </azteca-form-field>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'GTIN:'\">\n                                          <az-textbox formControlName=\"gtin\" [(ngModel)]=\"articulo.articuloStock.gtin\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <!--Ocultar si se manejan series-->\n                                      <azteca-form-field *ngIf=\"!articulo.articuloStock.manejaSeries\" [label]=\"'Tipo de unidad de medida:'\">\n                                          <az-combobox formControlName=\"idTipoUnidad\"\n                                                       [(ngModel)]=\"articulo.articuloStock.unidadMedida.idUnidadMedidaTipo\"\n                                                       [items]=\"tiposUnidad\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       (selectedItemChanged)=\"onTipoUnidadChanged($event)\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                        \n                              <!--Ocultar si se manejan series-->\n                              <!--<div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field *ngIf=\"!articulo.articuloStock.manejaSeries\" [label]=\"'Unidad de Compra:'\">\n                                          <az-combobox formControlName=\"idUnidadMedidaCompra\"\n                                                       [(ngModel)]=\"articulo.idUnidadMedida\"\n                                                       [items]=\"unidadesMedida\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>-->\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <!--Ocultar si se manejan series-->\n                                      <azteca-form-field *ngIf=\"!articulo.articuloStock.manejaSeries\" [label]=\"'Unidad de Almacenamiento:'\">\n                                          <az-combobox formControlName=\"idUnidadMedida\"\n                                                       [(ngModel)]=\"articulo.articuloStock.idUnidadMedida\"\n                                                       [items]=\"unidadesMedida\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <az-checkbox [label]=\"'Habilitar control por n&uacute;mero de serie'\"\n                                                   formControlName=\"manejaSeries\"\n                                                   [(ngModel)]=\"articulo.articuloStock.manejaSeries\"\n                                                   (change)=\"manejaSeriesChecked()\"></az-checkbox>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <az-checkbox [label]=\"'Habilitar control por lotes'\"\n                                                   formControlName=\"manejaLotes\"\n                                                   [(ngModel)]=\"articulo.articuloStock.manejaLotes\"></az-checkbox>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <az-checkbox [label]=\"'Requiere control de fechas de caducidad'\"\n                                                   formControlName=\"manejaCaducidad\"\n                                                   [(ngModel)]=\"articulo.articuloStock.manejaCaducidad\"></az-checkbox>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\" *ngIf=\"articulo.articuloStock.manejaLotes\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <label>M&eacute;todo de Valuaci&oacute;n:</label>\n                                      <input type=\"radio\" formControlName=\"metodoValuacion\"\n                                             value=\"N\"\n                                             [checked]=\"formCtrlMetodoValuacion.value=='N'\"> Ninguno\n                                      <input type=\"radio\" formControlName=\"metodoValuacion\"\n                                             value=\"F\"\n                                             [checked]=\"formCtrlMetodoValuacion.value=='F'\"> PEPS\n                                      <input type=\"radio\" formControlName=\"metodoValuacion\"\n                                             value=\"L\"\n                                             [checked]=\"formCtrlMetodoValuacion.value=='L'\"> UEPS\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Descripci&oacute;n:'\">\n                                          <az-textarea formControlName=\"descripcion\" [(ngModel)]=\"articulo.articuloStock.descripcion\"></az-textarea>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                          <tab heading=\"Proveedores\" (select)=\"refreshControls('Proveedores')\">\n                              <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAgregarProveedor()\" [disabled]=\"articulo.identity == 0 || readonlyMode\">\n                                  <span aria-hidden=\"true\" class=\"glyphicon glyphicon-plus\"></span>\n                                  Agregar \n                              </button>\n                              <purchasing-producto-proveedor #proveedorArticulo [idArticulo]=\"articulo.identity\"\n                                                             [showTitle]=\"false\"\n                                                             [searchElement]=\"false\"\n                                                             [searchByArticulo]=\"true\"\n                                                             [searchByServicio]=\"false\"></purchasing-producto-proveedor>\n\n                          </tab>\n                          <tab heading=\"Impuestos\" (select)=\"refreshControls('Impuestos')\">\n                              <purchasing-articulo-impuesto formControlName=\"impuestos\"\n                                                            [(ngModel)]=\"articulo.impuestos\">\n                              </purchasing-articulo-impuesto>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n        \n          </azteca-catalog-editor>\n\n          <!--Asignacion de impuestos-->\n          <accounting-impuesto-asignacion (dataUpdater)=\"onAgregarImpuesto($event)\">\n\n          </accounting-impuesto-asignacion>\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ArticulosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: articulo_service_1.ArticuloService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, articulo_service_1.ArticuloService, unidad_medida_service_1.UnidadMedidaService, unidad_medida_tipo_service_1.UnidadMedidaTipoService])
    ], ArticulosEditor);
    return ArticulosEditor;
}(editors_1.CatalogEditor));
exports.ArticulosEditor = ArticulosEditor;
