import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { ToolbarButton } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs, TrackableCollection } from 'framework3/editors';
import { CategoriasPresupuestalesService } from '../services/categorias-presupuestales.service';
import { CategoriasPresupuestalesInfo } from '../models/categorias-presupuestales';
import { ServicioListComponent } from '../dialogs/servicio-list.component';
import { ArticuloListComponent } from "../dialogs/articulo-list.component";
import { ArticuloItem } from '../models/articulo';
import { ServicioItem } from '../models/servicio';
export declare class CategoriasPresupuestalesEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private categoriasPresupuestalesService;
    categoriasPresupuestales: CategoriasPresupuestalesInfo;
    Editing: boolean;
    articulosCollection: TrackableCollection;
    serviciosCollection: TrackableCollection;
    articuloDialog: ArticuloListComponent;
    servicioDialog: ServicioListComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, categoriasPresupuestalesService: CategoriasPresupuestalesService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onSelectTab(args: any): void;
    onToolbarButtonClick(args: ToolbarButton): void;
    onAgregarArticulo(): void;
    onAgregarServicio(): void;
    onSelectedArticuloChanged(articulos: ArticuloItem[]): void;
    onSelectedServicioChanged(servicios: ServicioItem[]): void;
    onRemoveArticulo(item: any): void;
    onRemoveServicio(item: any): void;
}
