"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var categorias_presupuestales_service_1 = require("../services/categorias-presupuestales.service");
var CategoriasPresupuestalesManager = /** @class */ (function (_super) {
    __extends(CategoriasPresupuestalesManager, _super);
    //    
    function CategoriasPresupuestalesManager(context, router, route, categoriasPresupuestalesService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.categoriasPresupuestalesService = categoriasPresupuestalesService;
        _this.categoriasPresupuestales = [];
        return _this;
    }
    CategoriasPresupuestalesManager_1 = CategoriasPresupuestalesManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    CategoriasPresupuestalesManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
        this.refreshList();
        this.applyPolicies();
    };
    CategoriasPresupuestalesManager.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.categoriasPresupuestalesService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.categoriasPresupuestales = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CategoriasPresupuestalesManager.prototype.onAddingItem = function () {
        this.router.navigate([0], { relativeTo: this.route });
    };
    CategoriasPresupuestalesManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    CategoriasPresupuestalesManager.prototype.onEditingItem = function (item) {
        this.router.navigate([item.id], { relativeTo: this.route });
    };
    CategoriasPresupuestalesManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.categoriasPresupuestalesService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CategoriasPresupuestalesManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    CategoriasPresupuestalesManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.categoriasPresupuestalesService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var CategoriasPresupuestalesManager_1;
    CategoriasPresupuestalesManager = CategoriasPresupuestalesManager_1 = __decorate([
        core_1.Component({
            selector: 'compras-categorias-presupuestales-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Compras - CategoriasPresupuestales</div>\n          <div class=\"card-block\">\n\n      \t\t<azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n      \t\t\t\t\t\t\t\t(addingItem)=\"onAddingItem()\"\n      \t\t\t\t\t\t\t\t(viewingItem)=\"onViewingItem($event)\"\n      \t\t\t\t\t\t\t\t(editingItem)=\"onEditingItem($event)\"\n      \t\t\t\t\t\t\t\t(deletingItem)=\"onDeletingItem($event)\"\n      \t\t\t\t\t\t\t\t(cloningItem)=\"onCloningItem($event)\"\n      \t\t\t\t\t\t\t\t(changingItemState)=\"onChangingItemState($event)\"\n      \t\t\t\t\t\t\t\t(configureCatalog)=\"onConfigureCatalog($event)\"\n      \t\t\t\t\t\t\t\t[enabled]=\"enabled\"\n      \t\t\t\t\t\t\t\t[allowNew]=\"allowNew\"\n      \t\t\t\t\t\t\t\t[allowView]=\"allowView\"\n      \t\t\t\t\t\t\t\t[allowEdit]=\"allowEdit\"\n      \t\t\t\t\t\t\t\t[allowDelete]=\"allowDelete\"\n      \t\t\t\t\t\t\t\t[allowClone]=\"allowClone\"\n      \t\t\t\t\t\t\t\t[allowChangeState]=\"allowChangeState\"\n      \t\t\t\t\t\t\t\t[allowAudit]=\"allowAudit\"\n      \t\t\t\t\t\t\t\t[catalogList]=\"categoriasPresupuestales\"\n      \t\t\t\t\t\t\t\t[totalRows]=\"totalRows\"\n      \t\t\t\t\t\t\t\t[pageIndex]=\"pageIndex\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Columnas del listado ----------------------------->\n    \n      \t\t\t<azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n      \t\t\t<azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\t\t\t\n\n      \t\t</azteca-catalog-manager>\n\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CategoriasPresupuestalesManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: categorias_presupuestales_service_1.CategoriasPresupuestalesService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, categorias_presupuestales_service_1.CategoriasPresupuestalesService])
    ], CategoriasPresupuestalesManager);
    return CategoriasPresupuestalesManager;
}(editors_1.CatalogManager));
exports.CategoriasPresupuestalesManager = CategoriasPresupuestalesManager;
