import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { MenuItem } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { CentralService } from '../services/central.service';
import { CentralInfo } from '../models/central';
import { CajaService } from '../../treasury/services/caja.service';
import { CajaItem } from '../../treasury/models/caja';
import { ZonaCompraService } from '../services/zona-compra.service';
import { ZonaCompraItem } from '../models/zona-compra';
export declare class CentralesEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private centralService;
    private cajaService;
    private zonaCompraService;
    central: CentralInfo;
    cajas: CajaItem[];
    zonasCompra: ZonaCompraItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, centralService: CentralService, cajaService: CajaService, zonaCompraService: ZonaCompraService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadCajas(): void;
    loadZonasCompra(): void;
    onMenuItemClick(option: MenuItem): void;
}
