"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var central_service_1 = require("../services/central.service");
var central_1 = require("../models/central");
var caja_service_1 = require("../../treasury/services/caja.service");
var zona_compra_service_1 = require("../services/zona-compra.service");
var CentralesEditor = /** @class */ (function (_super) {
    __extends(CentralesEditor, _super);
    //
    function CentralesEditor(router, route, formBuilder, changeDetector, context, location, centralService, cajaService, zonaCompraService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.centralService = centralService;
        _this.cajaService = cajaService;
        _this.zonaCompraService = zonaCompraService;
        _this.central = new central_1.CentralInfo();
        _this.cajas = [];
        _this.zonasCompra = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idCaja': ['', controls_1.AztecaValidators.selected],
            'idZonaCompra': ['', controls_1.AztecaValidators.selected],
            'idRemitente': ['', controls_1.AztecaValidators.selected],
            'idOperador': [''],
        });
        return _this;
    }
    CentralesEditor_1 = CentralesEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    CentralesEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.loadCajas();
        this.loadZonasCompra();
    };
    CentralesEditor.prototype.onCreatingItem = function () {
    };
    CentralesEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.centralService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.central = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentralesEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.centralService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.central = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentralesEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.centralService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.central = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentralesEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.centralService.update(this.central)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.central.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.central = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentralesEditor.prototype.loadCajas = function () {
        var _this = this;
        this.cajaService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (cajas) {
            _this.cajas = cajas;
        })
            .catch(function (error) { return _this.showAlert(error, 'danger'); });
    };
    CentralesEditor.prototype.loadZonasCompra = function () {
        var _this = this;
        this.zonaCompraService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (zonas) {
            _this.zonasCompra = zonas;
        })
            .catch(function (error) { return _this.showAlert(error, 'danger'); });
    };
    CentralesEditor.prototype.onMenuItemClick = function (option) {
        if (option.name == 'USERS') {
            this.router.navigate(['members'], { relativeTo: this.route });
        }
        else if (option.name == 'DEPTOS') {
            this.router.navigate(['departamentos'], { relativeTo: this.route });
        }
    };
    var CentralesEditor_1;
    CentralesEditor = CentralesEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-central-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Central'\"\n                                 [info]=\"central\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Miembros'\" [smallText]=\"'editar usuarios miembro'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'DEPTOS'\" [icon]=\"'glyphicon glyphicon-lock'\" [text]=\"'Departamentos'\" [smallText]=\"'definir departamentos'\"></azteca-menu-item>\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"central.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"central.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-4\">\n                                      <azteca-form-field [label]=\"'Zona de Compra'\">\n                                          <az-combobox formControlName=\"idZonaCompra\"\n                                                       [(ngModel)]=\"central.idZonaCompra\"\n                                                       [items]=\"zonasCompra\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Caja:'\">\n                                          <az-combobox formControlName=\"idCaja\"\n                                                       [(ngModel)]=\"central.idCaja\"\n                                                       [items]=\"cajas\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <az-panel [header]=\"'Notificaciones'\">\n\n                                  <azteca-form-field [label]=\"'Remitente:'\">\n                                      <notification-remitente-mail-selector formControlName=\"idRemitente\" [(ngModel)]=\"central.idRemitente\"></notification-remitente-mail-selector>\n                                  </azteca-form-field>\n\n                                  <azteca-form-field [label]=\"'Operador:'\">\n                                      <notification-operador-selector formControlName=\"idOperador\" [(ngModel)]=\"central.idOperador\"></notification-operador-selector>\n                                  </azteca-form-field>\n\n                              </az-panel>\n                          </tab>\n\n                   \n                      </tabset>\n                  </div>\n              </div>\n\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CentralesEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: central_service_1.CentralService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, central_service_1.CentralService, caja_service_1.CajaService, zona_compra_service_1.ZonaCompraService])
    ], CentralesEditor);
    return CentralesEditor;
}(editors_1.CatalogEditor));
exports.CentralesEditor = CentralesEditor;
