import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { ToolbarButton, MenuItem } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs, TrackableCollection } from 'framework3/editors';
import { CentroCostoService } from '../services/centro-costo.service';
import { CentroCostoInfo } from '../models/centro-costo';
import { SegmentoNegocioService } from '../../accounting/services/segmento-negocio.service';
import { SegmentoNegocioItem } from '../../accounting/models/segmento-negocio';
import { ArticuloItem } from '../models/articulo';
import { ServicioItem } from '../models/servicio';
import { ServicioListComponent } from '../dialogs/servicio-list.component';
import { ArticuloListComponent } from "../dialogs/articulo-list.component";
export declare class CentrosCostoEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private centroCostoService;
    private segmentoNegocioService;
    centroCosto: CentroCostoInfo;
    segmentosNegocio: SegmentoNegocioItem[];
    articulosCollection: TrackableCollection;
    serviciosCollection: TrackableCollection;
    articuloDialog: ArticuloListComponent;
    servicioDialog: ServicioListComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, centroCostoService: CentroCostoService, segmentoNegocioService: SegmentoNegocioService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadSegmentosNegocio(): void;
    onSelectTab(args: any): void;
    onToolbarButtonClick(args: ToolbarButton): void;
    onAgregarArticulo(): void;
    onAgregarServicio(): void;
    onSelectedArticuloChanged(articulos: ArticuloItem[]): void;
    onSelectedServicioChanged(servicios: ServicioItem[]): void;
    onRemoveArticulo(item: any): void;
    onRemoveServicio(item: any): void;
    onMenuItemClick(option: MenuItem): void;
}
