"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var centro_costo_service_1 = require("../services/centro-costo.service");
var centro_costo_1 = require("../models/centro-costo");
var segmento_negocio_service_1 = require("../../accounting/services/segmento-negocio.service");
var categorias_presupuestales_1 = require("../models/categorias-presupuestales");
var wijmo_1 = require("wijmo/wijmo");
var servicio_list_component_1 = require("../dialogs/servicio-list.component");
var articulo_list_component_1 = require("../dialogs/articulo-list.component");
var CentrosCostoEditor = /** @class */ (function (_super) {
    __extends(CentrosCostoEditor, _super);
    //
    function CentrosCostoEditor(router, route, formBuilder, changeDetector, context, location, centroCostoService, segmentoNegocioService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.centroCostoService = centroCostoService;
        _this.segmentoNegocioService = segmentoNegocioService;
        _this.centroCosto = new centro_costo_1.CentroCostoInfo();
        _this.segmentosNegocio = [];
        _this.articulosCollection = new editors_1.TrackableCollection();
        _this.serviciosCollection = new editors_1.TrackableCollection();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idSegmentoNegocio': [0, controls_1.AztecaValidators.selected],
        });
        return _this;
    }
    CentrosCostoEditor_1 = CentrosCostoEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    CentrosCostoEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.loadSegmentosNegocio();
    };
    CentrosCostoEditor.prototype.onCreatingItem = function () {
    };
    CentrosCostoEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.centroCostoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.centroCosto = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentrosCostoEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.centroCostoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.centroCosto = info;
            _this.articulosCollection.sourceCollection = _this.centroCosto.articulos;
            _this.articulosCollection.refresh();
            _this.serviciosCollection.sourceCollection = _this.centroCosto.servicios;
            _this.serviciosCollection.refresh();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentrosCostoEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.centroCostoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.centroCosto = info;
            _this.articulosCollection.sourceCollection = _this.centroCosto.articulos;
            _this.articulosCollection.refresh();
            _this.serviciosCollection.sourceCollection = _this.centroCosto.servicios;
            _this.serviciosCollection.refresh();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentrosCostoEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.centroCostoService.update(this.centroCosto)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.centroCosto.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.centroCosto = info;
            _this.articulosCollection.sourceCollection = _this.centroCosto.articulos;
            _this.articulosCollection.refresh();
            _this.serviciosCollection.sourceCollection = _this.centroCosto.servicios;
            _this.serviciosCollection.refresh();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentrosCostoEditor.prototype.loadSegmentosNegocio = function () {
        var _this = this;
        this.segmentoNegocioService.loadList(this.context.app.defaultCompany.identity)
            .then(function (items) { return _this.segmentosNegocio = items; })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentrosCostoEditor.prototype.onSelectTab = function (args) {
        if (args.heading) {
            wijmo_1.Control.invalidateAll();
        }
    };
    CentrosCostoEditor.prototype.onToolbarButtonClick = function (args) {
        if (args.name == 'ADD-ARTICULO')
            this.onAgregarArticulo();
        else if (args.name == 'ADD-SERVICIO')
            this.onAgregarServicio();
    };
    CentrosCostoEditor.prototype.onAgregarArticulo = function () {
        this.articuloDialog.show();
    };
    CentrosCostoEditor.prototype.onAgregarServicio = function () {
        this.servicioDialog.show();
    };
    CentrosCostoEditor.prototype.onSelectedArticuloChanged = function (articulos) {
        for (var _i = 0, articulos_1 = articulos; _i < articulos_1.length; _i++) {
            var articulo = articulos_1[_i];
            if (this.centroCosto.articulos.filter(function (X) { return X.id == articulo.id; }).length == 0) {
                var articulosSlice = this.centroCosto.articulos.slice();
                var articuloNew = new categorias_presupuestales_1.Articulo();
                articuloNew.id = articulo.id;
                articuloNew.codigo = articulo.codigo;
                articuloNew.nombre = articulo.nombre;
                articuloNew.activo = true;
                articulosSlice.push(articuloNew);
                this.centroCosto.articulos = articulosSlice;
                this.articulosCollection.sourceCollection = articulosSlice;
                this.articulosCollection.refresh();
            }
        }
    };
    CentrosCostoEditor.prototype.onSelectedServicioChanged = function (servicios) {
        for (var _i = 0, servicios_1 = servicios; _i < servicios_1.length; _i++) {
            var servicio = servicios_1[_i];
            if (this.centroCosto.servicios.filter(function (X) { return X.id == servicio.id; }).length == 0) {
                var serviciosSlice = this.centroCosto.servicios.slice();
                var servicioNew = new categorias_presupuestales_1.Servicio();
                servicioNew.id = servicio.id;
                servicioNew.codigo = servicio.codigo;
                servicioNew.nombre = servicio.nombre;
                servicioNew.activo = true;
                serviciosSlice.push(servicioNew);
                this.centroCosto.servicios = serviciosSlice;
                this.serviciosCollection.sourceCollection = serviciosSlice;
                this.serviciosCollection.refresh();
            }
        }
    };
    CentrosCostoEditor.prototype.onRemoveArticulo = function (item) {
        this.articulosCollection.remove(item);
        this.articulosCollection.refresh();
    };
    CentrosCostoEditor.prototype.onRemoveServicio = function (item) {
        this.serviciosCollection.remove(item);
        this.serviciosCollection.refresh();
    };
    CentrosCostoEditor.prototype.onMenuItemClick = function (option) {
        if (option.name == 'USERS') {
            this.router.navigate(['members'], { relativeTo: this.route });
        }
    };
    var CentrosCostoEditor_1;
    __decorate([
        core_1.ViewChild(core_1.forwardRef(function () { return articulo_list_component_1.ArticuloListComponent; })),
        __metadata("design:type", articulo_list_component_1.ArticuloListComponent)
    ], CentrosCostoEditor.prototype, "articuloDialog", void 0);
    __decorate([
        core_1.ViewChild(core_1.forwardRef(function () { return servicio_list_component_1.ServicioListComponent; })),
        __metadata("design:type", servicio_list_component_1.ServicioListComponent)
    ], CentrosCostoEditor.prototype, "servicioDialog", void 0);
    CentrosCostoEditor = CentrosCostoEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-centro-costo-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'CentroCosto'\"\n                                 [info]=\"centroCosto\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Miembros'\" [smallText]=\"'editar usuarios miembro'\"></azteca-menu-item>\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"centroCosto.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"centroCosto.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n                              <azteca-form-field [label]=\"'Segmento de negocio:'\">\n                                  <az-combobox formControlName=\"idSegmentoNegocio\"\n                                               [(ngModel)]=\"centroCosto.idSegmentoNegocio\"\n                                               [items]=\"segmentosNegocio\"\n                                               [displayMember]=\"'nombre'\"\n                                               [valueMember]=\"'id'\">\n                                  </az-combobox>\n                              </azteca-form-field>\n                          </tab>\n                          <tab heading=\"Articulos \" (select)=\"onSelectTab($event)\">\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD-ARTICULO'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar Articulo'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                              </az-toolbar>\n\n\n                              <wj-flex-grid #gridArticulos style=\"height:550px\"\n                                            [itemsSource]=\"articulosCollection\">\n\n                                  <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveArticulo(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-trash\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n\n                              <purchasing-articulo-list (selectedItemsChanged)=\"onSelectedArticuloChanged($event)\" [multiSelect]=\"true\"></purchasing-articulo-list>\n                          </tab>\n                          <tab heading=\"Servicios\" (select)=\"onSelectTab($event)\">\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD-SERVICIO'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar Servicio'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                              </az-toolbar>\n\n\n                              <wj-flex-grid #gridServicios style=\"height:550px\"\n                                            [itemsSource]=\"serviciosCollection\">\n\n                                  <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveServicio(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-trash\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                              <purchasing-servicio-list (selectedItemsChanged)=\"onSelectedServicioChanged($event)\" [multiSelect]=\"true\"></purchasing-servicio-list>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CentrosCostoEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: centro_costo_service_1.CentroCostoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, centro_costo_service_1.CentroCostoService, segmento_negocio_service_1.SegmentoNegocioService])
    ], CentrosCostoEditor);
    return CentrosCostoEditor;
}(editors_1.CatalogEditor));
exports.CentrosCostoEditor = CentrosCostoEditor;
