import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { MenuItem } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { AreaItem } from '../../inventory/models/area';
import { AreaService } from '../../inventory/services/area.service';
import { AlmacenItem } from '../../inventory/models/almacen';
import { CentroRecepcionService } from '../services/centro-recepcion.service';
import { CentroRecepcionInfo } from '../models/centro-recepcion';
export declare class CentrosRecepcionEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private centroRecepcionService;
    private areaService;
    centroRecepcion: CentroRecepcionInfo;
    areas: AreaItem[];
    almacenes: AlmacenItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, centroRecepcionService: CentroRecepcionService, areaService: AreaService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onSelectTab(): void;
    loadAreas(): void;
    selectArea(idArea: any): void;
    onMenuItemClick(option: MenuItem): void;
}
