"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var area_service_1 = require("../../inventory/services/area.service");
//Features
var centro_recepcion_service_1 = require("../services/centro-recepcion.service");
var centro_recepcion_1 = require("../models/centro-recepcion");
var CentrosRecepcionEditor = /** @class */ (function (_super) {
    __extends(CentrosRecepcionEditor, _super);
    //
    function CentrosRecepcionEditor(router, route, formBuilder, changeDetector, context, location, centroRecepcionService, areaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.centroRecepcionService = centroRecepcionService;
        _this.areaService = areaService;
        _this.centroRecepcion = new centro_recepcion_1.CentroRecepcionInfo();
        //idArea: number;
        _this.areas = [];
        _this.almacenes = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'area': ['', forms_1.Validators.required],
            'almacen': ['', forms_1.Validators.required],
            'idCuenta': [0],
            'domicilio': [''],
            'telefono1': [''],
            'telefono2': [''],
            'fax': [''],
            'correo': [''],
        });
        //Suscribirse a cambios en central ya que esta determina varios comportamientos en los campos y validaciones
        _this.catalogForm.controls['area'].valueChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.selectArea(value); });
        });
        return _this;
    }
    CentrosRecepcionEditor_1 = CentrosRecepcionEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    CentrosRecepcionEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.loadAreas();
    };
    CentrosRecepcionEditor.prototype.onCreatingItem = function () {
    };
    CentrosRecepcionEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.centroRecepcionService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.centroRecepcion = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentrosRecepcionEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.centroRecepcionService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.centroRecepcion = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentrosRecepcionEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.centroRecepcionService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.centroRecepcion = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentrosRecepcionEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.centroRecepcionService.update(this.centroRecepcion)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.centroRecepcion.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.centroRecepcion = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentrosRecepcionEditor.prototype.onSelectTab = function () {
        //refresca los controles de wijmo
        wijmo_1.Control.invalidateAll();
    };
    CentrosRecepcionEditor.prototype.loadAreas = function () {
        var _this = this;
        this.areaService.loadList(this.context.app.defaultSite.identity)
            .then(function (areas) { return _this.areas = areas; })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentrosRecepcionEditor.prototype.selectArea = function (idArea) {
        var _this = this;
        this.areaService.loadAlmacenes(idArea)
            .then(function (almacenes) { return _this.almacenes = almacenes; })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentrosRecepcionEditor.prototype.onMenuItemClick = function (option) {
        if (option.name == 'USERS') {
            this.router.navigate(['members'], { relativeTo: this.route });
        }
    };
    var CentrosRecepcionEditor_1;
    CentrosRecepcionEditor = CentrosRecepcionEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-centro-recepcion-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'CentroRecepcion'\"\n                                 [info]=\"centroRecepcion\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Miembros'\" [smallText]=\"'editar usuarios miembro'\"></azteca-menu-item>\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"centroRecepcion.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"centroRecepcion.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onSelectTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Area:'\">\n                                          <az-combobox formControlName=\"area\"\n                                                       [(ngModel)]=\"centroRecepcion.idArea\"\n                                                       [items]=\"areas\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\"\n                                                       (selectedItemChanged)=\"selectArea($event)\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Almacen:'\">\n                                          <az-combobox formControlName=\"almacen\"\n                                                       [(ngModel)]=\"centroRecepcion.idAlmacen\"\n                                                       [items]=\"almacenes\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"idCuenta\" [(ngModel)]=\"centroRecepcion.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n\n\n                          <tab heading=\"Domicilio\" (select)=\"onSelectTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"''\">\n                                          <general-domicilio-editor #domicilio formControlName=\"domicilio\"\n                                                                    [(ngModel)]=\"centroRecepcion.domicilio\"\n                                                                    [asentamientoVisible]=\"false\"\n                                                                    [cruceUnoVisible]=\"false\"\n                                                                    [cruceDosVisible]=\"false\">\n                                          </general-domicilio-editor>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'Telefono 1:'\">\n                                          <az-textbox formControlName=\"telefono1\" [(ngModel)]=\"centroRecepcion.telefono1\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'Telefono 2:'\">\n                                          <az-textbox formControlName=\"telefono2\" [(ngModel)]=\"centroRecepcion.telefono2\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                           \n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'Fax:'\">\n                                          <az-textbox formControlName=\"fax\" [(ngModel)]=\"centroRecepcion.fax\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'Correo:'\">\n                                          <az-textbox formControlName=\"correo\" [(ngModel)]=\"centroRecepcion.correo\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CentrosRecepcionEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: centro_recepcion_service_1.CentroRecepcionService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, centro_recepcion_service_1.CentroRecepcionService, area_service_1.AreaService])
    ], CentrosRecepcionEditor);
    return CentrosRecepcionEditor;
}(editors_1.CatalogEditor));
exports.CentrosRecepcionEditor = CentrosRecepcionEditor;
