import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { MenuItem } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { DepartamentoService } from '../services/departamento.service';
import { DepartamentoInfo } from '../models/departamento';
import { CajaService } from '../../treasury/services/caja.service';
import { CajaItem } from '../../treasury/models/caja';
export declare class DepartamentosEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private departamentoService;
    private cajaService;
    departamento: DepartamentoInfo;
    tiposPresupuesto: {
        id: string;
        nombre: string;
    }[];
    cajas: CajaItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, departamentoService: DepartamentoService, cajaService: CajaService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadCajas(): void;
    onMenuItemClick(option: MenuItem): void;
}
