"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var departamento_service_1 = require("../services/departamento.service");
var departamento_1 = require("../models/departamento");
var caja_service_1 = require("../../treasury/services/caja.service");
var DepartamentosEditor = /** @class */ (function (_super) {
    __extends(DepartamentosEditor, _super);
    //
    function DepartamentosEditor(router, route, formBuilder, changeDetector, context, location, departamentoService, cajaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.departamentoService = departamentoService;
        _this.cajaService = cajaService;
        _this.departamento = new departamento_1.DepartamentoInfo();
        _this.tiposPresupuesto = [];
        _this.cajas = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'tipoPresupuesto': ['', forms_1.Validators.required],
            'idCaja': [0],
            'idCuenta': [0],
            'idCentroCosto': [0],
        });
        _this.tiposPresupuesto =
            [
                { 'id': 'N', 'nombre': 'No Controlado' },
                //{ 'id': 'D', 'nombre': 'Nivel Departamento' },
                { 'id': 'C', 'nombre': 'Nivel Categoria' }
            ];
        return _this;
    }
    DepartamentosEditor_1 = DepartamentosEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    DepartamentosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.loadCajas();
    };
    DepartamentosEditor.prototype.onCreatingItem = function () {
    };
    DepartamentosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.departamentoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.departamento = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DepartamentosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.departamentoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.departamento = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DepartamentosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.departamentoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.departamento = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DepartamentosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.departamentoService.update(this.departamento)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.departamento.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.departamento = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DepartamentosEditor.prototype.loadCajas = function () {
        var _this = this;
        this.cajaService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (cajas) {
            _this.cajas = cajas;
        })
            .catch(function (error) { return _this.showAlert(error, 'danger'); });
    };
    DepartamentosEditor.prototype.onMenuItemClick = function (option) {
        if (option.name == 'USERS') {
            this.router.navigate(['members'], { relativeTo: this.route });
        }
        else if (option.name == 'C.RECEP') {
            this.router.navigate(['centros-recepcion'], { relativeTo: this.route });
        }
        else if (option.name == 'C.COSTO') {
            this.router.navigate(['centros-costo'], { relativeTo: this.route });
        }
        else if (option.name == 'CAT.PRES') {
            this.router.navigate(['categorias-presupuestales'], { relativeTo: this.route });
        }
    };
    var DepartamentosEditor_1;
    DepartamentosEditor = DepartamentosEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-departamento-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Departamento'\"\n                                 [info]=\"departamento\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Miembros'\" [smallText]=\"'editar usuarios miembro'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'C.RECEP'\" [icon]=\"'glyphicon glyphicon-lock'\" [text]=\"'Centros de Recepci\u00F3n'\" [smallText]=\"'definir centros de recepci\u00F3n'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'CAT.PRES'\" [icon]=\"'glyphicon glyphicon-lock'\" [text]=\"'Categorias Presupuestales'\" [smallText]=\"'definir las categorias presupuetales'\"></azteca-menu-item>\n              <!--<azteca-menu-item [name]=\"'C.COSTO'\" [icon]=\"'glyphicon glyphicon-lock'\" [text]=\"'Centros de Costo'\" [smallText]=\"'definir centros de costo'\"></azteca-menu-item>-->\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"departamento.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"departamento.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\">\n\n                              <!--<div class=\"row\">\n                              <div class=\"col-12 col-md-6\">\n                                  <azteca-form-field [label]=\"'Caja:'\">\n                                      <az-combobox formControlName=\"idCaja\"\n                                                   [(ngModel)]=\"departamento.idCaja\"\n                                                   [items]=\"cajas\"\n                                                   [valueMember]=\"'id'\"\n                                                   [displayMember]=\"'nombre'\">\n                                      </az-combobox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>-->\n\n                              <div class=\"row\">\n                                  <div class=\"col-5 col-md-4\">\n                                      <azteca-form-field [label]=\"'Manejo de Presupuesto'\">\n                                          <az-combobox formControlName=\"tipoPresupuesto\"\n                                                       [(ngModel)]=\"departamento.tipoPresupuesto\"\n                                                       [items]=\"tiposPresupuesto\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"idCuenta\" [(ngModel)]=\"departamento.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Centro de Costo:'\">\n                                          <purchasing-centro-costo-selector formControlName=\"idCentroCosto\"\n                                                                            [enabled]=\"true\"\n                                                                            [(ngModel)]=\"departamento.idCentroCosto\"></purchasing-centro-costo-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return DepartamentosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: departamento_service_1.DepartamentoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, departamento_service_1.DepartamentoService, caja_service_1.CajaService])
    ], DepartamentosEditor);
    return DepartamentosEditor;
}(editors_1.CatalogEditor));
exports.DepartamentosEditor = DepartamentosEditor;
