"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var departamento_service_1 = require("../services/departamento.service");
var DepartamentosManager = /** @class */ (function (_super) {
    __extends(DepartamentosManager, _super);
    //    
    function DepartamentosManager(context, router, route, departamentoService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.departamentoService = departamentoService;
        _this.departamentos = [];
        return _this;
    }
    DepartamentosManager_1 = DepartamentosManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    DepartamentosManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
        this.refreshList();
        this.applyPolicies();
    };
    DepartamentosManager.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.departamentoService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.departamentos = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DepartamentosManager.prototype.onAddingItem = function () {
        this.router.navigate([0], { relativeTo: this.route });
    };
    DepartamentosManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    DepartamentosManager.prototype.onEditingItem = function (item) {
        this.router.navigate([item.id], { relativeTo: this.route });
    };
    DepartamentosManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.departamentoService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DepartamentosManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    DepartamentosManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.departamentoService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DepartamentosManager.prototype.onMenuItemClick = function (option) {
        if (option.name == 'USERS') {
            this.router.navigate([this.manager.currentItem.id.toString() + '/members'], { relativeTo: this.route });
        }
        else if (option.name == 'C.RECEP') {
            this.router.navigate([this.manager.currentItem.id.toString() + '/centros-recepcion'], { relativeTo: this.route });
        }
        else if (option.name == 'C.COSTO') {
            this.router.navigate([this.manager.currentItem.id.toString() + '/centros-costo'], { relativeTo: this.route });
        }
        else if (option.name == 'CAT.PRES') {
            this.router.navigate([this.manager.currentItem.id.toString() + '/categorias-presupuestales'], { relativeTo: this.route });
        }
    };
    var DepartamentosManager_1;
    DepartamentosManager = DepartamentosManager_1 = __decorate([
        core_1.Component({
            selector: 'compras-departamentos-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Compras - Departamentos</div>\n          <div class=\"card-block\">\n\n              <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                                      (addingItem)=\"onAddingItem()\"\n                                      (viewingItem)=\"onViewingItem($event)\"\n                                      (editingItem)=\"onEditingItem($event)\"\n                                      (deletingItem)=\"onDeletingItem($event)\"\n                                      (cloningItem)=\"onCloningItem($event)\"\n                                      (changingItemState)=\"onChangingItemState($event)\"\n                                      (configureCatalog)=\"onConfigureCatalog($event)\"\n                                      [enabled]=\"enabled\"\n                                      [allowNew]=\"allowNew\"\n                                      [allowView]=\"allowView\"\n                                      [allowEdit]=\"allowEdit\"\n                                      [allowDelete]=\"allowDelete\"\n                                      [allowClone]=\"allowClone\"\n                                      [allowChangeState]=\"allowChangeState\"\n                                      [allowAudit]=\"allowAudit\"\n                                      [catalogList]=\"departamentos\"\n                                      [totalRows]=\"totalRows\"\n                                      [pageIndex]=\"pageIndex\"\n                                      (menuItemClick)=\"onMenuItemClick($event)\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Miembros'\" [smallText]=\"'editar usuarios miembro'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'C.RECEP'\" [icon]=\"'glyphicon glyphicon-lock'\" [text]=\"'Centros de Recepci\u00F3n'\" [smallText]=\"'definir centros de recepci\u00F3n'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'CAT.PRES'\" [icon]=\"'glyphicon glyphicon-lock'\" [text]=\"'Categorias Presupuestales'\" [smallText]=\"'definir las categorias presupuetales'\"></azteca-menu-item>\n                  <!--<azteca-menu-item [name]=\"'C.COSTO'\" [icon]=\"'glyphicon glyphicon-lock'\" [text]=\"'Centros de Costo'\" [smallText]=\"'definir centros de costo'\"></azteca-menu-item>-->\n                  <!------------------- Controles del editor ----------------------------->\n\n                  <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n\n              </azteca-catalog-manager>\n\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return DepartamentosManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: departamento_service_1.DepartamentoService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, departamento_service_1.DepartamentoService])
    ], DepartamentosManager);
    return DepartamentosManager;
}(editors_1.CatalogManager));
exports.DepartamentosManager = DepartamentosManager;
