import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, WorkflowStep } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { FormatoTipoService, FormatoItem } from 'framework3/general';
import { EmpresaService } from '../services/empresa.service';
import { EmpresaInfo } from '../models/empresa';
import { SucursalItem } from '../models/sucursal';
import { SucursalService } from '../services/sucursal.service';
import { EjercicioTipoItem } from '../../accounting/models/ejercicio-tipo';
import { EjercicioTipoService } from '../../accounting/services/ejercicio-tipo.service';
import { DocumentTypeService } from 'framework3/core/services/document-type.service';
export declare class EmpresasEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private empresaService;
    private sucursalService;
    private formatoService;
    private ejercicioTipoService;
    private documentTypeService;
    empresa: EmpresaInfo;
    sucursales: SucursalItem[];
    formatosImpresion: FormatoItem[];
    ejerciciosTipos: EjercicioTipoItem[];
    ordenSteps: WorkflowStep[];
    requisicionesSteps: WorkflowStep[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, empresaService: EmpresaService, sucursalService: SucursalService, formatoService: FormatoTipoService, ejercicioTipoService: EjercicioTipoService, documentTypeService: DocumentTypeService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadSucursales(): void;
    loadFormatosImpresion(): void;
    selectSucursalesTab(arg: any): void;
    loadEjerciciosTipos(): void;
    loadOrdenesSteps(): void;
    loadRequisicionesSteps(): void;
}
