"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
var search_1 = require("framework3/search");
var general_1 = require("framework3/general");
//Features
var empresa_service_1 = require("../services/empresa.service");
var empresa_1 = require("../models/empresa");
var sucursal_service_1 = require("../services/sucursal.service");
var ejercicio_tipo_service_1 = require("../../accounting/services/ejercicio-tipo.service");
var wijmo_1 = require("wijmo/wijmo");
var document_type_service_1 = require("framework3/core/services/document-type.service");
var EmpresasEditor = /** @class */ (function (_super) {
    __extends(EmpresasEditor, _super);
    //
    function EmpresasEditor(router, route, formBuilder, changeDetector, context, location, empresaService, sucursalService, formatoService, ejercicioTipoService, documentTypeService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.empresaService = empresaService;
        _this.sucursalService = sucursalService;
        _this.formatoService = formatoService;
        _this.ejercicioTipoService = ejercicioTipoService;
        _this.documentTypeService = documentTypeService;
        _this.empresa = new empresa_1.EmpresaInfo();
        _this.sucursales = [];
        _this.formatosImpresion = [];
        _this.ejerciciosTipos = [];
        _this.ordenSteps = [];
        _this.requisicionesSteps = [];
        _this.catalogForm = formBuilder.group({
            'codigo': [''],
            'nombre': [''],
            'idRemitentePortal': [0],
            'idRemitenteOrdenes': [0],
            'idFormatoPresupuesto': [0],
            'idFormatoOrden': [0],
            'correoRecepcionCFD': ['', controls_1.AztecaValidators.email],
            'servidorPopCFD': [''],
            'puertoPopCFD': [0],
            'passwordPopCFD': [''],
            'idEjercicioTipo': [0, controls_1.AztecaValidators.selected],
            'idWorkflowStepRequisicionOrdenar': [0, controls_1.AztecaValidators.selected],
            'idWorkflowStepOrdenRecibir': [0, controls_1.AztecaValidators.selected],
        });
        return _this;
    }
    EmpresasEditor_1 = EmpresasEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    EmpresasEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.loadEjerciciosTipos();
        this.loadOrdenesSteps();
        this.loadRequisicionesSteps();
    };
    EmpresasEditor.prototype.onCreatingItem = function () {
    };
    EmpresasEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.empresaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empresa = info;
            _this.loadSucursales();
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.empresaService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empresa = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.empresaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empresa = info;
            _this.loadSucursales();
            _this.loadFormatosImpresion();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.empresaService.update(this.empresa)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.empresa.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.empresa = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.loadSucursales = function () {
        var _this = this;
        var request = new search_1.SearchRequest();
        request.paged = false;
        //Agregar condición de empresa actual
        var condicion = { field: "IdEmpresa", operator: "=", valueType: "int", value: this.empresa.identity.toString() };
        request.conditions.push(condicion);
        //
        this.context.app.showSpinner();
        this.sucursalService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.sucursales = response.rows;
            console.log(JSON.stringify(_this.sucursales));
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.loadFormatosImpresion = function () {
        var _this = this;
        this.formatoService.loadFormatos('PURCHASING_FORMATOS', this.empresa.identity)
            .then(function (formatos) {
            _this.formatosImpresion = formatos;
            _this.formatosImpresion.unshift({ id: 0, nombre: '[NINGUNO]', activo: true, codigo: '' });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //
    //Manejo de Estados
    EmpresasEditor.prototype.selectSucursalesTab = function (arg) {
        wijmo_1.Control.invalidateAll();
    };
    //
    EmpresasEditor.prototype.loadEjerciciosTipos = function () {
        var _this = this;
        this.ejercicioTipoService.loadList(this.context.app.defaultSite.identity)
            .then(function (tipos) { return _this.ejerciciosTipos = tipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.loadOrdenesSteps = function () {
        var _this = this;
        this.documentTypeService.getDetailByCode(this.context.app.defaultSite.identity, "PURCHASING_ORDER")
            .then(function (orden) { return _this.ordenSteps = orden.workflowSteps; })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.loadRequisicionesSteps = function () {
        var _this = this;
        this.documentTypeService.getDetailByCode(this.context.app.defaultSite.identity, "PURCHASING_REQ")
            .then(function (req) { return _this.requisicionesSteps = req.workflowSteps; })
            .catch(function (error) { return _this.handleError(error); });
    };
    var EmpresasEditor_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], EmpresasEditor.prototype, "sucursales", void 0);
    EmpresasEditor = EmpresasEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-empresa-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Empresa'\"\n                                 [info]=\"empresa\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"empresa.code\" [automatic]=\"true\"></catalog-code>\n                      </azteca-form-field>\n\n                      <label class=\"control-label\">Nombre:</label>\n                      <az-label [text]=\"empresa.empresaBase.nombre\"></az-label>\n\n                  </div>\n              </div>\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n                              <az-panel [header]=\"'Remitentes'\">\n                                  <azteca-form-field [label]=\"'Remitente del portal de proveedores:'\">\n                                      <notification-remitente-mail-selector formControlName=\"idRemitentePortal\" [(ngModel)]=\"empresa.idRemitentePortal\"></notification-remitente-mail-selector>\n                                  </azteca-form-field>\n\n                                  <azteca-form-field [label]=\"'Remitente de ordenes de compra:'\">\n                                      <notification-remitente-mail-selector formControlName=\"idRemitenteOrdenes\" [(ngModel)]=\"empresa.idRemitenteOrdenes\"></notification-remitente-mail-selector>\n                                  </azteca-form-field>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-6\">\n                                          <azteca-form-field [label]=\"'Tipo de ejercicio:'\">\n                                              <az-combobox formControlName=\"idEjercicioTipo\"\n                                                           [(ngModel)]=\"empresa.idEjercicioTipo\"\n                                                           [items]=\"ejerciciosTipos\"\n                                                           [displayMember]=\"'nombre'\"\n                                                           [valueMember]=\"'id'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n                              </az-panel>\n\n                              <az-panel [header]=\"'Buz\u00F3n de comprobantes fiscales'\">\n\n\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-lg-6\">\n                                          <azteca-form-field [label]=\"'Correo electr\u00F3nico:'\">\n                                              <az-textbox formControlName=\"correoRecepcionCFD\" [(ngModel)]=\"empresa.correoRecepcionCFD\"></az-textbox>\n                                          </azteca-form-field>\n                                      </div>\n                                      <div class=\"col-12 col-lg-6\">\n                                          <azteca-form-field [label]=\"'Contrase\u00F1a:'\">\n                                              <az-password formControlName=\"passwordPopCFD\" [(ngModel)]=\"empresa.passwordPopCFD\"></az-password>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-lg-9\">\n                                          <azteca-form-field [label]=\"'Servidor POP3:'\">\n                                              <az-textbox formControlName=\"servidorPopCFD\" [(ngModel)]=\"empresa.servidorPopCFD\"></az-textbox>\n                                          </azteca-form-field>\n                                      </div>\n                                      <div class=\"col-12 col-lg-3\">\n                                          <azteca-form-field [label]=\"'Puerto:'\">\n                                              <az-input-number formControlName=\"puertoPopCFD\" [(ngModel)]=\"empresa.puertoPopCFD\"></az-input-number>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n                              </az-panel>\n\n                       \n                          </tab>\n\n                          <tab heading=\"Configuracion\" (select)=\"selectSucursalesTab($event)\">\n\n                              <az-panel [header]=\"'Formatos'\">\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-lg-5\">\n                                          <azteca-form-field [label]=\"'Formato de Presupuesto:'\">\n                                              <az-combobox formControlName=\"idFormatoPresupuesto\" [(ngModel)]=\"empresa.idFormatoPresupuesto\" [items]=\"formatosImpresion\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-lg-5\">\n                                          <azteca-form-field [label]=\"'Formato de Orden:'\">\n                                              <az-combobox formControlName=\"idFormatoOrden\" [(ngModel)]=\"empresa.idFormatoOrden\" [items]=\"formatosImpresion\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n                              </az-panel>\n\n                              <az-panel [header]=\"'Documentos habilitados'\">\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-lg-5\">\n                                          <azteca-form-field [label]=\"'Generar ordenes con requisiciones en estatus:'\">\n                                              <az-combobox formControlName=\"idWorkflowStepRequisicionOrdenar\" [(ngModel)]=\"empresa.idWorkflowStepRequisicionOrdenar\" [items]=\"requisicionesSteps\" [valueMember]=\"'idWorkflowStep'\" [displayMember]=\"'statusText'\"></az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n\n                                      <div class=\"col-12 col-lg-5\">\n                                          <azteca-form-field [label]=\"'Recibir ordenes en estatus:'\">\n                                              <az-combobox formControlName=\"idWorkflowStepOrdenRecibir\" [(ngModel)]=\"empresa.idWorkflowStepOrdenRecibir\" [items]=\"ordenSteps\" [valueMember]=\"'idWorkflowStep'\" [displayMember]=\"'statusText'\"></az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n                              </az-panel>\n                          </tab>\n\n                          <!--------------------------- SUCURSALES ------------------------------------------------->\n                          <tab heading=\"Sucursales\" [disabled]=\"empresa.identity == 0\" (select)=\"selectSucursalesTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n\n                                      <compras-sucursales-manager [name]=\"'sucursales'\"\n                                                                  [sucursales]=\"sucursales\"\n                                                                  [idEmpresa]=\"empresa.identity\"\n                                                                  (refreshListParent)=\"loadSucursales()\">\n                                      </compras-sucursales-manager>\n\n                                  </div>\n                              </div>\n                          </tab>\n\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return EmpresasEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: empresa_service_1.EmpresaService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, empresa_service_1.EmpresaService, sucursal_service_1.SucursalService, general_1.FormatoTipoService, ejercicio_tipo_service_1.EjercicioTipoService,
            document_type_service_1.DocumentTypeService])
    ], EmpresasEditor);
    return EmpresasEditor;
}(editors_1.CatalogEditor));
exports.EmpresasEditor = EmpresasEditor;
