import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { GastoTipoService } from '../services/gasto-tipo.service';
import { GastoTipoInfo } from '../models/gasto-tipo';
import { OperacionTipoItem } from '../models/operacion-tipo';
import { OperacionTipoService } from '../services/operacion-tipo.service';
export declare class GastosTiposEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private gastoTipoService;
    private operacionTipoService;
    gastoTipo: GastoTipoInfo;
    operacionesTipo: OperacionTipoItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, gastoTipoService: GastoTipoService, operacionTipoService: OperacionTipoService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    loadOperacionesTipo(): void;
    onSavingItem(args: EditorEventArgs): void;
}
