"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var gasto_tipo_service_1 = require("../services/gasto-tipo.service");
var gasto_tipo_1 = require("../models/gasto-tipo");
var operacion_tipo_service_1 = require("../services/operacion-tipo.service");
var GastosTiposEditor = /** @class */ (function (_super) {
    __extends(GastosTiposEditor, _super);
    //
    function GastosTiposEditor(router, route, formBuilder, changeDetector, context, location, gastoTipoService, operacionTipoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.gastoTipoService = gastoTipoService;
        _this.operacionTipoService = operacionTipoService;
        _this.gastoTipo = new gasto_tipo_1.GastoTipoInfo();
        _this.operacionesTipo = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idOperacionTipo': [0, controls_1.AztecaValidators.selected],
            'idCuenta': [0],
        });
        return _this;
    }
    GastosTiposEditor_1 = GastosTiposEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    GastosTiposEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.loadOperacionesTipo();
    };
    GastosTiposEditor.prototype.onCreatingItem = function () {
    };
    GastosTiposEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.gastoTipoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.gastoTipo = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GastosTiposEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.gastoTipoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.gastoTipo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GastosTiposEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.gastoTipoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.gastoTipo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GastosTiposEditor.prototype.loadOperacionesTipo = function () {
        var _this = this;
        this.operacionTipoService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (operaciones) {
            _this.operacionesTipo = operaciones;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GastosTiposEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.gastoTipoService.update(this.gastoTipo)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.gastoTipo.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.gastoTipo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var GastosTiposEditor_1;
    GastosTiposEditor = GastosTiposEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-gasto-tipo-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'GastoTipo'\"\n                                 [info]=\"gastoTipo\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"gastoTipo.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"gastoTipo.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n\n                          -<tab heading=\"Generales\">\n\n\n          <div class=\"row\">\n              <div class=\"col-12 col-md-10\">\n\n                  <azteca-form-field [label]=\"'Cuenta:'\">\n                      <accounting-cuenta-selector formControlName=\"idCuenta\" [(ngModel)]=\"gastoTipo.idCuenta\"></accounting-cuenta-selector>\n                  </azteca-form-field>\n\n              </div>\n          </div>\n\n          <div class=\"col-12 col-md-4\">\n              <azteca-form-field [label]=\"'Tipo de Operaci\u00F3n:'\">\n                  <az-combobox formControlName=\"idOperacionTipo\"\n                               [(ngModel)]=\"gastoTipo.idOperacionTipo\"\n                               [items]=\"operacionesTipo\"\n                               [displayMember]=\"'nombre'\"\n                               [valueMember]=\"'id'\">\n                  </az-combobox>\n              </azteca-form-field>\n          </div>\n\n\n\n      </tab>\n\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return GastosTiposEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: gasto_tipo_service_1.GastoTipoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, gasto_tipo_service_1.GastoTipoService,
            operacion_tipo_service_1.OperacionTipoService])
    ], GastosTiposEditor);
    return GastosTiposEditor;
}(editors_1.CatalogEditor));
exports.GastosTiposEditor = GastosTiposEditor;
