"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var editors_1 = require("framework3/editors");
var core_1 = require("framework3/core");
var services_1 = require("../services");
var core_2 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var proveedor_tipo_1 = require("../models/proveedor-tipo");
var common_1 = require("@angular/common");
var ProveedorTipoEditor = /** @class */ (function (_super) {
    __extends(ProveedorTipoEditor, _super);
    function ProveedorTipoEditor(router, route, formBuilder, changeDetector, context, location, proveedorTipoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.proveedorTipoService = proveedorTipoService;
        _this.proveedorTipo = new proveedor_tipo_1.ProveedorTipoInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idCuenta': ['']
        });
        return _this;
    }
    ProveedorTipoEditor_1 = ProveedorTipoEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ProveedorTipoEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    ProveedorTipoEditor.prototype.onCreatingItem = function () {
    };
    ProveedorTipoEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.proveedorTipoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.proveedorTipo = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ProveedorTipoEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.proveedorTipoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.proveedorTipo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ProveedorTipoEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.proveedorTipoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.proveedorTipo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ProveedorTipoEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.proveedorTipoService.update(this.proveedorTipo)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.proveedorTipo.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.proveedorTipo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var ProveedorTipoEditor_1;
    ProveedorTipoEditor = ProveedorTipoEditor_1 = __decorate([
        core_2.Component({
            selector: 'proveedores-tipos-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Proveedores'\"\n                                 [info]=\"proveedorTipos\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"proveedorTipo.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"proveedorTipo.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <azteca-form-field [label]=\"'Cuenta:'\">\n                          <accounting-cuenta-selector formControlName=\"idCuenta\" [(ngModel)]=\"proveedorTipo.idCuenta\"></accounting-cuenta-selector>\n                      </azteca-form-field>\n                  </div> \n              </div>\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_1.BaseComponent, useExisting: core_2.forwardRef(function () { return ProveedorTipoEditor_1; })
                },
                {
                    provide: core_1.CatalogService, useExisting: services_1.ProveedorTipoService
                }
            ],
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_2.ChangeDetectorRef,
            core_1.Context, common_1.Location, services_1.ProveedorTipoService])
    ], ProveedorTipoEditor);
    return ProveedorTipoEditor;
}(editors_1.CatalogEditor));
exports.ProveedorTipoEditor = ProveedorTipoEditor;
