import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, PolicyInfo } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { MenuItem } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { ProveedorService } from '../services/proveedor.service';
import { ProveedorInfo } from '../models/proveedor';
import { ArticuloService } from '../services/articulo.service';
import { ProveedorTipoService } from '../services';
import { ProveedorTipoInfo } from '../models/proveedor-tipo';
import { ProveedorProductoComponent } from '../components/proveedor-producto.component';
export declare class ProveedoresEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private proveedorService;
    private articuloSvc;
    private proveedorTipoSvc;
    proveedor: ProveedorInfo;
    tiposProveedor: ProveedorTipoInfo[];
    proceso: number;
    idProveedor: number;
    allowComprobante: boolean;
    allowEditDiasCredito: boolean;
    selectSiNo: {
        id: boolean;
        nombre: string;
    }[];
    proveedorArticulo: ProveedorProductoComponent;
    proveedorServicio: ProveedorProductoComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, proveedorService: ProveedorService, articuloSvc: ArticuloService, proveedorTipoSvc: ProveedorTipoService);
    ngOnInit(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    applyPolicy(policy: PolicyInfo): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onAgregarArticulo(): void;
    onAgregarServicio(): void;
    refreshControls(): void;
    loadProveedoresTipos(): void;
    onMenuItemClick(item: MenuItem): void;
}
