"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var proveedor_service_1 = require("../services/proveedor.service");
var ProveedoresManager = /** @class */ (function (_super) {
    __extends(ProveedoresManager, _super);
    //    
    function ProveedoresManager(context, router, route, proveedorService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.proveedorService = proveedorService;
        _this.proveedores = [];
        return _this;
    }
    ProveedoresManager_1 = ProveedoresManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ProveedoresManager.prototype.enviarRegistro = function () {
        var _this = this;
        this.proveedorService.enviarRegistro(this.manager.currentItem.id)
            .then(function (_) {
            _this.showAlert('Se ha enviado un correo electrónico con la invitación de registro', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ProveedoresManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
        this.refreshList();
        this.applyPolicies();
    };
    ProveedoresManager.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.proveedorService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.proveedores = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ProveedoresManager.prototype.onAddingItem = function () {
        this.router.navigate([0], { relativeTo: this.route });
    };
    ProveedoresManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    ProveedoresManager.prototype.onEditingItem = function (item) {
        this.router.navigate([item.id], { relativeTo: this.route });
    };
    ProveedoresManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.proveedorService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ProveedoresManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    ProveedoresManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.proveedorService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ProveedoresManager.prototype.onItemChange = function (item) {
        this.proveedor = item;
    };
    ProveedoresManager.prototype.onAgregarArticulo = function () {
        this.router.navigate(['purchasing/proveedor-articulo', this.process.id, 0, this.proveedor.id, 0, 0, 0, 1, 1]);
    };
    ProveedoresManager.prototype.onAgregarServicio = function () {
        this.router.navigate(['purchasing/proveedor-servicio', this.process.id, 0, this.proveedor.id, 0, 0, 0, 1, 1]);
    };
    ProveedoresManager.prototype.onAgregarContacto = function () {
        this.router.navigate(['purchasing/proveedores/contacts', this.process.id, this.proveedor.id]);
    };
    ProveedoresManager.prototype.onMenuItemClick = function (option) {
        if (option.name == 'ARTICULOS') {
            this.onAgregarArticulo();
        }
        else if (option.name == 'SERVICIOS') {
            this.onAgregarServicio();
        }
        else if (option.name == 'CONTACTOS') {
            this.onAgregarContacto();
        }
        else if (option.name == 'REGISTRO') {
            this.enviarRegistro();
        }
    };
    var ProveedoresManager_1;
    ProveedoresManager = ProveedoresManager_1 = __decorate([
        core_1.Component({
            selector: 'compras-proveedores-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Compras - Proveedores</div>\n          <div class=\"card-body\">\n\n      \t\t<azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n      \t\t\t\t\t\t\t\t(addingItem)=\"onAddingItem()\"\n      \t\t\t\t\t\t\t\t(viewingItem)=\"onViewingItem($event)\"\n      \t\t\t\t\t\t\t\t(editingItem)=\"onEditingItem($event)\"\n      \t\t\t\t\t\t\t\t(deletingItem)=\"onDeletingItem($event)\"\n      \t\t\t\t\t\t\t\t(cloningItem)=\"onCloningItem($event)\"\n      \t\t\t\t\t\t\t\t(changingItemState)=\"onChangingItemState($event)\"\n      \t\t\t\t\t\t\t\t(configureCatalog)=\"onConfigureCatalog($event)\"\n                                      (menuItemClick)=\"onMenuItemClick($event)\"\n                                      (currentItemChanged)=\"onItemChange($event)\"\n      \t\t\t\t\t\t\t\t[enabled]=\"enabled\"\n      \t\t\t\t\t\t\t\t[allowNew]=\"allowNew\"\n      \t\t\t\t\t\t\t\t[allowView]=\"allowView\"\n      \t\t\t\t\t\t\t\t[allowEdit]=\"allowEdit\"\n      \t\t\t\t\t\t\t\t[allowDelete]=\"allowDelete\"\n      \t\t\t\t\t\t\t\t[allowClone]=\"allowClone\"\n      \t\t\t\t\t\t\t\t[allowChangeState]=\"allowChangeState\"\n      \t\t\t\t\t\t\t\t[allowAudit]=\"allowAudit\"\n      \t\t\t\t\t\t\t\t[catalogList]=\"proveedores\"\n      \t\t\t\t\t\t\t\t[totalRows]=\"totalRows\"\n      \t\t\t\t\t\t\t\t[pageIndex]=\"pageIndex\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'CONTACTOS'\" [icon]=\"'fa fa-users'\" [text]=\"'Contactos'\" [smallText]=\"'editar contactos'\" [enabled]=\"true\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'ARTICULOS'\" [icon]=\"'fa fa-cubes'\" [text]=\"'Art\u00EDculos'\" [smallText]=\"'asignar art\u00EDculos'\" [enabled]=\"true\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'SERVICIOS'\" [icon]=\"'fa fa-wrench'\" [text]=\"'Servicios'\" [smallText]=\"'asignar servicios'\" [enabled]=\"true\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'REGISTRO'\" [icon]=\"'glyphicon glyphicon-send'\" [text]=\"'Enviar invitaci\u00F3n'\" [smallText]=\"'enviar correo de registro al portal'\" [enabled]=\"true\"></azteca-menu-item>\n\n              <!------------------- Columnas del listado ----------------------------->\n    \n      \t\t\t<azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"100\"></azteca-grid-column>\n      \t\t\t<azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'30*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'RFC'\" [binding]=\"'rfc'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Correo'\" [binding]=\"'correo'\" [width]=\"'20*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Tel\u00E9fono'\" [binding]=\"'telefono'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Domicilio'\" [binding]=\"'domicilio'\" [width]=\"'20*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Poblacion'\" [binding]=\"'poblacion'\" [width]=\"'20*'\"></azteca-grid-column>\n\t\t\t\n      \t\t</azteca-catalog-manager>\n\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ProveedoresManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: proveedor_service_1.ProveedorService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, proveedor_service_1.ProveedorService])
    ], ProveedoresManager);
    return ProveedoresManager;
}(editors_1.CatalogManager));
exports.ProveedoresManager = ProveedoresManager;
