import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, UsuarioItem, CatalogItem } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { ToolbarButton } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { SearchRequest, CatalogListComponent } from 'framework3/search';
import { ZonaCompraService } from '../services/zona-compra.service';
import { ZonaCompraInfo } from '../models/zona-compra';
import { ProveedorService } from '../services/proveedor.service';
import { UsuariosListComponent } from 'framework3/security/components/dialogs/usuarios-list.component';
import { ModalDirective } from 'ngx-bootstrap';
export declare class ZonasCompraEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private zonaCompraService;
    private proveedorSvc;
    zonaCompra: ZonaCompraInfo;
    usuarios: UsuarioItem[];
    currentItem: CatalogItem;
    requestProveedor: SearchRequest;
    proveedores: any[];
    pageSizeProveedor: number;
    serverSideProveedor: boolean;
    totalRowsProveedor: number;
    pageIndexProveedor: number;
    agregarUsuarios: boolean;
    restricciones: {
        id: number;
        nombre: string;
    }[];
    catalogList: CatalogListComponent;
    usuariosDialog: UsuariosListComponent;
    dialog: ModalDirective;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, zonaCompraService: ZonaCompraService, proveedorSvc: ProveedorService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onCurrentItemChanged(item: CatalogItem): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    searchArticuloRequested(request: SearchRequest): void;
    refreshListProveedores(): void;
    refreshListAccess(): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onSelectedUsersChanged(newUsers: UsuarioItem[]): void;
    onRemoveUser(): void;
    show(): void;
    loadRestriccionesCostos(): void;
}
