"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var search_1 = require("framework3/search");
//Features
var zona_compra_service_1 = require("../services/zona-compra.service");
var zona_compra_1 = require("../models/zona-compra");
var proveedor_service_1 = require("../services/proveedor.service");
var usuarios_list_component_1 = require("framework3/security/components/dialogs/usuarios-list.component");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
var ZonasCompraEditor = /** @class */ (function (_super) {
    __extends(ZonasCompraEditor, _super);
    function ZonasCompraEditor(router, route, formBuilder, changeDetector, context, location, zonaCompraService, proveedorSvc) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.zonaCompraService = zonaCompraService;
        _this.proveedorSvc = proveedorSvc;
        _this.zonaCompra = new zona_compra_1.ZonaCompraInfo();
        _this.proveedores = [];
        _this.pageSizeProveedor = 20;
        _this.serverSideProveedor = false;
        _this.totalRowsProveedor = 0;
        _this.pageIndexProveedor = 0;
        _this.agregarUsuarios = false;
        _this.restricciones = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idCuenta': [''],
            'restriccionCosto': [0]
        });
        return _this;
    }
    ZonasCompraEditor_1 = ZonasCompraEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ZonasCompraEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    ZonasCompraEditor.prototype.onCreatingItem = function () {
        this.agregarUsuarios = false;
        this.loadRestriccionesCostos();
    };
    ZonasCompraEditor.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    ZonasCompraEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.loadRestriccionesCostos();
        this.zonaCompraService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.zonaCompra = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ZonasCompraEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.zonaCompraService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.zonaCompra = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ZonasCompraEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.agregarUsuarios = true;
        this.context.app.showSpinner();
        this.loadRestriccionesCostos();
        this.zonaCompraService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.zonaCompra = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ZonasCompraEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.zonaCompraService.update(this.zonaCompra)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.zonaCompra.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.zonaCompra = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ZonasCompraEditor.prototype.searchArticuloRequested = function (request) {
        this.requestProveedor = request;
        this.refreshListProveedores();
    };
    ZonasCompraEditor.prototype.refreshListProveedores = function () {
        var _this = this;
        if (this.zonaCompra.identity > 0) {
            this.context.app.showSpinner();
            if (this.requestProveedor == null) {
                this.requestProveedor = new search_1.SearchRequest();
                this.requestProveedor.pageIndex = this.pageIndexProveedor;
                this.requestProveedor.pageSize = this.pageSizeProveedor;
                this.requestProveedor.paged = this.serverSideProveedor;
            }
            this.proveedorSvc.searchProveedorByZona(this.zonaCompra.identity, this.context.app.defaultSite.identity, this.requestProveedor)
                .then(function (response) {
                _this.proveedores = response.rows;
                _this.totalRowsProveedor = response.totalRows;
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    ZonasCompraEditor.prototype.refreshListAccess = function () {
        var _this = this;
        if (this.zonaCompra.identity > 0) {
            this.context.app.showSpinner();
            this.zonaCompraService.loadAccessUsersList(this.zonaCompra.identity)
                .then(function (usuarios) {
                _this.usuarios = usuarios;
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    ZonasCompraEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.usuariosDialog.show();
        }
        else if (button.name == 'ADDPROVIDER') {
            this.show();
        }
    };
    ZonasCompraEditor.prototype.onSelectedUsersChanged = function (newUsers) {
        var _this = this;
        this.context.app.showSpinner();
        this.zonaCompraService.addUser(this.zonaCompra.identity, newUsers)
            .then(function (_) {
            _this.context.app.hideSpinner();
            //this.alerts.showAlert('Los usuarios han sido agregados con éxito.', 'success');
            _this.refreshListAccess();
        })
            .catch(function (error) { return _this.handleError(error); });
        console.log(JSON.stringify(this.usuarios));
    };
    ZonasCompraEditor.prototype.onRemoveUser = function () {
        var _this = this;
        this.context.app.showSpinner();
        console.log(this.currentItem.id);
        this.zonaCompraService.removeUser(this.currentItem.id)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.usuarios = _this.usuarios.filter(function (item) { return item.id != _this.currentItem.id; });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ZonasCompraEditor.prototype.show = function () {
        this.dialog.config.backdrop = "static";
        this.dialog.config.ignoreBackdropClick = true;
        this.dialog.config.animated = true;
        this.dialog.show();
    };
    ZonasCompraEditor.prototype.loadRestriccionesCostos = function () {
        var _this = this;
        this.zonaCompraService.loadRestriccionesCostos()
            .then(function (info) {
            _this.restricciones = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var ZonasCompraEditor_1;
    __decorate([
        core_1.ViewChild(search_1.CatalogListComponent),
        __metadata("design:type", search_1.CatalogListComponent)
    ], ZonasCompraEditor.prototype, "catalogList", void 0);
    __decorate([
        core_1.ViewChild(usuarios_list_component_1.UsuariosListComponent),
        __metadata("design:type", usuarios_list_component_1.UsuariosListComponent)
    ], ZonasCompraEditor.prototype, "usuariosDialog", void 0);
    __decorate([
        core_1.ViewChild('dialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ZonasCompraEditor.prototype, "dialog", void 0);
    ZonasCompraEditor = ZonasCompraEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-zona-compra-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'ZonaCompra'\"\n                                 [info]=\"zonaCompra\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"zonaCompra.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"zonaCompra.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Gneral\">\n\n                              <div class=\"row\">\n\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"idCuenta\" [(ngModel)]=\"zonaCompra.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'Restriccion de Costos:'\">\n                                          <az-combobox formControlName=\"restriccionCosto\"\n                                                       [(ngModel)]=\"zonaCompra.idRestriccionCosto\"\n                                                       [items]=\"restricciones\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                          <tab heading=\"Proveedores\" (select)=\"refreshListProveedores()\">\n                              <!--<button class=\"btn btn-primary\" data-toggle=\"modal\" data-target=\"#myModal\" appModal>Launch Modal</button>-->\n                              <!--az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADDPROVIDER'\" [type]=\"'primary'\" [text]=\"'Agregar Articulos-Servicios'\" [icon]=\"'glyphicon glyphicon-plus'\" [enabled]=\"agregarUsuarios\" data-backdrop=\"false\" ata-dismiss=\"modal\"></az-toolbar-button>\n                              </!--az-toolbar-->\n                              <azteca-catalog-list [catalogList]=\"proveedores\"\n                                                   [showRowButton]=\"false\"\n                                                   (currentItemChanged)=\"onCurrentItemArticuloChanged($event)\"\n                                                   (searchRequested)=\"searchProveedorRequested($event)\"\n                                                   (contextMenuClick)=\"optionProveedorClick($event)\"\n                                                   [enabled]=\"true\"\n                                                   [pageSize]=\"pageSizeProveedor\"\n                                                   [serverSide]=\"serverSideProveedor\"\n                                                   [totalRows]=\"totalRowsProveedor\"\n                                                   [pageIndex]=\"pageIndexProveedor\">\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'MODIFY'\" [icon]=\"'glyphicon glyphicon-edit'\" [text]=\"'Modificar'\" [smallText]=\"'modificar registro'\"></azteca-menu-item>\n\n\n                                  <azteca-grid-column [header]=\"'C&oacute;digo'\" [binding]=\"'codigo'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'50*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n\n                              </azteca-catalog-list>\n\n\n\n\n                              <!-- MODAL -->\n\n                              <!--<div class=\"modal\" id=\"myModal\">\n                                  <div class=\"modal-dialog\">\n                                      <div class=\"modal-content\">\n                                          <div class=\"modal-header\">\n                                              <h5 class=\"modal-title\">Modal Title</h5>\n                                              <button class=\"close\" data-dismiss=\"modal\" appModal>&times;</button>\n                                          </div>\n                                          <div class=\"modal-body\">\n                                              Lorem ipsum dolor sit amet, consectetur adipisicing elit. Temporibus unde veniam harum magnam molestias dignissimos omnis\n                                              architecto, quod, obcaecati dolorum debitis dolore porro qui, iusto quo accusantium voluptates pariatur illo.\n                                          </div>\n                                          <div class=\"modal-footer\">\n                                              <button class=\"btn btn-secondary\" data-dismiss=\"modal\" appModal>Close</button>\n                                          </div>\n                                      </div>\n                                  </div>\n                              </div>-->\n\n                          </tab>\n                          <tab heading=\"Accesos\" (select)=\"refreshListAccess()\">\n                              <div class=\"col-12 col-md-10\">\n                                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                      <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar Usuarios'\" [icon]=\"'glyphicon glyphicon-plus'\" [enabled]=\"agregarUsuarios\"></az-toolbar-button>\n                                  </az-toolbar>\n\n                                  <!-- Lista de usuarios-->\n                                  <azteca-catalog-list [catalogList]=\"usuarios\"\n                                                       [showRowButton]=\"true\"\n                                                       [rowButtonIcon]=\"'glyphicon glyphicon-trash'\"\n                                                       (rowButtonClick)=\"onRemoveUser()\"\n                                                       (currentItemChanged)=\"onCurrentItemChanged($event)\"\n                                                       [enabled]=\"enabled\"\n                                                       [pageSize]=\"15\"\n                                                       [serverSide]=\"false\">\n\n                                      <azteca-grid-column [header]=\"'Usuario'\" [binding]=\"'codigo'\" [width]=\"'20*'\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'40*'\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Dominio'\" [binding]=\"'dominio'\" [width]=\"'20*'\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Correo'\" [binding]=\"'correo'\" [width]=\"'20*'\"></azteca-grid-column>\n\n                                  </azteca-catalog-list>\n                              </div>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n              <security-usuarios-list (selectedItemsChanged)=\"onSelectedUsersChanged($event)\"\n                                      [excludedItems]=\"usuarios\"\n                                      [multiSelect]=\"true\">\n              </security-usuarios-list>\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ZonasCompraEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: zona_compra_service_1.ZonaCompraService
                }
            ],
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, zona_compra_service_1.ZonaCompraService, proveedor_service_1.ProveedorService])
    ], ZonasCompraEditor);
    return ZonasCompraEditor;
}(editors_1.CatalogEditor));
exports.ZonasCompraEditor = ZonasCompraEditor;
