import { EventEmitter, Renderer } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { PolicyInfo } from 'framework3/core';
import { BaseControl } from 'framework3/controls';
import * as wjcCore from 'wijmo/wijmo';
import { CellRangeEventArgs, DataMap } from 'wijmo/wijmo.grid';
import { ImpuestoAsignacionInfo } from '../../accounting/models/impuesto-asignacion';
import { ImpuestosAsignacionEditor } from '../../accounting/components/impuesto-asignacion.editor';
export declare class ArticuloImpuestoComponent extends BaseControl implements ControlValueAccessor {
    private renderer;
    _Impuestos: Array<ImpuestoAsignacionInfo>;
    impuestos: any[];
    impuestosChange: EventEmitter<Array<ImpuestoAsignacionInfo>>;
    dataArticuloImpuesto: wjcCore.CollectionView;
    tiposCalculo: {
        "tipo": string;
        "nombre": string;
    }[];
    tipoCalculoMap: DataMap;
    readOnly: boolean;
    servicioImpuestosDialog: ImpuestosAsignacionEditor;
    constructor(renderer: Renderer);
    ngAfterViewInit(): void;
    updateImpuestos(): void;
    notifyChange(): void;
    onAgregar(): void;
    onCellUpdated(args: CellRangeEventArgs): void;
    onRowDeleteImpuesto(impuesto: ImpuestoAsignacionInfo): void;
    onAgregarImpuesto(args: ImpuestoAsignacionInfo): void;
    applyPolicy(policy: PolicyInfo): void;
    writeValue(value: any): void;
    propagateChange: (_: any) => void;
    registerOnChange(fn: any): void;
    registerOnTouched(): void;
}
