"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
// Wijmo
var wjcCore = require("wijmo/wijmo");
var wijmo_grid_1 = require("wijmo/wijmo.grid");
var impuesto_asignacion_1 = require("../../accounting/models/impuesto-asignacion");
var impuesto_asignacion_editor_1 = require("../../accounting/components/impuesto-asignacion.editor");
var ArticuloImpuestoComponent = /** @class */ (function (_super) {
    __extends(ArticuloImpuestoComponent, _super);
    function ArticuloImpuestoComponent(renderer) {
        var _this = _super.call(this) || this;
        _this.renderer = renderer;
        _this._Impuestos = new Array();
        _this.impuestos = [];
        _this.impuestosChange = new core_1.EventEmitter();
        _this.tiposCalculo = [{ "tipo": "B", "nombre": "Base" }, { "tipo": "C", "nombre": "Cascada" }];
        _this.readOnly = false;
        _this.propagateChange = function (_) { };
        return _this;
    }
    ArticuloImpuestoComponent_1 = ArticuloImpuestoComponent;
    ArticuloImpuestoComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) {
            _this.tipoCalculoMap = new wijmo_grid_1.DataMap(_this.tiposCalculo, 'tipo', 'nombre');
            _this.dataArticuloImpuesto = new wjcCore.CollectionView(_this._Impuestos);
        });
    };
    // Handlers
    ArticuloImpuestoComponent.prototype.updateImpuestos = function () {
        var _this = this;
        this._Impuestos.length = 0;
        this.impuestos.forEach(function (item) {
            var impuesto = new impuesto_asignacion_1.ImpuestoAsignacionInfo();
            impuesto.idImpuesto = item.idImpuesto;
            impuesto.impuesto = item.impuesto;
            impuesto.base = item.base;
            impuesto.tasaOCuota = item.tasaOCuota;
            impuesto.tipoCalculo = item.tipoCalculo;
            impuesto.ordenCalculo = item.ordenCalculo;
            impuesto.tipoAplicacion = item.tipoAplicacion;
            impuesto.state = core_2.ChangeState.UNCHANGED;
            _this._Impuestos.push(impuesto);
        });
        if (this.dataArticuloImpuesto != undefined)
            this.dataArticuloImpuesto.refresh();
    };
    ArticuloImpuestoComponent.prototype.notifyChange = function () {
        var impuestos = new Array();
        this.impuestos.forEach(function (item) {
            if (item.state == core_2.ChangeState.UNCHANGED) {
                var impuesto = new impuesto_asignacion_1.ImpuestoAsignacionInfo();
                impuesto.idImpuesto = item.idImpuesto;
                impuesto.impuesto = item.impuesto;
                impuesto.base = item.base;
                impuesto.tasaOCuota = item.tasaOCuota;
                impuesto.tipoCalculo = item.tipoCalculo;
                impuesto.ordenCalculo = item.ordenCalculo;
                impuesto.tipoAplicacion = item.tipoAplicacion;
                impuesto.state = core_2.ChangeState.UNCHANGED;
                impuestos.push(impuesto);
            }
        });
        this.dataArticuloImpuesto.itemsAdded.forEach(function (item) {
            var impuesto = new impuesto_asignacion_1.ImpuestoAsignacionInfo();
            impuesto.idImpuesto = item.idImpuesto;
            impuesto.impuesto = item.impuesto;
            impuesto.base = item.base;
            impuesto.tasaOCuota = item.tasaOCuota;
            impuesto.tipoCalculo = item.tipoCalculo;
            impuesto.ordenCalculo = item.ordenCalculo;
            impuesto.tipoAplicacion = item.tipoAplicacion;
            impuesto.state = core_2.ChangeState.ADDED;
            impuestos.push(impuesto);
        });
        this.dataArticuloImpuesto.itemsEdited.forEach(function (item) {
            var impuesto = new impuesto_asignacion_1.ImpuestoAsignacionInfo();
            impuesto.idImpuesto = item.idImpuesto;
            impuesto.impuesto = item.impuesto;
            impuesto.base = item.base;
            impuesto.tasaOCuota = item.tasaOCuota;
            impuesto.tipoCalculo = item.tipoCalculo;
            impuesto.ordenCalculo = item.ordenCalculo;
            impuesto.tipoAplicacion = item.tipoAplicacion;
            impuesto.state = core_2.ChangeState.MODIFIED;
            impuestos.push(impuesto);
        });
        this.dataArticuloImpuesto.itemsRemoved.forEach(function (item) {
            var impuesto = new impuesto_asignacion_1.ImpuestoAsignacionInfo();
            impuesto.idImpuesto = item.idImpuesto;
            impuesto.impuesto = item.impuesto;
            impuesto.base = item.base;
            impuesto.tasaOCuota = item.tasaOCuota;
            impuesto.tipoCalculo = item.tipoCalculo;
            impuesto.ordenCalculo = item.ordenCalculo;
            impuesto.tipoAplicacion = item.tipoAplicacion;
            impuesto.state = core_2.ChangeState.DELETED;
            impuestos.push(impuesto);
        });
        this.impuestosChange.emit(impuestos);
        this.propagateChange(impuestos);
    };
    // Control Events
    ArticuloImpuestoComponent.prototype.onAgregar = function () {
        this.servicioImpuestosDialog.show();
    };
    ArticuloImpuestoComponent.prototype.onCellUpdated = function (args) {
        switch (args.col) {
            case 4:
            case 5:
                if (this.dataArticuloImpuesto.currentItem != null) {
                    this.dataArticuloImpuesto.itemsEdited.push(this.dataArticuloImpuesto.currentItem);
                }
                this.notifyChange();
                break;
        }
    };
    ArticuloImpuestoComponent.prototype.onRowDeleteImpuesto = function (impuesto) {
        this.dataArticuloImpuesto.remove(impuesto);
        this.dataArticuloImpuesto.itemsRemoved.push(impuesto);
        this.notifyChange();
    };
    ArticuloImpuestoComponent.prototype.onAgregarImpuesto = function (args) {
        var impuestoExists = false;
        this._Impuestos.forEach(function (servicioImp) {
            if (servicioImp.idImpuesto == args.idImpuesto && servicioImp.state != 'DELETED') {
                impuestoExists = true;
            }
        });
        if (!impuestoExists) {
            this._Impuestos.push(args);
            this.dataArticuloImpuesto.itemsAdded.push(args);
            this.dataArticuloImpuesto.refresh();
            this.notifyChange();
        }
    };
    // Base control implementations
    ArticuloImpuestoComponent.prototype.applyPolicy = function (policy) {
    };
    //Implementación de control value accesor
    ArticuloImpuestoComponent.prototype.writeValue = function (value) {
        this.impuestos = value ? value : [];
        this.updateImpuestos();
    };
    ArticuloImpuestoComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    ArticuloImpuestoComponent.prototype.registerOnTouched = function () { };
    var ArticuloImpuestoComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], ArticuloImpuestoComponent.prototype, "impuestos", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ArticuloImpuestoComponent.prototype, "impuestosChange", void 0);
    __decorate([
        core_1.ViewChild(impuesto_asignacion_editor_1.ImpuestosAsignacionEditor),
        __metadata("design:type", impuesto_asignacion_editor_1.ImpuestosAsignacionEditor)
    ], ArticuloImpuestoComponent.prototype, "servicioImpuestosDialog", void 0);
    ArticuloImpuestoComponent = ArticuloImpuestoComponent_1 = __decorate([
        core_1.Component({
            selector: 'purchasing-articulo-impuesto',
            template: "\n      <!-- Administrador de impuestos -->\n      <div class=\"row\">\n          <div class=\"col-12\">\n              <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAgregar()\" [disabled]=\"readOnly\">\n                  <span aria-hidden=\"true\" class=\"glyphicon glyphicon-plus\"></span>\n                  Agregar\n              </button>\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <wj-flex-grid style=\"height:500px\"\n                                    [itemsSource]=\"dataArticuloImpuesto\"\n                                    [selectionMode]=\"'Row'\"\n                                    (cellEditEnded)=\"onCellUpdated($event)\">\n                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                          <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                              <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\" *ngIf=\"!readOnly\">\n                                  <button type=\"button\" class=\"btn btn-default\" (click)=\"onRowDeleteImpuesto(cell.item)\">\n                                      <span class=\"glyphicon glyphicon-remove\"></span>\n                                  </button>\n                              </ng-template>\n                          </wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'impuesto.code'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Tasa \u00F3 cuota'\" [binding]=\"'tasaOCuota'\" [width]=\"'30*'\" [isReadOnly]=\"true\" format=\"n2\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Orden C&aacute;lculo'\" [binding]=\"'ordenCalculo'\" [width]=\"'25*'\" [format]=\"'n0'\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Tipo C&aacute;lculo'\" [binding]=\"'tipoCalculo'\" [width]=\"'25*'\" [dataMap]=\"tipoCalculoMap\"></wj-flex-grid-column>\n                      </wj-flex-grid>\n                  </div>\n              </div>\n          </div>\n      </div>\n      <!-- Asignacion de impuestos -->\n      <accounting-impuesto-asignacion (dataUpdater)=\"onAgregarImpuesto($event)\"></accounting-impuesto-asignacion>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ArticuloImpuestoComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR, useExisting: core_1.forwardRef(function () { return ArticuloImpuestoComponent_1; }), multi: true
                }
            ]
        }),
        __metadata("design:paramtypes", [core_1.Renderer])
    ], ArticuloImpuestoComponent);
    return ArticuloImpuestoComponent;
}(controls_1.BaseControl));
exports.ArticuloImpuestoComponent = ArticuloImpuestoComponent;
