"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("framework3/core");
var router_1 = require("@angular/router");
var search_1 = require("framework3/search");
var controls_1 = require("framework3/controls");
var categorias_presupuestales_service_1 = require("../services/categorias-presupuestales.service");
var articulo_list_component_1 = require("../dialogs/articulo-list.component");
var editors_1 = require("framework3/editors");
var CategoriasPresupuestalesArticulosComponent = /** @class */ (function (_super) {
    __extends(CategoriasPresupuestalesArticulosComponent, _super);
    function CategoriasPresupuestalesArticulosComponent(context, router, route, categoriaPresupuestalsvc) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.categoriaPresupuestalsvc = categoriaPresupuestalsvc;
        _this.articulos = [];
        _this.articulosCollection = new editors_1.TrackableCollection();
        _this.articulosEliminados = [];
        _this.enableAdd = true;
        _this.pageSizeArticulo = 20;
        _this.totalRowsArticulo = 0;
        _this.pageIndexArticulo = 0;
        _this.serverSideArticulo = false;
        _this.Editing = true;
        _this.articulosSelected = new core_1.EventEmitter();
        _this.articulosDeleted = new core_1.EventEmitter();
        _this._IdCategoriaPresupuestal = 0;
        return _this;
    }
    Object.defineProperty(CategoriasPresupuestalesArticulosComponent.prototype, "idCategoriaPresupuestal", {
        set: function (IdCategoriaPresupuestal) {
            this._IdCategoriaPresupuestal = IdCategoriaPresupuestal;
            this.refreshListArticulios();
        },
        enumerable: true,
        configurable: true
    });
    CategoriasPresupuestalesArticulosComponent.prototype.applyPolicy = function (policy) {
    };
    CategoriasPresupuestalesArticulosComponent.prototype.refreshListArticulios = function () {
        if (this._IdCategoriaPresupuestal > 0) {
            this.enableAdd = false;
            this.context.app.showSpinner();
            if (this.requestArticulo == null) {
                this.requestArticulo = new search_1.SearchRequest();
                this.requestArticulo.pageIndex = this.pageIndexArticulo;
                this.requestArticulo.pageSize = this.pageSizeArticulo;
                this.requestArticulo.paged = this.serverSideArticulo;
            }
            /*this.categoriaPresupuestalsvc.searchArticuloCategoriaPresupuestal(this._IdCategoriaPresupuestal, this.context.app.defaultSite.identity)
                .then(response => {
                    this.articulos = response.rows;
                    this.articulosCollection.sourceCollection = this.articulos;
                    this.totalRowsArticulo = response.totalRows;
                    this.context.app.hideSpinner();
                })
                .catch(error => this.handleError(error));*/
        }
        else {
            this.enableAdd = true;
        }
    };
    CategoriasPresupuestalesArticulosComponent.prototype.onCurrentItemArticuloChanged = function (args) {
        this.currentItemArticulo = args;
    };
    CategoriasPresupuestalesArticulosComponent.prototype.searchArticuloRequested = function (request) {
        this.requestArticulo = request;
        this.refreshListArticulios();
    };
    CategoriasPresupuestalesArticulosComponent.prototype.optionArticuloClick = function (option) {
        var _this = this;
        if (option.name == "DELETE") {
            var newArticulos = this.articulos.slice();
            newArticulos.splice(newArticulos.findIndex(function (K) { return K.id == _this.currentItemArticulo.id; }), 1);
            this.articulosEliminados.push(this.currentItemArticulo);
            this.articulos = newArticulos;
            this.articulosDeleted.emit(this.articulosEliminados);
            this.articulosSelected.emit(this.articulos);
        }
    };
    CategoriasPresupuestalesArticulosComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    CategoriasPresupuestalesArticulosComponent.prototype.onSelectedArticuloChanged = function (args) {
        if (args.length > 0) {
            var newArticulos = this.articulos.slice();
            for (var i = 0; i < args.length; i++) {
                if (newArticulos.findIndex(function (K) { return K.id == args[i].id; }) == -1) {
                    newArticulos.push(args[i]);
                }
            }
            this.articulos = newArticulos.slice();
            this.articulosSelected.emit(this.articulos);
        }
    };
    CategoriasPresupuestalesArticulosComponent.prototype.onAgregarArticulo = function () {
        this.ArticuloDialog.show();
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CategoriasPresupuestalesArticulosComponent.prototype, "pageSizeArticulo", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CategoriasPresupuestalesArticulosComponent.prototype, "totalRowsArticulo", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CategoriasPresupuestalesArticulosComponent.prototype, "pageIndexArticulo", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], CategoriasPresupuestalesArticulosComponent.prototype, "serverSideArticulo", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], CategoriasPresupuestalesArticulosComponent.prototype, "Editing", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], CategoriasPresupuestalesArticulosComponent.prototype, "idCategoriaPresupuestal", null);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], CategoriasPresupuestalesArticulosComponent.prototype, "articulosSelected", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], CategoriasPresupuestalesArticulosComponent.prototype, "articulosDeleted", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], CategoriasPresupuestalesArticulosComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild(core_1.forwardRef(function () { return articulo_list_component_1.ArticuloListComponent; })),
        __metadata("design:type", articulo_list_component_1.ArticuloListComponent)
    ], CategoriasPresupuestalesArticulosComponent.prototype, "ArticuloDialog", void 0);
    CategoriasPresupuestalesArticulosComponent = __decorate([
        core_1.Component({
            selector: 'categorias-presupuestales-articulos',
            template: "\n      <div class=\"card\">\n          <div class=\"card-block\">\n              <purchasing-articulo-list (selectedItemsChanged)=\"onSelectedArticuloChanged($event)\" [multiSelect]=\"true\"></purchasing-articulo-list>\n              <div class=\"mt-3\">\n                  <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAgregarArticulo()\" [disabled]=\"enableAdd\">\n                      <span aria-hidden=\"true\" class=\"glyphicon glyphicon-plus\"></span>\n                      Agregar Articulos\n                  </button>\n              </div>\n              <div class=\"mt-3\">\n                  <azteca-catalog-list [catalogList]=\"articulosCollection\"\n                                       [showRowButton]=\"false\"\n                                       (currentItemChanged)=\"onCurrentItemArticuloChanged($event)\"\n                                       (searchRequested)=\"searchArticuloRequested($event)\"\n                                       (contextMenuClick)=\"optionArticuloClick($event)\"\n                                       [enabled]=\"Editing\"\n                                       [pageSize]=\"pageSizeArticulo\"\n                                       [serverSide]=\"serverSideArticulo\"\n                                       [totalRows]=\"totalRowsArticulo\"\n                                       [pageIndex]=\"pageIndexArticulo\">\n\n                      <!-- OPCIONES DEL MENU-->\n                      <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                      <azteca-grid-column [header]=\"'C&oacute;digo'\" [binding]=\"'codigo'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'50*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n\n                  </azteca-catalog-list>\n              </div>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute,
            categorias_presupuestales_service_1.CategoriasPresupuestalesService])
    ], CategoriasPresupuestalesArticulosComponent);
    return CategoriasPresupuestalesArticulosComponent;
}(core_2.BaseComponent));
exports.CategoriasPresupuestalesArticulosComponent = CategoriasPresupuestalesArticulosComponent;
