"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("framework3/core");
var servicio_list_component_1 = require("../dialogs/servicio-list.component");
var router_1 = require("@angular/router");
var search_1 = require("framework3/search");
var controls_1 = require("framework3/controls");
var categorias_presupuestales_service_1 = require("../services/categorias-presupuestales.service");
var CategoriasPresupuestalesServiciosComponent = /** @class */ (function (_super) {
    __extends(CategoriasPresupuestalesServiciosComponent, _super);
    function CategoriasPresupuestalesServiciosComponent(context, router, route, categoriaPresupuestalsvc) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.categoriaPresupuestalsvc = categoriaPresupuestalsvc;
        _this.servicios = [];
        _this.serviciosEliminados = [];
        _this.enableAdd = true;
        _this.pageSizeServicio = 20;
        _this.totalRowsArticulo = 0;
        _this.pageIndexServicio = 0;
        _this.serverSideServicio = false;
        _this.Editing = true;
        _this.servicioSelected = new core_1.EventEmitter();
        _this.servicioDeleted = new core_1.EventEmitter();
        _this._IdCategoriaPresupuestal = 0;
        return _this;
    }
    Object.defineProperty(CategoriasPresupuestalesServiciosComponent.prototype, "idCategoriaPresupuestal", {
        set: function (IdCategoriaPresupuestal) {
            this._IdCategoriaPresupuestal = IdCategoriaPresupuestal;
            this.refreshListServicios();
        },
        enumerable: true,
        configurable: true
    });
    CategoriasPresupuestalesServiciosComponent.prototype.applyPolicy = function (policy) {
    };
    CategoriasPresupuestalesServiciosComponent.prototype.refreshListServicios = function () {
        var _this = this;
        if (this._IdCategoriaPresupuestal > 0) {
            this.enableAdd = false;
            this.context.app.showSpinner();
            if (this.requestServicio == null) {
                this.requestServicio = new search_1.SearchRequest();
                this.requestServicio.pageIndex = this.pageIndexServicio;
                this.requestServicio.pageSize = this.pageSizeServicio;
                this.requestServicio.paged = this.serverSideServicio;
            }
            this.categoriaPresupuestalsvc.searchServicioCategoriaPresupuestal(this._IdCategoriaPresupuestal, this.context.app.defaultSite.identity, this.requestServicio)
                .then(function (response) {
                _this.servicios = response.rows;
                _this.totalRowsArticulo = response.totalRows;
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.enableAdd = true;
        }
    };
    CategoriasPresupuestalesServiciosComponent.prototype.onCurrentItemServicioChanged = function (args) {
        this.currentItemServicio = args;
    };
    CategoriasPresupuestalesServiciosComponent.prototype.searchServicioRequested = function (request) {
        this.requestServicio = request;
        this.refreshListServicios();
    };
    CategoriasPresupuestalesServiciosComponent.prototype.optionServicioClick = function (option) {
        var _this = this;
        if (option.name == "DELETE") {
            var newServicios = this.servicios.slice();
            newServicios.splice(newServicios.findIndex(function (K) { return K.id == _this.currentItemServicio.id; }), 1);
            this.serviciosEliminados.push(this.currentItemServicio);
            this.servicios = newServicios;
            this.servicioDeleted.emit(this.serviciosEliminados);
            this.servicioSelected.emit(this.servicios);
        }
    };
    CategoriasPresupuestalesServiciosComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    CategoriasPresupuestalesServiciosComponent.prototype.onSelectedServicioChanged = function (args) {
        if (args.length > 0) {
            var newServicios = this.servicios.slice();
            for (var i = 0; i < args.length; i++) {
                if (newServicios.findIndex(function (K) { return K.id == args[i].id; }) == -1) {
                    newServicios.push(args[i]);
                }
            }
            this.servicios = newServicios.slice();
            this.servicioSelected.emit(this.servicios);
        }
    };
    CategoriasPresupuestalesServiciosComponent.prototype.onAgregarServicio = function () {
        this.ServicioDialog.show();
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CategoriasPresupuestalesServiciosComponent.prototype, "pageSizeServicio", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CategoriasPresupuestalesServiciosComponent.prototype, "totalRowsArticulo", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CategoriasPresupuestalesServiciosComponent.prototype, "pageIndexServicio", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], CategoriasPresupuestalesServiciosComponent.prototype, "serverSideServicio", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], CategoriasPresupuestalesServiciosComponent.prototype, "Editing", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], CategoriasPresupuestalesServiciosComponent.prototype, "idCategoriaPresupuestal", null);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], CategoriasPresupuestalesServiciosComponent.prototype, "servicioSelected", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], CategoriasPresupuestalesServiciosComponent.prototype, "servicioDeleted", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], CategoriasPresupuestalesServiciosComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild(core_1.forwardRef(function () { return servicio_list_component_1.ServicioListComponent; })),
        __metadata("design:type", servicio_list_component_1.ServicioListComponent)
    ], CategoriasPresupuestalesServiciosComponent.prototype, "ServicioDialog", void 0);
    CategoriasPresupuestalesServiciosComponent = __decorate([
        core_1.Component({
            selector: 'categorias-presupuestales-servicios',
            template: "\n      <div class=\"card\">\n          <div class=\"card-block\">\n              <purchasing-servicio-list (selectedItemsChanged)=\"onSelectedServicioChanged($event)\" [multiSelect]=\"true\"></purchasing-servicio-list>\n              <div class=\"mt-3\">\n                  <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAgregarServicio()\"  [disabled]=\"enableAdd\">\n                      <span aria-hidden=\"true\" class=\"glyphicon glyphicon-plus\"></span>\n                      Agregar Servicios\n                  </button>\n              </div>\n              <div class=\"mt-3\">\n                  <azteca-catalog-list [catalogList]=\"servicios\"\n                                       [showRowButton]=\"false\"\n                                       (currentItemChanged)=\"onCurrentItemServicioChanged($event)\"\n                                       (searchRequested)=\"searchServicioRequested($event)\"\n                                       (contextMenuClick)=\"optionServicioClick($event)\"\n                                       [enabled]=\"Editing\"\n                                       [pageSize]=\"pageSizeServicio\"\n                                       [serverSide]=\"serverSideServicio\"\n                                       [totalRows]=\"totalRowsServicio\"\n                                       [pageIndex]=\"pageIndexServicio\">\n\n                      <!-- OPCIONES DEL MENU-->\n                      <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                      <azteca-grid-column [header]=\"'C&oacute;digo'\" [binding]=\"'codigo'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'50*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n\n                  </azteca-catalog-list>\n              </div>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute,
            categorias_presupuestales_service_1.CategoriasPresupuestalesService])
    ], CategoriasPresupuestalesServiciosComponent);
    return CategoriasPresupuestalesServiciosComponent;
}(core_2.BaseComponent));
exports.CategoriasPresupuestalesServiciosComponent = CategoriasPresupuestalesServiciosComponent;
