import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormGroup } from '@angular/forms';
import { Context, BaseComponent, PolicyInfo } from 'framework3/core';
import { SearchRequest } from 'framework3/search';
import { AlertsBarComponent, MenuItem } from 'framework3/controls';
import { ModalDirective } from 'ngx-bootstrap';
import { ArticuloService } from '../services/articulo.service';
import { ArticuloInfo } from '../models/articulo';
import { ProveedorService } from '../services/proveedor.service';
import { ZonaCompraService } from '../services';
export declare class ProductoProveedorComponent extends BaseComponent {
    private context;
    private formBuilder;
    protected router: Router;
    protected route: ActivatedRoute;
    private articuloSvc;
    private proveedorSvc;
    private zonaCompraSvc;
    form: FormGroup;
    proceso: number;
    proveedores: any[];
    private _IdArticulo;
    private _IdServicio;
    idArticulo: number;
    idServicio: number;
    searchElement: boolean;
    searchByArticulo: boolean;
    searchByServicio: boolean;
    showTitle: boolean;
    menuItemsProveedor: MenuItem[];
    requestProveedor: SearchRequest;
    currentProveedor: any;
    pageSizeProveedor: number;
    totalRowsProveedor: number;
    pageIndexProveedor: number;
    serverSideProveedor: boolean;
    dlgConfirmacion: ModalDirective;
    alerts: AlertsBarComponent;
    confirmacionText: string;
    constructor(context: Context, formBuilder: FormBuilder, router: Router, route: ActivatedRoute, articuloSvc: ArticuloService, proveedorSvc: ProveedorService, zonaCompraSvc: ZonaCompraService);
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    createMenuProveedor(): void;
    onSelectedArticulo(args: ArticuloInfo): void;
    onCurrentItemProveedorChanged(item: any): void;
    searchProveedorRequested(request: SearchRequest): void;
    optionProveedorClick(option: MenuItem): void;
    refreshListByArticulio(): void;
    refreshListByServicio(): void;
    onAceptarConfirmacion(): void;
    setReadOnly(): void;
}
