"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Azteca Kernel
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
var controls_1 = require("framework3/controls");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Features
var articulo_service_1 = require("../services/articulo.service");
var proveedor_service_1 = require("../services/proveedor.service");
var services_1 = require("../services");
var ProductoProveedorComponent = /** @class */ (function (_super) {
    __extends(ProductoProveedorComponent, _super);
    function ProductoProveedorComponent(context, formBuilder, router, route, articuloSvc, proveedorSvc, zonaCompraSvc) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.router = router;
        _this.route = route;
        _this.articuloSvc = articuloSvc;
        _this.proveedorSvc = proveedorSvc;
        _this.zonaCompraSvc = zonaCompraSvc;
        _this.proceso = 0;
        //
        _this.proveedores = [];
        _this.searchElement = true;
        _this.searchByArticulo = true;
        _this.searchByServicio = true;
        _this.showTitle = true;
        //
        _this.menuItemsProveedor = [];
        _this.pageSizeProveedor = 20;
        _this.totalRowsProveedor = 0;
        _this.pageIndexProveedor = 0;
        _this.serverSideProveedor = false;
        _this.confirmacionText = "";
        _this.form = formBuilder.group({
            'idArticulo': ['']
        });
        return _this;
    }
    Object.defineProperty(ProductoProveedorComponent.prototype, "idArticulo", {
        set: function (idArticulo) {
            this._IdArticulo = idArticulo;
            this.refreshListByArticulio();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProductoProveedorComponent.prototype, "idServicio", {
        set: function (idServicio) {
            this._IdServicio = idServicio;
            this.refreshListByServicio();
        },
        enumerable: true,
        configurable: true
    });
    ;
    ProductoProveedorComponent.prototype.applyPolicy = function (policy) {
    };
    ProductoProveedorComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    ProductoProveedorComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.proceso = +param['proceso'];
        });
    };
    ProductoProveedorComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        var thisRoot = this;
        setTimeout(function (_) {
            if (_this.searchByArticulo) {
                _this.refreshListByArticulio();
            }
            else {
                _this.refreshListByServicio();
            }
        });
        this.createMenuProveedor();
    };
    ProductoProveedorComponent.prototype.createMenuProveedor = function () {
        var mnuEditar = { icon: "glyphicon glyphicon-pencil", text: "Editar", name: "EDIT", smallText: "Abrir en modo edición" };
        var mnuEliminar = { icon: "glyphicon glyphicon-trash", text: "Eliminar", name: "DELETE", smallText: "Eliminar permanentemente" };
        this.menuItemsProveedor.push(mnuEditar, mnuEliminar);
        this.menuItemsProveedor.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    ////////////////////////// Articulo //////////////////////////
    ProductoProveedorComponent.prototype.onSelectedArticulo = function (args) {
        this._IdArticulo = args.identity;
        this.refreshListByArticulio();
    };
    ProductoProveedorComponent.prototype.onCurrentItemProveedorChanged = function (item) {
        this.currentProveedor = item;
    };
    ProductoProveedorComponent.prototype.searchProveedorRequested = function (request) {
        this.requestProveedor = request;
    };
    ProductoProveedorComponent.prototype.optionProveedorClick = function (option) {
        var _this = this;
        if (option.name == "EDIT") {
            if (this.searchByArticulo) {
                this.context.app.showSpinner();
                this.zonaCompraSvc.hasAccess(this.context.session.user.identity, this.currentProveedor.data.idzonaCompra)
                    .then(function (access) {
                    _this.context.app.hideSpinner();
                    if (access)
                        _this.router.navigate(['purchasing/proveedor-articulo', _this.proceso, _this.currentProveedor.data.idProveedorArticulo, 0, 0, 0, 0, 0, 0]);
                    else
                        _this.alerts.showAlert('No tienes acceso a esa zona de compra', 'danger');
                }).catch(function (error) { return _this.handleError(error); });
            }
            else
                this.router.navigate(['purchasing/proveedor-servicio', this.proceso, this.currentProveedor.data.idProveedorServicio, 0, 0, 0, 0, 0, 0]);
        }
        else if (option.name == "DELETE") {
            this.confirmacionText = "¿Está seguro que desea elmininar el proveedor " + this.currentProveedor.data.nombre + "?";
            this.dlgConfirmacion.config.backdrop = false;
            this.dlgConfirmacion.show();
        }
    };
    ProductoProveedorComponent.prototype.refreshListByArticulio = function () {
        var _this = this;
        if (this._IdArticulo > 0) {
            this.context.app.showSpinner();
            if (this.requestProveedor == null) {
                this.requestProveedor = new search_1.SearchRequest();
                this.requestProveedor.pageIndex = this.pageIndexProveedor;
                this.requestProveedor.pageSize = this.pageSizeProveedor;
                this.requestProveedor.paged = this.serverSideProveedor;
            }
            this.proveedorSvc.searchProveedorByArticulo(this._IdArticulo, this.context.app.defaultSite.identity, this.requestProveedor)
                .then(function (response) {
                _this.proveedores = response.rows;
                _this.totalRowsProveedor = response.totalRows;
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    ProductoProveedorComponent.prototype.refreshListByServicio = function () {
        var _this = this;
        if (this._IdServicio > 0) {
            this.context.app.showSpinner();
            if (this.requestProveedor == null) {
                this.requestProveedor = new search_1.SearchRequest();
                this.requestProveedor.pageIndex = this.pageIndexProveedor;
                this.requestProveedor.pageSize = this.pageSizeProveedor;
                this.requestProveedor.paged = this.serverSideProveedor;
            }
            this.proveedorSvc.searchProveedorByServicio(this._IdServicio, this.context.app.defaultSite.identity, this.requestProveedor)
                .then(function (response) {
                _this.proveedores = response.rows;
                _this.totalRowsProveedor = response.totalRows;
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    ProductoProveedorComponent.prototype.onAceptarConfirmacion = function () {
        var _this = this;
        this.context.app.showSpinner();
        if (this.searchByArticulo)
            this.proveedorSvc.deleteProveedorArticulo(this.currentProveedor.data.idProveedorArticulo)
                .then(function (result) {
                _this.context.app.hideSpinner();
                _this.refreshListByArticulio();
            })
                .catch(function (error) { return _this.handleError(error); });
        else
            this.proveedorSvc.deleteProveedorServicio(this.currentProveedor.data.idProveedorServicio)
                .then(function (result) {
                _this.context.app.hideSpinner();
                _this.refreshListByServicio();
            })
                .catch(function (error) { return _this.handleError(error); });
        this.dlgConfirmacion.hide();
    };
    ProductoProveedorComponent.prototype.setReadOnly = function () {
        this.menuItemsProveedor = [];
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], ProductoProveedorComponent.prototype, "idArticulo", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], ProductoProveedorComponent.prototype, "idServicio", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProductoProveedorComponent.prototype, "searchElement", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProductoProveedorComponent.prototype, "searchByArticulo", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProductoProveedorComponent.prototype, "searchByServicio", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProductoProveedorComponent.prototype, "showTitle", void 0);
    __decorate([
        core_1.ViewChild('dlgConfirmacion'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ProductoProveedorComponent.prototype, "dlgConfirmacion", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ProductoProveedorComponent.prototype, "alerts", void 0);
    ProductoProveedorComponent = __decorate([
        core_1.Component({
            selector: 'purchasing-producto-proveedor',
            template: "\n      <div class=\"card\">\n          <div *ngIf=\"showTitle\" class=\"card-header\">Proveedor Producto</div>\n          <div class=\"card-block\">\n\n              <alerts-bar></alerts-bar>\n              <div class=\"row\" *ngIf=\"searchElement\">\n                  <div *ngIf=\"searchByArticulo\" class=\"row\" [formGroup]=\"form\">\n                      <div class=\"col-12\">\n                          <azteca-form-field [label]=\"'Art&iacute;culo:'\">\n                              <purchasing-articulo-selector formControlName=\"idArticulo\"\n                                                            [(ngModel)]=\"idArticulo\"\n                                                            (articuloUpdated)=\"onSelectedArticulo($event)\"></purchasing-articulo-selector>\n\n                          </azteca-form-field>\n                      </div>\n                  </div>\n              </div>\n\n              <azteca-catalog-list [catalogList]=\"proveedores\"\n                                   [showRowButton]=\"false\"\n                                   (currentItemChanged)=\"onCurrentItemProveedorChanged($event)\"\n                                   (searchRequested)=\"searchProveedorRequested($event)\"\n                                   (contextMenuClick)=\"optionProveedorClick($event)\"\n                                   [enabled]=\"true\"\n                                   [pageSize]=\"pageSizeProveedor\"\n                                   [serverSide]=\"serverSideProveedor\"\n                                   [totalRows]=\"totalRowsProveedor\"\n                                   [pageIndex]=\"pageIndexProveedor\">\n\n                  <!-- Mapear opciones de men\u00FA de componente padre-->\n                  <azteca-menu-item *ngFor=\"let item of menuItemsProveedor\" [name]=\"item.name\" [icon]=\"item.icon\" [text]=\"item.text\" [smallText]=\"item.smallText\" [enabled]=\"item.enabled\"></azteca-menu-item>\n\n                  <azteca-grid-column [header]=\"'C&oacute;digo'\" [binding]=\"'codigo'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Proveedor'\" [binding]=\"'nombre'\" [width]=\"'140*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Zona'\" [binding]=\"'codigoZona'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Zona Compra'\" [binding]=\"'zona'\" [width]=\"'140*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Costo'\" [binding]=\"'costo'\" [width]=\"'40*'\" [format]=\"'n4'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'UM'\" [binding]=\"'unidadMedida'\" [width]=\"'40*'\" ></azteca-grid-column>\n              </azteca-catalog-list>\n\n          </div>\n      </div>\n\n      <!--DIALOGO DE CONFIRMACION-->\n      <div bsModal #dlgConfirmacion=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\" id=\"exampleModalLabel\">Confirmaci&oacute;n</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"onCancelarConfirmacion()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <span>{{confirmacionText}}</span>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn\" (click)=\"onCancelarConfirmacion()\">\n                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-remove\"></span>\n                          Cancelar\n                      </button>\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAceptarConfirmacion()\">\n                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-ok\"></span>\n                          Aceptar\n                      </button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute,
            articulo_service_1.ArticuloService, proveedor_service_1.ProveedorService, services_1.ZonaCompraService])
    ], ProductoProveedorComponent);
    return ProductoProveedorComponent;
}(core_2.BaseComponent));
exports.ProductoProveedorComponent = ProductoProveedorComponent;
;
