"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//
var proveedor_1 = require("../models/proveedor");
var articulo_service_1 = require("../services/articulo.service");
var unidad_medida_service_1 = require("../../inventory/services/unidad-medida.service");
var unidad_medida_tipo_service_1 = require("../../inventory/services/unidad-medida-tipo.service");
var divisas_selector_component_1 = require("../../accounting/controls/divisas-selector.component");
var proveedor_service_1 = require("../services/proveedor.service");
var ProveedorArtioculoComponent = /** @class */ (function (_super) {
    __extends(ProveedorArtioculoComponent, _super);
    function ProveedorArtioculoComponent(context, formBuilder, route, location, proveedorSvc, articuloSvc, unidadMedidaService, tipoUnidadService) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.route = route;
        _this.location = location;
        _this.proveedorSvc = proveedorSvc;
        _this.articuloSvc = articuloSvc;
        _this.unidadMedidaService = unidadMedidaService;
        _this.tipoUnidadService = tipoUnidadService;
        //
        _this.proveedorArticulo = new proveedor_1.ProveedorArticulo();
        //articulo: ArticuloInfo = new ArticuloInfo();
        _this.tiposUnidad = [];
        _this.unidadesMedida = [];
        //
        _this.editProveedor = true;
        _this.editArticulo = true;
        _this.editZona = true;
        _this.standAlone = true;
        //
        _this.idProveedorArticulo = 0;
        _this.idProveedor = 0;
        _this.idArticulo = 0;
        _this.idZona = 0;
        //
        _this.savedCost = new core_1.EventEmitter();
        _this.cancelCost = new core_1.EventEmitter();
        _this.form = formBuilder.group({
            'idProveedor': [''],
            'idZonaCompra': [''],
            'idArticulo': [],
            'costo': [''],
            'diasCredito': [''],
            'diasEntrega': [''],
            'porcAnticipo': [''],
            'idDivisa': [''],
            'idTipoUnidad': [''],
            'idUnidadMedida': [''],
            'porcDescuento1': [''],
            'porcDescuento2': [''],
            'porcDescuento3': [''],
            'porcDescuento4': [''],
            'porcDescuento5': [''],
            'predeterminado': ['']
        });
        return _this;
    }
    ProveedorArtioculoComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.route.params) {
            this.route.params.forEach(function (param) {
                _this.idProveedorArticulo = +param['id'];
                _this.idProveedor = +param['idProveedor'];
                _this.idArticulo = +param['idArticulo'];
                _this.idZona = +param['idZona'];
                _this.editProveedor = +param['editProveedor'] == 1;
                _this.editArticulo = +param['editArticulo'] == 1;
                _this.editZona = +param['editZona'] == 1;
            });
        }
    };
    ProveedorArtioculoComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) {
            _this.loadTiposUnidad();
            _this.loadInitialData();
        });
    };
    ProveedorArtioculoComponent.prototype.loadInitialData = function () {
        var _this = this;
        if (this.idProveedorArticulo > 0) {
            this.context.app.showSpinner();
            this.proveedorSvc.getDetailProveedorArticulo(this.idProveedorArticulo)
                .then(function (result) {
                _this.context.app.hideSpinner();
                _this.proveedorArticulo = result;
                _this.selDivisa.loadItem(_this.proveedorArticulo.idDivisa);
                _this.loadUnidadesMedida(_this.proveedorArticulo.articulo.articuloStock.unidadMedida.idUnidadMedidaTipo);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.proveedorArticulo.idProveedor = this.idProveedor;
            this.proveedorArticulo.idArticulo = this.idArticulo;
            this.proveedorArticulo.idZonaCompra = this.idZona;
        }
    };
    ProveedorArtioculoComponent.prototype.applyPolicy = function (policy) {
    };
    ProveedorArtioculoComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    ProveedorArtioculoComponent.prototype.loadTiposUnidad = function () {
        var _this = this;
        this.tipoUnidadService.loadList()
            .then(function (tipos) { return _this.tiposUnidad = tipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ProveedorArtioculoComponent.prototype.articuloChanged = function (articulo) {
        if (articulo) {
            this.proveedorArticulo.articulo = articulo;
            this.loadUnidadesMedida(articulo.articuloStock.unidadMedida.idUnidadMedidaTipo);
        }
    };
    ProveedorArtioculoComponent.prototype.onTipoUnidadChanged = function (idTipoUnidad) {
        this.loadUnidadesMedida(idTipoUnidad);
    };
    ProveedorArtioculoComponent.prototype.loadUnidadesMedida = function (idTipoUnidad) {
        var _this = this;
        this.unidadMedidaService.loadList(idTipoUnidad)
            .then(function (unidades) {
            _this.unidadesMedida = unidades;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ProveedorArtioculoComponent.prototype.mainToolbarHandler = function (button) {
        var _this = this;
        if (button.name == "SAVE") {
            if (this.proveedorArticulo.costo > 0) {
                this.context.app.showSpinner();
                this.proveedorArticulo.idDivisa = this.selDivisa.selectedItem.identity;
                // Guardar proveedor articulo
                this.proveedorSvc.updateProveedorArticulo(this.proveedorArticulo)
                    .then(function (result) {
                    _this.context.app.hideSpinner();
                    if (result) {
                        if (_this.standAlone)
                            _this.location.back();
                        else
                            _this.savedCost.emit(_this.proveedorArticulo);
                    }
                })
                    .catch(function (error) {
                    _this.context.app.hideSpinner();
                    _this.alerts.showAlert(error.error.message, 'danger');
                });
            }
            else
                this.alerts.showAlert("El costo no puede ser igual o menor a 0", 'danger');
        }
        else if (button.name == "CLOSE") {
            if (this.standAlone)
                this.location.back();
            else
                this.cancelCost.emit(true);
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProveedorArtioculoComponent.prototype, "editProveedor", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProveedorArtioculoComponent.prototype, "editArticulo", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProveedorArtioculoComponent.prototype, "editZona", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProveedorArtioculoComponent.prototype, "standAlone", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ProveedorArtioculoComponent.prototype, "idProveedorArticulo", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ProveedorArtioculoComponent.prototype, "idProveedor", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ProveedorArtioculoComponent.prototype, "idArticulo", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ProveedorArtioculoComponent.prototype, "idZona", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ProveedorArtioculoComponent.prototype, "savedCost", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ProveedorArtioculoComponent.prototype, "cancelCost", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ProveedorArtioculoComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('selDivisa'),
        __metadata("design:type", divisas_selector_component_1.DivisasSelectorComponent)
    ], ProveedorArtioculoComponent.prototype, "selDivisa", void 0);
    ProveedorArtioculoComponent = __decorate([
        core_1.Component({
            selector: 'purchasing-proveedor-articulo',
            template: "\n      <form [formGroup]=\"form\">\n\n          <div class=\"row\">\n              <div class=\"col-12 col-lg-12\">\n                  <alerts-bar></alerts-bar>\n                  <az-panel header=\"Proveedor\">\n\n                      <az-toolbar (buttonClick)=\"mainToolbarHandler($event)\">\n                          <az-toolbar-button [name]=\"'SAVE'\" [type]=\"'primary'\" [text]=\"'Guardar Cambios'\" [icon]=\"'glyphicon glyphicon-floppy-disk'\"></az-toolbar-button>\n                          <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Cerrar'\" [icon]=\"'glyphicon glyphicon-remove'\"></az-toolbar-button>\n                      </az-toolbar>\n\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'Proveedor:'\">\n                                  <purchasing-proveedor-selector formControlName=\"idProveedor\"\n                                                                 [proveedorSelector]=\"editProveedor\"\n                                                                 [(ngModel)]=\"proveedorArticulo.idProveedor\"></purchasing-proveedor-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'Zona de Compra:'\">\n                                  <purchasing-zona-compra-selector formControlName=\"idZonaCompra\"\n                                                                   [zonaCompraSelector]=\"editZona\"\n                                                                   [(ngModel)]=\"proveedorArticulo.idZonaCompra\"></purchasing-zona-compra-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'Art&iacute;culo:'\">\n                                  <purchasing-articulo-selector formControlName=\"idArticulo\"\n                                                                [articuloSelector]=\"editArticulo\"\n                                                                [(ngModel)]=\"proveedorArticulo.idArticulo\"\n                                                                (articuloUpdated)=\"articuloChanged($event)\">\n\n                                  </purchasing-articulo-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'Costo:'\">\n                                  <az-input-number formControlName=\"costo\" [(ngModel)]=\"proveedorArticulo.costo\" format=\"'n4'\" [min]=\"0\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'D&iacute;as de Cr&eacute;dito:'\">\n                                  <az-input-number formControlName=\"diasCredito\" [(ngModel)]=\"proveedorArticulo.diasCredito\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'D&iacute;as de Entrega:'\">\n                                  <az-input-number formControlName=\"diasEntrega\" [(ngModel)]=\"proveedorArticulo.diasEntrega\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'Porcentaje de Anticipo:'\">\n                                  <az-input-number formControlName=\"porcAnticipo\" [(ngModel)]=\"proveedorArticulo.porcAnticipo\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'Divisa:'\">\n                                  <accounting-divisas-selector #selDivisa formControlName=\"idDivisa\" [(ngModel)]=\"proveedorArticulo.idDivisa\"></accounting-divisas-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <!--Ocultar si se manejan series-->\n                              <azteca-form-field *ngIf=\"!proveedorArticulo.articulo.articuloStock.manejaSeries\" [label]=\"'Tipo de unidad de medida:'\">\n                                  <az-combobox \n                                               formControlName=\"idTipoUnidad\"\n                                               [(ngModel)]=\"proveedorArticulo.articulo.articuloStock.unidadMedida.idUnidadMedidaTipo\"\n                                               [items]=\"tiposUnidad\"\n                                               [valueMember]=\"'id'\"\n                                               [displayMember]=\"'nombre'\"\n                                               (selectedItemChanged)=\"onTipoUnidadChanged($event)\">\n                                  </az-combobox>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <!--Ocultar si se manejan series-->\n                              <azteca-form-field *ngIf=\"!proveedorArticulo.articulo.articuloStock.manejaSeries\" [label]=\"'Unidad de Compra:'\">\n                                  <az-combobox formControlName=\"idUnidadMedida\"\n                                               [(ngModel)]=\"proveedorArticulo.idUnidadMedida\"\n                                               [items]=\"unidadesMedida\"\n                                               [valueMember]=\"'id'\"\n                                               [displayMember]=\"'nombre'\">\n                                  </az-combobox>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <!--<div class=\"row\">\n                          <div class=\"col-12\">\n                              <purchasing-articulo-impuesto #ctrlArticuloImpuestos [idArticulo]=\"proveedorArticulo.idArticulo\"></purchasing-articulo-impuesto>\n                          </div>\n                      </div>-->\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-2\">\n                              <azteca-form-field [label]=\"'% Desc. 1:'\">\n                                  <az-input-number formControlName=\"porcDescuento1\" [(ngModel)]=\"proveedorArticulo.porcDescuento1\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-2\">\n                              <azteca-form-field [label]=\"'% Desc. 2:'\">\n                                  <az-input-number formControlName=\"porcDescuento2\" [(ngModel)]=\"proveedorArticulo.porcDescuento2\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-2\">\n                              <azteca-form-field [label]=\"'% Desc. 3:'\">\n                                  <az-input-number formControlName=\"porcDescuento3\" [(ngModel)]=\"proveedorArticulo.porcDescuento3\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-2\">\n                              <azteca-form-field [label]=\"'% Desc. 4:'\">\n                                  <az-input-number formControlName=\"porcDescuento4\" [(ngModel)]=\"proveedorArticulo.porcDescuento4\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-2\">\n                              <azteca-form-field [label]=\"'% Desc. 5:'\">\n                                  <az-input-number formControlName=\"porcDescuento5\" [(ngModel)]=\"proveedorArticulo.porcDescuento5\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-6\">\n                              <az-checkbox [label]=\"'Predeterminado'\"\n                                           formControlName=\"predeterminado\"\n                                           [(ngModel)]=\"proveedorArticulo.predeterminado\"></az-checkbox>\n                          </div>\n                      </div>\n\n                  </az-panel>\n              </div>\n\n          </div>\n\n      </form>\n\n      <!--DIALOGO DE CONFIRMACION-->\n      <div bsModal #dlgConfirmacion=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\" id=\"exampleModalLabel\">Confirmaci&oacute;n</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"onCancelarConfirmacion()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <span>{{confirmacionText}}</span>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn\" (click)=\"onCancelarConfirmacion()\">\n                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-remove\"></span>\n                          Cancelar\n                      </button>\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAceptarConfimracion()\">\n                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-ok\"></span>\n                          Aceptar\n                      </button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, router_1.ActivatedRoute, common_1.Location,
            proveedor_service_1.ProveedorService, articulo_service_1.ArticuloService, unidad_medida_service_1.UnidadMedidaService, unidad_medida_tipo_service_1.UnidadMedidaTipoService])
    ], ProveedorArtioculoComponent);
    return ProveedorArtioculoComponent;
}(core_2.BaseComponent));
exports.ProveedorArtioculoComponent = ProveedorArtioculoComponent;
