import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormGroup } from '@angular/forms';
import { Context, BaseComponent, PolicyInfo } from 'framework3/core';
import { SearchRequest } from 'framework3/search';
import { AlertsBarComponent, MenuItem } from 'framework3/controls';
import { ModalDirective } from 'ngx-bootstrap';
import { ArticuloService } from '../services/articulo.service';
import { ProveedorInfo } from '../models/proveedor';
import { ProveedorService } from '../services/proveedor.service';
import { ServicioService } from '../services/servicio.service';
import { ZonaCompraService } from '../services';
export declare class ProveedorProductoComponent extends BaseComponent {
    private context;
    private formBuilder;
    protected router: Router;
    protected route: ActivatedRoute;
    private articuloSvc;
    private proveedorSvc;
    private servicioSvc;
    private zonaCompraSvc;
    form: FormGroup;
    proceso: number;
    articulos: any[];
    servicios: any[];
    requestArticulo: SearchRequest;
    requestServicio: SearchRequest;
    currentItemArticulo: any;
    currentItemServicio: any;
    menuItemsArticulo: MenuItem[];
    menuItemsServicio: MenuItem[];
    showTitle: boolean;
    pageSizeArticulo: number;
    totalRowsArticulo: number;
    pageIndexArticulo: number;
    serverSideArticulo: boolean;
    dlgConfirmacion: ModalDirective;
    alerts: AlertsBarComponent;
    private _IdProveedor;
    confirmacionText: string;
    onAceptarConfimracion: any;
    idProveedor: number;
    selectProveedor: boolean;
    showArticulo: boolean;
    showServicio: boolean;
    constructor(context: Context, formBuilder: FormBuilder, router: Router, route: ActivatedRoute, articuloSvc: ArticuloService, proveedorSvc: ProveedorService, servicioSvc: ServicioService, zonaCompraSvc: ZonaCompraService);
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    createMenuArticulo(): void;
    createMenuServicio(): void;
    onSelectedProveedor(args: ProveedorInfo): void;
    onCurrentItemArticuloChanged(args: any): void;
    onCurrentItemServicioChanged(args: any): void;
    optionArticuloClick(option: MenuItem): void;
    optionServicioClick(option: MenuItem): void;
    searchArticuloRequested(request: SearchRequest): void;
    searchServicioRequested(request: SearchRequest): void;
    refreshListArticulios(): void;
    refreshListServicios(): void;
    onCancelarConfirmacion(): void;
    setReadOnly(): void;
}
