"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Azteca Kernel
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
var controls_1 = require("framework3/controls");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Features
var articulo_service_1 = require("../services/articulo.service");
var proveedor_service_1 = require("../services/proveedor.service");
var servicio_service_1 = require("../services/servicio.service");
var services_1 = require("../services");
var ProveedorProductoComponent = /** @class */ (function (_super) {
    __extends(ProveedorProductoComponent, _super);
    function ProveedorProductoComponent(context, formBuilder, router, route, articuloSvc, proveedorSvc, servicioSvc, zonaCompraSvc) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.router = router;
        _this.route = route;
        _this.articuloSvc = articuloSvc;
        _this.proveedorSvc = proveedorSvc;
        _this.servicioSvc = servicioSvc;
        _this.zonaCompraSvc = zonaCompraSvc;
        _this.proceso = 0;
        //
        _this.articulos = [];
        _this.servicios = [];
        _this.menuItemsArticulo = [];
        _this.menuItemsServicio = [];
        _this.showTitle = true;
        _this.pageSizeArticulo = 20;
        _this.totalRowsArticulo = 0;
        _this.pageIndexArticulo = 0;
        _this.serverSideArticulo = false;
        //
        _this._IdProveedor = 0;
        //
        _this.confirmacionText = "";
        _this.selectProveedor = true;
        _this.showArticulo = true;
        _this.showServicio = true;
        _this.form = formBuilder.group({
            'idProveedor': ['']
        });
        return _this;
    }
    Object.defineProperty(ProveedorProductoComponent.prototype, "idProveedor", {
        set: function (idProveedor) {
            this._IdProveedor = idProveedor;
            this.refreshListArticulios();
            this.refreshListServicios();
        },
        enumerable: true,
        configurable: true
    });
    ProveedorProductoComponent.prototype.applyPolicy = function (policy) {
    };
    ProveedorProductoComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    ProveedorProductoComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.proceso = +param['proceso'];
        });
    };
    ProveedorProductoComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        var thisRoot = this;
        setTimeout(function (_) {
            if (_this.showArticulo)
                _this.refreshListArticulios();
            if (_this.showServicio)
                _this.refreshListServicios();
        });
        if (this.showArticulo)
            this.createMenuArticulo();
        if (this.showServicio)
            this.createMenuServicio();
    };
    ProveedorProductoComponent.prototype.createMenuArticulo = function () {
        var mnuEditar = { icon: "glyphicon glyphicon-pencil", text: "Editar", name: "EDIT", smallText: "Abrir en modo edición" };
        var mnuEliminar = { icon: "glyphicon glyphicon-trash", text: "Eliminar", name: "DELETE", smallText: "Eliminar permanentemente" };
        this.menuItemsArticulo.push(mnuEditar, mnuEliminar);
        this.menuItemsArticulo.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    ProveedorProductoComponent.prototype.createMenuServicio = function () {
        var mnuEditar = { icon: "glyphicon glyphicon-pencil", text: "Editar", name: "EDIT", smallText: "Abrir en modo edición" };
        var mnuEliminar = { icon: "glyphicon glyphicon-trash", text: "Eliminar", name: "DELETE", smallText: "Eliminar permanentemente" };
        this.menuItemsServicio.push(mnuEditar, mnuEliminar);
        this.menuItemsServicio.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    /////////////////////////////
    ProveedorProductoComponent.prototype.onSelectedProveedor = function (args) {
        this._IdProveedor = args.identity;
        if (this.showArticulo)
            this.refreshListArticulios();
        if (this.showServicio)
            this.refreshListServicios();
    };
    ProveedorProductoComponent.prototype.onCurrentItemArticuloChanged = function (args) {
        this.currentItemArticulo = args;
    };
    ProveedorProductoComponent.prototype.onCurrentItemServicioChanged = function (args) {
        this.currentItemServicio = args;
    };
    ProveedorProductoComponent.prototype.optionArticuloClick = function (option) {
        var _this = this;
        if (option.name == "EDIT") {
            this.context.app.showSpinner();
            this.zonaCompraSvc.hasAccess(this.context.session.user.identity, this.currentItemArticulo.data.idzonaCompra)
                .then(function (access) {
                _this.context.app.hideSpinner();
                if (access)
                    _this.router.navigate(['purchasing/proveedor-articulo', _this.proceso, _this.currentItemArticulo.data.idProveedorArticulo, 0, 0, 0, 0, 0, 0]);
                else
                    _this.alerts.showAlert('No tienes acceso a esa zona de compra', 'danger');
            }).catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == "DELETE") {
            this.confirmacionText = "¿Está seguro que desea elmininar el artículo " + this.currentItemArticulo.data.nombre + "?";
            this.onAceptarConfimracion = function () {
                _this.context.app.showSpinner();
                _this.proveedorSvc.deleteProveedorArticulo(_this.currentItemArticulo.data.idProveedorArticulo)
                    .then(function (result) {
                    _this.context.app.hideSpinner();
                    _this.refreshListArticulios();
                })
                    .catch(function (error) { return _this.handleError(error); });
            };
            this.dlgConfirmacion.config.backdrop = false;
            this.dlgConfirmacion.show();
        }
    };
    ProveedorProductoComponent.prototype.optionServicioClick = function (option) {
        var _this = this;
        if (option.name == "EDIT") {
            this.router.navigate(['purchasing/proveedor-servicio', this.proceso, this.currentItemServicio.data.idProveedorServicio, 0, 0, 0, 0, 0, 0]);
        }
        else if (option.name == "DELETE") {
            this.confirmacionText = "¿Está seguro que desea elmininar el servicio " + this.currentItemServicio.data.nombre + "?";
            this.onAceptarConfimracion = function () {
                _this.context.app.showSpinner();
                _this.proveedorSvc.deleteProveedorServicio(_this.currentItemServicio.data.idProveedorServicio)
                    .then(function (result) {
                    _this.context.app.hideSpinner();
                    _this.refreshListServicios();
                })
                    .catch(function (error) { return _this.handleError(error); });
            };
            this.dlgConfirmacion.config.backdrop = false;
            this.dlgConfirmacion.show();
        }
    };
    ProveedorProductoComponent.prototype.searchArticuloRequested = function (request) {
        this.requestArticulo = request;
        this.refreshListArticulios();
    };
    ProveedorProductoComponent.prototype.searchServicioRequested = function (request) {
        this.requestServicio = request;
        this.refreshListServicios();
    };
    ProveedorProductoComponent.prototype.refreshListArticulios = function () {
        var _this = this;
        if (this._IdProveedor > 0) {
            this.context.app.showSpinner();
            if (this.requestArticulo == null) {
                this.requestArticulo = new search_1.SearchRequest();
                this.requestArticulo.pageIndex = this.pageIndexArticulo;
                this.requestArticulo.pageSize = this.pageSizeArticulo;
                this.requestArticulo.paged = this.serverSideArticulo;
            }
            this.articuloSvc.searchArticuloProveedor(this._IdProveedor, this.context.app.defaultSite.identity, this.requestArticulo)
                .then(function (response) {
                _this.articulos = response.rows;
                _this.totalRowsArticulo = response.totalRows;
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    ProveedorProductoComponent.prototype.refreshListServicios = function () {
        var _this = this;
        if (this._IdProveedor > 0) {
            this.context.app.showSpinner();
            if (this.requestServicio == null) {
                this.requestServicio = new search_1.SearchRequest();
                this.requestServicio.pageIndex = this.pageIndexArticulo;
                this.requestServicio.pageSize = this.pageSizeArticulo;
                this.requestServicio.paged = this.serverSideArticulo;
            }
            this.servicioSvc.searchServicioProveedor(this._IdProveedor, this.context.app.defaultSite.identity, this.requestServicio)
                .then(function (response) {
                _this.servicios = response.rows;
                _this.totalRowsArticulo = response.totalRows;
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    ProveedorProductoComponent.prototype.onCancelarConfirmacion = function () {
        this.dlgConfirmacion.hide();
    };
    ProveedorProductoComponent.prototype.setReadOnly = function () {
        this.menuItemsArticulo = [];
        this.menuItemsServicio = [];
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProveedorProductoComponent.prototype, "showTitle", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ProveedorProductoComponent.prototype, "pageSizeArticulo", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ProveedorProductoComponent.prototype, "totalRowsArticulo", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ProveedorProductoComponent.prototype, "pageIndexArticulo", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProveedorProductoComponent.prototype, "serverSideArticulo", void 0);
    __decorate([
        core_1.ViewChild('dlgConfirmacion'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ProveedorProductoComponent.prototype, "dlgConfirmacion", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ProveedorProductoComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], ProveedorProductoComponent.prototype, "idProveedor", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProveedorProductoComponent.prototype, "selectProveedor", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProveedorProductoComponent.prototype, "showArticulo", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProveedorProductoComponent.prototype, "showServicio", void 0);
    ProveedorProductoComponent = __decorate([
        core_1.Component({
            selector: 'purchasing-proveedor-producto',
            template: "\n      <div class=\"card\">\n          <div *ngIf=\"showTitle\" class=\"card-header\">Proveedor Producto</div>\n          <div class=\"card-block\">\n\n              <alerts-bar></alerts-bar>\n              <div *ngIf=\"selectProveedor\" class=\"row\" [formGroup]=\"form\">\n                  <div class=\"col-12\">\n                      <azteca-form-field [label]=\"'Proveedor:'\">\n                          <purchasing-proveedor-selector formControlName=\"idProveedor\"\n                                                         [(ngModel)]=\"idProveedor\"\n                                                         (proveedorUpdated)=\"onSelectedProveedor($event)\"></purchasing-proveedor-selector>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <tabset>\n                  <tab *ngIf=\"showArticulo\" heading=\"Art&iacute;culos\">\n\n                      <azteca-catalog-list [catalogList]=\"articulos\"\n                                           [showRowButton]=\"false\"\n                                           (currentItemChanged)=\"onCurrentItemArticuloChanged($event)\"\n                                           (searchRequested)=\"searchArticuloRequested($event)\"\n                                           (contextMenuClick)=\"optionArticuloClick($event)\"\n                                           [enabled]=\"true\"\n                                           [pageSize]=\"pageSizeArticulo\"\n                                           [serverSide]=\"serverSideArticulo\"\n                                           [totalRows]=\"totalRowsArticulo\"\n                                           [pageIndex]=\"pageIndexArticulo\">\n\n                          <!-- Mapear opciones de men\u00FA de componente padre-->\n                          <azteca-menu-item *ngFor=\"let item of menuItemsArticulo\" [name]=\"item.name\" [icon]=\"item.icon\" [text]=\"item.text\" [smallText]=\"item.smallText\" [enabled]=\"item.enabled\"></azteca-menu-item>\n\n                          <azteca-grid-column [header]=\"'C&oacute;digo'\" [binding]=\"'codigo'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Art&iacute;te'\" [binding]=\"'nombre'\" [width]=\"'140*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Zona'\" [binding]=\"'codigoZona'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Zona Compra'\" [binding]=\"'zona'\" [width]=\"'140*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Costo'\" [binding]=\"'costo'\" [width]=\"'40*'\" [format]=\"'n2'\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Unidad Medida'\" [binding]=\"'unidadMedida'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                      </azteca-catalog-list>\n                  </tab>\n\n                  <tab *ngIf=\"showServicio\" heading=\"Servicios\">\n                      <azteca-catalog-list [catalogList]=\"servicios\"\n                                           [showRowButton]=\"false\"\n                                           (currentItemChanged)=\"onCurrentItemServicioChanged($event)\"\n                                           (searchRequested)=\"searchServicioRequested($event)\"\n                                           (contextMenuClick)=\"optionServicioClick($event)\"\n                                           [enabled]=\"true\"\n                                           [pageSize]=\"pageSizeArticulo\"\n                                           [serverSide]=\"serverSideArticulo\"\n                                           [totalRows]=\"totalRowsArticulo\"\n                                           [pageIndex]=\"pageIndexArticulo\">\n\n                          <!-- Mapear opciones de men\u00FA de componente padre-->\n                          <azteca-menu-item *ngFor=\"let item of menuItemsServicio\" [name]=\"item.name\" [icon]=\"item.icon\" [text]=\"item.text\" [smallText]=\"item.smallText\" [enabled]=\"item.enabled\"></azteca-menu-item>\n\n                          <azteca-grid-column [header]=\"'C&oacute;digo'\" [binding]=\"'codigo'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Servicio'\" [binding]=\"'nombre'\" [width]=\"'140*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Zona'\" [binding]=\"'codigoZona'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Zona Compra'\" [binding]=\"'zona'\" [width]=\"'140*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Costo'\" [binding]=\"'costo'\" [width]=\"'40*'\" [format]=\"'n2'\"></azteca-grid-column>\n                      </azteca-catalog-list>\n                  </tab>\n              </tabset>\n\n          </div>\n      </div>\n\n      <!--DIALOGO DE CONFIRMACION-->\n      <div bsModal #dlgConfirmacion=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\" id=\"exampleModalLabel\">Confirmaci&oacute;n</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"onCancelarConfirmacion()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <span>{{confirmacionText}}</span>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn\" (click)=\"onCancelarConfirmacion()\">\n                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-remove\"></span>\n                          Cancelar\n                      </button>\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAceptarConfimracion()\">\n                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-ok\"></span>\n                          Aceptar\n                      </button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute,
            articulo_service_1.ArticuloService, proveedor_service_1.ProveedorService, servicio_service_1.ServicioService, services_1.ZonaCompraService])
    ], ProveedorProductoComponent);
    return ProveedorProductoComponent;
}(core_2.BaseComponent));
exports.ProveedorProductoComponent = ProveedorProductoComponent;
