import { EventEmitter } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { FormBuilder, FormGroup } from '@angular/forms';
import { BaseComponent, Context, PolicyInfo } from 'framework3/core';
import { ToolbarButtonDirective, AlertsBarComponent } from 'framework3/controls';
import { ProveedorServicio } from '../models/proveedor';
import { ServicioService } from '../services/servicio.service';
import { ServicioInfo } from '../models/servicio';
import { ProveedorService } from '../services/proveedor.service';
import { DivisaInfo } from '../../accounting';
export declare class ProveedorServicioComponent extends BaseComponent {
    private context;
    private formBuilder;
    private route;
    private location;
    private proveedorSvc;
    private servicioSvc;
    form: FormGroup;
    proveedorServicio: ProveedorServicio;
    servicio: ServicioInfo;
    showTitle: boolean;
    editProveedor: boolean;
    editServicio: boolean;
    editZona: boolean;
    standAlone: boolean;
    idProveedorServicio: number;
    idProveedor: number;
    idServicio: number;
    idZona: number;
    savedCost: EventEmitter<ProveedorServicio>;
    cancelCost: EventEmitter<Boolean>;
    alerts: AlertsBarComponent;
    constructor(context: Context, formBuilder: FormBuilder, route: ActivatedRoute, location: Location, proveedorSvc: ProveedorService, servicioSvc: ServicioService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadInitialData(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
    mainToolbarHandler(button: ToolbarButtonDirective): void;
    onDivisaSelected(divisa: DivisaInfo): void;
}
