"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//
var proveedor_1 = require("../models/proveedor");
var servicio_service_1 = require("../services/servicio.service");
var servicio_1 = require("../models/servicio");
var proveedor_service_1 = require("../services/proveedor.service");
var ProveedorServicioComponent = /** @class */ (function (_super) {
    __extends(ProveedorServicioComponent, _super);
    //@ViewChild('ctrlArticuloImpuestos') ctrlArticuloImpuestos: ArticuloImpuestoComponent;
    function ProveedorServicioComponent(context, formBuilder, route, location, proveedorSvc, servicioSvc) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.route = route;
        _this.location = location;
        _this.proveedorSvc = proveedorSvc;
        _this.servicioSvc = servicioSvc;
        //
        _this.proveedorServicio = new proveedor_1.ProveedorServicio();
        _this.servicio = new servicio_1.ServicioInfo();
        //tiposUnidad: UnidadMedidaTipoItem[] = [];
        //unidadesMedida: UnidadMedidaItem[] = [];
        //
        _this.showTitle = true;
        _this.editProveedor = true;
        _this.editServicio = true;
        _this.editZona = true;
        _this.standAlone = true;
        //
        _this.idProveedorServicio = 0;
        _this.idProveedor = 0;
        _this.idServicio = 0;
        _this.idZona = 0;
        //
        _this.savedCost = new core_1.EventEmitter();
        _this.cancelCost = new core_1.EventEmitter();
        _this.form = formBuilder.group({
            'idProveedor': [''],
            'idZonaCompra': [''],
            'idServicio': [],
            'costo': [''],
            'diasCredito': [''],
            'diasEntrega': [''],
            'porcAnticipo': [''],
            'idDivisa': [''],
            'porcDescuento1': [''],
            'porcDescuento2': [''],
            'porcDescuento3': [''],
            'porcDescuento4': [''],
            'porcDescuento5': [''],
            'predeterminado': ['']
        });
        return _this;
    }
    ProveedorServicioComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idProveedorServicio = +param['id'];
            _this.idProveedor = +param['idProveedor'];
            _this.idServicio = +param['idServicio'];
            _this.idZona = +param['idZona'];
            _this.editProveedor = +param['editProveedor'] == 1;
            _this.editServicio = +param['editServicio'] == 1;
            _this.editZona = +param['editZona'] == 1;
        });
    };
    ProveedorServicioComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.loadInitialData(); });
    };
    ProveedorServicioComponent.prototype.loadInitialData = function () {
        var _this = this;
        //this.loadTiposUnidad();
        if (this.idProveedorServicio > 0) {
            this.context.app.showSpinner();
            this.proveedorSvc.getDetailProveedorServicio(this.idProveedorServicio)
                .then(function (result) {
                _this.context.app.hideSpinner();
                _this.proveedorServicio = result;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.proveedorServicio.idProveedor = this.idProveedor;
            this.proveedorServicio.idServicio = this.idServicio;
            this.proveedorServicio.idZonaCompra = this.idZona;
        }
    };
    ProveedorServicioComponent.prototype.applyPolicy = function (policy) {
    };
    ProveedorServicioComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    //loadTiposUnidad() {
    //    this.tipoUnidadService.loadList()
    //        .then(tipos => this.tiposUnidad = tipos)
    //        .catch(error => this.handleError(error));
    //}
    //onTipoUnidadChanged(idTipoUnidad) {
    //    this.loadUnidadesMedida(idTipoUnidad);
    //}
    //loadUnidadesMedida(idTipoUnidad: number) {
    //    this.unidadMedidaService.loadList(idTipoUnidad)
    //        .then(unidades => this.unidadesMedida = unidades)
    //        .catch(error => this.handleError(error));
    //}
    ProveedorServicioComponent.prototype.mainToolbarHandler = function (button) {
        var _this = this;
        if (button.name == "SAVE") {
            this.context.app.showSpinner();
            // Guardar impuestos
            //this.articulo.articulosImpuestos = this.ctrlArticuloImpuestos.getItems();
            //this.articuloSvc.updateArticuloImpuestos(this.articulo.articulosImpuestos)
            //    .then(resultImpuestos => {
            //        if (resultImpuestos) {
            //            // Guardar proveedor articulo
            if (this.proveedorServicio.porcAnticipo >= 0 && this.proveedorServicio.porcAnticipo <= 100) {
                this.proveedorSvc.updateProveedorServicio(this.proveedorServicio)
                    .then(function (result) {
                    _this.context.app.hideSpinner();
                    if (result) {
                        if (_this.standAlone)
                            _this.location.back();
                        else
                            _this.savedCost.emit(_this.proveedorServicio);
                    }
                })
                    .catch(function (error) {
                    console.log(error);
                    _this.context.app.hideSpinner();
                    _this.alerts.showAlert(error.error.message, 'danger');
                });
            }
            else
                this.handleError("El anticipo debe de ser entre 0 - 100");
            //            }
            //        })
            //        .catch(error => this.handleError(error));
        }
        else if (button.name == "CLOSE") {
            if (this.standAlone)
                this.location.back();
            else
                this.cancelCost.emit(true);
        }
    };
    ProveedorServicioComponent.prototype.onDivisaSelected = function (divisa) {
        this.proveedorServicio.idDivisa = divisa.identity;
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProveedorServicioComponent.prototype, "showTitle", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProveedorServicioComponent.prototype, "editProveedor", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProveedorServicioComponent.prototype, "editServicio", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProveedorServicioComponent.prototype, "editZona", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ProveedorServicioComponent.prototype, "standAlone", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ProveedorServicioComponent.prototype, "idProveedorServicio", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ProveedorServicioComponent.prototype, "idProveedor", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ProveedorServicioComponent.prototype, "idServicio", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ProveedorServicioComponent.prototype, "idZona", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ProveedorServicioComponent.prototype, "savedCost", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ProveedorServicioComponent.prototype, "cancelCost", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ProveedorServicioComponent.prototype, "alerts", void 0);
    ProveedorServicioComponent = __decorate([
        core_1.Component({
            selector: 'purchasing-proveedor-servicio',
            template: "\n      <form [formGroup]=\"form\">\n\n          <div class=\"row\">\n              <div class=\"col-12 col-lg-12\">\n                  <alerts-bar></alerts-bar>\n                  <az-panel *ngIf=\"showTitle\" header=\"Proveedor Servicio\">\n\n                      <az-toolbar (buttonClick)=\"mainToolbarHandler($event)\">\n                          <az-toolbar-button [name]=\"'SAVE'\" [type]=\"'primary'\" [text]=\"'Guardar Cambios'\" [icon]=\"'glyphicon glyphicon-floppy-disk'\"></az-toolbar-button>\n                          <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Cerrar'\" [icon]=\"'glyphicon glyphicon-remove'\"></az-toolbar-button>\n                      </az-toolbar>\n\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'Proveedor:'\">\n                                  <purchasing-proveedor-selector formControlName=\"idProveedor\"\n                                                                 [proveedorSelector]=\"editProveedor\"\n                                                                 [(ngModel)]=\"proveedorServicio.idProveedor\"></purchasing-proveedor-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'Zona de Compra:'\">\n                                  <purchasing-zona-compra-selector formControlName=\"idZonaCompra\"\n                                                                   [zonaCompraSelector]=\"editZona\"\n                                                                   [(ngModel)]=\"proveedorServicio.idZonaCompra\"></purchasing-zona-compra-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'Servicio:'\">\n                                  <purchasing-servicios-selector formControlName=\"idServicio\"\n                                                                [enabled]=\"editServicio\"                                                          \n                                                                [(ngModel)]=\"proveedorServicio.idServicio\"></purchasing-servicios-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'Costo:'\">\n                                  <az-input-number formControlName=\"costo\" [(ngModel)]=\"proveedorServicio.costo\" [format]=\"n4\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'D&iacute;as de Cr&eacute;dito:'\">\n                                  <az-input-number formControlName=\"diasCredito\" [(ngModel)]=\"proveedorServicio.diasCredito\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'D&iacute;as de Entrega:'\">\n                                  <az-input-number formControlName=\"diasEntrega\" [(ngModel)]=\"proveedorServicio.diasEntrega\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'Porcentaje de Anticipo:'\">\n                                  <az-input-number formControlName=\"porcAnticipo\" [(ngModel)]=\"proveedorServicio.porcAnticipo\" [min]=\"0\" [max]=\"100\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'Divisa:'\">\n                                  <accounting-divisas-selector formControlName=\"idDivisa\" [(ngModel)]=\"proveedorServicio.idDivisa\" (selectedItemChanged)=\"onDivisaSelected($event)\"></accounting-divisas-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-2\">\n                              <azteca-form-field [label]=\"'% Desc. 1:'\">\n                                  <az-input-number formControlName=\"porcDescuento1\" [(ngModel)]=\"proveedorServicio.porcDescuento1\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-2\">\n                              <azteca-form-field [label]=\"'% Desc. 2:'\">\n                                  <az-input-number formControlName=\"porcDescuento2\" [(ngModel)]=\"proveedorServicio.porcDescuento2\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-2\">\n                              <azteca-form-field [label]=\"'% Desc. 3:'\">\n                                  <az-input-number formControlName=\"porcDescuento3\" [(ngModel)]=\"proveedorServicio.porcDescuento3\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-2\">\n                              <azteca-form-field [label]=\"'% Desc. 4:'\">\n                                  <az-input-number formControlName=\"porcDescuento4\" [(ngModel)]=\"proveedorServicio.porcDescuento4\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-2\">\n                              <azteca-form-field [label]=\"'% Desc. 5:'\">\n                                  <az-input-number formControlName=\"porcDescuento5\" [(ngModel)]=\"proveedorServicio.porcDescuento5\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-6\">\n                              <az-checkbox [label]=\"'Predeterminado'\"\n                                           formControlName=\"predeterminado\"\n                                           [(ngModel)]=\"proveedorServicio.predeterminado\"></az-checkbox>\n                          </div>\n                      </div>\n\n                  </az-panel>\n              </div>\n\n          </div>\n\n      </form>\n\n      <!--DIALOGO DE CONFIRMACION-->\n      <div bsModal #dlgConfirmacion=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\" id=\"exampleModalLabel\">Confirmaci&oacute;n</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"onCancelarConfirmacion()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <span>{{confirmacionText}}</span>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn\" (click)=\"onCancelarConfirmacion()\">\n                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-remove\"></span>\n                          Cancelar\n                      </button>\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAceptarConfimracion()\">\n                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-ok\"></span>\n                          Aceptar\n                      </button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, router_1.ActivatedRoute, common_1.Location,
            proveedor_service_1.ProveedorService, servicio_service_1.ServicioService])
    ], ProveedorServicioComponent);
    return ProveedorServicioComponent;
}(core_2.BaseComponent));
exports.ProveedorServicioComponent = ProveedorServicioComponent;
