"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
//
var wijmo_grid_1 = require("wijmo/wijmo.grid");
var wijmo = require("wijmo/wijmo");
var wijmo_1 = require("wijmo/wijmo");
var ngx_bootstrap_1 = require("ngx-bootstrap");
//
var controls_1 = require("framework3/controls");
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
var proveedor_service_1 = require("../services/proveedor.service");
var proveedor_1 = require("../models/proveedor");
//
var proveedor_servicio_component_1 = require("../components/proveedor-servicio.component");
//
var ProveedoresServicioListComponent = /** @class */ (function (_super) {
    __extends(ProveedoresServicioListComponent, _super);
    function ProveedoresServicioListComponent(context, proveedorService) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.proveedorService = proveedorService;
        _this.currentItem = null;
        _this.selectedItem = new core_1.EventEmitter();
        _this.collectionView = new wijmo_1.CollectionView();
        return _this;
    }
    ProveedoresServicioListComponent.prototype.applyPolicy = function () {
    };
    ProveedoresServicioListComponent.prototype.ngAfterViewInit = function () {
        // this.setFilterType();
        this.currentItem = new proveedor_1.ProveedorServicioItem();
        this.triggerSearch();
    };
    //private setFilterType() {
    //    if (this._serverSide) {
    //        this.filter.defaultFilterType = FilterType.Condition;
    //        this._currentFilter = this.filter.filterDefinition;
    //    }
    //    else {
    //        this.filter.defaultFilterType = FilterType.Both;
    //        this._currentFilter = this._emptyFilter;
    //    }
    //    this.setDefaultFilterOperator();
    //}
    ProveedoresServicioListComponent.prototype.initializeGrid = function (sender) {
        var _this = this;
        var self = this;
        //Manejo de doble click
        sender.addEventListener(sender.hostElement, "dblclick", function (e) {
            var ht = sender.hitTest(e);
            if (ht.cellType == wijmo_grid_1.CellType.Cell) {
                _this.selectedItem.emit(_this.currentItem);
            }
        });
        this.collectionView.currentChanged.addHandler(function (args) {
            _this.currentItem = self.collectionView.currentItem;
        }, self);
        //Establecer el operador "comienza con" para todas cadenas
        //this.setDefaultFilterOperator();
        //        
    };
    ProveedoresServicioListComponent.prototype.onSearchRequested = function (request) {
        var _this = this;
        if (this.idServicio != 0 && this.idServicio != undefined) {
            this.proveedorService.searchProveedorByServicio(this.idServicio, this.context.app.defaultSite.identity, request)
                .then(function (result) {
                _this.collectionView.sourceCollection = result.rows;
                //this.totalRows = result.totalRows;
                //this.pageIndex = request.pageIndex;
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    ProveedoresServicioListComponent.prototype.triggerSearch = function () {
        var request = new search_1.SearchRequest();
        request.pageIndex = 0;
        request.pageSize = 20; //this.pageSize;
        request.paged = false; //this.serverSide ? true : false;
        //
        this.onSearchRequested(request); //this.searchRequested.emit(request);
    };
    //onSelectedItemsChanged(selectedItems: any[]) {
    //    this.selectedItemsChanged.emit(selectedItems);
    //}
    //onSelectedItemChanged(item: any) {
    //    this.selectedItemChanged.emit(item);
    //}
    //setDefaultFilterOperator() {
    //    for (let i: number = 0; i < this.grid.columns.length; i++) {
    //        let col: Column = this.grid.columns[i];
    //        let colFilter: ColumnFilter = this.filter.getColumnFilter(col);
    //        if (colFilter != null) {
    //            if (col.dataType == undefined || col.dataType == DataType.String) {
    //                colFilter.conditionFilter.condition1.operator = Operator.BW;
    //            }
    //        }
    //    }
    //}
    ProveedoresServicioListComponent.prototype.show = function () {
        this.currentItem = null;
        this.listDialog.config.backdrop = false;
        this.triggerSearch();
        this.listDialog.show();
    };
    ProveedoresServicioListComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    ProveedoresServicioListComponent.prototype.isValid = function () {
        return this.selectedItem != null;
    };
    ProveedoresServicioListComponent.prototype.onChangeCost = function (proveedor) {
        this.costoDialog.config.backdrop = false;
        this.proveedorCostoComponent.idServicio = this.idServicio;
        this.proveedorCostoComponent.idProveedor = this.currentItem.idProveedor;
        this.proveedorCostoComponent.idProveedorServicio = this.currentItem.idProveedorServicio;
        this.proveedorCostoComponent.standAlone = false;
        this.proveedorCostoComponent.loadInitialData();
        this.costoDialog.show();
    };
    ProveedoresServicioListComponent.prototype.onSavedCost = function (item) {
        this.currentItem = item;
        this.selectedItem.emit(this.currentItem);
        this.costoDialog.hide();
        this.listDialog.hide();
        this.grid.refresh();
    };
    ProveedoresServicioListComponent.prototype.onCancelCost = function (item) {
        this.costoDialog.hide();
    };
    ProveedoresServicioListComponent.prototype.onConfirmClick = function () {
        this.selectedItem.emit(this.currentItem);
        this.listDialog.hide();
    };
    ProveedoresServicioListComponent.prototype.onCancelClick = function () {
        this.listDialog.hide();
    };
    ProveedoresServicioListComponent.prototype.refreshControls = function () {
        wijmo.Control.invalidateAll();
    };
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ProveedoresServicioListComponent.prototype, "selectedItem", void 0);
    __decorate([
        core_1.ViewChild('listDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ProveedoresServicioListComponent.prototype, "listDialog", void 0);
    __decorate([
        core_1.ViewChild('grid'),
        __metadata("design:type", wijmo_grid_1.FlexGrid)
    ], ProveedoresServicioListComponent.prototype, "grid", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ProveedoresServicioListComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('cambioPrecioDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ProveedoresServicioListComponent.prototype, "costoDialog", void 0);
    __decorate([
        core_1.ViewChild('proveedorCostoComponent'),
        __metadata("design:type", proveedor_servicio_component_1.ProveedorServicioComponent)
    ], ProveedoresServicioListComponent.prototype, "proveedorCostoComponent", void 0);
    ProveedoresServicioListComponent = __decorate([
        core_1.Component({
            selector: 'purchasing-proveedores-servicio-list',
            template: "\n      <div bsModal #listDialog=\"bs-modal\" (onShown)=\"refreshControls()\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n\n          <alerts-bar></alerts-bar>\n\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">Proveedores del servicio</div>\n                  <div class=\"modal-body\">\n\n                      <!--(sortedColumn)=\"sortChanged(grid, $event)\"\n                          [isReadOnly]=\"true\"\n                          -->\n\n                      <wj-flex-grid #grid\n                                    [itemsSource]=\"collectionView\"\n                                    (initialized)=\"initializeGrid(grid)\"\n                                    [selectionMode]=\"'Row'\">\n\n                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                          <wj-flex-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"130\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'40*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Telefono'\" [binding]=\"'telefono'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Costo Unitario'\" [binding]=\"'costo'\" [width]=\"'10*'\" [isReadOnly]=\"true\" [format]=\"'n2'\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"$\" [width]=\"45\">\n                              <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-item=\"item\" let-cell=\"cell\">\n                                  <button type=\"button\" class=\"glyphicon glyphicon-usd\" (click)=\"onChangeCost(item)\" [disabled]=\"false\"></button>\n                              </ng-template>\n                          </wj-flex-grid-column>\n\n                      </wj-flex-grid>\n\n                  </div> <!-- Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onConfirmClick()\" [disabled]=\"!isValid()\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"onCancelClick()\">Cancelar</button>\n                  </div> <!-- Modal Footer-->\n\n              </div> <!--Modal Content-->\n          </div> <!-- Modal-->\n      </div> <!-- Modal Directive-->\n      <!--Cambio de precio-->\n      <div bsModal #cambioPrecioDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myEgresoModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n\n              <div class=\"modal-content\">\n\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\">Establezca el nuevo costo del servicio:</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n\n                  <div class=\"modal-body\">\n                      <alerts-bar></alerts-bar>\n\n                      <purchasing-proveedor-servicio #proveedorCostoComponent\n                                                     (savedCost)=\"onSavedCost($event)\"\n                                                     (cancelCost)=\"onCancelCost($event)\">\n                      </purchasing-proveedor-servicio>\n\n                  </div>\n              </div>\n              <!--</div>-->\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, proveedor_service_1.ProveedorService])
    ], ProveedoresServicioListComponent);
    return ProveedoresServicioListComponent;
}(core_2.BaseComponent));
exports.ProveedoresServicioListComponent = ProveedoresServicioListComponent;
