"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
//
//import { Context, SucursalItem, SucursalService } from '../../../core';
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
var services_1 = require("../services");
//
var RecepcionesListComponent = /** @class */ (function (_super) {
    __extends(RecepcionesListComponent, _super);
    function RecepcionesListComponent(context, recepcionService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.recepcionService = recepcionService;
        _this.idWorkflowStep = 0;
        _this.idBeneficiario = 0;
        _this.idDivisa = 0;
        _this.idProveedor = 0;
        return _this;
    }
    RecepcionesListComponent.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        ////agregar filtro de empresa
        //let condEmpresa: SearchCondition = { field: 'idSucursal', operator: '=', valueType: 'int', value: this.context.app.defaultSite.identity.toString() };
        //request.conditions.push(condEmpresa);
        //Si se especificó status, agregar filtro
        if (this.idWorkflowStep && this.idWorkflowStep != 0) {
            var condition = { field: 'IdWorkflowStep', operator: '=', valueType: 'int', value: this.idWorkflowStep };
            request.conditions.push(condition);
        }
        //Si se especificó Beneficiario, agregar filtro
        if (this.idBeneficiario != 0) {
            var condition = { field: 'IdBeneficiario', operator: '=', valueType: 'int', value: this.idBeneficiario };
            request.conditions.push(condition);
        }
        //Si se especificó divisa, agregar filtro
        if (this.idDivisa != 0) {
            var condition = { field: 'IdDivisa', operator: '=', valueType: 'int', value: this.idDivisa };
            request.conditions.push(condition);
        }
        //Si se especificó Beneficiario, agregar filtro
        if (this.idProveedor != 0) {
            var condition = { field: 'IdProveedor', operator: '=', valueType: 'int', value: this.idBeneficiario };
            request.conditions.push(condition);
        }
        this.recepcionService.search(this.context.app.defaultSite.identity, request)
            .then(function (result) {
            _this.recepciones = result.rows;
            //this.totalRows = result.totalRows; se habilita cuando se agregue el extends a DocumentListDialog
            _this.pageIndex = request.pageIndex;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesListComponent.prototype.onSelectedItemsChanged = function (selecteItems) {
        var _this = this;
        var elements = [];
        selecteItems.forEach(function (item) {
            _this.recepciones.forEach(function (itemCuentaPorPagar) {
                if (itemCuentaPorPagar.id == item.id) {
                    elements.push(itemCuentaPorPagar);
                }
            });
        });
        this.selectedItemsChanged.emit(elements);
    };
    RecepcionesListComponent.prototype.onSelectedItemChanged = function (item) {
        var _this = this;
        if (item != null) {
            this.recepciones.forEach(function (itemCuentaPorPagar) {
                if (itemCuentaPorPagar.id == item.id) {
                    _this.selectedItemChanged.emit(itemCuentaPorPagar);
                }
            });
        }
    };
    //se borra cuando se agregue el extends a DocumentListDialog
    RecepcionesListComponent.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], RecepcionesListComponent.prototype, "idWorkflowStep", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], RecepcionesListComponent.prototype, "idBeneficiario", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], RecepcionesListComponent.prototype, "idDivisa", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], RecepcionesListComponent.prototype, "idProveedor", void 0);
    RecepcionesListComponent = __decorate([
        core_1.Component({
            selector: 'purchasing-recepciones-list',
            template: "\n      <document-list-dialog (searchRequested)=\"onSearchRequested($event)\"\n                            (selectedItemsChanged)=\"onSelectedItemsChanged($event)\"\n                            (selectedItemChanged)=\"onSelectedItemChanged($event)\"\n                            [documentList]=\"recepciones\"\n                            [excludedItems]=\"excludedItems\"\n                            [multiSelect]=\"multiSelect\"\n                            [serverSide]=\"serverSide\"\n                            [pageSize]=\"pageSize\"\n                            [pageIndex]=\"pageIndex\"\n                            [startPeriod]=\"startPeriod\"\n                            [title]=\"'Recepciones'\">\n          <!--[totalRows]=\"totalRows\"-->\n\n          <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"150\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"130\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Central'\" [binding]=\"'central'\" [width]=\"'20*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Centro de Recepcion'\" [binding]=\"'centroRecepcion'\" [width]=\"250\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Proveedor'\" [binding]=\"'proveedor'\" [width]=\"250\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"150\" format=\"c\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"'20*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"'20*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"'20*'\"></azteca-grid-column>\n\n\n      </document-list-dialog> \n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, services_1.RecepcionService])
    ], RecepcionesListComponent);
    return RecepcionesListComponent;
}(search_1.DocumentListDialog));
exports.RecepcionesListComponent = RecepcionesListComponent;
