import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { AdelantoInfo } from '../models/adelanto';
import { AdelantoDetail } from '../models/adelanto-detail';
import { AdelantoService } from '../services/adelanto.service';
import { AdelantoDetailEditor } from './parts/adelantos-detail.editor';
import { OrdenService } from '../services/orden.service';
import { OrdenInfo } from '../models/orden';
import { OrdenDetail } from '../models/orden-detail';
import { ImportesInfo } from '../../accounting/models/importes';
export declare class AdelantosEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private adelantoService;
    private ordenService;
    adelanto: AdelantoInfo;
    orden: OrdenInfo;
    detailsList: EditableListComponent;
    detailsEditor: AdelantoDetailEditor;
    readonly proveedorText: string;
    readonly importes: ImportesInfo;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, adelantoService: AdelantoService, ordenService: OrdenService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onCancelingEdit(): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: AdelantoDetail): void;
    onDeletingDetail(detail: AdelantoDetail): void;
    onListItemsUpdated(updatedDetails: AdelantoDetail[]): void;
    onSavingDetail(detail: AdelantoDetail): void;
    cargarInfomacionEntidades(): void;
    importesDesglosados(): ImportesInfo;
    combineDetail(): OrdenDetail[];
}
