"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var adelanto_1 = require("../models/adelanto");
var adelanto_detail_1 = require("../models/adelanto-detail");
var adelanto_service_1 = require("../services/adelanto.service");
var adelantos_detail_editor_1 = require("./parts/adelantos-detail.editor");
var orden_service_1 = require("../services/orden.service");
var orden_1 = require("../models/orden");
var importes_1 = require("../../accounting/models/importes");
var AdelantosEditor = /** @class */ (function (_super) {
    __extends(AdelantosEditor, _super);
    function AdelantosEditor(context, router, route, location, formBuilder, documentTypeService, adelantoService, ordenService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.adelantoService = adelantoService;
        _this.ordenService = ordenService;
        _this.adelanto = new adelanto_1.AdelantoInfo();
        _this.orden = new orden_1.OrdenInfo();
        _this.documentForm = formBuilder.group({
            'porcentaje': [0, forms_1.Validators.required],
        });
        return _this;
    }
    AdelantosEditor_1 = AdelantosEditor;
    Object.defineProperty(AdelantosEditor.prototype, "proveedorText", {
        get: function () {
            return this.orden.proveedor.code + '-' + this.orden.proveedor.nombre;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AdelantosEditor.prototype, "importes", {
        get: function () {
            var importesTMP = this.importesDesglosados();
            return importesTMP;
        },
        enumerable: true,
        configurable: true
    });
    AdelantosEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
    };
    AdelantosEditor.prototype.onCreatingDocument = function () {
        var _this = this;
        //Cargar parámetros que se proporcionan cuando es un nuevo documento
        this.route.params.forEach(function (params) {
            _this.adelanto.idOrden = params['idOrden'];
        });
        setTimeout(function (_) { return _this.cargarInfomacionEntidades(); });
    };
    AdelantosEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.adelantoService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.adelanto = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AdelantosEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.adelantoService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.adelanto = doc;
            _this.detailsEditor.clientIndexStart = _this.adelanto.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AdelantosEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.adelantoService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.adelanto = doc;
            _this.cargarInfomacionEntidades();
            _this.detailsEditor.clientIndexStart = _this.adelanto.details.length;
            if (_this.adelanto.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AdelantosEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.adelantoService.update(this.adelanto)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.adelanto.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.location.back();
                //this.router.navigate(['../'], { relativeTo: this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.adelanto = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AdelantosEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.adelantoService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AdelantosEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.adelantoService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AdelantosEditor.prototype.onCancelingEdit = function () {
        this.location.back();
    };
    AdelantosEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.adelanto.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    AdelantosEditor.prototype.onAddingDetail = function () {
        this.detailsEditor.detail = new adelanto_detail_1.AdelantoDetail();
        this.detailsEditor.show();
    };
    AdelantosEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    AdelantosEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    AdelantosEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.adelanto.details = updatedDetails;
    };
    AdelantosEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    ///////////////////////////////////metodos generados
    AdelantosEditor.prototype.cargarInfomacionEntidades = function () {
        var _this = this;
        this.ordenService.getDetail(this.adelanto.idOrden)
            .then(function (orden) {
            _this.orden = orden;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AdelantosEditor.prototype.importesDesglosados = function () {
        var desglose = new importes_1.ImportesInfo();
        var elementos = this.combineDetail().filter(function (item) { return item.state != 'DELETED'; });
        elementos.forEach(function (item) {
            desglose.subtotal += item.costoUnitario * item.cantidad;
            desglose.descuentos += (item.descuentos.descuento1 + item.descuentos.descuento2 + item.descuentos.descuento3 + item.descuentos.descuento4 + item.descuentos.descuento5) * item.cantidad;
            if (item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "T"; }).length > 0)
                desglose.impuestosTrasladados += item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "T"; }).map(function (imp) { return imp.importe * item.cantidad; }).reduce(function (a, b) { return a + b; });
            if (item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "R"; }).length > 0)
                desglose.impuestosRetenidos += item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "R"; }).map(function (imp) { return imp.importe * item.cantidad; }).reduce(function (a, b) { return a + b; });
        });
        desglose.total = desglose.subtotal - desglose.descuentos + desglose.impuestosTrasladados - desglose.impuestosRetenidos;
        //this.totalOC = desglose.total;
        //this.visualValidacion();
        return desglose;
    };
    AdelantosEditor.prototype.combineDetail = function () {
        var articulos = this.orden.details.map(function (d) { return d; }).filter(function (d) { return d.idArticulo && d.idArticulo > 0; });
        var servicios = this.orden.details.map(function (d) { return d; }).filter(function (d) { return d.idServicio && d.idServicio > 0; });
        var defaultDate = new Date(1901, 1, 1);
        var newDetail = [];
        servicios.forEach(function (s) { return newDetail.push(s); });
        articulos.forEach(function (a) { return newDetail.push(a); });
        return newDetail;
    };
    var AdelantosEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], AdelantosEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", adelantos_detail_editor_1.AdelantoDetailEditor)
    ], AdelantosEditor.prototype, "detailsEditor", void 0);
    AdelantosEditor = AdelantosEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-adelantos-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'Adelantos'\"\n                                         [document]=\"adelanto\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-7\">\n                                      <label class=\"control-label\">Proveedor:</label>\n                                      <az-label [text]=\"proveedorText\"></az-label>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <accounting-importes-component [importes]=\"importes\" [titulo]=\"'Totales de la orden'\"></accounting-importes-component>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-4\">\n                                      <azteca-form-field [label]=\"'% Anticipo:'\">\n                                          <az-input-number formControlName=\"porcentaje\" [(ngModel)]=\"adelanto.porcentaje\" [min]=\"0\" [max]=\"100\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                          </tab>\n                          <!--<tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list   #detailsList\n                                                      (addingItem)=\"onAddingDetail()\"\n                                                      (editingItem)=\"onEditingDetail($event)\"\n                                                      (deletingItem)=\"onDeletingDetail($event)\"\n                                                      (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                      [listItems]=\"adelanto.details\">-->\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <!--<azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>-->\n\n                                  <!-- COLUMNAS DEL GRID-->\n      \t\t\t\t\t\t\t<!-- Columnas de Ejemplo\n                                  <azteca-grid-column [header]=\"'Art\u00EDculo'\" [binding]=\"'articulo'\" [width]=\"'30*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'U.M.'\" [binding]=\"'unidad'\" [width]=\"'10*'\" [isReadOnly]=\"false\"></azteca-grid-column>                            \n      \t\t\t\t\t\t\t-->\n\n                              <!--</azteca-editable-list>\n                          </tab>-->\n\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"adelanto.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <compras-adelanto-detail-editor #detailsEditor                                     \n                                           (savingItem)=\"onSavingDetail($event)\">\n\n      </compras-adelanto-detail-editor>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return AdelantosEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: adelanto_service_1.AdelantoService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            adelanto_service_1.AdelantoService,
            orden_service_1.OrdenService])
    ], AdelantosEditor);
    return AdelantosEditor;
}(editors_1.DocumentEditor));
exports.AdelantosEditor = AdelantosEditor;
