import { Router, ActivatedRoute } from '@angular/router';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, DocumentItem } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { AdelantoItem } from '../models/adelanto';
import { AdelantoService } from '../services/adelanto.service';
import { OrdenService } from '../services/orden.service';
import { OrdenesListComponent } from '../dialogs/ordenes-list.component';
import { OrdenItem } from '../models/orden';
export declare class AdelantosManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private adelantoService;
    private ordenService;
    adelantos: AdelantoItem[];
    idProveedor: number;
    ordenesList: OrdenesListComponent;
    proveedorDialog: ModalDirective;
    constructor(context: Context, router: Router, route: ActivatedRoute, adelantoService: AdelantoService, ordenService: OrdenService);
    onConfigureDocument(): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onProveedorSelected(): void;
    onOrdenSelected(orden: OrdenItem): void;
    cerrarProveedor(): void;
}
