"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var adelanto_service_1 = require("../services/adelanto.service");
var orden_service_1 = require("../services/orden.service");
var ordenes_list_component_1 = require("../dialogs/ordenes-list.component");
var AdelantosManager = /** @class */ (function (_super) {
    __extends(AdelantosManager, _super);
    function AdelantosManager(context, router, route, adelantoService, ordenService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.adelantoService = adelantoService;
        _this.ordenService = ordenService;
        _this.idProveedor = 0;
        return _this;
    }
    AdelantosManager_1 = AdelantosManager;
    AdelantosManager.prototype.onConfigureDocument = function () {
        this.refreshList();
        this.applyPolicies();
    };
    AdelantosManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.adelantoService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.adelantos = response.rows;
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AdelantosManager.prototype.onAddingItem = function () {
        this.idProveedor = 0;
        this.proveedorDialog.config.backdrop = false;
        this.proveedorDialog.show();
        //this.router.navigate(['0'], { relativeTo: this.route });
    };
    AdelantosManager.prototype.onViewingItem = function (document) {
        this.router.navigate([document.id, { readonly: true }], { relativeTo: this.route });
    };
    AdelantosManager.prototype.onEditingItem = function (document) {
        //this.router.navigate([document.id], { relativeTo: this.route });
        this.router.navigate([document.id, '0'], { relativeTo: this.route });
    };
    AdelantosManager.prototype.onDeletingItem = function (document) {
        var _this = this;
        this.adelantoService.delete(document.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El documento ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AdelantosManager.prototype.onCloningItem = function (document) {
        this.router.navigate([0, { cloneId: document.id }], { relativeTo: this.route });
    };
    AdelantosManager.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.adelantoService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AdelantosManager.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.adelantoService.previousStep(document.id, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    /////////////////////////////
    AdelantosManager.prototype.onProveedorSelected = function () {
        this.proveedorDialog.hide();
        //
        //this.ordenesList.config.backdrop = false;
        this.ordenesList.show();
    };
    AdelantosManager.prototype.onOrdenSelected = function (orden) {
        //let item = this.manager.documentList.find(item => item.id == ingreso.id);
        //this.ingresosDialog.hide();
        var _this = this;
        //let OrdenFull = <OrdenItem>this.manager.documentList.find(item => item.id == orden.id)
        this.ordenService.getDetail(orden.id)
            .then(function (ordenFull) {
            if (ordenFull.idAnticipo && ordenFull.idAnticipo.trim() != '')
                _this.showAlert('La orden seleccionada ya tiene relacionado un adelanto previo con folio[' + ordenFull.idAnticipo + '].', 'warning');
            else
                _this.router.navigate(['0', orden.id], { relativeTo: _this.route });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AdelantosManager.prototype.cerrarProveedor = function () {
        this.proveedorDialog.hide();
    };
    var AdelantosManager_1;
    __decorate([
        core_1.ViewChild('ordenesList'),
        __metadata("design:type", ordenes_list_component_1.OrdenesListComponent)
    ], AdelantosManager.prototype, "ordenesList", void 0);
    __decorate([
        core_1.ViewChild('proveedorDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], AdelantosManager.prototype, "proveedorDialog", void 0);
    AdelantosManager = AdelantosManager_1 = __decorate([
        core_1.Component({
            selector: 'compras-adelantos-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Adelantos</div>\n          <div class=\"card-block\">\n              <azteca-document-manager (searchRequested)=\"onSearchRequested($event)\"\n                                       (addingItem)=\"onAddingItem()\"\n                                       (viewingItem)=\"onViewingItem($event)\"\n                                       (editingItem)=\"onEditingItem($event)\"\n                                       (deletingItem)=\"onDeletingItem($event)\"\n                                       (cloningItem)=\"onCloningItem($event)\"\n                                       (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                       (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                       (configureDocument)=\"onConfigureDocument($event)\"\n                                       [enabled]=\"enabled\"\n                                       [allowNew]=\"allowNew\"\n                                       [allowView]=\"allowView\"\n                                       [allowEdit]=\"allowEdit\"\n                                       [allowDelete]=\"allowDelete\"\n                                       [allowClone]=\"allowClone\"\n                                       [allowNext]=\"allowNext\"\n                                       [allowPrevious]=\"allowPrevious\"\n                                       [allowAudit]=\"allowAudit\"\n                                       [filterGroups]=\"filterGroups\"\n                                       [documentList]=\"adelantos\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"180\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"170\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Proveedor'\" [binding]=\"'proveedor'\" [width]=\"250\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Orden'\" [binding]=\"'idOrden'\" [width]=\"170\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Porcentaje'\" [binding]=\"'porcentaje'\" [width]=\"'5*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Monto'\" [binding]=\"'monto'\" [width]=\"'10*'\"></azteca-grid-column>            \n                  <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"'10*'\"></azteca-grid-column>\n\n              </azteca-document-manager>\n          </div>\n      </div>\n\n\n      <div bsModal #proveedorDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myEgresoModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n\n              <div class=\"modal-content\">\n\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\">Selecci\u00F3ne al proveedor</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"cerrarProveedor()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n\n                  <div class=\"row\">\n                      <div class=\"col-12 col-md-10\">\n                          <purchasing-proveedor-selector [(ngModel)]=\"idProveedor\"\n                                                         (selectedItemChanged)=\"onProveedorChanged($event)\"\n                                                         [showListButton]=\"false\">\n                          </purchasing-proveedor-selector>\n                      </div>\n                  </div>\n\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onProveedorSelected()\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\" (click)=\"cerrarProveedor()\">Cerrar</button>\n                  </div>\n              </div>\n              <!--</div>-->\n          </div>\n\n      </div>\n\n      <purchasing-ordenes-list #ordenesList (selectedItemChanged)=\"onOrdenSelected($event)\"\n                               [idWorkflowStep]=\"1\"\n                               [idProveedor]=\"idProveedor\"\n                               [idCentroRecepcion]=\"idCentroRecepcion\"\n                               [saldoPendiente]=\"true\"\n                               [startPeriod]=\"15\">\n      </purchasing-ordenes-list>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return AdelantosManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: adelanto_service_1.AdelantoService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, adelanto_service_1.AdelantoService, orden_service_1.OrdenService])
    ], AdelantosManager);
    return AdelantosManager;
}(editors_1.DocumentManager));
exports.AdelantosManager = AdelantosManager;
