"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var moment = require("moment");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var search_1 = require("framework3/search");
//Locales
var accounting_1 = require("../../accounting");
var comprobante_fiscal_service_1 = require("../services/comprobante-fiscal.service");
var comprobante_fiscal_1 = require("../models/comprobante-fiscal");
var AlmacenDigitalComponent = /** @class */ (function (_super) {
    __extends(AlmacenDigitalComponent, _super);
    function AlmacenDigitalComponent(context, router, route, formBuilder, comprobanteService, comprobanteBaseService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.comprobanteService = comprobanteService;
        _this.comprobanteBaseService = comprobanteBaseService;
        _this.menuItems = [];
        _this.fechaInicial = new Date();
        _this.fechaFinal = new Date();
        _this.pageSize = 20;
        _this.maxRows = 3000;
        _this.totalRows = 0;
        _this.comprobantes = [];
        _this.filterGroups = [];
        _this.currentComprobante = new comprobante_fiscal_1.ComprobanteFiscalInfo();
        //Crear formulario de parámetros
        _this.form = formBuilder.group({
            'fechaInicial': [new Date()],
            'fechaFinal': [new Date()]
        });
        return _this;
    }
    AlmacenDigitalComponent.prototype.ngOnInit = function () {
        this.createMenu();
    };
    AlmacenDigitalComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.fechaInicial = moment().subtract(7, 'day').toDate();
        this.fechaFinal = moment().add(1, 'day').toDate();
        setTimeout(function (_) { return _this.refreshList(); });
    };
    /////////////////////// METODOS ////////////////////////////////////
    AlmacenDigitalComponent.prototype.refreshList = function () {
        var _this = this;
        this.context.app.showSpinner();
        //Disparar búsqueda inicial. Si el manejo se realiza del lado del servidor, obtener sólo la primer página, si es local obtener toda la información disponible
        var request = new search_1.SearchRequest();
        request.pageIndex = 0;
        request.pageSize = this.pageSize;
        request.paged = false;
        request.maxRows = this.maxRows;
        //Agregar condiciones de fecha
        var condicionFechaIni = { field: 'fechaComprobante', operator: '>=', valueType: search_1.ConditionValueType.DATE_TIME, value: moment(this.fechaInicial).format() };
        var condicionFechaFin = { field: 'fechaComprobante', operator: '<=', valueType: search_1.ConditionValueType.DATE_TIME, value: moment(this.fechaFinal).format() };
        request.conditions.push(condicionFechaIni, condicionFechaFin);
        this.comprobanteService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.comprobantes = response.rows;
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AlmacenDigitalComponent.prototype.createMenu = function () {
        //Agregar opciones estándar del catálogo
        var mnuView = { icon: "glyphicon glyphicon-folder-open", text: "Ver", name: "OPEN", smallText: "ver resumen del comprobante" };
        var mnuPdf = { icon: "glyphicon glyphicon-download-alt", text: "Imprimir", name: "PDF", smallText: "generar PDF del comprobante" };
        var mnuXml = { icon: "glyphicon glyphicon-download-alt", text: "Descargar XML", name: "XML", smallText: "descargar en formato XML" };
        var mnuExport = { icon: "glyphicon glyphicon-export", text: "Exportar", name: "EXPORT", smallText: "exportar XML a sistema externo" };
        this.menuItems.push(mnuView, mnuPdf, /*mnuXml,*/ mnuExport);
        this.menuItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    AlmacenDigitalComponent.prototype.viewComprobante = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteService.getDetail(this.documentList.currentDocument.id)
            .then(function (comprobante) {
            _this.currentComprobante = comprobante;
            _this.context.app.hideSpinner();
            _this.viewDialog.config.backdrop = false;
            _this.viewDialog.show();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AlmacenDigitalComponent.prototype.exportXml = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteService.export(this.documentList.currentDocument.id)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alertsBar.showAlert('El comprobante ha sido exportado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    /////////////////////// HANDLERS //////////////////////////////////
    AlmacenDigitalComponent.prototype.onMainToolbar = function (button) {
        if (button.name == 'ADD') {
            this.router.navigate(['./upload'], { relativeTo: this.route });
        }
    };
    AlmacenDigitalComponent.prototype.optionClick = function (option) {
        var _this = this;
        if (option.name == 'OPEN') {
            this.viewComprobante();
        }
        if (option.name == 'PDF') {
            this.context.app.showSpinner();
            this.comprobanteService.getDetail(this.documentList.currentDocument.id)
                .then(function (comprobante) {
                _this.comprobanteBaseService.generarPdfTemporal(comprobante.comprobanteBase.identity)
                    .then(function (file) {
                    _this.context.app.hideSpinner();
                    window.open('/file-server/' + file.uri, '_blank');
                })
                    .catch(function (error) { return _this.handleError(error); });
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        if (option.name == 'XML') {
        }
        if (option.name == 'EXPORT') {
            this.exportXml();
        }
    };
    AlmacenDigitalComponent.prototype.onValidateMenu = function () {
    };
    AlmacenDigitalComponent.prototype.currentItemChangedHandler = function () {
    };
    AlmacenDigitalComponent.prototype.handleError = function (error) {
        console.log(error);
        var message = this.context.getExceptionMessage(error);
        this.alertsBar.showAlert(message, 'error');
        this.context.app.hideSpinner();
    };
    //Implementacion de politicas
    AlmacenDigitalComponent.prototype.applyPolicy = function (policy) {
    };
    __decorate([
        core_1.ViewChild(controls_1.DownloadPopupComponent),
        __metadata("design:type", controls_1.DownloadPopupComponent)
    ], AlmacenDigitalComponent.prototype, "downloadPopup", void 0);
    __decorate([
        core_1.ViewChild('viewDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], AlmacenDigitalComponent.prototype, "viewDialog", void 0);
    __decorate([
        core_1.ViewChild(search_1.DocumentListComponent),
        __metadata("design:type", search_1.DocumentListComponent)
    ], AlmacenDigitalComponent.prototype, "documentList", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], AlmacenDigitalComponent.prototype, "alertsBar", void 0);
    AlmacenDigitalComponent = __decorate([
        core_1.Component({
            selector: 'purchasing-almacen-digital',
            template: "\n      <alerts-bar></alerts-bar>\n      <!--PANEL DE PERIODO Y RESUMEN DE ESTATUS-->\n      <div class=\"row\">\n          <div class=\"col-12 col-lg-3\">\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <az-panel [header]=\"'Per\u00EDodo'\">\n                          <form [formGroup]=\"form\">\n                              <azteca-form-field [label]=\"'Fecha inicial:'\">\n                                  <az-input-date formControlName=\"fechaInicial\" [(ngModel)]=\"fechaInicial\"></az-input-date>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Fecha final:'\">\n                                  <az-input-date formControlName=\"fechaFinal\" [(ngModel)]=\"fechaFinal\"></az-input-date>\n                              </azteca-form-field>\n\n                              <br />\n                              <button type=\"button\" class=\"btn btn-primary\" (click)=\"refreshList()\"><span class=\"glyphicon glyphicon-refresh\"></span> Consultar</button>\n                          </form>\n                      </az-panel>\n                  </div> <!-- COL-->\n              </div> <!--ROW PANEL-->\n          </div> <!--COL PANEL-->\n          <div class=\"col-12 col-lg-9\">\n              <az-toolbar (buttonClick)=\"onMainToolbar($event)\" (menuItemClick)=\"optionClick($event)\">\n                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Subir'\" [icon]=\"'glyphicon glyphicon-plus'\" [title]=\"'Subir nuevo archivo'\"></az-toolbar-button>\n                  <az-toolbar-menu [name]=\"'OPTIONS'\" [header]=\"'Opciones'\" [menuItems]=\"menuItems\"></az-toolbar-menu>\n              </az-toolbar>\n\n\n\n              <azteca-document-list [documentList]=\"comprobantes\"\n                                    [filterGroup]=\"selectedGroup\"\n                                    (currentItemChanged)=\"currentItemChangedHandler($event)\"\n                                    (contextMenuClick)=\"optionClick($event)\"\n                                    (contextMenuOpen)=\"onValidateMenu($event)\"\n                                    [enabled]=\"true\"\n                                    [pageSize]=\"pageSize\">\n\n\n                  <!-- Mapear opciones de men\u00FA de componente padre-->\n                  <azteca-menu-item *ngFor=\"let item of menuItems\" [name]=\"item.name\" [icon]=\"item.icon\" [text]=\"item.text\" [smallText]=\"item.smallText\" [enabled]=\"item.enabled\"></azteca-menu-item>\n\n\n                  <azteca-grid-column [header]=\"'Fecha Carga'\" [binding]=\"'fechaCreacion'\" [width]=\"150\" format=\"dd/MM/yyyy\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha Comprobante'\" [binding]=\"'fechaComprobante'\" [width]=\"150\" format=\"dd/MM/yyyy\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'UUID'\" [binding]=\"'uuid'\" [width]=\"'20*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'RFC'\" [binding]=\"'rfcEmisor'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Emisor'\" [binding]=\"'nombreEmisor'\" [width]=\"'20*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Tipo'\" [binding]=\"'tipoComprobante'\" [width]=\"'10*'\" format=\"c\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"'10*'\" format=\"c\"></azteca-grid-column>\n\n              </azteca-document-list>\n\n          </div> <!--COL GRID-->\n      </div><!--ROW-->\n\n      <download-popup></download-popup>\n\n      <div bsModal #viewDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\"></h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"viewDialog.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <accounting-comprobante-viewer [comprobante]=\"currentComprobante.comprobanteBase\"></accounting-comprobante-viewer>\n                  </div> <!--Modal Body-->\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder,
            comprobante_fiscal_service_1.ComprobanteFiscalService, accounting_1.ComprobanteFiscalService])
    ], AlmacenDigitalComponent);
    return AlmacenDigitalComponent;
}(core_2.ProcessComponent));
exports.AlmacenDigitalComponent = AlmacenDigitalComponent;
