import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { CostoPresupuestoInfo } from '../models/costo-presupuesto';
import { CostoPresupuestoDetail } from '../models/costo-presupuesto-detail';
import { CostoPresupuestoService } from '../services/costo-presupuesto.service';
import { CostoPresupuestoDetailEditor } from './parts/costos-presupuestos-detail.editor';
import { DivisaService } from '../../accounting/services/divisa.service';
import { EmpresaService } from '../../accounting/services/empresa.service';
import { BeneficiarioSelectorComponent } from '../../treasury/controls/beneficiario-selector.component';
import { CuentasPorPagarListComponent } from '../../treasury/dialogs/cuenta-por-pagar-list.component';
import { CuentaPorPagarItem } from '../../treasury/models/cuenta-por-pagar';
import { ServicioItem } from '../models/servicio';
import { ServicioService } from '../services/servicio.service';
import { ServicioListComponent } from '../dialogs/servicio-list.component';
export declare class CostosPresupuestosEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private costoPresupuestoService;
    private divisaService;
    private empresaService;
    private servicioService;
    costoPresupuesto: CostoPresupuestoInfo;
    idDivisaDefault: number;
    tipoCambio: string;
    currentDetailCopy: CostoPresupuestoDetail;
    idServicio: number;
    detailsList: EditableListComponent;
    detailsEditor: CostoPresupuestoDetailEditor;
    selectorBeneficiario: BeneficiarioSelectorComponent;
    dlgCuentasPorPagar: CuentasPorPagarListComponent;
    dlgServicio: ServicioListComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, costoPresupuestoService: CostoPresupuestoService, divisaService: DivisaService, empresaService: EmpresaService, servicioService: ServicioService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onMenuItemClick(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: CostoPresupuestoDetail): void;
    onDeletingDetail(detail: CostoPresupuestoDetail): void;
    onListItemsUpdated(updatedDetails: CostoPresupuestoDetail[]): void;
    onSavingDetail(detail: CostoPresupuestoDetail): void;
    getDivisaDefault(creating: boolean): void;
    onDivisaSelected(args: any): void;
    loadNewDetalle(idPresupuesto: string): void;
    tieneCPP(): boolean;
    onServicioSelected(args: ServicioItem): void;
    onCuentaPorPagarSelected(args: CuentaPorPagarItem): void;
}
