"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var costo_presupuesto_1 = require("../models/costo-presupuesto");
var costo_presupuesto_detail_1 = require("../models/costo-presupuesto-detail");
var costo_presupuesto_service_1 = require("../services/costo-presupuesto.service");
var costos_presupuestos_detail_editor_1 = require("./parts/costos-presupuestos-detail.editor");
var divisa_service_1 = require("../../accounting/services/divisa.service");
var empresa_service_1 = require("../../accounting/services/empresa.service");
var beneficiario_selector_component_1 = require("../../treasury/controls/beneficiario-selector.component");
var cuenta_por_pagar_list_component_1 = require("../../treasury/dialogs/cuenta-por-pagar-list.component");
var servicio_service_1 = require("../services/servicio.service");
var servicio_list_component_1 = require("../dialogs/servicio-list.component");
var editors_2 = require("framework3/editors");
var CostosPresupuestosEditor = /** @class */ (function (_super) {
    __extends(CostosPresupuestosEditor, _super);
    function CostosPresupuestosEditor(context, router, route, location, formBuilder, documentTypeService, costoPresupuestoService, divisaService, empresaService, servicioService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.costoPresupuestoService = costoPresupuestoService;
        _this.divisaService = divisaService;
        _this.empresaService = empresaService;
        _this.servicioService = servicioService;
        _this.costoPresupuesto = new costo_presupuesto_1.CostoPresupuestoInfo();
        _this.idDivisaDefault = 0;
        _this.currentDetailCopy = new costo_presupuesto_detail_1.CostoPresupuestoDetail();
        _this.idServicio = 0;
        _this.documentForm = formBuilder.group({
            'idBeneficiario': [0, forms_1.Validators.required],
            'idDivisa': [0, forms_1.Validators.required],
            'idServicio': [0],
            'observaciones': ['', forms_1.Validators.required],
        });
        return _this;
    }
    CostosPresupuestosEditor_1 = CostosPresupuestosEditor;
    CostosPresupuestosEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
        this.getDivisaDefault(false);
    };
    CostosPresupuestosEditor.prototype.onCreatingDocument = function () {
        var _this = this;
        this.route.params.forEach(function (params) {
            if (params['idPresupuesto']) {
                _this.costoPresupuesto.idPresupuesto = params['idPresupuesto'];
            }
            if (params['idDepartamento']) {
                _this.costoPresupuesto.idDepartamento = params['idDepartamento'];
            }
            if (params['idBeneficiario']) {
                _this.costoPresupuesto.idBeneficiario = params['idBeneficiario'];
            }
        });
        this.getDivisaDefault(true);
        this.loadNewDetalle(this.costoPresupuesto.idPresupuesto);
    };
    CostosPresupuestosEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.costoPresupuestoService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.costoPresupuesto = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CostosPresupuestosEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.costoPresupuestoService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.costoPresupuesto = doc;
            _this.detailsEditor.clientIndexStart = _this.costoPresupuesto.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CostosPresupuestosEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.costoPresupuestoService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.costoPresupuesto = doc;
            _this.detailsEditor.clientIndexStart = _this.costoPresupuesto.details.length;
            if (_this.costoPresupuesto.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CostosPresupuestosEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.costoPresupuesto.tipoBeneficiario = this.selectorBeneficiario.selectedItem.tipoBeneficiario;
        this.costoPresupuestoService.update(this.costoPresupuesto)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.costoPresupuesto.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.costoPresupuesto = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CostosPresupuestosEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.costoPresupuestoService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CostosPresupuestosEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.costoPresupuestoService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CostosPresupuestosEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.costoPresupuesto.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    CostosPresupuestosEditor.prototype.onMenuItemClick = function (args) {
        if (args.name == 'SERVICIO') {
            var detail;
            detail = new costo_presupuesto_detail_1.CostoPresupuestoDetail();
            detail = this.detailsList.currentItem;
            this.currentDetailCopy = detail;
            this.dlgServicio.show();
        }
    };
    CostosPresupuestosEditor.prototype.onAddingDetail = function () {
    };
    CostosPresupuestosEditor.prototype.onEditingDetail = function (detail) {
        this.currentDetailCopy = detail;
        this.dlgCuentasPorPagar.show();
    };
    CostosPresupuestosEditor.prototype.onDeletingDetail = function (detail) {
        detail.idCuentaPorPagar = '';
        detail.importe = 0;
        detail.state = editors_2.ChangeState.MODIFIED;
        wijmo_1.Control.invalidateAll();
    };
    CostosPresupuestosEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.costoPresupuesto.details = updatedDetails;
    };
    CostosPresupuestosEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    CostosPresupuestosEditor.prototype.getDivisaDefault = function (creating) {
        var _this = this;
        this.divisaService.getDetailByEmpresa(this.context.app.defaultCompany.identity)
            .then(function (r) {
            _this.idDivisaDefault = r.identity;
            if (creating) {
                _this.costoPresupuesto.idDivisa = r.identity;
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CostosPresupuestosEditor.prototype.onDivisaSelected = function (args) {
        var _this = this;
        if (this.costoPresupuesto.idDivisa == this.idDivisaDefault) {
            this.costoPresupuesto.tipoCambio = 1;
            this.tipoCambio = this.costoPresupuesto.tipoCambio.toString();
        }
        else {
            this.divisaService.loadTiposCambio(this.context.app.defaultCompany.identity)
                .then(function (tipos) {
                var tCambio = tipos.find(function (search) { return search.idDivisaOrigen == _this.costoPresupuesto.idDivisa && search.idDivisaDestino == _this.idDivisaDefault; });
                if (tCambio == undefined) {
                    _this.showAlert("No está definido el tipo de cambio para la divisa seleccionada", "danger");
                    _this.tipoCambio = null;
                    _this.costoPresupuesto.idDivisa = null;
                    _this.costoPresupuesto.tipoCambio = 0;
                }
                else {
                    _this.empresaService.getDetailFromCache(_this.context.app.defaultCompany.identity)
                        .then(function (emp) {
                        if (emp.tipoCambio == 'O') {
                            _this.costoPresupuesto.tipoCambio = tCambio.precioOtro;
                            _this.tipoCambio = tCambio.precioOtro.toString();
                        }
                        else if (emp.tipoCambio == 'V') {
                            _this.costoPresupuesto.tipoCambio = tCambio.precioVenta;
                            _this.tipoCambio = tCambio.precioVenta.toString();
                        }
                        else if (emp.tipoCambio == 'C') {
                            _this.costoPresupuesto.tipoCambio = tCambio.precioCompra;
                            _this.tipoCambio = tCambio.precioCompra.toString();
                        }
                    });
                }
            });
        }
    };
    CostosPresupuestosEditor.prototype.loadNewDetalle = function (idPresupuesto) {
        var _this = this;
        this.costoPresupuestoService.loadDetalleNew(idPresupuesto)
            .then(function (det) {
            _this.costoPresupuesto.details = det;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CostosPresupuestosEditor.prototype.tieneCPP = function () {
        var detail;
        detail = new costo_presupuesto_detail_1.CostoPresupuestoDetail();
        var ret;
        if (this.detailsList.currentItem != undefined) {
            detail = this.detailsList.currentItem;
            ret = (detail.idCuentaPorPagar.trim() != "");
        }
        else {
            ret = false;
        }
        return ret;
    };
    CostosPresupuestosEditor.prototype.onServicioSelected = function (args) {
        var _this = this;
        this.servicioService.getDetailByID(args.id)
            .then(function (doc) {
            _this.currentDetailCopy.idServicio = args.id;
            _this.currentDetailCopy.nombreServicio = doc.nombre;
            _this.currentDetailCopy.state = editors_2.ChangeState.MODIFIED;
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CostosPresupuestosEditor.prototype.onCuentaPorPagarSelected = function (args) {
        this.currentDetailCopy.idCuentaPorPagar = args.id;
        this.currentDetailCopy.fechaCuentaPorPagar = args.fechaSys;
        this.currentDetailCopy.importe = args.total;
        this.currentDetailCopy.state = editors_2.ChangeState.MODIFIED;
        //Actualizar controles de wijmo
        wijmo_1.Control.invalidateAll();
    };
    var CostosPresupuestosEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], CostosPresupuestosEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", costos_presupuestos_detail_editor_1.CostoPresupuestoDetailEditor)
    ], CostosPresupuestosEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild('selectorBeneficiario'),
        __metadata("design:type", beneficiario_selector_component_1.BeneficiarioSelectorComponent)
    ], CostosPresupuestosEditor.prototype, "selectorBeneficiario", void 0);
    __decorate([
        core_1.ViewChild('dlgCuentasPorPagar'),
        __metadata("design:type", cuenta_por_pagar_list_component_1.CuentasPorPagarListComponent)
    ], CostosPresupuestosEditor.prototype, "dlgCuentasPorPagar", void 0);
    __decorate([
        core_1.ViewChild('dlgServicio'),
        __metadata("design:type", servicio_list_component_1.ServicioListComponent)
    ], CostosPresupuestosEditor.prototype, "dlgServicio", void 0);
    CostosPresupuestosEditor = CostosPresupuestosEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-costos-presupuestos-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                  [title]=\"'CostosPresupuestos'\"\n                                  [document]=\"costoPresupuesto\"\n                                  [valid]=\"valid\"\n                                  (configureDocument)=\"onConfigureDocument($event)\"\n                                  (creatingDocument)=\"onCreatingDocument()\"\n                                  (viewingDocument)=\"onViewingDocument($event)\"\n                                  (cloningDocument)=\"onCloningDocument($event)\"\n                                  (savingDocument)=\"onSavingDocument($event)\"\n                                  (loadingDocument)=\"onLoadingDocument($event)\"\n                                  (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                  (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n                              <azteca-form-field [label]=\"'Beneficiario:'\">\n                                  <treasury-beneficiario-selector #selectorBeneficiario\n                                                                  formControlName=\"idBeneficiario\"\n                                                                  [(ngModel)]=\"costoPresupuesto.idBeneficiario\"\n                                                                  [enabled]=\"false\">\n                                  </treasury-beneficiario-selector>\n                              </azteca-form-field>\n\n                              <div class=\"row\">\n                                  <div class=\"col-10 col-md-4\">\n                                      <azteca-form-field [label]=\"'Divisa:'\">\n                                          <accounting-divisas-selector #divisasSelector formControlName=\"idDivisa\" [(ngModel)]=\"costoPresupuesto.idDivisa\" ngDefaultControl=\"\" (selectedItemChanged)=\"onDivisaSelected($event)\"></accounting-divisas-selector>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-10 col-md-4\">\n                                      <label class=\"control-label\">Tipo de cambio:</label>\n                                      <az-label [text]=\"tipoCambio\"></az-label>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Observaciones:'\">\n                                          <az-textarea formControlName=\"observaciones\" [(ngModel)]=\"costoPresupuesto.observaciones\"></az-textarea>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                          </tab>\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                        \n                              <!--<azteca-form-field [label]=\"'Servicio:'\">\n                                  <purchasing-servicios-selector #selectorServicio\n                                                                  formControlName=\"idServicio\"\n                                                                  [(ngModel)]=\"idServicio\">\n                                  </purchasing-servicios-selector>\n                              </azteca-form-field>-->\n\n\n                              <azteca-editable-list #detailsList\n                                                    (addingItem)=\"onAddingDetail()\"\n                                                    (editingItem)=\"onEditingDetail($event)\"\n                                                    (deletingItem)=\"onDeletingDetail($event)\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    (menuItemClick)=\"onMenuItemClick($event)\"\n                                                    [listItems]=\"costoPresupuesto.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Asignar cuenta por pagar'\" [smallText]=\"'asignar cuenta por pagar'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'SERVICIO'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Asignar servicio'\" [smallText]=\"'asignar servicio'\" [enabled]=\"tieneCPP()\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-erase'\" [text]=\"'Limpiar'\" [smallText]=\"'limpiar'\"></azteca-menu-item>\n\n                                  <azteca-grid-column [header]=\"'Categor\u00EDa presupuestal'\" [binding]=\"'nombreCategoriaPresupuestal'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Servicio'\" [binding]=\"'nombreServicio'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Disponible'\" [binding]=\"'montoDisponible'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Cuenta por pagar'\" [binding]=\"'idCuentaPorPagar'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n\n                              </azteca-editable-list>\n                          </tab>\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"costoPresupuesto.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <treasury-cuentas-por-pagar-list #dlgCuentasPorPagar\n                                       [idWorkflowStep]=\"0\"\n                                       [idBeneficiario]=\"costoPresupuesto.idBeneficiario\"\n                                       [idDivisa]=\"costoPresupuesto.idDivisa\"\n                                       [idStatus]=\"2\"\n                                       (selectedItemChanged)=\"onCuentaPorPagarSelected($event)\"\n                                       (selectedItemsChanged)=\"onItemsCuentaPorPagarSelected($event)\">\n      </treasury-cuentas-por-pagar-list>\n\n      <purchasing-servicio-list #dlgServicio\n                                (selectedItemChanged)=\"onServicioSelected($event)\">\n    \n      </purchasing-servicio-list>\n\n\n      <compras-costo-presupuesto-detail-editor #detailsEditor\n                                               (savingItem)=\"onSavingDetail($event)\">\n\n      </compras-costo-presupuesto-detail-editor>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CostosPresupuestosEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: costo_presupuesto_service_1.CostoPresupuestoService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            costo_presupuesto_service_1.CostoPresupuestoService,
            divisa_service_1.DivisaService,
            empresa_service_1.EmpresaService,
            servicio_service_1.ServicioService])
    ], CostosPresupuestosEditor);
    return CostosPresupuestosEditor;
}(editors_1.DocumentEditor));
exports.CostosPresupuestosEditor = CostosPresupuestosEditor;
