import { Router, ActivatedRoute } from '@angular/router';
import { FormGroup, FormBuilder } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { CollectionView } from 'wijmo/wijmo';
import { Context, ProcessComponent, PolicyInfo } from 'framework3/core';
import { FileInfo } from 'framework3/general';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { TrackableCollection } from 'framework3/editors';
import { GastoInfo } from '../models/gasto';
import { GastoComprobarItem } from '../models/gasto-comprobar-item';
import { GastoService } from '../services/gasto.service';
import { CFDValiationResult } from '../models/cfd-validation-result';
import { ComprobanteFiscalService } from '../services/comprobante-fiscal.service';
import { ComprobanteFiscalInfo, ComprobanteFiscalItem } from '../models/comprobante-fiscal';
import { ProveedorInfo } from '../models/proveedor';
export declare class GastoComprobar extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    private gastoService;
    private comprobanteFiscalService;
    form: FormGroup;
    gasto: GastoInfo;
    idGasto: string;
    origenesCF: {
        id: string;
        nombre: string;
    }[];
    idProveedor: number;
    origenCF: string;
    selectedFile: FileInfo;
    previewCollectionDetallesGasto: CollectionView;
    previewCollectionDetallesGastoCats: CollectionView;
    previewCollectionDetallesComprobantes: TrackableCollection;
    detailMode: string;
    detailModeMulti: string;
    alerts: AlertsBarComponent;
    origenCFDialog: ModalDirective;
    comprobantesListDialog: ModalDirective;
    uploadDialog: ModalDirective;
    applyPolicy(policy: PolicyInfo): void;
    constructor(context: Context, router: Router, route: ActivatedRoute, formBuilder: FormBuilder, gastoService: GastoService, comprobanteFiscalService: ComprobanteFiscalService);
    ngOnInit(): void;
    handleError(error: any): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onAsignar(info: ComprobanteFiscalInfo): void;
    getDet(toComp: GastoComprobarItem[]): CollectionView;
    onOrigenCFSelected(): void;
    onFileChanged(file: FileInfo): void;
    onValidateFile(): void;
    validateFile(): void;
    cathComprobantes(ValidCFDcomprobantes: CFDValiationResult[]): void;
    onProveedorChanged(proveedor: ProveedorInfo): void;
    onComprobanteSelected(comprobante: ComprobanteFiscalItem): void;
    onRemoveComprobante(item: any): void;
}
