"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Locales
var gasto_1 = require("../models/gasto");
var gasto_comprobar_item_1 = require("../models/gasto-comprobar-item");
var gasto_comprobante_item_1 = require("../models/gasto-comprobante-item");
var gasto_service_1 = require("../services/gasto.service");
var comprobante_fiscal_service_1 = require("../services/comprobante-fiscal.service");
var wjcGridDetail = require("wijmo/wijmo.grid.detail");
var GastoComprobar = /** @class */ (function (_super) {
    __extends(GastoComprobar, _super);
    function GastoComprobar(context, router, route, formBuilder, gastoService, comprobanteFiscalService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.gastoService = gastoService;
        _this.comprobanteFiscalService = comprobanteFiscalService;
        _this.gasto = new gasto_1.GastoInfo();
        _this.origenesCF = [];
        _this.idProveedor = 0;
        _this.origenCF = "L";
        _this.previewCollectionDetallesGasto = new wijmo_1.CollectionView();
        _this.previewCollectionDetallesGastoCats = new wijmo_1.CollectionView();
        _this.previewCollectionDetallesComprobantes = new editors_1.TrackableCollection();
        //previewCollectionDetallesComprobantes: CollectionView = new CollectionView();
        _this.detailMode = wjcGridDetail.DetailVisibilityMode[wjcGridDetail.DetailVisibilityMode.ExpandSingle];
        _this.detailModeMulti = wjcGridDetail.DetailVisibilityMode[wjcGridDetail.DetailVisibilityMode.ExpandMulti];
        _this.route.params.subscribe(function (params) {
            _this.idGasto = params['idGasto'];
        });
        _this.form = formBuilder.group({});
        return _this;
    }
    //Implementacion de politicas
    GastoComprobar.prototype.applyPolicy = function (policy) {
    };
    GastoComprobar.prototype.ngOnInit = function () {
        var _this = this;
        this.gastoService.getDetail(this.idGasto)
            .then(function (gto) {
            _this.gasto = gto;
            _this.previewCollectionDetallesGasto.sourceCollection = _this.gasto.details;
            _this.previewCollectionDetallesComprobantes.sourceCollection = _this.gasto.comprobantes;
        })
            .catch(function (error) { return _this.handleError(error); });
        this.origenesCF =
            [
                { "id": 'L', "nombre": "Ruta Local" },
                { "id": 'A', "nombre": "Almacen digital" },
            ];
    };
    GastoComprobar.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    GastoComprobar.prototype.onToolbarButtonClick = function (button) {
        var _this = this;
        if (button.name == 'SELECCIONAR') {
            this.origenCFDialog.config.backdrop = false;
            this.idProveedor = 0;
            this.origenCFDialog.show();
        }
        if (button.name == 'GUARDAR') {
            this.gastoService.updateComprobantes(this.gasto)
                .then(function (ret) {
                _this.alerts.showAlert('Informacion guardada con éxito', 'success');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    GastoComprobar.prototype.onAsignar = function (info) {
        if (this.previewCollectionDetallesGastoCats.currentItem == null) {
            this.alerts.showAlert("Seleccione primero un servicio de la categría presupuestal", 'success');
        }
        else {
            var item = new gasto_comprobar_item_1.GastoComprobarItem;
            item = this.previewCollectionDetallesGastoCats.currentItem;
            var comprobante = new gasto_comprobante_item_1.GastoComprobanteItem();
            comprobante.idCategoriaPresupuestal = item.idCategoriaPresupuestal;
            comprobante.idComprobante = info.identity;
            comprobante.idFlujo = 0;
            comprobante.referenciaAlf = info.comprobanteBase.serie;
            comprobante.referenciaNum = +info.comprobanteBase.folio;
            comprobante.total = info.comprobanteBase.total;
            comprobante.idServicio = item.idServicio;
            comprobante.nombreServicio = item.nombreServicio;
            comprobante.impuestosRetenidos = info.comprobanteBase.impuestos.totalRetenciones;
            comprobante.impuestosTrasladados = info.comprobanteBase.impuestos.totalTraslados;
            comprobante.subTotal = info.comprobanteBase.subTotal;
            comprobante.descuentos = info.comprobanteBase.descuentos;
            var newCompGto = this.gasto.comprobantes.slice();
            newCompGto.push(comprobante);
            this.gasto.comprobantes = newCompGto;
            this.previewCollectionDetallesComprobantes.sourceCollection = this.gasto.comprobantes;
            this.previewCollectionDetallesComprobantes.refresh;
        }
    };
    GastoComprobar.prototype.getDet = function (toComp) {
        this.previewCollectionDetallesGastoCats.sourceCollection = toComp;
        return this.previewCollectionDetallesGastoCats;
    };
    GastoComprobar.prototype.onOrigenCFSelected = function () {
        if (this.origenCF == "A" && this.idProveedor == 0)
            this.alerts.showAlert("Debe seleccionar un proveedor ", 'danger');
        else {
            this.origenCFDialog.hide();
            // Ver que va a cargar
            //this.comprobantesListDialog.config.backdrop = false;
            if (this.origenCF == "A")
                this.comprobantesListDialog.show();
            else {
                this.uploadDialog.config.backdrop = false;
                this.uploadDialog.show();
            }
        }
    };
    GastoComprobar.prototype.onFileChanged = function (file) {
        this.selectedFile = file;
    };
    GastoComprobar.prototype.onValidateFile = function () {
        this.uploadDialog.hide();
        this.validateFile();
    };
    GastoComprobar.prototype.validateFile = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteFiscalService.validate(this.context.app.defaultCompany.identity, this.selectedFile)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.cathComprobantes(result);
            //this.validatedFiles = result;
            //this.comprobantesCollection.sourceCollection = result;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GastoComprobar.prototype.cathComprobantes = function (ValidCFDcomprobantes) {
        var _this = this;
        var promises = [];
        ValidCFDcomprobantes.forEach(function (validCFD) {
            if (validCFD.valid) {
                _this.context.app.showSpinner();
                var savePromise = _this.comprobanteFiscalService.save(0, _this.context.app.defaultCompany.identity, _this.context.app.defaultSite.identity, validCFD.comprobante.comprobanteBase.contenidoXML)
                    .then(function (comprobante) {
                    _this.context.app.hideSpinner();
                    _this.idProveedor = comprobante.idProveedor;
                    _this.onAsignar(comprobante);
                })
                    .catch(function (error) { return _this.handleError(error); });
            }
            else
                _this.alerts.showAlert("Algunos comprobantes no se pudieron validar correctamente:[" + validCFD.validationMessage + "]", "danger");
        });
    };
    GastoComprobar.prototype.onProveedorChanged = function (proveedor) {
        this.idProveedor = proveedor.identity;
    };
    GastoComprobar.prototype.onComprobanteSelected = function (comprobante) {
        var _this = this;
        this.comprobanteFiscalService.getDetail(comprobante.id)
            .then(function (comp) {
            _this.onAsignar(comp);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GastoComprobar.prototype.onRemoveComprobante = function (item) {
        this.previewCollectionDetallesComprobantes.remove(item);
        this.previewCollectionDetallesComprobantes.refresh();
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], GastoComprobar.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('cargaComprobanteFiscalDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], GastoComprobar.prototype, "origenCFDialog", void 0);
    __decorate([
        core_1.ViewChild('comprobantesList'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], GastoComprobar.prototype, "comprobantesListDialog", void 0);
    __decorate([
        core_1.ViewChild('uploadDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], GastoComprobar.prototype, "uploadDialog", void 0);
    GastoComprobar = __decorate([
        core_1.Component({
            selector: 'purchasing-gasto-comprobar',
            template: "\n      <form [formGroup]=\"form\">\n\n          <alerts-bar></alerts-bar>\n\n          <div class=\"form-inline\">\n\n              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                  <az-toolbar-button [name]=\"'GUARDAR'\" [type]=\"'primary'\" [text]=\"'Guardar'\" [toolTip]=\"'Guardar'\" [icon]=\"'glyphicon glyphicon-floppy-save'\" [enabled]=\"true\"></az-toolbar-button>\n              </az-toolbar>\n\n          </div>\n\n          <div class=\"row\">\n\n              <div class=\"col-6\">\n                  <label class=\"control-label\">Seleccione el servicio dentro de la categor\u00EDa presupuestal a que se asignar\u00E1 el comprobante:</label>\n\n                  <wj-flex-grid #grid style=\"height:200px\"\n                                [itemsSource]=\"previewCollectionDetallesGasto\"\n                                [isReadOnly]=\"true\">\n                      <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                      <wj-flex-grid-column [header]=\"'Categor\u00EDa presupuestal'\" [binding]=\"'nombreCategoriaPresupuestal'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n\n\n                      <ng-template wjFlexGridDetail [maxHeight]=\"800\" [detailVisibilityMode]=\"detailModeMulti\" let-item=\"item\" [isAnimated]=\"true\">\n                          <wj-flex-grid #gridDet [itemsSource]=\"getDet(item.toComprobar)\" style=\"height:600px\" [isReadOnly]=\"false\"\n                                        (cellEditEnding)=\"cellEditEndingHandler(gridDet, $event)\"\n                                        (cellEditEnded)=\"onCellEditEnded(gridDet, $event)\">\n                              <wj-flex-grid-column [header]=\"'Servicio'\" [binding]=\"'nombreServicio'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          </wj-flex-grid>\n                      </ng-template>\n\n                  </wj-flex-grid>\n\n              </div>\n          </div>\n\n          <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n              <az-toolbar-button [name]=\"'SELECCIONAR'\" [type]=\"'primary'\" [text]=\"'Seleccionar comprobante'\" [toolTip]=\"'Seleccionar Comprobante'\" [icon]=\"'glyphicon glyphicon-search'\" [enabled]=\"true\"></az-toolbar-button>\n          </az-toolbar>\n\n\n          <div class=\"row\">\n\n              <wj-flex-grid #grid style=\"height:400px\"\n                            [itemsSource]=\"previewCollectionDetallesComprobantes\"\n                            [isReadOnly]=\"true\">\n\n                  <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveComprobante(cell.item)\">\n                              <span class=\"glyphicon glyphicon-trash\"></span>\n                          </button>\n                      </ng-template>\n                  </wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Servicio'\" [binding]=\"'nombreServicio'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Serie'\" [binding]=\"'referenciaAlf'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Folio'\" [binding]=\"'referenciaNum'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Importe'\" [binding]=\"'total'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n              </wj-flex-grid>\n\n\n          </div>\n\n\n      </form>\n\n      <!--Solicitar la forma en la que se carga el Comprobante Fiscal-->\n      <div bsModal #cargaComprobanteFiscalDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myEgresoModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n\n              <div class=\"modal-content\">\n\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\">Obtener el comprobante fiscal desde:</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n\n                  <div class=\"modal-body\">\n                      <alerts-bar></alerts-bar>\n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-6\">\n                              <az-combobox [(ngModel)]=\"origenCF\"\n                                           [items]=\"origenesCF\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'id'\">\n                              </az-combobox>\n                          </div>\n                      </div>\n\n                      <div class=\"row\" *ngIf=\"origenCF=='A'\">\n                          <div class=\"col-12 col-md-6\">\n                              <az-label [text]=\"'Proveedor:'\"></az-label>\n                          </div>\n                          <div class=\"col-12 col-md-6\">\n                              <purchasing-proveedor-selector [(ngModel)]=\"idProveedor\"\n                                                             [showListButton]=\"false\"\n                                                             (proveedorUpdated)=\"onProveedorChanged($event)\">\n                              </purchasing-proveedor-selector>\n                          </div>\n                      </div>\n\n                  </div>\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onOrigenCFSelected()\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\" (click)=\"cargaComprobanteFiscalDialog.hide()\">Cerrar</button>\n                  </div>\n              </div>\n              <!--</div>-->\n          </div>\n      </div>\n\n      <!--DIALOGO DE CARGA DE ARCHIVO LOCAL para el Comprobante Fiscal-->\n      <div bsModal #uploadDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"mySmallModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-sm\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n                      <div>Seleccione el archivo a cargar:</div>\n                      <azteca-file-box (fileChanged)=\"onFileChanged($event)\"></azteca-file-box>\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onValidateFile()\" [disabled]=\"!selectedFile\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-danger\" (click)=\"uploadDialog.hide()\">Cancelar</button>\n                  </div> <!--Modal Footer-->\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n      <!--DIALOGO DE CARGA DE ALMACEN DIGITAL-->\n      <purchasing-comprobantes-list #comprobantesList\n                                    (selectedItemChanged)=\"onComprobanteSelected($event)\"\n                                    [idProveedor]=\"idProveedor\"\n                                    [idComprobanteTipo]=\"1\"\n                                    [Activos]=\"true\"\n                                    [sinReferencia]=\"true\">\n      </purchasing-comprobantes-list>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder,
            gasto_service_1.GastoService,
            comprobante_fiscal_service_1.ComprobanteFiscalService])
    ], GastoComprobar);
    return GastoComprobar;
}(core_2.ProcessComponent));
exports.GastoComprobar = GastoComprobar;
