import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { CollectionView } from 'wijmo/wijmo';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { AlertsBarComponent } from 'framework3/controls';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { ImportesInfo } from '../../accounting/models/importes';
import { GastoInfo } from '../models/gasto';
import { GastoDetail } from '../models/gasto-detail';
import { GastoService } from '../services/gasto.service';
import { GastoDetailEditor } from './parts/gastos-detail.editor';
import { DivisaService } from '../../accounting/services/divisa.service';
import { EmpresaService } from '../../accounting/services/empresa.service';
import { BeneficiarioSelectorComponent } from '../../treasury/controls/beneficiario-selector.component';
export declare class GastosEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private gastoService;
    private divisaService;
    private empresaService;
    gasto: GastoInfo;
    idDivisaDefault: number;
    tipoCambio: string;
    previewCollectionDetallesComprobantes: CollectionView;
    readonly importesG: ImportesInfo;
    readonly importesC: ImportesInfo;
    detailMode: string;
    detailModeMulti: string;
    alertsBarComprobante: AlertsBarComponent;
    detailsList: EditableListComponent;
    detailsEditor: GastoDetailEditor;
    selectorBeneficiario: BeneficiarioSelectorComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, gastoService: GastoService, divisaService: DivisaService, empresaService: EmpresaService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: GastoDetail): void;
    onDeletingDetail(detail: GastoDetail): void;
    onListItemsUpdated(updatedDetails: GastoDetail[]): void;
    onSavingDetail(detail: GastoDetail): void;
    loadNewDetalle(idPresupuesto: string): void;
    getDivisaDefault(creating: boolean): void;
    importesDesglosados(origen: string): ImportesInfo;
    onBeneficiarioSelected(args: any): void;
    onDivisaSelected(args: any): void;
}
