"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Locales
var importes_1 = require("../../accounting/models/importes");
var gasto_1 = require("../models/gasto");
var gasto_service_1 = require("../services/gasto.service");
var gastos_detail_editor_1 = require("./parts/gastos-detail.editor");
var divisa_service_1 = require("../../accounting/services/divisa.service");
var empresa_service_1 = require("../../accounting/services/empresa.service");
var beneficiario_selector_component_1 = require("../../treasury/controls/beneficiario-selector.component");
var wjcGridDetail = require("wijmo/wijmo.grid.detail");
var GastosEditor = /** @class */ (function (_super) {
    __extends(GastosEditor, _super);
    function GastosEditor(context, router, route, location, formBuilder, documentTypeService, gastoService, divisaService, empresaService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.gastoService = gastoService;
        _this.divisaService = divisaService;
        _this.empresaService = empresaService;
        _this.gasto = new gasto_1.GastoInfo();
        _this.idDivisaDefault = 0;
        _this.previewCollectionDetallesComprobantes = new wijmo_1.CollectionView();
        _this.detailMode = wjcGridDetail.DetailVisibilityMode[wjcGridDetail.DetailVisibilityMode.ExpandSingle];
        _this.detailModeMulti = wjcGridDetail.DetailVisibilityMode[wjcGridDetail.DetailVisibilityMode.ExpandMulti];
        _this.documentForm = formBuilder.group({
            'idBeneficiario': [0, forms_1.Validators.required],
            'idDivisa': [0, forms_1.Validators.required],
        });
        return _this;
    }
    GastosEditor_1 = GastosEditor;
    Object.defineProperty(GastosEditor.prototype, "importesG", {
        get: function () {
            return this.importesDesglosados('G');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GastosEditor.prototype, "importesC", {
        get: function () {
            return this.importesDesglosados('C');
        },
        enumerable: true,
        configurable: true
    });
    GastosEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
        this.getDivisaDefault(false);
    };
    GastosEditor.prototype.onCreatingDocument = function () {
        var _this = this;
        this.route.params.forEach(function (params) {
            if (params['idPresupuesto']) {
                _this.gasto.idPresupuesto = params['idPresupuesto'];
            }
            if (params['idDepartamento']) {
                _this.gasto.idDepartamento = params['idDepartamento'];
            }
            if (params['idGastoTipo']) {
                _this.gasto.idGastoTipo = params['idGastoTipo'];
            }
        });
        this.getDivisaDefault(true);
        this.loadNewDetalle(this.gasto.idPresupuesto);
    };
    GastosEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.gastoService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.previewCollectionDetallesComprobantes.sourceCollection = doc.comprobantes;
            _this.gasto = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GastosEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.gastoService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.gasto = doc;
            _this.detailsEditor.clientIndexStart = _this.gasto.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GastosEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.gastoService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.previewCollectionDetallesComprobantes.sourceCollection = doc.comprobantes;
            _this.gasto = doc;
            _this.detailsEditor.clientIndexStart = _this.gasto.details.length;
            if (_this.gasto.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GastosEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.gasto.tipoBeneficiario = this.selectorBeneficiario.selectedItem.tipoBeneficiario;
        this.gastoService.update(this.gasto)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.gasto.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.gasto = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GastosEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.gastoService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GastosEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.gastoService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GastosEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.gasto.identity);
            }
            if (args.heading == 'Comprobacion') {
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    GastosEditor.prototype.onAddingDetail = function () {
        /*
        this.detailsEditor.detail = new GastoDetail();
        this.detailsEditor.show();
        */
    };
    GastosEditor.prototype.onEditingDetail = function (detail) {
        /*
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
        */
    };
    GastosEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    GastosEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.gasto.details = updatedDetails;
    };
    GastosEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    GastosEditor.prototype.loadNewDetalle = function (idPresupuesto) {
        var _this = this;
        this.gastoService.loadDetalleNew(idPresupuesto)
            .then(function (det) {
            _this.gasto.details = det;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GastosEditor.prototype.getDivisaDefault = function (creating) {
        var _this = this;
        this.divisaService.getDetailByEmpresa(this.context.app.defaultCompany.identity)
            .then(function (r) {
            _this.idDivisaDefault = r.identity;
            if (creating) {
                _this.gasto.idDivisa = r.identity;
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///metodos locales
    GastosEditor.prototype.importesDesglosados = function (origen) {
        var desglose = new importes_1.ImportesInfo();
        if (origen == 'G') {
            var elementos = this.gasto.details.filter(function (item) { return item.state != 'DELETED'; }); //this.combineDetail();
            if (elementos.length > 0)
                elementos.forEach(function (item) {
                    desglose.subtotal += item.importe;
                });
            desglose.total = desglose.subtotal - desglose.descuentos + desglose.impuestosTrasladados - desglose.impuestosRetenidos;
        }
        if (origen == 'C') {
            var elementos = this.gasto.comprobantes.filter(function (item) { return item.state != 'DELETED'; }); //this.combineDetail();
            if (elementos.length > 0)
                elementos.forEach(function (item) {
                    desglose.subtotal += item.subTotal;
                    desglose.descuentos += item.descuentos;
                    desglose.impuestosTrasladados += item.impuestosTrasladados;
                    desglose.impuestosRetenidos += item.impuestosRetenidos;
                });
            desglose.total = desglose.subtotal - desglose.descuentos + desglose.impuestosTrasladados - desglose.impuestosRetenidos;
        }
        return desglose;
    };
    GastosEditor.prototype.onBeneficiarioSelected = function (args) {
        var beneficiario;
        beneficiario = args;
        if (!beneficiario.active) {
            this.showAlert("No no se puede hacer un gasto para un beneficiario inactivo", "danger");
            beneficiario = null;
            this.selectorBeneficiario.displayValue = null;
            this.selectorBeneficiario.selectedItem = null;
            this.selectorBeneficiario.valueMember = null;
            wijmo_1.Control.invalidateAll();
        }
    };
    GastosEditor.prototype.onDivisaSelected = function (args) {
        var _this = this;
        if (this.gasto.idDivisa == this.idDivisaDefault) {
            this.gasto.tipoCambio = 1;
            this.tipoCambio = this.gasto.tipoCambio.toString();
        }
        else {
            this.divisaService.loadTiposCambio(this.context.app.defaultCompany.identity)
                .then(function (tipos) {
                var tCambio = tipos.find(function (search) { return search.idDivisaOrigen == _this.gasto.idDivisa && search.idDivisaDestino == _this.idDivisaDefault; });
                if (tCambio == undefined) {
                    _this.showAlert("No está definido el tipo de cambio para la divisa seleccionada", "danger");
                    _this.tipoCambio = null;
                    _this.gasto.idDivisa = null;
                    _this.gasto.tipoCambio = 0;
                }
                else {
                    _this.empresaService.getDetailFromCache(_this.context.app.defaultCompany.identity)
                        .then(function (emp) {
                        if (emp.tipoCambio == 'O') {
                            _this.gasto.tipoCambio = tCambio.precioOtro;
                            _this.tipoCambio = tCambio.precioOtro.toString();
                        }
                        else if (emp.tipoCambio == 'V') {
                            _this.gasto.tipoCambio = tCambio.precioVenta;
                            _this.tipoCambio = tCambio.precioVenta.toString();
                        }
                        else if (emp.tipoCambio == 'C') {
                            _this.gasto.tipoCambio = tCambio.precioCompra;
                            _this.tipoCambio = tCambio.precioCompra.toString();
                        }
                    });
                }
            });
        }
    };
    var GastosEditor_1;
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], GastosEditor.prototype, "alertsBarComprobante", void 0);
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], GastosEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", gastos_detail_editor_1.GastoDetailEditor)
    ], GastosEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild('selectorBeneficiario'),
        __metadata("design:type", beneficiario_selector_component_1.BeneficiarioSelectorComponent)
    ], GastosEditor.prototype, "selectorBeneficiario", void 0);
    GastosEditor = GastosEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-gastos-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                  [title]=\"'Gastos'\"\n                                  [document]=\"gasto\"\n                                  [valid]=\"valid\"\n                                  (configureDocument)=\"onConfigureDocument($event)\"\n                                  (creatingDocument)=\"onCreatingDocument()\"\n                                  (viewingDocument)=\"onViewingDocument($event)\"\n                                  (cloningDocument)=\"onCloningDocument($event)\"\n                                  (savingDocument)=\"onSavingDocument($event)\"\n                                  (loadingDocument)=\"onLoadingDocument($event)\"\n                                  (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                  (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                  (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <label class=\"control-label\">Gasto:</label>\n                      <accounting-importes-component [importes]=\"importesG\"></accounting-importes-component>\n                      <label class=\"control-label\">Comprobaci\u00F3n:</label>\n                      <accounting-importes-component [importes]=\"importesC\"></accounting-importes-component>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n                              <azteca-form-field [label]=\"'Beneficiario:'\">\n                                  <treasury-beneficiario-selector #selectorBeneficiario\n                                                                  formControlName=\"idBeneficiario\"\n                                                                  [(ngModel)]=\"gasto.idBeneficiario\"\n                                                                  ngDefaultControl=\"\"\n                                                                  (itemSelected)=\"onBeneficiarioSelected($event)\"\n                                                                  tipoBeneficiario =\"E\">\n                                  </treasury-beneficiario-selector>\n                              </azteca-form-field>\n\n                              <div class=\"row\">\n                                  <div class=\"col-10 col-md-4\">\n                                      <azteca-form-field [label]=\"'Divisa:'\">\n                                          <accounting-divisas-selector #divisasSelector formControlName=\"idDivisa\" [(ngModel)]=\"gasto.idDivisa\" ngDefaultControl=\"\" (selectedItemChanged)=\"onDivisaSelected($event)\"></accounting-divisas-selector>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-10 col-md-4\">\n                                      <label class=\"control-label\">Tipo de cambio:</label>\n                                      <az-label [text]=\"tipoCambio\"></az-label>\n                                  </div>\n                              </div>\n\n                          </tab>\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #detailsList\n                                                    (addingItem)=\"onAddingDetail()\"\n                                                    (editingItem)=\"onEditingDetail($event)\"\n                                                    (deletingItem)=\"onDeletingDetail($event)\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    [listItems]=\"gasto.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                                  <azteca-grid-column [header]=\"'Categor\u00EDa presupuestal'\" [binding]=\"'nombreCategoriaPresupuestal'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Disponible'\" [binding]=\"'montoDisponible'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'10*'\" [isReadOnly]=\"false\"></azteca-grid-column>\n\n\n                              </azteca-editable-list>\n                          </tab>\n\n                          <tab heading=\"Comprobacion\" (select)=\"onTabSelected($event)\" [disabled]=\"gasto.identity==''\">\n\n                              <div class=\"row\">\n\n                                  <wj-flex-grid #grid style=\"height:400px\"\n                                                [itemsSource]=\"previewCollectionDetallesComprobantes\"\n                                                [isReadOnly]=\"true\">\n                                      <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                                      <wj-flex-grid-column [header]=\"'Servicio'\" [binding]=\"'nombreServicio'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Serie'\" [binding]=\"'referenciaAlf'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Folio'\" [binding]=\"'referenciaNum'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Importe'\" [binding]=\"'total'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  </wj-flex-grid>\n\n\n                              </div>\n                          </tab>\n\n\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"gasto.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <compras-gasto-detail-editor #detailsEditor\n                                   (savingItem)=\"onSavingDetail($event)\">\n\n      </compras-gasto-detail-editor>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return GastosEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: gasto_service_1.GastoService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            gasto_service_1.GastoService,
            divisa_service_1.DivisaService,
            empresa_service_1.EmpresaService])
    ], GastosEditor);
    return GastosEditor;
}(editors_1.DocumentEditor));
exports.GastosEditor = GastosEditor;
