import { Router, ActivatedRoute } from '@angular/router';
import { MenuItem } from 'framework3/controls';
import { Context, DocumentItem } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { GastoItem } from '../models/gasto';
import { GastoService } from '../services/gasto.service';
import { PolizaPerfilListComponent, PolizaPerfilItem, PolizaInfo, PolizaService } from '../../accounting/index';
import { ModalDirective } from 'ngx-bootstrap/modal/modal.directive';
export declare class GastosManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private gastoService;
    private polizaSvc;
    gastos: GastoItem[];
    currentPoliza: PolizaInfo;
    dlgPolizaViewer: ModalDirective;
    dlgPolizaPerfil: PolizaPerfilListComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, gastoService: GastoService, polizaSvc: PolizaService);
    onConfigureDocument(): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onMenuItemClick(option: MenuItem): void;
    onSelectedPolizaPerfil(item: PolizaPerfilItem): void;
    onClickGuardar(): void;
}
