import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { GrupoRequisicionesInfo } from '../models/grupo-requisiciones';
import { GrupoRequisicionesDetail } from '../models/grupo-requisiciones-detail';
import { GrupoRequisicionesService } from '../services/grupo-requisiciones.service';
import { GrupoRequisicionesDetailEditor } from './parts/grupo-requisiciones-detail.editor';
import { RequisicionItem } from '../models/requisicion';
export declare class GrupoRequisicionesEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private grupoRequisicionesService;
    grupoRequisiciones: GrupoRequisicionesInfo;
    requisiciones: RequisicionItem[];
    detailsList: EditableListComponent;
    detailsEditor: GrupoRequisicionesDetailEditor;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, grupoRequisicionesService: GrupoRequisicionesService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: GrupoRequisicionesDetail): void;
    onDeletingDetail(detail: GrupoRequisicionesDetail): void;
    onListItemsUpdated(updatedDetails: GrupoRequisicionesDetail[]): void;
    onSavingDetail(detail: GrupoRequisicionesDetail): void;
    loadRequisiciones(): void;
}
