"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var search_1 = require("framework3/search");
//Locales
var grupo_requisiciones_1 = require("../models/grupo-requisiciones");
var grupo_requisiciones_detail_1 = require("../models/grupo-requisiciones-detail");
var grupo_requisiciones_service_1 = require("../services/grupo-requisiciones.service");
var grupo_requisiciones_detail_editor_1 = require("./parts/grupo-requisiciones-detail.editor");
var GrupoRequisicionesEditor = /** @class */ (function (_super) {
    __extends(GrupoRequisicionesEditor, _super);
    function GrupoRequisicionesEditor(context, router, route, location, formBuilder, documentTypeService, grupoRequisicionesService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.grupoRequisicionesService = grupoRequisicionesService;
        _this.grupoRequisiciones = new grupo_requisiciones_1.GrupoRequisicionesInfo();
        _this.requisiciones = [];
        _this.documentForm = formBuilder.group({
            'sample': ['', forms_1.Validators.required],
        });
        return _this;
    }
    GrupoRequisicionesEditor_1 = GrupoRequisicionesEditor;
    GrupoRequisicionesEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
    };
    GrupoRequisicionesEditor.prototype.onCreatingDocument = function () {
    };
    GrupoRequisicionesEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.grupoRequisicionesService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.grupoRequisiciones = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GrupoRequisicionesEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.grupoRequisicionesService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.grupoRequisiciones = doc;
            _this.detailsEditor.clientIndexStart = _this.grupoRequisiciones.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GrupoRequisicionesEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.grupoRequisicionesService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.grupoRequisiciones = doc;
            _this.detailsEditor.clientIndexStart = _this.grupoRequisiciones.details.length;
            if (_this.grupoRequisiciones.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GrupoRequisicionesEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.grupoRequisicionesService.update(this.grupoRequisiciones)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.grupoRequisiciones.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.grupoRequisiciones = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GrupoRequisicionesEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.grupoRequisicionesService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GrupoRequisicionesEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.grupoRequisicionesService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GrupoRequisicionesEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.grupoRequisiciones.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    GrupoRequisicionesEditor.prototype.onAddingDetail = function () {
        this.detailsEditor.detail = new grupo_requisiciones_detail_1.GrupoRequisicionesDetail();
        this.detailsEditor.show();
    };
    GrupoRequisicionesEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    GrupoRequisicionesEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    GrupoRequisicionesEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.grupoRequisiciones.details = updatedDetails;
    };
    GrupoRequisicionesEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    GrupoRequisicionesEditor.prototype.loadRequisiciones = function () {
        var _this = this;
        var request = new search_1.SearchRequest();
        request.paged = false;
        //Agregar condición de empresa actual
        var condicion = { field: "IdEmpresa", operator: "=", valueType: "int", value: this.grupoRequisiciones.identity };
        request.conditions.push(condicion);
        //
        this.context.app.showSpinner();
        this.grupoRequisicionesService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.requisiciones = response.rows;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var GrupoRequisicionesEditor_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], GrupoRequisicionesEditor.prototype, "requisiciones", void 0);
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], GrupoRequisicionesEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", grupo_requisiciones_detail_editor_1.GrupoRequisicionesDetailEditor)
    ], GrupoRequisicionesEditor.prototype, "detailsEditor", void 0);
    GrupoRequisicionesEditor = GrupoRequisicionesEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-grupo-requisiciones-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'Grupo de Requisiciones'\"\n                                         [document]=\"grupoRequisiciones\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n\n                      <az-label [text]=\"'Guarde el documento de agrupacion de requisiciones para poder agregar requisiciones'\" *ngIf=\"grupoRequisiciones.identity==''\"></az-label>\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n\n                          </tab>\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\" >\n\n                              <compras-requisiciones-manager [requisiciones]=\"requisiciones\"\n                                                             [idGrupoRequisiciones]=\"grupoRequisiciones.identity\"\n                                                             (refreshListParent)=\"loadRequisiciones()\"\n                                                             >\n\n                              </compras-requisiciones-manager>\n\n                          </tab>\n\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"grupoRequisiciones.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <compras-grupo-requisiciones-detail-editor #detailsEditor                                     \n                                           (savingItem)=\"onSavingDetail($event)\">\n\n      </compras-grupo-requisiciones-detail-editor>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return GrupoRequisicionesEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: grupo_requisiciones_service_1.GrupoRequisicionesService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            grupo_requisiciones_service_1.GrupoRequisicionesService])
    ], GrupoRequisicionesEditor);
    return GrupoRequisicionesEditor;
}(editors_1.DocumentEditor));
exports.GrupoRequisicionesEditor = GrupoRequisicionesEditor;
