import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { FileInfo } from 'framework3/general';
import { ToolbarButton } from 'framework3/controls';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { ImportesInfo } from '../../accounting/models/importes';
import { NotaInfo } from '../models/nota';
import { NotaDetail } from '../models/nota-detail';
import { NotaService } from '../services/nota.service';
import { NotaDetailEditor } from './parts/notas-detail.editor';
import { ProveedorInfo } from '../models/proveedor';
import { CFDValiationResult } from '../models/cfd-validation-result';
import { ComprobanteFiscalService } from '../services/comprobante-fiscal.service';
import { ComprobanteFiscalInfo, ComprobanteFiscalItem } from '../models/comprobante-fiscal';
import { DivisaService } from '../../accounting/services/divisa.service';
import { EmpresaService } from '../../accounting/services/empresa.service';
export declare class NotasEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private notaService;
    private divisaService;
    private empresaService;
    private comprobanteFiscalService;
    nota: NotaInfo;
    origenesCF: {
        id: string;
        nombre: string;
    }[];
    origenCF: string;
    idProveedor: number;
    nombreProveedor: string;
    selectedFile: FileInfo;
    idDivisaDefault: number;
    tipoCambio: string;
    readonly importesC: ImportesInfo;
    readonly importesN: ImportesInfo;
    detailsList: EditableListComponent;
    detailsEditor: NotaDetailEditor;
    origenCFDialog: ModalDirective;
    comprobantesListDialog: ModalDirective;
    uploadDialog: ModalDirective;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, notaService: NotaService, divisaService: DivisaService, empresaService: EmpresaService, comprobanteFiscalService: ComprobanteFiscalService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: NotaDetail): void;
    onDeletingDetail(detail: NotaDetail): void;
    onListItemsUpdated(updatedDetails: NotaDetail[]): void;
    onSavingDetail(detail: NotaDetail): void;
    onProveedorChanged(proveedor: ProveedorInfo): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onOrigenCFSelected(): void;
    onComprobanteSelected(comprobante: ComprobanteFiscalItem): void;
    onAsignar(info: ComprobanteFiscalInfo): void;
    getDetailNew(idProveedor: number): void;
    importesDesglosados(origen: string): ImportesInfo;
    divisaAsignar(args: any): void;
    getDivisaDefault(creating: boolean): void;
    onFileChanged(file: FileInfo): void;
    onValidateFile(): void;
    validateFile(): void;
    cathComprobantes(ValidCFDcomprobantes: CFDValiationResult[]): void;
}
