"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var importes_1 = require("../../accounting/models/importes");
var nota_1 = require("../models/nota");
var nota_service_1 = require("../services/nota.service");
var notas_detail_editor_1 = require("./parts/notas-detail.editor");
var comprobante_fiscal_service_1 = require("../services/comprobante-fiscal.service");
var divisa_service_1 = require("../../accounting/services/divisa.service");
var empresa_service_1 = require("../../accounting/services/empresa.service");
var NotasEditor = /** @class */ (function (_super) {
    __extends(NotasEditor, _super);
    function NotasEditor(context, router, route, location, formBuilder, documentTypeService, notaService, divisaService, empresaService, comprobanteFiscalService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.notaService = notaService;
        _this.divisaService = divisaService;
        _this.empresaService = empresaService;
        _this.comprobanteFiscalService = comprobanteFiscalService;
        _this.nota = new nota_1.NotaInfo();
        _this.origenesCF = [];
        _this.origenCF = "L";
        _this.nombreProveedor = "";
        _this.idDivisaDefault = 0;
        _this.documentForm = formBuilder.group({
            'idProveedor': [0, forms_1.Validators.required],
            'idDivisa': [0, forms_1.Validators.required],
            'nombreProveedor': [''],
        });
        return _this;
    }
    NotasEditor_1 = NotasEditor;
    Object.defineProperty(NotasEditor.prototype, "importesC", {
        get: function () {
            return this.importesDesglosados('C');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NotasEditor.prototype, "importesN", {
        get: function () {
            return this.importesDesglosados('N');
        },
        enumerable: true,
        configurable: true
    });
    /*
    ngOnInit() {

        this.origenesCF =
            [
                { "id": 'L', "nombre": "Ruta Local" },
                { "id": 'A', "nombre": "Almacen digital" },
            ];
    }
    */
    NotasEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
        this.getDivisaDefault(true);
        this.origenesCF =
            [
                { "id": 'L', "nombre": "Ruta Local" },
                { "id": 'A', "nombre": "Almacen digital" },
            ];
    };
    NotasEditor.prototype.onCreatingDocument = function () {
        this.getDivisaDefault(true);
    };
    NotasEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.nota = doc;
            _this.getDivisaDefault(false);
            //this.divisaAsignar();
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.notaService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.nota = doc;
            _this.detailsEditor.clientIndexStart = _this.nota.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.nombreProveedor = doc.proveedor.nombre;
            _this.nota = doc;
            //this.divisaAsignar();
            _this.detailsEditor.clientIndexStart = _this.nota.details.length;
            if (_this.nota.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.update(this.nota)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.nota.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.nota = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.nota.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    NotasEditor.prototype.onAddingDetail = function () {
        //this.detailsEditor.detail = new NotaDetail();
        //this.detailsEditor.show();
    };
    NotasEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    NotasEditor.prototype.onDeletingDetail = function (detail) {
        //this.detailsList.deleteItem(detail);
    };
    NotasEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.nota.details = updatedDetails;
    };
    NotasEditor.prototype.onSavingDetail = function (detail) {
        var _this = this;
        this.detailsList.updateItem(detail);
        var suma = 0;
        this.nota.details.forEach(function (i) {
            suma = suma + i.importe;
            _this.nota.total = suma;
        });
    };
    NotasEditor.prototype.onProveedorChanged = function (proveedor) {
        this.idProveedor = proveedor.identity;
    };
    NotasEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'SELECCIONAR') {
            this.origenCFDialog.config.backdrop = false;
            this.idProveedor = 0;
            this.origenCFDialog.show();
        }
    };
    NotasEditor.prototype.onOrigenCFSelected = function () {
        if (this.origenCF == "A" && this.idProveedor == 0)
            this.showAlert("Debe seleccionar un proveedor ", 'danger');
        else {
            this.origenCFDialog.hide();
            // Ver que va a cargar
            //this.comprobantesListDialog.config.backdrop = false;
            if (this.origenCF == "A")
                this.comprobantesListDialog.show();
            else {
                this.uploadDialog.config.backdrop = false;
                this.uploadDialog.show();
            }
        }
    };
    NotasEditor.prototype.onComprobanteSelected = function (comprobante) {
        var _this = this;
        this.comprobanteFiscalService.getDetail(comprobante.id)
            .then(function (comp) {
            _this.onAsignar(comp);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onAsignar = function (info) {
        this.nombreProveedor = info.proveedor.nombre;
        this.nota.idProveedor = info.proveedor.identity;
        this.nota.idDivisa = info.comprobanteBase.divisa.identity;
        this.nota.idComprobante = info.identity;
        this.nota.fechaComprobante = info.fechaSys;
        this.nota.impuestosRetenidos = info.comprobanteBase.impuestos.totalRetenciones;
        this.nota.impuestosTrasladados = info.comprobanteBase.impuestos.totalTraslados;
        this.nota.comprobante = info;
        //this.divisaAsignar();
        this.getDetailNew(info.proveedor.identity);
    };
    NotasEditor.prototype.getDetailNew = function (idProveedor) {
        var _this = this;
        this.notaService.loadDetalleNew(idProveedor)
            .then(function (detNew) {
            _this.nota.details = detNew;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.importesDesglosados = function (origen) {
        var desglose = new importes_1.ImportesInfo();
        if (origen == 'C') {
            desglose.impuestosTrasladados = this.nota.impuestosTrasladados;
            desglose.impuestosRetenidos = this.nota.impuestosRetenidos;
            desglose.subtotal = this.nota.comprobante.comprobanteBase.subTotal;
            desglose.total = desglose.subtotal - desglose.descuentos + desglose.impuestosTrasladados - desglose.impuestosRetenidos;
        }
        if (origen == 'N') {
            this.nota.impuestosTrasladados = this.nota.comprobante.comprobanteBase.impuestos.totalTraslados;
            this.nota.impuestosRetenidos = this.nota.comprobante.comprobanteBase.impuestos.totalRetenciones;
            desglose.impuestosTrasladados = this.nota.impuestosTrasladados;
            desglose.impuestosRetenidos = this.nota.impuestosRetenidos;
            desglose.total = this.nota.total;
            desglose.subtotal = desglose.total + desglose.descuentos - desglose.impuestosTrasladados + desglose.impuestosRetenidos;
        }
        return desglose;
    };
    NotasEditor.prototype.divisaAsignar = function (args) {
        var _this = this;
        if (this.nota.idDivisa == this.idDivisaDefault) {
            this.nota.tipoCambio = 1;
            this.tipoCambio = this.nota.tipoCambio.toString();
        }
        else {
            this.divisaService.loadTiposCambio(this.context.app.defaultCompany.identity)
                .then(function (tipos) {
                var tCambio = tipos.find(function (search) { return search.idDivisaOrigen == _this.nota.idDivisa && search.idDivisaDestino == _this.idDivisaDefault; });
                if (tCambio == undefined) {
                    _this.showAlert("No está definido el tipo de cambio para la divisa seleccionada", "danger");
                    _this.tipoCambio = null;
                    _this.nota.idDivisa = null;
                    _this.nota.tipoCambio = 0;
                }
                else {
                    _this.empresaService.getDetailFromCache(_this.context.app.defaultCompany.identity)
                        .then(function (emp) {
                        if (emp.tipoCambio == 'O') {
                            _this.nota.tipoCambio = tCambio.precioOtro;
                            _this.tipoCambio = tCambio.precioOtro.toString();
                        }
                        else if (emp.tipoCambio == 'V') {
                            _this.nota.tipoCambio = tCambio.precioVenta;
                            _this.tipoCambio = tCambio.precioVenta.toString();
                        }
                        else if (emp.tipoCambio == 'C') {
                            _this.nota.tipoCambio = tCambio.precioCompra;
                            _this.tipoCambio = tCambio.precioCompra.toString();
                        }
                    });
                }
            });
        }
    };
    NotasEditor.prototype.getDivisaDefault = function (creating) {
        var _this = this;
        this.divisaService.getDetailByEmpresa(this.context.app.defaultCompany.identity)
            .then(function (r) {
            _this.idDivisaDefault = r.identity;
            if (creating) {
                _this.nota.idDivisa = r.identity;
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onFileChanged = function (file) {
        this.selectedFile = file;
    };
    NotasEditor.prototype.onValidateFile = function () {
        this.uploadDialog.hide();
        this.validateFile();
    };
    NotasEditor.prototype.validateFile = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteFiscalService.validate(this.context.app.defaultCompany.identity, this.selectedFile)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.cathComprobantes(result);
            //this.validatedFiles = result;
            //this.comprobantesCollection.sourceCollection = result;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.cathComprobantes = function (ValidCFDcomprobantes) {
        var _this = this;
        var promises = [];
        ValidCFDcomprobantes.forEach(function (validCFD) {
            if (validCFD.valid) {
                _this.context.app.showSpinner();
                var savePromise = _this.comprobanteFiscalService.save(0, _this.context.app.defaultCompany.identity, _this.context.app.defaultSite.identity, validCFD.comprobante.comprobanteBase.contenidoXML)
                    .then(function (comprobante) {
                    _this.context.app.hideSpinner();
                    _this.idProveedor = comprobante.proveedor.identity;
                    _this.onAsignar(comprobante);
                })
                    .catch(function (error) { return _this.handleError(error); });
            }
            else
                _this.showAlert("Algunos comprobantes no se pudieron validar correctamente:[" + validCFD.validationMessage + "]", "danger");
        });
    };
    var NotasEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], NotasEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", notas_detail_editor_1.NotaDetailEditor)
    ], NotasEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild('cargaComprobanteFiscalDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], NotasEditor.prototype, "origenCFDialog", void 0);
    __decorate([
        core_1.ViewChild('comprobantesList'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], NotasEditor.prototype, "comprobantesListDialog", void 0);
    __decorate([
        core_1.ViewChild('uploadDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], NotasEditor.prototype, "uploadDialog", void 0);
    NotasEditor = NotasEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-notas-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                  [title]=\"'Notas'\"\n                                  [document]=\"nota\"\n                                  [valid]=\"valid\"\n                                  (configureDocument)=\"onConfigureDocument($event)\"\n                                  (creatingDocument)=\"onCreatingDocument()\"\n                                  (viewingDocument)=\"onViewingDocument($event)\"\n                                  (cloningDocument)=\"onCloningDocument($event)\"\n                                  (savingDocument)=\"onSavingDocument($event)\"\n                                  (loadingDocument)=\"onLoadingDocument($event)\"\n                                  (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                  (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <label class=\"control-label\">Comprobante fiscal:</label>\n                      <accounting-importes-component [importes]=\"importesC\"></accounting-importes-component>\n                      <label class=\"control-label\">Captura:</label>\n                      <accounting-importes-component [importes]=\"importesN\"></accounting-importes-component>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n                              <br />\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                          <az-toolbar-button [name]=\"'SELECCIONAR'\" [type]=\"'primary'\" [text]=\"'Seleccionar nota'\" [toolTip]=\"'Seleccionar nota'\" [icon]=\"'glyphicon glyphicon-search'\" [enabled]=\"nota.identity=='' && nombreProveedor==''\"></az-toolbar-button>\n                                      </az-toolbar>\n                                  </div>\n                              </div>\n                              <br />\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <az-label [text]=\"'Proveedor: ' + nombreProveedor\"></az-label>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <az-label [text]=\"'Serie: ' + nota.comprobante.comprobanteBase.serie\"></az-label>\n                                      <az-label [text]=\"'Folio: ' + nota.comprobante.comprobanteBase.folio\"></az-label>\n                                  </div>\n                              </div>\n                              <br />\n                              <div class=\"row\">\n                                  <div class=\"col-10 col-md-4\">\n                                      <azteca-form-field [label]=\"'Divisa:'\">\n                                          <accounting-divisas-selector #divisasSelector formControlName=\"idDivisa\" [(ngModel)]=\"nota.idDivisa\" ngDefaultControl=\"\" [enabled]=\"false\" (selectedItemChanged)=\"divisaAsignar($event)\"></accounting-divisas-selector>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-10 col-md-4\">\n                                      <label class=\"control-label\">Tipo de cambio:</label>\n                                      <az-label [text]=\"tipoCambio\"></az-label>\n                                  </div>\n                              </div>\n\n\n                          </tab>\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #detailsList\n                                                    (addingItem)=\"onAddingDetail()\"\n                                                    (editingItem)=\"onEditingDetail($event)\"\n                                                    (deletingItem)=\"onDeletingDetail($event)\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    [listItems]=\"nota.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n\n                                  <azteca-grid-column [header]=\"'Cuenta por pagar'\" [binding]=\"'idCuentaPorPagar'\" [width]=\"'30*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Saldo'\" [binding]=\"'saldo'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'10*'\"></azteca-grid-column>\n\n\n                              </azteca-editable-list>\n                          </tab>\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"nota.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <compras-nota-detail-editor #detailsEditor\n                                  (savingItem)=\"onSavingDetail($event)\">\n\n      </compras-nota-detail-editor>\n\n\n      <!--Solicitar la forma en la que se carga el Comprobante Fiscal-->\n      <div bsModal #cargaComprobanteFiscalDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myEgresoModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n\n              <div class=\"modal-content\">\n\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\">Obtener el comprobante fiscal desde:</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n\n                  <div class=\"modal-body\">\n                      <alerts-bar></alerts-bar>\n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-6\">\n                              <az-combobox [(ngModel)]=\"origenCF\"\n                                           [items]=\"origenesCF\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'id'\">\n                              </az-combobox>\n                          </div>\n                      </div>\n\n                      <div class=\"row\" *ngIf=\"origenCF=='A'\">\n                          <div class=\"col-12 col-md-6\">\n                              <az-label [text]=\"'Proveedor:'\"></az-label>\n                          </div>\n                          <div class=\"col-12 col-md-6\">\n                              <purchasing-proveedor-selector [(ngModel)]=\"idProveedor\"\n                                                             [showListButton]=\"false\"\n                                                             (proveedorUpdated)=\"onProveedorChanged($event)\">\n                              </purchasing-proveedor-selector>\n                          </div>\n                      </div>\n\n                  </div>\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onOrigenCFSelected()\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\" (click)=\"cargaComprobanteFiscalDialog.hide()\">Cerrar</button>\n                  </div>\n              </div>\n              <!--</div>-->\n          </div>\n      </div>\n\n      <!--DIALOGO DE CARGA DE ARCHIVO LOCAL para el Comprobante Fiscal-->\n      <div bsModal #uploadDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"mySmallModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-sm\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n                      <div>Seleccione el archivo a cargar:</div>\n                      <azteca-file-box (fileChanged)=\"onFileChanged($event)\"></azteca-file-box>\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onValidateFile()\" [disabled]=\"!selectedFile\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-danger\" (click)=\"uploadDialog.hide()\">Cancelar</button>\n                  </div> <!--Modal Footer-->\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n      <!--DIALOGO DE CARGA DE ALMACEN DIGITAL-->\n      <purchasing-comprobantes-list #comprobantesList\n                                    (selectedItemChanged)=\"onComprobanteSelected($event)\"\n                                    [idProveedor]=\"idProveedor\"\n                                    [idComprobanteTipo]=\"2\"\n                                    [Activos]=\"true\"\n                                    [sinReferencia]=\"true\">\n      </purchasing-comprobantes-list>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return NotasEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: nota_service_1.NotaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            nota_service_1.NotaService,
            divisa_service_1.DivisaService,
            empresa_service_1.EmpresaService,
            comprobante_fiscal_service_1.ComprobanteFiscalService])
    ], NotasEditor);
    return NotasEditor;
}(editors_1.DocumentEditor));
exports.NotasEditor = NotasEditor;
