import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormGroup } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, BaseComponent, PolicyInfo } from 'framework3/core';
import { AlertsBarComponent } from 'framework3/controls';
import { CentralService } from '../services/central.service';
import { OrdenService } from '../services/orden.service';
import { SecurityContext } from '../models/security-context';
import { CentralItem } from '../models/central';
import { DepartamentoItem } from '../models/departamento';
import { OrdenRequisicionDetail } from '../models/orden-detail';
import { ProveedoresArticuloListComponent } from '../dialogs/proveedores-articulo-list.component';
import { ProveedoresServicioListComponent } from '../dialogs/proveedores-servicio-list.component';
import * as wjcCore from 'wijmo/wijmo';
import * as wjcGrid from 'wijmo/wijmo.grid';
import { FlexGrid } from 'wijmo/wijmo.grid';
export declare class OrdenesWizardEditorComponent extends BaseComponent {
    private context;
    private formBuilder;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private centralService;
    private ordenService;
    currentStep: number;
    form: FormGroup;
    idCentralCompras: number;
    idDepartamento: number;
    fechaIni: Date;
    fechaFin: Date;
    securityContext: SecurityContext[];
    centrales: CentralItem[];
    departamentos: DepartamentoItem[];
    requisiciones: OrdenRequisicionDetail[];
    data: wjcCore.CollectionView;
    dataPreview: wjcCore.CollectionView;
    grid: FlexGrid;
    groupItems: OrdenRequisicionDetail[];
    alerts: AlertsBarComponent;
    proveedoresArticulosDialog: ProveedoresArticuloListComponent;
    proveedoresServiciosDialog: ProveedoresServicioListComponent;
    gridPreview: FlexGrid;
    constructor(context: Context, formBuilder: FormBuilder, router: Router, route: ActivatedRoute, location: Location, centralService: CentralService, ordenService: OrdenService);
    ngOnInit(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
    initializeGrid(flex: wjcGrid.FlexGrid): void;
    loadCentrales(): void;
    loadDepartamentos(idCentral: number): void;
    onClickRequisiciones(): void;
    agregarProveedor(group: any): void;
    proveedorArticuloSelected(proveedor: any): void;
    proveedorServicioSelected(proveedor: any): void;
    onCellEditEnded(flex: any, e: any, cell: any): void;
    showPreview(): void;
    onClickPrev(): void;
    onClickNext(): void;
    onClickGenerar(): void;
    onClickCancel(): void;
}
