import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { OrdenInfo } from '../models/orden';
import { OrdenDetail } from '../models/orden-detail';
import { OrdenService } from '../services/orden.service';
import { OrdenDetailArticuloEditor } from './parts/ordenes-detail-articulos.editor';
import { OrdenDetailServicioEditor } from './parts/ordenes-detail-servicios.editor';
import { CentralItem } from '../models/central';
import { CentralService } from '../services/central.service';
import { DepartamentoItem } from '../models/departamento';
import { DepartamentoService } from '../services/departamento.service';
import { CentroRecepcionService } from '../services/centro-recepcion.service';
import { ProveedorInfo } from '../models/proveedor';
import { ProveedorSelectorComponent } from '../components/proveedor-selector.component';
import { SecurityContext } from '../models/security-context';
import { ImportesInfo } from '../../accounting/models/importes';
import { DivisaService } from '../../accounting/services/divisa.service';
import { ContribuyenteService } from '../../accounting/services/contribuyente.service';
import { DivisaInfo } from '../../accounting';
import { OrdenDetailArticulo } from '../models/orden-detail-articulo';
import { OrdenDetailServicio } from '../models/orden-detail-servicio';
export declare class OrdenesEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private ordenService;
    private centralService;
    private departamentoService;
    private centroRecepcionService;
    private divisaService;
    private contribuyenteService;
    orden: OrdenInfo;
    securityContext: SecurityContext[];
    centrales: CentralItem[];
    departamentos: DepartamentoItem[];
    centrosRecepcion: CentralItem[];
    articulos: OrdenDetail[];
    servicios: OrdenDetail[];
    idDivisaDefault: number;
    tipoCambio: string;
    articulosList: EditableListComponent;
    serviciosList: EditableListComponent;
    articulosEditor: OrdenDetailArticuloEditor;
    serviciosEditor: OrdenDetailServicioEditor;
    selProveedor: ProveedorSelectorComponent;
    readonly importes: ImportesInfo;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, ordenService: OrdenService, centralService: CentralService, departamentoService: DepartamentoService, centroRecepcionService: CentroRecepcionService, divisaService: DivisaService, contribuyenteService: ContribuyenteService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    separarDetail(): void;
    combineDetail(): OrdenDetail[];
    loadCentrales(): void;
    loadCentrosRecepcion(idCentral: number): void;
    loadDepartamentos(idCentroRecepcion: number): void;
    importesDesglosados(): ImportesInfo;
    getDivisaDefault(creating: boolean): void;
    onTabSelected(args: any): void;
    onProveedorChanged(proveedor: ProveedorInfo): void;
    onDivisaChanged(divisa: DivisaInfo): void;
    onAddingArticulo(): void;
    onEditingArticulo(detail: OrdenDetailArticulo): void;
    onDeletingArticulo(detail: OrdenDetailArticulo): void;
    onArticulosUpdated(updatedItems: OrdenDetailArticulo[]): void;
    onSavingArticulo(detail: OrdenDetailArticulo): void;
    onSavingArticulos(details: OrdenDetailArticulo[]): void;
    onAddingServicio(): void;
    onEditingServicio(detail: OrdenDetailServicio): void;
    onDeletingServicio(detail: OrdenDetailServicio): void;
    onServiciosUpdated(updatedServices: OrdenDetailServicio[]): void;
    onSavingServicio(detail: OrdenDetailServicio): void;
    onSavingServicios(details: OrdenDetailServicio[]): void;
}
