"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Locales
var orden_1 = require("../models/orden");
var orden_service_1 = require("../services/orden.service");
var ordenes_detail_articulos_editor_1 = require("./parts/ordenes-detail-articulos.editor");
var ordenes_detail_servicios_editor_1 = require("./parts/ordenes-detail-servicios.editor");
var central_service_1 = require("../services/central.service");
var departamento_service_1 = require("../services/departamento.service");
var centro_recepcion_service_1 = require("../services/centro-recepcion.service");
var proveedor_selector_component_1 = require("../components/proveedor-selector.component");
var importes_1 = require("../../accounting/models/importes");
var divisa_service_1 = require("../../accounting/services/divisa.service");
var contribuyente_service_1 = require("../../accounting/services/contribuyente.service");
var _ = require("lodash");
var orden_detail_articulo_1 = require("../models/orden-detail-articulo");
var orden_detail_servicio_1 = require("../models/orden-detail-servicio");
var OrdenesEditor = /** @class */ (function (_super) {
    __extends(OrdenesEditor, _super);
    function OrdenesEditor(context, router, route, location, formBuilder, documentTypeService, ordenService, centralService, departamentoService, centroRecepcionService, divisaService, contribuyenteService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.ordenService = ordenService;
        _this.centralService = centralService;
        _this.departamentoService = departamentoService;
        _this.centroRecepcionService = centroRecepcionService;
        _this.divisaService = divisaService;
        _this.contribuyenteService = contribuyenteService;
        _this.orden = new orden_1.OrdenInfo();
        _this.securityContext = [];
        _this.centrales = [];
        _this.departamentos = [];
        _this.centrosRecepcion = [];
        _this.articulos = [];
        _this.servicios = [];
        _this.documentForm = formBuilder.group({
            'idCentral': [0, controls_1.AztecaValidators.selected],
            'idDepartamento': [0, controls_1.AztecaValidators.selected],
            'idCentroRecepcion': [0, controls_1.AztecaValidators.selected],
            'idProveedor': [0, controls_1.AztecaValidators.selected],
            'fechaEntrega': [new Date],
            'idDivisa': [0, controls_1.AztecaValidators.selected],
        });
        return _this;
        //Suscribirse a cambios en central ya que esta determina varios comportamientos en los campos y validaciones
        //this.documentForm.controls['idCentral'].valueChanges.subscribe(value => {
        //    setTimeout(_ => this.loadCentrosRecepcion(value));
        //});
        //Suscribirse a cambios en central ya que esta determina varios comportamientos en los campos y validaciones
        //this.documentForm.controls['idCentroRecepcion'].valueChanges.subscribe(value => {
        //    setTimeout(_ =>this.loadDepartamentos(value));
        //});
    }
    OrdenesEditor_1 = OrdenesEditor;
    Object.defineProperty(OrdenesEditor.prototype, "importes", {
        get: function () {
            return this.importesDesglosados();
        },
        enumerable: true,
        configurable: true
    });
    OrdenesEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
        this.loadCentrales();
    };
    OrdenesEditor.prototype.onCreatingDocument = function () {
        this.getDivisaDefault(false);
    };
    OrdenesEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.ordenService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.orden = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    OrdenesEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.ordenService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.orden = doc;
            //
            _this.articulos = _this.orden.details.map(function (d) { return d; }).filter(function (d) { return d.idArticulo && d.idArticulo > 0; });
            _this.servicios = _this.orden.details.map(function (d) { return d; }).filter(function (d) { return d.idServicio && d.idServicio > 0; });
            //
            //this.detailsEditor.clientIndexStart = this.articulos.length;
            _this.articulosEditor.clientIndexStart = _this.articulos.length;
            _this.serviciosEditor.clientIndexStart = _this.servicios.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    OrdenesEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.ordenService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.loadCentrosRecepcion(doc.idCentralCompras);
            _this.loadDepartamentos(doc.idCentroRecepcion);
            _this.orden = doc;
            //separar el detalle en arreglo de articulos y servicios
            _this.separarDetail();
            if (_this.orden.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
            //setTimeout(_ => this.refreshValidity());
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    OrdenesEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.orden.details = this.combineDetail();
        this.ordenService.update(this.orden)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.orden.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.orden = updatedDoc;
            _this.separarDetail();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    OrdenesEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.ordenService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    OrdenesEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.ordenService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //////////////////////////// Metodos locales //////////////////////              
    //Separar articulos y servicios
    OrdenesEditor.prototype.separarDetail = function () {
        //
        this.articulos = this.orden.details.map(function (d) { return d; }).filter(function (d) { return d.idArticulo && d.idArticulo > 0; });
        this.servicios = this.orden.details.map(function (d) { return d; }).filter(function (d) { return d.idServicio && d.idServicio > 0; });
        //
        //this.detailsEditor.clientIndexStart = this.articulos.length + this.servicios.length;
        this.articulosEditor.clientIndexStart = this.articulos.length;
        this.serviciosEditor.clientIndexStart = this.servicios.length;
    };
    OrdenesEditor.prototype.combineDetail = function () {
        var newDetail = [];
        this.servicios.forEach(function (s) { return newDetail.push(s); });
        this.articulos.forEach(function (a) { return newDetail.push(a); });
        return newDetail;
    };
    OrdenesEditor.prototype.loadCentrales = function () {
        var _this = this;
        //this.centralService.loadListByUser(this.context.app.defaultSite.identity)
        //    .then(items => this.centrales = items)
        //    .catch(error => this.handleError(error));
        this.centralService.loadSecurityContext(this.context.app.defaultCompany.identity)
            .then(function (items) {
            _this.securityContext = items;
            var result = _(_this.securityContext).groupBy('idCentral').transform(function (result, current) {
                result.push({
                    id: current[0].idCentral,
                    nombre: current[0].central,
                });
            }, []).value();
            _this.centrales = result;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    OrdenesEditor.prototype.loadCentrosRecepcion = function (idCentral) {
        //this.centroRecepcionService.loadListByDepartamentoAndUser(idDepartamento, this.context.app.defaultSite.identity)
        //    .then(items => this.centrosRecepcion = items)
        //    .catch(error => this.handleError(error));
        var result = _(this.securityContext.filter(function (item) { return item.idCentral == idCentral; })).groupBy('idCentroRecepcion').transform(function (result, current) {
            result.push({
                id: current[0].idCentroRecepcion,
                nombre: current[0].centroRecepcion,
            });
        }, []).value();
        this.centrosRecepcion = result;
        if (this.centrosRecepcion.length > 0 && this.orden.identity == '')
            this.orden.idCentroRecepcion = this.centrosRecepcion[0].id;
    };
    OrdenesEditor.prototype.loadDepartamentos = function (idCentroRecepcion) {
        var _this = this;
        //this.departamentoService.loadListByCentralUser(idCentral, this.context.app.defaultSite.identity)
        //    .then(items => this.departamentos = items)
        //    .catch(error => this.handleError(error));
        var result = _(this.securityContext.filter(function (item) { return item.idCentral == _this.orden.idCentralCompras && item.idCentroRecepcion == idCentroRecepcion; })).groupBy('idDepartamento').transform(function (result, current) {
            result.push({
                id: current[0].idDepartamento,
                nombre: current[0].departamento,
                tipoPresupuesto: current[0].tipoPresupuesto,
                capturaDetallada: current[0].capturaDetallada
            });
        }, []).value();
        this.departamentos = result;
        if (this.departamentos.length > 0 && this.orden.identity == '')
            this.orden.idDepartamento = this.departamentos[0].id;
    };
    OrdenesEditor.prototype.importesDesglosados = function () {
        var desglose = new importes_1.ImportesInfo();
        var elementos = this.combineDetail().filter(function (item) { return item.state != 'DELETED'; });
        elementos.forEach(function (item) {
            desglose.subtotal += item.costoUnitario * item.cantidad;
            desglose.descuentos += (item.descuentos.descuento1 + item.descuentos.descuento2 + item.descuentos.descuento3 + item.descuentos.descuento4 + item.descuentos.descuento5) * item.cantidad;
            if (item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "T"; }).length > 0)
                desglose.impuestosTrasladados += item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "T"; }).map(function (imp) { return imp.importe * item.cantidad; }).reduce(function (a, b) { return a + b; });
            if (item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "R"; }).length > 0)
                desglose.impuestosRetenidos += item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "R"; }).map(function (imp) { return imp.importe * item.cantidad; }).reduce(function (a, b) { return a + b; });
        });
        desglose.total = desglose.subtotal - desglose.descuentos + desglose.impuestosTrasladados - desglose.impuestosRetenidos;
        return desglose;
    };
    //Metodos generales
    OrdenesEditor.prototype.getDivisaDefault = function (creating) {
        var _this = this;
        this.divisaService.getDetailByEmpresa(this.context.app.defaultCompany.identity)
            .then(function (r) {
            _this.orden.idDivisa = r.identity;
            _this.idDivisaDefault = r.identity;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ////////////////////////// Manejo de eventos /////////////
    OrdenesEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.orden.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    OrdenesEditor.prototype.onProveedorChanged = function (proveedor) {
        var _this = this;
        if (proveedor && proveedor.identity > 0) {
            var hoy = new Date();
            this.orden.fechaEntrega = hoy; // moment(hoy).add(proveedor.);        
            if (this.orden.identity == "") {
                this.contribuyenteService.inListaNegraEFO(proveedor.contribuyente.rfc, proveedor.idCompany)
                    .then(function (result) {
                    if (result == true) {
                        _this.showAlert("El contribuyente esta registrado como EFO", "danger");
                        _this.selProveedor.clear();
                    }
                })
                    .catch(function (error) { return _this.handleError(error); });
                this.articulos = [];
                this.servicios = [];
            }
        }
    };
    OrdenesEditor.prototype.onDivisaChanged = function (divisa) {
        var _this = this;
        this.orden.divisa = divisa;
        this.orden.details = [];
        //this.recepcionSinOC..sourceCollection = [];
        if (this.orden.idDivisa == this.idDivisaDefault) {
            this.orden.tipoCambio = 1;
        }
        else {
            if (this.orden.identity == '') //solo para documentos nuevos
             {
                this.divisaService.loadTiposCambio(this.context.app.defaultSite.identity)
                    .then(function (tipos) {
                    var tCambio = tipos.find(function (search) { return search.idDivisaOrigen == _this.orden.idDivisa && search.idDivisaDestino == divisa.identity; });
                    if (tCambio == undefined) {
                        _this.showAlert("No está definido el tipo de cambio para la divisa seleccionada", "danger");
                        _this.tipoCambio = null;
                        _this.orden.idDivisa = null;
                        _this.orden.tipoCambio = 0;
                    }
                    else {
                        _this.orden.tipoCambio = tCambio.precioOtro;
                    }
                });
            }
        }
        //
        this.tipoCambio = this.orden.tipoCambio.toString();
    };
    ///////////// ARTICULOS /////////////////////////
    OrdenesEditor.prototype.onAddingArticulo = function () {
        if (this.orden.idProveedor == undefined || this.orden.idProveedor == 0) {
            this.showAlert("No se ha seleccionado un proveedor", "warning");
        }
        else {
            this.articulosEditor.detail = new orden_detail_articulo_1.OrdenDetailArticulo();
            this.articulosEditor.show();
        }
    };
    OrdenesEditor.prototype.onEditingArticulo = function (detail) {
        this.articulosEditor.detail = detail;
        this.articulosEditor.onLoadingItem(detail);
        this.articulosEditor.show();
        //this.quantityEditor.unidadMedida = detail.articulo.articuloStock.unidadMedida;
        //this.quantityEditor.cantidad = detail.cantidad;
        //this.quantityEditor.unidades = detail.unidades;
        //this.quantityEditor.show();
    };
    OrdenesEditor.prototype.onDeletingArticulo = function (detail) {
        this.articulosList.deleteItem(detail);
    };
    OrdenesEditor.prototype.onArticulosUpdated = function (updatedItems) {
        this.articulos = updatedItems;
    };
    OrdenesEditor.prototype.onSavingArticulo = function (detail) {
        this.articulosList.updateItem(detail);
    };
    OrdenesEditor.prototype.onSavingArticulos = function (details) {
        this.articulosList.updateItems(details);
    };
    //onUpdateQuantity(value: any) {
    //    let detail = <OrdenDetailArticulo>this.articulosList.currentItem;
    //    if (detail.unidadMedida.paquete) {
    //        let cantidad = <Empaquetado>value;
    //        detail.cantidad = cantidad.paquetes;
    //        detail.unidades = cantidad.unidades;
    //    }
    //    else {
    //        detail.cantidad = <number>value;
    //    }
    //    this.articulosList.updateItem(detail);
    //}
    ///////////// SERVICIOS /////////////////////////
    OrdenesEditor.prototype.onAddingServicio = function () {
        if (this.orden.idProveedor == undefined || this.orden.idProveedor == 0) {
            this.showAlert("No se ha seleccionado un proveedor", "warning");
        }
        else {
            this.serviciosEditor.detail = new orden_detail_servicio_1.OrdenDetailServicio();
            this.serviciosEditor.show();
        }
    };
    OrdenesEditor.prototype.onEditingServicio = function (detail) {
        this.serviciosEditor.detail = detail;
        this.serviciosEditor.show();
    };
    OrdenesEditor.prototype.onDeletingServicio = function (detail) {
        this.serviciosList.deleteItem(detail);
    };
    OrdenesEditor.prototype.onServiciosUpdated = function (updatedServices) {
        this.servicios = updatedServices;
    };
    OrdenesEditor.prototype.onSavingServicio = function (detail) {
        this.serviciosList.updateItem(detail);
    };
    OrdenesEditor.prototype.onSavingServicios = function (details) {
        this.serviciosList.updateItems(details);
    };
    var OrdenesEditor_1;
    __decorate([
        core_1.ViewChild('articulosList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], OrdenesEditor.prototype, "articulosList", void 0);
    __decorate([
        core_1.ViewChild('serviciosList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], OrdenesEditor.prototype, "serviciosList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditorArticulos'),
        __metadata("design:type", ordenes_detail_articulos_editor_1.OrdenDetailArticuloEditor)
    ], OrdenesEditor.prototype, "articulosEditor", void 0);
    __decorate([
        core_1.ViewChild('detailsEditorServicios'),
        __metadata("design:type", ordenes_detail_servicios_editor_1.OrdenDetailServicioEditor)
    ], OrdenesEditor.prototype, "serviciosEditor", void 0);
    __decorate([
        core_1.ViewChild('selProveedor'),
        __metadata("design:type", proveedor_selector_component_1.ProveedorSelectorComponent)
    ], OrdenesEditor.prototype, "selProveedor", void 0);
    OrdenesEditor = OrdenesEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-ordenes-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                  [title]=\"'Ordenes'\"\n                                  [document]=\"orden\"\n                                  [valid]=\"valid\"\n                                  (configureDocument)=\"onConfigureDocument($event)\"\n                                  (creatingDocument)=\"onCreatingDocument()\"\n                                  (viewingDocument)=\"onViewingDocument($event)\"\n                                  (cloningDocument)=\"onCloningDocument($event)\"\n                                  (savingDocument)=\"onSavingDocument($event)\"\n                                  (loadingDocument)=\"onLoadingDocument($event)\"\n                                  (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                  (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <accounting-importes-component [importes]=\"importes\"></accounting-importes-component>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Central:'\">\n                                          <az-combobox formControlName=\"idCentral\"\n                                                       [(ngModel)]=\"orden.idCentralCompras\"\n                                                       [items]=\"centrales\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\"\n                                                       (selectedItemChanged)=\"loadCentrosRecepcion($event)\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Centro de Recepci\u00F3n:'\">\n                                          <az-combobox formControlName=\"idCentroRecepcion\"\n                                                       [(ngModel)]=\"orden.idCentroRecepcion\"\n                                                       [items]=\"centrosRecepcion\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\"\n                                                       (selectedItemChanged)=\"loadDepartamentos($event)\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Departamento:'\">\n                                          <az-combobox formControlName=\"idDepartamento\"\n                                                       [(ngModel)]=\"orden.idDepartamento\"\n                                                       [items]=\"departamentos\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Proveedor:'\">\n                                          <purchasing-proveedor-selector #selProveedor\n                                                                         formControlName=\"idProveedor\"\n                                                                         [(ngModel)]=\"orden.idProveedor\"\n                                                                         (proveedorUpdated)=\"onProveedorChanged($event)\"\n                                                                         [proveedorSelector]=\"orden.identity==''\">\n                                          </purchasing-proveedor-selector>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Fecha de entrega:'\">\n                                          <az-input-date formControlName=\"fechaEntrega\"\n                                                         [(ngModel)]=\"orden.fechaEntrega\">\n                                          </az-input-date>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Divisa:'\">\n                                          <accounting-divisas-selector formControlName=\"idDivisa\"\n                                                                       [(ngModel)]=\"orden.idDivisa\"\n                                                                       (selectedItemChanged)=\"onDivisaChanged($event)\">\n                                          </accounting-divisas-selector>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-6 col-md-1\">\n                                      <label class=\"control-label\">T.C.:</label>\n                                      <az-label [text]=\"tipoCambio\"></az-label>\n                                  </div>\n\n                              </div>\n\n\n                          </tab>\n\n                          <!--ARTICULOS -->\n                          <tab heading=\"Art\u00EDculos\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #articulosList\n                                                    (addingItem)=\"onAddingArticulo()\"\n                                                    (editingItem)=\"onEditingArticulo($event)\"\n                                                    (deletingItem)=\"onDeletingArticulo($event)\"\n                                                    (listItemsUpdated)=\"onArticulosUpdated($event)\"\n                                                    [listItems]=\"articulos\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar art\u00EDculo'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar art\u00EDculo'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'Departamento'\" [binding]=\"'departamento'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'articulo.code'\" [width]=\"100\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Descripci\u00F3n'\" [binding]=\"'articulo.articuloStock.nombre'\" [width]=\"'50*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'U.M.'\" [binding]=\"'articulo.articuloStock.unidadMedida.nombre'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Unidades'\" [binding]=\"'unidades'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Precio'\" [binding]=\"'costoUnitario'\" [width]=\"'10*'\" format=\"c\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'20*'\" format=\"c\"></azteca-grid-column>\n                              </azteca-editable-list>\n                          </tab>\n                          <!--SERVICIOS -->\n                          <tab heading=\"Servicios\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #serviciosList\n                                                    (addingItem)=\"onAddingServicio()\"\n                                                    (editingItem)=\"onEditingServicio($event)\"\n                                                    (deletingItem)=\"onDeletingServicio($event)\"\n                                                    (listItemsUpdated)=\"onServiciosUpdated($event)\"\n                                                    [listItems]=\"servicios\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar servicio'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar servicio'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'Departamento'\" [binding]=\"'departamento'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'servicio.code'\" [width]=\"100\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Descripci\u00F3n'\" [binding]=\"'servicio.nombre'\" [width]=\"'50*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Costo'\" [binding]=\"'costoUnitario'\" [width]=\"'10*'\" format=\"c\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'10*'\" format=\"c\"></azteca-grid-column>\n\n                              </azteca-editable-list>\n                          </tab>\n\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"orden.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n\n\n          <!--<compras-orden-detail-editor #detailsEditor\n                                       (savingItem)=\"onSavingDetail($event)\"\n                                       [idProveedor]=\"orden.idProveedor\"\n                                       [departamentos]=\"departamentos\">\n          </compras-orden-detail-editor>-->\n\n          <compras-orden-detail-articulos-editor #detailsEditorArticulos\n                                                 (savingItem)=\"onSavingArticulo($event)\"\n                                                 [idProveedor]=\"orden?orden.idProveedor:0\"\n                                                 [departamentos]=\"departamentos\">\n          </compras-orden-detail-articulos-editor>\n\n          <compras-orden-detail-servicios-editor #detailsEditorServicios\n                                                 (savingItem)=\"onSavingServicio($event)\"\n                                                 [idProveedor]=\"orden.idProveedor\"\n                                                 [departamentos]=\"departamentos\">\n          </compras-orden-detail-servicios-editor>\n\n          <!--(savingItem)=\"onSavingArticuloDetail($event)\"-->\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return OrdenesEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: orden_service_1.OrdenService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            orden_service_1.OrdenService,
            central_service_1.CentralService,
            departamento_service_1.DepartamentoService,
            centro_recepcion_service_1.CentroRecepcionService,
            divisa_service_1.DivisaService,
            contribuyente_service_1.ContribuyenteService])
    ], OrdenesEditor);
    return OrdenesEditor;
}(editors_1.DocumentEditor));
exports.OrdenesEditor = OrdenesEditor;
