import { Router, ActivatedRoute } from '@angular/router';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, DocumentItem, PolicyInfo } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { MenuItem } from 'framework3/controls';
import { SearchRequest } from 'framework3/search';
import { ContentViewerComponent } from 'framework3/controls/components/content-viewer.component';
import { OrdenItem } from '../models/orden';
import { OrdenService } from '../services/orden.service';
import { ReportService } from 'framework3/core';
export declare class OrdenesManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private ordenService;
    private reportSvc;
    ordenesTit: OrdenItem[];
    opcionesNew: {
        id: string;
        nombre: string;
    }[];
    opcionNew: string;
    dlgTipo: ModalDirective;
    reportViewer: ContentViewerComponent;
    titleContentView: string;
    fileNameContentView: string;
    constructor(context: Context, router: Router, route: ActivatedRoute, ordenService: OrdenService, reportSvc: ReportService);
    onConfigureDocument(): void;
    applyPolicy(policy: PolicyInfo): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onMenuItemClick(option: MenuItem): void;
    onTipoAddAceptar(): void;
}
