"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
// Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var content_viewer_component_1 = require("framework3/controls/components/content-viewer.component");
var orden_service_1 = require("../services/orden.service");
var core_3 = require("framework3/core");
var OrdenesManager = /** @class */ (function (_super) {
    __extends(OrdenesManager, _super);
    function OrdenesManager(context, router, route, ordenService, reportSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.ordenService = ordenService;
        _this.reportSvc = reportSvc;
        _this.opcionesNew = [];
        _this.opcionNew = "N";
        _this.titleContentView = "";
        _this.fileNameContentView = "";
        _this.opcionesNew =
            [
                { "id": 'N', "nombre": "Normal" },
                { "id": 'W', "nombre": "Asistente para requisiciones" }
            ];
        return _this;
    }
    OrdenesManager_1 = OrdenesManager;
    OrdenesManager.prototype.onConfigureDocument = function () {
        this.refreshList();
        this.applyPolicies();
    };
    //applyPolicies() {
    //    let mnuAsistente: MenuItem = { icon: "glyphicon glyphicon-duplicate", text: "Asistente para generación de ordenes", name: "mnuAsistente", smallText: "generación de ordenes a partir de requisiciones" };
    //    this.manager.menuItems.push(mnuAsistente);
    //}
    OrdenesManager.prototype.applyPolicy = function (policy) {
        if (policy.valor == 'ASISTENTE_OC') {
            var mnuAsistente = { icon: "glyphicon glyphicon-duplicate", text: "Asistente para generación de ordenes", name: "ASISTENTE_OC", smallText: "generación de ordenes a partir de requisiciones", enabled: true };
            this.manager.menuItems.push(mnuAsistente);
        }
    };
    OrdenesManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.ordenService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.ordenesTit = response.rows;
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    OrdenesManager.prototype.onAddingItem = function () {
        // Dialogo para seleccionar si se quiere usar el asistente de oc o el editor de oc
        //this.dlgTipo.config.backdrop = false;
        //this.dlgTipo.show();
        this.router.navigate(['0'], { relativeTo: this.route });
    };
    OrdenesManager.prototype.onViewingItem = function (document) {
        this.router.navigate([document.id, { readonly: true }], { relativeTo: this.route });
    };
    OrdenesManager.prototype.onEditingItem = function (document) {
        this.router.navigate([document.id], { relativeTo: this.route });
    };
    OrdenesManager.prototype.onDeletingItem = function (document) {
        var _this = this;
        this.ordenService.delete(document.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El documento ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    OrdenesManager.prototype.onCloningItem = function (document) {
        this.router.navigate([0, { cloneId: document.id }], { relativeTo: this.route });
    };
    OrdenesManager.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.ordenService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    OrdenesManager.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.ordenService.previousStep(document.id, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    OrdenesManager.prototype.onMenuItemClick = function (option) {
        var _this = this;
        if (option.name == 'PDF') {
            if (this.manager.currentDocument.idStatus > 1) {
                this.context.app.showSpinner();
                this.ordenService.generarPdfOrden(this.manager.currentDocument.id)
                    .then(function (file) {
                    _this.context.app.hideSpinner();
                    window.open('/file-server/' + file.uri, '_blank');
                })
                    .catch(function (error) { return _this.handleError(error); });
            }
            else {
                this.showAlert('No puede imprimir una orden en el estatus actual.', 'success');
            }
        }
        if (option.name == 'ASISTENTE_OC') {
            this.router.navigate(['0/wizard'], { relativeTo: this.route });
        }
        //else if (option.name == 'PDF') {
        //    this.context.app.showSpinner();
        //    let item = <OrdenItem> this.manager.currentDocument;
        //    let informe = new ReporteInfo();
        //    let parametro = new ParametroInfo();
        //    parametro.name = "IdOrdenTit";
        //    parametro.values.push(item.id);
        //    informe.parametros.push(parametro);
        //    informe.path = "/Onili/Compras/OrdenRPT";
        //    informe.format = "pdf";
        //    this.reportSvc.loadReporte(informe)
        //        .then(info => {
        //            this.context.app.hideSpinner();
        //            let item = <OrdenItem>this.manager.currentDocument;
        //            this.titleContentView = "Orden " + item.id;
        //            this.fileNameContentView = item.id + ".pdf";
        //            this.reportViewer.show("data:application/pdf; base64, " + info.content);
        //        })
        //        .catch(error => this.handleError(error));
        //}
    };
    OrdenesManager.prototype.onTipoAddAceptar = function () {
        if (this.opcionNew == "W")
            this.router.navigate(['0/wizard'], { relativeTo: this.route });
        else
            this.router.navigate(['0'], { relativeTo: this.route });
    };
    var OrdenesManager_1;
    __decorate([
        core_1.ViewChild('tipoDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], OrdenesManager.prototype, "dlgTipo", void 0);
    __decorate([
        core_1.ViewChild(content_viewer_component_1.ContentViewerComponent),
        __metadata("design:type", content_viewer_component_1.ContentViewerComponent)
    ], OrdenesManager.prototype, "reportViewer", void 0);
    OrdenesManager = OrdenesManager_1 = __decorate([
        core_1.Component({
            selector: 'compras-ordenes-manager',
            template: "\n          <div class=\"card\">\n          <div class=\"card-header\">Ordenes</div>\n          <div class=\"card-block\">\n              <azteca-document-manager (searchRequested)=\"onSearchRequested($event)\"\n                                       (addingItem)=\"onAddingItem()\"\n                                       (viewingItem)=\"onViewingItem($event)\"\n                                       (editingItem)=\"onEditingItem($event)\"\n                                       (deletingItem)=\"onDeletingItem($event)\"\n                                       (cloningItem)=\"onCloningItem($event)\"\n                                       (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                       (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                       (configureDocument)=\"onConfigureDocument($event)\"\n                                       (menuItemClick)=\"onMenuItemClick($event)\"\n                                       [enabled]=\"enabled\"\n                                       [allowNew]=\"allowNew\"\n                                       [allowView]=\"allowView\"\n                                       [allowEdit]=\"allowEdit\"\n                                       [allowDelete]=\"allowDelete\"\n                                       [allowClone]=\"allowClone\"\n                                       [allowNext]=\"allowNext\"\n                                       [allowPrevious]=\"allowPrevious\"\n                                       [allowAudit]=\"allowAudit\"\n                                       [filterGroups]=\"filterGroups\"\n                                       [documentList]=\"ordenesTit\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'PDF'\" [icon]=\"'glyphicon glyphicon-print'\" [text]=\"'Imprimir'\" [smallText]=\"'generar pdf de la orden'\" ></azteca-menu-item>\n\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"190\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"160\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Proveedor'\" [binding]=\"'proveedor'\" [width]=\"250\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Dias Credito'\" [binding]=\"'diasCredito'\" [width]=\"90\" dataType=\"Number\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha Entrega'\" [binding]=\"'fechaEntrega'\" [width]=\"160\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha Revisi\u00F3n'\" [binding]=\"'fechaRevision'\" [width]=\"160\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha Autorizacion'\" [binding]=\"'fechaAutorizacion'\" [width]=\"160\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Dias Vencidos'\" [binding]=\"'diasVencidos'\" dataType=\"Number\"[width]=\"100\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"150\" dataType=\"Number\" format=\"c\"></azteca-grid-column>\n\n                  <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"100\"></azteca-grid-column>\n\n              </azteca-document-manager>\n          </div>\n      </div>\n\n      <!-- Tipo de Orden -->\n      <div bsModal #tipoDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\">Opcion de generaci\u00F3n de orden...</h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"viewDialog.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <az-combobox [(ngModel)]=\"opcionNew\"\n                                   [items]=\"opcionesNew\"\n                                   [valueMember]=\"'id'\"\n                                   [displayMember]=\"'nombre'\">\n                      </az-combobox>\n                  </div> <!--Modal Body-->\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-default\" data-dismiss=\"modal\" (click)=\"viewDialog.hide()\">Cancelar</button>\n                      <button type=\"button\" class=\"btn btn-primary\" data-dismiss=\"modal\" (click)=\"onTipoAddAceptar()\">Aceptar</button>\n                  </div>\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return OrdenesManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: orden_service_1.OrdenService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, orden_service_1.OrdenService, core_3.ReportService])
    ], OrdenesManager);
    return OrdenesManager;
}(editors_1.DocumentManager));
exports.OrdenesManager = OrdenesManager;
