"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var nota_detail_1 = require("../../models/nota-detail");
var NotaDetailEditor = /** @class */ (function (_super) {
    __extends(NotaDetailEditor, _super);
    function NotaDetailEditor(context, builder) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.builder = builder;
        //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
        _this.detailCopy = new nota_detail_1.NotaDetail();
        //Objeto original que se editará
        _this.detail = new nota_detail_1.NotaDetail();
        _this.total = 0;
        _this.form = builder.group({
            'total': [0],
        });
        return _this;
    }
    /////////////////// METODOS ///////////////////////////////
    /////////////////// HANDLERS //////////////////////////////
    NotaDetailEditor.prototype.onCreatingItem = function () {
        this.detailCopy = this.detail;
        this.form.reset({ sample: '' });
        this.form.markAsPristine();
    };
    NotaDetailEditor.prototype.onLoadingItem = function (detail) {
        this.detailCopy = this.copyItem(this.detail);
    };
    NotaDetailEditor.prototype.onUpdatingItem = function (detail) {
        if (this.detailCopy._clientID == 0) {
            this.detailCopy._clientID = this.createClientID();
        }
        else {
            this.detailCopy.state = editors_1.ChangeState.MODIFIED;
        }
        this.savingItem.emit(this.detailCopy);
    };
    NotaDetailEditor.prototype.onCellEditEnded = function (flex, e) {
        var sum = 0;
        flex.rows.forEach(function (item) {
            sum = sum + item.dataItem.importe;
        });
        this.detailCopy.importe = sum;
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", nota_detail_1.NotaDetail)
    ], NotaDetailEditor.prototype, "detail", void 0);
    NotaDetailEditor = __decorate([
        core_1.Component({
            selector: 'compras-nota-detail-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <azteca-basic-editor [item]=\"detail\"\n                               [dirty]=\"dirty\"\n                               [valid]=\"valid\"\n                               (creatingItem)=\"onCreatingItem()\"\n                               (loadingItem)=\"onLoadingItem($event)\"\n                               (updatingItem)=\"onUpdatingItem($event)\">\n\n              <wj-flex-grid #grid style=\"height:200px\"\n                            [itemsSource]=\"detailCopy.categoriasPresupuestales\"\n                            [isReadOnly]=\"false\"\n                            (cellEditEnded)=\"onCellEditEnded(grid, $event)\">\n\n                  <wj-flex-grid-column [header]=\"'Categor\u00EDa presupuestal'\" [binding]=\"'nombreCategoriaPresupuestal'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'10*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n\n\n              </wj-flex-grid>\n\n              <azteca-form-field [label]=\"'Total:'\">\n                  <az-textbox formControlName=\"total\" [(ngModel)]=\"detailCopy.importe\" [enabled]=\"false\"></az-textbox>\n              </azteca-form-field>\n\n          </azteca-basic-editor>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder])
    ], NotaDetailEditor);
    return NotaDetailEditor;
}(editors_1.BasicEditor));
exports.NotaDetailEditor = NotaDetailEditor;
