"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Framework
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//Compras
var costo_presupuesto_service_1 = require("../../services/costo-presupuesto.service");
var presupuestos_service_1 = require("../../services/presupuestos.service");
var NuevoCostosPresupuestosComponent = /** @class */ (function () {
    function NuevoCostosPresupuestosComponent(formBuilder, router, route, context, costoPresupuestoSvc, presupuestoService) {
        this.formBuilder = formBuilder;
        this.router = router;
        this.route = route;
        this.context = context;
        this.costoPresupuestoSvc = costoPresupuestoSvc;
        this.presupuestoService = presupuestoService;
        this.presupuestos = [];
        this.form = formBuilder.group({
            'idDepartamento': [0],
            'idPresupuestoSelected': [''],
            'idBeneficiario': [0]
        });
    }
    /////////// HANDLERS
    NuevoCostosPresupuestosComponent.prototype.onToolbarClick = function (button) {
        if (button.name == 'ACEPTAR') {
            this.router.navigate(['../', '0', { idPresupuesto: this.idPresupuestoSelected, idDepartamento: this.idDepartamento, idBeneficiario: this.idBeneficiario }], { relativeTo: this.route });
        }
        else if (button.name == 'CANCEL') {
            this.router.navigate(['../'], { relativeTo: this.route });
        }
    };
    NuevoCostosPresupuestosComponent.prototype.ngOnInit = function () {
    };
    NuevoCostosPresupuestosComponent.prototype.loadPresupuestos = function (depa) {
        var _this = this;
        this.presupuestoService.loadPresupuestos(depa.identity)
            .then(function (ret) {
            _this.presupuestos = ret;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NuevoCostosPresupuestosComponent.prototype.handleError = function (error) {
        console.log(error);
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alertsBar.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], NuevoCostosPresupuestosComponent.prototype, "alertsBar", void 0);
    NuevoCostosPresupuestosComponent = __decorate([
        core_1.Component({
            selector: 'compras-nuevo-costos-presupuestos',
            template: "\n      <form [formGroup]=\"form\">\n          <az-panel [header]=\"'Nueva costo presupuestal'\">\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-8\">\n                      <alerts-bar></alerts-bar>\n                      <az-toolbar (buttonClick)=\"onToolbarClick($event)\">\n                          <az-toolbar-button [name]=\"'ACEPTAR'\" [text]=\"'Aceptar'\" [icon]=\"'glyphicon glyphicon-ok'\"></az-toolbar-button>\n                          <az-toolbar-button [name]=\"'CANCEL'\" [text]=\"'Cancelar'\" [icon]=\"'glyphicon glyphicon-remove'\"></az-toolbar-button>\n                      </az-toolbar>\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <label class=\"control-label\">Departamento:</label>\n\n                              <purchasing-departamentos-selector formControlName=\"idDepartamento\"\n                                                                 [(ngModel)]=\"idDepartamento\"\n                                                                 (selectedItemChanged)=\"loadPresupuestos($event)\">\n                              </purchasing-departamentos-selector>\n\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <label class=\"control-label\">Presupuesto:</label>\n\n                              <az-combobox formControlName=\"idPresupuestoSelected\"\n                                           [(ngModel)]=\"idPresupuestoSelected\"\n                                           [items]=\"presupuestos\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'id'\">\n                              </az-combobox>\n\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <label class=\"control-label\">Beneficiario:</label>\n\n\n                              <treasury-beneficiario-selector #selectorBeneficiario\n                                                              formControlName=\"idBeneficiario\"\n                                                              [(ngModel)]=\"idBeneficiario\">\n                              </treasury-beneficiario-selector>\n\n                          </div>\n                      </div>\n\n\n                  </div>\n              </div>\n          </az-panel>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute,
            core_2.Context,
            costo_presupuesto_service_1.CostoPresupuestoService,
            presupuestos_service_1.PresupuestosService])
    ], NuevoCostosPresupuestosComponent);
    return NuevoCostosPresupuestosComponent;
}());
exports.NuevoCostosPresupuestosComponent = NuevoCostosPresupuestosComponent;
