import { Router, ActivatedRoute } from '@angular/router';
import { FormGroup, FormBuilder } from '@angular/forms';
import { Context } from 'framework3/core';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { GastoService } from '../../services/gasto.service';
import { PresupuestosService } from '../../services/presupuestos.service';
import { GastoTipoService } from '../../services/gasto-tipo.service';
import { PresupuestosItem } from '../../models/presupuestos';
import { DepartamentoInfo, DepartamentoItem } from '../../models/departamento';
import { DepartamentoService } from '../../services/departamento.service';
import { GastoTipoItem } from '../../models/gasto-tipo';
export declare class NuevoGastoComponent {
    private formBuilder;
    private router;
    private route;
    private context;
    private gastoSvc;
    private presupuestoService;
    private gastoTipoService;
    private departamentoService;
    form: FormGroup;
    idDepartamento: number;
    idPresupuestoSelected: string;
    idGastoTipo: number;
    presupuestos: PresupuestosItem[];
    gastosTipos: GastoTipoItem[];
    departamento: DepartamentoInfo;
    departamentos: DepartamentoItem[];
    alertsBar: AlertsBarComponent;
    constructor(formBuilder: FormBuilder, router: Router, route: ActivatedRoute, context: Context, gastoSvc: GastoService, presupuestoService: PresupuestosService, gastoTipoService: GastoTipoService, departamentoService: DepartamentoService);
    onToolbarClick(button: ToolbarButton): void;
    ngOnInit(): void;
    loadPresupuestos(idDepartamento: any): void;
    loadGastosTipos(): void;
    loadDepartamentos(): void;
    handleError(error: any): void;
}
