"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Framework
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//Compras
var gasto_service_1 = require("../../services/gasto.service");
var presupuestos_service_1 = require("../../services/presupuestos.service");
var gasto_tipo_service_1 = require("../../services/gasto-tipo.service");
var departamento_service_1 = require("../../services/departamento.service");
var NuevoGastoComponent = /** @class */ (function () {
    function NuevoGastoComponent(formBuilder, router, route, context, gastoSvc, presupuestoService, gastoTipoService, departamentoService) {
        this.formBuilder = formBuilder;
        this.router = router;
        this.route = route;
        this.context = context;
        this.gastoSvc = gastoSvc;
        this.presupuestoService = presupuestoService;
        this.gastoTipoService = gastoTipoService;
        this.departamentoService = departamentoService;
        this.presupuestos = [];
        this.gastosTipos = [];
        this.departamentos = [];
        this.form = formBuilder.group({
            'idDepartamento': [0],
            'idGastoTipo': [0],
            'idPresupuestoSelected': ['']
        });
    }
    /////////// HANDLERS
    NuevoGastoComponent.prototype.onToolbarClick = function (button) {
        if (button.name == 'ACEPTAR') {
            this.router.navigate(['../', '0', { idPresupuesto: this.idPresupuestoSelected, idDepartamento: this.idDepartamento, idGastoTipo: this.idGastoTipo }], { relativeTo: this.route });
        }
        else if (button.name == 'CANCEL') {
            this.router.navigate(['../'], { relativeTo: this.route });
        }
    };
    NuevoGastoComponent.prototype.ngOnInit = function () {
        this.loadGastosTipos();
        this.loadDepartamentos();
    };
    NuevoGastoComponent.prototype.loadPresupuestos = function (idDepartamento) {
        var _this = this;
        this.presupuestoService.loadPresupuestos(idDepartamento)
            .then(function (ret) {
            _this.presupuestos = ret.filter(function (item) { return item.workFlowStepTag == 'OPEN'; });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NuevoGastoComponent.prototype.loadGastosTipos = function () {
        var _this = this;
        this.gastoTipoService.loadListByUser(this.context.app.defaultSite.idBranch)
            .then(function (ret) {
            _this.gastosTipos = ret;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NuevoGastoComponent.prototype.loadDepartamentos = function () {
        var _this = this;
        this.departamentoService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (items) { return _this.departamentos = items; })
            .catch(function (error) { return _this.handleError(error); });
    };
    NuevoGastoComponent.prototype.handleError = function (error) {
        console.log(error);
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alertsBar.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], NuevoGastoComponent.prototype, "alertsBar", void 0);
    NuevoGastoComponent = __decorate([
        core_1.Component({
            selector: 'compras-nuevo-gasto',
            template: "\n      <form [formGroup]=\"form\">\n          <az-panel [header]=\"'Nueva gasto'\">\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-8\">\n                      <alerts-bar></alerts-bar>\n                      <az-toolbar (buttonClick)=\"onToolbarClick($event)\">\n                          <az-toolbar-button [name]=\"'ACEPTAR'\" [text]=\"'Aceptar'\" [icon]=\"'glyphicon glyphicon-ok'\"></az-toolbar-button>\n                          <az-toolbar-button [name]=\"'CANCEL'\" [text]=\"'Cancelar'\" [icon]=\"'glyphicon glyphicon-remove'\"></az-toolbar-button>\n                      </az-toolbar>\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <label class=\"control-label\">Departamento:</label>\n\n                              <az-combobox formControlName=\"idDepartamento\"\n                                           [(ngModel)]=\"idDepartamento\"\n                                           [items]=\"departamentos\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'id'\"\n                                           (selectedItemChanged)=\"loadPresupuestos($event)\">\n                              </az-combobox>\n\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <label class=\"control-label\">Presupuesto:</label>\n\n                              <az-combobox formControlName=\"idPresupuestoSelected\"\n                                           [(ngModel)]=\"idPresupuestoSelected\"\n                                           [items]=\"presupuestos\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'id'\">\n                              </az-combobox>\n\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <label class=\"control-label\">Tipo de gasto:</label>\n\n                              <az-combobox formControlName=\"idGastoTipo\"\n                                           [(ngModel)]=\"idGastoTipo\"\n                                           [items]=\"gastosTipos\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'id'\">\n                              </az-combobox>\n\n                          </div>\n                      </div>\n\n\n\n                  </div>\n              </div>\n          </az-panel>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute,
            core_2.Context,
            gasto_service_1.GastoService,
            presupuestos_service_1.PresupuestosService,
            gasto_tipo_service_1.GastoTipoService,
            departamento_service_1.DepartamentoService])
    ], NuevoGastoComponent);
    return NuevoGastoComponent;
}());
exports.NuevoGastoComponent = NuevoGastoComponent;
