import { FormBuilder } from '@angular/forms';
import { CollectionView } from 'wijmo/wijmo';
import { FlexGrid, CellRangeEventArgs, FormatItemEventArgs } from 'wijmo/wijmo.grid';
import { Context } from 'framework3/core';
import { BasicEditor } from 'framework3/editors';
import { UnidadMedidaItem, UnidadMedidaService } from '../../../inventory';
import { OrdenDetailArticulo } from '../../models/orden-detail-articulo';
import { DepartamentoItem } from '../../models/departamento';
import { PresupuestosService } from '../../services/presupuestos.service';
import { PresupuestosItem } from '../../models/presupuestos';
import { CategoriasPresupuestalesItem } from '../../models/categorias-presupuestales';
import { ArticuloInfo } from '../../models/articulo';
import { ArticuloService } from '../../services/articulo.service';
import { ProveedorService } from '../../services/proveedor.service';
import { QuantityInputComponent } from '../../../inventory/controls/quantity-input.component';
export declare class OrdenDetailArticuloEditor extends BasicEditor {
    protected context: Context;
    private builder;
    private unidadMedidaService;
    private presupuestoService;
    private articuloService;
    private proveedorService;
    detailCopy: OrdenDetailArticulo;
    trasladosCollection: CollectionView;
    retencionesCollection: CollectionView;
    detail: OrdenDetailArticulo;
    departamentos: DepartamentoItem[];
    idProveedor: number;
    costoUnitario: number;
    departamento: DepartamentoItem;
    presupuestos: PresupuestosItem[];
    categoriasPresupuestales: CategoriasPresupuestalesItem[];
    unidadesMedida: {
        id: number;
        nombre: string;
    }[];
    unidadesMedidaItems: UnidadMedidaItem[];
    quantity: QuantityInputComponent;
    private selectedUM;
    validInput: boolean;
    readonly costo: string;
    constructor(context: Context, builder: FormBuilder, unidadMedidaService: UnidadMedidaService, presupuestoService: PresupuestosService, articuloService: ArticuloService, proveedorService: ProveedorService);
    onCreatingItem(): void;
    onLoadingItem(detail: OrdenDetailArticulo): void;
    onUpdatingItem(detail: OrdenDetailArticulo): void;
    onDepartamentoChanged(idDepartamento: number): void;
    onPresupuestoChanged(idPresupuesto: string): void;
    onArticuloChanged(articulo: ArticuloInfo): void;
    cantidadChanged(monto: number): void;
    onCantidadChange(cantidad: number): void;
    onUnidadesChange(unidades: number): void;
    onUnidadMedidaChanged(idUnidadMedida: number): void;
    onInputValidChange(valid: boolean): void;
    loadUnidadesMedida(idTipoUnidad: number): void;
    setCurrentUnidad(idUnidadMedida: number): void;
    loadPresupuestos(idDepartamento: number): void;
    loadCategoriasPresupuestales(idPresupuesto: string): void;
    onEditCell(grid: FlexGrid, args: CellRangeEventArgs): void;
    onFormatCell(grid: FlexGrid, args: FormatItemEventArgs): void;
}
