"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
var wijmo_grid_1 = require("wijmo/wijmo.grid");
//Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
var search_1 = require("framework3/search");
//Inventario
var inventory_1 = require("../../../inventory");
var accounting_1 = require("../../../accounting");
//Locales
var orden_detail_articulo_1 = require("../../models/orden-detail-articulo");
var presupuestos_service_1 = require("../../services/presupuestos.service");
var articulo_1 = require("../../models/articulo");
var articulo_service_1 = require("../../services/articulo.service");
var proveedor_service_1 = require("../../services/proveedor.service");
var quantity_input_component_1 = require("../../../inventory/controls/quantity-input.component");
var OrdenDetailArticuloEditor = /** @class */ (function (_super) {
    __extends(OrdenDetailArticuloEditor, _super);
    function OrdenDetailArticuloEditor(context, builder, unidadMedidaService, presupuestoService, articuloService, proveedorService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.builder = builder;
        _this.unidadMedidaService = unidadMedidaService;
        _this.presupuestoService = presupuestoService;
        _this.articuloService = articuloService;
        _this.proveedorService = proveedorService;
        //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
        _this.detailCopy = new orden_detail_articulo_1.OrdenDetailArticulo();
        _this.trasladosCollection = new wijmo_1.CollectionView();
        _this.retencionesCollection = new wijmo_1.CollectionView();
        //Objeto original que se editará
        _this.detail = new orden_detail_articulo_1.OrdenDetailArticulo();
        _this.departamentos = [];
        _this.idProveedor = 0;
        _this.costoUnitario = 0;
        _this.presupuestos = [];
        _this.categoriasPresupuestales = [];
        _this.unidadesMedida = []; //UnidadMedidaItem[] = [];
        _this.unidadesMedidaItems = [];
        _this.validInput = false;
        _this.form = builder.group({
            'idDepartamento': [0, controls_1.AztecaValidators.selected],
            'idArticulo': [0, controls_1.AztecaValidators.selected],
            'idUnidadMedida': [0, controls_1.AztecaValidators.selected],
            //'cantidad': [0, Validators.required],
            'idPresupuesto': [''],
            'idCategoriaPresupuestal': [0],
            'observaciones': [''],
            'costo': [0],
        });
        _this.trasladosCollection.filter = function (item) {
            return item.tipoAplicacion == accounting_1.TipoAplicacion.TRASLADO;
        };
        _this.retencionesCollection.filter = function (item) {
            return item.tipoAplicacion == accounting_1.TipoAplicacion.RETENCION;
        };
        //Suscribirse a cambios en central ya que esta determina varios comportamientos en los campos y validaciones
        _this.form.controls['idUnidadMedida'].valueChanges.subscribe(function (value) {
            setTimeout(function (_) {
                _this.setCurrentUnidad(value);
                _this.onUnidadMedidaChanged(value);
            });
        });
        //Si se manejan series, la unidad de medida no será requerida
        _this.form.controls['idDepartamento'].valueChanges.subscribe(function (value) {
            _this.form.controls['idPresupuesto'].setValidators(null);
            _this.form.controls['idCategoriaPresupuestal'].setValidators(null);
            if (_this.departamento && _this.departamento.tipoPresupuesto != "N") {
                _this.form.controls['idPresupuesto'].setValidators(forms_1.Validators.required);
                if (_this.departamento && _this.departamento.tipoPresupuesto == "C")
                    _this.form.controls['idCategoriaPresupuestal'].setValidators(controls_1.AztecaValidators.selected);
            }
            _this.form.controls['idPresupuesto'].updateValueAndValidity();
            _this.form.controls['idCategoriaPresupuestal'].updateValueAndValidity();
        });
        return _this;
    }
    Object.defineProperty(OrdenDetailArticuloEditor.prototype, "costo", {
        get: function () {
            return wijmo_1.Globalize.formatNumber(this.costoUnitario, "c");
        },
        enumerable: true,
        configurable: true
    });
    /////////////////// METODOS ///////////////////////////////
    //validatePresupuesto( control: FormControl) {
    //    if (this.departamento && this.departamento.tipoPresupuesto != "N" && control.value == "")
    //        return 'Debe establecerse un presupuesto';
    //    else
    //        return null;
    //}
    //validateCategoria( control: FormControl) {
    //    if (this.departamento && this.departamento.tipoPresupuesto == "C" && control.value == "")
    //        return 'Debe establecer una categoria presupuestal';
    //    else
    //        return null;
    //}
    /////////////////// HANDLERS //////////////////////////////
    OrdenDetailArticuloEditor.prototype.onCreatingItem = function () {
        this.detailCopy = this.detail;
        //this.departamento = new DepartamentoItem();
        this.form.reset({ idArticulo: 0, idServicio: 0, idUnidadMedida: 0, Cantidad: 0, idDepartamento: 0, idPresupuesto: '', idCategoriaPresupuestal: 0, costo: 0 });
        this.form.markAsPristine();
        if (this.departamentos.length > 0) {
            this.detailCopy.idDepartamento = this.departamentos[0].id;
            this.onDepartamentoChanged(this.departamentos[0].id);
        }
    };
    OrdenDetailArticuloEditor.prototype.onLoadingItem = function (detail) {
        this.detailCopy = this.copyItem(this.detail);
        //this.validators();
    };
    OrdenDetailArticuloEditor.prototype.onUpdatingItem = function (detail) {
        if (this.detailCopy._clientID == 0) {
            this.detailCopy._clientID = this.createClientID();
        }
        else {
            this.detailCopy.state = editors_1.ChangeState.MODIFIED;
        }
        this.savingItem.emit(this.detailCopy);
    };
    OrdenDetailArticuloEditor.prototype.onDepartamentoChanged = function (idDepartamento) {
        if (idDepartamento > 0) {
            this.departamento = this.departamentos.find(function (item) { return item.id == idDepartamento; });
            this.detailCopy.departamento = this.departamento.nombre;
            if (this.departamento.tipoPresupuesto != 'N') {
                this.loadPresupuestos(idDepartamento);
            }
        }
    };
    OrdenDetailArticuloEditor.prototype.onPresupuestoChanged = function (idPresupuesto) {
        this.loadCategoriasPresupuestales(idPresupuesto);
    };
    OrdenDetailArticuloEditor.prototype.onArticuloChanged = function (articulo) {
        if (articulo) {
            this.detailCopy.articulo = articulo;
            this.loadUnidadesMedida(this.detailCopy.articulo.articuloStock.unidadMedida.idUnidadMedidaTipo);
            this.loadCategoriasPresupuestales(this.detailCopy.idPresupuesto);
            //this.articuloService.calcularCostoProveedor(this.detailCopy.idArticulo,articulo.idUnidadMedida, this.idProveedor, this.context.app.defaultCompany.identity)
            //    .then(costo => {
            //        this.detailCopy.costoUnitario = costo.costoBase;
            //        this.detailCopy.costoNeto = costo.costoNeto;
            //        this.detailCopy.descuentos = costo.descuentos;
            //        this.detailCopy.impuestos = costo.impuestos;
            //        this.costoUnitario = this.detailCopy.costoUnitario;
            //        this.detailCopy.importe = this.detailCopy.costoUnitario * this.detailCopy.cantidad;
            //        //
            //        this.trasladosCollection.sourceCollection = costo.impuestos;
            //        this.retencionesCollection.sourceCollection = costo.impuestos;                    
            //    })
            //    .catch(error => this.handleError(error));
        }
        else {
            this.detailCopy.articulo = new articulo_1.ArticuloInfo();
        }
        this.trasladosCollection.sourceCollection = null;
        this.retencionesCollection.sourceCollection = null;
    };
    OrdenDetailArticuloEditor.prototype.cantidadChanged = function (monto) {
        this.detailCopy.importe = this.detailCopy.costoUnitario * monto;
    };
    OrdenDetailArticuloEditor.prototype.onCantidadChange = function (cantidad) {
        this.detailCopy.cantidad = cantidad;
        this.detailCopy.importe = this.detailCopy.costoUnitario * this.quantity.totalDecimal;
    };
    OrdenDetailArticuloEditor.prototype.onUnidadesChange = function (unidades) {
        this.detailCopy.unidades = unidades;
        this.detailCopy.importe = this.detailCopy.costoUnitario * this.quantity.totalDecimal; //this.detailCopy.cantidad;
    };
    OrdenDetailArticuloEditor.prototype.onUnidadMedidaChanged = function (idUnidadMedida) {
        var _this = this;
        if (this.detailCopy.idArticulo > 0 && idUnidadMedida > 0) {
            this.articuloService.calcularCostoProveedor(this.detailCopy.idArticulo, idUnidadMedida, this.idProveedor, this.context.app.defaultCompany.identity)
                .then(function (costo) {
                _this.detailCopy.costoUnitario = costo.costoBase;
                _this.detailCopy.costoNeto = costo.costoNeto;
                _this.detailCopy.descuentos = costo.descuentos;
                _this.detailCopy.impuestos = costo.impuestos;
                _this.costoUnitario = _this.detailCopy.costoUnitario;
                _this.detailCopy.importe = _this.detailCopy.costoUnitario * _this.detailCopy.cantidad;
                //
                _this.trasladosCollection.sourceCollection = costo.impuestos;
                _this.retencionesCollection.sourceCollection = costo.impuestos;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    OrdenDetailArticuloEditor.prototype.onInputValidChange = function (valid) {
        this.validInput = valid;
    };
    OrdenDetailArticuloEditor.prototype.loadUnidadesMedida = function (idTipoUnidad) {
        var _this = this;
        //Si el articulo esta controlado por series, no se puede cambiar la unidad de medida, por lo tanto solo se debe utilizar la unidad de medida el articulo,
        //en caso contrario, cargar lista de unidades de medida del mismo tipo
        if (this.detailCopy.articulo.articuloStock.manejaSeries) {
            var unidadArticulo = this.detailCopy.articulo.articuloStock.unidadMedida;
            var newUnidad = {
                id: unidadArticulo.identity, codigo: unidadArticulo.code, idUnidadMedidaTipo: unidadArticulo.idUnidadMedidaTipo, base: unidadArticulo.base, nombre: unidadArticulo.nombre,
                factor: unidadArticulo.factor, fraccionable: unidadArticulo.fraccionable, paquete: unidadArticulo.paquete, activo: true
            };
            var newUnidades = [];
            newUnidades.push(newUnidad);
            this.unidadesMedida = newUnidades;
            this.detailCopy.idUnidadMedida = unidadArticulo.identity;
        }
        else {
            this.unidadesMedida = [];
            this.unidadMedidaService.loadList(idTipoUnidad)
                .then(function (unidadesMedidaItems) {
                _this.unidadesMedidaItems = unidadesMedidaItems;
                //this.detailCopy.idUnidadMedida = this.detailCopy.articulo.idUnidadMedida;
                var requestProveedor = new search_1.SearchRequest();
                requestProveedor.pageIndex = 0;
                requestProveedor.pageSize = 0;
                requestProveedor.paged = false;
                _this.proveedorService.searchProveedorByArticulo(_this.detail.articulo.identity, _this.context.app.defaultSite.identity, requestProveedor)
                    .then(function (unidadesMedida) {
                    unidadesMedida.rows.forEach(function (item) {
                        var um = _this.unidadesMedida.find(function (x) { return x.id == item.idUnidadMedida; });
                        if (um == null || um == undefined)
                            _this.unidadesMedida.push({ id: item.idUnidadMedida, nombre: item.unidadMedida });
                    });
                    _this.detailCopy.idUnidadMedida = _this.detailCopy.articulo.articuloStock.idUnidadMedida;
                })
                    .catch(function (error) { return _this.handleError(error); });
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    OrdenDetailArticuloEditor.prototype.setCurrentUnidad = function (idUnidadMedida) {
        this.selectedUM = this.unidadesMedidaItems.find(function (u) { return u.id == idUnidadMedida; });
    };
    OrdenDetailArticuloEditor.prototype.loadPresupuestos = function (idDepartamento) {
        var _this = this;
        if (this.departamento.tipoPresupuesto != 'N') {
            this.presupuestoService.loadPresupuestos(idDepartamento)
                .then(function (info) {
                if (_this.detail.id == 0) //nuevo
                    _this.presupuestos = info.filter(function (opens) { return opens.workFlowStepTag == 'OPEN'; }); //solo los presupuesto abiertos 
                else
                    _this.presupuestos = info; //mostrar todos los presupuestos
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    OrdenDetailArticuloEditor.prototype.loadCategoriasPresupuestales = function (idPresupuesto) {
        var _this = this;
        if (this.departamento && this.departamento.tipoPresupuesto == 'C' && idPresupuesto != "" && this.detailCopy.idArticulo != 0) {
            this.presupuestoService.loadCategoriasConArticulo(idPresupuesto, this.detailCopy.idArticulo)
                .then(function (info) {
                _this.categoriasPresupuestales = info;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    //validators() {
    //    if (this.detailCopy.articuloServicio == "A") {
    //        this.form.controls.idArticulo.setValidators(AztecaValidators.selected);
    //        this.form.controls.idUnidadMedida.setValidators(AztecaValidators.selected);
    //        this.form.controls.idServicio.setValidators(null);
    //    }
    //    else {
    //        this.form.controls.idServicio.setValidators(AztecaValidators.selected);
    //        this.form.controls.idArticulo.setValidators(null);
    //        this.form.controls.idUnidadMedida.setValidators(null);
    //    }
    //    this.form.controls.idArticulo.updateValueAndValidity();
    //    this.form.controls.idUnidadMedida.updateValueAndValidity();
    //    this.form.controls.idServicio.updateValueAndValidity();
    //}
    OrdenDetailArticuloEditor.prototype.onEditCell = function (grid, args) {
        if (!grid.rows[args.row].dataItem.impuesto.rango && grid.columns[args.col].binding == 'tasaOCuota') {
            args.cancel = true;
        }
    };
    OrdenDetailArticuloEditor.prototype.onFormatCell = function (grid, args) {
        if (args.panel.cellType == wijmo_grid_1.CellType.Cell && !grid.rows[args.row].dataItem.impuesto.rango && grid.columns[args.col].binding == 'tasaOCuota') {
            args.cell.style.backgroundColor = '#C0C0C0';
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", orden_detail_articulo_1.OrdenDetailArticulo)
    ], OrdenDetailArticuloEditor.prototype, "detail", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], OrdenDetailArticuloEditor.prototype, "departamentos", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], OrdenDetailArticuloEditor.prototype, "idProveedor", void 0);
    __decorate([
        core_1.ViewChild('quantity'),
        __metadata("design:type", quantity_input_component_1.QuantityInputComponent)
    ], OrdenDetailArticuloEditor.prototype, "quantity", void 0);
    OrdenDetailArticuloEditor = __decorate([
        core_1.Component({
            selector: 'compras-orden-detail-articulos-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <azteca-basic-editor [item]=\"detail\"\n                               [dirty]=\"dirty\"\n                               [valid]=\"valid\"\n                               (creatingItem)=\"onCreatingItem()\"\n                               (loadingItem)=\"onLoadingItem($event)\"\n                               (updatingItem)=\"onUpdatingItem($event)\">\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-6\">\n                      <azteca-form-field [label]=\"'Departamento:'\">\n                          <az-combobox formControlName=\"idDepartamento\"\n                                       [(ngModel)]=\"detailCopy.idDepartamento\"\n                                       [items]=\"departamentos\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\"\n                                       (selectedItemChanged)=\"onDepartamentoChanged($event)\">\n                          </az-combobox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-8\">\n                      <azteca-form-field [label]=\"'Articulo:'\" >\n                          <purchasing-articulo-selector formControlName=\"idArticulo\"\n                                                        [showListButton]=\"true\"\n                                                        [(ngModel)]=\"detailCopy.idArticulo\"\n                                                        (selectedItemChanged)=\"onArticuloChanged($event)\"\n                                                        (articuloUpdated)=\"onArticuloChanged($event)\">\n                          </purchasing-articulo-selector>\n                      </azteca-form-field>\n                  </div>\n\n                  <div class=\"col-12 col-md-4\">\n                      <azteca-form-field [label]=\"'Unidad de medida:'\" >\n                          <az-combobox formControlName=\"idUnidadMedida\"\n                                       [(ngModel)]=\"detailCopy.idUnidadMedida\"\n                                       [items]=\"unidadesMedida\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\"\n                                       (selectedItemChanged)=\"onUnidadMedidaChanged($event)\">\n                          </az-combobox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-3\">\n                      <!--<azteca-form-field [label]=\"'Cantidad:'\">\n                          <az-input-number formControlName=\"cantidad\"\n                                           [(ngModel)]=\"detailCopy.cantidad\"\n                                           (valueChange)=\"cantidadChanged($event)\">\n                          </az-input-number>\n                      </azteca-form-field>-->\n\n                \n                          <inventory-quantity-input #quantity\n                                                    [cantidad]=\"detailCopy.cantidad\"\n                                                    [unidades]=\"detailCopy.unidades\"\n                                                    [unidadMedida]=\"selectedUM\"\n                                                    (cantidadChange)=\"onCantidadChange($event)\"\n                                                    (unidadesChange)=\"onUnidadesChange($event)\"\n                                                    [enabledCantidad]=\"true\"\n                                                    >\n                          </inventory-quantity-input>\n                \n\n\n\n                  </div>\n\n                  <div class=\"col-12 col-lg-6\">\n                      <azteca-form-field [label]=\"'Costo:'\">\n                          <az-input-number formControlName=\"costo\" [(ngModel)]=\"costoUnitario\" [enabled]=\"false\" [format]=\"n2\"></az-input-number>\n                      </azteca-form-field>\n                  </div>\n\n              </div>\n\n              <az-panel [header]=\"'Presupuesto'\" type=\"success\" *ngIf=\"departamento ? departamento.tipoPresupuesto != 'N' : false\">\n                  <div class=\"row\">\n                      <div class=\"col-12 col-md-6\">\n                          <azteca-form-field [label]=\"'Presupuesto:'\" *ngIf=\"departamento ? departamento.tipoPresupuesto != 'N' :false\">\n                              <az-combobox formControlName=\"idPresupuesto\"\n                                           [(ngModel)]=\"detailCopy.idPresupuesto\"\n                                           [items]=\"presupuestos\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'id'\"\n                                           (selectedItemChanged)=\"onPresupuestoChanged($event)\">\n                              </az-combobox>\n                          </azteca-form-field>\n                      </div>\n                      <div class=\"col-12 col-md-6\">\n                          <azteca-form-field [label]=\"'Categoria Presupuestal:'\" *ngIf=\"departamento ? departamento.tipoPresupuesto == 'C' : false\" >\n                              <az-combobox formControlName=\"idCategoriaPresupuestal\"\n                                           [(ngModel)]=\"detailCopy.idCategoriaPresupuestal\"\n                                           [items]=\"categoriasPresupuestales\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'id'\">\n                              </az-combobox>\n                          </azteca-form-field>\n                      </div>\n                  </div>\n              </az-panel>\n\n              <!--GRID DE TRASLADOS-->\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <label class=\"control-label\">Traslados:</label>\n                      <wj-flex-grid #gridTraslados style=\"height:120px\" [itemsSource]=\"trasladosCollection\"\n                                    (beginningEdit)=\"onEditCell(gridTraslados, $event)\" (formatItem)=\"onFormatCell(gridTraslados, $event)\">\n                          <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Factor'\" [binding]=\"'tipoFactor'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Base'\" [binding]=\"'base'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Tasa \u00F3 cuota'\" [binding]=\"'tasaOCuota'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      </wj-flex-grid>\n                  </div>\n              </div>\n\n              <!--GRID DE RETENCIONES-->\n              <!--<div class=\"row\" *ngIf=\"detailCopy.articuloServicio=='S'\">\n                  <div class=\"col-12\">\n\n                      <label class=\"control-label\">Retenciones:</label>\n                      <wj-flex-grid #gridRetenciones style=\"height:120px\" [itemsSource]=\"retencionesCollection\"\n                                    (beginningEdit)=\"onEditCell(gridRetenciones, $event)\" (formatItem)=\"onFormatCell(gridRetenciones, $event)\">\n                          <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Factor'\" [binding]=\"'tipoFactor'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Base'\" [binding]=\"'base'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Tasa \u00F3 cuota'\" [binding]=\"'tasaOCuota'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      </wj-flex-grid>\n\n                  </div>\n              </div>-->\n\n          </azteca-basic-editor>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, inventory_1.UnidadMedidaService,
            presupuestos_service_1.PresupuestosService,
            articulo_service_1.ArticuloService,
            proveedor_service_1.ProveedorService])
    ], OrdenDetailArticuloEditor);
    return OrdenDetailArticuloEditor;
}(editors_1.BasicEditor));
exports.OrdenDetailArticuloEditor = OrdenDetailArticuloEditor;
