"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
var wijmo_grid_1 = require("wijmo/wijmo.grid");
//Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var controls_1 = require("framework3/controls");
//Inventario
//import { ArticuloStockInfo, UnidadMedidaInfo, UnidadMedidaItem, StockInfo, LoteInfo, SerieInfo, UnidadMedidaService, AlmacenService, MetodoValuacion } from '../../../inventory';
var accounting_1 = require("../../../accounting");
//Locales
var orden_detail_servicio_1 = require("../../models/orden-detail-servicio");
var presupuestos_service_1 = require("../../services/presupuestos.service");
var presupuestos_1 = require("../../models/presupuestos");
var servicio_1 = require("../../models/servicio");
var servicio_service_1 = require("../../services/servicio.service");
var OrdenDetailServicioEditor = /** @class */ (function (_super) {
    __extends(OrdenDetailServicioEditor, _super);
    //unidadesMedida: UnidadMedidaItem[] = [];
    function OrdenDetailServicioEditor(context, builder, presupuestoService, servicioService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.builder = builder;
        _this.presupuestoService = presupuestoService;
        _this.servicioService = servicioService;
        //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
        _this.detailCopy = new orden_detail_servicio_1.OrdenDetailServicio();
        _this.trasladosCollection = new wijmo_1.CollectionView();
        _this.retencionesCollection = new wijmo_1.CollectionView();
        //Objeto original que se editará
        _this.detail = new orden_detail_servicio_1.OrdenDetailServicio();
        _this.departamentos = [];
        _this.idProveedor = 0;
        _this.costoUnitario = '$0.0';
        _this.presupuestos = [];
        _this.presupuesto = new presupuestos_1.PresupuestosItem();
        _this.categoriasPresupuestales = [];
        _this.form = builder.group({
            'idDepartamento': [0, controls_1.AztecaValidators.selected],
            'idServicio': [0, controls_1.AztecaValidators.selected],
            'cantidad': [0, forms_1.Validators.required],
            'idPresupuesto': [''],
            'idCategoriaPresupuestal': [0],
            'observaciones': [''],
            'costo': [0],
        });
        _this.trasladosCollection.filter = function (item) {
            return item.tipoAplicacion == accounting_1.TipoAplicacion.TRASLADO;
        };
        _this.retencionesCollection.filter = function (item) {
            return item.tipoAplicacion == accounting_1.TipoAplicacion.RETENCION;
        };
        //Si se manejan series, la unidad de medida no será requerida
        _this.form.controls['idDepartamento'].valueChanges.subscribe(function (value) {
            _this.form.controls['idPresupuesto'].setValidators(null);
            _this.form.controls['idCategoriaPresupuestal'].setValidators(null);
            if (_this.departamento && _this.departamento.tipoPresupuesto != "N") {
                _this.form.controls['idPresupuesto'].setValidators(forms_1.Validators.required);
                if (_this.departamento && _this.departamento.tipoPresupuesto == "C")
                    _this.form.controls['idCategoriaPresupuestal'].setValidators(controls_1.AztecaValidators.selected);
            }
            _this.form.controls['idPresupuesto'].updateValueAndValidity();
            _this.form.controls['idCategoriaPresupuestal'].updateValueAndValidity();
        });
        return _this;
    }
    ///////////////////// METODOS ///////////////////////////////
    //validatePresupuesto(departamento: DepartamentoItem, control: FormControl) {
    //    if (departamento && departamento.tipoPresupuesto != "N" && control.value == "")
    //        return 'Debe establecerse un presupuesto';
    //    else
    //        return null;
    //}
    //validateCategoria(departamento: DepartamentoItem, control: FormControl) {
    //    if (departamento && departamento.tipoPresupuesto == "C" && control.value == "")
    //        return 'Debe establecer una categoria presupuestal';
    //    else
    //        return null;
    //}
    /////////////////// HANDLERS //////////////////////////////
    OrdenDetailServicioEditor.prototype.onCreatingItem = function () {
        this.detailCopy = this.detail;
        this.form.reset({ idArticulo: 0, idServicio: 0, idUnidadMedida: 0, Cantidad: 0, idDepartamento: 0, idPresupuesto: '', idCategoriaPresupuestal: 0, costo: 0 });
        //this.departamento = new DepartamentoItem();
        this.form.markAsPristine();
        if (this.departamentos.length > 0) {
            this.detailCopy.idDepartamento = this.departamentos[0].id;
            this.onDepartamentoChanged(this.departamentos[0].id);
        }
    };
    OrdenDetailServicioEditor.prototype.onLoadingItem = function (detail) {
        this.detailCopy = this.copyItem(this.detail);
    };
    OrdenDetailServicioEditor.prototype.onUpdatingItem = function (detail) {
        if (this.detailCopy._clientID == 0) {
            this.detailCopy._clientID = this.createClientID();
        }
        else {
            this.detailCopy.state = editors_1.ChangeState.MODIFIED;
        }
        this.savingItem.emit(this.detailCopy);
    };
    OrdenDetailServicioEditor.prototype.onDepartamentoChanged = function (idDepartamento) {
        if (idDepartamento > 0) {
            this.departamento = this.departamentos.find(function (item) { return item.id == idDepartamento; });
            this.detailCopy.departamento = this.departamento.nombre;
            if (this.departamento.tipoPresupuesto != 'N') {
                this.loadPresupuestos(idDepartamento);
            }
        }
    };
    OrdenDetailServicioEditor.prototype.onPresupuestoChanged = function (idPresupuesto) {
        this.loadCategoriasPresupuestales(idPresupuesto);
    };
    OrdenDetailServicioEditor.prototype.onServicioChanged = function (servicio) {
        var _this = this;
        if (servicio) {
            this.detailCopy.servicio = servicio;
            ////Hacer requerido el campo de descripción cuando el servicio sea de concepto libre
            //if (this.detailCopy.articuloServicio=="S") {
            //    this.form.controls.idServicio.setValidators(Validators.required);
            //}
            //else {
            //    this.form.controls.idServicio.setValidators(null);
            //}
            //this.form.controls.descripcion.updateValueAndValidity();
            this.loadCategoriasPresupuestales(this.detailCopy.idPresupuesto);
            //Cargar información de precios del servicio
            this.servicioService.calcularCostoProveedor(this.detailCopy.idServicio, this.idProveedor, this.context.app.defaultCompany.identity, 0)
                .then(function (costo) {
                _this.detailCopy.costoUnitario = costo.costoBase;
                _this.detailCopy.costoNeto = costo.costoNeto;
                _this.detailCopy.impuestos = costo.impuestos;
                _this.detailCopy.descuentos = costo.descuentos;
                _this.detailCopy.importe = _this.detailCopy.costoUnitario * _this.detailCopy.cantidad;
                //
                _this.trasladosCollection.sourceCollection = costo.impuestos;
                _this.retencionesCollection.sourceCollection = costo.impuestos;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.detailCopy.servicio = new servicio_1.ServicioInfo();
        }
        this.trasladosCollection.sourceCollection = null;
        this.retencionesCollection.sourceCollection = null;
    };
    OrdenDetailServicioEditor.prototype.loadPresupuestos = function (idDepartamento) {
        var _this = this;
        if (this.departamento && this.departamento.tipoPresupuesto != 'N') {
            this.presupuestoService.loadPresupuestos(idDepartamento)
                .then(function (info) {
                if (_this.detail.id == 0) //nuevo
                    _this.presupuestos = info.filter(function (opens) { return opens.workFlowStepTag == 'OPEN'; }); //solo los presupuesto abiertos 
                else
                    _this.presupuestos = info; //mostrar todos los presupuestos
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    OrdenDetailServicioEditor.prototype.loadCategoriasPresupuestales = function (idPresupuesto) {
        var _this = this;
        if (this.departamento && this.departamento.tipoPresupuesto == 'C' && idPresupuesto != "" && this.detailCopy.idServicio != 0) {
            this.presupuestoService.loadCategoriasConServicio(idPresupuesto, this.detailCopy.idServicio)
                .then(function (info) {
                _this.categoriasPresupuestales = info;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    OrdenDetailServicioEditor.prototype.cantidadChanged = function (monto) {
        this.detailCopy.importe = this.detailCopy.costoUnitario * monto;
    };
    OrdenDetailServicioEditor.prototype.onEditCell = function (grid, args) {
        if (!grid.rows[args.row].dataItem.impuesto.rango && grid.columns[args.col].binding == 'tasaOCuota') {
            args.cancel = true;
        }
    };
    OrdenDetailServicioEditor.prototype.onFormatCell = function (grid, args) {
        if (args.panel.cellType == wijmo_grid_1.CellType.Cell && !grid.rows[args.row].dataItem.impuesto.rango && grid.columns[args.col].binding == 'tasaOCuota') {
            args.cell.style.backgroundColor = '#C0C0C0';
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", orden_detail_servicio_1.OrdenDetailServicio)
    ], OrdenDetailServicioEditor.prototype, "detail", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], OrdenDetailServicioEditor.prototype, "departamentos", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], OrdenDetailServicioEditor.prototype, "idProveedor", void 0);
    OrdenDetailServicioEditor = __decorate([
        core_1.Component({
            selector: 'compras-orden-detail-servicios-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <azteca-basic-editor [item]=\"detail\"\n                               [dirty]=\"dirty\"\n                               [valid]=\"valid\"\n                               (creatingItem)=\"onCreatingItem()\"\n                               (loadingItem)=\"onLoadingItem($event)\"\n                               (updatingItem)=\"onUpdatingItem($event)\">\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-6\">\n                      <azteca-form-field [label]=\"'Departamento:'\">\n                          <az-combobox formControlName=\"idDepartamento\"\n                                       [(ngModel)]=\"detailCopy.idDepartamento\"\n                                       [items]=\"departamentos\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\"\n                                       (selectedItemChanged)=\"onDepartamentoChanged($event)\">\n                          </az-combobox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n       \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-8\">\n                      <azteca-form-field [label]=\"'Servicio:'\" >\n                          <purchasing-servicios-selector formControlName=\"idServicio\"\n                                                         [showListButton]=\"false\"\n                                                         (selectedItemChanged)=\"onServicioChanged($event)\"\n                                                         [(ngModel)]=\"detailCopy.idServicio\"\n                                                         (itemSelected)=\"onServicioChanged($event)\">\n                          </purchasing-servicios-selector>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-3\">\n                      <azteca-form-field [label]=\"'Cantidad:'\">\n                          <az-input-number formControlName=\"cantidad\"\n                                           [(ngModel)]=\"detailCopy.cantidad\"\n                                           (valueChange)=\"cantidadChanged($event)\">\n                          </az-input-number>\n                      </azteca-form-field>\n                  </div>\n\n                  <div class=\"col-12 col-lg-6\">\n                      <azteca-form-field [label]=\"'Costo:'\">\n                          <az-input-number formControlName=\"costo\" [(ngModel)]=\"detailCopy.costoUnitario\" [enabled]=\"false\" [format]=\"n2\"></az-input-number>\n                      </azteca-form-field>\n                  </div>\n\n              </div>\n\n              <az-panel [header]=\"'Presupuesto'\" type=\"success\" *ngIf=\"departamento ? departamento.tipoPresupuesto != 'N' : false\">\n                  <div class=\"row\">\n                      <div class=\"col-12 col-md-6\">\n                          <azteca-form-field [label]=\"'Presupuesto:'\" *ngIf=\"departamento ? departamento.tipoPresupuesto != 'N' :false\">\n                              <az-combobox formControlName=\"idPresupuesto\"\n                                           [(ngModel)]=\"detailCopy.idPresupuesto\"\n                                           [items]=\"presupuestos\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'id'\"\n                                           (selectedItemChanged)=\"onPresupuestoChanged($event)\">\n                              </az-combobox>\n                          </azteca-form-field>\n                      </div>\n                      <div class=\"col-12 col-md-6\">\n                          <azteca-form-field [label]=\"'Categoria Presupuestal:'\" *ngIf=\"departamento ? departamento.tipoPresupuesto == 'C' : false\">\n                              <az-combobox formControlName=\"idCategoriaPresupuestal\"\n                                           [(ngModel)]=\"detailCopy.idCategoriaPresupuestal\"\n                                           [items]=\"categoriasPresupuestales\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'id'\">\n                              </az-combobox>\n                          </azteca-form-field>\n                      </div>\n                  </div>\n              </az-panel>\n\n              <!--GRID DE TRASLADOS-->\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <label class=\"control-label\">Traslados:</label>\n                      <wj-flex-grid #gridTraslados style=\"height:120px\" [itemsSource]=\"trasladosCollection\"\n                                    (beginningEdit)=\"onEditCell(gridTraslados, $event)\" (formatItem)=\"onFormatCell(gridTraslados, $event)\">\n                          <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Factor'\" [binding]=\"'tipoFactor'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Base'\" [binding]=\"'base'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Tasa \u00F3 cuota'\" [binding]=\"'tasaOCuota'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      </wj-flex-grid>\n                  </div>\n              </div>\n\n              <!--GRID DE RETENCIONES-->\n              <div class=\"row\">\n                  <div class=\"col-12\">\n\n                      <label class=\"control-label\">Retenciones:</label>\n                      <wj-flex-grid #gridRetenciones style=\"height:120px\" [itemsSource]=\"retencionesCollection\"\n                                    (beginningEdit)=\"onEditCell(gridRetenciones, $event)\" (formatItem)=\"onFormatCell(gridRetenciones, $event)\">\n                          <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Factor'\" [binding]=\"'tipoFactor'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Base'\" [binding]=\"'base'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Tasa \u00F3 cuota'\" [binding]=\"'tasaOCuota'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      </wj-flex-grid>\n\n                  </div>\n              </div>\n\n          </azteca-basic-editor>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder,
            presupuestos_service_1.PresupuestosService,
            servicio_service_1.ServicioService])
    ], OrdenDetailServicioEditor);
    return OrdenDetailServicioEditor;
}(editors_1.BasicEditor));
exports.OrdenDetailServicioEditor = OrdenDetailServicioEditor;
