import { ChangeDetectorRef } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { Context } from 'framework3/core';
import { BasicEditor } from 'framework3/editors';
import { UnidadMedidaItem, StockInfo, UnidadMedidaService, AlmacenService } from '../../../inventory';
import { RecepcionArticuloDetail } from '../../models/recepcion-articulo-detail';
export declare class RecepcionArticulosDetailEditor extends BasicEditor {
    protected context: Context;
    private builder;
    private unidadMedidaService;
    private almacenService;
    private cdRef;
    unidadesMedida: UnidadMedidaItem[];
    stockConfig: StockInfo;
    validInput: boolean;
    detailCopy: RecepcionArticuloDetail;
    detail: RecepcionArticuloDetail;
    idAlmacen: number;
    enabledCantidad: boolean;
    readonly articuloCode: string;
    constructor(context: Context, builder: FormBuilder, unidadMedidaService: UnidadMedidaService, almacenService: AlmacenService, cdRef: ChangeDetectorRef);
    loadStock(idArticulo: number): void;
    loadUnidadesMedida(idTipoUnidad: number): void;
    onCreatingItem(): void;
    onLoadingItem(detail: RecepcionArticuloDetail): void;
    ngAfterViewInit(): void;
    onUpdatingItem(detail: RecepcionArticuloDetail): void;
    onInputValidChange(valid: boolean): void;
    onCantidadCambio(value: number): void;
    onUnidadesCambio(value: number): void;
    onChangeFechaCaducidad(value: any): void;
}
