"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Inventario
var inventory_1 = require("../../../inventory");
var recepcion_articulo_detail_1 = require("../../models/recepcion-articulo-detail");
var RecepcionArticulosDetailEditor = /** @class */ (function (_super) {
    __extends(RecepcionArticulosDetailEditor, _super);
    function RecepcionArticulosDetailEditor(context, builder, unidadMedidaService, almacenService, cdRef) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.builder = builder;
        _this.unidadMedidaService = unidadMedidaService;
        _this.almacenService = almacenService;
        _this.cdRef = cdRef;
        _this.unidadesMedida = [];
        _this.validInput = false;
        //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
        _this.detailCopy = new recepcion_articulo_detail_1.RecepcionArticuloDetail();
        //Objeto original que se editará
        _this.detail = new recepcion_articulo_detail_1.RecepcionArticuloDetail();
        _this.idAlmacen = 0;
        _this.enabledCantidad = true;
        //
        _this.form = builder.group({});
        return _this;
    }
    Object.defineProperty(RecepcionArticulosDetailEditor.prototype, "articuloCode", {
        //
        get: function () {
            return this.detailCopy.articulo ? this.detailCopy.articulo.code + '-' + this.detailCopy.articulo.nombre : '';
        },
        enumerable: true,
        configurable: true
    });
    /////////////////// METODOS ///////////////////////////////
    RecepcionArticulosDetailEditor.prototype.loadStock = function (idArticulo) {
        var _this = this;
        if (idArticulo && idArticulo > 0) {
            this.almacenService.loadStock(this.idAlmacen, idArticulo)
                .then(function (stock) {
                _this.stockConfig = stock;
                _this.loadUnidadesMedida(_this.detailCopy.articulo.articuloStock.unidadMedida.idUnidadMedidaTipo);
                //this.form.updateValueAndValidity();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    RecepcionArticulosDetailEditor.prototype.loadUnidadesMedida = function (idTipoUnidad) {
        var _this = this;
        //Si el articulo esta controlado por series, no se puede cambiar la unidad de medida, por lo tanto solo se debe utilizar la unidad de medida el articulo,
        //en caso contrario, cargar lista de unidades de medida del mismo tipo
        if (this.stockConfig.manejaSeries) {
            var unidadArticulo = this.detailCopy.articulo.articuloStock.unidadMedida;
            var newUnidad = {
                id: unidadArticulo.identity, codigo: unidadArticulo.code, idUnidadMedidaTipo: unidadArticulo.idUnidadMedidaTipo, base: unidadArticulo.base,
                factor: unidadArticulo.factor, fraccionable: unidadArticulo.fraccionable, paquete: unidadArticulo.paquete, activo: true
            };
            var newUnidades = [];
            newUnidades.push(newUnidad);
            this.unidadesMedida = newUnidades;
            this.detailCopy.idUnidadMedida = unidadArticulo.identity;
        }
        else {
            this.unidadMedidaService.loadList(idTipoUnidad)
                .then(function (unidadesMedida) {
                _this.unidadesMedida = unidadesMedida;
                _this.detailCopy.idUnidadMedida = _this.detailCopy.articulo.articuloStock.idUnidadMedida;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    /////////////////// HANDLERS //////////////////////////////
    RecepcionArticulosDetailEditor.prototype.onCreatingItem = function () {
        this.detailCopy = this.detail;
        this.cdRef.detectChanges();
        this.form.reset({ articulo: '' });
        this.form.markAsPristine();
    };
    RecepcionArticulosDetailEditor.prototype.onLoadingItem = function (detail) {
        this.detailCopy = this.copyItem(this.detail);
        //this.onCreatingItem();
        this.loadStock(this.detailCopy.articulo.articuloStock.identity);
        //setTimeout(_ => this.loadStock(this.detailCopy.articulo.articuloStock.identity), 1000);
    };
    RecepcionArticulosDetailEditor.prototype.ngAfterViewInit = function () {
        //setTimeout(_ => this.loadStock(this.detailCopy.articulo.articuloStock.identity),1000);            
    };
    RecepcionArticulosDetailEditor.prototype.onUpdatingItem = function (detail) {
        var _this = this;
        this.unidadMedidaService.getDetailFromCache(this.detailCopy.idUnidadMedida)
            .then(function (unidad) {
            _this.detailCopy.unidadMedida = unidad;
            if (_this.detailCopy._clientID == 0) {
                _this.detailCopy._clientID = _this.createClientID();
            }
            else {
                _this.detailCopy.state = editors_1.ChangeState.MODIFIED;
            }
            _this.savingItem.emit(_this.detailCopy);
            _this.detailCopy = new recepcion_articulo_detail_1.RecepcionArticuloDetail();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionArticulosDetailEditor.prototype.onInputValidChange = function (valid) {
        this.validInput = valid;
    };
    //onLotesChange(lotes: LoteInfo[]) {
    //    this.lotes = lotes;
    //}
    //onSeriesChange(series: SerieInfo[]) {
    //    this.series = series;
    //}
    RecepcionArticulosDetailEditor.prototype.onCantidadCambio = function (value) {
        this.detailCopy.importe = this.detailCopy.costoUnitario * this.detailCopy.cantidad;
    };
    RecepcionArticulosDetailEditor.prototype.onUnidadesCambio = function (value) {
        this.detailCopy.importe = this.detailCopy.costoUnitario * this.detailCopy.cantidad;
    };
    RecepcionArticulosDetailEditor.prototype.onChangeFechaCaducidad = function (value) {
        if (this.detailCopy.articulo.articuloStock.manejaCaducidad)
            this.detailCopy.fechaCaducidad = value;
        this.cdRef.detectChanges();
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", recepcion_articulo_detail_1.RecepcionArticuloDetail)
    ], RecepcionArticulosDetailEditor.prototype, "detail", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], RecepcionArticulosDetailEditor.prototype, "idAlmacen", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], RecepcionArticulosDetailEditor.prototype, "enabledCantidad", void 0);
    RecepcionArticulosDetailEditor = __decorate([
        core_1.Component({
            selector: 'compras-recepcion-articulos-detail-editor',
            template: "\n      <form [formGroup]=\"form\">\n\n          <azteca-basic-editor [item]=\"detail\"\n                               [dirty]=\"dirty\"\n                               [valid]=\"validInput\"\n                               [title]=\"'Editar art\u00EDculos de la recepci\u00F3n'\"\n                               (creatingItem)=\"onCreatingItem()\"\n                               (loadingItem)=\"onLoadingItem($event)\"\n                               (updatingItem)=\"onUpdatingItem($event)\">\n\n\n              <div class=\"row\">\n                  <div class=\"col\">\n                      <span>Art&iacute;culo: {{articuloCode}}</span>\n                  </div>\n              </div>\n\n              <!--<div class=\"row\">\n                  <div class=\"col-12\">\n                      <azteca-form-field [label]=\"'Art\u00EDculo:'\">\n                          <purchasing-articulo-selector formControlName=\"idArticulo\"\n                                                          [(ngModel)]=\"detailCopy.articulo.identity\"\n                                                          [showListButton]=\"false\"\n                                                          [enabled]=\"false\">\n                          </purchasing-articulo-selector>\n                      </azteca-form-field>\n                  </div>\n              </div>-->\n\n              <div class=\"row\">\n                  <div class=\"col-12\">\n\n                      <inventory-articulo-stock-entrada [stockConfig]=\"stockConfig\"\n                                                        [unidadesMedida]=\"unidadesMedida\"\n                                                        [idAlmacen]=\"idAlmacen\"\n                                                        [(cantidad)]=\"detailCopy.cantidad\"\n                                                        [(unidades)]=\"detailCopy.unidades\"\n                                                        [(costoUnitario)]=\"detailCopy.costoUnitario\"\n                                                        [(idUnidadMedida)]=\"detailCopy.idUnidadMedida\"\n                                                        [(numeroSerie)]=\"detailCopy.numSerie\"\n                                                        [(fechaCaducidad)]=\"detailCopy.fechaCaducidad\"\n                                                        [(idUbicacion)]=\"detailCopy.idUbicacion\"\n                                                        (validChange)=\"onInputValidChange($event)\"\n                                                        [costoEnabled]=\"false\"\n                                                        (cantidadChange)=\"onCantidadCambio($event)\"\n                                                        (unidadesChange)=\"onUnidadesCambio($event)\"\n                                                        (fechaCaducidadChange)=\"onChangeFechaCaducidad($event)\"\n                                                        [unidadMedidaEnabled]=\"false\"\n                                                        [enabledCantidad]=\"enabledCantidad\">\n                      </inventory-articulo-stock-entrada>\n\n                  </div>\n              </div>\n\n\n          </azteca-basic-editor>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, inventory_1.UnidadMedidaService, inventory_1.AlmacenService, core_1.ChangeDetectorRef])
    ], RecepcionArticulosDetailEditor);
    return RecepcionArticulosDetailEditor;
}(editors_1.BasicEditor));
exports.RecepcionArticulosDetailEditor = RecepcionArticulosDetailEditor;
