import { FormBuilder } from '@angular/forms';
import { CollectionView } from 'wijmo/wijmo';
import { FlexGrid, CellRangeEventArgs, FormatItemEventArgs } from 'wijmo/wijmo.grid';
import { Context } from 'framework3/core';
import { BasicEditor } from 'framework3/editors';
import { RecepcionSinOCDetail } from '../../models/recepcion-sin-oc-detail';
import { ArticuloInfo } from '../../models/articulo';
import { DepartamentoItem } from '../../models/departamento';
import { ArticuloService } from '../../services/articulo.service';
import { RecepcionSinOCDetailArticulo } from '../../models/recepcion-sin-oc-detail-articulo';
import { StockInfo } from '../../../inventory/models/stock';
import { ArticuloStockEntradaComponent } from '../../../inventory/controls/articulo-stock-entrada.component';
import { UnidadMedidaService } from '../../../inventory/services/unidad-medida.service';
import { AlmacenService } from '../../../inventory/services/almacen.service';
import { PresupuestosService } from '../../services/presupuestos.service';
import { PresupuestosItem } from '../../models/presupuestos';
import { CategoriasPresupuestalesItem } from '../../models/categorias-presupuestales';
import { ProveedorService } from '../../services/proveedor.service';
export declare class RecepcionSinOCArticulosEditor extends BasicEditor {
    protected context: Context;
    private builder;
    private articuloService;
    private unidadMedidaService;
    private almacenService;
    private presupuestosService;
    private proveedorService;
    detailCopy: RecepcionSinOCDetailArticulo;
    stockConfig: StockInfo;
    unidadesMedida: {
        id: number;
        nombre: string;
    }[];
    trasladosCollection: CollectionView;
    retencionesCollection: CollectionView;
    detail: RecepcionSinOCDetailArticulo;
    idAlmacen: number;
    idProveedor: number;
    departamentos: DepartamentoItem[];
    articuloEntrada: ArticuloStockEntradaComponent;
    departamento: DepartamentoItem;
    presupuestos: PresupuestosItem[];
    presupuesto: PresupuestosItem;
    categoriasPresupuestales: CategoriasPresupuestalesItem[];
    costoUnitario: number;
    readonly costo: string;
    constructor(context: Context, builder: FormBuilder, articuloService: ArticuloService, unidadMedidaService: UnidadMedidaService, almacenService: AlmacenService, presupuestosService: PresupuestosService, proveedorService: ProveedorService);
    onArticuloChanged(articulo: ArticuloInfo): void;
    loadStock(idArticulo: number): void;
    loadUnidadesMedida(idTipoUnidad: number): void;
    onUnidadMedidaChange(idUnidadMedida: number): void;
    onCantidadChanged(cantidad: number): void;
    onCostoUnitarioChanged(costo: number): void;
    onDepartamentoChanged(idDepartamento: number): void;
    onPresupuestoChanged(idPresupuesto: string): void;
    loadPresupuestos(idDepartamento: number): void;
    loadCategoriasPresupuestales(idPresupuesto: string): void;
    onCreatingItem(): void;
    onLoadingItem(detail: RecepcionSinOCDetailArticulo): void;
    onUpdatingItem(detail: RecepcionSinOCDetail): void;
    onEditCell(grid: FlexGrid, args: CellRangeEventArgs): void;
    onEditedCell(grid: FlexGrid, args: CellRangeEventArgs): void;
    onFormatCell(grid: FlexGrid, args: FormatItemEventArgs): void;
}
