"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//wijmo
var wijmo_1 = require("wijmo/wijmo");
var wijmo_grid_1 = require("wijmo/wijmo.grid");
//Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
var search_1 = require("framework3/search");
var articulo_service_1 = require("../../services/articulo.service");
var recepcion_sin_oc_detail_articulo_1 = require("../../models/recepcion-sin-oc-detail-articulo");
var articulo_stock_entrada_component_1 = require("../../../inventory/controls/articulo-stock-entrada.component");
var unidad_medida_service_1 = require("../../../inventory/services/unidad-medida.service");
var almacen_service_1 = require("../../../inventory/services/almacen.service");
var presupuestos_service_1 = require("../../services/presupuestos.service");
var presupuestos_1 = require("../../models/presupuestos");
var accounting_1 = require("../../../accounting");
var timers_1 = require("timers");
var proveedor_service_1 = require("../../services/proveedor.service");
var RecepcionSinOCArticulosEditor = /** @class */ (function (_super) {
    __extends(RecepcionSinOCArticulosEditor, _super);
    function RecepcionSinOCArticulosEditor(context, builder, articuloService, unidadMedidaService, almacenService, presupuestosService, proveedorService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.builder = builder;
        _this.articuloService = articuloService;
        _this.unidadMedidaService = unidadMedidaService;
        _this.almacenService = almacenService;
        _this.presupuestosService = presupuestosService;
        _this.proveedorService = proveedorService;
        //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
        _this.detailCopy = new recepcion_sin_oc_detail_articulo_1.RecepcionSinOCDetailArticulo();
        _this.unidadesMedida = []; //UnidadMedidaItem[] = [];
        _this.trasladosCollection = new wijmo_1.CollectionView();
        _this.retencionesCollection = new wijmo_1.CollectionView();
        //Objeto original que se editará
        _this.detail = new recepcion_sin_oc_detail_articulo_1.RecepcionSinOCDetailArticulo();
        _this.idAlmacen = 0;
        _this.idProveedor = 0;
        _this.departamentos = [];
        _this.presupuestos = [];
        _this.presupuesto = new presupuestos_1.PresupuestosItem();
        _this.categoriasPresupuestales = [];
        _this.costoUnitario = 0;
        _this.form = builder.group({
            'idDepartamento': [0, controls_1.AztecaValidators.selected],
            'idArticulo': [0, controls_1.AztecaValidators.selected],
            'idPresupuesto': [''],
            'idCategoriaPresupuestal': [0],
        });
        _this.trasladosCollection.filter = function (item) {
            return item.tipoAplicacion == accounting_1.TipoAplicacion.TRASLADO;
        };
        _this.retencionesCollection.filter = function (item) {
            return item.tipoAplicacion == accounting_1.TipoAplicacion.RETENCION;
        };
        //Si se manejan presupuesto
        _this.form.controls['idDepartamento'].valueChanges.subscribe(function (value) {
            _this.form.controls['idPresupuesto'].setValidators(null);
            _this.form.controls['idCategoriaPresupuestal'].setValidators(null);
            if (_this.departamento && _this.departamento.tipoPresupuesto != "N") {
                _this.form.controls['idPresupuesto'].setValidators(forms_1.Validators.required);
                if (_this.departamento && _this.departamento.tipoPresupuesto == "C")
                    _this.form.controls['idCategoriaPresupuestal'].setValidators(controls_1.AztecaValidators.selected);
            }
            _this.form.controls['idPresupuesto'].updateValueAndValidity();
            _this.form.controls['idCategoriaPresupuestal'].updateValueAndValidity();
        });
        return _this;
    }
    Object.defineProperty(RecepcionSinOCArticulosEditor.prototype, "costo", {
        get: function () {
            return wijmo_1.Globalize.formatNumber(this.costoUnitario, "c");
        },
        enumerable: true,
        configurable: true
    });
    /////////////////// METODOS ///////////////////////////////
    //validatePresupuesto(departamento: DepartamentoItem, control: FormControl) {
    //    if (departamento && departamento.tipoPresupuesto != "N" && control.value == "")
    //        return 'Debe establecerse un presupuesto';
    //    else
    //        return null;
    //}
    //validateCategoria(departamento: DepartamentoItem, control: FormControl) {
    //    if (departamento && departamento.tipoPresupuesto == "C" && control.value == "")
    //        return 'Debe establecer una categoria presupuestal';
    //    else
    //        return null;
    //}
    RecepcionSinOCArticulosEditor.prototype.onArticuloChanged = function (articulo) {
        if (articulo) {
            if (this.detailCopy.idArticulo > 0) {
                this.costoUnitario = 0;
                this.detailCopy.articulo = articulo;
                this.loadStock(this.detailCopy.articulo.articuloStock.identity);
                this.loadCategoriasPresupuestales(this.detailCopy.idPresupuesto);
                //this.articuloService.calcularCostoProveedor(this.detailCopy.articulo.identity, articulo.idUnidadMedida, this.idProveedor, this.context.app.defaultCompany.identity)
                //    .then(costo => {
                //        this.detailCopy.costoUnitario = costo.costoBase;
                //        this.detailCopy.costoNeto = costo.costoNeto;
                //        this.detailCopy.descuentos = costo.descuentos;
                //        this.detailCopy.impuestos = costo.impuestos;
                //        this.detailCopy.importe = costo.costoBase * this.detailCopy.cantidad;
                //        this.costoUnitario = this.detailCopy.costoUnitario;
                //        //this.costoUnitario = Globalize.formatNumber(this.detailCopy.costoUnitario, 'c');
                //        //
                //        this.trasladosCollection.sourceCollection = costo.impuestos;
                //        this.retencionesCollection.sourceCollection = costo.impuestos;
                //    })
                //    .catch(error => this.handleError(error));
            }
        }
        //else {
        //    let impuestosEmpty: ImpuestoDetailInfo[] = [];
        //    this.trasladosCollection.sourceCollection = impuestosEmpty;
        //    this.retencionesCollection.sourceCollection = impuestosEmpty;
        //}
    };
    RecepcionSinOCArticulosEditor.prototype.loadStock = function (idArticulo) {
        var _this = this;
        this.almacenService.loadStock(this.idAlmacen, idArticulo)
            .then(function (stock) {
            _this.stockConfig = stock;
            _this.loadUnidadesMedida(_this.detailCopy.articulo.articuloStock.unidadMedida.idUnidadMedidaTipo);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionSinOCArticulosEditor.prototype.loadUnidadesMedida = function (idTipoUnidad) {
        var _this = this;
        //Si el articulo esta controlado por series, no se puede cambiar la unidad de medida, por lo tanto solo se debe utilizar la unidad de medida el articulo,
        //en caso contrario, cargar lista de unidades de medida del mismo tipo
        if (this.stockConfig.manejaSeries) {
            var unidadArticulo = this.detailCopy.articulo.articuloStock.unidadMedida;
            var newUnidad = {
                id: unidadArticulo.identity, codigo: unidadArticulo.code, idUnidadMedidaTipo: unidadArticulo.idUnidadMedidaTipo, base: unidadArticulo.base,
                factor: unidadArticulo.factor, fraccionable: unidadArticulo.fraccionable, paquete: unidadArticulo.paquete, activo: true
            };
            var newUnidades = [];
            newUnidades.push(newUnidad);
            this.unidadesMedida = newUnidades;
            this.detailCopy.idUnidadMedida = unidadArticulo.identity;
            this.detailCopy.unidadMedida.nombre = unidadArticulo.nombre;
        }
        else {
            this.unidadesMedida = [];
            var requestProveedor = new search_1.SearchRequest();
            requestProveedor.pageIndex = 0;
            requestProveedor.pageSize = 0;
            requestProveedor.paged = false;
            this.proveedorService.searchProveedorByArticulo(this.detailCopy.articulo.identity, this.context.app.defaultSite.identity, requestProveedor)
                //this.unidadMedidaService.loadList(idTipoUnidad)
                .then(function (unidadesMedida) {
                //this.unidadesMedida = unidadesMedida;
                unidadesMedida.rows.forEach(function (item) {
                    var um = _this.unidadesMedida.find(function (x) { return x.id == item.idUnidadMedida; });
                    if (um == null || um == undefined)
                        _this.unidadesMedida.push({ id: item.idUnidadMedida, nombre: item.unidadMedida });
                });
                _this.detailCopy.idUnidadMedida = _this.detailCopy.articulo.articuloStock.idUnidadMedida;
                _this.onUnidadMedidaChange(_this.detailCopy.articulo.articuloStock.idUnidadMedida);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    RecepcionSinOCArticulosEditor.prototype.onUnidadMedidaChange = function (idUnidadMedida) {
        var _this = this;
        this.articuloService.calcularCostoProveedor(this.detailCopy.idArticulo, idUnidadMedida, this.idProveedor, this.context.app.defaultCompany.identity)
            .then(function (costo) {
            _this.detailCopy.costoUnitario = costo.costoBase;
            _this.detailCopy.costoNeto = costo.costoNeto;
            _this.detailCopy.descuentos = costo.descuentos;
            _this.detailCopy.impuestos = costo.impuestos;
            _this.costoUnitario = _this.detailCopy.costoUnitario;
            _this.detailCopy.importe = _this.detailCopy.costoUnitario * _this.detailCopy.cantidad;
            //
            _this.trasladosCollection.sourceCollection = costo.impuestos;
            _this.retencionesCollection.sourceCollection = costo.impuestos;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionSinOCArticulosEditor.prototype.onCantidadChanged = function (cantidad) {
        this.detailCopy.importe = this.detailCopy.costoUnitario * cantidad;
    };
    RecepcionSinOCArticulosEditor.prototype.onCostoUnitarioChanged = function (costo) {
        this.detailCopy.importe = this.detailCopy.importe; //this.detailCopy.cantidad * costo;
    };
    RecepcionSinOCArticulosEditor.prototype.onDepartamentoChanged = function (idDepartamento) {
        if (idDepartamento > 0) {
            this.departamento = this.departamentos.find(function (item) { return item.id == idDepartamento; });
            this.detailCopy.departamento = this.departamento.nombre;
            if (this.departamento.tipoPresupuesto != 'N') {
                this.loadPresupuestos(idDepartamento);
            }
        }
    };
    RecepcionSinOCArticulosEditor.prototype.onPresupuestoChanged = function (idPresupuesto) {
        this.loadCategoriasPresupuestales(idPresupuesto);
    };
    RecepcionSinOCArticulosEditor.prototype.loadPresupuestos = function (idDepartamento) {
        var _this = this;
        if (this.departamento.tipoPresupuesto != 'N') {
            this.presupuestosService.loadPresupuestos(idDepartamento)
                .then(function (info) {
                //Si es nuevo, solo que despliegue los presupuestos abiertos
                if (_this.detailCopy.id == 0) {
                    _this.presupuestos = info.filter(function (prestos) { return prestos.workFlowStepTag == 'OPEN'; });
                }
                else
                    _this.presupuestos = info;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    RecepcionSinOCArticulosEditor.prototype.loadCategoriasPresupuestales = function (idPresupuesto) {
        var _this = this;
        if (this.departamento && this.departamento.tipoPresupuesto == 'C' && idPresupuesto != "" && this.detailCopy.idArticulo != 0) {
            this.presupuestosService.loadCategoriasConArticulo(idPresupuesto, this.detailCopy.idArticulo)
                .then(function (info) {
                _this.categoriasPresupuestales = info;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    /////////////////// HANDLERS //////////////////////////////
    RecepcionSinOCArticulosEditor.prototype.onCreatingItem = function () {
        this.detailCopy = this.detail;
        this.form.reset({ idArticulo: 0, costoUnitario: 0, idDepartamento: 0 });
        this.costoUnitario = 0;
        this.detailCopy.costoUnitario = 0;
        this.trasladosCollection = new wijmo_1.CollectionView();
        this.retencionesCollection = new wijmo_1.CollectionView();
        this.form.markAsPristine();
        if (this.departamentos.length > 0) {
            this.detailCopy.idDepartamento = this.departamentos[0].id;
            this.onDepartamentoChanged(this.departamentos[0].id);
        }
    };
    RecepcionSinOCArticulosEditor.prototype.onLoadingItem = function (detail) {
        var _this = this;
        this.detailCopy = this.copyItem(this.detail);
        timers_1.setTimeout(function (_) {
            if (_this.departamentos.length > 0) {
                _this.onDepartamentoChanged(detail.idDepartamento);
            }
            _this.loadStock(_this.detailCopy.articulo.articuloStock.identity);
            _this.costoUnitario = _this.detailCopy.costoUnitario;
            _this.trasladosCollection.sourceCollection = _this.detailCopy.impuestos;
            _this.retencionesCollection.sourceCollection = _this.detailCopy.impuestos;
        }, 1 * 1000);
    };
    RecepcionSinOCArticulosEditor.prototype.onUpdatingItem = function (detail) {
        if (this.detailCopy._clientID == 0) {
            this.detailCopy._clientID = this.createClientID();
        }
        else {
            this.detailCopy.state = editors_1.ChangeState.MODIFIED;
        }
        this.savingItem.emit(this.detailCopy);
    };
    RecepcionSinOCArticulosEditor.prototype.onEditCell = function (grid, args) {
        if (!grid.rows[args.row].dataItem.impuesto.rango && grid.columns[args.col].binding == 'tasaOCuota') {
            args.cancel = true;
        }
    };
    RecepcionSinOCArticulosEditor.prototype.onEditedCell = function (grid, args) {
        if (grid.rows[args.row].dataItem.impuesto.rango && grid.columns[args.col].binding == 'tasaOCuota') {
            grid.rows[args.row].dataItem.importe = grid.rows[args.row].dataItem.base * grid.rows[args.row].dataItem.tasaOCuota;
        }
    };
    RecepcionSinOCArticulosEditor.prototype.onFormatCell = function (grid, args) {
        if (args.panel.cellType == wijmo_grid_1.CellType.Cell && !grid.rows[args.row].dataItem.impuesto.rango && grid.columns[args.col].binding == 'tasaOCuota') {
            args.cell.style.backgroundColor = '#C0C0C0';
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", recepcion_sin_oc_detail_articulo_1.RecepcionSinOCDetailArticulo)
    ], RecepcionSinOCArticulosEditor.prototype, "detail", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], RecepcionSinOCArticulosEditor.prototype, "idAlmacen", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], RecepcionSinOCArticulosEditor.prototype, "idProveedor", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], RecepcionSinOCArticulosEditor.prototype, "departamentos", void 0);
    __decorate([
        core_1.ViewChild('articuloEntrada'),
        __metadata("design:type", articulo_stock_entrada_component_1.ArticuloStockEntradaComponent)
    ], RecepcionSinOCArticulosEditor.prototype, "articuloEntrada", void 0);
    RecepcionSinOCArticulosEditor = __decorate([
        core_1.Component({
            selector: 'compras-recepcion-sin-oc-articulos-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <azteca-basic-editor [item]=\"detail\"\n                               [dirty]=\"dirty\"\n                               [valid]=\"valid\"\n                               (creatingItem)=\"onCreatingItem()\"\n                               (loadingItem)=\"onLoadingItem($event)\"\n                               (updatingItem)=\"onUpdatingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-8\">\n                      <azteca-form-field [label]=\"'Articulo:'\">\n                          <purchasing-articulo-selector formControlName=\"idArticulo\"\n                                                        showListButton=\"false\"\n                                                        [(ngModel)]=\"detailCopy.idArticulo\"\n                                                        (selectedItemChanged)=\"onArticuloChanged($event)\"\n                                                        (articuloUpdated)=\"onArticuloChanged($event)\">\n                          </purchasing-articulo-selector>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12\">                \n                      <inventory-articulo-stock-entrada #articuloEntrada\n                                                        [stockConfig]=\"stockConfig\"\n                                                        [unidadesMedida]=\"unidadesMedida\"\n                                                        [idAlmacen]=\"idAlmacen\"\n                                                        [(cantidad)]=\"detailCopy.cantidad\"\n                                                        [(unidades)]=\"detailCopy.unidades\"\n                                                        [(costoUnitario)]=\"costoUnitario\"\n                                                        [(idUnidadMedida)]=\"detailCopy.idUnidadMedida\"\n                                                        [(numeroSerie)]=\"detailCopy.numeroSerie\"\n                                                        [(fechaCaducidad)]=\"detailCopy.fechaCaducidad\"\n                                                        [(idUbicacion)]=\"detailCopy.idUbicacion\"\n                                                        [costoEnabled]=\"false\"\n                                                        [unidadMedidaEnabled]=\"true\"\n                                                        (unidadMedidaChange)=\"onUnidadMedidaChange($event)\"\n                                                        (cantidadChange)=\"onCantidadChanged($event)\"\n                                                        (costoUnitarioChange)=\"onCostoUnitarioChanged($event)\">\n                      </inventory-articulo-stock-entrada>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-6\">\n                      <azteca-form-field [label]=\"'Departamento:'\">\n                          <az-combobox formControlName=\"idDepartamento\"\n                                       [(ngModel)]=\"detailCopy.idDepartamento\"\n                                       [items]=\"departamentos\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\"\n                                       (selectedItemChanged)=\"onDepartamentoChanged($event)\">\n                          </az-combobox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <az-panel [header]=\"'Presupuesto'\" type=\"success\" *ngIf=\"departamento ? departamento.tipoPresupuesto != 'N' : false\">\n                  <div class=\"row\">\n                      <div class=\"col-12 col-md-6\">\n                          <azteca-form-field [label]=\"'Presupuesto:'\" *ngIf=\"departamento ? departamento.tipoPresupuesto != 'N' :false\">\n                              <az-combobox formControlName=\"idPresupuesto\"\n                                           [(ngModel)]=\"detailCopy.idPresupuesto\"\n                                           [items]=\"presupuestos\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'id'\"\n                                           (selectedItemChanged)=\"onPresupuestoChanged($event)\">\n                              </az-combobox>\n                          </azteca-form-field>\n                      </div>\n                      <div class=\"col-12 col-md-6\">\n                          <azteca-form-field [label]=\"'Categoria Presupuestal:'\" *ngIf=\"departamento ? departamento.tipoPresupuesto == 'C' : false\">\n                              <az-combobox formControlName=\"idCategoriaPresupuestal\"\n                                           [(ngModel)]=\"detailCopy.idCategoriaPresupuestal\"\n                                           [items]=\"categoriasPresupuestales\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'id'\">\n                              </az-combobox>\n                          </azteca-form-field>\n                      </div>\n                  </div>\n              </az-panel>\n\n              <!--GRID DE TRASLADOS-->\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <label class=\"control-label\">Traslados:</label>\n                      <wj-flex-grid #gridTraslados style=\"height:120px\" [itemsSource]=\"trasladosCollection\"\n                                    (beginningEdit)=\"onEditCell(gridTraslados, $event)\" (formatItem)=\"onFormatCell(gridTraslados, $event)\"\n                                    (rowEditEnded)=\"onEditedCell(gridTraslados, $event)\">\n                          <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Factor'\" [binding]=\"'tipoFactor'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Base'\" [binding]=\"'base'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Tasa \u00F3 cuota'\" [binding]=\"'tasaOCuota'\" [width]=\"'20*'\" [isReadOnly]=\"'!impuesto.rango'\"></wj-flex-grid-column>\n                      </wj-flex-grid>\n                  </div>\n              </div>\n\n              <!--GRID DE RETENCIONES-->\n              <div class=\"row\" *ngIf=\"detailCopy.articuloServicio=='S'\">\n                  <div class=\"col-12\">\n\n                      <label class=\"control-label\">Retenciones:</label>\n                      <wj-flex-grid #gridRetenciones style=\"height:120px\" [itemsSource]=\"retencionesCollection\"\n                                    (beginningEdit)=\"onEditCell(gridRetenciones, $event)\" (formatItem)=\"onFormatCell(gridRetenciones, $event)\">\n                          <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Factor'\" [binding]=\"'tipoFactor'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Base'\" [binding]=\"'base'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Tasa \u00F3 cuota'\" [binding]=\"'tasaOCuota'\" [width]=\"'20*'\" [isReadOnly]=\"'!impuesto.rango'\"></wj-flex-grid-column>\n                      </wj-flex-grid>\n\n                  </div>\n              </div>\n\n\n\n\n          </azteca-basic-editor>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, articulo_service_1.ArticuloService,
            unidad_medida_service_1.UnidadMedidaService, almacen_service_1.AlmacenService,
            presupuestos_service_1.PresupuestosService, proveedor_service_1.ProveedorService])
    ], RecepcionSinOCArticulosEditor);
    return RecepcionSinOCArticulosEditor;
}(editors_1.BasicEditor));
exports.RecepcionSinOCArticulosEditor = RecepcionSinOCArticulosEditor;
