import { FormBuilder } from '@angular/forms';
import { CollectionView } from 'wijmo/wijmo';
import { FlexGrid, CellRangeEventArgs, FormatItemEventArgs } from 'wijmo/wijmo.grid';
import { Context } from 'framework3/core';
import { BasicEditor } from 'framework3/editors';
import { RecepcionSinOCDetailServicio } from '../../models/recepcion-sin-oc-detail-servicio';
import { ServicioService } from '../../services/servicio.service';
import { ServicioInfo } from '../../models/servicio';
import { DepartamentoItem } from '../../models/departamento';
import { PresupuestosService } from '../../services/presupuestos.service';
import { PresupuestosItem } from '../../models/presupuestos';
import { CategoriasPresupuestalesItem } from '../../models/categorias-presupuestales';
export declare class RecepcionSinOCServiciosEditor extends BasicEditor {
    protected context: Context;
    private builder;
    private servicioService;
    private presupuestosService;
    detailCopy: RecepcionSinOCDetailServicio;
    trasladosCollection: CollectionView;
    retencionesCollection: CollectionView;
    detail: RecepcionSinOCDetailServicio;
    idAlmacen: number;
    idProveedor: number;
    departamentos: DepartamentoItem[];
    departamento: DepartamentoItem;
    presupuestos: PresupuestosItem[];
    presupuesto: PresupuestosItem;
    categoriasPresupuestales: CategoriasPresupuestalesItem[];
    constructor(context: Context, builder: FormBuilder, servicioService: ServicioService, presupuestosService: PresupuestosService);
    onServicioChanged(servicio: ServicioInfo): void;
    onCantidadChange(cantidad: number): void;
    onCostoChange(costo: number): void;
    onDepartamentoChanged(idDepartamento: number): void;
    onPresupuestoChanged(idPresupuesto: string): void;
    loadPresupuestos(idDepartamento: number): void;
    loadCategoriasPresupuestales(idPresupuesto: string): void;
    filtrarImpuestos(): void;
    onCreatingItem(): void;
    onLoadingItem(detail: RecepcionSinOCDetailServicio): void;
    onUpdatingItem(detail: RecepcionSinOCDetailServicio): void;
    onEditCell(grid: FlexGrid, args: CellRangeEventArgs): void;
    onEditedCell(grid: FlexGrid, args: CellRangeEventArgs): void;
    onFormatCell(grid: FlexGrid, args: FormatItemEventArgs): void;
}
