import { FormBuilder } from '@angular/forms';
import { Context } from 'framework3/core';
import { BasicEditor, EditableListComponent } from 'framework3/editors';
import { RecepcionSinOCDetail } from '../../models/recepcion-sin-oc-detail';
import { RecepcionSinOCDetailArticulo } from '../../models/recepcion-sin-oc-detail-articulo';
import { DepartamentoItem } from '../../models/departamento';
import { RecepcionSinOCArticulosEditor } from './recepciones-sin-oc-detail-articulos.editor';
import { RecepcionSinOCServiciosEditor } from './recepciones-sin-oc-detail-servicios.editor';
import { OrdenDetail } from '../../models/orden-detail';
import { ImportesInfo } from '../../../accounting/models/importes';
import { RecepcionSinOCDetailServicio } from '../../models/recepcion-sin-oc-detail-servicio';
export declare class RecepcionSinOCDetailEditor extends BasicEditor {
    protected context: Context;
    private builder;
    detailCopy: RecepcionSinOCDetail;
    detail: RecepcionSinOCDetail;
    idAlmacen: number;
    departamentos: DepartamentoItem[];
    idProveedor: number;
    totalCF: number;
    totalRecepcion: number;
    montoDiferencia: string;
    articulosList: EditableListComponent;
    serviciosList: EditableListComponent;
    articulosEditor: RecepcionSinOCArticulosEditor;
    serviciosEditor: RecepcionSinOCServiciosEditor;
    constructor(context: Context, builder: FormBuilder);
    readonly importesComprobante: ImportesInfo;
    readonly importesRecepcion: ImportesInfo;
    validDiferencia(): string;
    calcularImportes(): ImportesInfo;
    separarDetail(): void;
    combineDetail(): OrdenDetail[];
    onCreatingItem(): void;
    onLoadingItem(detail: RecepcionSinOCDetail): void;
    onUpdatingItem(detail: RecepcionSinOCDetail): void;
    onAddingArticulo(): void;
    onEditingArticulo(detail: RecepcionSinOCDetailArticulo): void;
    onDeletingArticulo(detail: RecepcionSinOCDetailArticulo): void;
    onArticulosUpdated(updatedItems: RecepcionSinOCDetailArticulo[]): void;
    onSavingArticulo(detail: RecepcionSinOCDetailArticulo): void;
    onSavingArticulos(details: RecepcionSinOCDetailArticulo[]): void;
    onUpdateQuantity(value: any): void;
    onAddingServicio(): void;
    onEditingServicio(detail: RecepcionSinOCDetailServicio): void;
    onDeletingServicio(detail: RecepcionSinOCDetailServicio): void;
    onServiciosUpdated(updatedServices: RecepcionSinOCDetailServicio[]): void;
    onSavingServicio(detail: RecepcionSinOCDetailServicio): void;
    onSavingServicios(details: RecepcionSinOCDetailServicio[]): void;
    onTabSelected(args: any): void;
}
