"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var recepcion_sin_oc_detail_1 = require("../../models/recepcion-sin-oc-detail");
var recepcion_sin_oc_detail_articulo_1 = require("../../models/recepcion-sin-oc-detail-articulo");
var recepciones_sin_oc_detail_articulos_editor_1 = require("./recepciones-sin-oc-detail-articulos.editor");
var recepciones_sin_oc_detail_servicios_editor_1 = require("./recepciones-sin-oc-detail-servicios.editor");
//modulos del sistema
var importes_1 = require("../../../accounting/models/importes");
var recepcion_sin_oc_detail_servicio_1 = require("../../models/recepcion-sin-oc-detail-servicio");
var RecepcionSinOCDetailEditor = /** @class */ (function (_super) {
    __extends(RecepcionSinOCDetailEditor, _super);
    function RecepcionSinOCDetailEditor(context, builder) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.builder = builder;
        //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
        _this.detailCopy = new recepcion_sin_oc_detail_1.RecepcionSinOCDetail();
        //Objeto original que se editará
        _this.detail = new recepcion_sin_oc_detail_1.RecepcionSinOCDetail();
        _this.idAlmacen = 0;
        _this.departamentos = [];
        //
        _this.idProveedor = 0;
        _this.totalCF = 0;
        _this.totalRecepcion = 0;
        _this.montoDiferencia = '$0.00';
        _this.form = builder.group({
            'montoDeDiferencia': [0, function (control) { return _this.validDiferencia(); }]
        });
        return _this;
    }
    Object.defineProperty(RecepcionSinOCDetailEditor.prototype, "importesComprobante", {
        get: function () {
            var desglose = new importes_1.ImportesInfo();
            if (this.detail.comprobante) {
                desglose.total = this.detail.comprobante.total;
                desglose.subtotal = this.detail.comprobante.subtotal;
                desglose.descuentos = this.detail.comprobante.descuentos;
                desglose.impuestosTrasladados = this.detail.comprobante.impuestosTrasladados;
                desglose.impuestosRetenidos = this.detail.comprobante.impuestosRetenidos;
                this.totalCF = desglose.total;
                //this.visualValidacion();
            }
            return desglose;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RecepcionSinOCDetailEditor.prototype, "importesRecepcion", {
        get: function () {
            return this.calcularImportes();
        },
        enumerable: true,
        configurable: true
    });
    /////////////////// METODOS ///////////////////////////////
    RecepcionSinOCDetailEditor.prototype.validDiferencia = function () {
        var resultado = 'No correspone el total detallado contra el total del comprobante fiscal';
        if (Math.abs(this.totalCF - this.totalRecepcion) < .50 && this.totalCF + this.totalRecepcion > 0) //|| !this.recepcion.proveedor.comprobanteFiscal)
            resultado = null;
        return resultado;
    };
    RecepcionSinOCDetailEditor.prototype.calcularImportes = function () {
        var desglose = new importes_1.ImportesInfo();
        var elementos = this.combineDetail().filter(function (item) { return item.state != 'DELETED'; });
        elementos.forEach(function (item) {
            desglose.subtotal += item.costoUnitario * item.cantidad;
            desglose.descuentos += (item.descuentos.descuento1 + item.descuentos.descuento2 + item.descuentos.descuento3 + item.descuentos.descuento4 + item.descuentos.descuento5) * item.cantidad;
            if (item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "T"; }).length > 0)
                desglose.impuestosTrasladados += item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "T"; }).map(function (imp) { return imp.importe * item.cantidad; }).reduce(function (a, b) { return a + b; });
            if (item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "R"; }).length > 0)
                desglose.impuestosRetenidos += item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "R"; }).map(function (imp) { return imp.importe * item.cantidad; }).reduce(function (a, b) { return a + b; });
        });
        desglose.total = desglose.subtotal - desglose.descuentos + desglose.impuestosTrasladados - desglose.impuestosRetenidos;
        this.totalRecepcion = desglose.total;
        //this.visualValidacion();
        this.montoDiferencia = wijmo_1.Globalize.formatNumber(this.totalRecepcion - this.totalCF, 'c');
        return desglose;
    };
    //Separar articulos y servicios
    RecepcionSinOCDetailEditor.prototype.separarDetail = function () {
        //    //
        //    this.articulos = this.recepcion.details.map(d => <RecepcionArticuloDetail>d).filter(d => d.idArticulo && d.idArticulo > 0);
        //    this.servicios = this.recepcion.details.map(d => <RecepcionServicioDetail>d).filter(d => d.idServicio && d.idServicio > 0);
        //    //
        //    //this.detailsEditor.clientIndexStart = this.articulos.length + this.servicios.length;
        //    this.articulosEditor.clientIndexStart = this.articulos.length;
        //    this.serviciosEditor.clientIndexStart = this.servicios.length;
    };
    RecepcionSinOCDetailEditor.prototype.combineDetail = function () {
        var defaultDate = new Date(1901, 1, 1);
        var newDetail = [];
        this.detailCopy.servicios.filter(function (f) { return f.state != "DELETED"; }).forEach(function (s) { return newDetail.push(s); });
        this.detailCopy.articulos.filter(function (f) { return f.state != "DELETED"; }).forEach(function (a) {
            if (!a.articulo.articuloStock.manejaCaducidad)
                a.fechaCaducidad = defaultDate;
            newDetail.push(a);
        });
        return newDetail;
    };
    /////////////////// HANDLERS //////////////////////////////
    RecepcionSinOCDetailEditor.prototype.onCreatingItem = function () {
        this.detailCopy = this.detail;
        this.idProveedor = this.detailCopy.comprobante.idProveedor;
        this.form.reset({ sample: '' });
        this.form.markAsPristine();
    };
    RecepcionSinOCDetailEditor.prototype.onLoadingItem = function (detail) {
        this.detailCopy = this.copyItem(this.detail);
        this.idProveedor = this.detailCopy.comprobante.idProveedor;
        //this.articulos = this.detailCopy.articulos;
        //this.servicios = this.detailCopy.servicios;
        //separar el detalle en arreglo de articulos y servicios
        this.separarDetail();
    };
    RecepcionSinOCDetailEditor.prototype.onUpdatingItem = function (detail) {
        if (this.detailCopy._clientID == 0) {
            this.detailCopy._clientID = this.createClientID();
        }
        else {
            this.detailCopy.state = editors_1.ChangeState.MODIFIED;
        }
        //this.detail.orden.details = this.combineDetail();
        this.savingItem.emit(this.detailCopy);
    };
    //Handlers Articulos / servicios
    ///////////// ARTICULOS /////////////////////////
    RecepcionSinOCDetailEditor.prototype.onAddingArticulo = function () {
        this.articulosEditor.detail = new recepcion_sin_oc_detail_articulo_1.RecepcionSinOCDetailArticulo();
        this.articulosEditor.show();
    };
    RecepcionSinOCDetailEditor.prototype.onEditingArticulo = function (detail) {
        this.articulosEditor.detail = detail;
        //this.articulosEditor.onLoadingItem(detail);
        this.articulosEditor.show();
        //this.quantityEditor.unidadMedida = detail.unidadMedida;
        //this.quantityEditor.cantidad = detail.cantidad;
        //this.quantityEditor.unidades = detail.unidades;
        //this.quantityEditor.show();
    };
    RecepcionSinOCDetailEditor.prototype.onDeletingArticulo = function (detail) {
        this.articulosList.deleteItem(detail);
    };
    RecepcionSinOCDetailEditor.prototype.onArticulosUpdated = function (updatedItems) {
        this.detailCopy.articulos = updatedItems;
    };
    RecepcionSinOCDetailEditor.prototype.onSavingArticulo = function (detail) {
        this.articulosList.updateItem(detail);
    };
    RecepcionSinOCDetailEditor.prototype.onSavingArticulos = function (details) {
        this.articulosList.updateItems(details);
    };
    RecepcionSinOCDetailEditor.prototype.onUpdateQuantity = function (value) {
        var detail = this.articulosList.currentItem;
        if (detail.unidadMedida.paquete) {
            var cantidad = value;
            detail.cantidad = cantidad.paquetes;
            detail.unidades = cantidad.unidades;
        }
        else {
            detail.cantidad = value;
        }
        this.articulosList.updateItem(detail);
    };
    ///////////// SERVICIOS /////////////////////////
    RecepcionSinOCDetailEditor.prototype.onAddingServicio = function () {
        this.serviciosEditor.detail = new recepcion_sin_oc_detail_servicio_1.RecepcionSinOCDetailServicio();
        this.serviciosEditor.show();
    };
    RecepcionSinOCDetailEditor.prototype.onEditingServicio = function (detail) {
        this.serviciosEditor.detail = detail;
        //this.serviciosEditor.onLoadingItem(detail);
        this.serviciosEditor.show();
    };
    RecepcionSinOCDetailEditor.prototype.onDeletingServicio = function (detail) {
        this.serviciosList.deleteItem(detail);
    };
    RecepcionSinOCDetailEditor.prototype.onServiciosUpdated = function (updatedServices) {
        this.detailCopy.servicios = updatedServices;
    };
    RecepcionSinOCDetailEditor.prototype.onSavingServicio = function (detail) {
        this.serviciosList.updateItem(detail);
    };
    RecepcionSinOCDetailEditor.prototype.onSavingServicios = function (details) {
        this.serviciosList.updateItems(details);
    };
    RecepcionSinOCDetailEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", recepcion_sin_oc_detail_1.RecepcionSinOCDetail)
    ], RecepcionSinOCDetailEditor.prototype, "detail", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], RecepcionSinOCDetailEditor.prototype, "idAlmacen", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], RecepcionSinOCDetailEditor.prototype, "departamentos", void 0);
    __decorate([
        core_1.ViewChild('articulosList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], RecepcionSinOCDetailEditor.prototype, "articulosList", void 0);
    __decorate([
        core_1.ViewChild('serviciosList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], RecepcionSinOCDetailEditor.prototype, "serviciosList", void 0);
    __decorate([
        core_1.ViewChild('articulosEditor'),
        __metadata("design:type", recepciones_sin_oc_detail_articulos_editor_1.RecepcionSinOCArticulosEditor)
    ], RecepcionSinOCDetailEditor.prototype, "articulosEditor", void 0);
    __decorate([
        core_1.ViewChild('serviciosEditor'),
        __metadata("design:type", recepciones_sin_oc_detail_servicios_editor_1.RecepcionSinOCServiciosEditor)
    ], RecepcionSinOCDetailEditor.prototype, "serviciosEditor", void 0);
    RecepcionSinOCDetailEditor = __decorate([
        core_1.Component({
            selector: 'compras-recepcion-sin-oc-detail-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <azteca-basic-editor [title]=\"'Relaci\u00F3n de recepci\u00F3n de articulos/servicios del comprobante fiscal'\"\n                               [item]=\"detail\"\n                               [dirty]=\"dirty\"\n                               [valid]=\"valid\"\n                               (creatingItem)=\"onCreatingItem()\"\n                               (loadingItem)=\"onLoadingItem($event)\"\n                               (updatingItem)=\"onUpdatingItem($event)\">\n\n\n              <div class=\"row\">\n                  <div class=\"col-sm-12 col-md-5\">\n                      <accounting-importes-component [importes]=\"importesComprobante\"\n                                                     [titulo]=\"'Importes Comprobante Fiscal'\">\n                      </accounting-importes-component>\n                  </div>\n                  <div class=\"col-sm-12 col-md-2\">\n                      <div class=\"row\">\n                          <div class=\"col-12\">\n                              <azteca-form-field [label]=\"'Diferencia:'\">\n                                  <az-textbox formControlName=\"montoDeDiferencia\" [(ngModel)]=\"montoDiferencia\" style=\"text-align:right; font-size:small;\" [enabled]=\"false\"></az-textbox>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n                  </div>\n                  <div class=\"col-sm-12 col-md-5\">\n                      <accounting-importes-component [importes]=\"importesRecepcion\"\n                                                     [titulo]=\"'Importes articulos/servicios detallados'\">\n                      </accounting-importes-component>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-12\">\n\n                      <tabset>\n                          <!--ARTICULOS -->\n                          <tab heading=\"Art\u00EDculos\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #articulosList\n                                                    (addingItem)=\"onAddingArticulo()\"\n                                                    (editingItem)=\"onEditingArticulo($event)\"\n                                                    (deletingItem)=\"onDeletingArticulo($event)\"\n                                                    (listItemsUpdated)=\"onArticulosUpdated($event)\"\n                                                    [listItems]=\"detailCopy.articulos\"\n                                                    [allowNew]=\"true\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar art\u00EDculo'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar art\u00EDculo'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'articulo.code'\" [width]=\"100\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Descripci\u00F3n'\" [binding]=\"'articulo.articuloStock.nombre'\" [width]=\"'45*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'U.M.'\" [binding]=\"'unidadMedida.nombre'\" [width]=\"'20*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Unidades'\" [binding]=\"'unidades'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Costo'\" [binding]=\"'costoUnitario'\" [width]=\"'15*'\" format=\"C\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'20*'\" format=\"C\"></azteca-grid-column>\n                              </azteca-editable-list>\n                          </tab>\n\n                          <!--SERVICIOS -->\n                          <tab heading=\"Servicios\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #serviciosList\n                                                    (addingItem)=\"onAddingServicio()\"\n                                                    (editingItem)=\"onEditingServicio($event)\"\n                                                    (deletingItem)=\"onDeletingServicio($event)\"\n                                                    (listItemsUpdated)=\"onServiciosUpdated($event)\"\n                                                    [listItems]=\"detailCopy.servicios\"\n                                                    [allowNew]=\"true\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar servicio'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar servicio'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'servicio.code'\" [width]=\"100\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Descripci\u00F3n'\" [binding]=\"'servicio.nombre'\" [width]=\"'5*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [width]=\"'1*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Costo'\" [binding]=\"'costoUnitario'\" [width]=\"'1*'\" format=\"C\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'1*'\" format=\"C\"></azteca-grid-column>\n\n                              </azteca-editable-list>\n                          </tab>\n\n                      </tabset>\n\n                  </div>\n              </div>\n\n\n          </azteca-basic-editor>\n      </form>\n\n\n      <!--llamar al editor de articulos-->\n      <!--el proveedor se puede incluir  en el objeto detailCopy.comprobante-->\n      <compras-recepcion-sin-oc-articulos-editor #articulosEditor\n                                                 [idAlmacen]=\"idAlmacen\"\n                                                 [idProveedor]=\"idProveedor\"\n                                                 (savingItem)=\"onSavingArticulo($event)\"\n                                                 (savingItems)=\"onSavingArticulos($event)\"\n                                                 [departamentos]=\"departamentos\">\n      </compras-recepcion-sin-oc-articulos-editor>\n\n      <!--llamar al editor de servicios-->\n      <!--el proveedor se puede incluir  en el objeto detailCopy.comprobante-->\n      <compras-recepcion-sin-oc-servicios-editor #serviciosEditor\n                                                 [idProveedor]=\"idProveedor\"\n                                                 (savingItem)=\"onSavingServicio($event)\"\n                                                 (savingItems)=\"onSavingServicios($event)\"\n                                                 [departamentos]=\"departamentos\">\n      </compras-recepcion-sin-oc-servicios-editor>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder])
    ], RecepcionSinOCDetailEditor);
    return RecepcionSinOCDetailEditor;
}(editors_1.BasicEditor));
exports.RecepcionSinOCDetailEditor = RecepcionSinOCDetailEditor;
