"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var editors_1 = require("framework3/editors");
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//
var presupuestos_service_1 = require("../services/presupuestos.service");
var presupuestos_1 = require("../models/presupuestos");
var presupuestos_detail_1 = require("../models/presupuestos-detail");
var wijmo_grid_1 = require("wijmo/wijmo.grid");
var PresupuestosCambioEditor = /** @class */ (function (_super) {
    __extends(PresupuestosCambioEditor, _super);
    function PresupuestosCambioEditor(context, router, route, location, formBuilder, presupuestosService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.presupuestosService = presupuestosService;
        _this.idPresupuesto = "";
        _this.collectionView = new wijmo_1.CollectionView();
        _this.idCategoriaSelected = 0;
        _this.conceptoEdit = "";
        _this.montoEdit = 0;
        _this.form = formBuilder.group({
            '': [0, forms_1.Validators.required],
        });
        _this.presupuestos = new presupuestos_1.PresupuestosInfo();
        return _this;
    }
    PresupuestosCambioEditor.prototype.ngOnInit = function () {
        var _this = this;
        if (this.route.params) {
            this.route.params.forEach(function (param) {
                _this.idPresupuesto = param['id'];
            });
        }
    };
    PresupuestosCambioEditor.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.onLoadingDocument(_this.idPresupuesto); });
    };
    PresupuestosCambioEditor.prototype.agregarConcepto = function (detail) {
        this.idCategoriaSelected = detail.categoriaPresupuestal.identity;
        this.detailCurrent = detail;
        //this.dialogArticulos.idCategoriaPresupuestal = detail.categoriaPresupuestal.identity;
        this.dialogConceptos.config.backdrop = false;
        this.dialogConceptos.show();
        wijmo_1.Control.invalidateAll();
    };
    PresupuestosCambioEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.presupuestosService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.presupuestos = doc;
            _this.collectionView.sourceCollection = _this.presupuestos.details;
            //this.data = new CollectionView(this.presupuestos.details, {
            //    sortDescriptions: ['key'],
            //    groupDescriptions: ['key']
            //});
            //setTimeout(_ => {
            //    if (this.grid)
            //        this.grid.collapseGroupsToLevel(0);
            //});
            _this.recalcularImportes();
            //this.detailsEditor.clientIndexStart = this.presupuestos.details.length;
            //if (this.presupuestos.status != DocumentStatus.DRAFT)
            //    this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PresupuestosCambioEditor.prototype.onCellEditEnded = function (flex, e, cell) {
        this.recalcularDetalle();
    };
    PresupuestosCambioEditor.prototype.recalcularDetalle = function () {
        var monto = 0;
        if (this.detailCurrent.conceptos.filter(function (search) { return search.state != 'DELETED'; }).length > 0)
            monto += this.detailCurrent.conceptos.filter(function (search) { return search.state != 'DELETED'; }).map(function (c) { return c.montoPresupuesto; }).reduce(function (sum, current) { return sum + current; });
        if (this.detailCurrent.articulos.filter(function (search) { return search.state != 'DELETED'; }).length > 0)
            monto += this.detailCurrent.articulos.filter(function (search) { return search.state != 'DELETED'; }).map(function (c) { return c.montoPresupuesto; }).reduce(function (sum, current) { return sum + current; });
        if (this.detailCurrent.servicios.filter(function (search) { return search.state != 'DELETED'; }).length > 0)
            monto += this.detailCurrent.servicios.filter(function (search) { return search.state != 'DELETED'; }).map(function (c) { return c.montoPresupuesto; }).reduce(function (sum, current) { return sum + current; });
        this.detailCurrent.montoPresupuesto = monto;
        this.recalcularImportes();
        this.detailCurrent.state = "MODIFIED";
        this.detailsList.refreshCells(true);
        wijmo_1.Control.invalidateAll();
    };
    PresupuestosCambioEditor.prototype.recalcularImportes = function () {
        this.presupuestos.montoPresupuesto = this.presupuestos.details.map(function (c) { return c.montoPresupuesto; }).reduce(function (sum, current) { return sum + current; }); //this.categoriasPresupuestales.map(c => c.montoPresupuesto).reduce((sum, current) => sum + current);
        this.presupuestos.montoUtilizado = this.presupuestos.details.map(function (c) { return c.montoUtilizado; }).reduce(function (sum, current) { return sum + current; });
        this.presupuestos.montoDisponible = this.presupuestos.details.map(function (c) { return c.montoDisponible; }).reduce(function (sum, current) { return sum + current; });
        this.presupuestos.montoApartado = this.presupuestos.details.map(function (c) { return c.montoApartado; }).reduce(function (sum, current) { return sum + current; });
    };
    PresupuestosCambioEditor.prototype.initialized = function (flex) {
        var _this = this;
        var self = this;
        this.grid = flex;
        this.collectionView.currentChanged.addHandler(function (args) {
            _this.detailsList.refresh();
            _this.detailsList.collapseGroupsToLevel(1);
            _this.detailCurrent = self.collectionView.currentItem;
            var curRow = _this.detailsList.rows[_this.detailsList.selection.row];
            curRow.isCollapsed = false;
            curRow.isCollapsed = true;
        }, self);
        // start collapsed
        if (flex)
            flex.collapseGroupsToLevel(0);
    };
    PresupuestosCambioEditor.prototype.onConceptoSelected = function (concepto, monto) {
        var bakItems = this.detailCurrent.conceptos.slice();
        //items.forEach(articulo => {
        var searchItem = this.detailCurrent.conceptos.find(function (concep) { return concep.descripcion == concepto; });
        if (searchItem == undefined) {
            var newCatDetail = new presupuestos_detail_1.CategoriaDetail();
            newCatDetail._clientID = bakItems.length + 1;
            newCatDetail.idArticulo = 0;
            newCatDetail.descripcion = concepto;
            newCatDetail.montoPresupuesto = monto;
            newCatDetail.idServicio = 0;
            //newCatDetail.idPresupuestoDet = 0;
            bakItems.push(newCatDetail);
        }
        //});
        this.detailCurrent.conceptos = bakItems;
        this.detailCurrent.state = "MODIFIED";
        this.conceptoEdit = "";
        this.montoEdit = 0;
        this.recalcularDetalle();
    };
    Object.defineProperty(PresupuestosCambioEditor.prototype, "montoPresupuesto", {
        //////////////////////////// Atributos de lectura ////////////////////////////////
        get: function () {
            if (this.presupuestos.montoPresupuesto == undefined)
                this.presupuestos.montoPresupuesto = 0;
            return wijmo_1.Globalize.formatNumber(this.presupuestos.montoPresupuesto, 'c');
        },
        enumerable: true,
        configurable: true
    });
    PresupuestosCambioEditor.prototype.onConfirmClick = function () {
        var _this = this;
        //this.loadDetails();
        this.context.app.showSpinner();
        this.presupuestosService.saveChange(this.presupuestos)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            //this.reset();
            //if (!args.closeEditor && this.presupuestos.identity == '') {
            //    this.router.navigate(['../', updatedDoc.identity], { relativeTo: this.route });
            //}
            //else {
            //    if (args.closeEditor)
            _this.router.navigate(['../../'], { relativeTo: _this.route });
            //    else
            //        this.showAlert('La información ha sido actualizada con éxito', 'success');
            //}
            //this.presupuestos = updatedDoc;
        })
            .catch(function (error) {
            _this.handleError(error);
        });
    };
    PresupuestosCambioEditor.prototype.onCancelClick = function () {
        this.location.back();
    };
    PresupuestosCambioEditor.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], PresupuestosCambioEditor.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", wijmo_grid_1.FlexGrid)
    ], PresupuestosCambioEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('conceptoDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], PresupuestosCambioEditor.prototype, "dialogConceptos", void 0);
    PresupuestosCambioEditor = __decorate([
        core_1.Component({
            selector: 'compras-presupuestos-cambio-editor',
            template: "\n\n      <az-panel title=\"Actualizar los montos del presupuesto.\">\n\n          <div class=\"row\">\n              <label class=\"control-label\">Total:</label>\n          </div>\n\n          <alerts-bar></alerts-bar>\n\n          <div class=\"row\">\n              <div class=\"input-group input-group-sm mb-0\">\n                  <div class=\"input-group-prepend\">\n                      <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 130px\">Presupuesto</span>\n                  </div>\n                  <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 200px\">{{montoPresupuesto}}</span>\n              </div>\n          </div>\n\n\n\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <!--(selectionChanged)=\"selectionChanged(detailsList, $event)\"-->\n                  <!--(cellEditEnding)=\"cellEditEndingHandler(detailsList, $event)\"\n                  (cellEditEnded)=\"onCellEditEndedCategoria(detailsList, $event, cell)\"-->\n\n                  <wj-flex-grid #detailsList\n                                (initialized)=\"initialized(grid, $event)\"\n                                [itemsSource]=\"collectionView\"\n                                [isReadOnly]=\"true\">\n                      <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                      <wj-flex-grid-column [header]=\"'Categoria Presupuestal'\" [binding]=\"'categoriaPresupuestal.nombre'\" [width]=\"'60*'\" [isReadOnly]=\"true\"></wj-flex-grid-column> <!-- Agrupar porseries-->\n                      <wj-flex-grid-column [header]=\"'Monto Presupuesto'\" [binding]=\"'montoPresupuesto'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"n2\" (change)=\"onCellEditEnded()\"></wj-flex-grid-column>\n\n\n                      <!--detailMode-->\n                      <ng-template wjFlexGridDetail [detailVisibilityMode]=\"detailMode\" let-item=\"item\">\n                          <!--[allowAddNew]=\"true\"-->\n                          <div class=\"row\">\n                              <div class=\"col-1\">\n                                  <button type=\"button\" class=\"btn btn-primary btn-sm fa fa-plus\" (click)=\"agregarConcepto(item)\" [disabled]=\"false\" title=\"Conceptos\"></button>\n                              </div>\n                              <p>Conceptos</p>\n                          </div>\n\n                          <div class=\"row\">\n\n                              <div class=\"col-12\">\n                                  <wj-flex-grid [itemsSource]=\"item.conceptos\"\n                                                [headersVisibility]=\"'Column'\"\n                                                (cellEditEnded)=\"onCellEditEnded(detailsList, $event, cell)\">\n                                      <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                      <wj-flex-grid-column [header]=\"'Concepto'\" [binding]=\"'descripcion'\" [width]=\"'60*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Monto'\" [binding]=\"'montoPresupuesto'\" [width]=\"'20*'\" [isReadOnly]=\"false\" format=\"n2\"></wj-flex-grid-column>\n                                  </wj-flex-grid>\n\n                                  <!--<div class=\"row\">\n                                          <div class=\"col-1\">\n                                              <button type=\"button\" class=\"btn btn-primary btn-sm fa fa-plus\" (click)=\"agregarArticulos(item)\" [disabled]=\"false\" title=\"Articulo\"></button>\n                                          </div>\n                                          <p>Articulos</p>\n                                      </div>\n\n                                      <wj-flex-grid [itemsSource]=\"item.articulos\"\n                                                    (cellEditEnded)=\"onCellEditEnded(detailsList, $event, cell)\">\n                                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                          <wj-flex-grid-column [header]=\"'Articulo'\" [binding]=\"'descripcion'\" [width]=\"'60*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Presupuesto'\" [binding]=\"'montoPresupuesto'\" [width]=\"'20*'\" [isReadOnly]=\"false\" format=\"n2\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Utilizado'\" [binding]=\"'montoUtilizado'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Apartado'\" [binding]=\"'montoApartado'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Disponible'\" [binding]=\"'montoDisponible'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                      </wj-flex-grid>\n                                  </div>\n\n                                  <div class=\"col-6\">\n                                      <div class=\"row\">\n                                          <div class=\"col-1\">\n                                              <button type=\"button\" class=\"btn btn-primary btn-sm fa fa-plus\" (click)=\"agregarServicios(item)\" [disabled]=\"false\" title=\"Articulo\"></button>\n                                          </div>\n                                          <p>Servicio</p>\n                                      </div>\n\n                                      <wj-flex-grid [itemsSource]=\"item.servicios\"\n                                                    style=\"height:100%\"\n                                                    (cellEditEnded)=\"onCellEditEnded(detailsList, $event, cell)\">\n                                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                          <wj-flex-grid-column [header]=\"'Servicio'\" [binding]=\"'descripcion'\" [width]=\"'60*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Presupuesto'\" [binding]=\"'montoPresupuesto'\" [width]=\"'20*'\" [isReadOnly]=\"false\" format=\"n2\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Utilizado'\" [binding]=\"'montoUtilizado'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Apartado'\" [binding]=\"'montoApartado'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Disponible'\" [binding]=\"'montoDisponible'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                       </wj-flex-grid>-->\n\n                              </div>\n                          </div>\n                      </ng-template>\n                  </wj-flex-grid>\n              </div>\n          </div>\n\n          <!--[disabled]=\"!isValid()\"-->\n          <div class=\"modal-footer\">\n              <button type=\"button\" class=\"btn btn-primary\" (click)=\"onConfirmClick()\">Aceptar</button>\n              <button type=\"button\" class=\"btn btn-default\" (click)=\"onCancelClick()\">Cancelar</button>\n          </div> <!-- Modal Footer-->\n\n      </az-panel>\n\n      <div bsModal #conceptoDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"mySmallModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\">Agregar conceptos</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <div class=\"row\">\n                          <div class=\"col-10\">\n                              <label class=\"control-label\">Concepto:</label>\n                              <az-textbox #txtConcepto [(ngModel)]=\"conceptoEdit\"></az-textbox>\n                          </div>\n                      </div>\n                      <div class=\"row\">\n                          <div class=\"col-10\">\n                              <label class=\"control-label\">Monto:</label>\n                              <az-input-number #txtMonto [format]=\"n2\" [(ngModel)]=\"montoEdit\"></az-input-number>\n                          </div>\n                      </div>\n                  </div> <!--Modal Body-->\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onConceptoSelected(txtConcepto.text, txtMonto.value)\" [disabled]=\"false\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-danger\" (click)=\"conceptoDialog.hide()\">Cancelar</button>\n                  </div> <!--Modal Footer-->\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            presupuestos_service_1.PresupuestosService])
    ], PresupuestosCambioEditor);
    return PresupuestosCambioEditor;
}(editors_1.BasicEditor));
exports.PresupuestosCambioEditor = PresupuestosCambioEditor;
