import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import '../../../css/styles.css';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { AzTextboxComponent } from 'framework3/controls';
import { DocumentEditor, EditorEventArgs, WorkflowEventArgs, TrackableCollection } from 'framework3/editors';
import { PresupuestosInfo } from '../models/presupuestos';
import { PresupuestosDetail, CategoriaDetail } from '../models/presupuestos-detail';
import { PresupuestosService } from '../services/presupuestos.service';
import { PresupuestosDetailEditor } from './parts/presupuestos-detail.editor';
import { PeriodoInfo } from '../../accounting/models/periodo';
import { CategoriasPresupuestalesService } from '../services/categorias-presupuestales.service';
import { ModalDirective } from 'ngx-bootstrap';
import { DepartamentoService } from '../services/departamento.service';
import { CategoriaPresupuestalArticulosListComponent } from '../dialogs/categorias-presupuestal-articulos-list.component';
import { CategoriaPresupuestalServiciosListComponent } from '../dialogs/categorias-presupuestal-servicios-list.component';
import { ArticuloItem } from '../models/articulo';
import { ServicioItem } from '../models/servicio';
import { FlexGrid } from 'wijmo/wijmo.grid';
import { SecurityContext } from '../models/security-context';
import { DepartamentoItem } from '../models/departamento';
import { CentralService } from '../services/central.service';
import { EmpresaService } from '../services/empresa.service';
export declare class PresupuestosEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private presupuestosService;
    protected categoriaPresupuestalsvc: CategoriasPresupuestalesService;
    private departamentoService;
    private centralService;
    private empresaService;
    presupuestos: PresupuestosInfo;
    detailCurrent: PresupuestosDetail;
    collectionView: TrackableCollection;
    conceptoEdit: string;
    montoEdit: number;
    articulos: any[];
    pageSizeArticulo: number;
    totalRowsArticulo: number;
    pageIndexArticulo: number;
    private IdCategoriaSelected;
    disabled: boolean;
    private idEjercicioTipo;
    securityContext: SecurityContext[];
    departamentos: DepartamentoItem[];
    detailMode: string;
    detailModeMulti: string;
    detailsList: FlexGrid;
    detailsEditor: PresupuestosDetailEditor;
    dialogArticulos: CategoriaPresupuestalArticulosListComponent;
    dialogServicios: CategoriaPresupuestalServiciosListComponent;
    dialogConceptos: ModalDirective;
    txtConcepto: AzTextboxComponent;
    conceptosList: FlexGrid;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, presupuestosService: PresupuestosService, categoriaPresupuestalsvc: CategoriasPresupuestalesService, departamentoService: DepartamentoService, centralService: CentralService, empresaService: EmpresaService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onPeriodoChanged(periodo: PeriodoInfo): void;
    onDepartamentoItemChanged(idDepto: number): void;
    agregarConcepto(detail: PresupuestosDetail): void;
    agregarArticulos(detail: PresupuestosDetail): void;
    agregarServicios(detail: PresupuestosDetail): void;
    onArticulosSelected(items: ArticuloItem[]): void;
    onConceptoSelected(concepto: string, monto: number): void;
    conceptosLoaded(a: any, b: any, c: any): void;
    onServiciosSelected(items: ServicioItem[]): void;
    readonly montoPresupuesto: string;
    readonly montoApartado: string;
    readonly montoUtilizado: string;
    readonly montoDisponible: string;
    loadDepartamentos(): void;
    loadCategoriasPresupuestales(): void;
    initialized(sender: FlexGrid, args: any): void;
    onCellEditEnded(flex: any, e: any, cell: any): void;
    recalcularDetalle(): void;
    recalcularImportes(): void;
    getConceptoCollection(item: PresupuestosDetail): CategoriaDetail[];
}
