"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
var wjcGridDetail = require("wijmo/wijmo.grid.detail");
require("../../../css/styles.css");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Locales
var presupuestos_1 = require("../models/presupuestos");
var presupuestos_detail_1 = require("../models/presupuestos-detail");
var presupuestos_service_1 = require("../services/presupuestos.service");
var presupuestos_detail_editor_1 = require("./parts/presupuestos-detail.editor");
var categorias_presupuestales_service_1 = require("../services/categorias-presupuestales.service");
var ngx_bootstrap_1 = require("ngx-bootstrap");
var wijmo_2 = require("wijmo/wijmo");
//import { detachEmbeddedView } from '@angular/core/src/view';
//import { now } from 'moment';
//import { getDate } from 'ngx-bootstrap/chronos/utils/date-getters';
var departamento_service_1 = require("../services/departamento.service");
var categorias_presupuestal_articulos_list_component_1 = require("../dialogs/categorias-presupuestal-articulos-list.component");
var categorias_presupuestal_servicios_list_component_1 = require("../dialogs/categorias-presupuestal-servicios-list.component");
var wijmo_grid_1 = require("wijmo/wijmo.grid");
var central_service_1 = require("../services/central.service");
var empresa_service_1 = require("../services/empresa.service");
var PresupuestosEditor = /** @class */ (function (_super) {
    __extends(PresupuestosEditor, _super);
    function PresupuestosEditor(context, router, route, location, formBuilder, documentTypeService, presupuestosService, categoriaPresupuestalsvc, departamentoService, centralService, empresaService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.presupuestosService = presupuestosService;
        _this.categoriaPresupuestalsvc = categoriaPresupuestalsvc;
        _this.departamentoService = departamentoService;
        _this.centralService = centralService;
        _this.empresaService = empresaService;
        _this.presupuestos = new presupuestos_1.PresupuestosInfo();
        _this.collectionView = new editors_1.TrackableCollection();
        _this.conceptoEdit = "";
        _this.montoEdit = 0;
        _this.articulos = [];
        _this.pageSizeArticulo = 20;
        _this.totalRowsArticulo = 0;
        _this.pageIndexArticulo = 0;
        _this.disabled = true;
        _this.idEjercicioTipo = 0;
        _this.securityContext = [];
        _this.departamentos = [];
        _this.detailMode = wjcGridDetail.DetailVisibilityMode[wjcGridDetail.DetailVisibilityMode.ExpandSingle];
        _this.detailModeMulti = wjcGridDetail.DetailVisibilityMode[wjcGridDetail.DetailVisibilityMode.ExpandMulti];
        _this.documentForm = formBuilder.group({
            'periodo': ['', forms_1.Validators.required],
            'departamento': ['', forms_1.Validators.required],
            'presupuesto': [''],
            'apartado': [''],
            'utilizado': [''],
            'disponible': [''],
            'montoPresupuesto': [0]
        });
        _this.documentForm.controls['montoPresupuesto'].valueChanges.subscribe(function (value) {
            _this.documentForm.controls['montoPresupuesto'].setValidators(null);
            if (_this.presupuestos.departamento && _this.presupuestos.departamento.tipoPresupuesto == "D") {
                _this.documentForm.controls['montoPresupuesto'].setValidators(forms_1.Validators.required);
            }
            _this.documentForm.controls['montoPresupuesto'].updateValueAndValidity();
        });
        return _this;
    }
    PresupuestosEditor_1 = PresupuestosEditor;
    PresupuestosEditor.prototype.onConfigureDocument = function (docType) {
        var _this = this;
        this.applyPolicies();
        this.loadDepartamentos();
        this.empresaService.getDetailFromCache(this.context.app.defaultCompany.identity)
            .then(function (info) {
            _this.idEjercicioTipo = info.idEjercicioTipo;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PresupuestosEditor.prototype.onCreatingDocument = function () {
    };
    PresupuestosEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.presupuestosService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.presupuestos = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PresupuestosEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.presupuestosService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.presupuestos = doc;
            //this.detailsEditor.clientIndexStart = this.presupuestos.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PresupuestosEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.presupuestosService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.presupuestos = doc;
            _this.collectionView.sourceCollection = _this.presupuestos.details;
            _this.recalcularImportes();
            //this.detailsEditor.clientIndexStart = this.presupuestos.details.length;
            if (_this.presupuestos.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PresupuestosEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        //this.loadDetails();
        this.context.app.showSpinner();
        this.presupuestosService.update(this.presupuestos)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.presupuestos.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.presupuestos = updatedDoc;
            _this.collectionView.sourceCollection = _this.presupuestos.details;
            //Si se dio guardar hay q actualizar el document detail ya actualizado con el id
            if (!args.closeEditor && _this.detailCurrent != undefined) {
                var detail = _this.presupuestos.details.find(function (detail) { return detail.idCategoriaPresupuestal == _this.detailCurrent.idCategoriaPresupuestal; });
                _this.detailCurrent = detail;
                _this.detailCurrent.state = "MODIFIED";
                _this.getConceptoCollection(_this.detailCurrent);
                if (_this.detailsList)
                    _this.detailsList.refresh();
                if (_this.conceptosList)
                    _this.conceptosList.refresh();
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PresupuestosEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.presupuestosService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PresupuestosEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.presupuestosService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    //onAddingDetail() {
    //    this.detailsEditor.detail = new PresupuestosDetail();
    //    this.detailsEditor.show();
    //}
    //onEditingDetail(detail: PresupuestosDetail) {
    //    this.detailsEditor.detail = detail;
    //    this.detailsEditor.show();
    //}
    //onDeletingDetail(detail: PresupuestosDetail) {
    //    this.detailsList.deleteItem(detail);
    //}
    //onListItemsUpdated(updatedDetails: PresupuestosDetail[]) {
    //    this.presupuestos.details = updatedDetails;
    //}
    //onSavingDetail(detail: PresupuestosDetail) {
    //    this.detailsList.updateItem(detail);
    //}
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    PresupuestosEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.presupuestos.identity);
            }
            else if (args.heading == 'Detalle') {
                //this.loadCategoriasPresupuestales();
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    //metodos y eventos del componente
    PresupuestosEditor.prototype.onPeriodoChanged = function (periodo) {
        this.presupuestos.idPeriodo = periodo.identity;
        this.presupuestos.fechaPeriodo = periodo.fechaSys;
    };
    PresupuestosEditor.prototype.onDepartamentoItemChanged = function (idDepto) {
        var _this = this;
        this.departamentoService.getDetailFromCache(idDepto)
            .then(function (info) {
            _this.presupuestos.departamento = info; //
            if (info.tipoPresupuesto == 'N') {
                _this.documentForm.reset();
                _this.showAlert('Este departamento no controla presupuesto', 'success');
            }
            else {
                if (_this.presupuestos.identity == "") {
                    _this.presupuestos.details = [];
                    _this.loadCategoriasPresupuestales();
                }
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PresupuestosEditor.prototype.agregarConcepto = function (detail) {
        this.IdCategoriaSelected = detail.categoriaPresupuestal.identity;
        this.detailCurrent = detail;
        //this.dialogArticulos.idCategoriaPresupuestal = detail.categoriaPresupuestal.identity;
        this.dialogConceptos.config.backdrop = false;
        this.dialogConceptos.show();
        wijmo_1.Control.invalidateAll();
    };
    PresupuestosEditor.prototype.agregarArticulos = function (detail) {
        this.IdCategoriaSelected = detail.categoriaPresupuestal.identity;
        this.detailCurrent = detail;
        this.dialogArticulos.idCategoriaPresupuestal = detail.categoriaPresupuestal.identity;
        this.dialogArticulos.show();
        wijmo_1.Control.invalidateAll();
    };
    PresupuestosEditor.prototype.agregarServicios = function (detail) {
        this.IdCategoriaSelected = detail.categoriaPresupuestal.identity;
        this.detailCurrent = detail;
        this.dialogServicios.idCategoriaPresupuestal = detail.categoriaPresupuestal.identity;
        this.dialogServicios.show();
        wijmo_1.Control.invalidateAll();
    };
    PresupuestosEditor.prototype.onArticulosSelected = function (items) {
        var _this = this;
        var bakItems = this.detailCurrent.articulos.slice();
        items.forEach(function (articulo) {
            var searchArt = _this.detailCurrent.articulos.find(function (art) { return art.idArticulo == articulo.id; });
            if (searchArt == undefined) {
                var newCatDetail = new presupuestos_detail_1.CategoriaDetail();
                newCatDetail._clientID = bakItems.length + 1;
                newCatDetail.idArticulo = articulo.id;
                newCatDetail.descripcion = articulo.nombre;
                newCatDetail.idServicio = 0;
                //newCatDetail.idPresupuestoDet = 0;
                bakItems.push(newCatDetail);
            }
        });
        this.detailCurrent.articulos = bakItems;
        this.detailCurrent.state = "MODIFIED";
    };
    PresupuestosEditor.prototype.onConceptoSelected = function (concepto, monto) {
        var bakItems = this.detailCurrent.conceptos.slice();
        //items.forEach(articulo => {
        var searchItem = this.detailCurrent.conceptos.find(function (concep) { return concep.descripcion == concepto; });
        if (searchItem == undefined) {
            var newCatDetail = new presupuestos_detail_1.CategoriaDetail();
            newCatDetail._clientID = bakItems.length + 1;
            newCatDetail.idArticulo = 0;
            newCatDetail.descripcion = concepto;
            newCatDetail.montoPresupuesto = monto;
            newCatDetail.idServicio = 0;
            //newCatDetail.idPresupuestoDet = 0;
            bakItems.push(newCatDetail);
        }
        //});
        this.detailCurrent.conceptos = bakItems;
        this.detailCurrent.state = "MODIFIED";
        this.conceptoEdit = "";
        this.montoEdit = 0;
        this.conceptosList.focus();
        this.detailsList.collapseGroupsToLevel(0);
        //if (this.detailsList.selectedRows.length > 0) {
        //    this.detailsList.autoSizeRow(this.detailsList.selectedRows[0].index, true);
        //    this.conceptosList.refresh();
        //    this.conceptosList.scrollIntoView(this.detailCurrent.conceptos.length - 1, 0); //this.conceptosList.scrollIntoView(this.conceptosList.rows.length - 1, 0);
        //    this.conceptosList.select(this.detailCurrent.conceptos.length - 1, 0);
        //}
        //if (this.conceptosList.rows.length > 0) {
        //    this.conceptosList.scrollIntoView(this.conceptosList.rows.length - 1, -1)
        //    let rc = this.conceptosList.cells.getCellBoundingRect(this.conceptosList.rows.length - 1, 0, true);
        //    this.conceptosList.scrollPosition = new wjcCore.Point(this.conceptosList.scrollPosition.x, rc.bottom);
        //}        
        this.detailsList.refresh();
        this.recalcularDetalle();
        this.txtConcepto.textbox.nativeElement.focus();
    };
    PresupuestosEditor.prototype.conceptosLoaded = function (a, b, c) {
        if (this.detailsList.selectedRows.length > 0) {
            this.detailsList.autoSizeRow(this.detailsList.selectedRows[0].index, true);
        }
        if (this.detailCurrent.conceptos.length > 0) {
            if (this.conceptosList != undefined) {
                this.conceptosList.refresh();
                this.conceptosList.scrollIntoView(this.conceptosList.rows.length - 1, 0); //this.conceptosList.scrollIntoView(this.detailCurrent.conceptos.length - 1, 0);
                this.conceptosList.select(this.conceptosList.rows.length - 1, 0);
            }
        }
    };
    PresupuestosEditor.prototype.onServiciosSelected = function (items) {
        var _this = this;
        var bakItems = this.detailCurrent.servicios.slice();
        items.forEach(function (servicio) {
            var searchArt = _this.detailCurrent.servicios.find(function (serv) { return serv.idArticulo == servicio.id; });
            if (searchArt == undefined) {
                var newCatDetail = new presupuestos_detail_1.CategoriaDetail();
                newCatDetail._clientID = bakItems.length + 1;
                newCatDetail.idServicio = servicio.id;
                newCatDetail.descripcion = servicio.nombre;
                newCatDetail.idArticulo = 0;
                //newCatDetail.idPresupuestoDet = 0;
                bakItems.push(newCatDetail);
            }
        });
        this.detailCurrent.servicios = bakItems;
        this.detailCurrent.state = "MODIFIED";
    };
    Object.defineProperty(PresupuestosEditor.prototype, "montoPresupuesto", {
        //////////////////////////// Atributos de lectura ////////////////////////////////
        get: function () {
            if (this.presupuestos.montoPresupuesto == undefined)
                this.presupuestos.montoPresupuesto = 0;
            return wijmo_2.Globalize.formatNumber(this.presupuestos.montoPresupuesto, 'c');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PresupuestosEditor.prototype, "montoApartado", {
        get: function () {
            if (this.presupuestos.montoApartado == undefined)
                this.presupuestos.montoApartado = 0;
            return wijmo_2.Globalize.formatNumber(this.presupuestos.montoApartado, 'c');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PresupuestosEditor.prototype, "montoUtilizado", {
        get: function () {
            if (this.presupuestos.montoUtilizado == undefined)
                this.presupuestos.montoUtilizado = 0;
            return wijmo_2.Globalize.formatNumber(this.presupuestos.montoUtilizado, 'c');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PresupuestosEditor.prototype, "montoDisponible", {
        get: function () {
            if (this.presupuestos.montoDisponible == undefined)
                this.presupuestos.montoDisponible = 0;
            return wijmo_2.Globalize.formatNumber(this.presupuestos.montoDisponible, 'c');
        },
        enumerable: true,
        configurable: true
    });
    /////////////////////////////////////////////////////////////////////////////////////
    PresupuestosEditor.prototype.loadDepartamentos = function () {
        var _this = this;
        this.departamentoService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (result) {
            //Muestra a los que el usuario tiene permisos y que son presupuestables
            _this.departamentos = result.filter(function (presupuestables) { return presupuestables.tipoPresupuesto != 'N'; }); //
        })
            .catch(function (error) { return _this.handleError(error); });
        //this.centralService.loadSecurityContext(this.context.app.defaultCompany.identity)
        //    .then(items => {
        //        this.securityContext = items;
        //        var result = _(this.securityContext).groupBy('idDepartamento').transform(function (result, current) {
        //            result.push({
        //                id: current[0].idDepartamento,
        //                nombre: current[0].departamento,
        //            });
        //        }, []).value();
        //        this.departamentos = result;//
        //    })
        //    .catch(error => this.handleError(error));  
        //this.departamentos = result;
        if (this.departamentos.length > 0 && this.presupuestos.identity == '')
            this.presupuestos.idDepartamento = this.departamentos[0].id;
    };
    PresupuestosEditor.prototype.loadCategoriasPresupuestales = function () {
        var _this = this;
        //if (this.presupuestos.idDepartamento > 0 && this.categoriasPresupuestales.length==0) {
        //this.presupuestosService.getCategoriasPresupuestales(this.presupuestos.idDepartamento, this.presupuestos.identity)
        this.departamentoService.getCategoriasPresupuestales(this.presupuestos.idDepartamento)
            .then(function (info) {
            var details = [];
            info.forEach(function (categoriaDepto) {
                var detail = new presupuestos_detail_1.PresupuestosDetail();
                detail.idCategoriaPresupuestal = categoriaDepto.id;
                detail.categoriaPresupuestal.identity = categoriaDepto.id;
                detail.categoriaPresupuestal.nombre = categoriaDepto.nombre;
                detail.montoPresupuesto = 0;
                detail.montoUtilizado = 0;
                detail.montoApartado = 0;
                detail.montoDisponible = 0;
                details.push(detail);
            });
            _this.presupuestos.details = details;
            _this.collectionView.sourceCollection = _this.presupuestos.details;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PresupuestosEditor.prototype.initialized = function (sender, args) {
        var _this = this;
        var self = this;
        this.collectionView.currentChanged.addHandler(function (args) {
            _this.detailsList.refresh();
            _this.detailsList.collapseGroupsToLevel(0);
            if (self.collectionView.currentItem != null) {
                _this.detailCurrent = self.collectionView.currentItem;
            }
        }, self);
    };
    PresupuestosEditor.prototype.onCellEditEnded = function (flex, e, cell) {
        this.recalcularDetalle();
    };
    PresupuestosEditor.prototype.recalcularDetalle = function () {
        var monto = 0;
        if (this.detailCurrent) {
            if (this.detailCurrent.conceptos.filter(function (search) { return search.state != 'DELETED'; }).length > 0)
                monto += this.detailCurrent.conceptos.filter(function (search) { return search.state != 'DELETED'; }).map(function (c) { return c.montoPresupuesto; }).reduce(function (sum, current) { return sum + current; });
            if (this.detailCurrent.articulos.filter(function (search) { return search.state != 'DELETED'; }).length > 0)
                monto += this.detailCurrent.articulos.filter(function (search) { return search.state != 'DELETED'; }).map(function (c) { return c.montoPresupuesto; }).reduce(function (sum, current) { return sum + current; });
            if (this.detailCurrent.servicios.filter(function (search) { return search.state != 'DELETED'; }).length > 0)
                monto += this.detailCurrent.servicios.filter(function (search) { return search.state != 'DELETED'; }).map(function (c) { return c.montoPresupuesto; }).reduce(function (sum, current) { return sum + current; });
            this.detailCurrent.montoPresupuesto = monto;
            this.recalcularImportes();
            this.detailCurrent.state = "MODIFIED";
            this.detailsList.refreshCells(true);
            wijmo_1.Control.invalidateAll();
        }
    };
    PresupuestosEditor.prototype.recalcularImportes = function () {
        this.presupuestos.montoPresupuesto = this.presupuestos.details.map(function (c) { return c.montoPresupuesto; }).reduce(function (sum, current) { return sum + current; }); //this.categoriasPresupuestales.map(c => c.montoPresupuesto).reduce((sum, current) => sum + current);
        this.presupuestos.montoUtilizado = this.presupuestos.details.map(function (c) { return c.montoUtilizado; }).reduce(function (sum, current) { return sum + current; });
        this.presupuestos.montoDisponible = this.presupuestos.details.map(function (c) { return c.montoDisponible; }).reduce(function (sum, current) { return sum + current; });
        this.presupuestos.montoApartado = this.presupuestos.details.map(function (c) { return c.montoApartado; }).reduce(function (sum, current) { return sum + current; });
    };
    PresupuestosEditor.prototype.getConceptoCollection = function (item) {
        return item.conceptos;
    };
    var PresupuestosEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", wijmo_grid_1.FlexGrid)
    ], PresupuestosEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", presupuestos_detail_editor_1.PresupuestosDetailEditor)
    ], PresupuestosEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild('dialogArticulos'),
        __metadata("design:type", categorias_presupuestal_articulos_list_component_1.CategoriaPresupuestalArticulosListComponent)
    ], PresupuestosEditor.prototype, "dialogArticulos", void 0);
    __decorate([
        core_1.ViewChild('dialogServicios'),
        __metadata("design:type", categorias_presupuestal_servicios_list_component_1.CategoriaPresupuestalServiciosListComponent)
    ], PresupuestosEditor.prototype, "dialogServicios", void 0);
    __decorate([
        core_1.ViewChild('conceptoDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], PresupuestosEditor.prototype, "dialogConceptos", void 0);
    __decorate([
        core_1.ViewChild('txtConcepto'),
        __metadata("design:type", controls_1.AzTextboxComponent)
    ], PresupuestosEditor.prototype, "txtConcepto", void 0);
    __decorate([
        core_1.ViewChild('conceptosList'),
        __metadata("design:type", wijmo_grid_1.FlexGrid)
    ], PresupuestosEditor.prototype, "conceptosList", void 0);
    PresupuestosEditor = PresupuestosEditor_1 = __decorate([
        core_1.Component({
            selector: 'azteca.compras-presupuestos-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                  [title]=\"'Presupuestos'\"\n                                  [document]=\"presupuestos\"\n                                  [valid]=\"valid\"\n                                  (configureDocument)=\"onConfigureDocument($event)\"\n                                  (creatingDocument)=\"onCreatingDocument()\"\n                                  (viewingDocument)=\"onViewingDocument($event)\"\n                                  (cloningDocument)=\"onCloningDocument($event)\"\n                                  (savingDocument)=\"onSavingDocument($event)\"\n                                  (loadingDocument)=\"onLoadingDocument($event)\"\n                                  (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                  (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col col-md-4\">\n                      <azteca-form-field [label]=\"'Periodo:'\">\n                          <accounting-periodos-selector formControlName=\"periodo\"\n                                                        (selectedItemChanged)=\"onPeriodoChanged($event)\"\n                                                        [(ngModel)]=\"presupuestos.idPeriodo\"\n                                                        [idEjercicioTipo]=\"idEjercicioTipo\"\n                                                        #selectorPeriodos></accounting-periodos-selector>\n                      </azteca-form-field>\n                  </div>\n\n\n                  <div class=\"col-12 col-md-4\">\n                      <azteca-form-field [label]=\"'Departamento:'\">\n                          <az-combobox #selectorDepartamento\n                                       formControlName=\"departamento\"\n                                       [(ngModel)]=\"presupuestos.idDepartamento\"\n                                       [items]=\"departamentos\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\"\n                                       (selectedItemChanged)=\"onDepartamentoItemChanged($event)\">\n                          </az-combobox>\n                      </azteca-form-field>\n                  </div>\n\n\n                  <div col-12 col-md-4 *ngIf=\"presupuestos.departamento && presupuestos.departamento.tipoPresupuesto== 'C' \">\n\n                      <div class=\"row\">\n                          <label class=\"control-label\">Total:</label>\n                      </div>\n                      <div class=\"row\">\n                          <div class=\"input-group input-group-sm mb-0\">\n                              <div class=\"input-group-prepend\">\n                                  <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 130px\">Presupuesto</span>\n                              </div>\n                              <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 200px\" *ngIf=\"presupuestos.departamento && presupuestos.departamento.tipoPresupuesto== 'C' \">{{montoPresupuesto}}</span>\n                          </div>\n\n                      </div>\n                  </div>\n\n\n                  <!--(valueChange)=\"cantidadChanged($event)\"-->\n                  <div class=\"col-12 col-md-4\" *ngIf=\"presupuestos.departamento && presupuestos.departamento.tipoPresupuesto== 'D' \">\n                      <azteca-form-field [label]=\"'Total'\">\n                          <az-input-number formControlName=\"montoPresupuesto\"\n                                           [(ngModel)]=\"presupuestos.montoPresupuesto\">\n                          </az-input-number>\n                      </azteca-form-field>\n                  </div>\n\n              </div>\n\n              <!--<div class=\"row\">\n                  <div col-6 col-md-2>\n                      <div class=\"input-group input-group-sm mb-0\">\n                          <div class=\"input-group-prepend\">\n                              <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 130px\">Presupuesto</span>\n                          </div>\n                          <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 200px\">{{montoPresupuesto}}</span>\n                      </div>\n                  </div>\n                  <div col-6 col-md-2>\n                      <div class=\"input-group input-group-sm mb-0\">\n                          <div class=\"input-group-prepend\">\n                              <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 130px\">Utilizado</span>\n                          </div>\n                          <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 200px\">{{montoUtilizado}}</span>\n                      </div>\n                  </div>\n                  <div col-6 col-md-2>\n                      <div class=\"input-group input-group-sm mb-0\">\n                          <div class=\"input-group-prepend\">\n                              <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 130px\">Apartado</span>\n                          </div>\n                          <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 200px\">{{montoApartado}}</span>\n                      </div>\n                  </div>\n\n                  <div col-6 col-md-2>\n                      <div class=\"input-group input-group-sm mb-0\">\n                          <div class=\"input-group-prepend\">\n                              <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 130px\">Disponible</span>\n                          </div>\n                          <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 200px\">{{montoDisponible}}</span>\n                      </div>\n                  </div>\n              </div>-->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <!--<tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n                          </tab>-->\n\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <!--(selectionChanged)=\"selectionChanged(detailsList, $event)\"-->\n                                      <!--(cellEditEnding)=\"cellEditEndingHandler(detailsList, $event)\"\n                                      (cellEditEnded)=\"onCellEditEndedCategoria(detailsList, $event, cell)\"-->\n\n                                      <!--[autoRowHeights]=\"true\"-->\n                                      <wj-flex-grid #detailsList\n                                                    (initialized)=\"initialized(grid, $event)\"\n                                                    [itemsSource]=\"collectionView\"\n                                                    [isReadOnly]=\"true\">\n\n                                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                                          <wj-flex-grid-column [header]=\"'Categoria Presupuestal'\" [binding]=\"'categoriaPresupuestal.nombre'\" [width]=\"'60*'\" [isReadOnly]=\"true\"></wj-flex-grid-column> <!-- Agrupar porseries-->\n                                          <wj-flex-grid-column [header]=\"'Monto Presupuesto'\" [binding]=\"'montoPresupuesto'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"n2\" (change)=\"onCellEditEnded()\"></wj-flex-grid-column>\n                                    \n\n                                          <!--detailMode-->\n                                          <ng-template wjFlexGridDetail  let-item=\"item\">\n                                        \n                                                  <div class=\"row\">\n                                                      <div class=\"col-1\">\n                                                          <button type=\"button\" class=\"btn btn-primary btn-sm fa fa-plus\" (click)=\"agregarConcepto(item)\" [disabled]=\"false\" title=\"Conceptos\"></button>\n                                                      </div>\n                                                      <p>Conceptos</p>\n                                                  </div>\n\n                                                  <div class=\"row\">\n                                                      <div class=\"col-10\" >\n                                                          <div>  <!--style=\"overflow-y:scroll\">-->\n                                                              <wj-flex-grid #conceptosList     \n                                                                            style=\"height:400px\"\n                                                                            [itemsSource]=\"getConceptoCollection(item)\"                                                                      \n                                                                            [headersVisibility]=\"'Column'\"\n                                                                            (cellEditEnded)=\"onCellEditEnded(detailsList, $event, cell)\"\n                                                                            (loadedRows)=\"conceptosLoaded($event,$a,$b)\">\n                                                                  <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                                                  <wj-flex-grid-column [header]=\"'Concepto'\" [binding]=\"'descripcion'\" [width]=\"'60*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                                                                  <wj-flex-grid-column [header]=\"'Monto'\" [binding]=\"'montoPresupuesto'\" [width]=\"'20*'\" [isReadOnly]=\"presupuestos.status>1\" format=\"n2\"></wj-flex-grid-column>\n                                                              </wj-flex-grid>\n                                                          </div>\n\n                                                          <!--<div class=\"row\">\n                                                              <div class=\"col-1\">\n                                                                  <button type=\"button\" class=\"btn btn-primary btn-sm fa fa-plus\" (click)=\"agregarArticulos(item)\" [disabled]=\"false\" title=\"Articulo\"></button>\n                                                              </div>\n                                                              <p>Articulos</p>\n                                                          </div>\n\n                                                          <wj-flex-grid [itemsSource]=\"item.articulos\"\n                                                                        (cellEditEnded)=\"onCellEditEnded(detailsList, $event, cell)\">\n                                                              <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                                              <wj-flex-grid-column [header]=\"'Articulo'\" [binding]=\"'descripcion'\" [width]=\"'60*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                                              <wj-flex-grid-column [header]=\"'Presupuesto'\" [binding]=\"'montoPresupuesto'\" [width]=\"'20*'\" [isReadOnly]=\"false\" format=\"n2\"></wj-flex-grid-column>\n                                                              <wj-flex-grid-column [header]=\"'Utilizado'\" [binding]=\"'montoUtilizado'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                                              <wj-flex-grid-column [header]=\"'Apartado'\" [binding]=\"'montoApartado'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                                              <wj-flex-grid-column [header]=\"'Disponible'\" [binding]=\"'montoDisponible'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                                          </wj-flex-grid>\n                                                      </div>\n\n                                                      <div class=\"col-6\">\n                                                          <div class=\"row\">\n                                                              <div class=\"col-1\">\n                                                                  <button type=\"button\" class=\"btn btn-primary btn-sm fa fa-plus\" (click)=\"agregarServicios(item)\" [disabled]=\"false\" title=\"Articulo\"></button>\n                                                              </div>\n                                                              <p>Servicio</p>\n                                                          </div>\n\n                                                          <wj-flex-grid [itemsSource]=\"item.servicios\"\n                                                                        style=\"height:100%\"\n                                                                        (cellEditEnded)=\"onCellEditEnded(detailsList, $event, cell)\">\n                                                              <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                                              <wj-flex-grid-column [header]=\"'Servicio'\" [binding]=\"'descripcion'\" [width]=\"'60*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                                              <wj-flex-grid-column [header]=\"'Presupuesto'\" [binding]=\"'montoPresupuesto'\" [width]=\"'20*'\" [isReadOnly]=\"false\" format=\"n2\"></wj-flex-grid-column>\n                                                              <wj-flex-grid-column [header]=\"'Utilizado'\" [binding]=\"'montoUtilizado'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                                              <wj-flex-grid-column [header]=\"'Apartado'\" [binding]=\"'montoApartado'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                                              <wj-flex-grid-column [header]=\"'Disponible'\" [binding]=\"'montoDisponible'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                                           </wj-flex-grid>-->\n\n                                                      </div>\n                                                \n                                                  </div>\n\n\n                                                  <div class=\"row\">\n                                                      <div class=\"col-1\">\n                                                          ...\n                                                      </div>\n                                                  </div>                                                                                  \n\n\n                                          </ng-template>\n                                      </wj-flex-grid>\n                                  </div>\n                              </div>\n\n                          </tab>\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"presupuestos.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n\n\n\n\n      </form>\n\n\n      <div bsModal #conceptoDialog =\"bs-modal\" class=\"modal fade\"  tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"mySmallModalLabel\" aria-hidden=\"true\" >\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\">Agregar conceptos</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">\n                          <span aria-hidden=\"true\" (click)=\"conceptoDialog.hide()\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <div class=\"row\">\n                          <div class=\"col-10\">\n                              <label class=\"control-label\">Concepto:</label>\n                              <az-textbox #txtConcepto [(ngModel)]=\"conceptoEdit\"></az-textbox>\n                          </div>\n                      </div>\n                      <div class=\"row\">\n                          <div class=\"col-10\">\n                              <label class=\"control-label\">Monto:</label>\n                              <az-input-number #txtMonto [format]=\"n2\"[(ngModel)]=\"montoEdit\"></az-input-number>\n                          </div>\n                      </div>\n                  </div> <!--Modal Body-->\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onConceptoSelected(txtConcepto.text, txtMonto.value)\" [disabled]=\"false\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-danger\" (click)=\"conceptoDialog.hide()\">Cancelar</button>\n                  </div> <!--Modal Footer-->\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n\n      <purchasing-categoria-presupuestal-articulos-list #dialogArticulos\n                                                        [multiSelect]=\"true\"\n                                                        (selectedItemsChanged)=\"onArticulosSelected($event)\">\n          <!--[excludedItems]=\"detailCurrent.categoriasDetail\"-->\n\n      </purchasing-categoria-presupuestal-articulos-list>\n\n\n      <purchasing-categoria-presupuestal-servicios-list #dialogServicios\n                                                        [multiSelect]=\"true\"\n                                                        (selectedItemsChanged)=\"onServiciosSelected($event)\">\n      </purchasing-categoria-presupuestal-servicios-list>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return PresupuestosEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: presupuestos_service_1.PresupuestosService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            presupuestos_service_1.PresupuestosService,
            categorias_presupuestales_service_1.CategoriasPresupuestalesService,
            departamento_service_1.DepartamentoService,
            central_service_1.CentralService,
            empresa_service_1.EmpresaService])
    ], PresupuestosEditor);
    return PresupuestosEditor;
}(editors_1.DocumentEditor));
exports.PresupuestosEditor = PresupuestosEditor;
