import { Router, ActivatedRoute } from '@angular/router';
import { Context, DocumentItem, PolicyInfo } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { MenuItem } from 'framework3/controls';
import { PresupuestosItem } from '../models/presupuestos';
import { PresupuestosService } from '../services/presupuestos.service';
export declare class PresupuestosManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private presupuestosService;
    presupuestos: PresupuestosItem[];
    constructor(context: Context, router: Router, route: ActivatedRoute, presupuestosService: PresupuestosService);
    onConfigureDocument(): void;
    applyPolicy(policy: PolicyInfo): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onMenuItemClick(option: MenuItem): void;
}
