"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var presupuestos_service_1 = require("../services/presupuestos.service");
var PresupuestosManager = /** @class */ (function (_super) {
    __extends(PresupuestosManager, _super);
    function PresupuestosManager(context, router, route, presupuestosService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.presupuestosService = presupuestosService;
        return _this;
    }
    PresupuestosManager_1 = PresupuestosManager;
    PresupuestosManager.prototype.onConfigureDocument = function () {
        this.refreshList();
        this.applyPolicies();
    };
    PresupuestosManager.prototype.applyPolicy = function (policy) {
        if (policy.valor == 'BUDGET_CHANGE') {
            var mnuChange = { icon: "glyphicon glyphicon-random", text: "Cambiar presupuesto", name: "BUDGET_CHANGE", smallText: "Cambiar los montos del presupuesto", enabled: true };
            this.manager.menuItems.push(mnuChange);
        }
    };
    PresupuestosManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.presupuestosService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.presupuestos = response.rows;
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PresupuestosManager.prototype.onAddingItem = function () {
        this.router.navigate(['0'], { relativeTo: this.route });
    };
    PresupuestosManager.prototype.onViewingItem = function (document) {
        this.router.navigate([document.id, { readonly: true }], { relativeTo: this.route });
    };
    PresupuestosManager.prototype.onEditingItem = function (document) {
        this.router.navigate([document.id], { relativeTo: this.route });
    };
    PresupuestosManager.prototype.onDeletingItem = function (document) {
        var _this = this;
        this.presupuestosService.delete(document.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El documento ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PresupuestosManager.prototype.onCloningItem = function (document) {
        this.router.navigate([0, { cloneId: document.id }], { relativeTo: this.route });
    };
    PresupuestosManager.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.presupuestosService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PresupuestosManager.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.presupuestosService.previousStep(document.id, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ////////////////////////////////////        ////////////////////////////////////////
    PresupuestosManager.prototype.onMenuItemClick = function (option) {
        var _this = this;
        if (option.name == 'UNLOCK') { // abrir el presupuesto
            this.context.app.showSpinner();
            this.presupuestosService.unlock(this.manager.currentDocument.id)
                .then(function (_) {
                _this.context.app.hideSpinner();
                _this.refreshList();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        if (option.name == 'LOCK') { //cerrar presupuesto
            this.context.app.showSpinner();
            this.presupuestosService.lock(this.manager.currentDocument.id)
                .then(function (_) {
                _this.context.app.hideSpinner();
                _this.refreshList();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        if (option.name == 'BUDGET_CHANGE') { //Cambiar
            this.router.navigate([this.manager.currentDocument.id, 'change'], { relativeTo: this.route });
        }
        if (option.name == 'PDF') {
            this.context.app.showSpinner();
            this.presupuestosService.generarPdfImpresion(this.manager.currentDocument.id)
                .then(function (file) {
                _this.context.app.hideSpinner();
                window.open('/file-server/' + file.uri, '_blank');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    var PresupuestosManager_1;
    PresupuestosManager = PresupuestosManager_1 = __decorate([
        core_1.Component({
            selector: 'azteca.compras-presupuestos-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Presupuestos</div>\n          <div class=\"card-block\">\n              <azteca-document-manager (searchRequested)=\"onSearchRequested($event)\"\n                                       (addingItem)=\"onAddingItem()\"\n                                       (viewingItem)=\"onViewingItem($event)\"\n                                       (editingItem)=\"onEditingItem($event)\"\n                                       (deletingItem)=\"onDeletingItem($event)\"\n                                       (cloningItem)=\"onCloningItem($event)\"\n                                       (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                       (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                       (configureDocument)=\"onConfigureDocument($event)\"\n                                       (menuItemClick)=\"onMenuItemClick($event)\"\n                                       [enabled]=\"enabled\"\n                                       [allowNew]=\"allowNew\"\n                                       [allowView]=\"allowView\"\n                                       [allowEdit]=\"allowEdit\"\n                                       [allowDelete]=\"allowDelete\"\n                                       [allowClone]=\"allowClone\"\n                                       [allowNext]=\"allowNext\"\n                                       [allowPrevious]=\"allowPrevious\"\n                                       [allowAudit]=\"allowAudit\"\n                                       [filterGroups]=\"filterGroups\"\n                                       [documentList]=\"presupuestos\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'PDF'\" [icon]=\"'glyphicon glyphicon-print'\" [text]=\"'Imprimir'\" [smallText]=\"'generar impresi\u00F3n del presupuesto'\"></azteca-menu-item>\n\n                  <!--<azteca-menu-item [name]=\"'UNLOCK'\" [icon]=\"'glyphicon glyphicon-ok'\" [text]=\"'Abrir Presupuesto'\" [smallText]=\"'abrir el presupuesto'\"></azteca-menu-item>\n          <azteca-menu-item [name]=\"'LOCK'\" [icon]=\"'glyphicon glyphicon-remove'\" [text]=\"'Cerrar Presupuesto'\" [smallText]=\"'cerrar el presupuesto'\"></azteca-menu-item>-->\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"200\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"180\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Departamento'\" [binding]=\"'departamento'\" [width]=\"180\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Periodo'\" [binding]=\"'periodo'\" [width]=\"180\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Presupuestado'\" [binding]=\"'montoPresupuesto'\" [width]=\"140\" dataType=\"Number\" format=\"c\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Utilizado'\" [binding]=\"'montoUtilizado'\" [width]=\"140\" dataType=\"Number\" format=\"c\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Apartado'\" [binding]=\"'montoApartado'\" [width]=\"140\" dataType=\"Number\" format=\"c\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Disponible'\" [binding]=\"'montoDisponible'\" [width]=\"140\" dataType=\"Number\" format=\"c\"></azteca-grid-column>\n                  <!--<azteca-grid-column [header]=\"'Estado'\" [binding]=\"'estatus'\" [width]=\"180\"></azteca-grid-column>-->\n                  <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"140\"></azteca-grid-column>\n\n              </azteca-document-manager>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return PresupuestosManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: presupuestos_service_1.PresupuestosService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, presupuestos_service_1.PresupuestosService])
    ], PresupuestosManager);
    return PresupuestosManager;
}(editors_1.DocumentManager));
exports.PresupuestosManager = PresupuestosManager;
