import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { AlertsBarComponent } from 'framework3/controls';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { FileInfo } from 'framework3/general';
import { RecepcionSinOCInfo } from '../models/recepcion-sin-oc';
import { RecepcionSinOCDetail } from '../models/recepcion-sin-oc-detail';
import { RecepcionSinOCService } from '../services/recepcion-sin-oc.service';
import { OrdenDetail } from '../models/orden-detail';
import { OperacionTipoItem } from '../models/operacion-tipo';
import { OperacionTipoService } from '../services/operacion-tipo.service';
import { RecepcionSinOCDetailEditor } from './parts/recepciones-sin-oc-detail.editor';
import { CFDValiationResult } from '../models/cfd-validation-result';
import { CentralService } from '../services/central.service';
import { CentroRecepcionService } from '../services/centro-recepcion.service';
import { CentralItem } from '../models/central';
import { DepartamentoItem } from '../models/departamento';
import { SecurityContext } from '../models/security-context';
import { ProveedorInfo } from '../models/proveedor';
import { ImportesInfo } from '../../accounting/models/importes';
import { DivisaService } from '../../accounting/services/divisa.service';
import { BeneficiarioInfo } from '../../treasury/models/beneficiario';
import { ComprobanteFiscalService } from '../services/comprobante-fiscal.service';
import { ComprobanteFiscalInfo, ComprobanteFiscalItem } from '../models/comprobante-fiscal';
import { DivisaItem } from '../../accounting';
import { ProveedorSelectorComponent } from '../components/proveedor-selector.component';
import { ContribuyenteService } from '../../accounting/services/contribuyente.service';
export declare class RecepcionesSinOCEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private recepcionSinOCService;
    private centralService;
    private comprobanteFiscalService;
    private centroRecepcionService;
    private operacionTipoService;
    private divisaService;
    private contribuyenteService;
    recepcionSinOC: RecepcionSinOCInfo;
    securityContext: SecurityContext[];
    centrales: CentralItem[];
    departamentos: DepartamentoItem[];
    centrosRecepcion: CentralItem[];
    origenesCF: {
        id: string;
        nombre: string;
    }[];
    idProveedor: number;
    idAlmacen: number;
    selectedFile: FileInfo;
    operacionesTipo: OperacionTipoItem[];
    alertsBarComprobante: AlertsBarComponent;
    origenCFDialog: ModalDirective;
    comprobantesListDialog: ModalDirective;
    uploadDialog: ModalDirective;
    selProveedor: ProveedorSelectorComponent;
    detailsList: EditableListComponent;
    detailsEditor: RecepcionSinOCDetailEditor;
    origenCF: string;
    totalComprobantes: number;
    totalRecepciones: number;
    montoDiferencia: string;
    idDivisaDefault: number;
    tipoCambio: string;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, recepcionSinOCService: RecepcionSinOCService, centralService: CentralService, comprobanteFiscalService: ComprobanteFiscalService, centroRecepcionService: CentroRecepcionService, operacionTipoService: OperacionTipoService, divisaService: DivisaService, contribuyenteService: ContribuyenteService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: RecepcionSinOCDetail): void;
    onDeletingDetail(detail: RecepcionSinOCDetail): void;
    onListItemsUpdated(updatedDetails: RecepcionSinOCDetail[]): void;
    onSavingDetail(detail: RecepcionSinOCDetail): void;
    onFileChanged(file: FileInfo): void;
    onValidateFile(): void;
    onOrigenCFSelected(): void;
    onProveedorChanged(proveedor: ProveedorInfo): void;
    onBeneficiarioChanged(beneficiario: BeneficiarioInfo): void;
    onComprobanteSelected(comprobante: ComprobanteFiscalItem): void;
    onDivisaChanged(divisa: DivisaItem): void;
    loadCentrales(): void;
    loadCentrosRecepcion(idCentral: number): void;
    loadDepartamentos(idCentroRecepcion: number): void;
    loadOperacionesTipo(): void;
    validateFile(): void;
    cathComprobantes(ValidCFDcomprobantes: CFDValiationResult[]): void;
    parseComprobanteItem(info: ComprobanteFiscalInfo): ComprobanteFiscalItem;
    addDetail(comprobante: ComprobanteFiscalItem): void;
    readonly importesComprobantes: ImportesInfo;
    readonly importesRecepciones: ImportesInfo;
    validDiferencia(): string;
    calcularImportes(): ImportesInfo;
    combineDetail(): OrdenDetail[];
    getDivisaDefault(creating: boolean): void;
}
