"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//
var _ = require("lodash");
//
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Locales
var recepcion_sin_oc_1 = require("../models/recepcion-sin-oc");
var recepcion_sin_oc_detail_1 = require("../models/recepcion-sin-oc-detail");
var recepcion_sin_oc_service_1 = require("../services/recepcion-sin-oc.service");
var operacion_tipo_service_1 = require("../services/operacion-tipo.service");
var recepciones_sin_oc_detail_editor_1 = require("./parts/recepciones-sin-oc-detail.editor");
var central_service_1 = require("../services/central.service");
var centro_recepcion_service_1 = require("../services/centro-recepcion.service");
var importes_1 = require("../../accounting/models/importes");
var divisa_service_1 = require("../../accounting/services/divisa.service");
var comprobante_fiscal_service_1 = require("../services/comprobante-fiscal.service");
var comprobante_fiscal_1 = require("../models/comprobante-fiscal");
//import { ComprobanteInfo } from '../../accounting';
//import { SecureContext } from 'tls';
var proveedor_selector_component_1 = require("../components/proveedor-selector.component");
var contribuyente_service_1 = require("../../accounting/services/contribuyente.service");
var RecepcionesSinOCEditor = /** @class */ (function (_super) {
    __extends(RecepcionesSinOCEditor, _super);
    function RecepcionesSinOCEditor(context, router, route, location, formBuilder, documentTypeService, recepcionSinOCService, centralService, comprobanteFiscalService, centroRecepcionService, operacionTipoService, divisaService, contribuyenteService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.recepcionSinOCService = recepcionSinOCService;
        _this.centralService = centralService;
        _this.comprobanteFiscalService = comprobanteFiscalService;
        _this.centroRecepcionService = centroRecepcionService;
        _this.operacionTipoService = operacionTipoService;
        _this.divisaService = divisaService;
        _this.contribuyenteService = contribuyenteService;
        _this.recepcionSinOC = new recepcion_sin_oc_1.RecepcionSinOCInfo();
        _this.securityContext = [];
        _this.centrales = [];
        _this.departamentos = [];
        _this.centrosRecepcion = [];
        _this.origenesCF = [];
        _this.idProveedor = 0;
        _this.idAlmacen = 0;
        _this.operacionesTipo = [];
        _this.origenCF = "L";
        //
        _this.totalComprobantes = 0;
        _this.totalRecepciones = 0;
        _this.montoDiferencia = '$0.00';
        _this.documentForm = formBuilder.group({
            'idCentral': [0, controls_1.AztecaValidators.selected],
            'idDepartamento': [0, controls_1.AztecaValidators.selected],
            'idCentroRecepcion': [0, controls_1.AztecaValidators.selected],
            'idBeneficiario': [0, controls_1.AztecaValidators.selected],
            'idOperacionTipo': [0, controls_1.AztecaValidators.selected],
            'idDivisa': [0, controls_1.AztecaValidators.selected],
            'idProveedor': [0],
            'origenCF': [''],
            'montoDeDiferencia': [0, function (control) { return _this.validDiferencia(); }]
        });
        return _this;
        ////Suscribirse a cambios en central ya que esta determina varios comportamientos en los campos y validaciones
        //this.documentForm.controls['idCentral'].valueChanges.subscribe(value => {
        //    setTimeout(_ => this.loadCentrosRecepcion(value));
        //});
        ////Suscribirse a cambios en central ya que esta determina varios comportamientos en los campos y validaciones
        //this.documentForm.controls['idCentroRecepcion'].valueChanges.subscribe(value => {
        //    setTimeout(_ => this.loadDepartamentos(value));
        //});
    }
    RecepcionesSinOCEditor_1 = RecepcionesSinOCEditor;
    RecepcionesSinOCEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
        this.loadCentrales();
        this.loadOperacionesTipo();
        this.getDivisaDefault(false);
        this.origenesCF =
            [
                { "id": 'L', "nombre": "Ruta Local" },
                { "id": 'A', "nombre": "Almacen digital" },
            ];
    };
    RecepcionesSinOCEditor.prototype.onCreatingDocument = function () {
    };
    RecepcionesSinOCEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.recepcionSinOCService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.recepcionSinOC = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesSinOCEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.recepcionSinOCService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.recepcionSinOC = doc;
            _this.detailsEditor.clientIndexStart = _this.recepcionSinOC.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesSinOCEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.recepcionSinOCService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.recepcionSinOC = doc;
            _this.loadCentrosRecepcion(doc.idCentralCompras);
            _this.loadDepartamentos(doc.idCentroRecepcion);
            _this.detailsEditor.clientIndexStart = _this.recepcionSinOC.details.length;
            if (_this.recepcionSinOC.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
            _this.documentForm.controls['montoDeDiferencia'].markAsPristine();
            _this.documentForm.markAsPristine();
            _this.calcularImportes();
            _this.tipoCambio = doc.tipoCambio.toString();
            _this.documentForm.controls['montoDeDiferencia'].updateValueAndValidity();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesSinOCEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.recepcionSinOCService.update(this.recepcionSinOC)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.recepcionSinOC.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.recepcionSinOC = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesSinOCEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.recepcionSinOCService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesSinOCEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.recepcionSinOCService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesSinOCEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.recepcionSinOC.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    RecepcionesSinOCEditor.prototype.onAddingDetail = function () {
        this.origenCFDialog.config.backdrop = false;
        this.idProveedor = 0;
        this.origenCFDialog.show();
    };
    RecepcionesSinOCEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    RecepcionesSinOCEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    RecepcionesSinOCEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.recepcionSinOC.details = updatedDetails;
    };
    RecepcionesSinOCEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    /////////////////////// HANDLERS //////////////////////////////////
    RecepcionesSinOCEditor.prototype.onFileChanged = function (file) {
        this.selectedFile = file;
    };
    RecepcionesSinOCEditor.prototype.onValidateFile = function () {
        this.uploadDialog.hide();
        this.validateFile();
    };
    RecepcionesSinOCEditor.prototype.onOrigenCFSelected = function () {
        if (this.origenCF == "A" && this.idProveedor == 0)
            this.alertsBarComprobante.showAlert("Debe seleccionar un proveedor ", 'danger');
        else {
            this.origenCFDialog.hide();
            // Ver que va a cargar
            //this.comprobantesListDialog.config.backdrop = false;
            if (this.origenCF == "A")
                this.comprobantesListDialog.show();
            else {
                this.uploadDialog.config.backdrop = false;
                this.uploadDialog.show();
            }
        }
    };
    RecepcionesSinOCEditor.prototype.onProveedorChanged = function (proveedor) {
        var _this = this;
        if (proveedor) {
            this.idProveedor = proveedor.identity;
            this.contribuyenteService.inListaNegraEFO(proveedor.contribuyente.rfc, proveedor.idCompany)
                .then(function (result) {
                if (result == true) {
                    _this.showAlert("El contribuyente esta registrado como EFO", "danger");
                    _this.selProveedor.clear();
                }
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    RecepcionesSinOCEditor.prototype.onBeneficiarioChanged = function (beneficiario) {
    };
    RecepcionesSinOCEditor.prototype.onComprobanteSelected = function (comprobante) {
        var _this = this;
        this.comprobanteFiscalService.getDetail(comprobante.id)
            .then(function (comp) {
            _this.addDetail(_this.parseComprobanteItem(comp));
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesSinOCEditor.prototype.onDivisaChanged = function (divisa) {
        var _this = this;
        if (this.recepcionSinOC.identity == "") {
            this.recepcionSinOC.details = [];
            //this.recepcionSinOC..sourceCollection = [];
            if (this.recepcionSinOC.idDivisa == this.idDivisaDefault) {
                this.recepcionSinOC.tipoCambio = 1;
                this.tipoCambio = this.recepcionSinOC.tipoCambio.toString();
            }
            else {
                this.divisaService.loadTiposCambio(this.context.app.defaultSite.identity)
                    .then(function (tipos) {
                    var tCambio = tipos.find(function (search) { return search.idDivisaOrigen == _this.recepcionSinOC.idDivisa && search.idDivisaDestino == divisa.id; });
                    if (tCambio == undefined) {
                        _this.showAlert("No está definido el tipo de cambio para la divisa seleccionada", "danger");
                        _this.tipoCambio = null;
                        _this.recepcionSinOC.idDivisa = null;
                        _this.recepcionSinOC.tipoCambio = 0;
                    }
                    else {
                        _this.recepcionSinOC.tipoCambio = tCambio.precioOtro;
                        _this.tipoCambio = tCambio.precioOtro.toString();
                    }
                });
            }
        }
    };
    /////////////////////// METODOS DE CARGA INICIAL///////////////////////////////////   
    RecepcionesSinOCEditor.prototype.loadCentrales = function () {
        var _this = this;
        //this.centralService.loadListByUser(this.context.app.defaultSite.identity)
        //    .then(items => this.centrales = items)
        //    .catch(error => this.handleError(error));
        this.centralService.loadSecurityContext(this.context.app.defaultCompany.identity)
            .then(function (items) {
            _this.securityContext = items;
            var result = _(_this.securityContext).groupBy('idCentral').transform(function (result, current) {
                result.push({
                    id: current[0].idCentral,
                    nombre: current[0].central,
                });
            }, []).value();
            _this.centrales = result;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesSinOCEditor.prototype.loadCentrosRecepcion = function (idCentral) {
        //this.centroRecepcionService.loadListByDepartamentoAndUser(idDepartamento, this.context.app.defaultSite.identity)
        //    .then(items => this.centrosRecepcion = items)
        //    .catch(error => this.handleError(error));
        var result = _(this.securityContext.filter(function (item) { return item.idCentral == idCentral; })).groupBy('idCentroRecepcion').transform(function (result, current) {
            result.push({
                id: current[0].idCentroRecepcion,
                nombre: current[0].centroRecepcion,
            });
        }, []).value();
        this.centrosRecepcion = result;
        if (this.centrosRecepcion.length > 0 && this.recepcionSinOC.identity == '')
            this.recepcionSinOC.idCentroRecepcion = this.centrosRecepcion[0].id;
    };
    RecepcionesSinOCEditor.prototype.loadDepartamentos = function (idCentroRecepcion) {
        var _this = this;
        if (idCentroRecepcion) {
            var item = this.securityContext.find(function (item) { return item.idCentroRecepcion == idCentroRecepcion; });
            if (item)
                this.idAlmacen = item.idAlmacen;
            //this.departamentoService.loadListByCentralUser(idCentral, this.context.app.defaultSite.identity)
            //    .then(items => this.departamentos = items)
            //    .catch(error => this.handleError(error));
            var result = _(this.securityContext.filter(function (item) { return item.idCentral == _this.recepcionSinOC.idCentralCompras && item.idCentroRecepcion == idCentroRecepcion; })).groupBy('idDepartamento').transform(function (result, current) {
                result.push({
                    id: current[0].idDepartamento,
                    nombre: current[0].departamento,
                    tipoPresupuesto: current[0].tipoPresupuesto,
                    capturaDetallada: current[0].capturaDetallada
                });
            }, []).value();
            this.centroRecepcionService.getDetailByID(idCentroRecepcion)
                .then(function (centro) {
                _this.idAlmacen = centro.idAlmacen;
            })
                .catch(function (error) { return _this.handleError(error); });
            this.departamentos = result;
            if (this.departamentos.length > 0 && this.recepcionSinOC.identity == '')
                this.recepcionSinOC.idDepartamento = this.departamentos[0].id;
        }
    };
    RecepcionesSinOCEditor.prototype.loadOperacionesTipo = function () {
        var _this = this;
        this.operacionTipoService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (operaciones) {
            _this.operacionesTipo = operaciones;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    /////////////////////// METODOS DE CARGA DE COMPROBANTES///////////////////////////////////   
    RecepcionesSinOCEditor.prototype.validateFile = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteFiscalService.validate(this.context.app.defaultCompany.identity, this.selectedFile)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.cathComprobantes(result);
            //this.validatedFiles = result;
            //this.comprobantesCollection.sourceCollection = result;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesSinOCEditor.prototype.cathComprobantes = function (ValidCFDcomprobantes) {
        var _this = this;
        var promises = [];
        ValidCFDcomprobantes.forEach(function (validCFD) {
            if (validCFD.valid) {
                _this.context.app.showSpinner();
                var savePromise = _this.comprobanteFiscalService.save(0, _this.context.app.defaultCompany.identity, _this.context.app.defaultSite.identity, validCFD.comprobante.comprobanteBase.contenidoXML)
                    .then(function (comprobante) {
                    _this.context.app.hideSpinner();
                    _this.idProveedor = comprobante.proveedor.identity;
                    validCFD.comprobante.proveedor = comprobante.proveedor;
                    _this.addDetail(_this.parseComprobanteItem(comprobante));
                })
                    .catch(function (error) { return _this.handleError(error); });
            }
            else
                _this.showAlert("Algunos comprobantes no se pudieron validar correctamente:[" + validCFD.validationMessage + "]", "danger");
        });
    };
    RecepcionesSinOCEditor.prototype.parseComprobanteItem = function (info) {
        var item = new comprobante_fiscal_1.ComprobanteFiscalItem();
        item.id = info.identity;
        item.proveedor = info.proveedor.nombre;
        item.rfcEmisor = info.comprobanteBase.emisor.rfc;
        item.nombreEmisor = info.comprobanteBase.emisor.nombre;
        item.uuid = info.comprobanteBase.timbreFiscal.uuid;
        item.serie = info.comprobanteBase.serie;
        item.folio = info.comprobanteBase.folio;
        item.fechaComprobante = info.fechaSys;
        item.subtotal = info.comprobanteBase.subTotal;
        item.descuentos = info.comprobanteBase.descuentos;
        item.impuestosTrasladados = info.comprobanteBase.impuestos.totalTraslados;
        item.impuestosRetenidos = info.comprobanteBase.impuestos.totalRetenciones;
        item.total = info.comprobanteBase.total;
        item.idProveedor = info.proveedor.identity;
        return item;
    };
    RecepcionesSinOCEditor.prototype.addDetail = function (comprobante) {
        var exists = this.recepcionSinOC.details.find(function (det) { return det.idComprobante == comprobante.id; });
        if (exists == null) {
            var detalle_1 = new recepcion_sin_oc_detail_1.RecepcionSinOCDetail();
            detalle_1.idComprobante = comprobante.id;
            detalle_1.comprobante = comprobante;
            var newDetails = this.recepcionSinOC.details.slice();
            if (detalle_1._clientID == 0) {
                detalle_1._clientID = this.recepcionSinOC.details.length + 1;
                newDetails.push(detalle_1);
            }
            else {
                var index = newDetails.findIndex(function (item) { return item._clientID == detalle_1._clientID; });
                newDetails[index] = detalle_1;
            }
            this.recepcionSinOC.details = newDetails;
        }
        else {
            this.showAlert("El comprobantes ya ha sido agregado a una partida", "warning");
        }
    };
    Object.defineProperty(RecepcionesSinOCEditor.prototype, "importesComprobantes", {
        //////////////////////////CALCULO DE TOTALES ////////////////////////////////////
        get: function () {
            var desglose = new importes_1.ImportesInfo();
            this.recepcionSinOC.details.filter(function (det) { return det.state != "DELETED"; }).forEach(function (detail) {
                desglose.total += detail.comprobante.total;
                desglose.subtotal += detail.comprobante.subtotal;
                desglose.descuentos += detail.comprobante.descuentos;
                desglose.impuestosTrasladados += detail.comprobante.impuestosTrasladados;
                desglose.impuestosRetenidos += detail.comprobante.impuestosRetenidos;
            });
            this.totalComprobantes = desglose.total;
            //this.visualValidacion();
            return desglose;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RecepcionesSinOCEditor.prototype, "importesRecepciones", {
        get: function () {
            return this.calcularImportes();
        },
        enumerable: true,
        configurable: true
    });
    RecepcionesSinOCEditor.prototype.validDiferencia = function () {
        var resultado = 'No correspone el total detallado contra el total del comprobante fiscal';
        if (Math.abs(this.totalComprobantes - this.totalRecepciones) < .05 && this.totalComprobantes + this.totalRecepciones > 0) //|| !this.recepcion.proveedor.comprobanteFiscal)
            resultado = null;
        return resultado;
    };
    RecepcionesSinOCEditor.prototype.calcularImportes = function () {
        var desglose = new importes_1.ImportesInfo();
        var elementos = this.combineDetail().filter(function (item) { return item.state != 'DELETED'; });
        elementos.forEach(function (item) {
            desglose.subtotal += item.costoUnitario * item.cantidad;
            desglose.descuentos += (item.descuentos.descuento1 + item.descuentos.descuento2 + item.descuentos.descuento3 + item.descuentos.descuento4 + item.descuentos.descuento5) * item.cantidad;
            if (item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "T"; }).length > 0)
                desglose.impuestosTrasladados += item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "T"; }).map(function (imp) { return imp.importe * item.cantidad; }).reduce(function (a, b) { return a + b; });
            if (item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "R"; }).length > 0)
                desglose.impuestosRetenidos += item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "R"; }).map(function (imp) { return imp.importe * item.cantidad; }).reduce(function (a, b) { return a + b; });
        });
        desglose.total = desglose.subtotal - desglose.descuentos + desglose.impuestosTrasladados - desglose.impuestosRetenidos;
        this.totalRecepciones = desglose.total;
        //this.visualValidacion();
        this.montoDiferencia = wijmo_1.Globalize.formatNumber(this.totalComprobantes - this.totalRecepciones, 'c');
        return desglose;
    };
    RecepcionesSinOCEditor.prototype.combineDetail = function () {
        var defaultDate = new Date(1901, 1, 1);
        var newDetail = [];
        this.recepcionSinOC.details.filter(function (item) { return item.state != 'DELETED'; }).forEach(function (detail) {
            detail.servicios.filter(function (f) { return f.state != "DELETED"; }).forEach(function (s) { return newDetail.push(s); });
            detail.articulos.filter(function (f) { return f.state != "DELETED"; }).forEach(function (a) {
                if (!a.articulo.articuloStock.manejaCaducidad)
                    a.fechaCaducidad = defaultDate;
                newDetail.push(a);
            });
        });
        return newDetail;
    };
    //Metodos generales
    RecepcionesSinOCEditor.prototype.getDivisaDefault = function (creating) {
        var _this = this;
        this.divisaService.getDetailByEmpresa(this.context.app.defaultCompany.identity)
            .then(function (r) {
            _this.recepcionSinOC.idDivisa = r.identity;
            _this.idDivisaDefault = r.identity;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var RecepcionesSinOCEditor_1;
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], RecepcionesSinOCEditor.prototype, "alertsBarComprobante", void 0);
    __decorate([
        core_1.ViewChild('cargaComprobanteFiscalDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], RecepcionesSinOCEditor.prototype, "origenCFDialog", void 0);
    __decorate([
        core_1.ViewChild('comprobantesList'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], RecepcionesSinOCEditor.prototype, "comprobantesListDialog", void 0);
    __decorate([
        core_1.ViewChild('uploadDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], RecepcionesSinOCEditor.prototype, "uploadDialog", void 0);
    __decorate([
        core_1.ViewChild('selProveedor'),
        __metadata("design:type", proveedor_selector_component_1.ProveedorSelectorComponent)
    ], RecepcionesSinOCEditor.prototype, "selProveedor", void 0);
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], RecepcionesSinOCEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", recepciones_sin_oc_detail_editor_1.RecepcionSinOCDetailEditor)
    ], RecepcionesSinOCEditor.prototype, "detailsEditor", void 0);
    RecepcionesSinOCEditor = RecepcionesSinOCEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-recepciones-sin-oc-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                  [title]=\"'Recepciones Sin Orden de Compra(Gasto)'\"\n                                  [document]=\"recepcionSinOC\"\n                                  [valid]=\"valid\"\n                                  (configureDocument)=\"onConfigureDocument($event)\"\n                                  (creatingDocument)=\"onCreatingDocument()\"\n                                  (viewingDocument)=\"onViewingDocument($event)\"\n                                  (cloningDocument)=\"onCloningDocument($event)\"\n                                  (savingDocument)=\"onSavingDocument($event)\"\n                                  (loadingDocument)=\"onLoadingDocument($event)\"\n                                  (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                  (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-sm-12 col-md-4\">\n                      <accounting-importes-component [importes]=\"importesComprobantes\"\n                                                     [titulo]=\"'Total en Comprobantes Fiscales'\">\n                      </accounting-importes-component>\n                  </div>\n                  <div class=\"col-sm-12 col-md-2\">\n                      <div class=\"row\">\n                          <div class=\"col-12\">\n                              <azteca-form-field [label]=\"'Diferencia:'\">\n                                  <az-textbox formControlName=\"montoDeDiferencia\" [(ngModel)]=\"montoDiferencia\" style=\"text-align:right; font-size:small;\" [enabled]=\"false\"></az-textbox>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n                \n                  </div>\n                  <div class=\"col-sm-12 col-md-4\">\n                      <accounting-importes-component [importes]=\"importesRecepciones\"\n                                                     [titulo]=\"'Total en articulos/servicios comprobados'\">\n                      </accounting-importes-component>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Central:'\">\n                                          <az-combobox formControlName=\"idCentral\"\n                                                       [(ngModel)]=\"recepcionSinOC.idCentralCompras\"\n                                                       [items]=\"centrales\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\"\n                                                       (selectedItemChanged)=\"loadCentrosRecepcion($event)\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Centro de Recepci\u00F3n:'\">\n                                          <az-combobox formControlName=\"idCentroRecepcion\"\n                                                       [(ngModel)]=\"recepcionSinOC.idCentroRecepcion\"\n                                                       [items]=\"centrosRecepcion\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\"\n                                                       (selectedItemChanged)=\"loadDepartamentos($event)\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Departamento:'\">\n                                          <az-combobox formControlName=\"idDepartamento\"\n                                                       [(ngModel)]=\"recepcionSinOC.idDepartamento\"\n                                                       [items]=\"departamentos\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Beneficiario:'\">\n                                          <treasury-beneficiario-selector formControlName=\"idBeneficiario\"\n                                                                          [(ngModel)]=\"recepcionSinOC.idBeneficiario\"\n                                                                          (itemSelected)=\"onBeneficiarioChanged($event)\">\n                                          </treasury-beneficiario-selector>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Tipo de Operaci\u00F3n:'\">\n                                          <az-combobox formControlName=\"idOperacionTipo\"\n                                                       [(ngModel)]=\"recepcionSinOC.idOperacionTipo\"\n                                                       [items]=\"operacionesTipo\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Divisa:'\">\n                                          <accounting-divisas-selector formControlName=\"idDivisa\"\n                                                                       [(ngModel)]=\"recepcionSinOC.idDivisa\"\n                                                                       (selectedItemChanged)=\"onDivisaChanged($event)\"\n                                                                       [enabled]=\"recepcionSinOC.identity.length==0 \">\n                                          </accounting-divisas-selector>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-6 col-md-1\">\n                                      <label class=\"control-label\">T.C.:</label>\n                                      <az-label [text]=\"tipoCambio\"></az-label>\n                                  </div>\n                              </div>\n\n                          </tab>\n\n\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #detailsList\n                                                    (addingItem)=\"onAddingDetail()\"\n                                                    (editingItem)=\"onEditingDetail($event)\"\n                                                    (deletingItem)=\"onDeletingDetail($event)\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    [listItems]=\"recepcionSinOC.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'RFC'\" [binding]=\"'comprobante.rfcEmisor'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Emisor'\" [binding]=\"'comprobante.nombreEmisor'\" [width]=\"'20*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Serie'\" [binding]=\"'comprobante.serie'\" [width]=\"'5*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'comprobante.folio'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'UUID'\" [binding]=\"'comprobante.uuid'\" [width]=\"'20*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Subtotal'\" [binding]=\"'comprobante.subtotal'\" [width]=\"'10*'\" format=\"c\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Trasladados'\" [binding]=\"'comprobante.impuestosTrasladados'\" [width]=\"'10*'\" format=\"c\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Retenidos'\" [binding]=\"'comprobante.impuestosRetenidos'\" [width]=\"'10*'\" format=\"c\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Total'\" [binding]=\"'comprobante.total'\" [width]=\"'10*'\" format=\"c\"></azteca-grid-column>\n\n                              </azteca-editable-list>\n                          </tab>\n\n\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"recepcionSinOC.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n\n      <!--Detalles de la Recepcion sin OC-->\n      <compras-recepcion-sin-oc-detail-editor #detailsEditor\n                                              (savingItem)=\"onSavingDetail($event)\"                                        \n                                              [idAlmacen]=\"idAlmacen\"\n                                              [departamentos]=\"departamentos\">\n\n      </compras-recepcion-sin-oc-detail-editor>\n\n      <!--Solicitar la forma en la que se carga el Comprobante Fiscal-->\n      <div bsModal #cargaComprobanteFiscalDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myEgresoModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n\n              <div class=\"modal-content\">\n\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\">Obtener el comprobante fiscal desde:</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>                \n                  </div>\n\n                  <div class=\"modal-body\">\n                      <alerts-bar></alerts-bar>\n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-6\">\n                              <az-combobox [(ngModel)]=\"origenCF\"\n                                           [items]=\"origenesCF\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'id'\">\n                              </az-combobox>\n                          </div>\n                      </div>\n\n                      <div class=\"row\" *ngIf=\"origenCF=='A'\">\n                          <div class=\"col-12 col-md-6\">\n                              <az-label [text]=\"'Proveedor:'\"></az-label>\n                          </div>\n                          <div class=\"col-12 col-md-6\">\n                              <purchasing-proveedor-selector #selProveedor\n                                                             [(ngModel)]=\"idProveedor\"\n                                                             [showListButton]=\"false\"\n                                                             (proveedorUpdated)=\"onProveedorChanged($event)\">\n                              </purchasing-proveedor-selector>\n                          </div>\n                      </div>\n\n                  </div>\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onOrigenCFSelected()\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\" (click)=\"cargaComprobanteFiscalDialog.hide()\">Cerrar</button>\n                  </div>\n              </div>\n              <!--</div>-->\n          </div>\n      </div>\n\n      <!--DIALOGO DE CARGA DE ARCHIVO LOCAL para el Comprobante Fiscal-->\n      <div bsModal #uploadDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"mySmallModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-sm\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n                      <div>Seleccione el archivo a cargar:</div>\n                      <azteca-file-box (fileChanged)=\"onFileChanged($event)\"></azteca-file-box>                \n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onValidateFile()\" [disabled]=\"!selectedFile\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-danger\" (click)=\"uploadDialog.hide()\">Cancelar</button>\n                  </div> <!--Modal Footer-->\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n\n      <!--DIALOGO DE CARGA DE ALMACEN DIGITAL-->\n      <purchasing-comprobantes-list #comprobantesList\n                                    (selectedItemChanged)=\"onComprobanteSelected($event)\"\n                                    [idProveedor]=\"idProveedor\"\n                                    [idComprobanteTipo]=\"1\"\n                                    [Activos]=\"true\"\n                                    [sinReferencia]=\"true\">\n      </purchasing-comprobantes-list>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return RecepcionesSinOCEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: recepcion_sin_oc_service_1.RecepcionSinOCService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            recepcion_sin_oc_service_1.RecepcionSinOCService,
            central_service_1.CentralService,
            comprobante_fiscal_service_1.ComprobanteFiscalService,
            centro_recepcion_service_1.CentroRecepcionService,
            operacion_tipo_service_1.OperacionTipoService,
            divisa_service_1.DivisaService,
            contribuyente_service_1.ContribuyenteService])
    ], RecepcionesSinOCEditor);
    return RecepcionesSinOCEditor;
}(editors_1.DocumentEditor));
exports.RecepcionesSinOCEditor = RecepcionesSinOCEditor;
