import { Router, ActivatedRoute } from '@angular/router';
import { Context, DocumentItem } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { MenuItem } from 'framework3/controls';
import { SearchRequest } from 'framework3/search';
import { OrdenItem } from '../models/orden';
import { RecepcionItem } from '../models/recepcion';
import { RecepcionService } from '../services/recepcion.service';
import { ModalDirective } from 'ngx-bootstrap';
import { EmpresaService } from '../services/empresa.service';
import { CentralService } from '../services/central.service';
import { CentroRecepcionItem } from '../models/centro-recepcion';
import { OrdenesListComponent } from '../dialogs/ordenes-list.component';
import { PolizaPerfilListComponent, PolizaPerfilItem } from '../../accounting/index';
import { PolizaInfo } from '../../accounting/index';
import { PolizaService } from '../../accounting/index';
export declare class RecepcionesManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private recepcionService;
    private centralService;
    private polizaSvc;
    private empresaService;
    recepciones: RecepcionItem[];
    idProveedor: number;
    idCentroRecepcion: number;
    centrosRecepcion: CentroRecepcionItem[];
    currentPoliza: PolizaInfo;
    idWorkflowStepOrdenRecibir: number;
    dlgPolizaViewer: ModalDirective;
    ordenesList: OrdenesListComponent;
    proveedorDialog: ModalDirective;
    dlgPolizaPerfil: PolizaPerfilListComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, recepcionService: RecepcionService, centralService: CentralService, polizaSvc: PolizaService, empresaService: EmpresaService);
    onConfigureDocument(): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    loadCentrales(): void;
    onProveedorSelected(): void;
    onOrdenSelected(orden: OrdenItem): void;
    onMenuItemClick(option: MenuItem): void;
    cerrarProveedor(): void;
    onSelectedPolizaPerfil(item: PolizaPerfilItem): void;
    onClickGuardar(): void;
    loadEmpresa(): void;
}
