import { EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Context, DocumentItem } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { RequisicionItem } from '../models/requisicion';
import { RequisicionService } from '../services/requisicion.service';
export declare class RequisicionesManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private requisicionService;
    requisiciones: RequisicionItem[];
    idGrupoRequisiciones: string;
    showFilterPanel: boolean;
    standAlone: boolean;
    refreshListParent: EventEmitter<void>;
    constructor(context: Context, router: Router, route: ActivatedRoute, requisicionService: RequisicionService);
    onConfigureDocument(): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
}
