"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var wijmo_grid_1 = require("wijmo/wijmo.grid");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var requisicion_service_1 = require("../services/requisicion.service");
var RequisicionesManager = /** @class */ (function (_super) {
    __extends(RequisicionesManager, _super);
    function RequisicionesManager(context, router, route, requisicionService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.requisicionService = requisicionService;
        _this.showFilterPanel = true;
        _this.standAlone = true;
        _this.refreshListParent = new core_1.EventEmitter();
        return _this;
    }
    RequisicionesManager_1 = RequisicionesManager;
    RequisicionesManager.prototype.onConfigureDocument = function () {
        if (this.standAlone) {
            this.refreshList();
            this.applyPolicies();
        }
        //Cell
        this.manager.baseList.grid.formatItem.addHandler(function (grid, args) {
            if (args.panel.cellType == wijmo_grid_1.CellType.Cell && grid.columns[args.col].binding == 'workflowStep' &&
                grid.rows[args.row].dataItem.diasSinOrden > 2) {
                args.cell.style.backgroundColor = '#dc3545';
            }
            else if (args.panel.cellType == wijmo_grid_1.CellType.Cell && grid.columns[args.col].binding == 'workflowStep' &&
                grid.rows[args.row].dataItem.diasSinAutorizar > 2) {
                args.cell.style.backgroundColor = '#dca535';
            }
            else
                args.cell.style.backgroundColor = '';
        });
    };
    RequisicionesManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        if (this.standAlone) {
            this.context.app.showSpinner();
            this.requisicionService.search(this.context.app.defaultSite.identity, request)
                .then(function (response) {
                _this.context.app.hideSpinner();
                //
                _this.requisiciones = response.rows;
                _this.totalRows = response.totalRows;
                _this.filterGroups = response.filterGroups;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    RequisicionesManager.prototype.onAddingItem = function () {
        if (this.standAlone)
            this.router.navigate(['0'], { relativeTo: this.route });
        else
            this.router.navigate(['purchasing/requisiciones', this.process.id, this.idGrupoRequisiciones, 0]);
    };
    RequisicionesManager.prototype.onViewingItem = function (document) {
        this.router.navigate([document.id, { readonly: true }], { relativeTo: this.route });
    };
    RequisicionesManager.prototype.onEditingItem = function (document) {
        if (this.standAlone)
            this.router.navigate([document.id], { relativeTo: this.route });
        else
            this.router.navigate(['purchasing/requisiciones', this.process.id, this.idGrupoRequisiciones, document.id]);
    };
    RequisicionesManager.prototype.onDeletingItem = function (document) {
        var _this = this;
        this.requisicionService.delete(document.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El documento ha sido eliminado con éxito.', 'success');
            _this.refreshListParent.emit();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RequisicionesManager.prototype.onCloningItem = function (document) {
        this.router.navigate([0, { cloneId: document.id }], { relativeTo: this.route });
    };
    RequisicionesManager.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.requisicionService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
            _this.refreshListParent.emit();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RequisicionesManager.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.requisicionService.previousStep(document.id, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
            _this.refreshListParent.emit();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var RequisicionesManager_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], RequisicionesManager.prototype, "requisiciones", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], RequisicionesManager.prototype, "idGrupoRequisiciones", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], RequisicionesManager.prototype, "showFilterPanel", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], RequisicionesManager.prototype, "standAlone", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], RequisicionesManager.prototype, "refreshListParent", void 0);
    RequisicionesManager = RequisicionesManager_1 = __decorate([
        core_1.Component({
            selector: 'compras-requisiciones-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Requisiciones</div>\n          <div class=\"card-block\">\n              <azteca-document-manager (searchRequested)=\"onSearchRequested($event)\"\n                                       (addingItem)=\"onAddingItem()\"\n                                       (viewingItem)=\"onViewingItem($event)\"\n                                       (editingItem)=\"onEditingItem($event)\"\n                                       (deletingItem)=\"onDeletingItem($event)\"\n                                       (cloningItem)=\"onCloningItem($event)\"\n                                       (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                       (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                       (configureDocument)=\"onConfigureDocument($event)\"\n                                       [enabled]=\"enabled\"\n                                       [allowNew]=\"allowNew\"\n                                       [allowView]=\"allowView\"\n                                       [allowEdit]=\"allowEdit\"\n                                       [allowDelete]=\"allowDelete\"\n                                       [allowClone]=\"allowClone\"\n                                       [allowNext]=\"allowNext\"\n                                       [allowPrevious]=\"allowPrevious\"\n                                       [allowAudit]=\"allowAudit\"\n                                       [filterGroups]=\"filterGroups\"\n                                       [documentList]=\"requisiciones\"\n                                       [showFilterPanel]=\"showFilterPanel\"\n                                       [standAlone]=\"standAlone\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"200\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaSys'\" [width]=\"150\"  dataType=\"Date\" format=\"dd-MM-yyyy\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha Afectacion'\" [binding]=\"'fechaAfectacion'\" [width]=\"180\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Dias sin autorizar'\" [binding]=\"'diasSinAutorizar'\" [width]=\"100\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha Autorizacion'\" [binding]=\"'fechaAutorizacion'\" [width]=\"180\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Dias sin orden'\" [binding]=\"'diasSinOrden'\" [width]=\"100\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Tipo'\" [binding]=\"'tipoRequisicion'\" [width]=\"100\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Periodo'\" [binding]=\"'periodo'\" [width]=\"100\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Departamento'\" [binding]=\"'departamento'\" [width]=\"150\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Centro de Recep.'\" [binding]=\"'centroRecepcion'\" [width]=\"100\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"80\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Art./Serv'\" [binding]=\"'articuloServicio'\" [width]=\"200\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [width]=\"80\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Cat.Presup.'\" [binding]=\"'categoriaPresupuestal'\" [width]=\"150\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Observaciones'\" [binding]=\"'observaciones'\" [width]=\"150\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Usuario'\" [binding]=\"'usuario'\" [width]=\"150\"></azteca-grid-column>\n            \n                  <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"90\"></azteca-grid-column>\n\n              </azteca-document-manager>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return RequisicionesManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: requisicion_service_1.RequisicionService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, requisicion_service_1.RequisicionService])
    ], RequisicionesManager);
    return RequisicionesManager;
}(editors_1.DocumentManager));
exports.RequisicionesManager = RequisicionesManager;
