"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//Locales
var proveedor_service_1 = require("../services/proveedor.service");
var proveedores_registrar_editor_maintenance_1 = require("./proveedores-registrar-editor.maintenance");
var confirmacion_component_1 = require("./parts/confirmacion.component");
var ProveedoresRegistrar = /** @class */ (function (_super) {
    __extends(ProveedoresRegistrar, _super);
    function ProveedoresRegistrar(context, router, route, formBuilder, proveedorService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.proveedorService = proveedorService;
        _this.pRegistro = [];
        return _this;
    }
    ProveedoresRegistrar.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.listarCandidatos(); });
    };
    ProveedoresRegistrar.prototype.onRefrescar = function () {
        var _this = this;
        setTimeout(function (_) { return _this.listarCandidatos(); });
    };
    ProveedoresRegistrar.prototype.listarCandidatos = function () {
        var _this = this;
        this.proveedorService.preRegistros()
            .then(function (candidatos) {
            _this.pRegistro = candidatos;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ProveedoresRegistrar.prototype.onEditItem = function (item) {
        this.proveedoresRegistrarEditor.show(item);
    };
    ProveedoresRegistrar.prototype.onDataUpdated = function (args) {
        var _this = this;
        setTimeout(function (_) { return _this.listarCandidatos(); });
    };
    ProveedoresRegistrar.prototype.onRemoveItem = function (args) {
        this.confirma.show(args.idPreRegistro, "¿Esta seguro de eliminar el elemento seleccionado?");
    };
    ProveedoresRegistrar.prototype.onConfirmar = function (idPreRegistro) {
        var _this = this;
        if (idPreRegistro > 0) {
            this.proveedorService.preRegistroEliminar(idPreRegistro)
                .then(function (_) {
                _this.listarCandidatos();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    //Implementacion de politicas
    ProveedoresRegistrar.prototype.applyPolicy = function (policy) {
    };
    ProveedoresRegistrar.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(proveedores_registrar_editor_maintenance_1.ProveedoresRegistrarEditor),
        __metadata("design:type", proveedores_registrar_editor_maintenance_1.ProveedoresRegistrarEditor)
    ], ProveedoresRegistrar.prototype, "proveedoresRegistrarEditor", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ProveedoresRegistrar.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild(confirmacion_component_1.Confirmacion),
        __metadata("design:type", confirmacion_component_1.Confirmacion)
    ], ProveedoresRegistrar.prototype, "confirma", void 0);
    ProveedoresRegistrar = __decorate([
        core_1.Component({
            selector: 'purchasing-proveedores-registrar',
            template: "\n      <button class=\"btn btn\" (click)=\"onRefrescar()\"><span class=\"glyphicon glyphicon-refresh\"></span>  Refrescar</button>\n\n\n\n      <div class=\"row\">\n          <div class=\"col-12\">\n              <wj-flex-grid #grid style=\"height:550px\"\n                            [itemsSource]=\"pRegistro\">\n                  <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                  <wj-flex-grid-column [width]=\"55\" [isReadOnly]=\"true\">\n                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onEditItem(cell.item)\">\n                              <span class=\"glyphicon glyphicon-edit\"></span>\n                          </button>\n                      </ng-template>\n                  </wj-flex-grid-column>\n\n                  <wj-flex-grid-column [width]=\"55\" [isReadOnly]=\"true\">\n                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveItem(cell.item)\">\n                              <span class=\"glyphicon glyphicon-trash\"></span>\n                          </button>\n                      </ng-template>\n                  </wj-flex-grid-column>\n\n\n                  <wj-flex-grid-column [header]=\"'Fecha'\" [binding]=\"'fecha'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'RFC'\" [binding]=\"'rfc'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Raz\u00F3n Social'\" [binding]=\"'razonSocial'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Nombre Comercial'\" [binding]=\"'nombreComercial'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Correo'\" [binding]=\"'correo'\" [width]=\"'20*'\"></wj-flex-grid-column>\n              </wj-flex-grid>\n          </div>\n      </div>\n\n      <purchasing-proveedores-registrar-editor (dataUpdated)=\"onDataUpdated($event)\">\n\n      </purchasing-proveedores-registrar-editor>\n\n      <confirmacion (aceptado)=\"onConfirmar($event)\">    </confirmacion>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, proveedor_service_1.ProveedorService])
    ], ProveedoresRegistrar);
    return ProveedoresRegistrar;
}(core_2.ProcessComponent));
exports.ProveedoresRegistrar = ProveedoresRegistrar;
