import { DocumentInfo, DocumentItem } from 'framework3/core';
import { RecepcionDetail } from './recepcion-detail';
import { ProveedorInfo } from '../models/proveedor';
export declare class RecepcionInfo extends DocumentInfo<RecepcionDetail> {
    fechaAfectacion: Date;
    idCentralCompras: number;
    idCentroRecepcion: number;
    idProveedor: number;
    idOrdenTit: string;
    fechaOrden: Date;
    idOperacionTipo: number;
    idRecepcionSinOC: string;
    fechaRecepcionSinOC: Date;
    idEntrada: string;
    fechaEntrada: Date;
    idCuentaPorPagarTit: string;
    fechaCuentaPorPagar: Date;
    idComprobante: string;
    fechaComprobante: Date;
    idDivisa: number;
    tipoCambio: number;
    subtotal: number;
    impuestosTrasladados: number;
    impuestosRetenidos: number;
    descuentos: number;
    flete: number;
    total: number;
    proveedor: ProveedorInfo;
    centroRecepcion: string;
    constructor();
}
export declare class RecepcionItem extends DocumentItem {
    central: string;
    centroRecepcion: string;
    proveedor: string;
    idBeneficiario: number;
    total: number;
    serie: string;
    folio: number;
    idCuentaPorPagarTit: string;
    fechaCuentaPorPagar: Date;
    subTotal?: number;
    impuestosTrasladados?: number;
    impuestosRetenidos?: number;
}
