import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { BaseComponent, Context, CatalogItem, PolicyInfo } from 'framework3/core';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { CentrosRecepcionListComponent } from '../dialogs/centros-recepcion-list.component';
import { CentralService } from '../services/central.service';
import { CentralInfo } from '../models/central';
import { CentroRecepcionItem } from '../models/centro-recepcion';
export declare class CentralDepartamentosComponent extends BaseComponent {
    private context;
    private centralService;
    private router;
    private route;
    private location;
    title: string;
    centrosRecepcion: CentroRecepcionItem[];
    idCentral: number;
    central: CentralInfo;
    currentItem: CatalogItem;
    centrosRecepcionDialog: CentrosRecepcionListComponent;
    alerts: AlertsBarComponent;
    constructor(context: Context, centralService: CentralService, router: Router, route: ActivatedRoute, location: Location);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadCentral(): void;
    refreshList(): void;
    onCurrentItemChanged(item: CatalogItem): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onSelectedItemsChanged(newCtroRecep: CentroRecepcionItem[]): void;
    onRemoveCentroRecepcion(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
