import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { BaseComponent, Context, CatalogItem, PolicyInfo, UsuarioItem } from 'framework3/core';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { UsuariosListComponent } from 'framework3/security';
import { CentralService } from '../services/central.service';
import { CentralInfo } from '../models/central';
export declare class CentralMiembrosComponent extends BaseComponent {
    private context;
    private centralService;
    private router;
    private route;
    private location;
    title: string;
    usuarios: UsuarioItem[];
    idCentral: number;
    central: CentralInfo;
    currentItem: CatalogItem;
    usuariosDialog: UsuariosListComponent;
    alerts: AlertsBarComponent;
    constructor(context: Context, centralService: CentralService, router: Router, route: ActivatedRoute, location: Location);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadCentral(): void;
    refreshList(): void;
    onCurrentItemChanged(item: CatalogItem): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onSelectedUsersChanged(newUsers: UsuarioItem[]): void;
    onRemoveUser(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
