import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { BaseComponent, Context, CatalogItem, PolicyInfo, UsuarioItem } from 'framework3/core';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { UsuariosListComponent } from 'framework3/security';
import { CentroRecepcionService } from '../services/centro-recepcion.service';
import { CentroRecepcionInfo } from '../models/centro-recepcion';
export declare class CentrosRecepcionMiembrosComponent extends BaseComponent {
    private context;
    private centroRecepcionService;
    private router;
    private route;
    private location;
    title: string;
    usuarios: UsuarioItem[];
    idCentroRecepcion: number;
    centroRecepcion: CentroRecepcionInfo;
    currentItem: CatalogItem;
    usuariosDialog: UsuariosListComponent;
    alerts: AlertsBarComponent;
    constructor(context: Context, centroRecepcionService: CentroRecepcionService, router: Router, route: ActivatedRoute, location: Location);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadCentral(): void;
    refreshList(): void;
    onCurrentItemChanged(item: CatalogItem): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onSelectedUsersChanged(newUsers: UsuarioItem[]): void;
    onRemoveUser(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
