"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//
var security_1 = require("framework3/security");
//
var centro_recepcion_service_1 = require("../services/centro-recepcion.service");
var CentrosRecepcionMiembrosComponent = /** @class */ (function (_super) {
    __extends(CentrosRecepcionMiembrosComponent, _super);
    //
    function CentrosRecepcionMiembrosComponent(context, centroRecepcionService, router, route, location) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.centroRecepcionService = centroRecepcionService;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.title = '';
        return _this;
    }
    CentrosRecepcionMiembrosComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idCentroRecepcion = +param['id'];
        });
    };
    CentrosRecepcionMiembrosComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.refreshList(); });
        setTimeout(function (_) { return _this.loadCentral(); });
    };
    ///////////////// METODOS ///////////////////////////////
    CentrosRecepcionMiembrosComponent.prototype.loadCentral = function () {
        var _this = this;
        this.centroRecepcionService.getDetailByID(this.idCentroRecepcion)
            .then(function (info) {
            _this.centroRecepcion = info;
            _this.title = 'Miembros de la central - ' + _this.centroRecepcion.nombre;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentrosRecepcionMiembrosComponent.prototype.refreshList = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.centroRecepcionService.getMembers(this.idCentroRecepcion)
            .then(function (usuarios) {
            _this.usuarios = usuarios;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////// HANDLERS ///////////////////////////////
    CentrosRecepcionMiembrosComponent.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    CentrosRecepcionMiembrosComponent.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.usuariosDialog.show();
        }
        if (button.name == 'REFRESH') {
            this.refreshList();
        }
        if (button.name == 'CLOSE') {
            this.location.back();
        }
    };
    CentrosRecepcionMiembrosComponent.prototype.onSelectedUsersChanged = function (newUsers) {
        var _this = this;
        this.centroRecepcionService.addMembers(this.idCentroRecepcion, newUsers)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('Los usuarios han sido agregados con éxito.', 'success');
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentrosRecepcionMiembrosComponent.prototype.onRemoveUser = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.centroRecepcionService.removeMember(this.idCentroRecepcion, this.currentItem.id)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.usuarios = _this.usuarios.filter(function (item) { return item.id != _this.currentItem.id; });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CentrosRecepcionMiembrosComponent.prototype.applyPolicy = function (policy) {
    };
    CentrosRecepcionMiembrosComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(security_1.UsuariosListComponent),
        __metadata("design:type", security_1.UsuariosListComponent)
    ], CentrosRecepcionMiembrosComponent.prototype, "usuariosDialog", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], CentrosRecepcionMiembrosComponent.prototype, "alerts", void 0);
    CentrosRecepcionMiembrosComponent = __decorate([
        core_1.Component({
            selector: 'purchasing-centros-recepcion-miembros',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-md-10\">\n              <az-panel [header]=\"title\">\n                  <alerts-bar></alerts-bar>\n                  <!--Toolbar Principal-->\n                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                      <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar Usuarios'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'REFRESH'\" [text]=\"'Actualizar'\" [icon]=\"'glyphicon glyphicon-refresh'\" [class]=\"'d-none d-lg-block'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Regresar'\" [icon]=\"'glyphicon glyphicon-circle-arrow-left'\"></az-toolbar-button>\n                  </az-toolbar>\n\n                  <!-- Lista de usuarios-->\n                  <azteca-catalog-list [catalogList]=\"usuarios\"\n                                       [showRowButton]=\"true\"\n                                       [rowButtonIcon]=\"'glyphicon glyphicon-trash'\"\n                                       (rowButtonClick)=\"onRemoveUser()\"\n                                       (currentItemChanged)=\"onCurrentItemChanged($event)\"\n                                       [enabled]=\"enabled\"\n                                       [pageSize]=\"15\"\n                                       [serverSide]=\"false\">\n\n                      <!--<azteca-grid-column [header]=\"'ID'\" [binding]=\"'id'\" [width]=\"50\"></azteca-grid-column>-->\n                      <azteca-grid-column [header]=\"'Usuario'\" [binding]=\"'codigo'\" [width]=\"'20*'\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'40*'\"></azteca-grid-column>\n\n                  </azteca-catalog-list>\n\n\n              </az-panel>\n          </div>\n      </div>\n\n      <security-usuarios-list (selectedItemsChanged)=\"onSelectedUsersChanged($event)\"\n                              [excludedItems]=\"usuarios\"\n                              [multiSelect]=\"true\">\n\n      </security-usuarios-list>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, centro_recepcion_service_1.CentroRecepcionService, router_1.Router, router_1.ActivatedRoute,
            common_1.Location])
    ], CentrosRecepcionMiembrosComponent);
    return CentrosRecepcionMiembrosComponent;
}(core_2.BaseComponent));
exports.CentrosRecepcionMiembrosComponent = CentrosRecepcionMiembrosComponent;
