import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { BaseComponent, Context, CatalogItem, PolicyInfo } from 'framework3/core';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { CentroRecepcionItem } from '../models/centro-recepcion';
import { CentrosRecepcionListComponent } from '../dialogs/centros-recepcion-list.component';
import { DepartamentoService } from '../services/departamento.service';
import { DepartamentoInfo } from '../models/departamento';
export declare class DepartamentosCentrosRecepcionComponent extends BaseComponent {
    private context;
    private departamentoService;
    private router;
    private route;
    private location;
    title: string;
    centrosRecepcion: CentroRecepcionItem[];
    idDepartamento: number;
    departamento: DepartamentoInfo;
    currentItem: CatalogItem;
    centrosRecepcionDialog: CentrosRecepcionListComponent;
    alerts: AlertsBarComponent;
    constructor(context: Context, departamentoService: DepartamentoService, router: Router, route: ActivatedRoute, location: Location);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadDepartamento(): void;
    refreshList(): void;
    onCurrentItemChanged(item: CatalogItem): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onSelectedItemsChanged(newItems: CentroRecepcionItem[]): void;
    onRemoveItem(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
