import { EventEmitter, ChangeDetectorRef } from "@angular/core";
import { BaseComponent, Context, PolicyInfo } from "framework3/core";
import { PersonaService, PersonaInfo } from "framework3/general";
import { FormGroup, FormBuilder } from "@angular/forms";
import { AlertsBarComponent } from "framework3/controls";
import { ModalDirective } from "ngx-bootstrap";
import { ActivatedRoute } from "@angular/router";
import { Location } from '@angular/common';
import { ProveedorService } from "../services";
export declare class ProveedoresContactosEditor extends BaseComponent {
    private context;
    private route;
    private formBuilder;
    private location;
    protected changeDetector: ChangeDetectorRef;
    private personaService;
    private proveedorService;
    editorForm: FormGroup;
    title: string;
    idProveedor: number;
    idContacto: number;
    idPersona: number;
    persona: PersonaInfo;
    alerts: AlertsBarComponent;
    dataUpdated: EventEmitter<number>;
    dialog: ModalDirective;
    constructor(context: Context, route: ActivatedRoute, formBuilder: FormBuilder, location: Location, changeDetector: ChangeDetectorRef, personaService: PersonaService, proveedorService: ProveedorService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadContacto(): void;
    loadPersona(): void;
    onUpdate(): void;
    onCancel(): void;
    applyPolicy(policy: PolicyInfo): void;
    onPersonValidChange(): void;
    handleError(error: any): void;
}
