"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
var wijmo_grid_1 = require("wijmo/wijmo.grid");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var comprobante_fiscal_service_1 = require("../services/comprobante-fiscal.service");
var ValidacionCFDComponent = /** @class */ (function (_super) {
    __extends(ValidacionCFDComponent, _super);
    function ValidacionCFDComponent(context, router, route, comprobanteService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.comprobanteService = comprobanteService;
        _this.comprobantesCollection = new wijmo_1.CollectionView();
        _this.menuItems = [];
        _this.validatedFiles = [];
        return _this;
    }
    /////////////////////// METODOS ///////////////////////////////////
    ValidacionCFDComponent.prototype.validateFile = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteService.validate(this.context.app.defaultCompany.identity, this.selectedFile)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.validatedFiles = result;
            _this.comprobantesCollection.sourceCollection = result;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ValidacionCFDComponent.prototype.createMenu = function () {
        //Agregar opciones estándar del catálogo
        //let mnuView: MenuItem = { icon: "glyphicon glyphicon-folder-open", text: "Ver", name: "OPEN", smallText: "ver resumen del comprobante" };
        //this.menuItems.push(mnuView, mnuPdf, mnuXml);
        this.menuItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    ValidacionCFDComponent.prototype.save = function () {
        var _this = this;
        var promises = [];
        this.validatedFiles.filter(function (file) { return file.valid && !file.saved; }).forEach(function (file) {
            _this.context.app.showSpinner();
            var savePromise = _this.comprobanteService.save(0, _this.context.app.defaultCompany.identity, _this.context.app.defaultSite.identity, file.comprobante.comprobanteBase.contenidoXML)
                .then(function (comprobante) {
                file.validationMessage = 'Guardado';
                file.saved = true;
            })
                .catch(function (error) { return _this.handleError(error); });
            promises.push(savePromise);
        });
        Promise.all(promises)
            .then(function (_) {
            _this.comprobantesCollection.refresh();
            _this.context.app.hideSpinner();
            _this.alertsBar.showAlert('El proceso terminó con éxito.', 'success');
        });
    };
    /////////////////////// HANDLERS //////////////////////////////////
    ValidacionCFDComponent.prototype.onToolbarClick = function (button) {
        if (button.name == 'FILE') {
            this.uploadDialog.config.backdrop = false;
            this.uploadDialog.show();
        }
        else if (button.name == 'SAVE') {
            this.save();
        }
        else if (button.name == 'CLOSE') {
            this.router.navigate(['../'], { relativeTo: this.route });
        }
    };
    ValidacionCFDComponent.prototype.initialized = function (sender, args) {
        var self = this;
        //Agregar manejador para menú contextual        
        sender.addEventListener(sender.hostElement, "contextmenu", function (e) {
            var ht = sender.hitTest(e);
            sender.select(new wijmo_grid_1.CellRange(ht.row, ht.col), true);
        });
    };
    ValidacionCFDComponent.prototype.onFileChanged = function (file) {
        this.selectedFile = file;
    };
    ValidacionCFDComponent.prototype.onValidateFile = function () {
        this.uploadDialog.hide();
        this.validateFile();
    };
    ValidacionCFDComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        console.log(error);
        var message = this.context.getExceptionMessage(error);
        this.alertsBar.showAlert(message, 'danger');
    };
    //Implementacion de politicas
    ValidacionCFDComponent.prototype.applyPolicy = function (policy) {
    };
    __decorate([
        core_1.ViewChild('uploadDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ValidacionCFDComponent.prototype, "uploadDialog", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ValidacionCFDComponent.prototype, "alertsBar", void 0);
    ValidacionCFDComponent = __decorate([
        core_1.Component({
            selector: 'purchasing-validacion-cfd',
            template: "\n      <az-panel [header]=\"'Carga y validaci\u00F3n de comprobantes fiscales'\">\n          <alerts-bar></alerts-bar>\n\n          <az-toolbar (buttonClick)=\"onToolbarClick($event)\">\n              <az-toolbar-button [name]=\"'FILE'\" [type]=\"'primary'\" [text]=\"'Seleccionar archivo'\" [icon]=\"'glyphicon glyphicon-folder-open'\"></az-toolbar-button>\n              <az-toolbar-button [name]=\"'SAVE'\" [text]=\"'Guardar'\" [icon]=\"'glyphicon glyphicon-floppy-disk'\" [title]=\"'Guardar archivos v\u00E1lidos'\" [enabled]=\"validatedFiles.length > 0\"></az-toolbar-button>\n              <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Cerrar'\" [icon]=\"'glyphicon glyphicon-remove'\" [title]=\"'Regresar al almac\u00E9n digital'\"></az-toolbar-button>\n          </az-toolbar>\n\n          <wj-flex-grid #grid\n                        style=\"height:550px\"\n                        [itemsSource]=\"comprobantesCollection\"\n                        (initialized)=\"initialized(grid, $event)\"\n                        [isReadOnly]=\"true\"\n                        [wjContextMenu]=\"ctxMenu\">\n\n              <wj-flex-grid-column [header]=\"'Estatus'\" [width]=\"100\">\n                  <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                      <div [ngStyle]=\"{color: cell.item.valid ? 'darkgreen' : 'darkred'}\">\n                          <span [class]=\"'glyphicon glyphicon-' + cell.item.saved ? 'floppy-saved' : 'file'\"></span>\n                          {{cell.item.valid ? 'V\u00E1lido': 'Inv\u00E1lido'}}\n                      </div>\n                  </ng-template>\n              </wj-flex-grid-column>\n\n              <wj-flex-grid-column [header]=\"'Fecha'\" [binding]=\"'fecha'\" [width]=\"150\" dataType=\"Date\" format=\"dd/MM/yyyy\"></wj-flex-grid-column>\n              <wj-flex-grid-column [header]=\"'Archivo'\" [binding]=\"'fileName'\" [width]=\"150\"></wj-flex-grid-column>\n              <wj-flex-grid-column [header]=\"'UUID'\" [binding]=\"'uuid'\" [width]=\"'20*'\"></wj-flex-grid-column>\n              <wj-flex-grid-column [header]=\"'RFC'\" [binding]=\"'rfcEmisor'\" [width]=\"'20*'\"></wj-flex-grid-column>\n              <wj-flex-grid-column [header]=\"'Emisor'\" [binding]=\"'nombreEmisor'\" [width]=\"'20*'\"></wj-flex-grid-column>\n              <wj-flex-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"'20*'\" dataType=\"Number\" format=\"c\"></wj-flex-grid-column>\n              <ng-template wjFlexGridDetail [detailVisibilityMode]=\"'ExpandSingle'\" let-item=\"item\">           \n                  <div class=\"row\" *ngIf=\"!item.valid\">\n                      <div class=\"col-12\">\n                          <label class=\"control-label\"></label>\n                          <textarea class=\"form-control\" style=\"height: 100px;font-size:12px;color:darkred\" [value]=\"item.validationMessage\" readonly></textarea>\n                      </div>\n                  </div>\n                  <accounting-comprobante-viewer [comprobante]=\"item.comprobante.comprobanteBase\"></accounting-comprobante-viewer>\n              </ng-template>\n\n          </wj-flex-grid>\n\n\n      </az-panel>\n\n      <!--DIALOGO DE CARGA DE ARCHIVO-->\n      <div bsModal #uploadDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"mySmallModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-sm\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n                      <div>Seleccione el archivo a cargar:</div>\n                      <azteca-file-box (fileChanged)=\"onFileChanged($event)\"></azteca-file-box>\n                      <small><strong>Tip: Puede subir varios comprobantes utilizando un archivo zip</strong></small>\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onValidateFile()\" [disabled]=\"!selectedFile\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-danger\" (click)=\"uploadDialog.hide()\">Cancelar</button>\n                  </div> <!--Modal Footer-->\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n\n      <!--MENU CONTEXTUAL-->\n      <wj-menu #ctxMenu (itemClicked)=\"contextMenuClick(ctxMenu)\" style=\"display:none\">\n          <wj-menu-item *ngFor=\"let item of menuItems\">\n              <div *ngIf=\"item.enabled\">\n                  <span [class]=\"item.icon\"></span>\n                  <b>{{item.text}}</b>\n                  <br>\n                  <small><i>{{item.smallText}}</i></small>\n              </div>\n          </wj-menu-item>\n      </wj-menu>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute,
            comprobante_fiscal_service_1.ComprobanteFiscalService])
    ], ValidacionCFDComponent);
    return ValidacionCFDComponent;
}(core_2.ProcessComponent));
exports.ValidacionCFDComponent = ValidacionCFDComponent;
