"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//////////////////////////// Guards //////////////////////////////////
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
/////////////////////////////  Componentes //////////////////////////////
var fromCatalogs = require("./catalogs");
var fromDocuments = require("./documents");
var fromComponents = require("./components");
var fromParts = require("./parts");
//////////////////////////// Mantenimientos ////////////////////////////////
var proveedores_registrar_maintenance_1 = require("./maintenances/proveedores-registrar.maintenance");
var parts_1 = require("./parts");
var proveedores_contactos_component_1 = require("./parts/proveedores-contactos.component");
///////////////////////////// Rutas /////////////////////////////////
var routes = [
    {
        path: '',
        canActivateChild: [core_2.AuthGuard],
        children: [
            // CATALOGS
            { path: 'empresas-compras/:proceso', component: fromCatalogs.EmpresasManager },
            { path: 'empresas-compras/:proceso/:id', component: fromCatalogs.EmpresasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'centrales/:proceso', component: fromCatalogs.CentralesManager },
            { path: 'centrales/:proceso/:id', component: fromCatalogs.CentralesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'centrales/:proceso/:id/members', component: fromParts.CentralMiembrosComponent },
            { path: 'centrales/:proceso/:id/departamentos', component: fromParts.CentralDepartamentosComponent },
            { path: 'departamentos/:proceso', component: fromCatalogs.DepartamentosManager },
            { path: 'departamentos/:proceso/:id', component: fromCatalogs.DepartamentosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'departamentos/:proceso/:id/members', component: fromParts.DepartamentosMiembrosComponent },
            { path: 'departamentos/:proceso/:id/centros-recepcion', component: fromParts.DepartamentosCentrosRecepcionComponent },
            { path: 'departamentos/:proceso/:id/categorias-presupuestales', component: fromParts.DepartamentosCategoriasPresupuestalesComponent },
            //{ path: 'departamentos/:proceso/:id/centros-costo', component: DepartamentosCentrosRecepcionComponent },
            { path: 'centros-recepcion/:proceso', component: fromCatalogs.CentrosRecepcionManager },
            { path: 'centros-recepcion/:proceso/:id', component: fromCatalogs.CentrosRecepcionEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'centros-recepcion/:proceso/:id/members', component: fromParts.CentrosRecepcionMiembrosComponent },
            { path: 'centros-costo/:proceso', component: fromCatalogs.CentrosCostoManager },
            { path: 'centros-costo/:proceso/:id', component: fromCatalogs.CentrosCostoEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'centros-costo/:proceso/:id/members', component: fromParts.CentrosCostoMiembrosComponent },
            { path: 'proveedores/:proceso', component: fromCatalogs.ProveedoresManager },
            { path: 'proveedores/:proceso/:id', component: fromCatalogs.ProveedoresEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'zonas-compra/:proceso', component: fromCatalogs.ZonasCompraManager },
            { path: 'zonas-compra/:proceso/:id', component: fromCatalogs.ZonasCompraEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'articulos/:proceso', component: fromCatalogs.ArticulosManager },
            { path: 'articulos/:proceso/:id', component: fromCatalogs.ArticulosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'proveedor-articulo/:proceso/:id/:idProveedor/:idArticulo/:idZona/:editProveedor/:editArticulo/:editZona', component: fromComponents.ProveedorArtioculoComponent, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'proveedor-producto/:proceso', component: fromComponents.ProveedorProductoComponent },
            { path: 'producto-proveedor/:proceso', component: fromComponents.ProductoProveedorComponent },
            { path: 'servicios-compras/:proceso', component: fromCatalogs.ServiciosManager },
            { path: 'servicios-compras/:proceso/:id', component: fromCatalogs.ServiciosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'proveedor-servicio/:proceso/:id/:idProveedor/:idServicio/:idZona/:editProveedor/:editServicio/:editZona', component: fromComponents.ProveedorServicioComponent, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'categorias-presupuestales/:proceso', component: fromCatalogs.CategoriasPresupuestalesManager },
            { path: 'categorias-presupuestales/:proceso/:id', component: fromCatalogs.CategoriasPresupuestalesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'presupuestos/:proceso', component: fromDocuments.PresupuestosManager },
            { path: 'presupuestos/:proceso/:id', component: fromDocuments.PresupuestosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'presupuestos/:proceso/:id/change', component: fromDocuments.PresupuestosCambioEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'proveedores-tipos/:proceso/:id', component: fromCatalogs.ProveedorTipoEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'proveedores-tipos/:proceso', component: fromCatalogs.ProveedoresTiposManager },
            { path: 'tipos-operaciones/:proceso', component: fromCatalogs.OperacionesTiposManager },
            { path: 'tipos-operaciones/:proceso/:id', component: fromCatalogs.OperacionesTiposEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'tipos-operaciones/:proceso/:id/members', component: fromParts.OperacionesTiposMiembrosComponent },
            { path: 'sucursales-compras/:proceso/:idEmpresa/:id', component: fromCatalogs.SucursalesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'tipos-requisiciones/:proceso', component: fromCatalogs.TiposRequisicionManager },
            { path: 'tipos-requisiciones/:proceso/:id', component: fromCatalogs.TiposRequisicionEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'gastos-tipos/:proceso', component: fromCatalogs.GastosTiposManager },
            { path: 'gastos-tipos/:proceso/:id', component: fromCatalogs.GastosTiposEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            //DOCUMENTS
            { path: 'almacen-digital/:proceso', component: fromDocuments.AlmacenDigitalComponent },
            //PARTS
            { path: 'almacen-digital/:proceso/upload', component: fromParts.ValidacionCFDComponent },
            { path: 'grupo-requisiciones/:proceso', component: fromDocuments.GrupoRequisicionesManager },
            { path: 'grupo-requisiciones/:proceso/:id', component: fromDocuments.GrupoRequisicionesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'requisiciones/:proceso', component: fromDocuments.RequisicionesManager },
            { path: 'requisiciones/:proceso/:id', component: fromDocuments.RequisicionesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'requisiciones/:proceso/:idGrupoRequisiciones/:id', component: fromDocuments.RequisicionesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'ordenes-compra/:proceso', component: fromDocuments.OrdenesManager },
            { path: 'ordenes-compra/:proceso/:id', component: fromDocuments.OrdenesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'ordenes-compra/:proceso/:id/wizard', component: fromDocuments.OrdenesWizardEditorComponent, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'recepciones/:proceso', component: fromDocuments.RecepcionesManager },
            { path: 'recepciones/:proceso/:id/:idCentroRecepcion/:idOrden', component: fromDocuments.RecepcionesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'recepciones-sin-oc/:proceso', component: fromDocuments.RecepcionesSinOCManager },
            { path: 'recepciones-sin-oc/:proceso/:id', component: fromDocuments.RecepcionesSinOCEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'gastos/:proceso', component: fromDocuments.GastosManager },
            { path: 'gastos/:proceso/new', component: fromDocuments.NuevoGastoComponent },
            { path: 'gastos/:proceso/:id', component: fromDocuments.GastosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'gasto-comprobar/:proceso/:idGasto', component: fromDocuments.GastoComprobar },
            { path: 'adelantos/:proceso', component: fromDocuments.AdelantosManager },
            { path: 'adelantos/:proceso/:id/:idOrden', component: fromDocuments.AdelantosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'proveedores-registrar/:proceso', component: proveedores_registrar_maintenance_1.ProveedoresRegistrar },
            { path: 'notas/:proceso', component: fromDocuments.NotasManager },
            { path: 'notas/:proceso/:id', component: fromDocuments.NotasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'costos-presupuestos/:proceso', component: fromDocuments.CostosPresupuestosManager },
            { path: 'costos-presupuestos/:proceso/new', component: fromDocuments.NuevoCostosPresupuestosComponent },
            { path: 'costos-presupuestos/:proceso/:id', component: fromDocuments.CostosPresupuestosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'proveedores/contacts/:proceso/:id', component: proveedores_contactos_component_1.ProveedoresContactosComponent },
            { path: 'proveedores/contacts/:proceso/:id/:idContacto/:idPersona', component: parts_1.ProveedoresContactosEditor },
        ]
    },
];
var PurchasingRoutingModule = /** @class */ (function () {
    function PurchasingRoutingModule() {
    }
    PurchasingRoutingModule = __decorate([
        core_1.NgModule({
            imports: [
                router_1.RouterModule.forChild(routes)
            ],
            exports: [
                router_1.RouterModule
            ]
        })
    ], PurchasingRoutingModule);
    return PurchasingRoutingModule;
}());
exports.PurchasingRoutingModule = PurchasingRoutingModule;
