import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService } from 'framework3/core';
import { CentralInfo, CentralItem } from '../models/central';
import { UsuarioItem } from 'framework3/core';
import { DepartamentoItem } from '../models/departamento';
import { CentroRecepcionItem } from '../models/centro-recepcion';
import { SecurityContext } from '../models/security-context';
export declare class CentralService extends CatalogService<CentralInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<CentralInfo>;
    loadSecurityContext(idEmpresa: number): Promise<SecurityContext[]>;
    loadListByUser(idSucursal: number): Promise<CentralItem[]>;
    getMembers(idCentral: number): Promise<UsuarioItem[]>;
    addMembers(idCentral: number, users: UsuarioItem[]): Promise<any>;
    removeMember(idCentral: number, idUser: number): Promise<any>;
    getCentrosRecepcion(idCentral: number): Promise<CentroRecepcionItem[]>;
    addCentrosRecepcion(idCentral: number, centrosRecepcion: CentroRecepcionItem[]): Promise<any>;
    removeCentroRecepcion(idCentral: number, idCentroRecepcion: number): Promise<any>;
    getDepartamentos(idCentral: number): Promise<DepartamentoItem[]>;
    addDepartamentos(idCentral: number, departamentos: DepartamentoItem[]): Promise<any>;
    removeDepartamento(idCentral: number, idDepartamento: number): Promise<any>;
}
