"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
//Azteca Kernel
var core_2 = require("framework3/core");
//Locales
var central_1 = require("../models/central");
var CentralService = /** @class */ (function (_super) {
    __extends(CentralService, _super);
    function CentralService(http, context) {
        return _super.call(this, http, context, 'api/compras/centrales') || this;
    }
    CentralService.prototype.create = function () {
        return Promise.resolve(new central_1.CentralInfo());
    };
    CentralService.prototype.loadSecurityContext = function (idEmpresa) {
        var params = new http_1.HttpParams()
            .set('IdEmpresa', idEmpresa.toString());
        return this.apiService.get('load-security-context', params)
            .toPromise();
    };
    CentralService.prototype.loadListByUser = function (idSucursal) {
        var params = new http_1.HttpParams()
            .set('idSucursal', idSucursal.toString());
        return this.apiService.get('load-list', params)
            .toPromise();
    };
    CentralService.prototype.getMembers = function (idCentral) {
        var params = new http_1.HttpParams()
            .set('idCentral', idCentral.toString());
        return this.apiService.get('members', params)
            .toPromise();
    };
    CentralService.prototype.addMembers = function (idCentral, users) {
        var params = new http_1.HttpParams()
            .set('idCentral', idCentral.toString());
        return this.apiService.post('add-members', params, users)
            .toPromise();
    };
    CentralService.prototype.removeMember = function (idCentral, idUser) {
        var params = new http_1.HttpParams()
            .set('idCentral', idCentral.toString())
            .set('idUser', idUser.toString());
        return this.apiService.delete('remove-member', params)
            .toPromise();
    };
    //Centros recepcion
    CentralService.prototype.getCentrosRecepcion = function (idCentral) {
        var params = new http_1.HttpParams()
            .set('idCentral', idCentral.toString());
        return this.apiService.get('get-centros-recepcion', params)
            .toPromise();
    };
    CentralService.prototype.addCentrosRecepcion = function (idCentral, centrosRecepcion) {
        var params = new http_1.HttpParams()
            .set('idCentral', idCentral.toString());
        return this.apiService.post('add-centro-recepcion', params, centrosRecepcion)
            .toPromise();
    };
    CentralService.prototype.removeCentroRecepcion = function (idCentral, idCentroRecepcion) {
        var params = new http_1.HttpParams()
            .set('idCentral', idCentral.toString())
            .set('idCentroRecepcion', idCentroRecepcion.toString());
        return this.apiService.delete('remove-centro-recepcion', params)
            .toPromise();
    };
    //Departamentos
    CentralService.prototype.getDepartamentos = function (idCentral) {
        var params = new http_1.HttpParams()
            .set('idCentral', idCentral.toString());
        return this.apiService.get('get-central-departamentos', params)
            .toPromise();
    };
    CentralService.prototype.addDepartamentos = function (idCentral, departamentos) {
        var params = new http_1.HttpParams()
            .set('idCentral', idCentral.toString());
        return this.apiService.post('add-departamento', params, departamentos)
            .toPromise();
    };
    CentralService.prototype.removeDepartamento = function (idCentral, idDepartamento) {
        var params = new http_1.HttpParams()
            .set('idCentral', idCentral.toString())
            .set('idDepartamento', idDepartamento.toString());
        return this.apiService.delete('remove-departamento', params)
            .toPromise();
    };
    CentralService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], CentralService);
    return CentralService;
}(core_2.CatalogService));
exports.CentralService = CentralService;
