import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService } from 'framework3/core';
import { DepartamentoInfo, DepartamentoItem } from '../models/departamento';
import { UsuarioItem } from 'framework3/core';
import { CentroRecepcionItem } from '../models/centro-recepcion';
import { CategoriasPresupuestalesItem } from '../models/categorias-presupuestales';
export declare class DepartamentoService extends CatalogService<DepartamentoInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<DepartamentoInfo>;
    loadListByUser(idSucursal: number): Promise<DepartamentoItem[]>;
    loadListByCentralUser(idCentral: number, idSucursal: number): Promise<DepartamentoItem[]>;
    getMembers(idDepartamento: number): Promise<UsuarioItem[]>;
    addMembers(idDepartamento: number, users: UsuarioItem[]): Promise<any>;
    removeMember(idDepartamento: number, idUser: number): Promise<any>;
    getCentrosRecepcion(idDepartamento: number): Promise<CentroRecepcionItem[]>;
    addCentrosRecepcion(idDepartamento: number, centrosRecepcion: CentroRecepcionItem[]): Promise<any>;
    removeCentroRecepcion(idDepartamento: number, idCentroRecepcion: number): Promise<any>;
    getCategoriasPresupuestales(idDepartamento: number): Promise<CategoriasPresupuestalesItem[]>;
    addCategoriaPresupuestal(idDepartamento: number, categoriasPresupuestales: CategoriasPresupuestalesItem[]): Promise<any>;
    removeCategoriaPresupuestal(idDepartamento: number, idCategoriaPresupuestal: number): Promise<any>;
}
