import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, DocumentService, FileLink } from 'framework3/core';
import { OrdenInfo } from '../models/orden';
import { OrdenDetail, OrdenRequisicionDetail } from '../models/orden-detail';
import { ComprobanteFiscalInfo } from '../models/comprobante-fiscal';
export declare class OrdenService extends DocumentService<OrdenDetail, OrdenInfo> {
    protected http: HttpClient;
    protected context: Context;
    constructor(http: HttpClient, context: Context);
    create(): Promise<OrdenInfo>;
    update(info: OrdenInfo): Promise<OrdenInfo>;
    protected mapDocument(document: OrdenInfo): void;
    generarPdfOrden(idOrden: string): Promise<FileLink>;
    requisicionesPendientes(idCentral: number, fechaIni: Date, fechaFin: Date): Promise<OrdenRequisicionDetail[]>;
    generarDesdeRequisiciones(idCentralCompras: number, idDepartamento: number, idSucursal: number, idEmpresa: number, requisiciones: OrdenRequisicionDetail[]): Promise<boolean>;
    getComprobanteRelacionado(idOrden: string): Promise<ComprobanteFiscalInfo>;
}
