"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
//Azteca Framework
var core_2 = require("framework3/core");
//
var moment = require("moment");
//Locales
var orden_1 = require("../models/orden");
var inventory_1 = require("../../inventory");
var OrdenService = /** @class */ (function (_super) {
    __extends(OrdenService, _super);
    function OrdenService(http, context) {
        var _this = _super.call(this, http, context, 'api/compras/ordenes') || this;
        _this.http = http;
        _this.context = context;
        return _this;
    }
    OrdenService.prototype.create = function () {
        var newDoc = new orden_1.OrdenInfo();
        return Promise.resolve(newDoc);
    };
    OrdenService.prototype.update = function (info) {
        //Si no tiene asignado la empresa y sucursal, asignar la actual
        if (info.idSucursal == 0)
            info.idSucursal = this.context.app.defaultSite.identity;
        //Actualizar campo de cantidad basado en las propiedades auxiliares (solo para articulos)
        info.details.filter(function (detail) { return detail.idArticulo > 0; }).map(function (detail) { return detail; }).forEach(function (detail) {
            if (detail.unidadMedida.paquete && detail.unidadMedida.factor > 1) {
                var cantidad = new inventory_1.Empaquetado(detail.cantidad, detail.unidadMedida.factor, detail.unidades);
                detail.cantidad = cantidad.toDecimal();
            }
        });
        var params = new http_1.HttpParams();
        return this.apiService.post('save', params, info)
            .toPromise();
    };
    OrdenService.prototype.mapDocument = function (document) {
        document.details.filter(function (detail) { return detail.idArticulo > 0; }).map(function (detail) { return detail; }).forEach(function (detail) {
            //Si la unidad de medida es un paquete, separar unidades
            if (detail.unidadMedida.paquete && detail.unidadMedida.factor > 1) {
                var cantidad = new inventory_1.Empaquetado(detail.cantidad, detail.unidadMedida.factor);
                detail.cantidad = cantidad.paquetes;
                detail.unidades = cantidad.unidades;
            }
            else {
                detail.unidades = 0;
            }
        });
    };
    OrdenService.prototype.generarPdfOrden = function (idOrden) {
        var params = new http_1.HttpParams()
            .set("idOrden", idOrden);
        return this.apiService.get("pdf-orden", params)
            .toPromise();
    };
    OrdenService.prototype.requisicionesPendientes = function (idCentral, fechaIni, fechaFin) {
        var fi = moment(fechaIni).format();
        var ff = moment(fechaFin).format();
        var params = new http_1.HttpParams()
            .set("IdCentral", idCentral.toString())
            .set("FechaIni", fi)
            .set("FechaFin", ff);
        return this.apiService.get("requisiciones-pendientes", params)
            .toPromise();
    };
    OrdenService.prototype.generarDesdeRequisiciones = function (idCentralCompras, idDepartamento, idSucursal, idEmpresa, requisiciones) {
        var params = new http_1.HttpParams()
            .set("IdCentral", idCentralCompras.toString())
            .set("IdDepartamento", idDepartamento.toString())
            .set("IdSucursal", idSucursal.toString())
            .set("IdEmpresa", idEmpresa.toString());
        return this.apiService.post('generar-desde-requisiciones', params, requisiciones)
            .toPromise();
    };
    OrdenService.prototype.getComprobanteRelacionado = function (idOrden) {
        var params = new http_1.HttpParams()
            .set("idOrden", idOrden);
        return this.apiService.get("get-comprobante-relacionado", params)
            .toPromise();
    };
    OrdenService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], OrdenService);
    return OrdenService;
}(core_2.DocumentService));
exports.OrdenService = OrdenService;
