import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, DocumentService, FileLink } from 'framework3/core';
import { PresupuestosInfo, PresupuestosItem } from '../models/presupuestos';
import { PresupuestosDetail } from '../models/presupuestos-detail';
import { CategoriasPresupuestalesItem } from '../models/categorias-presupuestales';
export declare class PresupuestosService extends DocumentService<PresupuestosDetail, PresupuestosInfo> {
    protected http: HttpClient;
    protected context: Context;
    constructor(http: HttpClient, context: Context);
    create(): Promise<PresupuestosInfo>;
    loadPresupuestos(idDepartamento: number): Promise<PresupuestosItem[]>;
    unlock(idPresupuesto: string): Promise<any>;
    lock(idPresupuesto: string): Promise<any>;
    loadCategoriasConArticulo(idPresupuesto: string, idArticulo: number): Promise<CategoriasPresupuestalesItem[]>;
    loadCategoriasConServicio(idPresupuesto: string, idServicio: number): Promise<CategoriasPresupuestalesItem[]>;
    saveChange(presupuesto: PresupuestosInfo): Promise<void>;
    generarPdfImpresion(idPresupuesto: string): Promise<FileLink>;
}
