"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
//Azteca Framework
var core_2 = require("framework3/core");
//Locales
var presupuestos_1 = require("../models/presupuestos");
var PresupuestosService = /** @class */ (function (_super) {
    __extends(PresupuestosService, _super);
    function PresupuestosService(http, context) {
        var _this = _super.call(this, http, context, 'api/compras/presupuestos') || this;
        _this.http = http;
        _this.context = context;
        return _this;
    }
    PresupuestosService.prototype.create = function () {
        var newDoc = new presupuestos_1.PresupuestosInfo();
        return Promise.resolve(newDoc);
    };
    PresupuestosService.prototype.loadPresupuestos = function (idDepartamento) {
        var params = new http_1.HttpParams()
            .set('idDepartamento', idDepartamento.toString());
        return this.apiService.get('load-presupuestos', params)
            .toPromise();
    };
    PresupuestosService.prototype.unlock = function (idPresupuesto) {
        var params = new http_1.HttpParams()
            .set('IdPresupuesto', idPresupuesto);
        return this.apiService.post('unlock', params)
            .toPromise();
    };
    PresupuestosService.prototype.lock = function (idPresupuesto) {
        var params = new http_1.HttpParams()
            .set('IdPresupuesto', idPresupuesto);
        return this.apiService.post('lock', params)
            .toPromise();
    };
    PresupuestosService.prototype.loadCategoriasConArticulo = function (idPresupuesto, idArticulo) {
        var params = new http_1.HttpParams()
            .set('IdPresupuesto', idPresupuesto)
            .set('IdArticulo', idArticulo.toString());
        return this.apiService.get('load-categorias-presupuestales-con-articulo', params)
            .toPromise();
    };
    PresupuestosService.prototype.loadCategoriasConServicio = function (idPresupuesto, idServicio) {
        var params = new http_1.HttpParams()
            .set('IdPresupuesto', idPresupuesto)
            .set('IdServicio', idServicio.toString());
        return this.apiService.get('load-categorias-presupuestales-con-servicio', params)
            .toPromise();
    };
    PresupuestosService.prototype.saveChange = function (presupuesto) {
        var params = new http_1.HttpParams();
        return this.apiService.post('change', params, presupuesto)
            .toPromise();
    };
    PresupuestosService.prototype.generarPdfImpresion = function (idPresupuesto) {
        var params = new http_1.HttpParams()
            .set("idPresupuesto", idPresupuesto);
        return this.apiService.get("pdf-presupuesto", params)
            .toPromise();
    };
    PresupuestosService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], PresupuestosService);
    return PresupuestosService;
}(core_2.DocumentService));
exports.PresupuestosService = PresupuestosService;
