import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService, EmpresaItem } from 'framework3/core';
import { SearchResult, SearchRequest } from 'framework3/search';
import { ProveedorInfo, ProveedorServicio, ProveedorArticulo, PreRegistro } from '../models/proveedor';
import { PersonaInfo } from 'framework3/general';
export declare class ProveedorService extends CatalogService<ProveedorInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<ProveedorInfo>;
    enviarRegistro(idProveedor: number): Promise<any>;
    registrar(idProveedor: number, password: string): Promise<any>;
    getDetailByUser(idUsuario: number, idEmpresa: number): Promise<ProveedorInfo>;
    loadEmpresas(idUsuario: number): Promise<EmpresaItem[]>;
    updateProveedorArticulo(proveedorArticulo: ProveedorArticulo): Promise<boolean>;
    getDetailProveedorArticulo(idProveedorArticulo: number): Promise<ProveedorArticulo>;
    deleteProveedorArticulo(idProveedorArticulo: number): Promise<boolean>;
    searchProveedorByArticulo(idArticulo: number, idBranch: number, request: SearchRequest): Promise<SearchResult>;
    searchProveedorArticuloByZona(idZonaCompra: number, idBranch: number, request: SearchRequest): Promise<SearchResult>;
    searchProveedorByZona(idZonaCompra: number, idBranch: number, request: SearchRequest): Promise<SearchResult>;
    updateProveedorServicio(proveedorServicio: ProveedorServicio): Promise<boolean>;
    getDetailProveedorServicio(idProveedorServicio: number): Promise<ProveedorServicio>;
    deleteProveedorServicio(idProveedorServicio: number): Promise<boolean>;
    searchProveedorByServicio(idServicio: number, idBranch: number, request: SearchRequest): Promise<SearchResult>;
    searchProveedorServicioByZona(idZonaCompra: number, idBranch: number, request: SearchRequest): Promise<SearchResult>;
    registrarDePreregistro(idProveedor: number, password: string, idPreRegistro: number, correo: string): Promise<any>;
    preRegistroEliminar(idPreRegistro: number): Promise<any>;
    preRegistrar(preReg: PreRegistro): Promise<any>;
    preRegistros(): Promise<PreRegistro[]>;
    loadContactos(idProveedor: number): Promise<PersonaInfo[]>;
    addContacto(idProveedor: number, contacto: PersonaInfo): Promise<any>;
    removeContacto(idProveedor: number, idPersona: number): Promise<any>;
}
