"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
//Azteca Kernel
var core_2 = require("framework3/core");
//Locales
var proveedor_1 = require("../models/proveedor");
var ProveedorService = /** @class */ (function (_super) {
    __extends(ProveedorService, _super);
    function ProveedorService(http, context) {
        return _super.call(this, http, context, 'api/compras/proveedores') || this;
    }
    ProveedorService.prototype.create = function () {
        return Promise.resolve(new proveedor_1.ProveedorInfo());
    };
    ProveedorService.prototype.enviarRegistro = function (idProveedor) {
        var params = new http_1.HttpParams()
            .set('idProveedor', idProveedor.toString());
        return this.apiService.get('enviar-registro', params)
            .toPromise();
    };
    ProveedorService.prototype.registrar = function (idProveedor, password) {
        var params = new http_1.HttpParams()
            .set('idProveedor', idProveedor.toString())
            .set('password', password);
        return this.apiService.get('registrar', params)
            .toPromise();
    };
    ProveedorService.prototype.getDetailByUser = function (idUsuario, idEmpresa) {
        var params = new http_1.HttpParams()
            .set('idUsuario', idUsuario.toString())
            .set('idEmpresa', idEmpresa.toString());
        return this.apiService.get('detail-by-user', params)
            .toPromise();
    };
    ProveedorService.prototype.loadEmpresas = function (idUsuario) {
        var params = new http_1.HttpParams()
            .set('idUsuario', idUsuario.toString());
        return this.apiService.get('empresas', params)
            .toPromise();
    };
    //Administrar articulos
    ProveedorService.prototype.updateProveedorArticulo = function (proveedorArticulo) {
        var params = new http_1.HttpParams();
        return this.apiService.post('update-proveedor-articulo', params, proveedorArticulo)
            .toPromise();
    };
    ProveedorService.prototype.getDetailProveedorArticulo = function (idProveedorArticulo) {
        var params = new http_1.HttpParams()
            .set('idProveedorArticulo', idProveedorArticulo.toString());
        return this.apiService.get("get-detail-proveedor-articulo", params).toPromise();
    };
    ProveedorService.prototype.deleteProveedorArticulo = function (idProveedorArticulo) {
        var params = new http_1.HttpParams()
            .set('idProveedorArticulo', idProveedorArticulo.toString());
        return this.apiService.post("delete-proveedor-articulo", params).toPromise();
    };
    ProveedorService.prototype.searchProveedorByArticulo = function (idArticulo, idBranch, request) {
        var params = new http_1.HttpParams()
            .set('idArticulo', idArticulo.toString())
            .set('idBranch', idBranch.toString());
        return this.apiService.post('search-proveedor-articulo', params, request)
            .toPromise();
    };
    ProveedorService.prototype.searchProveedorArticuloByZona = function (idZonaCompra, idBranch, request) {
        var params = new http_1.HttpParams()
            .set('idZonaCompra', idZonaCompra.toString())
            .set('idBranch', idBranch.toString());
        return this.apiService.post('search-proveedor-articulo-by-zona', params, request).toPromise();
    };
    ProveedorService.prototype.searchProveedorByZona = function (idZonaCompra, idBranch, request) {
        var params = new http_1.HttpParams()
            .set('idZonaCompra', idZonaCompra.toString())
            .set('idBranch', idBranch.toString());
        return this.apiService.post('search-proveedor-by-zona', params, request).toPromise();
    };
    //Administrar servicios
    ProveedorService.prototype.updateProveedorServicio = function (proveedorServicio) {
        var params = new http_1.HttpParams();
        return this.apiService.post('update-proveedor-servicio', params, proveedorServicio) //falta
            .toPromise();
    };
    ProveedorService.prototype.getDetailProveedorServicio = function (idProveedorServicio) {
        var params = new http_1.HttpParams()
            .set('idProveedorServicio', idProveedorServicio.toString());
        return this.apiService.get("get-detail-proveedor-servicio", params).toPromise(); //falta
    };
    ProveedorService.prototype.deleteProveedorServicio = function (idProveedorServicio) {
        var params = new http_1.HttpParams()
            .set('idProveedorServicio', idProveedorServicio.toString());
        return this.apiService.post("delete-proveedor-servicio", params).toPromise();
    };
    ProveedorService.prototype.searchProveedorByServicio = function (idServicio, idBranch, request) {
        var params = new http_1.HttpParams()
            .set('idServicio', idServicio.toString())
            .set('idBranch', idBranch.toString());
        return this.apiService.post('search-proveedor-servicio', params, request)
            .toPromise();
    };
    ProveedorService.prototype.searchProveedorServicioByZona = function (idZonaCompra, idBranch, request) {
        var params = new http_1.HttpParams()
            .set('idZonaCompra', idZonaCompra.toString())
            .set('idBranch', idBranch.toString());
        return this.apiService.post('search-proveedor-servicio-by-zona', params, request).toPromise();
    };
    //Pre registro
    ProveedorService.prototype.registrarDePreregistro = function (idProveedor, password, idPreRegistro, correo) {
        var params = new http_1.HttpParams()
            .set('idProveedor', idProveedor.toString())
            .set('password', password)
            .set('idPreRegistro', idPreRegistro.toString())
            .set('correo', correo);
        return this.apiService.get('registrar-de-preregistro', params)
            .toPromise();
    };
    ProveedorService.prototype.preRegistroEliminar = function (idPreRegistro) {
        var params = new http_1.HttpParams()
            .set('idPreRegistro', idPreRegistro.toString());
        return this.apiService.post('pre-registro-delete', params)
            .toPromise();
    };
    ProveedorService.prototype.preRegistrar = function (preReg) {
        var params = new http_1.HttpParams();
        return this.apiService.post("pre-registrar", params, preReg)
            .toPromise();
    };
    ProveedorService.prototype.preRegistros = function () {
        var params = new http_1.HttpParams();
        return this.apiService.get('pre-registros', params)
            .toPromise();
    };
    ProveedorService.prototype.loadContactos = function (idProveedor) {
        var params = new http_1.HttpParams()
            .append("idProveedor", idProveedor.toString());
        return this.apiService.get("load-contactos", params)
            .toPromise();
    };
    ProveedorService.prototype.addContacto = function (idProveedor, contacto) {
        var params = new http_1.HttpParams()
            .set('idProveedor', idProveedor.toString());
        return this.apiService.post('add-contacto', params, contacto)
            .toPromise();
    };
    ProveedorService.prototype.removeContacto = function (idProveedor, idPersona) {
        var params = new http_1.HttpParams()
            .set('idProveedor', idProveedor.toString())
            .set('idPersona', idPersona.toString());
        return this.apiService.delete('remove-contacto', params)
            .toPromise();
    };
    ProveedorService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], ProveedorService);
    return ProveedorService;
}(core_2.CatalogService));
exports.ProveedorService = ProveedorService;
