import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService, UsuarioItem, CatalogItem } from 'framework3/core';
import { ZonaCompraInfo, ZonaCompraItem } from '../models/zona-compra';
import { SearchResult, SearchRequest } from 'framework3/search';
export declare class ZonaCompraService extends CatalogService<ZonaCompraInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<ZonaCompraInfo>;
    loadListByUser(idSucursal: number): Promise<ZonaCompraItem[]>;
    addUser(idZonaCompra: number, usuarios: UsuarioItem[]): Promise<any>;
    loadAccessUsersList(idZonaCompra: number): Promise<UsuarioItem[]>;
    removeUser(idZonaCompraAcceso: number): Promise<any>;
    searchKeyword2(idUsuario: number, idSucursal: number, keyword: string): Observable<CatalogItem[]>;
    loadRestriccionesCostos(): Promise<any[]>;
    search2(idBranch: number, request: SearchRequest): Promise<SearchResult>;
    hasAccess(idUsuario: number, idZonaCompra: number): Promise<boolean>;
}
