"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
//Azteca Kernel
var core_2 = require("framework3/core");
//Locales
var zona_compra_1 = require("../models/zona-compra");
var ZonaCompraService = /** @class */ (function (_super) {
    __extends(ZonaCompraService, _super);
    function ZonaCompraService(http, context) {
        return _super.call(this, http, context, 'api/compras/zonas-compra') || this;
    }
    ZonaCompraService.prototype.create = function () {
        return Promise.resolve(new zona_compra_1.ZonaCompraInfo());
    };
    ZonaCompraService.prototype.loadListByUser = function (idSucursal) {
        var params = new http_1.HttpParams()
            .set('idSucursal', idSucursal.toString());
        return this.apiService.get('load-list', params)
            .toPromise();
    };
    ZonaCompraService.prototype.addUser = function (idZonaCompra, usuarios) {
        var params = new http_1.HttpParams()
            .set('IdZonaCompra', idZonaCompra.toString());
        return this.apiService.post('add-user', params, usuarios)
            .toPromise();
    };
    ZonaCompraService.prototype.loadAccessUsersList = function (idZonaCompra) {
        var params = new http_1.HttpParams()
            .append("IdZonaCompra", idZonaCompra.toString());
        return this.apiService.get("load-access-users-list", params)
            .toPromise();
    };
    ZonaCompraService.prototype.removeUser = function (idZonaCompraAcceso) {
        var params = new http_1.HttpParams()
            .append("IdZonaCompraAcceso", idZonaCompraAcceso.toString());
        return this.apiService.post("remove-user", params)
            .toPromise();
    };
    ZonaCompraService.prototype.searchKeyword2 = function (idUsuario, idSucursal, keyword) {
        var params = new http_1.HttpParams()
            .append("idSucursal", idSucursal.toString())
            .append("idUsuario", idUsuario.toString())
            .append("keyword", keyword);
        return this.apiService.get("search-zona-compra", params);
    };
    ZonaCompraService.prototype.loadRestriccionesCostos = function () {
        var params = new http_1.HttpParams();
        return this.apiService.get("load-resticciones-costos", params)
            .toPromise();
    };
    ZonaCompraService.prototype.search2 = function (idBranch, request) {
        var params = new http_1.HttpParams()
            .set('idBranch', idBranch.toString());
        //
        return this.apiService.post('search2', params, request)
            .toPromise();
    };
    ZonaCompraService.prototype.hasAccess = function (idUsuario, idZonaCompra) {
        var params = new http_1.HttpParams()
            .set('idUsuario', idUsuario.toString())
            .set('idZonaCompra', idZonaCompra.toString());
        return this.apiService.get('has-access', params).toPromise();
    };
    ZonaCompraService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], ZonaCompraService);
    return ZonaCompraService;
}(core_2.CatalogService));
exports.ZonaCompraService = ZonaCompraService;
