"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
var wijmo_1 = require("wijmo/wijmo");
var menu_item_directive_1 = require("framework3/controls/directives/menu-item.directive");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
// wijmo
var wjcCore = require("wijmo/wijmo");
var wjcGridDetail = require("wijmo/wijmo.grid.detail");
var moment = require("moment");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var content_viewer_component_1 = require("framework3/controls/components/content-viewer.component");
//Features
var cedulafiniquito_service_1 = require("../services/cedulafiniquito.service");
var cedulafiniquito_1 = require("../models/cedulafiniquito");
var CedulasFiniquitosEditor = /** @class */ (function (_super) {
    __extends(CedulasFiniquitosEditor, _super);
    //
    function CedulasFiniquitosEditor(router, route, formBuilder, changeDetector, context, location, cedulaFiniquitoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.cedulaFiniquitoService = cedulaFiniquitoService;
        _this.cedulaFiniquito = new cedulafiniquito_1.CedulaFiniquitoInfo();
        _this.rescisionesLaborales = new Array();
        _this.calcularComision = false;
        _this.calcular = true;
        _this.timerInterval = null;
        _this.idConceptoParent = 0;
        _this.newCedulaConcepto = new cedulafiniquito_1.CedulaConcepto();
        _this.menuItemsConcepto = [];
        _this.tileDowmload = "";
        _this.nameDownload = "";
        _this.fechaAdeudo = new Date();
        _this.maxDate = new Date();
        _this.detailMode = wjcGridDetail.DetailVisibilityMode[wjcGridDetail.DetailVisibilityMode.ExpandSingle];
        _this.detailModeMulti = wjcGridDetail.DetailVisibilityMode[wjcGridDetail.DetailVisibilityMode.ExpandMulti];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'empleado': [''],
            'nombre': [''],
            'apPaterno': [''],
            'apMaterno': [''],
            'departamento': [''],
            'bodega': [''],
            'sindicalizado': [''],
            'fechaAntiguedad': [''],
            'ultimoDiaLaborado': [''],
            'fechaBaja': [''],
            'fechaUltimoAguinaldo': [''],
            'diasAguinaldoContrato': [''],
            'disfrutePrevioAguinaldo': [''],
            'primaVacacionalPendiente': [''],
            'pirmaVacExentaPagada': [''],
            'porcentajePrimaVacacional': [''],
            'diasVacacionesPendiente': [''],
            'diasVacacionesGeneradas': [''],
            'totalDiasVacaciones': [''],
            'porcentajePrimaAntiguedad': [''],
            'porcentajeVeinteDiasAnio': [''],
            'sueldoDiario': [''],
            'sueldoPromedio': [''],
            'sueldoDiarioIntegrado': [''],
            'ausentismo': [''],
            'sueldoDias': [''],
            'sueldoImporte': [''],
            'comisiones': [''],
            'incentivos': [''],
            'horasExtraImporte': [''],
            'primaVacacionalPendienteEntrega': [''],
            'primaDominicalNumDomingos': [''],
            'primaDominicalImporte': [''],
            'repartoUtilidades': [''],
            'diasNegociadoIndemnizacion': [''],
            'otros': [''],
            'salarioMinimoZonaNegosiacion': [''],
            'salarioMinimoZonaApoyo': [''],
            'idRescicionLaboral': [''],
            'comisionespagado': [''],
            'infonavit': [''],
            'fonacot': [''],
            'adeudo': [''],
            'importeNetoFiniquito': [''],
            'newConcepto': [''],
            'newCantidad': [''],
            'newImporteGravado': [''],
            'newImporteExento': [''],
            'newImporteTotal': [''],
            'primaVacacionalExento': ['']
        });
        return _this;
    }
    CedulasFiniquitosEditor_1 = CedulasFiniquitosEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    CedulasFiniquitosEditor.prototype.ngAfterViewInit = function () {
        _super.prototype.ngAfterViewInit.call(this);
        this.createMenu();
    };
    CedulasFiniquitosEditor.prototype.createMenu = function () {
        var mnuAgergar = { icon: "glyphicon glyphicon-plus", text: "Ageregar Adeudo", name: "AGREGAR_ADEUDO", smallText: "Agregar nuevo adeudo" };
        var mnuEliminar = { icon: "glyphicon glyphicon-minus", text: "Eliminar Adeudo", name: "ELIMINAR_ADEUDO", smallText: "Eliminar adeudo" };
        var mnuAgergarPercepcion = { icon: "glyphicon glyphicon-plus", text: "Ageregar Percepción", name: "AGREGAR_PERCEPCION", smallText: "Agregar nuevo adeudo" };
        var mnuEliminarPercepcion = { icon: "glyphicon glyphicon-minus", text: "Eliminar Percepción", name: "ELIMINAR_PERCEPCION", smallText: "Eliminar adeudo" };
        this.menuItemsConcepto.push(mnuAgergar);
        this.menuItemsConcepto.push(mnuEliminar);
        this.menuItemsConcepto.push(mnuAgergarPercepcion);
        this.menuItemsConcepto.push(mnuEliminarPercepcion);
        this.menuItemsConcepto.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    CedulasFiniquitosEditor.prototype.onMenuItemClicked = function (menu, args) {
        var item = this.menuItemsConcepto[menu.selectedIndex];
        if (item.name == "AGREGAR_ADEUDO") {
            this.idConceptoParent = 149;
            this.lastCedulaConcepto = this.conceptosPrevio.currentItem;
            this.conceptosPrevio.addNew();
            this.newCedulaConcepto.concepto = "";
            this.newCedulaConcepto.importeTotal = 0;
            this.dlgConcepto.config.backdrop = false;
            this.dlgConcepto.config.ignoreBackdropClick = true;
            this.dlgConcepto.show();
        }
        else if (item.name == "ELIMINAR_ADEUDO") {
            if (this.conceptosPrevio.currentItem.idParent == 149) {
                this.conceptosPrevio.currentItem.importeTotal = 0;
                this.cedulaFiniquito.eliminar.push(this.conceptosPrevio.currentItem);
                this.conceptosPrevio.remove(this.conceptosPrevio.currentItem);
                this.cedulaPrevioFiniquito();
            }
        }
        else if (item.name == "AGREGAR_PERCEPCION") {
            this.idConceptoParent = 159;
            this.lastCedulaConcepto = this.conceptosPrevio.currentItem;
            this.conceptosPrevio.addNew();
            this.newCedulaConcepto.concepto = "";
            this.newCedulaConcepto.importeTotal = 0;
            this.dlgConcepto.config.backdrop = false;
            this.dlgConcepto.config.ignoreBackdropClick = true;
            this.dlgConcepto.show();
        }
        else if (item.name == "ELIMINAR_PERCEPCION") {
            if (this.conceptosPrevio.currentItem.idParent == 159) {
                this.conceptosPrevio.currentItem.importeTotal = 0;
                this.cedulaFiniquito.eliminar.push(this.conceptosPrevio.currentItem);
                this.conceptosPrevio.remove(this.conceptosPrevio.currentItem);
                this.cedulaPrevioFiniquito();
            }
        }
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    CedulasFiniquitosEditor.prototype.onConfigureCatalog = function (options) {
        var _this = this;
        this.autogeneratedCode = options.codigoAutogenerado;
        this.cedulaFiniquitoService.loadRescisionesLaborales()
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.rescisionesLaborales = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CedulasFiniquitosEditor.prototype.onCreatingItem = function () {
    };
    CedulasFiniquitosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.cedulaFiniquitoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cedulaFiniquito = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CedulasFiniquitosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.cedulaFiniquitoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cedulaFiniquito = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CedulasFiniquitosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.cedulaFiniquitoService.getDetailByID(id)
            .then(function (info) {
            _this.calcular = false;
            _this.context.app.hideSpinner();
            _this.cedulaFiniquito = info;
            _this.conceptosCedulaNegosiacion = new wjcCore.CollectionView(_this.cedulaFiniquito.conceptosNegociacion);
            _this.conceptosCedulaNegosiacion.refresh();
            var cvn = _this.conceptosCedulaNegosiacion;
            cvn.beginUpdate();
            cvn.groupDescriptions.clear();
            var groupDesc = new wjcCore.PropertyGroupDescription("clasificacionConcepto.descripcion");
            cvn.groupDescriptions.push(groupDesc);
            cvn.refresh();
            cvn.endUpdate();
            cvn.refresh();
            _this.conceptosApoyo = new wjcCore.CollectionView(_this.cedulaFiniquito.conceptosApoyo);
            _this.conceptosApoyo.refresh();
            var cva = _this.conceptosApoyo;
            cva.beginUpdate();
            cva.groupDescriptions.clear();
            var groupDescApoyo = new wjcCore.PropertyGroupDescription("clasificacionConcepto.descripcion");
            cva.groupDescriptions.push(groupDescApoyo);
            cva.refresh();
            cva.endUpdate();
            cva.refresh();
            _this.conceptosIsr = new wjcCore.CollectionView(_this.cedulaFiniquito.conceptosIsr);
            _this.conceptosIsr.refresh();
            var cvIsr = _this.conceptosIsr;
            cvIsr.beginUpdate();
            cvIsr.groupDescriptions.clear();
            var groupDescIsr = new wjcCore.PropertyGroupDescription("clasificacionConcepto.descripcion");
            cvIsr.groupDescriptions.push(groupDescIsr);
            cvIsr.refresh();
            cvIsr.endUpdate();
            cvIsr.refresh();
            _this.conceptosPrevio = new wjcCore.CollectionView(_this.cedulaFiniquito.conceptosPrevio);
            _this.conceptosPrevio.refresh();
            var cvPrevio = _this.conceptosPrevio;
            cvPrevio.beginUpdate();
            cvPrevio.groupDescriptions.clear();
            var groupDescPrevio = new wjcCore.PropertyGroupDescription("clasificacionConcepto.descripcion");
            cvPrevio.groupDescriptions.push(groupDescPrevio);
            cvPrevio.refresh();
            cvPrevio.endUpdate();
            cvPrevio.refresh();
            _this.calcular = true;
            // Desencadenador
            _this.cedulaIsrPartesProporcionales();
            _this.cedulaDeduccionesIsr(5);
            _this.cedulaDeduccionesIsr(10);
            _this.calcularSeguros(4);
            _this.calcularSeguros(9);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CedulasFiniquitosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.cedulaPrevioFiniquito();
        this.context.app.showSpinner();
        this.cedulaFiniquitoService.update(this.cedulaFiniquito)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cedulaFiniquito = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CedulasFiniquitosEditor.prototype.onEmpleadoSelected = function (args) {
        if (this.cedulaFiniquito.identity == 0) {
            this.dlgConfigirmacionCalculo.config.backdrop = false;
            this.dlgConfigirmacionCalculo.config.ignoreBackdropClick = true;
            this.dlgConfigirmacionCalculo.show();
        }
    };
    CedulasFiniquitosEditor.prototype.loadIngresoInformacion = function (idEmpleado, comision) {
        var _this = this;
        if (this.cedulaFiniquito.identity == 0) {
            this.context.app.showSpinner();
            this.cedulaFiniquitoService.loadIngresoInformacion(idEmpleado, comision).then(function (info) {
                _this.cedulaFiniquito.empleado = info.empleado;
                _this.cedulaFiniquito.clase = info.clase;
                _this.cedulaFiniquito.departamento = info.departamento;
                _this.cedulaFiniquito.bodega = info.bodega;
                _this.cedulaFiniquito.puesto = info.puesto;
                _this.cedulaFiniquito.diasAguinaldoContrato = info.diasAguinaldoContrato;
                _this.cedulaFiniquito.aguinaldoSindicato = info.aguinaldoSindicato;
                _this.cedulaFiniquito.sindicalizado = info.sindicalizado;
                if (_this.cedulaFiniquito.sindicalizado) {
                    _this.cedulaFiniquito.diasAguinaldoContrato = info.aguinaldoSindicato;
                }
                _this.cedulaFiniquito.fechaAntiguedad = moment(info.fechaAntiguedad).toDate();
                _this.cedulaFiniquito.fechaUltimoAguinaldo = moment(info.fechaUltimoAguinaldo).toDate();
                _this.cedulaFiniquito.ultimoDiaLaborado = moment(info.ultimoDiaLaborado).toDate();
                _this.cedulaFiniquito.fechaBaja = moment(info.fechaBaja).toDate();
                _this.cedulaFiniquito.disfrutePrevioAguinaldo = info.disfrutePrevioAguinaldo;
                _this.cedulaFiniquito.pirmaVacExentaPagada = info.pirmaVacExentaPagada;
                _this.cedulaFiniquito.primaVacacionalPendiente = info.primaVacacionalPendiente;
                _this.cedulaFiniquito.porcentajePrimaVacacional = info.porcentajePrimaVacacional;
                _this.cedulaFiniquito.diasVacacionesPendiente = info.diasVacacionesPendiente;
                _this.cedulaFiniquito.diasVacacionesGeneradas = info.diasVacacionesGeneradas;
                _this.cedulaFiniquito.porcentajePrimaAntiguedad = info.porcentajePrimaAntiguedad;
                _this.cedulaFiniquito.porcentajeVeinteDiasAnio = info.porcentajeVeinteDiasAnio;
                _this.cedulaFiniquito.sueldoDiario = info.sueldoDiario;
                _this.cedulaFiniquito.sueldoPromedio = info.sueldoPromedio;
                _this.cedulaFiniquito.sueldoDiarioIntegrado = info.sueldoDiarioIntegrado;
                _this.cedulaFiniquito.ausentismo = info.ausentismo;
                _this.cedulaFiniquito.sueldoDias = info.sueldoDias;
                _this.cedulaFiniquito.sueldoImporte = info.sueldoImporte;
                _this.cedulaFiniquito.comisiones = info.comisiones;
                _this.cedulaFiniquito.incentivos = info.incentivos;
                _this.cedulaFiniquito.horasExtraImporte = info.horasExtraImporte;
                _this.cedulaFiniquito.primaVacacionalPendienteEntrega = info.primaVacacionalPendienteEntrega;
                _this.cedulaFiniquito.primaDominicalNumDomingos = info.primaDominicalNumDomingos;
                _this.cedulaFiniquito.primaDominicalImporte = info.primaDominicalImporte;
                _this.cedulaFiniquito.repartoUtilidades = info.repartoUtilidades;
                _this.cedulaFiniquito.diasNegociadoIndemnizacion = info.diasNegociadoIndemnizacion;
                _this.cedulaFiniquito.indemnnizacionAdicional = info.indemnnizacionAdicional;
                _this.cedulaFiniquito.otros = info.otros;
                _this.cedulaFiniquito.salarioMinimoZona = info.salarioMinimoZona;
                _this.cedulaFiniquito.uma = info.uma;
                _this.cedulaFiniquito.conceptosNegociacion = info.conceptosNegociacion;
                _this.cedulaFiniquito.conceptosApoyo = info.conceptosApoyo;
                _this.cedulaFiniquito.conceptosIsr = info.conceptosIsr;
                _this.cedulaFiniquito.idRescicionLaboral = info.idRescicionLaboral;
                _this.cedulaFiniquito.seguros = info.seguros;
                _this.cedulaFiniquito.conceptosPrevio = info.conceptosPrevio;
                _this.cedulaFiniquito.tarifasPagosProvicionales = info.tarifasPagosProvicionales;
                _this.cedulaFiniquito.subsidiosEmpleo = info.subsidiosEmpleo;
                _this.cedulaFiniquito.idTaskComision = info.idTaskComision;
                _this.cedulaFiniquito.infonavit = info.infonavit;
                _this.cedulaFiniquito.fonacot = info.fonacot;
                _this.cedulaFiniquito.autoriza = info.autoriza;
                _this.cedulaFiniquito.infonavitOrFonacot = info.infonavitOrFonacot;
                _this.cedulaFiniquito.periodoPago = info.periodoPago;
                _this.cedulaFiniquito.adeudo = info.adeudo;
                _this.cedulaFiniquito.variables = info.variables;
                _this.cedulaFiniquito.primaVacacionalExento = info.primaVacacionalExento;
                _this.conceptosCedulaNegosiacion = new wjcCore.CollectionView(_this.cedulaFiniquito.conceptosNegociacion);
                _this.conceptosCedulaNegosiacion.refresh();
                var cvn = _this.conceptosCedulaNegosiacion;
                cvn.beginUpdate();
                cvn.groupDescriptions.clear();
                var groupDesc = new wjcCore.PropertyGroupDescription("clasificacionConcepto.descripcion");
                cvn.groupDescriptions.push(groupDesc);
                cvn.refresh();
                cvn.endUpdate();
                cvn.refresh();
                _this.conceptosApoyo = new wjcCore.CollectionView(_this.cedulaFiniquito.conceptosApoyo);
                _this.conceptosApoyo.refresh();
                var cva = _this.conceptosApoyo;
                cva.beginUpdate();
                cva.groupDescriptions.clear();
                var groupDescApoyo = new wjcCore.PropertyGroupDescription("clasificacionConcepto.descripcion");
                cva.groupDescriptions.push(groupDescApoyo);
                cva.refresh();
                cva.endUpdate();
                cva.refresh();
                _this.conceptosIsr = new wjcCore.CollectionView(_this.cedulaFiniquito.conceptosIsr);
                _this.conceptosIsr.refresh();
                var cvIsr = _this.conceptosIsr;
                cvIsr.beginUpdate();
                cvIsr.groupDescriptions.clear();
                var groupDescIsr = new wjcCore.PropertyGroupDescription("clasificacionConcepto.descripcion");
                cvIsr.groupDescriptions.push(groupDescIsr);
                cvIsr.refresh();
                cvIsr.endUpdate();
                cvIsr.refresh();
                _this.conceptosPrevio = new wjcCore.CollectionView(_this.cedulaFiniquito.conceptosPrevio);
                _this.conceptosPrevio.refresh();
                var cvPrevio = _this.conceptosPrevio;
                cvPrevio.beginUpdate();
                cvPrevio.groupDescriptions.clear();
                var groupDescPrevio = new wjcCore.PropertyGroupDescription("clasificacionConcepto.descripcion");
                cvPrevio.groupDescriptions.push(groupDescPrevio);
                cvPrevio.refresh();
                cvPrevio.endUpdate();
                cvPrevio.refresh();
                if (_this.timerInterval != null)
                    clearInterval(_this.timerInterval);
                if (_this.cedulaFiniquito.idTaskComision > 0) {
                    _this.timerInterval = setInterval(function () {
                        _this.verificarTaskComision();
                    }, 3000);
                }
                else {
                    _this.context.app.hideSpinner();
                }
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    CedulasFiniquitosEditor.prototype.onCambioSindicalizado = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.sindicalizado = args;
        if (this.cedulaFiniquito.sindicalizado) {
            this.cedulaFiniquito.diasAguinaldoContrato = this.cedulaFiniquito.clase.aguinaldoSindicato;
        }
        else {
            this.cedulaFiniquito.diasAguinaldoContrato = this.cedulaFiniquito.clase.aguinaldo;
        }
    };
    CedulasFiniquitosEditor.prototype.onSeleccionRescision = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.idRescicionLaboral = args;
        this.cedulaConceptoPrimaAntiguedad(3);
        this.cedulaConceptoPrimaAntiguedad(8);
        this.cedulaConceptoIndeminzacionLeyDiasAnio(3);
        this.cedulaConceptoIndeminzacionLeyDiasAnio(8);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(3);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(8);
        this.cedulaConceptoTotalPagosSeparacion();
        this.cedulaIsrInjustificado();
        this.cedulaConceptoTotalPagosSeparacionInjust();
        this.cedulaIsrJustificado();
        this.cedulaIsrPercepcionesAdeudadas();
        this.cedulaPrevioFiniquito();
    };
    CedulasFiniquitosEditor.prototype.onCambioFechaAntiguedad = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.fechaAntiguedad = args;
        this.cedulaConceptoPrimaAntiguedad(3);
        this.cedulaConceptoPrimaAntiguedad(8);
        this.cedulaConceptoIndeminzacionLeyDiasAnio(3);
        this.cedulaConceptoIndeminzacionLeyDiasAnio(8);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(3);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(8);
    };
    CedulasFiniquitosEditor.prototype.onCambioUltimoDiaLaborado = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.ultimoDiaLaborado = args;
        this.cedulaConceptoAguinaldo(2);
        this.cedulaConceptoAguinaldo(7);
        this.cedulaConceptoPrimaAntiguedad(3);
        this.cedulaConceptoPrimaAntiguedad(8);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(3);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(8);
    };
    CedulasFiniquitosEditor.prototype.onCambioFechaBaja = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.fechaBaja = args;
        this.cedulaConceptoAguinaldo(2);
        this.cedulaConceptoAguinaldo(7);
        this.cedulaConceptoPrimaAntiguedad(3);
        this.cedulaConceptoPrimaAntiguedad(8);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(3);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(8);
    };
    CedulasFiniquitosEditor.prototype.onCambioFechaUltimoAguinaldo = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.fechaUltimoAguinaldo = args;
        this.cedulaConceptoAguinaldo(2);
        this.cedulaConceptoAguinaldo(7);
        this.cedulaConceptoPrimaAntiguedad(3);
        this.cedulaConceptoPrimaAntiguedad(8);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(3);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(8);
    };
    CedulasFiniquitosEditor.prototype.onCambioDiasAguinaldoContrato = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.diasAguinaldoContrato = args;
        this.cedulaConceptoAguinaldo(2);
        this.cedulaConceptoAguinaldo(7);
    };
    CedulasFiniquitosEditor.prototype.onCambioDisfrutePrevioAguinaldo = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.disfrutePrevioAguinaldo = args;
        this.cedulaConceptoAguinaldo(2);
        this.cedulaConceptoAguinaldo(7);
    };
    CedulasFiniquitosEditor.prototype.onCambioPrimaVacacionalPendiente = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.primaVacacionalPendiente = args;
        this.cedulaConceptoPrimaVacacional(2);
        this.cedulaConceptoPrimaVacacional(7);
    };
    CedulasFiniquitosEditor.prototype.onCambioPirmaVacExentaPagada = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.pirmaVacExentaPagada = args;
        this.cedulaConceptoPrimaVacacional(2);
        this.cedulaConceptoPrimaVacacional(7);
    };
    CedulasFiniquitosEditor.prototype.onCambioPorcentajePrimaVacacional = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.porcentajePrimaVacacional = args;
        this.cedulaConceptoPrimaVacacional(2);
        this.cedulaConceptoPrimaVacacional(7);
        this.cedulaConceptoPrimaAntiguedad(3);
        this.cedulaConceptoPrimaAntiguedad(8);
    };
    CedulasFiniquitosEditor.prototype.onCambioVacacionesPendiente = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.diasVacacionesPendiente = args;
        this.cedulaFiniquito.totalDiasVacaciones = this.cedulaFiniquito.diasVacacionesGeneradas + args;
    };
    CedulasFiniquitosEditor.prototype.onCambioVacacionesGeneradas = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.diasVacacionesGeneradas = args;
        this.cedulaFiniquito.totalDiasVacaciones = this.cedulaFiniquito.diasVacacionesPendiente + args;
        this.cedulaConceptoPrimaVacacional(2);
        this.cedulaConceptoPrimaVacacional(7);
    };
    CedulasFiniquitosEditor.prototype.onCambioTotalDiasVacaciones = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.totalDiasVacaciones = args;
        this.cedulaConceptoVacaciones(2);
        this.cedulaConceptoVacaciones(7);
        this.cedulaConceptoPrimaVacacional(2);
        this.cedulaConceptoPrimaVacacional(7);
    };
    CedulasFiniquitosEditor.prototype.onCambioPorcentajePrimaAntiguedad = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.porcentajePrimaAntiguedad = args;
        this.cedulaConceptoPrimaAntiguedad(3);
        this.cedulaConceptoPrimaAntiguedad(8);
        this.cedulaConceptoIndeminzacionLeyDiasAnio(3);
        this.cedulaConceptoIndeminzacionLeyDiasAnio(8);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(3);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(8);
        this.cedulaConceptoTotalPagosSeparacion();
        this.cedulaIsrInjustificado();
        this.cedulaConceptoTotalPagosSeparacionInjust();
        this.cedulaIsrJustificado();
        this.cedulaIsrPercepcionesAdeudadas();
        this.cedulaPrevioFiniquito();
    };
    CedulasFiniquitosEditor.prototype.onCambioPorcentajeVeinteDiasAnio = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.porcentajeVeinteDiasAnio = args;
        this.cedulaConceptoIndeminzacionLeyDiasAnio(3);
        this.cedulaConceptoIndeminzacionLeyDiasAnio(8);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(3);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(8);
        this.cedulaDeduccionesIsr(5);
        this.cedulaDeduccionesIsr(10);
        this.calcularSeguros(4);
        this.calcularSeguros(9);
    };
    CedulasFiniquitosEditor.prototype.onCambioSueldoDiario = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.sueldoDiario = args;
        this.cedulaConceptoIndeminzacionAdicionalAcordada(3);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(8);
        this.cedulaIsrSueldoMensualOrdinario();
    };
    CedulasFiniquitosEditor.prototype.onCambioSueldoPromedio = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.sueldoPromedio = args;
        this.cedulaConceptoAguinaldo(2);
        this.cedulaConceptoAguinaldo(7);
        this.cedulaConceptoVacaciones(2);
        this.cedulaConceptoVacaciones(7);
        this.cedulaConceptoPrimaVacacional(2);
        this.cedulaConceptoPrimaVacacional(7);
        this.cedulaConceptoAdeudoSueldo(1);
        this.cedulaConceptoAdeudoSueldo(6);
        this.cedulaConceptoHorasExtra(1);
        this.cedulaConceptoHorasExtra(6);
        this.cedulaConceptoPrimaAntiguedad(3);
        this.cedulaConceptoPrimaAntiguedad(8);
        this.cedulaConceptoIndeminzacionLeyDiasAnio(3);
        this.cedulaConceptoIndeminzacionLeyDiasAnio(8);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(3);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(8);
        this.cedulaConceptoIndeminzacionLeyDias(3);
        this.cedulaConceptoIndeminzacionLeyDias(8);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(3);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(8);
        this.cedulaIsrSueldoMensualOrdinario();
    };
    CedulasFiniquitosEditor.prototype.onCambioSueldoDiarioIntegrado = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.sueldoDiarioIntegrado = args;
        this.cedulaInfonavitFonacot();
        this.cedulaIsrSueldoMensualOrdinario();
    };
    CedulasFiniquitosEditor.prototype.onCambioAusentismo = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.ausentismo = args;
        this.cedulaConceptoAguinaldo(2);
        this.cedulaConceptoAguinaldo(7);
    };
    CedulasFiniquitosEditor.prototype.onCambioSueldoDias = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.sueldoDias = args;
        // Calculos que depende del concepto
        this.cedulaInfonavitFonacot();
        this.cedulaConceptoAdeudoSueldo(1);
        this.cedulaConceptoAdeudoSueldo(6);
        this.cedulaConceptoHorasExtra(1);
        this.cedulaConceptoHorasExtra(6);
        this.cedulaIsrPartesProporcionales();
        this.cedulaIsrInjustificado();
        this.cedulaIsrJustificado();
        this.cedulaIsrPercepcionesAdeudadas();
    };
    CedulasFiniquitosEditor.prototype.onCambioSueldoImporte = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.sueldoImporte = args;
        this.cedulaConceptoAdeudoSueldo(1);
        this.cedulaConceptoAdeudoSueldo(6);
        this.cedulaConceptoHorasExtra(1);
        this.cedulaConceptoHorasExtra(6);
    };
    CedulasFiniquitosEditor.prototype.onCambioComisiones = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.comisiones = args;
        this.cedulaConceptoComisiones(1);
        this.cedulaConceptoComisiones(6);
    };
    CedulasFiniquitosEditor.prototype.onCambioIncentivos = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.incentivos = args;
        this.cedulaConceptoIncentivos(1);
        this.cedulaConceptoIncentivos(6);
    };
    CedulasFiniquitosEditor.prototype.onCambioHorasExtraImporte = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.horasExtraImporte = args;
        this.cedulaConceptoHorasExtra(1);
        this.cedulaConceptoHorasExtra(6);
    };
    CedulasFiniquitosEditor.prototype.onCambioPrimaVacacionalPendienteEntrega = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.primaVacacionalPendienteEntrega = args;
        this.cedulaConceptoPrimaVacacional(2);
        this.cedulaConceptoPrimaVacacional(7);
    };
    CedulasFiniquitosEditor.prototype.onCambioNumDomingos = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.primaDominicalNumDomingos = args;
        this.cedulaConceptoPrimaDominical(2);
        this.cedulaConceptoPrimaDominical(7);
        this.calcularSeguros(4);
        this.calcularSeguros(9);
    };
    CedulasFiniquitosEditor.prototype.onCambioPrimaDominicalImporte = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.primaDominicalImporte = args;
        this.cedulaConceptoPrimaDominical(2);
        this.cedulaConceptoPrimaDominical(7);
        this.calcularSeguros(4);
        this.calcularSeguros(9);
    };
    CedulasFiniquitosEditor.prototype.onCambioRepartoUtilidades = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.repartoUtilidades = args;
        this.cedulaConceptoRepartoUtilidades(1);
        this.cedulaConceptoRepartoUtilidades(6);
    };
    CedulasFiniquitosEditor.prototype.onCambioDiasNegociadosIndemnizacion = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.diasNegociadoIndemnizacion = args;
        this.cedulaConceptoIndeminzacionLeyDias(3);
        this.cedulaConceptoIndeminzacionLeyDias(8);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(3);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(8);
        this.calcularSeguros(4);
        this.calcularSeguros(9);
    };
    CedulasFiniquitosEditor.prototype.onCambioIndemnizacionAdicional = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.indemnnizacionAdicional = args;
        this.cedulaConceptoIndeminzacionLeyDias(3);
        this.cedulaConceptoIndeminzacionLeyDias(8);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(3);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(8);
        this.calcularSeguros(4);
        this.calcularSeguros(9);
    };
    CedulasFiniquitosEditor.prototype.onCambioOtros = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.otros = args;
        this.cedulaConceptoIndeminzacionLeyDias(3);
        this.cedulaConceptoIndeminzacionLeyDias(8);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(3);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(8);
        this.cedulaConceptoOtros(1);
        this.cedulaConceptoOtros(6);
    };
    CedulasFiniquitosEditor.prototype.onCambioSalarioMinimoZona = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.salarioMinimoZona = args;
        this.onCambioIndemnizacionAdicional(this.cedulaFiniquito.indemnnizacionAdicional);
        this.cedulaConceptoHorasExtra(1);
        this.cedulaConceptoHorasExtra(6);
        this.cedulaConceptoRepartoUtilidades(1);
        this.cedulaConceptoRepartoUtilidades(6);
        this.cedulaConceptoOtros(1);
        this.cedulaConceptoOtros(6);
        this.cedulaConceptoAguinaldo(2);
        this.cedulaConceptoAguinaldo(7);
        this.cedulaConceptoPrimaDominical(2);
        this.cedulaConceptoPrimaDominical(7);
        this.cedulaConceptoPrimaVacacional(2);
        this.cedulaConceptoPrimaVacacional(7);
        this.cedulaConceptoPrimaAntiguedad(3);
        this.cedulaConceptoPrimaAntiguedad(8);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(3);
        this.cedulaConceptoIndeminzacionAdicionalAcordada(8);
        this.calcularSeguros(4);
        this.calcularSeguros(9);
        this.cedulaIsrPartesProporcionales();
        this.cedulaConceptoTotalPagosSeparacion();
        this.cedulaIsrInjustificado();
        this.cedulaConceptoTotalPagosSeparacionInjust();
        this.cedulaIsrJustificado();
        this.calcularSeguros(4);
        this.calcularSeguros(9);
    };
    CedulasFiniquitosEditor.prototype.onCambioInfonavit = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.infonavit = args;
        this.calcularImporteAdeudo(4);
        this.calcularImporteAdeudo(9);
        this.calcularSeguros(4);
        this.calcularSeguros(9);
        this.cedulaPrevioFiniquito();
    };
    CedulasFiniquitosEditor.prototype.onCambioFonacot = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.fonacot = args;
        this.calcularImporteAdeudo(4);
        this.calcularImporteAdeudo(9);
        this.calcularSeguros(4);
        this.calcularSeguros(9);
        this.cedulaPrevioFiniquito();
    };
    CedulasFiniquitosEditor.prototype.onCambioAdeudo = function (args) {
        if (!this.calcular)
            return;
        this.cedulaFiniquito.adeudo = args;
        this.calcularImporteAdeudo(4);
        this.calcularImporteAdeudo(9);
        this.calcularSeguros(4);
        this.calcularSeguros(9);
        this.cedulaPrevioFiniquito();
    };
    CedulasFiniquitosEditor.prototype.consultarCalculo = function (calcular) {
        this.loadIngresoInformacion(this.cedulaFiniquito.idEmpleado, calcular);
        this.dlgConfigirmacionCalculo.hide();
    };
    CedulasFiniquitosEditor.prototype.onConceptoCancelar = function () {
        this.dlgConcepto.hide();
        this.conceptosPrevio.cancelEdit();
        this.conceptosPrevio.cancelNew();
    };
    CedulasFiniquitosEditor.prototype.onConceptoAgregar = function () {
        var _this = this;
        this.dlgConcepto.hide();
        this.conceptosPrevio.currentItem.concepto = this.newCedulaConcepto.concepto;
        this.conceptosPrevio.currentItem.idClasificacionConcepto = this.lastCedulaConcepto.idClasificacionConcepto;
        this.conceptosPrevio.currentItem.cantidad = this.newCedulaConcepto.cantidad;
        this.conceptosPrevio.currentItem.importeGravado = this.newCedulaConcepto.importeGravado;
        this.conceptosPrevio.currentItem.importeExento = this.newCedulaConcepto.importeExento;
        this.conceptosPrevio.currentItem.importeTotal = this.newCedulaConcepto.importeTotal;
        this.conceptosPrevio.currentItem.idParent = this.idConceptoParent; // Conxepto de adedos.
        this.conceptosPrevio.currentItem.acumula = this.conceptosPrevio.currentItem.acumula;
        this.cedulaFiniquito.conceptosPrevio.forEach(function (element) {
            if (element.idConcepto == _this.idConceptoParent) {
                _this.conceptosPrevio.currentItem.clasificacionConcepto = element.clasificacionConcepto;
            }
        });
        this.conceptosPrevio.commitEdit();
        this.conceptosPrevio.commitNew();
        this.conceptosPrevio.refresh();
        this.cedulaPrevioFiniquito();
    };
    /**
    * Calcula el concepto de adeudo sueldo
    *
    * @param {number} idClasificacion - La clasificación determina si son los conceptos de (2) negosiacion o (7) negosiación
    */
    CedulasFiniquitosEditor.prototype.cedulaConceptoAdeudoSueldo = function (idClasificacion) {
        var concepto = this.getConcepto(idClasificacion, "Adeudo de Sueldo");
        if (idClasificacion == 1) {
            if (this.cedulaFiniquito.sueldoImporte > 0) {
                concepto.cantidad = (this.cedulaFiniquito.sueldoImporte / this.cedulaFiniquito.sueldoPromedio);
            }
            else {
                concepto.cantidad = this.cedulaFiniquito.sueldoDias;
            }
            if (this.cedulaFiniquito.sueldoImporte > 0) {
                concepto.importeTotal = this.cedulaFiniquito.sueldoImporte;
            }
            else {
                concepto.importeTotal = concepto.cantidad * this.cedulaFiniquito.sueldoDiario;
            }
            concepto.importeGravado = concepto.importeTotal;
        }
        else if (idClasificacion == 6) {
            concepto.cantidad = (this.cedulaFiniquito.sueldoDias);
            concepto.importeTotal = concepto.cantidad * this.cedulaFiniquito.sueldoDiario;
            concepto.importeGravado = concepto.importeTotal;
        }
        // Calculos que depende del concepto
        this.cedulaIsrPartesProporcionales();
        this.cedulaIsrInjustificado();
        this.cedulaIsrJustificado();
        this.cedulaIsrPercepcionesAdeudadas();
    };
    /**
    * Calcula las concepto de comisiones
    * @param {number} idClasificacion - La clasificación determina si son los conceptos de (1) negociacion o (6) apoyo
    */
    CedulasFiniquitosEditor.prototype.cedulaConceptoComisiones = function (idClasificacion) {
        var concepto = this.getConcepto(idClasificacion, "Comisiones");
        concepto.importeTotal = (this.cedulaFiniquito.comisiones);
        concepto.importeGravado = concepto.importeTotal;
        // Calculos que depende del concepto
        this.cedulaIsrPartesProporcionales();
        this.cedulaIsrInjustificado();
        this.cedulaIsrJustificado();
        this.cedulaIsrPercepcionesAdeudadas();
    };
    /**
    * Calcula las concepto de incentivos
    * @param {number} idClasificacion - La clasificación determina si son los conceptos de (1) negociacion o (6) apoyo
    */
    CedulasFiniquitosEditor.prototype.cedulaConceptoIncentivos = function (idClasificacion) {
        var concepto = this.getConcepto(idClasificacion, "Incentivos");
        concepto.importeTotal = this.cedulaFiniquito.incentivos;
        concepto.importeGravado = concepto.importeTotal;
        // Calculos que depende del concepto
        this.cedulaIsrPartesProporcionales();
        this.cedulaIsrInjustificado();
        this.cedulaIsrJustificado();
        this.cedulaIsrPercepcionesAdeudadas();
    };
    /**
    * Calcula las concepto de Horas Extra
    * @param {number} idClasificacion - La clasificación determina si son los conceptos de (1) negociacion o (6) apoyo
    */
    CedulasFiniquitosEditor.prototype.cedulaConceptoHorasExtra = function (idClasificacion) {
        var concepto = this.getConcepto(idClasificacion, "Horas Extra (Importe)");
        var conceptoAdeudo = this.getConcepto(idClasificacion, "Adeudo de Sueldo");
        concepto.importeTotal = this.cedulaFiniquito.horasExtraImporte;
        if (concepto.importeTotal > 0) {
            concepto.importeExento = this.cedulaFiniquito.salarioMinimoZona * 5 * (conceptoAdeudo.cantidad == 0 ? 0 : ((conceptoAdeudo.cantidad / 7) < 1 ? 1 : Math.round(conceptoAdeudo.cantidad / 7)));
        }
        else {
            concepto.importeExento = 0;
        }
        concepto.importeGravado = concepto.importeTotal - concepto.importeExento;
        // Calculos que depende del concepto
        this.cedulaIsrPartesProporcionales();
        this.cedulaIsrInjustificado();
        this.cedulaIsrJustificado();
        this.cedulaIsrPercepcionesAdeudadas();
    };
    /**
    * Calcula las concepto de Reparto de Utilidades
    * @param {number} idClasificacion - La clasificación determina si son los conceptos de (1) negociacion o (6) apoyo
    */
    CedulasFiniquitosEditor.prototype.cedulaConceptoRepartoUtilidades = function (idClasificacion) {
        var concepto = this.getConcepto(idClasificacion, "Reparto Utilidades");
        concepto.importeTotal = this.cedulaFiniquito.repartoUtilidades;
        if (concepto.importeTotal > 0) {
            if (concepto.importeTotal < (this.cedulaFiniquito.salarioMinimoZona * 15)) {
                concepto.importeExento = concepto.importeTotal;
            }
            else {
                concepto.importeExento = (this.cedulaFiniquito.salarioMinimoZona * 15);
            }
        }
        else {
            concepto.importeExento = 0;
        }
        concepto.importeGravado = concepto.importeTotal - concepto.importeExento;
        // Calculos que depende del concepto
        this.cedulaIsrPartesProporcionales();
        this.cedulaIsrInjustificado();
        this.cedulaIsrJustificado();
        this.cedulaIsrPercepcionesAdeudadas();
    };
    /**
    * Calculo del concepto Otros (En otros todo es gravado)
    * @param {number} idClasificacion - La clasificación determina si son los conceptos de (1) negociacion o (6) apoyo
    */
    CedulasFiniquitosEditor.prototype.cedulaConceptoOtros = function (idClasificacion) {
        var concepto = this.getConcepto(idClasificacion, "Otros");
        concepto.importeTotal = this.cedulaFiniquito.otros;
        concepto.importeGravado = this.cedulaFiniquito.otros;
        // Calculos que depende del concepto
        this.cedulaIsrPartesProporcionales();
        this.cedulaIsrInjustificado();
        this.cedulaIsrJustificado();
        this.cedulaIsrPercepcionesAdeudadas();
    };
    /**
    * Calcula el concepto de aguninaldo
    *
    * @param {number} idClasificacion - La clasificación determina si son los conceptos de (2) negosiacion o (7) negosiación
    */
    CedulasFiniquitosEditor.prototype.cedulaConceptoAguinaldo = function (idClasificacion) {
        var concepto = this.getConcepto(idClasificacion, "Aguinaldo");
        if (idClasificacion == 2) {
            if (this.cedulaFiniquito.disfrutePrevioAguinaldo) {
                concepto.cantidad = 0;
            }
            else {
                var dias = (this.getDaysBetweenTwoDates(this.cedulaFiniquito.ultimoDiaLaborado, this.cedulaFiniquito.fechaUltimoAguinaldo) + 1) + (this.cedulaFiniquito.ausentismo) * -1;
                dias = dias / 365;
                dias = dias * this.cedulaFiniquito.diasAguinaldoContrato;
                concepto.cantidad = (dias);
            }
        }
        else if (idClasificacion == 7) {
            if (this.cedulaFiniquito.disfrutePrevioAguinaldo) {
                concepto.cantidad = 0;
            }
            else {
                concepto.cantidad = (((this.getDaysBetweenTwoDates(this.cedulaFiniquito.ultimoDiaLaborado, this.cedulaFiniquito.fechaUltimoAguinaldo) - (this.cedulaFiniquito.ausentismo)) / 365) * this.cedulaFiniquito.diasAguinaldoContrato);
            }
        }
        concepto.importeTotal = (concepto.cantidad * this.cedulaFiniquito.sueldoPromedio);
        if (this.cedulaFiniquito.uma * 30 < concepto.importeTotal) {
            concepto.importeGravado = (concepto.importeTotal - (this.cedulaFiniquito.uma * 30));
        }
        else {
            concepto.importeGravado = 0;
        }
        if (concepto.importeTotal < (this.cedulaFiniquito.uma * 30)) {
            concepto.importeExento = concepto.importeTotal;
        }
        else {
            concepto.importeExento = (this.cedulaFiniquito.uma * 30);
        }
        this.cedulaIsrPartesProporcionales();
    };
    /**
    * Calcula el concepto de vacaciones
    *
    * @param {number} idClasificacion - La clasificación determina si son los conceptos de (2) negosiacion o (7) negosiación
    */
    CedulasFiniquitosEditor.prototype.cedulaConceptoVacaciones = function (idClasificacion) {
        var concepto = this.getConcepto(idClasificacion, "Vacaciones");
        concepto.cantidad = this.cedulaFiniquito.totalDiasVacaciones;
        concepto.importeTotal = (concepto.cantidad) * this.cedulaFiniquito.sueldoPromedio;
        concepto.importeGravado = (concepto.importeTotal);
        this.cedulaIsrPartesProporcionales();
    };
    /**
    * Calcula el concepto de Prima Dominical
    *
    * @param {number} idClasificacion - La clasificación determina si son los conceptos de (2) negosiacion o (7) negosiación
    */
    CedulasFiniquitosEditor.prototype.cedulaConceptoPrimaDominical = function (idClasificacion) {
        var concepto = this.getConcepto(idClasificacion, "Prima Dominical");
        concepto.cantidad = this.cedulaFiniquito.primaDominicalNumDomingos;
        concepto.importeTotal = this.cedulaFiniquito.primaDominicalImporte;
        if (concepto.cantidad == 0) {
            concepto.importeExento = 0;
        }
        else {
            concepto.importeExento = concepto.importeTotal <= this.cedulaFiniquito.uma * concepto.cantidad ? concepto.importeTotal : this.cedulaFiniquito.uma * concepto.cantidad;
        }
        concepto.importeGravado = concepto.importeTotal - concepto.importeExento;
    };
    /**
    * Calcula el concepto de Prima Vacacional
    *
    * @param {number} idClasificacion - La clasificación determina si son los conceptos de (2) negosiacion o (7) apoyo previo finiquito
    */
    CedulasFiniquitosEditor.prototype.cedulaConceptoPrimaVacacional = function (idClasificacion) {
        var concepto = this.getConcepto(idClasificacion, "Prima Vacacional");
        var conceptoVacaciones = this.getConcepto(idClasificacion, "Vacaciones");
        var importeExento = ((this.cedulaFiniquito.uma * 15) - this.cedulaFiniquito.pirmaVacExentaPagada) < 0 ? 0 : (this.cedulaFiniquito.uma * 15) - this.cedulaFiniquito.pirmaVacExentaPagada;
        if (idClasificacion == 2) {
            if (this.cedulaFiniquito.primaVacacionalPendiente) {
                concepto.cantidad = conceptoVacaciones.cantidad * (this.cedulaFiniquito.porcentajePrimaVacacional / 100);
            }
            else {
                concepto.cantidad = this.cedulaFiniquito.diasVacacionesGeneradas * (this.cedulaFiniquito.porcentajePrimaVacacional / 100);
            }
        }
        else if (idClasificacion == 7) {
            concepto.cantidad = (conceptoVacaciones.cantidad) * 0.5;
        }
        concepto.importeTotal = concepto.cantidad * this.cedulaFiniquito.sueldoPromedio;
        if (importeExento >= concepto.importeTotal) {
            concepto.importeExento = concepto.importeTotal;
        }
        else {
            concepto.importeExento = importeExento;
        }
        concepto.importeGravado = concepto.importeTotal - concepto.importeExento;
        this.cedulaIsrPartesProporcionales();
    };
    /**
    * Calcula el concepto de Prima Antiguedad
    *
    * @param {number} idClasificacion - La clasificación determina si son los conceptos de (3) negosiacion o (8) negosiación
    */
    CedulasFiniquitosEditor.prototype.cedulaConceptoPrimaAntiguedad = function (idClasificacion) {
        var concepto = this.getConcepto(idClasificacion, "Prima Antigüedad");
        var topeSueldo = 0;
        var sueldoMinimoZona = this.cedulaFiniquito.salarioMinimoZona;
        if (this.cedulaFiniquito.sueldoPromedio > sueldoMinimoZona * 2) {
            topeSueldo = sueldoMinimoZona * 2;
        }
        else if (this.cedulaFiniquito.sueldoPromedio < sueldoMinimoZona * 2 && this.cedulaFiniquito.sueldoPromedio > sueldoMinimoZona) {
            topeSueldo = this.cedulaFiniquito.sueldoPromedio;
        }
        else {
            topeSueldo = sueldoMinimoZona;
        }
        if (idClasificacion == 3) {
            if (this.cedulaFiniquito.idRescicionLaboral == 2 || this.cedulaFiniquito.idRescicionLaboral == 3 || this.getDaysBetweenTwoDates(this.cedulaFiniquito.ultimoDiaLaborado, this.cedulaFiniquito.fechaAntiguedad) >= 5465) {
                concepto.cantidad = (this.getDaysBetweenTwoDates(this.cedulaFiniquito.ultimoDiaLaborado, this.cedulaFiniquito.fechaAntiguedad) + 1) / 365;
                concepto.cantidad = concepto.cantidad > Math.round(concepto.cantidad) ? concepto.cantidad : Math.round(concepto.cantidad);
            }
            else {
                concepto.cantidad = 0;
            }
        }
        else if (idClasificacion == 8) {
            var cantidadCalculo = ((this.getDaysBetweenTwoDates(this.cedulaFiniquito.ultimoDiaLaborado, this.cedulaFiniquito.fechaAntiguedad) + 1) / 365);
            concepto.cantidad = (cantidadCalculo > Math.round(cantidadCalculo) ? cantidadCalculo : Math.round(cantidadCalculo)) * (this.cedulaFiniquito.porcentajePrimaAntiguedad / 100);
        }
        concepto.importeTotal = concepto.cantidad * topeSueldo * 12;
        // Calculos que depende del concepto
        this.cedulaIsrPartesProporcionales();
        this.cedulaGravadoVsExento(idClasificacion);
        this.cedulaConceptoTotalPagosSeparacion();
        this.cedulaIsrInjustificado();
        this.cedulaConceptoTotalPagosSeparacionInjust();
        this.cedulaIsrJustificado();
    };
    /**
    * Calcula el concepto de Indemnizacion Ley(20d x Año)
    *
    * @param {number} idClasificacion - La clasificación determina si son los conceptos de (3) negosiacion o (8) negosiación
    */
    CedulasFiniquitosEditor.prototype.cedulaConceptoIndeminzacionLeyDiasAnio = function (idClasificacion) {
        var concepto = this.getConcepto(idClasificacion, "Indemnización Ley (20d x Año)");
        if (idClasificacion == 3) {
            if (this.cedulaFiniquito.idRescicionLaboral == 3) {
                concepto.cantidad = ((this.getDaysBetweenTwoDates(this.cedulaFiniquito.ultimoDiaLaborado, this.cedulaFiniquito.fechaAntiguedad) + 1) / 365) * 20 * (this.cedulaFiniquito.porcentajeVeinteDiasAnio / 100);
            }
            else {
                concepto.cantidad = 0;
            }
            concepto.importeTotal = concepto.cantidad * this.cedulaFiniquito.sueldoPromedio;
        }
        else {
            concepto.cantidad = ((this.getDaysBetweenTwoDates(this.cedulaFiniquito.ultimoDiaLaborado, this.cedulaFiniquito.fechaAntiguedad) + 1) / 365) * 20 * (this.cedulaFiniquito.porcentajeVeinteDiasAnio / 100);
            concepto.importeTotal = concepto.cantidad * this.cedulaFiniquito.sueldoPromedio;
        }
        // Calculos que depende del concepto
        this.cedulaGravadoVsExento(idClasificacion);
        this.cedulaIsrPartesProporcionales();
        this.cedulaConceptoTotalPagosSeparacion();
        this.cedulaIsrInjustificado();
        this.cedulaConceptoTotalPagosSeparacionInjust();
        this.cedulaIsrJustificado();
    };
    /**
    * Calcula el concepto de Indemnizacion Ley(Días)
    *
    * @param {number} idClasificacion - La clasificación determina si son los conceptos de (3) negosiacion o (8) negosiación
    */
    CedulasFiniquitosEditor.prototype.cedulaConceptoIndeminzacionLeyDias = function (idClasificacion) {
        var concepto = this.getConcepto(idClasificacion, "Indemnización Ley (Días)");
        concepto.cantidad = this.cedulaFiniquito.diasNegociadoIndemnizacion;
        concepto.importeTotal = concepto.cantidad * this.cedulaFiniquito.sueldoPromedio;
        // Calculos que depende del concepto
        this.cedulaGravadoVsExento(idClasificacion);
        this.cedulaIsrPartesProporcionales();
        this.cedulaConceptoTotalPagosSeparacion();
        this.cedulaIsrInjustificado();
        this.cedulaConceptoTotalPagosSeparacionInjust();
        this.cedulaIsrJustificado();
    };
    /**
    * Calcula el concepto de Indemnizacion Adicional Acordada
    *
    * @param {number} idClasificacion - La clasificación determina si son los conceptos de (3) negosiacion o (8) negosiación
    */
    CedulasFiniquitosEditor.prototype.cedulaConceptoIndeminzacionAdicionalAcordada = function (idClasificacion) {
        var concepto = this.getConcepto(idClasificacion, "Indemnización Adicional Acordada");
        var conceptoIndemnizacionLeyDias = this.getConcepto(idClasificacion, "Indemnización Ley (Días)");
        concepto.importeTotal = this.cedulaFiniquito.indemnnizacionAdicional;
        concepto.cantidad = concepto.importeTotal / this.cedulaFiniquito.sueldoDiario;
        // Calculos que depende del concepto
        this.cedulaGravadoVsExento(idClasificacion);
        this.cedulaConceptoTotalPagosSeparacion();
        this.cedulaIsrPartesProporcionales();
        this.cedulaIsrInjustificado();
        this.cedulaConceptoTotalPagosSeparacionInjust();
        this.cedulaIsrJustificado();
    };
    CedulasFiniquitosEditor.prototype.cedulaGravadoVsExento = function (idClasificacion) {
        var antiguedad = (this.getDaysBetweenTwoDates(this.cedulaFiniquito.ultimoDiaLaborado, this.cedulaFiniquito.fechaAntiguedad) + 1) / 365.0;
        //antiguedad = parseInt(antiguedad.toFixed(0));
        var totalExento = this.cedulaFiniquito.uma * 90 * Math.round(antiguedad);
        var conceptoPrimaAntiguedad = this.getConcepto(idClasificacion, "Prima Antigüedad");
        var conceptoIndemnizacion = this.getConcepto(idClasificacion, "Indemnización Ley (20d x Año)");
        var conceptoIndemnizacionDias = this.getConcepto(idClasificacion, "Indemnización Ley (Días)");
        var conceptoIndemnizacionAdicional = this.getConcepto(idClasificacion, "Indemnización Adicional Acordada");
        // Prima de antigüedad
        if (conceptoPrimaAntiguedad.importeTotal > totalExento) {
            conceptoPrimaAntiguedad.importeGravado = conceptoPrimaAntiguedad.importeTotal - totalExento;
            conceptoPrimaAntiguedad.importeExento = totalExento;
            totalExento = 0;
        }
        else if (conceptoPrimaAntiguedad.importeTotal <= totalExento) {
            conceptoPrimaAntiguedad.importeGravado = 0;
            conceptoPrimaAntiguedad.importeExento = conceptoPrimaAntiguedad.importeTotal;
            totalExento = totalExento - conceptoPrimaAntiguedad.importeTotal;
        }
        // Indemnización Ley (20d x Año)
        if (conceptoIndemnizacion.importeTotal > totalExento) {
            conceptoIndemnizacion.importeGravado = conceptoIndemnizacion.importeTotal - totalExento;
            conceptoIndemnizacion.importeExento = totalExento;
            totalExento = 0;
        }
        else if (conceptoIndemnizacion.importeTotal <= totalExento) {
            conceptoIndemnizacion.importeGravado = 0;
            conceptoIndemnizacion.importeExento = conceptoIndemnizacion.importeTotal;
            totalExento = totalExento - conceptoIndemnizacion.importeTotal;
        }
        // Indemnización Ley (Días)
        if (this.cedulaFiniquito.idRescicionLaboral != 4) {
            if (conceptoIndemnizacionDias.importeTotal > totalExento) {
                conceptoIndemnizacionDias.importeGravado = conceptoIndemnizacionDias.importeTotal - totalExento;
                conceptoIndemnizacionDias.importeExento = totalExento;
                totalExento = 0;
            }
            else if (conceptoIndemnizacionDias.importeTotal <= totalExento) {
                conceptoIndemnizacionDias.importeGravado = 0;
                conceptoIndemnizacionDias.importeExento = conceptoIndemnizacionDias.importeTotal;
                totalExento = totalExento - conceptoIndemnizacionDias.importeTotal;
            }
        }
        // Indemnización Adicional Acordada
        if (conceptoIndemnizacionAdicional.importeTotal > totalExento) {
            conceptoIndemnizacionAdicional.importeGravado = conceptoIndemnizacionAdicional.importeTotal - totalExento;
            conceptoIndemnizacionAdicional.importeExento = totalExento;
            totalExento = 0;
        }
        else if (conceptoIndemnizacionAdicional.importeTotal <= totalExento) {
            conceptoIndemnizacionAdicional.importeGravado = 0;
            conceptoIndemnizacionAdicional.importeExento = conceptoIndemnizacionAdicional.importeTotal;
            totalExento = totalExento - conceptoIndemnizacionAdicional.importeTotal;
        }
    };
    /**
     * Actualiza el ISR
     * @param idClasificacion
     */
    CedulasFiniquitosEditor.prototype.cedulaDeduccionesIsr = function (idClasificacion) {
        var conceptoIsrPartesProporcionales = this.getConcepto(idClasificacion, "ISR a Retener Partes Proporcionales");
        var conceptoIsrPagosSeparacion = this.getConcepto(idClasificacion, "ISR a Retener Pagos Separación");
        conceptoIsrPartesProporcionales.importeTotal = this.getConcepto(14, "Impuesto a Cargo").importeTotal;
        if (idClasificacion == 5) {
            conceptoIsrPagosSeparacion.importeTotal = this.getConcepto(3, "Total Pagos Separación").importeGravado * (this.getConcepto(11, 'Tasa Efectiva Impuesto Separación').importeTotal / 100);
        }
        else {
            conceptoIsrPagosSeparacion.importeTotal = this.getConcepto(8, "Total Pagos Separación Injust").importeGravado * (this.getConcepto(11, 'Tasa Efectiva Impuesto Separación').importeTotal / 100);
        }
    };
    CedulasFiniquitosEditor.prototype.calcularSeguros = function (idClasificacion) {
        var sdi = this.cedulaFiniquito.sueldoDiarioIntegrado;
        var smdf = this.cedulaFiniquito.salarioMinimoZona;
        var total = 0;
        for (var _i = 0, _a = this.cedulaFiniquito.seguros; _i < _a.length; _i++) {
            var seguro = _a[_i];
            seguro.dias = this.cedulaFiniquito.sueldoDias;
            if (seguro.seguro == "Prov. TRAB ENF Y MAT E3") {
                seguro.calculo = ((sdi - (smdf * 3)) * seguro.dias) * (seguro.porcentaje / 100);
            }
            else {
                seguro.calculo = ((sdi * seguro.dias) * (seguro.porcentaje / 100));
            }
            total += seguro.calculo;
        }
        var conceptoImssRetener = this.getConcepto(idClasificacion, "IMSS a Retener");
        conceptoImssRetener.importeTotal = total;
        var conceptoImporteNeto = this.getConcepto(idClasificacion, "Importe Neto Finiquito");
        if (idClasificacion == 4) {
            conceptoImporteNeto.importeTotal = (this.getImporteTotal(1) + this.getImporteTotal(2) + this.getConcepto(3, "Total Pagos Separación").importeTotal) - this.getImporteTotal(5) - this.getConcepto(4, 'IMSS a Retener').importeTotal - this.getConcepto(4, 'Importe Adeudos').importeTotal;
        }
        else if (idClasificacion == 9) {
            conceptoImporteNeto.importeTotal = (this.getImporteTotal(6) + this.getImporteTotal(7) + this.getConcepto(8, "Total Pagos Separación Injust").importeTotal) - this.getImporteTotal(10) - this.getConcepto(9, 'IMSS a Retener').importeTotal - this.getConcepto(9, 'Importe Adeudos').importeTotal;
        }
    };
    /**
    * ISR Mensual Ordinario - Sueldo Mensual Ordinario
    */
    CedulasFiniquitosEditor.prototype.calcularImporteAdeudo = function (idClasificacion) {
        var concepto = this.getConcepto(idClasificacion, "Importe Adeudos");
        concepto.importeTotal = this.cedulaFiniquito.adeudo + this.cedulaFiniquito.infonavit + this.cedulaFiniquito.fonacot;
    };
    /**
     * Calcula el concepto de Total Pagos Separación
     */
    CedulasFiniquitosEditor.prototype.cedulaConceptoTotalPagosSeparacion = function () {
        var concepto = this.getConcepto(3, "Total Pagos Separación");
        concepto.importeTotal = 0;
        var conceptoPrimaAntiguedad = this.getConcepto(3, "Prima Antigüedad");
        var conceptoIndemnizacion = this.getConcepto(3, "Indemnización Ley (20d x Año)");
        var conceptoIddemnizacionLey = this.getConcepto(3, "Indemnización Ley (Días)");
        var conceptoIddemnizacionAdicional = this.getConcepto(3, "Indemnización Adicional Acordada");
        concepto.importeTotal = conceptoPrimaAntiguedad.importeTotal + conceptoIndemnizacion.importeTotal + conceptoIddemnizacionLey.importeTotal + conceptoIddemnizacionAdicional.importeTotal;
        concepto.importeGravado = conceptoPrimaAntiguedad.importeGravado + conceptoIndemnizacion.importeGravado + conceptoIddemnizacionLey.importeGravado + conceptoIddemnizacionAdicional.importeGravado;
        concepto.importeExento = conceptoPrimaAntiguedad.importeExento + conceptoIndemnizacion.importeExento + conceptoIddemnizacionLey.importeExento + conceptoIddemnizacionAdicional.importeExento;
    };
    /**
     * Calcula el concepto de Total Pagos Separación (Injust, Negocia)
     */
    CedulasFiniquitosEditor.prototype.cedulaConceptoTotalPagosSeparacionInjust = function () {
        var conceptoInjust = this.getConcepto(8, "Total Pagos Separación Injust");
        var conceptoNegocia = this.getConcepto(8, "Total Pagos Separación Negocia");
        conceptoInjust.importeTotal = 0;
        conceptoNegocia.importeTotal = 0;
        var conceptoPrimaAntiguedad = this.getConcepto(8, "Prima Antigüedad");
        var conceptoIndemnizacion = this.getConcepto(8, "Indemnización Ley (20d x Año)");
        var conceptoIddemnizacionLey = this.getConcepto(8, "Indemnización Ley (Días)");
        var conceptoIddemnizacionAdicional = this.getConcepto(8, "Indemnización Adicional Acordada");
        conceptoInjust.importeTotal = conceptoPrimaAntiguedad.importeTotal + conceptoIndemnizacion.importeTotal + conceptoIddemnizacionLey.importeTotal + conceptoIddemnizacionAdicional.importeTotal;
        conceptoNegocia.importeTotal = conceptoPrimaAntiguedad.importeTotal + conceptoIddemnizacionAdicional.importeTotal;
        conceptoInjust.importeGravado = conceptoPrimaAntiguedad.importeGravado + conceptoIndemnizacion.importeGravado + conceptoIddemnizacionLey.importeGravado + conceptoIddemnizacionAdicional.importeGravado;
        conceptoNegocia.importeGravado = conceptoPrimaAntiguedad.importeGravado + conceptoIddemnizacionAdicional.importeGravado;
        conceptoInjust.importeExento = conceptoPrimaAntiguedad.importeExento + conceptoIndemnizacion.importeExento + conceptoIddemnizacionLey.importeExento + conceptoIddemnizacionAdicional.importeExento;
        conceptoNegocia.importeExento = conceptoPrimaAntiguedad.importeExento + conceptoIddemnizacionAdicional.importeExento;
    };
    /**
    * ISR Mensual Ordinario - Sueldo Mensual Ordinario
    */
    CedulasFiniquitosEditor.prototype.cedulaIsrSueldoMensualOrdinario = function () {
        var conceptoSueldoMensualOrdinario = this.getConcepto(11, "Sueldo Mensual Ordinario");
        var conceptoImporteExento = this.getConcepto(11, "ImporteExento");
        var conceptoBaseImpuesto = this.getConcepto(11, "Base Impuesto");
        var conceptoLimiteInferior = this.getConcepto(11, "Limite Inferior");
        var conceptoExcente = this.getConcepto(11, "Excente L.I.");
        var conceptoPorcentajeExc = this.getConcepto(11, "% s/ Exc L.I.");
        var conceptoImptoSinExc = this.getConcepto(11, "Impto s/ Exc L.I");
        var conceptoCuotaFija = this.getConcepto(11, "Cuota Fija");
        var conceptoImpuestoBruto = this.getConcepto(11, "Impuesto Bruto");
        var conceptoImpuestoNeto = this.getConcepto(11, "Impuesto Neto");
        var conceptoTasaEfectiva = this.getConcepto(11, "Tasa Efectiva Impuesto Separación");
        conceptoSueldoMensualOrdinario.importeTotal = this.cedulaFiniquito.sueldoDiario * 30;
        conceptoBaseImpuesto.importeTotal = conceptoSueldoMensualOrdinario.importeTotal - conceptoImporteExento.importeTotal;
        var self = this;
        if (this.cedulaFiniquito.empleado.idCompania != undefined) {
            var infoTarifa = this.getTarifaPagoProvicional(conceptoBaseImpuesto.importeTotal);
            conceptoLimiteInferior.importeTotal = infoTarifa != null ? infoTarifa.limiteInferior : 0;
            conceptoExcente.importeTotal = conceptoBaseImpuesto.importeTotal - conceptoLimiteInferior.importeTotal;
            conceptoPorcentajeExc.importeTotal = infoTarifa != null ? infoTarifa.porcentaje : 0;
            conceptoImptoSinExc.importeTotal = conceptoExcente.importeTotal * (conceptoPorcentajeExc.importeTotal / 100);
            conceptoCuotaFija.importeTotal = infoTarifa != null ? infoTarifa.cuotaFija : 0;
            conceptoImpuestoBruto.importeTotal = conceptoImptoSinExc.importeTotal + conceptoCuotaFija.importeTotal;
            conceptoImpuestoNeto.importeTotal = conceptoImpuestoBruto.importeTotal;
            conceptoTasaEfectiva.importeTotal = (conceptoImpuestoNeto.importeTotal / conceptoBaseImpuesto.importeTotal) * 100;
        }
        // Desencadenador
        this.cedulaIsrPartesProporcionales();
        this.cedulaDeduccionesIsr(5);
        this.cedulaDeduccionesIsr(10);
        this.calcularSeguros(4);
        this.calcularSeguros(9);
        if (this.conceptosIsr != undefined)
            this.conceptosIsr.refresh();
    };
    CedulasFiniquitosEditor.prototype.cedulaIsrInjustificado = function () {
        var conceptoBaseImpuesto = this.getConcepto(12, "Base Impuesto");
        var conceptoLimiteInferior = this.getConcepto(12, "Limite Inferior");
        var conceptoExcente = this.getConcepto(12, "Excente L.I.");
        var conceptoPorcentajeExc = this.getConcepto(12, "% s/ Exc L.I.");
        var conceptoImptoSinExc = this.getConcepto(12, "Impto s/ Exc L.I");
        var conceptoCuotaFija = this.getConcepto(12, "Cuota Fija");
        var conceptoImpuestoBruto = this.getConcepto(12, "Impuesto Bruto");
        var conceptoSubsidio = this.getConcepto(12, "Subsidio");
        var conceptoImpuestoNeto = this.getConcepto(12, "Impuesto Neto");
        var conceptoTotalPagoSeparacion = this.getConcepto(3, "Total Pagos Separación");
        conceptoBaseImpuesto.importeTotal = conceptoTotalPagoSeparacion.importeGravado + this.getImporteGravado(1);
        if (this.cedulaFiniquito.empleado.idCompania != undefined) {
            var infoTarifa = this.getTarifaPagoProvicional(conceptoBaseImpuesto.importeTotal);
            conceptoLimiteInferior.importeTotal = infoTarifa != null ? infoTarifa.limiteInferior : 0;
            conceptoExcente.importeTotal = conceptoBaseImpuesto.importeTotal - conceptoLimiteInferior.importeTotal;
            conceptoPorcentajeExc.importeTotal = infoTarifa != null ? infoTarifa.porcentaje : 0;
            conceptoImptoSinExc.importeTotal = conceptoExcente.importeTotal * (conceptoPorcentajeExc.importeTotal / 100);
            conceptoCuotaFija.importeTotal = infoTarifa != null ? infoTarifa.cuotaFija : 0;
            conceptoImpuestoBruto.importeTotal = conceptoImptoSinExc.importeTotal + conceptoCuotaFija.importeTotal;
            conceptoImpuestoNeto.importeTotal = conceptoImpuestoBruto.importeTotal;
            // Se solicita descartar el subsidio.
            //let infoSubsidio: SubsidioEmpleo = this.getSubsidioEmpleo(conceptoBaseImpuesto.importeTotal);
            //conceptoSubsidio.importeTotal = infoSubsidio != null ? infoSubsidio.subsidio : 0;
            conceptoSubsidio.importeTotal = 0;
            if (conceptoBaseImpuesto.importeTotal == 0) {
                conceptoImpuestoNeto.importeTotal = 0;
            }
            else {
                conceptoImpuestoNeto.importeTotal = conceptoImpuestoBruto.importeTotal;
            }
        }
        this.cedulaDeduccionesIsr(5);
        this.cedulaDeduccionesIsr(10);
        this.calcularSeguros(4);
        this.calcularSeguros(9);
        if (this.conceptosIsr != undefined)
            this.conceptosIsr.refresh();
    };
    CedulasFiniquitosEditor.prototype.cedulaIsrJustificado = function () {
        var conceptoBaseImpuesto = this.getConcepto(13, "Base Impuesto");
        var conceptoLimiteInferior = this.getConcepto(13, "Limite Inferior");
        var conceptoExcente = this.getConcepto(13, "Excente L.I.");
        var conceptoPorcentajeExc = this.getConcepto(13, "% s/ Exc L.I.");
        var conceptoImptoSinExc = this.getConcepto(13, "Impto s/ Exc L.I");
        var conceptoCuotaFija = this.getConcepto(13, "Cuota Fija");
        var conceptoImpuestoBruto = this.getConcepto(13, "Impuesto Bruto");
        var conceptoSubsidio = this.getConcepto(13, "Subsidio");
        var conceptoImpuestoNeto = this.getConcepto(13, "Impuesto Neto");
        var totalPercepcionAdeudada = this.getImporteGravado(6);
        var totalPagosSeparacionNegocia = this.getConcepto(8, 'Total Pagos Separación Negocia').importeGravado;
        conceptoBaseImpuesto.importeTotal = totalPercepcionAdeudada + totalPagosSeparacionNegocia;
        if (this.cedulaFiniquito.empleado.idCompania != undefined) {
            var infoTarifa = this.getTarifaPagoProvicional(conceptoBaseImpuesto.importeTotal);
            conceptoLimiteInferior.importeTotal = infoTarifa != null ? infoTarifa.limiteInferior : 0;
            conceptoExcente.importeTotal = conceptoBaseImpuesto.importeTotal - conceptoLimiteInferior.importeTotal;
            conceptoPorcentajeExc.importeTotal = infoTarifa != null ? infoTarifa.porcentaje : 0;
            conceptoImptoSinExc.importeTotal = conceptoExcente.importeTotal * (conceptoPorcentajeExc.importeTotal / 100);
            conceptoCuotaFija.importeTotal = infoTarifa != null ? infoTarifa.cuotaFija : 0;
            conceptoImpuestoBruto.importeTotal = conceptoImptoSinExc.importeTotal + conceptoCuotaFija.importeTotal;
            conceptoImpuestoNeto.importeTotal = conceptoImpuestoBruto.importeTotal;
            // Solicitan descartar subsidio
            //let infoSubsidio: SubsidioEmpleo = this.getSubsidioEmpleo(conceptoBaseImpuesto.importeTotal);
            //conceptoSubsidio.importeTotal = infoSubsidio != null ? infoSubsidio.subsidio : 0;
            conceptoSubsidio.importeTotal = 0;
            if (conceptoBaseImpuesto.importeTotal == 0) {
                conceptoImpuestoNeto.importeTotal = 0;
            }
            else {
                conceptoImpuestoNeto.importeTotal = conceptoImpuestoBruto.importeTotal;
            }
            if (this.conceptosIsr != undefined)
                this.conceptosIsr.refresh();
        }
    };
    // Calculo ISR
    CedulasFiniquitosEditor.prototype.cedulaIsrPartesProporcionales = function () {
        var conceptoAdeudoSueldo = this.getConcepto(14, "Adeudo de sueldo");
        var conceptoComisiones = this.getConcepto(14, "Comisiones");
        var conceptoIncentivos = this.getConcepto(14, "Incentivos");
        var conceptoHorasExtra = this.getConcepto(14, "Horas Extra");
        var conceptoOtros = this.getConcepto(14, "Otros");
        var conceptoTotalPartesProporcional = this.getConcepto(14, "Total Partes Proporcionales");
        var conceptoBaseGravable = this.getConcepto(14, "Base Gravable");
        var conceptoLimiteInferior = this.getConcepto(14, "Limite Inferior");
        var conceptoDiferencia = this.getConcepto(14, "Diferencia");
        var conceptoTarifaAplicable = this.getConcepto(14, "% Tarifa Aplicable");
        var conceptoCuotaFija = this.getConcepto(14, "Cuota Fija");
        var conceptoImpuestoMarginal = this.getConcepto(14, "Impuesto Marginal");
        var conceptoImpuesto = this.getConcepto(14, "Impuesto");
        var conceptoSubsidioEmpleo = this.getConcepto(14, "Subsidio Empleo");
        var conceptoImpuestoCargo = this.getConcepto(14, "Impuesto a Cargo");
        conceptoAdeudoSueldo.importeTotal = this.getConcepto(1, "Adeudo de Sueldo").importeGravado;
        conceptoComisiones.importeTotal = this.getConcepto(1, "Comisiones").importeGravado;
        conceptoIncentivos.importeTotal = this.getConcepto(1, "Incentivos").importeGravado;
        conceptoHorasExtra.importeTotal = this.getConcepto(1, "Horas Extra (Importe)").importeGravado;
        conceptoOtros.importeTotal = this.getConcepto(1, "Otros").importeGravado;
        conceptoTotalPartesProporcional.importeTotal = 0;
        conceptoTotalPartesProporcional.importeTotal += this.getConcepto(2, "Aguinaldo").importeGravado;
        conceptoTotalPartesProporcional.importeTotal += this.getConcepto(2, "Vacaciones").importeGravado;
        conceptoTotalPartesProporcional.importeTotal += this.getConcepto(2, "Prima Dominical").importeGravado;
        conceptoTotalPartesProporcional.importeTotal += this.getConcepto(2, "Prima Vacacional").importeGravado;
        // Acumulando las percepciones
        var conceptoAcumuladorPercepcion = new cedulafiniquito_1.CedulaConcepto();
        conceptoAcumuladorPercepcion.idConcepto = 159;
        conceptoAcumuladorPercepcion.acumula = "1,1,1,1";
        this.getImporteAcumulado(conceptoAcumuladorPercepcion);
        conceptoBaseGravable.importeTotal = conceptoAdeudoSueldo.importeTotal +
            conceptoComisiones.importeTotal +
            conceptoIncentivos.importeTotal +
            conceptoHorasExtra.importeTotal +
            conceptoOtros.importeTotal +
            conceptoTotalPartesProporcional.importeTotal +
            conceptoAcumuladorPercepcion.importeTotal;
        // ((Total Gravable / 365) * 30.4) * (Sueld Mensual Ordinario * 30)
        //var importeMensual = ((conceptoBaseGravable.importeTotal / 365) * 30.4);
        //var percepcionMensulizada = (importeMensual + this.getConcepto(11, "Sueldo Mensual Ordinario").importeTotal);
        // Consultamos la tarifa 
        //var tarifa = this.getTarifaPagoProvicional(percepcionMensulizada);
        //var factor = ((((percepcionMensulizada - tarifa.limiteInferior) * (tarifa.porcentaje / 100)) + tarifa.cuotaFija) - this.getConcepto(11, "Impuesto Neto").importeTotal) / importeMensual;
        //conceptoImpuesto.importeTotal = factor * conceptoBaseGravable.importeTotal;
        var tarifa = this.getTarifaPagoProvicional(conceptoBaseGravable.importeTotal);
        conceptoLimiteInferior.importeTotal = tarifa.limiteInferior;
        conceptoDiferencia.importeTotal = conceptoBaseGravable.importeTotal - conceptoLimiteInferior.importeTotal;
        conceptoTarifaAplicable.importeTotal = tarifa.porcentaje;
        conceptoCuotaFija.importeTotal = tarifa.cuotaFija;
        conceptoImpuestoMarginal.importeTotal = conceptoDiferencia.importeTotal * (tarifa.porcentaje / 100.0);
        conceptoImpuesto.importeTotal = conceptoCuotaFija.importeTotal + conceptoImpuestoMarginal.importeTotal;
        if (this.cedulaFiniquito.sueldoDias > 0) {
            //Solicitud de modificación cedula finiquitos URGENTE. Solicita que en la cedula de finiquitos de Onili, ya no se utilice el concepto de Subsidio para el Empleo
            //conceptoSubsidioEmpleo.importeTotal = this.getSubsidioEmpleoByDia(this.cedulaFiniquito.sueldoDias, conceptoBaseGravable.importeTotal).subsidio;
            conceptoSubsidioEmpleo.importeTotal = 0;
        }
        else {
            conceptoSubsidioEmpleo.importeTotal = 0;
        }
        conceptoImpuestoCargo.importeTotal = conceptoImpuesto.importeTotal - conceptoSubsidioEmpleo.importeTotal;
        if (this.conceptosIsr != undefined)
            this.conceptosIsr.refresh();
    };
    CedulasFiniquitosEditor.prototype.cedulaIsrPercepcionesAdeudadas = function () {
        var conceptoBaseImpuesto = this.getConcepto(15, "Base Impuesto");
        var conceptoLimiteInferior = this.getConcepto(15, "Limite Inferior");
        var conceptoExcente = this.getConcepto(15, "Excente L.I.");
        var conceptoPorcentajeExc = this.getConcepto(15, "% s/ Exc L.I.");
        var conceptoImptoSinExc = this.getConcepto(15, "Impto s/ Exc L.I");
        var conceptoCuotaFija = this.getConcepto(15, "Cuota Fija");
        var conceptoImpuestoBruto = this.getConcepto(15, "Impuesto Bruto");
        var conceptoSubsidio = this.getConcepto(15, "Subsidio");
        var conceptoImpuestoNeto = this.getConcepto(15, "Impuesto Neto Perc Adeu");
        conceptoBaseImpuesto.importeTotal = this.getImporteGravado(1);
        var self = this;
        if (this.cedulaFiniquito.empleado.idCompania != undefined) {
            var infoTarifa = this.getTarifaPagoProvicional(conceptoBaseImpuesto.importeTotal);
            conceptoLimiteInferior.importeTotal = infoTarifa != null ? infoTarifa.limiteInferior : 0;
            conceptoExcente.importeTotal = conceptoBaseImpuesto.importeTotal - conceptoLimiteInferior.importeTotal;
            conceptoPorcentajeExc.importeTotal = infoTarifa != null ? infoTarifa.porcentaje : 0;
            conceptoImptoSinExc.importeTotal = conceptoExcente.importeTotal * (conceptoPorcentajeExc.importeTotal / 100);
            conceptoCuotaFija.importeTotal = infoTarifa != null ? infoTarifa.cuotaFija : 0;
            conceptoImpuestoBruto.importeTotal = conceptoImptoSinExc.importeTotal + conceptoCuotaFija.importeTotal;
            // Solicitan descartar el subsidio del empleo
            //let infoSubsidio: SubsidioEmpleo    = this.getSubsidioEmpleo(conceptoBaseImpuesto.importeTotal);
            //conceptoSubsidio.importeTotal       = infoSubsidio != null ? infoSubsidio.subsidio : 0;
            conceptoSubsidio.importeTotal = 0;
            if (conceptoBaseImpuesto.importeTotal == 0) {
                conceptoImpuestoNeto.importeTotal = 0;
            }
            else {
                conceptoImpuestoNeto.importeTotal = conceptoImpuestoBruto.importeTotal - conceptoSubsidio.importeTotal;
            }
        }
        this.cedulaDeduccionesIsr(5);
        this.cedulaDeduccionesIsr(10);
        this.calcularSeguros(4);
        this.calcularSeguros(9);
        if (this.conceptosIsr != undefined)
            this.conceptosIsr.refresh();
    };
    CedulasFiniquitosEditor.prototype.cedulaPrevioFiniquito = function () {
        this.getConcepto(16, "Adeudo de Sueldo").importeTotal = this.getConcepto(1, "Adeudo de Sueldo").importeTotal;
        this.getConcepto(16, "Comisiones").importeTotal = this.getConcepto(1, "Comisiones").importeTotal;
        this.getConcepto(16, "Incentivos").importeTotal = this.getConcepto(1, "Incentivos").importeTotal;
        this.getConcepto(16, "Horas Extra (Importe)").importeTotal = this.getConcepto(1, "Horas Extra (Importe)").importeTotal;
        this.getConcepto(16, "Reparto Utilidades").importeTotal = this.getConcepto(1, "Reparto Utilidades").importeTotal;
        this.getConcepto(16, "Otros").importeTotal = this.getConcepto(1, "Otros").importeTotal;
        this.getConcepto(17, "Aguinaldo").importeTotal = this.getConcepto(2, "Aguinaldo").importeTotal;
        this.getConcepto(17, "Vacaciones").importeTotal = this.getConcepto(2, "Vacaciones").importeTotal;
        this.getConcepto(17, "Prima Dominical").importeTotal = this.getConcepto(2, "Prima Dominical").importeTotal;
        this.getConcepto(17, "Prima Dominical").importeGravado = this.getConcepto(2, "Prima Dominical").importeGravado;
        this.getConcepto(17, "Prima Dominical").importeExento = this.getConcepto(2, "Prima Dominical").importeExento;
        this.getConcepto(17, "Prima Vacacional").importeTotal = this.getConcepto(2, "Prima Vacacional").importeTotal;
        this.getConcepto(17, "Prima Vacacional").importeGravado = this.getConcepto(2, "Prima Vacacional").importeGravado;
        this.getConcepto(17, "Prima Vacacional").importeExento = this.getConcepto(2, "Prima Vacacional").importeExento;
        if (this.cedulaFiniquito.idRescicionLaboral == 2 || this.cedulaFiniquito.idRescicionLaboral == 3 || this.cedulaFiniquito.idRescicionLaboral == 4) {
            this.getConcepto(18, "Indemnización Adicional Acordada").importeTotal = this.getConcepto(8, "Indemnización Adicional Acordada").importeTotal;
            this.getConcepto(18, "Indemnización Adicional Acordada").importeGravado = this.getConcepto(8, "Indemnización Adicional Acordada").importeGravado;
            this.getConcepto(18, "Indemnización Adicional Acordada").importeExento = this.getConcepto(8, "Indemnización Adicional Acordada").importeExento;
            this.getConcepto(18, "Prima Antigüedad").importeTotal = this.getConcepto(8, "Prima Antigüedad").importeTotal;
            this.getConcepto(18, "Prima Antigüedad").importeGravado = this.getConcepto(8, "Prima Antigüedad").importeGravado;
            this.getConcepto(18, "Prima Antigüedad").importeExento = this.getConcepto(8, "Prima Antigüedad").importeExento;
        }
        else {
            if (this.cedulaFiniquito.idRescicionLaboral == 4) {
                this.getConcepto(18, "Indemnización Adicional Acordada").importeTotal = this.getConcepto(8, "Indemnización Adicional Acordada").importeTotal;
                this.getConcepto(18, "Indemnización Adicional Acordada").importeGravado = this.getConcepto(8, "Indemnización Adicional Acordada").importeGravado;
                this.getConcepto(18, "Indemnización Adicional Acordada").importeExento = this.getConcepto(8, "Indemnización Adicional Acordada").importeExento;
            }
            else {
                this.getConcepto(18, "Indemnización Adicional Acordada").importeTotal = 0;
                this.getConcepto(18, "Indemnización Adicional Acordada").importeGravado = 0;
                this.getConcepto(18, "Indemnización Adicional Acordada").importeExento = 0;
            }
            this.getConcepto(18, "Prima Antigüedad").importeTotal = 0;
            this.getConcepto(18, "Prima Antigüedad").importeGravado = 0;
            this.getConcepto(18, "Prima Antigüedad").importeExento = 0;
        }
        if (this.cedulaFiniquito.idRescicionLaboral == 3) {
            this.getConcepto(18, "Indemnización Ley (Días)").importeTotal = this.getConcepto(8, "Indemnización Ley (Días)").importeTotal;
            this.getConcepto(18, "Indemnización Ley (Días)").importeGravado = this.getConcepto(8, "Indemnización Ley (Días)").importeGravado;
            this.getConcepto(18, "Indemnización Ley (Días)").importeExento = this.getConcepto(8, "Indemnización Ley (Días)").importeExento;
            this.getConcepto(18, "Indemnización Ley (20d x Año)").importeTotal = this.getConcepto(8, "Indemnización Ley (20d x Año)").importeTotal;
            this.getConcepto(18, "Indemnización Ley (20d x Año)").importeGravado = this.getConcepto(8, "Indemnización Ley (20d x Año)").importeGravado;
            this.getConcepto(18, "Indemnización Ley (20d x Año)").importeExento = this.getConcepto(8, "Indemnización Ley (20d x Año)").importeExento;
        }
        else {
            this.getConcepto(18, "Indemnización Ley (Días)").importeTotal = 0;
            this.getConcepto(18, "Indemnización Ley (Días)").importeGravado = 0;
            this.getConcepto(18, "Indemnización Ley (Días)").importeExento = 0;
            this.getConcepto(18, "Indemnización Ley (20d x Año)").importeTotal = 0;
            this.getConcepto(18, "Indemnización Ley (20d x Año)").importeGravado = 0;
            this.getConcepto(18, "Indemnización Ley (20d x Año)").importeExento = 0;
        }
        var conceptoTotalPagosSeparacion = this.getConcepto(18, "Total Pagos Separación");
        conceptoTotalPagosSeparacion.importeTotal = 0;
        conceptoTotalPagosSeparacion.importeTotal = this.getImporteTotal(18);
        //ISR a Retener Percepción Adeudada
        //this.getConcepto(20, "ISR a Retener Percepción Adeudada").importeTotal = this.getConcepto(5, "ISR a Retener Percepción Adeudada").importeTotal;
        //ISR a Retener Partes Proporcionales
        this.getConcepto(20, "ISR a Retener Partes Proporcionales").importeTotal = this.getConcepto(5, "ISR a Retener Partes Proporcionales").importeTotal;
        //ISR a Retener Pagos Separación
        if (this.cedulaFiniquito.idRescicionLaboral == 2 || this.cedulaFiniquito.idRescicionLaboral == 3 || this.cedulaFiniquito.idRescicionLaboral == 4) {
            this.getConcepto(20, "ISR a Retener Pagos Separación").importeTotal = this.getConcepto(10, "ISR a Retener Pagos Separación").importeTotal;
        }
        else {
            if (conceptoTotalPagosSeparacion.importeTotal > 0) {
                this.getConcepto(20, "ISR a Retener Pagos Separación").importeTotal = this.getConcepto(5, "ISR a Retener Pagos Separación").importeTotal;
            }
            else {
                this.getConcepto(20, "ISR a Retener Pagos Separación").importeTotal = 0;
            }
        }
        this.getConcepto(19, "IMSS a Retener").importeTotal = this.getConcepto(4, 'IMSS a Retener').importeTotal;
        this.getConcepto(19, "Importe Adeudos").importeTotal = this.cedulaFiniquito.adeudo;
        this.getConcepto(19, "Infonavit").importeTotal = this.cedulaFiniquito.infonavit;
        this.getConcepto(19, "Fonacot").importeTotal = this.cedulaFiniquito.fonacot;
        var conceptoAcumulador = new cedulafiniquito_1.CedulaConcepto();
        conceptoAcumulador.idConcepto = 149;
        conceptoAcumulador.acumula = "1,1,1,1";
        this.getImporteAcumulado(conceptoAcumulador);
        var conceptoAcumuladorPercepcion = new cedulafiniquito_1.CedulaConcepto();
        conceptoAcumuladorPercepcion.idConcepto = 159;
        conceptoAcumuladorPercepcion.acumula = "1,1,1,1";
        this.getImporteAcumulado(conceptoAcumuladorPercepcion);
        // Importe Neto Finiquito
        // (1) Renuncia Voluntaria
        // (4) Retiro Negociado
        var totalPercepciones = this.getImporteTotal(16) + this.getImporteTotal(17) + this.getConcepto(18, 'Total Pagos Separación').importeTotal + conceptoAcumuladorPercepcion.importeTotal;
        var totalDeducciones = this.getImporteTotal(20) + this.getConcepto(19, "IMSS a Retener").importeTotal + this.cedulaFiniquito.adeudo + this.cedulaFiniquito.infonavit + this.cedulaFiniquito.fonacot + conceptoAcumulador.importeTotal;
        this.getConcepto(19, "Importe Neto Finiquito").importeTotal = parseFloat((totalPercepciones - totalDeducciones).toFixed(2));
        this.cedulaFiniquito.importeNetoFiniquito = parseFloat((totalPercepciones - totalDeducciones).toFixed(2));
    };
    CedulasFiniquitosEditor.prototype.cedulaInfonavitFonacot = function () {
        var _this = this;
        if (this.cedulaFiniquito.variables) {
            if (this.cedulaFiniquito.variables.length > 0) {
                var infonavit_1 = 0.0;
                var fonacot_1 = 0.0;
                this.cedulaFiniquito.variables.forEach(function (element) {
                    if (element.secuencia == 3) {
                        var porcentaje = (element.variableTrabajador / 10000.00);
                        var factor = porcentaje * _this.cedulaFiniquito.sueldoDiarioIntegrado;
                        infonavit_1 += factor * _this.cedulaFiniquito.sueldoDias;
                    }
                    else if (element.secuencia == 11 && _this.cedulaFiniquito.periodoPago > 0) {
                        var importe = (element.variableTrabajador / _this.cedulaFiniquito.periodoPago);
                        infonavit_1 += importe * _this.cedulaFiniquito.sueldoDias;
                    }
                    else if (element.secuencia == 5 && _this.cedulaFiniquito.periodoPago > 0) {
                        fonacot_1 += (element.variableTrabajador / _this.cedulaFiniquito.periodoPago) * _this.cedulaFiniquito.sueldoDias;
                    }
                });
                this.cedulaFiniquito.infonavit = infonavit_1;
                this.cedulaFiniquito.fonacot = fonacot_1;
            }
        }
    };
    CedulasFiniquitosEditor.prototype.onTabSelectedPrevios = function (flex) {
        this.cedulaPrevioFiniquito();
        if (flex.collectionView != null) {
            flex.collectionView.refresh();
        }
        wijmo_1.Control.invalidateAll();
    };
    CedulasFiniquitosEditor.prototype.onCambioComision = function (event) {
        var total = 0;
        this.cedulaFiniquito.comisionPeriodos.forEach(function (element) {
            if (element.pagado) {
                total += element.importe;
            }
        });
        this.cedulaFiniquito.comisiones = total;
    };
    /*************************************************************************/
    CedulasFiniquitosEditor.prototype.getConcepto = function (idClasificacion, concepto) {
        if (idClasificacion >= 1 && idClasificacion <= 5) {
            for (var _i = 0, _a = this.cedulaFiniquito.conceptosNegociacion; _i < _a.length; _i++) {
                var conceptoCedula = _a[_i];
                if (conceptoCedula.idClasificacionConcepto == idClasificacion && conceptoCedula.concepto == concepto) {
                    return conceptoCedula;
                }
            }
        }
        else if (idClasificacion >= 6 && idClasificacion <= 10) {
            for (var _b = 0, _c = this.cedulaFiniquito.conceptosApoyo; _b < _c.length; _b++) {
                var conceptoCedula = _c[_b];
                if (conceptoCedula.idClasificacionConcepto == idClasificacion && conceptoCedula.concepto == concepto) {
                    return conceptoCedula;
                }
            }
        }
        else if (idClasificacion >= 16 && idClasificacion <= 20) {
            for (var _d = 0, _e = this.cedulaFiniquito.conceptosPrevio; _d < _e.length; _d++) {
                var conceptoCedula = _e[_d];
                if (conceptoCedula.idClasificacionConcepto == idClasificacion && conceptoCedula.concepto == concepto) {
                    return conceptoCedula;
                }
            }
        }
        else {
            for (var _f = 0, _g = this.cedulaFiniquito.conceptosIsr; _f < _g.length; _f++) {
                var conceptoCedula = _g[_f];
                if (conceptoCedula.idClasificacionConcepto == idClasificacion && conceptoCedula.concepto == concepto) {
                    return conceptoCedula;
                }
            }
        }
        return new cedulafiniquito_1.CedulaConcepto();
    };
    CedulasFiniquitosEditor.prototype.getImporteCantidad = function (idClasificacion) {
        return this.getImporte(idClasificacion, "C");
    };
    CedulasFiniquitosEditor.prototype.getImporteTotal = function (idClasificacion) {
        return this.getImporte(idClasificacion, "T");
    };
    CedulasFiniquitosEditor.prototype.getImporteGravado = function (idClasificacion) {
        return this.getImporte(idClasificacion, "G");
    };
    CedulasFiniquitosEditor.prototype.getImporteExento = function (idClasificacion) {
        return this.getImporte(idClasificacion, "E");
    };
    CedulasFiniquitosEditor.prototype.getImporte = function (idClasificacion, tipo) {
        var cantidad = 0;
        var total = 0;
        var gravado = 0;
        var exento = 0;
        if (idClasificacion >= 1 && idClasificacion <= 5) {
            for (var _i = 0, _a = this.cedulaFiniquito.conceptosNegociacion; _i < _a.length; _i++) {
                var conceptoCedula = _a[_i];
                if (conceptoCedula.idClasificacionConcepto == idClasificacion && conceptoCedula.idParent == 0) {
                    cantidad += conceptoCedula.cantidad;
                    total += conceptoCedula.importeTotal;
                    gravado += conceptoCedula.importeGravado;
                    exento += conceptoCedula.importeExento;
                }
            }
        }
        else if (idClasificacion >= 6 && idClasificacion <= 10) {
            for (var _b = 0, _c = this.cedulaFiniquito.conceptosApoyo; _b < _c.length; _b++) {
                var conceptoCedula = _c[_b];
                if (conceptoCedula.idClasificacionConcepto == idClasificacion && conceptoCedula.idParent == 0) {
                    cantidad += conceptoCedula.cantidad;
                    total += conceptoCedula.importeTotal;
                    gravado += conceptoCedula.importeGravado;
                    exento += conceptoCedula.importeExento;
                }
            }
        }
        else if (idClasificacion >= 16 && idClasificacion <= 20) {
            for (var _d = 0, _e = this.cedulaFiniquito.conceptosPrevio; _d < _e.length; _d++) {
                var conceptoCedula = _e[_d];
                if (conceptoCedula.idClasificacionConcepto == idClasificacion && conceptoCedula.idParent == 0) {
                    cantidad += conceptoCedula.cantidad;
                    total += conceptoCedula.importeTotal;
                    gravado += conceptoCedula.importeGravado;
                    exento += conceptoCedula.importeExento;
                }
            }
        }
        else {
            for (var _f = 0, _g = this.cedulaFiniquito.conceptosIsr; _f < _g.length; _f++) {
                var conceptoCedula = _g[_f];
                if (conceptoCedula.idClasificacionConcepto == idClasificacion && conceptoCedula.idParent == 0) {
                    cantidad += conceptoCedula.cantidad;
                    total += conceptoCedula.importeTotal;
                    gravado += conceptoCedula.importeGravado;
                    exento += conceptoCedula.importeExento;
                }
            }
        }
        if (tipo == "C") {
            return cantidad;
        }
        else if (tipo == "T") {
            return total;
        }
        else if (tipo == "G") {
            return gravado;
        }
        else if (tipo == "E") {
            return exento;
        }
        return 0;
    };
    CedulasFiniquitosEditor.prototype.getImporteAcumulado = function (concepto) {
        if (concepto != null) {
            var acumCantidad = 0;
            var acumTotal = 0;
            var acumGravado = 0;
            var acumExento = 0;
            this.cedulaFiniquito.conceptosPrevio.forEach(function (element) {
                if (element.idParent == concepto.idConcepto) {
                    acumCantidad += element.cantidad;
                    acumTotal += element.importeTotal;
                    acumGravado += element.importeGravado;
                    acumExento += element.importeExento;
                }
            });
            var reglas = concepto.acumula.split(",");
            if (reglas[0] == "1") {
                concepto.cantidad += acumCantidad;
            }
            if (reglas[1] == "1") {
                concepto.importeTotal += acumTotal;
            }
            if (reglas[2] == "1") {
                concepto.importeGravado += acumGravado;
            }
            if (reglas[3] == "1") {
                concepto.importeExento += acumExento;
            }
            return concepto;
        }
    };
    CedulasFiniquitosEditor.prototype.onTabSelectedFlexGrid = function (flex) {
        if (flex.collectionView != null) {
            flex.collectionView.refresh();
        }
        wijmo_1.Control.invalidateAll();
    };
    CedulasFiniquitosEditor.prototype.getDaysBetweenTwoDates = function (dateIni, dateFin) {
        try {
            var diasDif = new Date(dateIni.toDateString()).getTime() - new Date(dateFin.toDateString()).getTime();
            return Math.round(diasDif / (1000 * 60 * 60 * 24));
        }
        catch (err) {
        }
        return 0;
    };
    CedulasFiniquitosEditor.prototype.onRowDblclicked = function (s, e) {
        var _this = this;
        if (s.selectedRows[0].dataItem.concepto === 'Importe Adeudos') {
            this.context.app.showSpinner();
            this.cedulaFiniquitoService.generarCedulaFiniquitoAdeudo(this.cedulaFiniquito.idEmpleado)
                .then(function (report) {
                _this.tileDowmload = "Contpaqi - Adeudos";
                _this.nameDownload = "adeudo_" + _this.cedulaFiniquito.empleado.code;
                _this.reportViewer.show("data:application/pdf; base64, " + report);
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    CedulasFiniquitosEditor.prototype.printKardexAsistencia = function () {
        var _this = this;
        if (this.cedulaFiniquito.idEmpleado > 0) {
            this.context.app.showSpinner();
            this.cedulaFiniquitoService.generarKardexAsistencia(this.cedulaFiniquito.empleado.code, moment(this.cedulaFiniquito.fechaAntiguedad).format(), moment(this.cedulaFiniquito.ultimoDiaLaborado).format())
                .then(function (report) {
                _this.tileDowmload = "Kardex de asistencia";
                _this.nameDownload = "kardex_" + _this.cedulaFiniquito.empleado.code;
                _this.reportViewer.show("data:application/pdf; base64, " + report);
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    CedulasFiniquitosEditor.prototype.getSubsidioEmpleo = function (importe) {
        for (var _i = 0, _a = this.cedulaFiniquito.subsidiosEmpleo; _i < _a.length; _i++) {
            var subsidio = _a[_i];
            if (subsidio.limiteInferior <= importe && (subsidio.limiteSuperior >= importe || subsidio.limiteSuperior == 0) && subsidio.limiteInferior <= importe) {
                return subsidio;
            }
        }
        return new cedulafiniquito_1.SubsidioEmpleo();
    };
    CedulasFiniquitosEditor.prototype.getSubsidioEmpleoByDia = function (dias, importe) {
        if (dias > 0) {
            for (var _i = 0, _a = this.cedulaFiniquito.subsidiosEmpleo; _i < _a.length; _i++) {
                var subsidio = _a[_i];
                if ((subsidio.subsidioDiario.limiteInferior * dias) <= importe && ((subsidio.subsidioDiario.limiteSuperior * dias) >= importe || (subsidio.subsidioDiario.limiteSuperior * dias) == 0) && (subsidio.subsidioDiario.limiteInferior * dias) <= importe) {
                    return subsidio;
                }
            }
        }
        return new cedulafiniquito_1.SubsidioEmpleo();
    };
    CedulasFiniquitosEditor.prototype.getTarifaPagoProvicional = function (importe) {
        for (var _i = 0, _a = this.cedulaFiniquito.tarifasPagosProvicionales; _i < _a.length; _i++) {
            var tarifa = _a[_i];
            if ((tarifa.limiteInferior <= importe) && (tarifa.limiteSuperior >= importe || tarifa.limiteSuperior == 0) && tarifa.limiteInferior <= importe) {
                return tarifa;
            }
        }
        return new cedulafiniquito_1.TarifaPagoProvicional();
    };
    CedulasFiniquitosEditor.prototype.verificarTaskComision = function () {
        var _this = this;
        var self = this;
        this.context.app.showSpinner();
        this.cedulaFiniquitoService.getTaskComision(this.cedulaFiniquito.idTaskComision)
            .then(function (response) {
            if (response.completo) {
                self.cedulaFiniquito.comisionPeriodos = [];
                if (!(response.result === '')) {
                    var result = JSON.parse(response.result);
                    result.forEach(function (element) {
                        var comision = new cedulafiniquito_1.ComisionPeriodo();
                        comision.idCedulaFiniquito = self.cedulaFiniquito.identity;
                        comision.anio = element.Anio;
                        comision.periodo = element.Periodo;
                        comision.fechaInicio = moment(element.FechaInicio).toDate();
                        comision.fechaTermino = moment(element.FechaTermino).toDate();
                        comision.fechaPago = moment(element.FechaPago).toDate();
                        comision.importe = parseFloat(element.Importe);
                        self.cedulaFiniquito.comisionPeriodos.push(comision);
                    });
                }
                clearInterval(_this.timerInterval);
                _this.context.app.hideSpinner();
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //Administracion de contactos
    CedulasFiniquitosEditor.prototype.onMenuItemClick = function (option) {
        if (option.name == 'ADEUDO') {
            if (this.cedulaFiniquito.idEmpleado > 0) {
                this.dlgAdeudo.config.backdrop = false;
                this.dlgAdeudo.show();
            }
            else {
                this.showAlert("Seleccion el empleado", 'danger');
            }
        }
    };
    CedulasFiniquitosEditor.prototype.onConsultarAdeudo = function () {
        var _this = this;
        this.dlgAdeudo.hide();
        this.context.app.showSpinner();
        this.cedulaFiniquitoService.loadAdeudosEmpleado(this.cedulaFiniquito.empleado.compania.code, this.cedulaFiniquito.empleado.code, moment(this.cedulaFiniquito.fechaBaja).format())
            .then(function (info) {
            _this.onCambioAdeudo(info);
            _this.context.app.hideSpinner();
        })
            .catch(function (e) { return _this.handleError(e); });
    };
    CedulasFiniquitosEditor.prototype.calcularPercepciones = function (acumulado) {
        var percepciones = acumulado.acumuladoDet
            .map(function (c) { return c.percepciones; })
            .reduce(function (sum, current) { return sum + current; });
        return "Total percepciones $" + percepciones.toFixed(2);
    };
    CedulasFiniquitosEditor.prototype.calcularDeducciones = function (acumulado) {
        var deducciones = acumulado.acumuladoDet
            .map(function (c) { return c.deducciones; })
            .reduce(function (sum, current) { return sum + current; });
        return "Total deducciones $" + deducciones.toFixed(2);
    };
    CedulasFiniquitosEditor.prototype.calcularTotales = function (acumulado) {
        var percepciones = acumulado.acumuladoDet
            .map(function (c) { return c.percepciones; })
            .reduce(function (sum, current) { return sum + current; });
        var deducciones = acumulado.acumuladoDet
            .map(function (c) { return c.deducciones; })
            .reduce(function (sum, current) { return sum + current; });
        return "Neto a pagar $" + (percepciones - deducciones).toFixed(2);
    };
    var CedulasFiniquitosEditor_1;
    __decorate([
        core_1.ContentChildren(menu_item_directive_1.MenuItemDirective),
        __metadata("design:type", core_1.QueryList)
    ], CedulasFiniquitosEditor.prototype, "menuItems", void 0);
    __decorate([
        core_1.ViewChild('dlgConfigirmacionCalculo'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], CedulasFiniquitosEditor.prototype, "dlgConfigirmacionCalculo", void 0);
    __decorate([
        core_1.ViewChild('dlgConcepto'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], CedulasFiniquitosEditor.prototype, "dlgConcepto", void 0);
    __decorate([
        core_1.ViewChild('dlgAdeudo'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], CedulasFiniquitosEditor.prototype, "dlgAdeudo", void 0);
    __decorate([
        core_1.ViewChild(content_viewer_component_1.ContentViewerComponent),
        __metadata("design:type", content_viewer_component_1.ContentViewerComponent)
    ], CedulasFiniquitosEditor.prototype, "reportViewer", void 0);
    CedulasFiniquitosEditor = CedulasFiniquitosEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-cedulasfiniquitos-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'CedulaFiniquito'\"\n                                 [info]=\"cedulafiniquito\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'ADEUDO'\" [icon]=\"'glyphicon glyphicon-refresh'\" [text]=\"'Adeudos'\" [smallText]=\"'actualizar adeudos'\"></azteca-menu-item>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"cedulaFiniquito.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Empleado:'\">\n                          <rh-empleado-selector formControlName=\"empleado\" [(ngModel)]=\"cedulaFiniquito.idEmpleado\"\n                                                [enabled]=\"cedulaFiniquito.identity == 0\"\n                                                (empleadoUpdated)=\"onEmpleadoSelected($event)\">\n                          </rh-empleado-selector>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Ingreso\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Nombre:'\">\n                                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"cedulaFiniquito.empleado.persona.nombre\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Ap. Paterno:'\">\n                                          <az-textbox formControlName=\"apPaterno\" [(ngModel)]=\"cedulaFiniquito.empleado.persona.apellidoPaterno\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Ap. Paterno:'\">\n                                          <az-textbox formControlName=\"apMaterno\" [(ngModel)]=\"cedulaFiniquito.empleado.persona.apellidoMaterno\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\" *ngIf=\"cedulaFiniquito.infonavitOrFonacot\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <div class=\"alert alert-danger\" role=\"alert\">\n                                          EL EMPLEADO CUENTA CON INFONAVIT O FONACOT\n                                      </div>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Departamento:'\">\n                                          <az-textbox formControlName=\"departamento\" [ngModel]=\"cedulaFiniquito.departamento\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Bodega:'\">\n                                          <az-textbox formControlName=\"bodega\" [ngModel]=\"cedulaFiniquito.bodega\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <az-checkbox [label]=\"'Sindicalizado'\" formControlName=\"sindicalizado\" [(ngModel)]=\"cedulaFiniquito.sindicalizado\" (checkedChanged)=\"onCambioSindicalizado($event)\"></az-checkbox>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Tipo Resici&oacute;n Laboral:'\">\n                                          <az-combobox formControlName=\"idRescicionLaboral\" [(ngModel)]=\"cedulaFiniquito.idRescicionLaboral\" [items]=\"rescisionesLaborales\" [displayMember]=\"'descripcion'\" [valueMember]=\"'idRescisionLaboral'\" (selectedItemChanged)=\"onSeleccionRescision($event)\"></az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Fecha antig&uuml;edad:'\">\n                                          <az-input-date formControlName=\"fechaAntiguedad\" [(ngModel)]=\"cedulaFiniquito.fechaAntiguedad\" (valueChange)=\"onCambioFechaAntiguedad($event)\" [enabled]=\"false\"></az-input-date>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Fecha &uacute;ltimo d&iacute;a laborado:'\">\n                                          <az-input-date formControlName=\"ultimoDiaLaborado\" [(ngModel)]=\"cedulaFiniquito.ultimoDiaLaborado\" (valueChange)=\"onCambioUltimoDiaLaborado($event)\"></az-input-date>\n                                      </azteca-form-field>\n\n                                  </div>\n                                  <div class=\"col-12 col-md-6\">\n                                      <button class=\"btn btn-default\" (click)=\"printKardexAsistencia()\">Asistencias</button>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Fecha de Baja:'\">\n                                          <az-input-date formControlName=\"fechaBaja\" [(ngModel)]=\"cedulaFiniquito.fechaBaja\" (valueChange)=\"onCambioFechaBaja($event)\"></az-input-date>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Fecha de &uacute;ltimo pago de Aguinaldo:'\">\n                                          <az-input-date formControlName=\"fechaUltimoAguinaldo\" [(ngModel)]=\"cedulaFiniquito.fechaUltimoAguinaldo\" (valueChange)=\"onCambioFechaUltimoAguinaldo($event)\"></az-input-date>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'D&iacute;as Aguinaldo Contrato:'\">\n                                          <az-input-number formControlName=\"diasAguinaldoContrato\" decimal=\"false\" [(ngModel)]=\"cedulaFiniquito.diasAguinaldoContrato\" [format]=\"'n0'\" [min]=\"0\" [max]=\"100\" (valueChange)=\"onCambioDiasAguinaldoContrato($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <az-checkbox [label]=\"'Disfruto Previamente Aguinaldo'\" formControlName=\"disfrutePrevioAguinaldo\" [(ngModel)]=\"cedulaFiniquito.disfrutePrevioAguinaldo\" (checkedChanged)=\"onCambioDisfrutePrevioAguinaldo($event)\"></az-checkbox>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <az-checkbox [label]=\"'Prima Vacacional Pendiente de Entregar'\" formControlName=\"primaVacacionalPendiente\" [(ngModel)]=\"cedulaFiniquito.primaVacacionalPendiente\" (checkedChanged)=\"onCambioPrimaVacacionalPendiente($event)\"></az-checkbox>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Importe de Prima Vacacional Exenta pagada:'\">\n                                          <az-input-number formControlName=\"pirmaVacExentaPagada\" [(ngModel)]=\"cedulaFiniquito.pirmaVacExentaPagada\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioPirmaVacExentaPagada($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Porcentaje de Prima Vacacional:'\">\n                                          <az-input-number formControlName=\"porcentajePrimaVacacional\" [(ngModel)]=\"cedulaFiniquito.porcentajePrimaVacacional\" [format]=\"'n2'\" [min]=\"0\" [max]=\"100\" (valueChange)=\"onCambioPorcentajePrimaVacacional($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'N&uacute;mero de D&iacute;as de Vacaciones pendiente de Disfrute:'\">\n                                          <az-input-number formControlName=\"diasVacacionesPendiente\" [(ngModel)]=\"cedulaFiniquito.diasVacacionesPendiente\" [format]=\"'n2'\" [min]=\"0\" [max]=\"100\" (valueChange)=\"onCambioVacacionesPendiente($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'N&uacute;mero de D&iacute;as de Vacaciones generadas del \u00FAltimo per\u00EDodo:'\">\n                                          <az-input-number formControlName=\"diasVacacionesGeneradas\" [(ngModel)]=\"cedulaFiniquito.diasVacacionesGeneradas\" [format]=\"'n4'\" [min]=\"0\" [max]=\"100\" (valueChange)=\"onCambioVacacionesGeneradas($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Total de D&iacute;as de Vacaciones:'\">\n                                          <az-input-number formControlName=\"totalDiasVacaciones\" [(ngModel)]=\"cedulaFiniquito.totalDiasVacaciones\" [format]=\"'n4'\" [min]=\"0\" [max]=\"100\" (valueChange)=\"onCambioTotalDiasVacaciones($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Porcentaje de Pago de prima de antig&uuml;edad:'\">\n                                          <az-input-number formControlName=\"porcentajePrimaAntiguedad\" [(ngModel)]=\"cedulaFiniquito.porcentajePrimaAntiguedad\" [format]=\"'n0'\" [min]=\"0\" [max]=\"100\" (valueChange)=\"onCambioPorcentajePrimaAntiguedad($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Porcentaje de Pago de 20 d&iacute;as por a&ntilde;o:'\">\n                                          <az-input-number formControlName=\"porcentajeVeinteDiasAnio\" [(ngModel)]=\"cedulaFiniquito.porcentajeVeinteDiasAnio\" [format]=\"'n0'\" [min]=\"0\" [max]=\"100\" (valueChange)=\"onCambioPorcentajeVeinteDiasAnio($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Sueldo Diario:'\">\n                                          <az-input-number formControlName=\"sueldoDiario\" [(ngModel)]=\"cedulaFiniquito.sueldoDiario\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioSueldoDiario($event)\" [enabled]=\"false\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Sueldo Diario Promedio:'\">\n                                          <az-input-number formControlName=\"sueldoPromedio\" [(ngModel)]=\"cedulaFiniquito.sueldoPromedio\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioSueldoPromedio($event)\" [enabled]=\"false\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'&Uacute;ltimo SDI:'\">\n                                          <az-input-number formControlName=\"sueldoDiarioIntegrado\" [(ngModel)]=\"cedulaFiniquito.sueldoDiarioIntegrado\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioSueldoDiarioIntegrado($event)\" [enabled]=\"false\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Ausentismo Aguinaldo / Vacaciones:'\">\n                                          <az-input-number formControlName=\"ausentismo\" [(ngModel)]=\"cedulaFiniquito.ausentismo\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioAusentismo($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Sueldo (d&iacute;as):'\">\n                                          <az-input-number formControlName=\"sueldoDias\" [(ngModel)]=\"cedulaFiniquito.sueldoDias\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioSueldoDias($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Sueldo (Importe):'\">\n                                          <az-input-number formControlName=\"sueldoImporte\" [(ngModel)]=\"cedulaFiniquito.sueldoImporte\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioSueldoImporte($event)\"></az-input-number>\n\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Comisiones:'\">\n                                          <az-input-number formControlName=\"comisiones\" [(ngModel)]=\"cedulaFiniquito.comisiones\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioComisiones($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <table class=\"table table-bordered table-responsive\">\n                                          <thead>\n                                              <tr>\n                                                  <th>Comisi&oacute;n</th>\n                                                  <th>Periodo</th>\n                                              </tr>\n                                          </thead>\n                                          <tbody>\n                                              <tr *ngFor=\"let item of cedulaFiniquito.comisionPeriodos\">\n                                                  <th>\n                                                      <input class=\"form-check-input\" formControlName=\"comisionespagado\" type=\"checkbox\" style=\"margin-left:2px;!important\" [(ngModel)]=\"item.pagado\" (change)=\"onCambioComision($event)\" />\n                                                      {{item.importe | number:'1.2-2'}}\n                                                  </th>\n                                                  <td>\n                                                      <span>{{item.periodo}}</span>\n                                                  </td>\n                                              </tr>\n                                          </tbody>\n                                      </table>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Incentivos:'\">\n                                          <az-input-number formControlName=\"incentivos\" [(ngModel)]=\"cedulaFiniquito.incentivos\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioIncentivos($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Horas Extras (importe):'\">\n                                          <az-input-number formControlName=\"horasExtraImporte\" [(ngModel)]=\"cedulaFiniquito.horasExtraImporte\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioHorasExtraImporte($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Prima Vacacional Pendiente de Entregar:'\">\n                                          <az-input-number formControlName=\"primaVacacionalPendienteEntrega\" [(ngModel)]=\"cedulaFiniquito.primaVacacionalPendienteEntrega\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioPrimaVacacionalPendienteEntrega($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Prima Dominical (N&uacute;mero de Domingos):'\">\n                                          <az-input-number formControlName=\"primaDominicalNumDomingos\" [(ngModel)]=\"cedulaFiniquito.primaDominicalNumDomingos\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioNumDomingos($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Prima Dominical (Importe):'\">\n                                          <az-input-number formControlName=\"primaDominicalImporte\" [(ngModel)]=\"cedulaFiniquito.primaDominicalImporte\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioPrimaDominicalImporte($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Reparto de Utilidades:'\">\n                                          <az-input-number formControlName=\"repartoUtilidades\" [(ngModel)]=\"cedulaFiniquito.repartoUtilidades\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioRepartoUtilidades($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'D&iacute;as negociado Indemnizacion Ley:'\">\n                                          <az-input-number formControlName=\"diasNegociadoIndemnizacion\" [(ngModel)]=\"cedulaFiniquito.diasNegociadoIndemnizacion\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioDiasNegociadosIndemnizacion($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Otros:'\">\n                                          <az-input-number formControlName=\"otros\" [(ngModel)]=\"cedulaFiniquito.otros\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioOtros($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Infonavit:'\">\n                                          <az-input-number formControlName=\"infonavit\" [(ngModel)]=\"cedulaFiniquito.infonavit\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioInfonavit($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Fonacot:'\">\n                                          <az-input-number formControlName=\"fonacot\" [(ngModel)]=\"cedulaFiniquito.fonacot\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioFonacot($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Importe Adeudo:'\">\n                                          <az-input-number formControlName=\"adeudo\" [(ngModel)]=\"cedulaFiniquito.adeudo\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioAdeudo($event)\" [enabled]=\"false\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Prima Vacacional Exenta:'\">\n                                          <az-input-number formControlName=\"primaVacacionalExento\" [(ngModel)]=\"cedulaFiniquito.primaVacacionalExento\" [format]=\"'n2'\" [min]=\"0\" [enabled]=\"false\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                          </tab>\n\n                          <tab heading=\"Previos\" (select)=\"onTabSelectedPrevios(grdCedulaPrevios)\" [wjContextMenu]=\"mnuConcepto\">\n                              <wj-flex-grid #grdCedulaPrevios [(itemsSource)]=\"conceptosPrevio\" [showGroups]=\"true\">\n                                  <wj-flex-grid-column [header]=\"'Tipo'\" [visible]=\"false\" [binding]=\"'clasificacionConcepto.descripcion'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Concepto'\" [binding]=\"'concepto'\" [width]=\"'*'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Importe Total'\" [binding]=\"'importeTotal'\" [format]=\"'n2'\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </tab>\n\n                          <tab heading=\"C\u00E9dula Negociaci\u00F3n\" (select)=\"onTabSelectedFlexGrid(grdCedulaNegosiacion)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Salario M&iacute;nimo Zona:'\">\n                                          <az-input-number formControlName=\"salarioMinimoZonaNegosiacion\" [(ngModel)]=\"cedulaFiniquito.salarioMinimoZona\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioSalarioMinimoZona($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <wj-flex-grid #grdCedulaNegosiacion [(itemsSource)]=\"conceptosCedulaNegosiacion\" [showGroups]=\"true\" (dblclick)=\"onRowDblclicked(grdCedulaNegosiacion, $event)\">\n                                  <wj-flex-grid-column [header]=\"'Tipo'\" [visible]=\"false\" [binding]=\"'clasificacionConcepto.descripcion'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Concepto'\" [binding]=\"'concepto'\" [isReadOnly]=\"true\" [width]=\"'*'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [format]=\"'n2'\" [aggregate]=\"'Sum'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Importe Total'\" [binding]=\"'importeTotal'\" [format]=\"'n2'\" [aggregate]=\"'Sum'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Gravado'\" [binding]=\"'importeGravado'\" [format]=\"'n2'\" [aggregate]=\"'Sum'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Exento'\" [binding]=\"'importeExento'\" [format]=\"'n2'\" [aggregate]=\"'Sum'\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </tab>\n                          <tab heading=\"ISR\" (select)=\"onTabSelectedFlexGrid(grdCedulaIsr)\">\n                              <wj-flex-grid #grdCedulaIsr [(itemsSource)]=\"conceptosIsr\" [showGroups]=\"true\">\n                                  <wj-flex-grid-column [header]=\"'Tipo'\" [visible]=\"false\" [binding]=\"'clasificacionConcepto.descripcion'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Concepto'\" [binding]=\"'concepto'\" [width]=\"'*'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Importe Total'\" [binding]=\"'importeTotal'\" [format]=\"'n2'\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </tab>\n                          <tab heading=\"C\u00E9dula Apoyo Previo Finiquito\" (select)=\"onTabSelectedFlexGrid(grdCedulaApoyo)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Salario M&iacute;nimo Zona:'\">\n                                          <az-input-number formControlName=\"salarioMinimoZonaApoyo\" [(ngModel)]=\"cedulaFiniquito.salarioMinimoZona\" [format]=\"'n2'\" [min]=\"0\" (valueChange)=\"onCambioSalarioMinimoZona($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <wj-flex-grid #grdCedulaApoyo [(itemsSource)]=\"conceptosApoyo\" [showGroups]=\"true\">\n                                  <wj-flex-grid-column [header]=\"'Tipo'\" [visible]=\"false\" [binding]=\"'clasificacionConcepto.descripcion'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Concepto'\" [binding]=\"'concepto'\" [isReadOnly]=\"true\" [width]=\"'*'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [format]=\"'n2'\" [aggregate]=\"'Sum'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Importe Total'\" [binding]=\"'importeTotal'\" [format]=\"'n2'\" [aggregate]=\"'Sum'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Gravado'\" [binding]=\"'importeGravado'\" [format]=\"'n2'\" [aggregate]=\"'Sum'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Exento'\" [binding]=\"'importeExento'\" [format]=\"'n2'\" [aggregate]=\"'Sum'\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </tab>\n                          <tab heading=\"Acumulado\" (select)=\"onTabSelectedFlexGrid(grdAcumulado)\" *ngIf=\"cedulaFiniquito.identity >0 && (context.app.defaultCompany.identity==1||context.app.defaultCompany.identity==2||context.app.defaultCompany.identity==3)\">\n                              <wj-flex-grid #grdAcumulado [allowDragging]=\"'Both'\"\n                                            [itemsSource]=\"cedulaFiniquito.acumuladoBajas\">\n                                  <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                                  <wj-flex-grid-column [header]=\"'Clase Nomina'\" [binding]=\"'claseNomina'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Tipo Nomina'\" [binding]=\"'tipoNomina'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Periodo'\" [binding]=\"'periodo'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Percepciones'\" [binding]=\"'percepciones'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Deducciones'\" [binding]=\"'deducciones'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Neto'\" [binding]=\"'neto'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n\n\n                                  <ng-template wjFlexGridDetail [detailVisibilityMode]=\"detailMode\" let-item=\"item\" [isAnimated]=\"true\">\n                                      <div class=\"row\">\n                                          <div class=\"col-12\">\n                                              <wj-flex-grid [itemsSource]=\"item.acumuladoDet\">\n                                                  <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                                  <wj-flex-grid-column [header]=\"'Clave'\" [binding]=\"'clave'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                                  <wj-flex-grid-column [header]=\"'Concepto'\" [binding]=\"'concepto'\" [width]=\"'60*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                                  <wj-flex-grid-column [header]=\"'Tiempo '\" [binding]=\"'tiempo'\" [width]=\"'20*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                                  <wj-flex-grid-column [header]=\"'Percepciones'\" [binding]=\"'percepciones'\" [width]=\"'30*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                                  <wj-flex-grid-column [header]=\"'Deducciones'\" [binding]=\"'deducciones'\" [width]=\"'30*'\" [isReadOnly]=\"true\" format=\"'n2'\"></wj-flex-grid-column>\n                                              </wj-flex-grid>\n                                          </div>\n                                      </div>\n                                      <div class=\"row\">\n                                          <div class=\"col-10 text-right\">\n                                              {{calcularPercepciones(item)}}\n                                          </div>\n                                          <div class=\"col-2 text-right\">\n                                              {{calcularDeducciones(item)}}\n                                          </div>\n                                      </div>\n                                      <div class=\"row\">\n                                          <div class=\"col-12 text-right\">\n                                              {{calcularTotales(item)}}\n                                          </div>\n                                      </div>\n                                  </ng-template>\n                              </wj-flex-grid>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n\n          </azteca-catalog-editor>\n\n          <!--DIALOGO DE CARGA DE COMPROBANTES-->\n          <div bsModal #dlgConfigirmacionCalculo=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n              <div class=\"modal-dialog\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-body\">\n                          <div>\u00BFDesea calcular la comisi&oacute;n del empleado?</div>\n                      </div>\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"consultarCalculo(false)\">No</button>\n                          <button type=\"button\" class=\"btn btn-default\" (click)=\"consultarCalculo(true)\">Si</button>\n                      </div>\n                  </div>\n              </div>\n          </div>\n\n          <!--DIALOGO CREAR CONCEPTOS-->\n          <div bsModal #dlgConcepto=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"false\">\n              <div class=\"modal-dialog\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-body\">\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Concepto:'\">\n                                      <az-textbox formControlName=\"newConcepto\" [(ngModel)]=\"newCedulaConcepto.concepto\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\" *ngIf=\"false\">\n                              <div class=\"col-12 col-md-4\">\n                                  <azteca-form-field [label]=\"'Cantidad:'\">\n                                      <az-input-number formControlName=\"newCantidad\" [(ngModel)]=\"newCedulaConcepto.cantidad\" [format]=\"'n2'\" [min]=\"0\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n\n                          <div class=\"row\" *ngIf=\"false\">\n                              <div class=\"col-12 col-md-4\">\n                                  <azteca-form-field [label]=\"'Importe Gravado:'\">\n                                      <az-input-number formControlName=\"newImporteGravado\" [(ngModel)]=\"newCedulaConcepto.importeGravado\" [format]=\"'n2'\" [min]=\"0\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\" *ngIf=\"false\">\n                              <div class=\"col-12 col-md-4\">\n                                  <azteca-form-field [label]=\"'Importe Exento:'\">\n                                      <az-input-number formControlName=\"newImporteExento\" [(ngModel)]=\"newCedulaConcepto.importeExento\" [format]=\"'n2'\" [min]=\"0\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-md-4\">\n                                  <azteca-form-field [label]=\"'Importe Total:'\">\n                                      <az-input-number formControlName=\"newImporteTotal\" [(ngModel)]=\"newCedulaConcepto.importeTotal\" [format]=\"'n2'\" [min]=\"0\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                      </div>\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onConceptoCancelar()\">Cancelar</button>\n                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onConceptoAgregar()\">Agregar</button>\n                      </div>\n                  </div>\n              </div>\n          </div>\n\n          <!--DIALOGO ADEDUDO-->\n          <div bsModal #dlgAdeudo=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"false\">\n              <div class=\"modal-dialog\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-body\">\n                          <div class=\"row\">\n                              <span>Seleccione la fecha de consula de adeudo del empleado</span>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-12 col-md-6\">\n                                  <wj-calendar [(value)]=\"fechaAdeudo\"\n                                               [min]=\"cedulaFiniquito.fechaBaja\"\n                                               [max]=\"maxDate\">\n                                  </wj-calendar>\n                              </div>\n                          </div>\n\n                      </div>\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onConsultarAdeudo()\">Cancelar</button>\n                          <button type=\"button\" class=\"btn btn-default\" (click)=\"dlgAdeudo.hide()\">Agregar</button>\n                      </div>\n                  </div>\n              </div>\n          </div>\n\n\n          <!-- CONTENT VIEW -->\n          <azteca-content-viewer [title]=\"tileDowmload\" [fileName]=\"nameDownload\"></azteca-content-viewer>\n\n          <!-- MENUS SECUNDARIOS -->\n          <wj-menu #mnuConcepto\n                   (itemClicked)=\"onMenuItemClicked(mnuConcepto, $event)\"\n                   [header]=\"'Run'\"\n                   [isButton]=\"false\"\n                   style=\"display:none\">\n              <wj-menu-item *ngFor=\"let item of menuItemsConcepto\">\n                  <div *ngIf=\"item.enabled\">\n                      <span [class]=\"item.icon\"></span>\n                      <b>{{item.text}}</b>\n                      <br>\n                      <small><i>{{item.smallText}}</i></small>\n                  </div>\n              </wj-menu-item>\n          </wj-menu>\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CedulasFiniquitosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: cedulafiniquito_service_1.CedulaFiniquitoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, cedulafiniquito_service_1.CedulaFiniquitoService])
    ], CedulasFiniquitosEditor);
    return CedulasFiniquitosEditor;
}(editors_1.CatalogEditor));
exports.CedulasFiniquitosEditor = CedulasFiniquitosEditor;
