import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, UsuarioItem, CatalogItem } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { MenuItem, ToolbarButton } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { DataMap } from 'wijmo/wijmo.grid';
import * as wjcCore from 'wijmo/wijmo';
import { Menu } from 'wijmo/wijmo.input';
import { EmpleadoListComponent } from '../controls/empleado-list.component';
import { ChecadorService } from '../services/checador.service';
import { FirmwareService } from '../services/firmware.service';
import { ChecadorInfo, ChecadorUsuarioIten } from '../models/checador';
import { FirmwareItem } from '../models/firmware';
import { EmpleadoItem } from '../models/empleado';
import { UsuariosListComponent } from 'framework3/security';
export declare class ChecadoresEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private checadorService;
    private firmwareSvc;
    checador: ChecadorInfo;
    firmwares: FirmwareItem[];
    usuarios: UsuarioItem[];
    currentItem: CatalogItem;
    cvUsuarios: wjcCore.CollectionView;
    itemsDeleted: any[];
    tipoUsuarioMap: DataMap;
    mnuEmpleadoItems: MenuItem[];
    selEmpleado: EmpleadoListComponent;
    usuariosDialog: UsuariosListComponent;
    tiposConexion: {
        'value': string;
        'name': string;
    }[];
    tipoUsuario: {
        'value': number;
        'name': string;
    }[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, checadorService: ChecadorService, firmwareSvc: FirmwareService);
    ngAfterViewInit(): void;
    createMenuDetail(): void;
    cargarFirmwares(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onTabSelected(args: any): void;
    onClickTestConnection(): void;
    onAgregarEmpleado(): void;
    onSelectedEmleado(item: any): void;
    onSelectedEmleados(items: EmpleadoItem[]): void;
    onRowDeleteUsuario(item: ChecadorUsuarioIten): void;
    onClickMnuEmpleado(menu: Menu): void;
    cloneInfo<T>(element: any): T;
    onToolbarButtonClick(button: ToolbarButton): void;
    onSelectedUsersChanged(newUsers: UsuarioItem[]): void;
    onRemoveUser(): void;
    onCurrentItemChanged(item: CatalogItem): void;
    refreshListAccess(): void;
}
