"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
var wijmo_grid_1 = require("wijmo/wijmo.grid");
var wjcCore = require("wijmo/wijmo");
//Controls
var empleado_list_component_1 = require("../controls/empleado-list.component");
//Features
var checador_service_1 = require("../services/checador.service");
var firmware_service_1 = require("../services/firmware.service");
var checador_1 = require("../models/checador");
var security_1 = require("framework3/security");
var ChecadoresEditor = /** @class */ (function (_super) {
    __extends(ChecadoresEditor, _super);
    function ChecadoresEditor(router, route, formBuilder, changeDetector, context, location, checadorService, firmwareSvc) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.checadorService = checadorService;
        _this.firmwareSvc = firmwareSvc;
        _this.checador = new checador_1.ChecadorInfo();
        _this.firmwares = [];
        //
        _this.cvUsuarios = new wjcCore.CollectionView();
        _this.itemsDeleted = [];
        _this.mnuEmpleadoItems = [];
        _this.tiposConexion = [
            { 'value': 'E', 'name': 'Ethernet' },
            { 'value': 'P', 'name': 'Puerto Serial' },
            { 'value': 'U', 'name': 'USB / Archivo' }
        ];
        _this.tipoUsuario = [
            { 'value': 1, 'name': 'Grabador' },
            { 'value': 2, 'name': 'Administrador' },
            { 'value': 3, 'name': 'Supervisor' },
            { 'value': 0, 'name': 'Normal' }
        ];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idBranch': [''],
            'ordenDescarga': [''],
            'sincronizarReloj': [''],
            'licencia': [''],
            'tipoConexion': ['', forms_1.Validators.required],
            'direccionIP': [''],
            'puerto': [0],
            'password': [''],
            'idFirmware': [0],
            'enlaceRemoto': [false],
            'direccionEnlace': [''],
            'puertoEnlace': [0]
        });
        _this.cvUsuarios = new wjcCore.CollectionView();
        _this.cvUsuarios.collectionChanged.addHandler(function (sender, args) {
            if (args.action == wijmo_1.NotifyCollectionChangedAction.Change && args.item != null) {
                args.item.state = core_2.ChangeState.MODIFIED;
            }
        });
        _this.tipoUsuarioMap = new wijmo_grid_1.DataMap(_this.tipoUsuario, 'value', 'name');
        return _this;
    }
    ChecadoresEditor_1 = ChecadoresEditor;
    ChecadoresEditor.prototype.ngAfterViewInit = function () {
        var _this = this;
        _super.prototype.ngAfterViewInit.call(this);
        setTimeout(function (_) {
            _this.createMenuDetail();
        });
    };
    ChecadoresEditor.prototype.createMenuDetail = function () {
        var mnuAsignar = { icon: "glyphicon glyphicon-pencil", text: "Asignar empleado", name: "ASIGNAR", smallText: "asignar empleado" };
        this.mnuEmpleadoItems.push(mnuAsignar);
        this.mnuEmpleadoItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    ///////////////////////// METODOS ///////////////////////////////////////
    ChecadoresEditor.prototype.cargarFirmwares = function () {
        var _this = this;
        this.firmwareSvc.loadCbo(this.context.app.defaultSite.identity)
            .then(function (firmwares) {
            _this.firmwares = firmwares;
            _this.firmwares.unshift({ id: 0, codigo: '', nombre: '[NINGUNO]', activo: true });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ChecadoresEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.cargarFirmwares();
    };
    ChecadoresEditor.prototype.onCreatingItem = function () {
        this.cvUsuarios.sourceCollection = this.cloneInfo(this.checador.usuarios);
    };
    ChecadoresEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.checadorService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.checador = info;
            _this.cvUsuarios.sourceCollection = _this.cloneInfo(_this.checador.usuarios);
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ChecadoresEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.checadorService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.checador = info;
            _this.cvUsuarios.sourceCollection = _this.cloneInfo(_this.checador.usuarios);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ChecadoresEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.checadorService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.checador = info;
            _this.cvUsuarios.sourceCollection = _this.cloneInfo(_this.checador.usuarios);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ChecadoresEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        var items = [];
        this.checador.usuarios = items.concat(this.cvUsuarios.items, this.itemsDeleted);
        this.checadorService.update(this.checador)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.checador.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.checador = info;
            _this.cvUsuarios.sourceCollection = _this.cloneInfo(_this.checador.usuarios);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ChecadoresEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            wijmo_1.Control.invalidateAll();
        }
    };
    ChecadoresEditor.prototype.onClickTestConnection = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.checadorService.testConnection(this.checador)
            .then(function (result) {
            if (result) {
                _this.showAlert('Conexión exitosa', 'success');
            }
            else {
                _this.showAlert('Conexión exitosa', 'danger');
            }
            _this.context.app.hideSpinner();
        }).
            catch(function (error) { return _this.handleError(error); });
    };
    ChecadoresEditor.prototype.onAgregarEmpleado = function () {
        this.selEmpleado.multiSelect = true;
        this.selEmpleado.show();
    };
    ChecadoresEditor.prototype.onSelectedEmleado = function (item) {
        var currentItem = this.cvUsuarios.currentItem;
        if (currentItem) {
            this.cvUsuarios.editItem(currentItem);
            currentItem.idEmpleado = item.id;
            currentItem.empleado = item.data;
            currentItem.codigo = item.data.codigo;
            currentItem.state = core_2.ChangeState.MODIFIED;
            this.cvUsuarios.commitEdit();
        }
    };
    ChecadoresEditor.prototype.onSelectedEmleados = function (items) {
        var _this = this;
        var elements = this.cvUsuarios.sourceCollection;
        items.forEach(function (item) {
            var empleado = null;
            elements.forEach(function (element) {
                if (item.id == element.id) {
                    empleado = item;
                }
            });
            if (empleado == null) {
                var element = _this.cvUsuarios.addNew();
                element.idEmpleado = item.id;
                element.empleado = item;
                element.codigo = item.codigo;
                element.activo = true;
                element.afectaIncidencia = true;
                element.tipo = 0;
                element.state = core_2.ChangeState.MODIFIED;
                _this.cvUsuarios.commitNew();
            }
        });
    };
    ChecadoresEditor.prototype.onRowDeleteUsuario = function (item) {
        item.state = core_2.ChangeState.DELETED;
        this.itemsDeleted.push(item);
        this.cvUsuarios.remove(item);
    };
    ChecadoresEditor.prototype.onClickMnuEmpleado = function (menu) {
        var option = this.mnuEmpleadoItems[menu.selectedIndex];
        if (option.name == "ASIGNAR") {
            this.selEmpleado.multiSelect = false;
            this.selEmpleado.show();
        }
    };
    ChecadoresEditor.prototype.cloneInfo = function (element) {
        return JSON.parse(JSON.stringify(element));
    };
    ChecadoresEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.usuariosDialog.show();
        }
    };
    ChecadoresEditor.prototype.onSelectedUsersChanged = function (newUsers) {
        var _this = this;
        this.context.app.showSpinner();
        this.checadorService.addUser(this.checador.identity, this.context.session.user.identity, newUsers)
            .then(function (_) {
            _this.context.app.hideSpinner();
            //this.alerts.showAlert('Los usuarios han sido agregados con éxito.', 'success');
            _this.refreshListAccess();
        })
            .catch(function (error) { return _this.handleError(error); });
        console.log(JSON.stringify(this.usuarios));
    };
    ChecadoresEditor.prototype.onRemoveUser = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.checadorService.removeUser(this.currentItem.id)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.usuarios = _this.usuarios.filter(function (item) { return item.id != _this.currentItem.id; });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ChecadoresEditor.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    ChecadoresEditor.prototype.refreshListAccess = function () {
        var _this = this;
        if (this.checador.identity > 0) {
            this.context.app.showSpinner();
            this.checadorService.loadAccessUsersList(this.checador.identity)
                .then(function (usuarios) {
                _this.usuarios = usuarios;
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    var ChecadoresEditor_1;
    __decorate([
        core_1.ViewChild(empleado_list_component_1.EmpleadoListComponent),
        __metadata("design:type", empleado_list_component_1.EmpleadoListComponent)
    ], ChecadoresEditor.prototype, "selEmpleado", void 0);
    __decorate([
        core_1.ViewChild(security_1.UsuariosListComponent),
        __metadata("design:type", security_1.UsuariosListComponent)
    ], ChecadoresEditor.prototype, "usuariosDialog", void 0);
    ChecadoresEditor = ChecadoresEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-checador-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Checador'\"\n                                 [info]=\"checador\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"checador.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"checador.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Orden de descarga:'\">\n                                          <az-input-number formControlName=\"ordenDescarga\"\n                                                           [(ngModel)]=\"checador.ordenDescarga\"\n                                                           [min]=\"0\"\n                                                           [max]=\"1000\">\n                                          </az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <az-checkbox [label]=\"'Sincronizar reloj al conectar'\"\n                                                   formControlName=\"sincronizarReloj\"\n                                                   [(ngModel)]=\"checador.sincronizarReloj\">\n                                      </az-checkbox>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Licencia:'\">\n                                          <az-textbox formControlName=\"licencia\"\n                                                      [(ngModel)]=\"checador.licencia\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-6\">\n                                      <button class=\"btn btn-primary\">Registrar</button>\n                                  </div>\n                              </div>\n                          </tab>\n                          <tab heading=\"Comunicaci\u00F3n\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Medio de comunicaci\u00F3n:'\">\n                                          <az-combobox formControlName=\"tipoConexion\"\n                                                       [(ngModel)]=\"checador.tipoConexion\"\n                                                       [items]=\"tiposConexion\"\n                                                       [displayMember]=\"'name'\"\n                                                       [valueMember]=\"'value'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Direcci\u00F3n IP:'\">\n                                          <az-textbox formControlName=\"direccionIP\"\n                                                      [(ngModel)]=\"checador.direccionIp\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Puerto:'\">\n                                          <az-input-number formControlName=\"puerto\"\n                                                           decimal=\"false\"\n                                                           [(ngModel)]=\"checador.puerto\"\n                                                           [format]=\"'n0'\"\n                                                           [min]=\"0\" [max]=\"999999\">\n                                          </az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Password:'\">\n                                          <az-password formControlName=\"password\"\n                                                       [(ngModel)]=\"checador.password\">\n                                          </az-password>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-6\">\n                                      <button class=\"btn btn-primary\" (click)=\"onClickTestConnection()\">Probar Conex&oacute;n</button>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Firmware:'\">\n                                          <az-combobox formControlName=\"idFirmware\"\n                                                       [(ngModel)]=\"checador.idFirmware\"\n                                                       [items]=\"firmwares\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\"></az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <az-checkbox [label]=\"'Enlace remoto'\"\n                                                   formControlName=\"enlaceRemoto\"\n                                                   [(ngModel)]=\"checador.enlaceRemoto\">\n                                      </az-checkbox>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Direcci\u00F3n Enlace:'\">\n                                          <az-textbox formControlName=\"direccionEnlace\"\n                                                      [(ngModel)]=\"checador.direccionEnlace\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Puerto Enlace:'\">\n                                          <az-input-number formControlName=\"puertoEnlace\"\n                                                           decimal=\"false\"\n                                                           [(ngModel)]=\"checador.puertoEnlace\"\n                                                           [format]=\"'n0'\"\n                                                           [min]=\"0\" [max]=\"999999\">\n                                          </az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                          <tab heading=\"Empleados\" (select)=\"onTabSelected($event)\">\n                              <div class=\"row\">\n                                  <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAgregarEmpleado()\">\n                                      <span aria-hidden=\"true\" class=\"glyphicon glyphicon-plus\"></span>\n                                      Agregar\n                                  </button>\n                              </div>\n                              <wj-flex-grid #grdUsuario\n                                            style=\"height:500px\"\n                                            [(itemsSource)]=\"cvUsuarios\"\n                                            [selectionMode]=\"'Row'\"\n                                            [wjContextMenu]=\"ctxMenuEmpleado\">\n                                  <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                  <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRowDeleteUsuario(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-remove\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'empleado.codigo'\" [width]=\"80\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Empleado'\" [binding]=\"'empleado.nombre'\" [width]=\"'140*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'C\u00F3digo Checador'\" [binding]=\"'codigo'\" [width]=\"80\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Nombre Corto'\" [binding]=\"'nombre'\" [width]=\"180\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Tipo'\" [binding]=\"'tipo'\" [width]=\"100\" [dataMap]=\"tipoUsuarioMap\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Kardex'\" [binding]=\"'afectaIncidencia'\" [width]=\"80\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Activo'\" [binding]=\"'activo'\" [width]=\"80\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </tab>\n                          <tab heading=\"Accesos\" (select)=\"refreshListAccess()\">\n                              <div class=\"col-12 col-md-10\">\n                                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                      <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar Usuarios'\" [icon]=\"'glyphicon glyphicon-plus'\" [enabled]=\"checador.identity>0\"></az-toolbar-button>\n                                  </az-toolbar>\n\n                                  <!-- Lista de usuarios-->\n                                  <azteca-catalog-list [catalogList]=\"usuarios\"\n                                                       [showRowButton]=\"true\"\n                                                       [rowButtonIcon]=\"'glyphicon glyphicon-trash'\"\n                                                       (rowButtonClick)=\"onRemoveUser()\"\n                                                       (currentItemChanged)=\"onCurrentItemChanged($event)\"\n                                                       [enabled]=\"enabled\"\n                                                       [pageSize]=\"15\"\n                                                       [serverSide]=\"false\">\n\n                                      <azteca-grid-column [header]=\"'Usuario'\" [binding]=\"'codigo'\" [width]=\"'20*'\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'40*'\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Dominio'\" [binding]=\"'dominio'\" [width]=\"'20*'\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Correo'\" [binding]=\"'correo'\" [width]=\"'20*'\"></azteca-grid-column>\n\n                                  </azteca-catalog-list>\n                              </div>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n              <security-usuarios-list (selectedItemsChanged)=\"onSelectedUsersChanged($event)\"\n                                      [excludedItems]=\"usuarios\"\n                                      [multiSelect]=\"true\">\n              </security-usuarios-list>\n          </azteca-catalog-editor>\n      </form>\n\n      <rh-empleado-list (selectedItemsChanged)=\"onSelectedEmleados($event)\"\n                        (selectedItemChanged)=\"onSelectedEmleado($event)\"\n                        [multiSelect]=\"true\">\n      </rh-empleado-list>\n\n      <wj-menu #ctxMenuEmpleado (itemClicked)=\"onClickMnuEmpleado(ctxMenuEmpleado)\" style=\"display:none\">\n          <wj-menu-item *ngFor=\"let item of mnuEmpleadoItems\">\n              <div *ngIf=\"item.enabled\">\n                  <span [class]=\"item.icon\"></span>\n                  <b>{{item.text}}</b>\n                  <br>\n                  <small><i>{{item.smallText}}</i></small>\n              </div>\n          </wj-menu-item>\n      </wj-menu>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ChecadoresEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: checador_service_1.ChecadorService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, checador_service_1.ChecadorService, firmware_service_1.FirmwareService])
    ], ChecadoresEditor);
    return ChecadoresEditor;
}(editors_1.CatalogEditor));
exports.ChecadoresEditor = ChecadoresEditor;
