"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var clase_nomina_service_1 = require("../services/clase-nomina.service");
var clase_nomina_1 = require("../models/clase-nomina");
var ClasesNominasEditor = /** @class */ (function (_super) {
    __extends(ClasesNominasEditor, _super);
    //
    function ClasesNominasEditor(router, route, formBuilder, changeDetector, context, location, claseNominaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.claseNominaService = claseNominaService;
        _this.claseNomina = new clase_nomina_1.ClaseNominaInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'claseNomina': [''],
            'idCompania': [0],
            'descripcion': [0],
            'parametro': []
        });
        return _this;
    }
    ClasesNominasEditor_1 = ClasesNominasEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ClasesNominasEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    ClasesNominasEditor.prototype.onCreatingItem = function () {
    };
    ClasesNominasEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.claseNominaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.claseNomina = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClasesNominasEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.claseNominaService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.claseNomina = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClasesNominasEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.claseNominaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.claseNomina = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClasesNominasEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.claseNominaService.update(this.claseNomina)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.claseNomina.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.claseNomina = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClasesNominasEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    var ClasesNominasEditor_1;
    ClasesNominasEditor = ClasesNominasEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-clase-nomina-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'ClaseNomina'\"\n                                 [info]=\"claseNomina\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"claseNomina.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"claseNomina.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Compa&ntilde;&iacute;a:'\">\n                                          <rh-compania-selector formControlName=\"idCompania\"\n                                                                [(ngModel)]=\"claseNomina.idCompania\"\n                                                                [enabled]=\"true\"></rh-compania-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Descripci&oacute;n:'\">\n                                          <az-textarea formControlName=\"descripcion\" [(ngModel)]=\"claseNomina.descripcion\"></az-textarea>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </tab>\n\n                          <tab heading=\"Parametros\" (select)=\"onTabSelected($event)\">\n                              <rh-parametros-editor formControlName=\"parametro\" \n                                                    [(ngModel)]=\"claseNomina.parametros\">\n                              </rh-parametros-editor>\n                          </tab>\n\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ClasesNominasEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: clase_nomina_service_1.ClaseNominaService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, clase_nomina_service_1.ClaseNominaService])
    ], ClasesNominasEditor);
    return ClasesNominasEditor;
}(editors_1.CatalogEditor));
exports.ClasesNominasEditor = ClasesNominasEditor;
