import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { ModalDirective } from 'ngx-bootstrap';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs, EditableListComponent } from 'framework3/editors';
import { CompaniaService } from '../services/compania.service';
import { CompaniaInfo, CompaniaParametroItem } from '../models/compania';
export declare class CompaniasEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private companiaService;
    compania: CompaniaInfo;
    newParameter: CompaniaParametroItem;
    dlgParameter: ModalDirective;
    editListParametros: EditableListComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, companiaService: CompaniaService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onTabSelected(args: any): void;
}
