import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormGroup } from '@angular/forms';
import { Location } from '@angular/common';
import { ModalDirective } from 'ngx-bootstrap';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs, EditableListComponent } from 'framework3/editors';
import { ConceptoAdamService } from '../services/concepto-adam.service';
import { ConceptoAdamInfo, ConceptoExpresionItem } from '../models/concepto-adam';
export declare class ConceptosAdamEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private conceptoAdamService;
    formExpresion: FormGroup;
    conceptoAdam: ConceptoAdamInfo;
    expresion: ConceptoExpresionItem;
    dlgExpresion: ModalDirective;
    editListExpresion: EditableListComponent;
    tipoPerDedSelected: string;
    tiposTransaccion: Array<any>;
    tiposGrupo: Array<any>;
    tipoExpresion: Array<any>;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, conceptoAdamService: ConceptoAdamService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onSelectedTipoTransaccion(args: any): void;
    onTabSelected(args: any): void;
    onAddingItemExpresion(): void;
    onEditingItemExpresion(item: ConceptoExpresionItem): void;
    onDeletingItemExpresion(item: ConceptoExpresionItem): void;
    onListItemUpdatedExpresion(expresiones: ConceptoExpresionItem[]): void;
    onUpdateExpresion(): void;
    createClientID(): number;
    cloneInfo<T>(element: any): T;
}
