"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//moment
var moment = require("moment");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var concepto_adam_service_1 = require("../services/concepto-adam.service");
var concepto_adam_1 = require("../models/concepto-adam");
var ConceptosAdamEditor = /** @class */ (function (_super) {
    __extends(ConceptosAdamEditor, _super);
    function ConceptosAdamEditor(router, route, formBuilder, changeDetector, context, location, conceptoAdamService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.conceptoAdamService = conceptoAdamService;
        _this.conceptoAdam = new concepto_adam_1.ConceptoAdamInfo();
        _this.expresion = new concepto_adam_1.ConceptoExpresionItem();
        //
        _this.tipoPerDedSelected = '';
        _this.tiposTransaccion = [
            { id: 1, nombre: 'Percepción', value: 'Percepciones' },
            { id: 2, nombre: 'Deducción', value: 'Deducciones' },
            { id: 3, nombre: 'Otros Pagos', value: 'Otros Pagos' },
            { id: 4, nombre: 'Incapacidad', value: 'Incapacidades' }
        ];
        _this.tiposGrupo = [
            { tipo: "I", nombre: "Importe" },
            { tipo: "G", nombre: "Gravado" },
            { tipo: "E", nombre: "Exento" },
            { tipo: "O", nombre: "Otro" }
        ];
        _this.tipoExpresion = [
            { tipo: "C", nombre: "Codigo" },
            { tipo: "S", nombre: "SQL Sentencia" }
        ];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'concepto': [''],
            'descripcion': ['', forms_1.Validators.required],
            'abreviatura': [''],
            'tipoTransaccion': ['', controls_1.AztecaValidators.selected],
            'tipoPerDed': [''],
            'compania': [''],
            'indemnizacion': [''],
            'deudorInterno': [''],
            'acumulable': ['']
        });
        _this.formExpresion = formBuilder.group({
            'expresionCodigo': ['', forms_1.Validators.required],
            'expresionNombre': ['', forms_1.Validators.required],
            'expresionOrden': ['', forms_1.Validators.required],
            'expresionTipo': ['', forms_1.Validators.required],
            'expresionGrupo': ['', forms_1.Validators.required],
            'expresionCode': ['']
        });
        return _this;
    }
    ConceptosAdamEditor_1 = ConceptosAdamEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ConceptosAdamEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    ConceptosAdamEditor.prototype.onCreatingItem = function () {
    };
    ConceptosAdamEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.conceptoAdamService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.conceptoAdam = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosAdamEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.conceptoAdamService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.conceptoAdam = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosAdamEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.conceptoAdamService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.conceptoAdam = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosAdamEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.conceptoAdamService.update(this.conceptoAdam)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.conceptoAdam.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.conceptoAdam = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosAdamEditor.prototype.onSelectedTipoTransaccion = function (args) {
        var _this = this;
        this.tiposTransaccion.forEach(function (item) {
            if (item.id == args) {
                _this.tipoPerDedSelected = item.value;
            }
        });
    };
    ConceptosAdamEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////////////////// Expresiones ///////////////////////////////////////
    ConceptosAdamEditor.prototype.onAddingItemExpresion = function () {
        this.expresion = new concepto_adam_1.ConceptoExpresionItem();
        this.expresion._clientID = this.createClientID();
        this.dlgExpresion.config.backdrop = false;
        this.dlgExpresion.show();
    };
    ConceptosAdamEditor.prototype.onEditingItemExpresion = function (item) {
        this.expresion = this.cloneInfo(item);
        this.dlgExpresion.config.backdrop = false;
        this.dlgExpresion.show();
    };
    ConceptosAdamEditor.prototype.onDeletingItemExpresion = function (item) {
        this.editListExpresion.deleteItem(item);
    };
    ConceptosAdamEditor.prototype.onListItemUpdatedExpresion = function (expresiones) {
        this.conceptoAdam.expresiones = expresiones;
    };
    ConceptosAdamEditor.prototype.onUpdateExpresion = function () {
        var item = this.cloneInfo(this.expresion);
        this.editListExpresion.updateItem(item);
        this.dlgExpresion.hide();
    };
    ConceptosAdamEditor.prototype.createClientID = function () {
        return parseInt((Math.random() * 1000).toString()) * 1000 + parseInt(moment().format("HHmmss"));
    };
    ConceptosAdamEditor.prototype.cloneInfo = function (element) {
        return JSON.parse(JSON.stringify(element));
    };
    var ConceptosAdamEditor_1;
    __decorate([
        core_1.ViewChild('dlgExpresion'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ConceptosAdamEditor.prototype, "dlgExpresion", void 0);
    __decorate([
        core_1.ViewChild('editListExpresiones'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], ConceptosAdamEditor.prototype, "editListExpresion", void 0);
    ConceptosAdamEditor = ConceptosAdamEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-concepto-adam-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Concepto ADAM'\"\n                                 [info]=\"conceptoAdam\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"conceptoAdam.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Concepto:'\">\n                          <az-input-number formControlName=\"concepto\" \n                                           [(ngModel)]=\"conceptoAdam.concepto\" \n                                           [format]=\"'n0'\" \n                                           [min]=\"0\"></az-input-number>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Descripci&oacute;n:'\">\n                                          <az-textbox formControlName=\"descripcion\" [(ngModel)]=\"conceptoAdam.descripcion\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Abreviatura:'\">\n                                          <az-textbox formControlName=\"abreviatura\" [(ngModel)]=\"conceptoAdam.abreviatura\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Tipo transacci&oacute;n:'\">\n                                          <az-combobox formControlName=\"tipoTransaccion\"\n                                                       [(ngModel)]=\"conceptoAdam.tipoTransaccion\"\n                                                       [items]=\"tiposTransaccion\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       (selectedItemChanged)=\"onSelectedTipoTransaccion($event)\"></az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Tipo transacci&oacute;n:'\">\n                                          <rh-tipo-per-ded-selector formControlName=\"tipoPerDed\"\n                                                                    [(ngModel)]=\"conceptoAdam.idTipoPerDed\"\n                                                                    [enabled]=\"conceptoAdam.tipoTransaccion > 0\"\n                                                                    [tipoPerDedSelector]=\"tipoPerDedSelected\"></rh-tipo-per-ded-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Compa&ntilde;&iacute;a:'\">\n                                          <rh-compania-selector formControlName=\"compania\"\n                                                                [(ngModel)]=\"conceptoAdam.idCompania\"\n                                                                [enabled]=\"true\"></rh-compania-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <az-checkbox [label]=\"'Concepto (Indemnizacion)'\"\n                                                   formControlName=\"indemnizacion\"\n                                                   [(ngModel)]=\"conceptoAdam.indemnizacion\">\n                                      </az-checkbox>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <az-checkbox [label]=\"'Concepto (Deudor Interno)'\"\n                                                   formControlName=\"deudorInterno\"\n                                                   [(ngModel)]=\"conceptoAdam.deudorInterno\">\n                                      </az-checkbox>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <az-checkbox [label]=\"'Concepto (Acumulable)'\"\n                                                   formControlName=\"acumulable\"\n                                                   [(ngModel)]=\"conceptoAdam.acumulable\">\n                                      </az-checkbox>\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <tab heading=\"Expresiones\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #editListExpresiones\n                                                    [allowNew]=\"true\"\n                                                    [allowEdit]=\"true\"\n                                                    [listItems]=\"conceptoAdam.expresiones\"\n                                                    (addingItem)=\"onAddingItemExpresion()\"\n                                                    (editingItem)=\"onEditingItemExpresion($event)\"\n                                                    (listItemsUpdated)=\"onListItemUpdatedExpresion($event)\"\n                                                    (deletingItem)=\"onDeletingItemExpresion($event)\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"180\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'180*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Orden'\" [binding]=\"'orden'\" [width]=\"'90*'\"></azteca-grid-column>\n                              </azteca-editable-list>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n\n      <div bsModal #dlgExpresion=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\">Expresi&oacute;n</h4>\n                  </div>\n                  <div class=\"modal-body\" [formGroup]=\"formExpresion\">\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-4\">\n                              <azteca-form-field [label]=\"'C&oacute;digo:'\">\n                                  <az-textbox formControlName=\"expresionCodigo\" [(ngModel)]=\"expresion.codigo\"></az-textbox>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-8\">\n                              <azteca-form-field [label]=\"'Nombre:'\">\n                                  <az-textbox formControlName=\"expresionNombre\" [(ngModel)]=\"expresion.nombre\"></az-textbox>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-4\">\n                              <azteca-form-field [label]=\"'Orden:'\">\n                                  <az-input-number formControlName=\"expresionOrden\"\n                                                   decimal=\"false\"\n                                                   [(ngModel)]=\"expresion.orden\"\n                                                   [format]=\"'n0'\"\n                                                   [min]=\"1\"\n                                                   [max]=\"100\">\n                                  </az-input-number>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-4\">\n                              <azteca-form-field [label]=\"'Tipo:'\">\n                                  <az-combobox formControlName=\"expresionTipo\"\n                                               [(ngModel)]=\"expresion.tipoExpresion\"\n                                               [items]=\"tipoExpresion\"\n                                               [valueMember]=\"'tipo'\"\n                                               [displayMember]=\"'nombre'\"></az-combobox>\n                              </azteca-form-field>\n                          </div>\n\n                          <div class=\"col-12 col-md-4\">\n                              <azteca-form-field [label]=\"'Grupo:'\">\n                                  <az-combobox formControlName=\"expresionGrupo\"\n                                               [(ngModel)]=\"expresion.grupo\"\n                                               [items]=\"tiposGrupo\"\n                                               [valueMember]=\"'tipo'\"\n                                               [displayMember]=\"'nombre'\"></az-combobox>\n                              </azteca-form-field>\n                          </div>\n\n                      </div>\n\n                      <az-code-editor formControlName=\"expresionCode\"\n                                      [language]=\"'csharp'\"\n                                      [theme]=\"'chrome'\"\n                                      [(ngModel)]=\"expresion.expresion\">\n                      </az-code-editor>\n                  </div>\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdateExpresion()\" [disabled]=\"!formExpresion.valid\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-danger\" (click)=\"dlgExpresion.hide()\">Cancelar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ConceptosAdamEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: concepto_adam_service_1.ConceptoAdamService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, concepto_adam_service_1.ConceptoAdamService])
    ], ConceptosAdamEditor);
    return ConceptosAdamEditor;
}(editors_1.CatalogEditor));
exports.ConceptosAdamEditor = ConceptosAdamEditor;
