"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var conceptos_fichas_service_1 = require("../services/conceptos-fichas.service");
var concepto_ficha_1 = require("../models/concepto-ficha");
var ConceptosFichasEditor = /** @class */ (function (_super) {
    __extends(ConceptosFichasEditor, _super);
    //
    function ConceptosFichasEditor(router, route, formBuilder, changeDetector, context, location, conceptosFichasService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.conceptosFichasService = conceptosFichasService;
        _this.conceptosFichas = new concepto_ficha_1.ConceptosFichasInfo();
        _this.afectador = [{ 'Id': 'C', 'Nombre': 'Cargo' }, { 'Id': 'A', 'Nombre': 'Abono' }];
        _this.mascaraCuenta = '';
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'cuenta': ['', forms_1.Validators.required],
            'afectador': ['', forms_1.Validators.required],
            'isEmpleado': [false],
            'negativo': [false]
        });
        return _this;
    }
    ConceptosFichasEditor_1 = ConceptosFichasEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ConceptosFichasEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    ConceptosFichasEditor.prototype.onCreatingItem = function () {
        this.mascara = 'XXX-00-00000';
    };
    ConceptosFichasEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.conceptosFichasService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.conceptosFichas = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosFichasEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.conceptosFichasService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.conceptosFichas = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosFichasEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.conceptosFichasService.getDetailByID(id)
            .then(function (info) {
            _this.onIsEmpleadoChange(info.isEmpleado);
            setTimeout(function () {
                _this.context.app.hideSpinner();
                _this.conceptosFichas = info;
                _this.mascaraCuenta = _this.conceptosFichas.mascaraCuenta;
            }, 500);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosFichasEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        if (!this.mascaraCuenta.includes('_')) {
            this.context.app.showSpinner();
            this.conceptosFichas.mascaraCuenta = this.mascaraCuenta;
            this.conceptosFichasService.update(this.conceptosFichas)
                .then(function (info) {
                _this.context.app.hideSpinner();
                _this.reset();
                //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
                if (!args.closeEditor && _this.conceptosFichas.identity == 0) {
                    _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
                }
                else {
                    if (args.closeEditor)
                        _this.router.navigate(['../'], { relativeTo: _this.route });
                    else
                        _this.showAlert('La información ha sido actualizada con éxito', 'success');
                }
                _this.conceptosFichas = info;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else
            this.showAlert('La mascara de la cuenta no esta completa', 'danger');
    };
    ConceptosFichasEditor.prototype.onIsEmpleadoChange = function (value) {
        if (value)
            this.mascara = '000-00-XXXXX';
        else
            this.mascara = 'XXX-00-00000';
    };
    var ConceptosFichasEditor_1;
    ConceptosFichasEditor = ConceptosFichasEditor_1 = __decorate([
        core_1.Component({
            selector: 'azteca.business.rh-conceptos-fichas-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'ConceptosFichas'\"\n                                 [info]=\"conceptosFichas\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"conceptosFichas.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"conceptosFichas.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\">\n                              <div class=\"row\">\n                                  <div class=\"col-sm-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Mascara de Cuenta:'\">\n                                          <wj-input-mask mask=\"{{mascara}}\"\n                                                         title=\"Cuenta: {{mascara}}\"\n                                                         formControlName=\"cuenta\"\n                                                         [(ngModel)]=\"mascaraCuenta\" style=\"margin-left: 10px; margin-top: 10px;\">\n                                          </wj-input-mask>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-sm-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Afectador:'\">\n                                          <az-combobox formControlName=\"afectador\" [items]=\"afectador\" [displayMember]=\"'Nombre'\" [valueMember]=\"'Id'\" [(ngModel)]=\"conceptosFichas.afectador\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-sm-12 col-md-3\">\n                                      <az-checkbox formControlName=\"isEmpleado\" (checkedChanged)=\"onIsEmpleadoChange($event)\" [(ngModel)]=\"conceptosFichas.isEmpleado\" [label]=\"'Es cuenta de empleado'\">\n                                      </az-checkbox>\n                                  </div>\n                                  <div class=\"col-sm-12 col-md-3\">\n                                      <az-checkbox formControlName=\"negativo\" [(ngModel)]=\"conceptosFichas.negativo\" [label]=\"'Negativo'\">\n                                      </az-checkbox>\n                                  </div>\n                              </div>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ConceptosFichasEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: conceptos_fichas_service_1.ConceptosFichasService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, conceptos_fichas_service_1.ConceptosFichasService])
    ], ConceptosFichasEditor);
    return ConceptosFichasEditor;
}(editors_1.CatalogEditor));
exports.ConceptosFichasEditor = ConceptosFichasEditor;
