import { ChangeDetectorRef } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { TreeNode } from 'angular-tree-component';
import { Context, HierarchyChanges } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { HierarchyManager } from 'framework3/editors';
import { DepartamentoInfo } from '../models/departamento';
import { DepartamentoService } from '../services/departamento.service';
export declare class DepartamentosManager extends HierarchyManager {
    protected context: Context;
    protected changeDetector: ChangeDetectorRef;
    private formBuilder;
    private departamentoService;
    protected router: Router;
    protected route: ActivatedRoute;
    departamentos: DepartamentoInfo[];
    departamentoEdicion: DepartamentoInfo;
    currentNode: TreeNode;
    currentParent: TreeNode;
    constructor(context: Context, changeDetector: ChangeDetectorRef, formBuilder: FormBuilder, departamentoService: DepartamentoService, router: Router, route: ActivatedRoute);
    loadHierarchy(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onNodesChanged(departamentos: DepartamentoInfo[]): void;
    onCurrentNodeChanged(node: TreeNode): void;
    onCreatingNode(parentNode: TreeNode): void;
    onEditingNode(node: TreeNode): void;
    onSavingNode(): void;
    onDeletingNode(node: TreeNode): void;
    onSavingHierarchy(changes: HierarchyChanges<DepartamentoInfo>): void;
}
