"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
//
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//
var departamento_1 = require("../models/departamento");
var departamento_service_1 = require("../services/departamento.service");
var DepartamentosManager = /** @class */ (function (_super) {
    __extends(DepartamentosManager, _super);
    function DepartamentosManager(context, changeDetector, formBuilder, departamentoService, router, route) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.context = context;
        _this.changeDetector = changeDetector;
        _this.formBuilder = formBuilder;
        _this.departamentoService = departamentoService;
        _this.router = router;
        _this.route = route;
        _this.departamentos = [];
        _this.departamentoEdicion = new departamento_1.DepartamentoInfo();
        _this.nodeForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'cuenta': ['']
        });
        return _this;
    }
    DepartamentosManager_1 = DepartamentosManager;
    ////////////////////// METODOS //////////////////////////////////////////////
    DepartamentosManager.prototype.loadHierarchy = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.departamentoService.loadHierarchy(this.context.app.defaultCompany.identity, 0)
            .then(function (nodes) {
            _this.context.app.hideSpinner();
            _this.departamentos = nodes;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //////////////////// HANDLERS //////////////////////////////////////
    DepartamentosManager.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.loadHierarchy();
        //Hacer llamadas de carga inicial de datos aquí
    };
    DepartamentosManager.prototype.onNodesChanged = function (departamentos) {
        this.departamentos = departamentos;
    };
    DepartamentosManager.prototype.onCurrentNodeChanged = function (node) {
        this.currentNode = node;
    };
    DepartamentosManager.prototype.onCreatingNode = function (parentNode) {
        this.departamentoEdicion = new departamento_1.DepartamentoInfo(); //Crear nueva instancia para evitar que reset modifique la información del último nodo en edición
        this.nodeForm.reset();
        this.departamentoEdicion = new departamento_1.DepartamentoInfo(); //Se vuelve a crear instancia para evitar valores nulos creados por reset
        //Inicializar valores del nodo
        this.departamentoEdicion.idBranch = this.context.app.defaultSite.identity;
        this.departamentoEdicion.idCompany = this.context.app.defaultCompany.identity;
        //
        this.currentParent = parentNode;
        this.showEditor();
    };
    DepartamentosManager.prototype.onEditingNode = function (node) {
        this.departamentoEdicion = this.departamentoService.copy(node.data);
        this.showEditor();
    };
    DepartamentosManager.prototype.onSavingNode = function () {
        //Si es un nuevo nodo
        if (this.departamentoEdicion.clientID == 0) {
            this.addNode(this.departamentoEdicion, this.currentParent);
        }
        //Si se estaba editando un nodo existente
        else {
            this.updateNode(this.departamentoEdicion);
        }
        this.departamentoEdicion = new departamento_1.DepartamentoInfo();
        this.hideEditor();
    };
    DepartamentosManager.prototype.onDeletingNode = function (node) {
        this.deleteNode(node);
    };
    DepartamentosManager.prototype.onSavingHierarchy = function (changes) {
        var _this = this;
        this.context.app.showSpinner();
        this.departamentoService.saveHierarchy(changes)
            .then(function (departamentos) {
            _this.departamentos = departamentos;
            _this.reset();
            _this.context.app.hideSpinner();
            _this.showAlert('Los cambios han sido guardados con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var DepartamentosManager_1;
    DepartamentosManager = DepartamentosManager_1 = __decorate([
        core_1.Component({
            selector: 'rh-departamentos-manager',
            template: "\n      <azteca-hierarchy-manager (configureCatalog)=\"onConfigureCatalog($event)\"\n                                (currentNodeChanged)=\"onCurrentNodeChanged($event)\"\n                                (creatingNode)=\"onCreatingNode($event)\"\n                                (editingNode)=\"onEditingNode($event)\"\n                                (savingNode)=\"onSavingNode()\"\n                                (deletingNode)=\"onDeletingNode($event)\"\n                                (savingHierarchy)=\"onSavingHierarchy($event)\"\n                                (nodesChanged)=\"onNodesChanged($event)\"\n                                [title]=\"'Administraci\u00F3n de departamentos'\"\n                                [validForm]=\"nodeForm.valid\"\n                                [currentNode]=\"currentNode\"\n                                [nodes]=\"departamentos\">\n\n          <form [formGroup]=\"nodeForm\">\n              <div class=\"row\">\n\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"departamentoEdicion.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <label class=\"control-label\">Ruta:</label>\n                      <az-label [text]=\"departamentoEdicion.namedPath\"></az-label>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"departamentoEdicion.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Cuenta:'\">\n                          <accounting-cuenta-selector formControlName=\"cuenta\"\n                                                      [(ngModel)]=\"departamentoEdicion.idCuenta\">\n                          </accounting-cuenta-selector>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n          </form>\n\n      </azteca-hierarchy-manager>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return DepartamentosManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: departamento_service_1.DepartamentoService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, core_1.ChangeDetectorRef, forms_1.FormBuilder, departamento_service_1.DepartamentoService, router_1.Router, router_1.ActivatedRoute])
    ], DepartamentosManager);
    return DepartamentosManager;
}(editors_1.HierarchyManager));
exports.DepartamentosManager = DepartamentosManager;
