"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var dispositivo_nixtla_service_1 = require("../services/dispositivo-nixtla.service");
var dispositivo_nixtla_1 = require("../models/dispositivo-nixtla");
var DispositivosNixtlaEditor = /** @class */ (function (_super) {
    __extends(DispositivosNixtlaEditor, _super);
    //
    function DispositivosNixtlaEditor(router, route, formBuilder, changeDetector, context, location, dispositivoNixtlaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.dispositivoNixtlaService = dispositivoNixtlaService;
        _this.dispositivoNixtla = new dispositivo_nixtla_1.DispositivoNixtlaInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'imei': ['', forms_1.Validators.required],
            'codigoEmpleado': ['', forms_1.Validators.required]
        });
        return _this;
    }
    DispositivosNixtlaEditor_1 = DispositivosNixtlaEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    DispositivosNixtlaEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    DispositivosNixtlaEditor.prototype.onCreatingItem = function () {
    };
    DispositivosNixtlaEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.dispositivoNixtlaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.dispositivoNixtla = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DispositivosNixtlaEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.dispositivoNixtlaService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.dispositivoNixtla = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DispositivosNixtlaEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.dispositivoNixtlaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.dispositivoNixtla = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DispositivosNixtlaEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.dispositivoNixtlaService.update(this.dispositivoNixtla)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.dispositivoNixtla.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.dispositivoNixtla = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var DispositivosNixtlaEditor_1;
    DispositivosNixtlaEditor = DispositivosNixtlaEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-dispositivo-nixtla-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'DispositivoNixtla'\"\n                                 [info]=\"dispositivoNixtla\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"dispositivoNixtla.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Dispositivo:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"dispositivoNixtla.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'IMEI:'\">\n                                          <az-textbox formControlName=\"imei\" [(ngModel)]=\"dispositivoNixtla.iMEI\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'C&oacute;digo Empleado:'\">\n                                          <az-textbox formControlName=\"codigoEmpleado\" [(ngModel)]=\"dispositivoNixtla.codigoEmpleado\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return DispositivosNixtlaEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: dispositivo_nixtla_service_1.DispositivoNixtlaService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, dispositivo_nixtla_service_1.DispositivoNixtlaService])
    ], DispositivosNixtlaEditor);
    return DispositivosNixtlaEditor;
}(editors_1.CatalogEditor));
exports.DispositivosNixtlaEditor = DispositivosNixtlaEditor;
