import { OnInit, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormControl } from '@angular/forms';
import { Location } from '@angular/common';
import { ModalDirective } from 'ngx-bootstrap';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { MenuItem } from 'framework3/controls';
import { EmpleadoService } from '../services/empleado.service';
import { EmpleadoInfo } from '../models/empleado';
import { TipoRegimenItem } from '../../accounting/models/tipo-regimen';
import { TipoRegimenService } from '../../accounting/services/tipo-regimen.service';
import { TipoContratoItem } from '../../accounting/models/tipo-contrato';
import { TipoContratoService } from '../../accounting/services/tipo-contrato.service';
import { FormGroup } from '@angular/forms/src/model';
import { TurnoSelectorComponent } from '../components/turno-selector.component';
export declare class EmpleadosEditor extends CatalogEditor implements OnInit {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private empleadoService;
    private tipoRegimenSvc;
    private tipoContratoSvc;
    empleado: EmpleadoInfo;
    tiposRegimen: TipoRegimenItem[];
    tiposContrato: TipoContratoItem[];
    formCambioTurno: FormGroup;
    formPasswd: FormGroup;
    idTurnoCambio: number;
    cambioTurnoFechaIni: Date;
    userContrasena: string;
    dlgCambioTurno: ModalDirective;
    dlgPasswd: ModalDirective;
    selTurno: TurnoSelectorComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, empleadoService: EmpleadoService, tipoRegimenSvc: TipoRegimenService, tipoContratoSvc: TipoContratoService);
    ngOnInit(): void;
    loadTiposRegimen(): void;
    loadTiposContrato(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onTabSelected(args: any): void;
    onMenuItemClick(option: MenuItem): void;
    onClickCambioTurno(): void;
    onClickCambioTurnoAceptar(): void;
    onClickPasswdAceptar(): void;
    validateFecha(control: FormControl): string;
}
