"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
var wijmo_1 = require("wijmo/wijmo");
//moment
var moment = require("moment");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var empleado_service_1 = require("../services/empleado.service");
var empleado_1 = require("../models/empleado");
var tipo_regimen_service_1 = require("../../accounting/services/tipo-regimen.service");
var tipo_contrato_service_1 = require("../../accounting/services/tipo-contrato.service");
var turno_selector_component_1 = require("../components/turno-selector.component");
var EmpleadosEditor = /** @class */ (function (_super) {
    __extends(EmpleadosEditor, _super);
    //
    function EmpleadosEditor(router, route, formBuilder, changeDetector, context, location, empleadoService, tipoRegimenSvc, tipoContratoSvc) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.empleadoService = empleadoService;
        _this.tipoRegimenSvc = tipoRegimenSvc;
        _this.tipoContratoSvc = tipoContratoSvc;
        _this.empleado = new empleado_1.EmpleadoInfo();
        _this.tiposRegimen = [];
        _this.tiposContrato = [];
        _this.userContrasena = "";
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'apPaterno': ['', forms_1.Validators.required],
            'apMaterno': ['', forms_1.Validators.required],
            'foto': [null],
            'sexo': ['', forms_1.Validators.required],
            'cuenta': [''],
            'fechaNacimiento': [''],
            'fechaIngreso': [''],
            'correo': [''],
            'imss': [''],
            'rfc': ['', forms_1.Validators.required],
            'curp': [''],
            'titulo': [''],
            'calle': [''],
            'cruce1': [''],
            'cruce2': [''],
            'numExt': [''],
            'numInt': [''],
            'colonia': [''],
            'poblacion': [''],
            'departamento': [''],
            'turno': [''],
            'plaza': [''],
            'cp': [''],
            'tipoRegimen': [0],
            'claseNomina': [0],
            'tipoContrato': [0],
            'sindicalizado': [false],
            'parametro': ['']
        });
        _this.formCambioTurno = _this.formBuilder.group({
            'idTurnoCambio': ['', controls_1.AztecaValidators.selected],
            'cambioTurnoFechaIni': [new Date, function (control) { return _this.validateFecha(control); }],
        });
        _this.formPasswd = _this.formBuilder.group({
            'userContrasena': ['', forms_1.Validators.required],
        });
        return _this;
    }
    EmpleadosEditor_1 = EmpleadosEditor;
    EmpleadosEditor.prototype.ngOnInit = function () {
        var _this = this;
        setTimeout(function () {
            _this.loadTiposRegimen();
            _this.loadTiposContrato();
        });
    };
    ///////////////////////// METODOS ///////////////////////////////////////
    EmpleadosEditor.prototype.loadTiposRegimen = function () {
        var _this = this;
        this.tipoRegimenSvc.loadCbo()
            .then(function (info) {
            _this.tiposRegimen = info;
        })
            .catch(function (e) { return _this.handleError(e); });
    };
    EmpleadosEditor.prototype.loadTiposContrato = function () {
        var _this = this;
        this.tipoContratoSvc.loadCbo()
            .then(function (info) {
            _this.tiposContrato = info;
        })
            .catch(function (e) { return _this.handleError(e); });
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    EmpleadosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    EmpleadosEditor.prototype.onCreatingItem = function () {
    };
    EmpleadosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.empleadoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empleado = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpleadosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.empleadoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empleado = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpleadosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.empleadoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empleado = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpleadosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.empleadoService.update(this.empleado)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empleado = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpleadosEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    EmpleadosEditor.prototype.onMenuItemClick = function (option) {
        if (option.name == 'DOCUEMNTS') {
            this.router.navigate(['rh/documento-empleado', this.process.id, this.empleado.identity]);
        }
        else if (option.name == "UPDATE_PASSWD") {
            this.userContrasena = "";
            this.dlgPasswd.config.backdrop = false;
            this.dlgPasswd.show();
        }
    };
    EmpleadosEditor.prototype.onClickCambioTurno = function () {
        this.dlgCambioTurno.config.backdrop = false;
        this.dlgCambioTurno.show();
    };
    EmpleadosEditor.prototype.onClickCambioTurnoAceptar = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.empleadoService.programarCambioTurno(this.empleado.identity, this.empleado.idTurno, this.idTurnoCambio, this.cambioTurnoFechaIni)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.empleado.idTurno = _this.idTurnoCambio;
            _this.selTurno.loadItem(_this.idTurnoCambio);
            _this.dlgCambioTurno.hide();
            _this.showAlert('La información del cambio de turno se actualizo con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpleadosEditor.prototype.onClickPasswdAceptar = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.empleadoService.cambioPassword(this.empleado.identity, this.userContrasena)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.dlgPasswd.hide();
            _this.showAlert('La información del cambio de password se actualizo con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpleadosEditor.prototype.validateFecha = function (control) {
        var FechaHoy;
        FechaHoy = moment(new Date).hour(0).minute(0).second(0).millisecond(0).toDate();
        if (control.value) {
            var Fecha = control.value;
            Fecha = moment(Fecha).hour(0).minute(0).second(0).millisecond(0).toDate();
            if (Fecha.getTime() >= FechaHoy.getTime())
                return null;
            else
                return 'La fecha no debe ser anterior a hoy';
        }
    };
    var EmpleadosEditor_1;
    __decorate([
        core_1.ViewChild('dlgCambioTurno'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], EmpleadosEditor.prototype, "dlgCambioTurno", void 0);
    __decorate([
        core_1.ViewChild('dlgPasswd'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], EmpleadosEditor.prototype, "dlgPasswd", void 0);
    __decorate([
        core_1.ViewChild('selTurno'),
        __metadata("design:type", turno_selector_component_1.TurnoSelectorComponent)
    ], EmpleadosEditor.prototype, "selTurno", void 0);
    EmpleadosEditor = EmpleadosEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-empleados-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Empleado'\"\n                                 [info]=\"empleado\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'DOCUEMNTS'\" [icon]=\"'glyphicon glyphicon-file'\" [text]=\"'Documentos'\" [smallText]=\"'documetnos del empleado'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'UPDATE_PASSWD'\" [icon]=\"'glyphicon glyphicon-file'\" [text]=\"'Establecer password'\" [smallText]=\"'password para acceso a informaci\u00F3n'\"></azteca-menu-item>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\"\n                                        [(ngModel)]=\"empleado.code\"\n                                        [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n\n                  <div class=\"col-4 col-lg-2\">\n                      <azteca-form-field>\n                          <azteca-image-box formControlName=\"foto\" [(ngModel)]=\"empleado.foto\"></azteca-image-box>\n                      </azteca-form-field>\n                  </div>\n\n                  <div class=\"col-12 col-md-6\">\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"empleado.persona.nombre\"></az-textbox>\n                      </azteca-form-field>\n                      <azteca-form-field [label]=\"'Ap. Paterno:'\">\n                          <az-textbox formControlName=\"apPaterno\" [(ngModel)]=\"empleado.persona.apellidoPaterno\"></az-textbox>\n                      </azteca-form-field>\n                      <azteca-form-field [label]=\"'Ap. Materno:'\">\n                          <az-textbox formControlName=\"apMaterno\" [(ngModel)]=\"empleado.persona.apellidoMaterno\"></az-textbox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Sexo:'\">\n                                          <select formControlName=\"sexo\" class=\"form-control\" [(ngModel)]=\"empleado.sexo\">\n                                              <option [value]=\"'M'\">Masculino</option>\n                                              <option [value]=\"'F'\">Femenino</option>\n                                          </select>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Fecha Nacimiento:'\">\n                                          <az-input-date formControlName=\"fechaNacimiento\" [(ngModel)]=\"empleado.fechaNacimiento\"></az-input-date>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Correo:'\">\n                                          <az-textbox formControlName=\"correo\" [(ngModel)]=\"empleado.persona.correo\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"cuenta\" [(ngModel)]=\"empleado.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <tab heading=\"Domicilio\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Calle:'\">\n                                          <az-textbox formControlName=\"calle\" [(ngModel)]=\"empleado.persona.domicilio.calle\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Cruce:'\">\n                                          <az-textbox formControlName=\"cruce1\" [(ngModel)]=\"empleado.persona.domicilio.cruce1\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Cruce:'\">\n                                          <az-textbox formControlName=\"cruce2\" [(ngModel)]=\"empleado.persona.domicilio.cruce2\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'N&uacute;mero Exterior:'\">\n                                          <az-textbox formControlName=\"numExt\" [(ngModel)]=\"empleado.persona.domicilio.numeroExterior\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'N&uacute;mero Interior:'\">\n                                          <az-textbox formControlName=\"numInt\" [(ngModel)]=\"empleado.persona.domicilio.numeroInterior\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'C&oacute;digo postal:'\">\n                                          <az-textbox formControlName=\"cp\" [(ngModel)]=\"empleado.persona.domicilio.codigoPostal\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Colonia:'\">\n                                          <az-textbox formControlName=\"colonia\" [(ngModel)]=\"empleado.persona.domicilio.colonia\"></az-textbox>\n                                      </azteca-form-field>\n                                      <azteca-form-field [label]=\"'Poblaci&oacute;n:'\">\n                                          <poblacion-selector formControlName=\"poblacion\" [(ngModel)]=\"empleado.persona.domicilio.idPoblacion\"></poblacion-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </tab>\n\n                          <tab heading=\"Inf. Laboral\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Escolaridad:'\">\n                                          <az-textbox formControlName=\"titulo\" [(ngModel)]=\"empleado.titulo\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Fecha incio laboral:'\">\n                                          <az-input-date formControlName=\"fechaIngreso\" [(ngModel)]=\"empleado.fechaIngreso\"></az-input-date>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Departamento:'\">\n                                          <rh-departamento-selector formControlName=\"departamento\"\n                                                                    [(ngModel)]=\"empleado.idDepartamento\">\n                                          </rh-departamento-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-10 col-md-5\">\n                                      <azteca-form-field [label]=\"'Turno:'\">\n                                          <rh-turno-selector #selTurno formControlName=\"turno\"\n                                                             [(ngModel)]=\"empleado.idTurno\"\n                                                             [enabled]=\"true\">\n                                          </rh-turno-selector>\n                                      </azteca-form-field>\n                                  </div>\n\n\n                                  <div class=\"col-2 col-md-1\">\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickCambioTurno()\" [disabled]=\"empleado.identity==0\">Programar cambio Turno</button>\n                                  </div>\n\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Plaza:'\">\n                                          <rh-plaza-selector formControlName=\"plaza\"\n                                                             [(ngModel)]=\"empleado.idPlaza\"\n                                                             [enabled]=\"true\"></rh-plaza-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Num. IMSS:'\">\n                                          <az-textbox formControlName=\"imss\" [(ngModel)]=\"empleado.imss\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'CURP:'\">\n                                          <az-textbox formControlName=\"curp\" [(ngModel)]=\"empleado.curp\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'RFC:'\">\n                                          <az-textbox formControlName=\"rfc\" [(ngModel)]=\"empleado.contribuyente.rfc\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Clase N\u00F3mina:'\">\n                                          <rh-clase-nomina-selector formControlName=\"claseNomina\"\n                                                                    [(ngModel)]=\"empleado.idClaseNomina\">\n                                          </rh-clase-nomina-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Tipo Regimen Contrato:'\">\n                                          <az-combobox formControlName=\"tipoRegimen\"\n                                                       [(ngModel)]=\"empleado.idTipoRegimen\"\n                                                       [items]=\"tiposRegimen\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Tipo Contrato:'\">\n                                          <az-combobox formControlName=\"tipoContrato\"\n                                                       [(ngModel)]=\"empleado.idTipoContrato\"\n                                                       [items]=\"tiposContrato\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n\n                              </div>\n\n                              <div class=\"row\">\n                                  <az-checkbox formControlName=\"sindicalizado\" [label]=\"'Sindicalizado'\" [(ngModel)]=\"empleado.sindicalizado\"></az-checkbox>\n                              </div>\n\n                          </tab>\n\n                          <tab heading=\"Parametros\" (select)=\"onTabSelected($event)\">\n\n                              <!--<rh-parametros-editor formControlName=\"parametro\"\n                                                [(ngModel)]=\"empleado.parametros\">\n                          </rh-parametros-editor>-->\n\n                              <az-parametros-editor formControlName=\"parametro\"\n                                                    [(ngModel)]=\"empleado.parametros\">\n\n                              </az-parametros-editor>\n\n                          </tab>\n\n                      </tabset>\n                  </div>\n              </div>\n\n          </azteca-catalog-editor>\n      </form>\n\n\n      <!--DIALOGO PASSWD-->\n      <div bsModal #dlgCambioTurno=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\" role=\"document\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\">Programar cambio de turno</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"dlgCambioTurno.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <form [formGroup]=\"formCambioTurno\">\n\n                          <div class=\"col-12 col-md-6\">\n                              <azteca-form-field [label]=\"'Turno Nuevo:'\">\n                                  <rh-turno-selector formControlName=\"idTurnoCambio\"\n                                                     [(ngModel)]=\"idTurnoCambio\"\n                                                     [enabled]=\"true\">\n                                  </rh-turno-selector>\n                              </azteca-form-field>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-md-6\">\n                                  <azteca-form-field [label]=\"'Fecha inicio:'\">\n                                      <az-input-date formControlName=\"cambioTurnoFechaIni\" [(ngModel)]=\"cambioTurnoFechaIni\"></az-input-date>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                      </form>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickCambioTurnoAceptar()\" [disabled]=\"!formCambioTurno.valid\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dlgCambioTurno.hide()\">Cancelar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n\n\n      <!--DIALOGO PASSWD-->\n      <div bsModal #dlgPasswd=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\" role=\"document\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\">Establecer Password</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"dlgPasswd.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <form [formGroup]=\"formPasswd\">\n                          <div class=\"row\">\n                              <div class=\"col\">\n                                  <azteca-form-field [label]=\"'Password'\">\n                                      <az-password formControlName=\"userContrasena\"\n                                                   [(ngModel)]=\"userContrasena\">\n                                      </az-password>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                      </form>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickPasswdAceptar()\" [disabled]=\"!formPasswd.valid\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dlgPasswd.hide()\">Cancelar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return EmpleadosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: empleado_service_1.EmpleadoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location,
            empleado_service_1.EmpleadoService,
            tipo_regimen_service_1.TipoRegimenService,
            tipo_contrato_service_1.TipoContratoService])
    ], EmpleadosEditor);
    return EmpleadosEditor;
}(editors_1.CatalogEditor));
exports.EmpleadosEditor = EmpleadosEditor;
