import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogManager } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { AsyncTaskService } from "framework3/queue/services/async-task.service";
import { ModalDirective } from 'ngx-bootstrap';
import { EmpleadoService } from '../services/empleado.service';
import { EmpleadoItem } from '../models/empleado';
import { MenuItem } from 'framework3/controls';
export declare class EmpleadosManager extends CatalogManager {
    protected router: Router;
    protected route: ActivatedRoute;
    protected context: Context;
    private empleadoService;
    private asyncTaskSvc;
    empleados: EmpleadoItem[];
    password: string;
    dlgPasswd: ModalDirective;
    constructor(router: Router, route: ActivatedRoute, context: Context, empleadoService: EmpleadoService, asyncTaskSvc: AsyncTaskService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
    onMenuItemClick(option: MenuItem): void;
    onClickPasswdAceptar(): void;
}
