"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var async_task_service_1 = require("framework3/queue/services/async-task.service");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Features
var empleado_service_1 = require("../services/empleado.service");
var EmpleadosManager = /** @class */ (function (_super) {
    __extends(EmpleadosManager, _super);
    function EmpleadosManager(router, route, context, empleadoService, asyncTaskSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.router = router;
        _this.route = route;
        _this.context = context;
        _this.empleadoService = empleadoService;
        _this.asyncTaskSvc = asyncTaskSvc;
        _this.empleados = [];
        return _this;
    }
    EmpleadosManager_1 = EmpleadosManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    EmpleadosManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
        this.refreshList();
    };
    EmpleadosManager.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.empleadoService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.empleados = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpleadosManager.prototype.onAddingItem = function () {
        this.router.navigate([0], { relativeTo: this.route });
    };
    EmpleadosManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    EmpleadosManager.prototype.onEditingItem = function (item) {
        this.router.navigate([item.id], { relativeTo: this.route });
    };
    EmpleadosManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.empleadoService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpleadosManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    EmpleadosManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.empleadoService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpleadosManager.prototype.onMenuItemClick = function (option) {
        var _this = this;
        if (option.name == 'DOCUEMNTS') {
            this.router.navigate(['rh/documento-empleado', this.process.id, this.manager.currentItem.id]);
        }
        if (option.name == 'IMPORTAR-ADAM') {
            this.context.app.showSpinner();
            this.empleadoService.asyncImportarEmpleadosAdam(this.context.app.defaultSite.idBranch)
                .then(function (r) {
                _this.asyncTaskSvc.subscribeTask(r.idAsyncTask).subscribe(function (info) {
                    _this.context.app.hideSpinner();
                    console.log(info);
                    _this.showAlert('Se completo la tarea de importación', 'success');
                });
                _this.showAlert('Se genero una tarea asincrona para la solicitud. Se notificara cuando se termine', 'warning');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == "UPDATE_PASSWD") {
            this.password = "";
            this.dlgPasswd.config.backdrop = false;
            this.dlgPasswd.show();
        }
    };
    EmpleadosManager.prototype.onClickPasswdAceptar = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.empleadoService.cambioPassword(this.manager.currentItem.id, this.password)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.dlgPasswd.hide();
            _this.showAlert('La información del cambio de password se actualizo con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var EmpleadosManager_1;
    __decorate([
        core_1.ViewChild('dlgPasswd'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], EmpleadosManager.prototype, "dlgPasswd", void 0);
    EmpleadosManager = EmpleadosManager_1 = __decorate([
        core_1.Component({
            selector: 'rh-empleados-manager',
            template: "\n      <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                              (addingItem)=\"onAddingItem()\"\n                              (viewingItem)=\"onViewingItem($event)\"\n                              (editingItem)=\"onEditingItem($event)\"\n                              (deletingItem)=\"onDeletingItem($event)\"\n                              (cloningItem)=\"onCloningItem($event)\"\n                              (changingItemState)=\"onChangingItemState($event)\"\n                              (configureCatalog)=\"onConfigureCatalog($event)\"\n                              [enabled]=\"enabled\"\n                              [allowNew]=\"allowNew\"\n                              [allowView]=\"allowView\"\n                              [allowEdit]=\"allowEdit\"\n                              [allowDelete]=\"allowDelete\"\n                              [allowClone]=\"allowClone\"\n                              [allowChangeState]=\"allowChangeState\"\n                              [catalogList]=\"empleados\"\n                              [totalRows]=\"totalRows\"\n                              [pageIndex]=\"pageIndex\"\n                              (menuItemClick)=\"onMenuItemClick($event)\">\n\n          <!------------------- Menu de acciones adicionales --------------------->\n          <azteca-menu-item [name]=\"'DOCUEMNTS'\" [icon]=\"'glyphicon glyphicon-file'\" [text]=\"'Documentos'\" [smallText]=\"'docuemtnos del empleado'\"></azteca-menu-item>\n          <azteca-menu-item [name]=\"'IMPORTAR-ADAM'\" [icon]=\"'glyphicon glyphicon-save'\" [text]=\"'Actualizar desde ADAM' \" [smallText]=\"'Actualizar desde ADAM'\"></azteca-menu-item>\n          <azteca-menu-item [name]=\"'UPDATE_PASSWD'\" [icon]=\"'glyphicon glyphicon-file'\" [text]=\"'Establecer password'\" [smallText]=\"'password para acceso a informaci\u00F3n'\"></azteca-menu-item>\n\n          <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n\n\n      </azteca-catalog-manager>\n\n\n      <!--DIALOGO PASSWD-->\n      <div bsModal #dlgPasswd=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\" role=\"document\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\">Establecer Password</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"dlgPasswd.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <div class=\"form-group\">\n                          <label for=\"txtPassword\">Password:</label>\n                          <input type=\"password\" id=\"txtPassword\" name=\"txtPassword\" [(ngModel)]=\"password\" class=\"form-control\" required />\n                      </div>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickPasswdAceptar()\" [disabled]=\"password==''\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dlgPasswd.hide()\">Cancelar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return EmpleadosManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: empleado_service_1.EmpleadoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, core_2.Context, empleado_service_1.EmpleadoService, async_task_service_1.AsyncTaskService])
    ], EmpleadosManager);
    return EmpleadosManager;
}(editors_1.CatalogManager));
exports.EmpleadosManager = EmpleadosManager;
