"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
var search_1 = require("framework3/search");
//Features
var empresa_service_1 = require("../services/empresa.service");
var empresa_1 = require("../models/empresa");
var sucursal_service_1 = require("../services/sucursal.service");
//
var wijmo_1 = require("wijmo/wijmo");
var EmpresasEditor = /** @class */ (function (_super) {
    __extends(EmpresasEditor, _super);
    //
    function EmpresasEditor(router, route, formBuilder, changeDetector, context, location, empresaService, sucursalService, sucursalKernelService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.empresaService = empresaService;
        _this.sucursalService = sucursalService;
        _this.sucursalKernelService = sucursalKernelService;
        _this.empresa = new empresa_1.EmpresaInfo();
        _this.politicasRangoVacacional = [];
        _this.sucursales = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idCalendario': [0, controls_1.AztecaValidators.selected],
            'politicaRangoVacacional': ['', forms_1.Validators.required],
            'idCuenta': [''],
            'monto': [0],
            'porcentaje': [0]
        });
        _this.politicasRangoVacacional =
            [
                { "id": "N", "nombre": "Durante el año natural" },
                { "id": "I", "nombre": "Desde su fecha de ingreso" }
            ];
        return _this;
    }
    EmpresasEditor_1 = EmpresasEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    EmpresasEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    EmpresasEditor.prototype.onCreatingItem = function () {
    };
    EmpresasEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.empresaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empresa = info;
            _this.loadSucursales();
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.empresaService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empresa = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.empresaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empresa = info;
            _this.loadSucursales();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.empresaService.update(this.empresa)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.empresa.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.empresa = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.selectTab = function (arg) {
        wijmo_1.Control.invalidateAll();
    };
    EmpresasEditor.prototype.loadSucursales = function () {
        var _this = this;
        var request = new search_1.SearchRequest();
        request.paged = false;
        //Agregar condición de empresa actual
        var condicionEmpresa = { field: "idEmpresa", operator: "=", valueType: "int", value: this.empresa.identity.toString() };
        request.conditions.push(condicionEmpresa);
        //
        this.context.app.showSpinner();
        this.sucursalKernelService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.sucursales = response.rows;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var EmpresasEditor_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], EmpresasEditor.prototype, "sucursales", void 0);
    EmpresasEditor = EmpresasEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-empresa-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Empresa'\"\n                                 [info]=\"empresa\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"empresa.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"empresa.empresaBase.nombre\"></az-textbox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Calendario:'\">\n                                          <kernel-calendario-selector formControlName=\"idCalendario\"\n                                                                      [(ngModel)]=\"empresa.idCalendario\">\n                                          </kernel-calendario-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Politica para periodos de vacacionales:'\">\n                                          <az-combobox formControlName=\"politicaRangoVacacional\"\n                                                       [(ngModel)]=\"empresa.politicaRangoVacacional\"\n                                                       [items]=\"politicasRangoVacacional\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"idCuenta\"\n                                                                      [(ngModel)]=\"empresa.idCuenta\">\n                                          </accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                          <tab heading=\"Fichas de Cargo\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Monto m\u00E1ximo a descontar:'\">\n                                          <az-input-number formControlName=\"monto\" [(ngModel)]=\"empresa.montoFicha\" [value]=\"empresa.montoFicha\" [format]=\"'C4'\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Porcentaje m\u00E1ximo a descontar:'\">\n                                          <az-input-number formControlName=\"porcentaje\" [(ngModel)]=\"empresa.porcentajeFicha\" [value]=\"empresa.porcentajeFicha\" [format]=\"'N0'\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </tab>\n\n                          <tab heading=\"Sucursales\" (select)=\"selectTab($event)\" [disabled]=\"empresa.identity==0\">\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n\n                                      <rh-sucursales-manager  [name]=\"'sucursales'\"\n                                                              [sucursales]=\"sucursales\"\n                                                              [idEmpresa]=\"empresa.identity\"\n                                                              (refreshListParent)=\"loadSucursales()\">\n                                      </rh-sucursales-manager>\n\n                                  </div>\n                              </div>\n                          </tab>\n\n\n\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return EmpresasEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: empresa_service_1.EmpresaService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, empresa_service_1.EmpresaService,
            sucursal_service_1.SucursalService, core_2.SucursalService])
    ], EmpresasEditor);
    return EmpresasEditor;
}(editors_1.CatalogEditor));
exports.EmpresasEditor = EmpresasEditor;
