"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var empresaadam_service_1 = require("../services/empresaadam.service");
var empresaadam_1 = require("../models/empresaadam");
var EmpresasAdamEditor = /** @class */ (function (_super) {
    __extends(EmpresasAdamEditor, _super);
    //
    function EmpresasAdamEditor(router, route, formBuilder, changeDetector, context, location, empresaAdamService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.empresaAdamService = empresaAdamService;
        _this.empresaAdam = new empresaadam_1.EmpresaAdamInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'cadenaConexion': ['', forms_1.Validators.required],
            'banco': ['', forms_1.Validators.required]
        });
        return _this;
    }
    EmpresasAdamEditor_1 = EmpresasAdamEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    EmpresasAdamEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    EmpresasAdamEditor.prototype.onCreatingItem = function () {
    };
    EmpresasAdamEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.empresaAdamService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empresaAdam = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasAdamEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.empresaAdamService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empresaAdam = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasAdamEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.empresaAdamService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empresaAdam = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasAdamEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.empresaAdamService.update(this.empresaAdam)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empresaAdam = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var EmpresasAdamEditor_1;
    EmpresasAdamEditor = EmpresasAdamEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-empresasadam-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'EmpresaAdam'\"\n                                 [info]=\"empresaadam\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-8\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"empresaAdam.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"empresaAdam.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Cadena Conexi&oacute;n:'\">\n                                          <az-textbox formControlName=\"cadenaConexion\" [(ngModel)]=\"empresaAdam.cadenaConexion\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Banco:'\">\n                                          <accounting-banco-selector formControlName=\"banco\" [(ngModel)]=\"empresaAdam.banco\"></accounting-banco-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return EmpresasAdamEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: empresaadam_service_1.EmpresaAdamService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, empresaadam_service_1.EmpresaAdamService])
    ], EmpresasAdamEditor);
    return EmpresasAdamEditor;
}(editors_1.CatalogEditor));
exports.EmpresasAdamEditor = EmpresasAdamEditor;
