"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var firmware_service_1 = require("../services/firmware.service");
var firmware_1 = require("../models/firmware");
var FirmwaresEditor = /** @class */ (function (_super) {
    __extends(FirmwaresEditor, _super);
    //
    function FirmwaresEditor(router, route, formBuilder, changeDetector, context, location, firmwareService, ensambladoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.firmwareService = firmwareService;
        _this.ensambladoService = ensambladoService;
        _this.firmware = new firmware_1.FirmwareInfo();
        _this.ensamblados = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idEnsamblado': [''],
            'clase': ['']
        });
        return _this;
    }
    FirmwaresEditor_1 = FirmwaresEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    FirmwaresEditor.prototype.cargarEnsamblados = function () {
        var _this = this;
        this.ensambladoService.loadList()
            .then(function (ensamblados) {
            _this.ensamblados = ensamblados;
            _this.ensamblados.unshift({ id: 0, codigo: '', nombre: '[NINGUNO]', activo: true });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    FirmwaresEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.cargarEnsamblados();
    };
    FirmwaresEditor.prototype.onCreatingItem = function () {
    };
    FirmwaresEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.firmwareService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.firmware = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FirmwaresEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.firmwareService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.firmware = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FirmwaresEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.firmwareService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.firmware = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FirmwaresEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.firmwareService.update(this.firmware)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.firmware.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.firmware = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var FirmwaresEditor_1;
    FirmwaresEditor = FirmwaresEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-firmware-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Firmware'\"\n                                 [info]=\"firmware\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"firmware.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"firmware.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Ensamblado:'\">\n                                          <az-combobox formControlName=\"idEnsamblado\"\n                                                       [(ngModel)]=\"firmware.idEnsamblado\"\n                                                       [items]=\"ensamblados\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\"></az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Clase:'\">\n                                          <az-textbox formControlName=\"clase\" [(ngModel)]=\"firmware.clase\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return FirmwaresEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: firmware_service_1.FirmwareService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, firmware_service_1.FirmwareService, core_2.EnsambladoService])
    ], FirmwaresEditor);
    return FirmwaresEditor;
}(editors_1.CatalogEditor));
exports.FirmwaresEditor = FirmwaresEditor;
