"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var horario_service_1 = require("../services/horario.service");
var horario_1 = require("../models/horario");
var HorariosEditor = /** @class */ (function (_super) {
    __extends(HorariosEditor, _super);
    //
    function HorariosEditor(router, route, formBuilder, changeDetector, context, location, horarioService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.horarioService = horarioService;
        _this.horario = new horario_1.HorarioInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'tipoHorario': [''],
            'horaEntrada': [''],
            'evaluarHorarioNormal': [''],
            'horaSalida': [''],
            'salidaComer': [''],
            'horaComida': [''],
            'duracionComida': [''],
            'toleranciaComida': [''],
            'toleranciaRet': [''],
            'toleranciaFalta': [''],
            'tolAntesEnt': [''],
            'tolAntesSal': [''],
            'tolDespuesSal': [''],
            'inicioHrExtra': [''],
            'diasHorario': [''],
            'jornada': ['']
        });
        _this.horario.horaEntrada = new Date();
        _this.tipoHorario = _this.catalogForm.controls['tipoHorario'];
        _this.evaluarHorarioNormal = _this.catalogForm.controls['evaluarHorarioNormal'];
        _this.tipoHorario.setValue('N');
        _this.evaluarHorarioNormal.setValue('SALIDA_FIJA');
        return _this;
    }
    HorariosEditor_1 = HorariosEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    HorariosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    HorariosEditor.prototype.onCreatingItem = function () {
    };
    HorariosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.horarioService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.horario = info;
            _this.tipoHorario.setValue(_this.horario.tipoHorario);
            _this.evaluarHorarioNormal.setValue(_this.horario.tipoEvaluacion);
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    HorariosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.horarioService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.horario = info;
            _this.tipoHorario.setValue(_this.horario.tipoHorario);
            _this.evaluarHorarioNormal.setValue(_this.horario.tipoEvaluacion);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    HorariosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.horarioService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.horario = info;
            _this.tipoHorario.setValue(_this.horario.tipoHorario);
            _this.evaluarHorarioNormal.setValue(_this.horario.tipoEvaluacion);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    HorariosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.horario.tipoHorario = this.tipoHorario.value;
        this.horario.tipoEvaluacion = this.evaluarHorarioNormal.value;
        this.context.app.showSpinner();
        this.horarioService.update(this.horario)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.horario.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.horario = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var HorariosEditor_1;
    HorariosEditor = HorariosEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-horario-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Horario'\"\n                                 [info]=\"horario\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"horario.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"horario.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n\n                              <div class=\"row\" style=\"padding: 1.25rem\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <label class=\"form-check-inline\">\n                                          <input class=\"form-check-input\" type=\"radio\" formControlName=\"tipoHorario\" name=\"tipoHorario\" [checked]=\"tipoHorario.value=='N'\" value=\"N\"> Horario Normal\n                                      </label>\n                                      <label class=\"form-check-inline\">\n                                          <input class=\"form-check-input\" type=\"radio\" formControlName=\"tipoHorario\" name=\"tipoHorario\" [checked]=\"tipoHorario.value=='L'\" value=\"L\"> Horario Libre\n                                      </label>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\" *ngIf=\"tipoHorario.value=='L' || (tipoHorario.value=='N' && (evaluarHorarioNormal.value=='NO_EVALUAR_SALIDA' || evaluarHorarioNormal.value=='EVALUAR_CON_ENTRADA'))\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Jornada de trabajo:'\">\n                                          <az-input-number formControlName=\"jornada\"\n                                                           [(ngModel)]=\"horario.jornada\"\n                                                           [format]=\"n1\"\n                                                           [min]=\"0\"\n                                                           [max]=\"24\">\n                                          </az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"card\" *ngIf=\"tipoHorario.value=='N'\">\n                                  <h5 class=\"card-header\">Horario normal</h5>\n                                  <div class=\"card-body\">\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-10\">\n                                              <azteca-form-field [label]=\"'Hora entrada:'\">\n                                                  <az-input-time formControlName=\"horaEntrada\"\n                                                                 [format]=\"'HH:mm'\"\n                                                                 [(ngModel)]=\"horario.horaEntrada\">\n                                                  </az-input-time>\n                                              </azteca-form-field>\n                                          </div>\n                                      </div>\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-10\">\n                                              <label class=\"form-check-inline\">\n                                                  <input class=\"form-check-input\"\n                                                         type=\"radio\"\n                                                         formControlName=\"evaluarHorarioNormal\"\n                                                         name=\"evaluarHorarioNormal\"\n                                                         [checked]=\"evaluarHorarioNormal.value=='NO_EVALUAR_SALIDA'\"\n                                                         value=\"NO_EVALUAR_SALIDA\"> No evaluar salida\n                                              </label>\n                                          </div>\n                                      </div>\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-10\">\n                                              <label class=\"form-check-inline\">\n                                                  <input class=\"form-check-input\"\n                                                         type=\"radio\"\n                                                         formControlName=\"evaluarHorarioNormal\"\n                                                         name=\"evaluarHorarioNormal\"\n                                                         [checked]=\"evaluarHorarioNormal.value=='EVALUAR_CON_ENTRADA'\"\n                                                         value=\"EVALUAR_CON_ENTRADA\"> Evaluar jornada de trabajo a partir de la entrada\n                                              </label>\n                                          </div>\n                                      </div>\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-6\">\n                                              <label class=\"form-check-inline\">\n                                                  <input class=\"form-check-input\"\n                                                         type=\"radio\"\n                                                         formControlName=\"evaluarHorarioNormal\"\n                                                         name=\"evaluarHorarioNormal\"\n                                                         [checked]=\"evaluarHorarioNormal.value=='SALIDA_FIJA'\"\n                                                         value=\"SALIDA_FIJA\"> Establecer una hora de salida fija\n                                              </label>\n                                          </div>    \n                                      </div>\n\n                                      <div class=\"row\" *ngIf=\"evaluarHorarioNormal.value=='SALIDA_FIJA'\">\n                                          <div class=\"col-12 col-md-10\">\n                                              <azteca-form-field [label]=\"'Hora salida:'\">\n                                                  <az-input-time formControlName=\"horaSalida\"\n                                                                 [format]=\"'HH:mm'\"\n                                                                 [(ngModel)]=\"horario.horaSalida\">\n                                                  </az-input-time>\n                                              </azteca-form-field>\n                                          </div>\n                                      </div>\n\n                                  </div>\n                              </div>\n\n\n                              <div class=\"card\" *ngIf=\"tipoHorario.value=='N'\">\n                                  <h5 class=\"card-header\">Comida</h5>\n                                  <div class=\"card-body\">\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-6\">\n                                              <az-checkbox formControlName=\"salidaComer\"\n                                                           [label]=\"'Salida a comer'\"\n                                                           [(ngModel)]=\"horario.salidaComer\">\n                                              </az-checkbox>\n                                          </div>\n                                      </div>\n\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-6\">\n                                              <azteca-form-field [label]=\"'Hora comida:'\">\n                                                  <az-input-time formControlName=\"horaComida\"\n                                                                 [format]=\"'HH:mm'\"\n                                                                 [enabled]=\"horario.salidaComer\"\n                                                                 [(ngModel)]=\"horario.horaComida\">\n                                                  </az-input-time>\n                                              </azteca-form-field>\n                                          </div>\n                                      </div>\n\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-6\">\n                                              <azteca-form-field [label]=\"'Duraci\u00F3n comida (Minutos):'\">\n                                                  <az-input-number formControlName=\"duracionComida\"\n                                                                   [enabled]=\"horario.salidaComer\"\n                                                                   [(ngModel)]=\"horario.duracionComida\"\n                                                                   [min]=\"0\"\n                                                                   [max]=\"480\">\n                                                  </az-input-number>\n                                              </azteca-form-field>\n                                          </div>\n                                      </div>\n\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-6\">\n                                              <azteca-form-field [label]=\"'Tolerancia comida (Minutos):'\">\n                                                  <az-input-number formControlName=\"toleranciaComida\"\n                                                                   [enabled]=\"horario.salidaComer\"\n                                                                   [(ngModel)]=\"horario.toleranciaComida\"\n                                                                   [min]=\"0\"\n                                                                   [max]=\"480\">\n                                                  </az-input-number>\n                                              </azteca-form-field>\n                                          </div>\n                                      </div>\n\n                                  </div>\n                              </div>\n\n\n                          </tab>\n                          <tab heading=\"Tolerancia Horario Normal\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Tolerancia retardo (Minutos):'\">\n                                          <az-input-number formControlName=\"toleranciaRet\"\n                                                           [(ngModel)]=\"horario.toleranciaRetardo\"\n                                                           [min]=\"0\"\n                                                           [max]=\"480\">\n                                          </az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Tolerancia falta (Minutos):'\">\n                                          <az-input-number formControlName=\"toleranciaFalta\"\n                                                           [(ngModel)]=\"horario.toleranciaFalta\"\n                                                           [min]=\"0\"\n                                                           [max]=\"480\">\n                                          </az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Tolerancia antes entrada (Minutos):'\">\n                                          <az-input-number formControlName=\"tolAntesEnt\"\n                                                           [(ngModel)]=\"horario.toleranciaAntesEntrada\"\n                                                           [min]=\"0\"\n                                                           [max]=\"480\">\n                                          </az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Tolerancia antes salida (Minutos):'\">\n                                          <az-input-number formControlName=\"tolAntesSal\"\n                                                           [(ngModel)]=\"horario.toleranciaAntesSalida\"\n                                                           [min]=\"0\"\n                                                           [max]=\"480\">\n                                          </az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Tolerancia (Minutos) despu\u00E9s salida (0=Sin l&iacute;mite):'\">\n                                          <az-input-number formControlName=\"tolDespuesSal\"\n                                                           [(ngModel)]=\"horario.toleranciaDespuesSalida\"\n                                                           [min]=\"0\"\n                                                           [max]=\"480\">\n                                          </az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Inicio horas extra (0=Sin horas extra):'\">\n                                          <az-input-number formControlName=\"inicioHrExtra\"\n                                                           [(ngModel)]=\"horario.inicioHoraExtra\"\n                                                           [min]=\"0\"\n                                                           [max]=\"480\">\n                                          </az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return HorariosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: horario_service_1.HorarioService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, horario_service_1.HorarioService])
    ], HorariosEditor);
    return HorariosEditor;
}(editors_1.CatalogEditor));
exports.HorariosEditor = HorariosEditor;
