import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { IncidenciaService } from '../services/incidencia.service';
import { KardexAsistenciaService } from '../services/kardex-asistencia.service';
import { IncidenciaInfo } from '../models/incidencia';
export declare class IncidenciasEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private incidenciaService;
    private kardexAsistenciaSvc;
    incidencia: IncidenciaInfo;
    kardexEstatus: any[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, incidenciaService: IncidenciaService, kardexAsistenciaSvc: KardexAsistenciaService);
    ngOnInit(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
}
