"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var incidencia_service_1 = require("../services/incidencia.service");
var kardex_asistencia_service_1 = require("../services/kardex-asistencia.service");
var incidencia_1 = require("../models/incidencia");
var IncidenciasEditor = /** @class */ (function (_super) {
    __extends(IncidenciasEditor, _super);
    //
    function IncidenciasEditor(router, route, formBuilder, changeDetector, context, location, incidenciaService, kardexAsistenciaSvc) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.incidenciaService = incidenciaService;
        _this.kardexAsistenciaSvc = kardexAsistenciaSvc;
        _this.incidencia = new incidencia_1.IncidenciaInfo();
        _this.kardexEstatus = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'descripcion': [''],
            'estatus': ['']
        });
        return _this;
    }
    IncidenciasEditor_1 = IncidenciasEditor;
    IncidenciasEditor.prototype.ngOnInit = function () {
        var _this = this;
        setTimeout(function (_) {
            _this.kardexAsistenciaSvc.getKardexEstatus()
                .then(function (info) {
                _this.kardexEstatus = info;
            })
                .catch(function (error) { return _this.handleError(error); });
        });
    };
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    IncidenciasEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    IncidenciasEditor.prototype.onCreatingItem = function () {
    };
    IncidenciasEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.incidenciaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.incidencia = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    IncidenciasEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.incidenciaService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.incidencia = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    IncidenciasEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.incidenciaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.incidencia = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    IncidenciasEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.incidenciaService.update(this.incidencia)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.incidencia.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.incidencia = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var IncidenciasEditor_1;
    IncidenciasEditor = IncidenciasEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-incidencia-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Incidencia'\"\n                                 [info]=\"incidencia\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"incidencia.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"incidencia.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Estatus:'\">\n                                          <az-combobox formControlName=\"estatus\" \n                                                       [(ngModel)]=\"incidencia.estatus\" \n                                                       [items]=\"kardexEstatus\" \n                                                       [displayMember]=\"'descripcion'\" \n                                                       [valueMember]=\"'estatus'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Descripci\u00F3n:'\">\n                                          <az-textarea formControlName=\"descripcion\"\n                                                       [(ngModel)]=\"incidencia.descripcion\">\n                                          </az-textarea>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return IncidenciasEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: incidencia_service_1.IncidenciaService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, incidencia_service_1.IncidenciaService, kardex_asistencia_service_1.KardexAsistenciaService])
    ], IncidenciasEditor);
    return IncidenciasEditor;
}(editors_1.CatalogEditor));
exports.IncidenciasEditor = IncidenciasEditor;
