"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
var moment = require("moment");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var search_1 = require("framework3/search");
var locker_service_1 = require("../services/locker.service");
var wijmo_1 = require("wijmo/wijmo");
var llaveManager = /** @class */ (function (_super) {
    __extends(llaveManager, _super);
    function llaveManager(context, router, route, location, lockersvc, formBuilder) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.lockersvc = lockersvc;
        _this.formBuilder = formBuilder;
        _this.filterPanelCollapsed = false;
        _this.showFilterPanel = true;
        _this.menuItems = [];
        _this.filterGroups = [];
        _this.currentItems = new Array();
        _this.totalRows = 0;
        _this.pageIndex = 0;
        _this.respuesta = false;
        _this.titleContentView = "";
        _this.fileNameContentView = "";
        _this.message = "";
        _this.collectionData = new wijmo_1.CollectionView();
        _this.form = formBuilder.group({
            'fechaInicial': [],
            'fechaFinal': []
        });
        return _this;
    }
    llaveManager.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) {
            _this.refreshList();
        });
        this.createMenu();
    };
    llaveManager.prototype.createMenu = function () {
        //Agregar opciones estándar del catálogo
        var mnuDownload = { icon: "glyphicon glyphicon-circle-arrow-down", text: "Consultar", name: "DOWNLOAD", smallText: "Consultar pendientes aprobar" };
        var mnuOpen = { icon: "glyphicon glyphicon-circle-arrow-down", text: "Abrir", name: "OPEN", smallText: "abrir en modo de sólo lectura" };
        //
        this.menuItems.push(mnuDownload);
        this.menuItems.push(mnuOpen);
        //
        this.menuItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    Object.defineProperty(llaveManager.prototype, "classGridPanel", {
        /*Permite tomar todo el espacio disponible cuando el panel de filtro no está visible y 75% cuando lo está*/
        get: function () {
            return !this.showFilterPanel || this.filterPanelCollapsed ? 'col-12' : 'col-12 col-lg-9';
        },
        enumerable: true,
        configurable: true
    });
    llaveManager.prototype.toggleCollapse = function () {
        this.filterPanelCollapsed = !this.filterPanelCollapsed;
    };
    llaveManager.prototype.onMenuItemClicked = function (menu, args) {
        var item = this.menuItems[menu.selectedIndex];
        //this.optionClick(item);
    };
    llaveManager.prototype.onClickSel = function (item) {
        //this.router.navigate(['new/5'], { relativeTo: this.route });
        this.currentItem = item;
        if (item.data.idLlave > 0) {
            this.router.navigate(['new/' + item.data.idLlave, { readonly: true }], { relativeTo: this.route });
        }
        else {
            this.alerts.showAlert("No existe registro de locker", 'danger');
        }
    };
    llaveManager.prototype.onParamsToolbar = function (button) {
        if (button.name == 'REFRESH') {
            this.refreshList();
        }
    };
    llaveManager.prototype.applyPolicy = function (policy) {
    };
    llaveManager.prototype.refreshList = function () {
        var _this = this;
        this.context.app.showSpinner();
        if (this.request == null) {
            this.request = new search_1.SearchRequest();
            this.request.pageIndex = 0;
            this.request.pageSize = 20;
            this.request.paged = false;
        }
        this.lockersvc.searchLlaves(this.context.app.defaultSite.identity, this.request)
            .then(function (response) {
            response.rows.forEach(function (r) {
                r['fecha'] = moment(r['fecha']).toDate();
            });
            _this.currentItems = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = _this.request.pageIndex;
            //
            var filterGroup = new search_1.FilterGroup();
            filterGroup.tag = "ALL";
            filterGroup.name = "Todos";
            filterGroup.rowCount = _this.totalRows;
            _this.filterGroups.length = 0;
            _this.filterGroups.push(filterGroup);
            //
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    // Se ejecuta al seleccionar btn Nuevo en Manager Locker
    llaveManager.prototype.newItemHandler = function () {
        this.router.navigate(['new'], { relativeTo: this.route });
    };
    llaveManager.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], llaveManager.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild(controls_1.ContentViewerComponent),
        __metadata("design:type", controls_1.ContentViewerComponent)
    ], llaveManager.prototype, "reportViewer", void 0);
    llaveManager = __decorate([
        core_1.Component({
            selector: 'rh-llave',
            template: "\n      <alerts-bar></alerts-bar>\n\n      <form [formGroup]=\"form\">\n          <div class=\"card\">\n              <div class=\"card-header\">ADMINISTRADOR DE LLAVES.</div>\n              <div class=\"card-body\">\n                  <!--PANEL DE PERIODO Y RESUMEN DE ESTATUS-->\n                  <div class=\"row\">\n                      <div [class]=\"classGridPanel\">\n                          <!--MEN\u00DA PRINCIPAL-->\n                          <div class=\"row\">\n                              <div class=\"col-12 \">\n                                  <div class=\"btn-group btn-module-primary\">\n                                      <button type=\"button\" class=\"btn btn-default\" [title]=\"(filterPanelCollapsed ? 'Mostrar' : 'Ocultar') + ' panel de filtro'\" (click)=\"toggleCollapse()\">\n                                          <span [class]=\"filterPanelCollapsed ? 'glyphicon glyphicon-chevron-right': 'glyphicon glyphicon-chevron-left'\"></span>\n                                      </button>\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"newItemHandler()\">\n                                          <span class=\"glyphicon glyphicon-plus\" aria-hidden=\"true\"></span> Nuevo\n                                      </button>\n                                      <wj-menu #menu\n                                               (itemClicked)=\"onMenuItemClicked(menu, $event)\"\n                                               [header]=\"'Opciones'\">\n                                          <wj-menu-item *ngFor=\"let item of menuItems\">\n                                              <div *ngIf=\"item.enabled\">\n                                                  <span [class]=\"item.icon\"></span>\n                                                  <b>{{item.text}}</b>\n                                                  <br>\n                                                  <small><i>{{item.smallText}}</i></small>\n                                              </div>\n                                          </wj-menu-item>\n                                      </wj-menu>\n                                  </div> <!--TOOLBAR-->\n                              </div> <!--COL MENU-->\n                          </div> <!--ROW MENU-->\n                          <!--GRID DE DOCUMENTOS-->\n                          <div class=\"row\">\n                              <div class=\"col-6\">\n                                  <!-- Listado de lockers registrados -->\n                                  <azteca-catalog-list [catalogList]=\"currentItems\"\n                                                       [showRowButton]=\"false\"\n                                                       (searchRequested)=\"searchRequested($event)\"\n                                                       (contextMenuClick)=\"optionClick($event)\"\n                                                       [enabled]=\"true\"\n                                                       [pageSize]=\"100\"\n                                                       [serverSide]=\"false\"\n                                                       [totalRows]=\"totalRows\"\n                                                       [pageIndex]=\"pageIndex\"\n                                                       (itemSelected)=\"onClickSel($event)\">\n                                      <!-- Mapear opciones de men\u00FA de componente padre-->\n                                      <azteca-menu-item *ngFor=\"let item of menuItems\" [name]=\"item.name\" [icon]=\"item.icon\" [text]=\"item.text\" [smallText]=\"item.smallText\" [enabled]=\"item.enabled\"></azteca-menu-item>\n                                      <azteca-grid-column [header]=\"'IdLlave'\" [binding]=\"'idLlave'\"[width]=\"'50*'\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'IdLocker'\" [binding]=\"'idLocker'\" [width]=\"'50*'\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'50*'\"></azteca-grid-column>\n                                  </azteca-catalog-list>\n                              </div> <!--COL GRID-->\n                          </div> <!--ROW GRID-->\n                      </div> <!--COL LIST-->\n                  </div>\n              </div>\n          </div>\n      </form>\n\n      <azteca-content-viewer></azteca-content-viewer>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, common_1.Location, locker_service_1.lockerService,
            forms_1.FormBuilder])
    ], llaveManager);
    return llaveManager;
}(core_2.BaseComponent));
exports.llaveManager = llaveManager;
