"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var core_3 = require("@angular/core");
var wijmo_1 = require("wijmo/wijmo");
//Features
var index_1 = require("../../translator/index");
var locker_service_1 = require("../services/locker.service");
var lockerEditor = /** @class */ (function () {
    function lockerEditor(formBuilder, lockerSvc, context, router, route, datasetSvc) {
        this.formBuilder = formBuilder;
        this.lockerSvc = lockerSvc;
        this.context = context;
        this.router = router;
        this.route = route;
        this.datasetSvc = datasetSvc;
        this.lockerInfo = [];
        this.previewCollection = new wijmo_1.CollectionView();
        this.selectedCollection = new wijmo_1.CollectionView();
        this.form = formBuilder.group({
            'Codigo': '',
            'Estatus': false,
            'CantLlaves': 0,
            'AdeudoLlaves': false
        });
    }
    lockerEditor_1 = lockerEditor;
    lockerEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (params) {
            if (params['id']) {
                _this.identity = +params['id'];
                if (_this.identity > 0) {
                    _this.lockerSvc.getLockerById(_this.identity)
                        .then(function (result) {
                        _this.lockerInfo = result;
                        _this.previewCollection.sourceCollection = _this.lockerInfo;
                    });
                }
            }
        });
    };
    //getLockerInfo(id: number) {
    //    this.restruct.getReestructuraDetalle(id)
    //        .then(result => {
    //            this.restructDetalle = result;
    //            this.previewCollection.sourceCollection = this.restructDetalle;
    //        })
    //}
    //Actualiza información del locker.
    lockerEditor.prototype.putLocker = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.lockerSvc.putLocker(this.lockerInfo)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert("Se actualizó la información de locker.", "success");
        })
            .catch(function (error) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert("Error al actualizar información de locker, valida los datos.", "danger");
        });
    };
    //Muestra mensaje de error.
    lockerEditor.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert("Error en reestructura maintenance.ts", "danger");
    };
    var lockerEditor_1;
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], lockerEditor.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('viewDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], lockerEditor.prototype, "viewDialog", void 0);
    lockerEditor = lockerEditor_1 = __decorate([
        core_1.Component({
            selector: 'locker-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <!--Componente para cargar el archivo.-->\n          <div [formGroup]=\"form\">\n              <!--Panel para mostrar el t\u00EDtulo de la reestructura-->\n              <div class=\"row\">\n                  <az-panel [header]=\"'EDITOR DE INFORMACI\u00D3N - LOCKERS'\">\n                      <alerts-bar></alerts-bar>\n                      <!--T\u00EDtulo de la Reestructura-->\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6 \">\n                              <!--<span aria-hidden=\"true\" style=\"font-size:larger; padding-top:4em\"></span> Detalle del t\u00EDtulo de la reestructura.-->\n                              <p style=\"color: dimgray\">Informaci\u00F3n de locker.</p>\n                              <wj-flex-grid #grid style=\"height:200px ; width: auto;\"\n                                            [itemsSource]=\"previewCollection\">\n                                  <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                  <wj-flex-grid-column [header]=\"'IdLocker'\" [binding]=\"'idLocker'\" [width]=\"'50*'\" [isReadOnly]=\"true\" [visible]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'50*'\" [isReadOnly]=\"false\" [visible]=\"true\" [dataType]=\"Number\" [format]=\"d\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Estatus'\" [binding]=\"'estatus'\" [width]=\"'50*'\" [isReadOnly]=\"false\" [visible]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'CantLlaves'\" [binding]=\"'cantLlaves'\" [width]=\"'50*'\" [visible]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'AdeudoLlaves'\" [binding]=\"'adeudoLlaves'\" [width]=\"'50*'\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n\n                              <button type=\"button\" class=\"btn btn-default d-none d-md-block\" style=\"background-color:dodgerblue; color:white\" (click)=\"putLocker()\">\n                                  <span class=\"glyphicon glyphicon-refresh\" aria-hidden=\"true\"></span> Actualizar Informaci\u00F3n\n                              </button>\n\n                          </div>\n                      </div>\n                  </az-panel>\n              </div>\n          </div>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_3.forwardRef(function () { return lockerEditor_1; })
                }
            ]
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder,
            locker_service_1.lockerService,
            core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            index_1.DatasetService])
    ], lockerEditor);
    return lockerEditor;
}());
exports.lockerEditor = lockerEditor;
