"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var core_3 = require("@angular/core");
var wijmo_1 = require("wijmo/wijmo");
//Features
var index_1 = require("../../translator/index");
var locker_1 = require("../models/locker");
var locker_service_1 = require("../services/locker.service");
var lockerManagerNuevo = /** @class */ (function () {
    function lockerManagerNuevo(formBuilder, lockerSvc, context, router, route, datasetSvc) {
        this.formBuilder = formBuilder;
        this.lockerSvc = lockerSvc;
        this.context = context;
        this.router = router;
        this.route = route;
        this.datasetSvc = datasetSvc;
        this.previewCollection = new wijmo_1.CollectionView();
        this.selectedCollection = new wijmo_1.CollectionView();
        this.lock = new locker_1.LockerInfo();
        this.form = formBuilder.group({
            'IdLocker': 0,
            'Codigo': '',
            'Estatus': false,
            'CantLlaves': 0,
            'AdedudoLlaves': false
        });
    }
    lockerManagerNuevo_1 = lockerManagerNuevo;
    //ngOnInit(): void {
    //    setTimeout(() => {
    //        this.onClickGuardar();
    //    });
    //}
    //Inserta nuevo locker
    lockerManagerNuevo.prototype.onClickGuardar = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.lockerSvc.postLocker(this.Codigo, this.CantLlaves).then(function (result) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert("Mensaje e alerta", "success");
        });
    };
    lockerManagerNuevo.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert("Error en reestructura maintenance.ts", "danger");
    };
    var lockerManagerNuevo_1;
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], lockerManagerNuevo.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('viewDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], lockerManagerNuevo.prototype, "viewDialog", void 0);
    lockerManagerNuevo = lockerManagerNuevo_1 = __decorate([
        core_1.Component({
            selector: 'locker-manager-new',
            template: "\n      <form [formGroup]=\"form\">\n          <!--Componente para cargar el archivo.-->\n          <div [formGroup]=\"form\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-6\">\n                      <az-panel [header]=\"'REGISTRO DE LOCKERS'\">\n                          <!--Barra de alertas-->\n                          <alerts-bar></alerts-bar>\n\n                          <!--Toolbar-->\n                          <button type=\"button\" class=\"btn btn-default d-none d-md-block\" style=\"background-color:dodgerblue; color:white\" (click)=\"onClickGuardar()\">\n                              <span class=\"glyphicon glyphicon-save-file\" aria-hidden=\"true\"></span> Agregar\n                          </button>\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-md-10\">\n                                  <azteca-form-field [label]=\"'Codigo:'\">\n                                      <az-textbox  formControlName=\"Codigo\"   [(ngModel)]=\"Codigo\"></az-textbox>\n                                  </azteca-form-field>\n\n                                  <azteca-form-field [label]=\"'Cantidad Llaves:'\">\n                                      <az-textbox formControlName=\"CantLlaves\"  [(ngModel)]=\"CantLlaves\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                      </az-panel>\n                  </div>\n              </div>\n          </div>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_3.forwardRef(function () { return lockerManagerNuevo_1; })
                }
            ]
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder,
            locker_service_1.lockerService,
            core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            index_1.DatasetService])
    ], lockerManagerNuevo);
    return lockerManagerNuevo;
}());
exports.lockerManagerNuevo = lockerManagerNuevo;
