"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//ngx bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//moment
var moment = require("moment");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var parametro_1 = require("../../models/parametro");
var ParametrosEditorComponent = /** @class */ (function (_super) {
    __extends(ParametrosEditorComponent, _super);
    function ParametrosEditorComponent(formBuilder) {
        var _this = _super.call(this) || this;
        _this.formBuilder = formBuilder;
        _this.newParameter = new parametro_1.ParametroItem();
        _this.parametros = [];
        _this.propagateChange = function (_) { };
        _this.form = formBuilder.group({
            'parameterPath': ['', forms_1.Validators.required],
            'parameterKey': ['', forms_1.Validators.required],
            'parameterValue': ['', forms_1.Validators.required]
        });
        return _this;
    }
    ParametrosEditorComponent_1 = ParametrosEditorComponent;
    Object.defineProperty(ParametrosEditorComponent.prototype, "valid", {
        get: function () {
            return this.form.valid;
        },
        enumerable: true,
        configurable: true
    });
    ParametrosEditorComponent.prototype.onAddingItem = function () {
        this.newParameter = new parametro_1.ParametroItem();
        this.dlgParameter.config.backdrop = false;
        this.dlgParameter.show();
    };
    ParametrosEditorComponent.prototype.onDeletingParameter = function (item) {
        this.editListParametros.deleteItem(item);
    };
    ParametrosEditorComponent.prototype.onListItemUpdateParameter = function (items) {
        this.parametros = items;
        this.propagateChange(this.parametros);
    };
    ParametrosEditorComponent.prototype.onUpdatedParameter = function () {
        this.newParameter._clientID = this.createClientID();
        this.editListParametros.updateItem(this.cloneInfo(this.newParameter));
        this.dlgParameter.hide();
    };
    //////////////////////////////// CONTROL VALUE ACCESOR ////////////////////////////////////////
    ParametrosEditorComponent.prototype.writeValue = function (value) {
        this.parametros = value;
    };
    ParametrosEditorComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    ParametrosEditorComponent.prototype.registerOnTouched = function () {
    };
    ParametrosEditorComponent.prototype.createClientID = function () {
        return parseInt((Math.random() * 1000).toString()) * 1000 + parseInt(moment().format("HHmmss"));
    };
    ParametrosEditorComponent.prototype.cloneInfo = function (element) {
        return JSON.parse(JSON.stringify(element));
    };
    var ParametrosEditorComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], ParametrosEditorComponent.prototype, "parametros", void 0);
    __decorate([
        core_1.ViewChild('dlgParametro'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ParametrosEditorComponent.prototype, "dlgParameter", void 0);
    __decorate([
        core_1.ViewChild('editListParametros'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], ParametrosEditorComponent.prototype, "editListParametros", void 0);
    ParametrosEditorComponent = ParametrosEditorComponent_1 = __decorate([
        core_1.Component({
            selector: 'rh-parametros-editor',
            template: "\n      <azteca-editable-list #editListParametros\n                            [allowNew]=\"true\"\n                            [allowEdit]=\"true\"\n                            [listItems]=\"parametros\"\n                            (addingItem)=\"onAddingItem()\"\n                            (listItemsUpdated)=\"onListItemUpdateParameter($event)\"\n                            (deletingItem)=\"onDeletingParameter($event)\">\n\n          <!-- OPCIONES DEL MENU-->\n          <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n          <!-- COLUMNAS DEL GRID-->\n          <azteca-grid-column [header]=\"'Path'\" [binding]=\"'path'\" [width]=\"180\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Key'\" [binding]=\"'key'\" [width]=\"180\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Value'\" [binding]=\"'value'\" [width]=\"'90*'\"></azteca-grid-column>\n      </azteca-editable-list>\n\n\n      <div bsModal #dlgParametro=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n\n                  <div class=\"modal-header\">\n                      <!--Modal Header-->\n                      <h4>Agregar Par&aacute;metro</h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"dlgParametro.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div> <!--Modal Header-->\n                  <div class=\"modal-body\">\n                      <form [formGroup]=\"form\">\n                          <div class=\"row\">\n                              <div class=\"col-12 col-md-6\">\n                                  <azteca-form-field [label]=\"'Path:'\">\n                                      <az-textbox formControlName=\"parameterPath\" \n                                                  [(ngModel)]=\"newParameter.path\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-12 col-md-6\">\n                                  <azteca-form-field [label]=\"'Key:'\">\n                                      <az-textbox formControlName=\"parameterKey\" \n                                                  [(ngModel)]=\"newParameter.key\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-12 col-md-6\">\n                                  <azteca-form-field [label]=\"'Value:'\">\n                                      <az-textbox formControlName=\"parameterValue\" \n                                                  [(ngModel)]=\"newParameter.value\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                      </form>\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdatedParameter()\" [disabled]=\"!form.valid\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dlgParametro.hide()\">Cancelar</button>\n                  </div> <!--Modal Footer-->\n\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ParametrosEditorComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR, useExisting: core_1.forwardRef(function () { return ParametrosEditorComponent_1; }), multi: true
                }
            ],
            styles: [
                '.ng-valid-component { border-left: 1px solid #ccc!important;}'
            ]
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder])
    ], ParametrosEditorComponent);
    return ParametrosEditorComponent;
}(controls_1.BaseControl));
exports.ParametrosEditorComponent = ParametrosEditorComponent;
