import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormGroup } from '@angular/forms';
import { Location } from '@angular/common';
import { WjCalendar } from 'wijmo/wijmo.angular2.input';
import { ModalDirective } from 'ngx-bootstrap';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs, EditableListComponent } from 'framework3/editors';
import { PeriodicidadPagoService } from '../services/periodicidad-pago.service';
import { PeriodicidadPagoInfo, PeriodoDiaItem } from '../models/periodicidad-pago';
import { PeriodoItem } from '../models/periodicidad-pago';
export declare class PeriodicidadPagoEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private periodicidadPagoService;
    formPeriodo: FormGroup;
    periodicidadPago: PeriodicidadPagoInfo;
    periodo: PeriodoItem;
    periodoDia: PeriodoDiaItem;
    fechaSelected: Date;
    dlgPeriodoEditor: ModalDirective;
    calendarFechaIncidencia: WjCalendar;
    editListPeriodos: EditableListComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, periodicidadPagoService: PeriodicidadPagoService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onTabSelected(args: any): void;
    onAddingItemPeriodo(): void;
    onListItemUpdatePeriodo(items: PeriodoItem[]): void;
    onEditingItemPeriodo(item: PeriodoItem): void;
    onDeletingPeriodo(item: any): void;
    onUpdatedPeriodo(): void;
    onDayClicked(event: any): void;
    createClientID(): number;
    cloneInfo<T>(element: any): T;
    replacer(key: any, value: any): any;
}
