"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
var wijmo_angular2_input_1 = require("wijmo/wijmo.angular2.input");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//moment
var moment = require("moment");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var periodicidad_pago_service_1 = require("../services/periodicidad-pago.service");
var periodicidad_pago_1 = require("../models/periodicidad-pago");
var periodicidad_pago_2 = require("../models/periodicidad-pago");
var PeriodicidadPagoEditor = /** @class */ (function (_super) {
    __extends(PeriodicidadPagoEditor, _super);
    //
    function PeriodicidadPagoEditor(router, route, formBuilder, changeDetector, context, location, periodicidadPagoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.periodicidadPagoService = periodicidadPagoService;
        _this.periodicidadPago = new periodicidad_pago_1.PeriodicidadPagoInfo();
        _this.periodo = new periodicidad_pago_2.PeriodoItem();
        _this.periodoDia = new periodicidad_pago_1.PeriodoDiaItem();
        _this.fechaSelected = new Date();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'dias': [0, forms_1.Validators.required],
            'descripcion': ['']
        });
        _this.formPeriodo = formBuilder.group({
            'periodoCodigo': ['', forms_1.Validators.required],
            'periodoNombre': ['', forms_1.Validators.required],
            'periodoDiaFeriado': [''],
            'periodoDiaFormaPago': ['']
        });
        return _this;
    }
    PeriodicidadPagoEditor_1 = PeriodicidadPagoEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    PeriodicidadPagoEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    PeriodicidadPagoEditor.prototype.onCreatingItem = function () {
    };
    PeriodicidadPagoEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.periodicidadPagoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.periodicidadPago = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodicidadPagoEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.periodicidadPagoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.periodicidadPago = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodicidadPagoEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.periodicidadPagoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.periodicidadPago = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodicidadPagoEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.periodicidadPagoService.update(this.periodicidadPago)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.periodicidadPago.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.periodicidadPago = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodicidadPagoEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////////////////// CUSTOM ///////////////////////////////////////
    PeriodicidadPagoEditor.prototype.onAddingItemPeriodo = function () {
        this.periodo = new periodicidad_pago_2.PeriodoItem();
        this.periodo._clientID = this.createClientID();
        this.dlgPeriodoEditor.config.backdrop = false;
        this.dlgPeriodoEditor.show();
    };
    PeriodicidadPagoEditor.prototype.onListItemUpdatePeriodo = function (items) {
        this.periodicidadPago.periodos = items;
    };
    PeriodicidadPagoEditor.prototype.onEditingItemPeriodo = function (item) {
        this.periodo = this.cloneInfo(this.editListPeriodos.currentItem);
        this.dlgPeriodoEditor.config.backdrop = false;
        this.dlgPeriodoEditor.show();
    };
    PeriodicidadPagoEditor.prototype.onDeletingPeriodo = function (item) {
        this.editListPeriodos.deleteItem(item);
    };
    PeriodicidadPagoEditor.prototype.onUpdatedPeriodo = function () {
        this.editListPeriodos.updateItem(this.periodo);
        this.dlgPeriodoEditor.hide();
    };
    PeriodicidadPagoEditor.prototype.onDayClicked = function (event) {
        var date = this.calendarFechaIncidencia.value;
        var dia = this.periodo.periodoDias.find(function (p) { return moment(p.fechaIncidencia).format("YYYY-MM-DD") == moment(date).format("YYYY-MM-DD"); });
        if (dia) {
            this.periodoDia = dia;
        }
        else {
            this.periodoDia = new periodicidad_pago_1.PeriodoDiaItem();
            this.periodoDia.fechaIncidencia = date;
            this.periodoDia.formaPago = 1;
            this.periodo.periodoDias.push(this.periodoDia);
        }
    };
    PeriodicidadPagoEditor.prototype.createClientID = function () {
        return parseInt((Math.random() * 1000).toString()) * 1000 + parseInt(moment().format("HHmmss"));
    };
    PeriodicidadPagoEditor.prototype.cloneInfo = function (element) {
        return JSON.parse(JSON.stringify(element), this.replacer);
    };
    PeriodicidadPagoEditor.prototype.replacer = function (key, value) {
        if (key == "fechaIniPago" || key == "fechaFinPago" || key == "fechaIniIncidencia" || key == "fechaFinIncidencia" || key == "fechaIncidencia")
            return moment(value).toDate();
        else
            return value;
    };
    var PeriodicidadPagoEditor_1;
    __decorate([
        core_1.ViewChild('dlgPeriodo'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], PeriodicidadPagoEditor.prototype, "dlgPeriodoEditor", void 0);
    __decorate([
        core_1.ViewChild('calendarFechaIncidencia'),
        __metadata("design:type", wijmo_angular2_input_1.WjCalendar)
    ], PeriodicidadPagoEditor.prototype, "calendarFechaIncidencia", void 0);
    __decorate([
        core_1.ViewChild('editListPeriodos'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], PeriodicidadPagoEditor.prototype, "editListPeriodos", void 0);
    PeriodicidadPagoEditor = PeriodicidadPagoEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-periodicidad-pago-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'RH - Periodos de Pago'\"\n                                 [info]=\"periodicidadPago\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"periodicidadPago.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"periodicidadPago.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'D\u00EDas:'\">\n                                          <az-input-number formControlName=\"dias\"\n                                                           decimal=\"false\"\n                                                           [(ngModel)]=\"periodicidadPago.dias\"\n                                                           [format]=\"'n0'\"\n                                                           [min]=\"1\"\n                                                           [max]=\"365\">\n                                          </az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Descripci&oacute;n:'\">\n                                          <az-textarea formControlName=\"descripcion\"\n                                                       [(ngModel)]=\"periodicidadPago.descripcion\">\n                                          </az-textarea>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </tab>\n\n                          <tab heading=\"Fechas\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #editListPeriodos\n                                                    [allowNew]=\"true\"\n                                                    [allowEdit]=\"true\"\n                                                    [listItems]=\"periodicidadPago.periodos\"\n                                                    (addingItem)=\"onAddingItemPeriodo()\"\n                                                    (editingItem)=\"onEditingItemPeriodo($event)\"\n                                                    (listItemsUpdated)=\"onListItemUpdatePeriodo($event)\"\n                                                    (deletingItem)=\"onDeletingPeriodo($event)\">\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-edit'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"180\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"180\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Ini Incidencia'\" [binding]=\"'fechaIniPago'\" [width]=\"110\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Fin Incidencia'\" [binding]=\"'fechaFinPago'\" [width]=\"110\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Ini Pago'\" [binding]=\"'fechaIniIncidencia'\" [width]=\"110\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Fin Pago'\" [binding]=\"'fechaFinIncidencia'\" [width]=\"110\"></azteca-grid-column>\n                              </azteca-editable-list>\n                          </tab>\n\n                      </tabset>\n                  </div>\n              </div>\n\n          </azteca-catalog-editor>\n      </form>\n\n\n      <div bsModal #dlgPeriodo=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <!--Modal Header-->\n                      <h4>Periodo</h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"dlgPeriodo.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div> <!--Modal Header-->\n                  <div class=\"modal-body\" [formGroup]=\"formPeriodo\">\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-4\">\n                              <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                                  <az-textbox formControlName=\"periodoCodigo\"\n                                              [(ngModel)]=\"periodo.codigo\">\n                                  </az-textbox>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-8\">\n                              <azteca-form-field [label]=\"'Nombre:'\">\n                                  <az-textbox formControlName=\"periodoNombre\"\n                                              [(ngModel)]=\"periodo.nombre\">\n                                  </az-textbox>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-4\">\n                              <label>Inicio Pago</label>\n                              <wj-input-date [(value)]=\"periodo.fechaIniPago\"\n                                             [format]=\"'MMM dd, yyyy'\">\n                              </wj-input-date>\n                          </div>\n                          <div class=\"col-12 col-md-4\">\n                              <label>Final Pago</label>\n                              <wj-input-date [(value)]=\"periodo.fechaFinPago\"\n                                             [min]=\"periodo.fechaIniPago\"\n                                             [format]=\"'MMM dd, yyyy'\">\n                              </wj-input-date>\n                          </div>\n                      </div>\n\n                      <div class=\"card\">\n                          <h5 class=\"card-header\">Periodo de Incidencias</h5>\n                          <div class=\"card-body\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <label>Inicio Incidencia</label>\n                                      <wj-input-date [(value)]=\"periodo.fechaIniIncidencia\"\n                                                     [format]=\"'MMM dd, yyyy'\">\n                                      </wj-input-date>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <label>Final Incidencia</label>\n                                      <wj-input-date [(value)]=\"periodo.fechaFinIncidencia\"\n                                                     [min]=\"periodo.fechaIniIncidencia\"\n                                                     [format]=\"'MMM dd, yyyy'\">\n                                      </wj-input-date>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <label>D&iacute;s Incidencias</label>\n                                      <wj-calendar #calendarFechaIncidencia\n                                                   [(value)]=\"fechaSelected\"\n                                                   (valueChanged)=\"onDayClicked($event)\"\n                                                   [min]=\"periodo.fechaIniIncidencia\"\n                                                   [max]=\"periodo.fechaFinIncidencia\">\n                                      </wj-calendar>\n                                  </div>\n                                  <div class=\"col-12 col-md-6\">\n                                      <div class=\"row\">\n                                          <az-checkbox formControlName=\"periodoDiaFeriado\"\n                                                       [label]=\"'Feriado'\"\n                                                       [(ngModel)]=\"periodoDia.feriado\"></az-checkbox>\n                                      </div>\n                                      <div class=\"row\">\n                                          <azteca-form-field [label]=\"'Costo por d\u00EDa:'\">\n                                              <az-input-number formControlName=\"periodoDiaFormaPago\"\n                                                               [(ngModel)]=\"periodoDia.formaPago\"\n                                                               [format]=\"'n2'\"\n                                                               [min]=\"1\">\n                                              </az-input-number>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n                              </div>\n                          </div>\n                      </div>\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdatedPeriodo()\" [disabled]=\"!formPeriodo.valid\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dlgPeriodo.hide()\">Cancelar</button>\n                  </div> <!--Modal Footer-->\n\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return PeriodicidadPagoEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: periodicidad_pago_service_1.PeriodicidadPagoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, periodicidad_pago_service_1.PeriodicidadPagoService])
    ], PeriodicidadPagoEditor);
    return PeriodicidadPagoEditor;
}(editors_1.CatalogEditor));
exports.PeriodicidadPagoEditor = PeriodicidadPagoEditor;
