import { ChangeDetectorRef, OnInit } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { TreeNode } from 'angular-tree-component';
import { Context, HierarchyChanges } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { HierarchyManager } from 'framework3/editors';
import { PuestoInfo } from '../models/puesto';
import { PuestoService } from '../services/puesto.service';
import { RiesgoPuestoService } from '../../accounting';
export declare class PuestosManager extends HierarchyManager implements OnInit {
    protected context: Context;
    protected changeDetector: ChangeDetectorRef;
    private formBuilder;
    private puestoService;
    protected router: Router;
    protected route: ActivatedRoute;
    private riesgoPuestoSvc;
    puestos: PuestoInfo[];
    puestoEdicion: PuestoInfo;
    currentNode: TreeNode;
    currentParent: TreeNode;
    riesgosPuestos: any[];
    constructor(context: Context, changeDetector: ChangeDetectorRef, formBuilder: FormBuilder, puestoService: PuestoService, router: Router, route: ActivatedRoute, riesgoPuestoSvc: RiesgoPuestoService);
    ngOnInit(): void;
    loadHierarchy(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onNodesChanged(puestos: PuestoInfo[]): void;
    onCurrentNodeChanged(node: TreeNode): void;
    onCreatingNode(parentNode: TreeNode): void;
    onEditingNode(node: TreeNode): void;
    onSavingNode(): void;
    onDeletingNode(node: TreeNode): void;
    onSavingHierarchy(changes: HierarchyChanges<PuestoInfo>): void;
}
