"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
//
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//
var puesto_1 = require("../models/puesto");
var puesto_service_1 = require("../services/puesto.service");
var accounting_1 = require("../../accounting");
var PuestosManager = /** @class */ (function (_super) {
    __extends(PuestosManager, _super);
    function PuestosManager(context, changeDetector, formBuilder, puestoService, router, route, riesgoPuestoSvc) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.context = context;
        _this.changeDetector = changeDetector;
        _this.formBuilder = formBuilder;
        _this.puestoService = puestoService;
        _this.router = router;
        _this.route = route;
        _this.riesgoPuestoSvc = riesgoPuestoSvc;
        _this.puestos = [];
        _this.puestoEdicion = new puesto_1.PuestoInfo();
        _this.riesgosPuestos = [];
        _this.nodeForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'cuenta': [null],
            'departamento': [null],
            'riesgoPuesto': [0]
        });
        return _this;
    }
    PuestosManager_1 = PuestosManager;
    PuestosManager.prototype.ngOnInit = function () {
        var _this = this;
        this.context.app.showSpinner();
        setTimeout(function () {
            _this.riesgoPuestoSvc.getRiesgoPuestoCbo(_this.context.app.defaultSite.identity)
                .then(function (info) {
                _this.riesgosPuestos = info;
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        });
    };
    ////////////////////// METODOS //////////////////////////////////////////////
    PuestosManager.prototype.loadHierarchy = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.puestoService.loadHierarchy(this.context.app.defaultCompany.identity, 0)
            .then(function (nodes) {
            _this.context.app.hideSpinner();
            _this.puestos = nodes;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //////////////////// HANDLERS //////////////////////////////////////
    PuestosManager.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.loadHierarchy();
        //Hacer llamadas de carga inicial de datos aquí
    };
    PuestosManager.prototype.onNodesChanged = function (puestos) {
        this.puestos = puestos;
    };
    PuestosManager.prototype.onCurrentNodeChanged = function (node) {
        this.currentNode = node;
    };
    PuestosManager.prototype.onCreatingNode = function (parentNode) {
        this.puestoEdicion = new puesto_1.PuestoInfo(); //Crear nueva instancia para evitar que reset modifique la información del último nodo en edición
        this.nodeForm.reset();
        this.puestoEdicion = new puesto_1.PuestoInfo(); //Se vuelve a crear instancia para evitar valores nulos creados por reset
        //Inicializar valores del nodo
        this.puestoEdicion.idBranch = this.context.app.defaultSite.identity;
        this.puestoEdicion.idCompany = this.context.app.defaultCompany.identity;
        //
        this.currentParent = parentNode;
        this.showEditor();
    };
    PuestosManager.prototype.onEditingNode = function (node) {
        this.puestoEdicion = this.puestoService.copy(node.data);
        this.showEditor();
    };
    PuestosManager.prototype.onSavingNode = function () {
        //Si es un nuevo nodo
        if (this.puestoEdicion.clientID == 0) {
            this.addNode(this.puestoEdicion, this.currentParent);
        }
        //Si se estaba editando un nodo existente
        else {
            this.updateNode(this.puestoEdicion);
        }
        this.puestoEdicion = new puesto_1.PuestoInfo();
        this.hideEditor();
    };
    PuestosManager.prototype.onDeletingNode = function (node) {
        this.deleteNode(node);
    };
    PuestosManager.prototype.onSavingHierarchy = function (changes) {
        var _this = this;
        this.context.app.showSpinner();
        this.puestoService.saveHierarchy(changes)
            .then(function (puestos) {
            _this.puestos = puestos;
            _this.reset();
            _this.context.app.hideSpinner();
            _this.showAlert('Los cambios han sido guardados con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var PuestosManager_1;
    PuestosManager = PuestosManager_1 = __decorate([
        core_1.Component({
            selector: 'rh-puestos-manager',
            template: "\n      <azteca-hierarchy-manager (configureCatalog)=\"onConfigureCatalog($event)\"\n                                (currentNodeChanged)=\"onCurrentNodeChanged($event)\"\n                                (creatingNode)=\"onCreatingNode($event)\"\n                                (editingNode)=\"onEditingNode($event)\"\n                                (savingNode)=\"onSavingNode()\"\n                                (deletingNode)=\"onDeletingNode($event)\"\n                                (savingHierarchy)=\"onSavingHierarchy($event)\"\n                                (nodesChanged)=\"onNodesChanged($event)\"\n                                [title]=\"'Administraci\u00F3n de puestos'\"\n                                [validForm]=\"nodeForm.valid\"\n                                [currentNode]=\"currentNode\"\n                                [nodes]=\"puestos\">\n\n          <form [formGroup]=\"nodeForm\">\n              <div class=\"row\">\n\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"puestoEdicion.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <label class=\"control-label\">Ruta:</label>\n                      <az-label [text]=\"puestoEdicion.namedPath\"></az-label>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"puestoEdicion.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Cuenta:'\">\n                          <accounting-cuenta-selector formControlName=\"cuenta\"\n                                                      [(ngModel)]=\"puestoEdicion.idCuenta\">\n                          </accounting-cuenta-selector>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Departamento:'\">\n                          <rh-departamento-selector formControlName=\"departamento\"\n                                                    [(ngModel)]=\"puestoEdicion.idDepartamento\">\n                          </rh-departamento-selector>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-6\">\n                      <azteca-form-field [label]=\"'Riesgo Puesto:'\">\n                          <az-combobox formControlName=\"riesgoPuesto\" [(ngModel)]=\"puestoEdicion.idRiesgoPuesto\" [items]=\"riesgosPuestos\" [displayMember]=\"'nombre'\" [valueMember]=\"'id'\"></az-combobox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n          </form>\n\n      </azteca-hierarchy-manager>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return PuestosManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: puesto_service_1.PuestoService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, core_1.ChangeDetectorRef, forms_1.FormBuilder, puesto_service_1.PuestoService, router_1.Router, router_1.ActivatedRoute,
            accounting_1.RiesgoPuestoService])
    ], PuestosManager);
    return PuestosManager;
}(editors_1.HierarchyManager));
exports.PuestosManager = PuestosManager;
