import { EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogManager } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { SucursalService } from '../services/sucursal.service';
import { SucursalItem } from '../models/sucursal';
export declare class SucursalesManager extends CatalogManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private sucursalService;
    sucursales: SucursalItem[];
    idEmpresa: number;
    refreshListParent: EventEmitter<void>;
    constructor(context: Context, router: Router, route: ActivatedRoute, sucursalService: SucursalService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
}
