"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var core_3 = require("@angular/core");
var wijmo_1 = require("wijmo/wijmo");
var suspension_service_1 = require("../services/suspension.service");
var suspensionEditor = /** @class */ (function () {
    function suspensionEditor(formBuilder, suspensionSvc, context, router, route) {
        this.formBuilder = formBuilder;
        this.suspensionSvc = suspensionSvc;
        this.context = context;
        this.router = router;
        this.route = route;
        this.info_Suspension = [];
        this.previewCollection = new wijmo_1.CollectionView();
        this.selectedCollection = new wijmo_1.CollectionView();
        this.form = formBuilder.group({
            'Codigo': '',
            'Descripcion': ""
        });
    }
    suspensionEditor_1 = suspensionEditor;
    suspensionEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (params) {
            if (params['id']) {
                _this.identity = +params['id'];
                if (_this.identity > 0) {
                    _this.suspensionSvc.getSuspensionById(_this.identity)
                        .then(function (result) {
                        _this.info_Suspension = result;
                        _this.previewCollection.sourceCollection = _this.info_Suspension;
                    });
                }
            }
        });
    };
    //Actualiza información del Suspension.
    suspensionEditor.prototype.putSuspension = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.suspensionSvc.putSuspension(this.info_Suspension)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert("Se actualizó la información de suspensión.", "success");
        })
            .catch(function (error) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert("Error al actualizar información de suspensión, valida los datos.", "danger");
        });
    };
    //Muestra mensaje de error.
    suspensionEditor.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert("Error al editar información", "danger");
    };
    var suspensionEditor_1;
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], suspensionEditor.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('viewDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], suspensionEditor.prototype, "viewDialog", void 0);
    suspensionEditor = suspensionEditor_1 = __decorate([
        core_1.Component({
            selector: 'suspension-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <!--Componente para cargar el archivo.-->\n          <div [formGroup]=\"form\">\n              <!--Panel para mostrar el t\u00EDtulo de la reestructura-->\n              <div class=\"row\">\n                  <az-panel [header]=\"'SUSPENSIONES EDITOR'\" >\n                      <alerts-bar></alerts-bar>\n                      <!--T\u00EDtulo de la Reestructura-->\n                      <div class=\"row\">\n                          <div class=\"col-12 \">\n                              <p style=\"color: dimgray\">Detalle de Suspension.</p>\n                              <wj-flex-grid #grid style=\"height:200px ; width: auto;\"\n                                            [itemsSource]=\"previewCollection\">\n                                  <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                  <wj-flex-grid-column [header]=\"'IdSuspensionCat'\" [binding]=\"'idSuspensionCat'\" [width]=\"'50*'\" [isReadOnly]=\"true\" [visible]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'50*'\" [isReadOnly]=\"false\" [visible]=\"true\" [dataType]=\"Number\" [format]=\"d\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Descripcion'\" [binding]=\"'descripcion'\" [width]=\"'50*'\" [isReadOnly]=\"false\" [visible]=\"true\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n\n                              <button type=\"button\" class=\"btn btn-default d-none d-md-block\" style=\"background-color:dodgerblue; color:white\" (click)=\"putSuspension()\">\n                                  <span class=\"glyphicon glyphicon-refresh\" aria-hidden=\"true\"></span> Actualizar Informaci\u00F3n\n                              </button>\n\n                          </div>\n                      </div>\n                  </az-panel>\n              </div>\n          </div>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_3.forwardRef(function () { return suspensionEditor_1; })
                }
            ]
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder,
            suspension_service_1.suspensionService,
            core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute])
    ], suspensionEditor);
    return suspensionEditor;
}());
exports.suspensionEditor = suspensionEditor;
