"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var tipos_descuentos_service_1 = require("../services/tipos-descuentos.service");
var tipo_descuento_1 = require("../models/tipo-descuento");
var TiposDescuentosEditor = /** @class */ (function (_super) {
    __extends(TiposDescuentosEditor, _super);
    //
    function TiposDescuentosEditor(router, route, formBuilder, changeDetector, context, location, tiposDescuentosService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.tiposDescuentosService = tiposDescuentosService;
        _this.tiposDescuentos = new tipo_descuento_1.TiposDescuentosInfo();
        _this.tipos = [{ 'value': 'P', 'text': 'Porcentaje' }, { 'value': 'M', 'text': 'Monto' }];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'secuencia': ['', forms_1.Validators.required],
            'tipo': ['', forms_1.Validators.required]
        });
        return _this;
    }
    TiposDescuentosEditor_1 = TiposDescuentosEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    TiposDescuentosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    TiposDescuentosEditor.prototype.onCreatingItem = function () {
    };
    TiposDescuentosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.tiposDescuentosService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.tiposDescuentos = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TiposDescuentosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.tiposDescuentosService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.tiposDescuentos = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TiposDescuentosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.tiposDescuentosService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.tiposDescuentos = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TiposDescuentosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.tiposDescuentosService.update(this.tiposDescuentos)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.tiposDescuentos.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.tiposDescuentos = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var TiposDescuentosEditor_1;
    TiposDescuentosEditor = TiposDescuentosEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-tipos-descuentos-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'TiposDescuentos'\"\n                                 [info]=\"tiposDescuentos\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"tiposDescuentos.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"tiposDescuentos.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n\n\t\t\t\t\t\t\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Secuencia de Variable del Trabajador:'\">\n                                          <az-input-number formControlName=\"secuencia\" [(ngModel)]=\"tiposDescuentos.secuencia\" [value]=\"tiposDescuentos.secuencia\" [min]=\"0\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Tipo:'\">\n                                          <az-combobox formControlName=\"tipo\" [(ngModel)]=\"tiposDescuentos.tipo\" [items]=\"tipos\" [displayMember]=\"'text'\" [valueMember]=\"'value'\" ></az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\t\t\t\t\t\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return TiposDescuentosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: tipos_descuentos_service_1.TiposDescuentosService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, tipos_descuentos_service_1.TiposDescuentosService])
    ], TiposDescuentosEditor);
    return TiposDescuentosEditor;
}(editors_1.CatalogEditor));
exports.TiposDescuentosEditor = TiposDescuentosEditor;
