import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs, EditableListComponent } from 'framework3/editors';
import { TipoNominaService } from '../services/tipo-nomina.service';
import { TipoNominaInfo, TipoNominaConceptoItem } from '../models/tipo-nomina';
import { ConceptoAdamItem } from '../models/concepto-adam';
import { ConceptosListComponent } from '../controls/conceptos-list.component';
export declare class TiposNominasEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private tipoNominaService;
    tipoNomina: TipoNominaInfo;
    dlgConceptos: ConceptosListComponent;
    editListConceptos: EditableListComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, tipoNominaService: TipoNominaService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onAddingConcepto(): void;
    onListItemUpdatedConcepto(conceptos: TipoNominaConceptoItem[]): void;
    onDeletingConcepto(concepto: TipoNominaConceptoItem): void;
    onSelectedItemsConcepto(items: ConceptoAdamItem[]): void;
    onSelectedItemConcepto(item: ConceptoAdamItem): void;
    createConcepto(item: ConceptoAdamItem): TipoNominaConceptoItem;
    onTabSelected(args: any): void;
}
