"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var tipo_nomina_service_1 = require("../services/tipo-nomina.service");
var tipo_nomina_1 = require("../models/tipo-nomina");
var conceptos_list_component_1 = require("../controls/conceptos-list.component");
var TiposNominasEditor = /** @class */ (function (_super) {
    __extends(TiposNominasEditor, _super);
    function TiposNominasEditor(router, route, formBuilder, changeDetector, context, location, tipoNominaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.tipoNominaService = tipoNominaService;
        _this.tipoNomina = new tipo_nomina_1.TipoNominaInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idCompania': [0, controls_1.AztecaValidators.selected],
            'idPeriodicidadPago': [0, controls_1.AztecaValidators.selected],
            'descripcion': ['']
        });
        return _this;
    }
    TiposNominasEditor_1 = TiposNominasEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    TiposNominasEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    TiposNominasEditor.prototype.onCreatingItem = function () {
    };
    TiposNominasEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.tipoNominaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.tipoNomina = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TiposNominasEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.tipoNominaService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.tipoNomina = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TiposNominasEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.tipoNominaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.tipoNomina = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TiposNominasEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.tipoNominaService.update(this.tipoNomina)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.tipoNomina.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.tipoNomina = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    // Editing items
    TiposNominasEditor.prototype.onAddingConcepto = function () {
        this.dlgConceptos.show();
    };
    TiposNominasEditor.prototype.onListItemUpdatedConcepto = function (conceptos) {
        this.tipoNomina.conceptos = conceptos;
    };
    TiposNominasEditor.prototype.onDeletingConcepto = function (concepto) {
        this.editListConceptos.deleteItem(concepto);
    };
    // Conceptos
    TiposNominasEditor.prototype.onSelectedItemsConcepto = function (items) {
        var _this = this;
        var conceptos = [];
        items.forEach(function (item) {
            var concepto = _this.createConcepto(item);
            conceptos.push(concepto);
        });
        this.editListConceptos.updateItems(conceptos);
    };
    TiposNominasEditor.prototype.onSelectedItemConcepto = function (item) {
        var concepto = this.createConcepto(item);
        this.editListConceptos.updateItem(concepto);
    };
    TiposNominasEditor.prototype.createConcepto = function (item) {
        var tipoNominaConcepto = new tipo_nomina_1.TipoNominaConceptoItem();
        tipoNominaConcepto._clientID = item.id;
        tipoNominaConcepto.idConcepto = item.id;
        tipoNominaConcepto.codigo = item.codigo;
        tipoNominaConcepto.concepto = item.descripcion;
        return tipoNominaConcepto;
    };
    TiposNominasEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    var TiposNominasEditor_1;
    __decorate([
        core_1.ViewChild(conceptos_list_component_1.ConceptosListComponent),
        __metadata("design:type", conceptos_list_component_1.ConceptosListComponent)
    ], TiposNominasEditor.prototype, "dlgConceptos", void 0);
    __decorate([
        core_1.ViewChild('editListConceptos'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], TiposNominasEditor.prototype, "editListConceptos", void 0);
    TiposNominasEditor = TiposNominasEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-tipo-nomina-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'RH - TiposNominas'\"\n                                 [info]=\"tipoNomina\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"tipoNomina.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"tipoNomina.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Compa\u00F1\u00EDa:'\">\n                                          <rh-compania-selector formControlName=\"idCompania\"\n                                                                [(ngModel)]=\"tipoNomina.idCompania\">\n                                          </rh-compania-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Periodo Pago:'\">\n                                          <rh-periodicidad-pago-selector formControlName=\"idPeriodicidadPago\"\n                                                                         [(ngModel)]=\"tipoNomina.idPeriodicidadPago\">\n                                          </rh-periodicidad-pago-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Descripci\u00F3n:'\">\n                                          <az-textarea formControlName=\"descripcion\"\n                                                       [(ngModel)]=\"tipoNomina.descripcion\">\n                                          </az-textarea>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                          <tab heading=\"Conceptos\" (select)=\"onTabSelected($event)\">\n\n                              <azteca-editable-list #editListConceptos\n                                                    [allowNew]=\"true\"\n                                                    [allowEdit]=\"false\"\n                                                    [(listItems)]=\"tipoNomina.conceptos\"\n                                                    (addingItem)=\"onAddingConcepto()\"\n                                                    (listItemsUpdated)=\"onListItemUpdatedConcepto($event)\"\n                                                    (deletingItem)=\"onDeletingConcepto($event)\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"180\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Concepto'\" [binding]=\"'concepto'\" [width]=\"'180*'\"></azteca-grid-column>\n                              </azteca-editable-list>\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n\n\n      <rh-conceptos-list [multiSelect]=\"true\"\n                         (selectedItemsChanged)=\"onSelectedItemsConcepto($event)\"\n                         (selectedItemChanged)=\"onSelectedItemConcepto($event)\">\n      </rh-conceptos-list>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return TiposNominasEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: tipo_nomina_service_1.TipoNominaService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, tipo_nomina_service_1.TipoNominaService])
    ], TiposNominasEditor);
    return TiposNominasEditor;
}(editors_1.CatalogEditor));
exports.TiposNominasEditor = TiposNominasEditor;
