import { OnInit, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormControl } from '@angular/forms';
import { Location } from '@angular/common';
import * as wjcGrid from 'wijmo/wijmo.grid';
import { Menu } from 'wijmo/wijmo.input';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, CatalogItem } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { ToolbarButton, MenuItem } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs, TrackableCollection } from 'framework3/editors';
import { TurnoService } from '../services/turno.service';
import { TurnoInfo } from '../models/turno';
import { JornadaService } from '../../accounting/services/jornada.service';
import { HorarioService } from '../services/horario.service';
import { HorarioItem } from '../models/horario';
import { HorarioListComponent } from '../controls/horario-list.component';
import { FormGroup } from '@angular/forms/src/model';
import { EmpleadoItem } from '../models/empleado';
import { EmpleadoListComponent } from '../controls/empleado-list.component';
export declare class TurnosEditor extends CatalogEditor implements OnInit {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private turnoService;
    private jornadaSvc;
    private horarioSvc;
    formNumero: FormGroup;
    turno: TurnoInfo;
    horario: number;
    empleados: EmpleadoItem[];
    currentItem: CatalogItem;
    cvCiclo: TrackableCollection;
    menuCicloItems: MenuItem[];
    horarioCiclo: boolean;
    titleNumero: string;
    numero: number;
    turnoTipos: {
        'name': string;
        'value': string;
    }[];
    jornadas: any[];
    diasCubreTurno: boolean;
    evaluarAccion: FormControl;
    dlgHorario: HorarioListComponent;
    dlgNumero: ModalDirective;
    selEmpleado: EmpleadoListComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, turnoService: TurnoService, jornadaSvc: JornadaService, horarioSvc: HorarioService);
    ngOnInit(): void;
    createMenuDetail(): void;
    contextMnuHorarioClick(menu: Menu): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    updateCiclo(tipo: string, ciclo: number): void;
    initializedGrdCiclo(sender: wjcGrid.FlexGrid, args: any): void;
    onTabSelectedFlexGrid(flex: wjcGrid.FlexGrid): void;
    onSelectedHorario(horarioItem: HorarioItem): void;
    onClickCiclos(): void;
    onUpdatedNumro(): void;
    createClientID(): number;
    onToolbarButtonClick(button: ToolbarButton): void;
    onCurrentItemChanged(item: CatalogItem): void;
    refreshListEmployes(): void;
    onSelectedEmleados(items: EmpleadoItem[]): void;
    onRemoveEmploye(): void;
}
