"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
var wijmo_1 = require("wijmo/wijmo");
var wjcGrid = require("wijmo/wijmo.grid");
//moment
var moment = require("moment");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var turno_service_1 = require("../services/turno.service");
var turno_1 = require("../models/turno");
var jornada_service_1 = require("../../accounting/services/jornada.service");
var horario_service_1 = require("../services/horario.service");
var horario_list_component_1 = require("../controls/horario-list.component");
var empleado_list_component_1 = require("../controls/empleado-list.component");
var TurnosEditor = /** @class */ (function (_super) {
    __extends(TurnosEditor, _super);
    //
    function TurnosEditor(router, route, formBuilder, changeDetector, context, location, turnoService, jornadaSvc, horarioSvc) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.turnoService = turnoService;
        _this.jornadaSvc = jornadaSvc;
        _this.horarioSvc = horarioSvc;
        _this.turno = new turno_1.TurnoInfo();
        _this.horario = 0;
        _this.empleados = [];
        _this.menuCicloItems = [];
        _this.horarioCiclo = false;
        _this.titleNumero = "";
        _this.numero = 0;
        _this.turnoTipos = [
            { 'name': 'Semanal', 'value': 'S' },
            { 'name': 'Mensual', 'value': 'M' },
            { 'name': 'Programado', 'value': 'P' }
        ];
        _this.jornadas = [];
        _this.diasCubreTurno = false;
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'tipo': ['', forms_1.Validators.required],
            'ciclo': [''],
            'retardos': [''],
            'periodoDias': [''],
            'accion': [''],
            'nocturno': [''],
            'cuenta': [''],
            'diasCubreTurno': [''],
            'evaluarAccion': [''],
            'diasAccion': [''],
            'horario': [''],
            'idJornada': [0],
            'dom': [''],
            'lun': [''],
            'mar': [''],
            'mie': [''],
            'jue': [''],
            'vie': [''],
            'sab': ['']
        });
        _this.formNumero = formBuilder.group({
            'numero': [0, forms_1.Validators.required]
        });
        _this.evaluarAccion = _this.catalogForm.controls['evaluarAccion'];
        _this.cvCiclo = new editors_1.TrackableCollection();
        return _this;
    }
    TurnosEditor_1 = TurnosEditor;
    TurnosEditor.prototype.ngOnInit = function () {
        var _this = this;
        setTimeout(function () {
            _this.context.app.showSpinner();
            _this.jornadaSvc.getJornadaCbo(_this.context.app.defaultSite.identity)
                .then(function (info) {
                _this.jornadas = info;
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
            _this.createMenuDetail();
        });
        this.evaluarAccion.valueChanges.subscribe(function (value) {
            _this.turno.accion = value;
        });
    };
    TurnosEditor.prototype.createMenuDetail = function () {
        var mnuHorarioEliminar = { icon: "glyphicon glyphicon-trash", text: "Quitar Horario", name: "REMOVER_HORARIO", smallText: "Quitar horario" };
        var mnuHorarioCiclo = { icon: "glyphicon glyphicon-time", text: "Horario Ciclo", name: "HORARIO_CICLO", smallText: "Horario ciclo" };
        var mnuDiasCiclo = { icon: "glyphicon glyphicon-pencil", text: "Días Ciclo", name: "DIAS_CICLO", smallText: "Días ciclo" };
        this.menuCicloItems.push(mnuHorarioEliminar, mnuHorarioCiclo, mnuDiasCiclo);
        this.menuCicloItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    TurnosEditor.prototype.contextMnuHorarioClick = function (menu) {
        var option = this.menuCicloItems[menu.selectedIndex];
        if (option.name == "REMOVER_HORARIO") {
            this.context.app.showSpinner();
            var item = this.cvCiclo.currentItem;
            if (item) {
                this.cvCiclo.editItem(item);
                item.idHorario = 0;
                item.horario = null;
                item.state = core_2.ChangeState.MODIFIED;
                this.cvCiclo.commitEdit();
            }
            this.context.app.hideSpinner();
        }
        else if (option.name == "HORARIO_CICLO") {
            this.horarioCiclo = true;
            this.dlgHorario.show();
        }
        else if (option.name == "DIAS_CICLO") {
            if (this.turno.tipo == "P") {
                this.titleNumero = "Num. Días";
                this.numero = 1;
                this.dlgNumero.config.backdrop = false;
                this.dlgNumero.show();
            }
            else {
                this.showAlert('Opción para turnos programados', 'warning');
            }
        }
    };
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    TurnosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    TurnosEditor.prototype.onCreatingItem = function () {
        this.cvCiclo.sourceCollection = this.turno.horarios;
        this.cvCiclo.refresh();
        this.evaluarAccion.setValue("N");
    };
    TurnosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.turnoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.turno = info;
            _this.cvCiclo.sourceCollection = _this.turno.horarios;
            _this.cvCiclo.refresh();
            _this.evaluarAccion.setValue(_this.turno.accion);
            _this.diasCubreTurno = _this.turno.tipoPeriodo == "T";
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TurnosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.turnoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.turno = info;
            _this.turno.horarios = [];
            _this.cvCiclo.sourceCollection = _this.turno.horarios;
            _this.cvCiclo.refresh();
            _this.evaluarAccion.setValue(_this.turno.accion);
            _this.diasCubreTurno = _this.turno.tipoPeriodo == "T";
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TurnosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.turnoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.turno = info;
            _this.cvCiclo.sourceCollection = _this.turno.horarios;
            _this.cvCiclo.refresh();
            _this.evaluarAccion.setValue(_this.turno.accion);
            _this.diasCubreTurno = _this.turno.tipoPeriodo == "T";
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TurnosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.turno.accion = this.evaluarAccion.value;
        this.turno.tipoPeriodo = this.diasCubreTurno ? "T" : "F";
        this.context.app.showSpinner();
        this.turnoService.update(this.turno)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.turno = info;
            _this.cvCiclo.sourceCollection = _this.turno.horarios;
            _this.cvCiclo.refresh();
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TurnosEditor.prototype.updateCiclo = function (tipo, ciclo) {
        var _this = this;
        this.cvCiclo.items.forEach(function (item) {
            _this.cvCiclo.editItem(item);
            item.state = core_2.ChangeState.DELETED;
            _this.cvCiclo.commitEdit();
        });
        switch (tipo) {
            case 'S':
                if (this.cvCiclo.itemCount != ciclo * 7) {
                    for (var indexCiclo = 1; indexCiclo <= ciclo; indexCiclo++) {
                        for (var index = 1; index <= 7; index++) {
                            var item = this.cvCiclo.addNew();
                            item._clientID = this.createClientID();
                            item.dia = index;
                            item.ciclo = indexCiclo;
                            item.state = core_2.ChangeState.ADDED;
                            this.cvCiclo.commitNew();
                        }
                    }
                }
                break;
            case 'M':
                if (this.cvCiclo.itemCount != ciclo * 31) {
                    for (var indexCiclo = 1; indexCiclo <= ciclo; indexCiclo++) {
                        for (var index = 1; index <= 31; index++) {
                            var item = this.cvCiclo.addNew();
                            item._clientID = this.createClientID();
                            item.dia = index;
                            item.ciclo = indexCiclo;
                            item.state = core_2.ChangeState.ADDED;
                            this.cvCiclo.commitNew();
                        }
                    }
                }
                break;
            case 'P':
                for (var indexCiclo = 1; indexCiclo <= ciclo; indexCiclo++) {
                    var item = this.cvCiclo.addNew();
                    item._clientID = this.createClientID();
                    item.dia = 1;
                    item.ciclo = indexCiclo;
                    item.state = core_2.ChangeState.ADDED;
                    this.cvCiclo.commitNew();
                }
                break;
        }
    };
    TurnosEditor.prototype.initializedGrdCiclo = function (sender, args) {
        var _this = this;
        var self = this;
        //Manejo de doble click
        sender.addEventListener(sender.hostElement, "dblclick", function (e) {
            var ht = sender.hitTest(e);
            if (ht.cellType == wjcGrid.CellType.Cell) {
                _this.dlgHorario.show();
            }
        });
    };
    TurnosEditor.prototype.onTabSelectedFlexGrid = function (flex) {
        if (flex.collectionView != null) {
            flex.collectionView.refresh();
        }
        wijmo_1.Control.invalidateAll();
    };
    TurnosEditor.prototype.onSelectedHorario = function (horarioItem) {
        var _this = this;
        var horarioByCiclo = this.horarioCiclo;
        this.horarioCiclo = false;
        this.context.app.showSpinner();
        this.horarioSvc.getDetailByID(horarioItem.id)
            .then(function (info) {
            var item = _this.cvCiclo.currentItem;
            if (item) {
                if (horarioByCiclo) {
                    _this.cvCiclo.items.forEach(function (itemCiclo) {
                        if (item.ciclo == itemCiclo.ciclo) {
                            _this.cvCiclo.editItem(itemCiclo);
                            itemCiclo.idHorario = info.identity;
                            itemCiclo.horario = info;
                            itemCiclo.state = core_2.ChangeState.MODIFIED;
                            _this.cvCiclo.commitEdit();
                        }
                    });
                }
                else {
                    _this.cvCiclo.editItem(item);
                    item.idHorario = info.identity;
                    item.horario = info;
                    item.state = core_2.ChangeState.MODIFIED;
                    _this.cvCiclo.commitEdit();
                }
                _this.context.app.hideSpinner();
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TurnosEditor.prototype.onClickCiclos = function () {
        this.numero = this.turno.ciclo;
        this.titleNumero = "Num. Ciclos";
        this.dlgNumero.config.backdrop = false;
        this.dlgNumero.show();
    };
    TurnosEditor.prototype.onUpdatedNumro = function () {
        var _this = this;
        this.context.app.showSpinner();
        if (this.titleNumero == "Num. Ciclos") {
            this.turno.ciclo = this.numero;
            this.updateCiclo(this.turno.tipo, this.turno.ciclo);
        }
        else {
            var item_1 = this.cvCiclo.currentItem;
            if (item_1) {
                this.cvCiclo.items.forEach(function (itemCiclo) {
                    if (item_1.ciclo == itemCiclo.ciclo) {
                        _this.cvCiclo.editItem(itemCiclo);
                        itemCiclo.state = core_2.ChangeState.DELETED;
                        _this.cvCiclo.commitEdit();
                    }
                });
                this.cvCiclo.beginUpdate();
                for (var indexDia = 1; indexDia <= this.numero; indexDia++) {
                    var itemCiclo = this.cvCiclo.addNew();
                    itemCiclo._clientID = this.createClientID();
                    itemCiclo.dia = indexDia;
                    itemCiclo.ciclo = item_1.ciclo;
                    itemCiclo.state = core_2.ChangeState.ADDED;
                }
                this.cvCiclo.endUpdate();
            }
        }
        this.context.app.hideSpinner();
        this.dlgNumero.hide();
    };
    TurnosEditor.prototype.createClientID = function () {
        return parseInt((Math.random() * 1000).toString()) * 1000 + parseInt(moment().format("HHmmss"));
    };
    TurnosEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.selEmpleado.show();
        }
    };
    TurnosEditor.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    TurnosEditor.prototype.refreshListEmployes = function () {
        var _this = this;
        if (this.turno.identity > 0) {
            this.context.app.showSpinner();
            this.turnoService.getEmpleadosByTurno(this.turno.identity, this.context.app.defaultSite.identity)
                .then(function (empleados) {
                _this.empleados = empleados;
                _this.context.app.hideSpinner();
                wijmo_1.Control.invalidateAll();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    TurnosEditor.prototype.onSelectedEmleados = function (items) {
        var _this = this;
        this.context.app.showSpinner();
        this.turnoService.addTurnoEmpleado(this.turno.identity, items)
            .then(function (info) { return _this.refreshListEmployes(); })
            .catch(function (error) { return _this.handleError(error); });
    };
    TurnosEditor.prototype.onRemoveEmploye = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.turnoService.removeTurnoEmpleado(this.currentItem.id)
            .then(function (info) { return _this.refreshListEmployes(); })
            .catch(function (error) { return _this.handleError(error); });
    };
    var TurnosEditor_1;
    __decorate([
        core_1.ViewChild('dlgHorario'),
        __metadata("design:type", horario_list_component_1.HorarioListComponent)
    ], TurnosEditor.prototype, "dlgHorario", void 0);
    __decorate([
        core_1.ViewChild('dlgNumero'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], TurnosEditor.prototype, "dlgNumero", void 0);
    __decorate([
        core_1.ViewChild(empleado_list_component_1.EmpleadoListComponent),
        __metadata("design:type", empleado_list_component_1.EmpleadoListComponent)
    ], TurnosEditor.prototype, "selEmpleado", void 0);
    TurnosEditor = TurnosEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-turno-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Turnos'\"\n                                 [info]=\"turno\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"turno.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <catalog-code formControlName=\"nombre\" [(ngModel)]=\"turno.nombre\"></catalog-code>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Tipo:'\">\n                                          <az-combobox formControlName=\"tipo\"\n                                                       [(ngModel)]=\"turno.tipo\"\n                                                       [items]=\"turnoTipos\"\n                                                       [displayMember]=\"'name'\"\n                                                       [valueMember]=\"'value'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-4\">\n                                      <az-checkbox [label]=\"'Nocturno'\"\n                                                   formControlName=\"nocturno\"\n                                                   [(ngModel)]=\"turno.nocturno\">\n                                      </az-checkbox>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Jornada:'\">\n                                          <az-combobox formControlName=\"idJornada\"\n                                                       [(ngModel)]=\"turno.idJornada\"\n                                                       [items]=\"jornadas\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\"></az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                              <div class=\"card\">\n                                  <h5 class=\"card-header\">Par&aacute;metros de acci&oacute;n en retardos</h5>\n                                  <div class=\"card-body\">\n\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-4\">\n                                              <label>Despu&eacute;s de {{turno.retardos}} retardos en un periodo de</label>\n                                              <az-input-number formControlName=\"retardos\" [(ngModel)]=\"turno.retardos\" [format]=\"'n0'\" [min]=\"0\"></az-input-number>\n                                              <label> </label>\n                                          </div>\n                                          <div class=\"col-12 col-md-4\" *ngIf=\"diasCubreTurno == false\">\n                                              <label>{{turno.periodoDias}} d&iacute;as </label>\n                                              <az-input-number formControlName=\"periodoDias\"\n                                                               [(ngModel)]=\"turno.periodoDias\"\n                                                               [format]=\"'n0'\"\n                                                               [min]=\"0\"></az-input-number>\n                                          </div>\n\n                                          <div class=\"col-12 col-md-4\">\n                                              <az-checkbox formControlName=\"diasCubreTurno\"\n                                                           [label]=\"'D\u00EDas que cubre el turno'\"\n                                                           [(ngModel)]=\"diasCubreTurno\">\n                                              </az-checkbox>\n                                          </div>\n\n                                      </div>\n\n                                      <h4>Realizar la siguiente acci&oacute;n</h4>\n\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-6\">\n                                              <label class=\"form-check-inline\">\n                                                  <input class=\"form-check-input\"\n                                                         type=\"radio\"\n                                                         formControlName=\"evaluarAccion\"\n                                                         name=\"evaluarAccion\"\n                                                         [checked]=\"evaluarAccion.value=='F'\"\n                                                         value=\"F\"> Considerar como falta el &uacute;ltimo retardo\n                                              </label>\n                                          </div>\n                                      </div>\n\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-2\">\n                                              <label class=\"form-check-inline\">\n                                                  <input class=\"form-check-input\"\n                                                         type=\"radio\"\n                                                         formControlName=\"evaluarAccion\"\n                                                         name=\"evaluarAccion\"\n                                                         [checked]=\"evaluarAccion.value=='R'\"\n                                                         value=\"R\"> Restringir acceso a los {{turno.diasAccion}}\n                                              </label>\n                                          </div>\n                                          <div class=\"col-12 col-md-2\">\n                                              <label class=\"form-check-inline\">\n                                                  <az-input-number formControlName=\"diasAccion\"\n                                                                   [(ngModel)]=\"turno.diasAccion\"\n                                                                   [format]=\"'n0'\"\n                                                                   [min]=\"0\"></az-input-number>\n                                              </label>\n                                          </div>\n                                          <div class=\"col-12 col-md-4\">\n                                              <label class=\"form-check-inline\">\n                                                  <label> d&iacute;as h&aacute;biles despu&eacute;s del &uacute;ltimo retardo.</label>\n                                              </label>\n                                          </div>\n                                      </div>\n\n                                      <div *ngIf=\"evaluarAccion.value=='R'\" class=\"row\">\n                                          <h4>D&iacute;s de acci&oacute;n</h4>\n                                          <div class=\"col-12 col-md-4\">\n                                              <az-checkbox formControlName=\"dom\"\n                                                           [label]=\"'Domingo'\"\n                                                           [(ngModel)]=\"turno.dom\">\n                                              </az-checkbox>\n                                              <az-checkbox formControlName=\"lun\"\n                                                           [label]=\"'Lunes'\"\n                                                           [(ngModel)]=\"turno.lun\">\n                                              </az-checkbox>\n                                              <az-checkbox formControlName=\"mar\"\n                                                           [label]=\"'Martes'\"\n                                                           [(ngModel)]=\"turno.mar\">\n                                              </az-checkbox>\n                                              <az-checkbox formControlName=\"mie\"\n                                                           [label]=\"'Miercoles'\"\n                                                           [(ngModel)]=\"turno.mie\">\n                                              </az-checkbox>\n                                              <az-checkbox formControlName=\"jue\"\n                                                           [label]=\"'Jueves'\"\n                                                           [(ngModel)]=\"turno.jue\">\n                                              </az-checkbox>\n                                              <az-checkbox formControlName=\"vie\"\n                                                           [label]=\"'Viernes'\"\n                                                           [(ngModel)]=\"turno.vie\">\n                                              </az-checkbox>\n                                              <az-checkbox formControlName=\"sab\"\n                                                           [label]=\"'S\u00E1bado'\"\n                                                           [(ngModel)]=\"turno.sab\">\n                                              </az-checkbox>\n                                          </div>\n                                      </div>\n\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-6\">\n                                              <label class=\"form-check-inline\">\n                                                  <input class=\"form-check-input\"\n                                                         type=\"radio\"\n                                                         formControlName=\"evaluarAccion\"\n                                                         name=\"evaluarAccion\"\n                                                         [checked]=\"evaluarAccion.value=='P'\"\n                                                         value=\"P\"> Acci&oacute;n personalizada\n                                              </label>\n                                          </div>\n                                      </div>\n\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-6\">\n                                              <label class=\"form-check-inline\">\n                                                  <input class=\"form-check-input\"\n                                                         type=\"radio\"\n                                                         formControlName=\"evaluarAccion\"\n                                                         name=\"evaluarAccion\"\n                                                         [checked]=\"evaluarAccion.value=='N'\"\n                                                         value=\"N\"> No realizar ninguna acci&oacute;n\n                                              </label>\n                                          </div>\n                                      </div>\n\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-6\">\n                                              <azteca-form-field [label]=\"'Cuenta:'\">\n                                                  <accounting-cuenta-selector formControlName=\"cuenta\"\n                                                                              [(ngModel)]=\"turno.idCuenta\">\n                                                  </accounting-cuenta-selector>\n                                              </azteca-form-field>\n                                          </div>\n                                      </div>\n\n                                  </div>\n                              </div>\n                          </tab>\n\n                          <tab heading=\"Ciclos\" (select)=\"onTabSelectedFlexGrid(grdCiclo)\">\n                              <div class=\"row\">\n                                  <div class=\"col\">\n                                      <h6>N&uacute;mero de ciclos </h6>\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickCiclos()\">{{turno.ciclo}}</button>\n                                  </div>\n                              </div>\n\n                              <wj-flex-grid #grdCiclo\n                                            class=\"custom-flex-grid\"\n                                            (initialized)=\"initializedGrdCiclo(grdCiclo, $event)\"\n                                            [(itemsSource)]=\"cvCiclo\"\n                                            [allowResizing]=\"'None'\"\n                                            [selectionMode]=\"'Row'\"\n                                            [showGroups]=\"true\"\n                                            [wjContextMenu]=\"ctxMenuHorario\">\n                                  <wj-flex-grid-column [header]=\"'Ciclo'\" [binding]=\"'ciclo'\" [width]=\"40\" [align]=\"'left'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'D\u00EDa'\" [binding]=\"'dia'\" [width]=\"'2*'\" [align]=\"'center'\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate\n                                                   [autoSizeRows]=\"false\"\n                                                   [cellType]=\"'Cell'\"\n                                                   let-item=\"item\">\n                                          <span *ngIf=\"turno.tipo == 'S' && item.dia == 1\">Domingo</span>\n                                          <span *ngIf=\"turno.tipo == 'S' && item.dia == 2\">Lunes</span>\n                                          <span *ngIf=\"turno.tipo == 'S' && item.dia == 3\">Martes</span>\n                                          <span *ngIf=\"turno.tipo == 'S' && item.dia == 4\">Mi&eacute;rcoles</span>\n                                          <span *ngIf=\"turno.tipo == 'S' && item.dia == 5\">Jueves</span>\n                                          <span *ngIf=\"turno.tipo == 'S' && item.dia == 6\">Viernes</span>\n                                          <span *ngIf=\"turno.tipo == 'S' && item.dia == 7\">S&aacute;bado</span>\n                                          <span *ngIf=\"turno.tipo != 'S'\">D&iacute;a {{item.dia}}</span>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Horario'\" [binding]=\"'horario.nombre'\" [width]=\"'3*'\" [align]=\"'left'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </tab>\n                          <tab heading=\"Empleados\" (select)=\"refreshListEmployes()\">\n                              <div class=\"col-12 col-md-10\">\n                                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                      <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar Empleados'\" [icon]=\"'glyphicon glyphicon-plus'\" [enabled]=\"turno.identity>0\"></az-toolbar-button>\n                                  </az-toolbar>\n\n                                  <!-- Lista de usuarios-->\n                                  <azteca-catalog-list [catalogList]=\"empleados\"\n                                                       [showRowButton]=\"true\"\n                                                       [rowButtonIcon]=\"'glyphicon glyphicon-trash'\"\n                                                       (rowButtonClick)=\"onRemoveEmploye()\"\n                                                       (currentItemChanged)=\"onCurrentItemChanged($event)\"\n                                                       [enabled]=\"enabled\"\n                                                       [pageSize]=\"15\"\n                                                       [serverSide]=\"false\">\n\n                                      <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'20*'\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Empleado'\" [binding]=\"'nombre'\" [width]=\"'40*'\"></azteca-grid-column>\n                                  </azteca-catalog-list>\n                              </div>\n                          </tab>\n\n                      </tabset>\n                  </div>\n              </div>\n\n          </azteca-catalog-editor>\n\n          <rh-horario-list #dlgHorario (selectedItemChanged)=\"onSelectedHorario($event)\"></rh-horario-list>\n\n          <rh-empleado-list (selectedItemsChanged)=\"onSelectedEmleados($event)\"\n                            (selectedItemChanged)=\"onSelectedEmleado($event)\"\n                            [multiSelect]=\"true\">\n          </rh-empleado-list>\n\n      </form>\n\n      <wj-menu #ctxMenuHorario (itemClicked)=\"contextMnuHorarioClick(ctxMenuHorario)\" style=\"display:none\">\n          <wj-menu-item *ngFor=\"let item of menuCicloItems\">\n              <div *ngIf=\"item.enabled\">\n                  <span [class]=\"item.icon\"></span>\n                  <b>{{item.text}}</b>\n                  <br>\n                  <small><i>{{item.smallText}}</i></small>\n              </div>\n          </wj-menu-item>\n      </wj-menu>\n\n      <!--DIALOGO NUMERADOR-->\n      <div bsModal #dlgNumero=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"false\">\n          <div class=\"modal-dialog\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <!--Modal Header-->\n                      <h4>{{titleNumero}}</h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"dlgNumero.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div> <!--Modal Header-->\n                  <div class=\"modal-body\">\n                      <form [formGroup]=\"formNumero\">\n                          <div class=\"row\">\n                              <div class=\"col-12 col-md-4\">\n                                  <azteca-form-field [label]=\"titleNumero\">\n                                      <az-input-number formControlName=\"numero\"\n                                                       [(ngModel)]=\"numero\"\n                                                       [format]=\"'n0'\"\n                                                       [min]=\"0\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                      </form>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdatedNumro()\" [disabled]=\"!formNumero.valid\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dlgNumero.hide()\">Cancelar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return TurnosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: turno_service_1.TurnoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, turno_service_1.TurnoService, jornada_service_1.JornadaService, horario_service_1.HorarioService])
    ], TurnosEditor);
    return TurnosEditor;
}(editors_1.CatalogEditor));
exports.TurnosEditor = TurnosEditor;
