"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var http_1 = require("@angular/common/http");
//
var index_1 = require("framework3/controls/index");
var core_2 = require("framework3/core");
var core_3 = require("framework3/core");
//
var adamnomina_1 = require("../models/adamnomina");
var empresaadam_service_1 = require("../services/empresaadam.service");
var adam_service_1 = require("../services/adam.service");
var AdamNominaComponent = /** @class */ (function (_super) {
    __extends(AdamNominaComponent, _super);
    function AdamNominaComponent(http, context, formBuilder) {
        var _this = _super.call(this) || this;
        _this.formBuilder = formBuilder;
        // Inputs
        _this.adamNomina = new adamnomina_1.AdamNominaInfo();
        // Outputs
        _this.adamNominaUpdated = new core_1.EventEmitter();
        _this.validChange = new core_1.EventEmitter();
        _this.handleError = new core_1.EventEmitter();
        // Compania
        _this.companiaRequired = false;
        _this.companiaVisible = true;
        _this.companiaEnabled = true;
        // Clase Nomina
        _this.claseNominaRequired = false;
        _this.claseNominaVisible = true;
        _this.claseNominaEnabled = true;
        // Tipo Nomina
        _this.tipoNominaRequired = false;
        _this.tipoNominaVisible = true;
        _this.tipoNominaEnabled = true;
        // Anio
        _this.anioRequired = false;
        _this.anioVisible = true;
        _this.anioEnabled = true;
        // Periodo
        _this.periodoRequired = false;
        _this.periodoVisible = true;
        _this.periodoEnabled = true;
        // Internal values
        _this.nominaInfo = new adamnomina_1.AdamNominaInfo();
        _this.empresasAdam = new Array();
        _this.companiasAdam = new Array();
        _this.clasesNomina = new Array();
        _this.tiposNomina = new Array();
        _this.anios = new Array();
        _this.periodos = new Array();
        _this.propagateChange = function (_) { };
        _this.context = context;
        _this.form = formBuilder.group({
            'cboEmpresaAdam': [''],
            'cboCompaniaAdam': [''],
            'cboClaseNomina': [''],
            'cboTipoNomina': [''],
            'cboAnio': [''],
            'cboPeriodo': ['']
        });
        _this.empresaAdamSvc = new empresaadam_service_1.EmpresaAdamService(http, context);
        _this.adamSvc = new adam_service_1.AdamService(http, context);
        return _this;
    }
    AdamNominaComponent_1 = AdamNominaComponent;
    Object.defineProperty(AdamNominaComponent.prototype, "valid", {
        get: function () {
            return this.form.valid;
        },
        enumerable: true,
        configurable: true
    });
    AdamNominaComponent.prototype.onChangeEmpresaAdam = function (args) {
        this.nominaInfo.idEmpresaAdam = args;
        this.loadCompaniasAdam();
        this.loadClaseNomina();
        this.notifiyChange();
    };
    AdamNominaComponent.prototype.onChangeCompania = function (args) {
        this.nominaInfo.compania = args;
        this.loadAnios();
        this.loadPeriodos();
        this.notifiyChange();
    };
    AdamNominaComponent.prototype.onChangeClaseNomina = function (args) {
        this.nominaInfo.claseNomina = args;
        this.loadTiposNomina();
        this.notifiyChange();
    };
    AdamNominaComponent.prototype.onChangeTipoNomina = function (args) {
        this.nominaInfo.tipoNomina = args;
        this.loadAnios();
        this.loadPeriodos();
        this.notifiyChange();
    };
    AdamNominaComponent.prototype.onChangeAnio = function (args) {
        this.nominaInfo.anio = args;
        this.loadPeriodos();
        this.notifiyChange();
    };
    AdamNominaComponent.prototype.onChangePeriodo = function (args) {
        this.nominaInfo.periodo = args;
        this.notifiyChange();
    };
    AdamNominaComponent.prototype.ngOnChanges = function (changes) {
        if (changes['companiaRequired']) {
            this.form.controls['cboCompaniaAdam'].setValidators(this.companiaRequired ? forms_1.Validators.required : null);
        }
        if (changes['claseNominaRequired']) {
            this.form.controls['cboClaseNomina'].setValidators(this.companiaRequired ? forms_1.Validators.required : null);
        }
        if (changes['tipoNominaRequired']) {
            this.form.controls['cboTipoNomina'].setValidators(this.companiaRequired ? forms_1.Validators.required : null);
        }
        if (changes['anioRequired']) {
            this.form.controls['cboAnio'].setValidators(this.companiaRequired ? forms_1.Validators.required : null);
        }
        if (changes['periodoRequired']) {
            this.form.controls['cboPeriodo'].setValidators(this.companiaRequired ? forms_1.Validators.required : null);
        }
    };
    AdamNominaComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.form.statusChanges.subscribe(function (_) {
            _this.validChange.emit(_this.form.valid);
        });
        this.loadEmpresasAdam();
    };
    //////////////////////////////// HANDLERS ////////////////////////////////////////
    AdamNominaComponent.prototype.loadEmpresasAdam = function () {
        var _this = this;
        if (this.idSucursal > 0 && this.empresaAdamSvc != null) {
            this.context.app.showSpinner();
            this.empresaAdamSvc.loadEmpresasAdamCBO(this.idSucursal).then(function (info) {
                _this.empresasAdam = info;
                _this.context.app.hideSpinner();
            }).catch(function (error) {
                _this.context.app.hideSpinner();
                _this.handleError.emit(error);
            });
        }
    };
    AdamNominaComponent.prototype.loadCompaniasAdam = function () {
        var _this = this;
        if (this.nominaInfo.idEmpresaAdam > 0 &&
            this.adamSvc != null) {
            this.context.app.showSpinner();
            this.adamSvc.loadCompaniasAdam(this.nominaInfo.idEmpresaAdam).then(function (info) {
                _this.companiasAdam = info;
                _this.context.app.hideSpinner();
            }).catch(function (error) {
                _this.context.app.hideSpinner();
                _this.handleError.emit(error);
            });
        }
        else {
            this.companiasAdam.length = 0;
        }
    };
    AdamNominaComponent.prototype.loadClaseNomina = function () {
        var _this = this;
        if (this.nominaInfo.idEmpresaAdam > 0 &&
            this.adamSvc != null) {
            this.context.app.showSpinner();
            this.adamSvc.loadClaseNomina(this.nominaInfo.idEmpresaAdam).then(function (info) {
                _this.clasesNomina = info;
                _this.context.app.hideSpinner();
            }).catch(function (error) {
                _this.context.app.hideSpinner();
                _this.handleError.emit(error);
            });
        }
        else {
            this.clasesNomina.length = 0;
        }
    };
    AdamNominaComponent.prototype.loadTiposNomina = function () {
        var _this = this;
        if (this.nominaInfo.idEmpresaAdam > 0 &&
            this.nominaInfo.claseNomina != undefined &&
            this.nominaInfo.claseNomina != '' &&
            this.adamSvc != null) {
            this.context.app.showSpinner();
            this.adamSvc.loadTipoNomina(this.nominaInfo.idEmpresaAdam, this.nominaInfo.claseNomina).then(function (info) {
                _this.tiposNomina = info;
                _this.context.app.hideSpinner();
            }).catch(function (error) {
                _this.context.app.hideSpinner();
                _this.handleError.emit(error);
            });
        }
        else {
            this.tiposNomina.length = 0;
        }
    };
    AdamNominaComponent.prototype.loadAnios = function () {
        var _this = this;
        if (this.nominaInfo.idEmpresaAdam > 0 &&
            this.nominaInfo.compania != undefined &&
            this.nominaInfo.compania != '' &&
            this.nominaInfo.tipoNomina != undefined &&
            this.nominaInfo.tipoNomina != '' &&
            this.adamSvc != null) {
            this.context.app.showSpinner();
            this.adamSvc.loadAnio(this.nominaInfo.idEmpresaAdam, this.nominaInfo.compania, this.nominaInfo.tipoNomina).then(function (info) {
                _this.anios = info;
                _this.context.app.hideSpinner();
            }).catch(function (error) {
                _this.context.app.hideSpinner();
                _this.handleError.emit(error);
            });
        }
        else {
            this.anios.length = 0;
        }
    };
    AdamNominaComponent.prototype.loadPeriodos = function () {
        var _this = this;
        if (this.nominaInfo.idEmpresaAdam > 0 &&
            this.nominaInfo.compania != undefined &&
            this.nominaInfo.compania != '' &&
            this.nominaInfo.tipoNomina != undefined &&
            this.nominaInfo.tipoNomina != '' &&
            this.nominaInfo.anio > 0 &&
            this.adamSvc != null) {
            this.context.app.showSpinner();
            this.adamSvc.loadPeriodo(this.nominaInfo.idEmpresaAdam, this.nominaInfo.compania, this.nominaInfo.tipoNomina, this.nominaInfo.anio).then(function (info) {
                _this.periodos = info;
                _this.context.app.hideSpinner();
            }).catch(function (error) {
                _this.context.app.hideSpinner();
                _this.handleError.emit(error);
            });
        }
        else {
            this.periodos.length = 0;
        }
    };
    AdamNominaComponent.prototype.updateNominaAdam = function () {
        this.nominaInfo.idEmpresaAdam = this.adamNomina.idEmpresaAdam;
        this.nominaInfo.compania = this.adamNomina.compania;
        this.nominaInfo.claseNomina = this.adamNomina.claseNomina;
        this.nominaInfo.tipoNomina = this.adamNomina.tipoNomina;
        this.nominaInfo.anio = this.adamNomina.anio;
        this.nominaInfo.periodo = this.adamNomina.periodo;
    };
    AdamNominaComponent.prototype.notifiyChange = function () {
        var newAdamNomina = new adamnomina_1.AdamNominaInfo();
        newAdamNomina.idEmpresaAdam = this.nominaInfo.idEmpresaAdam;
        newAdamNomina.compania = this.nominaInfo.compania;
        newAdamNomina.claseNomina = this.nominaInfo.claseNomina;
        newAdamNomina.tipoNomina = this.nominaInfo.tipoNomina;
        newAdamNomina.anio = this.nominaInfo.anio;
        newAdamNomina.periodo = this.nominaInfo.periodo;
        this.adamNominaUpdated.emit(newAdamNomina);
        this.propagateChange(newAdamNomina);
    };
    //////////////////////////////// CONTROL VALUE ACCESOR ////////////////////////////////////////
    AdamNominaComponent.prototype.writeValue = function (value) {
        this.adamNomina = value;
    };
    AdamNominaComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    AdamNominaComponent.prototype.registerOnTouched = function () {
    };
    var AdamNominaComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", adamnomina_1.AdamNominaInfo)
    ], AdamNominaComponent.prototype, "adamNomina", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], AdamNominaComponent.prototype, "idSucursal", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], AdamNominaComponent.prototype, "adamNominaUpdated", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], AdamNominaComponent.prototype, "validChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], AdamNominaComponent.prototype, "handleError", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], AdamNominaComponent.prototype, "companiaRequired", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], AdamNominaComponent.prototype, "companiaVisible", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], AdamNominaComponent.prototype, "companiaEnabled", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], AdamNominaComponent.prototype, "claseNominaRequired", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], AdamNominaComponent.prototype, "claseNominaVisible", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], AdamNominaComponent.prototype, "claseNominaEnabled", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], AdamNominaComponent.prototype, "tipoNominaRequired", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], AdamNominaComponent.prototype, "tipoNominaVisible", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], AdamNominaComponent.prototype, "tipoNominaEnabled", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], AdamNominaComponent.prototype, "anioRequired", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], AdamNominaComponent.prototype, "anioVisible", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], AdamNominaComponent.prototype, "anioEnabled", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], AdamNominaComponent.prototype, "periodoRequired", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], AdamNominaComponent.prototype, "periodoVisible", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], AdamNominaComponent.prototype, "periodoEnabled", void 0);
    AdamNominaComponent = AdamNominaComponent_1 = __decorate([
        core_1.Component({
            selector: 'rh-adam-nomina',
            template: "\n      <form [formGroup]=\"form\">\n\n          <!--Empresa Adam-->\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field [label]=\"'Empresa:'\">\n                      <az-combobox formControlName=\"cboEmpresaAdam\" (selectedItemChanged)=\"onChangeEmpresaAdam($event)\" [(ngModel)]=\"nominaInfo.idEmpresaAdam\" [items]=\"empresasAdam\" [displayMember]=\"'nombre'\" [valueMember]=\"'id'\"></az-combobox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <!--Compania Adam-->\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field *ngIf=\"companiaVisible\" [label]=\"'Compa&ntilde;&iacute;a Adam:'\">\n                      <az-combobox formControlName=\"cboCompaniaAdam\" (selectedItemChanged)=\"onChangeCompania($event)\" [enabled]=\"companiaEnabled\" [(ngModel)]=\"nominaInfo.compania\" [items]=\"companiasAdam\" [displayMember]=\"'nombre_cia'\" [valueMember]=\"'compania'\"></az-combobox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <!--Clase Nomina-->\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field *ngIf=\"claseNominaVisible\" [label]=\"'Clase N&oacute;mina:'\">\n                      <az-combobox formControlName=\"cboClaseNomina\" (selectedItemChanged)=\"onChangeClaseNomina($event)\" [enabled]=\"claseNominaEnabled\" [(ngModel)]=\"nominaInfo.claseNomina\" [items]=\"clasesNomina\" [displayMember]=\"'descripcion'\" [valueMember]=\"'clase_nomina'\"></az-combobox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <!--Tipo Nomina-->\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field *ngIf=\"tipoNominaVisible\" [label]=\"'Tipo N&oacute;mina:'\">\n                      <az-combobox formControlName=\"cboTipoNomina\" (selectedItemChanged)=\"onChangeTipoNomina($event)\" [enabled]=\"tipoNominaEnabled\" [(ngModel)]=\"nominaInfo.tipoNomina\" [items]=\"tiposNomina\" [displayMember]=\"'descripcion'\" [valueMember]=\"'tipo_nomina'\"></az-combobox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <!--Anio-->\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field *ngIf=\"anioVisible\" [label]=\"'A&ntilde;o:'\">\n                      <az-combobox formControlName=\"cboAnio\" (selectedItemChanged)=\"onChangeAnio($event)\" [enabled]=\"anioEnabled\" [(ngModel)]=\"nominaInfo.anio\" [items]=\"anios\" [displayMember]=\"'anio'\" [valueMember]=\"'anio'\"></az-combobox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <!--Periodo-->\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field *ngIf=\"periodoVisible\" [label]=\"'Periodo:'\">\n                      <az-combobox formControlName=\"cboPeriodo\" (selectedItemChanged)=\"onChangePeriodo($event)\" [enabled]=\"periodoEnabled\" [(ngModel)]=\"nominaInfo.periodo\" [items]=\"periodos\" [displayMember]=\"'periodo'\" [valueMember]=\"'periodo'\"></az-combobox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n      </form>\n    ",
            providers: [{
                    provide: core_2.BaseComponent,
                    useExisting: core_1.forwardRef(function () { return AdamNominaComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return AdamNominaComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [http_1.HttpClient, core_3.Context, forms_1.FormBuilder])
    ], AdamNominaComponent);
    return AdamNominaComponent;
}(index_1.BaseControl));
exports.AdamNominaComponent = AdamNominaComponent;
