"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
//
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
//
var concepto_ficha_1 = require("../models/concepto-ficha");
var conceptos_fichas_service_1 = require("../services/conceptos-fichas.service");
var ConceptoFichasSelector = /** @class */ (function (_super) {
    __extends(ConceptoFichasSelector, _super);
    function ConceptoFichasSelector(context, conceptoService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.conceptoService = conceptoService;
        _this.selectedItem = new concepto_ficha_1.ConceptosFichasInfo;
        _this.conceptoUpdated = new core_1.EventEmitter();
        _this.keywordSearchSource = rxjs_1.Observable.create(function (observer) {
            observer.next(_this.innerSelector.displayValue);
        })
            .pipe(operators_1.mergeMap(function (keyword) { return _this.findConcepto(keyword); }));
        return _this;
    }
    ConceptoFichasSelector_1 = ConceptoFichasSelector;
    ConceptoFichasSelector.prototype.loadItem = function (itemID) {
        var _this = this;
        if (itemID > 0) {
            this.conceptoService.getDetailByID(itemID)
                .then(function (info) {
                _this.selectedItem = info;
                _this.displayValue = info.code + " " + info.nombre; //+ ", " + info.municipio.estado.nombre;
                _this.conceptoUpdated.emit(info);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.selectedItem = null;
            this.displayValue = "";
            this.conceptoUpdated.emit(null);
        }
    };
    ConceptoFichasSelector.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.conceptoService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.conceptos = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptoFichasSelector.prototype.findConcepto = function (keyword) {
        return this.conceptoService.searchKeyword(this.context.app.defaultSite.identity, keyword);
    };
    ConceptoFichasSelector.prototype.onKeywordSearch = function (keyword) {
        this.markUnselected();
    };
    var ConceptoFichasSelector_1;
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ConceptoFichasSelector.prototype, "conceptoUpdated", void 0);
    ConceptoFichasSelector = ConceptoFichasSelector_1 = __decorate([
        core_1.Component({
            selector: 'rh-conceptos-fichas-selector',
            template: "\n      <azteca-catalog-selector [catalogList]=\"conceptos\"\n                               [dialogTitle]=\"'Conceptos'\"\n                               [displayValue]=\"displayValue\"\n                               [serverSide]=\"true\"\n                               [selectedItem]=\"selectedItem\"\n                               [pageIndex]=\"pageIndex\"\n                               [pageSize]=\"pageSize\"\n                               [totalRows]=\"totalRows\"\n                               [visible]=\"visible\"\n                               [enabled]=\"enabled\"\n                               [dataSource]=\"keywordSearchSource\"\n                               [showListButton]=\"showListButton\"\n                               (selectedItemChanged)=\"itemChangedHandler($event)\"\n                               (keywordSearch)=\"onKeywordSearch($event)\"\n                               (searchRequested)=\"doSearch($event)\">\n\n          <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'2*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'3*'\"></azteca-grid-column>\n\n\n      </azteca-catalog-selector>\n    ",
            providers: [{
                    provide: core_2.BaseComponent,
                    useExisting: core_1.forwardRef(function () { return ConceptoFichasSelector_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return ConceptoFichasSelector_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [core_2.Context, conceptos_fichas_service_1.ConceptosFichasService])
    ], ConceptoFichasSelector);
    return ConceptoFichasSelector;
}(search_1.CatalogSelector));
exports.ConceptoFichasSelector = ConceptoFichasSelector;
