import { EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormGroup } from '@angular/forms';
import { Context } from 'framework3/core';
import { ModalDirective } from 'ngx-bootstrap';
import { AlertsBarComponent } from 'framework3/controls';
import { TiposDescuentosInfo, DescuentosEmpleado } from '../models/tipo-descuento';
import { FichasTitService } from '../services/fichas-tit.service';
import { EmpresaService } from '../services/empresa.service';
import { EmpresaInfo } from '../models/empresa';
import { TiposDescuentosService } from '../services/tipos-descuentos.service';
export declare class FichaComponent {
    private formBuilder;
    private context;
    private router;
    private route;
    private fichasTitService;
    private empresaService;
    private tiposDescuentoService;
    tipoDescuento: TiposDescuentosInfo;
    empresa: EmpresaInfo;
    descuentosEmpleado: DescuentosEmpleado[];
    editorForm: FormGroup;
    idFichatit: string;
    tipoNomina: string;
    claseNomina: number;
    idEmpleado: number;
    monto: number;
    porcentaje: number;
    alerts: AlertsBarComponent;
    dlgFicha: ModalDirective;
    descuentoSelected: EventEmitter<any>;
    constructor(formBuilder: FormBuilder, context: Context, router: Router, route: ActivatedRoute, fichasTitService: FichasTitService, empresaService: EmpresaService, tiposDescuentoService: TiposDescuentosService);
    show(): void;
    showAlert(message: string, type: string): void;
    accept(): void;
    discardChanges(): void;
    onTipoDescuentoSelected(args: TiposDescuentosInfo): void;
}
