"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//import { RegExp } from "typescript-dotnet-commonjs/System/Text/RegularExpressions";
//import { RegExp } from "RegularExpressions/Regex"; //
//
var core_2 = require("framework3/core");
//features
var ngx_bootstrap_1 = require("ngx-bootstrap");
var controls_1 = require("framework3/controls");
var fichas_tit_service_1 = require("../services/fichas-tit.service");
var empresa_service_1 = require("../services/empresa.service");
var empresa_1 = require("../models/empresa");
var tipos_descuentos_service_1 = require("../services/tipos-descuentos.service");
var FichaComponent = /** @class */ (function () {
    function FichaComponent(formBuilder, context, router, route, fichasTitService, empresaService, tiposDescuentoService) {
        var _this = this;
        this.formBuilder = formBuilder;
        this.context = context;
        this.router = router;
        this.route = route;
        this.fichasTitService = fichasTitService;
        this.empresaService = empresaService;
        this.tiposDescuentoService = tiposDescuentoService;
        this.tipoDescuento = undefined;
        this.empresa = new empresa_1.EmpresaInfo();
        this.idFichatit = '';
        this.tipoNomina = '';
        this.claseNomina = 0;
        this.idEmpleado = 0;
        this.descuentoSelected = new core_1.EventEmitter();
        this.editorForm = formBuilder.group({
            'descuento': [0, controls_1.AztecaValidators.selected],
            'monto': [1, forms_1.Validators.required],
            'porcentaje': [1, forms_1.Validators.required]
        });
        this.empresaService.getDetailByID(this.context.app.defaultCompany.identity).then(function (info) { return _this.empresa = info; })
            .catch(function (error) { return console.log(JSON.stringify); });
    }
    FichaComponent.prototype.show = function () {
        var _this = this;
        this.context.app.showSpinner();
        if (this.idFichatit.length != 0) {
            this.fichasTitService.getDetail(this.idFichatit).then(function (info) {
                _this.claseNomina = Number(info.claseNomina.trim());
                _this.tipoNomina = info.tipoNomina;
                _this.idEmpleado = info.idEmpleado;
                _this.tiposDescuentoService.infoDescuentosEmpleadoADAM(_this.idEmpleado, _this.context.app.defaultSite.identity).then(function (descuentos) {
                    _this.context.app.hideSpinner();
                    _this.descuentosEmpleado = descuentos;
                    _this.dlgFicha.config.backdrop = false;
                    _this.dlgFicha.show();
                }).catch(function (error) {
                    _this.context.app.hideSpinner();
                    _this.showAlert(error.message, 'danger');
                });
            }).catch(function (error) {
                _this.context.app.hideSpinner();
                _this.showAlert(error.message, 'danger');
            });
        }
    };
    FichaComponent.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    FichaComponent.prototype.accept = function () {
        if (this.tipoDescuento.tipo == 'M' && this.tipoNomina.startsWith('S') && this.monto > this.empresa.montoFicha) {
            this.showAlert('El monto a descontar no debe de ser de mas de ' + this.empresa.montoFicha.toString(), 'danger');
            return;
        }
        else if (this.tipoDescuento.tipo == 'P' && this, this.porcentaje > this.empresa.porcentajeFicha) {
            this.showAlert('El porcentaje a descontar no debe de ser de mas de ' + this.empresa.porcentajeFicha.toString(), 'danger');
            return;
        }
        this.dlgFicha.hide();
        var object = { 'tipoDescuento': null, 'monto': 1, 'porcentaje': 1 };
        object.monto = this.monto;
        object.porcentaje = this.porcentaje;
        object.tipoDescuento = this.tipoDescuento;
        this.descuentoSelected.emit(object);
    };
    FichaComponent.prototype.discardChanges = function () {
        this.dlgFicha.hide();
    };
    FichaComponent.prototype.onTipoDescuentoSelected = function (args) {
        console.log(JSON.stringify(args));
        this.tipoDescuento = args;
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], FichaComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('dlgFicha'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], FichaComponent.prototype, "dlgFicha", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], FichaComponent.prototype, "descuentoSelected", void 0);
    FichaComponent = __decorate([
        core_1.Component({
            selector: 'rh-ficha',
            template: "\n      <div bsModal #dlgFicha=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n                      <form [formGroup]=\"editorForm\">\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <alerts-bar></alerts-bar>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-10\">\n                                  <azteca-form-field [label]=\"'Tipo de Descuento:'\">\n                                      <rh-tipo-descuento-selector formControlName=\"descuento\" [(ngModel)]=\"idTipoDescuento\" [claseNomina]=\"claseNomina\" (tipoDescuentoUpdated)=\"onTipoDescuentoSelected($event)\"></rh-tipo-descuento-selector>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\" *ngIf=\"tipoDescuento!=undefined && tipoDescuento.tipo=='M'\">\n                              <div class=\"col-10\">\n                                  <azteca-form-field [label]=\"'Monto Descuento:'\">\n                                      <az-input-number formControlName=\"monto\" [(ngModel)]=\"monto\" [value]=\"monto\" [min]=\"1\" [format]=\"'C4'\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\" *ngIf=\"tipoDescuento!=undefined && tipoDescuento.tipo=='P'\">\n                              <div class=\"col-10\">\n                                  <azteca-form-field [label]=\"'Monto Descuento:'\">\n                                      <az-input-number formControlName=\"porcentaje\" [(ngModel)]=\"porcentaje\" [value]=\"porcentaje\" [min]=\"1\" [format]=\"'N0'\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <wj-flex-grid [itemsSource]=\"descuentosEmpleado\"\n                                                [selectionMode]=\"'Row'\">\n                                      <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                      <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'descuento'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Monto'\" [binding]=\"'monto'\" [width]=\"'30*'\" [isReadOnly]=\"true\" format=\"c2\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Tipo'\" [binding]=\"'tipo'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  </wj-flex-grid>\n                              </div>\n                          </div>\n                      </form>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"accept()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"discardChanges()\">Descartar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, core_2.Context, router_1.Router, router_1.ActivatedRoute, fichas_tit_service_1.FichasTitService, empresa_service_1.EmpresaService, tipos_descuentos_service_1.TiposDescuentosService])
    ], FichaComponent);
    return FichaComponent;
}());
exports.FichaComponent = FichaComponent;
