import { EventEmitter } from '@angular/core';
import { Observable } from 'rxjs';
import { Context, CatalogItem } from 'framework3/core';
import { SearchRequest, HierarchySelector, ITreeHost } from 'framework3/search/index';
import { PuestoInfo, PuestoItem } from '../models/puesto';
import { PuestoService } from '../services/puesto.service';
export declare class PuestoSelectorComponent extends HierarchySelector implements ITreeHost {
    protected context: Context;
    private puestoService;
    puestos: PuestoItem[];
    nodes: PuestoInfo[];
    selectedItem: PuestoInfo;
    idDocumento: number;
    version: number;
    idPadre: number;
    selectedItemChanged: EventEmitter<PuestoInfo>;
    constructor(context: Context, puestoService: PuestoService);
    loadItem(itemID: number): void;
    doSearch(request: SearchRequest): void;
    findKeyword(keyword: string): Observable<CatalogItem[]>;
    onKeywordSearch(keyword: string): void;
    onLoadingHierarchy(): void;
    loadChildren(parent: PuestoInfo): Promise<PuestoInfo[]>;
}
