"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
//
var core_2 = require("framework3/core");
var index_1 = require("framework3/search/index"); //'../../search/index';
var puesto_service_1 = require("../services/puesto.service");
var PuestoSelectorComponent = /** @class */ (function (_super) {
    __extends(PuestoSelectorComponent, _super);
    function PuestoSelectorComponent(context, puestoService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.puestoService = puestoService;
        _this.selectedItem = null;
        //Inputs
        _this.idDocumento = 0;
        _this.version = 0;
        _this.idPadre = 0;
        //Outputs
        _this.selectedItemChanged = new core_1.EventEmitter();
        _this.keywordSearchSource = rxjs_1.Observable.create(function (observer) {
            observer.next(_this.innerSelector.displayValue);
        }).pipe(operators_1.mergeMap(function (keyword) { return _this.findKeyword(keyword); }));
        return _this;
    }
    PuestoSelectorComponent_1 = PuestoSelectorComponent;
    PuestoSelectorComponent.prototype.loadItem = function (itemID) {
        var _this = this;
        if (itemID > 0) {
            this.puestoService.getDetailByID(itemID)
                .then(function (info) {
                _this.selectedItem = info;
                _this.displayValue = info.code + "-" + info.nombre;
                _this.selectedItemChanged.emit(_this.selectedItem);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.selectedItem = null;
            this.displayValue = '';
            this.selectedItemChanged.emit(this.selectedItem);
        }
    };
    PuestoSelectorComponent.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.puestoService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.puestos = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PuestoSelectorComponent.prototype.findKeyword = function (keyword) {
        return this.puestoService.searchKeyword(this.context.app.defaultSite.identity, keyword);
    };
    PuestoSelectorComponent.prototype.onKeywordSearch = function (keyword) {
        this.markUnselected();
    };
    PuestoSelectorComponent.prototype.onLoadingHierarchy = function () {
        var _this = this;
        //Cargar nodos raíz al abrir diálogo de jerarquía
        this.puestoService.loadChildren(this.context.app.defaultCompany.identity, 0)
            .then(function (rootNodes) { return _this.nodes = rootNodes; })
            .catch(function (error) { return _this.handleError(error); });
    };
    PuestoSelectorComponent.prototype.loadChildren = function (parent) {
        return this.puestoService.loadChildren(this.context.app.defaultCompany.identity, parent.identity);
    };
    var PuestoSelectorComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], PuestoSelectorComponent.prototype, "idDocumento", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], PuestoSelectorComponent.prototype, "version", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], PuestoSelectorComponent.prototype, "idPadre", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], PuestoSelectorComponent.prototype, "selectedItemChanged", void 0);
    PuestoSelectorComponent = PuestoSelectorComponent_1 = __decorate([
        core_1.Component({
            selector: 'rh-puesto-selector',
            template: "\n      <azteca-hierarchy-selector [hierarchyList]=\"puestos\"\n                                 [nodes]=\"nodes\"\n                                 [dialogTitle]=\"'Catalogo de Puestos'\"\n                                 [displayValue]=\"displayValue\"\n                                 [serverSide]=\"true\"\n                                 [selectedItem]=\"selectedItem\"\n                                 [pageIndex]=\"pageIndex\"\n                                 [pageSize]=\"pageSize\"\n                                 [totalRows]=\"totalRows\"\n                                 [enabled]=\"enabled\"\n                                 [visible]=\"visible\"\n                                 [dataSource]=\"keywordSearchSource\"\n                                 [showListButton]=\"showListButton\"\n                                 [showTreeButton]=\"showTreeButton\"\n                                 (selectedItemChanged)=\"itemChangedHandler($event)\"\n                                 (keywordSearch)=\"onKeywordSearch($event)\"\n                                 (loadingHierarchy)=\"onLoadingHierarchy($event)\"\n                                 (searchRequested)=\"doSearch($event)\">\n\n          <azteca-grid-column [header]=\"'ID'\" [binding]=\"'id'\" [dataType]=\"Number\" [width]=\"45\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Puesto'\" [binding]=\"'nombre'\" [width]=\"'50*'\"></azteca-grid-column>\n\n\n      </azteca-hierarchy-selector>\n    ",
            providers: [{
                    provide: core_2.BaseComponent,
                    useExisting: core_1.forwardRef(function () { return PuestoSelectorComponent_1; })
                },
                {
                    provide: index_1.ITreeHost,
                    useExisting: core_1.forwardRef(function () { return PuestoSelectorComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return PuestoSelectorComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [core_2.Context, puesto_service_1.PuestoService])
    ], PuestoSelectorComponent);
    return PuestoSelectorComponent;
}(index_1.HierarchySelector));
exports.PuestoSelectorComponent = PuestoSelectorComponent;
