"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
//
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
//
var tipos_descuentos_service_1 = require("../services/tipos-descuentos.service");
var tipo_descuento_1 = require("../models/tipo-descuento");
var TipoDescuentoSelector = /** @class */ (function (_super) {
    __extends(TipoDescuentoSelector, _super);
    function TipoDescuentoSelector(context, tipoDescuentoService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.tipoDescuentoService = tipoDescuentoService;
        _this.selectedItem = new tipo_descuento_1.TiposDescuentosInfo;
        _this.claseNomina = 0;
        _this.tipoDescuentoUpdated = new core_1.EventEmitter();
        _this.keywordSearchSource = rxjs_1.Observable.create(function (observer) {
            observer.next(_this.innerSelector.displayValue);
        })
            .pipe(operators_1.mergeMap(function (keyword) { return _this.findTipo(keyword); }));
        return _this;
    }
    TipoDescuentoSelector_1 = TipoDescuentoSelector;
    TipoDescuentoSelector.prototype.loadItem = function (itemID) {
        var _this = this;
        if (itemID > 0) {
            this.tipoDescuentoService.getDetailByID(itemID)
                .then(function (info) {
                _this.selectedItem = info;
                _this.displayValue = info.code + " " + info.nombre;
                _this.tipoDescuentoUpdated.emit(info);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.selectedItem = null;
            this.displayValue = "";
            this.tipoDescuentoUpdated.emit(null);
        }
    };
    TipoDescuentoSelector.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        if (this.claseNomina != 0 && this.claseNomina != 2 && this.claseNomina != 5 && this.claseNomina != 7) {
            var condition = { field: 'Tipo', operator: '=', valueType: 'string', value: 'M' };
            request.conditions.push(condition);
        }
        this.tipoDescuentoService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.tiposDescuentos = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TipoDescuentoSelector.prototype.findTipo = function (keyword) {
        var tipo = '';
        if (this.claseNomina != 0 && this.claseNomina != 2 && this.claseNomina != 5 && this.claseNomina != 7) {
            tipo = 'M';
        }
        return this.tipoDescuentoService.searchKeyword2(tipo, this.context.app.defaultSite.identity, keyword);
        //return this.tipoDescuentoService.searchKeyword(this.context.app.defaultSite.identity, keyword);
    };
    TipoDescuentoSelector.prototype.onKeywordSearch = function (keyword) {
        this.markUnselected();
    };
    var TipoDescuentoSelector_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], TipoDescuentoSelector.prototype, "claseNomina", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], TipoDescuentoSelector.prototype, "tipoDescuentoUpdated", void 0);
    TipoDescuentoSelector = TipoDescuentoSelector_1 = __decorate([
        core_1.Component({
            selector: 'rh-tipo-descuento-selector',
            template: "\n      <azteca-catalog-selector [catalogList]=\"tiposDescuentos\"\n                               [dialogTitle]=\"'Tipo de Descuento'\"\n                               [displayValue]=\"displayValue\"\n                               [serverSide]=\"true\"\n                               [selectedItem]=\"selectedItem\"\n                               [pageIndex]=\"pageIndex\"\n                               [pageSize]=\"pageSize\"\n                               [totalRows]=\"totalRows\"\n                               [visible]=\"visible\"\n                               [enabled]=\"enabled\"\n                               [dataSource]=\"keywordSearchSource\"\n                               [showListButton]=\"showListButton\"\n                               (selectedItemChanged)=\"itemChangedHandler($event)\"\n                               (keywordSearch)=\"onKeywordSearch($event)\"\n                               (searchRequested)=\"doSearch($event)\">\n\n          <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'2*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'3*'\"></azteca-grid-column>\n\n\n      </azteca-catalog-selector>\n    ",
            providers: [{
                    provide: core_2.BaseComponent,
                    useExisting: core_1.forwardRef(function () { return TipoDescuentoSelector_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return TipoDescuentoSelector_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [core_2.Context, tipos_descuentos_service_1.TiposDescuentosService])
    ], TipoDescuentoSelector);
    return TipoDescuentoSelector;
}(search_1.CatalogSelector));
exports.TipoDescuentoSelector = TipoDescuentoSelector;
