"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
//
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
var checador_service_1 = require("../services/checador.service");
//
var ChecadorListComponent = /** @class */ (function (_super) {
    __extends(ChecadorListComponent, _super);
    function ChecadorListComponent(context, service) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.service = service;
        _this.excludedItems = [];
        _this.titleDialog = 'Checadores';
        _this.validarPermisos = true;
        return _this;
    }
    ChecadorListComponent.prototype.onSearchRequested = function (request) {
        var _this = this;
        if (this.validarPermisos == true)
            this.service.searchChecador(this.context.session.user.identity, this.context.app.defaultSite.identity, request)
                .then(function (result) {
                if (_this.excludedItems.length > 0) {
                    result.rows = result.rows.filter(function (fitem) { return !_this.excludedItems.find(function (sitem) { return sitem.id == fitem.id; }); });
                }
                _this.items = result.rows;
                _this.totalRows = result.totalRows;
                _this.pageIndex = request.pageIndex;
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        else
            this.service.search(this.context.app.defaultSite.identity, request)
                .then(function (result) {
                if (_this.excludedItems.length > 0) {
                    result.rows = result.rows.filter(function (fitem) { return !_this.excludedItems.find(function (sitem) { return sitem.id == fitem.id; }); });
                }
                _this.items = result.rows;
                _this.totalRows = result.totalRows;
                _this.pageIndex = request.pageIndex;
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
    };
    ChecadorListComponent.prototype.onSelectedItemsChanged = function (selectedItem) {
        this.selectedItemsChanged.emit(selectedItem);
    };
    ChecadorListComponent.prototype.onSelectedItemChanged = function (item) {
        this.selectedItemChanged.emit(item);
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], ChecadorListComponent.prototype, "excludedItems", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], ChecadorListComponent.prototype, "titleDialog", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ChecadorListComponent.prototype, "validarPermisos", void 0);
    ChecadorListComponent = __decorate([
        core_1.Component({
            selector: 'rh-checador-list',
            template: "\n      <catalog-list-dialog (searchRequested)=\"onSearchRequested($event)\"\n                           (selectedItemsChanged)=\"onSelectedItemsChanged($event)\"\n                           (selectedItemChanged)=\"onSelectedItemChanged($event)\"\n                           [catalogList]=\"items\"\n                           [excludedItems]=\"excludedItems\"\n                           [multiSelect]=\"multiSelect\"\n                           [serverSide]=\"serverSide\"\n                           [pageSize]=\"pageSize\"\n                           [totalRows]=\"totalRows\"\n                           [pageIndex]=\"pageIndex\"\n                           [title]=\"titleDialog\">\n\n          <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'20*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Checador'\" [binding]=\"'nombre'\" [width]=\"'40*'\"></azteca-grid-column>\n\n      </catalog-list-dialog>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, checador_service_1.ChecadorService])
    ], ChecadorListComponent);
    return ChecadorListComponent;
}(search_1.CatalogListDialog));
exports.ChecadorListComponent = ChecadorListComponent;
