import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo, ReportService } from 'framework3/core';
import { MenuItem, ContentViewerComponent } from 'framework3/controls';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { FichasTitInfo } from '../models/fichas-tit';
import { EmpleadoInfo } from '../models/empleado';
import { FichasTitDetail } from '../models/fichas-tit-detail';
import { FichasTitService } from '../services/fichas-tit.service';
import { FichasTitDetailEditor } from './parts/fichas-tit-detail.editor';
import { TiposDescuentosInfo } from '../models/tipo-descuento';
import { AdamNominaInfo } from '../models/adamnomina';
import { FichaComponent } from '../components/ficha.component';
import { PolizaPerfilListComponent, PolizaInfo, PolizaPerfilItem, PolizaService } from '../../accounting';
import { ModalDirective } from 'ngx-bootstrap';
export declare class FichasTitEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private fichasTitService;
    private polizaSvc;
    private reportSvc;
    fichasTit: FichasTitInfo;
    currentPoliza: PolizaInfo;
    adamNomina: AdamNominaInfo;
    acumulado: number;
    total: number;
    argsCurrentDocument: WorkflowEventArgs;
    titleContentView: string;
    fileNameContentView: string;
    message: string;
    tipos: any[];
    detailsList: EditableListComponent;
    detailsEditor: FichasTitDetailEditor;
    dlgFicha: FichaComponent;
    dlgPolizaPerfil: PolizaPerfilListComponent;
    dlgPolizaViewer: ModalDirective;
    dlgFichaCargo: ModalDirective;
    reportViewer: ContentViewerComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, fichasTitService: FichasTitService, polizaSvc: PolizaService, reportSvc: ReportService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onTotalChanged(args: any): void;
    onEmpleadoSelected(args: EmpleadoInfo): void;
    onMenuItemClick(option: MenuItem): void;
    validateMontos(): string;
    validateMontos2(): string;
    onAddingDetail(): void;
    onEditingDetail(detail: FichasTitDetail): void;
    onDeletingDetail(detail: FichasTitDetail): void;
    onListItemsUpdated(updatedDetails: FichasTitDetail[]): void;
    onSavingDetail(detail: FichasTitDetail): void;
    onTipoDescuentoSelected(args: TiposDescuentosInfo): void;
    onDescuentoSelected(args: any): void;
    onSelectedPolizaPerfil(item: PolizaPerfilItem): void;
    onClickGuardar(): void;
    onAceptFicha(): void;
}
