"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Locales
var fichas_tit_1 = require("../models/fichas-tit");
var fichas_tit_detail_1 = require("../models/fichas-tit-detail");
var fichas_tit_service_1 = require("../services/fichas-tit.service");
var fichas_tit_detail_editor_1 = require("./parts/fichas-tit-detail.editor");
var adamnomina_1 = require("../models/adamnomina");
var ficha_component_1 = require("../components/ficha.component");
var accounting_1 = require("../../accounting");
var ngx_bootstrap_1 = require("ngx-bootstrap");
var FichasTitEditor = /** @class */ (function (_super) {
    __extends(FichasTitEditor, _super);
    function FichasTitEditor(context, router, route, location, formBuilder, documentTypeService, fichasTitService, polizaSvc, reportSvc) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.fichasTitService = fichasTitService;
        _this.polizaSvc = polizaSvc;
        _this.reportSvc = reportSvc;
        _this.fichasTit = new fichas_tit_1.FichasTitInfo();
        _this.currentPoliza = new accounting_1.PolizaInfo();
        _this.adamNomina = new adamnomina_1.AdamNominaInfo();
        _this.acumulado = 0;
        _this.total = 0;
        _this.titleContentView = "";
        _this.fileNameContentView = "";
        _this.message = "";
        _this.tipos = [{ 'value': 'N', 'text': 'Descuento Por Nomina' }, { 'value': 'C', 'text': 'Fecha de Pago' }];
        _this.documentForm = formBuilder.group({
            'idEmpleado': [0, controls_1.AztecaValidators.selected],
            'importe': [0, forms_1.Validators.required],
            'total': [0],
            'cargo': [0, forms_1.Validators.required],
            'descripcion': ['', forms_1.Validators.required],
            'tipo': ['', forms_1.Validators.required],
            'fechaPago': [''],
            'acumulado': [0]
        });
        return _this;
    }
    FichasTitEditor_1 = FichasTitEditor;
    FichasTitEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
    };
    FichasTitEditor.prototype.onCreatingDocument = function () {
    };
    FichasTitEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.fichasTitService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.fichasTit = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FichasTitEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.fichasTitService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.fichasTit = doc;
            _this.detailsEditor.clientIndexStart = _this.fichasTit.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FichasTitEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.fichasTitService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.fichasTit = doc;
            _this.detailsEditor.clientIndexStart = _this.fichasTit.details.length;
            if (_this.fichasTit.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
            _this.acumulado = _this.fichasTit.details.map(function (c) { return c.importe; })
                .reduce(function (sum, current) { return sum + current; });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FichasTitEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        if (this.fichasTit.totalFicha >= this.fichasTit.totalCargo) {
            if (this.total == this.acumulado) {
                this.context.app.showSpinner();
                this.fichasTitService.update(this.fichasTit)
                    .then(function (updatedDoc) {
                    _this.context.app.hideSpinner();
                    //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
                    _this.reset();
                    if (!args.closeEditor && _this.fichasTit.identity == '') {
                        _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
                    }
                    else {
                        if (args.closeEditor)
                            _this.router.navigate(['../'], { relativeTo: _this.route });
                        else
                            _this.showAlert('La información ha sido actualizada con éxito', 'success');
                    }
                    _this.fichasTit = updatedDoc;
                    _this.acumulado = _this.fichasTit.details.map(function (c) { return c.importe; })
                        .reduce(function (sum, current) { return sum + current; });
                })
                    .catch(function (error) { return _this.handleError(error); });
            }
            else {
                this.showAlert('Existe una diferencia entre el total y el caumulado', 'danger');
            }
        }
        else {
            this.showAlert('El total de la ficha debe de ser mayor o igual al total del cargo', 'danger');
        }
    };
    FichasTitEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.argsCurrentDocument = args;
        args.step.activities.forEach(function (activity) {
            if (activity.tag == 'APPLY') {
                if (_this.fichasTit.tipo == 'C') {
                    _this.message = 'Esta Ficha no se Descuenta Via Nomina Fecha de Pago Compromiso ' + _this.fichasTit.fechaPago.toDateString();
                    _this.dlgFichaCargo.config.backdrop = false;
                    _this.dlgFichaCargo.show();
                }
                else {
                    _this.dlgFicha.idFichatit = args.document.id;
                    _this.dlgFicha.show();
                }
            }
            else if (activity.tag == 'AUTHORIZE') {
                _this.context.app.showSpinner();
                _this.fichasTitService.getCuentaEmpleado(args.document.id).then(function (idCuenta) {
                    _this.context.app.hideSpinner();
                    if (idCuenta > 0) {
                        _this.fichasTitService.armarCuentas(args.document.id).then(function (a) {
                            _this.dlgPolizaPerfil.show();
                        }).catch(function (error) {
                            _this.context.app.hideSpinner();
                            _this.handleError(error);
                        });
                    }
                    else
                        _this.showAlert('El empleado no tiene cuenta asignada', 'danger');
                }).catch(function (error) {
                    _this.context.app.hideSpinner();
                    _this.handleError(error);
                });
            }
        });
    };
    FichasTitEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.fichasTitService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FichasTitEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.fichasTit.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    FichasTitEditor.prototype.onTotalChanged = function (args) {
        this.total = args;
        this.documentForm.updateValueAndValidity();
    };
    FichasTitEditor.prototype.onEmpleadoSelected = function (args) {
        var _this = this;
        if (args != undefined && args != null) {
            this.context.app.showSpinner();
            this.fichasTitService.loadInfoEmpleadoAdam(this.context.app.defaultSite.identity, args.code)
                .then(function (info) {
                _this.context.app.hideSpinner();
                if (info[0] != undefined) {
                    _this.fichasTit.claseNomina = info[0].clase_Nomina;
                    _this.fichasTit.compania = info[0].compania;
                    _this.fichasTit.ejercicio = info[0].ejercicio;
                    _this.fichasTit.periodoDescontar = info[0].periodo;
                    _this.fichasTit.tipoNomina = info[0].tipo_Nomina;
                }
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    FichasTitEditor.prototype.onMenuItemClick = function (option) {
        var _this = this;
        if (option.name == 'DOCUEMNTS') {
            this.router.navigate(['rh/documento-empleado', this.process.id, this.fichasTit.idEmpleado], { queryParams: { process: this.process.codigo } });
        }
        else if (option.name == 'PDF') {
            if (this.fichasTit.identity.length > 0) {
                this.context.app.showSpinner();
                var informe = new core_2.ReporteInfo();
                var parametroFicha = new core_2.ParametroInfo();
                var parametroSucursal = new core_2.ParametroInfo();
                parametroFicha.name = "IdFichaTit";
                parametroFicha.values.push(this.fichasTit.identity);
                parametroSucursal.name = "IdSucursal";
                parametroSucursal.values.push(this.context.app.defaultSite.identity.toString());
                informe.parametros.push(parametroFicha);
                informe.parametros.push(parametroSucursal);
                informe.path = "/Onili/RH/FichaCargo";
                informe.format = "pdf";
                this.reportSvc.loadReporte(informe)
                    .then(function (info) {
                    _this.context.app.hideSpinner();
                    _this.titleContentView = "Ficha " + _this.fichasTit.identity;
                    _this.fileNameContentView = _this.fichasTit.identity + ".pdf";
                    _this.reportViewer.show("data:application/pdf; base64, " + info.content);
                })
                    .catch(function (error) {
                    _this.context.app.hideSpinner();
                    _this.handleError(error);
                });
            }
        }
    };
    FichasTitEditor.prototype.validateMontos = function () {
        if (this.acumulado == this.total)
            return null;
        else
            return 'No coincide el total de la ficha con los conceptos capturados';
    };
    FichasTitEditor.prototype.validateMontos2 = function () {
        if (this.acumulado == this.total)
            return null;
        else
            return 'No coincide el total de la ficha con los conceptos capturados';
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    FichasTitEditor.prototype.onAddingDetail = function () {
        if (this.fichasTit.details.filter(function (detail) { return detail.state != 'DELETED'; }).length > 0) {
            this.showAlert('No se puede agregar mas de un concepto a la ficha', 'danger');
        }
        else {
            this.detailsEditor.detail = new fichas_tit_detail_1.FichasTitDetail();
            this.detailsEditor.show();
        }
    };
    FichasTitEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    FichasTitEditor.prototype.onDeletingDetail = function (detail) {
        this.acumulado = this.fichasTit.details.filter(function (detail) { return detail.state != 'DELETED'; })
            .map(function (c) { return c.importe; })
            .reduce(function (sum, current) { return sum + current; });
        this.total = this.fichasTit.totalCargo;
        this.detailsList.deleteItem(detail);
        this.documentForm.updateValueAndValidity();
    };
    FichasTitEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.fichasTit.details = updatedDetails;
        this.total = this.fichasTit.totalCargo;
        this.acumulado = this.fichasTit.details.filter(function (detail) { return detail.state != 'DELETED'; })
            .map(function (c) { return c.importe; })
            .reduce(function (sum, current) { return sum + current; });
        this.documentForm.updateValueAndValidity();
    };
    FichasTitEditor.prototype.onSavingDetail = function (detail) {
        var _this = this;
        if (this.fichasTit.details.length == 0)
            this.detailsList.updateItem(detail);
        else
            this.fichasTit.details.forEach(function (det) {
                if (det.concepto.identity == detail.concepto.identity && det.state != 'DELETED' && detail.state != 'MODIFIED')
                    _this.showAlert("El concepto ya fue agregado", "información");
                else
                    _this.detailsList.updateItem(detail);
            });
    };
    FichasTitEditor.prototype.onTipoDescuentoSelected = function (args) {
    };
    FichasTitEditor.prototype.onDescuentoSelected = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.fichasTitService.nextStep(this.editor.document.identity, this.argsCurrentDocument.step.idWorkflowStep, args)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(_this.editor.document.identity);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FichasTitEditor.prototype.onSelectedPolizaPerfil = function (item) {
        var _this = this;
        this.context.app.showSpinner();
        this.polizaSvc.loadPolizaByDocumento(this.editor.document.identity, item.id, this.context.app.defaultSite.identity)
            .then(function (result) {
            _this.currentPoliza = result;
            _this.context.app.hideSpinner();
            _this.dlgPolizaViewer.config.backdrop = false;
            _this.dlgPolizaViewer.show();
        }).catch(function (error) { return _this.handleError(error); });
    };
    FichasTitEditor.prototype.onClickGuardar = function () {
        var _this = this;
        this.dlgPolizaViewer.hide();
        this.context.app.showSpinner();
        if (this.currentPoliza.idPolizaOrigen == 0)
            this.currentPoliza.idPolizaOrigen = 1; //Manual
        this.fichasTitService.nextStep(this.argsCurrentDocument.document.id, this.argsCurrentDocument.step.idWorkflowStep, this.currentPoliza)
            .then(function (_) {
            _this.dlgPolizaViewer.hide();
            //Volver a cargar documento
            _this.onViewingDocument(_this.editor.document.identity);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FichasTitEditor.prototype.onAceptFicha = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.fichasTitService.nextStep(this.argsCurrentDocument.document.id, this.argsCurrentDocument.step.idWorkflowStep, null)
            .then(function (_) {
            _this.dlgFichaCargo.hide();
            //Volver a cargar documento
            _this.onViewingDocument(_this.editor.document.identity);
        })
            .catch(function (error) {
            _this.dlgFichaCargo.hide();
            _this.handleError(error);
        });
    };
    var FichasTitEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], FichasTitEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", fichas_tit_detail_editor_1.FichasTitDetailEditor)
    ], FichasTitEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild('dlgFicha'),
        __metadata("design:type", ficha_component_1.FichaComponent)
    ], FichasTitEditor.prototype, "dlgFicha", void 0);
    __decorate([
        core_1.ViewChild(accounting_1.PolizaPerfilListComponent),
        __metadata("design:type", accounting_1.PolizaPerfilListComponent)
    ], FichasTitEditor.prototype, "dlgPolizaPerfil", void 0);
    __decorate([
        core_1.ViewChild('viewDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], FichasTitEditor.prototype, "dlgPolizaViewer", void 0);
    __decorate([
        core_1.ViewChild('viewType'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], FichasTitEditor.prototype, "dlgFichaCargo", void 0);
    __decorate([
        core_1.ViewChild(controls_1.ContentViewerComponent),
        __metadata("design:type", controls_1.ContentViewerComponent)
    ], FichasTitEditor.prototype, "reportViewer", void 0);
    FichasTitEditor = FichasTitEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-fichas-tit-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                  [title]=\"'FichasTit'\"\n                                  [document]=\"fichasTit\"\n                                  [valid]=\"valid\"\n                                  (configureDocument)=\"onConfigureDocument($event)\"\n                                  (creatingDocument)=\"onCreatingDocument()\"\n                                  (viewingDocument)=\"onViewingDocument($event)\"\n                                  (cloningDocument)=\"onCloningDocument($event)\"\n                                  (savingDocument)=\"onSavingDocument($event)\"\n                                  (loadingDocument)=\"onLoadingDocument($event)\"\n                                  (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                  (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'DOCUEMNTS'\" [icon]=\"'glyphicon glyphicon-file'\" [text]=\"'Documentos'\" [smallText]=\"'documentos del empleado'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'PDF'\" [icon]=\"'glyphicon glyphicon-print'\" [text]=\"'Imprimir'\" [smallText]=\"'generar pdf de la ficha'\"></azteca-menu-item>\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-10\">\n                                      <azteca-form-field [label]=\"'Empleado:'\">\n                                          <rh-empleado-selector formControlName=\"idEmpleado\" [(ngModel)]=\"fichasTit.idEmpleado\" (empleadoUpdated)=\"onEmpleadoSelected($event)\"></rh-empleado-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-lg-6 col-md-10\">\n                                      <azteca-form-field [label]=\"'Monto Total de La Ficha:'\">\n                                          <az-input-number formControlName=\"importe\" [(ngModel)]=\"fichasTit.totalFicha\" [value]=\"fichasTit.totalFicha\" [min]=\"0\" [format]=\"'C4'\" ></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-lg-6 col-md-10\">\n                                      <azteca-form-field [label]=\"'Monto Total del Cargo:'\">\n                                          <az-input-number formControlName=\"cargo\" [(ngModel)]=\"fichasTit.totalCargo\" [value]=\"fichasTit.totalCargo\" [min]=\"0\" [format]=\"'C4'\" (valueChange)=\"onTotalChanged($event)\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-lg-10 col-sm-12\">\n                                      <azteca-form-field [label]=\"'Descripci\u00F3n:'\">\n                                          <az-textarea formControlName=\"descripcion\" [(ngModel)]=\"fichasTit.descripcion\"></az-textarea>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-lg-6 col-sm-12\">\n                                      <azteca-form-field [label]=\"'Tipo:'\">\n                                          <az-combobox formControlName=\"tipo\" [(ngModel)]=\"fichasTit.tipo\" [items]=\"tipos\" [displayMember]=\"'text'\" [valueMember]=\"'value'\"></az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-lg-6 col-sm-12\" *ngIf=\"fichasTit.tipo=='C'\">\n                                      <azteca-form-field [label]=\"'Fecha Pago:'\">\n                                          <az-input-date formControlName=\"fechaPago\" [(ngModel)]=\"fichasTit.fechaPago\" [value]=\"fichasTit.fechaPago\"></az-input-date>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </tab>\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Total:'\">\n                                          <az-input-number formControlName=\"total\" [(ngModel)]=\"total\" format=\"'N4'\" [enabled]=\"false\"></az-input-number>\n                                          <!--&& acumulado >0-->\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Capturado:'\">\n                                          <az-input-number formControlName=\"acumulado\" [(ngModel)]=\"acumulado\" format=\"'N4'\" [enabled]=\"false\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <azteca-editable-list #detailsList\n                                                    (addingItem)=\"onAddingDetail()\"\n                                                    (editingItem)=\"onEditingDetail($event)\"\n                                                    (deletingItem)=\"onDeletingDetail($event)\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    [listItems]=\"fichasTit.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                                  <azteca-grid-column [header]=\"'Concepto'\" [binding]=\"'concepto.nombre'\" [width]=\"'30*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'30*'\" format=\"'N4'\"></azteca-grid-column>\n                              </azteca-editable-list>\n                          </tab>\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"fichasTit.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <rh-fichas-tit-detail-editor #detailsEditor\n                                   (savingItem)=\"onSavingDetail($event)\">\n\n      </rh-fichas-tit-detail-editor>\n\n      <rh-ficha #dlgFicha\n                (descuentoSelected)=\"onDescuentoSelected($event)\">\n\n      </rh-ficha>\n\n      <!-- Perfil de poliza para contabilizar la ficha -->\n      <accounting-poliza-perfil-list [searchByUser]=\"true\" (selectedItemChanged)=\"onSelectedPolizaPerfil($event)\"></accounting-poliza-perfil-list>\n\n      <!-- Visualizar poliza -->\n      <div bsModal #viewDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\">P&oacute;liza</h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"viewDialog.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <accounting-poliza-viewer [poliza]=\"currentPoliza\"></accounting-poliza-viewer>\n                  </div> <!--Modal Body-->\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-default\" data-dismiss=\"modal\" (click)=\"viewDialog.hide()\">Cancelar</button>\n                      <button type=\"button\" class=\"btn btn-primary\" data-dismiss=\"modal\" (click)=\"onClickGuardar()\">Guardar</button>\n                  </div>\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n      <!-- Dialogo para el tipo de ficha de tipo cargo -->\n      <div bsModal #viewType=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\">Fichas de Cargo</h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"viewDialog.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <p>{{message}}</p>\n                  </div> <!--Modal Body-->\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-default\" data-dismiss=\"modal\" (click)=\"viewType.hide()\">Cancelar</button>\n                      <button type=\"button\" class=\"btn btn-primary\" data-dismiss=\"modal\" (click)=\"onAceptFicha()\">Guardar</button>\n                  </div>\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n\n      <azteca-content-viewer></azteca-content-viewer>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return FichasTitEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: fichas_tit_service_1.FichasTitService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            fichas_tit_service_1.FichasTitService,
            accounting_1.PolizaService,
            core_2.ReportService])
    ], FichasTitEditor);
    return FichasTitEditor;
}(editors_1.DocumentEditor));
exports.FichasTitEditor = FichasTitEditor;
