import { Router, ActivatedRoute } from '@angular/router';
import { Context, DocumentItem, ReportService } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { FichasTitItem } from '../models/fichas-tit';
import { FichasTitService } from '../services/fichas-tit.service';
import { FichaComponent } from '../components/ficha.component';
import { MenuItem, ContentViewerComponent } from 'framework3/controls';
import { PolizaPerfilListComponent, PolizaPerfilItem, PolizaService, PolizaInfo } from '../../accounting';
import { ModalDirective } from 'ngx-bootstrap';
export declare class FichasTitManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private fichasTitService;
    private polizaSvc;
    private reportSvc;
    fichasTit: FichasTitItem[];
    argsCurrentDocument: WorkflowEventArgs;
    currentPoliza: PolizaInfo;
    titleContentView: string;
    fileNameContentView: string;
    message: string;
    dlgFicha: FichaComponent;
    dlgPolizaPerfil: PolizaPerfilListComponent;
    dlgPolizaViewer: ModalDirective;
    dlgFichaCargo: ModalDirective;
    reportViewer: ContentViewerComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, fichasTitService: FichasTitService, polizaSvc: PolizaService, reportSvc: ReportService);
    onConfigureDocument(): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onDescuentoSelected(args: number): void;
    onSelectedPolizaPerfil(item: PolizaPerfilItem): void;
    onMenuItemClick(option: MenuItem): void;
    onClickGuardar(): void;
    onAceptFicha(): void;
}
