"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var fichas_tit_service_1 = require("../services/fichas-tit.service");
var ficha_component_1 = require("../components/ficha.component");
var controls_1 = require("framework3/controls");
var accounting_1 = require("../../accounting");
var ngx_bootstrap_1 = require("ngx-bootstrap");
var FichasTitManager = /** @class */ (function (_super) {
    __extends(FichasTitManager, _super);
    function FichasTitManager(context, router, route, fichasTitService, polizaSvc, reportSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.fichasTitService = fichasTitService;
        _this.polizaSvc = polizaSvc;
        _this.reportSvc = reportSvc;
        _this.currentPoliza = new accounting_1.PolizaInfo();
        _this.titleContentView = "";
        _this.fileNameContentView = "";
        _this.message = "";
        return _this;
    }
    FichasTitManager_1 = FichasTitManager;
    FichasTitManager.prototype.onConfigureDocument = function () {
        this.refreshList();
        this.applyPolicies();
    };
    FichasTitManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.fichasTitService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.fichasTit = response.rows;
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FichasTitManager.prototype.onAddingItem = function () {
        this.router.navigate(['0'], { relativeTo: this.route });
    };
    FichasTitManager.prototype.onViewingItem = function (document) {
        this.router.navigate([document.id, { readonly: true }], { relativeTo: this.route });
    };
    FichasTitManager.prototype.onEditingItem = function (document) {
        this.router.navigate([document.id], { relativeTo: this.route });
    };
    FichasTitManager.prototype.onDeletingItem = function (document) {
        var _this = this;
        this.fichasTitService.delete(document.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El documento ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FichasTitManager.prototype.onCloningItem = function (document) {
        this.router.navigate([0, { cloneId: document.id }], { relativeTo: this.route });
    };
    FichasTitManager.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.argsCurrentDocument = args;
        args.step.activities.forEach(function (activity) {
            if (activity.tag == 'APPLY') {
                if (_this.fichasTit.filter(function (X) { return X.id == _this.manager.currentDocument.id; })[0].tipo == 'C') {
                    _this.message = 'Esta Ficha no se Descuenta Via Nomina Fecha de Pago Compromiso ' + _this.fichasTit.filter(function (X) { return X.id == _this.manager.currentDocument.id; })[0].cobro;
                    _this.dlgFichaCargo.config.backdrop = false;
                    _this.dlgFichaCargo.show();
                }
                else {
                    _this.dlgFicha.idFichatit = args.document.id;
                    _this.dlgFicha.show();
                }
            }
            else if (activity.tag == 'AUTHORIZE') {
                _this.context.app.showSpinner();
                _this.fichasTitService.getCuentaEmpleado(args.document.id).then(function (idCuenta) {
                    _this.context.app.hideSpinner();
                    if (idCuenta > 0) {
                        _this.fichasTitService.armarCuentas(args.document.id).then(function (a) {
                            _this.dlgPolizaPerfil.show();
                        }).catch(function (error) {
                            _this.context.app.hideSpinner();
                            _this.handleError(error);
                        });
                    }
                    else
                        _this.showAlert('El empleado no tiene cuenta asignada', 'danger');
                }).catch(function (error) {
                    _this.context.app.hideSpinner();
                    _this.handleError(error);
                });
            }
        });
    };
    FichasTitManager.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.fichasTitService.previousStep(document.id, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FichasTitManager.prototype.onDescuentoSelected = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.fichasTitService.nextStep(this.argsCurrentDocument.document.id, this.argsCurrentDocument.step.idWorkflowStep, args)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FichasTitManager.prototype.onSelectedPolizaPerfil = function (item) {
        var _this = this;
        this.context.app.showSpinner();
        this.polizaSvc.loadPolizaByDocumento(this.manager.currentDocument.id, item.id, this.context.app.defaultSite.identity)
            .then(function (result) {
            _this.currentPoliza = result;
            _this.context.app.hideSpinner();
            _this.dlgPolizaViewer.config.backdrop = false;
            _this.dlgPolizaViewer.show();
        }).catch(function (error) { return _this.handleError(error); });
    };
    FichasTitManager.prototype.onMenuItemClick = function (option) {
        var _this = this;
        if (option.name == 'DEACTIVATE') {
            this.context.app.showSpinner();
            this.fichasTitService.deactivate(this.manager.currentDocument.id)
                .then(function (_) {
                _this.context.app.hideSpinner();
                _this.showAlert('El documento se desactivo con éxito', 'success');
                _this.refreshList();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == 'DOCUEMNTS') {
            this.context.app.showSpinner();
            this.fichasTitService.getDetail(this.manager.currentDocument.id)
                .then(function (doc) {
                _this.context.app.hideSpinner();
                _this.router.navigate(['rh/documento-empleado', _this.process.id, doc.idEmpleado], { queryParams: { process: _this.process.codigo } });
            })
                .catch(function (error) {
                _this.context.app.hideSpinner();
                _this.handleError(error);
            });
        }
        else if (option.name == 'PDF') {
            this.context.app.showSpinner();
            var item = this.manager.currentDocument;
            var informe = new core_2.ReporteInfo();
            var parametroFicha = new core_2.ParametroInfo();
            var parametroSucursal = new core_2.ParametroInfo();
            parametroFicha.name = "IdFichaTit";
            parametroFicha.values.push(item.id);
            parametroSucursal.name = "IdSucursal";
            parametroSucursal.values.push(this.context.app.defaultSite.identity.toString());
            informe.parametros.push(parametroFicha);
            informe.parametros.push(parametroSucursal);
            informe.path = "/Onili/RH/FichaCargo";
            informe.format = "pdf";
            this.reportSvc.loadReporte(informe)
                .then(function (info) {
                _this.context.app.hideSpinner();
                var item = _this.manager.currentDocument;
                _this.titleContentView = "Ficha " + item.id;
                _this.fileNameContentView = item.id + ".pdf";
                _this.reportViewer.show("data:application/pdf; base64, " + info.content);
            })
                .catch(function (error) {
                _this.context.app.hideSpinner();
                _this.handleError(error);
            });
        }
    };
    FichasTitManager.prototype.onClickGuardar = function () {
        var _this = this;
        this.dlgPolizaViewer.hide();
        this.context.app.showSpinner();
        if (this.currentPoliza.idPolizaOrigen == 0)
            this.currentPoliza.idPolizaOrigen = 1; //Manual
        this.fichasTitService.nextStep(this.argsCurrentDocument.document.id, this.argsCurrentDocument.step.idWorkflowStep, this.currentPoliza)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.dlgPolizaViewer.hide();
            _this.refreshList();
        })
            .catch(function (error) {
            _this.handleError(error);
        });
    };
    FichasTitManager.prototype.onAceptFicha = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.fichasTitService.nextStep(this.argsCurrentDocument.document.id, this.argsCurrentDocument.step.idWorkflowStep, null)
            .then(function (_) {
            _this.dlgFichaCargo.hide();
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) {
            _this.dlgFichaCargo.hide();
            _this.handleError(error);
        });
    };
    var FichasTitManager_1;
    __decorate([
        core_1.ViewChild('dlgFicha'),
        __metadata("design:type", ficha_component_1.FichaComponent)
    ], FichasTitManager.prototype, "dlgFicha", void 0);
    __decorate([
        core_1.ViewChild(accounting_1.PolizaPerfilListComponent),
        __metadata("design:type", accounting_1.PolizaPerfilListComponent)
    ], FichasTitManager.prototype, "dlgPolizaPerfil", void 0);
    __decorate([
        core_1.ViewChild('viewDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], FichasTitManager.prototype, "dlgPolizaViewer", void 0);
    __decorate([
        core_1.ViewChild('viewType'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], FichasTitManager.prototype, "dlgFichaCargo", void 0);
    __decorate([
        core_1.ViewChild(controls_1.ContentViewerComponent),
        __metadata("design:type", controls_1.ContentViewerComponent)
    ], FichasTitManager.prototype, "reportViewer", void 0);
    FichasTitManager = FichasTitManager_1 = __decorate([
        core_1.Component({
            selector: 'rh-fichas-tit-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">FichasTit</div>\n          <div class=\"card-block\">\n              <azteca-document-manager (searchRequested)=\"onSearchRequested($event)\"\n                                       (addingItem)=\"onAddingItem()\"\n                                       (viewingItem)=\"onViewingItem($event)\"\n                                       (editingItem)=\"onEditingItem($event)\"\n                                       (deletingItem)=\"onDeletingItem($event)\"\n                                       (cloningItem)=\"onCloningItem($event)\"\n                                       (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                       (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                       (configureDocument)=\"onConfigureDocument($event)\"\n                                       (menuItemClick)=\"onMenuItemClick($event)\"\n                                       [enabled]=\"enabled\"\n                                       [allowNew]=\"allowNew\"\n                                       [allowView]=\"allowView\"\n                                       [allowEdit]=\"allowEdit\"\n                                       [allowDelete]=\"allowDelete\"\n                                       [allowClone]=\"allowClone\"\n                                       [allowNext]=\"allowNext\"\n                                       [allowPrevious]=\"allowPrevious\"\n                                       [allowAudit]=\"allowAudit\"\n                                       [filterGroups]=\"filterGroups\"\n                                       [documentList]=\"fichasTit\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'DEACTIVATE'\" [icon]=\"'glyphicon glyphicon-remove'\" [text]=\"'Desactivar Documento'\" [smallText]=\"'Desactiva el documento'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'DOCUEMNTS'\" [icon]=\"'glyphicon glyphicon-file'\" [text]=\"'Documentos'\" [smallText]=\"'documentos del empleado'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'PDF'\" [icon]=\"'glyphicon glyphicon-print'\" [text]=\"'Imprimir'\" [smallText]=\"'generar pdf de la ficha'\"></azteca-menu-item>\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"200\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"180\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Tipo'\" [binding]=\"'cobro'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Empleado'\" [binding]=\"'codigoEmpleado'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Total Cargo'\" [binding]=\"'totalCargo'\" [width]=\"'10*'\" format=\"C2\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Cant. Documentos'\" [binding]=\"'cantDocs'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Estatus'\" [binding]=\"'status'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"'10*'\"></azteca-grid-column>\n\n              </azteca-document-manager>\n          </div>\n      </div>\n\n      <rh-ficha #dlgFicha\n                (descuentoSelected)=\"onDescuentoSelected($event)\">\n\n      </rh-ficha>\n\n      <!-- Perfil de poliza para contabilizar la ficha -->\n      <accounting-poliza-perfil-list [searchByUser]=\"true\" (selectedItemChanged)=\"onSelectedPolizaPerfil($event)\"></accounting-poliza-perfil-list>\n\n      <!-- Visualizar poliza -->\n      <div bsModal #viewDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\">P&oacute;liza</h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"viewDialog.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <accounting-poliza-viewer [poliza]=\"currentPoliza\"></accounting-poliza-viewer>\n                  </div> <!--Modal Body-->\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-default\" data-dismiss=\"modal\" (click)=\"viewDialog.hide()\">Cancelar</button>\n                      <button type=\"button\" class=\"btn btn-primary\" data-dismiss=\"modal\" (click)=\"onClickGuardar()\">Guardar</button>\n                  </div>\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n\n      <!-- Dialogo para el tipo de ficha de tipo cargo -->\n      <div bsModal #viewType=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\">Fichas de Cargo</h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"viewDialog.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <p>{{message}}</p>\n                  </div> <!--Modal Body-->\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-default\" data-dismiss=\"modal\" (click)=\"viewType.hide()\">Cancelar</button>\n                      <button type=\"button\" class=\"btn btn-primary\" data-dismiss=\"modal\" (click)=\"onAceptFicha()\">Guardar</button>\n                  </div>\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n\n      <azteca-content-viewer></azteca-content-viewer>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return FichasTitManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: fichas_tit_service_1.FichasTitService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, fichas_tit_service_1.FichasTitService, accounting_1.PolizaService, core_2.ReportService])
    ], FichasTitManager);
    return FichasTitManager;
}(editors_1.DocumentManager));
exports.FichasTitManager = FichasTitManager;
