import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { NominaInfo } from '../models/nomina';
import { NominaDetail } from '../models/nomina-detail';
import { NominaService } from '../services/nomina.service';
import { NominaDetailEditor } from './parts/nominas-detail.editor';
import { PeriodicidadPagoInfo, PeriodoItem } from '../models/periodicidad-pago';
export declare class NominasEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private nominaService;
    nomina: NominaInfo;
    periodos: PeriodoItem[];
    detailsList: EditableListComponent;
    detailsEditor: NominaDetailEditor;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, nominaService: NominaService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: NominaDetail): void;
    onDeletingDetail(detail: NominaDetail): void;
    onListItemsUpdated(updatedDetails: NominaDetail[]): void;
    onSavingDetail(detail: NominaDetail): void;
    onPeriodicidadUpdatead(item: PeriodicidadPagoInfo): void;
}
