"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var nomina_service_1 = require("../services/nomina.service");
var NominasManager = /** @class */ (function (_super) {
    __extends(NominasManager, _super);
    function NominasManager(context, router, route, nominaService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.nominaService = nominaService;
        return _this;
    }
    NominasManager_1 = NominasManager;
    NominasManager.prototype.onConfigureDocument = function () {
        this.refreshList();
        this.applyPolicies();
    };
    NominasManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.nominaService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.nominas = response.rows;
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NominasManager.prototype.onAddingItem = function () {
        this.router.navigate(['0'], { relativeTo: this.route });
    };
    NominasManager.prototype.onViewingItem = function (document) {
        this.router.navigate([document.id, { readonly: true }], { relativeTo: this.route });
    };
    NominasManager.prototype.onEditingItem = function (document) {
        this.router.navigate([document.id], { relativeTo: this.route });
    };
    NominasManager.prototype.onDeletingItem = function (document) {
        var _this = this;
        this.nominaService.delete(document.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El documento ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NominasManager.prototype.onCloningItem = function (document) {
        this.router.navigate([0, { cloneId: document.id }], { relativeTo: this.route });
    };
    NominasManager.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.nominaService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NominasManager.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.nominaService.previousStep(document.id, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NominasManager.prototype.onMenuItemClick = function (option) {
        var _this = this;
        if (option.name == 'CALCULAR') {
            this.context.app.showSpinner();
            this.nominaService.calcularNomina(this.manager.currentDocument.id)
                .then(function (file) {
                _this.context.app.hideSpinner();
                _this.showAlert("Se ha creado la tarea de cálculo", "success");
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == 'TIMBRAR') {
            this.context.app.showSpinner();
            this.nominaService.timbrarNomina(this.manager.currentDocument.id)
                .then(function (file) {
                _this.context.app.hideSpinner();
                _this.showAlert("Se ha creado la tarea de timbrado", "success");
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    var NominasManager_1;
    NominasManager = NominasManager_1 = __decorate([
        core_1.Component({
            selector: 'rh-nominas-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Nominas</div>\n          <div class=\"card-block\">\n              <azteca-document-manager (searchRequested)=\"onSearchRequested($event)\"\n                                       (addingItem)=\"onAddingItem()\"\n                                       (viewingItem)=\"onViewingItem($event)\"\n                                       (editingItem)=\"onEditingItem($event)\"\n                                       (deletingItem)=\"onDeletingItem($event)\"\n                                       (cloningItem)=\"onCloningItem($event)\"\n                                       (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                       (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                       (configureDocument)=\"onConfigureDocument($event)\"\n                                       (menuItemClick)=\"onMenuItemClick($event)\"\n                                       [enabled]=\"enabled\"\n                                       [allowNew]=\"allowNew\"\n                                       [allowView]=\"allowView\"\n                                       [allowEdit]=\"allowEdit\"\n                                       [allowDelete]=\"allowDelete\"\n                                       [allowClone]=\"allowClone\"\n                                       [allowNext]=\"allowNext\"\n                                       [allowPrevious]=\"allowPrevious\"\n                                       [allowAudit]=\"allowAudit\"\n                                       [filterGroups]=\"filterGroups\"\n                                       [documentList]=\"nominas\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'CALCULAR'\" [icon]=\"'glyphicon glyphicon-export'\" [text]=\"'Calcular N\u00F3mina'\" [smallText]=\"'Calcular n\u00F3mina y generar recibos de n\u00F3mina'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'TIMBRAR'\" [icon]=\"'glyphicon glyphicon-export'\" [text]=\"'Timbrar N\u00F3mina'\" [smallText]=\"'Timbrar recibos de n\u00F3mina'\"></azteca-menu-item>\n\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"200\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"180\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Estatus'\" [binding]=\"'status'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"'10*'\"></azteca-grid-column>\n\n              </azteca-document-manager>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return NominasManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: nomina_service_1.NominaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, nomina_service_1.NominaService])
    ], NominasManager);
    return NominasManager;
}(editors_1.DocumentManager));
exports.NominasManager = NominasManager;
