"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var fichas_tit_detail_1 = require("../../models/fichas-tit-detail");
var controls_1 = require("framework3/controls");
var FichasTitDetailEditor = /** @class */ (function (_super) {
    __extends(FichasTitDetailEditor, _super);
    function FichasTitDetailEditor(context, builder) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.builder = builder;
        //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
        _this.detailCopy = new fichas_tit_detail_1.FichasTitDetail();
        //Objeto original que se editará
        _this.detail = new fichas_tit_detail_1.FichasTitDetail();
        _this.form = builder.group({
            'concepto': ['', controls_1.AztecaValidators.selected],
            'importe': [0, forms_1.Validators.required]
        });
        return _this;
    }
    /////////////////// METODOS ///////////////////////////////
    /////////////////// HANDLERS //////////////////////////////
    FichasTitDetailEditor.prototype.onCreatingItem = function () {
        this.detailCopy = this.detail;
        this.form.reset({ concepto: '' });
        this.form.reset({ importe: 0 });
        this.form.markAsPristine();
    };
    FichasTitDetailEditor.prototype.onLoadingItem = function (detail) {
        this.detailCopy = this.copyItem(this.detail);
    };
    FichasTitDetailEditor.prototype.onUpdatingItem = function (detail) {
        if (this.detailCopy._clientID == 0) {
            this.detailCopy._clientID = this.createClientID();
        }
        else {
            this.detailCopy.state = editors_1.ChangeState.MODIFIED;
        }
        this.savingItem.emit(this.detailCopy);
    };
    FichasTitDetailEditor.prototype.onConceptoUpdate = function (args) {
        this.detailCopy.concepto = args;
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", fichas_tit_detail_1.FichasTitDetail)
    ], FichasTitDetailEditor.prototype, "detail", void 0);
    FichasTitDetailEditor = __decorate([
        core_1.Component({
            selector: 'rh-fichas-tit-detail-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <azteca-basic-editor [item]=\"detail\"\n                               [dirty]=\"dirty\"\n                               [valid]=\"valid\"\n                               (creatingItem)=\"onCreatingItem()\"\n                               (loadingItem)=\"onLoadingItem($event)\"\n                               (updatingItem)=\"onUpdatingItem($event)\">\n\n              <azteca-form-field [label]=\"'Concepto:'\">\n                  <rh-conceptos-fichas-selector formControlName=\"concepto\" (conceptoUpdated)=\"onConceptoUpdate($event)\"></rh-conceptos-fichas-selector>\n              </azteca-form-field>\n\n              <azteca-form-field [label]=\"'Importe:'\">\n                  <az-input-number formControlName=\"importe\" [(ngModel)]=\"detailCopy.importe\" [value]=\"detailCopy.importe\" [min]=\"0\" [format]=\"'C4'\"></az-input-number>\n              </azteca-form-field>\n          </azteca-basic-editor>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder])
    ], FichasTitDetailEditor);
    return FichasTitDetailEditor;
}(editors_1.BasicEditor));
exports.FichasTitDetailEditor = FichasTitDetailEditor;
