import { OnInit } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Menu } from 'wijmo/wijmo.input';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { MenuItem } from 'framework3/controls';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { ReciboNominaInfo } from '../models/recibo-nomina';
import { ReciboNominaDetail } from '../models/recibo-nomina-detail';
import { ReciboNominaService } from '../services/recibo-nomina.service';
import { ReciboNominaDetailEditor } from './parts/recibos-nominas-detail.editor';
import { TiposPerDedListComponent } from '../controls/tipos-per-ded-list.component';
import { TipoPerDedItem } from '../models/tipo-per-ded';
import { EmpleadoInfo } from '../models/empleado';
import { EmpleadoService } from '../services/empleado.service';
import { CompaniaService } from '../services/compania.service';
import { EmpresaService } from '../../accounting/services/empresa.service';
import { TipoRegimenService } from '../../accounting/services/tipo-regimen.service';
import { RegimenFiscalItem } from '../../accounting/models/empresa';
import { TipoRegimenItem } from '../../accounting/models/tipo-regimen';
import { TipoContratoItem } from '../../accounting/models/tipo-contrato';
import { TipoContratoService } from '../../accounting/services/tipo-contrato.service';
import { JornadaItem } from '../../accounting/models/jornada';
import { JornadaService } from '../../accounting/services/jornada.service';
import { RiesgoPuestoItem } from '../../accounting/models/riesgo-puesto';
import { RiesgoPuestoService } from '../../accounting/services/riesgo-puesto.service';
import { PeriodoPagoItem } from '../../accounting/models/periodo-pago';
import { PeriodoPagoService } from '../../accounting/services/periodo-pago.service';
export declare class RecibosNominasEditor extends DocumentEditor implements OnInit {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private reciboNominaService;
    private empleadoSvc;
    private empresaSvc;
    private companiaSvc;
    private tipoRegimenSvc;
    private tipoContratoSvc;
    private jornadaSvc;
    private riesgoPuestoSvc;
    private periodoPagoSvc;
    reciboNomina: ReciboNominaInfo;
    detailsList: EditableListComponent;
    detailsEditor: ReciboNominaDetailEditor;
    tipoPerDedList: TiposPerDedListComponent;
    menuDetailItems: MenuItem[];
    empledao: EmpleadoInfo;
    regimenesFiscales: RegimenFiscalItem[];
    tiposRegimen: TipoRegimenItem[];
    tiposContrato: TipoContratoItem[];
    jornadas: JornadaItem[];
    riesgosPuesto: RiesgoPuestoItem[];
    periodosPago: PeriodoPagoItem[];
    tiposNominas: {
        'tipo': string;
        'nombre': string;
    }[];
    readonly subtotal: string;
    readonly descuentos: string;
    readonly total: string;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, reciboNominaService: ReciboNominaService, empleadoSvc: EmpleadoService, empresaSvc: EmpresaService, companiaSvc: CompaniaService, tipoRegimenSvc: TipoRegimenService, tipoContratoSvc: TipoContratoService, jornadaSvc: JornadaService, riesgoPuestoSvc: RiesgoPuestoService, periodoPagoSvc: PeriodoPagoService);
    ngOnInit(): void;
    createMenuDetail(): void;
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    loadRegimenesFiscales(): void;
    loadTiposRegimen(): void;
    loadJornadas(): void;
    loadRiesgosPuesto(): void;
    loadPeriodosPago(): void;
    loadTiposContrato(): void;
    onEmpleadoUpdated(info: EmpleadoInfo): void;
    onDeletingDetail(detail: ReciboNominaDetail): void;
    onListItemsUpdated(updatedDetails: ReciboNominaDetail[]): void;
    onSavingDetail(detail: ReciboNominaDetail): void;
    onMenuDetailItemClicked(menu: Menu, args: any): void;
    onSelectedTiposPerDedChanged(args: TipoPerDedItem[]): void;
    createClientID(): number;
}
