"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//moment
var moment = require("moment");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Locales
var recibo_nomina_1 = require("../models/recibo-nomina");
var recibo_nomina_detail_1 = require("../models/recibo-nomina-detail");
var recibo_nomina_service_1 = require("../services/recibo-nomina.service");
var recibos_nominas_detail_editor_1 = require("./parts/recibos-nominas-detail.editor");
var tipos_per_ded_list_component_1 = require("../controls/tipos-per-ded-list.component");
var empleado_service_1 = require("../services/empleado.service");
var compania_service_1 = require("../services/compania.service");
var empresa_service_1 = require("../../accounting/services/empresa.service");
var tipo_regimen_service_1 = require("../../accounting/services/tipo-regimen.service");
var empresa_1 = require("../../accounting/models/empresa");
var tipo_contrato_service_1 = require("../../accounting/services/tipo-contrato.service");
var jornada_service_1 = require("../../accounting/services/jornada.service");
var riesgo_puesto_service_1 = require("../../accounting/services/riesgo-puesto.service");
var periodo_pago_service_1 = require("../../accounting/services/periodo-pago.service");
var RecibosNominasEditor = /** @class */ (function (_super) {
    __extends(RecibosNominasEditor, _super);
    function RecibosNominasEditor(context, router, route, location, formBuilder, documentTypeService, reciboNominaService, empleadoSvc, empresaSvc, companiaSvc, tipoRegimenSvc, tipoContratoSvc, jornadaSvc, riesgoPuestoSvc, periodoPagoSvc) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.reciboNominaService = reciboNominaService;
        _this.empleadoSvc = empleadoSvc;
        _this.empresaSvc = empresaSvc;
        _this.companiaSvc = companiaSvc;
        _this.tipoRegimenSvc = tipoRegimenSvc;
        _this.tipoContratoSvc = tipoContratoSvc;
        _this.jornadaSvc = jornadaSvc;
        _this.riesgoPuestoSvc = riesgoPuestoSvc;
        _this.periodoPagoSvc = periodoPagoSvc;
        _this.reciboNomina = new recibo_nomina_1.ReciboNominaInfo();
        _this.menuDetailItems = [];
        _this.regimenesFiscales = [];
        _this.tiposRegimen = [];
        _this.tiposContrato = [];
        _this.jornadas = [];
        _this.riesgosPuesto = [];
        _this.periodosPago = [];
        _this.tiposNominas = [
            { 'tipo': 'O', 'nombre': 'Ordinaria' },
            { 'tipo': 'E', 'nombre': 'Extraordinaria' }
        ];
        _this.documentForm = formBuilder.group({
            'idEmpleado': [null, controls_1.AztecaValidators.selected],
            'tipoNomina': ['', forms_1.Validators.required],
            'numDiasPago': [0, forms_1.Validators.required],
            'fechaPago': [''],
            'fechaInicialPago': [''],
            'fechaFinalPago': [''],
            'subtotal': [''],
            'descuentos': [''],
            'total': [''],
            'rfc': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'regimenFiscal': ['', forms_1.Validators.required],
            'curp': [''],
            'registroPatronal': ['', forms_1.Validators.required],
            'fechaInicioRelLaboral': [''],
            'sindicalizado': [''],
            'antiguedad': [''],
            'tipoContrato': [''],
            'tipoJornada': [''],
            'tipoRegimen': [''],
            'numEmpleado': ['', forms_1.Validators.required],
            'departamento': [''],
            'puesto': [''],
            'riesgoPuesto': [''],
            'periodicidadPago': [''],
            'banco': [''],
            'cuentaBancaria': [''],
            'claveEntFed': [''],
            'salarioBaseCotApor': [''],
            'salarioDiarioIntegrado': ['']
        });
        return _this;
    }
    RecibosNominasEditor_1 = RecibosNominasEditor;
    Object.defineProperty(RecibosNominasEditor.prototype, "subtotal", {
        get: function () {
            var total = 0;
            this.reciboNomina.details.forEach(function (item) {
                if (item.idPercepcion > 0) {
                    total += item.gravado + item.exento;
                }
                else if (item.idOtroPago > 0) {
                    total += item.importe;
                }
            });
            return wijmo_1.Globalize.formatNumber(total, 'c');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RecibosNominasEditor.prototype, "descuentos", {
        get: function () {
            var total = 0;
            this.reciboNomina.details.forEach(function (item) {
                if (item.idDeducccion > 0) {
                    total += item.importe;
                }
            });
            return wijmo_1.Globalize.formatNumber(total, 'c');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RecibosNominasEditor.prototype, "total", {
        get: function () {
            return wijmo_1.Globalize.formatNumber((wijmo_1.Globalize.parseFloat(this.subtotal, 'c') - wijmo_1.Globalize.parseFloat(this.descuentos, 'c')), 'c');
        },
        enumerable: true,
        configurable: true
    });
    RecibosNominasEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.createMenuDetail();
        setTimeout(function () {
            _this.loadRegimenesFiscales();
            _this.loadTiposRegimen();
            _this.loadJornadas();
            _this.loadRiesgosPuesto();
            _this.loadPeriodosPago();
            _this.loadTiposContrato();
        });
    };
    RecibosNominasEditor.prototype.createMenuDetail = function () {
        var mnuPercepcion = { icon: "glyphicon glyphicon-plus", text: "Percepcion", name: "PERCEPCION", smallText: "Percepcion" };
        var mnuDeduccion = { icon: "glyphicon glyphicon-plus", text: "Deduccion", name: "DEDUCCION", smallText: "Deduccion" };
        var mnuOtroPago = { icon: "glyphicon glyphicon-plus", text: "Otro pago", name: "OTRO_PAGO", smallText: "Otro pago" };
        var mnuHoraExtra = { icon: "glyphicon glyphicon-plus", text: "Hora extra", name: "HORAS_EXTRA", smallText: "Hora extra" };
        var mnuHoraIncapacidad = { icon: "glyphicon glyphicon-plus", text: "Incapacidad", name: "INCAPCIDAD", smallText: "Incapacidad" };
        this.menuDetailItems.push(mnuPercepcion, mnuDeduccion, mnuOtroPago, mnuHoraExtra, mnuHoraIncapacidad);
        this.menuDetailItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    RecibosNominasEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
    };
    RecibosNominasEditor.prototype.onCreatingDocument = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.reciboNominaService.create()
            .then(function (doc) {
            _this.reciboNomina = doc;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecibosNominasEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.reciboNominaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.reciboNomina = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecibosNominasEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.reciboNominaService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.reciboNomina = doc;
            _this.detailsEditor.clientIndexStart = _this.reciboNomina.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecibosNominasEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.reciboNominaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.reciboNomina = doc;
            _this.detailsEditor.clientIndexStart = _this.reciboNomina.details.length;
            if (_this.reciboNomina.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecibosNominasEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.reciboNominaService.update(this.reciboNomina)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.reciboNomina.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.reciboNomina = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecibosNominasEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.reciboNominaService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecibosNominasEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.reciboNominaService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecibosNominasEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.reciboNomina.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    RecibosNominasEditor.prototype.loadRegimenesFiscales = function () {
        var _this = this;
        this.empresaSvc.loadRegimenesFiscales(this.context.app.defaultCompany.identity)
            .then(function (regimenes) {
            _this.regimenesFiscales = regimenes;
            var item = new empresa_1.RegimenFiscalItem();
            item.id = 0;
            item.nombre = "[NINGUNO]";
            item.activo = true;
            item.codigo = '';
            _this.regimenesFiscales.unshift(item);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecibosNominasEditor.prototype.loadTiposRegimen = function () {
        var _this = this;
        this.tipoRegimenSvc.loadCbo()
            .then(function (info) {
            _this.tiposRegimen = info;
        })
            .catch(function (e) { return _this.handleError(e); });
    };
    RecibosNominasEditor.prototype.loadJornadas = function () {
        var _this = this;
        this.jornadaSvc.getJornadaCbo(this.context.app.defaultSite.identity)
            .then(function (info) {
            _this.jornadas = info;
        })
            .catch(function (e) { return _this.handleError(e); });
    };
    RecibosNominasEditor.prototype.loadRiesgosPuesto = function () {
        var _this = this;
        this.riesgoPuestoSvc.getRiesgoPuestoCbo(this.context.app.defaultSite.identity)
            .then(function (info) {
            _this.riesgosPuesto = info;
        })
            .catch(function (e) { return _this.handleError(e); });
    };
    RecibosNominasEditor.prototype.loadPeriodosPago = function () {
        var _this = this;
        this.periodoPagoSvc.loadCbo()
            .then(function (info) {
            _this.periodosPago = info;
        })
            .catch(function (e) { return _this.handleError(e); });
    };
    RecibosNominasEditor.prototype.loadTiposContrato = function () {
        var _this = this;
        this.tipoContratoSvc.loadCbo()
            .then(function (info) {
            _this.tiposContrato = info;
        })
            .catch(function (e) { return _this.handleError(e); });
    };
    ///////////// GENERAL EDITOR /////////////////////////
    RecibosNominasEditor.prototype.onEmpleadoUpdated = function (info) {
        this.empledao = info;
        // Emisor
        if (this.empledao.idCompania > 0) {
            this.reciboNomina.emisor.registroPatronal = this.empledao.compania.registroPatronal;
            this.reciboNomina.emisor.rfc = this.empledao.compania.rfcEmisor;
            this.reciboNomina.emisor.nombre = this.empledao.compania.razonSocial;
            this.reciboNomina.emisor.regimenFiscal = this.empledao.compania.regimenFiscal;
        }
        // Receptor
        this.reciboNomina.receptor.fechaInicioRelLaboral = this.empledao.fechaIngreso;
        this.reciboNomina.receptor.numEmpleado = this.empledao.code;
        this.reciboNomina.receptor.tipoRegimen = this.empledao.idTipoRegimen.toString();
        this.reciboNomina.receptor.departamento = this.empledao.departamento;
        this.reciboNomina.receptor.puesto = this.empledao.puesto;
        this.reciboNomina.receptor.riesgoPuesto = this.empledao.riesgoPuesto;
        this.reciboNomina.receptor.periodicidadPago = this.empledao.periodicidadPago;
        this.reciboNomina.receptor.claveEntFed = this.empledao.claveEntFed;
        this.reciboNomina.receptor.tipoContrato = this.empledao.claveTipoContrato;
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    RecibosNominasEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    RecibosNominasEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.reciboNomina.details = updatedDetails;
    };
    RecibosNominasEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    RecibosNominasEditor.prototype.onMenuDetailItemClicked = function (menu, args) {
        var option = this.menuDetailItems[menu.selectedIndex];
        if (option.name == 'PERCEPCION') {
            this.tipoPerDedList.tipoPerDedSelector = "Percepciones";
            this.tipoPerDedList.titleDialog = "Percepciones";
        }
        else if (option.name == 'DEDUCCION') {
            this.tipoPerDedList.tipoPerDedSelector = "Deducciones";
            this.tipoPerDedList.titleDialog = "Deducciones";
        }
        else if (option.name == 'OTRO_PAGO') {
            this.tipoPerDedList.tipoPerDedSelector = "Otros Pagos";
            this.tipoPerDedList.titleDialog = "Otros Pagos";
        }
        else if (option.name == 'INCAPCIDAD') {
            this.tipoPerDedList.tipoPerDedSelector = "Incapacidades";
        }
        if (option.name != 'HORAS_EXTRA') {
            this.tipoPerDedList.show();
        }
    };
    RecibosNominasEditor.prototype.onSelectedTiposPerDedChanged = function (args) {
        var _this = this;
        args.forEach(function (item) {
            var detail = new recibo_nomina_detail_1.ReciboNominaDetail();
            detail._clientID = _this.createClientID();
            detail.tipo = item.codigo;
            detail.concepto = item.descripcion;
            if (item.tipoTransaccion == "Percepciones") {
                detail.idPercepcion = item.id;
            }
            else if (item.tipoTransaccion == "Deducciones") {
                detail.idDeducccion = item.id;
            }
            else if (item.tipoTransaccion == "Otros Pagos") {
                detail.idOtroPago = item.id;
            }
            else if (item.tipoTransaccion == "Incapacidades") {
                detail.idIncapacidad = item.id;
            }
            detail.gravado = 0;
            detail.exento = 0;
            detail.importe = 0;
            _this.detailsList.updateItem(detail);
        });
    };
    RecibosNominasEditor.prototype.createClientID = function () {
        return parseInt(moment().format("HHmmss"));
    };
    var RecibosNominasEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], RecibosNominasEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", recibos_nominas_detail_editor_1.ReciboNominaDetailEditor)
    ], RecibosNominasEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild(tipos_per_ded_list_component_1.TiposPerDedListComponent),
        __metadata("design:type", tipos_per_ded_list_component_1.TiposPerDedListComponent)
    ], RecibosNominasEditor.prototype, "tipoPerDedList", void 0);
    RecibosNominasEditor = RecibosNominasEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-recibos-nominas-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                  [title]=\"'RecibosNominas'\"\n                                  [document]=\"reciboNomina\"\n                                  [valid]=\"valid\"\n                                  (configureDocument)=\"onConfigureDocument($event)\"\n                                  (creatingDocument)=\"onCreatingDocument()\"\n                                  (viewingDocument)=\"onViewingDocument($event)\"\n                                  (cloningDocument)=\"onCloningDocument($event)\"\n                                  (savingDocument)=\"onSavingDocument($event)\"\n                                  (loadingDocument)=\"onLoadingDocument($event)\"\n                                  (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                  (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-4\">\n                      <azteca-form-field [label]=\"'Empleado:'\">\n                          <rh-empleado-selector formControlName=\"idEmpleado\"\n                                                [(ngModel)]=\"reciboNomina.idEmpleado\"\n                                                (empleadoUpdated)=\"onEmpleadoUpdated($event)\">\n                          </rh-empleado-selector>\n                      </azteca-form-field>\n                  </div>\n\n                  <div class=\"col-12 col-md-4\">\n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-6\">\n                              <azteca-form-field [label]=\"'Tipo n&oacute;mina:'\">\n                                  <az-combobox formControlName=\"tipoNomina\"\n                                               [(ngModel)]=\"reciboNomina.tipoNomina\"\n                                               [items]=\"tiposNominas\"\n                                               [displayMember]=\"'nombre'\"\n                                               [valueMember]=\"'tipo'\">\n                                  </az-combobox>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-6\">\n                              <azteca-form-field [label]=\"'D&iacute;s de Pago:'\">\n                                  <az-input-number formControlName=\"numDiasPago\" [(ngModel)]=\"reciboNomina.numDiasPago\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-4\">\n                      <azteca-form-field [label]=\"'Fecha pago:'\">\n                          <az-input-date formControlName=\"fechaPago\" [(ngModel)]=\"reciboNomina.fechaPago\"></az-input-date>\n                      </azteca-form-field>\n                  </div>\n                  <div class=\"col-12 col-md-4\">\n                      <azteca-form-field [label]=\"'Fecha inicio:'\">\n                          <az-input-date formControlName=\"fechaInicialPago\" [(ngModel)]=\"reciboNomina.fechaInicialPago\"></az-input-date>\n                      </azteca-form-field>\n                  </div>\n                  <div class=\"col-12 col-md-4\">\n                      <azteca-form-field [label]=\"'Fecha final:'\">\n                          <az-input-date formControlName=\"fechaFinalPago\" [(ngModel)]=\"reciboNomina.fechaFinalPago\"></az-input-date>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <az-panel [header]=\"'Importes'\" style=\"font-weight:bold; padding-top:10px; padding-bottom:10px\" type=\"success\">\n                  <div class=\"row\">\n                      <div col-6 col-md-2>\n                          <div class=\"input-group input-group-sm mb-0\">\n                              <div class=\"input-group-prepend\">\n                                  <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 130px\">Subtotal</span>\n                              </div>\n                              <input type=\"text\" formControlName=\"subtotal\" [ngModel]=\"subtotal\" [attr.disabled]=\"true\" class=\"form-control\" aria-label=\"Small\" aria-describedby=\"inputGroup-sizing-sm\" style=\"text-align:right; margin-bottom:0px\" />\n                          </div>\n                      </div>\n                      <div col-6 col-md-2>\n                          <div class=\"input-group input-group-sm mb-0\">\n                              <div class=\"input-group-prepend\">\n                                  <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 130px\">Descuentos</span>\n                              </div>\n                              <input type=\"text\" formControlName=\"descuentos\" [ngModel]=\"descuentos\" [attr.disabled]=\"true\" class=\"form-control\" aria-label=\"Small\" aria-describedby=\"inputGroup-sizing-sm\" style=\"text-align:right\" />\n                          </div>\n                      </div>\n                      <div col-6 col-md-2>\n                          <div class=\"input-group input-group-sm mb-0\">\n                              <div class=\"input-group-prepend\">\n                                  <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 130px\">Total</span>\n                              </div>\n                              <input type=\"text\" formControlName=\"total\" [ngModel]=\"total\" [attr.disabled]=\"true\" class=\"form-control\" aria-label=\"Small\" aria-describedby=\"inputGroup-sizing-sm\" style=\"text-align:right\" />\n                          </div>\n                      </div>\n                  </div>\n              </az-panel>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n\n                          <tab heading=\"Conceptos\" (select)=\"onTabSelected($event)\">\n\n                              <div class=\"btn-group\">\n                                  <wj-menu #menuReciboDetail\n                                           (itemClicked)=\"onMenuDetailItemClicked(menuReciboDetail, $event)\"\n                                           [header]=\"'Agregar'\">\n                                      <wj-menu-item *ngFor=\"let item of menuDetailItems\">\n                                          <div>\n                                              <span [class]=\"item.icon\"></span>\n                                              <b>{{item.text}}</b>\n                                              <br>\n                                              <small><i>{{item.smallText}}</i></small>\n                                          </div>\n                                      </wj-menu-item>\n                                  </wj-menu>\n                              </div>\n\n                              <azteca-editable-list #detailsList\n                                                    [allowNew]=\"false\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    [listItems]=\"reciboNomina.details\"\n                                                    (deletingItem)=\"onDeletingDetail($event)\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'Tipo'\" [binding]=\"'tipo'\" [width]=\"100\" [isReadOnly]=\"false\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Clave'\" [binding]=\"'clave'\" [width]=\"150\" [isReadOnly]=\"false\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Concepto'\" [binding]=\"'concepto'\" [width]=\"'120*'\" [isReadOnly]=\"false\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Gravado'\" [binding]=\"'gravado'\" [width]=\"180\" [isReadOnly]=\"false\" [format]=\"'n2'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Exento'\" [binding]=\"'exento'\" [width]=\"180\" [isReadOnly]=\"false\" [format]=\"'n2'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"180\" [isReadOnly]=\"false\" [format]=\"'n2'\"></azteca-grid-column>\n                              </azteca-editable-list>\n\n                          </tab>\n\n                          <tab heading=\"Emisor\" (select)=\"onTabSelected($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'RFC:'\">\n                                          <az-textbox formControlName=\"rfc\" [(ngModel)]=\"reciboNomina.emisor.rfc\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-8\">\n                                      <azteca-form-field [label]=\"'Nombre:'\">\n                                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"reciboNomina.emisor.nombre\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Regimen Fiscal:'\">\n                                          <az-combobox formControlName=\"regimenFiscal\"\n                                                       [(ngModel)]=\"reciboNomina.emisor.regimenFiscal\"\n                                                       [items]=\"regimenesFiscales\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'CURP:'\">\n                                          <az-textbox formControlName=\"curp\" [(ngModel)]=\"reciboNomina.emisor.curp\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Registro Patronal:'\">\n                                          <az-textbox formControlName=\"registroPatronal\" [(ngModel)]=\"reciboNomina.emisor.registroPatronal\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </tab>\n\n                          <tab heading=\"Receptor\" (select)=\"onTabSelected($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Inicio Relaci&oacute;n Laboral:'\">\n                                          <az-input-date formControlName=\"fechaInicioRelLaboral\" [(ngModel)]=\"reciboNomina.receptor.fechaInicioRelLaboral\"></az-input-date>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <az-checkbox [label]=\"'Sindicalizado'\"\n                                                   formControlName=\"sindicalizado\"\n                                                   [(ngModel)]=\"reciboNomina.receptor.sindicalizado\"></az-checkbox>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Antiguedad:'\">\n                                          <az-textbox formControlName=\"antiguedad\" [(ngModel)]=\"reciboNomina.receptor.antiguedad\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Tipo Contrato:'\">\n                                          <az-combobox formControlName=\"tipoContrato\"\n                                                       [(ngModel)]=\"reciboNomina.receptor.tipoContrato\"\n                                                       [items]=\"tiposContrato\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'codigo'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Tipo Jornada:'\">\n                                          <az-combobox formControlName=\"tipoJornada\"\n                                                       [(ngModel)]=\"reciboNomina.receptor.tipoJornada\"\n                                                       [items]=\"jornadas\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'codigo'\">\n                                          </az-combobox>\n\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Tipo Regimen Contrato:'\">\n                                          <az-combobox formControlName=\"tipoRegimen\"\n                                                       [(ngModel)]=\"reciboNomina.receptor.tipoRegimen\"\n                                                       [items]=\"tiposRegimen\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'codigo'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Num. Empleado:'\">\n                                          <az-textbox formControlName=\"numEmpleado\" [(ngModel)]=\"reciboNomina.receptor.numEmpleado\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Departamento:'\">\n                                          <az-textbox formControlName=\"departamento\" [(ngModel)]=\"reciboNomina.receptor.departamento\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Puesto:'\">\n                                          <az-textbox formControlName=\"puesto\" [(ngModel)]=\"reciboNomina.receptor.puesto\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Riesgo Puesto:'\">\n                                          <az-combobox formControlName=\"riesgoPuesto\"\n                                                       [(ngModel)]=\"reciboNomina.receptor.riesgoPuesto\"\n                                                       [items]=\"riesgosPuesto\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'codigo'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Periodicidad Pago:'\">\n                                          <az-combobox formControlName=\"periodicidadPago\"\n                                                       [(ngModel)]=\"reciboNomina.receptor.periodicidadPago\"\n                                                       [items]=\"periodosPago\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'codigo'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Banco:'\">\n                                          <az-textbox formControlName=\"banco\" [(ngModel)]=\"reciboNomina.receptor.banco\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Cuenta Bancaria:'\">\n                                          <az-textbox formControlName=\"cuentaBancaria\" [(ngModel)]=\"reciboNomina.receptor.cuentaBancaria\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Clave Entidad Federal:'\">\n                                          <az-textbox formControlName=\"claveEntFed\" [(ngModel)]=\"reciboNomina.receptor.claveEntFed\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Salario Base Cotizaci&oacute;n Aportaci&oacute;n:'\">\n                                          <az-input-number formControlName=\"salarioBaseCotApor\" [(ngModel)]=\"reciboNomina.receptor.salarioBaseCotApor\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Salario Diario Integrado:'\">\n                                          <az-input-number formControlName=\"salarioDiarioIntegrado\" [(ngModel)]=\"reciboNomina.receptor.salarioDiarioIntegrado\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </tab>\n\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"reciboNomina.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <rh-recibo-nomina-detail-editor #detailsEditor                                     \n                                      (savingItem)=\"onSavingDetail($event)\">\n\n      </rh-recibo-nomina-detail-editor>\n\n      <rh-tipos-per-ded-list (selectedItemsChanged)=\"onSelectedTiposPerDedChanged($event)\"\n                             [multiSelect]=\"true\">\n      </rh-tipos-per-ded-list>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return RecibosNominasEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: recibo_nomina_service_1.ReciboNominaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            recibo_nomina_service_1.ReciboNominaService,
            empleado_service_1.EmpleadoService,
            empresa_service_1.EmpresaService,
            compania_service_1.CompaniaService,
            tipo_regimen_service_1.TipoRegimenService,
            tipo_contrato_service_1.TipoContratoService,
            jornada_service_1.JornadaService,
            riesgo_puesto_service_1.RiesgoPuestoService,
            periodo_pago_service_1.PeriodoPagoService])
    ], RecibosNominasEditor);
    return RecibosNominasEditor;
}(editors_1.DocumentEditor));
exports.RecibosNominasEditor = RecibosNominasEditor;
