import { Router, ActivatedRoute } from '@angular/router';
import { Context, DocumentItem } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { MenuItem } from 'framework3/controls';
import { ContentViewerComponent } from 'framework3/controls/components/content-viewer.component';
import { ReciboNominaItem } from '../models/recibo-nomina';
import { ReciboNominaService } from '../services/recibo-nomina.service';
export declare class RecibosNominasManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private reciboNominaService;
    recibosNominas: ReciboNominaItem[];
    reportViewer: ContentViewerComponent;
    titleContentView: string;
    fileNameContentView: string;
    constructor(context: Context, router: Router, route: ActivatedRoute, reciboNominaService: ReciboNominaService);
    onConfigureDocument(): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onMenuItemClick(option: MenuItem): void;
}
