"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var moment = require("moment");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var content_viewer_component_1 = require("framework3/controls/components/content-viewer.component");
var recibo_nomina_service_1 = require("../services/recibo-nomina.service");
var RecibosNominasManager = /** @class */ (function (_super) {
    __extends(RecibosNominasManager, _super);
    function RecibosNominasManager(context, router, route, reciboNominaService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.reciboNominaService = reciboNominaService;
        _this.titleContentView = "";
        _this.fileNameContentView = "";
        return _this;
    }
    RecibosNominasManager_1 = RecibosNominasManager;
    RecibosNominasManager.prototype.onConfigureDocument = function () {
        this.refreshList();
        this.applyPolicies();
    };
    RecibosNominasManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.reciboNominaService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.recibosNominas = response.rows;
            _this.recibosNominas.forEach(function (item) {
                item.fechaPago = moment(item.fechaPago).toDate();
            });
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecibosNominasManager.prototype.onAddingItem = function () {
        this.router.navigate(['0'], { relativeTo: this.route });
    };
    RecibosNominasManager.prototype.onViewingItem = function (document) {
        this.router.navigate([document.id, { readonly: true }], { relativeTo: this.route });
    };
    RecibosNominasManager.prototype.onEditingItem = function (document) {
        this.router.navigate([document.id], { relativeTo: this.route });
    };
    RecibosNominasManager.prototype.onDeletingItem = function (document) {
        var _this = this;
        this.reciboNominaService.delete(document.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El documento ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecibosNominasManager.prototype.onCloningItem = function (document) {
        this.router.navigate([0, { cloneId: document.id }], { relativeTo: this.route });
    };
    RecibosNominasManager.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.reciboNominaService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecibosNominasManager.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.reciboNominaService.previousStep(document.id, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecibosNominasManager.prototype.onMenuItemClick = function (option) {
        var _this = this;
        if (option.name == 'PRINT') {
            this.context.app.showSpinner();
            this.reciboNominaService.printReciboPdf(this.manager.currentDocument.id)
                .then(function (report) {
                var item = _this.manager.currentDocument;
                _this.context.app.hideSpinner();
                _this.titleContentView = "Recibo " + item.id;
                _this.fileNameContentView = item.id + ".pdf";
                _this.reportViewer.show("data:application/pdf; base64, " + report);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == 'DOWNLOAD') {
            this.context.app.showSpinner();
            this.reciboNominaService.loadReciboXml(this.manager.currentDocument.id)
                .then(function (response) {
                var item = _this.manager.currentDocument;
                _this.titleContentView = "Recibo " + item.id;
                _this.fileNameContentView = item.id + ".xml";
                _this.reportViewer.show("data:text/xml, " + response);
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    var RecibosNominasManager_1;
    __decorate([
        core_1.ViewChild(content_viewer_component_1.ContentViewerComponent),
        __metadata("design:type", content_viewer_component_1.ContentViewerComponent)
    ], RecibosNominasManager.prototype, "reportViewer", void 0);
    RecibosNominasManager = RecibosNominasManager_1 = __decorate([
        core_1.Component({
            selector: 'rh-recibos-nominas-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">RecibosNominas</div>\n          <div class=\"card-block\">\n              <azteca-document-manager (searchRequested)=\"onSearchRequested($event)\"\n                                       (addingItem)=\"onAddingItem()\"\n                                       (viewingItem)=\"onViewingItem($event)\"\n                                       (editingItem)=\"onEditingItem($event)\"\n                                       (deletingItem)=\"onDeletingItem($event)\"\n                                       (cloningItem)=\"onCloningItem($event)\"\n                                       (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                       (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                       (configureDocument)=\"onConfigureDocument($event)\"\n                                       (menuItemClick)=\"onMenuItemClick($event)\"\n                                       [enabled]=\"enabled\"\n                                       [allowNew]=\"allowNew\"\n                                       [allowView]=\"allowView\"\n                                       [allowEdit]=\"allowEdit\"\n                                       [allowDelete]=\"allowDelete\"\n                                       [allowClone]=\"allowClone\"\n                                       [allowNext]=\"allowNext\"\n                                       [allowPrevious]=\"allowPrevious\"\n                                       [allowAudit]=\"allowAudit\"\n                                       [filterGroups]=\"filterGroups\"\n                                       [documentList]=\"recibosNominas\">\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'PRINT'\" [icon]=\"'glyphicon glyphicon-print'\" [text]=\"'Imprimir'\" [smallText]=\"'impresi\u00F3n de comprobante'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'DOWNLOAD'\" [icon]=\"'glyphicon glyphicon-download-alt'\" [text]=\"'Descargar'\" [smallText]=\"'descarga de comprobante'\"></azteca-menu-item>\n\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"160\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"120\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Num. Empleado'\" [binding]=\"'numTrabajador'\" [width]=\"100\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Empleado'\" [binding]=\"'empleado'\" [width]=\"220\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha Pago'\" [binding]=\"'fechaPago'\" [width]=\"100\" dataType=\"Date\" format=\"dd-MM-yyyy\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'D\u00EDas Pago'\" [binding]=\"'numDiasPago'\" [width]=\"80\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Nomina'\" [binding]=\"'tipoNomina'\" [width]=\"140\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"100\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"120\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Estatus'\" [binding]=\"'status'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"'10*'\"></azteca-grid-column>\n\n              </azteca-document-manager>\n          </div>\n      </div>\n\n      <azteca-content-viewer [title]=\"titleContentView\" [fileName]=\"fileNameContentView\"></azteca-content-viewer>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return RecibosNominasManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: recibo_nomina_service_1.ReciboNominaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, recibo_nomina_service_1.ReciboNominaService])
    ], RecibosNominasManager);
    return RecibosNominasManager;
}(editors_1.DocumentManager));
exports.RecibosNominasManager = RecibosNominasManager;
