import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormControl } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { SolicitudVacacionalInfo } from '../models/solicitud-vacacional';
import { SolicitudVacacionalDetail } from '../models/solicitud-vacacional-detail';
import { SolicitudVacacionalService } from '../services/solicitud-vacacional.service';
import { SolicitudVacacionalDetailEditor } from './parts/solicitudes-vacacionales-detail.editor';
import { PeriodoVacacionalService } from '../services/periodo-vacacional.service';
import { EmpleadoInfo } from '../models/empleado';
export declare class SolicitudesVacacionalesEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private solicitudVacacionalService;
    private periodoVacacionalService;
    solicitudVacacional: SolicitudVacacionalInfo;
    loadingDocument: boolean;
    idBorrador: number;
    empleadoCurrent: EmpleadoInfo;
    detailsList: EditableListComponent;
    detailsEditor: SolicitudVacacionalDetailEditor;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, solicitudVacacionalService: SolicitudVacacionalService, periodoVacacionalService: PeriodoVacacionalService);
    validateFecha(control: FormControl): string;
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: SolicitudVacacionalDetail): void;
    onDeletingDetail(detail: SolicitudVacacionalDetail): void;
    onListItemsUpdated(updatedDetails: SolicitudVacacionalDetail[]): void;
    onSavingDetail(detail: SolicitudVacacionalDetail): void;
    onEmpleadoUpdated(empleado: EmpleadoInfo): void;
    onFechaChanged(value: Date): void;
    validateDetail(): Promise<boolean>;
    checkDetails(): boolean;
    reset(): void;
}
