"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var core_2 = require("framework3/core");
//Azteca Kernel
var core_3 = require("framework3/core");
var controls_1 = require("framework3/controls");
var search_1 = require("framework3/search");
//Features
var finiquito_autorizacion_service_1 = require("../services/finiquito-autorizacion.service");
var AutorizacionFiniquitoMaintenance = /** @class */ (function (_super) {
    __extends(AutorizacionFiniquitoMaintenance, _super);
    function AutorizacionFiniquitoMaintenance(context, formBuilder, router, route, finiquitoAutorizacionService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.finiquitoAutorizacionService = finiquitoAutorizacionService;
        _this.currentItems = new Array();
        _this.totalRows = 0;
        _this.pageIndex = 0;
        _this.menuItems = [];
        _this.editorForm = formBuilder.group({
            '': []
        });
        return _this;
    }
    AutorizacionFiniquitoMaintenance.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) {
            _this.refreshList();
        });
        this.createMenu();
        this.refreshList();
    };
    AutorizacionFiniquitoMaintenance.prototype.createMenu = function () {
        var mnuEditar = { icon: "glyphicon glyphicon-repeat", text: "Editar", name: "EDITAR", smallText: "Editar autorizaci&oacute;n" };
        var mnuEliminar = { icon: "glyphicon glyphicon-remove-alt", text: "Eliminar", name: "ELIMINAR", smallText: "Eliminar autorizaci&oacute;n" };
        this.menuItems.push(mnuEditar, mnuEliminar);
        this.menuItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    AutorizacionFiniquitoMaintenance.prototype.refreshList = function () {
        var _this = this;
        this.context.app.showSpinner();
        if (this.request == null) {
            this.request = new search_1.SearchRequest();
            this.request.pageIndex = 0;
            this.request.pageSize = 20;
            this.request.paged = false;
        }
        this.finiquitoAutorizacionService.searchFiniquitAutorizacion(this.context.app.defaultSite.identity, this.request)
            .then(function (response) {
            _this.currentItems = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = _this.request.pageIndex;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AutorizacionFiniquitoMaintenance.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    AutorizacionFiniquitoMaintenance.prototype.searchRequested = function (request) {
        this.request = request;
        this.refreshList();
    };
    AutorizacionFiniquitoMaintenance.prototype.optionClick = function (option) {
        var _this = this;
        if (option.name == "EDITAR") {
            this.router.navigate(['rh/finiquito-autorizacion/autorizacion', this.process.id, this.currentItem.data.idFiniquitoAutorizacion]);
        }
        else if (option.name == "ELIMINAR") {
            this.finiquitoAutorizacionService.delete(this.currentItem.data.idFiniquitoAutorizacion)
                .then(function (response) {
                _this.refreshList();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    AutorizacionFiniquitoMaintenance.prototype.showAlert = function (message, type) {
        this.context.app.hideSpinner();
        this.alerts.showAlert(message, type);
    };
    AutorizacionFiniquitoMaintenance.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    AutorizacionFiniquitoMaintenance.prototype.applyPolicy = function (policy) {
    };
    AutorizacionFiniquitoMaintenance.prototype.onAgregar = function () {
        this.router.navigate(['rh/finiquito-autorizacion/autorizacion', this.process.id, 0]);
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], AutorizacionFiniquitoMaintenance.prototype, "alerts", void 0);
    AutorizacionFiniquitoMaintenance = __decorate([
        core_1.Component({
            selector: 'autorizacion-finiquito',
            template: "\n      <div class=\"row justify-content-center\">\n          <div class=\"col-12 col-md-10 col-lg-8\">\n              <form [formGroup]=\"editorForm\">\n\n                  <alerts-bar></alerts-bar>\n\n                  <az-panel [header]=\"'Autorizaciones Finiquitio'\">\n                \n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAgregar()\">Agregar</button>\n\n                      <azteca-catalog-list [catalogList]=\"currentItems\"\n                                           [showRowButton]=\"false\"\n                                           [showStatusColumn]=\"false\"\n                                           (currentItemChanged)=\"onCurrentItemChanged($event)\"\n                                           (searchRequested)=\"searchRequested($event)\"\n                                           (contextMenuClick)=\"optionClick($event)\"\n                                           [enabled]=\"true\"\n                                           [pageSize]=\"100\"\n                                           [serverSide]=\"false\"\n                                           [totalRows]=\"totalRows\"\n                                           [pageIndex]=\"pageIndex\">\n\n                          <!-- Mapear opciones de men\u00FA de componente padre-->\n                          <azteca-menu-item *ngFor=\"let item of menuItems\" [name]=\"item.name\" [icon]=\"item.icon\" [text]=\"item.text\" [smallText]=\"item.smallText\" [enabled]=\"item.enabled\"></azteca-menu-item>\n                          <azteca-grid-column [header]=\"'Compania'\" [binding]=\"'compania'\" [width]=\"300\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Clase Nomina'\" [binding]=\"'claseNomina'\" [width]=\"180\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Elabora'\" [binding]=\"'elabora'\" [width]=\"220\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Autoriza'\" [binding]=\"'autoriza'\" [width]=\"220\"></azteca-grid-column>\n                      </azteca-catalog-list>\n\n                  </az-panel>\n              </form>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [core_3.Context, forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute, finiquito_autorizacion_service_1.FiniquitoAutorizacionService])
    ], AutorizacionFiniquitoMaintenance);
    return AutorizacionFiniquitoMaintenance;
}(core_2.ProcessComponent));
exports.AutorizacionFiniquitoMaintenance = AutorizacionFiniquitoMaintenance;
