"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
// moment
var moment = require("moment");
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
// Wijmo
var wjcCore = require("wijmo/wijmo");
var checador_service_1 = require("../services/checador.service");
var motivo_service_1 = require("../services/motivo.service");
var modal_directive_1 = require("ngx-bootstrap/modal/modal.directive");
var ChecadaEmpleadoMaintenance = /** @class */ (function (_super) {
    __extends(ChecadaEmpleadoMaintenance, _super);
    function ChecadaEmpleadoMaintenance(context, router, route, location, formBuilder, checadorSvc, motivoSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.checadorSvc = checadorSvc;
        _this.motivoSvc = motivoSvc;
        _this.idEmpleado = 0;
        _this.fechaIni = new Date();
        _this.fechaFin = new Date();
        _this.valid = false;
        _this.widthClass = [];
        _this.cvTransacciones = new wjcCore.CollectionView();
        _this.eliminadas = [];
        _this.motivos = [];
        _this.menuChecadaItems = [];
        // 
        _this.idMotivo = 0;
        _this.fecha = new Date();
        _this.hora = new Date();
        _this.form = formBuilder.group({
            'idEmpleado': [null, controls_1.AztecaValidators.selected],
            'fechaIni': [null, forms_1.Validators.required],
            'fechaFin': [null, forms_1.Validators.required]
        });
        _this.formChecada = formBuilder.group({
            'idMotivo': ['', controls_1.AztecaValidators.selected],
            'fecha': [null, forms_1.Validators.required],
            'hora': [null, forms_1.Validators.required]
        });
        _this.cvTransacciones.sourceCollection = [];
        return _this;
    }
    ChecadaEmpleadoMaintenance.prototype.ngOnInit = function () {
        var _this = this;
        //Establecer el ancho establecido para la aplicación
        this.widthClass.push(this.context.app.defaultWidth);
        setTimeout(function () {
            _this.motivoSvc.loadCbo(_this.context.app.defaultSite.identity)
                .then(function (info) {
                _this.motivos = info;
                _this.motivos.unshift({ id: 0, codigo: '', nombre: '[Seleccione un motivo]', Descripcion: '' });
            })
                .catch(function (error) { return _this.handleError(error); });
        });
    };
    ChecadaEmpleadoMaintenance.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (!this.form)
            return;
        setTimeout(function (_) {
            _this.fechaIni = moment().subtract(16, 'day').toDate();
            _this.fechaFin = moment().subtract(1, 'day').toDate();
            _this.createMenuDetail();
        });
        this.form.statusChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.changeState(); });
        });
    };
    ChecadaEmpleadoMaintenance.prototype.changeState = function () {
        this.valid = this.form.valid;
    };
    ChecadaEmpleadoMaintenance.prototype.createMenuDetail = function () {
        var mnuQuitar = { icon: "glyphicon glyphicon-remove", text: "Eliminar", name: "QUITAR", smallText: "eliminar checada" };
        this.menuChecadaItems.push(mnuQuitar);
        this.menuChecadaItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    ////////////////////////////////////////////////////////
    ChecadaEmpleadoMaintenance.prototype.onClickGuardar = function () {
        var _this = this;
        this.context.app.showSpinner();
        var items = this.cvTransacciones.items;
        var transacciones = items.concat(this.eliminadas);
        this.checadorSvc.updateTransaccionesEmpleado(transacciones)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.onClickActualizar();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ChecadaEmpleadoMaintenance.prototype.onClickGuardarProcesar = function () {
        var _this = this;
        this.context.app.showSpinner();
        var items = this.cvTransacciones.items;
        var transacciones = items.concat(this.eliminadas);
        this.checadorSvc.procesarTransaccionesEmpleado(transacciones)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.onClickActualizar();
            _this.alerts.showAlert('Se agrego la tarea para procesar las checadas', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ChecadaEmpleadoMaintenance.prototype.onClickCerrar = function () {
        this.location.back();
    };
    ChecadaEmpleadoMaintenance.prototype.onClickActualizar = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.checadorSvc.getTransaccionesEmpleado(this.fechaIni, this.fechaFin, this.idEmpleado)
            .then(function (result) {
            _this.eliminadas = [];
            _this.cvTransacciones.sourceCollection = result.filter(function (check) { return check.manual == true; });
            _this.cvTransacciones.refresh();
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ChecadaEmpleadoMaintenance.prototype.onClickAgregar = function () {
        this.idMotivo = 0;
        this.fecha = new Date();
        this.hora = new Date();
        this.dlgChecada.config.backdrop = false;
        this.dlgChecada.show();
    };
    ChecadaEmpleadoMaintenance.prototype.onClickMnuChecada = function (menu) {
        var option = this.menuChecadaItems[menu.selectedIndex];
        if (option.name == "QUITAR") {
            var item = this.cvTransacciones.currentItem;
            if (item) {
                item.state = core_2.ChangeState.DELETED;
                this.cvTransacciones.remove(item);
                this.eliminadas.push(item);
            }
        }
    };
    ChecadaEmpleadoMaintenance.prototype.onClickChecadaAceptar = function () {
        this.context.app.showSpinner();
        var transaccion = this.cvTransacciones.addNew();
        transaccion.idEmpleado = this.idEmpleado;
        transaccion.fecha = this.hora;
        transaccion.idMotivo = this.idMotivo;
        transaccion.manual = true;
        transaccion.usuario = this.context.session.user.code;
        transaccion.state = core_2.ChangeState.ADDED;
        this.cvTransacciones.commitNew();
        this.dlgChecada.hide();
        this.context.app.hideSpinner();
    };
    ////////////////////////////////////////////////////////
    ChecadaEmpleadoMaintenance.prototype.applyPolicy = function (policy) {
        throw new Error("Method not implemented.");
    };
    ChecadaEmpleadoMaintenance.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ChecadaEmpleadoMaintenance.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('dlgChecada'),
        __metadata("design:type", modal_directive_1.ModalDirective)
    ], ChecadaEmpleadoMaintenance.prototype, "dlgChecada", void 0);
    ChecadaEmpleadoMaintenance = __decorate([
        core_1.Component({
            selector: 'rh-checada-empleado',
            template: "\n      <form [formGroup]=\"form\">\n          <div class=\"row\">\n              <div [ngClass]=\"widthClass\">\n\n                  <az-panel [header]=\"'Asignaci\u00F3n de periodos temporales de trabajo'\">\n\n                      <!--Barra de alertas-->\n                      <alerts-bar></alerts-bar>\n\n                      <!--Toolbar-->\n                      <div class=\"btn-group\">\n                          <button type=\"submit\" class=\"btn btn-primary\" (click)=\"onClickGuardar()\">\n                              <span class=\"glyphicon glyphicon-floppy-disk\" aria-hidden=\"true\"></span> Guardar\n                          </button>\n\n                          <!--En dispositivos peque\u00F1os se mostrar\u00E1 un bot\u00F3n con el \u00EDcono de cerrar, en dispositivos grandes se mostrar\u00E1 con texto-->\n                          <button type=\"button\" class=\"btn btn-default d-none d-lg-block cancel-win\" (click)=\"onClickGuardarProcesar()\">\n                              <span class=\"glyphicon glyphicon-retweet\" aria-hidden=\"true\"></span> Guradar y Procesar\n                          </button>\n\n                          <!--En dispositivos peque\u00F1os se mostrar\u00E1 un bot\u00F3n con el \u00EDcono de cerrar, en dispositivos grandes se mostrar\u00E1 con texto-->\n                          <button type=\"button\" class=\"btn btn-default d-none d-lg-block cancel-win\" (click)=\"onClickCerrar()\">\n                              <span class=\"glyphicon glyphicon-remove\" aria-hidden=\"true\"></span> Cerrar\n                          </button>\n                      </div>\n\n                      <!--Controles del formulario-->\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Empleado:'\">\n                                  <rh-empleado-selector formControlName=\"idEmpleado\"\n                                                        [(ngModel)]=\"idEmpleado\">\n                                  </rh-empleado-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Fecha Incio:'\">\n                                  <az-input-date formControlName=\"fechaIni\"\n                                                 [(ngModel)]=\"fechaIni\">\n                                  </az-input-date>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Fecha Fin:'\">\n                                  <az-input-date formControlName=\"fechaFin\"\n                                                 [(ngModel)]=\"fechaFin\">\n                                  </az-input-date>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"btn-group\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickActualizar()\" [disabled]=\"!valid\">\n                              <span aria-hidden=\"true\" class=\"glyphicon glyphicon-refresh\"></span>\n                              Consultar\n                          </button>\n\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickAgregar()\" [disabled]=\"!valid\">\n                              <span aria-hidden=\"true\" class=\"glyphicon glyphicon-plus\"></span>\n                              Agregar\n                          </button>\n                      </div>\n\n                      <wj-flex-grid style=\"height:500px\"\n                                    [itemsSource]=\"cvTransacciones\"\n                                    [selectionMode]=\"'Row'\"\n                                    [wjContextMenu]=\"ctxMenuChecada\">\n                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                          <wj-flex-grid-column [header]=\"'Fecha'\" [binding]=\"'fecha'\" [width]=\"180\" [format]=\"'dddd, dd MMMM yyyy'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Hora'\" [binding]=\"'fecha'\" [width]=\"60\" [format]=\"'HH:mm'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Checador'\" [binding]=\"'checador.nombre'\" [width]=\"'120*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Manual'\" [binding]=\"'manual'\" [width]=\"50\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Usuario'\" [binding]=\"'usuario'\" [width]=\"140\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      </wj-flex-grid>\n\n                  </az-panel>\n              </div>\n          </div>\n      </form>\n\n      <wj-menu #ctxMenuChecada (itemClicked)=\"onClickMnuChecada(ctxMenuChecada)\" style=\"display:none\">\n          <wj-menu-item *ngFor=\"let item of menuChecadaItems\">\n              <div *ngIf=\"item.enabled\">\n                  <span [class]=\"item.icon\"></span>\n                  <b>{{item.text}}</b>\n                  <br>\n                  <small><i>{{item.smallText}}</i></small>\n              </div>\n          </wj-menu-item>\n      </wj-menu>\n\n\n      <!--DIALOGO FOLIO OBSERVACIOINES-->\n      <div bsModal #dlgChecada=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\" role=\"document\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\" id=\"exampleModalLabel\">Agregar checada</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"dlgChecada.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <form [formGroup]=\"formChecada\">\n                          <div class=\"row\">\n                              <div class=\"col\">\n                                  <azteca-form-field [label]=\"'Motivo:'\">\n                                      <az-combobox formControlName=\"idMotivo\"\n                                                   [(ngModel)]=\"idMotivo\"\n                                                   [items]=\"motivos\"\n                                                   [displayMember]=\"'nombre'\"\n                                                   [valueMember]=\"'id'\">\n                                      </az-combobox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col\">\n                                  <azteca-form-field [label]=\"'Fecha:'\">\n                                      <az-input-date formControlName=\"fecha\"\n                                                     [(ngModel)]=\"hora\">\n                                      </az-input-date>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col\">\n                                  <azteca-form-field [label]=\"'Hora:'\">\n                                      <az-input-time formControlName=\"hora\"\n                                                     [format]=\"'HH:mm'\"\n                                                     [(ngModel)]=\"hora\">\n                                      </az-input-time>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                      </form>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickChecadaAceptar()\" [disabled]=\"!formChecada.valid\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dlgChecada.hide()\">Cancelar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            checador_service_1.ChecadorService,
            motivo_service_1.MotivoService])
    ], ChecadaEmpleadoMaintenance);
    return ChecadaEmpleadoMaintenance;
}(core_2.ProcessComponent));
exports.ChecadaEmpleadoMaintenance = ChecadaEmpleadoMaintenance;
