import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { Menu } from "wijmo/wijmo.input";
import { FormGroup, FormBuilder } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap/modal/modal.directive';
import { CellRangeEventArgs, DataMap } from 'wijmo/wijmo.grid';
import * as wjcCore from 'wijmo/wijmo';
import { AlertsBarComponent, MenuItem } from "framework3/controls";
import { Context, ProcessComponent, PolicyInfo } from 'framework3/core';
import { EmpleadoListComponent } from '../controls/empleado-list.component';
import { ChecadorListComponent } from '../controls/checadores-list.component';
import { ChecadorUsuarioIten, ChecadorItem } from '../models/checador';
import { ChecadorService } from '../services/checador.service';
export declare class ChecadorUsuarioMaintenance extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    private checadorSvc;
    formUsuario: FormGroup;
    formPasswd: FormGroup;
    labelChecador: string;
    identity: number;
    usuario: ChecadorUsuarioIten;
    userContrasena: string;
    cvUsuarios: wjcCore.CollectionView;
    tipoUsuarioMap: DataMap;
    items: ChecadorUsuarioIten[];
    widthClass: string[];
    mnuEmpleadoItems: MenuItem[];
    checadoresExclude: ChecadorItem[];
    selEmpleado: EmpleadoListComponent;
    checadoresList: ChecadorListComponent;
    tipoUsuario: {
        'value': number;
        'name': string;
    }[];
    alertsBar: AlertsBarComponent;
    dlgUsuario: ModalDirective;
    dlgPasswd: ModalDirective;
    dlgConfirmacion: ModalDirective;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, checadorSvc: ChecadorService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    createMenuDetail(): void;
    onLoadingItem(id: number): void;
    getDetail(): void;
    onClickActualizar(): void;
    onClickGuardar(): void;
    onConfirm(sincronizarChecador: boolean): void;
    onSelectedEmleado(item: any): void;
    onSelectedChecador(item: any): void;
    onCellUpdated(args: CellRangeEventArgs): void;
    onClickMnuEmpleado(menu: Menu): void;
    exportFingers(idChecador: number): void;
    onClickUsuarioAceptar(): void;
    onClickPasswdAceptar(): void;
    handleError(error: any): void;
    applyPolicy(policy: PolicyInfo): void;
    cloneInfo<T>(element: any): T;
    onClickKardexSelect(): void;
}
