"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
//Bootstrap
var modal_directive_1 = require("ngx-bootstrap/modal/modal.directive");
//wijmo
var wijmo_grid_1 = require("wijmo/wijmo.grid");
var wjcCore = require("wijmo/wijmo");
//frmework
var controls_1 = require("framework3/controls");
var core_2 = require("framework3/core");
//Controls
var empleado_list_component_1 = require("../controls/empleado-list.component");
var checadores_list_component_1 = require("../controls/checadores-list.component");
//Features
var checador_1 = require("../models/checador");
var checador_service_1 = require("../services/checador.service");
var ChecadorUsuarioMaintenance = /** @class */ (function (_super) {
    __extends(ChecadorUsuarioMaintenance, _super);
    function ChecadorUsuarioMaintenance(context, router, route, location, formBuilder, checadorSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.checadorSvc = checadorSvc;
        _this.labelChecador = "Administrador de empleados en checador";
        _this.usuario = new checador_1.ChecadorUsuarioIten();
        _this.userContrasena = "";
        _this.cvUsuarios = new wjcCore.CollectionView();
        _this.items = [];
        _this.widthClass = [];
        _this.mnuEmpleadoItems = [];
        _this.tipoUsuario = [
            { 'value': 1, 'name': 'Grabador' },
            { 'value': 2, 'name': 'Administrador' },
            { 'value': 3, 'name': 'Supervisor' },
            { 'value': 0, 'name': 'Normal' }
        ];
        _this.tipoUsuarioMap = new wijmo_grid_1.DataMap(_this.tipoUsuario, 'value', 'name');
        _this.formUsuario = _this.formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'tipoUsuario': [0],
            'contrasena': ['']
        });
        _this.formPasswd = _this.formBuilder.group({
            'userContrasena': ['', forms_1.Validators.required],
        });
        return _this;
    }
    ChecadorUsuarioMaintenance.prototype.ngOnInit = function () {
        //Establecer el ancho establecido para la aplicación
        this.widthClass.push(this.context.app.defaultWidth);
    };
    ChecadorUsuarioMaintenance.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) {
            _this.route.params.forEach(function (params) {
                _this.identity = +params['id'];
            });
            _this.onLoadingItem(_this.identity);
            _this.createMenuDetail();
        });
    };
    ChecadorUsuarioMaintenance.prototype.createMenuDetail = function () {
        var mnuAsignar = { icon: "glyphicon glyphicon-user", text: "Asignar empleado", name: "ALLOCATE", smallText: "asignar empleado" };
        var mnuImportar = { icon: "glyphicon glyphicon-download-alt", text: "Importar usuario seleccionado", name: "IMPORT_USR", smallText: "importar usuario" };
        var mnuNuevo = { icon: "glyphicon glyphicon-plus", text: "Importar usuarios nuevos", name: "IMPORT_NEW", smallText: "importar nuevos" };
        var mnuImportHuella = { icon: "glyphicon glyphicon-download", text: "Importar huellas", name: "IMPORT_FINGER", smallText: "importar huellas" };
        var mnuExportHuella = { icon: "glyphicon glyphicon-upload", text: "Exportar huellas", name: "EXPORT_FINGER", smallText: "importar huellas" };
        var mnuAgregar = { icon: "glyphicon glyphicon-plus", text: "Agregar usuario", name: "ADD_USER", smallText: "agregar usuario" };
        var mnuEliminar = { icon: "glyphicon glyphicon-remove", text: "Eliminar usuario", name: "DELETE_USER", smallText: "eliminar usuario" };
        var mnuPasswdEliminar = { icon: "glyphicon glyphicon-remove-circle", text: "Eliminar password", name: "DELETE_PASSWD", smallText: "Eliminar password" };
        var mnuPasswdUpdate = { icon: "glyphicon glyphicon-refresh", text: "Establecer password", name: "UPDATE_PASSWD", smallText: "Establecer password" };
        this.mnuEmpleadoItems.push(mnuAsignar, mnuImportar, mnuNuevo, mnuImportHuella, mnuExportHuella, mnuAgregar, mnuEliminar, mnuPasswdEliminar, mnuPasswdUpdate);
        this.mnuEmpleadoItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    ChecadorUsuarioMaintenance.prototype.onLoadingItem = function (id) {
        var _this = this;
        if (id && id > 0) {
            this.context.app.showSpinner();
            this.checadorSvc.importUsers(id)
                .then(function (items) {
                _this.items = items;
                //Si el empleado no tiene id es porque no esta en base de datos, asi que lo marcamos como añadido para cuando se quiere guardar
                _this.items.filter(function (item) { return item.id == 0; }).forEach(function (item) {
                    item.state = core_2.ChangeState.ADDED;
                });
                _this.cvUsuarios.sourceCollection = _this.items;
                _this.getDetail();
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    ChecadorUsuarioMaintenance.prototype.getDetail = function () {
        var _this = this;
        this.checadorSvc.getDetailByID(this.identity)
            .then(function (info) {
            _this.labelChecador = "Administrador de empleados en checador: " + info.nombre;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////////////// METODOS ///////////////////////////////////////
    ChecadorUsuarioMaintenance.prototype.onClickActualizar = function () {
        this.onLoadingItem(this.identity);
    };
    ChecadorUsuarioMaintenance.prototype.onClickGuardar = function () {
        this.dlgConfirmacion.config.backdrop = false;
        this.dlgConfirmacion.show();
    };
    ChecadorUsuarioMaintenance.prototype.onConfirm = function (sincronizarChecador) {
        var _this = this;
        this.context.app.showSpinner();
        var itemsUpdated = [];
        itemsUpdated = this.items.filter(function (item) { return item.state != core_2.ChangeState.UNCHANGED; });
        this.checadorSvc.exportUsers(this.identity, itemsUpdated, sincronizarChecador)
            .then(function (items) {
            _this.context.app.hideSpinner();
            _this.items = items;
            _this.cvUsuarios.sourceCollection = _this.items;
            _this.cvUsuarios.refresh();
            _this.dlgConfirmacion.hide();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ChecadorUsuarioMaintenance.prototype.onSelectedEmleado = function (item) {
        var currentItem = this.cvUsuarios.currentItem;
        if (currentItem) {
            this.cvUsuarios.editItem(currentItem);
            currentItem.idEmpleado = item.id;
            currentItem.empleado = item.data;
            currentItem.state = core_2.ChangeState.MODIFIED;
            this.cvUsuarios.commitEdit();
        }
    };
    ChecadorUsuarioMaintenance.prototype.onSelectedChecador = function (item) {
        var currentItem = this.cvUsuarios.currentItem;
        if (currentItem) {
            this.exportFingers(item.id);
        }
    };
    ChecadorUsuarioMaintenance.prototype.onCellUpdated = function (args) {
        var currentItem = this.cvUsuarios.currentItem;
        currentItem.state = core_2.ChangeState.MODIFIED;
        this.cvUsuarios.commitEdit();
    };
    ChecadorUsuarioMaintenance.prototype.onClickMnuEmpleado = function (menu) {
        var _this = this;
        var option = this.mnuEmpleadoItems[menu.selectedIndex];
        if (option.name == "ALLOCATE") {
            this.selEmpleado.multiSelect = false;
            this.selEmpleado.show();
        }
        else if (option.name == "IMPORT_USR" || option.name == "IMPORT_FINGER") {
            this.context.app.showSpinner();
            var usuarioItem_1 = this.cvUsuarios.currentItem;
            this.checadorSvc.importUser(this.identity, usuarioItem_1)
                .then(function (result) {
                _this.context.app.hideSpinner();
                _this.cvUsuarios.editItem(usuarioItem_1);
                usuarioItem_1.id = result.id;
                _this.cvUsuarios.commitEdit();
                if (option.name == "IMPORT_USR") {
                    _this.alertsBar.showAlert('Usuario importado', 'success ');
                }
                else {
                    _this.alertsBar.showAlert('Huellas de usuario importadas', 'success ');
                }
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == "IMPORT_NEW") {
            this.context.app.showSpinner();
            var items = this.cvUsuarios.sourceCollection;
            this.checadorSvc.importNewUser(this.identity, items)
                .then(function (result) {
                _this.context.app.hideSpinner();
                _this.cvUsuarios.sourceCollection = result;
                _this.cvUsuarios.refresh();
                _this.alertsBar.showAlert('Usuarios nuevos importados', 'success ');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == "EXPORT_FINGER") {
            var checadoresTemp = [];
            var checador = new checador_1.ChecadorItem();
            checador.id = this.identity;
            checadoresTemp.push(checador);
            this.checadoresExclude = checadoresTemp;
            this.checadoresList.show();
        }
        else if (option.name == "ADD_USER") {
            this.usuario.nombre = "";
            this.usuario.codigo = "";
            this.usuario.tipo = 0;
            this.usuario.passwd = "";
            this.dlgUsuario.config.backdrop = false;
            this.dlgUsuario.show();
        }
        else if (option.name == "DELETE_USER") {
            this.context.app.showSpinner();
            var usuarioItem_2 = this.cvUsuarios.currentItem;
            this.checadorSvc.deleteUser(this.identity, usuarioItem_2)
                .then(function (result) {
                _this.context.app.hideSpinner();
                _this.alertsBar.showAlert('Usuario eliminado', 'success ');
                _this.cvUsuarios.remove(usuarioItem_2);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == "DELETE_PASSWD") {
            this.context.app.showSpinner();
            var item = this.cvUsuarios.currentItem;
            this.cvUsuarios.editItem(item);
            item.passwd = "";
            this.cvUsuarios.commitEdit();
            this.alertsBar.showAlert('Password eliminado. Guarde cambios', 'success ');
        }
        else if (option.name == "UPDATE_PASSWD") {
            this.userContrasena = "";
            this.dlgPasswd.config.backdrop = false;
            this.dlgPasswd.show();
        }
    };
    ChecadorUsuarioMaintenance.prototype.exportFingers = function (idChecador) {
        var _this = this;
        this.context.app.showSpinner();
        var usuarioItem = this.cvUsuarios.currentItem;
        this.checadorSvc.exportFingers(idChecador, usuarioItem)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.alertsBar.showAlert('Huellas de usuario exportadas', 'success ');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ChecadorUsuarioMaintenance.prototype.onClickUsuarioAceptar = function () {
        this.dlgUsuario.hide();
        var newUser = this.cvUsuarios.addNew();
        newUser.codigo = this.usuario.codigo;
        newUser.nombre = this.usuario.nombre;
        newUser.passwd = this.usuario.passwd;
        newUser.tipo = this.usuario.tipo;
        newUser.afectaIncidencia = this.usuario.afectaIncidencia;
        newUser.idEmpleado = 0;
        newUser.activo = true;
        newUser.state = core_2.ChangeState.ADDED;
        this.cvUsuarios.commitNew();
    };
    ChecadorUsuarioMaintenance.prototype.onClickPasswdAceptar = function () {
        var item = this.cvUsuarios.currentItem;
        this.cvUsuarios.editItem(item);
        item.passwd = this.userContrasena;
        this.cvUsuarios.commitEdit();
        this.dlgPasswd.hide();
        this.alertsBar.showAlert('Password establecido. Guarde cambios', 'success ');
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ChecadorUsuarioMaintenance.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alertsBar.showAlert(message, 'danger');
    };
    ChecadorUsuarioMaintenance.prototype.applyPolicy = function (policy) {
    };
    // Util
    ChecadorUsuarioMaintenance.prototype.cloneInfo = function (element) {
        return JSON.parse(JSON.stringify(element));
    };
    ChecadorUsuarioMaintenance.prototype.onClickKardexSelect = function () {
        var usuarios = this.cvUsuarios.sourceCollection;
        usuarios.filter(function (usrKdx) { return usrKdx.afectaIncidencia == false; }).forEach(function (user) {
            user.afectaIncidencia = true;
            user.state = core_2.ChangeState.MODIFIED;
        });
        this.cvUsuarios.refresh();
    };
    __decorate([
        core_1.ViewChild(empleado_list_component_1.EmpleadoListComponent),
        __metadata("design:type", empleado_list_component_1.EmpleadoListComponent)
    ], ChecadorUsuarioMaintenance.prototype, "selEmpleado", void 0);
    __decorate([
        core_1.ViewChild(checadores_list_component_1.ChecadorListComponent),
        __metadata("design:type", checadores_list_component_1.ChecadorListComponent)
    ], ChecadorUsuarioMaintenance.prototype, "checadoresList", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ChecadorUsuarioMaintenance.prototype, "alertsBar", void 0);
    __decorate([
        core_1.ViewChild('dlgUsuario'),
        __metadata("design:type", modal_directive_1.ModalDirective)
    ], ChecadorUsuarioMaintenance.prototype, "dlgUsuario", void 0);
    __decorate([
        core_1.ViewChild('dlgPasswd'),
        __metadata("design:type", modal_directive_1.ModalDirective)
    ], ChecadorUsuarioMaintenance.prototype, "dlgPasswd", void 0);
    __decorate([
        core_1.ViewChild('dlgConfirmacion'),
        __metadata("design:type", modal_directive_1.ModalDirective)
    ], ChecadorUsuarioMaintenance.prototype, "dlgConfirmacion", void 0);
    ChecadorUsuarioMaintenance = __decorate([
        core_1.Component({
            selector: 'rh-checador-usaurio',
            template: "\n      <div class=\"row\">\n          <div [ngClass]=\"widthClass\">\n              <az-panel [header]=\"labelChecador\">\n\n                  <alerts-bar></alerts-bar>\n\n                  <div class=\"row\">\n                      <div class=\"col-9\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickActualizar()\">\n                              <span aria-hidden=\"true\" class=\"glyphicon glyphicon-refresh\"></span>\n                              Actualizar\n                          </button>\n\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickGuardar()\">\n                              <span aria-hidden=\"true\" class=\"glyphicon glyphicon-plus\"></span>\n                              Guardar\n                          </button>\n                      </div>\n                      <div class=\"col-3\">\n                          <button type=\"button\" class=\"btn btn-outline-secondary\" (click)=\"onClickKardexSelect()\">\n                              <span aria-hidden=\"true\" class=\"glyphicon glyphicon-check\"></span>\n                              Marcar Kardex\n                          </button>\n                      </div>\n                  </div>\n\n                  <wj-flex-grid #grdUsuario\n                                style=\"height:500px\"\n                                [(itemsSource)]=\"cvUsuarios\"\n                                [selectionMode]=\"'Row'\"\n                                (cellEditEnded)=\"onCellUpdated($event)\"\n                                [wjContextMenu]=\"ctxMenuEmpleado\">\n                      <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                      <wj-flex-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'empleado.codigo'\" [width]=\"80\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Empleado'\" [binding]=\"'empleado.nombre'\" [width]=\"'140*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'C\u00F3digo Checador'\" [binding]=\"'codigo'\" [width]=\"80\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Nombre Corto'\" [binding]=\"'nombre'\" [width]=\"180\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Tipo'\" [binding]=\"'tipo'\" [width]=\"100\" [dataMap]=\"tipoUsuarioMap\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Kardex'\" [binding]=\"'afectaIncidencia'\" [width]=\"80\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Activo'\" [binding]=\"'activo'\" [width]=\"80\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Nuevo'\" [binding]=\"'nuevo'\" [width]=\"80\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  </wj-flex-grid>\n\n              </az-panel>\n          </div>\n      </div>\n\n      <rh-empleado-list (selectedItemChanged)=\"onSelectedEmleado($event)\"\n                        [multiSelect]=\"false\">\n      </rh-empleado-list>\n\n      <rh-checador-list (selectedItemChanged)=\"onSelectedChecador($event)\"\n                        [excludedItems]=\"checadoresExclude\"\n                        [multiSelect]=\"false\"\n                        [validarPermisos]=\"true\">\n      </rh-checador-list>\n\n\n      <wj-menu #ctxMenuEmpleado (itemClicked)=\"onClickMnuEmpleado(ctxMenuEmpleado)\" style=\"display:none\">\n          <wj-menu-item *ngFor=\"let item of mnuEmpleadoItems\">\n              <div *ngIf=\"item.enabled\">\n                  <span [class]=\"item.icon\"></span>\n                  <b>{{item.text}}</b>\n                  <br>\n                  <small><i>{{item.smallText}}</i></small>\n              </div>\n          </wj-menu-item>\n      </wj-menu>\n\n      <!--DIALOGO USUARIO-->\n      <div bsModal #dlgUsuario=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\" role=\"document\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\">Usuario</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"dlgUsuario.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <form [formGroup]=\"formUsuario\">\n                          <div class=\"row\">\n                              <div class=\"col\">\n                                  <azteca-form-field [label]=\"'Codigo'\">\n                                      <az-textbox formControlName=\"codigo\"\n                                                  [(ngModel)]=\"usuario.codigo\">\n                                      </az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col\">\n                                  <azteca-form-field [label]=\"'Nombre corto'\">\n                                      <az-textbox formControlName=\"nombre\"\n                                                  [(ngModel)]=\"usuario.nombre\">\n                                      </az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col\">\n                                  <azteca-form-field [label]=\"'Tipo usuario'\">\n                                      <az-combobox formControlName=\"tipoUsuario\"\n                                                   [(ngModel)]=\"usuario.tipo\"\n                                                   [items]=\"tipoUsuario\"\n                                                   [displayMember]=\"'name'\"\n                                                   [valueMember]=\"'value'\">\n                                      </az-combobox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col\">\n                                  <azteca-form-field [label]=\"'Password'\">\n                                      <az-password formControlName=\"contrasena\"\n                                                   [(ngModel)]=\"usuario.passwd\">\n                                      </az-password>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                      </form>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickUsuarioAceptar()\" [disabled]=\"!formUsuario.valid\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dlgUsuario.hide()\">Cancelar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n\n      <!--DIALOGO PASSWD-->\n      <div bsModal #dlgPasswd=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\" role=\"document\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\">Establecer Password</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"dlgPasswd.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <form [formGroup]=\"formPasswd\">\n                          <div class=\"row\">\n                              <div class=\"col\">\n                                  <azteca-form-field [label]=\"'Password'\">\n                                      <az-password formControlName=\"userContrasena\"\n                                                   [(ngModel)]=\"userContrasena\">\n                                      </az-password>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                      </form>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickPasswdAceptar()\" [disabled]=\"!formPasswd.valid\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dlgPasswd.hide()\">Cancelar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n\n      <!--DIALOGO CONFIRMACION-->\n      <div bsModal #dlgConfirmacion=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\" role=\"document\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\">Confirmar acci\u00F3n</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"dlgConfirmacion.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <p>\u00BFDesea sincronizar con el reloj checador?.</p>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onConfirm(true)\">Si</button>\n                      <button type=\"button\" class=\"btn btn-secondary\" (click)=\"onConfirm(false)\">No</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dlgConfirmacion.hide()\">Cancelar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            checador_service_1.ChecadorService])
    ], ChecadorUsuarioMaintenance);
    return ChecadorUsuarioMaintenance;
}(core_2.ProcessComponent));
exports.ChecadorUsuarioMaintenance = ChecadorUsuarioMaintenance;
