import { FormGroup, FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { TrackableCollection } from 'framework3/editors';
import { ToolbarButton } from 'framework3/controls';
import { Acceso } from '../models/departamento';
import { DepartamentoService } from '../services/departamento.service';
import { DepartamentoSelectorComponent } from '../components/departamento-selector.component';
import { Context, ProcessComponent, PolicyInfo, UsuarioInfo } from 'framework3/core';
import { AlertsBarComponent } from 'framework3/controls';
export declare class DepartamentosAccesosMaintenance extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private departamentoService;
    form: FormGroup;
    usuario: UsuarioInfo;
    accesos: Acceso[];
    accesosCollection: TrackableCollection;
    selectorDepartamento: DepartamentoSelectorComponent;
    alerts: AlertsBarComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, departamentoService: DepartamentoService);
    applyPolicy(policy: PolicyInfo): void;
    onUsuarioSelected(usuario: UsuarioInfo): void;
    onClickAgregar(): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onRemoveAcceso(item: any): void;
    handleError(error: any): void;
}
