"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var editors_1 = require("framework3/editors");
//Locales
var departamento_1 = require("../models/departamento");
var departamento_service_1 = require("../services/departamento.service");
var departamento_selector_component_1 = require("../components/departamento-selector.component");
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var DepartamentosAccesosMaintenance = /** @class */ (function (_super) {
    __extends(DepartamentosAccesosMaintenance, _super);
    function DepartamentosAccesosMaintenance(context, router, route, location, formBuilder, departamentoService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.departamentoService = departamentoService;
        _this.accesos = [];
        _this.accesosCollection = new editors_1.TrackableCollection();
        _this.form = formBuilder.group({
        //        'idUsuario': [0, AztecaValidators.selected],           
        });
        return _this;
    }
    DepartamentosAccesosMaintenance.prototype.applyPolicy = function (policy) {
        throw new Error("Method not implemented.");
    };
    DepartamentosAccesosMaintenance.prototype.onUsuarioSelected = function (usuario) {
        var _this = this;
        this.usuario = usuario;
        this.departamentoService.loadAccesos(usuario.identity)
            .then(function (ret) {
            _this.accesos = ret;
            _this.accesosCollection.sourceCollection = _this.accesos;
            _this.accesosCollection.refresh;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DepartamentosAccesosMaintenance.prototype.onClickAgregar = function () {
        var _this = this;
        var coincidencias = this.accesos.filter(function (subList) { return subList.departamento.path == _this.selectorDepartamento.selectedItem.path; });
        if (coincidencias.length == 0) {
            var accesoNew = new departamento_1.Acceso();
            accesoNew.idUsuario = this.usuario.identity;
            accesoNew.idDepartamento = this.selectorDepartamento.selectedItem.identity;
            accesoNew.departamento = this.selectorDepartamento.selectedItem;
            var accesosSlice = this.accesos.slice();
            accesosSlice.push(accesoNew);
            this.accesos = accesosSlice;
            this.accesosCollection.sourceCollection = this.accesos;
            this.accesosCollection.refresh;
        }
    };
    DepartamentosAccesosMaintenance.prototype.onToolbarButtonClick = function (button) {
        var _this = this;
        if (button.name == 'GUARDAR') {
            this.departamentoService.updateAccesos(this.usuario.identity, this.accesos)
                .then(function (ret) {
                _this.alerts.showAlert('La información fué guardada con éxito', 'sucess');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        if (button.name == 'AGREGAR') {
            this.onClickAgregar();
        }
    };
    DepartamentosAccesosMaintenance.prototype.onRemoveAcceso = function (item) {
        this.accesosCollection.remove(item);
        this.accesosCollection.refresh();
    };
    DepartamentosAccesosMaintenance.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild('selectorDepartamento'),
        __metadata("design:type", departamento_selector_component_1.DepartamentoSelectorComponent)
    ], DepartamentosAccesosMaintenance.prototype, "selectorDepartamento", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], DepartamentosAccesosMaintenance.prototype, "alerts", void 0);
    DepartamentosAccesosMaintenance = __decorate([
        core_1.Component({
            selector: 'rh-departamentos-accesos',
            template: "\n      <form [formGroup]=\"form\">\n          <div class=\"form-inline\">\n              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                  <az-toolbar-button [name]=\"'GUARDAR'\" [type]=\"'primary'\" [text]=\"'Guardar'\" [toolTip]=\"'Guardar'\" [icon]=\"'glyphicon glyphicon-floppy-disk'\" [enabled]=\"true\"></az-toolbar-button>\n                  <az-toolbar-button [name]=\"'AGREGAR'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar'\" [icon]=\"'glyphicon glyphicon-arrow-down'\" [enabled]=\"selectorDepartamento.selectedItem && selectorDepartamento.selectedItem.identity>0\"></az-toolbar-button>\n              </az-toolbar>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12 col-md-10\">\n\n                  <div [ngClass]=\"widthClass\">\n\n                      <div class=\"col-12\">\n                          <az-panel [header]=\"'Administrar accesos a departamentos'\">\n\n                              <!--Barra de alertas-->\n                              <alerts-bar #alertsGral></alerts-bar>\n                              <div class=\"row\">\n                                  <div class=\"form-group\">\n                                      <label>Usuario:</label>\n                                      <usuario-selector (selectedItemChanged)=\"onUsuarioSelected($event)\"></usuario-selector>\n                                  </div>\n                                  <div class=\"form-group\">\n                                      <label>Departamentos:</label>\n                                      <rh-departamento-selector [withAccess]=\"false\" #selectorDepartamento>  </rh-departamento-selector>\n                                  </div>\n                              </div>\n                              <!--<div class=\"row\">\n                                  <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickAgregar()\">Agregar</button>\n                              </div>-->\n\n                          </az-panel>\n                      </div>\n\n\n                      <div class=\"col-12\">\n                          <az-panel [header]=\"'Al agregar un nodo se d\u00E1 acceso a todas las ramificaciones.'\">\n                              <wj-flex-grid #gridAccesos style=\"height:500px\"\n                                            [itemsSource]=\"accesosCollection\">\n\n                                  <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveAcceso(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-trash\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n\n                                  <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'departamento.nombre'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Rama'\" [binding]=\"'departamento.namedPath'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </az-panel>\n                      </div>\n\n                  </div>\n\n\n              </div>\n\n              </div>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            departamento_service_1.DepartamentoService])
    ], DepartamentosAccesosMaintenance);
    return DepartamentosAccesosMaintenance;
}(core_2.ProcessComponent));
exports.DepartamentosAccesosMaintenance = DepartamentosAccesosMaintenance;
