import { FormGroup, FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { Menu } from "wijmo/wijmo.input";
import { MenuItem, ToolbarButton, AlertsBarComponent } from "framework3/controls";
import { Context, ProcessComponent, PolicyInfo } from 'framework3/core';
import { FilterGroup, SearchRequest } from "framework3/search";
import { EvaluacionKardexService } from "../services/evaluacion-kardex.service";
import { EvaluacionKardexItem } from '../models/evaluacion-kardex';
export declare class EvaluacionKardexMaintenance extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    private evaluacionKardeSvc;
    form: FormGroup;
    filterPanelCollapsed: boolean;
    showFilterPanel: boolean;
    menuItems: MenuItem[];
    filterGroups: FilterGroup[];
    selectedGroup: FilterGroup;
    alertsBar: AlertsBarComponent;
    request: SearchRequest;
    fechaTransaccion: Date;
    currentItems: Array<any>;
    currentItem: any;
    totalRows: number;
    pageIndex: number;
    respuesta: boolean;
    enabled: boolean;
    allowNew: boolean;
    currentEvaluacionKardex: EvaluacionKardexItem;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, evaluacionKardeSvc: EvaluacionKardexService);
    ngAfterViewInit(): void;
    createMenu(): void;
    readonly classGridPanel: string;
    toggleCollapse(): void;
    onMenuItemClicked(menu: Menu, args: any): void;
    optionClick(option: MenuItem): void;
    onParamsToolbar(button: ToolbarButton): void;
    applyPolicy(policy: PolicyInfo): void;
    onCurrentItemChanged(item: any): void;
    searchRequested(request: SearchRequest): void;
    handleError(error: any): void;
    onIsDroppedDown(menu: Menu, args: any): void;
    onValidateMenu(item: any): void;
    getMenuItem(name: string): MenuItem;
    onFilterGroupChanged(group: FilterGroup): void;
    refreshList(): void;
    newItemHandler(): void;
    onViewingItem(item: any): void;
}
