"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var moment = require("moment");
var controls_1 = require("framework3/controls");
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
var evaluacion_kardex_service_1 = require("../services/evaluacion-kardex.service");
var evaluacion_kardex_1 = require("../models/evaluacion-kardex");
var EvaluacionKardexMaintenance = /** @class */ (function (_super) {
    __extends(EvaluacionKardexMaintenance, _super);
    function EvaluacionKardexMaintenance(context, router, route, location, formBuilder, evaluacionKardeSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.evaluacionKardeSvc = evaluacionKardeSvc;
        _this.filterPanelCollapsed = false;
        _this.showFilterPanel = true;
        _this.menuItems = [];
        _this.filterGroups = [];
        _this.fechaTransaccion = new Date();
        _this.currentItems = new Array();
        _this.totalRows = 0;
        _this.pageIndex = 0;
        _this.respuesta = false;
        _this.enabled = true;
        _this.allowNew = true;
        _this.currentEvaluacionKardex = new evaluacion_kardex_1.EvaluacionKardexItem();
        _this.form = formBuilder.group({
            'fechaTransaccion': []
        });
        return _this;
    }
    EvaluacionKardexMaintenance.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) {
            _this.fechaTransaccion = moment().subtract(1, 'day').toDate();
            _this.refreshList();
        });
        this.createMenu();
    };
    EvaluacionKardexMaintenance.prototype.createMenu = function () {
        //Agregar opciones estándar del catálogo
        var mnuError = { icon: "glyphicon glyphicon-circle-arrow-down", text: "Consultar error", name: "ERROR", smallText: "Consultar errores proceso" };
        var mnuDetail = { icon: "glyphicon glyphicon-circle-arrow-down", text: "Detalle", name: "DETAIL", smallText: "de evaluación" };
        //
        this.menuItems.push(mnuError);
        this.menuItems.push(mnuDetail);
        //
        this.menuItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    Object.defineProperty(EvaluacionKardexMaintenance.prototype, "classGridPanel", {
        /*Permite tomar todo el espacio disponible cuando el panel de filtro no está visible y 75% cuando lo está*/
        get: function () {
            return !this.showFilterPanel || this.filterPanelCollapsed ? 'col-12' : 'col-12 col-lg-9';
        },
        enumerable: true,
        configurable: true
    });
    EvaluacionKardexMaintenance.prototype.toggleCollapse = function () {
        this.filterPanelCollapsed = !this.filterPanelCollapsed;
    };
    EvaluacionKardexMaintenance.prototype.onMenuItemClicked = function (menu, args) {
        var item = this.menuItems[menu.selectedIndex];
        this.optionClick(item);
    };
    EvaluacionKardexMaintenance.prototype.optionClick = function (option) {
        if (option.name == "ERROR") {
        }
        else if (option.name == "DETAIL") {
        }
    };
    EvaluacionKardexMaintenance.prototype.onParamsToolbar = function (button) {
        if (button.name == 'REFRESH') {
            this.refreshList();
        }
    };
    EvaluacionKardexMaintenance.prototype.applyPolicy = function (policy) {
    };
    EvaluacionKardexMaintenance.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    EvaluacionKardexMaintenance.prototype.searchRequested = function (request) {
        this.request = request;
        this.refreshList();
    };
    EvaluacionKardexMaintenance.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alertsBar.showAlert(message, 'danger');
    };
    EvaluacionKardexMaintenance.prototype.onIsDroppedDown = function (menu, args) {
        this.onValidateMenu(this.currentItem);
    };
    EvaluacionKardexMaintenance.prototype.onValidateMenu = function (item) {
        if (item) {
            var mnuError = this.getMenuItem('ERROR');
            var mnuDetail = this.getMenuItem('DETAIL');
            if (item.estatus != "Error") {
                mnuError.enabled = false;
            }
            if (item.estatus != "Error") {
                mnuDetail.enabled = false;
            }
        }
    };
    EvaluacionKardexMaintenance.prototype.getMenuItem = function (name) {
        var retItem = null;
        this.menuItems.forEach(function (item) {
            if (item.name == name) {
                retItem = item;
            }
        });
        return retItem;
    };
    EvaluacionKardexMaintenance.prototype.onFilterGroupChanged = function (group) {
        this.selectedGroup = group;
    };
    ////////////////////////////////////////
    EvaluacionKardexMaintenance.prototype.refreshList = function () {
        var _this = this;
        this.context.app.showSpinner();
        if (this.request == null) {
            this.request = new search_1.SearchRequest();
            this.request.pageIndex = 0;
            this.request.pageSize = 20;
            this.request.paged = false;
        }
        var exist = false;
        this.request.conditions.forEach(function (r) {
            if (r.field == "fecha") {
                exist = true;
                r.value = _this.fechaTransaccion;
            }
        });
        if (!exist) {
            var conFecha = { field: "fecha", operator: "=", valueType: "datetime", value: this.fechaTransaccion };
            this.request.conditions.push(conFecha);
        }
        this.evaluacionKardeSvc.search(this.context.app.defaultSite.identity, this.request)
            .then(function (response) {
            response.rows.forEach(function (r) {
                r['fecha'] = moment(r['fecha']).toDate();
            });
            _this.currentItems = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = _this.request.pageIndex;
            //
            var filterGroup = new search_1.FilterGroup();
            filterGroup.tag = "ALL";
            filterGroup.name = "Todos";
            filterGroup.rowCount = _this.totalRows;
            _this.filterGroups.length = 0;
            _this.filterGroups.push(filterGroup);
            //
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EvaluacionKardexMaintenance.prototype.newItemHandler = function () {
        this.router.navigate(['new'], { relativeTo: this.route });
    };
    EvaluacionKardexMaintenance.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id], { relativeTo: this.route });
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], EvaluacionKardexMaintenance.prototype, "alertsBar", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], EvaluacionKardexMaintenance.prototype, "enabled", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], EvaluacionKardexMaintenance.prototype, "allowNew", void 0);
    EvaluacionKardexMaintenance = __decorate([
        core_1.Component({
            selector: 'rh-evaluacion-kardex',
            template: "\n      <!--Pool de alertas-->\n      <alerts-bar></alerts-bar>\n\n      <form [formGroup]=\"form\">\n\n          <div class=\"card\">\n              <div class=\"card-header\">Proceso de Transacciones</div>\n              <div class=\"card-body\">\n                  <div class=\"row\">\n                      <div *ngIf=\"showFilterPanel\" class=\"col-12 col-lg-3\">\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <az-panel [header]=\"'Evaluaci\u00F3n'\">\n\n                                      <azteca-form-field [label]=\"'Fecha Transacciones:'\">\n                                          <az-input-date formControlName=\"fechaTransaccion\" [(ngModel)]=\"fechaTransaccion\"></az-input-date>\n                                      </azteca-form-field>\n\n                                      <az-toolbar (buttonClick)=\"onParamsToolbar($event)\">\n                                          <az-toolbar-button [name]=\"'REFRESH'\" [type]=\"'primary'\" [text]=\"'Actualizar listado'\" [icon]=\"'glyphicon glyphicon-refresh'\" [enabled]=\"form.valid\"></az-toolbar-button>\n                                      </az-toolbar>\n\n                                  </az-panel>\n                              </div>\n                              <div class=\"col-12 d-none d-lg-block\">\n                                  <az-panel [header]=\"'Resumen de estados'\" [type]=\"'info'\">\n                                      <!--Falta opciones de los paneles -->\n                                      <document-groups [groups]=\"filterGroups\"\n                                                       [selectedGroup]=\"selectedGroup\"\n                                                       (selectedGroupChanged)=\"onFilterGroupChanged($event)\"></document-groups>\n                                  </az-panel>\n                              </div>\n                          </div> <!--ROW PANEL-->\n                      </div> <!--COL PANEL-->\n\n                      <div [class]=\"classGridPanel\">\n\n                          <!--MEN\u00DA PRINCIPAL-->\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n\n                                  <div class=\"btn-group btn-module-primary\">\n\n                                      <button type=\"button\" class=\"btn btn-default\" [title]=\"(filterPanelCollapsed ? 'Mostrar' : 'Ocultar') + ' panel de filtro'\" (click)=\"toggleCollapse()\">\n                                          <span [class]=\"filterPanelCollapsed ? 'glyphicon glyphicon-chevron-right': 'glyphicon glyphicon-chevron-left'\"></span>\n                                      </button>\n\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"newItemHandler()\" *ngIf=\"enabled && allowNew\">\n                                          <span class=\"glyphicon glyphicon-plus\" aria-hidden=\"true\"></span> Nuevo\n                                      </button>\n\n                                      <wj-menu #menu\n                                               (itemClicked)=\"onMenuItemClicked(menu, $event)\"\n                                               [header]=\"'Opciones'\">\n                                          <wj-menu-item *ngFor=\"let item of menuItems\">\n                                              <div *ngIf=\"item.enabled\">\n                                                  <span [class]=\"item.icon\"></span>\n                                                  <b>{{item.text}}</b>\n                                                  <br>\n                                                  <small><i>{{item.smallText}}</i></small>\n                                              </div>\n                                          </wj-menu-item>\n\n                                      </wj-menu>\n\n                                  </div> <!--TOOLBAR-->\n                              </div> <!--COL MENU-->\n                          </div> <!--ROW MENU-->\n                          <!--GRID DE DOCUMENTOS-->\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <!-- Recibos generados dentro del periodo -->\n                                  <azteca-catalog-list [catalogList]=\"currentItems\"\n                                                       [showRowButton]=\"false\"\n                                                       (currentItemChanged)=\"onCurrentItemChanged($event)\"\n                                                       (searchRequested)=\"searchRequested($event)\"\n                                                       (contextMenuClick)=\"optionClick($event)\"\n                                                       (itemSelected)=\"onViewingItem($event)\"\n                                                       [enabled]=\"true\"\n                                                       [pageSize]=\"100\"\n                                                       [serverSide]=\"false\"\n                                                       [totalRows]=\"totalRows\"\n                                                       [pageIndex]=\"pageIndex\">\n\n                                      <!-- Mapear opciones de men\u00FA de componente padre-->\n                                      <azteca-menu-item *ngFor=\"let item of menuItems\" [name]=\"item.name\" [icon]=\"item.icon\" [text]=\"item.text\" [smallText]=\"item.smallText\" [enabled]=\"item.enabled\"></azteca-menu-item>\n                                      <azteca-grid-column [header]=\"'Inicio'\" [binding]=\"'fechaIni'\" [width]=\"140\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Final'\" [binding]=\"'fechaFin'\" [width]=\"140\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Descripcion'\" [binding]=\"'descripcion'\" [width]=\"'520*'\"></azteca-grid-column>\n                                      <azteca-grid-column [header]=\"'Estatus'\" [binding]=\"'estatus'\" [width]=\"80\"></azteca-grid-column>\n                                  </azteca-catalog-list>\n\n                              </div> <!--COL GRID-->\n                          </div> <!--ROW GRID-->\n\n                      </div> <!--COL LIST-->\n                  </div> <!--ROW-->\n\n              </div>\n          </div>\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder, evaluacion_kardex_service_1.EvaluacionKardexService])
    ], EvaluacionKardexMaintenance);
    return EvaluacionKardexMaintenance;
}(core_2.ProcessComponent));
exports.EvaluacionKardexMaintenance = EvaluacionKardexMaintenance;
