"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("framework3/core");
var checador_service_1 = require("../services/checador.service");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var controls_1 = require("framework3/controls");
var core_2 = require("@angular/core");
var moment = require("moment");
var EventosUsuarioMaintenance = /** @class */ (function (_super) {
    __extends(EventosUsuarioMaintenance, _super);
    function EventosUsuarioMaintenance(context, formBuilder, router, route, checadorService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.checadorService = checadorService;
        _this.currentItems = new Array();
        _this.fechaIni = new Date();
        _this.fechaFin = new Date();
        _this.totalRows = 0;
        _this.pageIndex = 0;
        _this.menuItems = [];
        _this.editorForm = formBuilder.group({
            'fechaIni': [0],
            'fechaFin': [0]
        });
        return _this;
    }
    EventosUsuarioMaintenance.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.fechaIni = moment().subtract(30, 'day').toDate();
        this.fechaFin = moment().add(1, 'day').toDate();
        setTimeout(function (_) {
            _this.refreshList();
        });
        this.createMenu();
    };
    EventosUsuarioMaintenance.prototype.createMenu = function () {
        var mnuEditar = { icon: "glyphicon glyphicon-repeat", text: "Editar", name: "EDITAR", smallText: "Editar autorizaci&oacute;n" };
        var mnuDeactivate = { icon: "glyphicon glyphicon-remove-alt", text: "Desactivar", name: "STATE", smallText: "Cambia el estatus del evento" };
        this.menuItems.push(mnuEditar, mnuDeactivate);
        this.menuItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    EventosUsuarioMaintenance.prototype.refreshList = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.checadorService.searchChecadoresEventos(this.context.app.defaultSite.identity, this.fechaIni, this.fechaFin)
            .then(function (response) {
            _this.currentItems = response;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EventosUsuarioMaintenance.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
        //Cambiar texto de opción para activar o desactivar registros
        var mnuState = this.menuItems.filter(function (item) { return item.name == "STATE"; })[0];
        if (item.activo) {
            mnuState.text = "Desactivar";
        }
        else {
            mnuState.text = "Activar";
        }
    };
    EventosUsuarioMaintenance.prototype.searchRequested = function (request) {
        this.request = request;
        this.refreshList();
    };
    EventosUsuarioMaintenance.prototype.optionClick = function (option) {
        var _this = this;
        if (!this.currentItem.data.aplicado) {
            if (option.name == "EDITAR") {
                this.router.navigate(['rh/eventos-usuario/eventos', this.process.id, this.currentItem.data.idEventoUsuario]);
            }
            else if (option.name == "STATE") {
                this.context.app.showSpinner();
                this.checadorService.statusEvento(this.currentItem.data.idEventoUsuario, !this.currentItem.data.activo, this.context.session.user.identity)
                    .then(function (result) {
                    _this.refreshList();
                    _this.showAlert('Se desactivo con exito', 'success');
                })
                    .catch(function (error) { return _this.handleError(error); });
            }
        }
        else {
            this.showAlert('El evento ya fue aplicado, no se puede modificar', 'danger');
        }
    };
    EventosUsuarioMaintenance.prototype.showAlert = function (message, type) {
        this.context.app.hideSpinner();
        this.alerts.showAlert(message, type);
    };
    EventosUsuarioMaintenance.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
    };
    EventosUsuarioMaintenance.prototype.onAgregar = function () {
        this.router.navigate(['rh/eventos-usuario/eventos', this.process.id, 0]);
    };
    EventosUsuarioMaintenance.prototype.applyPolicy = function (policy) {
    };
    __decorate([
        core_2.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], EventosUsuarioMaintenance.prototype, "alerts", void 0);
    EventosUsuarioMaintenance = __decorate([
        core_2.Component({
            selector: 'eventos-usuario',
            template: "\n      <form [formGroup]=\"editorForm\">\n          <div class=\"row  \">\n              <div class=\"col-12 \">\n            \n                  <alerts-bar></alerts-bar>\n\n                  <az-panel [header]=\"'Eventos Usuarios'\">\n                      <div class=\"row\">\n                          <div class=\"col-sm-12 col-md-3\">\n                              <az-panel [header]=\"'Per\u00EDodo'\">\n                                  <div class=\"row\">\n                                      <div class=\"col-12\">\n                                          <azteca-form-field [label]=\"'Fecha Inicial:'\">\n                                              <az-input-date-time formControlName=\"fechaIni\" [(ngModel)]=\"fechaIni\"></az-input-date-time>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n                                  <div class=\"row\">\n                                      <div class=\"col-12\">\n                                          <azteca-form-field [label]=\"'Fecha Final:'\">\n                                              <az-input-date-time formControlName=\"fechaFin\" [(ngModel)]=\"fechaFin\"></az-input-date-time>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n                                  <br />\n                                  <div class=\"row\">\n                                      <div class=\"col-12\">\n                                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"refreshList()\">Actualizar</button>\n                                      </div>\n                                  </div>\n                              </az-panel>\n                          </div>\n\n                          <div class=\"col-sm-12 col-md-9\">\n                              <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAgregar()\">Agregar</button>\n                              <azteca-catalog-list [catalogList]=\"currentItems\"\n                                                   [showRowButton]=\"false\"\n                                                   [showStatusColumn]=\"false\"\n                                                   (currentItemChanged)=\"onCurrentItemChanged($event)\"\n                                                   (searchRequested)=\"searchRequested($event)\"\n                                                   (contextMenuClick)=\"optionClick($event)\"\n                                                   [enabled]=\"true\"\n                                                   [pageSize]=\"20\"\n                                                   [serverSide]=\"false\"\n                                                   [totalRows]=\"totalRows\"\n                                                   [pageIndex]=\"pageIndex\">\n\n                                  <!-- Mapear opciones de men\u00FA de componente padre-->\n                                  <azteca-menu-item *ngFor=\"let item of menuItems\" [name]=\"item.name\" [icon]=\"item.icon\" [text]=\"item.text\" [smallText]=\"item.smallText\" [enabled]=\"item.enabled\"></azteca-menu-item>\n                                  <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"300\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"180\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Incidencia'\" [binding]=\"'incidencia'\" [width]=\"220\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fecha'\" [width]=\"220\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Restringir'\" [binding]=\"'restringir'\" [width]=\"150\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Aplicado'\" [binding]=\"'aplicadoTexto'\" [width]=\"150\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Activo'\" [binding]=\"'activoTexto'\" [width]=\"150\"></azteca-grid-column>\n                              </azteca-catalog-list>\n                          </div>\n                      </div>             \n\n                  </az-panel>\n              </div>\n          </div>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_1.Context, forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute, checador_service_1.ChecadorService])
    ], EventosUsuarioMaintenance);
    return EventosUsuarioMaintenance;
}(core_1.ProcessComponent));
exports.EventosUsuarioMaintenance = EventosUsuarioMaintenance;
