import { ProcessComponent, Context, PolicyInfo } from "framework3/core";
import { FormGroup, FormBuilder } from "@angular/forms";
import { MenuItem, AlertsBarComponent, ToolbarButton } from "framework3/controls";
import { FilterGroup, SearchRequest } from "framework3/search";
import { Router, ActivatedRoute } from "@angular/router";
import { Location } from '@angular/common';
import { Menu } from "wijmo/wijmo.input";
import { InterfazAdamItem } from "../models/interfaz-adam";
import { InterfazAdamService } from "../services/interfaz-adam.service";
import { ModalDirective } from "ngx-bootstrap";
export declare class InterfazAdamMaintenance extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    private interfazAdamSvc;
    form: FormGroup;
    filterPanelCollapsed: boolean;
    showFilterPanel: boolean;
    menuItems: MenuItem[];
    filterGroups: FilterGroup[];
    selectedGroup: FilterGroup;
    message: string;
    alertsBar: AlertsBarComponent;
    viewError: ModalDirective;
    request: SearchRequest;
    fechaTransaccion: Date;
    currentItems: Array<any>;
    currentItem: any;
    totalRows: number;
    pageIndex: number;
    respuesta: boolean;
    enabled: boolean;
    allowNew: boolean;
    currentEvaluacionKardex: InterfazAdamItem;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, interfazAdamSvc: InterfazAdamService);
    ngAfterViewInit(): void;
    createMenu(): void;
    readonly classGridPanel: string;
    toggleCollapse(): void;
    onMenuItemClicked(menu: Menu, args: any): void;
    optionClick(option: MenuItem): void;
    onParamsToolbar(button: ToolbarButton): void;
    applyPolicy(policy: PolicyInfo): void;
    onCurrentItemChanged(item: any): void;
    searchRequested(request: SearchRequest): void;
    handleError(error: any): void;
    onIsDroppedDown(menu: Menu, args: any): void;
    onValidateMenu(item: any): void;
    getMenuItem(name: string): MenuItem;
    onFilterGroupChanged(group: FilterGroup): void;
    refreshList(): void;
    newItemHandler(): void;
    onViewingItem(item: any): void;
    onCerrar(): void;
}
