import { FormGroup, FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { Context, ProcessComponent, CatalogItem, PolicyInfo } from 'framework3/core';
import { AlertsBarComponent, MenuItem } from 'framework3/controls';
import { ModalDirective } from 'ngx-bootstrap/modal/modal.directive';
import * as wjcCore from 'wijmo/wijmo';
import { Menu } from 'wijmo/wijmo.input';
import { KardexAsistenciaService } from "../services/kardex-asistencia.service";
import { IncidenciaService } from "../services/incidencia.service";
import { IncidenciaListComponent } from '../controls/incidencia-list.component';
export declare class KardexEmpleadoMaintenance extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    private kardexAsistenciaSvc;
    private incidenciaSvc;
    form: FormGroup;
    formFolio: FormGroup;
    idEmpleado: number;
    fechaIni: Date;
    fechaFin: Date;
    valid: boolean;
    folio: string;
    observacion: string;
    widthClass: string[];
    menuIncidenciaItems: MenuItem[];
    alerts: AlertsBarComponent;
    lstDlgIncidencia: IncidenciaListComponent;
    dlgFolio: ModalDirective;
    cvKardexAsistencia: wjcCore.CollectionView;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, kardexAsistenciaSvc: KardexAsistenciaService, incidenciaSvc: IncidenciaService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    private changeState;
    closeEditor(): void;
    createMenuDetail(): void;
    onClickKadexActualizar(): void;
    onClickMnuIncidencia(menu: Menu): void;
    onClickFolioAceptar(): void;
    onSelectedIncidencia(catalogItem: CatalogItem): void;
    saveHandler(): void;
    applyPolicy(policy: PolicyInfo): void;
    private handleError;
}
