"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
// Framework
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
// Bootstrap
var modal_directive_1 = require("ngx-bootstrap/modal/modal.directive");
// moment
var moment = require("moment");
// Wijmo
var wjcCore = require("wijmo/wijmo");
// Features
var kardex_asistencia_service_1 = require("../services/kardex-asistencia.service");
var incidencia_service_1 = require("../services/incidencia.service");
var incidencia_1 = require("../models/incidencia");
var incidencia_list_component_1 = require("../controls/incidencia-list.component");
var KardexEmpleadoMaintenance = /** @class */ (function (_super) {
    __extends(KardexEmpleadoMaintenance, _super);
    function KardexEmpleadoMaintenance(context, router, route, location, formBuilder, kardexAsistenciaSvc, incidenciaSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.kardexAsistenciaSvc = kardexAsistenciaSvc;
        _this.incidenciaSvc = incidenciaSvc;
        _this.idEmpleado = 0;
        _this.fechaIni = new Date();
        _this.fechaFin = new Date();
        _this.valid = false;
        _this.folio = "";
        _this.observacion = "";
        _this.widthClass = [];
        _this.menuIncidenciaItems = [];
        _this.cvKardexAsistencia = new wjcCore.CollectionView();
        _this.form = formBuilder.group({
            'idEmpleado': [null, controls_1.AztecaValidators.selected],
            'fechaIni': [null, forms_1.Validators.required],
            'fechaFin': [null, forms_1.Validators.required]
        });
        _this.formFolio = formBuilder.group({
            'folio': ['', forms_1.Validators.required],
            'observacion': ['', forms_1.Validators.required]
        });
        return _this;
    }
    KardexEmpleadoMaintenance.prototype.ngOnInit = function () {
        //Establecer el ancho establecido para la aplicación
        this.widthClass.push(this.context.app.defaultWidth);
    };
    KardexEmpleadoMaintenance.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (!this.form)
            return;
        setTimeout(function (_) {
            _this.fechaIni = moment().subtract(16, 'day').toDate();
            _this.fechaFin = moment().subtract(1, 'day').toDate();
            _this.createMenuDetail();
        });
        this.form.statusChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.changeState(); });
        });
    };
    KardexEmpleadoMaintenance.prototype.changeState = function () {
        this.valid = this.form.valid;
    };
    KardexEmpleadoMaintenance.prototype.closeEditor = function () {
        this.location.back();
    };
    KardexEmpleadoMaintenance.prototype.createMenuDetail = function () {
        var mnuAsignar = { icon: "glyphicon glyphicon-pencil", text: "Asignar Incidencia", name: "ASIGNAR", smallText: "asignar incidencia" };
        var mnuQuitar = { icon: "glyphicon glyphicon-remove", text: "Quitar Incidencia", name: "QUITAR", smallText: "quitar incidencia" };
        var mnuFolio = { icon: "glyphicon glyphicon-edit", text: "Asignar Folio", name: "FOLIO", smallText: "asignar folio" };
        this.menuIncidenciaItems.push(mnuAsignar, mnuQuitar, mnuFolio);
        this.menuIncidenciaItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    ////////////////////////////////////////////////////////
    // Evnents handler
    KardexEmpleadoMaintenance.prototype.onClickKadexActualizar = function () {
        var _this = this;
        if (this.valid) {
            this.context.app.showSpinner();
            this.kardexAsistenciaSvc.getKardexAsistencia(this.idEmpleado, this.fechaIni, this.fechaFin)
                .then(function (info) {
                _this.cvKardexAsistencia.sourceCollection = info;
                _this.cvKardexAsistencia.refresh();
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.cvKardexAsistencia.sourceCollection = [];
            this.cvKardexAsistencia.refresh();
        }
    };
    KardexEmpleadoMaintenance.prototype.onClickMnuIncidencia = function (menu) {
        var option = this.menuIncidenciaItems[menu.selectedIndex];
        if (option.name == "ASIGNAR") {
            this.lstDlgIncidencia.show();
        }
        else if (option.name == "QUITAR") {
            var item = this.cvKardexAsistencia.currentItem;
            this.cvKardexAsistencia.editItem(item);
            item.idIncidencia = 0;
            item.incidencia = new incidencia_1.IncidenciaInfo();
            item.folio = "";
            item.observaciones = "";
            item.manual = true;
            item.estatus = "";
            item.state = core_2.ChangeState.DELETED;
            this.cvKardexAsistencia.commitEdit();
        }
        else if (option.name == "FOLIO") {
            var item = this.cvKardexAsistencia.currentItem;
            if (item) {
                this.folio = item.folio;
                this.observacion = item.observaciones;
                this.dlgFolio.config.backdrop = false;
                this.dlgFolio.show();
            }
        }
    };
    KardexEmpleadoMaintenance.prototype.onClickFolioAceptar = function () {
        var item = this.cvKardexAsistencia.currentItem;
        if (item) {
            this.cvKardexAsistencia.editItem(item);
            item.folio = this.folio;
            item.observaciones = this.observacion;
            item.state = core_2.ChangeState.MODIFIED;
            this.cvKardexAsistencia.commitEdit();
        }
        this.dlgFolio.hide();
    };
    KardexEmpleadoMaintenance.prototype.onSelectedIncidencia = function (catalogItem) {
        var _this = this;
        this.context.app.showSpinner();
        this.incidenciaSvc.getDetailByID(catalogItem.id)
            .then(function (info) {
            var item = _this.cvKardexAsistencia.currentItem;
            if (item) {
                _this.cvKardexAsistencia.editItem(item);
                item.idIncidencia = info.identity;
                item.incidencia = info;
                item.estatus = info.estatus;
                item.state = core_2.ChangeState.MODIFIED;
                item.manual = true;
                _this.cvKardexAsistencia.commitEdit();
            }
            _this.context.app.hideSpinner();
        }).catch(function (error) { return _this.handleError(error); });
    };
    KardexEmpleadoMaintenance.prototype.saveHandler = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.kardexAsistenciaSvc.updateKardexAsistencia(this.cvKardexAsistencia.sourceCollection)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('Kardex del empleado actualizado', 'success');
            _this.onClickKadexActualizar();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ////////////////////////////////////////////////////////
    KardexEmpleadoMaintenance.prototype.applyPolicy = function (policy) {
        throw new Error("Method not implemented.");
    };
    KardexEmpleadoMaintenance.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], KardexEmpleadoMaintenance.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('lstDlgIncidencia'),
        __metadata("design:type", incidencia_list_component_1.IncidenciaListComponent)
    ], KardexEmpleadoMaintenance.prototype, "lstDlgIncidencia", void 0);
    __decorate([
        core_1.ViewChild('dlgFolio'),
        __metadata("design:type", modal_directive_1.ModalDirective)
    ], KardexEmpleadoMaintenance.prototype, "dlgFolio", void 0);
    KardexEmpleadoMaintenance = __decorate([
        core_1.Component({
            selector: 'rh-kardex-empleado',
            template: "\n      <form [formGroup]=\"form\">\n          <div class=\"row\">\n              <div [ngClass]=\"widthClass\">\n\n                  <az-panel [header]=\"'Kardex de Asistencias'\">\n\n                      <!--Barra de alertas-->\n                      <alerts-bar></alerts-bar>\n\n                      <!--Toolbar-->\n                      <div class=\"btn-group\">\n                          <button type=\"submit\" class=\"btn btn-primary\" (click)=\"saveHandler()\">\n                              <span class=\"glyphicon glyphicon-floppy-disk\" aria-hidden=\"true\"></span> Guardar\n                          </button>\n                          <!--En dispositivos peque\u00F1os se mostrar\u00E1 un bot\u00F3n con el \u00EDcono de cerrar, en dispositivos grandes se mostrar\u00E1 con texto-->\n                          <button type=\"button\" class=\"btn btn-default d-none d-lg-block cancel-win\" (click)=\"closeEditor()\">\n                              <span class=\"glyphicon glyphicon-remove\" aria-hidden=\"true\"></span> Cerrar\n                          </button>\n                      </div>\n\n                      <!--Controles del formulario-->\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Empleado:'\">\n                                  <rh-empleado-selector formControlName=\"idEmpleado\"\n                                                        [(ngModel)]=\"idEmpleado\">\n                                  </rh-empleado-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Fecha Incio:'\">\n                                  <az-input-date formControlName=\"fechaIni\"\n                                                 [(ngModel)]=\"fechaIni\">\n                                  </az-input-date>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Fecha fin:'\">\n                                  <az-input-date formControlName=\"fechaFin\"\n                                                 [(ngModel)]=\"fechaFin\">\n                                  </az-input-date>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickKadexActualizar()\" [disabled]=\"!valid\">\n                              <span aria-hidden=\"true\" class=\"glyphicon glyphicon-refresh\"></span>\n                              Consultar\n                          </button>\n                      </div>\n\n                      <wj-flex-grid style=\"height:500px\"\n                                    [itemsSource]=\"cvKardexAsistencia\"\n                                    [selectionMode]=\"'Row'\"\n                                    [wjContextMenu]=\"ctxMenuIncidencia\">\n                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                          <wj-flex-grid-column [header]=\"'Fecha'\" [binding]=\"'fecha'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Incidencia'\" [binding]=\"'incidencia.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"'30*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Observaiones'\" [binding]=\"'observaciones'\" [width]=\"'30*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                      </wj-flex-grid>\n\n                  </az-panel>\n              </div>\n          </div>\n      </form>\n\n      <rh-incidencia-list #lstDlgIncidencia\n                          (selectedItemChanged)=\"onSelectedIncidencia($event)\"\n                          [multiSelect]=\"false\">\n      </rh-incidencia-list>\n\n      <wj-menu #ctxMenuIncidencia (itemClicked)=\"onClickMnuIncidencia(ctxMenuIncidencia)\" style=\"display:none\">\n          <wj-menu-item *ngFor=\"let item of menuIncidenciaItems\">\n              <div *ngIf=\"item.enabled\">\n                  <span [class]=\"item.icon\"></span>\n                  <b>{{item.text}}</b>\n                  <br>\n                  <small><i>{{item.smallText}}</i></small>\n              </div>\n          </wj-menu-item>\n      </wj-menu>\n\n      <!--DIALOGO FOLIO OBSERVACIOINES-->\n      <div bsModal #dlgFolio=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\" role=\"document\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\" id=\"exampleModalLabel\">Folio</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"dlgFolio.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n\n                      <form [formGroup]=\"formFolio\">\n                          <div class=\"row\">\n                              <div class=\"col\">\n                                  <azteca-form-field [label]=\"'Folio'\">\n                                      <az-textbox formControlName=\"folio\" \n                                                  [(ngModel)]=\"folio\">\n                                      </az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col\">\n                                  <azteca-form-field [label]=\"'Observaciones'\">\n                                      <az-textarea formControlName=\"observacion\" \n                                                   [(ngModel)]=\"observacion\"></az-textarea>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                      </form>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickFolioAceptar()\" [disabled]=\"!formFolio.valid\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dlgFolio.hide()\">Cancelar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            kardex_asistencia_service_1.KardexAsistenciaService,
            incidencia_service_1.IncidenciaService])
    ], KardexEmpleadoMaintenance);
    return KardexEmpleadoMaintenance;
}(core_2.ProcessComponent));
exports.KardexEmpleadoMaintenance = KardexEmpleadoMaintenance;
