"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//Features
var finiquito_autorizacion_1 = require("../../models/finiquito-autorizacion");
var finiquito_autorizacion_service_1 = require("../../services/finiquito-autorizacion.service");
var AutorizacionFiniquitoEditor = /** @class */ (function (_super) {
    __extends(AutorizacionFiniquitoEditor, _super);
    function AutorizacionFiniquitoEditor(formBuilder, route, location, finiquitoAutorizacionService, context) {
        var _this = _super.call(this) || this;
        _this.formBuilder = formBuilder;
        _this.route = route;
        _this.location = location;
        _this.finiquitoAutorizacionService = finiquitoAutorizacionService;
        _this.context = context;
        _this.currentItem = new finiquito_autorizacion_1.FiniquitoAutorizacionInfo();
        _this.autoriza = "";
        _this.clasesNominas = [];
        _this.personasAutorizan = [];
        _this.editorForm = formBuilder.group({
            'idUsuarioElabora': [],
            'idClaseNomina': [],
            'personaAutoriza': [],
            'autoriza': []
        });
        return _this;
    }
    AutorizacionFiniquitoEditor.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) {
            _this.loadClasesNominas();
        });
    };
    AutorizacionFiniquitoEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idFiniquitoAutorizacion = +param['id'];
        });
    };
    AutorizacionFiniquitoEditor.prototype.showAlert = function (message, type) {
        this.context.app.hideSpinner();
        this.alerts.showAlert(message, type);
    };
    AutorizacionFiniquitoEditor.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    AutorizacionFiniquitoEditor.prototype.applyPolicy = function (policy) {
    };
    AutorizacionFiniquitoEditor.prototype.loadClasesNominas = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.finiquitoAutorizacionService.loadClasesNominas().then(function (info) {
            _this.clasesNominas = info;
            _this.context.app.hideSpinner();
            _this.loadPersonasAutorizan();
        }).catch(function (error) {
            _this.context.app.hideSpinner();
            _this.handleError(error);
        });
    };
    AutorizacionFiniquitoEditor.prototype.loadPersonasAutorizan = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.finiquitoAutorizacionService.loadPersonasAutorizan().then(function (info) {
            _this.personasAutorizan = info;
            _this.context.app.hideSpinner();
            //
            if (_this.idFiniquitoAutorizacion > 0) {
                _this.loadFiniquitoAutorizacion();
            }
            else {
                _this.currentItem = new finiquito_autorizacion_1.FiniquitoAutorizacionInfo();
            }
        }).catch(function (error) {
            _this.context.app.hideSpinner();
            _this.handleError(error);
        });
    };
    AutorizacionFiniquitoEditor.prototype.loadFiniquitoAutorizacion = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.finiquitoAutorizacionService.getDetail(this.idFiniquitoAutorizacion).then(function (info) {
            _this.currentItem = info;
            _this.context.app.hideSpinner();
        }).catch(function (error) {
            _this.context.app.hideSpinner();
            _this.handleError(error);
        });
    };
    AutorizacionFiniquitoEditor.prototype.onSeleccionAutoriza = function (args) {
        this.currentItem.autoriza = args;
    };
    AutorizacionFiniquitoEditor.prototype.onCancel = function () {
        this.location.back();
    };
    AutorizacionFiniquitoEditor.prototype.onUpdate = function () {
        var _this = this;
        if (!(this.currentItem.idUsuarioElabora > 0)) {
            this.alerts.showAlert("Seleccione el usuario", 'danger');
        }
        else if (!(this.currentItem.idClaseNomina > 0)) {
            this.alerts.showAlert("Seleccione la clase de nómina", 'danger');
        }
        else if (this.currentItem.autoriza == '') {
            this.alerts.showAlert("Indique el nombre de la presona que autoriza", 'danger');
        }
        else {
            this.context.app.showSpinner();
            this.finiquitoAutorizacionService.update(this.currentItem).then(function (info) {
                _this.context.app.hideSpinner();
                _this.alerts.showAlert("Información actualizada", 'success');
                _this.location.back();
            }).catch(function (error) {
                _this.context.app.hideSpinner();
                _this.handleError(error);
            });
        }
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], AutorizacionFiniquitoEditor.prototype, "alerts", void 0);
    AutorizacionFiniquitoEditor = __decorate([
        core_1.Component({
            selector: 'autorizacion-finiquito-editor',
            template: "\n      <form [formGroup]=\"editorForm\">\n\n          <div class=\"row\">\n              <div class=\"col-12 col-lg-8\">\n                  <alerts-bar></alerts-bar>\n                  <az-panel header=\"Datos de contacto\">\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-6\">\n                              <azteca-form-field [label]=\"'Usuario:'\">\n                                  <usuario-selector formControlName=\"idUsuarioElabora\" [(ngModel)]=\"currentItem.idUsuarioElabora\"></usuario-selector>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-6\">\n                              <azteca-form-field [label]=\"'Clase N&oacute;mina:'\">\n                                  <az-combobox formControlName=\"idClaseNomina\" [(ngModel)]=\"currentItem.idClaseNomina\" [items]=\"clasesNominas\" [displayMember]=\"'claseNomina'\" [valueMember]=\"'idClaseNomina'\"></az-combobox>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-6\">\n                              <azteca-form-field [label]=\"'Persona Autoriza:'\">\n                                  <az-combobox formControlName=\"personaAutoriza\" [(ngModel)]=\"autoriza\" [items]=\"personasAutorizan\" [displayMember]=\"'autoriza'\" [valueMember]=\"'autoriza'\"  (selectedItemChanged)=\"onSeleccionAutoriza($event)\"></az-combobox>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-6\">\n                              <azteca-form-field [label]=\"'Autoriza:'\">\n                                  <az-textbox formControlName=\"autoriza\" [(ngModel)]=\"currentItem.autoriza\"></az-textbox>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"onCancel()\">Cancelar</button>\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                      </div> <!--Modal Footer-->\n\n                  </az-panel>\n              </div>\n\n          </div>\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, router_1.ActivatedRoute, common_1.Location, finiquito_autorizacion_service_1.FiniquitoAutorizacionService, core_2.Context])
    ], AutorizacionFiniquitoEditor);
    return AutorizacionFiniquitoEditor;
}(core_2.BaseComponent));
exports.AutorizacionFiniquitoEditor = AutorizacionFiniquitoEditor;
