"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var evaluacion_kardex_service_1 = require("../../services/evaluacion-kardex.service");
var evaluacion_kardex_1 = require("../../models/evaluacion-kardex");
var EvaluacionKardexDet = /** @class */ (function (_super) {
    __extends(EvaluacionKardexDet, _super);
    function EvaluacionKardexDet(context, router, route, location, evaluacionKardexSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.evaluacionKardexSvc = evaluacionKardexSvc;
        _this.widthClass = [];
        _this.idEvaluacionKardex = 0;
        _this.info = new evaluacion_kardex_1.EvaluacionKardexInfo();
        return _this;
    }
    EvaluacionKardexDet.prototype.ngOnInit = function () {
        var _this = this;
        //Establecer el ancho establecido para la aplicación
        this.widthClass.push(this.context.app.defaultWidth);
        this.route.params.forEach(function (params) {
            _this.idEvaluacionKardex = +params['id'];
            if (_this.idEvaluacionKardex > 0) {
                _this.context.app.showSpinner();
                _this.evaluacionKardexSvc.getDetail(_this.idEvaluacionKardex)
                    .then(function (result) {
                    _this.info = result;
                    _this.context.app.hideSpinner();
                }).catch(function (e) { return _this.handleError(e); });
            }
        });
    };
    EvaluacionKardexDet.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    EvaluacionKardexDet.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    EvaluacionKardexDet.prototype.applyPolicy = function (policy) {
        throw new Error("Method not implemented.");
    };
    ///////////////////////////////////////////////
    EvaluacionKardexDet.prototype.closeEditor = function () {
        this.location.back();
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], EvaluacionKardexDet.prototype, "alerts", void 0);
    EvaluacionKardexDet = __decorate([
        core_1.Component({
            selector: 'rh-evaluacion-kardex-det',
            template: "\n      <div class=\"row\">\n          <div [ngClass]=\"widthClass\">\n\n              <az-panel [header]=\"title\">\n\n                  <!--Barra de alertas-->\n                  <alerts-bar></alerts-bar>\n\n                  <!--Toolbar-->\n                  <div class=\"btn-group\">\n                      <!--En dispositivos peque\u00F1os se mostrar\u00E1 un bot\u00F3n con el \u00EDcono de cerrar, en dispositivos grandes se mostrar\u00E1 con texto-->\n                      <button type=\"button\" class=\"btn btn-default d-none d-lg-block cancel-win\" (click)=\"closeEditor()\">\n                          <span class=\"glyphicon glyphicon-remove\" aria-hidden=\"true\"></span> Cerrar\n                      </button>\n                  </div>\n\n\n                  <div class=\"row\">\n                      <!--------- EMISOR ----------->\n                      <div class=\"col-12 col-lg-3\">\n                          <az-panel [header]=\"'Emisor'\">\n\n                              <label class=\"control-label\">Fecha Inicial:</label>\n                              <az-label [text]=\"info.fechaIni | dateFormat:'DD/MM/YYYY HH:mm'\"></az-label>\n\n                              <label class=\"control-label\">Fecha Final:</label>\n                              <az-label [text]=\"info.fechaFin | dateFormat:'DD/MM/YYYY HH:mm'\"></az-label>\n\n                              <label class=\"control-label\">Regenerar periodos de trabajo:</label>\n                              <az-label *ngIf=\"info.regenerarPeriodo\" [text]=\"'S\u00ED'\"></az-label>\n                              <az-label *ngIf=\"!info.regenerarPeriodo\" [text]=\"'No'\"></az-label>\n\n                              <label class=\"control-label\">Regenerar checadas:</label>\n                              <az-label *ngIf=\"info.regenerarChecada\" [text]=\"'S\u00ED'\"></az-label>\n                              <az-label *ngIf=\"!info.regenerarChecada\" [text]=\"'No'\"></az-label>\n\n                              <label class=\"control-label\">Regenerar Kardex de asistencias:</label>\n                              <!--<az-label [text]=\"info.regenerarKardex\"></az-label>-->\n                              <az-label *ngIf=\"info.regenerarKardex\" [text]=\"'S\u00ED'\"></az-label>\n                              <az-label *ngIf=\"!info.regenerarKardex\" [text]=\"'No'\"></az-label>\n\n                          </az-panel>\n                      </div>\n                  </div>\n\n\n              </az-panel>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            evaluacion_kardex_service_1.EvaluacionKardexService])
    ], EvaluacionKardexDet);
    return EvaluacionKardexDet;
}(core_2.ProcessComponent));
exports.EvaluacionKardexDet = EvaluacionKardexDet;
