import { EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { FormGroup, FormBuilder } from '@angular/forms';
import { Context, ProcessComponent, PolicyInfo } from 'framework3/core';
import { AlertsBarComponent } from 'framework3/controls';
import { EvaluacionKardexInfo } from '../../models/evaluacion-kardex';
import { EvaluacionKardexService } from '../../services/evaluacion-kardex.service';
export declare class EvaluacionKardexEditorComponent extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    private evaluacionKardexSvc;
    catalogForm: FormGroup;
    identity: number;
    readonlyMode: boolean;
    dirty: boolean;
    valid: boolean;
    widthClass: string[];
    canceled: boolean;
    info: EvaluacionKardexInfo;
    title: string;
    savedItem: EventEmitter<EvaluacionKardexInfo>;
    alerts: AlertsBarComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, evaluacionKardexSvc: EvaluacionKardexService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    private changeState;
    showAlert(message: string, type: string): void;
    handleError(error: any): void;
    applyPolicy(policy: PolicyInfo): void;
    closeEditor(): void;
    saveHandler(): void;
}
