"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//
var evaluacion_kardex_1 = require("../../models/evaluacion-kardex");
var evaluacion_kardex_service_1 = require("../../services/evaluacion-kardex.service");
var EvaluacionKardexEditorComponent = /** @class */ (function (_super) {
    __extends(EvaluacionKardexEditorComponent, _super);
    function EvaluacionKardexEditorComponent(context, router, route, location, formBuilder, evaluacionKardexSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.evaluacionKardexSvc = evaluacionKardexSvc;
        _this.readonlyMode = false;
        _this.dirty = false;
        _this.valid = false;
        _this.widthClass = [];
        _this.canceled = false;
        _this.info = new evaluacion_kardex_1.EvaluacionKardexInfo();
        _this.title = "Proceso de Transacciones";
        _this.savedItem = new core_1.EventEmitter();
        _this.catalogForm = formBuilder.group({
            'fechaIni': [null, forms_1.Validators.required],
            'fechaFin': [null, forms_1.Validators.required],
            'idEmpleado': [0],
            'idChecador': [0],
            'idDepartamento': [0],
            'idHorario': [0],
            'idTurno': [0],
            'regenerarPeriodo': [false],
            'regenerarChecada': [false],
            'regenerarKardex': [false]
        });
        return _this;
    }
    EvaluacionKardexEditorComponent.prototype.ngOnInit = function () {
        //Establecer el ancho establecido para la aplicación
        this.widthClass.push(this.context.app.defaultWidth);
    };
    EvaluacionKardexEditorComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (!this.catalogForm)
            return;
        this.catalogForm.statusChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.changeState(); });
        });
    };
    EvaluacionKardexEditorComponent.prototype.changeState = function () {
        this.valid = this.catalogForm.valid;
        this.dirty = this.catalogForm.dirty;
    };
    EvaluacionKardexEditorComponent.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    EvaluacionKardexEditorComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    EvaluacionKardexEditorComponent.prototype.applyPolicy = function (policy) {
        throw new Error("Method not implemented.");
    };
    ///////////////////////////////////////////////
    EvaluacionKardexEditorComponent.prototype.closeEditor = function () {
        this.location.back();
    };
    EvaluacionKardexEditorComponent.prototype.saveHandler = function () {
        var _this = this;
        this.info.idBranch = this.context.app.defaultSite.identity;
        this.context.app.showSpinner();
        this.evaluacionKardexSvc.update(this.info)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.location.back();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], EvaluacionKardexEditorComponent.prototype, "title", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], EvaluacionKardexEditorComponent.prototype, "savedItem", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], EvaluacionKardexEditorComponent.prototype, "alerts", void 0);
    EvaluacionKardexEditorComponent = __decorate([
        core_1.Component({
            selector: 'rh-evaluacion-kardex-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n          <div class=\"row\">\n              <div [ngClass]=\"widthClass\">\n\n                  <az-panel [header]=\"title\">\n\n                      <!--Barra de alertas-->\n                      <alerts-bar></alerts-bar>\n\n                      <!--Toolbar-->\n                      <div class=\"btn-group\">\n                          <button type=\"submit\" class=\"btn btn-primary\" (click)=\"saveHandler()\" [disabled]=\"!valid\">\n                              <span class=\"glyphicon glyphicon-floppy-disk\" aria-hidden=\"true\"></span> Guardar\n                          </button>\n                          <!--En dispositivos peque\u00F1os se mostrar\u00E1 un bot\u00F3n con el \u00EDcono de cerrar, en dispositivos grandes se mostrar\u00E1 con texto-->\n                          <button type=\"button\" class=\"btn btn-default d-none d-lg-block cancel-win\" (click)=\"closeEditor()\">\n                              <span class=\"glyphicon glyphicon-remove\" aria-hidden=\"true\"></span> {{dirty ? 'Cancelar' : 'Cerrar'}}\n                          </button>\n                      </div>\n\n                      <!--Controles del formulario-->\n                      <div class=\"row\">\n                          <div class=\"col-12 col-3\">\n                              <azteca-form-field [label]=\"'Fecha Inicial:'\">\n                                  <az-input-date formControlName=\"fechaIni\"\n                                                 [(ngModel)]=\"info.fechaIni\">\n                                  </az-input-date>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-3\">\n                              <azteca-form-field [label]=\"'Fecha Final:'\">\n                                  <az-input-date formControlName=\"fechaFin\"\n                                                 [(ngModel)]=\"info.fechaFin\">\n                                  </az-input-date>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Empleado:'\">\n                                  <rh-empleado-selector formControlName=\"idEmpleado\"\n                                                        [(ngModel)]=\"info.idEmpleado\">\n                                  </rh-empleado-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Checador:'\">\n                                  <rh-checador-selector formControlName=\"idChecador\"\n                                                        [(ngModel)]=\"info.idChecador\">\n                                  </rh-checador-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Departamento:'\">\n                                  <rh-departamento-selector formControlName=\"idDepartamento\"\n                                                            [(ngModel)]=\"info.idDepartamento\">\n                                  </rh-departamento-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Horario:'\">\n                                  <rh-horario-selector formControlName=\"idHorario\"\n                                                       [(ngModel)]=\"info.idHorario\"></rh-horario-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Turno:'\">\n                                  <rh-turno-selector formControlName=\"idTurno\"\n                                                     [(ngModel)]=\"info.idTurno\">\n                                  </rh-turno-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <az-checkbox [label]=\"'Regenerar periodos de trabajo'\"\n                                       formControlName=\"regenerarPeriodo\"\n                                       [(ngModel)]=\"info.regenerarPeriodo\">\n                          </az-checkbox>\n                      </div>\n\n                      <div class=\"row\">\n                          <az-checkbox [label]=\"'Regenerar checadas'\"\n                                       formControlName=\"regenerarChecada\"\n                                       [(ngModel)]=\"info.regenerarChecada\">\n                          </az-checkbox>\n                      </div>\n\n                      <div class=\"row\">\n                          <az-checkbox [label]=\"'Regenerar Kardex de asistencias'\"\n                                       formControlName=\"regenerarKardex\"\n                                       [(ngModel)]=\"info.regenerarKardex\">\n                          </az-checkbox>\n                      </div>\n\n                  </az-panel>\n              </div>\n          </div>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            evaluacion_kardex_service_1.EvaluacionKardexService])
    ], EvaluacionKardexEditorComponent);
    return EvaluacionKardexEditorComponent;
}(core_2.ProcessComponent));
exports.EvaluacionKardexEditorComponent = EvaluacionKardexEditorComponent;
