"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("framework3/core");
var forms_1 = require("@angular/forms");
var controls_1 = require("framework3/controls");
var core_2 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var checador_service_1 = require("../../services/checador.service");
var evento_usuario_1 = require("../../models/evento-usuario");
var EventosUsuarioEditor = /** @class */ (function (_super) {
    __extends(EventosUsuarioEditor, _super);
    function EventosUsuarioEditor(formBuilder, route, location, checadorService, context) {
        var _this = _super.call(this) || this;
        _this.formBuilder = formBuilder;
        _this.route = route;
        _this.location = location;
        _this.checadorService = checadorService;
        _this.context = context;
        _this.idEventoUsuario = 0;
        _this.eventoUsuario = new evento_usuario_1.EventoUsuarioInfo();
        _this.editorForm = formBuilder.group({
            'idEmpleado': [0, controls_1.AztecaValidators.selected],
            'fecha': [0, forms_1.Validators.required],
            'idChecador': [0, controls_1.AztecaValidators.selected],
            'restringir': [0],
            'idTipoEvento': [0, controls_1.AztecaValidators.selected],
            'mensaje': [0, forms_1.Validators.required]
        });
        return _this;
    }
    EventosUsuarioEditor.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) {
            _this.loadEvento();
        });
    };
    EventosUsuarioEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idEventoUsuario = +param['id'];
        });
    };
    EventosUsuarioEditor.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    EventosUsuarioEditor.prototype.applyPolicy = function (policy) {
    };
    EventosUsuarioEditor.prototype.onEmpleadoSelected = function (args) {
        if (args != undefined && args != null)
            this.eventoUsuario.codigo = args.code;
    };
    EventosUsuarioEditor.prototype.onCancel = function () {
        this.location.back();
    };
    EventosUsuarioEditor.prototype.onUpdate = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.checadorService.saveEventoUsuario(this.eventoUsuario).then(function (info) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert("Información actualizada", 'success');
            _this.location.back();
        }).catch(function (error) {
            _this.handleError(error);
        });
    };
    EventosUsuarioEditor.prototype.loadEvento = function () {
        var _this = this;
        if (this.idEventoUsuario > 0) {
            this.context.app.showSpinner();
            this.checadorService.getEventoUsuario(this.idEventoUsuario).then(function (info) {
                console.log(JSON.stringify(info));
                _this.eventoUsuario = info[0];
                console.log(JSON.stringify(_this.eventoUsuario));
                _this.context.app.hideSpinner();
            }).catch(function (error) {
                _this.handleError(error);
            });
        }
    };
    __decorate([
        core_2.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], EventosUsuarioEditor.prototype, "alerts", void 0);
    EventosUsuarioEditor = __decorate([
        core_2.Component({
            selector: 'eventos-usuario-editor',
            template: "\n      <form [formGroup]=\"editorForm\">\n\n          <div class=\"row\">\n              <div class=\"col-12 col-lg-8\">\n                  <alerts-bar></alerts-bar>\n                  <az-panel header=\"Evento Usuario\">\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-md-8\">\n                              <azteca-form-field [label]=\"'Empleado:'\">\n                                  <rh-empleado-selector formControlName=\"idEmpleado\" [(ngModel)]=\"eventoUsuario.idEmpleado\" (empleadoUpdated)=\"onEmpleadoSelected($event)\"></rh-empleado-selector>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-8\">\n                              <azteca-form-field [label]=\"'Hora a Aplicar:'\">\n                                  <az-input-date-time formControlName=\"fecha\" [(ngModel)]=\"eventoUsuario.fecha\"></az-input-date-time>\n                              </azteca-form-field>\n                          </div>\n                    \n                          <div class=\"col-12 col-md-8\">\n                              <azteca-form-field [label]=\"'Checador:'\">\n                                  <rh-checador-selector formControlName=\"idChecador\" [(ngModel)]=\"eventoUsuario.idChecador\"></rh-checador-selector>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-8\">\n                              <azteca-form-field [label]=\"'Restringir:'\">\n                                  <az-checkbox formControlName=\"restringir\" [(ngModel)]=\"eventoUsuario.restringir\"></az-checkbox>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-8\">\n                              <azteca-form-field [label]=\"'Tipo de Evento:'\">\n                                  <tipo-evento-selector formControlName=\"idTipoEvento\" [(ngModel)]=\"eventoUsuario.idEventoTipo\"></tipo-evento-selector>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-md-8\">\n                              <azteca-form-field [label]=\"'Mensaje:'\">\n                                  <az-textarea formControlName=\"mensaje\" [(ngModel)]=\"eventoUsuario.mensaje\"></az-textarea>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"onCancel()\">Cancelar</button>\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!editorForm.valid\">Guardar</button>\n                      </div> <!--Modal Footer-->\n\n                  </az-panel>\n              </div>\n\n          </div>\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, router_1.ActivatedRoute, common_1.Location, checador_service_1.ChecadorService, core_1.Context])
    ], EventosUsuarioEditor);
    return EventosUsuarioEditor;
}(core_1.BaseComponent));
exports.EventosUsuarioEditor = EventosUsuarioEditor;
