import { EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { FormGroup, FormBuilder } from '@angular/forms';
import * as wjcCore from 'wijmo/wijmo';
import { Context, ProcessComponent, PolicyInfo } from 'framework3/core';
import { AlertsBarComponent } from 'framework3/controls';
import { IncidenciaEmpleadoInfo } from '../../models/incidencia-empleado';
import { EmpleadoItem } from '../../models/empleado';
import { KardexAsistenciaService } from '../../services/kardex-asistencia.service';
import { EmpleadoListComponent } from '../../controls/empleado-list.component';
import { IncidenciaInfo } from "../../models/incidencia";
export declare class IncidenciaEmpleadoEditorComponent extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    private kardexAsistenciaSvc;
    catalogForm: FormGroup;
    catalogFormEmpleado: FormGroup;
    identity: number;
    readonlyMode: boolean;
    dirty: boolean;
    valid: boolean;
    validEmpleado: boolean;
    fechaIni: Date;
    fechaFin: Date;
    idIncidencia: number;
    idEmpleado: number;
    incidenciasByEmpleado: wjcCore.CollectionView;
    incidencia: IncidenciaInfo;
    folioEmpleado: string;
    observacionEmpleado: string;
    widthClass: string[];
    canceled: boolean;
    info: IncidenciaEmpleadoInfo;
    cvEmpleados: wjcCore.CollectionView;
    title: string;
    savedItem: EventEmitter<IncidenciaEmpleadoInfo>;
    alerts: AlertsBarComponent;
    selEmpleado: EmpleadoListComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, kardexAsistenciaSvc: KardexAsistenciaService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    private changeState;
    showAlert(message: string, type: string): void;
    private handleError;
    applyPolicy(policy: PolicyInfo): void;
    closeEditor(): void;
    saveHandler(): void;
    onAgregarEmpleado(): void;
    onSelectedEmleado(items: EmpleadoItem[]): void;
    onRowDeleteImpuesto(item: EmpleadoItem): void;
    refreshEmpleado(): void;
    invertirSeleccion(): void;
    onIncidenciaUpdated(info: IncidenciaInfo): void;
    asign(): void;
    saveIncidenciasEmpleado(): void;
}
