"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var wjcCore = require("wijmo/wijmo");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//
var incidencia_empleado_1 = require("../../models/incidencia-empleado");
var kardex_asistencia_service_1 = require("../../services/kardex-asistencia.service");
var empleado_list_component_1 = require("../../controls/empleado-list.component");
var moment = require("moment");
var IncidenciaEmpleadoEditorComponent = /** @class */ (function (_super) {
    __extends(IncidenciaEmpleadoEditorComponent, _super);
    function IncidenciaEmpleadoEditorComponent(context, router, route, location, formBuilder, kardexAsistenciaSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.kardexAsistenciaSvc = kardexAsistenciaSvc;
        _this.readonlyMode = false;
        _this.dirty = false;
        _this.valid = false;
        _this.idIncidencia = 0;
        _this.idEmpleado = 0;
        _this.incidenciasByEmpleado = new wjcCore.CollectionView();
        _this.folioEmpleado = '';
        _this.observacionEmpleado = '';
        _this.widthClass = [];
        _this.canceled = false;
        _this.info = new incidencia_empleado_1.IncidenciaEmpleadoInfo();
        _this.cvEmpleados = new wjcCore.CollectionView();
        _this.title = "Captura de incidencias";
        _this.savedItem = new core_1.EventEmitter();
        _this.catalogForm = formBuilder.group({
            'fecha': [null, forms_1.Validators.required],
            'incidencia': [0, controls_1.AztecaValidators.selected],
            'folio': [''],
            'observacion': ['']
        });
        _this.catalogFormEmpleado = formBuilder.group({
            'fechaIni': [null, forms_1.Validators.required],
            'fechaFin': [null, forms_1.Validators.required],
            'empleado': [0, controls_1.AztecaValidators.selected],
            'incidenciaEmpleado': [0],
            'folioEmpleado': [''],
            'observacionEmpleado': ['']
        });
        return _this;
    }
    IncidenciaEmpleadoEditorComponent.prototype.ngOnInit = function () {
        //Establecer el ancho establecido para la aplicación
        this.widthClass.push(this.context.app.defaultWidth);
        this.cvEmpleados.sourceCollection = this.info.empleados;
    };
    IncidenciaEmpleadoEditorComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (!this.catalogForm)
            return;
        this.catalogForm.statusChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.changeState(); });
        });
        this.catalogFormEmpleado.statusChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.changeState(); });
        });
        setTimeout(function (_) {
            _this.fechaIni = moment().subtract(10, 'day').toDate();
        });
    };
    IncidenciaEmpleadoEditorComponent.prototype.changeState = function () {
        this.valid = this.catalogForm.valid;
        this.dirty = this.catalogForm.dirty;
        this.validEmpleado = this.catalogFormEmpleado.valid;
    };
    IncidenciaEmpleadoEditorComponent.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    IncidenciaEmpleadoEditorComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    IncidenciaEmpleadoEditorComponent.prototype.applyPolicy = function (policy) {
        throw new Error("Method not implemented.");
    };
    ///////////////////////////////////////////////
    IncidenciaEmpleadoEditorComponent.prototype.closeEditor = function () {
        this.location.back();
    };
    IncidenciaEmpleadoEditorComponent.prototype.saveHandler = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.kardexAsistenciaSvc.updateIncidenciaEmpleado(this.info)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.location.back();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    IncidenciaEmpleadoEditorComponent.prototype.onAgregarEmpleado = function () {
        this.selEmpleado.show();
    };
    IncidenciaEmpleadoEditorComponent.prototype.onSelectedEmleado = function (items) {
        var _this = this;
        var elements = this.cvEmpleados.sourceCollection;
        items.forEach(function (item) {
            var empleado = null;
            elements.forEach(function (element) {
                if (item.id == element.id) {
                    empleado = item;
                }
            });
            if (empleado == null) {
                var element = _this.cvEmpleados.addNew();
                element.id = item.id;
                element.codigo = item.codigo;
                element.nombre = item.nombre;
                element.activo = item.activo;
                _this.cvEmpleados.commitNew();
            }
        });
    };
    IncidenciaEmpleadoEditorComponent.prototype.onRowDeleteImpuesto = function (item) {
        this.cvEmpleados.beginUpdate();
        this.cvEmpleados.remove(item);
        this.cvEmpleados.commitEdit();
    };
    ////////////////////////////////////////////Empleado///////////////////////////////
    IncidenciaEmpleadoEditorComponent.prototype.refreshEmpleado = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.kardexAsistenciaSvc.getIncidenciasByEmpleado(this.idEmpleado, this.fechaIni, this.fechaFin)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.incidenciasByEmpleado.sourceCollection = info;
            _this.incidenciasByEmpleado.refresh();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    IncidenciaEmpleadoEditorComponent.prototype.invertirSeleccion = function () {
        var i = 0;
        for (i = 0; i <= this.incidenciasByEmpleado.totalItemCount - 1; i++) {
            this.incidenciasByEmpleado._view[i].seleccion = !this.incidenciasByEmpleado._view[i].seleccion;
        }
        wjcCore.Control.invalidateAll();
    };
    IncidenciaEmpleadoEditorComponent.prototype.onIncidenciaUpdated = function (info) {
        this.incidencia = info;
    };
    IncidenciaEmpleadoEditorComponent.prototype.asign = function () {
        var i = 0;
        if (this.idIncidencia != 0) {
            for (i = 0; i <= this.incidenciasByEmpleado.totalItemCount - 1; i++) {
                if (this.incidenciasByEmpleado._view[i].seleccion) {
                    if (this.incidencia != undefined) {
                        this.incidenciasByEmpleado._view[i].nombreIncidencia = this.incidencia.nombre;
                        this.incidenciasByEmpleado._view[i].idIncidencia = this.incidencia.identity;
                        this.incidenciasByEmpleado._view[i].folio = this.folioEmpleado;
                        this.incidenciasByEmpleado._view[i].observaciones = this.observacionEmpleado;
                    }
                    this.incidenciasByEmpleado._view[i].seleccion = !this.incidenciasByEmpleado._view[i].seleccion;
                }
            }
            wjcCore.Control.invalidateAll();
        }
    };
    IncidenciaEmpleadoEditorComponent.prototype.saveIncidenciasEmpleado = function () {
        var _this = this;
        var i = 0;
        var incidencias = [];
        for (i = 0; i <= this.incidenciasByEmpleado.totalItemCount - 1; i++) {
            if (this.incidenciasByEmpleado._view[i].idIncidencia > 0) {
                incidencias.push(this.incidenciasByEmpleado._view[i]);
            }
        }
        if (incidencias.length > 0) {
            this.context.app.showSpinner();
            this.kardexAsistenciaSvc.updateIncidenciasByEmpleado(incidencias)
                .then(function (result) {
                _this.context.app.hideSpinner();
                _this.alerts.showAlert('Se guardaron con éxito las incidencias', 'success');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], IncidenciaEmpleadoEditorComponent.prototype, "title", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], IncidenciaEmpleadoEditorComponent.prototype, "savedItem", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], IncidenciaEmpleadoEditorComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild(empleado_list_component_1.EmpleadoListComponent),
        __metadata("design:type", empleado_list_component_1.EmpleadoListComponent)
    ], IncidenciaEmpleadoEditorComponent.prototype, "selEmpleado", void 0);
    IncidenciaEmpleadoEditorComponent = __decorate([
        core_1.Component({
            selector: 'rh-incidencias-empleado-editor',
            template: "\n\n          <div class=\"row\">\n              <div [ngClass]=\"widthClass\">\n\n                  <az-panel [header]=\"title\">\n\n                      <!--Barra de alertas-->\n                      <alerts-bar></alerts-bar>\n\n                      <tabset>\n                          <tab heading=\"Incidencias por Fecha\">\n                              <form [formGroup]=\"catalogForm\">\n                                  <!--Toolbar-->\n                                  <div class=\"btn-group\">\n                                      <button type=\"submit\" class=\"btn btn-primary\" (click)=\"saveHandler()\" [disabled]=\"!valid\">\n                                          <span class=\"glyphicon glyphicon-floppy-disk\" aria-hidden=\"true\"></span> Guardar\n                                      </button>\n                                      <!--En dispositivos peque\u00F1os se mostrar\u00E1 un bot\u00F3n con el \u00EDcono de cerrar, en dispositivos grandes se mostrar\u00E1 con texto-->\n                                      <button type=\"button\" class=\"btn btn-default d-none d-lg-block cancel-win\" (click)=\"closeEditor()\">\n                                          <span class=\"glyphicon glyphicon-remove\" aria-hidden=\"true\"></span> {{dirty ? 'Cancelar' : 'Cerrar'}}\n                                      </button>\n                                  </div>\n\n                                  <!--Controles del formulario-->\n                                  <div class=\"row\">\n                                      <div class=\"col-6\">\n                                          <azteca-form-field [label]=\"'Fecha:'\">\n                                              <az-input-date formControlName=\"fecha\"\n                                                             [(ngModel)]=\"info.fecha\">\n                                              </az-input-date>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-6\">\n                                          <azteca-form-field [label]=\"'Asignar la siguiente incidencia:'\">\n                                              <rh-incidencia-selector formControlName=\"incidencia\"\n                                                                      [(ngModel)]=\"info.idIncidencia\">\n                                              </rh-incidencia-selector>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-6\">\n                                          <azteca-form-field [label]=\"'Folio:'\">\n                                              <az-textbox formControlName=\"folio\"\n                                                          [(ngModel)]=\"info.folio\"></az-textbox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-6\">\n                                          <azteca-form-field [label]=\"'Observaciones:'\">\n                                              <az-textarea formControlName=\"observacion\"\n                                                           [(ngModel)]=\"info.observacion\">\n                                              </az-textarea>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAgregarEmpleado()\">\n                                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-plus\"></span>\n                                          Agregar\n                                      </button>\n                                  </div>\n                                  <wj-flex-grid style=\"height:500px\"\n                                                [itemsSource]=\"cvEmpleados\"\n                                                [selectionMode]=\"'Row'\">\n                                      <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                      <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                          <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                              <button type=\"button\" class=\"btn btn-default\" (click)=\"onRowDeleteImpuesto(cell.item)\">\n                                                  <span class=\"glyphicon glyphicon-remove\"></span>\n                                              </button>\n                                          </ng-template>\n                                      </wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  </wj-flex-grid>\n                              </form>\n                          </tab>\n                          <tab heading=\"Incidencias por Empleado\">\n                              <form [formGroup]=\"catalogFormEmpleado\">\n                                  <!--Toolbar-->\n                                  <div class=\"btn-group\">\n                                      <button type=\"submit\" class=\"btn btn-primary\" (click)=\"saveIncidenciasEmpleado()\" [disabled]=\"!validEmpleado\">\n                                          <span class=\"glyphicon glyphicon-floppy-disk\" aria-hidden=\"true\"></span> Guardar\n                                      </button>\n                                      <!--En dispositivos peque\u00F1os se mostrar\u00E1 un bot\u00F3n con el \u00EDcono de cerrar, en dispositivos grandes se mostrar\u00E1 con texto-->\n                                      <button type=\"button\" class=\"btn btn-default d-none d-lg-block cancel-win\" (click)=\"closeEditor()\">\n                                          <span class=\"glyphicon glyphicon-remove\" aria-hidden=\"true\"></span> {{dirty ? 'Cancelar' : 'Cerrar'}}\n                                      </button>\n                                  </div>\n\n                                  <!--Controles del formulario-->\n                                  <div class=\"row\">\n                                      <div class=\"col-6\">\n                                          <azteca-form-field [label]=\"'Empleado:'\">\n                                              <rh-empleado-selector formControlName=\"empleado\"\n                                                                      [(ngModel)]=\"idEmpleado\">\n                                              </rh-empleado-selector>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-6 \">\n                                          <azteca-form-field [label]=\"'Fecha Inicial:'\">\n                                              <az-input-date formControlName=\"fechaIni\"\n                                                             [(ngModel)]=\"fechaIni\">\n                                              </az-input-date>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-6 \">\n                                          <azteca-form-field [label]=\"'Fecha Final:'\">\n                                              <az-input-date formControlName=\"fechaFin\"\n                                                             [(ngModel)]=\"fechaFin\">\n                                              </az-input-date>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-6\">\n                                          <az-panel [header]=\"'Informaci\u00F3n de Incidencia'\">\n                                              <div class=\"row\">\n                                                  <div class=\" col-12\">\n                                                      <azteca-form-field [label]=\"'Incidencia:'\">\n                                                          <rh-incidencia-selector formControlName=\"incidenciaEmpleado\"\n                                                                                  [(ngModel)]=\"idIncidencia\"\n                                                                                  (incidenciaUpdated)=\"onIncidenciaUpdated($event)\">\n                                                          </rh-incidencia-selector>\n                                                      </azteca-form-field>\n                                                  </div>\n                                              </div>\n\n                                              <div class=\"row\">\n                                                  <div class=\"col-12\">\n                                                      <azteca-form-field [label]=\"'Folio:'\">\n                                                          <az-textbox formControlName=\"folioEmpleado\"\n                                                                      [(ngModel)]=\"folioEmpleado\"></az-textbox>\n                                                      </azteca-form-field>\n                                                  </div>\n                                              </div>\n\n                                              <div class=\"row\">\n                                                  <div class=\"col-12\">\n                                                      <azteca-form-field [label]=\"'Observaciones:'\">\n                                                          <az-textarea formControlName=\"observacionEmpleado\"\n                                                                       [(ngModel)]=\"observacionEmpleado\">\n                                                          </az-textarea>\n                                                      </azteca-form-field>\n                                                  </div>\n                                              </div>\n                                          </az-panel>\n\n                                       \n                                      </div>\n                                      <div class=\"col-2\">\n                                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"asign()\" [disabled]=\"incidencia == undefined\">\n                                              <span class=\"glyphicon glyphicon-ok\" aria-hidden=\"true\"></span> Asignar\n                                          </button>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"refreshEmpleado()\" [disabled]=\"!validEmpleado\">\n                                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-refresh\"></span>\n                                          Consultar\n                                      </button>\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"invertirSeleccion()\" [disabled]=\"!validEmpleado\">\n                                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-check\"></span>\n                                          Invertir Selecci\u00F3n\n                                      </button>\n                                  </div>\n\n                                  <wj-flex-grid style=\"height:500px\"\n                                                [itemsSource]=\"incidenciasByEmpleado\">\n                                      <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                      <wj-flex-grid-column [header]=\"'Seleccionar'\" [binding]=\"'seleccion'\" [width]=\"'10*'\" [isReadOnly]=\"false\" [align]=\"'center'\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Fecha'\" [binding]=\"'fecha'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Incidencia'\" [binding]=\"'nombreIncidencia'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"'20*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>}\n                                      <wj-flex-grid-column [header]=\"'Observaciones'\" [binding]=\"'observaciones'\" [width]=\"'30*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                                  </wj-flex-grid>\n\n                              </form>\n                          </tab>\n                      </tabset>\n                  </az-panel>\n              </div>\n          </div>\n\n      <rh-empleado-list (selectedItemsChanged)=\"onSelectedEmleado($event)\"\n                        [multiSelect]=\"true\">\n      </rh-empleado-list>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            kardex_asistencia_service_1.KardexAsistenciaService])
    ], IncidenciaEmpleadoEditorComponent);
    return IncidenciaEmpleadoEditorComponent;
}(core_2.ProcessComponent));
exports.IncidenciaEmpleadoEditorComponent = IncidenciaEmpleadoEditorComponent;
