"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var interfaz_adam_1 = require("../../models/interfaz-adam");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var interfaz_adam_service_1 = require("../../services/interfaz-adam.service");
var InterfazAdamDetail = /** @class */ (function (_super) {
    __extends(InterfazAdamDetail, _super);
    function InterfazAdamDetail(context, router, route, location, formBuilder, interfazAdamsvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.interfazAdamsvc = interfazAdamsvc;
        _this.widthClass = [];
        _this.idInterfazAdam = 0;
        _this.info = new interfaz_adam_1.InterfazAdamInfo();
        _this.catalogForm = formBuilder.group({
            'fechaIni': [null, forms_1.Validators.required],
            'fechaFin': [null, forms_1.Validators.required],
            'idDepartamento': [0, controls_1.AztecaValidators.selected],
            'idEmpresaAdam': [0, controls_1.AztecaValidators.selected],
        });
        return _this;
    }
    InterfazAdamDetail.prototype.ngOnInit = function () {
        var _this = this;
        //Establecer el ancho establecido para la aplicación
        this.widthClass.push(this.context.app.defaultWidth);
        this.route.params.forEach(function (params) {
            _this.idInterfazAdam = +params['id'];
            if (_this.idInterfazAdam > 0) {
                _this.context.app.showSpinner();
                _this.interfazAdamsvc.getDetail(_this.idInterfazAdam)
                    .then(function (result) {
                    _this.info = result;
                    _this.context.app.hideSpinner();
                }).catch(function (e) { return _this.handleError(e); });
            }
        });
    };
    InterfazAdamDetail.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    InterfazAdamDetail.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    InterfazAdamDetail.prototype.applyPolicy = function (policy) {
        throw new Error("Method not implemented.");
    };
    ///////////////////////////////////////////////
    InterfazAdamDetail.prototype.closeEditor = function () {
        this.location.back();
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], InterfazAdamDetail.prototype, "alerts", void 0);
    InterfazAdamDetail = __decorate([
        core_1.Component({
            selector: 'rh-interfaz-adam-det',
            template: "\n      <form [formGroup]=\"catalogForm\">\n          <div class=\"row\">\n              <div [ngClass]=\"widthClass\">\n\n                  <az-panel [header]=\"tittle\">\n\n                      <!--Barra de alertas-->\n                      <alerts-bar></alerts-bar>\n\n                      <!--Toolbar-->\n                      <div class=\"btn-group\">\n                          <!--En dispositivos peque\u00F1os se mostrar\u00E1 un bot\u00F3n con el \u00EDcono de cerrar, en dispositivos grandes se mostrar\u00E1 con texto-->\n                          <button type=\"button\" class=\"btn btn-default d-none d-lg-block cancel-win\" (click)=\"closeEditor()\">\n                              <span class=\"glyphicon glyphicon-remove\" aria-hidden=\"true\"></span> {{dirty ? 'Cancelar' : 'Cerrar'}}\n                          </button>\n                      </div>\n\n                      <!--Controles del formulario-->\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Fecha Inicial:'\">\n                                  <az-input-date formControlName=\"fechaIni\"\n                                                 [(ngModel)]=\"info.fechaIni\"\n                                                 [enabled]=\"false\">\n                                  </az-input-date>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Fecha Final:'\">\n                                  <az-input-date formControlName=\"fechaFin\"\n                                                 [(ngModel)]=\"info.fechaFin\"\n                                                 [enabled]=\"false\">\n                                  </az-input-date>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Departamento:'\">\n                                  <rh-departamento-selector formControlName=\"idDepartamento\"\n                                                            [(ngModel)]=\"info.idDepartamento\"\n                                                            [enabled]=\"false\">\n                                  </rh-departamento-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Empresa ADAM:'\">\n                                  <rh-empresa-adam-selector formControlName=\"idEmpresaAdam\"\n                                                            [(ngModel)]=\"info.idEmpresaAdam\"\n                                                            [enabled]=\"false\">\n                                  </rh-empresa-adam-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12\">\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <wj-flex-grid style=\"height:500px\"\n                                                    [itemsSource]=\"info.details\"\n                                                    [selectionMode]=\"'Row'\"\n                                                    (cellEditEnded)=\"onCellUpdated($event)\">\n                                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                          <wj-flex-grid-column [header]=\"'C\u00F3digo Empleado'\" [binding]=\"'codigoEmpleado'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Empleado'\" [binding]=\"'empleado'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Fecha'\" [binding]=\"'fecha'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Incidencia'\" [binding]=\"'incidencia'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      </wj-flex-grid>\n                                  </div>\n                              </div>\n                          </div>\n                      </div>\n\n                  </az-panel>\n              </div>\n          </div>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            interfaz_adam_service_1.InterfazAdamService])
    ], InterfazAdamDetail);
    return InterfazAdamDetail;
}(core_2.ProcessComponent));
exports.InterfazAdamDetail = InterfazAdamDetail;
