"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("framework3/core");
var forms_1 = require("@angular/forms");
var controls_1 = require("framework3/controls");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var interfaz_adam_1 = require("../../models/interfaz-adam");
var interfaz_adam_service_1 = require("../../services/interfaz-adam.service");
var InterfazAdamEditor = /** @class */ (function (_super) {
    __extends(InterfazAdamEditor, _super);
    function InterfazAdamEditor(context, router, route, location, formBuilder, interfazAdamSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.interfazAdamSvc = interfazAdamSvc;
        _this.readonlyMode = false;
        _this.dirty = false;
        _this.valid = false;
        _this.widthClass = [];
        _this.canceled = false;
        _this.info = new interfaz_adam_1.InterfazAdamInfo();
        _this.title = "Interfaz de Incidencias";
        _this.savedItem = new core_1.EventEmitter();
        _this.catalogForm = formBuilder.group({
            'fechaIni': [null, forms_1.Validators.required],
            'fechaFin': [null, forms_1.Validators.required],
            'idDepartamento': [0, controls_1.AztecaValidators.selected],
            'idEmpresaAdam': [0, controls_1.AztecaValidators.selected],
        });
        return _this;
    }
    InterfazAdamEditor.prototype.ngOnInit = function () {
        //Establecer el ancho establecido para la aplicación
        this.widthClass.push(this.context.app.defaultWidth);
    };
    InterfazAdamEditor.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (!this.catalogForm)
            return;
        this.catalogForm.statusChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.changeState(); });
        });
    };
    InterfazAdamEditor.prototype.changeState = function () {
        this.valid = this.catalogForm.valid;
        this.dirty = this.catalogForm.dirty;
    };
    InterfazAdamEditor.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    InterfazAdamEditor.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    InterfazAdamEditor.prototype.applyPolicy = function (policy) {
        throw new Error("Method not implemented.");
    };
    ///////////////////////////////////////////////
    InterfazAdamEditor.prototype.closeEditor = function () {
        this.location.back();
    };
    InterfazAdamEditor.prototype.onCargar = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.interfazAdamSvc.getEmpleadosInterfaz(this.info.fechaIni, this.info.fechaFin, this.info.idDepartamento, this.info.idEmpresaAdam, this.context.app.defaultSite.identity, this.context.app.defaultCompany.identity)
            .then(function (info) {
            _this.context.app.hideSpinner();
            console.log(JSON.stringify(info));
            _this.info.details = info;
        })
            .catch(function (error) {
            console.log(error);
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('Error al consultar ' + error, 'danger');
        });
    };
    InterfazAdamEditor.prototype.saveHandler = function () {
        var _this = this;
        this.info.idSucursal = this.context.app.defaultSite.identity;
        console.log(this.info);
        this.context.app.showSpinner();
        this.interfazAdamSvc.update(this.info)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.location.back();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], InterfazAdamEditor.prototype, "title", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], InterfazAdamEditor.prototype, "savedItem", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], InterfazAdamEditor.prototype, "alerts", void 0);
    InterfazAdamEditor = __decorate([
        core_1.Component({
            selector: 'rh-interfaz-adam-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n          <div class=\"row\">\n              <div [ngClass]=\"widthClass\">\n\n                  <az-panel [header]=\"tittle\">\n\n                      <!--Barra de alertas-->\n                      <alerts-bar></alerts-bar>\n\n                      <!--Toolbar-->\n                      <div class=\"btn-group\">\n                          <button type=\"submit\" class=\"btn btn-primary\" (click)=\"saveHandler()\" [disabled]=\"!valid\">\n                              <span class=\"glyphicon glyphicon-floppy-disk\" aria-hidden=\"true\"></span> Guardar\n                          </button>\n                          <!--En dispositivos peque\u00F1os se mostrar\u00E1 un bot\u00F3n con el \u00EDcono de cerrar, en dispositivos grandes se mostrar\u00E1 con texto-->\n                          <button type=\"button\" class=\"btn btn-default d-none d-lg-block cancel-win\" (click)=\"closeEditor()\">\n                              <span class=\"glyphicon glyphicon-remove\" aria-hidden=\"true\"></span> {{dirty ? 'Cancelar' : 'Cerrar'}}\n                          </button>\n                      </div>\n\n                      <!--Controles del formulario-->\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Fecha Inicial:'\">\n                                  <az-input-date formControlName=\"fechaIni\"\n                                                 [(ngModel)]=\"info.fechaIni\">\n                                  </az-input-date>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Fecha Final:'\">\n                                  <az-input-date formControlName=\"fechaFin\"\n                                                 [(ngModel)]=\"info.fechaFin\">\n                                  </az-input-date>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Departamento:'\">\n                                  <rh-departamento-selector formControlName=\"idDepartamento\"\n                                                            [(ngModel)]=\"info.idDepartamento\">\n                                  </rh-departamento-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Empresa ADAM:'\">\n                                  <rh-empresa-adam-selector formControlName=\"idEmpresaAdam\"\n                                                            [(ngModel)]=\"info.idEmpresaAdam\">\n                                  </rh-empresa-adam-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n                \n                      <div class=\"row\">\n                          <div class=\"col-12\">\n                              <button type=\"button\" class=\"btn btn-primary\" (click)=\"onCargar()\" [disabled]=\"!valid\">\n                                  <span aria-hidden=\"true\" class=\"glyphicon glyphicon-refresh\"></span>\n                                  Cargar\n                              </button>\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <wj-flex-grid style=\"height:500px\"\n                                                    [itemsSource]=\"info.details\"\n                                                    [selectionMode]=\"'Row'\"\n                                                    (cellEditEnded)=\"onCellUpdated($event)\">\n                                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                          <wj-flex-grid-column [header]=\"'C\u00F3digo Empleado'\" [binding]=\"'codigoEmpleado'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Empleado'\" [binding]=\"'empleado'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Fecha'\" [binding]=\"'fecha'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Incidencia'\" [binding]=\"'incidencia'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      </wj-flex-grid>\n                                  </div>\n                              </div>\n                          </div>\n                      </div>\n\n                  </az-panel>\n              </div>\n          </div>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            interfaz_adam_service_1.InterfazAdamService])
    ], InterfazAdamEditor);
    return InterfazAdamEditor;
}(core_2.ProcessComponent));
exports.InterfazAdamEditor = InterfazAdamEditor;
