import { FormGroup, FormBuilder, FormControl } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { Context, ProcessComponent, CatalogItem, PolicyInfo, ReportService } from 'framework3/core';
import { AlertsBarComponent, MenuItem, ContentViewerComponent } from 'framework3/controls';
import * as wjcCore from 'wijmo/wijmo';
import { Menu } from 'wijmo/wijmo.input';
import { PeriodoTrabajoService } from '../services/periodo-trabajo.service';
import { HorarioService } from '../services/horario.service';
import { TurnoService } from '../services/turno.service';
import { TurnoListComponent } from '../controls/turno-list.component';
import { HorarioListComponent } from '../controls/horario-list.component';
import { TurnoInfo } from '../models/turno';
import { HorarioInfo } from '../models/horario';
import { EmpleadoInfo } from '../models/empleado';
export declare class PeriodoTrabajoEmpleadoMaintenance extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    private peridoTrabajoSvc;
    private turnoSvc;
    private horarioSvc;
    private reportSvc;
    form: FormGroup;
    formFecha: FormGroup;
    tipoHorario: FormControl;
    idEmpleado: number;
    fechaIni: Date;
    fechaFin: Date;
    fecha: Date;
    valid: boolean;
    validFecha: boolean;
    idTurno: number;
    idHorario: number;
    widthClass: string[];
    menuIncidenciaItems: MenuItem[];
    titleContentView: string;
    fileNameContentView: string;
    dlgLstTurno: TurnoListComponent;
    dlgLstHorario: HorarioListComponent;
    alerts: AlertsBarComponent;
    reportViewer: ContentViewerComponent;
    cvPeriodoTrabajo: wjcCore.CollectionView;
    cvPeriodoTrabajoFecha: wjcCore.CollectionView;
    turnoInfo: TurnoInfo;
    horarioInfo: HorarioInfo;
    empleadoInfo: EmpleadoInfo;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, peridoTrabajoSvc: PeriodoTrabajoService, turnoSvc: TurnoService, horarioSvc: HorarioService, reportSvc: ReportService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    private changeState;
    closeEditor(): void;
    createMenuDetail(): void;
    onClickPeriodoActualizar(): void;
    onClickMnuPeriodo(menu: Menu): void;
    saveHandler(): void;
    onSelectedTurno(catalogItem: CatalogItem): void;
    onSelectedHorario(catalogItem: CatalogItem): void;
    printRPT(): void;
    onEmpleadoUpdate(empleado: EmpleadoInfo): void;
    applyPolicy(policy: PolicyInfo): void;
    private handleError;
    refresh(): void;
    invertirSeleccion(): void;
    onHorarioUpdate(info: HorarioInfo): void;
    onTurnoUpdated(info: TurnoInfo): void;
    asign(): void;
    saveFechas(): void;
    printFechaRPT(): void;
}
