"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
// Framework
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
// moment
var moment = require("moment");
// Wijmo
var wjcCore = require("wijmo/wijmo");
// Features
var periodo_trabajo_service_1 = require("../services/periodo-trabajo.service");
var horario_service_1 = require("../services/horario.service");
var turno_service_1 = require("../services/turno.service");
var turno_list_component_1 = require("../controls/turno-list.component");
var horario_list_component_1 = require("../controls/horario-list.component");
var PeriodoTrabajoEmpleadoMaintenance = /** @class */ (function (_super) {
    __extends(PeriodoTrabajoEmpleadoMaintenance, _super);
    function PeriodoTrabajoEmpleadoMaintenance(context, router, route, location, formBuilder, peridoTrabajoSvc, turnoSvc, horarioSvc, reportSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.peridoTrabajoSvc = peridoTrabajoSvc;
        _this.turnoSvc = turnoSvc;
        _this.horarioSvc = horarioSvc;
        _this.reportSvc = reportSvc;
        _this.idEmpleado = 0;
        _this.fechaIni = new Date();
        _this.fechaFin = new Date();
        _this.fecha = new Date();
        _this.valid = false;
        _this.validFecha = false;
        _this.idTurno = 0;
        _this.idHorario = 0;
        _this.widthClass = [];
        _this.menuIncidenciaItems = [];
        _this.titleContentView = "";
        _this.fileNameContentView = "";
        _this.cvPeriodoTrabajo = new wjcCore.CollectionView();
        _this.cvPeriodoTrabajoFecha = new wjcCore.CollectionView();
        _this.form = formBuilder.group({
            'idEmpleado': [null, controls_1.AztecaValidators.selected],
            'fechaIni': [null, forms_1.Validators.required],
            'fechaFin': [null, forms_1.Validators.required]
        });
        _this.formFecha = formBuilder.group({
            'fecha': [null, forms_1.Validators.required],
            'idTurno': [0],
            'idHorario': [0],
            'tipoHorario': ['']
        });
        _this.tipoHorario = _this.formFecha.controls['tipoHorario'];
        _this.tipoHorario.setValue('T');
        return _this;
    }
    PeriodoTrabajoEmpleadoMaintenance.prototype.ngOnInit = function () {
        //Establecer el ancho establecido para la aplicación
        this.widthClass.push(this.context.app.defaultWidth);
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (!this.form)
            return;
        setTimeout(function (_) {
            _this.fechaIni = moment().subtract(8, 'day').toDate();
            _this.fechaFin = moment().subtract(1, 'day').toDate();
            _this.fecha = moment().add(1, 'day').toDate();
            _this.createMenuDetail();
        });
        this.form.statusChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.changeState(); });
        });
        this.formFecha.statusChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.changeState(); });
        });
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.changeState = function () {
        this.valid = this.form.valid;
        this.validFecha = this.formFecha.valid;
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.closeEditor = function () {
        this.location.back();
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.createMenuDetail = function () {
        var mnuTurno = { icon: "glyphicon glyphicon-calendar", text: "Asignar Turno", name: "TURNO", smallText: "asignar turno" };
        var mnuHorario = { icon: "glyphicon glyphicon-time", text: "Asignar Horario", name: "HORARIO", smallText: "asignar horario" };
        var mnuRemove = { icon: "glyphicon glyphicon-remove", text: "Quitar Turno y/o Horario", name: "REMOVE", smallText: "asignar folio" };
        this.menuIncidenciaItems.push(mnuTurno, mnuHorario, mnuRemove);
        this.menuIncidenciaItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    ////////////////////////////////////////////////////////
    // Evnents handler
    PeriodoTrabajoEmpleadoMaintenance.prototype.onClickPeriodoActualizar = function () {
        var _this = this;
        if (this.valid) {
            this.context.app.showSpinner();
            this.peridoTrabajoSvc.getPeriodoTrabajo(this.idEmpleado, this.fechaIni, this.fechaFin)
                .then(function (info) {
                _this.cvPeriodoTrabajo.sourceCollection = info;
                _this.cvPeriodoTrabajo.refresh();
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.cvPeriodoTrabajo.sourceCollection = [];
            this.cvPeriodoTrabajo.refresh();
        }
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.onClickMnuPeriodo = function (menu) {
        var option = this.menuIncidenciaItems[menu.selectedIndex];
        if (option.name == "TURNO") {
            this.dlgLstTurno.show();
        }
        else if (option.name == "HORARIO") {
            this.dlgLstHorario.show();
        }
        else if (option.name == "REMOVE") {
            var periodoTrabajo = this.cvPeriodoTrabajo.currentItem;
            if (periodoTrabajo) {
                this.cvPeriodoTrabajo.editItem(periodoTrabajo);
                periodoTrabajo.idTurno = 0;
                periodoTrabajo.idHorario = 0;
                periodoTrabajo.turno = null;
                periodoTrabajo.horario = null;
                periodoTrabajo.entrada = null;
                periodoTrabajo.salida = null;
                periodoTrabajo.state = core_2.ChangeState.DELETED;
                this.cvPeriodoTrabajo.commitEdit();
            }
        }
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.saveHandler = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.peridoTrabajoSvc.updatePeriodoTurnoHorario(this.cvPeriodoTrabajo.items)
            .then(function (result) {
            _this.onClickPeriodoActualizar();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.onSelectedTurno = function (catalogItem) {
        var _this = this;
        this.context.app.showSpinner();
        this.turnoSvc.getDetailByID(catalogItem.id)
            .then(function (result) {
            var periodoTrabajo = _this.cvPeriodoTrabajo.currentItem;
            _this.cvPeriodoTrabajo.editItem(periodoTrabajo);
            periodoTrabajo.turno = result;
            periodoTrabajo.idTurno = result.identity;
            periodoTrabajo.horario = null;
            periodoTrabajo.idHorario = 0;
            periodoTrabajo.manual = true;
            periodoTrabajo.state = core_2.ChangeState.MODIFIED;
            _this.cvPeriodoTrabajo.commitEdit();
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.onSelectedHorario = function (catalogItem) {
        var _this = this;
        this.context.app.showSpinner();
        this.horarioSvc.getDetailByID(catalogItem.id)
            .then(function (result) {
            var periodoTrabajo = _this.cvPeriodoTrabajo.currentItem;
            _this.cvPeriodoTrabajo.editItem(periodoTrabajo);
            periodoTrabajo.horario = result;
            periodoTrabajo.idHorario = result.identity;
            periodoTrabajo.turno = null;
            periodoTrabajo.idTurno = 0;
            periodoTrabajo.manual = true;
            periodoTrabajo.state = core_2.ChangeState.MODIFIED;
            _this.cvPeriodoTrabajo.commitEdit();
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.printRPT = function () {
        var _this = this;
        this.context.app.showSpinner();
        var informe = new core_2.ReporteInfo();
        var parametroIdEmpleado = new core_2.ParametroInfo();
        var parametroFechaIni = new core_2.ParametroInfo();
        var parametroFechaFin = new core_2.ParametroInfo();
        var parametroNombre = new core_2.ParametroInfo();
        parametroIdEmpleado.name = "IdEmpleado";
        parametroIdEmpleado.values.push(this.idEmpleado.toString());
        parametroFechaIni.name = "FechaIni";
        parametroFechaIni.values.push(this.fechaIni.toLocaleDateString());
        parametroFechaFin.name = "FechaFin";
        parametroFechaFin.values.push(this.fechaFin.toLocaleDateString());
        parametroNombre.name = "Nombre";
        parametroNombre.values.push(this.empleadoInfo.persona.apellidoPaterno + " " + this.empleadoInfo.persona.apellidoMaterno + " " + this.empleadoInfo.persona.nombre);
        informe.parametros.push(parametroIdEmpleado);
        informe.parametros.push(parametroFechaIni);
        informe.parametros.push(parametroFechaFin);
        informe.parametros.push(parametroNombre);
        informe.path = "/Onili/RH/ReporteMovimientosPerTrabajo";
        informe.format = "pdf";
        this.reportSvc.loadReporte(informe)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.titleContentView = "Periodo de Trabajo";
            _this.fileNameContentView = "periodo_trabajo.pdf";
            _this.reportViewer.show("data:application/pdf; base64, " + info.content);
        })
            .catch(function (error) {
            _this.context.app.hideSpinner();
            _this.handleError(error);
        });
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.onEmpleadoUpdate = function (empleado) {
        this.empleadoInfo = empleado;
    };
    ////////////////////////////////////////////////////////
    PeriodoTrabajoEmpleadoMaintenance.prototype.applyPolicy = function (policy) {
        throw new Error("Method not implemented.");
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    ///////////////////Por Fecha/////////////////
    PeriodoTrabajoEmpleadoMaintenance.prototype.refresh = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.peridoTrabajoSvc.getPeriodoTrabajoFecha(this.context.app.defaultSite.identity, this.fecha)
            .then(function (info) {
            _this.cvPeriodoTrabajoFecha.sourceCollection = info;
            _this.cvPeriodoTrabajoFecha.refresh();
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.invertirSeleccion = function () {
        var i = 0;
        for (i = 0; i <= this.cvPeriodoTrabajoFecha.totalItemCount - 1; i++) {
            this.cvPeriodoTrabajoFecha._view[i].seleccion = !this.cvPeriodoTrabajoFecha._view[i].seleccion;
        }
        wjcCore.Control.invalidateAll();
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.onHorarioUpdate = function (info) {
        this.horarioInfo = info;
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.onTurnoUpdated = function (info) {
        this.turnoInfo = info;
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.asign = function () {
        console.log(this.tipoHorario);
        if (this.cvPeriodoTrabajoFecha.itemCount > 0) {
            var i = 0;
            for (i = 0; i <= this.cvPeriodoTrabajoFecha.totalItemCount - 1; i++) {
                if (this.cvPeriodoTrabajoFecha._view[i].seleccion) {
                    if (this.tipoHorario.value == 'T') {
                        if (this.turnoInfo != undefined) {
                            this.cvPeriodoTrabajoFecha._view[i].idTurnoTit = this.turnoInfo.identity;
                            this.cvPeriodoTrabajoFecha._view[i].turno = this.turnoInfo.nombre;
                            this.cvPeriodoTrabajoFecha._view[i].idHorario = 0;
                            this.cvPeriodoTrabajoFecha._view[i].horario = '';
                        }
                    }
                    else if (this.tipoHorario.value == 'H') {
                        if (this.horarioInfo != undefined) {
                            this.cvPeriodoTrabajoFecha._view[i].idHorario = this.horarioInfo.identity;
                            this.cvPeriodoTrabajoFecha._view[i].horario = this.horarioInfo.nombre;
                            this.cvPeriodoTrabajoFecha._view[i].idTurnoTit = 0;
                            this.cvPeriodoTrabajoFecha._view[i].turno = '';
                        }
                    }
                    this.cvPeriodoTrabajoFecha._view[i].seleccion = false;
                }
            }
            wjcCore.Control.invalidateAll();
        }
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.saveFechas = function () {
        var _this = this;
        var items = [];
        var i = 0;
        this.context.app.showSpinner();
        for (i = 0; i <= this.cvPeriodoTrabajoFecha.totalItemCount - 1; i++) {
            if (this.cvPeriodoTrabajoFecha._view[i].idTurnoTit != 0 || this.cvPeriodoTrabajoFecha._view[i].idHorario != 0) {
                items.push(this.cvPeriodoTrabajoFecha._view[i]);
            }
        }
        this.peridoTrabajoSvc.updatePeriodosFecha(this.fecha, items)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('Se agregaron con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodoTrabajoEmpleadoMaintenance.prototype.printFechaRPT = function () {
        var _this = this;
        this.context.app.showSpinner();
        var informe = new core_2.ReporteInfo();
        var parametroFecha = new core_2.ParametroInfo();
        var parametroSucursal = new core_2.ParametroInfo();
        parametroFecha.name = "Fecha";
        parametroFecha.values.push(this.fecha.toLocaleDateString());
        parametroSucursal.name = "IdSucursal";
        parametroSucursal.values.push(this.context.app.defaultSite.identity.toString());
        informe.parametros.push(parametroFecha);
        informe.parametros.push(parametroSucursal);
        informe.path = "/Onili/RH/ReporteMovimientosPeriodoTrabajoPorFecha";
        informe.format = "pdf";
        this.reportSvc.loadReporte(informe)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.titleContentView = "Periodo de Trabajo";
            _this.fileNameContentView = "periodo_trabajo.pdf";
            _this.reportViewer.show("data:application/pdf; base64, " + info.content);
        })
            .catch(function (error) {
            _this.context.app.hideSpinner();
            _this.handleError(error);
        });
    };
    __decorate([
        core_1.ViewChild('lstDlgTurno'),
        __metadata("design:type", turno_list_component_1.TurnoListComponent)
    ], PeriodoTrabajoEmpleadoMaintenance.prototype, "dlgLstTurno", void 0);
    __decorate([
        core_1.ViewChild('lstDlgHorario'),
        __metadata("design:type", horario_list_component_1.HorarioListComponent)
    ], PeriodoTrabajoEmpleadoMaintenance.prototype, "dlgLstHorario", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], PeriodoTrabajoEmpleadoMaintenance.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild(controls_1.ContentViewerComponent),
        __metadata("design:type", controls_1.ContentViewerComponent)
    ], PeriodoTrabajoEmpleadoMaintenance.prototype, "reportViewer", void 0);
    PeriodoTrabajoEmpleadoMaintenance = __decorate([
        core_1.Component({
            selector: 'rh-periodo-trabajo-empleado',
            template: "\n\n          <div class=\"row\">\n              <div [ngClass]=\"widthClass\">\n\n                  <az-panel [header]=\"'Asignaci\u00F3n de periodos temporales de trabajo'\">\n                      <alerts-bar></alerts-bar>\n                      <tabset>\n                          <tab heading=\"Por Empleado\">\n                              <!--Barra de alertas-->\n                              <form [formGroup]=\"form\">\n                                  <!--Toolbar-->\n                                  <div class=\"btn-group\">\n                                      <button type=\"submit\" class=\"btn btn-primary\" (click)=\"saveHandler()\">\n                                          <span class=\"glyphicon glyphicon-floppy-disk\" aria-hidden=\"true\"></span> Guardar\n                                      </button>\n                                      <button type=\"submit\" class=\"btn btn-primary\" (click)=\"printRPT()\" [disabled]=\"!valid\">\n                                          <span class=\"glyphicon glyphicon-print\" aria-hidden=\"true\"></span> Imprimir\n                                      </button>\n                                      <!--En dispositivos peque\u00F1os se mostrar\u00E1 un bot\u00F3n con el \u00EDcono de cerrar, en dispositivos grandes se mostrar\u00E1 con texto-->\n                                      <button type=\"button\" class=\"btn btn-default d-none d-lg-block cancel-win\" (click)=\"closeEditor()\">\n                                          <span class=\"glyphicon glyphicon-remove\" aria-hidden=\"true\"></span> Cerrar\n                                      </button>\n                                  </div>\n\n                                  <!--Controles del formulario-->\n                                  <div class=\"row\">\n                                      <div class=\"col-6\">\n                                          <azteca-form-field [label]=\"'Empleado:'\">\n                                              <rh-empleado-selector formControlName=\"idEmpleado\"\n                                                                    [(ngModel)]=\"idEmpleado\"\n                                                                    (empleadoUpdated)=\"onEmpleadoUpdate($event)\">\n                                              </rh-empleado-selector>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-6\">\n                                          <azteca-form-field [label]=\"'Fecha Incio:'\">\n                                              <az-input-date formControlName=\"fechaIni\"\n                                                             [(ngModel)]=\"fechaIni\">\n                                              </az-input-date>\n                                          </azteca-form-field>\n                                      </div>\n                                      <div class=\"col-6\">\n                                          <azteca-form-field [label]=\"'Fecha Fin:'\">\n                                              <az-input-date formControlName=\"fechaFin\"\n                                                             [(ngModel)]=\"fechaFin\">\n                                              </az-input-date>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickPeriodoActualizar()\" [disabled]=\"!valid\">\n                                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-refresh\"></span>\n                                          Consultar\n                                      </button>\n                                  </div>\n\n                                  <wj-flex-grid style=\"height:500px\"\n                                                [itemsSource]=\"cvPeriodoTrabajo\"\n                                                [selectionMode]=\"'Row'\"\n                                                [wjContextMenu]=\"ctxMenuPeriodo\">\n                                      <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                      <wj-flex-grid-column [header]=\"'Fecha'\" [binding]=\"'fecha'\" [width]=\"'30*'\" [format]=\"'dddd, dd MMMM yyyy'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Turno'\" [binding]=\"'turno.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Horario'\" [binding]=\"'horario.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Entrada'\" [binding]=\"'entrada'\" [width]=\"80\" [format]=\"'HH:mm'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Salida'\" [binding]=\"'salida'\" [width]=\"80\" [format]=\"'HH:mm'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  </wj-flex-grid>\n                              </form>\n                          </tab>\n                          <tab heading=\"Por Fecha\">\n                              <form [formGroup]=\"formFecha\">\n                                  <div class=\"row\">\n                                      <div [ngClass]=\"widthClass\">\n                                          <!--Toolbar-->\n                                          <div class=\"btn-group\">\n                                              <button type=\"submit\" class=\"btn btn-primary\" (click)=\"saveFechas()\" [disabled]=\"this.cvPeriodoTrabajoFecha.totalItemCount==0\">\n                                                  <span class=\"glyphicon glyphicon-floppy-disk\" aria-hidden=\"true\"></span> Guardar\n                                              </button>\n                                              <button type=\"submit\" class=\"btn btn-primary\" (click)=\"printFechaRPT()\" [disabled]=\"!validFecha\">\n                                                  <span class=\"glyphicon glyphicon-print\" aria-hidden=\"true\"></span> Imprimir\n                                              </button>\n                                          </div>\n\n                                          <!--Controles del formulario-->\n                                          <div class=\"row\">\n                                              <div class=\"col-6\">\n                                                  <azteca-form-field [label]=\"'Fecha:'\">\n                                                      <az-input-date formControlName=\"fecha\"\n                                                                     [(ngModel)]=\"fecha\">\n                                                      </az-input-date>\n                                                  </azteca-form-field>\n                                              </div>\n                                          </div>\n\n                                          <div class=\"row\" style=\"padding:10px\">\n                                              <div class=\"col-1\">\n                                                  <label class=\"form-check-inline\">\n                                                      <input class=\"form-check-input\" type=\"radio\" formControlName=\"tipoHorario\" name=\"tipoHorario\" value=\"T\"> Turno\n                                                  </label>\n                                              </div>\n                                              <div class=\"col-6\">\n                                                  <rh-turno-selector formControlName=\"idTurno\"\n                                                                     [(ngModel)]=\"idTurno\"\n                                                                     (empleadoUpdated)=\"onTurnoUpdated($event)\">\n\n                                                  </rh-turno-selector>\n                                              </div>\n                                              <div class=\"col-2\">\n                                                  <button type=\"button\" class=\"btn btn-primary\" (click)=\"asign()\" [disabled]=\"!validFecha\">\n                                                      <span class=\"glyphicon glyphicon-ok\" aria-hidden=\"true\"></span> Asignar\n                                                  </button>\n                                              </div>\n                                          </div>\n\n                                          <div class=\"row\" style=\"padding:10px\">\n                                              <div class=\"col-1\">\n                                                  <label class=\"form-check-inline\">\n                                                      <input class=\"form-check-input\" type=\"radio\" formControlName=\"tipoHorario\" name=\"tipoHorario\" value=\"H\"> Horario\n                                                  </label>\n                                              </div>\n                                              <div class=\"col-6\">\n                                                  <rh-horario-selector formControlName=\"idHorario\"\n                                                                       [(ngModel)]=\"idHorario\"\n                                                                       (horarioUpdated)=\"onHorarioUpdate($event)\">\n                                                  </rh-horario-selector>\n                                              </div>\n                                          </div>\n                                          <div class=\"row\">\n                                              <button type=\"button\" class=\"btn btn-primary\" (click)=\"refresh()\" [disabled]=\"!validFecha\">\n                                                  <span aria-hidden=\"true\" class=\"glyphicon glyphicon-refresh\"></span>\n                                                  Consultar\n                                              </button>\n                                              <button type=\"button\" class=\"btn btn-primary\" (click)=\"invertirSeleccion()\" [disabled]=\"!validFecha\">\n                                                  <span aria-hidden=\"true\" class=\"glyphicon glyphicon-check\"></span>\n                                                  Invertir Selecci\u00F3n\n                                              </button>\n                                          </div>\n\n                                          <wj-flex-grid style=\"height:500px\"\n                                                        [itemsSource]=\"cvPeriodoTrabajoFecha\">\n                                              <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                              <wj-flex-grid-column [header]=\"'Seleccionar'\" [binding]=\"'seleccion'\" [width]=\"'10*'\" [isReadOnly]=\"false\" [align]=\"'center'\"></wj-flex-grid-column>\n                                              <wj-flex-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                              <wj-flex-grid-column [header]=\"'Empleado'\" [binding]=\"'nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                              <wj-flex-grid-column [header]=\"'Departamento'\" [binding]=\"'departamento'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                              <wj-flex-grid-column [header]=\"'Turno'\" [binding]=\"'turno'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                              <wj-flex-grid-column [header]=\"'Horario'\" [binding]=\"'horario'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                              <wj-flex-grid-column [header]=\"'Entrada'\" [binding]=\"'horaEnt'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                              <wj-flex-grid-column [header]=\"'Salida'\" [binding]=\"'horaSal'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                              <wj-flex-grid-column [header]=\"'Comida'\" [binding]=\"'horaComida'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          </wj-flex-grid>\n                                      </div>\n                                  </div>\n                              </form>\n                          </tab>\n                      </tabset>\n                  </az-panel>\n              </div>\n          </div>\n\n\n      <rh-turno-list #lstDlgTurno\n                     (selectedItemChanged)=\"onSelectedTurno($event)\"\n                     [multiSelect]=\"false\">\n      </rh-turno-list>\n\n      <rh-horario-list #lstDlgHorario\n                       (selectedItemChanged)=\"onSelectedHorario($event)\"\n                       [multiSelect]=\"false\">\n      </rh-horario-list>\n\n      <wj-menu #ctxMenuPeriodo (itemClicked)=\"onClickMnuPeriodo(ctxMenuPeriodo)\" style=\"display:none\">\n          <wj-menu-item *ngFor=\"let item of menuIncidenciaItems\">\n              <div *ngIf=\"item.enabled\">\n                  <span [class]=\"item.icon\"></span>\n                  <b>{{item.text}}</b>\n                  <br>\n                  <small><i>{{item.smallText}}</i></small>\n              </div>\n          </wj-menu-item>\n      </wj-menu>\n\n      <azteca-content-viewer></azteca-content-viewer>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            periodo_trabajo_service_1.PeriodoTrabajoService,
            turno_service_1.TurnoService,
            horario_service_1.HorarioService,
            core_2.ReportService])
    ], PeriodoTrabajoEmpleadoMaintenance);
    return PeriodoTrabajoEmpleadoMaintenance;
}(core_2.ProcessComponent));
exports.PeriodoTrabajoEmpleadoMaintenance = PeriodoTrabajoEmpleadoMaintenance;
