"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("framework3/core");
var forms_1 = require("@angular/forms");
var controls_1 = require("framework3/controls");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var checador_service_1 = require("../services/checador.service");
var motivo_service_1 = require("../services/motivo.service");
var moment = require("moment");
var wijmo_1 = require("wijmo/wijmo");
var PlancharChecadasMaintenance = /** @class */ (function (_super) {
    __extends(PlancharChecadasMaintenance, _super);
    function PlancharChecadasMaintenance(context, router, route, location, formBuilder, checadorSvc, motivoSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.checadorSvc = checadorSvc;
        _this.motivoSvc = motivoSvc;
        _this.fecha = new Date();
        _this.valid = false;
        _this.widthClass = [];
        _this.idMotivo = 0;
        _this.motivos = [];
        _this.periodosEmpleados = new wijmo_1.CollectionView();
        _this.form = formBuilder.group({
            'idMotivo': [null, controls_1.AztecaValidators.selected],
            'fecha': [null, forms_1.Validators.required]
        });
        return _this;
    }
    PlancharChecadasMaintenance.prototype.ngOnInit = function () {
        var _this = this;
        //Establecer el ancho establecido para la aplicación
        this.widthClass.push(this.context.app.defaultWidth);
        setTimeout(function () {
            _this.motivoSvc.loadCbo(_this.context.app.defaultSite.identity)
                .then(function (info) {
                _this.motivos = info;
                _this.motivos.unshift({ id: 0, codigo: '', nombre: '[Seleccione un motivo]', Descripcion: '' });
            })
                .catch(function (error) { return _this.handleError(error); });
        });
    };
    PlancharChecadasMaintenance.prototype.applyPolicy = function (policy) {
        throw new Error("Method not implemented.");
    };
    PlancharChecadasMaintenance.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (!this.form)
            return;
        setTimeout(function (_) {
            _this.fecha = moment().subtract(1, 'day').toDate();
        });
        this.form.statusChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.changeState(); });
        });
    };
    PlancharChecadasMaintenance.prototype.changeState = function () {
        this.valid = this.form.valid;
    };
    PlancharChecadasMaintenance.prototype.closeEditor = function () {
        this.location.back();
    };
    PlancharChecadasMaintenance.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    PlancharChecadasMaintenance.prototype.refresh = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.periodosEmpleados.sourceCollection = [];
        this.periodosEmpleados.refresh();
        this.checadorSvc.getPeriodoTrabaoEmpleados(this.context.app.defaultCompany.identity, this.context.app.defaultSite.identity, this.fecha)
            .then(function (info) {
            console.log(info);
            _this.periodosEmpleados.sourceCollection = info;
            _this.periodosEmpleados.refresh();
            _this.context.app.hideSpinner();
        })
            .catch(function (error) {
            _this.handleError(error);
        });
    };
    PlancharChecadasMaintenance.prototype.saveHandler = function () {
        var _this = this;
        this.context.app.showSpinner();
        var items = [];
        for (var i = 0; i <= this.periodosEmpleados.totalItemCount - 1; i++) {
            if (this.periodosEmpleados._view[i].sel || this.periodosEmpleados._view[i].selFin || this.periodosEmpleados._view[i].selIni) {
                items.push(this.periodosEmpleados._view[i]);
            }
        }
        this.checadorSvc.plancharChecadas(items, this.idMotivo, this.context.session.user.identity, this.context.session.user.code)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('Se plancharon las checadas y se reprocesarán los empleados', 'success');
            _this.periodosEmpleados.sourceCollection = [];
            wijmo_1.Control.invalidateAll();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], PlancharChecadasMaintenance.prototype, "alerts", void 0);
    PlancharChecadasMaintenance = __decorate([
        core_1.Component({
            selector: 'rh-planchar-checada',
            template: "\n      <form [formGroup]=\"form\">\n          <div class=\"row\">\n              <div [ngClass]=\"widthClass\">\n\n                  <az-panel [header]=\"'Planchar Checadas'\">\n\n                      <!--Barra de alertas-->\n                      <alerts-bar></alerts-bar>\n\n                      <!--Toolbar-->\n                      <div class=\"btn-group\">\n                          <button type=\"submit\" class=\"btn btn-primary\" (click)=\"saveHandler()\" [disabled]=\"this.periodosEmpleados.totalItemCount==0\">\n                              <span class=\"glyphicon glyphicon-floppy-disk\" aria-hidden=\"true\"></span> Guardar\n                          </button>\n                          <!--En dispositivos peque\u00F1os se mostrar\u00E1 un bot\u00F3n con el \u00EDcono de cerrar, en dispositivos grandes se mostrar\u00E1 con texto-->\n                          <button type=\"button\" class=\"btn btn-default d-none d-lg-block cancel-win\" (click)=\"closeEditor()\">\n                              <span class=\"glyphicon glyphicon-remove\" aria-hidden=\"true\"></span> Cerrar\n                          </button>\n                      </div>\n\n                      <!--Controles del formulario-->\n\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Fecha:'\">\n                                  <az-input-date formControlName=\"fecha\"\n                                                 [(ngModel)]=\"fecha\">\n                                  </az-input-date>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Incidencia:'\">\n                                  <azteca-form-field [label]=\"'Motivo:'\">\n                                      <az-combobox formControlName=\"idMotivo\"\n                                                   [(ngModel)]=\"idMotivo\"\n                                                   [items]=\"motivos\"\n                                                   [displayMember]=\"'nombre'\"\n                                                   [valueMember]=\"'id'\">\n                                      </az-combobox>\n                                  </azteca-form-field>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n\n\n                      <div class=\"row\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"refresh()\" [disabled]=\"!valid\">\n                              <span aria-hidden=\"true\" class=\"glyphicon glyphicon-refresh\"></span>\n                              Consultar\n                          </button>\n                      </div>\n\n                      <wj-flex-grid style=\"height:500px\"\n                                    [itemsSource]=\"periodosEmpleados\">\n                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                          <wj-flex-grid-column [header]=\"'x'\" [binding]=\"'sel'\" [width]=\"'10*'\" [isReadOnly]=\"false\" [align]=\"'center'\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Codigo'\" [binding]=\"'codEmpleado'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Empleado'\" [binding]=\"'empleado'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'x'\" [binding]=\"'selIni'\" [width]=\"'10*'\" [isReadOnly]=\"false\" [align]=\"'center'\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Entrada'\" [binding]=\"'horaEntrada'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Comida'\" [binding]=\"'horaComida'\" [width]=\"'20*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Regreso'\" [binding]=\"'retComida'\" [width]=\"'20*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'x'\" [binding]=\"'selFin'\" [width]=\"'10*'\" [isReadOnly]=\"false\" [align]=\"'center'\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Salida'\" [binding]=\"'horaSalida'\" [width]=\"'20*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                      </wj-flex-grid>\n\n                  </az-panel>\n              </div>\n          </div>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            checador_service_1.ChecadorService,
            motivo_service_1.MotivoService])
    ], PlancharChecadasMaintenance);
    return PlancharChecadasMaintenance;
}(core_2.ProcessComponent));
exports.PlancharChecadasMaintenance = PlancharChecadasMaintenance;
