"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
// Wijmo
var wjcCore = require("wijmo/wijmo");
var clase_nomina_service_1 = require("../services/clase-nomina.service");
var modal_directive_1 = require("ngx-bootstrap/modal/modal.directive");
var rango_vacacional_1 = require("../models/rango-vacacional");
var RangosVacacionalesMaintenance = /** @class */ (function (_super) {
    __extends(RangosVacacionalesMaintenance, _super);
    function RangosVacacionalesMaintenance(context, router, route, location, formBuilder, claseNominaService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.claseNominaService = claseNominaService;
        _this.idClaseNomina = null;
        _this.valid = false;
        _this.widthClass = [];
        _this.cvRangos = new wjcCore.CollectionView();
        _this.eliminadas = [];
        _this.motivos = [];
        _this.menuRangoItems = [];
        // 
        _this.currentRango = new rango_vacacional_1.RangoVacacionalInfo();
        _this.form = formBuilder.group({
        //        'idClaseNomina': [0, AztecaValidators.selected],           
        });
        _this.formRango = formBuilder.group({
            'anios': [null, forms_1.Validators.required],
            'dias': [null, forms_1.Validators.required],
            'diasAcumulado': [null, forms_1.Validators.required],
            'diasVacaciones': [null, forms_1.Validators.required],
            'diasDisfrute': [null, forms_1.Validators.required],
            'diasVacacionesSin': [null, forms_1.Validators.required],
            'diasDisfruteSin': [null, forms_1.Validators.required],
        });
        _this.cvRangos.sourceCollection = [];
        return _this;
    }
    RangosVacacionalesMaintenance.prototype.ngOnInit = function () {
        var _this = this;
        //Establecer el ancho establecido para la aplicación
        this.widthClass.push(this.context.app.defaultWidth);
        //setTimeout(() => {
        //    this.motivoSvc.loadCbo(this.context.app.defaultSite.identity)
        //        .then(info => {
        //            this.motivos = info;
        //            this.motivos.unshift({ id: 0, codigo: '', nombre: '[Seleccione un motivo]', Descripcion: '' });
        //        })
        //        .catch(error => this.handleError(error));
        //});
        if (this.route.params) {
            this.route.params.forEach(function (param) {
                _this.idClaseNomina = +param['idClaseNomina'];
            });
        }
        setTimeout(function (_) {
            _this.onClickActualizar();
        });
    };
    RangosVacacionalesMaintenance.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (!this.form)
            return;
        setTimeout(function (_) {
            _this.createMenuDetail();
        });
        this.form.statusChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.changeState(); });
        });
    };
    RangosVacacionalesMaintenance.prototype.changeState = function () {
        this.valid = this.form.valid;
    };
    RangosVacacionalesMaintenance.prototype.createMenuDetail = function () {
        var mnuEditar = { icon: "glyphicon glyphicon-pencil", text: "Editar", name: "EDIT", smallText: "editar rango vacacional" };
        var mnuQuitar = { icon: "glyphicon glyphicon-remove", text: "Eliminar", name: "QUITAR", smallText: "eliminar rango vacacional" };
        this.menuRangoItems.push(mnuEditar);
        this.menuRangoItems.push(mnuQuitar);
        this.menuRangoItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    ////////////////////////////////////////////////////////
    RangosVacacionalesMaintenance.prototype.onClickGuardar = function () {
        var _this = this;
        this.context.app.showSpinner();
        var items = this.cvRangos.items;
        var rangos = items.concat(this.eliminadas);
        this.claseNominaService.saveRangosVacacionales(rangos)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.onClickActualizar();
            _this.alerts.showAlert("La información se guardo correctamente", "ok");
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RangosVacacionalesMaintenance.prototype.onSelectedClaseChanged = function (item) {
        this.onClickActualizar();
    };
    RangosVacacionalesMaintenance.prototype.onClickCerrar = function () {
        this.location.back();
    };
    RangosVacacionalesMaintenance.prototype.onClickActualizar = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.claseNominaService.getRangosVacacionales(this.idClaseNomina)
            .then(function (result) {
            _this.eliminadas = [];
            _this.cvRangos.sourceCollection = result;
            _this.cvRangos.refresh();
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RangosVacacionalesMaintenance.prototype.onClickAgregar = function () {
        //
        this.currentRango = new rango_vacacional_1.RangoVacacionalInfo();
        this.currentRango._clientID = 0;
        //
        this.dlgRango.config.backdrop = false;
        this.dlgRango.show();
    };
    RangosVacacionalesMaintenance.prototype.onClickMenu = function (menu) {
        var option = this.menuRangoItems[menu.selectedIndex];
        if (option.name == "QUITAR") {
            var item = this.cvRangos.currentItem;
            if (item) {
                item.state = core_2.ChangeState.DELETED;
                this.cvRangos.remove(item);
                this.eliminadas.push(item);
            }
        }
        if (option.name == "EDIT") {
            //Editar
            this.currentRango = this.copyRango(this.cvRangos.currentItem);
            this.dlgRango.config.backdrop = false;
            this.dlgRango.show();
        }
    };
    //onClickRangoAceptar() {        
    //    if (this.validarNew()==true) {
    //        this.context.app.showSpinner();
    //        let rangoVacac = <RangoVacacionalInfo>this.cvTransacciones.addNew();
    //        rangoVacac.idClaseNomina = this.idClaseNomina;
    //        rangoVacac.anios = this.anios;
    //        rangoVacac.dias = this.dias;
    //        rangoVacac.diasAcumulado = this.diasAcumulado;
    //        rangoVacac.diasVacaciones = this.diasVacaciones;
    //        rangoVacac.diasDisfrute = this.diasDisfrute;
    //        rangoVacac.state = ChangeState.ADDED;
    //        this.cvTransacciones.commitNew();
    //        this.dlgRango.hide();
    //        this.context.app.hideSpinner();
    //    }
    //}
    RangosVacacionalesMaintenance.prototype.onClickRangoAceptar = function () {
        var _this = this;
        var newRangos = this.cvRangos.sourceCollection.slice();
        this.currentRango.state = 'MODIFIED';
        this.currentRango.idClaseNomina = this.idClaseNomina;
        if (this.currentRango._clientID == 0) {
            this.currentRango._clientID = this.cvRangos.sourceCollection.length + 1;
            newRangos.push(this.currentRango);
        }
        else {
            var index = newRangos.findIndex(function (item) { return item._clientID == _this.currentRango._clientID; });
            newRangos[index] = this.currentRango;
        }
        //this.producto.insumos = newInsumos;
        this.cvRangos.sourceCollection = newRangos;
        this.dlgRango.hide();
    };
    RangosVacacionalesMaintenance.prototype.copyRango = function (original) {
        return JSON.parse(JSON.stringify(original));
    };
    ////////////////////////////////////////////////////////
    RangosVacacionalesMaintenance.prototype.validarNew = function () {
        var _this = this;
        var existAnio = this.cvRangos.items.find(function (rango) { return rango.anios == _this.currentRango.anios; });
        if (existAnio != null || existAnio != undefined) {
            this.alertsEdit.showAlert("Un rango para esa cantidad de años ya existe en los elementos de esta clase de nómina", 'warning');
            return false;
        }
        if (this.currentRango.dias > this.currentRango.diasAcumulado) {
            this.alertsEdit.showAlert("No puede ser mayor los dias de inicio a los dias acumulados", 'warning');
            return false;
        }
        return true;
    };
    RangosVacacionalesMaintenance.prototype.applyPolicy = function (policy) {
        throw new Error("Method not implemented.");
    };
    RangosVacacionalesMaintenance.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild('#alertsGral'),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], RangosVacacionalesMaintenance.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('alertsEdit'),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], RangosVacacionalesMaintenance.prototype, "alertsEdit", void 0);
    __decorate([
        core_1.ViewChild('dlgRango'),
        __metadata("design:type", modal_directive_1.ModalDirective)
    ], RangosVacacionalesMaintenance.prototype, "dlgRango", void 0);
    RangosVacacionalesMaintenance = __decorate([
        core_1.Component({
            selector: 'rh-rangos-vacacionales',
            template: "\n      <form [formGroup]=\"form\">\n          <div class=\"row\">\n              <div [ngClass]=\"widthClass\">\n\n                  <az-panel [header]=\"'Administraci\u00F3n de rangos vacacionales'\">\n\n                      <!--Barra de alertas-->\n                      <alerts-bar #alertsGral></alerts-bar>\n\n                      <!--Toolbar-->\n                      <div class=\"row\">\n                          <div class=\"btn-group\">\n                              <button type=\"submit\" class=\"btn btn-primary\" (click)=\"onClickGuardar()\">\n                                  <span class=\"glyphicon glyphicon-floppy-disk\" aria-hidden=\"true\"></span> Guardar\n                              </button>\n\n                              <!--En dispositivos peque\u00F1os se mostrar\u00E1 un bot\u00F3n con el \u00EDcono de cerrar, en dispositivos grandes se mostrar\u00E1 con texto-->\n                              <button type=\"button\" class=\"btn btn-default d-none d-lg-block cancel-win\" (click)=\"onClickCerrar()\">\n                                  <span class=\"glyphicon glyphicon-remove\" aria-hidden=\"true\"></span> Cerrar\n                              </button>\n                          </div>\n                      </div>\n\n                      <!--Controles del formulario-->\n                      <!--<div class=\"row\">\n                          <div class=\"col-12 flex-lg-grow-1\">\n                              <azteca-form-field [label]=\"'clase de n\u00F3mina:'\">\n                                  <rh-clase-nomina-selector formControlName=\"idClaseNomina\" [(ngModel)]=\"idClaseNomina\" (claseNominaUpdated)=\"onSelectedClaseChanged($event)\"></rh-clase-nomina-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>-->\n\n                      <div class=\"row\">\n                          <div class=\"btn-group\">                      \n\n                              <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickAgregar()\" >\n                                  <span aria-hidden=\"true\" class=\"glyphicon glyphicon-plus\"></span>\n                                  Agregar\n                              </button>\n                          </div>\n                      </div>\n\n                      <wj-flex-grid style=\"height:500px\"\n                                    [itemsSource]=\"cvRangos\"\n                                    [selectionMode]=\"'Row'\"\n                                    [wjContextMenu]=\"ctxMenuRango\">\n                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                          <wj-flex-grid-column [header]=\"'A\u00F1os'\" [binding]=\"'anios'\" [width]=\"90\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Dias'\" [binding]=\"'dias'\" [width]=\"90\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Dias Acumulados'\" [binding]=\"'diasAcumulado'\" [width]=\"160\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Dias Vacaciones'\" [binding]=\"'diasVacaciones'\" [width]=\"160\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Dias Disfrute'\" [binding]=\"'diasDisfrute'\" [width]=\"160\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Dias Vacaciones(Sindicalizado)'\" [binding]=\"'diasVacacionesSin'\" [width]=\"160\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Dias Disfrute(Sindicalizado)'\" [binding]=\"'diasDisfruteSin'\" [width]=\"160\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n\n                      </wj-flex-grid>\n\n                  </az-panel>\n              </div>\n          </div>\n      </form>\n\n      <wj-menu #ctxMenuRango (itemClicked)=\"onClickMenu(ctxMenuRango)\" style=\"display:none\">\n          <wj-menu-item *ngFor=\"let item of menuRangoItems\">\n              <div *ngIf=\"item.enabled\">\n                  <span [class]=\"item.icon\"></span>\n                  <b>{{item.text}}</b>\n                  <br>\n                  <small><i>{{item.smallText}}</i></small>\n              </div>\n          </wj-menu-item>\n      </wj-menu>\n\n\n\n      <!--DIALOGO DE RANGO VACACIONAL-->\n      <div bsModal #dlgRango=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\" role=\"document\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\" id=\"exampleModalLabel\">Agregar nuevo rango vacacional</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"dlgRango.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <form [formGroup]=\"formRango\">\n                          <alerts-bar #alertsEdit></alerts-bar>\n                          <div class=\"row\">\n                              <div class=\"col-6\">\n                                  <azteca-form-field [label]=\"'A\u00F1o:'\">\n                                      <az-input-number formControlName=\"anios\"\n                                                       [(ngModel)]=\"currentRango.anios\"\n                                                       [min]=\"1\"\n                                                       [max]=\"60\">\n                                      </az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-6\">\n                                  <azteca-form-field [label]=\"'Dias:'\">\n                                      <az-input-number formControlName=\"dias\"\n                                                       [(ngModel)]=\"currentRango.dias\"\n                                                       [min]=\"((currentRango.anios-1)*365)\"\n                                                       [max]=\"((currentRango.anios-1)*365)+365\">\n                                      </az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-6\">\n                                  <azteca-form-field [label]=\"'Dias Acumulados:'\">\n                                      <az-input-number formControlName=\"diasAcumulado\"\n                                                       [(ngModel)]=\"currentRango.diasAcumulado\"\n                                                       [min]=\"currentRango.dias+1\"\n                                                       [max]=\"currentRango.dias+365\">\n                                      </az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-12 col-md-6\">\n                                  <azteca-form-field [label]=\"'Dias Vacaciones:'\">\n                                      <az-input-number formControlName=\"diasVacaciones\"\n                                                       [(ngModel)]=\"currentRango.diasVacaciones\"\n                                                       [min]=\"1\"\n                                                       [max]=\"60\">\n                                      </az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                              <div class=\"col-12 col-md-6\">\n                                  <azteca-form-field [label]=\"'Dias Vacaciones sindicalizados:'\">\n                                      <az-input-number formControlName=\"diasVacacionesSin\"\n                                                       [(ngModel)]=\"currentRango.diasVacacionesSin\"\n                                                       [min]=\"1\"\n                                                       [max]=\"60\">\n                                      </az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-md-6\">\n                                  <azteca-form-field [label]=\"'Dias a disfrutar:'\">\n                                      <az-input-number formControlName=\"diasDisfrute\"\n                                                       [(ngModel)]=\"currentRango.diasDisfrute\"\n                                                       [min]=\"1\"\n                                                       [max]=\"60\">\n                                      </az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                              <div class=\"col-12 col-md-6\">\n                                  <azteca-form-field [label]=\"'Dias a disfrutar sindicalizados:'\">\n                                      <az-input-number formControlName=\"diasDisfruteSin\"\n                                                       [(ngModel)]=\"currentRango.diasDisfruteSin\"\n                                                       [min]=\"1\"\n                                                       [max]=\"60\">\n                                      </az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                      </form>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickRangoAceptar()\" [disabled]=\"!formRango.valid\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dlgRango.hide()\">Cancelar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            clase_nomina_service_1.ClaseNominaService])
    ], RangosVacacionalesMaintenance);
    return RangosVacacionalesMaintenance;
}(core_2.ProcessComponent));
exports.RangosVacacionalesMaintenance = RangosVacacionalesMaintenance;
