import { FormGroup, FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { ModalDirective } from 'ngx-bootstrap';
import * as wjcCore from 'wijmo/wijmo';
import { Context, BaseComponent, PolicyInfo } from 'framework3/core';
import { SearchRequest } from 'framework3/search';
import { AlertsBarComponent } from 'framework3/controls/index';
import { NominaAdamInfo } from '../models/recibo-nomina-adam';
import { MenuItem } from "framework3/controls";
import { ReciboAdamService } from '../services/recibo-adam.service';
import { ReciboNominaService } from '../services/recibo-nomina.service';
import { ProgramacionReciboAdamService } from '../services/programacion-recibo-adam.service';
import { ContentViewerComponent } from 'framework3/controls/components/content-viewer.component';
export declare class ReciboAdamMaintenance extends BaseComponent {
    private context;
    private router;
    private route;
    private location;
    private formBuilder;
    private reciboAdamService;
    private reciboNominaSvc;
    private programacionReciboSvc;
    editForm: FormGroup;
    titleDialog: string;
    currentRecibos: Array<any>;
    currentItem: any;
    fechaInicial: Date;
    fechaFinal: Date;
    currentProgramacion: Array<any>;
    currentItemProg: any;
    fechaInicialProg: Date;
    fechaFinalProg: Date;
    collectionSustitucion: wjcCore.CollectionView;
    fechaInicialSustitucion: Date;
    fechaFinalSustitucion: Date;
    errorProgramacion: Array<any>;
    errorDisplay: string;
    idProgramacion: string;
    timerInterval: any;
    titleContentView: string;
    fileNameContentView: string;
    errorDialog: boolean;
    errorServer: string;
    menuItems: MenuItem[];
    menuItemsProg: MenuItem[];
    request: SearchRequest;
    requestProg: SearchRequest;
    requestSustitucion: SearchRequest;
    totalRows: number;
    pageIndex: number;
    totalRowsProg: number;
    pageIndexProg: number;
    totalRowsSustitucion: number;
    pageIndexSustitucion: number;
    adamNomina: NominaAdamInfo;
    presupuesto: any;
    toRefresh: any;
    alerts: AlertsBarComponent;
    reportViewer: ContentViewerComponent;
    dlgComprobante: ModalDirective;
    dlgTipoComprobante: ModalDirective;
    dlgErrorComprobante: ModalDirective;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, reciboAdamService: ReciboAdamService, reciboNominaSvc: ReciboNominaService, programacionReciboSvc: ProgramacionReciboAdamService);
    ngAfterViewInit(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
    onCurrentItemChanged(item: any): void;
    onCurrentItemProgChanged(item: any): void;
    refreshList(): void;
    refreshListSustucion(): void;
    searchRequested(request: SearchRequest): void;
    createMenu(): void;
    createMenuProg(): void;
    optionClick(option: MenuItem): void;
    generarComprobante(): void;
    cancelarComprobante(): void;
    agregarComprobante(): void;
    onPresupuestoSelected(args: any): void;
    onCancelar(): void;
    onGenerarFiniquito(sustitucion: boolean): void;
    onGenerarRecibo(sustitucion: boolean): void;
    searchRequestedProg(request: SearchRequest): void;
    refreshListProg(): void;
    optionClickProg(option: MenuItem): void;
    optionClickSustitucion(option: MenuItem): void;
    agregarProgramacion(): void;
    agregarProgramacionSustitucion(): void;
    onProcesoCancelar(args: any): void;
    onCloseDialogComprobante(): void;
    onCloseDialogErrorComprobante(): void;
    verificarTaskDownload(): void;
    onClickSeleccionar(): void;
    onClickInvertir(): void;
}
