import { CatalogInfo, CatalogItem } from 'framework3/core';
import { EmpleadoInfo } from './empleado';
export declare class CedulaFiniquitoInfo extends CatalogInfo {
    idEmpleado: number;
    departamento: string;
    bodega: string;
    puesto: string;
    sindicalizado: boolean;
    idRescicionLaboral: number;
    fechaAntiguedad: Date;
    ultimoDiaLaborado: Date;
    fechaBaja: Date;
    fechaUltimoAguinaldo: Date;
    diasAguinaldoContrato: number;
    disfrutePrevioAguinaldo: boolean;
    primaVacacionalPendiente: boolean;
    pirmaVacExentaPagada: number;
    porcentajePrimaVacacional: number;
    diasVacacionesPendiente: number;
    diasVacacionesGeneradas: number;
    totalDiasVacaciones: number;
    porcentajePrimaAntiguedad: number;
    porcentajeVeinteDiasAnio: number;
    sueldoDiario: number;
    sueldoPromedio: number;
    sueldoDiarioIntegrado: number;
    ausentismo: number;
    sueldoDias: number;
    sueldoImporte: number;
    comisiones: number;
    incentivos: number;
    horasExtraImporte: number;
    primaVacacionalPendienteEntrega: number;
    primaDominicalNumDomingos: number;
    primaDominicalImporte: number;
    repartoUtilidades: number;
    diasNegociadoIndemnizacion: number;
    indemnnizacionAdicional: number;
    otros: number;
    salarioMinimoZona: number;
    uma: number;
    aguinaldoSindicato: number;
    idTaskComision: number;
    infonavit: number;
    fonacot: number;
    autoriza: string;
    periodoPago: number;
    adeudo: number;
    importeNetoFiniquito: number;
    infonavitOrFonacot: boolean;
    primaVacacionalExento: number;
    empleado: EmpleadoInfo;
    clase: ClaseNomina;
    conceptosNegociacion: Array<CedulaConcepto>;
    conceptosApoyo: Array<CedulaConcepto>;
    conceptosIsr: Array<CedulaConcepto>;
    seguros: Array<SeguroIMSS>;
    conceptosPrevio: Array<CedulaConcepto>;
    tarifasPagosProvicionales: Array<TarifaPagoProvicional>;
    subsidiosEmpleo: Array<SubsidioEmpleo>;
    comisionPeriodos: Array<ComisionPeriodo>;
    variables: Array<Variable>;
    eliminar: Array<CedulaConcepto>;
    acumuladosBajas: Array<AcumuladoBajaTit>;
    constructor();
}
export declare class CedulaFiniquitoItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
    selected?: boolean;
}
export declare class CedulaConcepto {
    idCedulaConcepto: number;
    idCedulaFiniquito: number;
    idConcepto: number;
    concepto: string;
    idClasificacionConcepto: number;
    cantidad: number;
    importeGravado: number;
    importeExento: number;
    importeTotal: number;
    idParent: number;
    acumula: string;
    conceptoFiniquito: ConceptoFiniquito;
    clasificacionConcepto: ClasificacionConcepto;
    constructor();
}
export declare class ConceptoFiniquito {
    idConceptoFiniquito: number;
    concepto: string;
    idClasificacionConcepto: number;
    cantidadManual: boolean;
    totalManual: boolean;
    gravadoManual: boolean;
    exentoManual: boolean;
    orden: number;
    observable: string;
    procesos: Array<FiniquitoProceso>;
    constructor();
}
export declare class FiniquitoProceso {
    idProceso: number;
    nombre: string;
    descripcion: string;
    proceso: string;
    constructor();
}
export declare class ClasificacionConcepto {
    idClasificacionConcepto: number;
    descripcion: string;
    tipo: string;
    constructor();
}
export declare class RescisionLaboral {
    idRescisionLaboral: number;
    descripcion: string;
    constructor();
}
export declare class TarifaPagoProvicional {
    idTarifaPAgoProvicional: number;
    idCompania: number;
    limiteInferior: number;
    limiteSuperior: number;
    cuotaFija: number;
    porcentaje: number;
    constructor();
}
export declare class SubsidioEmpleo {
    idSubsidioEmpleo: number;
    idCompania: number;
    limiteInferior: number;
    limiteSuperior: number;
    subsidio: number;
    subsidioDiario: SubsidioEmpleo;
    constructor();
}
export declare class SeguroIMSS {
    idSeguro: number;
    seguro: string;
    dias: number;
    porcentaje: number;
    calculo: number;
    constructor();
}
export declare class ComisionPeriodo {
    idCedulaFiniquito: number;
    anio: number;
    periodo: number;
    fechaInicio: Date;
    fechaTermino: Date;
    fechaPago: Date;
    importe: number;
    pagado: boolean;
    constructor();
}
export declare class ClaseNomina {
    idClaseNomina: number;
    clase: string;
    descripcion: string;
    idCompania: number;
    porcPrimaVacacional: number;
    porcPrimaAntiguedad: number;
    porcVeinteDiasAnio: number;
    aguinaldo: number;
    aguinaldoSindicato: number;
    constructor();
}
export declare class AsyncTaskInfo {
    idTask: number;
    fecha: Date;
    horaInicio: Date;
    horaFin: Date;
    referencia: string;
    completo: boolean;
    ejecutando: boolean;
    error: boolean;
    errorEjecucion: string;
    result: string;
    constructor();
}
export declare class Variable {
    compania: string;
    trabajador: string;
    secuencia: number;
    variableTrabajador: number;
    constructor();
}
export declare class AcumuladoBajaTit {
    idAcumulado: number;
    claseNomina: number;
    tipoNomina: string;
    periodo: number;
    percepciones: number;
    deducciones: number;
    neto: number;
    acumuladoDet: Array<AcumuladoDet>;
    constructor();
}
export declare class AcumuladoDet {
    clave: string;
    concepto: string;
    percepciones: number;
    deducciones: number;
    tiempo: number;
}
