import { CatalogInfo, CatalogItem, TrackableItem } from 'framework3/core';
export declare class PeriodicidadPagoInfo extends CatalogInfo {
    nombre: string;
    descripcion: string;
    dias: number;
    periodos: PeriodoItem[];
    constructor();
}
export declare class PeriodicidadPagoItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
    selected?: boolean;
}
export declare class PeriodoItem extends TrackableItem {
    codigo: string;
    nombre: string;
    fechaIniPago: Date;
    fechaFinPago: Date;
    fechaIniIncidencia: Date;
    fechaFinIncidencia: Date;
    periodoDias: PeriodoDiaItem[];
    constructor();
}
export declare class PeriodoDiaItem extends TrackableItem {
    fechaIncidencia: Date;
    feriado: boolean;
    formaPago: number;
    constructor();
}
