import { DocumentInfo, DocumentItem, TrackableItem } from 'framework3/core';
import { ReciboNominaDetail } from './recibo-nomina-detail';
export declare class ReciboNominaInfo extends DocumentInfo<ReciboNominaDetail> {
    fechaAfectacion: Date;
    idComprobante: string;
    fechaComprobante: Date;
    tipoNomina: string;
    idEmpleado: number;
    percepcionGravado: number;
    percepcionExento: number;
    otrosPagos: number;
    deduccion: number;
    subTotal: number;
    descuento: number;
    total: number;
    numDiasPago: number;
    fechaPago: Date;
    fechaInicialPago: Date;
    fechaFinalPago: Date;
    idBanco: number;
    lugarExpedicion: string;
    idCuentaPorPagar: string;
    fechaCuentaPorPagar: Date;
    idDivisa: number;
    tipoCambio: number;
    idDocumento: string;
    fechaDocumento: string;
    idCFDSerie: number;
    emisor: EmisorInfo;
    receptor: ReceptorInfo;
    relaciones: RelacionInfo[];
    subContrataciones: SubContratacionInfo[];
    constructor();
}
export declare class ReciboNominaItem extends DocumentItem {
    fechaPago?: Date;
    idComprobante?: string;
    numTrabajador?: string;
}
export declare class EmisorInfo {
    rfc: string;
    nombre: string;
    regimenFiscal: string;
    curp: string;
    registroPatronal: string;
    origenRecurso: string;
    montoRecursoPropio: number;
    rfcPatronOrigen: string;
}
export declare class ReceptorInfo {
    fechaInicioRelLaboral: Date;
    antiguedad: string;
    tipoContrato: string;
    sindicalizado: boolean;
    tipoJornada: string;
    tipoRegimen: string;
    numEmpleado: string;
    departamento: string;
    puesto: string;
    riesgoPuesto: string;
    periodicidadPago: string;
    banco: string;
    cuentaBancaria: string;
    salarioBaseCotApor: number;
    salarioDiarioIntegrado: number;
    claveEntFed: string;
}
export declare class RelacionInfo extends TrackableItem {
    idComprobante: string;
    fechaComprobante: Date;
    uuid: string;
    tipoRelacion: string;
}
export declare class SubContratacionInfo extends TrackableItem {
    rfcLabora: string;
    porcentajeTiempo: number;
}
