import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { FormBuilder, FormGroup } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap/modal/modal.directive';
import { Context, ProcessComponent, PolicyInfo } from "framework3/core";
import { ContentViewerComponent, AlertsBarComponent, MenuItem } from 'framework3/controls';
import { EditableListComponent } from 'framework3/editors';
import { EmpleadoService } from '../services/empleado.service';
import { DocumentoEmpleadoItem } from '../models/empleado';
import { DocumentoTipoListComponent } from '../controls/documentos-tipo-list.component';
import { DocumentoTipoInfo, DocumentoTipoItem } from '../models/documento-tipo';
export declare class DocumentoEmpleadoComponent extends ProcessComponent {
    private location;
    private empleadoService;
    formDocumento: FormGroup;
    idEmpleado: number;
    proceso: string;
    titleContentView: string;
    fileNameContentView: string;
    documentos: DocumentoEmpleadoItem[];
    currentDocumento: DocumentoEmpleadoItem;
    alerts: AlertsBarComponent;
    dlgDocumento: ModalDirective;
    dlgDocmentoTipo: DocumentoTipoListComponent;
    editListDocumentos: EditableListComponent;
    reportViewer: ContentViewerComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, builder: FormBuilder, location: Location, empleadoService: EmpleadoService);
    ngOnInit(): void;
    loadDocumentos(): void;
    onAddingItemDocumento(): void;
    onListItemUpdateDocumento(items: DocumentoEmpleadoItem[]): void;
    onDeletingDocumento(item: DocumentoEmpleadoItem): void;
    onSelectedItemDocumentoTipo(item: DocumentoTipoItem): void;
    onUpdatedDocumento(): void;
    onSelectedDocumentoTipo(item: DocumentoTipoInfo): void;
    onMenuItemClick(option: MenuItem): void;
    onCancel(): void;
    handleError(error: any): void;
    createClientID(): number;
    cloneInfo<T>(element: any): T;
    applyPolicy(policy: PolicyInfo): void;
}
