"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var modal_directive_1 = require("ngx-bootstrap/modal/modal.directive");
//moment
var moment = require("moment");
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
var empleado_service_1 = require("../services/empleado.service");
var empleado_1 = require("../models/empleado");
var documentos_tipo_list_component_1 = require("../controls/documentos-tipo-list.component");
var DocumentoEmpleadoComponent = /** @class */ (function (_super) {
    __extends(DocumentoEmpleadoComponent, _super);
    function DocumentoEmpleadoComponent(context, router, route, builder, location, empleadoService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.location = location;
        _this.empleadoService = empleadoService;
        _this.idEmpleado = 0;
        _this.proceso = '';
        _this.titleContentView = "";
        _this.fileNameContentView = "";
        _this.documentos = [];
        _this.currentDocumento = new empleado_1.DocumentoEmpleadoItem();
        _this.formDocumento = builder.group({
            'idDocumentoTipo': [null, controls_1.AztecaValidators.selected],
            'archivo': [null, controls_1.AztecaValidators.validFile],
            'descripcion': ['']
        });
        return _this;
    }
    DocumentoEmpleadoComponent.prototype.ngOnInit = function () {
        var _this = this;
        setTimeout(function () {
            _this.route.params.forEach(function (param) {
                _this.idEmpleado = +param['id'];
            });
            _this.route.queryParams.forEach(function (param) {
                _this.proceso = param['process'] || '';
            });
            console.log(_this.proceso);
            _this.loadDocumentos();
        });
    };
    DocumentoEmpleadoComponent.prototype.loadDocumentos = function () {
        var _this = this;
        setTimeout(function () {
            _this.empleadoService.getDocumentos(_this.idEmpleado)
                .then(function (items) {
                _this.documentos = items.filter(function (x) { return x.proceso == _this.proceso; });
            })
                .catch(function (error) { return _this.handleError(error); });
        });
    };
    DocumentoEmpleadoComponent.prototype.onAddingItemDocumento = function () {
        this.dlgDocmentoTipo.show();
    };
    DocumentoEmpleadoComponent.prototype.onListItemUpdateDocumento = function (items) {
        this.documentos = items;
    };
    DocumentoEmpleadoComponent.prototype.onDeletingDocumento = function (item) {
        var _this = this;
        this.context.app.showSpinner();
        this.empleadoService.deleteDocumento(item.id)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.editListDocumentos.deleteItem(item);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DocumentoEmpleadoComponent.prototype.onSelectedItemDocumentoTipo = function (item) {
        if (this.documentos.filter(function (X) { return X.idDocumentoTipo == item.id && X.state != 'DELETED'; }).length == 0) {
            this.currentDocumento = new empleado_1.DocumentoEmpleadoItem();
            this.currentDocumento._clientID = this.createClientID();
            this.currentDocumento.idDocumentoTipo = item.id;
            this.dlgDocumento.config.backdrop = false;
            this.dlgDocumento.show();
        }
        else {
            this.alerts.showAlert('Ya existe un documento de ese tipo', 'danger');
        }
    };
    DocumentoEmpleadoComponent.prototype.onUpdatedDocumento = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.empleadoService.updateDocumento(this.idEmpleado, this.currentDocumento)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.dlgDocumento.hide();
            _this.loadDocumentos();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DocumentoEmpleadoComponent.prototype.onSelectedDocumentoTipo = function (item) {
        this.currentDocumento.documentoTipo = item;
    };
    DocumentoEmpleadoComponent.prototype.onMenuItemClick = function (option) {
        var _this = this;
        if (option.name == 'PREVIEW') {
            var documento = this.editListDocumentos.currentItem;
            if (documento) {
                this.context.app.showSpinner();
                this.empleadoService.getDocumento(documento.idArchivo)
                    .then(function (item) {
                    _this.context.app.hideSpinner();
                    _this.titleContentView = "Documento " + item.originalFileName;
                    _this.fileNameContentView = item.id + "." + item.extension;
                    _this.reportViewer.show('/file-server/' + item.fileUri);
                })
                    .catch(function (e) { return _this.handleError(e); });
            }
        }
    };
    DocumentoEmpleadoComponent.prototype.onCancel = function () {
        this.location.back();
    };
    DocumentoEmpleadoComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    DocumentoEmpleadoComponent.prototype.createClientID = function () {
        return parseInt((Math.random() * 1000).toString()) * 1000 + parseInt(moment().format("HHmmss"));
    };
    DocumentoEmpleadoComponent.prototype.cloneInfo = function (element) {
        return JSON.parse(JSON.stringify(element));
    };
    // Implementation Process
    DocumentoEmpleadoComponent.prototype.applyPolicy = function (policy) {
        throw new Error("Method not implemented.");
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], DocumentoEmpleadoComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('dlgDocumento'),
        __metadata("design:type", modal_directive_1.ModalDirective)
    ], DocumentoEmpleadoComponent.prototype, "dlgDocumento", void 0);
    __decorate([
        core_1.ViewChild('dlgDocmentoTipo'),
        __metadata("design:type", documentos_tipo_list_component_1.DocumentoTipoListComponent)
    ], DocumentoEmpleadoComponent.prototype, "dlgDocmentoTipo", void 0);
    __decorate([
        core_1.ViewChild('editListDocumentos'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], DocumentoEmpleadoComponent.prototype, "editListDocumentos", void 0);
    __decorate([
        core_1.ViewChild(controls_1.ContentViewerComponent),
        __metadata("design:type", controls_1.ContentViewerComponent)
    ], DocumentoEmpleadoComponent.prototype, "reportViewer", void 0);
    DocumentoEmpleadoComponent = __decorate([
        core_1.Component({
            selector: 'rh-documento-empleado',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-md-10\">\n              <az-panel [header]=\"'Documentos Empleado'\">\n                  <alerts-bar></alerts-bar>\n                  <div class=\"row\">\n                      <div class=\"col-12\">\n\n                          <azteca-editable-list #editListDocumentos\n                                                [allowNew]=\"true\"\n                                                [allowEdit]=\"true\"\n                                                [listItems]=\"documentos\"\n                                                (addingItem)=\"onAddingItemDocumento()\"\n                                                (listItemsUpdated)=\"onListItemUpdateDocumento($event)\"\n                                                (deletingItem)=\"onDeletingDocumento($event)\"\n                                                (menuItemClick)=\"onMenuItemClick($event)\">\n\n                              <!-- OPCIONES DEL MENU-->\n                              <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n                              <azteca-menu-item [name]=\"'PREVIEW'\" [icon]=\"'glyphicon glyphicon-open'\" [text]=\"'Preview'\" [smallText]=\"'documento'\"></azteca-menu-item>\n                              <!-- COLUMNAS DEL GRID-->\n                              <azteca-grid-column [header]=\"'Tipo'\" [binding]=\"'documentoTipo.nombre'\" [width]=\"140\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Descripci\u00F3n'\" [binding]=\"'descripcion'\" [width]=\"'180*'\"></azteca-grid-column>\n                          </azteca-editable-list>\n\n                      </div>\n                  </div>\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-danger\" (click)=\"onCancel()\">Cerrar</button>\n\n                  </div> <!--Modal Footer-->\n\n              </az-panel>\n          </div>\n      </div>\n\n      <azteca-content-viewer [title]=\"titleContentView\" [fileName]=\"fileNameContentView\"></azteca-content-viewer>\n\n      <rh-documentos-tipo-list #dlgDocmentoTipo\n                               [multiSelect]=\"false\"\n                               [proceso] =\"proceso\"\n                               (selectedItemChanged)=\"onSelectedItemDocumentoTipo($event)\">\n      </rh-documentos-tipo-list>\n\n\n      <div bsModal #dlgDocumento=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n\n                  <div class=\"modal-header\">\n                      <!--Modal Header-->\n                      <h4>Documento</h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"dlgDocumento.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div> <!--Modal Header-->\n                  <div class=\"modal-body\">\n                      <form [formGroup]=\"formDocumento\">\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-md-6\">\n                                  <azteca-form-field [label]=\"'Tipo de Documento:'\">\n                                      <rh-documento-tipo-selector formControlName=\"idDocumentoTipo\"\n                                                                  [(ngModel)]=\"currentDocumento.idDocumentoTipo\"\n                                                                  [proceso]=\"proceso\"\n                                                                  (documentoTipoUpdated)=\"onSelectedDocumentoTipo($event)\">\n                                      </rh-documento-tipo-selector>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-lg-6\">\n                                  <azteca-form-field [label]=\"'Archivo:'\">\n                                      <azteca-file-box formControlName=\"archivo\"\n                                                       [(ngModel)]=\"currentDocumento.archivo\">\n                                      </azteca-file-box>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-lg-6\">\n                                  <azteca-form-field [label]=\"'Descripci\u00F3n:'\">\n                                      <az-textarea formControlName=\"descripcion\"\n                                                   [(ngModel)]=\"currentDocumento.descripcion\">\n                                      </az-textarea>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                      </form>\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdatedDocumento()\" [disabled]=\"!formDocumento.valid\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dlgDocumento.hide()\">Cancelar</button>\n                  </div> <!--Modal Footer-->\n\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            forms_1.FormBuilder,
            common_1.Location,
            empleado_service_1.EmpleadoService])
    ], DocumentoEmpleadoComponent);
    return DocumentoEmpleadoComponent;
}(core_2.ProcessComponent));
exports.DocumentoEmpleadoComponent = DocumentoEmpleadoComponent;
