"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("framework3/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var controls_1 = require("framework3/controls");
var common_1 = require("@angular/common");
var EmpleadosReportComponent = /** @class */ (function (_super) {
    __extends(EmpleadosReportComponent, _super);
    function EmpleadosReportComponent(context, router, route, location, formBuilder, reportSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.reportSvc = reportSvc;
        _this.title = 'Reporte de Empleados';
        _this.idDepartamento = 0;
        _this.idTurno = 0;
        _this.filtroDepartamento = false;
        _this.filtroTurno = false;
        _this.incluirInactivos = false;
        _this.valid = true;
        _this.titleContentView = "";
        _this.fileNameContentView = "";
        _this.catalogForm = formBuilder.group({
            'filtroDepartamento': [0],
            'filtroTurno': [0],
            'departamento': [0],
            'turno': [0],
            incluirInactivos: [0]
        });
        return _this;
    }
    EmpleadosReportComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.catalogForm.statusChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.changeState(); });
        });
    };
    EmpleadosReportComponent.prototype.changeState = function () {
        this.valid = this.catalogForm.valid;
    };
    EmpleadosReportComponent.prototype.onDepartamentoChecekd = function (args) {
        console.log(args);
        if (args)
            this.catalogForm.controls['departamento'].setValidators(controls_1.AztecaValidators.selected);
        else
            this.catalogForm.controls['departamento'].setValidators(null);
        this.catalogForm.controls['departamento'].updateValueAndValidity();
    };
    EmpleadosReportComponent.prototype.onTurnoChecekd = function (args) {
        console.log(args);
        if (args)
            this.catalogForm.controls['turno'].setValidators(controls_1.AztecaValidators.selected);
        else
            this.catalogForm.controls['turno'].setValidators(null);
        this.catalogForm.controls['turno'].updateValueAndValidity();
    };
    EmpleadosReportComponent.prototype.print = function () {
        var _this = this;
        this.context.app.showSpinner();
        var informe = new core_2.ReporteInfo();
        var parametroIdSucursal = new core_2.ParametroInfo();
        var parametroIdDepartamento = new core_2.ParametroInfo();
        var parametroIdTurno = new core_2.ParametroInfo();
        var parametroIncluirBajas = new core_2.ParametroInfo();
        parametroIdSucursal.name = "IdSucursal";
        parametroIdSucursal.values.push(this.context.app.defaultSite.identity.toString());
        parametroIncluirBajas.name = 'IncluirBajas';
        parametroIncluirBajas.values.push(this.incluirInactivos ? 'true' : 'false');
        parametroIdDepartamento.name = "IdDepartamento";
        if (this.filtroDepartamento)
            parametroIdDepartamento.values.push(this.idDepartamento.toString());
        else
            parametroIdDepartamento.values.push('0');
        parametroIdTurno.name = "IdTurno";
        if (this.filtroTurno)
            parametroIdTurno.values.push(this.idTurno.toString());
        else
            parametroIdTurno.values.push('0');
        informe.parametros.push(parametroIdSucursal);
        informe.parametros.push(parametroIdDepartamento);
        informe.parametros.push(parametroIncluirBajas);
        informe.parametros.push(parametroIdTurno);
        informe.path = "/Onili/RH/EmpleadosRPT";
        informe.format = "pdf";
        this.reportSvc.loadReporte(informe)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.titleContentView = 'Incidencias';
            _this.fileNameContentView = "Incidencias.pdf";
            _this.reportViewer.show("data:application/pdf; base64, " + info.content);
        })
            .catch(function (error) {
            _this.context.app.hideSpinner();
            _this.handleError(error);
        });
    };
    EmpleadosReportComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alertsBar.showAlert(message, 'danger');
    };
    EmpleadosReportComponent.prototype.applyPolicy = function (policy) {
        throw new Error("Method not implemented.");
    };
    __decorate([
        core_1.ViewChild(controls_1.ContentViewerComponent),
        __metadata("design:type", controls_1.ContentViewerComponent)
    ], EmpleadosReportComponent.prototype, "reportViewer", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], EmpleadosReportComponent.prototype, "alertsBar", void 0);
    EmpleadosReportComponent = __decorate([
        core_1.Component({
            selector: 'rh-empleados-report',
            template: "\n      <form [formGroup]=\"catalogForm\">\n          <div class=\"row\">\n              <div [ngClass]=\"'col-12 col-lg-10'\">\n\n                  <az-panel [header]=\"title\">\n                      <!--Barra de alertas-->\n                      <alerts-bar></alerts-bar>\n\n                      <!--Toolbar-->\n                      <div class=\"btn-group\">\n                          <button type=\"submit\" class=\"btn btn-primary\" (click)=\"print()\" [disabled]=\"!valid\">\n                              <span class=\"glyphicon glyphicon-print\" aria-hidden=\"true\"></span> Imprimir\n                          </button>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-sm-12 col-md-2\">\n                              <az-checkbox formControlName=\"filtroDepartamento\" [(ngModel)]=\"filtroDepartamento\" [label]=\"'Departamento'\" (checkedChanged)=\"onDepartamentoChecekd($event)\">\n                              </az-checkbox>\n                          </div>\n                          <div class=\"col-sm-12 col-md-6\" *ngIf=\"filtroDepartamento\">\n                              <azteca-form-field [label]=\"'Departamento:'\">\n                                  <rh-departamento-selector [(ngModel)]=\"idDepartamento\"\n                                                            formControlName=\"departamento\">\n                                  </rh-departamento-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-sm-12 col-md-2\">\n                              <az-checkbox formControlName=\"filtroTurno\" [(ngModel)]=\"filtroTurno\" [label]=\"'Turno'\" (checkedChanged)=\"onTurnoChecekd($event)\">\n                              </az-checkbox>\n                          </div>\n                          <div class=\"col-sm-12 col-md-6\" *ngIf=\"filtroTurno\">\n                              <azteca-form-field [label]=\"'Departamento:'\">\n                                  <rh-turno-selector formControlName=\"turno\"\n                                                     [(ngModel)]=\"idTurno\">\n                                  </rh-turno-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <az-checkbox formControlName=\"incluirInactivos\" [(ngModel)]=\"incluirInactivos\" [label]=\"'Incluir Inactivos'\">\n                          </az-checkbox>\n                      </div>\n                  </az-panel>\n              </div>\n          </div>\n      </form>\n\n\n      <azteca-content-viewer></azteca-content-viewer>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.ReportService])
    ], EmpleadosReportComponent);
    return EmpleadosReportComponent;
}(core_2.ProcessComponent));
exports.EmpleadosReportComponent = EmpleadosReportComponent;
