"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("framework3/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
var controls_1 = require("framework3/controls");
var common_1 = require("@angular/common");
var moment = require("moment");
var incidencia_list_component_1 = require("../controls/incidencia-list.component");
var wjcCore = require("wijmo/wijmo");
var IncidenciasEmpleadoReportComponent = /** @class */ (function (_super) {
    __extends(IncidenciasEmpleadoReportComponent, _super);
    function IncidenciasEmpleadoReportComponent(context, router, route, location, formBuilder, reportSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.reportSvc = reportSvc;
        _this.title = 'Reporte Incidencias de Empleado';
        _this.idEmpresaAdam = 0;
        _this.idDepartamento = 0;
        _this.idEmpleado = 0;
        _this.valid = false;
        _this.todasIncidencias = false;
        _this.incluirInactivos = false;
        _this.titleContentView = "";
        _this.fileNameContentView = "";
        _this.cvIncidencias = new wjcCore.CollectionView();
        _this.incidencias = [];
        _this.catalogForm = formBuilder.group({
            'empresaAdam': [0, controls_1.AztecaValidators.selected],
            'tipoReporte': [''],
            'tipoFiltro': [''],
            'departamento': [0, controls_1.AztecaValidators.selected],
            'empleado': [0],
            'fechaIni': [null, forms_1.Validators.required],
            'fechaFin': [null, forms_1.Validators.required],
            'todasIncidencias': [false],
            'incluirInactivos': [false]
        });
        _this.tipoReporte = _this.catalogForm.controls['tipoReporte'];
        _this.tipoReporte.setValue('I');
        _this.tipoFiltro = _this.catalogForm.controls['tipoFiltro'];
        _this.tipoFiltro.setValue('D');
        _this.catalogForm.controls['tipoFiltro'].valueChanges.subscribe(function (value) {
            if (value == 'D') {
                _this.catalogForm.controls['departamento'].setValidators(controls_1.AztecaValidators.selected);
                _this.catalogForm.controls['empleado'].setValidators(null);
            }
            else if (value == 'E') {
                _this.catalogForm.controls['departamento'].setValidators(null);
                _this.catalogForm.controls['empleado'].setValidators(controls_1.AztecaValidators.selected);
            }
            _this.catalogForm.controls['departamento'].updateValueAndValidity();
            _this.catalogForm.controls['empleado'].updateValueAndValidity();
        });
        return _this;
    }
    IncidenciasEmpleadoReportComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) {
            _this.fechaIni = moment().subtract(8, 'day').toDate();
            _this.fechaFin = moment().subtract(1, 'day').toDate();
        });
        this.catalogForm.statusChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.changeState(); });
        });
        this.catalogForm.statusChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.changeState(); });
        });
    };
    IncidenciasEmpleadoReportComponent.prototype.changeState = function () {
        this.valid = this.catalogForm.valid;
    };
    IncidenciasEmpleadoReportComponent.prototype.onAgregarIncidencias = function () {
        this.lstDlgIncidencia.show();
    };
    IncidenciasEmpleadoReportComponent.prototype.onSelectedIncidencia = function (item) {
        if (this.incidencias.filter(function (X) { return X.id == item.id; }).length == 0) {
            this.incidencias.push(item);
        }
        this.cvIncidencias.sourceCollection = this.incidencias;
        this.cvIncidencias.refresh();
        wjcCore.Control.invalidateAll();
    };
    IncidenciasEmpleadoReportComponent.prototype.onSelectedIncidencias = function (items) {
        var _this = this;
        items.forEach(function (item) {
            if (_this.incidencias.filter(function (X) { return X.id == item.id; }).length == 0) {
                _this.incidencias.push(item);
            }
        });
        this.cvIncidencias.sourceCollection = this.incidencias;
        this.cvIncidencias.refresh();
        wjcCore.Control.invalidateAll();
    };
    IncidenciasEmpleadoReportComponent.prototype.onRowDeleteIncidencia = function (item) {
        this.incidencias.splice(this.incidencias.indexOf(item), 1);
        this.cvIncidencias.sourceCollection = this.incidencias;
        this.cvIncidencias.refresh();
    };
    IncidenciasEmpleadoReportComponent.prototype.print = function () {
        var _this = this;
        this.context.app.showSpinner();
        var informe = new core_2.ReporteInfo();
        var parametroFechaIni = new core_2.ParametroInfo();
        var parametroFechaFin = new core_2.ParametroInfo();
        var parametroIdSucursal = new core_2.ParametroInfo();
        var parametroIdEmpleado = new core_2.ParametroInfo();
        var parametroIdEmpresaAdam = new core_2.ParametroInfo();
        var parametroIdEmpresa = new core_2.ParametroInfo();
        var parametroIdDepartamento = new core_2.ParametroInfo();
        var parametroIdIncidencia = new core_2.ParametroInfo();
        var parametroIncluirInactivos = new core_2.ParametroInfo();
        var parametroTipoReporte = new core_2.ParametroInfo();
        var parametroFiltroIncidencias = new core_2.ParametroInfo();
        parametroFechaIni.name = "FechaIni";
        parametroFechaIni.values.push(this.fechaIni.toDateString());
        parametroFechaFin.name = "FechaFin";
        parametroFechaFin.values.push(this.fechaFin.toDateString());
        parametroIdSucursal.name = "IdSucursal";
        parametroIdSucursal.values.push(this.context.app.defaultSite.identity.toString());
        parametroIdEmpleado.name = "IdEmpleado";
        if (this.tipoFiltro.value == 'E')
            parametroIdEmpleado.values.push(this.idEmpleado.toString());
        else
            parametroIdEmpleado.values.push('0');
        parametroIdEmpresaAdam.name = "IdEmpresaAdam";
        parametroIdEmpresaAdam.values.push(this.idEmpresaAdam.toString());
        parametroIdDepartamento.name = "IdDepartamento";
        if (this.tipoFiltro.value == 'D')
            parametroIdDepartamento.values.push(this.idDepartamento.toString());
        else
            parametroIdDepartamento.values.push('0');
        parametroIdEmpresa.name = "IdEmpresa";
        parametroIdEmpresa.values.push(this.context.app.defaultCompany.identity.toString());
        parametroIdIncidencia.name = "IdIncidencia";
        parametroIdIncidencia.values.push('0');
        parametroIncluirInactivos.name = "IncluirInactivos";
        parametroIncluirInactivos.values.push(this.incluirInactivos ? 'true' : 'false');
        parametroTipoReporte.name = "TipoReporte";
        if (this.tipoReporte.value == 'I' && this.tipoFiltro.value == 'D')
            parametroTipoReporte.values.push('1');
        else if (this.tipoReporte.value == 'I' && this.tipoFiltro.value == 'E')
            parametroTipoReporte.values.push('2');
        else if (this.tipoReporte.value == 'S' && this.tipoFiltro.value == 'D')
            parametroTipoReporte.values.push('3');
        else if (this.tipoReporte.value == 'S' && this.tipoFiltro.value == 'E')
            parametroTipoReporte.values.push('4');
        parametroFiltroIncidencias.name = "FiltroIncidencias";
        var incidencias = '';
        this.incidencias.forEach(function (item) {
            incidencias = incidencias + ',' + item.id.toString();
        });
        incidencias = incidencias.slice(1, incidencias.length);
        parametroFiltroIncidencias.values.push(incidencias);
        informe.parametros.push(parametroFechaIni);
        informe.parametros.push(parametroFechaFin);
        informe.parametros.push(parametroIdSucursal);
        informe.parametros.push(parametroIdEmpleado);
        informe.parametros.push(parametroIdEmpresaAdam);
        informe.parametros.push(parametroIdDepartamento);
        informe.parametros.push(parametroIdEmpresa);
        informe.parametros.push(parametroIdIncidencia);
        informe.parametros.push(parametroIncluirInactivos);
        informe.parametros.push(parametroTipoReporte);
        informe.parametros.push(parametroFiltroIncidencias);
        informe.path = "/Onili/RH/IncidenciasEmpleado";
        informe.format = "pdf";
        this.reportSvc.loadReporte(informe)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.titleContentView = 'Incidencias';
            _this.fileNameContentView = "Incidencias.pdf";
            _this.reportViewer.show("data:application/pdf; base64, " + info.content);
        })
            .catch(function (error) {
            _this.context.app.hideSpinner();
            _this.handleError(error);
        });
    };
    IncidenciasEmpleadoReportComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alertsBar.showAlert(message, 'danger');
    };
    IncidenciasEmpleadoReportComponent.prototype.applyPolicy = function (policy) {
        throw new Error("Method not implemented.");
    };
    __decorate([
        core_1.ViewChild('lstDlgIncidencia'),
        __metadata("design:type", incidencia_list_component_1.IncidenciaListComponent)
    ], IncidenciasEmpleadoReportComponent.prototype, "lstDlgIncidencia", void 0);
    __decorate([
        core_1.ViewChild(controls_1.ContentViewerComponent),
        __metadata("design:type", controls_1.ContentViewerComponent)
    ], IncidenciasEmpleadoReportComponent.prototype, "reportViewer", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], IncidenciasEmpleadoReportComponent.prototype, "alertsBar", void 0);
    IncidenciasEmpleadoReportComponent = __decorate([
        core_1.Component({
            selector: 'rh-incidencias-empleado-report',
            template: "\n      <form [formGroup]=\"catalogForm\">\n          <div class=\"row\">\n              <div [ngClass]=\"'col-12 col-lg-10'\">\n\n                  <az-panel [header]=\"title\">\n                      <!--Barra de alertas-->\n                      <alerts-bar></alerts-bar>\n\n                      <!--Toolbar-->\n                      <div class=\"btn-group\">\n                          <button type=\"submit\" class=\"btn btn-primary\" (click)=\"print()\" [disabled]=\"!valid\">\n                              <span class=\"glyphicon glyphicon-print\" aria-hidden=\"true\"></span> Imprimir\n                          </button>\n                      </div>\n\n                      <div class=\"card\">\n                          <div class=\"card-body\">\n                              <div class=\"row\">\n                                  <div class=\"col-sm-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Empresa ADAM:'\">\n                                          <rh-empresa-adam-selector formControlName=\"empresaAdam\" [(ngModel)]=\"idEmpresaAdam\"></rh-empresa-adam-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </div>\n                      </div>\n\n                      <div class=\"row\" style=\"padding:10px\">\n                          <div class=\"col-1\">\n                              <label class=\"form-check-inline\">\n                                  <input class=\"form-check-input\" type=\"radio\" formControlName=\"tipoReporte\" name=\"tipoReporte\" value=\"I\"> Incidencias\n                              </label>\n                          </div>\n                          <div class=\"col-1\">\n                              <label class=\"form-check-inline\">\n                                  <input class=\"form-check-input\" type=\"radio\" formControlName=\"tipoReporte\" name=\"tipoReporte\" value=\"S\"> Suspenciones\n                              </label>\n                          </div>\n                      </div>\n\n                      <div class=\"card\" *ngIf=\"tipoReporte.value=='I'\">\n                          <div class=\"card-header\">\n                              Incidencias\n                          </div>\n                          <div class=\"card-body\">\n                              <div class=\"row\">\n                                  <div class=\"col-3\" *ngIf=\"!todasIncidencias\">\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAgregarIncidencias()\">\n                                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-plus\"></span>\n                                          Agregar Incidencias\n                                      </button>\n                                  </div>\n                                  <div class=\"col-3\">\n                                      <az-checkbox formControlName=\"todasIncidencias\" [(ngModel)]=\"todasIncidencias\" [label]=\"'Todas las incidencias'\">\n                                      </az-checkbox>\n                                  </div>\n                              </div>\n                              <wj-flex-grid #grdUsuario\n                                            style=\"height:500px\"\n                                            [(itemsSource)]=\"cvIncidencias\"\n                                            [selectionMode]=\"'Row'\"\n                                            *ngIf=\"!todasIncidencias\">\n                                  <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                                  <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRowDeleteIncidencia(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-remove\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'id'\" [width]=\"80\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Incidencia'\" [binding]=\"'nombre'\" [width]=\"'140*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </div>\n                      </div>\n                      <div class=\"card\">\n                          <div class=\"card-header\">\n                              Tipo de Filtro\n                          </div>\n                          <div class=\"card-body\">\n                              <div class=\"row\" style=\"padding:10px\">\n                                  <div class=\"col-2\">\n                                      <label class=\"form-check-inline\">\n                                          <input class=\"form-check-input\" type=\"radio\" formControlName=\"tipoFiltro\" name=\"tipoFiltro\" value=\"D\"> Departamento\n                                      </label>\n                                  </div>\n                                  <div class=\"col-1\">\n                                      <label class=\"form-check-inline\">\n                                          <input class=\"form-check-input\" type=\"radio\" formControlName=\"tipoFiltro\" name=\"tipoFiltro\" value=\"E\"> Empleado\n                                      </label>\n                                  </div>\n                              </div>\n                          </div>\n                      </div>\n\n                      <div class=\"row\" *ngIf=\"tipoFiltro.value=='D'\">\n                          <div class=\"col-sm-12 col-md-6\">\n                              <azteca-form-field [label]=\"'Departamento:'\">\n                                  <rh-departamento-selector [(ngModel)]=\"idDepartamento\"\n                                                            formControlName=\"departamento\">\n                                  </rh-departamento-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n                      <div class=\"row\" *ngIf=\"tipoFiltro.value=='E'\">\n                          <div class=\"col-sm-12 col-md-6\">\n                              <azteca-form-field [label]=\"'Empleado:'\">\n                                  <rh-empleado-selector [(ngModel)]=\"idEmpleado\"\n                                                        formControlName=\"empleado\">\n                                  </rh-empleado-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n                      <div class=\"row\">\n                          <div class=\"col-sm-12 col-md-6\">\n                              <azteca-form-field [label]=\"'Fecha Inicial:'\">\n                                  <az-input-date formControlName=\"fechaIni\"\n                                                 [(ngModel)]=\"fechaIni\">\n                                  </az-input-date>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-sm-12 col-md-6\">\n                              <azteca-form-field [label]=\"'Fecha Final:'\">\n                                  <az-input-date formControlName=\"fechaFin\"\n                                                 [(ngModel)]=\"fechaFin\">\n                                  </az-input-date>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <az-checkbox formControlName=\"incluirInactivos\" [(ngModel)]=\"incluirInactivos\" [label]=\"'Incluir Inactivos'\">\n                          </az-checkbox>\n                      </div>\n                  </az-panel>\n              </div>\n          </div>\n      </form>\n\n      <rh-incidencia-list #lstDlgIncidencia\n                          (selectedItemChanged)=\"onSelectedIncidencia($event)\"\n                          (selectedItemsChanged)=\"onSelectedIncidencias($event)\"\n                          [multiSelect]=\"true\">\n      </rh-incidencia-list>\n\n\n      <azteca-content-viewer></azteca-content-viewer>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.ReportService])
    ], IncidenciasEmpleadoReportComponent);
    return IncidenciasEmpleadoReportComponent;
}(core_2.ProcessComponent));
exports.IncidenciasEmpleadoReportComponent = IncidenciasEmpleadoReportComponent;
