"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var controls_1 = require("framework3/controls");
var core_2 = require("framework3/core");
var kardex_asistencia_service_1 = require("../services/kardex-asistencia.service");
var TarjetaAsistenciaReportComponent = /** @class */ (function (_super) {
    __extends(TarjetaAsistenciaReportComponent, _super);
    function TarjetaAsistenciaReportComponent(context, router, route, location, formBuilder, kardexAsistenciaSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.kardexAsistenciaSvc = kardexAsistenciaSvc;
        _this.title = "Reporte Tarjeta de Asistencias";
        _this.idEmpleado = 0;
        _this.idDepartamento = 0;
        _this.fechaIni = new Date();
        _this.fechaFin = new Date();
        _this.activo = true;
        _this.pie = "";
        _this.titleContentView = "Tarjeta de Asistencias";
        _this.fileNameContentView = "TarjetaAsistencia.pdf";
        _this.catalogForm = formBuilder.group({
            'idEmpleado': [null, controls_1.AztecaValidators.selected],
            'idDepartamento': [null, controls_1.AztecaValidators.selected],
            'fechaIni': [null],
            'fechaFin': [null],
            'activo': [false],
            'pie': ['']
        });
        return _this;
    }
    ///////////////////////// METHODS ///////////////////////////////////////
    TarjetaAsistenciaReportComponent.prototype.printTarjetaAsistencia = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.kardexAsistenciaSvc.printKardexAsistencia(this.idEmpleado, this.idDepartamento, this.fechaIni, this.fechaFin, (!this.activo), this.pie)
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.reportViewer.show("data:application/pdf; base64, " + result);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    TarjetaAsistenciaReportComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alertsBar.showAlert(message, 'danger');
    };
    TarjetaAsistenciaReportComponent.prototype.applyPolicy = function (policy) {
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], TarjetaAsistenciaReportComponent.prototype, "alertsBar", void 0);
    __decorate([
        core_1.ViewChild(controls_1.ContentViewerComponent),
        __metadata("design:type", controls_1.ContentViewerComponent)
    ], TarjetaAsistenciaReportComponent.prototype, "reportViewer", void 0);
    TarjetaAsistenciaReportComponent = __decorate([
        core_1.Component({
            selector: 'rh-tarjeta-asistencia-report',
            template: "\n      <form [formGroup]=\"catalogForm\">\n          <div class=\"row\">\n              <div [ngClass]=\"'col-12 col-lg-10'\">\n\n                  <az-panel [header]=\"title\">\n\n                      <!--Barra de alertas-->\n                      <alerts-bar></alerts-bar>\n\n                      <!--Toolbar-->\n                      <div class=\"btn-group\">\n                          <button type=\"submit\" class=\"btn btn-primary\" (click)=\"printTarjetaAsistencia()\">\n                              <span class=\"glyphicon glyphicon-floppy-disk\" aria-hidden=\"true\"></span> Imprimir\n                          </button>\n                      </div>\n\n                      <!--Controles del formulario-->\n\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Departamento:'\">\n                                  <rh-departamento-selector formControlName=\"idDepartamento\"\n                                                            [(ngModel)]=\"idDepartamento\">\n                                  </rh-departamento-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Empleado:'\">\n                                  <rh-empleado-selector formControlName=\"idEmpleado\"\n                                                        [(ngModel)]=\"idEmpleado\">\n                                  </rh-empleado-selector>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Fecha Inicial:'\">\n                                  <az-input-date formControlName=\"fechaIni\"\n                                                 [(ngModel)]=\"fechaIni\">\n                                  </az-input-date>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Fecha Final:'\">\n                                  <az-input-date formControlName=\"fechaFin\"\n                                                 [(ngModel)]=\"fechaFin\">\n                                  </az-input-date>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <azteca-form-field [label]=\"'Leyenda:'\">\n                                  <az-textarea formControlName=\"pie\"\n                                               [(ngModel)]=\"pie\">\n                                  </az-textarea>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <az-checkbox [label]=\"'Mostrar empleados inactivos'\"\n                                       formControlName=\"activo\"\n                                       [(ngModel)]=\"activo\">\n                          </az-checkbox>\n                      </div>\n\n                  </az-panel>\n              </div>\n          </div>\n      </form>\n\n      <azteca-content-viewer [title]=\"titleContentView\" [fileName]=\"fileNameContentView\"></azteca-content-viewer>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            kardex_asistencia_service_1.KardexAsistenciaService])
    ], TarjetaAsistenciaReportComponent);
    return TarjetaAsistenciaReportComponent;
}(core_2.ProcessComponent));
exports.TarjetaAsistenciaReportComponent = TarjetaAsistenciaReportComponent;
