import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService, UsuarioItem } from 'framework3/core';
import { ChecadorInfo, ChecadorItem } from '../models/checador';
import { ChecadorUsuarioIten } from '../models/checador';
import { TransaccionItem } from '../models/transaccion';
import { SearchRequest, SearchResult } from 'framework3/search';
import { EventoUsuarioInfo } from '../models/evento-usuario';
export declare class ChecadorService extends CatalogService<ChecadorInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<ChecadorInfo>;
    testConnection(checador: ChecadorInfo): Promise<boolean>;
    importUsers(idChecador: number): Promise<ChecadorUsuarioIten[]>;
    exportUsers(idChecador: number, usuarios: ChecadorUsuarioIten[], sincronizarChecador: boolean): Promise<ChecadorUsuarioIten[]>;
    exportEmployeesToChecks(usuarios: ChecadorUsuarioIten[], checadores: ChecadorItem[]): Promise<ChecadorUsuarioIten[]>;
    downloadTransacciones(idChecador: number): Promise<boolean>;
    importUser(idChecador: number, item: ChecadorUsuarioIten): Promise<ChecadorUsuarioIten>;
    importNewUser(idChecador: number, items: ChecadorUsuarioIten[]): Promise<ChecadorUsuarioIten[]>;
    exportFingers(idChecador: number, item: ChecadorUsuarioIten): Promise<boolean>;
    deleteUser(idChecador: number, item: ChecadorUsuarioIten): Promise<boolean>;
    getTransaccionesEmpleado(fechaIni: Date, fechaFin: Date, idEmpleado: number): Promise<TransaccionItem[]>;
    updateTransaccionesEmpleado(transacciones: TransaccionItem[]): Promise<boolean>;
    procesarTransaccionesEmpleado(transacciones: TransaccionItem[]): Promise<boolean>;
    searchChecadoresEventos(idBranch: number, fechaIni: Date, fechaFin: Date): Promise<any>;
    saveEventoUsuario(eventoUsuario: EventoUsuarioInfo): Promise<boolean>;
    getEventoUsuario(idEventoUsuario: number): Promise<EventoUsuarioInfo>;
    statusEvento(idEventoUsuario: number, status: boolean, idUser: number): Promise<boolean>;
    addUser(idChecador: number, userUpdate: number, usuarios: UsuarioItem[]): Promise<any>;
    loadAccessUsersList(idZonaCompra: number): Promise<UsuarioItem[]>;
    removeUser(idChecadorAcceso: number): Promise<any>;
    getPeriodoTrabaoEmpleados(idEmpresa: number, idSucursal: number, fecha: Date): Promise<any[]>;
    plancharChecadas(empleados: any[], idMotivo: number, idUsuario: number, usuario: string): Promise<boolean>;
    searchChecador(idUSuario: number, idBranch: number, request: SearchRequest): Promise<SearchResult>;
}
