"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
var operators_1 = require("rxjs/operators");
var moment = require("moment");
//Azteca Kernel
var core_2 = require("framework3/core");
//Locales
var checador_1 = require("../models/checador");
var https_1 = require("https");
var ChecadorService = /** @class */ (function (_super) {
    __extends(ChecadorService, _super);
    function ChecadorService(http, context) {
        return _super.call(this, http, context, 'api/rh/checadores') || this;
    }
    ChecadorService.prototype.create = function () {
        return Promise.resolve(new checador_1.ChecadorInfo());
    };
    ChecadorService.prototype.testConnection = function (checador) {
        var params = new http_1.HttpParams();
        return this.apiService.post('test-connection', params, checador)
            .toPromise();
    };
    ChecadorService.prototype.importUsers = function (idChecador) {
        var params = new http_1.HttpParams()
            .set('idChecador', idChecador.toString());
        return this.apiService.get('import-users', params)
            .toPromise();
    };
    ChecadorService.prototype.exportUsers = function (idChecador, usuarios, sincronizarChecador) {
        var params = new http_1.HttpParams()
            .set('idChecador', idChecador.toString())
            .set('sincronizarChecador', sincronizarChecador.toString());
        return this.apiService.post('export-users', params, usuarios)
            .toPromise();
    };
    ChecadorService.prototype.exportEmployeesToChecks = function (usuarios, checadores) {
        var checadoresUsuariosCollections = new checador_1.ChecadoresUsuariosCollections();
        checadoresUsuariosCollections.checadores = checadores;
        checadoresUsuariosCollections.checadoresUsuariosItem = usuarios;
        var params = new http_1.HttpParams();
        return this.apiService.post('export-employees-to-checks', params, checadoresUsuariosCollections)
            .toPromise();
    };
    ChecadorService.prototype.downloadTransacciones = function (idChecador) {
        var params = new http_1.HttpParams()
            .set('idChecador', idChecador.toString());
        return this.apiService.post('download-transacciones', params)
            .toPromise();
    };
    ChecadorService.prototype.importUser = function (idChecador, item) {
        var params = new http_1.HttpParams()
            .set('idChecador', idChecador.toString());
        return this.apiService.post('import-user', params, item)
            .toPromise();
    };
    ChecadorService.prototype.importNewUser = function (idChecador, items) {
        var params = new http_1.HttpParams()
            .set('idChecador', idChecador.toString());
        return this.apiService.post('import-new-user', params, items)
            .toPromise();
    };
    ChecadorService.prototype.exportFingers = function (idChecador, item) {
        var params = new http_1.HttpParams()
            .set('idChecador', idChecador.toString());
        return this.apiService.post('export-fingers', params, item)
            .toPromise();
    };
    ChecadorService.prototype.deleteUser = function (idChecador, item) {
        var params = new http_1.HttpParams()
            .set('idChecador', idChecador.toString());
        return this.apiService.post('delete-user', params, item)
            .toPromise();
    };
    ChecadorService.prototype.getTransaccionesEmpleado = function (fechaIni, fechaFin, idEmpleado) {
        var params = new http_1.HttpParams()
            .set('fechaIni', fechaIni.toLocaleDateString('en-US'))
            .set('fechaFin', fechaFin.toLocaleDateString('en-US'))
            .set('idEmpleado', idEmpleado.toString());
        return this.apiService.get('get-transacciones-empleado', params)
            .pipe(operators_1.map(function (result) {
            result.forEach(function (item) {
                item.fecha = moment(item.fecha).toDate();
            });
            return result;
        })).toPromise();
    };
    ChecadorService.prototype.updateTransaccionesEmpleado = function (transacciones) {
        var params = new http_1.HttpParams();
        return this.apiService.post('update-transacciones-empleado', params, transacciones).toPromise();
    };
    ChecadorService.prototype.procesarTransaccionesEmpleado = function (transacciones) {
        var params = new http_1.HttpParams();
        return this.apiService.post('procesar-transacciones-empleado', params, transacciones).toPromise();
    };
    ChecadorService.prototype.searchChecadoresEventos = function (idBranch, fechaIni, fechaFin) {
        var params = new http_1.HttpParams()
            .set('idBranch', idBranch.toString())
            .set('FechaIni', fechaIni.toLocaleString('en-US'))
            .set('FechaFin', fechaFin.toLocaleString('en-US'));
        return this.apiService.post('search-checadores-eventos', params, https_1.request)
            .toPromise();
    };
    ChecadorService.prototype.saveEventoUsuario = function (eventoUsuario) {
        var params = new http_1.HttpParams();
        return this.apiService.post('save-evento-usuario', params, eventoUsuario)
            .toPromise();
    };
    ChecadorService.prototype.getEventoUsuario = function (idEventoUsuario) {
        var params = new http_1.HttpParams()
            .set('idEventoUsuario', idEventoUsuario.toString());
        return this.apiService.get('get-evento-usuario', params)
            .toPromise();
    };
    ChecadorService.prototype.statusEvento = function (idEventoUsuario, status, idUser) {
        var params = new http_1.HttpParams()
            .set("idEventoUsuario", idEventoUsuario.toString())
            .set("status", status ? 'true' : 'false ');
        return this.apiService.post('evento-status', params)
            .toPromise();
    };
    ChecadorService.prototype.addUser = function (idChecador, userUpdate, usuarios) {
        var params = new http_1.HttpParams()
            .set('idChecador', idChecador.toString())
            .set('userUpdate', userUpdate.toString());
        return this.apiService.post('add-user', params, usuarios)
            .toPromise();
    };
    ChecadorService.prototype.loadAccessUsersList = function (idZonaCompra) {
        var params = new http_1.HttpParams()
            .append("idChecador", idZonaCompra.toString());
        return this.apiService.get("load-access-users-list", params)
            .toPromise();
    };
    ChecadorService.prototype.removeUser = function (idChecadorAcceso) {
        var params = new http_1.HttpParams()
            .append("idChecadorAcceso", idChecadorAcceso.toString());
        return this.apiService.post("remove-user", params)
            .toPromise();
    };
    ChecadorService.prototype.getPeriodoTrabaoEmpleados = function (idEmpresa, idSucursal, fecha) {
        var params = new http_1.HttpParams()
            .set('idEmpresa', idEmpresa.toString())
            .set('idSucursal', idSucursal.toString())
            .set('fecha', fecha.toDateString());
        return this.apiService.get('get-periodos-trabajo-empleado', params)
            .toPromise();
    };
    ChecadorService.prototype.plancharChecadas = function (empleados, idMotivo, idUsuario, usuario) {
        var params = new http_1.HttpParams()
            .set('idMotivo', idMotivo.toString())
            .set('idUsuario', idUsuario.toString())
            .set('Usuario', usuario);
        return this.apiService.post('planchar-checadas', params, empleados)
            .toPromise();
    };
    ChecadorService.prototype.searchChecador = function (idUSuario, idBranch, request) {
        var params = new http_1.HttpParams()
            .set('idUsuario', idUSuario.toString())
            .set('idBranch', idBranch.toString());
        return this.apiService.post('search-admin-checadores', params, request)
            .toPromise();
    };
    ChecadorService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], ChecadorService);
    return ChecadorService;
}(core_2.CatalogService));
exports.ChecadorService = ChecadorService;
