import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
import { Context, HierarchyService } from 'framework3/core';
import { DepartamentoInfo, DepartamentoItem, Acceso } from '../models/departamento';
export declare class DepartamentoService extends HierarchyService<DepartamentoInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<DepartamentoInfo>;
    loadAccesos(idUsuario: number): Promise<Acceso[]>;
    updateAccesos(idUsuario: number, accesos: Acceso[]): Promise<boolean>;
    searchKeywordWithAccess(idBranch: number, keyword: string): Observable<DepartamentoItem[]>;
    nodesWithAccess(idBranch: number): Promise<DepartamentoInfo[]>;
}
