import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService, CatalogItem } from 'framework3/core';
import { FileInfo } from 'framework3/general/models/file';
import { EmpleadoInfo, DocumentoEmpleadoItem, EmpleadoItem } from '../models/empleado';
import { AsyncTaskInfo } from 'framework3/queue/models/async-task';
export declare class EmpleadoService extends CatalogService<EmpleadoInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<EmpleadoInfo>;
    loadByCodeAndCompany(codigo: string, idEmpresa: number): Promise<any>;
    getDocumentos(idEmpleado: number): Promise<DocumentoEmpleadoItem[]>;
    getDocumento(idArchivo: string): Promise<FileInfo>;
    programarCambioTurno(idEmpleado: number, idTurnoActual: number, idTurnoNuevo: number, fecha: Date): Promise<void>;
    cambioPassword(idEmpleado: number, password: string): Promise<void>;
    deleteDocumento(idDocumentoEmpleado: number): Promise<boolean>;
    updateDocumento(idEmpleado: number, docuemnto: DocumentoEmpleadoItem): Promise<DocumentoEmpleadoItem>;
    asyncImportarEmpleadosAdam(idSucursal: number): Promise<AsyncTaskInfo>;
    getEmpleadosEmpresa(idSucursal: number): Promise<EmpleadoItem[]>;
    searchKeyword2(idBranch: number, keyword: string): Observable<CatalogItem[]>;
}
