"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
//Azteca Kernel
var core_2 = require("framework3/core");
//Locales
var empleado_1 = require("../models/empleado");
var EmpleadoService = /** @class */ (function (_super) {
    __extends(EmpleadoService, _super);
    function EmpleadoService(http, context) {
        return _super.call(this, http, context, "api/rh/empleados") || this;
    }
    EmpleadoService.prototype.create = function () {
        return Promise.resolve(new empleado_1.EmpleadoInfo());
    };
    EmpleadoService.prototype.loadByCodeAndCompany = function (codigo, idEmpresa) {
        var params = new http_1.HttpParams()
            .set('codigo', codigo)
            .set('idEmpresa', idEmpresa.toString());
        return this.apiService.get('load-employe-code-company', params)
            .toPromise();
    };
    EmpleadoService.prototype.getDocumentos = function (idEmpleado) {
        var params = new http_1.HttpParams()
            .set('idEmpleado', idEmpleado.toString());
        return this.apiService.get('load-documentos', params)
            .toPromise();
    };
    EmpleadoService.prototype.getDocumento = function (idArchivo) {
        var params = new http_1.HttpParams()
            .set('idArchivo', idArchivo);
        return this.apiService.get('get-documento', params)
            .toPromise();
    };
    EmpleadoService.prototype.programarCambioTurno = function (idEmpleado, idTurnoActual, idTurnoNuevo, fecha) {
        var params = new http_1.HttpParams()
            .set('IdEmpleado', idEmpleado.toString())
            .set('IdTurnoActual', idTurnoActual.toString())
            .set('IdTurnoNuevo', idTurnoNuevo.toString())
            .set('Fecha', fecha.toLocaleDateString('en-US'));
        return this.apiService.post('programar-cambio-turno', params)
            .toPromise();
    };
    EmpleadoService.prototype.cambioPassword = function (idEmpleado, password) {
        var params = new http_1.HttpParams()
            .set('IdEmpleado', idEmpleado.toString())
            .set('password', password);
        return this.apiService.post('establecer-password', params)
            .toPromise();
    };
    EmpleadoService.prototype.deleteDocumento = function (idDocumentoEmpleado) {
        var params = new http_1.HttpParams()
            .set('idDocumentoEmpleado', idDocumentoEmpleado.toString());
        return this.apiService.delete('delete-documento-empleado', params)
            .toPromise();
    };
    EmpleadoService.prototype.updateDocumento = function (idEmpleado, docuemnto) {
        var params = new http_1.HttpParams()
            .set('idEmpleado', idEmpleado.toString());
        return this.apiService.post('update-documento-empleado', params, docuemnto)
            .toPromise();
    };
    EmpleadoService.prototype.asyncImportarEmpleadosAdam = function (idSucursal) {
        var params = new http_1.HttpParams()
            .set('idSucursal', idSucursal.toString());
        return this.apiService.get('importar-empleados-adam', params)
            .toPromise();
    };
    EmpleadoService.prototype.getEmpleadosEmpresa = function (idSucursal) {
        var params = new http_1.HttpParams()
            .set('idSucursal', idSucursal.toString());
        return this.apiService.get('get-empleados-empresa', params)
            .toPromise();
    };
    EmpleadoService.prototype.searchKeyword2 = function (idBranch, keyword) {
        var params = new http_1.HttpParams()
            .set("idBranch", idBranch.toString())
            .set("keyword", keyword);
        return this.apiService.get("search-empleados-empresa", params);
    };
    EmpleadoService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], EmpleadoService);
    return EmpleadoService;
}(core_2.CatalogService));
exports.EmpleadoService = EmpleadoService;
