"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
var operators_1 = require("rxjs/operators");
//Azteca Kernel
var core_2 = require("framework3/core");
//Locales
var moment = require("moment");
var EvaluacionKardexService = /** @class */ (function (_super) {
    __extends(EvaluacionKardexService, _super);
    function EvaluacionKardexService(http, context) {
        return _super.call(this, http, context, 'api/rh/evaluacion-kardex') || this;
    }
    EvaluacionKardexService.prototype.getDetail = function (identity) {
        var params = new http_1.HttpParams()
            .set('identity', identity.toString());
        return this.apiService.get('get-detail', params)
            .pipe(operators_1.map(function (result) {
            result.details.forEach(function (item) {
                if (item.entrada)
                    item.entrada = moment(item.entrada).toDate();
                if (item.salida)
                    item.salida = moment(item.salida).toDate();
                if (item.comidaInicio)
                    item.comidaInicio = moment(item.comidaInicio).toDate();
                if (item.comidaFin)
                    item.comidaFin = moment(item.comidaFin).toDate();
            });
            return result;
        })).toPromise();
    };
    EvaluacionKardexService.prototype.search = function (idBranch, request) {
        var params = new http_1.HttpParams()
            .set('idBranch', idBranch.toString());
        return this.apiService.post('search', params, request)
            .pipe(operators_1.map(function (result) {
            result.rows.forEach(function (item) {
                item.fechaIni = moment(item.fechaIni).toDate();
                item.fechaFin = moment(item.fechaFin).toDate();
            });
            return result;
        })).toPromise();
    };
    EvaluacionKardexService.prototype.update = function (info) {
        var params = new http_1.HttpParams();
        return this.apiService.post('update', params, info).toPromise();
    };
    EvaluacionKardexService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], EvaluacionKardexService);
    return EvaluacionKardexService;
}(core_2.BaseService));
exports.EvaluacionKardexService = EvaluacionKardexService;
