"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("framework3/core");
var http_1 = require("@angular/common/http");
var operators_1 = require("rxjs/operators");
var moment = require("moment");
var InterfazAdamService = /** @class */ (function (_super) {
    __extends(InterfazAdamService, _super);
    function InterfazAdamService(http, context) {
        return _super.call(this, http, context, 'api/rh/interfaz-adam') || this;
    }
    InterfazAdamService.prototype.search = function (idBranch, request) {
        var params = new http_1.HttpParams()
            .set('idBranch', idBranch.toString());
        return this.apiService.post('search', params, request)
            .pipe(operators_1.map(function (result) {
            result.rows.forEach(function (item) {
                item.fechaIni = moment(item.fechaIni).toDate();
                item.fechaFin = moment(item.fechaFin).toDate();
            });
            return result;
        })).toPromise();
    };
    InterfazAdamService.prototype.getEmpleadosInterfaz = function (fechaIni, fechaFin, idDepartamento, idEmpresaAdam, idSucursal, idEmpresa) {
        var params = new http_1.HttpParams()
            .set('fechaIni', fechaIni.toDateString())
            .set('fechaFin', fechaFin.toDateString())
            .set('idDepartamento', idDepartamento.toString())
            .set('idEmpresaAdam', idEmpresaAdam.toString())
            .set('idSucursal', idSucursal.toString())
            .set('idEmpresa', idEmpresa.toString());
        return this.apiService.get('get-employes', params).toPromise();
    };
    InterfazAdamService.prototype.update = function (info) {
        var params = new http_1.HttpParams();
        return this.apiService.post('update', params, info).toPromise();
    };
    InterfazAdamService.prototype.getDetail = function (idInterfazAdam) {
        var params = new http_1.HttpParams()
            .set('idInterfazAdam', idInterfazAdam.toString());
        return this.apiService.get('get-detail', params).toPromise();
    };
    InterfazAdamService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], InterfazAdamService);
    return InterfazAdamService;
}(core_2.BaseService));
exports.InterfazAdamService = InterfazAdamService;
