import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, BaseService } from 'framework3/core';
import { SearchResult, SearchRequest } from 'framework3/search';
import { IncidenciaEmpleadoInfo } from '../models/incidencia-empleado';
import { KardexAsistenciaInfo } from '../models/kardex-asistencia';
export declare class KardexAsistenciaService extends BaseService {
    constructor(http: HttpClient, context: Context);
    searchIncidenciaEmpleado(idBranch: number, request: SearchRequest): Promise<SearchResult>;
    updateIncidenciaEmpleado(info: IncidenciaEmpleadoInfo): Promise<IncidenciaEmpleadoInfo>;
    deleteIncidenciaEmpleado(identity: number): Promise<boolean>;
    printKardexAsistencia(idEmpleado: number, idDepartamento: number, fechaIni: Date, fechaFin: Date, activo: boolean, pie: string): Promise<string>;
    printTransacciones(idEmpleado: number, idDepartamento: number, fechaIni: Date, fechaFin: Date, activo: boolean, pie: string): Promise<string>;
    getKardexAsistencia(idEmpleado: number, fechaIni: Date, fechaFin: Date): Promise<KardexAsistenciaInfo[]>;
    updateKardexAsistencia(incidencias: KardexAsistenciaInfo[]): Promise<boolean>;
    getKardexEstatus(): Promise<any[]>;
    getIncidenciasFecha(idSucursal: number, fecha: Date): Promise<any[]>;
    getIncidenciasByEmpleado(idEmpleado: number, fechaIni: Date, fechaFin: Date): Promise<any[]>;
    updateIncidenciasByEmpleado(incidencias: any[]): Promise<boolean>;
}
