"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
var operators_1 = require("rxjs/operators");
//Azteca Kernel
var core_2 = require("framework3/core");
//Locales
var moment = require("moment");
var KardexAsistenciaService = /** @class */ (function (_super) {
    __extends(KardexAsistenciaService, _super);
    function KardexAsistenciaService(http, context) {
        return _super.call(this, http, context, 'api/rh/kadex-asistencia') || this;
    }
    KardexAsistenciaService.prototype.searchIncidenciaEmpleado = function (idBranch, request) {
        var params = new http_1.HttpParams()
            .set('idBranch', idBranch.toString());
        return this.apiService.post('search-incidencia-empleado', params, request)
            .pipe(operators_1.map(function (result) {
            result.rows.forEach(function (item) {
                item.fecha = moment(item.fecha).toDate();
            });
            return result;
        })).toPromise();
    };
    KardexAsistenciaService.prototype.updateIncidenciaEmpleado = function (info) {
        var params = new http_1.HttpParams();
        return this.apiService.post('update-incidencia-empleado', params, info).toPromise();
    };
    KardexAsistenciaService.prototype.deleteIncidenciaEmpleado = function (identity) {
        var params = new http_1.HttpParams()
            .set('identity', identity.toString());
        return this.apiService.post('delete-incidencia-empleado', params).toPromise();
    };
    KardexAsistenciaService.prototype.printKardexAsistencia = function (idEmpleado, idDepartamento, fechaIni, fechaFin, activo, pie) {
        var params = new http_1.HttpParams()
            .set('idEmpleado', idEmpleado.toString())
            .set('idDepartamento', idDepartamento.toString())
            .set('fechaIni', fechaIni.toLocaleDateString('en-US'))
            .set('fechaFin', fechaFin.toLocaleDateString('en-US'))
            .set('activo', activo.toString())
            .set('pie', pie);
        return this.apiService.get('print-tarjeta-asistencias', params)
            .toPromise();
    };
    KardexAsistenciaService.prototype.printTransacciones = function (idEmpleado, idDepartamento, fechaIni, fechaFin, activo, pie) {
        var params = new http_1.HttpParams()
            .set('idEmpleado', idEmpleado.toString())
            .set('idDepartamento', idDepartamento.toString())
            .set('fechaIni', fechaIni.toLocaleDateString('en-US'))
            .set('fechaFin', fechaFin.toLocaleDateString('en-US'))
            .set('activo', activo.toString())
            .set('pie', pie);
        return this.apiService.get('print-transacciones', params)
            .toPromise();
    };
    KardexAsistenciaService.prototype.getKardexAsistencia = function (idEmpleado, fechaIni, fechaFin) {
        var params = new http_1.HttpParams()
            .set('idEmpleado', idEmpleado.toString())
            .set('fechaIni', fechaIni.toLocaleDateString('en-US'))
            .set('fechaFin', fechaFin.toLocaleDateString('en-US'));
        return this.apiService.get('get-kardex-asistencia', params)
            .pipe(operators_1.map(function (result) {
            result.forEach(function (item) {
                item.fecha = moment(item.fecha).toDate();
            });
            return result;
        })).toPromise();
    };
    KardexAsistenciaService.prototype.updateKardexAsistencia = function (incidencias) {
        var params = new http_1.HttpParams();
        return this.apiService.post('update-kardex-asistencia', params, incidencias).toPromise();
    };
    KardexAsistenciaService.prototype.getKardexEstatus = function () {
        return this.apiService.get('get-kardex-estatus').toPromise();
    };
    KardexAsistenciaService.prototype.getIncidenciasFecha = function (idSucursal, fecha) {
        var param = new http_1.HttpParams()
            .set('idSucursal', idSucursal.toString())
            .set('fecha', fecha.toLocaleDateString('en-US'));
        return this.apiService.get('get-incidencias-fecha', param).toPromise();
    };
    KardexAsistenciaService.prototype.getIncidenciasByEmpleado = function (idEmpleado, fechaIni, fechaFin) {
        var params = new http_1.HttpParams()
            .set('idEmpleado', idEmpleado.toString())
            .set('fechaIni', fechaIni.toDateString())
            .set('fechaFin', fechaFin.toDateString());
        return this.apiService.get('get-incidencias-by-empleado', params).toPromise();
    };
    KardexAsistenciaService.prototype.updateIncidenciasByEmpleado = function (incidencias) {
        var params = new http_1.HttpParams();
        return this.apiService.post('update-incidencias-by-empleado', params, incidencias).toPromise();
    };
    KardexAsistenciaService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], KardexAsistenciaService);
    return KardexAsistenciaService;
}(core_2.BaseService));
exports.KardexAsistenciaService = KardexAsistenciaService;
