"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
var operators_1 = require("rxjs/operators");
var moment = require("moment");
//Azteca Kernel
var core_2 = require("framework3/core");
//Locales
var periodicidad_pago_1 = require("../models/periodicidad-pago");
var PeriodicidadPagoService = /** @class */ (function (_super) {
    __extends(PeriodicidadPagoService, _super);
    function PeriodicidadPagoService(http, context) {
        return _super.call(this, http, context, 'api/rh/periodicidad-pago') || this;
    }
    PeriodicidadPagoService.prototype.create = function () {
        return Promise.resolve(new periodicidad_pago_1.PeriodicidadPagoInfo());
    };
    PeriodicidadPagoService.prototype.getDetailByID = function (itemID) {
        var params = new http_1.HttpParams()
            .set('itemID', itemID.toString());
        return this.apiService.get('get-detail-id', params)
            .pipe(operators_1.map(function (info) {
            info.periodos.forEach(function (periodo) {
                periodo.fechaIniPago = moment(periodo.fechaIniPago).toDate();
                periodo.fechaFinPago = moment(periodo.fechaFinPago).toDate();
                periodo.fechaIniIncidencia = moment(periodo.fechaIniIncidencia).toDate();
                periodo.fechaFinIncidencia = moment(periodo.fechaFinIncidencia).toDate();
                periodo.periodoDias.forEach(function (periodoDias) {
                    periodoDias.fechaIncidencia = moment(periodoDias.fechaIncidencia).toDate();
                });
            });
            return info;
        }))
            .toPromise();
    };
    PeriodicidadPagoService.prototype.getDetailByCode = function (idBranch, code) {
        var params = new http_1.HttpParams()
            .set('idBranch', idBranch.toString())
            .set('code', code);
        return this.apiService.get('get-detail-code', params)
            .pipe(operators_1.map(function (info) {
            info.periodos.forEach(function (periodo) {
                periodo.fechaIniPago = moment(periodo.fechaIniPago).toDate();
                periodo.fechaFinPago = moment(periodo.fechaFinPago).toDate();
                periodo.fechaIniIncidencia = moment(periodo.fechaIniIncidencia).toDate();
                periodo.fechaFinIncidencia = moment(periodo.fechaFinIncidencia).toDate();
                periodo.periodoDias.forEach(function (periodoDias) {
                    periodoDias.fechaIncidencia = moment(periodoDias.fechaIncidencia).toDate();
                });
            });
            return info;
        }))
            .toPromise();
    };
    PeriodicidadPagoService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], PeriodicidadPagoService);
    return PeriodicidadPagoService;
}(core_2.CatalogService));
exports.PeriodicidadPagoService = PeriodicidadPagoService;
