"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
var operators_1 = require("rxjs/operators");
//Locales
var moment = require("moment");
//Azteca Kernel
var core_2 = require("framework3/core");
var PeriodoTrabajoService = /** @class */ (function (_super) {
    __extends(PeriodoTrabajoService, _super);
    function PeriodoTrabajoService(http, context) {
        return _super.call(this, http, context, 'api/rh/periodos-trabajo') || this;
    }
    PeriodoTrabajoService.prototype.getPeriodoTrabajo = function (idEmpleado, fechaIni, fechaFin) {
        var params = new http_1.HttpParams()
            .set('idEmpleado', idEmpleado.toString())
            .set('fechaIni', fechaIni.toLocaleDateString('en-US'))
            .set('fechaFin', fechaFin.toLocaleDateString('en-US'));
        return this.apiService.get('get-periodo-trabajo', params)
            .pipe(operators_1.map(function (result) {
            result.forEach(function (item) {
                item.fecha = moment(item.fecha).toDate();
                if (item.entrada)
                    item.entrada = moment(item.entrada).toDate();
                if (item.salida)
                    item.salida = moment(item.salida).toDate();
            });
            return result;
        })).toPromise();
    };
    PeriodoTrabajoService.prototype.updatePeriodoTurnoHorario = function (periodos) {
        var params = new http_1.HttpParams();
        return this.apiService.post('update-periodo-turno-horario', params, periodos).toPromise();
    };
    PeriodoTrabajoService.prototype.getPeriodoTrabajoFecha = function (idSucursal, fecha) {
        var params = new http_1.HttpParams()
            .set('idSucursal', idSucursal.toString())
            .set('fecha', fecha.toDateString());
        return this.apiService.get('get-periodo-trabajo-fecha', params).toPromise();
    };
    PeriodoTrabajoService.prototype.updatePeriodosFecha = function (fecha, empleados) {
        var params = new http_1.HttpParams()
            .set('fecha', fecha.toDateString());
        return this.apiService.post('update-periodo-turno-horario-fecha', params, empleados).toPromise();
    };
    PeriodoTrabajoService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], PeriodoTrabajoService);
    return PeriodoTrabajoService;
}(core_2.BaseService));
exports.PeriodoTrabajoService = PeriodoTrabajoService;
