import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { MenuItem } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { Clasificacion } from 'framework3/general';
import { ClienteService } from '../services/cliente.service';
import { ClienteInfo } from '../models/cliente';
import { ListaPreciosService } from '../services/lista-precios.service';
import { ListaPreciosItem } from '../models/lista-precios';
import { GrupoDescuentoService } from '../services/grupo-descuento.service';
import { GrupoDescuentoItem } from '../models/grupo-descuento';
import { FormaPagoService } from '../../credit/services/forma-pago.service';
import { FormaPagoItem } from '../../credit/models/forma-pago';
import { AddendaItem } from '../../accounting/models/addenda';
import { ComprobanteFiscalService } from '../../accounting/services/comprobante-fiscal.service';
import { GrupoDeudorSelectorComponent } from '../../credit/components/grupo-deudores-selector.component';
import { GrupoDeudorInfo } from '../../credit/models/grupo-deudor';
import { DeudorService } from '../../credit/services/deudor.service';
import { ContribuyenteService } from '../../accounting/services/contribuyente.service';
import { UsoCFDIItem } from '../../accounting/models/contribuyente';
export declare class ClientesEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private clienteService;
    private listaPreciosService;
    private grupoDescuentoService;
    private formaPagoService;
    private comprobanteFiscalService;
    private contribuyenteService;
    private deudorService;
    cliente: ClienteInfo;
    listasPrecio: ListaPreciosItem[];
    gruposDescuento: GrupoDescuentoItem[];
    formasPago: FormaPagoItem[];
    addendas: AddendaItem[];
    condicionesPago: {
        id: string;
        nombre: string;
    }[];
    clasificadores: Clasificacion[];
    usosCFDI: UsoCFDIItem[];
    selInsumo: GrupoDeudorSelectorComponent;
    domicilioFiscal: GrupoDeudorSelectorComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, clienteService: ClienteService, listaPreciosService: ListaPreciosService, grupoDescuentoService: GrupoDescuentoService, formaPagoService: FormaPagoService, comprobanteFiscalService: ComprobanteFiscalService, contribuyenteService: ContribuyenteService, deudorService: DeudorService);
    onConfigureCatalog(options: CatalogOptions): void;
    loadClasificadores(): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadListasPrecio(): void;
    loadGruposDescuento(): void;
    loadFormasPago(): void;
    loadAddendas(): void;
    loadUsosCFDI(): void;
    onMenuItemClick(option: MenuItem): void;
    onSelectTab(args: any): void;
    onGrupoDeudorSelected(grupo: GrupoDeudorInfo): void;
}
