"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var cliente_service_1 = require("../services/cliente.service");
var cliente_1 = require("../models/cliente");
var lista_precios_service_1 = require("../services/lista-precios.service");
var lista_precios_1 = require("../models/lista-precios");
var grupo_descuento_service_1 = require("../services/grupo-descuento.service");
var grupo_descuento_1 = require("../models/grupo-descuento");
var forma_pago_service_1 = require("../../credit/services/forma-pago.service");
var comprobante_fiscal_service_1 = require("../../accounting/services/comprobante-fiscal.service");
var grupo_deudores_selector_component_1 = require("../../credit/components/grupo-deudores-selector.component");
var deudor_service_1 = require("../../credit/services/deudor.service");
var contribuyente_service_1 = require("../../accounting/services/contribuyente.service");
var ClientesEditor = /** @class */ (function (_super) {
    __extends(ClientesEditor, _super);
    //
    function ClientesEditor(router, route, formBuilder, changeDetector, context, location, clienteService, listaPreciosService, grupoDescuentoService, formaPagoService, comprobanteFiscalService, contribuyenteService, deudorService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.clienteService = clienteService;
        _this.listaPreciosService = listaPreciosService;
        _this.grupoDescuentoService = grupoDescuentoService;
        _this.formaPagoService = formaPagoService;
        _this.comprobanteFiscalService = comprobanteFiscalService;
        _this.contribuyenteService = contribuyenteService;
        _this.deudorService = deudorService;
        _this.cliente = new cliente_1.ClienteInfo();
        _this.listasPrecio = [];
        _this.gruposDescuento = [];
        _this.formasPago = [];
        _this.addendas = [];
        _this.condicionesPago = [];
        _this.clasificadores = [];
        _this.usosCFDI = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'telefonos': [''],
            'correo': [''],
            'pagina': [''],
            'pagWeb': [''],
            'webUser': [''],
            'webPassword': [''],
            'cuenta': [''],
            'domicilio': [''],
            'idGrupoDeudor': [0],
            'facturable': [''],
            'rfc': [''],
            'razonSocial': [''],
            'domicilioFiscal': [''],
            'idUsoCFDI': [0],
            'idAddenda': [''],
            'idListaPrecio': [0, controls_1.AztecaValidators.selected],
            'idGrupoDescuento': [0],
            'idFormaPago': [''],
            'cuentaPago': [''],
            'condiciones': ['', forms_1.Validators.required],
            'limiteCredito': [''],
            'diasCredito': [''],
            'clasificaciones': [[], controls_1.AztecaValidators.validClasifications],
            'desgloseIEPS': [''],
            'facturacionCategorizada': [0]
        });
        _this.catalogForm.controls['facturable'].valueChanges.subscribe(function (value) {
            if (value) {
                _this.catalogForm.controls['rfc'].setValidators(forms_1.Validators.required);
            }
            else
                _this.catalogForm.controls['rfc'].clearValidators();
            _this.catalogForm.controls['rfc'].updateValueAndValidity();
        });
        _this.condicionesPago =
            [
                { "id": '', "nombre": "[Seleccione la condición de pago]" },
                { "id": 'C', "nombre": "Credito" },
                { "id": 'E', "nombre": "Contado" }
            ];
        _this.cliente.deudor.condicionesPago = '';
        return _this;
    }
    ClientesEditor_1 = ClientesEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ClientesEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.loadListasPrecio();
        this.loadGruposDescuento();
        this.loadFormasPago();
        this.loadClasificadores();
        this.loadUsosCFDI();
        this.loadAddendas();
    };
    ClientesEditor.prototype.loadClasificadores = function () {
        var _this = this;
        this.deudorService.loadClassifiers(this.context.app.defaultSite.identity)
            .then(function (clasificadores) {
            _this.clasificadores = clasificadores;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClientesEditor.prototype.onCreatingItem = function () {
    };
    ClientesEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.clienteService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cliente = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClientesEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.clienteService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cliente = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClientesEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.domicilioFiscal.clear;
        this.clienteService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cliente = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClientesEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.clienteService.update(this.cliente)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cliente = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClientesEditor.prototype.loadListasPrecio = function () {
        var _this = this;
        this.listaPreciosService.loadList(this.context.app.defaultSite.identity)
            .then(function (listas) {
            var lista = new lista_precios_1.ListaPreciosItem;
            lista.id = 0;
            lista.codigo = "";
            lista.nombre = "[Sin Asignar]";
            listas.unshift(lista);
            _this.listasPrecio = listas;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClientesEditor.prototype.loadGruposDescuento = function () {
        var _this = this;
        this.grupoDescuentoService.loadList(this.context.app.defaultSite.identity)
            .then(function (grupos) {
            var grupo = new grupo_descuento_1.GrupoDescuentoItem;
            grupo.id = 0;
            grupo.codigo = "";
            grupo.nombre = "[Sin Asignar]";
            grupos.unshift(grupo);
            _this.gruposDescuento = grupos;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClientesEditor.prototype.loadFormasPago = function () {
        var _this = this;
        this.formaPagoService.loadList(this.context.app.defaultSite.identity)
            .then(function (formas) { return _this.formasPago = formas; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClientesEditor.prototype.loadAddendas = function () {
        var _this = this;
        this.comprobanteFiscalService.loadListAddendas(this.context.app.defaultCompany.identity)
            .then(function (addendas) { return _this.addendas = addendas; })
            .catch(function (error) {
            _this.handleError(error);
        });
    };
    ClientesEditor.prototype.loadUsosCFDI = function () {
        var _this = this;
        this.contribuyenteService.loadUsosCFDI(this.context.app.defaultCompany.identity)
            .then(function (usos) { return _this.usosCFDI = usos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    //Administracion de contactos
    ClientesEditor.prototype.onMenuItemClick = function (option) {
        if (option.name == 'CONTACTS') {
            this.router.navigate(['sales/clientes/contacts', this.process.id, this.cliente.identity]);
        }
    };
    ClientesEditor.prototype.onSelectTab = function (args) {
        if (args.heading) {
            wijmo_1.Control.invalidateAll();
        }
    };
    ClientesEditor.prototype.onGrupoDeudorSelected = function (grupo) {
        this.cliente.deudor.contribuyente = grupo.contribuyente;
    };
    var ClientesEditor_1;
    __decorate([
        core_1.ViewChild('selGrupoDeudor'),
        __metadata("design:type", grupo_deudores_selector_component_1.GrupoDeudorSelectorComponent)
    ], ClientesEditor.prototype, "selInsumo", void 0);
    __decorate([
        core_1.ViewChild('domicilioFiscal'),
        __metadata("design:type", grupo_deudores_selector_component_1.GrupoDeudorSelectorComponent)
    ], ClientesEditor.prototype, "domicilioFiscal", void 0);
    ClientesEditor = ClientesEditor_1 = __decorate([
        core_1.Component({
            selector: 'ventas-clientes-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <!--&& domicilio.valid &&  && domicilioFiscal.valid-->\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Cliente'\"\n                                 [info]=\"cliente\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'CONTACTS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Contactos'\" [smallText]=\"'editar personal de contacto'\"></azteca-menu-item>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"cliente.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"cliente.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Telefonos:'\">\n                                          <az-textbox formControlName=\"telefonos\" [(ngModel)]=\"cliente.telefonos\"></az-textbox>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'P\u00E1gina web:'\">\n                                          <az-textbox formControlName=\"pagina\" [(ngModel)]=\"cliente.pagWeb\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'Correo electr\u00F3nico:'\">\n                                          <az-textbox formControlName=\"correo\" [(ngModel)]=\"cliente.correo\"></az-textbox>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'Usuario web:'\">\n                                          <az-textbox formControlName=\"webUser\" [(ngModel)]=\"cliente.webUser\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                      \n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'Password web:'\">\n                                          <az-password formControlName=\"webPassword\" [(ngModel)]=\"cliente.webPassword\"></az-password>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Cuenta Contable:'\">\n                                          <accounting-cuenta-selector formControlName=\"cuenta\" [(ngModel)]=\"cliente.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <tab heading=\"Domicilio\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"''\">\n                                          <general-domicilio-editor #domicilio formControlName=\"domicilio\" \n                                                             [(ngModel)]=\"cliente.deudor.domicilio\"\n                                                             [asentamientoVisible]=\"false\">\n\n                                          </general-domicilio-editor>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </tab>\n\n                          <tab heading=\"Facturaci\u00F3n\">\n                              <div class=\"col-12 col-md-8\">\n                                  <azteca-form-field [label]=\"'Grupo deudor:'\">\n                                      <credit-grupo-deudores-selector  #selGrupoDeudor formControlName=\"idGrupoDeudor\" [(ngModel)]=\"cliente.deudor.idGrupoDeudor\" ngDefaultControl=\"\" (itemSelected)=\"onGrupoDeudorSelected($event)\"></credit-grupo-deudores-selector>\n                                  </azteca-form-field>\n                              </div>\n\n                              <az-checkbox formControlName=\"facturable\" [label]=\"'Solicita factura'\" [(ngModel)]=\"cliente.deudor.facturable\"></az-checkbox>\n\n                              <az-panel [enabled]=\"cliente.deudor.facturable\">\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-md-4\">\n                                          <azteca-form-field [label]=\"'RFC:'\">\n                                              <az-textbox formControlName=\"rfc\" [(ngModel)]=\"cliente.deudor.contribuyente.rfc\" [enabled]=\"cliente.deudor.facturable && cliente.deudor.idGrupoDeudor==0\"></az-textbox>\n                                          </azteca-form-field>\n                                      </div>\n                                      <div class=\"col-12 col-md-8\">\n                                          <azteca-form-field [label]=\"'Raz\u00F3n Social:'\">\n                                              <az-textbox formControlName=\"razonSocial\" [(ngModel)]=\"cliente.deudor.contribuyente.razonSocial\" [enabled]=\"cliente.deudor.facturable && cliente.deudor.idGrupoDeudor==0\"></az-textbox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n\n                                  <div class=\"row\">\n                                      <div class=\"col-10 col-md-10\">\n                                          <azteca-form-field [label]=\"''\">\n                                              <general-domicilio-editor #domicilioFiscal [enabled]=\"cliente.deudor.facturable && cliente.deudor.idGrupoDeudor==0\"\n                                                                 formControlName=\"domicilioFiscal\"\n                                                                 [(ngModel)]=\"cliente.deudor.contribuyente.domicilio\"\n                                                                 [cruceUnoVisible]=\"false\"\n                                                                 [cruceDosVisible]=\"false\">\n\n                                              </general-domicilio-editor>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-md-10\">\n                                          <azteca-form-field [label]=\"'Uso de CFDI:'\">\n                                              <az-combobox formControlName=\"idUsoCFDI\" [enabled]=\"cliente.deudor.facturable && cliente.deudor.idGrupoDeudor==0\"\n                                                           [(ngModel)]=\"cliente.deudor.contribuyente.idUsoCFDI\"\n                                                           [items]=\"usosCFDI\"\n                                                           [displayMember]=\"'nombre'\"\n                                                           [valueMember]=\"'id'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-md-10\">\n                                          <azteca-form-field [label]=\"'Addenda:'\">\n                                              <az-combobox formControlName=\"idAddenda\" [enabled]=\"cliente.deudor.facturable && cliente.deudor.idGrupoDeudor==0\"\n                                                           [(ngModel)]=\"cliente.deudor.idComprobanteAddenda\"\n                                                           [items]=\"addendas\"\n                                                           [displayMember]=\"'nombre'\"\n                                                           [valueMember]=\"'id'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <az-checkbox formControlName=\"desgloseIEPS\" [label]=\"'Desglosa IEPS'\" [(ngModel)]=\"cliente.deudor.desgloseIEPS\" [enabled]=\"cliente.deudor.facturable && cliente.deudor.idGrupoDeudor==0\"></az-checkbox>\n                                  <az-checkbox formControlName=\"facturacionCategorizada\" [label]=\"'Facturacion Agrupada por Categorias'\" [(ngModel)]=\"cliente.deudor.facturacionCategorizada\" [enabled]=\"cliente.deudor.facturable\"></az-checkbox>\n                              </az-panel>\n\n                          </tab>\n\n                          <tab heading=\"Condiciones Comerciales\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Lista de Precio:'\">\n                                          <az-combobox formControlName=\"idListaPrecio\"\n                                                       [(ngModel)]=\"cliente.idListaPrecios\"\n                                                       [items]=\"listasPrecio\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'idListaPrecios'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                                                \n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Grupo de Descuento:'\">\n                                          <az-combobox formControlName=\"idGrupoDescuento\"\n                                                       [(ngModel)]=\"cliente.idGrupoDescuentos\"\n                                                       [items]=\"gruposDescuento\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <az-panel [header]=\"'Condiciones de Cr\u00E9dito'\">\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-md-8\">\n                                          <azteca-form-field [label]=\"''\">\n                                              <az-combobox formControlName=\"condiciones\"\n                                                           [(ngModel)]=\"cliente.deudor.condicionesPago\"\n                                                           [items]=\"condicionesPago\"\n                                                           [displayMember]=\"'nombre'\"\n                                                           [valueMember]=\"'id'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-lg-4\">\n                                          <azteca-form-field [label]=\"'Limite de Cr\u00E9dito:'\">\n                                              <az-input-number formControlName=\"limiteCredito\" [(ngModel)]=\"cliente.deudor.limiteCredito\" format=\"C\" [enabled]=\"cliente.deudor.condicionesPago=='C'\"></az-input-number>\n                                          </azteca-form-field>\n                                      </div>\n                                      <div class=\"col-12 col-lg-4\">\n                                          <azteca-form-field [label]=\"'Dias de Cr\u00E9dito:'\">\n                                              <az-input-number formControlName=\"diasCredito\" [(ngModel)]=\"cliente.deudor.diasCredito\" format=\"n0\" [enabled]=\"cliente.deudor.condicionesPago=='C'\"></az-input-number>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                              </az-panel>                       \n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Forma de Pago Predeterminada:'\">\n                                          <az-combobox formControlName=\"idFormaPago\"\n                                                       [(ngModel)]=\"cliente.deudor.idFormaPago\"\n                                                       [items]=\"formasPago\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Cuenta de Pago:'\">\n                                          <az-textbox formControlName=\"cuentaPago\" [(ngModel)]=\"cliente.deudor.cuentaPago\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                            \n                      </tab>\n\n                      <tab  heading=\"Clasificaciones\"  (select)=\"onSelectTab($event)\">\n                          <div class=\"row\">\n                              <div class=\"col-12 col-md-10\">\n\n                                  <label>Clasificaciones a deudor</label>\n\n                                  <az-clasificaciones-editor formControlName=\"clasificaciones\" [(ngModel)]=\"cliente.deudor.clasificaciones\" [clasificadores]=\"clasificadores\">\n                            \n\n                                  </az-clasificaciones-editor>\n\n\n                              </div>\n                          </div>        \n                      </tab>\n\n                  </tabset>\n              </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ClientesEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: cliente_service_1.ClienteService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, cliente_service_1.ClienteService, lista_precios_service_1.ListaPreciosService,
            grupo_descuento_service_1.GrupoDescuentoService, forma_pago_service_1.FormaPagoService, comprobante_fiscal_service_1.ComprobanteFiscalService,
            contribuyente_service_1.ContribuyenteService, deudor_service_1.DeudorService])
    ], ClientesEditor);
    return ClientesEditor;
}(editors_1.CatalogEditor));
exports.ClientesEditor = ClientesEditor;
