"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var grupo_descuento_service_1 = require("../services/grupo-descuento.service");
var GruposDescuentosManager = /** @class */ (function (_super) {
    __extends(GruposDescuentosManager, _super);
    //    
    function GruposDescuentosManager(router, route, context, grupoDescuentoService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.router = router;
        _this.route = route;
        _this.context = context;
        _this.grupoDescuentoService = grupoDescuentoService;
        _this.gruposdescuentos = [];
        return _this;
    }
    GruposDescuentosManager_1 = GruposDescuentosManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    GruposDescuentosManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
        this.refreshList();
    };
    GruposDescuentosManager.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.grupoDescuentoService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.gruposdescuentos = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GruposDescuentosManager.prototype.onAddingItem = function () {
        this.router.navigate([0], { relativeTo: this.route });
    };
    GruposDescuentosManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    GruposDescuentosManager.prototype.onEditingItem = function (item) {
        this.router.navigate([item.id], { relativeTo: this.route });
    };
    GruposDescuentosManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.grupoDescuentoService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GruposDescuentosManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    GruposDescuentosManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.grupoDescuentoService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GruposDescuentosManager.prototype.onMenuItemClick = function (option) {
        if (option.name == 'ARTICULOS') {
            this.router.navigate([this.manager.currentItem.id, 'articulos'], { relativeTo: this.route });
        }
        else if (option.name == 'SERVICIOS') {
            this.router.navigate([this.manager.currentItem.id, 'servicios'], { relativeTo: this.route });
        }
        else if (option.name == 'CLIENTES') {
            this.router.navigate([this.manager.currentItem.id, 'clientes'], { relativeTo: this.route });
        }
    };
    var GruposDescuentosManager_1;
    GruposDescuentosManager = GruposDescuentosManager_1 = __decorate([
        core_1.Component({
            selector: 'ventas-gruposdescuentos-manager',
            template: "\n      <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                              (addingItem)=\"onAddingItem()\"\n                              (viewingItem)=\"onViewingItem($event)\"\n                              (editingItem)=\"onEditingItem($event)\"\n                              (deletingItem)=\"onDeletingItem($event)\"\n                              (cloningItem)=\"onCloningItem($event)\"\n                              (changingItemState)=\"onChangingItemState($event)\"\n      \t\t\t\t\t\t(configureCatalog)=\"onConfigureCatalog($event)\"\n                              (menuItemClick)=\"onMenuItemClick($event)\"\n                              [enabled]=\"enabled\"\n                              [allowNew]=\"allowNew\"\n                              [allowView]=\"allowView\"\n                              [allowEdit]=\"allowEdit\"\n                              [allowDelete]=\"allowDelete\"\n                              [allowClone]=\"allowClone\"\n                              [allowChangeState]=\"allowChangeState\"\n                              [catalogList]=\"gruposdescuentos\"\n                              [totalRows]=\"totalRows\"\n                              [pageIndex]=\"pageIndex\">\n\n          <!------------------- Menu de acciones adicionales --------------------->\n          <azteca-menu-item [name]=\"'ARTICULOS'\" [icon]=\"'glyphicon glyphicon-inbox'\" [text]=\"'Articulos'\" [smallText]=\"'editar los precios de los articulos'\"></azteca-menu-item>\n          <azteca-menu-item [name]=\"'SERVICIOS'\" [icon]=\"'glyphicon glyphicon-cog'\" [text]=\"'Servicios'\" [smallText]=\"'editar los precios de los servicios'\"></azteca-menu-item>\n          <azteca-menu-item [name]=\"'CLIENTES'\" [icon]=\"'fa fa-users'\" [text]=\"'Clientes'\" [smallText]=\"'editar los clientes miembros'\"></azteca-menu-item>\n\n          <!------------------- Columnas del listado --------------------->\n          <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n    \n      </azteca-catalog-manager>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return GruposDescuentosManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: grupo_descuento_service_1.GrupoDescuentoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, core_2.Context, grupo_descuento_service_1.GrupoDescuentoService])
    ], GruposDescuentosManager);
    return GruposDescuentosManager;
}(editors_1.CatalogManager));
exports.GruposDescuentosManager = GruposDescuentosManager;
