"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var lista_precios_service_1 = require("../services/lista-precios.service");
var lista_precios_1 = require("../models/lista-precios");
var ListasPreciosEditor = /** @class */ (function (_super) {
    __extends(ListasPreciosEditor, _super);
    //
    function ListasPreciosEditor(router, route, formBuilder, changeDetector, context, location, listaPreciosService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.listaPreciosService = listaPreciosService;
        _this.listaprecios = new lista_precios_1.ListaPreciosInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required]
        });
        return _this;
    }
    ListasPreciosEditor_1 = ListasPreciosEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ListasPreciosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    ListasPreciosEditor.prototype.onCreatingItem = function () {
    };
    ListasPreciosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.listaPreciosService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.listaprecios = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ListasPreciosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.listaPreciosService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.listaprecios = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ListasPreciosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.listaPreciosService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.listaprecios = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ListasPreciosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.listaPreciosService.update(this.listaprecios)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.listaprecios = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ListasPreciosEditor.prototype.onMenuItemClick = function (option) {
        if (option.name == 'ARTICULOS') {
            this.router.navigate(['articulos'], { relativeTo: this.route });
        }
        if (option.name == 'SERVICIOS') {
            this.router.navigate(['servicios'], { relativeTo: this.route });
        }
        if (option.name == 'CLIENTES') {
            this.router.navigate(['clientes'], { relativeTo: this.route });
        }
    };
    var ListasPreciosEditor_1;
    ListasPreciosEditor = ListasPreciosEditor_1 = __decorate([
        core_1.Component({
            selector: 'ventas-listasprecios-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'ListaPrecios'\"\n                                 [info]=\"listaprecios\"\n                                 [valid]=\"catalogForm.valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\" \n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'ARTICULOS'\" [icon]=\"'glyphicon glyphicon-inbox'\" [text]=\"'Articulos'\" [smallText]=\"'editar los precios de los articulos'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'SERVICIOS'\" [icon]=\"'glyphicon glyphicon-cog'\" [text]=\"'Servicios'\" [smallText]=\"'editar los precios de los servicios'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'CLIENTES'\" [icon]=\"'fa fa-users'\" [text]=\"'Clientes'\" [smallText]=\"'editar los clientes miembros'\"></azteca-menu-item>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"listaprecios.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"listaprecios.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ListasPreciosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: lista_precios_service_1.ListaPreciosService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, lista_precios_service_1.ListaPreciosService])
    ], ListasPreciosEditor);
    return ListasPreciosEditor;
}(editors_1.CatalogEditor));
exports.ListasPreciosEditor = ListasPreciosEditor;
