"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Contabilidad
var accounting_1 = require("../../accounting");
//Ventas
var servicio_service_1 = require("../services/servicio.service");
var servicio_1 = require("../models/servicio");
var unidad_medida_service_1 = require("../../inventory/services/unidad-medida.service");
var unidad_medida_tipo_1 = require("../../inventory/models/unidad-medida-tipo");
var unidad_medida_tipo_service_1 = require("../../inventory/services/unidad-medida-tipo.service");
var zona_venta_service_1 = require("../services/zona-venta.service");
var ServiciosEditor = /** @class */ (function (_super) {
    __extends(ServiciosEditor, _super);
    //
    function ServiciosEditor(router, route, formBuilder, changeDetector, context, location, servicioService, unidadMedidaService, tipoUnidadService, zonaVentaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.servicioService = servicioService;
        _this.unidadMedidaService = unidadMedidaService;
        _this.tipoUnidadService = tipoUnidadService;
        _this.zonaVentaService = zonaVentaService;
        _this.servicio = new servicio_1.ServicioInfo();
        _this.impuestosCollection = new editors_1.TrackableCollection();
        _this.tiposUnidad = [];
        _this.unidadesMedida = [];
        _this.unidadMedidaTipo = new unidad_medida_tipo_1.UnidadMedidaTipoInfo();
        _this.zonasVenta = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'categoriaFiscal': [0, controls_1.AztecaValidators.selected],
            'idEstCom': [0],
            'idFlujo': [0],
            'idCuenta': [0],
            'impuestoIncluido': [false],
            'libre': [false],
            'idUnidadMedida': [0, controls_1.AztecaValidators.selected],
            //
            'idZonaVenta': [0]
        });
        return _this;
    }
    ServiciosEditor_1 = ServiciosEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ServiciosEditor.prototype.loadTiposUnidad = function () {
        var _this = this;
        this.tipoUnidadService.getDetailByCode(this.context.app.defaultSite.idBranch, "SVC")
            .then(function (tipos) {
            _this.loadUnidadesMedida(tipos.identity);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServiciosEditor.prototype.loadZonasVenta = function () {
        var _this = this;
        this.zonaVentaService.loadList(this.context.app.defaultCompany.identity.toString())
            .then(function (zonasVenta) { return _this.zonasVenta = zonasVenta; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServiciosEditor.prototype.loadUnidadesMedida = function (idTipoUnidad) {
        var _this = this;
        this.unidadMedidaService.loadList(idTipoUnidad)
            .then(function (unidades) {
            _this.unidadesMedida = unidades;
            _this.unidadesMedida.unshift({ id: 0, codigo: '', nombre: '[Seleccionar]', activo: true, estatus: 'activo', factor: 0, base: false, fraccionable: false, paquete: false });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ServiciosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.loadTiposUnidad();
        this.loadZonasVenta();
    };
    ServiciosEditor.prototype.onCreatingItem = function () {
        this.impuestosCollection.sourceCollection = this.servicio.impuestos;
    };
    ServiciosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.servicioService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.servicio = info;
            _this.setReadonlyMode();
            //this.impuestosCollection.sourceCollection = this.servicio.impuestos;
            _this.impuestosCollection.sourceCollection = _this.servicio.impuestos.filter(function (item) { return item.idZonaVenta == _this.idZonaVenta; });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServiciosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.servicioService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.servicio = info;
            _this.impuestosCollection.sourceCollection = _this.servicio.impuestos;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServiciosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.servicioService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.servicio = info;
            _this.impuestosCollection.sourceCollection = _this.servicio.impuestos.filter(function (item) { return item.idZonaVenta == _this.idZonaVenta; });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServiciosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.servicioService.update(this.servicio)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.servicio.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.servicio = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServiciosEditor.prototype.onTabSelected = function () {
        wijmo_1.Control.invalidateAll();
    };
    ///////////// IMPUESTOS /////////////////////////
    ServiciosEditor.prototype.onImpuestosToolbar = function (button) {
        if (this.idZonaVenta > 0 && this.idZonaVenta != undefined)
            this.impuestoEditor.show();
        else
            this.showAlert("Debe seleccionar una zona de venta para incluir impuestos al servicio", "warning");
    };
    ServiciosEditor.prototype.onMenuItemClick = function (item) {
        if (item.name == 'LP') {
            this.router.navigate(['sales/articulo-listas-precio/' + this.process.id + '/' + this.servicio.identity.toString()]);
        }
        else if (item.name == 'GD') {
            this.router.navigate(['sales/articulo-grupo-descuento/' + this.process.id + '/' + this.servicio.identity.toString()]);
        }
    };
    ServiciosEditor.prototype.onRemoveItem = function (impuesto) {
        this.impuestosCollection.remove(impuesto);
    };
    ServiciosEditor.prototype.onImpuestoUpdated = function (impuesto) {
        var _this = this;
        var newImpuestos = this.servicio.impuestos.slice();
        impuesto.idZonaVenta = this.idZonaVenta; //se asigna la zona de venta seleccionada
        newImpuestos.push(impuesto);
        this.servicio.impuestos = newImpuestos;
        this.impuestosCollection.sourceCollection = newImpuestos.filter(function (item) { return item.idZonaVenta == _this.idZonaVenta; });
    };
    ServiciosEditor.prototype.onZonaVentaChanged = function (idZonaVenta) {
        this.impuestosCollection.sourceCollection = this.servicio.impuestos.filter(function (item) { return item.idZonaVenta == idZonaVenta; });
    };
    var ServiciosEditor_1;
    __decorate([
        core_1.ViewChild('impuestosList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], ServiciosEditor.prototype, "impuestosList", void 0);
    __decorate([
        core_1.ViewChild(accounting_1.ImpuestosAsignacionEditor),
        __metadata("design:type", accounting_1.ImpuestosAsignacionEditor)
    ], ServiciosEditor.prototype, "impuestoEditor", void 0);
    ServiciosEditor = ServiciosEditor_1 = __decorate([
        core_1.Component({
            selector: 'ventas-servicio-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Servicio'\"\n                                 [info]=\"servicio\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n\n              <!--Toolbar Principal-->\n              <azteca-menu-item [name]=\"'LP'\" [icon]=\"'glyphicon glyphicon-usd'\" [text]=\"'Listas de Precios'\" [smallText]=\"'configuraci\u00F3n de listas de precios'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'GD'\" [icon]=\"'glyphicon glyphicon-gift'\" [text]=\"'Grupos de Descuentos'\" [smallText]=\"'configuraci\u00F3n de grupos de gescuentos'\"></azteca-menu-item>\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"servicio.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"servicio.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <tabset>\n                          <!------------------- GENERALES ----------------------------->\n                          <tab heading=\"Generales\">\n\n\t\t\t\t\t\t\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n\n                                      <azteca-form-field [label]=\"'Estructura comercial:'\">\n                                          <sales-est-com-selector formControlName=\"idEstCom\" [(ngModel)]=\"servicio.idEstructuraComercial\"></sales-est-com-selector>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Categor\u00EDa de flujo:'\">\n                                          <accounting-flujo-selector formControlName=\"idFlujo\" [(ngModel)]=\"servicio.idFlujo\"></accounting-flujo-selector>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"idCuenta\" [(ngModel)]=\"servicio.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Agregar Categoria Fiscal:'\">\n                                          <accounting-articulo-categoria-fiscal-selector formControlName=\"categoriaFiscal\" [(ngModel)]=\"servicio.idCategoriaFiscal\" [showListButton]=\"true\" #selectorCategoria></accounting-articulo-categoria-fiscal-selector>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Unidad de medida:'\">\n                                          <az-combobox formControlName=\"idUnidadMedida\"\n                                                       [(ngModel)]=\"servicio.idUnidadMedida\"\n                                                       [items]=\"unidadesMedida\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n\n                                      <az-checkbox formControlName=\"impuestoIncluido\" [(ngModel)]=\"servicio.impuestoIncluido\" [label]=\"'El precio incluye impuestos'\"></az-checkbox>\n\n                                      <az-checkbox formControlName=\"libre\" [(ngModel)]=\"servicio.libre\" [label]=\"'El servicio se utiliza como concepto libre'\"></az-checkbox>\n\n                                  </div>\n                              </div>\n\t\t\t\t\t\t\n\n\n                          </tab>\n                          <!------------------- IMPUESTOS ----------------------------->\n                          <tab heading=\"Impuestos\" (select)=\"onTabSelected($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Zona de Venta:'\">\n                                          <az-combobox formControlName=\"idZonaVenta\"\n                                                       [(ngModel)]=\"idZonaVenta\"\n                                                       [items]=\"zonasVenta\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\"\n                                                       (selectedItemChanged)=\"onZonaVentaChanged($event)\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <!--Toolbar Principal-->\n                              <az-toolbar (buttonClick)=\"onImpuestosToolbar($event)\">\n                                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar Impuesto'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <wj-flex-grid #gridImpuestos style=\"height:550px\"\n                                            [itemsSource]=\"impuestosCollection\">\n\n                                  <wj-flex-grid-column [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveItem(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-trash\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n\n                                  <wj-flex-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'impuesto.code'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Tasa \u00F3 cuota'\" [binding]=\"'tasaOCuota'\" [width]=\"'30*'\" [isReadOnly]=\"true\" format=\"n2\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Orden c\u00E1lculo'\" [binding]=\"'ordenCalculo'\" [width]=\"'25*'\" [isReadOnly]=\"true\" format=\"n0\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Tipo c\u00E1lculo'\" [binding]=\"'tipoCalculo'\" [width]=\"'25*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n          </azteca-catalog-editor>\n\n          <accounting-impuesto-asignacion (dataUpdater)=\"onImpuestoUpdated($event)\">\n\n          </accounting-impuesto-asignacion>\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ServiciosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: servicio_service_1.ServicioService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, servicio_service_1.ServicioService,
            unidad_medida_service_1.UnidadMedidaService, unidad_medida_tipo_service_1.UnidadMedidaTipoService, zona_venta_service_1.ZonaVentaService])
    ], ServiciosEditor);
    return ServiciosEditor;
}(editors_1.CatalogEditor));
exports.ServiciosEditor = ServiciosEditor;
