"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var custom_1 = require("framework3/custom");
var editors_1 = require("framework3/editors");
//Features
var servicio_service_1 = require("../services/servicio.service");
var ServiciosManager = /** @class */ (function (_super) {
    __extends(ServiciosManager, _super);
    //    
    function ServiciosManager(context, router, route, servicioService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.servicioService = servicioService;
        _this.servicios = [];
        _this.options = new custom_1.CatalogOptions();
        return _this;
    }
    ServiciosManager_1 = ServiciosManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ServiciosManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
        this.refreshList();
        this.applyPolicies();
    };
    ServiciosManager.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.servicioService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.servicios = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServiciosManager.prototype.onAddingItem = function () {
        this.router.navigate([0], { relativeTo: this.route });
    };
    ServiciosManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    ServiciosManager.prototype.onEditingItem = function (item) {
        this.router.navigate([item.id], { relativeTo: this.route });
    };
    ServiciosManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.servicioService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServiciosManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    ServiciosManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.servicioService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServiciosManager.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    ServiciosManager.prototype.onMenuItemClick = function (item) {
        if (item.name == 'LP') {
            this.router.navigate(['sales/servicio-listas-precio/' + this.process.id + '/' + this.currentItem.id.toString()]);
        }
        else if (item.name == 'GD') {
            this.router.navigate(['sales/servicio-grupo-descuento/' + this.process.id + '/' + this.currentItem.id.toString()]);
        }
    };
    var ServiciosManager_1;
    ServiciosManager = ServiciosManager_1 = __decorate([
        core_1.Component({
            selector: 'ventas-servicios-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Ventas - Servicios</div>\n          <div class=\"card-body\">\n\n      \t\t<azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n      \t\t\t\t\t\t\t\t(addingItem)=\"onAddingItem()\"\n      \t\t\t\t\t\t\t\t(viewingItem)=\"onViewingItem($event)\"\n      \t\t\t\t\t\t\t\t(editingItem)=\"onEditingItem($event)\"\n      \t\t\t\t\t\t\t\t(deletingItem)=\"onDeletingItem($event)\"\n      \t\t\t\t\t\t\t\t(cloningItem)=\"onCloningItem($event)\"\n      \t\t\t\t\t\t\t\t(changingItemState)=\"onChangingItemState($event)\"\n      \t\t\t\t\t\t\t\t(configureCatalog)=\"onConfigureCatalog($event)\"\n                                      (currentItemChanged)=\"onCurrentItemChanged($event)\"\n      \t\t\t\t\t\t\t\t[enabled]=\"enabled\"\n      \t\t\t\t\t\t\t\t[allowNew]=\"allowNew\"\n      \t\t\t\t\t\t\t\t[allowView]=\"allowView\"\n      \t\t\t\t\t\t\t\t[allowEdit]=\"allowEdit\"\n      \t\t\t\t\t\t\t\t[allowDelete]=\"allowDelete\"\n      \t\t\t\t\t\t\t\t[allowClone]=\"allowClone\"\n      \t\t\t\t\t\t\t\t[allowChangeState]=\"allowChangeState\"\n      \t\t\t\t\t\t\t\t[allowAudit]=\"allowAudit\"\n      \t\t\t\t\t\t\t\t[catalogList]=\"servicios\"\n      \t\t\t\t\t\t\t\t[totalRows]=\"totalRows\"\n      \t\t\t\t\t\t\t\t[pageIndex]=\"pageIndex\"\n                                      (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'LP'\" [icon]=\"'glyphicon glyphicon-usd'\" [text]=\"'Listas de Precios'\" [smallText]=\"'configuraci\u00F3n de listas de precios'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'GD'\" [icon]=\"'glyphicon glyphicon-gift'\" [text]=\"'Grupos de Descuentos'\" [smallText]=\"'configuraci\u00F3n de grupos de gescuentos'\"></azteca-menu-item>\n\n              <!------------------- Columnas del listado ----------------------------->\n    \n      \t\t\t<azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n      \t\t\t<azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Estructura Comercial'\" [binding]=\"'estructuraComercial'\" [width]=\"'20*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Libre'\" [binding]=\"'libre'\" [width]=\"'10*'\" dataType=\"Boolean\"></azteca-grid-column>            \n\t\t\t\n\n      \t\t</azteca-catalog-manager>\n\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ServiciosManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: servicio_service_1.ServicioService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, servicio_service_1.ServicioService])
    ], ServiciosManager);
    return ServiciosManager;
}(editors_1.CatalogManager));
exports.ServiciosManager = ServiciosManager;
