import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { MenuItem } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { UnidadNegocioService } from '../services/unidad-negocio.service';
import { UnidadNegocioInfo } from '../models/unidad-negocio';
import { SerieFiscalItem } from '../../accounting/models/serie-fiscal';
import { SerieFiscalService } from '../../accounting/services/serie-fiscal.service';
import { DivisaService } from '../../accounting/services/divisa.service';
import { AreaItem } from '../../inventory/models/area';
import { AreaService } from '../../inventory/services/area.service';
import { AlmacenItem } from '../../inventory/models/almacen';
export declare class UnidadesNegocioEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private unidadNegocioService;
    private serieFiscalService;
    private divisaService;
    private areaService;
    unidadNegocio: UnidadNegocioInfo;
    series: SerieFiscalItem[];
    areas: AreaItem[];
    almacenes: AlmacenItem[];
    modalidadesAfectacion: {
        id: boolean;
        nombre: string;
    }[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, unidadNegocioService: UnidadNegocioService, serieFiscalService: SerieFiscalService, divisaService: DivisaService, areaService: AreaService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadSeries(): void;
    loadAreas(): void;
    selectTab(): void;
    selectArea(idArea: any): void;
    onMenuItemClick(option: MenuItem): void;
    onCancelingEdit(): void;
}
