import { ChangeDetectorRef, EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormGroup, FormBuilder } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { Context } from 'framework3/core';
import { CatalogEditor } from 'framework3/editors';
import { ArticuloService } from '../services/articulo.service';
import { ArticuloImpuestoItem } from '../models/articulo';
import { ImpuestoInfo } from '../../accounting/models/impuesto';
import { ImpuestosSelectorComponent } from '../../accounting/controls/impuestos-selector.component';
export declare class ArticulosImpuestosComponent extends CatalogEditor {
    private articulosService;
    protected context: Context;
    private formBuilder;
    protected router: Router;
    protected route: ActivatedRoute;
    protected changeDetectorRef: ChangeDetectorRef;
    editorForm: FormGroup;
    impuestoInfo: ImpuestoInfo;
    tiposFactor: {
        id: number;
        name: string;
    }[];
    tiposCalculo: {
        id: number;
        name: string;
    }[];
    data: ArticuloImpuestoItem;
    dataUpdater: EventEmitter<ArticuloImpuestoItem>;
    dialog: ModalDirective;
    selectorImpuestos: ImpuestosSelectorComponent;
    constructor(articulosService: ArticuloService, context: Context, formBuilder: FormBuilder, router: Router, route: ActivatedRoute, changeDetectorRef: ChangeDetectorRef);
    onFactorChange(): void;
    onTipoCalculoChange(): void;
    show(): void;
    onUpdate(): void;
    onItemChanged(args: ImpuestoInfo): void;
}
