"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Angular
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Framework 3
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var articulo_service_1 = require("../services/articulo.service");
var articulo_1 = require("../models/articulo");
var impuesto_1 = require("../../accounting/models/impuesto");
var impuestos_selector_component_1 = require("../../accounting/controls/impuestos-selector.component");
var ArticulosImpuestosComponent = /** @class */ (function (_super) {
    __extends(ArticulosImpuestosComponent, _super);
    function ArticulosImpuestosComponent(articulosService, context, formBuilder, router, route, changeDetectorRef) {
        var _this = _super.call(this, context, router, route, changeDetectorRef) || this;
        _this.articulosService = articulosService;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.router = router;
        _this.route = route;
        _this.changeDetectorRef = changeDetectorRef;
        _this.impuestoInfo = new impuesto_1.ImpuestoInfo();
        _this.tiposFactor = [
            { "id": 1, "name": "Tasa" },
            { "id": 2, "name": "Cuota" }
        ];
        _this.tiposCalculo = [
            { "id": 1, "name": "Base" },
            { "id": 2, "name": "Cascada" }
        ];
        //Inputs
        _this.data = new articulo_1.ArticuloImpuestoItem();
        //Outputs
        _this.dataUpdater = new core_1.EventEmitter();
        _this.editorForm = formBuilder.group({
            'impuestos': ['', controls_1.AztecaValidators.selected],
            'tipoFactor': [0, controls_1.AztecaValidators.selected],
            'valorTasa': [1],
            'valorCuota': [1],
            'tipoCalculo': [0, controls_1.AztecaValidators.selected],
            'ordenCalculo': [1]
        });
        return _this;
    }
    ArticulosImpuestosComponent_1 = ArticulosImpuestosComponent;
    ArticulosImpuestosComponent.prototype.onFactorChange = function () {
        //resetear el valor del campo tasa o cuota y si el campo rango es falso se asigna el valor fijo
        if (this.editorForm.controls.tipoFactor.value == 1) {
            this.data.cuota = 0;
            if (!this.impuestoInfo.rango)
                this.data.tasa = this.impuestoInfo.valorFijo;
        }
        if (this.editorForm.controls.tipoFactor.value == 2) {
            this.data.tasa = 0;
            if (!this.impuestoInfo.rango)
                this.data.cuota = this.impuestoInfo.valorFijo;
        }
    };
    ArticulosImpuestosComponent.prototype.onTipoCalculoChange = function () {
        if (this.editorForm.controls.tipoCalculo.value == 1) {
            this.data.tipoCalculo = 'B';
            this.data.ordenCalculo = 1;
        }
        else
            this.data.tipoCalculo = 'C';
        this.data.ordenCalculo = 2;
    };
    ArticulosImpuestosComponent.prototype.show = function () {
        var _this = this;
        this.data = new articulo_1.ArticuloImpuestoItem();
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) { return _this.editorForm.reset(); });
        wijmo_1.Control.invalidateAll();
    };
    ArticulosImpuestosComponent.prototype.onUpdate = function () {
        this.dataUpdater.emit(this.data);
        this.dialog.hide();
    };
    ArticulosImpuestosComponent.prototype.onItemChanged = function (args) {
        this.data.impuesto = args.nombre;
        this.data.codigo = args.code;
        this.impuestoInfo = args;
        if (args.factor == 'T')
            this.editorForm.controls.tipoFactor.patchValue(1);
        if (args.factor == 'C')
            this.editorForm.controls.tipoFactor.patchValue(2);
        this.onFactorChange();
    };
    var ArticulosImpuestosComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", articulo_1.ArticuloImpuestoItem)
    ], ArticulosImpuestosComponent.prototype, "data", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ArticulosImpuestosComponent.prototype, "dataUpdater", void 0);
    __decorate([
        core_1.ViewChild('dialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ArticulosImpuestosComponent.prototype, "dialog", void 0);
    __decorate([
        core_1.ViewChild('selectorImpuestos'),
        __metadata("design:type", impuestos_selector_component_1.ImpuestosSelectorComponent)
    ], ArticulosImpuestosComponent.prototype, "selectorImpuestos", void 0);
    ArticulosImpuestosComponent = ArticulosImpuestosComponent_1 = __decorate([
        core_1.Component({
            selector: 'sales-articulo-impuestos',
            template: "\n      <form [formGroup]=\"editorForm\">\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h4 class=\"modal-title\">Impuesto de Art\u00EDculo</h4>\n                      </div>\n                      <div class=\"modal-body\">\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Impuesto:'\">\n                                      <azteca-form-field [label]=\"Impuesto\">\n                                          <accounting-impuestos-selector formControlName=\"impuestos\"\n                                                                         [(ngModel)]=\"data.idImpuesto\"\n                                                                         [traslado]=\"true\"\n                                                                         [showListButton]=\"false\"\n                                                                         (selectedItemChanged)=\"onItemChanged($event)\"\n                                                                         #selectorImpuestos>\n                                          </accounting-impuestos-selector>\n                                      </azteca-form-field>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Tipo de Factor'\" *ngIf=\"data.idImpuesto > 0\">\n                                      <az-combobox formControlName=\"tipoFactor\"\n                                                   [items]=\"tiposFactor\"\n                                                   [valueMember]=\"'id'\"\n                                                   [displayMember]=\"'name'\"\n                                                   [enabled]=\"false\"\n                                                   (change)=\"onFactorChange()\">\n                                      </az-combobox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Tasa:'\" *ngIf=\"editorForm.controls.tipoFactor.value===1 && data.idImpuesto > 0\">\n                                      <az-input-number formControlName=\"valorTasa\" [(ngModel)]=\"data.tasa\" [format]=\"'P2'\" [enabled]=\"impuestoInfo.rango\" [min]=\"impuestoInfo.valorMinimo\" [max]=\"impuestoInfo.valorMaximo\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Cuota:'\" *ngIf=\"editorForm.controls.tipoFactor.value===2 && data.idImpuesto > 0\">\n                                      <az-input-number formControlName=\"valorCuota\" [(ngModel)]=\"data.cuota\" [format]=\"'N2'\" [enabled]=\"impuestoInfo.rango\" [min]=\"impuestoInfo.valorMinimo\" [max]=\"impuestoInfo.valorMaximo\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Tipo Calculo:'\">\n                                      <az-combobox formControlName=\"tipoCalculo\"\n                                                   [items]=\"tiposCalculo\"\n                                                   [valueMember]=\"'id'\"\n                                                   [displayMember]=\"'name'\"\n                                                   (change)=\"onTipoCalculoChange()\">\n                                      </az-combobox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Orden Calculo:'\" *ngIf=\"editorForm.controls.tipoCalculo.value===2\">\n                                      <az-input-number formControlName=\"ordenCalculo\" [(ngModel)]=\"data.ordenCalculo\" [min]=\"1\" integer=\"true\" [max]=\"2\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                    \n                      </div>\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Cancelar</button>\n                      </div>\n                  </div>\n              </div>\n          </div>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ArticulosImpuestosComponent_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: articulo_service_1.ArticuloService
                }
            ]
        }),
        __metadata("design:paramtypes", [articulo_service_1.ArticuloService, core_2.Context, forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute,
            core_1.ChangeDetectorRef])
    ], ArticulosImpuestosComponent);
    return ArticulosImpuestosComponent;
}(editors_1.CatalogEditor));
exports.ArticulosImpuestosComponent = ArticulosImpuestosComponent;
