import { EventEmitter, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormGroup } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, PolicyInfo } from 'framework3/core';
import { AlertsBarComponent } from 'framework3/controls';
import { CatalogEditor } from 'framework3/editors';
import { ArticuloListaPreciosItem } from '../models/articulo-lista-precios';
import { ArticuloService } from '../services/articulo.service';
import { DivisasSelectorComponent } from '../../accounting/controls/divisas-selector.component';
export declare class ArticuloListaPreciosEditorComponent extends CatalogEditor {
    private articuloService;
    protected context: Context;
    private formBuilder;
    protected router: Router;
    protected route: ActivatedRoute;
    protected changeDetector: ChangeDetectorRef;
    editorForm: FormGroup;
    info: ArticuloListaPreciosItem;
    formato: String;
    data: ArticuloListaPreciosItem;
    dataUpdated: EventEmitter<ArticuloListaPreciosItem>;
    dialog: ModalDirective;
    alerts: AlertsBarComponent;
    selectorDivisas: DivisasSelectorComponent;
    constructor(articuloService: ArticuloService, context: Context, formBuilder: FormBuilder, router: Router, route: ActivatedRoute, changeDetector: ChangeDetectorRef);
    show(): void;
    onSelectedItemChanged(args: any): void;
    onUpdate(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
