"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var articulo_lista_precios_1 = require("../models/articulo-lista-precios");
var articulo_service_1 = require("../services/articulo.service");
var divisas_selector_component_1 = require("../../accounting/controls/divisas-selector.component");
var ArticuloListaPreciosEditorComponent = /** @class */ (function (_super) {
    __extends(ArticuloListaPreciosEditorComponent, _super);
    function ArticuloListaPreciosEditorComponent(articuloService, context, formBuilder, router, route, changeDetector) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.articuloService = articuloService;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.router = router;
        _this.route = route;
        _this.changeDetector = changeDetector;
        _this.info = new articulo_lista_precios_1.ArticuloListaPreciosItem();
        _this.formato = '';
        //Inputs
        _this.data = new articulo_lista_precios_1.ArticuloListaPreciosItem();
        //outputs
        _this.dataUpdated = new core_1.EventEmitter();
        _this.editorForm = formBuilder.group({
            'divisa': ['', controls_1.AztecaValidators.selected],
            'precio': ['', forms_1.Validators.required]
        });
        return _this;
    }
    ArticuloListaPreciosEditorComponent_1 = ArticuloListaPreciosEditorComponent;
    ArticuloListaPreciosEditorComponent.prototype.show = function () {
        var _this = this;
        this.info = new articulo_lista_precios_1.ArticuloListaPreciosItem();
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) {
            _this.editorForm.reset();
            _this.info = _this.data;
            _this.data = new articulo_lista_precios_1.ArticuloListaPreciosItem();
        });
        wijmo_1.Control.invalidateAll();
    };
    ArticuloListaPreciosEditorComponent.prototype.onSelectedItemChanged = function (args) {
        if (args != null)
            this.formato = 'n' + args.decimales.toString();
    };
    ArticuloListaPreciosEditorComponent.prototype.onUpdate = function () {
        this.info.divisa = this.selectorDivisas.displayValue;
        this.dataUpdated.emit(this.info);
        this.dialog.hide();
    };
    ArticuloListaPreciosEditorComponent.prototype.applyPolicy = function (policy) {
    };
    ArticuloListaPreciosEditorComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    var ArticuloListaPreciosEditorComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", articulo_lista_precios_1.ArticuloListaPreciosItem)
    ], ArticuloListaPreciosEditorComponent.prototype, "data", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ArticuloListaPreciosEditorComponent.prototype, "dataUpdated", void 0);
    __decorate([
        core_1.ViewChild('dialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ArticuloListaPreciosEditorComponent.prototype, "dialog", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ArticuloListaPreciosEditorComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('selectorDivisas'),
        __metadata("design:type", divisas_selector_component_1.DivisasSelectorComponent)
    ], ArticuloListaPreciosEditorComponent.prototype, "selectorDivisas", void 0);
    ArticuloListaPreciosEditorComponent = ArticuloListaPreciosEditorComponent_1 = __decorate([
        core_1.Component({
            selector: 'ventas-articulo-lista-precios-editor',
            template: "\n      <form [formGroup]=\"editorForm\">\n\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h4 class=\"modal-title\">Asignar Lista de Precio</h4>\n                      </div>\n\n                      <div class=\"modal-body\">\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Divisa:'\">\n                                      <azteca-form-field [label]=\"Divisa\">\n                                          <accounting-divisas-selector formControlName=\"divisa\" [(ngModel)]=\"info.idDivisa\" [showListButton]=\"false\" (selectedItemChanged)=\"onSelectedItemChanged($event)\" #selectorDivisas></accounting-divisas-selector>\n                                      </azteca-form-field>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Precio:'\">\n                                      <az-input-number formControlName=\"precio\" decimal=\"True\" [(ngModel)]=\"info.precio\" [min]=\"0\" [format]=\"formato\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                      </div> <!--Modal Body-->\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Atr\u00E1s</button>\n                      </div> <!--Modal Footer-->\n\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div><!--Modal directive-->\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ArticuloListaPreciosEditorComponent_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: articulo_service_1.ArticuloService
                }
            ]
        }),
        __metadata("design:paramtypes", [articulo_service_1.ArticuloService, core_2.Context, forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute,
            core_1.ChangeDetectorRef])
    ], ArticuloListaPreciosEditorComponent);
    return ArticuloListaPreciosEditorComponent;
}(editors_1.CatalogEditor));
exports.ArticuloListaPreciosEditorComponent = ArticuloListaPreciosEditorComponent;
