"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Angular
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
//Framework3
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var core_3 = require("framework3/core");
var editors_1 = require("framework3/editors");
var articulo_service_1 = require("../services/articulo.service");
var articulo_lista_precios_editor_component_1 = require("./articulo-lista-precios-editor.component");
var ArticuloListaPreciosComponent = /** @class */ (function (_super) {
    __extends(ArticuloListaPreciosComponent, _super);
    function ArticuloListaPreciosComponent(context, articuloService, grupoService, router, route, location) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.articuloService = articuloService;
        _this.grupoService = grupoService;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.title = 'Lista de precios del artículo';
        _this.articuloListaPrecios = [];
        _this.artListPreCollection = new editors_1.TrackableCollection();
        return _this;
    }
    ArticuloListaPreciosComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idArticulo = +param['idArticulo'];
        });
    };
    ArticuloListaPreciosComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.loadArticuloListaPrecios(); });
    };
    //////////////////// METODOS /////////////////////////////////////////////////////////
    ArticuloListaPreciosComponent.prototype.loadArticuloListaPrecios = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.articuloService.loadArticuloListaPrecios(this.context.app.defaultCompany.identity, this.idArticulo)
            .then(function (artListPre) {
            _this.articuloListaPrecios = artListPre;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //////////////////// HANDLERS /////////////////////////////////////////////////////////
    ArticuloListaPreciosComponent.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    ArticuloListaPreciosComponent.prototype.ngAfterViewChecked = function () {
        this.artListPreCollection.sourceCollection = this.articuloListaPrecios;
    };
    ArticuloListaPreciosComponent.prototype.onEditItem = function (item) {
        this.articuloListaPreciosEditorComponent.show();
        this.articuloListaPreciosEditorComponent.data = item;
    };
    ArticuloListaPreciosComponent.prototype.applyPolicy = function (policy) {
    };
    ArticuloListaPreciosComponent.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'SAVE') {
            this.actualizarArticuloListaPrecios();
        }
        if (button.name == 'CLOSE') {
            this.location.back();
        }
    };
    ArticuloListaPreciosComponent.prototype.actualizarArticuloListaPrecios = function () {
        var _this = this;
        this.articuloService.updateArticuloListaPrecios(this.articuloListaPrecios, this.idArticulo)
            .then(function (r) {
            _this.loadArticuloListaPrecios();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticuloListaPreciosComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    ArticuloListaPreciosComponent.prototype.onDataUpdated = function (args) {
        this.articuloListaPrecios.forEach(function (artListPre) {
            if (artListPre.id == args.id) {
                artListPre.state = 'CHANGED';
                artListPre.idDivisa = args.idDivisa;
                artListPre.divisa = args.divisa;
                artListPre.precio = args.precio;
            }
        });
        this.artListPreCollection.refresh();
    };
    __decorate([
        core_1.ViewChild(articulo_lista_precios_editor_component_1.ArticuloListaPreciosEditorComponent),
        __metadata("design:type", articulo_lista_precios_editor_component_1.ArticuloListaPreciosEditorComponent)
    ], ArticuloListaPreciosComponent.prototype, "articuloListaPreciosEditorComponent", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ArticuloListaPreciosComponent.prototype, "alerts", void 0);
    ArticuloListaPreciosComponent = __decorate([
        core_1.Component({
            selector: 'ventas-articulo-lista-precios.component',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-md-10\">\n              <az-panel [header]=\"title\">\n                  <alerts-bar></alerts-bar>\n                  <!--Toolbar Principal-->\n                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                      <az-toolbar-button [name]=\"'SAVE'\" [type]=\"'primary'\" [text]=\"'Guardar'\" [icon]=\"'glyphicon glyphicon-ok'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Regresar'\" [icon]=\"'glyphicon glyphicon-circle-arrow-left'\"></az-toolbar-button>\n                  </az-toolbar>\n\n                  <wj-flex-grid #gridArticulosListasPrecio style=\"height:550px\"\n                                [itemsSource]=\"artListPreCollection\">\n\n                      <wj-flex-grid-column [width]=\"55\" [isReadOnly]=\"true\">\n                          <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                              <button type=\"button\" class=\"btn btn-default\" (click)=\"onEditItem(cell.item)\">\n                                  <span class=\"glyphicon glyphicon-edit\"></span>\n                              </button>\n                          </ng-template>\n                      </wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'ID'\" [binding]=\"'id'\" [width]=\"'5*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'5*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'15*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Id Divisa'\" [binding]=\"'idDivisa'\" [width]=\"'5*'\" [isReadOnly]=\"true\" [visible]=\"false\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Divisa'\" [binding]=\"'divisa'\" [width]=\"'15*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Precio'\" [binding]=\"'precio'\" [width]=\"'10*'\" [isReadOnly]=\"true\" [format]=\"n4\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Unidad de Medida'\" [binding]=\"'unidadMedida'\" [width]=\"'15*'\" [isReadOnly]=\"true\" [visible]=\"false\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Marca'\" [binding]=\"'marca'\" [width]=\"'15*'\" [isReadOnly]=\"true\" [visible]=\"false\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Activo'\" [binding]=\"'activo'\" [width]=\"'6*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  </wj-flex-grid>\n\n              </az-panel>\n          </div>\n      </div>\n\n      <ventas-articulo-lista-precios-editor (dataUpdated)=\"onDataUpdated($event)\">\n\n      </ventas-articulo-lista-precios-editor>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, articulo_service_1.ArticuloService, core_3.GrupoService, router_1.Router, router_1.ActivatedRoute,
            common_1.Location])
    ], ArticuloListaPreciosComponent);
    return ArticuloListaPreciosComponent;
}(core_2.BaseComponent));
exports.ArticuloListaPreciosComponent = ArticuloListaPreciosComponent;
