import { EventEmitter } from '@angular/core';
import { Observable } from 'rxjs';
import { Context, CatalogItem } from 'framework3/core';
import { SearchRequest, CatalogSelector } from 'framework3/search';
import { ArticuloInfo, ArticuloItem } from '../models/articulo';
import { ArticuloService } from '../services/articulo.service';
export declare class ArticulosSelectorComponent extends CatalogSelector {
    protected context: Context;
    private service;
    articulos: ArticuloItem[];
    selectedItem: ArticuloInfo;
    selectedItemChanged: EventEmitter<ArticuloInfo>;
    constructor(context: Context, service: ArticuloService);
    loadItem(itemID: number): void;
    doSearch(request: SearchRequest): void;
    findKeyword(keyword: string): Observable<CatalogItem[]>;
    onKeywordSearch(keyword: string): void;
}
