"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//
var inventory_1 = require("../../../inventory");
var accounting_1 = require("../../../accounting");
var unidad_negocio_service_1 = require("../../services/unidad-negocio.service");
var NuevaVentaComponent = /** @class */ (function () {
    function NuevaVentaComponent(formBuilder, router, route, context, areaService, almacenService, unidadNegocioService, divisaService) {
        var _this = this;
        this.formBuilder = formBuilder;
        this.router = router;
        this.route = route;
        this.context = context;
        this.areaService = areaService;
        this.almacenService = almacenService;
        this.unidadNegocioService = unidadNegocioService;
        this.divisaService = divisaService;
        this.valid = false;
        this.unidadesNegocio = [];
        this.areas = [];
        this.almacenes = [];
        this.form = formBuilder.group({
            'idUnidadNegocio': [0, controls_1.AztecaValidators.selected],
            'idArea': [0],
            'idAlmacen': [0],
            'idDivisa': [0, controls_1.AztecaValidators.selected],
            'idCliente': [0, controls_1.AztecaValidators.selected]
        });
        //
        this.form.controls['idUnidadNegocio'].valueChanges.subscribe(function (value) {
            _this.selectedUnidad = _this.unidadesNegocio.find(function (u) { return u.id == value; });
            if (_this.selectedUnidad) {
                if (_this.selectedUnidad.editarAlmacen)
                    _this.form.controls['idAlmacen'].setValidators(controls_1.AztecaValidators.selected);
                else
                    _this.form.controls['idAlmacen'].setValidators(null);
                _this.form.controls['idAlmacen'].updateValueAndValidity();
            }
        });
        //
        this.form.statusChanges.subscribe(function (_) { return setTimeout(function (_) { return _this.valid = _this.form.valid; }); });
        this.route.params.forEach(function (params) {
            _this.idOrigen = params['idOrigen'] ? +params['idOrigen'] : 0;
        });
    }
    NuevaVentaComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.loadUnidadesNegocio(); });
        setTimeout(function (_) { return _this.cargarDivisaDefault(); });
    };
    /////////// METHODS
    NuevaVentaComponent.prototype.loadUnidadesNegocio = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.unidadNegocioService.loadListByUser(this.context.app.defaultSite.identity, this.context.session.user.identity)
            .then(function (unidades) {
            _this.unidadesNegocio = unidades;
            _this.context.app.hideSpinner();
            _this.selectedUnidad = _this.unidadesNegocio[0];
            if (_this.selectedUnidad.editarAlmacen)
                _this.loadAreas();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NuevaVentaComponent.prototype.loadAreas = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.areaService.loadListByUser(this.context.app.defaultSite.identity, this.context.session.user.identity)
            .then(function (areas) {
            _this.areas = areas;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NuevaVentaComponent.prototype.loadAlmacenes = function (idArea) {
        var _this = this;
        this.idAlmacen = 0;
        this.context.app.showSpinner();
        this.almacenService.loadListByUser(idArea, this.context.session.user.identity)
            .then(function (almacenes) {
            _this.almacenes = almacenes.filter(function (almacen) { return almacen.salida; });
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NuevaVentaComponent.prototype.cargarDivisaDefault = function () {
        var _this = this;
        this.divisaService.getDetailByEmpresa(this.context.app.defaultCompany.identity)
            .then(function (divisa) {
            _this.idDivisa = divisa.identity;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    /////////// HANDLERS
    NuevaVentaComponent.prototype.onToolbarClick = function (button) {
        if (button.name == 'OK') {
            var idAlmacen = this.idAlmacen;
            if (this.selectedUnidad.afectarInventario) {
                //Si no está permitido que el usuario elija el almacén origen, utilizar el que la unidad de negocios tenga configurado
                if (!this.selectedUnidad.editarAlmacen)
                    idAlmacen = this.selectedUnidad.idAlmacen;
            }
            else {
                idAlmacen = 0;
            }
            //
            this.router.navigate(['../', '0', { idUnidadNegocio: this.idUnidadNegocio, idAlmacen: idAlmacen, idDivisa: this.idDivisa, idCliente: this.idCliente, idOrigen: this.idOrigen }], { relativeTo: this.route });
        }
        else if (button.name == 'CANCEL') {
            this.router.navigate(['../'], { relativeTo: this.route });
        }
    };
    NuevaVentaComponent.prototype.onClienteChanged = function (cliente) {
        this.cliente = cliente;
    };
    NuevaVentaComponent.prototype.handleError = function (error) {
        console.log(error);
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alertsBar.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], NuevaVentaComponent.prototype, "alertsBar", void 0);
    NuevaVentaComponent = __decorate([
        core_1.Component({
            selector: 'sales-nueva-venta',
            template: "\n      <form [formGroup]=\"form\">\n\n          <div class=\"row\">\n              <div class=\"col-12 col-lg-10\">\n                  <az-panel [header]=\"'Nueva venta'\">\n                      <alerts-bar></alerts-bar>\n                      <az-toolbar (buttonClick)=\"onToolbarClick($event)\">\n                          <az-toolbar-button [name]=\"'OK'\" [type]=\"'primary'\" [text]=\"'Aceptar'\" [icon]=\"'glyphicon glyphicon-ok'\" [enabled]=\"valid\"></az-toolbar-button>\n                          <az-toolbar-button [name]=\"'CANCEL'\" [text]=\"'Cancelar'\" [icon]=\"'glyphicon glyphicon-remove'\"></az-toolbar-button>\n                      </az-toolbar>\n\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-10\">\n                              <azteca-form-field [label]=\"'Unidad de negocio:'\">\n                                  <az-combobox formControlName=\"idUnidadNegocio\"\n                                               [(ngModel)]=\"idUnidadNegocio\"\n                                               [items]=\"unidadesNegocio\"\n                                               [valueMember]=\"'id'\"\n                                               [displayMember]=\"'nombre'\">\n\n                                  </az-combobox>\n                              </azteca-form-field>\n\n                          </div>\n                      </div>\n\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-5\">\n                              <azteca-form-field *ngIf=\"selectedUnidad && selectedUnidad.afectarInventario && selectedUnidad.editarAlmacen\" [label]=\"'\u00C1rea de inventario:'\">\n                                  <az-combobox formControlName=\"idArea\"\n                                               [(ngModel)]=\"idArea\"\n                                               [items]=\"areas\"\n                                               [valueMember]=\"'id'\"\n                                               [displayMember]=\"'nombre'\"\n                                               (selectedItemChanged)=\"loadAlmacenes($event)\"></az-combobox>\n                              </azteca-form-field>\n\n                          </div>\n                          <div class=\"col-12 col-lg-5\">\n                              <azteca-form-field *ngIf=\"selectedUnidad && selectedUnidad.afectarInventario && selectedUnidad.editarAlmacen\" [label]=\"'Almac\u00E9n origen:'\">\n                                  <az-combobox formControlName=\"idAlmacen\"\n                                               [(ngModel)]=\"idAlmacen\"\n                                               [items]=\"almacenes\"\n                                               [valueMember]=\"'id'\"\n                                               [displayMember]=\"'nombre'\">\n                                  </az-combobox>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-5\">\n                              <azteca-form-field [label]=\"'Divisa:'\">\n                                  <accounting-divisas-selector formControlName=\"idDivisa\" [(ngModel)]=\"idDivisa\"></accounting-divisas-selector>\n                              </azteca-form-field>\n                          </div>\n                          <div class=\"col-12 col-lg-5\">\n                              <azteca-form-field [label]=\"'Cliente:'\">\n                                  <sales-clientes-selector formControlName=\"idCliente\" [(ngModel)]=\"idCliente\" (selectedItemChanged)=\"onClienteChanged($event)\"></sales-clientes-selector>\n                                  <alert type=\"'warning'\" *ngIf=\"cliente ? cliente.idListaPrecios == 0 : false\">El cliente no tiene asignada una lista de precios</alert>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                  </az-panel>\n              </div>\n          </div>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute, core_2.Context,
            inventory_1.AreaService,
            inventory_1.AlmacenService,
            unidad_negocio_service_1.UnidadNegocioService,
            accounting_1.DivisaService])
    ], NuevaVentaComponent);
    return NuevaVentaComponent;
}());
exports.NuevaVentaComponent = NuevaVentaComponent;
