import { FormBuilder } from '@angular/forms';
import { Context } from 'framework3/core';
import { BasicEditor } from 'framework3/editors';
import { UnidadMedidaItem, StockInfo, LoteInfo, SerieInfo, UnidadMedidaService, AlmacenService } from '../../../inventory';
import { VentaDetail } from '../../models/venta-detail';
import { VentaArticuloDetail } from '../../models/venta-articulo-detail';
import { ArticuloInfo } from '../../models/articulo';
import { ArticuloService } from '../../services/articulo.service';
import { SucursalService } from '../../services/sucursal.service';
export declare class VentaArticulosDetailEditor extends BasicEditor {
    protected context: Context;
    private builder;
    private unidadService;
    private almacenService;
    private articuloService;
    private sucursalService;
    unidadesMedida: UnidadMedidaItem[];
    stockConfig: StockInfo;
    validInput: boolean;
    lotes: LoteInfo[];
    series: SerieInfo[];
    precioUnitario: string;
    detailCopy: VentaArticuloDetail;
    detail: VentaArticuloDetail;
    idCliente: number;
    idAlmacen: number;
    idZonaVenta: number;
    constructor(context: Context, builder: FormBuilder, unidadService: UnidadMedidaService, almacenService: AlmacenService, articuloService: ArticuloService, sucursalService: SucursalService);
    loadStock(idArticulo: number): void;
    loadUnidadesMedida(idTipoUnidad: number): void;
    ngOnInit(): void;
    loadSucursal(): void;
    onCreatingItem(): void;
    onLoadingItem(detail: VentaDetail): void;
    onUpdatingItem(detail: VentaArticuloDetail): void;
    onArticuloChanged(articulo: ArticuloInfo): void;
    onInputValidChange(valid: boolean): void;
    onLotesChange(lotes: LoteInfo[]): void;
    onSeriesChange(series: SerieInfo[]): void;
}
