import { FormBuilder } from '@angular/forms';
import { CollectionView } from 'wijmo/wijmo';
import { FlexGrid, CellRangeEventArgs, FormatItemEventArgs } from 'wijmo/wijmo.grid';
import { Context } from 'framework3/core';
import { BasicEditor } from 'framework3/editors';
import { UnidadMedidaItem, UnidadMedidaService, UnidadMedidaTipoService } from '../../../inventory';
import { VentaDetail } from '../../models/venta-detail';
import { VentaServicioDetail } from '../../models/venta-servicio-detail';
import { ServicioInfo } from '../../models/servicio';
import { ServicioService } from '../../services/servicio.service';
import { SucursalService } from '../../services/sucursal.service';
export declare class VentaServiciosDetailEditor extends BasicEditor {
    protected context: Context;
    private builder;
    private servicioService;
    private unidadService;
    private unidadTipoService;
    private sucursalService;
    detailCopy: VentaServicioDetail;
    trasladosCollection: CollectionView;
    retencionesCollection: CollectionView;
    unidadesMedida: UnidadMedidaItem[];
    idZonaVenta: number;
    detail: VentaServicioDetail;
    idCliente: number;
    constructor(context: Context, builder: FormBuilder, servicioService: ServicioService, unidadService: UnidadMedidaService, unidadTipoService: UnidadMedidaTipoService, sucursalService: SucursalService);
    loadUnidadMedida(): void;
    ngOnInit(): void;
    loadSucursal(): void;
    onPrecioChanged(precio: number): void;
    onCreatingItem(): void;
    onLoadingItem(detail: VentaDetail): void;
    onUpdatingItem(detail: VentaDetail): void;
    onServicioChanged(servicio: ServicioInfo): void;
    onEditCell(grid: FlexGrid, args: CellRangeEventArgs): void;
    onFormatCell(grid: FlexGrid, args: FormatItemEventArgs): void;
}
