"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var cliente_service_1 = require("../services/cliente.service");
var cliente_1 = require("../models/cliente");
var ClientesRegistrarEditor = /** @class */ (function (_super) {
    __extends(ClientesRegistrarEditor, _super);
    function ClientesRegistrarEditor(clienteService, context, formBuilder, router, route, changeDetector) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.clienteService = clienteService;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.router = router;
        _this.route = route;
        _this.changeDetector = changeDetector;
        _this.info = new cliente_1.PreRegistro();
        _this.pRegistro = new cliente_1.PreRegistro();
        _this.cliente = new cliente_1.ClienteInfo();
        //Inputs
        _this.data = new cliente_1.PreRegistro();
        //outputs
        _this.dataUpdated = new core_1.EventEmitter();
        _this.editorForm = formBuilder.group({
            'idCliente': [0]
        });
        return _this;
    }
    ClientesRegistrarEditor.prototype.show = function (inf) {
        var _this = this;
        this.pRegistro = inf;
        this.info = new cliente_1.PreRegistro();
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) {
            _this.editorForm.reset();
            _this.info = _this.data;
            _this.data = new cliente_1.PreRegistro();
        });
        wijmo_1.Control.invalidateAll();
    };
    ClientesRegistrarEditor.prototype.onSelectedItemChanged = function (args) {
        if (args != null) {
            this.cliente = args;
            this.idCliente = args.identity;
        }
    };
    ClientesRegistrarEditor.prototype.onConsultarCliente = function () {
        this.router.navigate(['sales/clientes-ventas', this.process.id, this.idCliente, { readonly: true }]);
    };
    ClientesRegistrarEditor.prototype.onUpdate = function (args) {
        var _this = this;
        this.clienteService.registrarDePreregistro(this.idCliente, this.pRegistro.password, this.pRegistro.idPreRegistro, this.pRegistro.correo)
            .then(function (_) {
            _this.dataUpdated.emit(_this.pRegistro);
            _this.dialog.hide();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", cliente_1.PreRegistro)
    ], ClientesRegistrarEditor.prototype, "data", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ClientesRegistrarEditor.prototype, "dataUpdated", void 0);
    __decorate([
        core_1.ViewChild('dialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ClientesRegistrarEditor.prototype, "dialog", void 0);
    ClientesRegistrarEditor = __decorate([
        core_1.Component({
            selector: 'sales-clientes-registrar-editor',
            template: "\n      <form [formGroup]=\"editorForm\">\n\n\n\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n\n\n              <div class=\"modal-dialog  modal-lg\" style=\"height: 100%!important;\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h4 class=\"modal-title\">Seleccionar cliente</h4>\n                      </div>\n\n                      <div class=\"modal-body\">\n\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-lg-6\">\n\n                                  <label class=\"control-label\">Nombre comercial:</label>\n                                  <az-label [text]=\"pRegistro.nombreComercial\"></az-label>\n\n                              </div>\n                              <div class=\"col-12 col-lg-6\">\n\n                                  <label class=\"control-label\">Correo electr\u00F3nico:</label>\n                                  <az-label [text]=\"pRegistro.correo\"></az-label>\n\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-lg-4\">\n\n                                  <label class=\"control-label\">RFC:</label>\n                                  <az-label [text]=\"pRegistro.rfc\"></az-label>\n\n                              </div>\n                              <div class=\"col-12 col-lg-6\">\n\n                                  <label class=\"control-label\">Raz\u00F3n social:</label>\n                                  <az-label [text]=\"pRegistro.razonSocial\"></az-label>\n\n                              </div>\n                          </div>\n\n                          <div class=\"row\" *ngIf=\"cliente.idUsuario > 0\">\n\n                              <div class=\"col-12 col-lg-6\">\n\n                                  <label class=\"control-label\">Cliente ya registrado con el c\u00F3digo de usuario:</label>\n                                  <az-label [text]=\"cliente.usuario.correo\"></az-label>\n\n                              </div>\n\n\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12 flex-lg-grow-1\">\n                                  <sales-clientes-selector formControlName=\"idCliente\" [(ngModel)]=\"idCliente\" (selectedItemChanged)=\"onSelectedItemChanged($event)\"></sales-clientes-selector>\n                              </div>\n                          </div>\n\n\n                          </div> <!--Modal Body-->\n                          <div class=\"modal-footer\">\n                              <button type=\"button\" class=\"btn btn-info\" (click)=\"onConsultarCliente()\" [disabled]=\"!editorForm.valid\">Consultar cliente</button>\n                              <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"cliente.idUsuario > 0\">Aceptar</button>\n                              <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Atr\u00E1s</button>\n                          </div> <!--Modal Footer-->\n\n                      </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div><!--Modal directive-->\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [cliente_service_1.ClienteService, core_2.Context, forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute, core_1.ChangeDetectorRef])
    ], ClientesRegistrarEditor);
    return ClientesRegistrarEditor;
}(editors_1.CatalogEditor));
exports.ClientesRegistrarEditor = ClientesRegistrarEditor;
