import { Router, ActivatedRoute } from '@angular/router';
import { FormGroup, FormBuilder } from '@angular/forms';
import { Context, ProcessComponent, PolicyInfo } from 'framework3/core';
import { AlertsBarComponent } from 'framework3/controls';
import { ClienteService } from '../services/cliente.service';
import { PreRegistro } from '../models/cliente';
import { ClientesRegistrarEditor } from './clientes-registrar-editor.maintenance';
import { Confirmacion } from './parts/confirmacion.component';
export declare class ClientesRegistrar extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    private clienteService;
    from: FormGroup;
    pRegistro: PreRegistro[];
    clientesRegistrarEditor: ClientesRegistrarEditor;
    alerts: AlertsBarComponent;
    confirma: Confirmacion;
    constructor(context: Context, router: Router, route: ActivatedRoute, formBuilder: FormBuilder, clienteService: ClienteService);
    ngAfterViewInit(): void;
    onRefrescar(): void;
    listarCandidatos(): void;
    onEditItem(item: PreRegistro): void;
    onDataUpdated(args: PreRegistro): void;
    onRemoveItem(args: PreRegistro): void;
    onConfirmar(idPreRegistro: number): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
