import { CatalogInfo, CatalogItem, UsuarioInfo } from 'framework3/core';
import { DeudorInfo } from '../../credit/models/deudor';
import { ClasificacionValor, IClasificable } from 'framework3/general';
export declare class ClienteInfo extends CatalogInfo implements IClasificable {
    nombre: string;
    idCuenta: number;
    latitud: number;
    longitud: number;
    posicion: string;
    telefonos: string;
    celular: string;
    correo: string;
    pagWeb: string;
    idListaPrecios: number;
    idGrupoDescuentos: number;
    primerCompra: Date;
    ultimaCompra: Date;
    usuario: UsuarioInfo;
    idContribuyente: number;
    idDeudor: number;
    webUser: string;
    webPassword: string;
    codigoReferencia: string;
    deudor: DeudorInfo;
    clasificaciones: ClasificacionValor[];
    constructor();
}
export declare class ClienteItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    rfc: string;
    razonSocial: string;
    calle: string;
    numeroExterior: string;
    numeroInterior: string;
    activo: boolean;
    estatus?: string;
    selected?: boolean;
}
export declare class PreRegistro {
    idPreRegistro: number;
    rfc: string;
    nombreComercial: string;
    razonSocial: string;
    correo: string;
    password: string;
}
