import { EventEmitter, SimpleChange } from '@angular/core';
import { ControlValueAccessor, FormBuilder } from '@angular/forms';
import { BaseControl } from 'framework3/controls/models/base-control';
import { ArticuloInfo } from '../models/articulo';
import { CuentaSelectorComponent } from '../../accounting/components/cuenta-selector.component';
import { EstComSelectorComponent } from '../controls/est-com-selector.component';
import { FlujoSelectorComponent } from '../../accounting/components/flujo-selector.component';
import { MarcasSelectorComponent } from '../controls/marcas-selector.component';
export declare class ArticuloComercialComponent extends BaseControl implements ControlValueAccessor {
    private formBuilder;
    private form;
    readonly valid: boolean;
    selectorCuenta: CuentaSelectorComponent;
    selectorEstCom: EstComSelectorComponent;
    selectorCatFlujo: FlujoSelectorComponent;
    selectorMarca: MarcasSelectorComponent;
    articulo: ArticuloInfo;
    articuloChange: EventEmitter<ArticuloInfo>;
    validChange: EventEmitter<boolean>;
    constructor(formBuilder: FormBuilder);
    ngOnChanges(changes: SimpleChange): void;
    ngAfterViewInit(): void;
    notifiyChange(): void;
    onCuentaChange(args: any): void;
    onEstComChange(args: any): void;
    onCatFlujoChange(args: any): void;
    onMarcasChange(args: any): void;
    onModeloChange(args: any): void;
    onImpuestoIncluidoChange(args: any): void;
    writeValue(value: any): void;
    propagateChange: (_: any) => void;
    registerOnChange(fn: any): void;
    registerOnTouched(): void;
}
