"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
//
var forms_1 = require("@angular/forms");
var ngx_bootstrap_1 = require("ngx-bootstrap");
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//
//import { PolicyInfo, UsuarioItem } from 'framework3/core';
//
var general_1 = require("framework3/general");
var cliente_service_1 = require("../services/cliente.service");
var ClientesContactosEditor = /** @class */ (function (_super) {
    __extends(ClientesContactosEditor, _super);
    function ClientesContactosEditor(context, route, formBuilder, location, changeDetector, personaService, clienteService) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.location = location;
        _this.changeDetector = changeDetector;
        _this.personaService = personaService;
        _this.clienteService = clienteService;
        _this.title = '';
        _this.persona = new general_1.PersonaInfo;
        //
        _this.dataUpdated = new core_1.EventEmitter();
        _this.editorForm = formBuilder.group({
            'persona': [''],
        });
        return _this;
    }
    ClientesContactosEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idCliente = +param['id'];
            _this.idContacto = +param['idContacto'];
            _this.idPersona = +param['idPersona'];
        });
    };
    ClientesContactosEditor.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.loadContacto(); });
    };
    ClientesContactosEditor.prototype.loadContacto = function () {
        if (this.idPersona == 0)
            this.persona = new general_1.PersonaInfo;
        else
            this.loadPersona();
    };
    ClientesContactosEditor.prototype.loadPersona = function () {
        var _this = this;
        this.personaService.getDetailByID(this.idPersona)
            .then(function (persona) { return _this.persona = persona; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClientesContactosEditor.prototype.onUpdate = function () {
        var _this = this;
        this.clienteService.addContacto(this.idCliente, this.persona)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('El contacto han sido agregado con éxito.', 'success');
            _this.location.back();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClientesContactosEditor.prototype.onCancel = function () {
        this.location.back();
    };
    ClientesContactosEditor.prototype.applyPolicy = function (policy) {
    };
    ClientesContactosEditor.prototype.onPersonValidChange = function () {
        this.changeDetector.detectChanges();
    };
    ClientesContactosEditor.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ClientesContactosEditor.prototype, "alerts", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ClientesContactosEditor.prototype, "dataUpdated", void 0);
    __decorate([
        core_1.ViewChild('dialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ClientesContactosEditor.prototype, "dialog", void 0);
    ClientesContactosEditor = __decorate([
        core_1.Component({
            selector: 'sales-clientes-contactos-editor',
            template: "\n      <form [formGroup]=\"editorForm\">\n\n          <div class=\"row\">\n              <div class=\"col-12 col-lg-8\">\n                  <alerts-bar></alerts-bar>\n                  <az-panel header=\"Datos de contacto\">\n\n                      <general-persona-editor #personaEditor\n                                              formControlName=\"persona\"\n                                              [(ngModel)]=\"persona\"\n                                              [nombreRequired]=\"true\"                                        \n                                              (validChange)=\"onPersonValidChange($event)\">\n\n                      </general-persona-editor>\n\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"onCancel()\">Cancelar</button>\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                      </div> <!--Modal Footer-->\n\n                  </az-panel>\n              </div>\n\n          </div>\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.CatalogService, useExisting: general_1.PersonaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.ActivatedRoute, forms_1.FormBuilder, common_1.Location, core_1.ChangeDetectorRef, general_1.PersonaService, cliente_service_1.ClienteService])
    ], ClientesContactosEditor);
    return ClientesContactosEditor;
}(core_2.BaseComponent));
exports.ClientesContactosEditor = ClientesContactosEditor;
