import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { FormBuilder, FormGroup } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { BaseComponent, Context, PolicyInfo } from 'framework3/core';
import { SearchRequest, CatalogListComponent } from 'framework3/search';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { DivisaInfo } from '../../accounting';
import { GrupoDescuentoService } from '../services/grupo-descuento.service';
import { GrupoDescuentoInfo } from '../models/grupo-descuento';
import { ServicioGrupoDescuentoItem } from '../models/servicio-grupo-descuento';
export declare class GruposDescuentosServiciosComponent extends BaseComponent {
    private context;
    private router;
    private route;
    private location;
    private formBuilder;
    private grupoDescuentosService;
    form: FormGroup;
    title: string;
    servicios: ServicioGrupoDescuentoItem[];
    idGrupoDescuentos: number;
    grupoDescuentos: GrupoDescuentoInfo;
    divisaDefault: DivisaInfo;
    currentItem: ServicioGrupoDescuentoItem;
    pageSize: number;
    pageIndex: number;
    totalRows: number;
    alerts: AlertsBarComponent;
    catalogList: CatalogListComponent;
    editDialog: ModalDirective;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, grupoDescuentosService: GrupoDescuentoService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadInitialData(): void;
    loadGrupoDescuentos(): void;
    triggerSearch(): void;
    onSearchRequested(request: SearchRequest): void;
    onCurrentItemChanged(item: ServicioGrupoDescuentoItem): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    applyPolicy(policy: PolicyInfo): void;
    onEditServicio(servicio: ServicioGrupoDescuentoItem): void;
    onUpdateItem(): void;
    handleError(error: any): void;
}
