import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { FormBuilder, FormGroup } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { BaseComponent, Context, PolicyInfo } from 'framework3/core';
import { SearchRequest, CatalogListComponent } from 'framework3/search';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { DivisaService, DivisaInfo } from '../../accounting';
import { ListaPreciosService } from '../services/lista-precios.service';
import { ListaPreciosInfo } from '../models/lista-precios';
import { ArticuloListaPreciosItem } from '../models/articulo-lista-precios';
export declare class ListasPreciosArticulosComponent extends BaseComponent {
    private context;
    private router;
    private route;
    private location;
    private formBuilder;
    private listaPreciosService;
    private divisaService;
    form: FormGroup;
    title: string;
    articulos: ArticuloListaPreciosItem[];
    idListaPrecios: number;
    listaPrecios: ListaPreciosInfo;
    divisaDefault: DivisaInfo;
    currentItem: ArticuloListaPreciosItem;
    pageSize: number;
    pageIndex: number;
    totalRows: number;
    alerts: AlertsBarComponent;
    catalogList: CatalogListComponent;
    editDialog: ModalDirective;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, listaPreciosService: ListaPreciosService, divisaService: DivisaService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadInitialData(): void;
    loadListaPrecios(): void;
    loadDivisaDefault(): void;
    triggerSearch(): void;
    onSearchRequested(request: SearchRequest): void;
    onCurrentItemChanged(item: ArticuloListaPreciosItem): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    applyPolicy(policy: PolicyInfo): void;
    onDivisaChanged(divisa: DivisaInfo): void;
    onEditArticulo(articulo: ArticuloListaPreciosItem): void;
    onUpdateItem(): void;
    handleError(error: any): void;
}
