"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//
var security_1 = require("framework3/security");
//
var unidad_negocio_service_1 = require("../services/unidad-negocio.service");
var UnidadesNegocioMembersComponent = /** @class */ (function (_super) {
    __extends(UnidadesNegocioMembersComponent, _super);
    //
    function UnidadesNegocioMembersComponent(context, unidadNegocioService, router, route, location) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.unidadNegocioService = unidadNegocioService;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.title = '';
        return _this;
    }
    UnidadesNegocioMembersComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idUnidadNegocio = +param['id'];
        });
    };
    UnidadesNegocioMembersComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.refreshList(); });
        setTimeout(function (_) { return _this.loadUnidadNegocio(); });
    };
    ///////////////// METODOS ///////////////////////////////
    UnidadesNegocioMembersComponent.prototype.loadUnidadNegocio = function () {
        var _this = this;
        this.unidadNegocioService.getDetailByID(this.idUnidadNegocio)
            .then(function (info) {
            _this.unidadNegocio = info;
            _this.title = 'Miembros de la unidad de negocio - ' + _this.unidadNegocio.nombre;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesNegocioMembersComponent.prototype.refreshList = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.unidadNegocioService.getMembers(this.idUnidadNegocio)
            .then(function (usuarios) {
            _this.usuarios = usuarios;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////// HANDLERS ///////////////////////////////
    UnidadesNegocioMembersComponent.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    UnidadesNegocioMembersComponent.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.usuariosDialog.show();
        }
        if (button.name == 'REFRESH') {
            this.refreshList();
        }
        if (button.name == 'CLOSE') {
            this.location.back();
        }
    };
    UnidadesNegocioMembersComponent.prototype.onSelectedUsersChanged = function (newUsers) {
        var _this = this;
        this.unidadNegocioService.addMembers(this.idUnidadNegocio, newUsers)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('Los usuarios han sido agregados con éxito.', 'success');
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesNegocioMembersComponent.prototype.onRemoveUser = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.unidadNegocioService.removeMember(this.idUnidadNegocio, this.currentItem.id)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.usuarios = _this.usuarios.filter(function (item) { return item.id != _this.currentItem.id; });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesNegocioMembersComponent.prototype.applyPolicy = function (policy) {
    };
    UnidadesNegocioMembersComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(security_1.UsuariosListComponent),
        __metadata("design:type", security_1.UsuariosListComponent)
    ], UnidadesNegocioMembersComponent.prototype, "usuariosDialog", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], UnidadesNegocioMembersComponent.prototype, "alerts", void 0);
    UnidadesNegocioMembersComponent = __decorate([
        core_1.Component({
            selector: 'sales-unidades-negocio-members',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-md-10\">\n              <az-panel [header]=\"title\">\n                  <alerts-bar></alerts-bar>\n                  <!--Toolbar Principal-->\n                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                      <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar Usuarios'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'REFRESH'\" [text]=\"'Actualizar'\" [icon]=\"'glyphicon glyphicon-refresh'\" [class]=\"'d-none d-lg-block'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Regresar'\" [icon]=\"'glyphicon glyphicon-circle-arrow-left'\"></az-toolbar-button>\n                  </az-toolbar>\n\n                  <!-- Lista de usuarios-->\n                  <azteca-catalog-list [catalogList]=\"usuarios\"\n                                       [showRowButton]=\"true\"\n                                       [rowButtonIcon]=\"'glyphicon glyphicon-trash'\"\n                                       (rowButtonClick)=\"onRemoveUser()\"\n                                       (currentItemChanged)=\"onCurrentItemChanged($event)\"\n                                       [enabled]=\"enabled\"\n                                       [pageSize]=\"15\"\n                                       [serverSide]=\"false\">\n\n                      <azteca-grid-column [header]=\"'ID'\" [binding]=\"'id'\" [width]=\"50\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Usuario'\" [binding]=\"'codigo'\" [width]=\"'20*'\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombrePersona'\" [width]=\"'40*'\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Estatus'\" [binding]=\"'estatus'\" [width]=\"'10*'\"></azteca-grid-column>\n\n                  </azteca-catalog-list>\n\n\n              </az-panel>\n          </div>\n      </div>\n\n      <security-usuarios-list (selectedItemsChanged)=\"onSelectedUsersChanged($event)\"\n                              [excludedItems]=\"usuarios\"\n                              [multiSelect]=\"true\">\n\n      </security-usuarios-list>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, unidad_negocio_service_1.UnidadNegocioService, router_1.Router, router_1.ActivatedRoute,
            common_1.Location])
    ], UnidadesNegocioMembersComponent);
    return UnidadesNegocioMembersComponent;
}(core_2.BaseComponent));
exports.UnidadesNegocioMembersComponent = UnidadesNegocioMembersComponent;
