"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//////////////////////////// Guards //////////////////////////////////
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//////////////////////////// Catalogos ////////////////////////////////
var empresas_manager_1 = require("./catalogs/empresas.manager");
var empresas_editor_1 = require("./catalogs/empresas.editor");
var sucursales_manager_1 = require("./catalogs/sucursales.manager");
var sucursales_editor_1 = require("./catalogs/sucursales.editor");
var unidades_negocio_editor_1 = require("./catalogs/unidades-negocio.editor");
var unidades_negocio_members_component_1 = require("./parts/unidades-negocio-members.component");
var regiones_manager_1 = require("./catalogs/regiones.manager");
var regiones_editor_1 = require("./catalogs/regiones.editor");
var zonas_venta_manager_1 = require("./catalogs/zonas-venta.manager");
var zonas_venta_editor_1 = require("./catalogs/zonas-venta.editor");
var clientes_manager_1 = require("./catalogs/clientes.manager");
var clientes_editor_1 = require("./catalogs/clientes.editor");
var listas_precios_manager_1 = require("./catalogs/listas-precios.manager");
var listas_precios_editor_1 = require("./catalogs/listas-precios.editor");
var grupos_descuentos_manager_1 = require("./catalogs/grupos-descuentos.manager");
var grupos_descuentos_editor_1 = require("./catalogs/grupos-descuentos.editor");
var est_com_manager_1 = require("./catalogs/est-com.manager");
var articulos_manager_1 = require("./catalogs/articulos.manager");
var articulos_editor_1 = require("./catalogs/articulos.editor");
var marcas_manager_1 = require("./catalogs/marcas.manager");
var marcas_editor_1 = require("./catalogs/marcas.editor");
var servicios_manager_1 = require("./catalogs/servicios.manager");
var servicios_editor_1 = require("./catalogs/servicios.editor");
var vendedores_manager_1 = require("./catalogs/vendedores.manager");
var vendedores_editor_1 = require("./catalogs/vendedores.editor");
var terminales_manager_1 = require("./catalogs/terminales.manager");
var terminales_editor_1 = require("./catalogs/terminales.editor");
///////////////////////////// Document /////////////////////////////////
var ventas_manager_1 = require("./documents/ventas.manager");
var ventas_editor_1 = require("./documents/ventas.editor");
var devoluciones_manager_1 = require("./documents/devoluciones.manager");
var devoluciones_editor_1 = require("./documents/devoluciones.editor");
//////////////////////////// Mantenimientos ////////////////////////////////
var clientes_registrar_maintenance_1 = require("./maintenances/clientes-registrar.maintenance");
///////////////////////////// Parts /////////////////////////////////
var clientes_contactos_component_1 = require("./parts/clientes-contactos.component");
var clientes_contactos_editor_1 = require("./parts/clientes-contactos.editor");
var listas_precios_clientes_component_1 = require("./parts/listas-precios-clientes.component");
var listas_precios_articulos_component_1 = require("./parts/listas-precios-articulos.component");
var listas_precios_servicios_component_1 = require("./parts/listas-precios-servicios.component");
var grupos_descuentos_articulos_component_1 = require("./parts/grupos-descuentos-articulos.component");
var grupos_descuentos_servicios_component_1 = require("./parts/grupos-descuentos-servicios.component");
var nueva_venta_component_1 = require("./documents/parts/nueva-venta.component");
var articulo_lista_precios_component_1 = require("./components/articulo-lista-precios.component");
var servicio_lista_precios_component_1 = require("./components/servicio-lista-precios.component");
var articulo_grupo_descuento_component_1 = require("./components/articulo-grupo-descuento.component");
var servicio_grupo_descuento_component_1 = require("./components/servicio-grupo-descuento.component");
///////////////////////////// Rutas /////////////////////////////////
var routes = [
    {
        path: '',
        canActivateChild: [core_2.AuthGuard],
        children: [
            { path: 'empresas-ventas/:proceso', component: empresas_manager_1.EmpresasManager },
            { path: 'empresas-ventas/:proceso/:id', component: empresas_editor_1.EmpresasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'sucursales-ventas/:proceso', component: sucursales_manager_1.SucursalesManager },
            { path: 'sucursales-ventas/:proceso/:idEmpresa/:id', component: sucursales_editor_1.SucursalesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'unidades-negocio/:idSucursal/:proceso/:id', component: unidades_negocio_editor_1.UnidadesNegocioEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'unidades-negocio/:idSucursal/:proceso/:id/members', component: unidades_negocio_members_component_1.UnidadesNegocioMembersComponent },
            { path: 'regiones/:proceso', component: regiones_manager_1.RegionesManager },
            { path: 'regiones/:proceso/:id', component: regiones_editor_1.RegionesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'zonas-venta/:proceso', component: zonas_venta_manager_1.ZonasVentaManager },
            { path: 'zonas-venta/:proceso/:id', component: zonas_venta_editor_1.ZonasVentaEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'clientes-ventas/:proceso', component: clientes_manager_1.ClientesManager },
            { path: 'clientes-ventas/:proceso/:id', component: clientes_editor_1.ClientesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'clientes/contacts/:proceso/:id', component: clientes_contactos_component_1.ClientesContactosComponent },
            { path: 'clientes/contacts/:proceso/:id/:idContacto/:idPersona', component: clientes_contactos_editor_1.ClientesContactosEditor },
            { path: 'listas-precio/:proceso', component: listas_precios_manager_1.ListasPreciosManager },
            { path: 'listas-precio/:proceso/:id', component: listas_precios_editor_1.ListasPreciosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'listas-precio/:proceso/:id/clientes', component: listas_precios_clientes_component_1.ListaPreciosClientesComponent },
            { path: 'listas-precio/:proceso/:id/articulos', component: listas_precios_articulos_component_1.ListasPreciosArticulosComponent },
            { path: 'listas-precio/:proceso/:id/servicios', component: listas_precios_servicios_component_1.ListasPreciosServiciosComponent },
            { path: 'grupos-descuento/:proceso', component: grupos_descuentos_manager_1.GruposDescuentosManager },
            { path: 'grupos-descuento/:proceso/:id', component: grupos_descuentos_editor_1.GruposDescuentosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'grupos-descuento/:proceso/:id/clientes', component: grupos_descuentos_articulos_component_1.GruposDescuentosArticulosComponent },
            { path: 'grupos-descuento/:proceso/:id/articulos', component: grupos_descuentos_articulos_component_1.GruposDescuentosArticulosComponent },
            { path: 'grupos-descuento/:proceso/:id/servicios', component: grupos_descuentos_servicios_component_1.GruposDescuentosServiciosComponent },
            { path: 'estructura-comercial/:proceso', component: est_com_manager_1.EstComManager },
            { path: 'articulos-ventas/:proceso', component: articulos_manager_1.ArticulosManager },
            { path: 'articulos-ventas/:proceso/:id', component: articulos_editor_1.ArticulosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'marcas/:proceso', component: marcas_manager_1.MarcasManager },
            { path: 'marcas/:proceso/:id', component: marcas_editor_1.MarcasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'terminales/:proceso', component: terminales_manager_1.TerminalesManager },
            { path: 'terminales/:proceso/:id', component: terminales_editor_1.TerminalesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'servicios/:proceso', component: servicios_manager_1.ServiciosManager },
            { path: 'servicios/:proceso/:id', component: servicios_editor_1.ServiciosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'vendedores/:proceso', component: vendedores_manager_1.VendedoresManager },
            { path: 'vendedores/:proceso/:id', component: vendedores_editor_1.VendedoresEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'ventas/:proceso', component: ventas_manager_1.VentasManager },
            { path: 'ventas/:proceso/new', component: nueva_venta_component_1.NuevaVentaComponent },
            { path: 'ventas/:proceso/:id', component: ventas_editor_1.VentasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'articulo-listas-precio/:proceso/:idArticulo', component: articulo_lista_precios_component_1.ArticuloListaPreciosComponent },
            { path: 'servicio-listas-precio/:proceso/:idServicio', component: servicio_lista_precios_component_1.ServicioListaPreciosComponent },
            { path: 'articulo-grupo-descuento/:proceso/:idArticulo', component: articulo_grupo_descuento_component_1.ArticuloGrupoDescuentoComponent },
            { path: 'servicio-grupo-descuento/:proceso/:idServicio', component: servicio_grupo_descuento_component_1.ServicioGrupoDescuentoComponent },
            { path: 'devoluciones/:proceso', component: devoluciones_manager_1.DevolucionesManager },
            { path: 'devoluciones/:proceso/:id', component: devoluciones_editor_1.DevolucionesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'clientes-registrar/:proceso', component: clientes_registrar_maintenance_1.ClientesRegistrar },
        ]
    },
];
var SalesRoutingModule = /** @class */ (function () {
    function SalesRoutingModule() {
    }
    SalesRoutingModule = __decorate([
        core_1.NgModule({
            imports: [
                router_1.RouterModule.forChild(routes)
            ],
            exports: [
                router_1.RouterModule
            ]
        })
    ], SalesRoutingModule);
    return SalesRoutingModule;
}());
exports.SalesRoutingModule = SalesRoutingModule;
