"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
var moment = require("moment");
//Azteca Framework
var core_2 = require("framework3/core");
//Inventario
var inventory_1 = require("../../inventory");
//Locales
var devolucion_1 = require("../models/devolucion");
var DevolucionService = /** @class */ (function (_super) {
    __extends(DevolucionService, _super);
    function DevolucionService(http, context) {
        var _this = _super.call(this, http, context, 'api/ventas/devoluciones') || this;
        _this.http = http;
        _this.context = context;
        return _this;
    }
    DevolucionService.prototype.create = function () {
        var newDoc = new devolucion_1.DevolucionInfo();
        return Promise.resolve(newDoc);
    };
    DevolucionService.prototype.update = function (info) {
        //Si no tiene asignado la empresa y sucursal, asignar la actual
        if (info.idSucursal == 0)
            info.idSucursal = this.context.app.defaultSite.identity;
        //Actualizar campo de cantidad basado en las propiedades auxiliares (solo para articulos)
        info.details.filter(function (detail) { return detail.idArticulo > 0; }).map(function (detail) { return detail; }).forEach(function (detail) {
            if (detail.unidadMedida.paquete && detail.unidadMedida.factor > 1) {
                var cantidad = new inventory_1.Empaquetado(Math.trunc(detail.cantidad), detail.unidadMedida.factor, Math.trunc(detail.unidades));
                detail.cantidad = cantidad.toDecimal();
                var cantidadRef = new inventory_1.Empaquetado(detail.cantidadRef, detail.unidadMedida.factor, detail.unidadesRef);
                detail.cantidadRef = cantidadRef.toDecimal();
            }
        });
        //
        var params = new http_1.HttpParams();
        return this.apiService.post('save', params, info)
            .toPromise();
    };
    DevolucionService.prototype.mapDocument = function (document) {
        document.details.filter(function (detail) { return detail.idArticulo > 0; }).map(function (detail) { return detail; }).forEach(function (detail) {
            detail.fechaCaducidad = moment(detail.fechaCaducidad).toDate();
            //Si la unidad de medida es un paquete, separar unidades
            if (detail.unidadMedida.paquete && detail.unidadMedida.factor > 1) {
                var cantidad = new inventory_1.Empaquetado(detail.cantidad, detail.unidadMedida.factor);
                detail.cantidad = Math.round(cantidad.paquetes);
                detail.unidades = Math.round(cantidad.unidades);
            }
            else {
                detail.unidades = 0;
            }
        });
    };
    DevolucionService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], DevolucionService);
    return DevolucionService;
}(core_2.DocumentService));
exports.DevolucionService = DevolucionService;
