import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService } from 'framework3/core';
import { GrupoDescuentoInfo, GrupoDescuentoItem } from '../models/grupo-descuento';
import { ArticuloGrupoDescuentoItem } from '../models/articulo-grupo-descuento';
import { ServicioGrupoDescuentoItem } from '../models/servicio-grupo-descuento';
import { ClienteItem } from '../models/cliente';
import { SearchRequest, SearchResult } from 'framework3/search';
export declare class GrupoDescuentoService extends CatalogService<GrupoDescuentoInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<GrupoDescuentoInfo>;
    loadList(idSucursal: number): Promise<GrupoDescuentoItem[]>;
    loadClientes(idGrupoDescuentos: number, idEmpresa: number, idUsuario: number, request: SearchRequest): Promise<SearchResult>;
    addClientes(idGrupoDescuentos: number, clientes: ClienteItem[]): Promise<any>;
    loadArticulos(idSucursal: number, idGrupoDescuentos: number, request: SearchRequest): Promise<SearchResult>;
    updateArticulo(idGrupoDescuentos: number, articulo: ArticuloGrupoDescuentoItem): Promise<any>;
    loadServicios(idSucursal: number, idGrupoDescuentos: number, request: SearchRequest): Promise<SearchResult>;
    updateServicio(idGrupoDescuentos: number, servicio: ServicioGrupoDescuentoItem): Promise<any>;
}
