"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
var moment = require("moment");
var operators_1 = require("rxjs/operators");
//Azteca Framework
var core_2 = require("framework3/core");
//Inventario
var inventory_1 = require("../../inventory");
//Locales
var venta_1 = require("../models/venta");
var VentaService = /** @class */ (function (_super) {
    __extends(VentaService, _super);
    function VentaService(http, context) {
        var _this = _super.call(this, http, context, 'api/ventas/ventas') || this;
        _this.http = http;
        _this.context = context;
        return _this;
    }
    VentaService.prototype.create = function () {
        var newDoc = new venta_1.VentaInfo();
        return Promise.resolve(newDoc);
    };
    VentaService.prototype.update = function (info) {
        //Si no tiene asignado la empresa y sucursal, asignar la actual
        if (info.idSucursal == 0)
            info.idSucursal = this.context.app.defaultSite.identity;
        //Actualizar campo de cantidad basado en las propiedades auxiliares (solo para articulos)
        info.details.filter(function (detail) { return detail.idArticulo > 0; }).map(function (detail) { return detail; }).forEach(function (detail) {
            if (detail.unidadMedida.paquete && detail.unidadMedida.factor > 1) {
                var cantidad = new inventory_1.Empaquetado(detail.cantidad, detail.unidadMedida.factor, detail.unidades);
                detail.cantidad = cantidad.toDecimal();
            }
        });
        //
        var params = new http_1.HttpParams();
        return this.apiService.post('save', params, info)
            .toPromise();
    };
    VentaService.prototype.searchKeyword = function (idBranch, keyword) {
        var params = new http_1.HttpParams()
            .set("idBranch", idBranch.toString())
            .set("keyword", keyword);
        //
        return this.apiService.get("search-ventas", params);
    };
    VentaService.prototype.XXXXmapDocument = function (document) {
        document.details.filter(function (detail) { return detail.idArticulo > 0; }).map(function (detail) { return detail; }).forEach(function (detail) {
            detail.fechaCaducidad = moment(detail.fechaCaducidad).toDate();
            //Si la unidad de medida es un paquete, separar unidades
            if (detail.unidadMedida.paquete && detail.unidadMedida.factor > 1) {
                var cantidad = new inventory_1.Empaquetado(detail.cantidad, detail.unidadMedida.factor);
                detail.cantidad = cantidad.paquetes;
                detail.unidades = cantidad.unidades;
            }
            else {
                detail.unidades = 0;
            }
        });
    };
    VentaService.prototype.generarPdfFactura = function (idVenta) {
        var params = new http_1.HttpParams()
            .set("idVenta", idVenta);
        return this.apiService.get("pdf-factura", params)
            .toPromise();
    };
    VentaService.prototype.getXmlFactura = function (idVenta) {
        var params = new http_1.HttpParams()
            .set("idVenta", idVenta);
        return this.apiService.get("xml-factura", params)
            .toPromise();
    };
    VentaService.prototype.loadEstadisticaPeriodo = function (idSucursal, fechaInicial, fechaFinal) {
        var fi = moment(fechaInicial).format();
        var ff = moment(fechaFinal).format();
        var params = new http_1.HttpParams()
            .set('idSucursal', idSucursal.toString())
            .set('fechaInicial', fi)
            .set('fechaFinal', ff);
        return this.apiService.get('estadistica-periodo', params)
            .pipe(operators_1.map(function (result) {
            result.forEach(function (row) {
                row.fechaAfectacion = moment(row.fechaAfectacion).toDate();
            });
            return result;
        }))
            .toPromise();
    };
    VentaService.prototype.imprimirFormatoVenta = function (idVenta) {
        var params = new http_1.HttpParams()
            .set("idVenta", idVenta);
        return this.apiService.get("formato-venta", params)
            .toPromise();
    };
    VentaService.prototype.regenerarFactura = function (idVenta) {
        var params = new http_1.HttpParams()
            .set("IdVenta", idVenta);
        //
        return this.apiService.post('regenerar-factura', params, null)
            .toPromise();
    };
    VentaService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], VentaService);
    return VentaService;
}(core_2.DocumentService));
exports.VentaService = VentaService;
