import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { BeneficiarioService } from '../services/beneficiario.service';
import { BeneficiarioInfo } from '../models/beneficiario';
import { GrupoBeneficiariosSelectorComponent } from '../controls/grupo-beneficiarios-selector.component';
import { GrupoBeneficiariosInfo } from '../models/grupo-beneficiarios';
import { BancoSelectorComponent } from '../../accounting/components/banco-selector.component';
export declare class BeneficiariosEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private beneficiarioService;
    beneficiario: BeneficiarioInfo;
    selGrupo: GrupoBeneficiariosSelectorComponent;
    selBanco: BancoSelectorComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, beneficiarioService: BeneficiarioService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onSelectTab(args: any): void;
    onGrupoBeneficiarioSelected(grupo: GrupoBeneficiariosInfo): void;
}
