import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { MenuItem } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { CajaService } from '../services/caja.service';
import { CajaInfo } from '../models/caja';
import { CuentaBancariaItem } from '../../accounting/models/cuenta-bancaria';
import { CuentaBancariaService } from '../../accounting/services/cuenta-bancaria.service';
export declare class CajasEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private cajaService;
    private cuentaBancariaService;
    caja: CajaInfo;
    cuentasBancarias: CuentaBancariaItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, cajaService: CajaService, cuentaBancariaService: CuentaBancariaService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onMenuItemClick(option: MenuItem): void;
    loadCuentasBancarias(): void;
}
