"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var caja_service_1 = require("../services/caja.service");
var caja_1 = require("../models/caja");
var cuenta_bancaria_service_1 = require("../../accounting/services/cuenta-bancaria.service");
var CajasEditor = /** @class */ (function (_super) {
    __extends(CajasEditor, _super);
    //
    function CajasEditor(router, route, formBuilder, changeDetector, context, location, cajaService, cuentaBancariaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.cajaService = cajaService;
        _this.cuentaBancariaService = cuentaBancariaService;
        _this.caja = new caja_1.CajaInfo();
        _this.cuentasBancarias = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idChequeraDefault': [''],
            'cuenta': ['']
        });
        return _this;
    }
    CajasEditor_1 = CajasEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    CajasEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.loadCuentasBancarias();
    };
    CajasEditor.prototype.onCreatingItem = function () {
    };
    CajasEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.cajaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.caja = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CajasEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.cajaService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.caja = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CajasEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.cajaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.caja = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CajasEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.cajaService.update(this.caja)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.caja.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.caja = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CajasEditor.prototype.onMenuItemClick = function (option) {
        if (option.name == 'USERS') {
            this.router.navigate(['members'], { relativeTo: this.route });
        }
    };
    CajasEditor.prototype.loadCuentasBancarias = function () {
        var _this = this;
        this.cuentaBancariaService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (cuentasBeneficiario) {
            _this.cuentasBancarias = cuentasBeneficiario;
        })
            .catch(function (error) { return _this.showAlert(error, 'danger'); });
    };
    var CajasEditor_1;
    CajasEditor = CajasEditor_1 = __decorate([
        core_1.Component({
            selector: 'tesoreria-caja-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Caja'\"\n                                 [info]=\"caja\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Miembros'\" [smallText]=\"'editar usuarios miembro'\"></azteca-menu-item>\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"caja.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"caja.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n\n                              <div class=\"col-12 col-lg-4\">\n                                  <azteca-form-field [label]=\"'Cuenta Bancaria Predeterminada'\">\n                                      <az-combobox #cboCuentasBeneficiario                                             \n                                                   formControlName=\"idChequeraDefault\"\n                                                   [(ngModel)]=\"caja.idChequeraDefault\"\n                                                   [items]=\"cuentasBancarias\"\n                                                   [displayMember]=\"'nombre'\"\n                                                   [valueMember]=\"'id'\">\n                                      </az-combobox>\n                                  </azteca-form-field>\n                              </div>\n                              <!--<div class=\"row\">\n                                      <div class=\"col-12 col-md-10\">\n                                          <azteca-form-field [label]=\"'Impresora:'\">\n                                              <az-textbox formControlName=\"impresora\" [(ngModel)]=\"caja.idImpresora\"></az-textbox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>-->\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"cuenta\" [(ngModel)]=\"caja.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CajasEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: caja_service_1.CajaService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, caja_service_1.CajaService, cuenta_bancaria_service_1.CuentaBancariaService])
    ], CajasEditor);
    return CajasEditor;
}(editors_1.CatalogEditor));
exports.CajasEditor = CajasEditor;
