import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { FormatoTipoService, FormatoItem } from 'framework3/general';
import { ChequeraService } from '../services/chequera.service';
import { ChequeraInfo } from '../models/chequera';
import { CuentaBancariaItem } from '../../accounting/models/cuenta-bancaria';
import { CuentaBancariaService } from '../../accounting/services/cuenta-bancaria.service';
export declare class ChequerasEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private chequeraService;
    private cuentaBancariaService;
    private formatoService;
    chequera: ChequeraInfo;
    cuentasBancarias: CuentaBancariaItem[];
    formatos: FormatoItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, chequeraService: ChequeraService, cuentaBancariaService: CuentaBancariaService, formatoService: FormatoTipoService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadCuentasBancarias(): void;
    loadFormatos(): void;
}
