"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var general_1 = require("framework3/general");
//Features
var chequera_service_1 = require("../services/chequera.service");
var chequera_1 = require("../models/chequera");
var cuenta_bancaria_service_1 = require("../../accounting/services/cuenta-bancaria.service");
var ChequerasEditor = /** @class */ (function (_super) {
    __extends(ChequerasEditor, _super);
    //
    function ChequerasEditor(router, route, formBuilder, changeDetector, context, location, chequeraService, cuentaBancariaService, formatoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.chequeraService = chequeraService;
        _this.cuentaBancariaService = cuentaBancariaService;
        _this.formatoService = formatoService;
        _this.chequera = new chequera_1.ChequeraInfo();
        _this.cuentasBancarias = [];
        _this.formatos = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'cuentaBancaria': [0, forms_1.Validators.required],
            'idFormato': [0],
            'folioCheque': [0],
            'folioTransferencia': [0],
            'idCuenta': [0],
            'sample_field': ['']
        });
        return _this;
    }
    ChequerasEditor_1 = ChequerasEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ChequerasEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.loadCuentasBancarias();
        this.loadFormatos();
        this.applyPolicies();
    };
    ChequerasEditor.prototype.onCreatingItem = function () {
    };
    ChequerasEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.chequeraService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.chequera = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ChequerasEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.chequeraService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.chequera = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ChequerasEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.chequeraService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.chequera = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ChequerasEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.chequeraService.update(this.chequera)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.chequera.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.chequera = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ChequerasEditor.prototype.loadCuentasBancarias = function () {
        var _this = this;
        this.cuentaBancariaService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (cuentasBancarias) {
            _this.cuentasBancarias = cuentasBancarias;
        })
            .catch(function (error) { return _this.showAlert(error, 'danger'); });
    };
    ChequerasEditor.prototype.loadFormatos = function () {
        var _this = this;
        this.formatoService.loadFormatos('CHECKS', this.context.app.defaultCompany.identity)
            .then(function (formatos) {
            _this.formatos = formatos;
            _this.formatos.unshift({ id: 0, nombre: '[NINGUNO]', activo: true, codigo: '' });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var ChequerasEditor_1;
    ChequerasEditor = ChequerasEditor_1 = __decorate([
        core_1.Component({
            selector: 'tesoreria-chequera-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Chequera'\"\n                                 [info]=\"chequera\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"chequera.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"chequera.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-6 col-md-4\">\n                                      <azteca-form-field [label]=\"'Cuenta Bancaria'\">\n                                          <az-combobox #cboCuentasBancaria\n                                                       formControlName=\"cuentaBancaria\"\n                                                       [(ngModel)]=\"chequera.idCuentaBancaria\"\n                                                       [items]=\"cuentasBancarias\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-6 col-lg-4\">\n                                      <azteca-form-field [label]=\"'Formato:'\">\n                                          <az-combobox formControlName=\"idFormato\" [(ngModel)]=\"chequera.idFormato\" [items]=\"formatos\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-12\">\n                                      <azteca-form-field [label]=\"'Cuenta contable:'\">\n                                          <accounting-cuenta-selector formControlName=\"idCuenta\" [(ngModel)]=\"chequera.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                          </tab>\n                          <tab heading=\"Folios\">\n                              <div class=\"row\">\n                                  <div class=\"col-xs-2 col-md-2\">\n                                      <azteca-form-field [label]=\"'Cheque'\">\n                                          <az-input-number formControlName=\"folioCheque\" decimal=\"True\" [(ngModel)]=\"chequera.folioCheque\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-xs-2 col-md-2\">\n                                      <azteca-form-field [label]=\"'Transferencia'\">\n                                          <az-input-number formControlName=\"folioTransferencia\" decimal=\"True\" [(ngModel)]=\"chequera.folioTransferencia\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n\n\n\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ChequerasEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: chequera_service_1.ChequeraService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, chequera_service_1.ChequeraService, cuenta_bancaria_service_1.CuentaBancariaService,
            general_1.FormatoTipoService])
    ], ChequerasEditor);
    return ChequerasEditor;
}(editors_1.CatalogEditor));
exports.ChequerasEditor = ChequerasEditor;
