import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { ToolbarButton } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs, EditableListComponent, TrackableCollection } from 'framework3/editors';
import { ConceptoService } from '../services/concepto.service';
import { ConceptoInfo } from '../models/concepto';
import { ImpuestoAsignacionInfo, ImpuestosAsignacionEditor } from '../../accounting';
export declare class ConceptosEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private conceptoService;
    concepto: ConceptoInfo;
    impuestosCollection: TrackableCollection;
    impuestosList: EditableListComponent;
    impuestoEditor: ImpuestosAsignacionEditor;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, conceptoService: ConceptoService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onImpuestosToolbar(button: ToolbarButton): void;
    onRemoveItem(impuesto: ImpuestoAsignacionInfo): void;
    onImpuestoUpdated(impuesto: ImpuestoAsignacionInfo): void;
}
