"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var concepto_service_1 = require("../services/concepto.service");
var concepto_1 = require("../models/concepto");
//Contabilidad
var accounting_1 = require("../../accounting");
var ConceptosEditor = /** @class */ (function (_super) {
    __extends(ConceptosEditor, _super);
    function ConceptosEditor(router, route, formBuilder, changeDetector, context, location, conceptoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.conceptoService = conceptoService;
        _this.concepto = new concepto_1.ConceptoInfo();
        //
        _this.impuestosCollection = new editors_1.TrackableCollection();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'sample_field': ['']
        });
        return _this;
    }
    ConceptosEditor_1 = ConceptosEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ConceptosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    ConceptosEditor.prototype.onCreatingItem = function () {
        this.impuestosCollection.sourceCollection = this.concepto.impuestos;
    };
    ConceptosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.conceptoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.concepto = info;
            _this.impuestosCollection.sourceCollection = _this.concepto.impuestos;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.conceptoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.concepto = info;
            _this.impuestosCollection.sourceCollection = _this.concepto.impuestos;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.conceptoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.concepto = info;
            _this.impuestosCollection.sourceCollection = _this.concepto.impuestos;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.conceptoService.update(this.concepto)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.concepto.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.concepto = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////// Metodos generales //////////////////
    //onMenuItemClick(item: MenuItem) {
    //    if (item.name == 'LP') {
    //        this.router.navigate(['sales/articulo-listas-precio/' + this.process.id + '/' + this.concepto.identity.toString()]);
    //    } else if (item.name == 'GD') {
    //        this.router.navigate(['sales/articulo-grupo-descuento/' + this.process.id + '/' + this.concepto.identity.toString()]);
    //    }
    //}
    ///////////// IMPUESTOS /////////////////////////
    ConceptosEditor.prototype.onImpuestosToolbar = function (button) {
        this.impuestoEditor.show();
    };
    ConceptosEditor.prototype.onRemoveItem = function (impuesto) {
        this.impuestosCollection.remove(impuesto);
    };
    ConceptosEditor.prototype.onImpuestoUpdated = function (impuesto) {
        var newImpuestos = this.concepto.impuestos.slice();
        newImpuestos.push(impuesto);
        this.concepto.impuestos = newImpuestos;
        this.impuestosCollection.sourceCollection = newImpuestos;
    };
    var ConceptosEditor_1;
    __decorate([
        core_1.ViewChild('impuestosList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], ConceptosEditor.prototype, "impuestosList", void 0);
    __decorate([
        core_1.ViewChild(accounting_1.ImpuestosAsignacionEditor),
        __metadata("design:type", accounting_1.ImpuestosAsignacionEditor)
    ], ConceptosEditor.prototype, "impuestoEditor", void 0);
    ConceptosEditor = ConceptosEditor_1 = __decorate([
        core_1.Component({
            selector: 'tesoreria-concepto-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Concepto'\"\n                                 [info]=\"concepto\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"concepto.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"concepto.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <!------------------- IMPUESTOS ----------------------------->\n                          <tab heading=\"Impuestos\" (select)=\"onTabSelected($event)\">\n\n                              <!--Toolbar Principal-->\n                              <az-toolbar (buttonClick)=\"onImpuestosToolbar($event)\">\n                                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar Impuesto'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <wj-flex-grid #gridImpuestos style=\"height:550px\"\n                                            [itemsSource]=\"impuestosCollection\">\n\n                                  <wj-flex-grid-column [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveItem(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-trash\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n\n                                  <wj-flex-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'impuesto.code'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Tasa \u00F3 cuota'\" [binding]=\"'tasaOCuota'\" [width]=\"'30*'\" [isReadOnly]=\"true\" format=\"n2\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Orden c\u00E1lculo'\" [binding]=\"'ordenCalculo'\" [width]=\"'25*'\" [isReadOnly]=\"true\" format=\"n0\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Tipo c\u00E1lculo'\" [binding]=\"'tipoCalculo'\" [width]=\"'25*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n\n\n          </azteca-catalog-editor>\n\n          <accounting-impuesto-asignacion (dataUpdater)=\"onImpuestoUpdated($event)\">\n\n          </accounting-impuesto-asignacion>\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ConceptosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: concepto_service_1.ConceptoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, concepto_service_1.ConceptoService])
    ], ConceptosEditor);
    return ConceptosEditor;
}(editors_1.CatalogEditor));
exports.ConceptosEditor = ConceptosEditor;
