"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var operacion_tipo_service_1 = require("../services/operacion-tipo.service");
var OperacionesTiposManager = /** @class */ (function (_super) {
    __extends(OperacionesTiposManager, _super);
    //    
    function OperacionesTiposManager(context, router, route, operacionTipoService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.operacionTipoService = operacionTipoService;
        _this.operacionesTipos = [];
        return _this;
    }
    OperacionesTiposManager_1 = OperacionesTiposManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    OperacionesTiposManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
        this.refreshList();
        this.applyPolicies();
    };
    OperacionesTiposManager.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.operacionTipoService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.operacionesTipos = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    OperacionesTiposManager.prototype.onAddingItem = function () {
        this.router.navigate([0], { relativeTo: this.route });
    };
    OperacionesTiposManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    OperacionesTiposManager.prototype.onEditingItem = function (item) {
        this.router.navigate([item.id], { relativeTo: this.route });
    };
    OperacionesTiposManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.operacionTipoService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    OperacionesTiposManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    OperacionesTiposManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.operacionTipoService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    OperacionesTiposManager.prototype.onMenuItemClick = function (option) {
        if (option.name == 'USERS') {
            this.router.navigate([this.manager.currentItem.id.toString() + '/members'], { relativeTo: this.route });
        }
    };
    var OperacionesTiposManager_1;
    OperacionesTiposManager = OperacionesTiposManager_1 = __decorate([
        core_1.Component({
            selector: 'tesoreria-operaciones-tipos-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Tesoreria - Tipos de Operaciones</div>\n          <div class=\"card-block\">\n\n              <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                                      (addingItem)=\"onAddingItem()\"\n                                      (viewingItem)=\"onViewingItem($event)\"\n                                      (editingItem)=\"onEditingItem($event)\"\n                                      (deletingItem)=\"onDeletingItem($event)\"\n                                      (cloningItem)=\"onCloningItem($event)\"\n                                      (changingItemState)=\"onChangingItemState($event)\"\n                                      (configureCatalog)=\"onConfigureCatalog($event)\"\n                                      [enabled]=\"enabled\"\n                                      [allowNew]=\"allowNew\"\n                                      [allowView]=\"allowView\"\n                                      [allowEdit]=\"allowEdit\"\n                                      [allowDelete]=\"allowDelete\"\n                                      [allowClone]=\"allowClone\"\n                                      [allowChangeState]=\"allowChangeState\"\n                                      [allowAudit]=\"allowAudit\"\n                                      [catalogList]=\"operacionesTipos\"\n                                      [totalRows]=\"totalRows\"\n                                      [pageIndex]=\"pageIndex\"\n                                      (menuItemClick)=\"onMenuItemClick($event)\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-lock'\" [text]=\"'Accesos'\" [smallText]=\"'definir accesos'\"></azteca-menu-item>\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Afectador'\" [binding]=\"'afectadorText'\" [width]=\"'30*'\"></azteca-grid-column>\n              </azteca-catalog-manager>\n\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return OperacionesTiposManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: operacion_tipo_service_1.OperacionTipoService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, operacion_tipo_service_1.OperacionTipoService])
    ], OperacionesTiposManager);
    return OperacionesTiposManager;
}(editors_1.CatalogManager));
exports.OperacionesTiposManager = OperacionesTiposManager;
