"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
//import { Context, SucursalItem, SucursalService } from '../../../core';
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
var cuenta_por_pagar_service_1 = require("../services/cuenta-por-pagar.service");
//
var CuentasPorPagarListComponent = /** @class */ (function (_super) {
    __extends(CuentasPorPagarListComponent, _super);
    function CuentasPorPagarListComponent(context, service) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.service = service;
        //Inputs    
        _this.idCentroRecepcion = 0;
        _this.idWorkflowStep = 0;
        _this.idBeneficiario = 0;
        _this.idDivisa = 0;
        _this.idStatus = 0;
        _this.startPeriod = 15;
        return _this;
    }
    CuentasPorPagarListComponent_1 = CuentasPorPagarListComponent;
    CuentasPorPagarListComponent.prototype.onSearchRequested = function (request) {
        var _this = this;
        //Si se especificó status, agregar filtro
        if (this.idWorkflowStep != 0) {
            var condition = { field: 'IdWorkflowStep', operator: '=', valueType: 'int', value: this.idWorkflowStep };
            request.conditions.push(condition);
        }
        //Si se especificó Beneficiario, agregar filtro
        if (this.idBeneficiario != 0) {
            var condition = { field: 'IdBeneficiario', operator: '=', valueType: 'int', value: this.idBeneficiario };
            request.conditions.push(condition);
        }
        //Si se especificó divisa, agregar filtro
        if (this.idDivisa != 0) {
            var condition = { field: 'IdDivisa', operator: '=', valueType: 'int', value: this.idDivisa };
            request.conditions.push(condition);
        }
        //Si se especificó centro de recepcion, agregar filtro
        if (this.idCentroRecepcion != 0) {
            var condition = { field: 'IdCentroRecepcion', operator: '=', valueType: 'int', value: this.idCentroRecepcion };
            request.conditions.push(condition);
        }
        //
        if (this.idStatus > 0) {
            var condition = { field: 'IdStatus', operator: '=', valueType: 'int', value: this.idStatus };
            request.conditions.push(condition);
        }
        this.service.search(this.context.app.defaultSite.identity, request)
            .then(function (result) {
            _this.ordenes = result.rows;
            //this.totalRows = result.totalRows; se habilita cuando se agregue el extends a DocumentListDialog
            _this.pageIndex = request.pageIndex;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasPorPagarListComponent.prototype.onSelectedItemsChanged = function (selecteItems) {
        var _this = this;
        var elements = [];
        selecteItems.forEach(function (item) {
            _this.ordenes.forEach(function (itemCuentaPorPagar) {
                if (itemCuentaPorPagar.id == item.id) {
                    elements.push(itemCuentaPorPagar);
                }
            });
        });
        this.selectedItemsChanged.emit(elements);
    };
    CuentasPorPagarListComponent.prototype.onSelectedItemChanged = function (item) {
        var _this = this;
        if (item != null) {
            this.ordenes.forEach(function (itemCuentaPorPagar) {
                if (itemCuentaPorPagar.id == item.id) {
                    _this.selectedItemChanged.emit(itemCuentaPorPagar);
                }
            });
        }
    };
    //se borra cuando se agregue el extends a DocumentListDialog
    CuentasPorPagarListComponent.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
    };
    var CuentasPorPagarListComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CuentasPorPagarListComponent.prototype, "idCentroRecepcion", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CuentasPorPagarListComponent.prototype, "idWorkflowStep", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CuentasPorPagarListComponent.prototype, "idBeneficiario", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CuentasPorPagarListComponent.prototype, "idDivisa", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CuentasPorPagarListComponent.prototype, "idStatus", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CuentasPorPagarListComponent.prototype, "startPeriod", void 0);
    CuentasPorPagarListComponent = CuentasPorPagarListComponent_1 = __decorate([
        core_1.Component({
            selector: 'treasury-cuentas-por-pagar-list',
            template: "\n      <document-list-dialog (searchRequested)=\"onSearchRequested($event)\"\n                            (selectedItemsChanged)=\"onSelectedItemsChanged($event)\"\n                            (selectedItemChanged)=\"onSelectedItemChanged($event)\"\n                            [documentList]=\"ordenes\"\n                            [excludedItems]=\"excludedItems\"\n                            [multiSelect]=\"multiSelect\"\n                            [serverSide]=\"serverSide\"\n                            [pageSize]=\"pageSize\"\n                            [pageIndex]=\"pageIndex\"\n                            [startPeriod]=\"startPeriod\"\n                            [title]=\"'Cuentas por Pagar'\">\n          <!--[totalRows]=\"totalRows\"-->\n\n          <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"150\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Referencia'\" [binding]=\"'idDocumentoRef'\" [width]=\"150\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"110\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Beneficiario'\" [binding]=\"'beneficiario'\" [width]=\"50\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"90\" format=\"c\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"60\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"60\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"30\"></azteca-grid-column>\n\n      </document-list-dialog> \n    ",
            providers: [{
                    provide: core_2.BaseComponent,
                    useExisting: core_1.forwardRef(function () { return CuentasPorPagarListComponent_1; })
                }]
        }),
        __metadata("design:paramtypes", [core_2.Context, cuenta_por_pagar_service_1.CuentaPorPagarService])
    ], CuentasPorPagarListComponent);
    return CuentasPorPagarListComponent;
}(search_1.DocumentListDialog));
exports.CuentasPorPagarListComponent = CuentasPorPagarListComponent;
