import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo, PolicyInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { ContrareciboInfo } from '../models/contrarecibo';
import { ContrareciboDetail } from '../models/contrarecibo-detail';
import { ContrareciboService } from '../services/contrarecibo.service';
import { ContrareciboDetailEditor } from './parts/contrarecibos-tit-detail.editor';
import { CuentasPorPagarListComponent } from '../dialogs/cuenta-por-pagar-list.component';
import { CuentaPorPagarItem } from '../models/cuenta-por-pagar';
import { BeneficiarioItem } from '../models';
import { DivisaInfo } from '../../accounting';
export declare class ContrarecibosTitEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private contrareciboService;
    contrarecibo: ContrareciboInfo;
    detailsList: EditableListComponent;
    detailsEditor: ContrareciboDetailEditor;
    dlgCuentasPorPagar: CuentasPorPagarListComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, contrareciboService: ContrareciboService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onDivisaChanged(args: DivisaInfo): void;
    onBeneficiarioSelected(beneficiario: BeneficiarioItem): void;
    onAddingDetail(): void;
    onEditingDetail(detail: ContrareciboDetail): void;
    onDeletingDetail(detail: ContrareciboDetail): void;
    onListItemsUpdated(updatedDetails: ContrareciboDetail[]): void;
    onSavingDetail(detail: ContrareciboDetail): void;
    onCuentaPorPagarSelected(args: CuentaPorPagarItem): void;
    selectedItemsChanged(args: CuentaPorPagarItem[]): void;
    applyPolicy(policy: PolicyInfo): void;
}
