"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Locales
var contrarecibo_1 = require("../models/contrarecibo");
var contrarecibo_detail_1 = require("../models/contrarecibo-detail");
var contrarecibo_service_1 = require("../services/contrarecibo.service");
var contrarecibos_tit_detail_editor_1 = require("./parts/contrarecibos-tit-detail.editor");
var cuenta_por_pagar_list_component_1 = require("../dialogs/cuenta-por-pagar-list.component");
var ContrarecibosTitEditor = /** @class */ (function (_super) {
    __extends(ContrarecibosTitEditor, _super);
    function ContrarecibosTitEditor(context, router, route, location, formBuilder, documentTypeService, contrareciboService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.contrareciboService = contrareciboService;
        _this.contrarecibo = new contrarecibo_1.ContrareciboInfo();
        _this.documentForm = formBuilder.group({
            'idCaja': [0],
            'idDivisa': [null, controls_1.AztecaValidators.selected],
            'idBeneficiario': [0, controls_1.AztecaValidators.selected],
            'vencimiento': ['']
        });
        return _this;
    }
    ContrarecibosTitEditor_1 = ContrarecibosTitEditor;
    ContrarecibosTitEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
    };
    ContrarecibosTitEditor.prototype.onCreatingDocument = function () {
    };
    ContrarecibosTitEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.contrareciboService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.contrarecibo = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContrarecibosTitEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.contrareciboService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.contrarecibo = doc;
            _this.detailsEditor.clientIndexStart = _this.contrarecibo.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContrarecibosTitEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.contrareciboService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.contrarecibo = doc;
            _this.detailsEditor.clientIndexStart = _this.contrarecibo.details.length;
            if (_this.contrarecibo.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContrarecibosTitEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        if (this.contrarecibo.details.length > 0) {
            this.context.app.showSpinner();
            this.contrareciboService.update(this.contrarecibo)
                .then(function (updatedDoc) {
                _this.context.app.hideSpinner();
                //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
                _this.reset();
                if (!args.closeEditor && _this.contrarecibo.identity == '') {
                    _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
                }
                else {
                    if (args.closeEditor)
                        _this.router.navigate(['../'], { relativeTo: _this.route });
                    else
                        _this.showAlert('La información ha sido actualizada con éxito', 'success');
                }
                _this.contrarecibo = updatedDoc;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.showAlert('No hay cuentas por pagar relacionadas', 'danger');
        }
    };
    ContrarecibosTitEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.contrareciboService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContrarecibosTitEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.contrareciboService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContrarecibosTitEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.contrarecibo.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ContrarecibosTitEditor.prototype.onDivisaChanged = function (args) {
        if (args != undefined) {
            this.contrarecibo.idDivisa = args.identity;
            this.documentForm.updateValueAndValidity();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    ContrarecibosTitEditor.prototype.onBeneficiarioSelected = function (beneficiario) {
        if (this.contrarecibo.identity.length == 0)
            this.contrarecibo.details = [];
        else {
            this.contrarecibo.details.forEach(function (detail) { return detail.state = 'DELETED'; });
        }
    };
    ContrarecibosTitEditor.prototype.onAddingDetail = function () {
        this.dlgCuentasPorPagar.show();
    };
    ContrarecibosTitEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    ContrarecibosTitEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    ContrarecibosTitEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.contrarecibo.details = updatedDetails;
    };
    ContrarecibosTitEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    /////////// Details
    ContrarecibosTitEditor.prototype.onCuentaPorPagarSelected = function (args) {
        if (args) {
            var exist = false;
            this.contrarecibo.details.forEach(function (item) {
                if (item.idCuentaPorPagarTit == args.id && item.state != 'DELETED') {
                    exist = true;
                }
            });
            if (!exist) {
                var d = new Date();
                var detail = new contrarecibo_detail_1.ContrareciboDetail();
                detail._clientID = parseInt(d.getHours() + "" + d.getMinutes() + "" + d.getSeconds());
                detail.idCuentaPorPagarTit = args.id;
                detail.fechaCuentaPorPagar = args.fechaSys;
                detail.subTotal = args.subTotal;
                detail.impuestosTrasladados = args.impuestosTrasladados;
                detail.impuestosRetenidos = args.impuestosRetenidos;
                detail.total = args.total;
                this.onSavingDetail(detail);
            }
        }
    };
    ContrarecibosTitEditor.prototype.selectedItemsChanged = function (args) {
        var _this = this;
        if (args) {
            args.forEach(function (item) {
                _this.onCuentaPorPagarSelected(item);
            });
        }
    };
    ContrarecibosTitEditor.prototype.applyPolicy = function (policy) {
        console.log('Aplicar politica');
    };
    var ContrarecibosTitEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], ContrarecibosTitEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", contrarecibos_tit_detail_editor_1.ContrareciboDetailEditor)
    ], ContrarecibosTitEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild('dlgCuentasPorPagar'),
        __metadata("design:type", cuenta_por_pagar_list_component_1.CuentasPorPagarListComponent)
    ], ContrarecibosTitEditor.prototype, "dlgCuentasPorPagar", void 0);
    ContrarecibosTitEditor = ContrarecibosTitEditor_1 = __decorate([
        core_1.Component({
            selector: 'tesoreria-contrarecibos-tit-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                  [title]=\"'Contrarecibos'\"\n                                  [document]=\"contrarecibo\"\n                                  [valid]=\"valid\"\n                                  (configureDocument)=\"onConfigureDocument($event)\"\n                                  (creatingDocument)=\"onCreatingDocument()\"\n                                  (viewingDocument)=\"onViewingDocument($event)\"\n                                  (cloningDocument)=\"onCloningDocument($event)\"\n                                  (savingDocument)=\"onSavingDocument($event)\"\n                                  (loadingDocument)=\"onLoadingDocument($event)\"\n                                  (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                  (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'Fecha Vencimiento:'\">\n                                          <az-input-date formControlName=\"vencimiento\"\n                                                         [(ngModel)]=\"contrarecibo.vencimiento\">\n                                          </az-input-date>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'Caja:'\">\n                                          <treasury-caja-selector formControlName=\"idCaja\"\n                                                                  [(ngModel)]=\"contrarecibo.idCaja\">\n                                          </treasury-caja-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'Divisa:'\">\n                                          <accounting-divisas-selector formControlName=\"idDivisa\"\n                                                                       [(ngModel)]=\"contrarecibo.idDivisa\"\n                                                                       (selectedItemChanged)=\"onDivisaChanged($event)\">\n                                          </accounting-divisas-selector>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'Beneficiario:'\">\n                                          <treasury-beneficiario-selector formControlName=\"idBeneficiario\"\n                                                                          [(ngModel)]=\"contrarecibo.idBeneficiario\"\n                                                                          (itemSelected)=\"onBeneficiarioSelected($event)\">\n                                          </treasury-beneficiario-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #detailsList\n                                                    (addingItem)=\"onAddingDetail()\"\n                                                    (editingItem)=\"onEditingDetail($event)\"\n                                                    (deletingItem)=\"onDeletingDetail($event)\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    [listItems]=\"contrarecibo.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'idCuentaPorPagarTit'\" [width]=\"'40*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCuentaPorPagar'\" [width]=\"'40*'\" [isReadOnly]=\"true\" dataType=\"Date\" format=\"dd-MM-yyyy\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Total.'\" [binding]=\"'total'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n\n                              </azteca-editable-list>\n                          </tab>\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"contrarecibo.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n\n      </form>\n\n      <treasury-cuentas-por-pagar-list #dlgCuentasPorPagar\n                                       [startPeriod]=\"15\"\n                                       [idWorkflowStep]=\"0\"\n                                       [idBeneficiario]=\"contrarecibo.idBeneficiario\"\n                                       [idDivisa]=\"contrarecibo.idDivisa\"\n                                       [idStatus]=\"2\"\n                                       (selectedItemChanged)=\"onCuentaPorPagarSelected($event)\"\n                                       (selectedItemsChanged)=\"onItemsCuentaPorPagarSelected($event)\">\n      </treasury-cuentas-por-pagar-list>\n\n      <tesoreria-contrarecibo-detail-editor #detailsEditor\n                                            (savingItem)=\"onSavingDetail($event)\">\n      </tesoreria-contrarecibo-detail-editor>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ContrarecibosTitEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: contrarecibo_service_1.ContrareciboService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            contrarecibo_service_1.ContrareciboService])
    ], ContrarecibosTitEditor);
    return ContrarecibosTitEditor;
}(editors_1.DocumentEditor));
exports.ContrarecibosTitEditor = ContrarecibosTitEditor;
