import { Router, ActivatedRoute } from '@angular/router';
import { Context, DocumentItem } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { MenuItem } from 'framework3/controls';
import { ContentViewerComponent } from 'framework3/controls/components/content-viewer.component';
import { ContrareciboItem } from '../models/contrarecibo';
import { ContrareciboService } from '../services/contrarecibo.service';
import { ReportService } from 'framework3/core';
export declare class ContrarecibosTitManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private contrareciboService;
    private reportSvc;
    contrarecibosTit: ContrareciboItem[];
    reportViewer: ContentViewerComponent;
    titleContentView: string;
    fileNameContentView: string;
    constructor(context: Context, router: Router, route: ActivatedRoute, contrareciboService: ContrareciboService, reportSvc: ReportService);
    onConfigureDocument(): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onMenuItemClick(option: MenuItem): void;
}
