"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var content_viewer_component_1 = require("framework3/controls/components/content-viewer.component");
var contrarecibo_service_1 = require("../services/contrarecibo.service");
var core_3 = require("framework3/core");
var core_4 = require("framework3/core");
var ContrarecibosTitManager = /** @class */ (function (_super) {
    __extends(ContrarecibosTitManager, _super);
    function ContrarecibosTitManager(context, router, route, contrareciboService, reportSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.contrareciboService = contrareciboService;
        _this.reportSvc = reportSvc;
        _this.titleContentView = "";
        _this.fileNameContentView = "";
        return _this;
    }
    ContrarecibosTitManager_1 = ContrarecibosTitManager;
    ContrarecibosTitManager.prototype.onConfigureDocument = function () {
        this.refreshList();
        this.applyPolicies();
    };
    ContrarecibosTitManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.contrareciboService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.contrarecibosTit = response.rows;
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContrarecibosTitManager.prototype.onAddingItem = function () {
        this.router.navigate(['0'], { relativeTo: this.route });
    };
    ContrarecibosTitManager.prototype.onViewingItem = function (document) {
        this.router.navigate([document.id, { readonly: true }], { relativeTo: this.route });
    };
    ContrarecibosTitManager.prototype.onEditingItem = function (document) {
        this.router.navigate([document.id], { relativeTo: this.route });
    };
    ContrarecibosTitManager.prototype.onDeletingItem = function (document) {
        var _this = this;
        this.contrareciboService.delete(document.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El documento ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContrarecibosTitManager.prototype.onCloningItem = function (document) {
        this.router.navigate([0, { cloneId: document.id }], { relativeTo: this.route });
    };
    ContrarecibosTitManager.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.contrareciboService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContrarecibosTitManager.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.contrareciboService.previousStep(document.id, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContrarecibosTitManager.prototype.onMenuItemClick = function (option) {
        var _this = this;
        if (option.name == 'PRINT') {
            this.context.app.showSpinner();
            var item = this.manager.currentDocument;
            var informe = new core_3.ReporteInfo();
            var parametro = new core_3.ParametroInfo();
            parametro.name = "IdContrareciboTit";
            parametro.values.push(item.id);
            informe.parametros.push(parametro);
            informe.path = "/Onili/Tesoreria/ContraRecibo";
            informe.format = "pdf";
            this.reportSvc.loadReporte(informe)
                .then(function (info) {
                _this.context.app.hideSpinner();
                var item = _this.manager.currentDocument;
                _this.titleContentView = "Recibo " + item.id;
                _this.fileNameContentView = item.id + ".pdf";
                _this.reportViewer.show("data:application/pdf; base64, " + info.content);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    var ContrarecibosTitManager_1;
    __decorate([
        core_1.ViewChild(content_viewer_component_1.ContentViewerComponent),
        __metadata("design:type", content_viewer_component_1.ContentViewerComponent)
    ], ContrarecibosTitManager.prototype, "reportViewer", void 0);
    ContrarecibosTitManager = ContrarecibosTitManager_1 = __decorate([
        core_1.Component({
            selector: 'tesoreria-contrarecibos-tit-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">ContrarecibosTit</div>\n          <div class=\"card-block\">\n              <azteca-document-manager (searchRequested)=\"onSearchRequested($event)\"\n                                       (addingItem)=\"onAddingItem()\"\n                                       (viewingItem)=\"onViewingItem($event)\"\n                                       (editingItem)=\"onEditingItem($event)\"\n                                       (deletingItem)=\"onDeletingItem($event)\"\n                                       (cloningItem)=\"onCloningItem($event)\"\n                                       (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                       (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                       (configureDocument)=\"onConfigureDocument($event)\"\n                                       (menuItemClick)=\"onMenuItemClick($event)\"\n                                       [enabled]=\"enabled\"\n                                       [allowNew]=\"allowNew\"\n                                       [allowView]=\"allowView\"\n                                       [allowEdit]=\"allowEdit\"\n                                       [allowDelete]=\"allowDelete\"\n                                       [allowClone]=\"allowClone\"\n                                       [allowNext]=\"allowNext\"\n                                       [allowPrevious]=\"allowPrevious\"\n                                       [allowAudit]=\"allowAudit\"\n                                       [filterGroups]=\"filterGroups\"\n                                       [documentList]=\"contrarecibosTit\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n\n                  <azteca-menu-item [name]=\"'PRINT'\" [icon]=\"'glyphicon glyphicon-print'\" [text]=\"'Imprimir'\" [smallText]=\"'impresi\u00F3n de comprobante'\"></azteca-menu-item>\n\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"200\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"180\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Beneficiario'\" [binding]=\"'beneficiario'\" [width]=\"360\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"'10*'\" format=\"c\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Estatus'\" [binding]=\"'status'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"'10*'\"></azteca-grid-column>\n\n              </azteca-document-manager>\n          </div>\n      </div>\n\n      <azteca-content-viewer [title]=\"titleContentView\" [fileName]=\"fileNameContentView\"></azteca-content-viewer>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ContrarecibosTitManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: contrarecibo_service_1.ContrareciboService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, contrarecibo_service_1.ContrareciboService, core_4.ReportService])
    ], ContrarecibosTitManager);
    return ContrarecibosTitManager;
}(editors_1.DocumentManager));
exports.ContrarecibosTitManager = ContrarecibosTitManager;
