import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { CuentaPorPagarInfo } from '../models/cuenta-por-pagar';
import { CuentaPorPagarDetail } from '../models/cuenta-por-pagar-detail';
import { CuentaPorPagarService } from '../services/cuenta-por-pagar.service';
import { CuentaPorPagarDetailEditor } from './parts/cuentas-por-pagar-detail.editor';
import { ImportesInfo } from '../../accounting/models/importes';
import { BeneficiarioInfo } from '../models';
import { OperacionTipoItem } from '../models/operacion-tipo';
import { OperacionTipoService } from '../services/operacion-tipo.service';
export declare class CuentasPorPagarEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private cuentaPorPagarService;
    private operacionTipoService;
    cuentaPorPagar: CuentaPorPagarInfo;
    operacionesTipos: OperacionTipoItem[];
    detailsList: EditableListComponent;
    detailsEditor: CuentaPorPagarDetailEditor;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, cuentaPorPagarService: CuentaPorPagarService, operacionTipoService: OperacionTipoService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: CuentaPorPagarDetail): void;
    onDeletingDetail(detail: CuentaPorPagarDetail): void;
    onListItemsUpdated(updatedDetails: CuentaPorPagarDetail[]): void;
    onSavingDetail(detail: CuentaPorPagarDetail): void;
    readonly importes: ImportesInfo;
    importesDesglosados(): ImportesInfo;
    onBeneficiarioChanged(beneficiario: BeneficiarioInfo): void;
    onDivisaChanged(divisa: any): void;
    loadOperacionesTipos(): void;
}
