"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var cuenta_por_pagar_1 = require("../models/cuenta-por-pagar");
var cuenta_por_pagar_detail_1 = require("../models/cuenta-por-pagar-detail");
var cuenta_por_pagar_service_1 = require("../services/cuenta-por-pagar.service");
var cuentas_por_pagar_detail_editor_1 = require("./parts/cuentas-por-pagar-detail.editor");
var importes_1 = require("../../accounting/models/importes");
var moment = require("moment");
var operacion_tipo_service_1 = require("../services/operacion-tipo.service");
var CuentasPorPagarEditor = /** @class */ (function (_super) {
    __extends(CuentasPorPagarEditor, _super);
    function CuentasPorPagarEditor(context, router, route, location, formBuilder, documentTypeService, cuentaPorPagarService, operacionTipoService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.cuentaPorPagarService = cuentaPorPagarService;
        _this.operacionTipoService = operacionTipoService;
        _this.cuentaPorPagar = new cuenta_por_pagar_1.CuentaPorPagarInfo();
        _this.operacionesTipos = [];
        _this.documentForm = formBuilder.group({
            'idBeneficiario': [0, forms_1.Validators.required],
            'idOperacionTipo': [0, forms_1.Validators.required],
            'idDivisa': [0, forms_1.Validators.required],
        });
        return _this;
    }
    CuentasPorPagarEditor_1 = CuentasPorPagarEditor;
    CuentasPorPagarEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
        this.loadOperacionesTipos();
    };
    CuentasPorPagarEditor.prototype.onCreatingDocument = function () {
        this.cuentaPorPagar.fechaDocumentoRef = new Date(1901, 1, 1);
    };
    CuentasPorPagarEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.cuentaPorPagarService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.cuentaPorPagar = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasPorPagarEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.cuentaPorPagarService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.cuentaPorPagar = doc;
            _this.detailsEditor.clientIndexStart = _this.cuentaPorPagar.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasPorPagarEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.cuentaPorPagarService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.cuentaPorPagar = doc;
            _this.detailsEditor.clientIndexStart = _this.cuentaPorPagar.details.length;
            if (_this.cuentaPorPagar.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasPorPagarEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.cuentaPorPagarService.update(this.cuentaPorPagar)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.cuentaPorPagar.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.cuentaPorPagar = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasPorPagarEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.cuentaPorPagarService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasPorPagarEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.cuentaPorPagarService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasPorPagarEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.cuentaPorPagar.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    CuentasPorPagarEditor.prototype.onAddingDetail = function () {
        this.detailsEditor.detail = new cuenta_por_pagar_detail_1.CuentaPorPagarDetail();
        this.detailsEditor.show();
    };
    CuentasPorPagarEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    CuentasPorPagarEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    CuentasPorPagarEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.cuentaPorPagar.details = updatedDetails;
    };
    CuentasPorPagarEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    Object.defineProperty(CuentasPorPagarEditor.prototype, "importes", {
        ///////////// METODOS GENERALES /////////////////////////
        get: function () {
            return this.importesDesglosados();
        },
        enumerable: true,
        configurable: true
    });
    CuentasPorPagarEditor.prototype.importesDesglosados = function () {
        var desglose = new importes_1.ImportesInfo();
        var elementos = this.cuentaPorPagar.details.filter(function (item) { return item.state != 'DELETED'; });
        elementos.forEach(function (item) {
            desglose.subtotal += item.costoUnitario * item.cantidad;
            //desglose.descuentos += (item.descuentos.descuento1 + item.descuentos.descuento2 + item.descuentos.descuento3 + item.descuentos.descuento4 + item.descuentos.descuento5) * item.cantidad;
            if (item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "T"; }).length > 0)
                desglose.impuestosTrasladados += item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "T"; }).map(function (imp) { return imp.importe * item.cantidad; }).reduce(function (a, b) { return a + b; });
            if (item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "R"; }).length > 0)
                desglose.impuestosRetenidos += item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "R"; }).map(function (imp) { return imp.importe * item.cantidad; }).reduce(function (a, b) { return a + b; });
        });
        desglose.total = desglose.subtotal - (desglose.descuentos ? desglose.descuentos : 0) + desglose.impuestosTrasladados - desglose.impuestosRetenidos;
        return desglose;
    };
    CuentasPorPagarEditor.prototype.onBeneficiarioChanged = function (beneficiario) {
        if (this.cuentaPorPagar.identity == "") {
            this.cuentaPorPagar.details = [];
            this.detailsList.refresh();
            this.cuentaPorPagar.vencimiento = moment(new Date).add(beneficiario.diasCredito, "days").toDate();
        }
    };
    CuentasPorPagarEditor.prototype.onDivisaChanged = function (divisa) {
    };
    CuentasPorPagarEditor.prototype.loadOperacionesTipos = function () {
        var _this = this;
        this.operacionTipoService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (operaciones) {
            _this.operacionesTipos = operaciones.filter(function (item) { return item.afectador == 'C' && item.interno == false; });
        })
            .catch(function (error) { return _this.showAlert(error, 'danger'); });
    };
    var CuentasPorPagarEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], CuentasPorPagarEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", cuentas_por_pagar_detail_editor_1.CuentaPorPagarDetailEditor)
    ], CuentasPorPagarEditor.prototype, "detailsEditor", void 0);
    CuentasPorPagarEditor = CuentasPorPagarEditor_1 = __decorate([
        core_1.Component({
            selector: 'tesoreria-cuentas-por-pagar-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                  [title]=\"'Cuentas por pagar'\"\n                                  [document]=\"cuentaPorPagar\"\n                                  [valid]=\"valid\"\n                                  (configureDocument)=\"onConfigureDocument($event)\"\n                                  (creatingDocument)=\"onCreatingDocument()\"\n                                  (viewingDocument)=\"onViewingDocument($event)\"\n                                  (cloningDocument)=\"onCloningDocument($event)\"\n                                  (savingDocument)=\"onSavingDocument($event)\"\n                                  (loadingDocument)=\"onLoadingDocument($event)\"\n                                  (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                  (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <accounting-importes-component [importes]=\"importes\" [titulo]=\"'Totales'\"></accounting-importes-component>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-4\">\n                      <azteca-form-field [label]=\"'Beneficiario:'\">\n                          <treasury-beneficiario-selector formControlName=\"idBeneficiario\"\n                                                          [(ngModel)]=\"cuentaPorPagar.idBeneficiario\"\n                                                          (itemSelected)=\"onBeneficiarioChanged($event)\">\n                          </treasury-beneficiario-selector>\n                      </azteca-form-field>\n                  </div>\n\n                  <div class=\"col-12 col-md-3\">\n                      <azteca-form-field [label]=\"'Operaci\u00F3n'\">\n                          <az-combobox \n                                       formControlName=\"idOperacionTipo\"\n                                       [(ngModel)]=\"cuentaPorPagar.idOperacionTipo\"\n                                       [items]=\"operacionesTipos\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\">\n                          </az-combobox>\n                      </azteca-form-field>\n                  </div>\n\n                  <div class=\"col-12 col-md-3\">\n                      <azteca-form-field [label]=\"'Divisa:'\">\n                          <accounting-divisas-selector formControlName=\"idDivisa\"\n                                                       [(ngModel)]=\"cuentaPorPagar.idDivisa\"\n                                                       (selectedItemChanged)=\"onDivisaChanged($event)\">\n                          </accounting-divisas-selector>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n\n                          <!--<tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n\n                      </tab>-->\n\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #detailsList\n                                                    (addingItem)=\"onAddingDetail()\"\n                                                    (editingItem)=\"onEditingDetail($event)\"\n                                                    (deletingItem)=\"onDeletingDetail($event)\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    [listItems]=\"cuentaPorPagar.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n\n                                  <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigoConcepto'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Concepto'\" [binding]=\"'descripcionConcepto'\" [width]=\"'30*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [width]=\"'10*'\" [isReadOnly]=\"false\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Costo Unitario'\" [binding]=\"'costoUnitario'\" [width]=\"'10*'\" [isReadOnly]=\"false\"></azteca-grid-column>\n\n                              </azteca-editable-list>\n                          </tab>\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"cuentaPorPagar.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <tesoreria-cuenta-por-pagar-detail-editor #detailsEditor                                     \n                                           (savingItem)=\"onSavingDetail($event)\">\n\n      </tesoreria-cuenta-por-pagar-detail-editor>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CuentasPorPagarEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: cuenta_por_pagar_service_1.CuentaPorPagarService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            cuenta_por_pagar_service_1.CuentaPorPagarService,
            operacion_tipo_service_1.OperacionTipoService])
    ], CuentasPorPagarEditor);
    return CuentasPorPagarEditor;
}(editors_1.DocumentEditor));
exports.CuentasPorPagarEditor = CuentasPorPagarEditor;
