import { Router, ActivatedRoute } from '@angular/router';
import { FormGroup, FormBuilder } from '@angular/forms';
import { Context, ProcessComponent, PolicyInfo } from 'framework3/core';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { TrackableCollection } from 'framework3/editors';
import { EstadoCuentaBancarioService } from '../services/estado-cuenta-bancario.service';
import { AsyncTaskService } from "framework3/queue/services/async-task.service";
export declare class EstadoCuentaBancarioConciliar extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    private estadoCuentaService;
    private asyncTaskSvc;
    form: FormGroup;
    idEstadoCuenta: string;
    conciliando: any[];
    cuenta: string;
    origenes: {
        id: string;
        nombre: string;
    }[];
    origen: string;
    previewCollectionMovimientos: TrackableCollection;
    previewCollectionMovimientosRepetidos: TrackableCollection;
    alerts: AlertsBarComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, formBuilder: FormBuilder, estadoCuentaService: EstadoCuentaBancarioService, asyncTaskSvc: AsyncTaskService);
    applyPolicy(policy: PolicyInfo): void;
    ngOnInit(): void;
    onSelectionChanged(args: any): void;
    onCellEditEnded(flex: any, e: any): void;
    onCellEditEndedB(flex: any, e: any): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    getStatusColor(color: number): string;
    handleError(error: any): void;
}
