"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
var estado_cuenta_bancario_service_1 = require("../services/estado-cuenta-bancario.service");
var estado_cuenta_bancario_conciliar_item_1 = require("../models/estado-cuenta-bancario-conciliar-item");
var async_task_service_1 = require("framework3/queue/services/async-task.service");
var EstadoCuentaBancarioConciliar = /** @class */ (function (_super) {
    __extends(EstadoCuentaBancarioConciliar, _super);
    function EstadoCuentaBancarioConciliar(context, router, route, formBuilder, estadoCuentaService, asyncTaskSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.estadoCuentaService = estadoCuentaService;
        _this.asyncTaskSvc = asyncTaskSvc;
        _this.conciliando = [];
        _this.origenes = [];
        _this.previewCollectionMovimientos = new editors_1.TrackableCollection();
        _this.previewCollectionMovimientosRepetidos = new editors_1.TrackableCollection();
        _this.route.params.subscribe(function (params) {
            _this.idEstadoCuenta = params['idEstadoCuenta'];
        });
        _this.form = formBuilder.group({
            'cuenta': ['', forms_1.Validators.required],
            'origen': ['', forms_1.Validators.required]
        });
        _this.origenes =
            [
                { "id": "P", "nombre": "Pixcua" },
                { "id": "O", "nombre": "Onili" },
                { "id": "C", "nombre": "Contpac" }
            ];
        return _this;
    }
    //Implementacion de politicas
    EstadoCuentaBancarioConciliar.prototype.applyPolicy = function (policy) {
    };
    EstadoCuentaBancarioConciliar.prototype.ngOnInit = function () {
    };
    EstadoCuentaBancarioConciliar.prototype.onSelectionChanged = function (args) {
        var currentItem = new estado_cuenta_bancario_conciliar_item_1.EstadoCuentaBancarioConciliarItem;
        currentItem = this.previewCollectionMovimientos.currentItem;
        this.previewCollectionMovimientosRepetidos.sourceCollection = this.conciliando.filter(function (item) { return item.IdEstadosCuentaBancariosDet == currentItem.IdEstadosCuentaBancariosDet; });
    };
    EstadoCuentaBancarioConciliar.prototype.onCellEditEnded = function (flex, e) {
        var det = flex.rows[e.row].dataItem;
    };
    EstadoCuentaBancarioConciliar.prototype.onCellEditEndedB = function (flex, e) {
        //let det: any = flex.rows[e.row].dataItem;
        var sels = [];
        sels = this.previewCollectionMovimientosRepetidos.sourceCollection.filter(function (item) { return item.Sel == true; });
        if (sels.length > 1) {
            this.alerts.showAlert('Sólo debe de seleccionar un registro', 'danger');
        }
    };
    EstadoCuentaBancarioConciliar.prototype.onToolbarButtonClick = function (button) {
        var _this = this;
        if (button.name == 'CONSULTAR') {
            if (this.form.valid) {
                this.context.app.showSpinner();
                this.estadoCuentaService.asyncConciliarIngresos(this.idEstadoCuenta, this.origen, this.cuenta + '%') //'102%'
                    .then(function (edo) {
                    _this.asyncTaskSvc.subscribeTask(edo.idAsyncTask).subscribe(function (info) {
                        _this.context.app.hideSpinner();
                        _this.conciliando = JSON.parse(info.result);
                        _this.previewCollectionMovimientos.sourceCollection = _this.conciliando.filter(function (item) { return item.Cont == 1; });
                    });
                })
                    .catch(function (error) { return _this.handleError(error); });
            }
            else {
                this.alerts.showAlert('Debe de establecer una cuenta o familia de cuentas', 'danger');
            }
        }
        if (button.name == 'GUARDAR') {
            this.estadoCuentaService.conciliarIngresosSet(this.conciliando)
                .then(function (result) {
                _this.alerts.showAlert('Informacion guardada exitosamente', 'sucess');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    EstadoCuentaBancarioConciliar.prototype.getStatusColor = function (color) {
        if (color == -1)
            return '#ff9900';
        else
            return 'white';
    };
    EstadoCuentaBancarioConciliar.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], EstadoCuentaBancarioConciliar.prototype, "alerts", void 0);
    EstadoCuentaBancarioConciliar = __decorate([
        core_1.Component({
            selector: 'tesoreria-estados-cuenta-bancarios-conciliar',
            template: "\n      <form [formGroup]=\"form\">\n          <alerts-bar></alerts-bar>\n    \n          <div class=\"form-inline\">\n\n              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                  <az-toolbar-button [name]=\"'CONSULTAR'\" [type]=\"'primary'\" [text]=\"'Consultar'\" [toolTip]=\"'Consultar'\" [icon]=\"'glyphicon glyphicon-floppy-save'\" [enabled]=\"true\"></az-toolbar-button>\n                  <az-toolbar-button [name]=\"'GUARDAR'\" [type]=\"'primary'\" [text]=\"'Guardar'\" [toolTip]=\"'Guardar'\" [icon]=\"'glyphicon glyphicon-floppy-save'\" [enabled]=\"true\"></az-toolbar-button>\n              </az-toolbar>\n              <azteca-form-field [label]=\"'Cuenta o familia de cuentas:'\">\n                  <az-textbox formControlName=\"cuenta\" [(ngModel)]=\"cuenta\"></az-textbox>\n              </azteca-form-field>\n              <azteca-form-field [label]=\"'Origen:'\">\n                  <az-combobox formControlName=\"origen\"\n                               [(ngModel)]=\"origen\"\n                               [items]=\"origenes\"\n                               [valueMember]=\"'id'\"\n                               [displayMember]=\"'nombre'\"\n                               (selectedItemChanged)=\"onOrigenChanged($event)\">\n                  </az-combobox>\n              </azteca-form-field>\n          </div>\n\n          <div class=\"row\">\n\n              <wj-flex-grid #grid style=\"height:400px\"\n                            [itemsSource]=\"previewCollectionMovimientos\"\n                            [isReadOnly]=\"false\"\n                            (selectionChanged)=\"onSelectionChanged($event)\"\n                            (cellEditEnded)=\"onCellEditEnded(gridDet, $event)\">\n                  <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                  <!--<wj-flex-grid-column [header]=\"'Cont'\" [binding]=\"'Cont'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>-->\n                  <wj-flex-grid-column [header]=\"'Sel'\" [binding]=\"'Sel'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'IdEstadoCuentaDet'\" [binding]=\"'IdEstadosCuentaBancariosDet'\" [width]=\"'10*'\" [isReadOnly]=\"true\">\n                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                          <div [ngStyle]=\"{'background-color': getStatusColor(cell.item.Color)}\">\n                              {{cell.item.IdEstadosCuentaBancariosDet}}\n                          </div>\n                      </ng-template>\n                  </wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Fecha Banco'\" [binding]=\"'FechaMovimientoEC'\" [width]=\"180\" [isReadOnly]=\"true\" dataType=\"Date\" format=\"dd-MM-yyyy\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Fecha Poliza'\" [binding]=\"'FechaPoliza'\" [width]=\"180\" [isReadOnly]=\"true\" dataType=\"Date\" format=\"dd-MM-yyyy\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Abono'\" [binding]=\"'AbonoPoliza'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Cuenta'\" [binding]=\"'CuentaPoliza'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <!--<wj-flex-grid-column [header]=\"'Poliza'\" [binding]=\"'FolioPoliza'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>-->\n                  <wj-flex-grid-column [header]=\"'Referencia poliza'\" [binding]=\"'ReferenciaPoliza'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <!--<wj-flex-grid-column [header]=\"'Concepto poliza'\" [binding]=\"'ConceptoPoliza'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>-->\n                  <wj-flex-grid-column [header]=\"'Concepto banco'\" [binding]=\"'ConceptoEC'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Referencia banco'\" [binding]=\"'ReferenciaEC'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <!--<wj-flex-grid-column [header]=\"'Documento'\" [binding]=\"'IdReferenciaDocumento'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>-->\n              </wj-flex-grid>\n\n              <wj-flex-grid #grid style=\"height:150px\"\n                            [itemsSource]=\"previewCollectionMovimientosRepetidos\"\n                            [isReadOnly]=\"false\"\n                            (cellEditEnded)=\"onCellEditEndedB(gridDet, $event)\">\n                  <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                  <!--<wj-flex-grid-column [header]=\"'Cont'\" [binding]=\"'Cont'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>-->\n                  <wj-flex-grid-column [header]=\"'Sel'\" [binding]=\"'Sel'\" [width]=\"'10*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'IdEstadoCuentaDet'\" [binding]=\"'IdEstadosCuentaBancariosDet'\" [width]=\"'10*'\" [isReadOnly]=\"true\">\n                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                          <div [ngStyle]=\"{'background-color': getStatusColor(cell.item.Color)}\">\n                              {{cell.item.IdEstadosCuentaBancariosDet}}\n                          </div>\n                      </ng-template>\n                  </wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Fecha Banco'\" [binding]=\"'FechaMovimientoEC'\" [width]=\"'10*'\" [isReadOnly]=\"true\" dataType=\"Date\" format=\"dd-MM-yyyy\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Fecha Poliza'\" [binding]=\"'FechaPoliza'\" [width]=\"'10*'\" [isReadOnly]=\"true\" dataType=\"Date\" format=\"dd-MM-yyyy\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Abono'\" [binding]=\"'AbonoPoliza'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Cuenta'\" [binding]=\"'CuentaPoliza'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Poliza'\" [binding]=\"'FolioPoliza'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Referencia poliza'\" [binding]=\"'ReferenciaPoliza'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Concepto poliza'\" [binding]=\"'ConceptoPoliza'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Concepto banco'\" [binding]=\"'ConceptoEC'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Referencia banco'\" [binding]=\"'ReferenciaEC'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Documento'\" [binding]=\"'IdReferenciaDocumento'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n              </wj-flex-grid>\n\n          </div>\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder,
            estado_cuenta_bancario_service_1.EstadoCuentaBancarioService,
            async_task_service_1.AsyncTaskService])
    ], EstadoCuentaBancarioConciliar);
    return EstadoCuentaBancarioConciliar;
}(core_2.ProcessComponent));
exports.EstadoCuentaBancarioConciliar = EstadoCuentaBancarioConciliar;
