import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { ContentViewerComponent } from 'framework3/controls';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { TrackableCollection } from 'framework3/editors';
import { EstadoCuentaBancarioInfo } from '../models/estado-cuenta-bancario';
import { EstadoCuentaBancarioDetail } from '../models/estado-cuenta-bancario-detail';
import { EstadoCuentaBancarioService } from '../services/estado-cuenta-bancario.service';
import { EstadoCuentaBancarioDetailEditor } from './parts/estados-cuenta-bancarios-detail.editor';
import { CuentaBancariaItem } from '../../accounting/models/cuenta-bancaria';
import { CuentaBancariaService } from '../../accounting/services/cuenta-bancaria.service';
import { EstadoCuentaBancarioFormatoInfo } from '../models/estado-cuenta-bancario-formato';
import { TranspilerInfo, DatasetService } from '../../translator/index';
export declare class EstadosCuentaBancariosEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private estadoCuentaBancarioService;
    private cuentaBancariaService;
    private datasetSvc;
    estadoCuentaBancario: EstadoCuentaBancarioInfo;
    cuentasBancarias: CuentaBancariaItem[];
    estadoCuentaFormato: EstadoCuentaBancarioFormatoInfo;
    cvParametros: TrackableCollection;
    interval: any;
    saldoContabilidad: number;
    saldoEstadoCuenta: number;
    titleContentView: string;
    fileNameContentView: string;
    detailsList: EditableListComponent;
    detailsEditor: EstadoCuentaBancarioDetailEditor;
    reportViewer: ContentViewerComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, estadoCuentaBancarioService: EstadoCuentaBancarioService, cuentaBancariaService: CuentaBancariaService, datasetSvc: DatasetService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    checaStatus(idLote: any): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: EstadoCuentaBancarioDetail): void;
    onDeletingDetail(detail: EstadoCuentaBancarioDetail): void;
    onListItemsUpdated(updatedDetails: EstadoCuentaBancarioDetail[]): void;
    onSavingDetail(detail: EstadoCuentaBancarioDetail): void;
    loadCuentasBancarias(): void;
    onTranspilerSelected(item: TranspilerInfo): void;
    onImprimir(): void;
    readonly getImporteDepositos: string;
    readonly getImporteRetiros: string;
    readonly getImporteDepositosOnili: string;
    readonly getImporteRetirosOnili: string;
    readonly getImporteDepositosPixcua: string;
    readonly getImporteRetirosPixcua: string;
    readonly getImporteDepositosContpac: string;
    readonly getImporteRetirosContpac: string;
    readonly getSaldoFinalEstadoCuenta: string;
}
