"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
var editors_2 = require("framework3/editors");
//Locales
var estado_cuenta_bancario_1 = require("../models/estado-cuenta-bancario");
var estado_cuenta_bancario_detail_1 = require("../models/estado-cuenta-bancario-detail");
var estado_cuenta_bancario_service_1 = require("../services/estado-cuenta-bancario.service");
var estados_cuenta_bancarios_detail_editor_1 = require("./parts/estados-cuenta-bancarios-detail.editor");
var cuenta_bancaria_service_1 = require("../../accounting/services/cuenta-bancaria.service");
var estado_cuenta_bancario_formato_1 = require("../models/estado-cuenta-bancario-formato");
var index_1 = require("../../translator/index");
var EstadosCuentaBancariosEditor = /** @class */ (function (_super) {
    __extends(EstadosCuentaBancariosEditor, _super);
    function EstadosCuentaBancariosEditor(context, router, route, location, formBuilder, documentTypeService, estadoCuentaBancarioService, cuentaBancariaService, datasetSvc) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.estadoCuentaBancarioService = estadoCuentaBancarioService;
        _this.cuentaBancariaService = cuentaBancariaService;
        _this.datasetSvc = datasetSvc;
        _this.estadoCuentaBancario = new estado_cuenta_bancario_1.EstadoCuentaBancarioInfo();
        _this.cuentasBancarias = [];
        _this.estadoCuentaFormato = new estado_cuenta_bancario_formato_1.EstadoCuentaBancarioFormatoInfo();
        _this.saldoContabilidad = 0;
        _this.saldoEstadoCuenta = 0;
        _this.titleContentView = "";
        _this.fileNameContentView = "";
        _this.documentForm = formBuilder.group({
            //'sample': ['', Validators.required],
            'idDataset': [controls_1.AztecaValidators.selected],
            archivo: [null, forms_1.Validators.required],
            'cuentaBancaria': [0, forms_1.Validators.required],
            'ImporteDepositos': [0],
            'ImporteRetiros': [0],
            'DepositosOnili': [0],
            'RetirosOnili': [0],
            'DepositosPixcua': [0],
            'RetirosPixcua': [0],
            'DepositosContpac': [0],
            'RetirosContpac': [0],
            'saldoEstadoCuenta': [0],
            'saldoContabilidad': [0],
        });
        _this.cvParametros = new editors_2.TrackableCollection();
        _this.cvParametros.filter = function (item) {
            return (!item.hidden && item.state != core_2.ChangeState.DELETED);
        };
        return _this;
    }
    EstadosCuentaBancariosEditor_1 = EstadosCuentaBancariosEditor;
    EstadosCuentaBancariosEditor.prototype.onConfigureDocument = function (docType) {
        this.loadCuentasBancarias();
        this.applyPolicies();
    };
    EstadosCuentaBancariosEditor.prototype.onCreatingDocument = function () {
    };
    EstadosCuentaBancariosEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.estadoCuentaBancarioService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.estadoCuentaBancario = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EstadosCuentaBancariosEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.estadoCuentaBancarioService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.estadoCuentaBancario = doc;
            _this.detailsEditor.clientIndexStart = _this.estadoCuentaBancario.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EstadosCuentaBancariosEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.estadoCuentaBancarioService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.estadoCuentaBancario = doc;
            _this.detailsEditor.clientIndexStart = _this.estadoCuentaBancario.details.length;
            if (_this.estadoCuentaBancario.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EstadosCuentaBancariosEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.estadoCuentaFormato.transpiler.datasetInput.parameters.forEach(function (param) {
            if (param.field == 'IdSucursal') {
                param.value = _this.context.app.defaultSite.identity.toString();
            }
            else if (param.field == 'IdCuentaBancaria') {
                param.value = _this.estadoCuentaBancario.idCuentaBancaria.toString();
            }
        });
        this.estadoCuentaBancarioService.encolarTranspiler(this.estadoCuentaFormato)
            .then(function (result) {
            if (result > 0) {
                _this.showAlert("Se ha generado la tarea para subir estado de cuenta", "success");
                _this.interval = setInterval(function (_) { return _this.checaStatus(result); }, 5000);
            }
            else {
                _this.context.app.hideSpinner();
                _this.showAlert("Se a generado un error al registrar la tarea para subir el estado de cuenta", "error");
            }
            /*
            this.context.app.hideSpinner();
            this.router.navigate(['../'], { relativeTo: this.route });
            */
        })
            .catch(function (error) { return _this.handleError(error); });
        /*
        this.estadoCuentaBancarioService.update(this.estadoCuentaBancario)
            .then(updatedDoc => {
                this.context.app.hideSpinner();
                //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
                this.reset();
                if (!args.closeEditor && this.estadoCuentaBancario.identity == '') {
                    this.router.navigate(['../', updatedDoc.identity], { relativeTo: this.route });
                }
                else {
                    if (args.closeEditor)
                        this.router.navigate(['../'], { relativeTo: this.route });
                    else
                        this.showAlert('La información ha sido actualizada con éxito', 'success');
                }
                this.estadoCuentaBancario = updatedDoc;
            })
            .catch(error => this.handleError(error));
        */
    };
    EstadosCuentaBancariosEditor.prototype.checaStatus = function (idLote) {
        var _this = this;
        this.estadoCuentaBancarioService.getTranspilerStatus(idLote)
            .then(function (result) {
            if (result.completed) {
                if (result.errorMessage.length > 0) {
                    clearInterval(_this.interval);
                    _this.context.app.hideSpinner();
                    _this.showAlert("Error al subir estado de cuenta " + result.errorMessage.length, "error");
                }
                else {
                    clearInterval(_this.interval);
                    _this.context.app.hideSpinner();
                    _this.showAlert("Se ha subido el estado de cuenta", "success");
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                }
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EstadosCuentaBancariosEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.estadoCuentaBancarioService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EstadosCuentaBancariosEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.estadoCuentaBancarioService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EstadosCuentaBancariosEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.estadoCuentaBancario.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    EstadosCuentaBancariosEditor.prototype.onAddingDetail = function () {
        this.detailsEditor.detail = new estado_cuenta_bancario_detail_1.EstadoCuentaBancarioDetail();
        this.detailsEditor.show();
    };
    EstadosCuentaBancariosEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    EstadosCuentaBancariosEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    EstadosCuentaBancariosEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.estadoCuentaBancario.details = updatedDetails;
    };
    EstadosCuentaBancariosEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    EstadosCuentaBancariosEditor.prototype.loadCuentasBancarias = function () {
        var _this = this;
        this.cuentaBancariaService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (cuentasBancarias) {
            _this.cuentasBancarias = cuentasBancarias;
        })
            .catch(function (error) { return _this.showAlert(error, 'danger'); });
    };
    EstadosCuentaBancariosEditor.prototype.onTranspilerSelected = function (item) {
        var _this = this;
        if (item) {
            this.estadoCuentaFormato.transpiler = item;
            this.context.app.showSpinner();
            var promises = [];
            if (item.idDatasetInput > 0) {
                var promiseInput = this.datasetSvc.getDetailByID(item.idDatasetInput)
                    .then(function (info) {
                    _this.estadoCuentaFormato.transpiler.datasetInput = info;
                    _this.cvParametros.sourceCollection = info.parameters;
                    _this.cvParametros.refresh();
                })
                    .catch(function (error) { return _this.handleError(error); });
                promises.push(promiseInput);
            }
            if (item.idDatasetOutput > 0) {
                var promisOutput = this.datasetSvc.getDetailByID(item.idDatasetOutput)
                    .then(function (info) { return _this.estadoCuentaFormato.transpiler.datasetOutput = info; })
                    .catch(function (error) { return _this.handleError(error); });
                promises.push(promisOutput);
            }
            Promise.all(promises).then(function () {
                _this.context.app.hideSpinner();
            });
        }
    };
    EstadosCuentaBancariosEditor.prototype.onImprimir = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.estadoCuentaBancarioService.toPdf(this.estadoCuentaBancario.identity, this.saldoContabilidad, this.saldoEstadoCuenta)
            .then(function (pdf) {
            _this.context.app.hideSpinner();
            //window.open('/file-server/' + pdf.url, '_blank');
            _this.titleContentView = "EstadoCuenta_" + _this.estadoCuentaBancario.identity + ".pdf";
            _this.fileNameContentView = "EstadoCuenta_" + _this.estadoCuentaBancario.identity + ".pdf";
            _this.reportViewer.show("data:application/pdf; base64, " + pdf);
        });
    };
    Object.defineProperty(EstadosCuentaBancariosEditor.prototype, "getImporteDepositos", {
        get: function () {
            if (!this.estadoCuentaBancario.importeDepositos)
                this.estadoCuentaBancario.importeDepositos = 0;
            return wijmo_1.Globalize.formatNumber(this.estadoCuentaBancario.importeDepositos, 'c');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EstadosCuentaBancariosEditor.prototype, "getImporteRetiros", {
        get: function () {
            if (!this.estadoCuentaBancario.importeRetiros)
                this.estadoCuentaBancario.importeRetiros = 0;
            return wijmo_1.Globalize.formatNumber(this.estadoCuentaBancario.importeRetiros, 'c');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EstadosCuentaBancariosEditor.prototype, "getImporteDepositosOnili", {
        get: function () {
            if (!this.estadoCuentaBancario.importeConciliadosDepositos)
                this.estadoCuentaBancario.importeConciliadosDepositos = 0;
            return wijmo_1.Globalize.formatNumber(this.estadoCuentaBancario.importeConciliadosDepositos, 'c');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EstadosCuentaBancariosEditor.prototype, "getImporteRetirosOnili", {
        get: function () {
            if (!this.estadoCuentaBancario.importeConciliadosRetiros)
                this.estadoCuentaBancario.importeConciliadosRetiros = 0;
            return wijmo_1.Globalize.formatNumber(this.estadoCuentaBancario.importeConciliadosRetiros, 'c');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EstadosCuentaBancariosEditor.prototype, "getImporteDepositosPixcua", {
        get: function () {
            if (!this.estadoCuentaBancario.importeConciliadosPixcuaDepositos)
                this.estadoCuentaBancario.importeConciliadosPixcuaDepositos = 0;
            return wijmo_1.Globalize.formatNumber(this.estadoCuentaBancario.importeConciliadosPixcuaDepositos, 'c');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EstadosCuentaBancariosEditor.prototype, "getImporteRetirosPixcua", {
        get: function () {
            if (!this.estadoCuentaBancario.importeConciliadosPixcuaRetiros)
                this.estadoCuentaBancario.importeConciliadosPixcuaRetiros = 0;
            return wijmo_1.Globalize.formatNumber(this.estadoCuentaBancario.importeConciliadosPixcuaRetiros, 'c');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EstadosCuentaBancariosEditor.prototype, "getImporteDepositosContpac", {
        get: function () {
            if (!this.estadoCuentaBancario.importeConciliadosContpacDepositos)
                this.estadoCuentaBancario.importeConciliadosContpacDepositos = 0;
            return wijmo_1.Globalize.formatNumber(this.estadoCuentaBancario.importeConciliadosContpacDepositos, 'c');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EstadosCuentaBancariosEditor.prototype, "getImporteRetirosContpac", {
        get: function () {
            if (!this.estadoCuentaBancario.importeConciliadosContpacRetiros)
                this.estadoCuentaBancario.importeConciliadosContpacRetiros = 0;
            return wijmo_1.Globalize.formatNumber(this.estadoCuentaBancario.importeConciliadosContpacRetiros, 'c');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EstadosCuentaBancariosEditor.prototype, "getSaldoFinalEstadoCuenta", {
        get: function () {
            if (!this.estadoCuentaBancario.saldoFinal)
                this.estadoCuentaBancario.saldoFinal = 0;
            return wijmo_1.Globalize.formatNumber(this.estadoCuentaBancario.saldoFinal, 'c');
        },
        enumerable: true,
        configurable: true
    });
    var EstadosCuentaBancariosEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], EstadosCuentaBancariosEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", estados_cuenta_bancarios_detail_editor_1.EstadoCuentaBancarioDetailEditor)
    ], EstadosCuentaBancariosEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild(controls_1.ContentViewerComponent),
        __metadata("design:type", controls_1.ContentViewerComponent)
    ], EstadosCuentaBancariosEditor.prototype, "reportViewer", void 0);
    EstadosCuentaBancariosEditor = EstadosCuentaBancariosEditor_1 = __decorate([
        core_1.Component({
            selector: 'tesoreria-estados-cuenta-bancarios-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'EstadosCuentaBancarios'\"\n                                         [document]=\"estadoCuentaBancario\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-6 col-md-4\">\n                                      <azteca-form-field [label]=\"'Cuenta Bancaria'\">\n                                          <az-combobox #cboCuentasBancaria\n                                                       formControlName=\"cuentaBancaria\"\n                                                       [(ngModel)]=\"estadoCuentaBancario.idCuentaBancaria\"\n                                                       [items]=\"cuentasBancarias\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-6\">\n                                      <azteca-form-field [label]=\"'Origen de datos:'\">\n                                          <translator-transpiler-selector formControlName=\"idDataset\"\n                                                                          [(ngModel)]=\"estadoCuentaFormato.idTranspiler\"\n                                                                          (itemUpdated)=\"onTranspilerSelected($event)\">\n                                          </translator-transpiler-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Archivo:'\">\n                                          <azteca-file-box formControlName=\"archivo\"\n                                                           [(ngModel)]=\"estadoCuentaFormato.file\">\n                                          </azteca-file-box>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <wj-flex-grid #grdParametros\n                                                [itemsSource]=\"cvParametros\"\n                                                [selectionMode]=\"'Row'\"\n                                                [autoGenerateColumns]=\"false\">\n                                      <wj-flex-grid-filter></wj-flex-grid-filter>\n                                      <wj-flex-grid-column [header]=\"'Parametro'\" [binding]=\"'label'\" [width]=\"'180*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Valor'\" [binding]=\"'value'\" [width]=\"120\"></wj-flex-grid-column>\n                                  </wj-flex-grid>\n                              </div>\n\n\n                          </tab>\n                          <tab heading=\"Resumen de conciliaci\u00F3n\" (select)=\"onTabSelected($event)\">\n\n                              <az-panel [header]=\"titulo\" style=\"font-weight:bold; padding-top:10px; padding-bottom:10px\" type=\"success\">\n                                  <div class=\"row\">\n                                      <div col-6 col-md-2>\n                                          <div class=\"input-group input-group-sm mb-0\">\n                                              <div class=\"input-group-prepend\">\n                                                  <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 180px\">Depositos</span>\n                                              </div>\n                                              <input type=\"text\" formControlName=\"ImporteDepositos\" [(ngModel)]=\"getImporteDepositos\" [disabled]=\"true\" class=\"form-control\" aria-label=\"Small\" aria-describedby=\"inputGroup-sizing-sm\" style=\"text-align:right; margin-bottom:0px\" />\n                                          </div>\n                                      </div>\n                                      <div col-6 col-md-2>\n                                          <div class=\"input-group input-group-sm mb-0\">\n                                              <div class=\"input-group-prepend\">\n                                                  <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 180px\">Retiros</span>\n                                              </div>\n                                              <input type=\"text\" formControlName=\"ImporteRetiros\" [(ngModel)]=\"getImporteRetiros\" [disabled]=\"true\" class=\"form-control\" aria-label=\"Small\" aria-describedby=\"inputGroup-sizing-sm\" style=\"text-align:right\" />\n                                          </div>\n                                      </div>\n\n                                      <div col-6 col-md-2>\n                                          <div class=\"input-group input-group-sm mb-0\">\n                                              <div class=\"input-group-prepend\">\n                                                  <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 180px\">Depositos Onili</span>\n                                              </div>\n                                              <input type=\"text\" formControlName=\"DepositosOnili\" [(ngModel)]=\"getImporteDepositosOnili\" [disabled]=\"true\" class=\"form-control\" aria-label=\"Small\" aria-describedby=\"inputGroup-sizing-sm\" style=\"text-align:right\" />\n                                          </div>\n                                      </div>\n                                      <div col-6 col-md-2>\n                                          <div class=\"input-group input-group-sm mb-0\">\n                                              <div class=\"input-group-prepend\">\n                                                  <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 180px\">Retiros Onili</span>\n                                              </div>\n                                              <input type=\"text\" formControlName=\"RetirosOnili\" [(ngModel)]=\"getImporteRetirosOnili\" [disabled]=\"true\" class=\"form-control\" aria-label=\"Small\" aria-describedby=\"inputGroup-sizing-sm\" style=\"text-align:right\" />\n                                          </div>\n                                      </div>\n\n                                      <div col-6 col-md-2>\n                                          <div class=\"input-group input-group-sm mb-0\">\n                                              <div class=\"input-group-prepend\">\n                                                  <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 180px\">Depositos Pixcua</span>\n                                              </div>\n                                              <input type=\"text\" formControlName=\"DepositosPixcua\" [(ngModel)]=\"getImporteDepositosPixcua\" [disabled]=\"true\" class=\"form-control\" aria-label=\"Small\" aria-describedby=\"inputGroup-sizing-sm\" style=\"text-align:right\" />\n                                          </div>\n                                      </div>\n                                      <div col-6 col-md-2>\n                                          <div class=\"input-group input-group-sm mb-0\">\n                                              <div class=\"input-group-prepend\">\n                                                  <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 180px\">Retiros Pixcua</span>\n                                              </div>\n                                              <input type=\"text\" formControlName=\"RetirosPixcua\" [(ngModel)]=\"getImporteRetirosPixcua\" [disabled]=\"true\" class=\"form-control\" aria-label=\"Small\" aria-describedby=\"inputGroup-sizing-sm\" style=\"text-align:right\" />\n                                          </div>\n                                      </div>\n\n                                      <div col-6 col-md-2>\n                                          <div class=\"input-group input-group-sm mb-0\">\n                                              <div class=\"input-group-prepend\">\n                                                  <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 180px\">Depositos Contpac</span>\n                                              </div>\n                                              <input type=\"text\" formControlName=\"DepositosContpac\" [(ngModel)]=\"getImporteDepositosContpac\" [disabled]=\"true\" class=\"form-control\" aria-label=\"Small\" aria-describedby=\"inputGroup-sizing-sm\" style=\"text-align:right\" />\n                                          </div>\n                                      </div>\n                                      <div col-6 col-md-2>\n                                          <div class=\"input-group input-group-sm mb-0\">\n                                              <div class=\"input-group-prepend\">\n                                                  <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 180px\">Retiros Contpac</span>\n                                              </div>\n                                              <input type=\"text\" formControlName=\"RetirosContpac\" [(ngModel)]=\"getImporteRetirosContpac\" [disabled]=\"true\" class=\"form-control\" aria-label=\"Small\" aria-describedby=\"inputGroup-sizing-sm\" style=\"text-align:right\" />\n                                          </div>\n                                      </div>\n\n                                      <div col-6 col-md-2>\n                                          <div class=\"input-group input-group-sm mb-0\">\n                                              <div class=\"input-group-prepend\">\n                                                  <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 180px\">Saldo final E. C.</span>\n                                              </div>\n                                              <input type=\"text\" formControlName=\"saldoEstadoCuenta\" [(ngModel)]=\"saldoEstadoCuenta\" [disabled]=\"true\" class=\"form-control\" aria-label=\"Small\" aria-describedby=\"inputGroup-sizing-sm\" style=\"text-align:right\" />\n                                          </div>\n                                      </div>\n                                      <div col-6 col-md-2>\n                                          <div class=\"input-group input-group-sm mb-0\">\n                                              <div class=\"input-group-prepend\">\n                                                  <span class=\"input-group-text\" id=\"inputGroup-sizing-sm\" style=\"font-weight:bold; width: 180px\">Saldo final Empresa</span>\n                                              </div>\n                                              <input type=\"text\" formControlName=\"saldoContabilidad\" [(ngModel)]=\"saldoContabilidad\" [disabled]=\"true\" class=\"form-control\" aria-label=\"Small\" aria-describedby=\"inputGroup-sizing-sm\" style=\"text-align:right\" />\n                                          </div>\n                                      </div>\n\n\n\n                                  </div>\n                              </az-panel>\n\n                              <button type=\"button\" class=\"btn btn-primary\" (click)=\"onImprimir()\" [disabled]=\"false\">\n                                  <span aria-hidden=\"true\" class=\"glyphicon glyphicon-eye-open\"></span>\n                                  Informe de conciliaci\u00F3n\n                              </button>\n\n\n                          </tab>\n                          <tab heading=\"Movimientos\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #detailsList\n                                                    (addingItem)=\"onAddingDetail()\"\n                                                    (editingItem)=\"onEditingDetail($event)\"\n                                                    (deletingItem)=\"onDeletingDetail($event)\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    [listItems]=\"estadoCuentaBancario.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'Importe Retiros'\" [binding]=\"'importeRetiros'\" [width]=\"'30*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe Depositos'\" [binding]=\"'importeDepositos'\" [width]=\"'30*'\" [isReadOnly]=\"false\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Referencia'\" [binding]=\"'referencia'\" [width]=\"'50*'\" [isReadOnly]=\"false\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Conciliado'\" [binding]=\"'conciliado'\" [width]=\"'10*'\" [isReadOnly]=\"false\"></azteca-grid-column>\n\n\n                              </azteca-editable-list>\n                          </tab>\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"estadoCuentaBancario.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <tesoreria-estado-cuenta-bancario-detail-editor #detailsEditor                                     \n                                           (savingItem)=\"onSavingDetail($event)\">\n\n      </tesoreria-estado-cuenta-bancario-detail-editor>\n\n      <azteca-content-viewer [title]=\"titleContentView\" [fileName]=\"fileNameContentView\"></azteca-content-viewer>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return EstadosCuentaBancariosEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: estado_cuenta_bancario_service_1.EstadoCuentaBancarioService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            estado_cuenta_bancario_service_1.EstadoCuentaBancarioService,
            cuenta_bancaria_service_1.CuentaBancariaService,
            index_1.DatasetService])
    ], EstadosCuentaBancariosEditor);
    return EstadosCuentaBancariosEditor;
}(editors_1.DocumentEditor));
exports.EstadosCuentaBancariosEditor = EstadosCuentaBancariosEditor;
