"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var estado_cuenta_bancario_service_1 = require("../services/estado-cuenta-bancario.service");
var EstadosCuentaBancariosManager = /** @class */ (function (_super) {
    __extends(EstadosCuentaBancariosManager, _super);
    function EstadosCuentaBancariosManager(context, router, route, estadoCuentaBancarioService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.estadoCuentaBancarioService = estadoCuentaBancarioService;
        return _this;
    }
    EstadosCuentaBancariosManager_1 = EstadosCuentaBancariosManager;
    EstadosCuentaBancariosManager.prototype.onConfigureDocument = function () {
        this.refreshList();
        this.applyPolicies();
    };
    EstadosCuentaBancariosManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.estadoCuentaBancarioService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.estadosCuentaBancarios = response.rows;
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EstadosCuentaBancariosManager.prototype.onAddingItem = function () {
        this.router.navigate(['0'], { relativeTo: this.route });
    };
    EstadosCuentaBancariosManager.prototype.onViewingItem = function (document) {
        this.router.navigate([document.id, { readonly: true }], { relativeTo: this.route });
    };
    EstadosCuentaBancariosManager.prototype.onEditingItem = function (document) {
        this.router.navigate([document.id], { relativeTo: this.route });
    };
    EstadosCuentaBancariosManager.prototype.onDeletingItem = function (document) {
        var _this = this;
        this.estadoCuentaBancarioService.delete(document.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El documento ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EstadosCuentaBancariosManager.prototype.onCloningItem = function (document) {
        this.router.navigate([0, { cloneId: document.id }], { relativeTo: this.route });
    };
    EstadosCuentaBancariosManager.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.estadoCuentaBancarioService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EstadosCuentaBancariosManager.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.estadoCuentaBancarioService.previousStep(document.id, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EstadosCuentaBancariosManager.prototype.onMenuItemClick = function (option) {
        if (option.name == 'CONCILIAR-INGRESOS') {
            this.router.navigate(['treasury/estados-cuenta-bancarios-conciliar/' + this.process.id + '/' + this.manager.currentDocument.id]);
        }
    };
    var EstadosCuentaBancariosManager_1;
    EstadosCuentaBancariosManager = EstadosCuentaBancariosManager_1 = __decorate([
        core_1.Component({
            selector: 'tesoreria-estados-cuenta-bancarios-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">EstadosCuentaBancarios</div>\n          <div class=\"card-block\">\n              <azteca-document-manager (searchRequested)=\"onSearchRequested($event)\"\n                                       (addingItem)=\"onAddingItem()\"\n                                       (viewingItem)=\"onViewingItem($event)\"\n                                       (editingItem)=\"onEditingItem($event)\"\n                                       (deletingItem)=\"onDeletingItem($event)\"\n                                       (cloningItem)=\"onCloningItem($event)\"\n                                       (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                       (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                       (configureDocument)=\"onConfigureDocument($event)\"\n                                       (menuItemClick)=\"onMenuItemClick($event)\"\n                                       [enabled]=\"enabled\"\n                                       [allowNew]=\"allowNew\"\n                                       [allowView]=\"allowView\"\n                                       [allowEdit]=\"allowEdit\"\n                                       [allowDelete]=\"allowDelete\"\n                                       [allowClone]=\"allowClone\"\n                                       [allowNext]=\"allowNext\"\n                                       [allowPrevious]=\"allowPrevious\"\n                                       [allowAudit]=\"allowAudit\"\n                                       [filterGroups]=\"filterGroups\"\n                                       [documentList]=\"estadosCuentaBancarios\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'CONCILIAR-INGRESOS'\" [icon]=\"'glyphicon glyphicon-usd'\" [text]=\"'Conciliar ingresos'\" [smallText]=\"'conciliar ingresos'\"></azteca-menu-item>\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"200\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"180\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Cuenta'\" [binding]=\"'cuentaBancaria'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha Inicial'\" [binding]=\"'fechaPrimerMovimiento'\" [width]=\"180\" dataType=\"Date\" format=\"dd-MM-yyyy\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha Final'\" [binding]=\"'fechaUltimoMovimiento'\" [width]=\"180\" dataType=\"Date\" format=\"dd-MM-yyyy\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Estatus'\" [binding]=\"'status'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"'10*'\"></azteca-grid-column>\n\n              </azteca-document-manager>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return EstadosCuentaBancariosManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: estado_cuenta_bancario_service_1.EstadoCuentaBancarioService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, estado_cuenta_bancario_service_1.EstadoCuentaBancarioService])
    ], EstadosCuentaBancariosManager);
    return EstadosCuentaBancariosManager;
}(editors_1.DocumentManager));
exports.EstadosCuentaBancariosManager = EstadosCuentaBancariosManager;
