import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { CollectionView } from 'wijmo/wijmo';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { ToolbarButton } from 'framework3/controls';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { LoteImpresionService, PrinterService } from 'framework3/printing';
import { PagoInfo } from '../models/pago';
import { PagoDetail } from '../models/pago-detail';
import { PagoService } from '../services/pago.service';
import { PagoDetailEditor } from './parts/pagos-detail.editor';
import { CajaService } from '../services/caja.service';
import { CajaItem } from '../models/caja';
import { PagoTipoService } from '../services/pago-tipo.service';
import { PagoTipoItem } from '../models/pago-tipo';
import { DivisaService } from '../../accounting/services/divisa.service';
import { DivisasSelectorComponent } from '../../accounting/controls/divisas-selector.component';
import { EmpresaService } from '../../accounting/services/empresa.service';
import { ModalDirective } from 'ngx-bootstrap';
export declare class PagosEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private cajaService;
    private pagoService;
    private divisaService;
    private pagoTipoService;
    private empresaService;
    private loteImpresionService;
    private printerService;
    pago: PagoInfo;
    cajas: CajaItem[];
    pagosTipo: PagoTipoItem[];
    acumulado: number;
    idDivisaDefault: number;
    tipoCambio: string;
    cuentasXPagar: CollectionView;
    intervalId: any;
    establecerMonto: boolean;
    formato: string;
    decimales: number;
    detailsList: EditableListComponent;
    detailsEditor: PagoDetailEditor;
    divisasSelector: DivisasSelectorComponent;
    dialogDecimales: ModalDirective;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, cajaService: CajaService, pagoService: PagoService, divisaService: DivisaService, pagoTipoService: PagoTipoService, empresaService: EmpresaService, loteImpresionService: LoteImpresionService, printerService: PrinterService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: PagoDetail): void;
    onDeletingDetail(detail: PagoDetail): void;
    onListItemsUpdated(updatedDetails: PagoDetail[]): void;
    onSavingDetail(detail: PagoDetail): void;
    loadCajas(): void;
    loadPagosTipo(): void;
    validateMontos(): string;
    validateMontos2(): string;
    onDetailsLoaded(details: PagoDetail[]): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    getStatusColor(vencimiento: Date): string;
    cellEditEndingHandler(sender: any, e: any): void;
    calcularAcumulado(): void;
    onCellEditEnded(flex: any, e: any): void;
    onChequeraSelected(): void;
    onBeneficiarioSelected(args: any): void;
    keydown(grid: any, args: any, cell: any): void;
    getDivisaDefault(creating: boolean): void;
    onDivisaSelected(args: any): void;
    assignFormat(): void;
    checaStatus(idLote: any): void;
    onChangeEstablecerMonto(args: any): void;
}
