"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var printing_1 = require("framework3/printing");
//Locales
var pago_1 = require("../models/pago");
var pago_detail_1 = require("../models/pago-detail");
var pago_service_1 = require("../services/pago.service");
var pagos_detail_editor_1 = require("./parts/pagos-detail.editor");
var caja_service_1 = require("../services/caja.service");
var pago_tipo_service_1 = require("../services/pago-tipo.service");
var divisa_service_1 = require("../../accounting/services/divisa.service");
var divisas_selector_component_1 = require("../../accounting/controls/divisas-selector.component");
var empresa_service_1 = require("../../accounting/services/empresa.service");
var ngx_bootstrap_1 = require("ngx-bootstrap");
var PagosEditor = /** @class */ (function (_super) {
    __extends(PagosEditor, _super);
    function PagosEditor(context, router, route, location, formBuilder, documentTypeService, cajaService, pagoService, divisaService, pagoTipoService, empresaService, loteImpresionService, printerService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.cajaService = cajaService;
        _this.pagoService = pagoService;
        _this.divisaService = divisaService;
        _this.pagoTipoService = pagoTipoService;
        _this.empresaService = empresaService;
        _this.loteImpresionService = loteImpresionService;
        _this.printerService = printerService;
        _this.pago = new pago_1.PagoInfo();
        _this.cajas = [];
        _this.pagosTipo = [];
        _this.acumulado = 0;
        _this.idDivisaDefault = 0;
        _this.cuentasXPagar = new wijmo_1.CollectionView();
        _this.establecerMonto = false;
        _this.formato = "C2";
        _this.decimales = 2;
        _this.documentForm = formBuilder.group({
            'caja': ['', forms_1.Validators.required],
            'idBeneficiario': [0, forms_1.Validators.required],
            'idPagoTipo': [0, forms_1.Validators.required],
            'idChequera': [0, forms_1.Validators.required],
            'idDivisa': [0, forms_1.Validators.required],
            'observaciones': ['', forms_1.Validators.required],
            'monto': ['0', function (_) { return _this.validateMontos(); }],
            'acumulado': ['0', function (_) { return _this.validateMontos2(); }],
            'establecerMonto': [false]
        });
        return _this;
    }
    PagosEditor_1 = PagosEditor;
    PagosEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
        this.loadCajas();
        this.loadPagosTipo();
        this.getDivisaDefault(false);
    };
    PagosEditor.prototype.onCreatingDocument = function () {
        this.getDivisaDefault(true);
    };
    PagosEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.pagoService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.pago = doc;
            _this.cuentasXPagar.sourceCollection = _this.pago.details;
            _this.calcularAcumulado();
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PagosEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.pagoService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.pago = doc;
            _this.detailsEditor.clientIndexStart = _this.pago.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PagosEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.pagoService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.pago = doc;
            _this.cuentasXPagar.sourceCollection = _this.pago.details;
            _this.calcularAcumulado();
            _this.detailsEditor.clientIndexStart = _this.pago.details.length;
            if (_this.pago.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PagosEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.pagoService.update(this.pago)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.pago.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.pago = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PagosEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.pagoService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PagosEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.pagoService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PagosEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.pago.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    PagosEditor.prototype.onAddingDetail = function () {
        //this.detailsEditor.detail = new PagoDetail();
        //this.detailsEditor.show();
    };
    PagosEditor.prototype.onEditingDetail = function (detail) {
        //this.detailsEditor.detail = detail;
        //this.detailsEditor.show();
    };
    PagosEditor.prototype.onDeletingDetail = function (detail) {
        //this.detailsList.deleteItem(detail);
    };
    PagosEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.pago.details = updatedDetails;
    };
    PagosEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    //////////////////////PERSONALIZACION//////////////////////
    PagosEditor.prototype.loadCajas = function () {
        var _this = this;
        this.cajaService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (cajas) { return _this.cajas = cajas; })
            .catch(function (error) { return _this.handleError(error); });
    };
    PagosEditor.prototype.loadPagosTipo = function () {
        var _this = this;
        this.pagoTipoService.loadList(this.context.app.defaultSite.identity)
            .then(function (pagosT) { return _this.pagosTipo = pagosT; })
            .catch(function (error) { return _this.handleError(error); });
    };
    PagosEditor.prototype.validateMontos = function () {
        if (Math.abs(this.pago.total - this.acumulado) <= 0.001 && this.acumulado > 0)
            return null;
        else
            return 'No coincide el monto deseado con el monto acumulado.';
    };
    PagosEditor.prototype.validateMontos2 = function () {
        if (Math.abs(this.pago.total - this.acumulado) <= 0.001 && this.acumulado > 0)
            return null;
        else
            return 'No coincide el monto deseado con el monto acumulado.';
    };
    PagosEditor.prototype.onDetailsLoaded = function (details) {
        this.acumulado = 0;
        var detailsOrder = details;
        this.detailsList.listItems = detailsOrder;
        this.pago.details = detailsOrder;
        this.cuentasXPagar.sourceCollection = detailsOrder;
    };
    PagosEditor.prototype.onToolbarButtonClick = function (button) {
        var _this = this;
        if (button.name == 'ADD') {
            this.detailsEditor.detail = new pago_detail_1.PagoDetail();
            this.detailsEditor.show();
        }
        else if (button.name == 'DECIMALES') {
            this.dialogDecimales.config.backdrop = false;
            this.dialogDecimales.show();
        }
        else if (button.name == 'IMPRIMIR') {
            var pagosToCheque = [];
            this.context.app.showSpinner();
            pagosToCheque[0] = this.pago.identity;
            this.pagoService.getLoteCheques(pagosToCheque)
                .then(function (lote) {
                _this.intervalId = setInterval(function (_) { return _this.checaStatus(lote.id); }, 5000);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    PagosEditor.prototype.getStatusColor = function (vencimiento) {
        var venc = new Date(vencimiento);
        var today = new Date();
        if (today < venc)
            return '#298A08';
        else
            return 'orangered';
    };
    PagosEditor.prototype.cellEditEndingHandler = function (sender, e) {
        var _this = this;
        var cxp = sender.rows[e.row].dataItem;
        var flex = sender, oldVal = flex.getCellData(e.row, e.col), newVal = flex.activeEditor.value;
        setTimeout(function (_) { return _this.calcularAcumulado(); });
        if (newVal > cxp.saldo) {
            this.showAlert("No puede abonar un importe mayor al saldo del documento", "danger");
            e.cancel = true;
            cxp.importe = cxp.saldo;
        }
        if (!isNaN(newVal)) // returns true if NaN, otherwise false            
            cxp.saldoFin = cxp.saldo - newVal;
        else //proviene del keydown ya que activaron el beginEdit
            e.cancel = true;
        cxp.state = "MODIFIED";
    };
    PagosEditor.prototype.calcularAcumulado = function () {
        this.acumulado = this.pago.details
            .map(function (c) { return c.importe; })
            .reduce(function (sum, current) { return sum + current; });
        this.documentForm.get('monto').updateValueAndValidity();
        if (!this.establecerMonto)
            this.pago.total = this.acumulado;
    };
    PagosEditor.prototype.onCellEditEnded = function (flex, e) {
        var _this = this;
        this.cuentasXPagar.refresh();
        var Total = this.pago.total;
        this.pago.total = Total;
        setTimeout(function (_) { return _this.calcularAcumulado(); });
    };
    PagosEditor.prototype.onChequeraSelected = function () {
    };
    PagosEditor.prototype.onBeneficiarioSelected = function (args) {
        if (this.pago.status == core_2.DocumentStatus.DRAFT) {
            this.pago.details = [];
            this.cuentasXPagar.sourceCollection = [];
        }
    };
    PagosEditor.prototype.keydown = function (grid, args, cell) {
        var _this = this;
        if (args.keyCode == 13) {
            var cxp = grid.rows[grid.selection.row].dataItem;
            if (this.acumulado == undefined)
                this.acumulado == 0;
            var disponible = this.pago.total - this.acumulado;
            if (disponible < 0 || disponible == undefined || isNaN(disponible))
                disponible = 0;
            if (disponible > cxp.saldo || !this.establecerMonto)
                cxp.importe = cxp.saldo;
            else
                cxp.importe = disponible;
            cxp.saldoFin = cxp.saldo - cxp.importe;
            cxp.state = "MODIFIED";
            //let total: number = this.cobranza.total+1;
            //this.cobranza.total = total-1;
            //this.documentForm.get('monto').markAsPristine();
            //this.documentForm.get('monto').markAsPending();
            this.detailsList.refresh();
            this.documentForm.get('monto').updateValueAndValidity();
            setTimeout(function (_) { return _this.calcularAcumulado(); });
        }
    };
    PagosEditor.prototype.getDivisaDefault = function (creating) {
        var _this = this;
        this.divisaService.getDetailByEmpresa(this.context.app.defaultCompany.identity)
            .then(function (r) {
            _this.idDivisaDefault = r.identity;
            if (creating) {
                _this.pago.idDivisa = r.identity;
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PagosEditor.prototype.onDivisaSelected = function (args) {
        var _this = this;
        if (this.pago.status == core_2.DocumentStatus.DRAFT) {
            this.pago.details = [];
            this.cuentasXPagar.sourceCollection = [];
        }
        if (this.pago.idDivisa == this.idDivisaDefault) {
            this.pago.tipoCambio = 1;
            this.tipoCambio = this.pago.tipoCambio.toString();
        }
        else {
            this.divisaService.loadTiposCambio(this.context.app.defaultCompany.identity)
                .then(function (tipos) {
                var tCambio = tipos.find(function (search) { return search.idDivisaOrigen == _this.pago.idDivisa && search.idDivisaDestino == _this.idDivisaDefault; });
                if (tCambio == undefined) {
                    _this.showAlert("No está definido el tipo de cambio para la divisa seleccionada", "danger");
                    _this.tipoCambio = null;
                    _this.pago.idDivisa = null;
                    _this.pago.tipoCambio = 0;
                }
                else {
                    _this.empresaService.getDetailFromCache(_this.context.app.defaultCompany.identity)
                        .then(function (emp) {
                        if (emp.tipoCambio == 'O') {
                            _this.pago.tipoCambio = tCambio.precioOtro;
                            _this.tipoCambio = tCambio.precioOtro.toString();
                        }
                        else if (emp.tipoCambio == 'V') {
                            _this.pago.tipoCambio = tCambio.precioVenta;
                            _this.tipoCambio = tCambio.precioVenta.toString();
                        }
                        else if (emp.tipoCambio == 'C') {
                            _this.pago.tipoCambio = tCambio.precioCompra;
                            _this.tipoCambio = tCambio.precioCompra.toString();
                        }
                    });
                }
            });
        }
    };
    PagosEditor.prototype.assignFormat = function () {
        this.formato = 'C' + this.decimales.toString();
        this.dialogDecimales.hide();
        this.calcularAcumulado();
    };
    PagosEditor.prototype.checaStatus = function (idLote) {
        var _this = this;
        //this.context.app.hideSpinner();
        this.loteImpresionService.getStatus(idLote)
            .then(function (result) {
            if (result == 'C') {
                _this.loteImpresionService.getFiles(idLote)
                    .then(function (files) {
                    _this.context.app.hideSpinner();
                    var links = [];
                    var Cheques = new core_2.FileLink;
                    Cheques.uri = files[0];
                    Cheques.fileName = files[0];
                    links.push(Cheques);
                    //this.printerService.printPdfFile('/file-server/' + files[0], 'EPSON FX-2190 Ver 2.0');
                    _this.printerService.printTextFile('/file-server/' + files[0]);
                    //this.downloadPopup.show(links);
                    clearInterval(_this.intervalId);
                });
            }
            /*
            if (result == 'R') {
                this.showAlert('Generando bloque de impresión, el proceso puede tardar varios minutos', 'success');
            }
            */
            if (result == 'E') {
                clearInterval(_this.intervalId);
                _this.context.app.hideSpinner();
                _this.showAlert('Error al obtener el bloque de impresión de cheques', 'success');
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PagosEditor.prototype.onChangeEstablecerMonto = function (args) {
        wijmo_1.Control.invalidateAll();
    };
    var PagosEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], PagosEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", pagos_detail_editor_1.PagoDetailEditor)
    ], PagosEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild('divisasSelector'),
        __metadata("design:type", divisas_selector_component_1.DivisasSelectorComponent)
    ], PagosEditor.prototype, "divisasSelector", void 0);
    __decorate([
        core_1.ViewChild('dialogDecimales'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], PagosEditor.prototype, "dialogDecimales", void 0);
    PagosEditor = PagosEditor_1 = __decorate([
        core_1.Component({
            selector: 'tesoreria-pagos-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                  [title]=\"'Pagos'\"\n                                  [document]=\"pago\"\n                                  [valid]=\"valid\"\n                                  (configureDocument)=\"onConfigureDocument($event)\"\n                                  (creatingDocument)=\"onCreatingDocument()\"\n                                  (viewingDocument)=\"onViewingDocument($event)\"\n                                  (cloningDocument)=\"onCloningDocument($event)\"\n                                  (savingDocument)=\"onSavingDocument($event)\"\n                                  (loadingDocument)=\"onLoadingDocument($event)\"\n                                  (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                  (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n                              <div class=\"row\">\n\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Tipo de pago:'\">\n\n                                          <az-combobox formControlName=\"idPagoTipo\"\n                                                       [(ngModel)]=\"pago.idPagoTipo\"\n                                                       [items]=\"pagosTipo\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Caja'\">\n                                          <az-combobox formControlName=\"caja\"\n                                                       [(ngModel)]=\"pago.idCaja\"\n                                                       [items]=\"cajas\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-10 col-md-8\">\n                                      <azteca-form-field [label]=\"'Chequera:'\">\n                                          <treasury-chequera-selector formControlName=\"idChequera\" [(ngModel)]=\"pago.idChequera\" ngDefaultControl=\"\" (itemSelected)=\"onChequeraSelected($event)\"></treasury-chequera-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                              <azteca-form-field [label]=\"'Observaciones:'\">\n                                  <az-textarea formControlName=\"observaciones\" [(ngModel)]=\"pago.observaciones\"></az-textarea>\n                              </azteca-form-field>\n\n\n                          </tab>\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'DECIMALES'\" [type]=\"'primary'\" [text]=\"'Cant. Decimales'\" [toolTip]=\"'Cantidad de decimales a mostrar'\" [icon]=\"'glyphicon glyphicon-sound-5-1'\" [enabled]=\"true\"></az-toolbar-button>\n                              </az-toolbar>\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-10 col-md-8\">\n                                      <azteca-form-field [label]=\"'Beneficiario:'\">\n                                          <treasury-beneficiario-selector formControlName=\"idBeneficiario\" [(ngModel)]=\"pago.idBeneficiario\" ngDefaultControl=\"\" (itemSelected)=\"onBeneficiarioSelected($event)\"></treasury-beneficiario-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"col-3 col-md-3\">\n                                  <az-checkbox [label]=\"'Establecer monto'\" formControlName=\"establecerMonto\" [(ngModel)]=\"establecerMonto\" (checkedChanged)=\"onChangeEstablecerMonto($event)\"></az-checkbox>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Monto:'\">\n                                          <az-input-number formControlName=\"monto\" [(ngModel)]=\"pago.total\" format=\"{{formato}}\" [enabled]=\"pago.identity==''\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Capturado:'\">\n                                          <az-input-number formControlName=\"acumulado\" [(ngModel)]=\"acumulado\" format=\"{{formato}}\" [enabled]=\"false\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-10 col-md-4\">\n                                      <azteca-form-field [label]=\"'Divisa de las cuentas por pagar:'\">\n                                          <accounting-divisas-selector #divisasSelector formControlName=\"idDivisa\" [(ngModel)]=\"pago.idDivisa\" ngDefaultControl=\"\" (selectedItemChanged)=\"onDivisaSelected($event)\"></accounting-divisas-selector>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-10 col-md-4\">\n                                      <label class=\"control-label\">Tipo de cambio:</label>\n                                      <az-label [text]=\"tipoCambio\"></az-label>\n                                  </div>\n                              </div>\n\n\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar documentos para pagos'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <wj-flex-grid #detailsList style=\"height:550px\"\n                                                    (dataLoaded)=\"onListItemsUpdated($event)\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    (cellEditEnding)=\"cellEditEndingHandler(detailsList, $event)\"\n                                                    (cellEditEnded)=\"onCellEditEnded(detailsList, $event, cell)\"\n                                                    [itemsSource]=\"cuentasXPagar\"\n                                                    (keydown)=\"keydown(detailsList, $event)\">\n\n                                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                                          <wj-flex-grid-column [header]=\"'Contra recibo'\" [binding]=\"'idContrareciboTit'\" [width]=\"140\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Cuenta por pagar'\" [binding]=\"'idCuentaPorPagar'\" [width]=\"140\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Vencimiento'\" [binding]=\"'vencimiento'\" [width]=\"100\" [isReadOnly]=\"true\">\n                                              <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                                  <div [ngStyle]=\"{'background-color': getStatusColor(cell.item.vencimiento), 'color': 'white'}\">\n                                                      {{cell.item.vencimiento}}\n                                                  </div>\n                                              </ng-template>\n                                          </wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"100\" dataType=\"Number\" format=\"{{formato}}\" [isReadOnly]=\"true\"> </wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Saldo'\" [binding]=\"'saldo'\" [width]=\"100\" dataType=\"Number\" format=\"{{formato}}\" [isReadOnly]=\"true\"> </wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Pago'\" [binding]=\"'importe'\" [width]=\"100\" dataType=\"Number\" format=\"{{formato}}\" [isReadOnly]=\"false\">\n                                              <!--<ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                              <input id=\"cobro\" type=\"text\" name=\"cobro\" ng-model=\"cell.item.importe\" (keyPress)=\"importeKeyPress(cell.item, $event)\">\n                          </ng-template>-->\n                                          </wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Saldo Fin'\" [binding]=\"'saldoFin'\" [width]=\"100\" dataType=\"Number\" format=\"{{formato}}\" [isReadOnly]=\"true\"> </wj-flex-grid-column>\n                                          <!--<wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                          <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                              <button type=\"button\" class=\"btn btn-default\" (click)=\"onImporteCheck(cell.item, $event)\">\n                                  <span class=\"glyphicon glyphicon-check\"></span>\n                              </button>\n                          </ng-template>\n                      </wj-flex-grid-column>-->\n\n                                      </wj-flex-grid>\n                                  </div>\n                              </div>\n\n                              <!--<azteca-editable-list #detailsList\n          (addingItem)=\"onAddingDetail()\"\n          (editingItem)=\"onEditingDetail($event)\"\n          (deletingItem)=\"onDeletingDetail($event)\"\n          (listItemsUpdated)=\"onListItemsUpdated($event)\"\n          [listItems]=\"pago.details\">-->\n                              <!-- OPCIONES DEL MENU-->\n                              <!--<azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n          <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>-->\n                              <!-- COLUMNAS DEL GRID-->\n                              <!-- Columnas de Ejemplo\n          <azteca-grid-column [header]=\"'Art\u00EDculo'\" [binding]=\"'articulo'\" [width]=\"'30*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'U.M.'\" [binding]=\"'unidad'\" [width]=\"'10*'\" [isReadOnly]=\"false\"></azteca-grid-column>\n          -->\n                              <!--</azteca-editable-list>-->\n                          </tab>\n                          <tab heading=\"Impresi\u00F3n\" (select)=\"onTabSelected($event)\" [disabled]=\"pago.identity==''\">\n                              <hr />\n\n                              <div class=\"row\">\n                                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                      <az-toolbar-button [name]=\"'IMPRIMIR'\" [type]=\"'primary'\" [text]=\"'Imprimir cheque'\" [toolTip]=\"'Imprimir cheque'\" [icon]=\"'glyphicon glyphicon-print'\" [enabled]=\"pago.status==2\"></az-toolbar-button>\n                                  </az-toolbar>\n\n                              </div>\n                          </tab>\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"pago.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <tesoreria-pago-detail-editor #detailsEditor\n                                    (savingItem)=\"onSavingDetail($event)\"\n                                    (dataLoaded)=\"onDetailsLoaded($event)\"\n                                    [idBeneficiario]=\"pago.idBeneficiario\"\n                                    [idDivisa]=\"pago.idDivisa\">\n\n      </tesoreria-pago-detail-editor>\n\n\n      <div bsModal #dialogDecimales=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\">Cantidad de decimales a mostrar</h4>\n                  </div>\n                  <div class=\"modal-body\">\n                      <az-input-number [(ngModel)]=\"decimales\" format=\"n\" [enabled]=\"true\"></az-input-number>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button class=\"btn btn-primary\" type=\"button\" (click)=\"assignFormat()\">Aceptar</button>\n                      <button class=\"btn btn-danger\" type=\"button\" (click)=\"dialogDecimales.hide()\">Cancelar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return PagosEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: pago_service_1.PagoService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            caja_service_1.CajaService,
            pago_service_1.PagoService,
            divisa_service_1.DivisaService,
            pago_tipo_service_1.PagoTipoService,
            empresa_service_1.EmpresaService,
            printing_1.LoteImpresionService,
            printing_1.PrinterService])
    ], PagosEditor);
    return PagosEditor;
}(editors_1.DocumentEditor));
exports.PagosEditor = PagosEditor;
