import { Router, ActivatedRoute } from '@angular/router';
import { Context, DocumentItem } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { LoteImpresionService, PrinterService } from 'framework3/printing';
import { PagoItem } from '../models/pago';
import { PagoService } from '../services/pago.service';
import { MenuItem, DownloadPopupComponent } from 'framework3/controls';
import { ModalDirective } from 'ngx-bootstrap/modal/modal.directive';
import { PolizaPerfilListComponent, PolizaPerfilItem, PolizaInfo, PolizaService } from '../../accounting/index';
export declare class PagosManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private pagoService;
    private loteImpresionService;
    private printerService;
    private polizaSvc;
    pagos: PagoItem[];
    pagosToCheque: string[];
    intervalId: any;
    currentPoliza: PolizaInfo;
    dlgPolizaViewer: ModalDirective;
    dlgPolizaPerfil: PolizaPerfilListComponent;
    downloadPopup: DownloadPopupComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, pagoService: PagoService, loteImpresionService: LoteImpresionService, printerService: PrinterService, polizaSvc: PolizaService);
    onConfigureDocument(): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onMenuItemClick(option: MenuItem): void;
    checaStatus(idLote: any): void;
    onSelectedPolizaPerfil(item: PolizaPerfilItem): void;
    onClickGuardar(): void;
}
