"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var printing_1 = require("framework3/printing");
var pago_service_1 = require("../services/pago.service");
var controls_1 = require("framework3/controls");
var modal_directive_1 = require("ngx-bootstrap/modal/modal.directive");
var index_1 = require("../../accounting/index");
var PagosManager = /** @class */ (function (_super) {
    __extends(PagosManager, _super);
    function PagosManager(context, router, route, pagoService, loteImpresionService, printerService, polizaSvc) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.pagoService = pagoService;
        _this.loteImpresionService = loteImpresionService;
        _this.printerService = printerService;
        _this.polizaSvc = polizaSvc;
        _this.pagosToCheque = [];
        _this.currentPoliza = new index_1.PolizaInfo();
        return _this;
    }
    PagosManager_1 = PagosManager;
    PagosManager.prototype.onConfigureDocument = function () {
        this.refreshList();
        this.applyPolicies();
    };
    PagosManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.pagoService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.pagos = response.rows;
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PagosManager.prototype.onAddingItem = function () {
        this.router.navigate(['0'], { relativeTo: this.route });
    };
    PagosManager.prototype.onViewingItem = function (document) {
        this.router.navigate([document.id, { readonly: true }], { relativeTo: this.route });
    };
    PagosManager.prototype.onEditingItem = function (document) {
        this.router.navigate([document.id], { relativeTo: this.route });
    };
    PagosManager.prototype.onDeletingItem = function (document) {
        var _this = this;
        this.pagoService.delete(document.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El documento ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PagosManager.prototype.onCloningItem = function (document) {
        this.router.navigate([0, { cloneId: document.id }], { relativeTo: this.route });
    };
    PagosManager.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.pagoService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PagosManager.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.pagoService.previousStep(document.id, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PagosManager.prototype.onMenuItemClick = function (option) {
        var _this = this;
        if (option.name == 'IMPRIMIR') {
            this.pagosToCheque = [];
            this.context.app.showSpinner();
            var i = 0;
            for (i = 0; i <= this.manager.baseList.documentsView.totalItemCount - 1; i++) {
                this.pagosToCheque[i] = this.manager.baseList.documentsView._view[i].id;
            }
            this.pagoService.getLoteCheques(this.pagosToCheque)
                .then(function (lote) {
                _this.intervalId = setInterval(function (_) { return _this.checaStatus(lote.id); }, 5000);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == "CONTABILIZAR") {
            this.dlgPolizaPerfil.show();
        }
    };
    PagosManager.prototype.checaStatus = function (idLote) {
        var _this = this;
        //this.context.app.hideSpinner();
        this.loteImpresionService.getStatus(idLote)
            .then(function (result) {
            if (result == 'C') {
                _this.loteImpresionService.getFiles(idLote)
                    .then(function (files) {
                    _this.context.app.hideSpinner();
                    var links = [];
                    var Cheques = new core_2.FileLink;
                    Cheques.uri = files[0];
                    Cheques.fileName = files[0];
                    links.push(Cheques);
                    _this.printerService.printTextFile('/file-server/' + files[0]);
                    clearInterval(_this.intervalId);
                });
            }
            /*
            if (result == 'R') {
                this.showAlert('Generando bloque de impresión, el proceso puede tardar varios minutos', 'success');
            }
            */
            if (result == 'E') {
                clearInterval(_this.intervalId);
                _this.context.app.hideSpinner();
                _this.showAlert('Error al obtener el bloque de impresión de cheques', 'success');
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PagosManager.prototype.onSelectedPolizaPerfil = function (item) {
        var _this = this;
        this.context.app.showSpinner();
        this.polizaSvc.loadPolizaByDocumento(this.manager.currentDocument.id, item.id, this.context.app.defaultSite.identity)
            .then(function (result) {
            _this.currentPoliza = result;
            _this.context.app.hideSpinner();
            _this.dlgPolizaViewer.config.backdrop = false;
            _this.dlgPolizaViewer.show();
        }).catch(function (error) { return _this.handleError(error); });
    };
    PagosManager.prototype.onClickGuardar = function () {
        var _this = this;
        this.context.app.showSpinner();
        if (this.currentPoliza.idPolizaOrigen == 0)
            this.currentPoliza.idPolizaOrigen = 1; //Manual
        this.polizaSvc.update(this.currentPoliza)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            _this.dlgPolizaViewer.hide();
            _this.manager.showAlert('La poliza ha sido registrada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var PagosManager_1;
    __decorate([
        core_1.ViewChild('viewDialog'),
        __metadata("design:type", modal_directive_1.ModalDirective)
    ], PagosManager.prototype, "dlgPolizaViewer", void 0);
    __decorate([
        core_1.ViewChild(index_1.PolizaPerfilListComponent),
        __metadata("design:type", index_1.PolizaPerfilListComponent)
    ], PagosManager.prototype, "dlgPolizaPerfil", void 0);
    __decorate([
        core_1.ViewChild(controls_1.DownloadPopupComponent),
        __metadata("design:type", controls_1.DownloadPopupComponent)
    ], PagosManager.prototype, "downloadPopup", void 0);
    PagosManager = PagosManager_1 = __decorate([
        core_1.Component({
            selector: 'tesoreria-pagos-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Pagos</div>\n          <div class=\"card-block\">\n              <azteca-document-manager (searchRequested)=\"onSearchRequested($event)\"\n                                       (addingItem)=\"onAddingItem()\"\n                                       (viewingItem)=\"onViewingItem($event)\"\n                                       (editingItem)=\"onEditingItem($event)\"\n                                       (deletingItem)=\"onDeletingItem($event)\"\n                                       (cloningItem)=\"onCloningItem($event)\"\n                                       (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                       (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                       (configureDocument)=\"onConfigureDocument($event)\"\n                                       (menuItemClick)=\"onMenuItemClick($event)\"\n                                       [enabled]=\"enabled\"\n                                       [allowNew]=\"allowNew\"\n                                       [allowView]=\"allowView\"\n                                       [allowEdit]=\"allowEdit\"\n                                       [allowDelete]=\"allowDelete\"\n                                       [allowClone]=\"allowClone\"\n                                       [allowNext]=\"allowNext\"\n                                       [allowPrevious]=\"allowPrevious\"\n                                       [allowAudit]=\"allowAudit\"\n                                       [filterGroups]=\"filterGroups\"\n                                       [documentList]=\"pagos\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'IMPRIMIR'\" [icon]=\"'glyphicon glyphicon-print'\" [text]=\"'Imprimir cheques de los pagos listados' \" [smallText]=\"'Imprimir cheques de los pagos listados'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'CONTABILIZAR'\" [icon]=\"'glyphicon glyphicon-usd'\" [text]=\"'Contabilizar'\" [smallText]=\"'generar poliza'\"></azteca-menu-item>\n\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"200\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"180\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Tipo Pago'\" [binding]=\"'tipoPagoNombre'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Chequera'\" [binding]=\"'chequera'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Impresiones'\" [binding]=\"'impresiones'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Estatus'\" [binding]=\"'status'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"'10*'\"></azteca-grid-column>\n\n              </azteca-document-manager>\n          </div>\n      </div>\n\n      <download-popup></download-popup>\n\n      <!-- Perfil de poliza para contabilizar la venta -->\n      <accounting-poliza-perfil-list [searchByUser]=\"true\" (selectedItemChanged)=\"onSelectedPolizaPerfil($event)\"></accounting-poliza-perfil-list>\n\n      <!-- Visualizar poliza -->\n      <div bsModal #viewDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\">P&oacute;liza</h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"viewDialog.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <accounting-poliza-viewer [poliza]=\"currentPoliza\"></accounting-poliza-viewer>\n                  </div> <!--Modal Body-->\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-default\" data-dismiss=\"modal\" (click)=\"viewDialog.hide()\">Cancelar</button>\n                      <button type=\"button\" class=\"btn btn-primary\" data-dismiss=\"modal\" (click)=\"onClickGuardar()\">Guardar</button>\n                  </div>\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return PagosManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: pago_service_1.PagoService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, pago_service_1.PagoService, printing_1.LoteImpresionService, printing_1.PrinterService, index_1.PolizaService])
    ], PagosManager);
    return PagosManager;
}(editors_1.DocumentManager));
exports.PagosManager = PagosManager;
