"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var cuenta_por_pagar_detail_1 = require("../../models/cuenta-por-pagar-detail");
var concepto_service_1 = require("../../services/concepto.service");
var impuesto_detail_1 = require("../../../accounting/models/impuesto-detail");
var CuentaPorPagarDetailEditor = /** @class */ (function (_super) {
    __extends(CuentaPorPagarDetailEditor, _super);
    function CuentaPorPagarDetailEditor(context, builder, conceptoService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.builder = builder;
        _this.conceptoService = conceptoService;
        //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
        _this.detailCopy = new cuenta_por_pagar_detail_1.CuentaPorPagarDetail();
        //Objeto original que se editará
        _this.detail = new cuenta_por_pagar_detail_1.CuentaPorPagarDetail();
        _this.form = builder.group({
            'idConcepto': [0, forms_1.Validators.required],
            'cantidad': [0, forms_1.Validators.required],
            'costoUnitario': [0, forms_1.Validators.required],
        });
        return _this;
    }
    /////////////////// METODOS ///////////////////////////////
    /////////////////// HANDLERS //////////////////////////////
    CuentaPorPagarDetailEditor.prototype.onCreatingItem = function () {
        this.detailCopy = this.detail;
        this.form.reset({ sample: '' });
        this.form.markAsPristine();
    };
    CuentaPorPagarDetailEditor.prototype.onLoadingItem = function (detail) {
        this.detailCopy = this.copyItem(this.detail);
    };
    CuentaPorPagarDetailEditor.prototype.onUpdatingItem = function (detail) {
        if (this.detailCopy._clientID == 0) {
            this.detailCopy._clientID = this.createClientID();
        }
        else {
            this.detailCopy.state = editors_1.ChangeState.MODIFIED;
        }
        this.savingItem.emit(this.detailCopy);
    };
    CuentaPorPagarDetailEditor.prototype.onConceptoChanged = function (concepto) {
        var _this = this;
        this.detailCopy.codigoConcepto = concepto.code;
        this.detailCopy.descripcionConcepto = concepto.nombre;
        //this.detailCopy.descuentos = concepto.descuentos;
        this.detailCopy.impuestos = [];
        concepto.impuestos.forEach(function (impuesto) {
            var impto = new impuesto_detail_1.ImpuestoDetailInfo();
            impto.base = 0;
            impto.idImpuesto = impuesto.idImpuesto;
            impto.impuesto = impuesto.impuesto;
            impto.tasaOCuota = impuesto.tasaOCuota;
            impto.tipoAplicacion = impuesto.tipoAplicacion;
            impto.tipoFactor = impuesto.tipoCalculo;
            _this.detailCopy.impuestos.push(impto);
        });
    };
    CuentaPorPagarDetailEditor.prototype.onCantidadChange = function (value) {
        this.detailCopy.importe = this.detailCopy.costoUnitario * value;
    };
    CuentaPorPagarDetailEditor.prototype.onCostoChange = function (costoUnitario) {
        if (costoUnitario > 0 && this.detailCopy) { //&& this.detailCopy.servicio.libre) {
            this.detailCopy.impuestos.forEach(function (impuesto) {
                impuesto.base = costoUnitario;
            });
            //this.trasladosCollection.refresh();
            //this.retencionesCollection.refresh();
        }
        var costo = this.conceptoService.calcularCostoLibre(costoUnitario, false, this.detailCopy.impuestos);
        this.detailCopy.costoUnitario = costo.costoBase;
        this.detailCopy.importe = costo.costoBase * this.detailCopy.cantidad;
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", cuenta_por_pagar_detail_1.CuentaPorPagarDetail)
    ], CuentaPorPagarDetailEditor.prototype, "detail", void 0);
    CuentaPorPagarDetailEditor = __decorate([
        core_1.Component({
            selector: 'tesoreria-cuenta-por-pagar-detail-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <azteca-basic-editor [item]=\"detail\"\n                               [dirty]=\"dirty\"\n                               [valid]=\"valid\"\n                               (creatingItem)=\"onCreatingItem()\"\n                               (loadingItem)=\"onLoadingItem($event)\"\n                               (updatingItem)=\"onUpdatingItem($event)\">\n\n\n\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <azteca-form-field [label]=\"'Concepto:'\">\n                          <treasury-concepto-selector formControlName=\"idConcepto\"\n                                                      [(ngModel)]=\"detailCopy.idConcepto\"\n                                                      (selectedItemChanged)=\"onConceptoChanged($event)\">\n                          </treasury-concepto-selector>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-4\">\n                      <azteca-form-field [label]=\"'Cantidad:'\">\n                          <az-input-number formControlName=\"cantidad\"\n                                           [(ngModel)]=\"detailCopy.cantidad\"\n                                           (valueChange)=\"onCantidadChange($event)\">\n                          </az-input-number>\n                      </azteca-form-field>\n                  </div>\n\n                  <div class=\"col-12 col-md-4\">\n                      <azteca-form-field [label]=\"'Costo unitario:'\">\n                          <az-input-number formControlName=\"costoUnitario\"\n                                           [value]=\"detailCopy.costoUnitario\"\n                                           [min]=\"0\"\n                                           format=\"c\"\n                                           (valueChange)=\"onCostoChange($event)\">\n                                          <!--[enabled]=\"detailCopy.servicio.libre\"-->\n                          </az-input-number>\n                      </azteca-form-field>\n                  </div>\n\n              </div>\n\n          </azteca-basic-editor>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, concepto_service_1.ConceptoService])
    ], CuentaPorPagarDetailEditor);
    return CuentaPorPagarDetailEditor;
}(editors_1.BasicEditor));
exports.CuentaPorPagarDetailEditor = CuentaPorPagarDetailEditor;
