"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var moment = require("moment");
//Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var pago_detail_1 = require("../../models/pago-detail");
var pago_service_1 = require("../../services/pago.service");
var PagoDetailEditor = /** @class */ (function (_super) {
    __extends(PagoDetailEditor, _super);
    function PagoDetailEditor(context, builder, pagoService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.builder = builder;
        _this.pagoService = pagoService;
        //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
        _this.detailCopy = new pago_detail_1.PagoDetail();
        //Objeto original que se editará
        _this.detail = new pago_detail_1.PagoDetail();
        _this.idBeneficiario = 0;
        _this.idDivisa = 0;
        _this.dataLoaded = new core_1.EventEmitter();
        _this.fechasFiltro = [];
        _this.fechaSearch = 'G';
        _this.form = builder.group({
            'fechaBusqueda': ['', forms_1.Validators.required],
            'fechaIni': [new Date()],
            'fechaFin': [new Date()],
        });
        _this.fechasFiltro =
            [
                { "id": "G", "nombre": "Generación" },
                { "id": "V", "nombre": "Vencimiento" }
            ];
        _this.fechaSearch = "G";
        _this.fechaIni = moment().subtract(3, 'months').toDate();
        _this.fechaFin = moment().add(2, 'week').toDate();
        return _this;
    }
    /////////////////// METODOS ///////////////////////////////
    /////////////////// HANDLERS //////////////////////////////
    PagoDetailEditor.prototype.onCreatingItem = function () {
        this.detailCopy = this.detail;
        //this.form.reset({ sample: '' });
        this.form.markAsPristine();
    };
    PagoDetailEditor.prototype.onLoadingItem = function (detail) {
        this.detailCopy = this.copyItem(this.detail);
    };
    PagoDetailEditor.prototype.onUpdatingItem = function (detail) {
        /*
        if (this.detailCopy._clientID == 0) {
            this.detailCopy._clientID = this.createClientID();
        }
        else {
            this.detailCopy.state = ChangeState.MODIFIED;
        }
        this.savingItem.emit(this.detailCopy);
        */
        this.loadCxPbyBeneficiario();
    };
    PagoDetailEditor.prototype.loadCxPbyBeneficiario = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.pagoService.loadCxPByBeneficiario(moment(this.fechaIni).format(), moment(this.fechaFin).format(), this.idBeneficiario, this.fechaSearch, this.idDivisa, this.context.app.defaultSite.identity)
            .then(function (cxc) {
            _this.context.app.hideSpinner();
            //this.details = cxc;
            _this.dataLoaded.emit(cxc);
        })
            .catch(function (error) { return _this.showAlert(error.message, 'danger'); });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", pago_detail_1.PagoDetail)
    ], PagoDetailEditor.prototype, "detail", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], PagoDetailEditor.prototype, "idBeneficiario", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], PagoDetailEditor.prototype, "idDivisa", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], PagoDetailEditor.prototype, "dataLoaded", void 0);
    PagoDetailEditor = __decorate([
        core_1.Component({
            selector: 'tesoreria-pago-detail-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <azteca-basic-editor [item]=\"detail\"\n                               [dirty]=\"dirty\"\n                               [valid]=\"valid\"\n                               (creatingItem)=\"onCreatingItem()\"\n                               (loadingItem)=\"onLoadingItem($event)\"\n                               (updatingItem)=\"onUpdatingItem($event)\">\n\n              <az-panel [header]=\"'Rango de Fechas'\">\n                  <div class=\"row\">\n                      <div class=\"col-12 col-md-6\">\n                          <azteca-form-field [label]=\"'Filtra por la fecha de:'\">\n                              <az-combobox #cboRango\n                                           formControlName=\"fechaBusqueda\"\n                                           [(ngModel)]=\"fechaSearch\"\n                                           [items]=\"fechasFiltro\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'id'\">\n                              </az-combobox>\n                          </azteca-form-field>\n                      </div>\n                  </div>\n\n                  <div class=\"row\">\n                      <div class=\"col-12 col-md-6\">\n                          <azteca-form-field [label]=\"'Fecha Inicial:'\">\n                              <az-input-date-time [(ngModel)]=\"fechaIni\" formControlName=\"fechaIni\" format='dd-MM-yyyy'></az-input-date-time>\n                          </azteca-form-field>\n                      </div>\n\n                      <div class=\"col-12 col-md-6\">\n                          <azteca-form-field [label]=\"'Fecha Final:'\">\n                              <az-input-date-time [(ngModel)]=\"fechaFin\" formControlName=\"fechaFin\" format='dd-MM-yyyy'></az-input-date-time>\n                          </azteca-form-field>\n                      </div>\n                  </div>\n              </az-panel>\n\n\n          </azteca-basic-editor>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, pago_service_1.PagoService])
    ], PagoDetailEditor);
    return PagoDetailEditor;
}(editors_1.BasicEditor));
exports.PagoDetailEditor = PagoDetailEditor;
