"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
//Azteca Kernel
var core_2 = require("framework3/core");
//Locales
var concepto_1 = require("../models/concepto");
var costo_1 = require("../models/costo");
var accounting_1 = require("../../accounting");
var ConceptoService = /** @class */ (function (_super) {
    __extends(ConceptoService, _super);
    function ConceptoService(http, context) {
        return _super.call(this, http, context, 'api/tesoreria/conceptos') || this;
    }
    ConceptoService.prototype.create = function () {
        return Promise.resolve(new concepto_1.ConceptoInfo());
    };
    ConceptoService.prototype.calcularCostoLibre = function (costoBase, impuestosIncluidos, impuestos) {
        var costo = new costo_1.CostoInfo();
        if (impuestosIncluidos) {
            costo.costoBase = this.calcularCostoBase(costoBase, impuestos);
        }
        else {
            costo.costoBase = costoBase;
        }
        //Recalcular importes de impuestos
        impuestos.forEach(function (impuesto) {
            impuesto.importe = impuesto.base * impuesto.tasaOCuota;
        });
        costo.impuestos = impuestos;
        //
        var totalTraslados = 0;
        impuestos.filter(function (i) { return i.tipoAplicacion == accounting_1.TipoAplicacion.TRASLADO; }).forEach(function (i) { return totalTraslados += i.importe; });
        //
        var totalRetenciones = 0;
        impuestos.filter(function (i) { return i.tipoAplicacion == accounting_1.TipoAplicacion.RETENCION; }).forEach(function (i) { return totalRetenciones += i.importe; });
        //
        costo.costoNeto = costo.costoBase + totalTraslados - totalRetenciones;
        return costo;
    };
    ConceptoService.prototype.calcularCostoBase = function (costoNeto, impuestos) {
        //Sumar las tasas de traslado
        var tasasTraslados = 0;
        impuestos.filter(function (i) { return i.tipoAplicacion == accounting_1.TipoAplicacion.TRASLADO && i.tipoFactor == accounting_1.TipoFactor.TASA; }).forEach(function (i) { return tasasTraslados += i.tasaOCuota; });
        //Sumar las cuotas de traslado
        var cuotasTraslados = 0;
        impuestos.filter(function (i) { return i.tipoAplicacion == accounting_1.TipoAplicacion.TRASLADO && i.tipoFactor == accounting_1.TipoFactor.CUOTA; }).forEach(function (i) { return cuotasTraslados += i.tasaOCuota * i.base; });
        //Sumar las tasas de las retenciones
        var tasasRetenciones = 0;
        impuestos.filter(function (i) { return i.tipoAplicacion == accounting_1.TipoAplicacion.RETENCION && i.tipoFactor == accounting_1.TipoFactor.TASA; }).forEach(function (i) { return tasasRetenciones += i.tasaOCuota; });
        //Sumar las cuotas de las retenciones
        var cuotasRetenciones = 0;
        impuestos.filter(function (i) { return i.tipoAplicacion == accounting_1.TipoAplicacion.RETENCION && i.tipoFactor == accounting_1.TipoFactor.CUOTA; }).forEach(function (i) { return cuotasRetenciones += i.tasaOCuota * i.base; });
        var costoBase = (costoNeto - cuotasTraslados + cuotasRetenciones) / (1 + (tasasTraslados - tasasRetenciones));
        return Math.round(costoBase * 100) / 100;
    };
    ConceptoService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], ConceptoService);
    return ConceptoService;
}(core_2.CatalogService));
exports.ConceptoService = ConceptoService;
