import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, DocumentService } from 'framework3/core';
import { EstadoCuentaBancarioInfo } from '../models/estado-cuenta-bancario';
import { EstadoCuentaBancarioDetail } from '../models/estado-cuenta-bancario-detail';
import { EstadoCuentaBancarioFormatoInfo } from '../models/estado-cuenta-bancario-formato';
import { EstadoCuentaBancarioConciliarItem } from '../models/estado-cuenta-bancario-conciliar-item';
import { AsyncTaskInfo } from 'framework3/queue/models/async-task';
export declare class EstadoCuentaBancarioService extends DocumentService<EstadoCuentaBancarioDetail, EstadoCuentaBancarioInfo> {
    protected http: HttpClient;
    protected context: Context;
    constructor(http: HttpClient, context: Context);
    create(): Promise<EstadoCuentaBancarioInfo>;
    encolarTranspiler(estadoCuentaFormato: EstadoCuentaBancarioFormatoInfo): Promise<any>;
    getTranspilerStatus(idLote: number): Promise<any>;
    conciliarIngresos(idEstadoCuenta: string, origen: string): Promise<EstadoCuentaBancarioConciliarItem[]>;
    conciliarIngresosSet(conciliado: EstadoCuentaBancarioConciliarItem[]): Promise<boolean>;
    asyncConciliarIngresos(idEstadoCuenta: string, origen: string, cuenta: string): Promise<AsyncTaskInfo>;
    toPdf(idEstadoCuenta: string, saldoEmpresa: number, saldoEstadoCuentaBancario: number): Promise<any>;
}
