"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
//Azteca Framework
var core_2 = require("framework3/core");
//Locales
var estado_cuenta_bancario_1 = require("../models/estado-cuenta-bancario");
var EstadoCuentaBancarioService = /** @class */ (function (_super) {
    __extends(EstadoCuentaBancarioService, _super);
    function EstadoCuentaBancarioService(http, context) {
        var _this = _super.call(this, http, context, 'api/tesoreria/estados-cuenta-bancarios') || this;
        _this.http = http;
        _this.context = context;
        return _this;
    }
    EstadoCuentaBancarioService.prototype.create = function () {
        var newDoc = new estado_cuenta_bancario_1.EstadoCuentaBancarioInfo();
        return Promise.resolve(newDoc);
    };
    EstadoCuentaBancarioService.prototype.encolarTranspiler = function (estadoCuentaFormato) {
        var params = new http_1.HttpParams();
        return this.apiService.post('encolar-transpiler', params, estadoCuentaFormato)
            .toPromise();
    };
    EstadoCuentaBancarioService.prototype.getTranspilerStatus = function (idLote) {
        var params = new http_1.HttpParams()
            .set("idLote", idLote.toString());
        return this.apiService.post("transpiler-status", params)
            .toPromise();
    };
    EstadoCuentaBancarioService.prototype.conciliarIngresos = function (idEstadoCuenta, origen) {
        var params = new http_1.HttpParams()
            .set('idEstadoCuenta', idEstadoCuenta)
            .set('origen', origen);
        return this.apiService.get('conciliar-ingresos', params)
            .toPromise();
    };
    EstadoCuentaBancarioService.prototype.conciliarIngresosSet = function (conciliado) {
        var params = new http_1.HttpParams();
        return this.apiService.post('conciliar-ingresos-set', params, conciliado)
            .toPromise();
    };
    EstadoCuentaBancarioService.prototype.asyncConciliarIngresos = function (idEstadoCuenta, origen, cuenta) {
        var params = new http_1.HttpParams()
            .set('idEstadoCuenta', idEstadoCuenta)
            .set('origen', origen)
            .set('cuenta', cuenta);
        return this.apiService.get('get-async-conciliar-ingresos', params)
            .toPromise();
    };
    EstadoCuentaBancarioService.prototype.toPdf = function (idEstadoCuenta, saldoEmpresa, saldoEstadoCuentaBancario) {
        var params = new http_1.HttpParams()
            .set('idEstadoCuenta', idEstadoCuenta)
            .set('saldoEmpresa', saldoEmpresa.toString())
            .set('saldoEstadoCuentaBancario', saldoEstadoCuentaBancario.toString());
        return this.apiService.post("to-pdf", params).toPromise();
    };
    EstadoCuentaBancarioService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], EstadoCuentaBancarioService);
    return EstadoCuentaBancarioService;
}(core_2.DocumentService));
exports.EstadoCuentaBancarioService = EstadoCuentaBancarioService;
