"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//////////////////////////// Guards //////////////////////////////////
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//////////////////////////// Catalogos ////////////////////////////////
var beneficiarios_manager_1 = require("./catalogs/beneficiarios.manager");
var beneficiarios_editor_1 = require("./catalogs/beneficiarios.editor");
var grupos_beneficiario_manager_1 = require("./catalogs/grupos-beneficiario.manager");
var grupos_beneficiario_editor_1 = require("./catalogs/grupos-beneficiario.editor");
var cajas_manager_1 = require("./catalogs/cajas.manager");
var cajas_editor_1 = require("./catalogs/cajas.editor");
var chequeras_manager_1 = require("./catalogs/chequeras.manager");
var chequeras_editor_1 = require("./catalogs/chequeras.editor");
var pagos_tipo_manager_1 = require("./catalogs/pagos-tipo.manager");
var pagos_tipo_editor_1 = require("./catalogs/pagos-tipo.editor");
var operaciones_tipos_manager_1 = require("./catalogs/operaciones-tipos.manager");
var operaciones_tipos_editor_1 = require("./catalogs/operaciones-tipos.editor");
var empresas_manager_1 = require("./catalogs/empresas.manager");
var empresas_editor_1 = require("./catalogs/empresas.editor");
var sucursales_manager_1 = require("./catalogs/sucursales.manager");
var sucursales_editor_1 = require("./catalogs/sucursales.editor");
///////////////////////////// Document /////////////////////////////////
var contrarecibos_tit_manager_1 = require("./documents/contrarecibos-tit.manager");
var contrarecibos_tit_editor_1 = require("./documents/contrarecibos-tit.editor");
var cuentas_por_pagar_manager_1 = require("./documents/cuentas-por-pagar.manager");
var cuentas_por_pagar_editor_1 = require("./documents/cuentas-por-pagar.editor");
var pagos_manager_1 = require("./documents/pagos.manager");
var pagos_editor_1 = require("./documents/pagos.editor");
var estados_cuenta_bancarios_manager_1 = require("./documents/estados-cuenta-bancarios.manager");
var estados_cuenta_bancarios_editor_1 = require("./documents/estados-cuenta-bancarios.editor");
//Parts//
var caja_miembros_component_1 = require("./parts/caja-miembros.component");
var operaciones_tipos_miembros_component_1 = require("./parts/operaciones-tipos-miembros.component");
///////////////////////////// Rutas /////////////////////////////////
/////////////////////////////  Componentes //////////////////////////////
var fromCatalogs = require("./catalogs");
var fromDocuments = require("./documents");
var routes = [
    {
        path: '',
        canActivateChild: [core_2.AuthGuard],
        children: [
            //CATALOGS
            { path: 'beneficiarios/:proceso', component: beneficiarios_manager_1.BeneficiariosManager },
            { path: 'beneficiarios/:proceso/:id', component: beneficiarios_editor_1.BeneficiariosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'grupo-beneficiarios/:proceso', component: grupos_beneficiario_manager_1.GruposBeneficiarioManager },
            { path: 'grupo-beneficiarios/:proceso/:id', component: grupos_beneficiario_editor_1.GruposBeneficiarioEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'cajas/:proceso', component: cajas_manager_1.CajasManager },
            { path: 'cajas/:proceso/:id', component: cajas_editor_1.CajasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'cajas/:proceso/:id/members', component: caja_miembros_component_1.CajaMiembrosComponent },
            { path: 'chequeras/:proceso', component: chequeras_manager_1.ChequerasManager },
            { path: 'chequeras/:proceso/:id', component: chequeras_editor_1.ChequerasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'pagos-tipo/:proceso', component: pagos_tipo_manager_1.PagosTipoManager },
            { path: 'pagos-tipo/:proceso/:id', component: pagos_tipo_editor_1.PagosTipoEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'operaciones-tipo/:proceso', component: operaciones_tipos_manager_1.OperacionesTiposManager },
            { path: 'operaciones-tipo/:proceso/:id', component: operaciones_tipos_editor_1.OperacionesTiposEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'operaciones-tipo/:proceso/:id/members', component: operaciones_tipos_miembros_component_1.OperacionesTiposMiembrosComponent },
            { path: 'conceptos/:proceso', component: fromCatalogs.ConceptosManager },
            { path: 'conceptos/:proceso/:id', component: fromCatalogs.ConceptosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'empresas-tesoreria/:proceso', component: empresas_manager_1.EmpresasManager },
            { path: 'empresas-tesoreria/:proceso/:id', component: empresas_editor_1.EmpresasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'sucursales-tesoreria/:proceso', component: sucursales_manager_1.SucursalesManager },
            { path: 'sucursales-tesoreria/:proceso/:idEmpresa/:id', component: sucursales_editor_1.SucursalesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            //DOCUMENTS
            { path: 'cuentas-por-pagar/:proceso', component: cuentas_por_pagar_manager_1.CuentasPorPagarManager },
            { path: 'cuentas-por-pagar/:proceso/:id', component: cuentas_por_pagar_editor_1.CuentasPorPagarEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            //DOCUMENTS
            { path: 'contra-recibo/:proceso', component: contrarecibos_tit_manager_1.ContrarecibosTitManager },
            { path: 'contra-recibo/:proceso/:id', component: contrarecibos_tit_editor_1.ContrarecibosTitEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'pagos/:proceso', component: pagos_manager_1.PagosManager },
            { path: 'pagos/:proceso/:id', component: pagos_editor_1.PagosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'estados-cuenta-bancarios/:proceso', component: estados_cuenta_bancarios_manager_1.EstadosCuentaBancariosManager },
            { path: 'estados-cuenta-bancarios/:proceso/:id', component: estados_cuenta_bancarios_editor_1.EstadosCuentaBancariosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'estados-cuenta-bancarios-conciliar/:proceso/:idEstadoCuenta', component: fromDocuments.EstadoCuentaBancarioConciliar }
        ]
    },
];
var TreasuryRoutingModule = /** @class */ (function () {
    function TreasuryRoutingModule() {
    }
    TreasuryRoutingModule = __decorate([
        core_1.NgModule({
            imports: [
                router_1.RouterModule.forChild(routes)
            ],
            exports: [
                router_1.RouterModule
            ]
        })
    ], TreasuryRoutingModule);
    return TreasuryRoutingModule;
}());
exports.TreasuryRoutingModule = TreasuryRoutingModule;
