﻿var gulp = require('gulp'),
    gp_clean = require('gulp-clean'),
    gp_concat = require('gulp-concat'),
    gp_sourcemaps = require('gulp-sourcemaps'),
    gp_typescript = require('gulp-typescript'),
    gp_uglify = require('gulp-uglify'),
    gp_inlineNg2Template = require('gulp-inline-ng2-template'),
    gp_import_css = require('gulp-import-css');

/// Define paths
var srcPaths = {
    accounting: ['src/app/accounting/**/*.ts'],
    credit: ['src/app/credit/**/*.ts'],    
    rh: ['src/app/rh/**/*.ts'],    
    treasury: ['src/app/treasury/**/*.ts'],
    inventory: ['src/app/inventory/**/*.ts'],
    purchasing: ['src/app/purchasing/**/*.ts'],
    sales: ['src/app/sales/**/*.ts']
};

var destPaths = {
    accounting: 'build/accounting',
    credit: 'build/credit',    
    rh: 'build/rh',    
    treasury: 'build/treasury',
    inventory: 'build/inventory',
    purchasing: 'build/purchasing',
    sales: 'build/sales'
};

//Compilar cada uno de los módulos

////////// ACCOUNTING

gulp.task('accounting', ['accounting_clean'], function () {
    return gulp.src(srcPaths.accounting)
        .pipe(gp_inlineNg2Template({ base: '/src/app/accounting', useRelativePaths: true }))
        .pipe(gp_typescript(require('./tsconfig-gulp.json').compilerOptions))
        //.pipe(gp_uglify({ mangle: false }))
        .pipe(gulp.dest(destPaths.accounting));
});

gulp.task('accounting_clean', function () {
    return gulp.src(destPaths.accounting + "*.*", { read: false })
        .pipe(gp_clean({ force: true }));
});


////////// CREDIT

gulp.task('credit', ['credit_clean'], function () {
    return gulp.src(srcPaths.credit)
        .pipe(gp_inlineNg2Template({ base: '/src/app/credit', useRelativePaths: true }))
        .pipe(gp_typescript(require('./tsconfig-gulp.json').compilerOptions))
        //.pipe(gp_uglify({ mangle: false }))
        .pipe(gulp.dest(destPaths.credit));
});

gulp.task('credit_clean', function () {
    return gulp.src(destPaths.credit + "*.*", { read: false })
        .pipe(gp_clean({ force: true }));
});

////////// RH

gulp.task('rh', ['rh_clean'], function () {
    return gulp.src(srcPaths.rh)
        .pipe(gp_inlineNg2Template({ base: '/src/app/rh', useRelativePaths: true }))
        .pipe(gp_typescript(require('./tsconfig-gulp.json').compilerOptions))
        //.pipe(gp_uglify({ mangle: false }))
        .pipe(gulp.dest(destPaths.rh));
});

gulp.task('rh_clean', function () {
    return gulp.src(destPaths.rh + "*.*", { read: false })
        .pipe(gp_clean({ force: true }));
});


////////// TESORERIA

gulp.task('treasury', ['treasury_clean'], function () {
    return gulp.src(srcPaths.treasury)
        .pipe(gp_inlineNg2Template({ base: '/src/app/treasury', useRelativePaths: true }))
        .pipe(gp_typescript(require('./tsconfig-gulp.json').compilerOptions))
        //.pipe(gp_uglify({ mangle: false }))
        .pipe(gulp.dest(destPaths.treasury));
});

gulp.task('treasury_clean', function () {
    return gulp.src(destPaths.treasury + "*.*", { read: false })
        .pipe(gp_clean({ force: true }));
});

////////// INVENTORY

gulp.task('inventory', ['inventory_clean'], function () {
    return gulp.src(srcPaths.inventory)
        .pipe(gp_inlineNg2Template({ base: '/src/app/inventory', useRelativePaths: true }))
        .pipe(gp_typescript(require('./tsconfig-gulp.json').compilerOptions))
        //.pipe(gp_uglify({ mangle: false }))
        .pipe(gulp.dest(destPaths.inventory));
});

gulp.task('inventory_clean', function () {
    return gulp.src(destPaths.inventory + "*.*", { read: false })
        .pipe(gp_clean({ force: true }));
});



////////// PURCHASING

gulp.task('purchasing', ['purchasing_clean'], function () {
    return gulp.src(srcPaths.purchasing)
        .pipe(gp_inlineNg2Template({ base: '/src/app/purchasing', useRelativePaths: true }))
        .pipe(gp_typescript(require('./tsconfig-gulp.json').compilerOptions))
        //.pipe(gp_uglify({ mangle: false }))
        .pipe(gulp.dest(destPaths.purchasing));
});

gulp.task('purchasing_clean', function () {
    return gulp.src(destPaths.purchasing + "*.*", { read: false })
        .pipe(gp_clean({ force: true }));
});

////////// SALES

gulp.task('sales', ['sales_clean'], function () {
    return gulp.src(srcPaths.sales)
        .pipe(gp_inlineNg2Template({ base: '/src/app/sales', useRelativePaths: true }))
        .pipe(gp_typescript(require('./tsconfig-gulp.json').compilerOptions))
        //.pipe(gp_uglify({ mangle: false }))
        .pipe(gulp.dest(destPaths.sales));
});

gulp.task('sales_clean', function () {
    return gulp.src(destPaths.sales + "*.*", { read: false })
        .pipe(gp_clean({ force: true }));
});


// Global cleanup task
gulp.task('cleanup', ['accounting_clean', 'credit_clean', 'rh_clean', 'treasury_clean', 'inventory_clean', 'purchasing_clean', 'sales_clean']);

// Define the default task so it will launch all other tasks
gulp.task('default', ['accounting', 'credit', 'rh', 'treasury', 'inventory', 'purchasing', 'sales']);

