﻿import { NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
//Modulos Azteca
import { CoreModule } from 'framework3/core';
import { EditorsModule } from 'framework3/editors';
import { SearchModule } from 'framework3/search';
import { GeneralModule } from 'framework3/general';
import { ControlsModule } from 'framework3/controls';
import { SecurityModule } from 'framework3/security';
import { NotificationModule } from 'framework3/notification';
import { AccountingRoutingModule } from './accounting.routing.module';
import { PrintingModule } from 'framework3/printing/printing.module';
import { QueueModule } from 'framework3/queue';

//Bootstrap
import { TabsModule, ModalModule } from 'ngx-bootstrap';
//Wijmo
import { WjCoreModule } from 'wijmo/wijmo.angular2.core';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';

//Tree
import { TreeModule } from 'angular-tree-component';

/////////////////////////////// Servicios ////////////////////////////
import { EjercicioService } from './services/ejercicio.service';
import { PeriodoService } from './services/periodo.service';
import { CategoriaUnidadesMedidaService } from './services/categoria-unidades-medida.service';
import { CategoriaArticulosService } from './services/categoria-articulos.service';
import { DivisaService } from './services/divisa.service';
import { PACService } from './services/pac.service';
import { ContribuyenteService } from './services/contribuyente.service';
import { EmpresaService } from './services/empresa.service';
import { SucursalService } from './services/sucursal.service';
import { FlujoService } from './services/flujo.service';
import { CuentaService } from './services/cuenta.service';
import { ImpuestoService } from './services/impuesto.service';
import { RetencionService } from './services/retencion.service';
import { CFDCertificadoService } from './services/cfd-certificado.service';
import { SerieFiscalService } from './services/serie-fiscal.service';
import { MetodoPagoService } from './services/metodo-pago.service';
import { PolizaService } from './services/poliza.service';
import { SegmentoNegocioService } from './services/segmento-negocio.service';
import { ComprobanteService } from './services/comprobante.service';
import { ComprobanteFiscalService } from './services/comprobante-fiscal.service';
import { NotaConceptoService } from './services/nota-concepto.service';
import { BancoService } from './services/banco.service';
import { CuentaBancariaService } from './services/cuenta-bancaria.service';
import { NotaService } from './services/nota.service';
import { FormaPagoService } from './services/forma-pago.service';
import { AddendaService } from './services/addenda.service';
import { FichaService } from './services/ficha.service';
import { PlantillaComprobanteService } from './services/plantilla-comprobante.service';
import { CancelacionService } from './services/cancelacion.service';
import { ComprobanteCancelacionService } from './services/comprobante-cancelacion.service';
import { PolizaPerfilService } from './services/poliza-perfil.service';
import { RiesgoPuestoService } from './services/riesgo-puesto.service';
import { JornadaService } from './services/jornada.service';
import { ListaNegraService } from './services/lista-negra.service';
import { TipoRegimenService } from './services/tipo-regimen.service';
import { PeriodoPagoService } from './services/periodo-pago.service';
import { TipoContratoService } from './services/tipo-contrato.service';
import { EjercicioTipoService } from './services/ejercicio-tipo.service';
import { EsquemaService } from './services/esquema.service';
import { MapaDistribucionService } from './services/mapa-distribucion.service';

//////////////////////////// Catalogos ////////////////////////////////
import { CategoriasArticulosManager } from './catalogs/categorias-articulos.manager';
import { CategoriasArticulosEditor } from './catalogs/categorias-articulos.editor';
import { CategoriasUnidadesMedidaManager } from './catalogs/categorias-unidades-medida.manager';
import { CategoriasUnidadesMedidaEditor } from './catalogs/categorias-unidades-medida.editor';
import { DivisasManager } from './catalogs/divisas.manager';
import { DivisasEditor } from './catalogs/divisas.editor';
import { PACsManager } from './catalogs/pacs.manager';
import { PACsEditor } from './catalogs/pacs.editor';
import { ContribuyentesManager } from './catalogs/contribuyentes.manager';
import { ContribuyentesEditor } from './catalogs/contribuyentes.editor';
import { EmpresasManager } from './catalogs/empresas.manager';
import { EmpresasEditor } from './catalogs/empresas.editor';
import { SucursalesManager } from './catalogs/sucursales.manager';
import { SucursalesEditor } from './catalogs/sucursales.editor';
import { FlujoManager } from './catalogs/flujo.manager';
import { CuentasManager } from './catalogs/cuentas.manager';
import { ImpuestosManager } from './catalogs/impuestos.manager';
import { ImpuestosEditor } from './catalogs/impuestos.editor';
import { RetencionesManager } from './catalogs/retenciones.manager';
import { RetencionesEditor } from './catalogs/retenciones.editor';
import { CFDCertificadosManager } from './catalogs/cfdcertificados.manager';
import { CFDCertificadosEditor } from './catalogs/cfdcertificados.editor';
import { CFDSeriesManager } from './catalogs/cfdseries.manager';
import { CFDSeriesEditor } from './catalogs/cfdseries.editor';
import { MetodosPagoManager } from './catalogs/metodos-pago.manager';
import { MetodosPagoEditor } from './catalogs/metodos-pago.editor';
import { SegmentosNegocioEditor } from './catalogs/segmentos-negocio.editor';
import { SegmentosNegocioManager } from './catalogs/segmentos-negocio.manager';
import { BancosManager } from './catalogs/bancos.manager';
import { BancosEditor } from './catalogs/bancos.editor';
import { CuentasBancariasManager } from './catalogs/cuentas-bancarias.manager';
import { CuentasBancariasEditor } from './catalogs/cuentas-bancarias.editor';
import { NotasConceptosEditor } from './catalogs/notas-conceptos.editor';
import { NotasConceptosManager } from './catalogs/notas-conceptos.manager';
import { AddendasEditor } from './catalogs/addendas.editor';
import { AddendasManager } from './catalogs/addendas.manager';
import { PlantillasComprobantesEditor } from './catalogs/plantillas-comprobantes.editor';
import { PlantillasComprobantesManager } from './catalogs/plantillas-comprobantes.manager';
import { RiesgosPuestosEditor } from './catalogs/riesgos-puestos.editor';
import { RiesgosPuestosManager } from './catalogs/riesgos-puestos.manager';
import { JornadasEditor } from './catalogs/jornadas.editor';
import { JornadasManager } from './catalogs/jornadas.manager';
import { TiposRegimenesEditor } from './catalogs/tipos-regimenes.editor';
import { TiposRegimenesManager } from './catalogs/tipos-regimenes.manager';
import { PeriodosPagosEditor } from './catalogs/periodos-pagos.editor';
import { PeriodosPagosManager } from './catalogs/periodos-pagos.manager';
import { TiposContratosEditor } from './catalogs/tipos-contratos.editor';
import { TiposContratosManager } from './catalogs/tipos-contratos.manager';
import { ListaNegraManager } from './catalogs/lista-negra.manager';
import { ListaNegraEditor } from './catalogs/lista-negra.editor';
import { EjerciciosTiposEditor } from './catalogs/ejercicios-tipos.editor';
import { EjerciciosTiposManager } from './catalogs/ejercicios-tipos.manager';
import { EsquemasEditor } from './catalogs/esquemas.editor';
import { EsquemasManager } from './catalogs/esquemas.manager';
import { MapasDistribucionesEditor } from './catalogs/mapas-distribuciones.editor';
import { MapasDistribucionesManager } from './catalogs/mapas-distribuciones.manager';

//////////////////////////// Mantenimientos ////////////////////////////////
import { ComprobanteMaintenance } from './maintenances/comprobante.maintenance';
import { IepsArchivoGenerador } from './maintenances/ieps-archivo-generador.maintenance';
import { AdmonCancelacion } from './maintenances/admon-cancelacion.maintenance';


//////////////////////////// Componentes /////////////////////////////
import { CuentaSelectorComponent } from './components/cuenta-selector.component';
import { FlujoSelectorComponent } from './components/flujo-selector.component';
import { ImpuestosAsignacionEditor } from './components/impuesto-asignacion.editor';
import { RetencionAsignacionEditor } from './components/retencion-asignacion.editor';
import { BancoSelectorComponent } from './components/banco-selector.component';
import { NotaConceptoSelectorComponent } from './components/nota-concepto-selector.component';
import { TipoCambioComponent } from './components/tipos-cambio.component';
import { TipoCambioEditorComponent } from './components/tipos-cambio-editor.component';
import { ComprobantesCorreoEditor } from './components/comprobante-correo.editor';
import { CuentaBancariaMiembrosComponent } from './components/cuenta-bancaria-miembros.component';
import { ImportesComponent } from './controls/importes.component';
import { ComprobantesListComponent} from './components/comprobantes-dialog.component';
import { MapaDistribucionCodeEditor } from './components/mapa-distribucion-code.editor';

///////////////////////////// Controls /////////////////////////////////
import { CuentasAutocompleteCellComponent } from './controls/cuenta-autocomplete-cell.component';
import { ArticuloCategoriaFiscalComponent } from './controls/articulo-categoria-fiscal-selector.component';
import { UnidadMedidaCategoriaFiscalComponent } from './controls/unidad-categoria-fiscal-selector.component';
import { ContribuyenteSelectorComponent } from './controls/contribuyente-selector.component';
import { ImpuestosSelectorComponent } from './controls/impuestos-selector.component';
import { RetencionesSelectorComponent } from './controls/retenciones-selector.component';
import { DivisasSelectorComponent } from './controls/divisas-selector.component';
import { ComprobanteFiscalSelectorComponent } from './controls/comprobante-fiscal-selector.component';
import { PeriodosSelectorComponent } from './controls/periodos-selector.component';
import { EsquemaSelectorComponent } from './controls/esquema-selector.component';

///////////////////////////// Documents /////////////////////////////////
import { EjerciciosManager } from './documents/ejercicios.manager';
import { EjerciciosEditor } from './documents/ejercicios.editor';

import { PeriodosManager } from './documents/periodos.manager';
import { PeriodosEditor } from './documents/periodos.editor';

import { PolizasEditor } from './documents/polizas.editor';
import { PolizasManager } from './documents/polizas.manager';
import { PolizasByLoteEditor } from './documents/parts/polizas-by-lote.editor';

import { ComprobantesManager } from './documents/comprobantes.manager';
import { ComprobanteFiscalDetailEditor } from './documents/parts/comprobantes-detail.editor';
import { ComprobantesLoaderComponent } from './documents/comprobantes.loader';

import { NotasManager } from './documents/notas.manager';
import { NotasEditor } from './documents/notas.editor';
import { NotaDetailEditor } from './documents/parts/notas-detail.editor';

import { FichasManager } from './documents/fichas.manager';
import { FichasEditor } from './documents/fichas.editor';
import { FichaDetailEditor } from './documents/parts/fichas-detail.editor';
//
import { ComprobanteSearch } from './documents/parts/comprobante-search.component';
//
import { ComprobantesCancelacionesManager } from './documents/comprobantes-cancelaciones.manager';
import { ComprobantesCancelacionesEditor } from './documents/comprobantes-cancelaciones.editor';


//////////////////////////// Parts /////////////////////////////////////
import { PolizaDetailEditor } from './documents/parts/polizas-detail.editor';
import { PolizasLogComponent } from './documents/parts/polizas-log.component';
import { PolizasAsociacionesComponent } from './documents/parts/polizas-asociaciones.component';
import { ComprobanteViewerComponent } from './documents/parts/comprobante-viewer.component';
import { PolizaViewerComponent } from './documents/parts/poliza-viewer.component';


//////////////////////////// Dialogs /////////////////////////////////////
import { PolizaPerfilListComponent } from './dialogs/poliza-perfil-list.component';


/////////////////////////////////////////////////////////////////////////////////
let COMPONENTES = [CategoriasArticulosManager, CategoriasArticulosEditor, CategoriasUnidadesMedidaManager, CategoriasUnidadesMedidaEditor, ContribuyentesManager, ContribuyentesEditor, ContribuyenteSelectorComponent, DivisasManager, ComprobantesCorreoEditor,
    DivisasEditor, PACsManager, PACsEditor, FlujoManager, FlujoSelectorComponent, CuentasManager, CuentaSelectorComponent, EmpresasManager, EmpresasEditor, SucursalesManager, SucursalesEditor,
    ImpuestosManager, ImpuestosEditor, RetencionesManager, RetencionesEditor, CFDCertificadosManager, CFDCertificadosEditor, CFDSeriesManager, CFDSeriesEditor, MetodosPagoManager, MetodosPagoEditor,
    PolizasManager, PolizasEditor, PolizasByLoteEditor, CuentasAutocompleteCellComponent, ArticuloCategoriaFiscalComponent, UnidadMedidaCategoriaFiscalComponent, PolizaDetailEditor, PolizasLogComponent,
    SegmentosNegocioManager, SegmentosNegocioEditor, PolizasAsociacionesComponent, ComprobanteMaintenance, ImpuestosSelectorComponent, RetencionesSelectorComponent, ImpuestosAsignacionEditor, RetencionAsignacionEditor, DivisasSelectorComponent,
    BancosManager, BancosEditor, BancoSelectorComponent, CuentasBancariasManager, CuentasBancariasEditor, CuentaBancariaMiembrosComponent,
    NotasConceptosManager, NotasConceptosEditor, ComprobantesManager, ComprobanteFiscalDetailEditor, ComprobantesLoaderComponent, ComprobantesListComponent,
    NotasEditor, NotasManager, NotaDetailEditor, NotaConceptoSelectorComponent, TipoCambioComponent, TipoCambioEditorComponent, ComprobanteFiscalSelectorComponent, 
    ComprobanteViewerComponent, AddendasEditor, AddendasManager, EjerciciosManager, EjerciciosEditor, PeriodosEditor, PeriodosManager,
    FichasEditor, FichasManager, FichaDetailEditor, IepsArchivoGenerador, PlantillasComprobantesEditor, PlantillasComprobantesManager, ComprobanteSearch, AdmonCancelacion, ComprobantesCancelacionesManager, ImportesComponent, ComprobantesCancelacionesEditor, PolizaPerfilListComponent, PolizaViewerComponent, PeriodosSelectorComponent,
    RiesgosPuestosEditor, RiesgosPuestosManager, JornadasEditor, JornadasManager, ListaNegraManager, ListaNegraEditor, TiposRegimenesEditor, TiposRegimenesManager, PeriodosPagosEditor, PeriodosPagosManager, TiposContratosEditor, TiposContratosManager,
    EjerciciosTiposManager, EjerciciosTiposEditor, EsquemasManager, EsquemasEditor, EsquemaSelectorComponent, MapasDistribucionesManager, MapasDistribucionesEditor, MapaDistribucionCodeEditor
];

let SERVICIOS = [CategoriaUnidadesMedidaService, CategoriaArticulosService, ContribuyenteService, DivisaService, PACService, FlujoService, CuentaService, EmpresaService, SucursalService,
    ImpuestoService, RetencionService, CFDCertificadoService, SerieFiscalService, MetodoPagoService, PolizaService, SegmentoNegocioService, ComprobanteService, ComprobanteFiscalService,
    BancoService, CuentaBancariaService, NotaConceptoService, NotaService, FormaPagoService, AddendaService, EjercicioService, PeriodoService, FichaService, PlantillaComprobanteService, CancelacionService, ComprobanteCancelacionService, PolizaPerfilService,
    RiesgoPuestoService, JornadaService, ListaNegraService, TipoRegimenService, PeriodoPagoService, TipoContratoService, EjercicioTipoService, EsquemaService, MapaDistribucionService
];

@NgModule({
    imports: [
        FormsModule, ReactiveFormsModule, CommonModule,
        TabsModule.forRoot(), ModalModule.forRoot(), TreeModule,
        CoreModule, EditorsModule, SearchModule, GeneralModule, ControlsModule, SecurityModule, NotificationModule, AccountingRoutingModule, QueueModule, 
        WjCoreModule, WjInputModule, WjGridModule, WjGridFilterModule, PrintingModule
    ],
    declarations: COMPONENTES,
    providers: SERVICIOS,
    exports: COMPONENTES
})
export class AccountingModule {

}
