﻿import { Component, Input, Output, EventEmitter, forwardRef } from '@angular/core';
//
import { BaseComponent, Context } from 'framework3/core';
import { AutocompleteCell } from 'framework3/search/index';

//
import { CuentaInfo, CuentaItem } from '../models/cuenta';
import { CuentaService } from '../services/cuenta.service';

@Component({
    selector: 'accounting-cuentas-autocomplete-cell',
    templateUrl: './cuenta-autocomplete-cell.component.html',
    providers: [{
        provide: BaseComponent,
        useExisting: forwardRef(() => CuentasAutocompleteCellComponent)
    }]
})
export class CuentasAutocompleteCellComponent extends AutocompleteCell {
    //Inputs
    @Input() idDocumento: number = 0;
    @Input() version: number = 0;
    @Input() idPadre: number = 0;

    constructor(protected context: Context, private cuentaService: CuentaService) {
        super();
    }

    ngOnInit() {
        this.itemsSourceHandler = (keyword, max, callback) => this.searchKeyword(keyword, max, callback);
    }

    searchKeyword(keyword: string, max: number, callback: any) {
        if (keyword && keyword != '') {
            this.cuentaService.searchKeyword(this.context.app.defaultSite.identity, keyword)
                .toPromise()
                .then(items => callback(items))
                .catch(_ => callback(null));
        }
        else {
            callback(null);
        }
    }

}