﻿import { Component, Input, Output, EventEmitter, Renderer } from '@angular/core';

import { FormGroup, FormBuilder, AbstractControl, Validators } from '@angular/forms';

import { BaseComponent, Context, FileLink } from "framework3/core";
import { AlertsBarComponent } from "framework3/controls"

import { ImportesInfo } from '../models/importes';
import { ModalDirective } from 'ngx-bootstrap';
import { Control, Globalize, CollectionView } from 'wijmo/wijmo';

//

@Component({
    selector: "accounting-importes-component",
    templateUrl: './importes.component.html'
})

export class ImportesComponent {

    @Input() importes: ImportesInfo = new ImportesInfo();
    @Input() titulo: string = '';

    get subtotal() {  
        if (!this.importes.subtotal)
            this.importes.subtotal = 0;
        return Globalize.formatNumber(this.importes.subtotal, 'c');
    }
    get descuentos() {
        if (!this.importes.descuentos)
            this.importes.descuentos = 0;
        return Globalize.formatNumber(this.importes.descuentos, 'c');
    }
    get impuestosTrasladados() {
        if (!this.importes.impuestosTrasladados)
            this.importes.impuestosTrasladados = 0;
        return Globalize.formatNumber(this.importes.impuestosTrasladados, 'c');
    }
    get impuestosRetenidos() {
        if (!this.importes.impuestosRetenidos)
            this.importes.impuestosRetenidos = 0;
        return Globalize.formatNumber(this.importes.impuestosRetenidos, 'c');
    }
    get total() {
        if (!this.importes.total)
            this.importes.total = 0;
        return Globalize.formatNumber(this.importes.total, 'c');
    }

    constructor() {
              
    }

}