﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';
//
import { PolizaPerfilInfo, PolizaPerfilItem } from '../models/poliza-perfil';
import { PolizaPerfilService } from '../services/poliza-perfil.service';

@Component({
    selector: 'accounting-poliza-perfil-list',
    templateUrl: './poliza-perfil-list.component.html'
})
export class PolizaPerfilListComponent extends CatalogListDialog {

    @Input() searchByUser: boolean = false;

    polizasPerfil: PolizaPerfilItem[];

    constructor(protected context: Context, private service: PolizaPerfilService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        if (this.searchByUser) {
            this.service.searchPerfilByUsuario(this.context.app.defaultSite.identity, request)
                .then(result => {
                    this.polizasPerfil = result.rows;
                    this.totalRows = result.totalRows;
                    this.pageIndex = request.pageIndex;
                    this.context.app.hideSpinner();
                })
                .catch(error => this.handleError(error));
        }
        else {
            this.service.search(this.context.app.defaultSite.identity, request)
                .then(result => {
                    this.polizasPerfil = result.rows;
                    this.totalRows = result.totalRows;
                    this.pageIndex = request.pageIndex;
                    this.context.app.hideSpinner();
                })
                .catch(error => this.handleError(error));
        }
    }

    onSelectedItemsChanged(selectedGroups: PolizaPerfilItem[]) {
        this.selectedItemsChanged.emit(selectedGroups);
    }

    onSelectedItemChanged(group: PolizaPerfilItem) {
        this.selectedItemChanged.emit(group);
    }

}