﻿import { Context, CatalogInfo, CatalogItem } from 'framework3/core';
import { DomicilioInfo } from 'framework3/general';
import { ComprobanteCorreo } from '../models/comprobante-correo'

export class ContribuyenteInfo extends CatalogInfo {
	idContribuyenteOrigen: number;
	rfc: string;
	razonSocial: string;	
    correo: string;
    idUsoCFDI: number;
	idCuenta: number;
    
    domicilio: DomicilioInfo;
    comprobantesCorreos: ComprobanteCorreo[];

    constructor() {        
        super();
        this.rfc = '';
        this.razonSocial = '';
        this.correo = '';
        this.domicilio = new DomicilioInfo();
        this.comprobantesCorreos = [];
    }
}

export class ContribuyenteItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    valido: string;
    estatus?: string;
    selected?: boolean = false;
}

export class UsoCFDIItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    valido: string;
    estatus?: string;
    selected?: boolean = false;
}