﻿import { Context, CatalogInfo, CatalogItem, TrackableItem } from 'framework3/core';

export class DivisaInfo extends CatalogInfo {
	nombre: string;
	abreviatura: string;
	tipo: string;
    serieBanxico: string;
    decimales: number;


    constructor() {
        super();
        this.code = 'MXN';
    }
}

export class DivisaItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
	selected?:boolean = false;
}

export class TipoCambioItem extends TrackableItem {
    id: number;
    idEmpresa: number;
    empresa: string;
    idDivisaOrigen: number;
    divisaOrigen: string;
    idDivisaDestino: number;
    divisaDestino: string;
    precioCompra: number;
    precioVenta: number;
    precioOtro: number;
}