﻿import { Context, CatalogInfo, CatalogItem } from 'framework3/core';

export class MapaDistribucionInfo extends CatalogInfo {
	nombre: string;
	idEsquema: number;


    constructor() {
        super();
        this.idEsquema = 0;
    }
}

export class MapaDistribucionItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
	selected?:boolean = false;
}

export class MapElementInfo {
    baseAssembly: string;
    baseTypeName: string;

    basePath: string;
    name: string;
    property: string;
    typeElement: string;
    elements: MapElementInfo[];
    hasChildren: boolean;

    constructor() {
        this.baseAssembly = "";
        this.baseTypeName = "";
        this.basePath = "";
        this.name = "";
        this.property = "";
        this.typeElement = "";
        this.elements = [];
        this.hasChildren = true;
    }

}