﻿import { DocumentInfo, DocumentItem } from 'framework3/core';
import { NotaDetail } from './nota-detail';
import { NotaRelaciones } from './nota-relaciones';
import { ImpuestoResumenInfo } from '../models/impuesto-resumen';
import { DivisaInfo } from '../models/divisa';

export class NotaInfo extends DocumentInfo<NotaDetail> {
	tipo: string;
    idContribuyente: number;
    idUsoCFDI: number;
	idDivisa: number;
	tipoCambio: number;
	subTotal: number;
	impuestosTrasladados: number;
	impuestosRetenidos: number;
	total: number;
    observaciones: string;
    origen: string;
    idFormaPago: number;
    idComprobante: string;
    fechaComprobante: Date;
    
    impuestos: ImpuestoResumenInfo[] = [];
    relaciones: NotaRelaciones[] = [];
    divisa: DivisaInfo;


    constructor() {
        super();
        this.tipo = "Tipo";
        this.tipoCambio = 0;
        this.subTotal = 0;
        this.idComprobante = "";
        this.fechaComprobante = new Date();
        this.origen = "";
        this.divisa = new DivisaInfo();

    }
}

export class NotaItem extends DocumentItem {

}