﻿import { DocumentInfo, DocumentItem } from 'framework3/core';
import { PolizaDetail } from './poliza-detail';
import { AsociacionItem } from './asociacion';

export class PolizaInfo extends DocumentInfo<PolizaDetail> {	
	folio: number;
    idPeriodo: string;
    fechaPeriodo: Date;
	idPolizaTipo: number;
	idPolizaOrigen: number;
	idPolizaPerfil: number;
	idDivisa: number;
	tipoCambio: number;
	cargos: number;
	abonos: number;
	concepto: string;
	horaContabilizacion: Date;
	importacionEstatus: string;

    asociaciones: AsociacionItem[];

    constructor() {
        super();
        this.asociaciones =[];
    }
}

export class PolizaItem extends DocumentItem {
    fechaSys: Date;
    importacionEstatus: string;
}

enum ExportacionEstatusEnum{
    Up = 1,
    Down,
    Left,
    Right
}