﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { ConsultaAsistenciaEmpleadoModelInfo } from '../models/ConsultaAsistenciaEmpleadoModel'
import { FileInfo } from 'framework3/general';

@Injectable()
export class ConsultaAsistemciaEmpleadoService extends CatalogService<ConsultaAsistenciaEmpleadoModelInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/rh/ConsultaAsistenciaEmpleados');
    }

    create(): Promise<ConsultaAsistenciaEmpleadoModelInfo> {
        return Promise.resolve(new ConsultaAsistenciaEmpleadoModelInfo());
    }

    listaFromFile(file: FileInfo, Codigo: number, fechaInicial: Date, fechaFinal: Date): Promise<any> {
        let params: HttpParams = new HttpParams()
            .append("Codigo", Codigo.toString())
            .append("fechaInicial", fechaInicial.toString())
         .append("fechaFinal", fechaFinal.toString());

       // return this.apiService.get<any>("cargar-asistencias-empleados", params, file)
        return this.apiService.get<ConsultaAsistenciaEmpleadoModelInfo>("cargar-asistencias-empleados", params)
            .toPromise();
    }
        
    }


