﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { AddendaInfo } from '../models/addenda'

@Injectable()
export class AddendaService extends CatalogService<AddendaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/contabilidad/addendas');
    }

    create(): Promise<AddendaInfo> {
        return Promise.resolve(new AddendaInfo());
    }

    AddendaList(idEmpresa: number): Promise<any[]> {
        let params: HttpParams = new HttpParams()       
            .set("idEmpresa", idEmpresa.toString());
        return this.apiService.get<any[]>("addenda-list", params)            
            .toPromise();
    }
}

