﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { BancoInfo } from '../models/banco'

@Injectable()
export class BancoService extends CatalogService<BancoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/contabilidad/bancos');
    }

    create(): Promise<BancoInfo> {
        return Promise.resolve(new BancoInfo());
    }

	/*
	//Sample method
    sampleMethod(param1: number): Promise<BancoInfo> {
        let params: URLSearchParams = new URLSearchParams();
        params.set('param1', param1.toString());
        return this.apiService.getData('sample-method', params)
            .map(response => response.json() as BancoInfo)
            .toPromise();
    }
	*/
}

