﻿import { BaseService, Context } from "framework3/core";
import { HttpClient, HttpParams } from "@angular/common/http";
import { Injectable } from "@angular/core";
import { SearchRequest, SearchResult } from "framework3/search";


@Injectable()
export class CancelacionService extends BaseService {


    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/contabilidad/cancelaciones');
    }

    search(idBranch: number, request: SearchRequest): Promise<SearchResult> {
        let params: HttpParams = new HttpParams()
            .set('idBranch', idBranch.toString());
        return this.apiService.post<any>('search', params, request)
            .toPromise();
    }

    downloadPeticionPendiente(idCompany: number): Promise<boolean> {
        let params: HttpParams = new HttpParams()
            .set("idCompany", idCompany.toString());
        return this.apiService.post<boolean>("download-peticion-pendiente", params, null)
            .toPromise();
    }

    downloadPeticionPendienteAsync(idCompany: number): Promise<boolean> {
        let params: HttpParams = new HttpParams()
            .set("idCompany", idCompany.toString());
        return this.apiService.post<boolean>("download-peticion-pendiente-async", params, null)
            .toPromise();
    }

    aceptarRechazar(idSucursal: number, aceptar: boolean, idCancelacionSolicitud: number): Promise<boolean> {
        let params: HttpParams = new HttpParams()
            .set("idSucursal", idSucursal.toString())
            .set("aceptar", aceptar.toString())
            .set("idCancelacionSolicitud", idCancelacionSolicitud.toString());
        return this.apiService.post<boolean>("aceptar-rechazar", params, null)
            .toPromise();
    }

}