﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Framework
import { Context, DocumentInfo, DocumentItem, DocumentService } from 'framework3/core';
//Locales
import { ComprobanteCancelacionInfo, ComprobanteCancelacionItem } from '../models/comprobante-cancelacion';
import { ComprobanteCancelacionDetail } from '../models/comprobante-cancelacion-detail';

@Injectable()
export class ComprobanteCancelacionService extends DocumentService<ComprobanteCancelacionDetail, ComprobanteCancelacionInfo> {

    constructor(protected http: HttpClient, protected context: Context ) {
        super(http, context, 'api/contabilidad/comprobante-cancelacion');
    }

    create(): Promise<ComprobanteCancelacionInfo> {
        let newDoc = new ComprobanteCancelacionInfo();
        return Promise.resolve(newDoc);
    }

    evaluarProceso(idComprobanteCancelacion: string): Promise<boolean> {
        let params = new HttpParams()
            .set('idComprobanteCancelacion', idComprobanteCancelacion);
        return this.apiService.post<boolean>('evaluar-proceso', params, null)
            .toPromise();
    }

	/*
    sampleMethod(param1: number, param2: string): Promise<ComprobanteCancelacionInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<ComprobanteCancelacionInfo>('sample-method', params)
            .toPromise();
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) en los resultados de búsquedas. Eliminar si no es necesario
	protected mapSearchResult(row: any) {
        
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) al cargar un documento. Eliminar si no es necesario
    protected mapDocument(document: ComprobanteCancelacionInfo) {

    }
	*/

}