﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, HierarchyInfo, HierarchyService } from 'framework3/core';
//Locales
import { CuentaInfo, CuentaTipoItem } from '../models/cuenta';

@Injectable()
export class CuentaService extends HierarchyService<CuentaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/contabilidad/cuentas");
    }

    create(): Promise<CuentaInfo> {
        return Promise.resolve(new CuentaInfo());
    }
    		
   loadTipos(idEmpresa:string ): Promise<CuentaTipoItem[]> {
       let params: HttpParams = new HttpParams()
            .set("idEmpresa", idEmpresa);
        return this.apiService.get<CuentaTipoItem[]>("load-tipos", params)            
            .toPromise();
    }
	

}
