﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { EjercicioTipoInfo,EjercicioTipoItem } from '../models/ejercicio-tipo'

@Injectable()
export class EjercicioTipoService extends CatalogService<EjercicioTipoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/contabilidad/ejercicios-tipos');
    }

    create(): Promise<EjercicioTipoInfo> {
        return Promise.resolve(new EjercicioTipoInfo());
    }

    loadList(idSucursal: number): Promise<EjercicioTipoItem[]> {
        let params: HttpParams = new HttpParams()
            .set("IdSucursal", idSucursal.toString());
        return this.apiService.get<EjercicioTipoItem[]>("load-list", params)
            .toPromise();
    }

}

