﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
import * as moment from 'moment';
//Azteca Framework
import { Context, DocumentInfo, DocumentItem, DocumentService } from 'framework3/core';
//Locales
import { FichaInfo, FichaItem } from '../models/ficha';
import { FichaDetail } from '../models/ficha-detail';

@Injectable()
export class FichaService extends DocumentService<FichaDetail, FichaInfo> {

    constructor(protected http: HttpClient, protected context: Context ) {
        super(http, context, 'api/contabilidad/fichas');
    }

    create(): Promise<FichaInfo> {
        let newDoc = new FichaInfo();
        return Promise.resolve(newDoc);
    }

    protected mapSearchResult(row: any) {
        row.fechaAfectacion = moment(row.fechaAfectacion).toDate();
    }


	/*
    sampleMethod(param: string): Promise<MovimientoInfo> {
        let params: URLSearchParams = new URLSearchParams();
        params.set('param', param);                
        return this.apiService.getData('sample-method', params)
            .map(response => response.json() as MovimientoInfo)
            .toPromise();
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) en los resultados de búsquedas. Eliminar si no es necesario
	protected mapSearchResult(row: any) {
        
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) al cargar un documento. Eliminar si no es necesario
    protected mapDocument(document: FichaInfo) {

    }
	*/



}