﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, HierarchyInfo, HierarchyService } from 'framework3/core';
//Locales
import { FlujoInfo } from '../models/flujo';

@Injectable()
export class FlujoService extends HierarchyService<FlujoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/contabilidad/flujo");
    }

    create(): Promise<FlujoInfo> {
        return Promise.resolve(new FlujoInfo());
    }

	/*
	//Sample method
    sampleMethod(param1: number): Promise<FlujoInfo> {
        let params: URLSearchParams = new URLSearchParams();
        params.set('param1', param1.toString());
        return this.apiService.getData('sample-method', params)
            .map(response => response.json() as FlujoInfo)
            .toPromise();
    }
	*/

}
