﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { FormaPagoInfo, FormaPagoItem } from '../models/forma-pago'

@Injectable()
export class FormaPagoService extends CatalogService<FormaPagoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/contabilidad/formas-pago');
    }

    create(): Promise<FormaPagoInfo> {
        return Promise.resolve(new FormaPagoInfo());
    }

    loadList(idSucursal: number): Promise<FormaPagoItem[]> {
        let params: HttpParams = new HttpParams()
            .set("idSucursal", idSucursal.toString());
        return this.apiService.get<FormaPagoItem[]>("load-list", params)            
            .toPromise();
    }


	/*
	//Sample method
    sampleMethod(param1: number): Promise<FormaPagoInfo> {
        let params: URLSearchParams = new URLSearchParams();
        params.set('param1', param1.toString());
        return this.apiService.getData('sample-method', params)
            .map(response => response.json() as FormaPagoInfo)
            .toPromise();
    }
	*/
}

