﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { JornadaInfo } from '../models/jornada'

@Injectable()
export class JornadaService extends CatalogService<JornadaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/contabilidad/jornadas');
    }

    create(): Promise<JornadaInfo> {
        return Promise.resolve(new JornadaInfo());
    }

    getJornadaCbo(idSucursal: number): Promise<any> {
        let params = new HttpParams()
            .set('idSucursal', idSucursal.toString());
        //
        return this.apiService.get<any>('get-jornada-cbo', params)
            .toPromise();
    }
}

