﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { ListaNegraInfo } from '../models/lista-negra'
import { FileInfo } from 'framework3/general';

@Injectable()
export class ListaNegraService extends CatalogService<ListaNegraInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/contabilidad/lista-negra');
    }

    create(): Promise<ListaNegraInfo> {
        return Promise.resolve(new ListaNegraInfo());
    }

    listaFromFile(file: FileInfo, idEmpresa:number,idSucursal:number): Promise<any> {
        let params: HttpParams = new HttpParams()
            .append("idEmpresa", idEmpresa.toString())
            .append("idSucursal", idSucursal.toString());
        
        return this.apiService.post<any>("lista-negra-file", params,file)
            .toPromise();
    }

    permitirEFO(idListaNegra: number,idUsuario:number,idEmpresa:number,status:boolean): Promise<any> {
        let params: HttpParams = new HttpParams()
            .append("IdListaNegra", idListaNegra.toString())
            .append("IdUsuario", idUsuario.toString())
            .append("IdEmpresa", idEmpresa.toString())
            .append("Status",status.toString());

        return this.apiService.post<any>("permitir-efo", params)
            .toPromise();
    }

    eliminarFirmas(): Promise<any> {
        let params: HttpParams = new HttpParams()

        return this.apiService.post<any>("eliminar-firmas", params)
            .toPromise();
    }


}

