﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { MapaDistribucionInfo, MapElementInfo } from '../models/mapa-distribucion'

@Injectable()
export class MapaDistribucionService extends CatalogService<MapaDistribucionInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/contabilidad/mapas-distribuciones');
    }

    create(): Promise<MapaDistribucionInfo> {
        return Promise.resolve(new MapaDistribucionInfo());
    }


    getElementByEsquma(idEsquema: number): Promise<MapElementInfo[]> {
        let params: HttpParams = new HttpParams()
            .set("idEsquema", idEsquema.toString());
        return this.apiService.get<MapElementInfo[]>('get-element-by-esquema', params).toPromise();
    }

    getElementChildrens(element: MapElementInfo): Promise<MapElementInfo[]> {
        let params: HttpParams = new HttpParams();
        return this.apiService.post<MapElementInfo[]>('get-element-childrens', params, element).toPromise();
    }

	/*
	//Sample method
    sampleMethod(param1: number): Promise<MapaDistribucionInfo> {
        let params: URLSearchParams = new URLSearchParams();
        params.set('param1', param1.toString());
        return this.apiService.getData('sample-method', params)
            .map(response => response.json() as MapaDistribucionInfo)
            .toPromise();
    }
	*/
}

