﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { MetodoPagoInfo, MetodoPagoItem } from '../models/metodo-pago'

@Injectable()
export class MetodoPagoService extends CatalogService<MetodoPagoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/contabilidad/metodospago");
    }

    create(): Promise<MetodoPagoInfo> {
        return Promise.resolve(new MetodoPagoInfo());
    }

    loadList(idEmpresa: number): Promise<MetodoPagoItem[]> {
        let params: HttpParams = new HttpParams()
            .set("idEmpresa", idEmpresa.toString());
        return this.apiService.get<MetodoPagoItem[]>("load-list", params)            
            .toPromise();
    }

}

