﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { PACInfo,PACItem } from '../models/pac'

@Injectable()
export class PACService extends CatalogService<PACInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/contabilidad/pacs");
    }

    create(): Promise<PACInfo> {
        return Promise.resolve(new PACInfo());
    }

    loadList(): Promise<PACItem[]> {
        let params: HttpParams = new HttpParams();
        return this.apiService.get<PACItem[]>("load-list", params)            
            .toPromise();
    }

}

