﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { PeriodoPagoInfo, PeriodoPagoItem } from '../models/periodo-pago'

@Injectable()
export class PeriodoPagoService extends CatalogService<PeriodoPagoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/contabilidad/periodos-pagos');
    }

    create(): Promise<PeriodoPagoInfo> {
        return Promise.resolve(new PeriodoPagoInfo());
    }

	
    loadCbo(): Promise<PeriodoPagoItem[]> {
        return this.apiService.get<PeriodoPagoItem[]>('load-cbo')
            .toPromise();
    }
	
}

