﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Framework
import { Context, DocumentInfo, DocumentItem, DocumentService } from 'framework3/core';
//Locales
import { PeriodoInfo, PeriodoItem } from '../models/periodo';
import { PeriodoDetail } from '../models/periodo-detail';

@Injectable()
export class PeriodoService extends DocumentService<PeriodoDetail, PeriodoInfo> {

    constructor(protected http: HttpClient, protected context: Context ) {
        super(http, context, 'api/contabilidad/periodos');
    }

    create(): Promise<PeriodoInfo> {
        let newDoc = new PeriodoInfo();
        return Promise.resolve(newDoc);
    }

    searchKeyword(idBranch: number, keyword: string): Observable<PeriodoItem[]> {
        let params: HttpParams = new HttpParams()
            .set("idBranch", idBranch.toString())
            .set("keyword", keyword);
        return this.apiService.get<PeriodoItem[]>("search-periodos", params)

    }

	/*
    sampleMethod(param: string): Promise<MovimientoInfo> {
        let params: URLSearchParams = new URLSearchParams();
        params.set('param', param);                
        return this.apiService.getData('sample-method', params)
            .map(response => response.json() as MovimientoInfo)
            .toPromise();
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) en los resultados de búsquedas. Eliminar si no es necesario
	protected mapSearchResult(row: any) {
        
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) al cargar un documento. Eliminar si no es necesario
    protected mapDocument(document: PeriodoInfo) {

    }
	*/



}