﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
import { FileInfo } from 'framework3/general';
//Locales
import { PlantillaComprobanteInfo } from '../models/plantilla-comprobante'

@Injectable()
export class PlantillaComprobanteService extends CatalogService<PlantillaComprobanteInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/accounting/plantillas-comprobantes');
    }

    create(): Promise<PlantillaComprobanteInfo> {
        return Promise.resolve(new PlantillaComprobanteInfo());
    }

    downloadPlantilla(idPlantillaComprobante: number): Promise<FileInfo> {
        let params = new HttpParams()
            .set('idPlantillaComprobante', idPlantillaComprobante.toString());
        return this.apiService.get<FileInfo>('download-plantilla', params)
            .toPromise();
    }

}

