﻿import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';


import { Context, CatalogService } from 'framework3/core';
import { SearchResult, SearchRequest } from 'framework3/search';

import { PolizaPerfilInfo } from '../models/poliza-perfil';

@Injectable()
export class PolizaPerfilService extends CatalogService<PolizaPerfilInfo>  {
    
    constructor(httpClient: HttpClient, context: Context) {
        super(httpClient, context, 'api/accounting/poliza-perfil');
    }

    create(): Promise<PolizaPerfilInfo> {
        var polizaPerfil: PolizaPerfilInfo = new PolizaPerfilInfo()
        return Promise.resolve(polizaPerfil);
    }


    searchPerfilByUsuario(idBranch: number, request: SearchRequest): Promise<SearchResult> {
        let params = new HttpParams()
            .set('idBranch', idBranch.toString());
        //
        return this.apiService.post<SearchResult>('search-perfil-by-usuario', params, request)
            .toPromise();
    }

}