﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { RetencionInfo, RetencionTipoItem } from '../models/retencion'
import { RetencionItem } from '../index';

@Injectable()
export class RetencionService extends CatalogService<RetencionInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/contabilidad/retenciones");
    }

    create(): Promise<RetencionInfo> {
        return Promise.resolve(new RetencionInfo());
    }

    loadTipos(idEmpresa: string): Promise<RetencionTipoItem[]> {
        let params: HttpParams = new HttpParams()
            .set("idEmpresa", idEmpresa);
        return this.apiService.get<RetencionTipoItem[]>("load-tipos", params)            
            .toPromise();
    }

    searchKeywordRetenciones(idBranch: number, keyword: string): Observable<RetencionItem[]> {
        let params: HttpParams = new HttpParams()
            .set('idBranch', idBranch.toString())
            .set('keyword', keyword);
        return this.apiService.get<RetencionItem[]>('search-keyword', params)

    }
}

