﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { RiesgoPuestoInfo, RiesgoPuestoItem } from '../models/riesgo-puesto'

@Injectable()
export class RiesgoPuestoService extends CatalogService<RiesgoPuestoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/contabilidad/riesgos-puestos');
    }

    create(): Promise<RiesgoPuestoInfo> {
        return Promise.resolve(new RiesgoPuestoInfo());
    }


    getRiesgoPuestoCbo(idSucursal: number): Promise<RiesgoPuestoItem[]> {
        let params = new HttpParams()
            .set('idSucursal', idSucursal.toString());
        //
        return this.apiService.get<RiesgoPuestoItem[]>('get-riesgo-puesto-cbo', params)
            .toPromise();
    }
	
}

