﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { SegmentoNegocioInfo, SegmentoNegocioItem } from '../models/segmento-negocio'

@Injectable()
export class SegmentoNegocioService extends CatalogService<SegmentoNegocioInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/contabilidad/segmentosnegocio");
    }

    create(): Promise<SegmentoNegocioInfo> {
        return Promise.resolve(new SegmentoNegocioInfo());
    }

    loadList(idEmpresa: number): Promise<SegmentoNegocioItem[]> {
        let params: HttpParams = new HttpParams()
            .set("idEmpresa", idEmpresa.toString());
        return this.apiService.get<SegmentoNegocioItem[]>("load-list", params)            
            .toPromise();
    }

}

