﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { SerieFiscalInfo,SerieFiscalItem } from '../models/serie-fiscal'

@Injectable()
export class SerieFiscalService extends CatalogService<SerieFiscalInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/contabilidad/cfdseries");
    }

    create(): Promise<SerieFiscalInfo> {
        return Promise.resolve(new SerieFiscalInfo());
    }

    loadList(idEmpresa: string): Promise<SerieFiscalItem[]> {
        let params: HttpParams = new HttpParams()
            .set("idEmpresa", idEmpresa);
        return this.apiService.get<SerieFiscalItem[]>("load-list", params)            
            .toPromise();
    }

}

