﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { TipoContratoInfo, TipoContratoItem } from '../models/tipo-contrato'

@Injectable()
export class TipoContratoService extends CatalogService<TipoContratoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/contabilidad/tipos-contratos');
    }

    create(): Promise<TipoContratoInfo> {
        return Promise.resolve(new TipoContratoInfo());
    }

    loadCbo(): Promise<TipoContratoItem[]> {
        //
        return this.apiService.get<TipoContratoItem[]>('load-cbo')
            .toPromise();
    }
}

