﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { TipoRegimenInfo, TipoRegimenItem } from '../models/tipo-regimen'

@Injectable()
export class TipoRegimenService extends CatalogService<TipoRegimenInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/contabilidad/tipos-regimenes');
    }

    create(): Promise<TipoRegimenInfo> {
        return Promise.resolve(new TipoRegimenInfo());
    }

    loadCbo(): Promise<TipoRegimenItem[]> {
		//
        return this.apiService.get<TipoRegimenItem[]>('load-cbo')
            .toPromise();
    }
}

