﻿import { Component, Input, Output, EventEmitter } from '@angular/core';
import { Observable } from 'rxjs';
import { mergeMap } from 'rxjs/operators';
import { TypeaheadDirective, TypeaheadMatch } from 'ngx-bootstrap';
//
import { Context, ProcesoService, CatalogItem, ProcesoItem } from 'framework3/core';

@Component({
    selector: 'search-box',
    templateUrl: './search-box.component.html'
})
export class SearchBoxComponent {
    value: string = '';

    dataSource: Observable<any>;

    /////////// INPUTS

    /////////// OUTPUS
    @Output() processSelected = new EventEmitter<ProcesoItem>();

    constructor(private context: Context, private procesoService: ProcesoService) {
        this.dataSource =Observable.create(observer => {
            observer.next(this.value);
        }).pipe(mergeMap((keyword: string) => this.findKeyword(keyword)));
    }

    /////////// METHODS

    /////////// HANDLERS

    typeaheadOnSelect(args: TypeaheadMatch) {
        this.processSelected.emit(args.item);
    }

    changeTypeaheadLoading(loading: boolean) {

    }

    changeTypeaheadNoResults(noResults: boolean) {

    }

    findKeyword(keyword: string): Observable<CatalogItem[]> {
        return this.procesoService.searchKeyword(this.context.app.defaultSite.identity, keyword);
    }

}
