import { NgModule } from '@angular/core';
import { registerLocaleData } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { HttpModule } from '@angular/http';

import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import localeEs from '@angular/common/locales/es';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';
import { AppRoutingModule } from './app.routing';

//Bootstrap
import { AlertModule, ModalModule, AccordionModule, TypeaheadModule } from 'ngx-bootstrap';
//Azteca Kernel
import { CoreModule, Context, AuthGuard, Server } from 'framework3/core';
import { ControlsModule } from 'framework3/controls';
import { GeneralModule } from 'framework3/general';
import { NotificationModule } from 'framework3/notification';

//App Root
import { AppComponent } from './app.component';
import { LoginComponent } from './app-components/login.component';
import { SelectComanyComponent } from './app-components/select-company.component';
import { MainComponent } from './app-components/main.component';
import { ChangePasswordComponent } from './app-components/change-password.component';
//Parts
import { SearchBoxComponent } from './app-components/search-box.component';


let COMPONENTS = [AppComponent, LoginComponent, MainComponent, SelectComanyComponent, ChangePasswordComponent, SearchBoxComponent];

registerLocaleData(localeEs);

@NgModule({
    imports: [
        BrowserModule, HttpClientModule, RouterModule, HttpModule, FormsModule, ReactiveFormsModule, BrowserAnimationsModule,
        AlertModule.forRoot(), ModalModule.forRoot(), AccordionModule.forRoot(), TypeaheadModule.forRoot(),
        CoreModule, ControlsModule, NotificationModule, AppRoutingModule
    ],
    providers: [Context, AuthGuard, Server],
    declarations: COMPONENTS,
    bootstrap: [AppComponent]
})
export class AppModule { }
