﻿import { ModuleWithProviders, NgModule }  from '@angular/core';
import { Routes, RouterModule, PreloadAllModules } from '@angular/router';
//
import { AuthGuard } from 'framework3/core';
//
import { LoginComponent } from './app-components/login.component';
import { SelectComanyComponent } from './app-components/select-company.component';
import { MainComponent } from './app-components/main.component';

const appRoutes: Routes = [
    {
        path: '',
        redirectTo: '/login',
        pathMatch: 'full'
    },
    {
        path: 'login',
        component: LoginComponent
    },
    {
        path: 'select-company',
        component: SelectComanyComponent
    },
    {
        path: 'main',
        canActivate: [AuthGuard],
        component: MainComponent
    },
    //Modulos de Framework3
    
    { path: 'kernel/bpm', loadChildren: 'framework3/bpm#BpmModule' },
    { path: 'kernel/custom', loadChildren: 'framework3/custom#CustomModule' },
    { path: 'kernel/security', loadChildren: 'framework3/security#SecurityModule' },
    { path: 'kernel/tracing', loadChildren: 'framework3/tracing#TracingModule' },
    { path: 'kernel/analytic', loadChildren: 'framework3/analytic#AnalyticModule' },
    { path: 'kernel/queue', loadChildren: 'framework3/queue#QueueModule' },
    //Modulos de Onili2
    { path: 'dashboard', loadChildren: './dashboard/dashboard.module#DashboardModule' },
    { path: 'accounting', loadChildren: './accounting/accounting.module#AccountingModule' },
    { path: 'inventory', loadChildren: './inventory/inventory.module#InventoryModule' },
    { path: 'credit', loadChildren: './credit/credit.module#CreditModule' },    
    { path: 'treasury', loadChildren: './treasury/treasury.module#TreasuryModule' },
    { path: 'rh', loadChildren: './rh/rh.module#RhModule' },
    { path: 'purchasing', loadChildren: './purchasing/purchasing.module#PurchasingModule' },
    { path: 'sales', loadChildren: './sales/sales.module#SalesModule' },    
    { path: 'production', loadChildren: './production/production.module#ProductionModule' },
    { path: 'maintenance', loadChildren: './maintenance/maintenance.module#MaintenanceModule' },
    { path: 'distribution', loadChildren: './distribution/distribution.module#DistributionModule' },
    //Portales externos
    { path: 'proveedores', loadChildren: './proveedores/proveedores.module#ProveedoresModule' },
    { path: 'clientes', loadChildren: './clientes/clientes.module#ClientesModule' },
    { path: 'empleados', loadChildren: './empleados/empleados.module#EmpleadosModule' },

    { path: 'custom/aga/credit', loadChildren: './custom/aga/credit/credit.module#CreditModule' },
    { path: 'custom/aga/distribution', loadChildren: './custom/aga/distribution/distribution.module#DistributionModule' }
    
];

@NgModule({
    exports: [
        RouterModule
    ],
    imports: [
        RouterModule.forRoot(appRoutes, {
            preloadingStrategy: PreloadAllModules
        })
    ]
})
export class AppRoutingModule { }

