﻿import { NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
//Modulos Azteca
import { CoreModule } from 'framework3/core';
import { EditorsModule } from 'framework3/editors';
import { SearchModule } from 'framework3/search';
import { GeneralModule } from 'framework3/general';
import { ControlsModule } from 'framework3/controls';
import { SecurityModule } from 'framework3/security';
import { NotificationModule } from 'framework3/notification';
import { ClientesRoutingModule } from '../clientes/clientes.routing.module'
//Bootstrap
import { AlertModule, TabsModule, ModalModule } from 'ngx-bootstrap';
//Wijmo
import { WjCoreModule } from 'wijmo/wijmo.angular2.core';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
//Modulos Pixkua
import { AccountingModule } from '../accounting';
import { PurchasingModule } from '../purchasing';
import { SalesModule } from '../sales';

//Componentes
import { LoginComponent } from './components/login.component';
import { RegistroComponent } from './components/registro.component';
import { PreRegistroComponent } from './components/pre-registro.component';
import { DownloadInvoiceComponent } from './components/download-invoice.component';

//Services
import { PortalContext } from './services/portal-context';
import { AuthGuard } from './services/auth-guard.service';


let COMPONENTES = [LoginComponent, RegistroComponent, DownloadInvoiceComponent, PreRegistroComponent];

let SERVICIOS = [PortalContext, AuthGuard];

@NgModule({
    imports: [
        FormsModule, ReactiveFormsModule, CommonModule,
        AlertModule.forRoot(), TabsModule.forRoot(), ModalModule.forRoot(),
        CoreModule, EditorsModule, SearchModule, GeneralModule, ControlsModule, SecurityModule, NotificationModule,
        AccountingModule, ClientesRoutingModule, SalesModule, PurchasingModule,
        WjCoreModule, WjInputModule, WjGridModule, WjGridFilterModule
    ],
    declarations: COMPONENTES,
    providers: SERVICIOS,
    exports: COMPONENTES
})
export class ClientesModule {

}
