﻿import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

//////////////////////////// Guards //////////////////////////////////
import { AuthGuard } from './services/auth-guard.service';

/////////////////////////// Componentes //////////////////////////////
import { LoginComponent } from './components/login.component';
import { RegistroComponent } from './components/registro.component';
import { PreRegistroComponent } from './components/pre-registro.component';
import { DownloadInvoiceComponent } from './components/download-invoice.component';


const routes: Routes = [
    { path: 'login', component: LoginComponent },
    { path: 'registro/:cliente/:expira', component: RegistroComponent },
    { path: 'pre-registro', component: PreRegistroComponent },
    {
        path: '',
        canActivateChild: [AuthGuard],
        children: [
            { path: 'download', component: DownloadInvoiceComponent }
        ]
    },
];

@NgModule({
    imports: [
        RouterModule.forChild(routes)
    ],
    exports: [
        RouterModule
    ]
})
export class ClientesRoutingModule { }

