﻿//Frameworks
import { Component, ViewChild, Input, Output, EventEmitter, ChangeDetectorRef, forwardRef } from '@angular/core';
import { Router, ActivatedRoute, Params } from '@angular/router';
import { FormBuilder, Validators, FormGroup } from '@angular/forms';
import { Location } from '@angular/common';
import * as moment from 'moment';
//Wijmo
import { Control } from 'wijmo/wijmo';
//Bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//Azteca Kernel
import { Context, BaseComponent, CatalogService, PolicyInfo } from 'framework3/core';
import { AztecaValidators, ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
//Features
import { ComprobanteFiscalService } from '../../accounting/services/comprobante-fiscal.service';

@Component({
    selector: 'base-portal-clientes',
    templateUrl: 'portal-clientes.component.html',
    providers: [
        {
            provide: BaseComponent, useExisting: forwardRef(() => PortalClientesComponent)
        },
        {
            provide: CatalogService, useExisting: ComprobanteFiscalService
        }
    ]
})
export class PortalClientesComponent extends CatalogEditor {
    form: FormGroup;
    @ViewChild(AlertsBarComponent) alerts: AlertsBarComponent;

    constructor(protected context: Context, private formBuilder: FormBuilder, protected router: Router, protected route: ActivatedRoute,
        protected changeDetector: ChangeDetectorRef, private comprobanteFiscalService: ComprobanteFiscalService) {
        super(context, router, route, changeDetector);
        this.form = formBuilder.group({
            'fechaBusquedaIni': ['', AztecaValidators.selected],
            'fechaBusquedaFin': ['']
        });
    }

    ngOnInit() {
        
    }

    applyPolicy(policy: PolicyInfo) {

    }

    handleError(error: any) {
        this.context.app.hideSpinner();
        let message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    }

}