﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';
//
import { CajeroItem } from '../models/cajero';
import { CajeroService } from '../services/cajero.service';

@Component({
    selector: 'credit-cajeros-list',
    templateUrl: './cajeros-list.component.html'
})
export class CajerosListComponent extends CatalogListDialog {
    cajeros: CajeroItem[];

    constructor(protected context: Context, private cajeroService: CajeroService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.cajeroService.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.cajeros = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedGroups: CajeroItem[]) {
        this.selectedItemsChanged.emit(selectedGroups);
    }

    onSelectedItemChanged(group: CajeroItem) {
        this.selectedItemChanged.emit(group);
    }

}