﻿import { Context, CatalogInfo, CatalogItem } from 'framework3/core';
import { ContribuyenteInfo } from '../../accounting/models/contribuyente';
import { GrupoDeudorInfo } from './grupo-deudor';
import { DomicilioInfo } from 'framework3/general';
import { ClasificacionValor, IClasificable } from 'framework3/general';
import { DomicilioComprobanteInfo } from './domicilio-comprobante';
import { ComprobanteCorreo } from '../../accounting/models/comprobante-correo';
import { RazonSocialComprobante } from './razon-social-comprobante';
import { DeudorPerfilAutoCobro } from './deudor-perfil-auto-cobro';

export class DeudorInfo extends CatalogInfo implements IClasificable {
	nombre: string;
	idGrupoDeudor: number;
	tipoDeudor: string;
	idReferencia: number;
    codigoReferencia: string;
    condicionesPago: string;
    adeudoCredito: number;
    adeudoPrestamo: number;
    idNotaTipo: number;
	limiteCredito: number;
	diasCredito: number;
    idFormaPago: number;
    cuentaPago: string;
    idCuenta: number;
    facturable: boolean;
    facturacionCategorizada: boolean;
    administraSaldo: boolean;
    domicilioComprobante: DomicilioComprobanteInfo;
    razonSocialComprobante: RazonSocialComprobante;

    domicilio: DomicilioInfo;
    idContribuyente: number;   
    contribuyente: ContribuyenteInfo;
    grupoDeudor: GrupoDeudorInfo;
    desgloseIEPS: boolean;
    IdCFDSerie: number;
    idComprobanteAddenda: number;
    idComprobanteDestino: number;
    gLN: string;
    gLNTienda: string;
    gLNComprador: string;
    numProveedor: string;
    clasificaciones: ClasificacionValor[];
    comprobantesCorreos: ComprobanteCorreo[];
    perfilesAutoCobro: DeudorPerfilAutoCobro[];
    metodoPago: string;
    rV: number[];

    constructor() {
        super();
        this.idGrupoDeudor = 0;
        this.facturable = false;
        this.desgloseIEPS = false;
        this.domicilio = new DomicilioInfo();
        this.contribuyente = new ContribuyenteInfo(); 
        this.grupoDeudor = new GrupoDeudorInfo();
        this.domicilioComprobante = new DomicilioComprobanteInfo();
        this.razonSocialComprobante = new RazonSocialComprobante();
        this.clasificaciones = [];     
        this.comprobantesCorreos = [];
        this.perfilesAutoCobro = [];
        this.rV = [];
    }
}

export class DeudorItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    adeudoPrestamo: number;
    activo: boolean;
    estatus?: string;
    selected?: boolean = false;
    sucursal?: string;
}