﻿import { Context, CatalogInfo, CatalogItem } from 'framework3/core';
import { ContribuyenteInfo } from '../../accounting/models/contribuyente';
import { DeudorPerfilAutoCobro } from './deudor-perfil-auto-cobro';

export class GrupoDeudorInfo extends CatalogInfo {
	nombre: string;
	idCFDSerie: number;
    limiteCredito: number;
    adeudoPrestamo: number;
    idNotaTipo: number;
	diasCredito: number;
    idCuenta: number;
    desgloseIeps: boolean;
    idContribuyente: number;
    perfilesAutoCobro: DeudorPerfilAutoCobro[];
    rV: number[];

    contribuyente: ContribuyenteInfo;
    
    
    constructor() {
        super();
        this.perfilesAutoCobro = [];
        this.rV = [];
        this.contribuyente = new ContribuyenteInfo();
    }    
}

export class GrupoDeudorItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
	selected?:boolean = false;
}