﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Framework
import { Context, DocumentInfo, DocumentItem, DocumentService } from 'framework3/core';
//Locales
import { AnticipoInfo, AnticipoItem } from '../models/anticipo';
import { AnticipoDetail } from '../models/anticipo-detail';

@Injectable()
export class AnticipoService extends DocumentService<AnticipoDetail, AnticipoInfo> {

    constructor(protected http: HttpClient, protected context: Context ) {
        super(http, context, 'api/credito/anticipos');
    }

    create(): Promise<AnticipoInfo> {
        let newDoc = new AnticipoInfo();
        return Promise.resolve(newDoc);
    }

    searchKeyword(idBranch: number, keyword: string): Observable<AnticipoItem[]> {
        let params: HttpParams = new HttpParams()
            .set("idBranch", idBranch.toString())
            .set("keyword", keyword);        
        return this.apiService.get<AnticipoItem[]>("search-anticipos", params)
           
    }

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) en los resultados de búsquedas. Eliminar si no es necesario
	protected mapSearchResult(row: any) {
        
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) al cargar un documento. Eliminar si no es necesario
    protected mapDocument(document: AnticipoInfo) {

    }
	*/



}