﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { CobroTipoInfo, CobroTipoItem } from '../models/cobro-tipo'

@Injectable()
export class CobroTipoService extends CatalogService<CobroTipoInfo> {

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/credito/cobros-tipos");
    }

    create(): Promise<CobroTipoInfo> {
        return Promise.resolve(new CobroTipoInfo());
    }

    loadList(idBranch: number, todos:boolean): Promise<CobroTipoItem[]> {
        let params: HttpParams = new HttpParams()
            .set("idBranch", idBranch.toString())
            .set("todos", todos.toString());
        return this.apiService.get<CobroTipoItem[]>("load-list", params)
            .toPromise();
    }

}

