﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
import * as moment from 'moment';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { ConceptoInfo, ConceptoItem } from '../models/concepto'

@Injectable()
export class ConceptoService extends CatalogService<ConceptoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/credito/conceptos");
    }

    create(): Promise<ConceptoInfo> {
        return Promise.resolve(new ConceptoInfo());
    }

    getConceptos(): Promise<ConceptoItem[]> {
        let params: HttpParams = new HttpParams();
        return this.apiService.get<ConceptoItem[]>('get-conceptos', params)            
            .toPromise();
    }
}