﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { DepositoTipoInfo, DepositoTipoItem } from '../models/deposito-tipo'

@Injectable()
export class DepositoTipoService extends CatalogService<DepositoTipoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/credito/depositos-tipos');
    }

    create(): Promise<DepositoTipoInfo> {
        return Promise.resolve(new DepositoTipoInfo());
    }

    loadList(idBranch: number): Promise<DepositoTipoItem[]> {
        let params: HttpParams = new HttpParams()
            .set("idBranch", idBranch.toString());
        return this.apiService.get<DepositoTipoItem[]>("load-list", params)
            .toPromise();
    }

}

