﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Framework
import { Context, DocumentInfo, DocumentItem, DocumentService } from 'framework3/core';
//Locales
import { DepositoInfo, DepositoItem } from '../models/deposito';
import { DepositoDetail } from '../models/deposito-detail';

@Injectable()
export class DepositoService extends DocumentService<DepositoDetail, DepositoInfo> {

    constructor(protected http: HttpClient, protected context: Context ) {
        super(http, context, 'api/credito/depositos');
    }

    create(): Promise<DepositoInfo> {
        let newDoc = new DepositoInfo();
        return Promise.resolve(newDoc);
    }

    searchKeyword(idBranch: number, keyword: string): Observable<DepositoItem[]> {
        let params: HttpParams = new HttpParams()
            .set("idBranch", idBranch.toString())
            .set("keyword", keyword);
        return this.apiService.get<DepositoItem[]>("search-depositos", params)

    }

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) en los resultados de búsquedas. Eliminar si no es necesario
	protected mapSearchResult(row: any) {
        
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) al cargar un documento. Eliminar si no es necesario
    protected mapDocument(document: DepositoInfo) {

    }
	*/



}