﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
import * as moment from 'moment';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { DeudorItem,DeudorInfo } from '../models/deudor'

@Injectable()
export class DeudorService extends CatalogService<DeudorInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/credito/deudores");
    }

    create(): Promise<DeudorInfo> {
        return Promise.resolve(new DeudorInfo());
    }

    loadBloqueados(idEmpresa: number, fecha: Date): Promise<DeudorItem[]> {
        let params: HttpParams = new HttpParams()
            .set("idEmpresa", idEmpresa.toString())
            .set("fecha", moment(fecha).format());
        return this.apiService.get<DeudorItem[]>("load-bloqueados", params)
            .toPromise();
    }

    desbloquear(idDeudor: number, fecha: Date): Promise<any> {
        let params: HttpParams = new HttpParams()
            .set('IdDeudor', idDeudor.toString())
            .set("Fecha", moment(fecha).format());
        return this.apiService.post<any>('desbloquear', params)
            .toPromise();
    }


}
