﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Framework
import { Context, DocumentInfo, DocumentItem, DocumentService } from 'framework3/core';
//Locales
import { FacturaInfo, FacturaItem } from '../models/factura';
import { FacturaDetail } from '../models/factura-detail';

@Injectable()
export class FacturaService extends DocumentService<FacturaDetail, FacturaInfo> {

    constructor(protected http: HttpClient, protected context: Context ) {
        super(http, context, 'api/credito/facturas');
    }

    create(): Promise<FacturaInfo> {
        let newDoc = new FacturaInfo();
        return Promise.resolve(newDoc);
    }

    searchKeyword(idBranch: number, keyword: string, idDeudor: number, idGrupoDeudor: number): Observable<FacturaItem[]> {
        let params: HttpParams = new HttpParams()
            .set("idBranch", idBranch.toString())
            .set("keyword", keyword)
            .set("idDeudor", idDeudor.toString())
            .set("idGrupoDeudor", idGrupoDeudor.toString());
        return this.apiService.get<FacturaItem[]>("search-facturas", params)            
    }


	/*
    sampleMethod(param: string): Promise<MovimientoInfo> {
        let params: URLSearchParams = new URLSearchParams();
        params.set('param', param);                
        return this.apiService.getData('sample-method', params)
            .map(response => response.json() as MovimientoInfo)
            .toPromise();
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) en los resultados de búsquedas. Eliminar si no es necesario
	protected mapSearchResult(row: any) {
        
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) al cargar un documento. Eliminar si no es necesario
    protected mapDocument(document: FacturaInfo) {

    }
	*/



}