﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { GrupoDeudorInfo, GrupoDeudorItem } from '../models/grupo-deudor';
import { DeudorItem } from '../models/deudor'

@Injectable()
export class GrupoDeudorService extends CatalogService<GrupoDeudorInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/credito/grupos-deudores");
    }

    create(): Promise<GrupoDeudorInfo> {
        return Promise.resolve(new GrupoDeudorInfo());
    }

    getGrupoDeudor(): Promise<GrupoDeudorItem[]> {
        let params: HttpParams = new HttpParams();
        return this.apiService.get<GrupoDeudorItem[]>('get-grupo-deudor', params)            
            .toPromise();
    }

    getDeudoresList(idGrupoDeudor: number): Promise<DeudorItem[]> {
        let params: HttpParams = new HttpParams()
            .set('idGrupoDeudor', idGrupoDeudor.toString());
        return this.apiService.get<DeudorItem[]>('list-deudores', params)
            .toPromise();
    }
}

