﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { NotaTipoInfo, NotaTipoItem } from '../models/nota-tipo';
import { NotaConceptoItem } from '../../accounting/models/nota-concepto'

@Injectable()
export class NotaTipoService extends CatalogService<NotaTipoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/credito/notas-tipos');
    }

    create(): Promise<NotaTipoInfo> {
        return Promise.resolve(new NotaTipoInfo());
    }

    loadList(idSucursal: number): Promise<NotaTipoItem[]> {
        let params: HttpParams = new HttpParams()
            .set('idSucursal', idSucursal.toString());
        return this.apiService.get<NotaTipoItem[]>('load-list', params)
            .toPromise();
    }

    loadConceptosList(idSucursal: number, idNotaTipo: number): Promise<NotaConceptoItem[]> {
        let params: HttpParams = new HttpParams()
            .set('idSucursal', idSucursal.toString())
            .set('idNotaTipo', idNotaTipo.toString());
        return this.apiService.get<NotaConceptoItem[]>('load-conceptos-list', params)
            .toPromise();
    }


	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<NotaTipoInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<NotaTipoInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

