﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { PerfilAutoCobroTipoInfo, PerfilAutoCobroTipoItem } from '../models/perfil-auto-cobro-tipo'

@Injectable()
export class PerfilAutoCobroTipoService extends CatalogService<PerfilAutoCobroTipoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/credito/perfiles-auto-cobros-tipos');
    }

    create(): Promise<PerfilAutoCobroTipoInfo> {
        return Promise.resolve(new PerfilAutoCobroTipoInfo());
    }

    loadList(idSucursal: number): Promise<PerfilAutoCobroTipoItem[]> {
        let params: HttpParams = new HttpParams()
            .set('idSucursal', idSucursal.toString());
        return this.apiService.get<PerfilAutoCobroTipoItem[]>('load-list', params)
            .toPromise();
    }


	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<PerfilAutoCobroTipoInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<PerfilAutoCobroTipoInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

