﻿import { Component, ViewChild } from '@angular/core';
import { FormGroup, FormBuilder} from '@angular/forms';
import { Router, Route, ActivatedRoute } from '@angular/router';

import { Context, ProcessComponent, PolicyInfo } from 'framework3/core';
import { AlertsBarComponent} from 'framework3/controls'
import { CuentasService} from '../services/cuentas.service';

@Component({
    selector: 'accounting-cuentas-importar',
    templateUrl: './cuentas-importar.component.html'
})
export class CuentasImportarComponent extends ProcessComponent {
    form: FormGroup;

    @ViewChild(AlertsBarComponent) alerts: AlertsBarComponent;

    constructor(protected context: Context, protected router: Router, protected route: ActivatedRoute, private formBuilder: FormBuilder, private cuentasService: CuentasService
        
    ) {
        super(context, router, route);
        this.form = formBuilder.group({

        });
    }

    addImportar() {
        this.context.app.showSpinner();
        this.cuentasService.importar(this.context.app.defaultCompany.identity)
            .then(_ => {
                this.context.app.hideSpinner();
                this.showAlert("Se han importado las Cuentas.", "success");
            })
            .catch(error => this.handleError(error))
    }

    //Implementacion de politicas
    applyPolicy(policy: PolicyInfo) {

    }

    showAlert(message: string, type: string) {
        this.context.app.hideSpinner();
        this.alerts.showAlert(message, type);
    }

    handleError(error: any) {
        this.context.app.hideSpinner();
        let message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    }

}