﻿import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

import { FormsModule, ReactiveFormsModule } from '@angular/forms';
//Modulos Azteca
import { CoreModule } from 'framework3/core';
import { EditorsModule } from 'framework3/editors';
import { SearchModule } from 'framework3/search';
import { GeneralModule } from 'framework3/general';
import { ControlsModule } from 'framework3/controls';
import { SecurityModule } from 'framework3/security';
import { NotificationModule } from 'framework3/notification';
import { CreditRoutingModule } from './credit.routing.module';
import { QueueModule } from 'framework3/queue';

import { TranslatorModule } from '../../../translator/index';

//Bootstrap
import { TabsModule, ModalModule } from 'ngx-bootstrap';
//Wijmo
import { WjCoreModule } from 'wijmo/wijmo.angular2.core';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
//Azteca Kernel
//import { InventoryModule } from '../inventory/inventory.module';

/////////////////////////////// Servicios ////////////////////////////
import { CustomCuentaPorCobrarService } from './services/cuenta-por-cobrar.service';
import { CustomMantenimientoCreditoService } from './services/mantenimiento-credito.service'

import { CuentasService } from '../accounting/services/cuentas.service';

//////////////////////////// parts ////////////////////////////////
import { ImportarPedidosComponent } from './parts/importar-pedidos.component';
import { contribuyentesUnificador } from './maintenances/contribuyentes-multiplicados-unificar.component'

import { CuentasImportarComponent } from '../accounting/maintenances/cuentas-importar.component';

//////////////////////////// Services /////////////////////////////
import { CobranzaFormatoService } from './services/cobranza-formato.service';

//////////////////////////// Componentes /////////////////////////////
import { FormatoCobranzaEditor } from './maintenances/formato-cobranza.editor';
import { FormatoCobranzaManager } from './maintenances/formato-cobranza.manager';

/////////////////////////////////////////////////////////////////////////////////
let COMPONENTES = [ImportarPedidosComponent, contribuyentesUnificador, CuentasImportarComponent, FormatoCobranzaEditor, FormatoCobranzaManager];

let SERVICIOS = [CustomCuentaPorCobrarService, CustomMantenimientoCreditoService, CuentasService, CobranzaFormatoService];

@NgModule({
    imports: [
        CommonModule, FormsModule, ReactiveFormsModule,
        TabsModule.forRoot(), ModalModule.forRoot(),
        CoreModule, EditorsModule, SearchModule, GeneralModule, ControlsModule, SecurityModule, NotificationModule, CreditRoutingModule, QueueModule,
        WjCoreModule, WjInputModule, WjGridModule, WjGridFilterModule, TranslatorModule
    ],
    declarations: COMPONENTES,
    providers: SERVICIOS,
    exports: COMPONENTES
})
export class CreditModule {

}

