﻿    import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

//////////////////////////// Guards //////////////////////////////////
import { AuthGuard } from 'framework3/core';
import { EditorDeactivateGuard } from 'framework3/editors';

//Parts//
import { ImportarPedidosComponent } from './parts/importar-pedidos.component';
import { contribuyentesUnificador } from './maintenances/contribuyentes-multiplicados-unificar.component';

import { CuentasImportarComponent } from '../accounting/maintenances/cuentas-importar.component';

import { FormatoCobranzaEditor } from './maintenances/formato-cobranza.editor';
import { FormatoCobranzaManager } from './maintenances/formato-cobranza.manager';

///////////////////////////// Rutas /////////////////////////////////

const routes: Routes = [
    {
        path: '',
        canActivateChild: [AuthGuard],
        children: [
            { path: 'importarPedidos/:proceso', component: ImportarPedidosComponent },
            { path: 'contribuyentesUnificar/:proceso', component: contribuyentesUnificador },
            { path: 'importar-cuentas/:proceso', component: CuentasImportarComponent },
            { path: 'importar-cuentas/:proceso', component: CuentasImportarComponent },

            { path: 'fomatos-cobranza/:proceso', component: FormatoCobranzaManager },
            { path: 'fomatos-cobranza/:proceso/new', component: FormatoCobranzaEditor }

        ]
    },
];



@NgModule({
    imports: [
        RouterModule.forChild(routes)
    ],
    exports: [
        RouterModule
    ]
})
export class CreditRoutingModule { }
