﻿import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

import { FormsModule, ReactiveFormsModule } from '@angular/forms';
//Modulos Azteca
import { CoreModule } from 'framework3/core';
import { EditorsModule } from 'framework3/editors';
import { SearchModule } from 'framework3/search';
import { GeneralModule } from 'framework3/general';
import { ControlsModule } from 'framework3/controls';
import { SecurityModule } from 'framework3/security';
import { NotificationModule } from 'framework3/notification';
//Bootstrap
import { TabsModule, ModalModule } from 'ngx-bootstrap';
//Wijmo
import { WjCoreModule } from 'wijmo/wijmo.angular2.core';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
//Azteca Kernel

// Azteca Custom Credit
import { CreditModule as CustomCreditModule} from '../credit/credit.module';

// Azteca Custom Distribution
import { DistributionRoutingModule as DistributionRouting } from './distribution.rounting.module';

/////////////////////////////// Servicios ////////////////////////////
import * as fromServices from './services';
const SERVICIOS = Object.keys(fromServices).map(key => fromServices[key]);

//////////////////////////// parts ////////////////////////////////

//////////////////////////// Maintenances /////////////////////////////
import * as fromMaintenances from './maintenances';
const MAINTENANCES = Object.keys(fromMaintenances).map(key => fromMaintenances[key]);

/////////////////////////////////////////////////////////////////////////////////

let COMPONENTES = [...MAINTENANCES];


@NgModule({
    imports: [
        CommonModule, FormsModule, ReactiveFormsModule,
        TabsModule.forRoot(), ModalModule.forRoot(),
        CoreModule, EditorsModule, SearchModule, GeneralModule, ControlsModule, SecurityModule, NotificationModule, DistributionRouting,
        WjCoreModule, WjInputModule, WjGridModule, WjGridFilterModule,
        CustomCreditModule
    ],
    declarations: COMPONENTES,
    providers: SERVICIOS,
    exports: COMPONENTES
})
export class DistributionModule {

}

