﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http'; import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, BaseService } from 'framework3/core';
import { SearchResult, SearchRequest } from 'framework3/search';

@Injectable()
export class PedidoPixcuaService extends BaseService {

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/custom/aga/distribucion/pedidos");
    }

    generarPedidoPixcua(idPedidoTit: string, idSucursal: number, codigoSucursal, origen: string, regenerar: boolean): Promise<boolean> {
        let params = new HttpParams()
            .set("idPedidoTit", idPedidoTit)
            .set("idSucursal", idSucursal.toString())
            .set("codigoSucursal", codigoSucursal)
            .set("origen", origen)
            .set("regenerar", regenerar.toString());
        return this.apiService.post<boolean>("generar-pedido-pixcua", params, null).toPromise();
    }

}