﻿import { NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';

//Kernel
import { CoreModule } from 'framework3/core';
import { ControlsModule } from 'framework3/controls';
import { SearchModule } from 'framework3/search';

//Bootstrap
import { TabsModule, ModalModule } from 'ngx-bootstrap';
//Wijmo
import { WjCoreModule } from 'wijmo/wijmo.angular2.core';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjChartModule } from 'wijmo/wijmo.angular2.chart';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';

//Ipati
import { DashboardRoutingModule } from './dashboard.routing.module';

//COMPONENTES
import { RouterComponent } from './router.component';

//SERVICIOS

let COMPONENTES = [RouterComponent];

let SERVICIOS = [];

@NgModule({
    imports: [
        FormsModule, ReactiveFormsModule, CommonModule,
        TabsModule.forRoot(), ModalModule.forRoot(),
        CoreModule, ControlsModule, SearchModule, DashboardRoutingModule,
        WjCoreModule, WjInputModule, WjGridModule, WjGridFilterModule, WjChartModule, WjInputModule
    ],
    declarations: COMPONENTES,
    providers: SERVICIOS,
    exports: COMPONENTES
})
export class DashboardModule {
}