﻿import { Component, EventEmitter, Input, Output, ViewChild, OnInit } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Context } from 'framework3/core';

import { UsuarioService, UsuarioInfo, SessionInfo, SucursalService, EmpresaService, ModuloService, RolInfo, RolService } from 'framework3/core';


@Component({
    selector: 'router-component',
    templateUrl: './router.component.html'
})
export class RouterComponent {

    constructor(private route: ActivatedRoute, private router: Router, private context: Context, private rolService: RolService) {

    }

    ngAfterViewInit() {
        //Obtener el Roll del usuario y la direccion del tablero que se debe mostrar
        if (this.context.session.user.idRol > 0) {
            this.rolService.getDetailByID(this.context.session.user.idRol)
                .then(rol =>this.navigate(rol) )
                .catch(error => this.handleError(error));
        }
    }

    navigate(rol:RolInfo) {
        this.router.navigate(['../', rol.url], {relativeTo: this.route});
    }

    handleError(error: any) {
        console.error(error);
    }

}