﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

//Features
import { CelulaItem } from '../../models/celula';
import { CelulaService } from '../../services/celula.service';

@Component({
    selector: 'distribution-celulas-list',
    templateUrl: './celulas-list.html'
})
export class CelulasListComponent extends CatalogListDialog {
    celulas: CelulaItem[];

    constructor(protected context: Context, private celulaService: CelulaService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.celulaService.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.celulas = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedProductos: CelulaItem[]) {
        this.selectedItemsChanged.emit(selectedProductos);
    }

    onSelectedItemChanged(producto: CelulaItem) {
        this.selectedItemChanged.emit(producto);
    }

}