﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

//Features
import { ProductosItem } from '../../models/productos';
import { ProductosService } from '../../services/productos.service';

@Component({
    selector: 'distribution-productos-list',
    templateUrl: './productos-list.html'
})
export class ProductosListComponent extends CatalogListDialog {
    productos: ProductosItem[];

    constructor(protected context: Context, private productosService: ProductosService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.productosService.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.productos = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedProductos: ProductosItem[]) {
        this.selectedItemsChanged.emit(selectedProductos);
    }

    onSelectedItemChanged(producto: ProductosItem) {
        this.selectedItemChanged.emit(producto);
    }

}