﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

import { RutasRepartoService } from '../services/rutas-reparto.service';
import { RutasRepartoItem } from '../models/rutas-reparto';

//

@Component({
    selector: 'purchasing-rutas-reparto-list',
    templateUrl: './ruta-reparto-list.component.html'
})
export class RutasRepartoListComponent extends CatalogListDialog {
    rutasReparto: RutasRepartoItem[];

    constructor(protected context: Context, private rutasRepartoService: RutasRepartoService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.rutasRepartoService.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.rutasReparto = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedItems: RutasRepartoItem[]) {
        this.selectedItemsChanged.emit(selectedItems);
    }

    onSelectedItemChanged(item: RutasRepartoItem) {
        this.selectedItemChanged.emit(item);
    }

}