﻿import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
//Modulos Azteca
import { CoreModule } from 'framework3/core';
import { EditorsModule } from 'framework3/editors';
import { SearchModule } from 'framework3/search';
import { GeneralModule } from 'framework3/general';
import { ControlsModule } from 'framework3/controls';
import { SecurityModule } from 'framework3/security';
import { GeolocationModule } from 'framework3/geolocation';
import { DistributionRoutingModule } from './distribution.routing.module';
import { SalesModule } from '../sales/sales.module';
import { AccountingModule } from '../accounting/accounting.module';
import { RhModule } from '../rh/rh.module';
import { CreditModule } from '../credit/credit.module';
import { InventoryModule } from '../inventory/inventory.module';
import { MaintenanceModule } from '../maintenance/maintenance.module';
import { TranslatorModule } from '../translator/index';

//Bootstrap
import { TabsModule, ModalModule } from 'ngx-bootstrap';
//Wijmo
import { WjCoreModule } from 'wijmo/wijmo.angular2.core';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjGridDetailModule } from 'wijmo/wijmo.angular2.grid.detail';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';

/////////////////////////////// Servicios ////////////////////////////
import { GamaService } from '../distribution/services/gama.service';
import { GrupoBeneficiosService } from '../distribution/services/grupo-beneficios.service';
import { EstVenService } from '../distribution/services/est-ven.service';
import { CelulaService } from '../distribution/services/celula.service';
import { ClienteService } from '../distribution/services/cliente.service';
import { RutasRepartoService } from './services/rutas-reparto.service';
import { ProductosService } from './services/productos.service';
import { CentrosService } from './services/centros.service';
import { RutasPreventaService } from './services/rutas-preventa.service';
import { SegmentosService } from './services/segmentos.service';
import { TerritoryPlannerService } from './services/territory-planner.service';
import { PedidoService } from './services/pedido.service';
import { ConteoService } from './services/conteo.service';
import { CargaFisicaService } from './services/carga-fisica.service';
import { FormaVentaService } from './services/forma-venta.service';
import { TipoConteoService } from './services/tipo-conteo.service';
import { EmpresaService } from './services/empresa.service';
import { SucursalService } from './services/sucursal.service';
import { CobranzaService as DistribucionCobranzaService } from './services/cobranza.service';
import { ValeTipoService } from './services/vale-tipo.service';
import { ValeService } from './services/vale.service';
import { TipoCapturaService } from './services/tipo-captura.service';
import { TripulanteTipoService } from './services/tripulante-tipo.service';
import { TripulacionService } from './services/tripulacion.service';
import { ValePagoService } from './services/vale-pago.service';
import { FrecuenciaVisitaService } from './services/frecuencia-visita.service';
import { FrecuenciaService } from './services/frecuencia.service';
import { ReestructuraService } from './services/reestructura.service';
import { ReestructuraEditorService } from './services/reestructura-editor-service';
//////////////////////////// Catalogos ////////////////////////////////
import { GamasManager } from '../distribution/catalogs/gamas.manager';
import { GamasEditor } from '../distribution/catalogs/gamas.editor';
import { GruposBeneficiosManager } from '../distribution/catalogs/grupos-beneficios.manager';
import { GruposBeneficiosEditor } from '../distribution/catalogs/grupos-beneficios.editor';
import { EstVenManager } from '../distribution/catalogs/est-ven.manager';
import { CelulasManager } from '../distribution/catalogs/celulas.manager';
import { CelulasEditor } from '../distribution/catalogs/celulas.editor';
import { ClientesManager } from '../distribution/catalogs/clientes.manager';
import { ClientesEditor } from '../distribution/catalogs/clientes.editor';
import { RutasRepartoManager } from './catalogs/rutas-reparto.manager';
import { RutasRepartoEditor } from './catalogs/rutas-reparto.editor';
import { ProductosManager } from './catalogs/productos.manager';
import { ProductosEditor } from './catalogs/productos.editor';
import { CentrosManager } from './catalogs/centros.manager';
import { CentrosEditor } from './catalogs/centros.editor';
import { RutasPreventaManager } from './catalogs/rutas-preventa.manager';
import { RutasPreventaEditor } from './catalogs/rutas-preventa.editor';
import { SegmentosManager } from './catalogs/segmentos.manager';
import { SegmentosEditor } from './catalogs/segmentos.editor';
import { FormasVentasManager } from './catalogs/formas-ventas.manager';
import { TiposConteosEditor } from './catalogs/tipos-conteos.editor'
import { TiposConteosManager } from './catalogs/tipos-conteos.manager';
import { EmpresasEditor } from './catalogs/empresas.editor'
import { EmpresasManager } from './catalogs/empresas.manager';
import { SucursalesEditor } from './catalogs/sucursales.editor'
import { SucursalesManager } from './catalogs/sucursales.manager';
import { ValesTiposEditor } from './catalogs/vales-tipos.editor'
import { ValesTiposManager } from './catalogs/vales-tipos.manager';
import { TiposCapturasEditor } from './catalogs/tipos-capturas.editor'
import { TiposCapturasManager } from './catalogs/tipos-capturas.manager';
import { TripulantesTiposEditor } from './catalogs/tripulantes-tipos.editor'
import { TripulantesTiposManager } from './catalogs/tripulantes-tipos.manager';
import { FrecuenciasVisitaEditor } from './catalogs/frecuencias-visita.editor'
import { FrecuenciasVisitaManager } from './catalogs/frecuencias-visita.manager';
import { FrecuenciasEditor } from './catalogs/frecuencias.editor';
import { FrecuenciasManager } from './catalogs/frecuencias.manager';
//////////////////////////// Mantenimientos /////////////////////////////
import { Conteo } from './maintenances/conteo';
import { ReestructuraDistribucion } from './maintenances/Reestructura.maintenance'; 
import { ReestructuraEditor } from './maintenances/reestructura-editor'; 
import { reestructurafile } from './maintenances/reestructura-file'; 
import { reestructura_editor_detalle } from './maintenances/reestructura-editor-detalle'; 
///////////////////////////// Dialogs //////////////////////////////
import { RutasRepartoListComponent } from './dialogs/ruta-reparto-list.component';

//////////////////////////// Componentes /////////////////////////////
import { EstVenSelectorComponent } from './controls/est-ven-selector.component';
import { ProductoNuevoComponent } from './components/nuevo-producto.component';
import { ProductosListComponent } from './components/dialogs/productos-list';
import { GamaProductosComponent } from './components/gama-productos.component';
import { CentrosSelectorComponent } from './controls/centro-selector.component';
import { AgregarDotacionesComponent } from './components/agregar-dotacion.component';
import { RutasRepartoSelectorComponent } from './controls/ruta-reparto-selector.component'
import { RutasPreventaSelectorComponent } from './controls/ruta-preventa-selector.component'
import { CelulasSelectorComponent } from './controls/celula-selector.component'
import { CelulasListComponent } from './components/dialogs/celulas-list';
import { RutasRepartoCelulasComponent } from './components/rutasreparto-celulas.component';
import { RutasPreventaCelulasComponent } from './components/rutaspreventa-celulas.component';
import { SegmentosSelectorComponent } from './controls/segmento-selector.component'
import { GamasSelectorComponent } from './controls/gama-selector.component'
import { ImpresionFacturasComponent } from './components/impresion-facturas.component'
import { CancelarFacturasComponent } from './components/cancelar-facturas.component'
import { ClienteSelectorComponent } from './controls/cliente-selector.component'
import { ProductosSelectorComponent } from './controls/producto-selector.component'
import { FormaVentaSelectorComponent } from './controls/forma-venta-selector.component'
//Territory planner
import { TerritoryPlannerComponent } from './maps/territory-planner.component';


///////////////////////////// Document /////////////////////////////////
import { PedidosManager } from './documents/pedidos.manager';
import { PedidosEditor } from './documents/pedidos.editor';
import { ConteosManager } from './documents/conteos.manager'
import { ConteosEditor } from './documents/conteos.editor'
import { CargasFisicasManager } from './documents/cargas-fisicas.manager';
import { CargasFisicasEditor } from './documents/cargas-fisicas.editor';
import { CargaFisicaDetailEditor } from './documents/parts/cargas-fisicas-detail.editor';
import { ValesManager } from './documents/vales.manager';
import { ValesEditor } from './documents/vales.editor';
import { TripulacionesManager } from './documents/tripulaciones.manager';
import { TripulacionesEditor } from './documents/tripulaciones.editor';
import { ValesPagosManager } from './documents/vales-pagos.manager';
import { ValesPagosEditor } from './documents/vales-pagos.editor';

//////////////////////////// Parts /////////////////////////////////////
import { GamasElementosComponent } from './parts/gamas-elementos.component';
import { ProductosInfoComponent } from './parts/productos-info.component';
import { PedidoDetailEditor } from './documents/parts/pedidos-detail.editor';
import { ConteoDetailEditor } from './documents/parts/conteos-detail.editor';
import { ValeDetailEditor } from './documents/parts/vales-detail.editor';
import { TripulacionDetailEditor } from './documents/parts/tripulaciones-detail.editor';
import { NuevaTripulacionComponent } from './documents/parts/nueva-trupulacion.component';
import { ValePagoDetailEditor } from './documents/parts/vales-pagos-detail.editor';
import { NuevoPagoValeComponent } from './documents/parts/nuevo-vale-pago.component';
import { CelulasAreaComponent } from './parts/celulas-area.component';
import { FrecuenciasAreaComponent } from './parts/frecuencias-area.component';

///////////////////////////// Maintenance /////////////////////////////////
import { CargaFisicaMaintenanceComponent } from './maintenances/carga-fisica.maintenance';
import { CobranzaMaintenanceComponent } from './maintenances/cobranza.maintenance';

/////////////////////////////////////////////////////////////////////////////////
let COMPONENTES = [GamasManager, GamasEditor, GamasElementosComponent, GruposBeneficiosManager, GruposBeneficiosEditor, EstVenManager, EstVenSelectorComponent, CelulasManager, CelulasEditor,
    ClientesManager, ClientesEditor, RutasRepartoManager, RutasRepartoEditor, ProductosManager, ProductosEditor, ProductosInfoComponent, ProductoNuevoComponent, ProductosListComponent,
    GamaProductosComponent, CentrosManager, CentrosEditor,  CentrosSelectorComponent,  AgregarDotacionesComponent, RutasRepartoSelectorComponent, RutasPreventaSelectorComponent,
    CelulasSelectorComponent, CelulasListComponent, RutasRepartoCelulasComponent, CelulasAreaComponent, RutasPreventaManager, RutasPreventaEditor, RutasPreventaCelulasComponent, SegmentosManager, SegmentosEditor,
    SegmentosSelectorComponent, GamasSelectorComponent, ImpresionFacturasComponent, CancelarFacturasComponent, TerritoryPlannerComponent,   
    PedidosManager, PedidosEditor, PedidoDetailEditor, ClienteSelectorComponent, ProductosSelectorComponent, ConteosManager, ConteosEditor, ConteoDetailEditor, FormasVentasManager, FormaVentaSelectorComponent,
    TiposConteosManager, TiposConteosEditor, Conteo, CargaFisicaMaintenanceComponent, CobranzaMaintenanceComponent,
    SucursalesManager, SucursalesEditor, EmpresasManager, EmpresasEditor, ValesTiposManager, ValesTiposEditor, CargasFisicasManager, CargasFisicasEditor, CargaFisicaDetailEditor,
    ValesManager, ValesEditor, ValeDetailEditor, TiposCapturasManager, TiposCapturasEditor,
    TripulantesTiposManager, TripulantesTiposEditor, TripulacionesManager, TripulacionesEditor, NuevaTripulacionComponent, TripulacionDetailEditor,
    ValesPagosManager, ValesPagosEditor, ValePagoDetailEditor, NuevoPagoValeComponent, RutasRepartoListComponent, FrecuenciasVisitaManager, FrecuenciasVisitaEditor, FrecuenciasManager, FrecuenciasEditor, FrecuenciasAreaComponent, ReestructuraDistribucion, ReestructuraEditor, reestructurafile, reestructura_editor_detalle];
let SERVICIOS = [GamaService, GrupoBeneficiosService, EstVenService, CelulaService, ClienteService, RutasRepartoService, ProductosService, CentrosService,  RutasPreventaService,
    SegmentosService, TerritoryPlannerService, PedidoService, ConteoService, FormaVentaService, TipoConteoService, CargaFisicaService, DistribucionCobranzaService, SucursalService, EmpresaService, ValeTipoService,
    ValeService, TipoCapturaService, TripulanteTipoService, TripulacionService, ValePagoService, FrecuenciaVisitaService, FrecuenciaService, ReestructuraService, ReestructuraEditorService];

@NgModule({
    imports: [
        CommonModule, FormsModule, ReactiveFormsModule,
        TabsModule.forRoot(), ModalModule.forRoot(),
        CoreModule, EditorsModule, SearchModule, GeneralModule, ControlsModule, SecurityModule, SalesModule, AccountingModule, CreditModule, InventoryModule, RhModule, DistributionRoutingModule, GeolocationModule,
        MaintenanceModule,
        WjCoreModule, WjInputModule, WjGridModule, WjGridFilterModule, WjGridDetailModule, TranslatorModule
    ],
    declarations: COMPONENTES,
    providers: SERVICIOS,
    exports: COMPONENTES
})
export class DistributionModule {

}
