﻿import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { FormGroup, FormBuilder, AbstractControl, Validators } from '@angular/forms';
import { EmpleadoSelectorComponent } from '../../../rh/components/empleado-selector.component'

//Kernel
import { Context } from 'framework3/core';
import { BasicEditor, ChangeState } from 'framework3/editors';
//Locales
import { TripulacionDetail } from '../../models/tripulacion-detail';

@Component({
    selector: 'distribucion-tripulacion-detail-editor',
    templateUrl: './tripulaciones-detail.editor.html'
})
export class TripulacionDetailEditor extends BasicEditor {    
    //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
    detailCopy = new TripulacionDetail();
    //Objeto original que se editará
    @Input() detail: TripulacionDetail = new TripulacionDetail();

    @ViewChild('selectorEmpleado') selectorEmpleado: EmpleadoSelectorComponent;


    constructor(protected context: Context, private builder: FormBuilder) {
        super(context);

        this.form = builder.group({
            'idEmpleado': [0],
        });
    }

    /////////////////// METODOS ///////////////////////////////


    /////////////////// HANDLERS //////////////////////////////

    onCreatingItem() {
        this.detailCopy = this.detail;
		this.form.reset({ sample: '' });
        this.form.markAsPristine();
    }

    onLoadingItem(detail: TripulacionDetail ) {
        this.detailCopy = <TripulacionDetail>this.copyItem(this.detail);
    }

    onUpdatingItem(detail: TripulacionDetail) {
        this.detailCopy.codigoEmpleado = this.selectorEmpleado.selectedItem.code;
        this.detailCopy.nombreEmpleado = this.selectorEmpleado.selectedItem.persona.nombre + ' ' + this.selectorEmpleado.selectedItem.persona.apellidoPaterno + ' ' + this.selectorEmpleado.selectedItem.persona.apellidoMaterno;
        this.detailCopy
        if (this.detailCopy._clientID == 0) {
            this.detailCopy._clientID = this.createClientID();
        }
        else {
            this.detailCopy.state = ChangeState.MODIFIED;
        }
        this.savingItem.emit(this.detailCopy);
    }
}
