﻿import { DocumentDetail, TrackableItem } from 'framework3/core';
import { ProductosInfo } from './productos';
import { ArticuloInfo } from '../../sales/models/articulo';

export class CargaFisicaDetail extends DocumentDetail {
	idDocumento: string;
	fechaDocumento: Date;
	idTraspaso: string;
    fechaTraspaso: Date;
    origen: string;
    fechaApartado?: Date;
    fechaCarga?: Date;

    documentsDet: CargaFiscaDocumentsDetail[] = [];

    constructor() {
        super();
    }
}

export class CargaFiscaDocumentsDetail {

    numeroRef: number;
    idProducto: number;
    cantidad: number;
    codigo: string;
    nombre: string;

    producto?: ProductosInfo;
}

export class CargaFisicaProducto extends TrackableItem {

    idProducto: number;
    idArticulo: number;
    idTipoConteo: number;
    cantidad: number;

    producto?: ProductosInfo;
    articulo?: ArticuloInfo;

}