﻿import { Context, CatalogInfo, CatalogItem } from 'framework3/core';
import { ClienteInfo as ClienteVentas } from '../../sales/models/cliente';
import { Position } from 'framework3/geolocation';

export class ClienteInfo extends CatalogInfo {
	idClienteVentas: number;
	atiende: string;
	codigoBarras: string;
	manejaPaquetes: boolean;
	idClienteCategoria: number;
	idGrupoBeneficio: number;
	idGama: number;
    idCelula: number;

	porcBonificacion: number;
	saldoBonificacion: number;
	tipoBonificacion: string;
	autVale: boolean;
	autDescVale: boolean;
    autDoctos: boolean;

	idReferencia: number;
	referencia: string;
	altaOrigen: string;
    idCuentaContable: number;

    clienteVentas: ClienteVentas;

    constructor() {
        super();
        this.clienteVentas = new ClienteVentas();         
    }
}

export class ClienteItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    posicion: Position;
    activo: boolean;
    estatus?: string;
    selected?: boolean = false;

    constructor() {
        this.posicion = new Position();
    }
}

export class ClienteRutasItem {
    idRutaPreventa: number;
    rutaPreventa: string;
    idRutaReparto: number;
    rutaReparto: string;
}