﻿import { DocumentInfo, DocumentItem, TrackableItem } from 'framework3/core';
import { CobranzaDetail } from './cobranza-detail';
import { FormaVentaInfo } from './forma-venta';
import { TipoPagoInfo } from './tipo-pago';

export class CobranzaInfo extends DocumentInfo<CobranzaDetail> {
	fechaAfectacion: Date;
	idCaja: number;
	idCorte: string;
	folioCorte: number;
	idRutaReparto: number;
	idEmpleado: number;
	observaciones: string;
	importe: number;
	monto: number;
    total: number;
    documentos: CobranzaDocumento[] = [];

    constructor() {
        super();
    }
}

export class CobranzaItem extends DocumentItem {

}

export class CobranzaDocumento extends TrackableItem {

    idDocumento: string;
    fechaDocumento: Date;
    idFormaVenta: number;
    idTipoPago: number;
    importe: number;
    origen: string;
    formaVenta?: FormaVentaInfo;
    tipoPago?: TipoPagoInfo;

    constructor() {
        super();
    }

}