﻿import { DocumentDetail } from 'framework3/core';
import { ImpuestoDetailInfo } from '../../accounting';
import { DescuentosInfo } from './descuentos';
import { ProductosInfo } from './productos';
import { UnidadMedidaInfo } from '../../inventory';

export class PedidoDetail extends DocumentDetail {
   	hora: Date;
	fechaCaptura: Date;
	horaInicio: Date;
	horaFin: Date;
	idVenta: string;
	fechaVenta: Date;
    idProducto: number;
    idUnidadMedida:number
	cantidadPTA: number;
	cantidadCAR: number;
    cantidadREC: number;
    cantidadVTA: number;
    //cantidades para fraccionables
    cantidad: number;
    unidades: number;

    precioUnitario: number;
    importe: number;
	
	idFormaVenta: number;
	idTipoPago: number;
	referencia: string;
	fechaReferencia: Date;
	idLote: number;
	numSerie: string;
	fechaCaducidad: Date;

    descuentos: DescuentosInfo;
    impuestos: ImpuestoDetailInfo[];
    producto: ProductosInfo;
    unidadMedida: UnidadMedidaInfo;

    constructor() {
        super();        
        this.producto = new ProductosInfo();
        this.descuentos = new DescuentosInfo();
        this.unidadMedida = new UnidadMedidaInfo();
        this.impuestos = [];
        this.cantidad=0;
        this.unidades = 0;
        this.precioUnitario = 0;
        this.importe = 0;
        this.idUnidadMedida = 0;
    }
}