﻿import { Context, CatalogInfo, CatalogItem, TrackableItem } from 'framework3/core';
import { ArticuloInfo } from '../../sales/models/articulo';
import { ContenedorInfo } from './contenedor';

export class ProductosInfo extends CatalogInfo {
    idArticulo: number;
    espacioUtilizado: number;
    idUnidadCarga: number;
    contenido: number;
    idUnidadContenido: number;
    aplicaCambios: boolean;
    aplicaIntroduccion: boolean;
    aplicaBonificacion: boolean;

    articulo: ArticuloInfo;
    contenedores?: ContenedorItem[];

    constructor() {
        super();
        this.articulo = new ArticuloInfo();
    }
}

export class ProductosItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
    selected?: boolean = false;
}


export class ContenedorItem extends TrackableItem {

    idContenedor: number;
    piezas: number;
    contenedor?: ContenedorInfo;

}