﻿import { Context, CatalogInfo, CatalogItem } from 'framework3/core';
import { ArticuloStockInfo } from '../../inventory/models/articulo-stock';
import { TrackableItem } from 'framework3/core';

export class RutasRepartoInfo extends CatalogInfo {
    nombre: string;
    idEstVen: number;
    idClienteGenerico: number;
    idDispositivoCaptura: number;
    idAlmacen: number;
    idAlmacenCarga: number;
    tipoRuta: string;
    dotacion: boolean;
    idVehiculo: number;
    capacidad: number;
    idCuenta: number;

    dotaciones: DotacionesInfo[] = [];

    constructor() {
        super();
    }
}

export class RutasRepartoItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
    selected?: boolean = false;
    idAlmacenCarga?: number;
}

export class DotacionesInfo extends TrackableItem {
    idRutaDotacion: number;
    cantidad: number;
    articuloStock: ArticuloStockInfo;

    constructor() {
        super();
        this.cantidad = 0;
        this.articuloStock = new ArticuloStockInfo();
    }
}