﻿import { DocumentInfo, DocumentItem } from 'framework3/core';
import { ValeDetail } from './vale-detail';
import { ClienteInfo } from './cliente';
import { RutasRepartoInfo } from './rutas-reparto';

export class ValeInfo extends DocumentInfo<ValeDetail> {
	fechaAfectacion: Date;
	idValeTipo: number;
	idDocumentoRef: string;
	fechaDocumentoRef: Date;
	idCliente: number;
	idEmpleadoPreventa: number;
	idEmpleadoReparto: number;
	idRutaPreventa: number;
	idRutaReparto: number;
	fechaCarga: Date;
	fechaEntrega: Date;
	fechaVencimiento: Date;
	fechaLiquidacion: Date;
	horaInicio: Date;
	horaFin: Date;
	idListaPrecio: number;
	idTipoCaptura: number;
	prorrogas: number;
	pagos: number;
	idOrigen: number;
	idFactura: string;
	fechaFactura: Date;
	idVenta: string;
	fechaVenta: Date;
	totalCantidad: number;
	idDivisa: number;
	tipoCambio: number;
	subTotal: number;
	impuestosTrasladados: number;
	impuestosRetenidos: number;
	descuentos: number;
	flete: number;
	comision: number;
	total: number;
	idWorkFlowStep: number;

    cliente: ClienteInfo;
    rutaReparto: RutasRepartoInfo;

    constructor() {
        super();
        this.cliente = new ClienteInfo();
        this.rutaReparto = new RutasRepartoInfo();
    }
}

export class ValeItem extends DocumentItem {

}