﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService, FileLink } from 'framework3/core';
//Locales
import { CelulaInfo, CelulaItem } from '../models/celula'
import { CelulaArea } from '../models/celula-area'

@Injectable()
export class CelulaService extends CatalogService<CelulaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/distribucion/celulas');
    }

    create(): Promise<CelulaInfo> {
        return Promise.resolve(new CelulaInfo());
    }

    loadList(idSucursal: number): Promise<CelulaItem[]> {
        let params = new HttpParams()
            .append("idSucursal", idSucursal.toString());
        return this.apiService.get<CelulaItem[]>("load-list", params)
            .toPromise();
    }

    updateAreaFromFile(celulaArea: CelulaArea): Promise<boolean> {
        let params: HttpParams = new HttpParams();
        return this.apiService.post<any>('area-from-file', params, celulaArea)
            .toPromise();
    }

    generarKmlArea(idCelula: number): Promise<FileLink> {
        let params = new HttpParams()
            .set("IdCelula", idCelula.toString());
        return this.apiService.get<FileLink>("area-kml", params)
            .toPromise();
    }

}

