﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, HierarchyInfo, HierarchyService } from 'framework3/core';
//Locales
import { EstVenInfo } from '../models/est-ven';
import { EstVenTipoItem } from '../models/est-ven-tipo';


@Injectable()
export class EstVenService extends HierarchyService<EstVenInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/distribucion/est-ven");
    }

    create(): Promise<EstVenInfo> {
        return Promise.resolve(new EstVenInfo());
    }

    loadListTipos(idSucursal: number): Promise<EstVenTipoItem[]> {
        let params = new HttpParams()
            .append("idSucursal", idSucursal.toString());
        return this.apiService.get<EstVenTipoItem[]>("load-list-tipos", params)
            .toPromise();
    }

}
