﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, HierarchyInfo, HierarchyService } from 'framework3/core';
//Locales
import { FormaVentaInfo } from '../models/forma-venta';

@Injectable()
export class FormaVentaService extends HierarchyService<FormaVentaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/distribucion/formas-ventas");
    }

    create(): Promise<FormaVentaInfo> {
        return Promise.resolve(new FormaVentaInfo());
    }

	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<FormaVentaInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<FormaVentaInfo> ('sample-method', params)
            .toPromise();
    }
	*/

}
