﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService, FileLink } from 'framework3/core';
//Locales
import { FrecuenciaInfo } from '../models/frecuencia'
import { FrecuenciaArea } from '../models/frecuencia-area'


@Injectable()
export class FrecuenciaService extends CatalogService<FrecuenciaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/distribucion/frecuencias');
    }

    create(): Promise<FrecuenciaInfo> {
        return Promise.resolve(new FrecuenciaInfo());
    }

    updateAreaFromFile(frecuenciaArea: FrecuenciaArea): Promise<boolean> {
        let params: HttpParams = new HttpParams();
        return this.apiService.post<any>('area-from-file', params, frecuenciaArea)
            .toPromise();
    }

    generarKmlArea(idFrecuencia: number): Promise<FileLink> {
        let params = new HttpParams()
            .set("IdFrecuencia", idFrecuencia.toString());
        return this.apiService.get<FileLink>("area-kml", params)
            .toPromise();
    }

	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<FrecuenciaInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<FrecuenciaInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

