﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { GamaInfo, GamaItem } from '../models/gama'
import { ProductosItem } from '../models/productos'

@Injectable()
export class GamaService extends CatalogService<GamaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/distribucion/gamas");
    }

    create(): Promise<GamaInfo> {
        return Promise.resolve(new GamaInfo());
    }

    loadList(idSucursal: number): Promise<GamaItem[]> {
        let params = new HttpParams()
            .append("idSucursal", idSucursal.toString());
        return this.apiService.get<GamaItem[]>("load-list", params)
            .toPromise();
    }

 ///////////////////////////// Productos ////////////////////////////////////////////////

    LoadProductosList(idGama: number): Promise<ProductosItem[]> {
        let params = new HttpParams()
            .append("idGama", idGama.toString());
        return this.apiService.get<ProductosItem[]>("load-productos-list", params)
            .toPromise();
    }

    addMembers(idGama: number, productos: ProductosItem[]): Promise<any> {
        let params = new HttpParams()
            .set('idGama', idGama.toString());
        return this.apiService.post<any>('add-members', params, productos)
            .toPromise();
    }

    removeMember(idGama: number, idProducto: number): Promise<any> {
        let params = new HttpParams()
            .set('idGama', idGama.toString())
            .set('idProducto', idProducto.toString());
        return this.apiService.delete<any>('remove-member', params)
            .toPromise();
    }
}

