﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { GrupoBeneficiosInfo, GrupoBeneficiosItem } from '../models/grupo-beneficios'

@Injectable()
export class GrupoBeneficiosService extends CatalogService<GrupoBeneficiosInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/distribucion/gruposbeneficios");
    }

    create(): Promise<GrupoBeneficiosInfo> {
        return Promise.resolve(new GrupoBeneficiosInfo());
    }

    loadList(idSucursal: number): Promise<GrupoBeneficiosItem[]> {
        let params = new HttpParams()
            .append("idSucursal", idSucursal.toString());
        return this.apiService.get<GrupoBeneficiosItem[]>("load-list", params)
            .toPromise();
    }

}

