﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { ProductosInfo } from '../models/productos'
import { ArticuloStockItem } from '../../inventory/models/articulo-stock';

@Injectable()
export class ProductosService extends CatalogService<ProductosInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/distribucion/productos');
    }

    create(): Promise<ProductosInfo> {
        return this.apiService.get<ProductosInfo>('create', null)
            .toPromise();
    }

    // metodos para agregar un producto nuevo

    GetArticuloStock(idSucursal: number, codigo: string): Promise<ArticuloStockItem> {
        let params = new HttpParams()
            .append("idSucursal", idSucursal.toString())
            .append("codigo", codigo);
        return this.apiService.get<ArticuloStockItem>("get-articulo-stock", params)
            .toPromise();
    }

    articuloAsignadoCheck(idArticuloStock: number): Promise<boolean> {
        let params = new HttpParams()
            .append("idArticuloStock", idArticuloStock.toString());
        return this.apiService.get<boolean>("articulo-asignado-check", params)
            .toPromise();
    }

}