﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import * as moment from 'moment';
import 'rxjs/add/operator/toPromise';
    //Azteca Kernel
    import { Context, BaseService } from 'framework3/core';
import { SearchResult, SearchRequest } from 'framework3/search';
//Locales
import { ReestructuraTranspilerFormato } from '../models/reestructura-transpiler-formato';
import { getTituloReestructura } from '../models/get-reestructura-titulo';
import { getReestructuraDetalle } from '../models/get-reestructura-detalle';
import { DateTime } from 'wijmo/wijmo';

@Injectable()
export class ReestructuraService extends BaseService
{
    arrayTit: any[] = [];
    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/distribucion/reestructura-distribucion");
    }

    //Encola el transpiler.
    encolarTranspiler(reestructuraFormato: ReestructuraTranspilerFormato): Promise<boolean> {
        let params: HttpParams = new HttpParams();
        return this.apiService.post<any>('encolar-transpiler', params, reestructuraFormato)
            .toPromise();
    }

    //Obtiene título de la reestructura.
    getReestructuraTitulo(fechaIni:DateTime,fechaFin:DateTime): Promise<getTituloReestructura[]> {
        let params = new HttpParams()
            .append("fechaIni", moment(fechaIni).format())
            .append("fechaFin", moment(fechaFin).format());
        return this.apiService.get<getTituloReestructura[]>("get-reestructuraTit",params)
            .toPromise();
    }

    //Obtiene título de la reestructura.
    getReestructuraDetalle(id: any): Promise<getReestructuraDetalle[]> {
        let params = new HttpParams()
        .append("id",id);
        return this.apiService.get<getReestructuraDetalle[]>("get-reestructuraDet",params)
            .toPromise();
    }

    //Actualiza la información
    ActualizaReestructura(r: getReestructuraDetalle[]): Promise<boolean> {
        let params: HttpParams = new HttpParams();
        return this.apiService.post<boolean>("put-reestructura", params,r)
            .toPromise();
    }
}