﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { RutasPreventaInfo } from '../models/rutas-preventa'
import { CelulaItem } from '../models/celula';

@Injectable()
export class RutasPreventaService extends CatalogService<RutasPreventaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/distribucion/rutas-preventa');
    }

    create(): Promise<RutasPreventaInfo> {
        return Promise.resolve(new RutasPreventaInfo());
    }

    ///////////////////////////// Celulas ////////////////////////////////////////////////

    LoadCelulasList(idRutaPreventa: number): Promise<CelulaItem[]> {
        let params = new HttpParams()
            .append("idRutaPreventa", idRutaPreventa.toString());
        return this.apiService.get<CelulaItem[]>("load-celulas-list", params)
            .toPromise();
    }

    addMembers(idRutaPreventa: number, celulas: CelulaItem[]): Promise<any> {
        let params = new HttpParams()
            .set('idRutaPreventa', idRutaPreventa.toString());
        return this.apiService.post<any>('add-members', params, celulas)
            .toPromise();
    }

    removeMember(idRutaPreventa: number, idCelula: number): Promise<any> {
        let params = new HttpParams()
            .set('idRutaPreventa', idRutaPreventa.toString())
            .set('idCelula', idCelula.toString());
        return this.apiService.delete<any>('remove-member', params)
            .toPromise();
    }
}

