﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { TipoConteoInfo } from '../models/tipo-conteo'

@Injectable()
export class TipoConteoService extends CatalogService<TipoConteoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/distribucion/tipos-conteos');
    }

    create(): Promise<TipoConteoInfo> {
        return Promise.resolve(new TipoConteoInfo());
    }

    getTiposConteoCbo(idSucursal: number): Promise<any[]> {
        let params = new HttpParams()
            .set("idSucursal", idSucursal.toString());
        return this.apiService.get<any[]>("get-tipos-conteo-cbo", params).toPromise();
    }
}

