﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Framework
import { Context, DocumentInfo, DocumentItem, DocumentService } from 'framework3/core';
//Locales
import { TripulacionInfo, TripulacionItem } from '../models/tripulacion';
import { TripulacionDetail } from '../models/tripulacion-detail';

@Injectable()
export class TripulacionService extends DocumentService<TripulacionDetail, TripulacionInfo> {

    constructor(protected http: HttpClient, protected context: Context ) {
        super(http, context, 'api/distribucion/tripulaciones');
    }

    create(): Promise<TripulacionInfo> {
        let newDoc = new TripulacionInfo();
        return Promise.resolve(newDoc);
    }

    detailNewDocument(tipoTripulacion, idSucursal): Promise<TripulacionDetail[]> {
        let params = new HttpParams()
            .set("tipoTripulacion", tipoTripulacion)
            .set("idSucursal", idSucursal);
        return this.apiService.get<TripulacionDetail[]>("detail-new-document", params).toPromise();
    }

	/*
    sampleMethod(param1: number, param2: string): Promise<TripulacionInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<TripulacionInfo>('sample-method', params)
            .toPromise();
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) en los resultados de búsquedas. Eliminar si no es necesario
	protected mapSearchResult(row: any) {
        
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) al cargar un documento. Eliminar si no es necesario
    protected mapDocument(document: TripulacionInfo) {

    }
	*/



}