﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
import * as moment from 'moment';
//Azteca Framework
import { Context, DocumentInfo, DocumentItem, DocumentService } from 'framework3/core';
//Locales
import { ValePagoInfo, ValePagoItem } from '../models/vale-pago';
import { ValePagoDetail } from '../models/vale-pago-detail';
import { ValePagoPendiente } from '../models/vale-pago-pendiente';

@Injectable()
export class ValePagoService extends DocumentService<ValePagoDetail, ValePagoInfo> {

    constructor(protected http: HttpClient, protected context: Context ) {
        super(http, context, 'api/distribucion/vales-pagos');
    }

    create(): Promise<ValePagoInfo> {
        let newDoc = new ValePagoInfo();
        return Promise.resolve(newDoc);
    }

    getPendientes(fechaIni: Date, fechaFin: Date, filtro: string, idSucursal: number): Promise<ValePagoPendiente[]> {
        let params = new HttpParams()
            .set("fechaIni", moment(fechaIni).format())
            .set("fechaFin", moment(fechaFin).format())
            .set("filtro", filtro)
            .set("idSucursal", idSucursal.toString());
        return this.apiService.get<ValePagoPendiente[]>("get-pendientes", params)
            .toPromise();
    }

	/*
    sampleMethod(param1: number, param2: string): Promise<ValePagoInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<ValePagoInfo>('sample-method', params)
            .toPromise();
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) en los resultados de búsquedas. Eliminar si no es necesario
	protected mapSearchResult(row: any) {
        
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) al cargar un documento. Eliminar si no es necesario
    protected mapDocument(document: ValePagoInfo) {

    }
	*/



}