﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { ValeTipoInfo } from '../models/vale-tipo'

@Injectable()
export class ValeTipoService extends CatalogService<ValeTipoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/distribucion/vales-tipos');
    }

    create(): Promise<ValeTipoInfo> {
        return Promise.resolve(new ValeTipoInfo());
    }

    getTiposValeCbo(idSucursal: number): Promise<any[]> {
        let params = new HttpParams()
            .set("idSucursal", idSucursal.toString());
        return this.apiService.get<any[]>("get-tipos-vale-cbo", params).toPromise();
    }


	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<ValeTipoInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<ValeTipoInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

