﻿import { NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
//Modulos Azteca
import { CoreModule } from 'framework3/core';
import { EditorsModule } from 'framework3/editors';
import { SearchModule } from 'framework3/search';
import { GeneralModule } from 'framework3/general';
import { ControlsModule } from 'framework3/controls';
import { SecurityModule } from 'framework3/security';
import { NotificationModule } from 'framework3/notification';
import { EmpleadosRoutingModule } from './empleados.routing.module';
//Bootstrap
import { AlertModule, TabsModule, ModalModule } from 'ngx-bootstrap';
//Wijmo
import { WjCoreModule } from 'wijmo/wijmo.angular2.core';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjGridDetailModule } from 'wijmo/wijmo.angular2.grid.detail';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
//Modulos Pixkua
import { AccountingModule } from '../accounting';
import { PurchasingModule } from '../purchasing';
import { RhModule } from '../rh';

//Componentes
import { LoginComponent } from './components/login.component';
import { DownloadInvoiceComponent } from './components/download-invoice.component';
//Parts
//Services
import { PortalContext } from './services/portal-context';
import { AuthGuard } from './services/auth-guard.service';

import { EmpleadoService as EmpleadoSvc } from './services/empleado.service';

let COMPONENTES = [LoginComponent, DownloadInvoiceComponent];
let SERVICIOS = [PortalContext, AuthGuard, EmpleadoSvc];

@NgModule({
    imports: [
        FormsModule, ReactiveFormsModule, CommonModule,
        AlertModule.forRoot(), TabsModule.forRoot(), ModalModule.forRoot(),
        CoreModule, EditorsModule, SearchModule, GeneralModule, ControlsModule, SecurityModule, NotificationModule,
        AccountingModule, EmpleadosRoutingModule, PurchasingModule, RhModule,
        WjCoreModule, WjInputModule, WjGridModule, WjGridFilterModule, WjGridDetailModule
    ],
    declarations: COMPONENTES,
    providers: SERVICIOS,
    exports: COMPONENTES
})
export class EmpleadosModule {

}
