﻿import { Injectable } from '@angular/core';
import { CanActivate, CanActivateChild, Router, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';

import { Context } from 'framework3/core';

@Injectable()
export class AuthGuard implements CanActivate, CanActivateChild {
    constructor(private context: Context, private router: Router) { }

    canActivate(route: ActivatedRouteSnapshot, state: RouterStateSnapshot): boolean {
        let url: string = state.url;
        let valid: boolean = false;
        //Verificar si el usuario ya hizo login
        valid = this.checkLogin();
        return valid;
    }

    canActivateChild(route: ActivatedRouteSnapshot, state: RouterStateSnapshot): boolean {
        return this.canActivate(route, state);
    }

    checkLogin(): boolean {
        if (this.context.session) {
            return true;
        }
        else {
            return false;
        }
    }

}