﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
import { Context, BaseService } from 'framework3/core';
import { AsyncTaskInfo } from 'framework3/queue/models/async-task';

// Features
import { EmpleadoInfo } from '../models/empleado'

@Injectable()
export class EmpleadoService extends BaseService {

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/custom/empleado");
    }

    loginEmpleado(numEmpleado: string, fechaNac: string, contrasena: string): Promise<EmpleadoInfo> {
        let params = new HttpParams()
            .set('numEmpleado', numEmpleado)
            .set('fecha', fechaNac)
            .set('contrasena', contrasena);
        return this.apiService.get<EmpleadoInfo>('login', params).toPromise();
    }


}