﻿import { Injectable } from '@angular/core';
//
import { EmpresaItem } from 'framework3/core';
//
import { EmpleadoInfo } from '../../rh';

@Injectable()
export class PortalContext {

    private _companies: EmpresaItem[] = [];
    private _empleado: EmpleadoInfo;

    get companies(): EmpresaItem[] {
        if (this._companies.length > 0) {
            return this._companies;
        }
        else {
            let storedCompanies: string = sessionStorage.getItem('empleados-companies');
            if (storedCompanies != null) {
                this._companies = JSON.parse(storedCompanies);
                return this._companies;
            }
            else {
                return [];
            }
        }
    }

    get empleado(): EmpleadoInfo {
        if (this._empleado) {
            return this._empleado;
        }
        else {
            let storedProvider: string = sessionStorage.getItem('empleados-empleado');
            if (storedProvider != null) {
                this._empleado = JSON.parse(storedProvider);
                return this._empleado;
            }
            else {
                return null;
            }
        }
    }

    setCompanies(companies: EmpresaItem[]) {
        this._companies = companies;
        sessionStorage.setItem('empleados-companies', JSON.stringify(companies));
    }

    setEmpleado(empleado: EmpleadoInfo) {
        this._empleado = empleado;
        sessionStorage.setItem('empleados-empleado', JSON.stringify(empleado));
    }

}