﻿import { Component, Input, Output, EventEmitter, forwardRef } from '@angular/core';
//
import { BaseComponent, Context } from 'framework3/core';
import { AutocompleteCell } from 'framework3/search';
//
import { ArticuloStockInfo, ArticuloStockItem } from '../models/articulo-stock';
import { ArticuloStockService } from '../services/articulo-stock.service';

@Component({
    selector: 'inventory-articulo-stock-autocomplete-cell',
    templateUrl: './articulo-stock-autocomplete-cell.component.html',
    providers: [{
        provide: BaseComponent,
        useExisting: forwardRef(() => ArticuloStockAutocompleteCellComponent)
    }]
})
export class ArticuloStockAutocompleteCellComponent extends AutocompleteCell {
    //Inputs
    
    constructor(protected context: Context, private articuloStockService: ArticuloStockService) {
        super();
    }

    ngOnInit() {
        this.itemsSourceHandler = (keyword, max, callback) => this.searchKeyword(keyword, max, callback);
    }

    searchKeyword(keyword: string, max: number, callback: any) {
        if (keyword && keyword != '') {
            this.articuloStockService.searchKeyword(this.context.app.defaultSite.identity, keyword)
                .toPromise()
                .then(items => callback(items))
                .catch(_ => callback(null));
        }
        else {
            callback(null);
        }
    }

}