﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

import { AlmacenService } from '../services/almacen.service';
import { AlmacenItem } from '../models/almacen';

//

@Component({
    selector: 'inventory-almacenes-list',
    templateUrl: './almacenes-list.component.html'
})
export class AlmacenListComponent extends CatalogListDialog {

    almacenes: AlmacenItem[];

    constructor(protected context: Context, private articuloSvc: AlmacenService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.articuloSvc.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.almacenes = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedItems: AlmacenItem[]) {
        this.selectedItemsChanged.emit(selectedItems);
    }

    onSelectedItemChanged(item: AlmacenItem) {
        this.selectedItemChanged.emit(item);
    }

}