﻿export * from './inventory.module';

//////////////////////////// MODELS ///////////////////////////////
export * from './models/unidad-medida';
export * from './models/unidad-medida-tipo';
export * from './models/stock';
export * from './models/articulo-stock';
export * from './models/metodo-valuacion';
export * from './models/area';
export * from './models/almacen';
export * from './models/empaquetado';
export * from './models/lote';
export * from './models/serie';
export * from './models/entrada';
export * from './models/entrada-detail';
export * from './models/salida';
export * from './models/salida-detail';
export * from './models/traspaso'
export * from './models/traspaso-detail'
export * from './models/transferencia'
export * from './models/transferencia-detail'
export * from './models/meta-almacen'


//////////////////////////// SERVICES ///////////////////////////////
export * from './services/unidad-medida.service';
export * from './services/unidad-medida-tipo.service';
export * from './services/articulo-stock.service';
export * from './services/area.service';
export * from './services/almacen.service';
export * from './services/entrada.service';
export * from './services/salida.service';
export * from './services/traspaso.service'
export * from './services/transferencia.service'
export * from './services/meta-almacen.service'

//////////// COMPONENTES Y DIRECTIVAS ////////////////////////////////
export * from './catalogs/unidades-medida.manager';
export * from './catalogs/unidades-medida.editor';
export * from './catalogs/unidades-medida-tipo.manager';
export * from './catalogs/unidades-medida-tipo.editor';
export * from './catalogs/articulos-stock.manager';
export * from './catalogs/articulos-stock.editor';
export * from './catalogs/areas.manager';
export * from './catalogs/areas.editor';
export * from './catalogs/almacenes.manager';
export * from './catalogs/almacenes.editor';
export * from './catalogs/ubicaciones.manager';
export * from './catalogs/meta-almacenes.manager'
export * from './catalogs/meta-almacenes.editor'

export * from './controls/articulo-stock-selector.component';
export * from './controls/almacenes-selector.component';
export * from './controls/quantity-input.component';
export * from './controls/quantity-label.component';
export * from './controls/articulo-stock-entrada.component';
export * from './controls/articulo-stock-salida.component';

export * from './documents/parts/detail-quantity.editor';

export * from './documents/entradas.manager';
export * from './documents/entradas.editor';
export * from './documents/salidas.manager';
export * from './documents/salidas.editor';

export * from './documents/traspasos-tit.manager'
export * from './documents/traspasos-tit.editor'

export * from './documents/transferencias-tit.manager'
export * from './documents/transferencias-tit.editor'


export * from './components/corte.component';

//////////// PARTS ////////////////////////////////
export * from './parts/articulos-stock-general.component';
export * from './parts/articulos-stock-controles.component';

export * from './parts/transferencia-aceptar.component';

// MAINTENANCES
export * from './maintenances/articulos-costo-estandar.maintenance';