﻿//Azteca Kernel
import { Context, CatalogInfo, CatalogItem } from 'framework3/core';
import { TrackableItem, ChangeState } from 'framework3/editors';
import { ClasificacionValor, IClasificable } from 'framework3/general';

export class AlmacenInfo extends CatalogInfo implements IClasificable {
    nombre: string;
    idArea: number;
    permiteNegativos: boolean;
    reqCapturaFisico: boolean;
    restriccionAccesos: boolean;
    restriccionArticulos: boolean;
    idCuenta: number;
    clasificaciones: ClasificacionValor[];


    constructor() {
        super();
        this.idArea = 0;
        this.clasificaciones = [];
    }
}

export class AlmacenItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    idArea: number;
    entrada: boolean;
    salida: boolean;
    activo: boolean;
    estatus?: string;
    selected?: boolean = false;
}

export class AlmacenUsuarioInfo extends CatalogInfo {
    idAlmacen: number;
    idUsuario: number;
    entrada: boolean;
    salida: boolean;


    constructor() {
        super();
    }
}

export class AlmacenUsuarioItem extends TrackableItem implements CatalogItem {
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
    selected?: boolean = false;
    entrada: boolean;
    salida: boolean;
}

export class AlmacenProvisionItem extends TrackableItem implements CatalogItem {
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
    selected?: boolean = false;    
}

export class ClasificacionesArticulosItem {
    selected: boolean;
    idGrupoClasificaciones: number;
    idClasificacion: number;
    grupo: string;
    clasificacion: string;
    valor: string;
    referencia: string;
}

export class Existencias {
    id: number;
    codigo: string;
    nombre: string;
    disponible: number;
    apartado: number;
    existencia: number;
    transito: number;
}

