﻿import { DocumentInfo, DocumentItem } from 'framework3/core';
//
import { EntradaDetail } from './entrada-detail';
import { AlmacenInfo } from './almacen';

export class EntradaInfo extends DocumentInfo<EntradaDetail> {
	horaMovto: Date;
	horaApartado: Date;
	horaCarga: Date;
	horaAplicado: Date;
	idConcepto: number;
	idAlmacen: number;
	totalCantidad: number;
	totalCosto: number;
	totalFlete: number;	
	referencia: string;
	fechaReferencia: Date;
	idTraspaso: string;
	fechaTraspaso: Date;
	idLote: number;
	idCorteCaptura: string;
	idCorteApartado: string;
	idCorteMovto: string;
	idCorteCarga: string;
	idCorteAplicado: string;
	observaciones: string;
	estatusInventario: string;

    almacen: AlmacenInfo;

    constructor() {
        super();
        this.almacen = new AlmacenInfo();
    }
}

export class EntradaItem extends DocumentItem {
    idAlmacen: number;
    almacen: string;
    horaAplicado: Date;
    totalCantidad: number;
    totalCosto: number;
}