﻿import { DocumentInfo, DocumentItem } from 'framework3/core';
//Inventario
import { SalidaDetail } from './salida-detail';
import { AlmacenInfo } from './almacen';

export class SalidaInfo extends DocumentInfo<SalidaDetail> {
	horaMovto: Date;
	horaApartado: Date;
	horaCarga: Date;
	horaAplicado: Date;
	idConcepto: number;
	idAlmacen: number;
	totalCantidad: number;
	totalCosto: number;
	totalFlete: number;
	direccion: number;
	referencia: string;
	fechaReferencia: Date;
	idTraspaso: string;
	fechaTraspaso: Date;
	idLote: number;
	idCorteCaptura: string;
	idCorteApartado: string;
	idCorteMovto: string;
	idCorteCarga: string;
	idCorteAplicado: string;
	observaciones: string;
	estatusInventario: string;

    almacen: AlmacenInfo;

    constructor() {
        super();
        this.almacen = new AlmacenInfo();
    }
}

export class SalidaItem extends DocumentItem {
    idAlmacen: number;
    almacen: string;
    horaAplicado: Date;
    totalCantidad: number;
    totalCosto: number;
}