﻿import { DocumentInfo, DocumentItem, SucursalInfo } from 'framework3/core';
import { TransferenciaDetail } from './transferencia-detail';
import { AlmacenInfo } from './almacen';

export class TransferenciaInfo extends DocumentInfo<TransferenciaDetail> {
	fechaAfectacion: Date;
	idAlmacenOrigen: number;
	idSucursalDestino: number;
	idAlmacenDestino: number;
	idTraspasoTit: string;
	totalCantidad: number;
	flete: number;
	referencia: string;
	fechaEnvio: Date;
	fechaRecepcion: Date;
	idCorteOrigen: string;
	idCorteDestino: string;
	observaciones: string;

    almacenOrigen: AlmacenInfo;
    almacenDestino: AlmacenInfo;
    sucursalDestino: SucursalInfo;

    constructor() {
        super();
        this.idAlmacenOrigen = 0;
        this.idAlmacenDestino = 0;
        this.idSucursalDestino = 0;
        this.almacenOrigen = new AlmacenInfo();
        this.almacenDestino = new AlmacenInfo();
        this.sucursalDestino = new SucursalInfo();

    }
}

export class TransferenciaItem extends DocumentItem {

}