﻿import { DocumentInfo, DocumentItem } from 'framework3/core';
import { TraspasoDetail } from './traspaso-detail';
import { AlmacenInfo } from './almacen';

export class TraspasoInfo extends DocumentInfo<TraspasoDetail> {
	fechaAfectacion: Date;
	horaMovto: Date;
	horaApartado: Date;
	horaCarga: Date;
	horaAplicado: Date;
	idConcepto: number;
	idAlmacenOrigen: number;
	idAlmacenDestino: number;
	idMovimientoIN: string;
	idMovimientoOUT: string;
	totalCantidad: number;
	totalCosto: number;
	flete: number;
	referencia: string;
	idCorteCaptura: string;
	idCorteApartado: string;
	idCorteMovto: string;
	idCorteCarga: string;
	idCorteAplicado: string;
	observaciones: string;

    almacenOrigen: AlmacenInfo;
    almacenDestino: AlmacenInfo;


    constructor() {
        super();
        this.idAlmacenOrigen = 0;
        this.idAlmacenDestino = 0;
        this.totalCantidad = 0;
        this.totalCosto = 0;
        this.flete = 0;
        this.almacenOrigen = new AlmacenInfo();
        this.almacenDestino = new AlmacenInfo();
    }
}

export class TraspasoItem extends DocumentItem {

}