﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { MetaAlmacenInfo } from '../models/meta-almacen'
import { MetaAlmacenSucursalItem } from '../models/metaalmacen-sucursal-item';

@Injectable()
export class MetaAlmacenService extends CatalogService<MetaAlmacenInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/inventario/meta-almacenes');
    }

    create(): Promise<MetaAlmacenInfo> {
        return Promise.resolve(new MetaAlmacenInfo());
    }

    getMetaAlmacenesSucursales(idMetaAlmacen: number, idEmpresa: number): Promise<MetaAlmacenSucursalItem[]> {
        let params = new HttpParams()
            .set('idMetaAlmacen', idMetaAlmacen.toString())
            .set('idEmpresa', idEmpresa.toString());
        return this.apiService.get<MetaAlmacenSucursalItem[]>('metaalmacenes-sucursales-load', params)
            .toPromise();
    }

    addAlmacen(idMetaAlmacen: number, idSucursal: number, idAlmacen: number) {
        let params = new HttpParams()
            .set('idMetaAlmacen', idMetaAlmacen.toString())
            .set('idSucursal', idSucursal.toString())
            .set('idAlmacen', idAlmacen.toString());
        return this.apiService.post<any>('add-almacen', params)
            .toPromise();
    }

}

