﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { TipoUbicacionInfo, TiposUbicacionItem } from '../models/tipo-ubicacion'

@Injectable()
export class TipoUbicacionService extends CatalogService<TipoUbicacionInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/inventario/tipos-ubicacion');
    }

    create(): Promise<TipoUbicacionInfo> {
        return Promise.resolve(new TipoUbicacionInfo());
    }

	//Sample method
    loadList(): Promise<TiposUbicacionItem[]> {
        let params = new HttpParams()
        return this.apiService.get<TiposUbicacionItem[]>("load-list", params)
            .toPromise();
    }
}

