﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, HierarchyInfo, HierarchyService } from 'framework3/core';
//Locales
import { UbicacionInfo, UbicacionItem } from '../models/ubicacion';

@Injectable()
export class UbicacionService extends HierarchyService<UbicacionInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/inventario/ubicaciones");
    }

    create(): Promise<UbicacionInfo> {
        return Promise.resolve(new UbicacionInfo());
    }

    loadJerarquia(idSucursal:number, idAlmacen: number): Promise<UbicacionInfo[]> {
        let params = new HttpParams()
            .set('idAlmacen', idAlmacen.toString())
            .set('idSucursal', idSucursal.toString());
        return this.apiService.get<UbicacionInfo[]>('load-jerarquia', params)
            .toPromise();
    }

    searchByAlmacen(idAlmacen: number, keyword: string): Observable<UbicacionItem[]> {
        let params = new HttpParams()
            .set('idAlmacen', idAlmacen.toString())
            .set('keyword', keyword);
        //
        return this.apiService.get<UbicacionItem[]>('search-by-almacen', params);
    }

}
