﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { UnidadMedidaTipoInfo, UnidadMedidaTipoItem } from '../models/unidad-medida-tipo'

@Injectable()
export class UnidadMedidaTipoService extends CatalogService<UnidadMedidaTipoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/inventario/unidades-medida-tipo");
    }

    create(): Promise<UnidadMedidaTipoInfo> {
        return Promise.resolve(new UnidadMedidaTipoInfo());
    }

    //Sample method
    loadList(): Promise<UnidadMedidaTipoItem[]> {
        let params = new HttpParams()
        return this.apiService.get<UnidadMedidaTipoItem[]>("load-list", params)
            .toPromise();
    }

}

