﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { UnidadMedidaInfo, UnidadMedidaItem } from '../models/unidad-medida'

@Injectable()
export class UnidadMedidaService extends CatalogService<UnidadMedidaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/inventario/unidades-medida");
    }

    create(): Promise<UnidadMedidaInfo> {
        return Promise.resolve(new UnidadMedidaInfo());
    }

	
    loadList(idTipoUnidad: number): Promise<UnidadMedidaItem[]> {
        let params = new HttpParams()
            .append("idUnidadMedidaTipo", idTipoUnidad.toString());
        return this.apiService.get<UnidadMedidaItem[]>("load-list", params)
            .toPromise();
    }

    //LoadUnidadesMedida

}

