﻿import { Component, EventEmitter, Input, Output, ViewChild } from '@angular/core';
import { FormGroup, FormBuilder, Validators } from '@angular/forms';


// Features
import { VersionItem } from '../../models/aplicacion';
import { ModalDirective } from 'ngx-bootstrap';


@Component({
    selector: 'maintenance-aplicacion-version',
    templateUrl: './aplicacion-version.editor.html'
})
export class AplicacionVersionEditor {

    form: FormGroup;

    @Input() version: VersionItem;
    @Output() onSaved: EventEmitter<void> = new EventEmitter<void>();

    @ViewChild(ModalDirective) dialog: ModalDirective;

    constructor(builder: FormBuilder) {
        this.form = builder.group({
            'versionAplicacion': ['', Validators.required],
            'lanzamiento': ['', Validators.required],
            'aplicacion': ['', Validators.required]
        });
    }

    onUpdate() {
        this.onSaved.emit();
        this.dialog.hide();
    }

    show() {
        this.dialog.config.backdrop = false;
        this.dialog.show();
    }

    hide() {
        this.dialog.hide();
    }
}
