﻿import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
//Modulos Azteca
import { CoreModule } from 'framework3/core';
import { EditorsModule } from 'framework3/editors';
import { SearchModule } from 'framework3/search';
import { GeneralModule } from 'framework3/general';
import { ControlsModule } from 'framework3/controls';
import { SecurityModule } from 'framework3/security';
import { MaintenanceRoutingModule } from './maintenance.routing.module';
//Bootstrap
import { TabsModule, ModalModule, CarouselModule } from 'ngx-bootstrap';
//Wijmo
import { WjCoreModule } from 'wijmo/wijmo.angular2.core';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
//Modulos locales
import { InventoryModule } from '../inventory/inventory.module';
import { RhModule } from '../rh/rh.module';
import { PurchasingModule } from '../purchasing/purchasing.module';

/////////////////////////////// Servicios ////////////////////////////
import { MarcaService } from './services/marcas.service';
import { TipoServicioService } from './services/tipos-servicio.service';
import { GrupoVehiculosService } from './services/grupo-vehiculos.service';
import { VehiculoService } from './services/vehiculo.service';
import { TipoMotorService } from './services/tipo-motor.service';
import { TipoCombustibleService } from './services/tipo-combustible.service';
import { TipoTransmisionService } from './services/tipo-transmision.service';
import { LocalizacionService } from './services/localizacion.service';
import { DocumentoTipoService } from './services/documento-tipo.service';
import { EquipoService } from './services/equipo.service';
import { PiezaService } from './services/pieza.service';
import { RefaccionService } from './services/refaccion.service';
import { GrupoEquiposIndustrialesService } from './services/grupo-equipos-industriales.service';
import { EquipoIndustrialService } from './services/equipo-industrial.service';
import { GrupoRefrigeradoresService } from './services/grupo-refrigeradores.service';
import { RefrigeradorService } from './services/refrigerador.service';
import { DespieceService } from './services/despiece.service';
import { RequisicionServicioService } from './services/requisicion-servicio.service';
import { OrdenService } from './services/orden.service';
import { OrdenServicioService } from './services/orden-servicio.service';
import { TipoOrdenService } from './services/tipo-orden.service';
import { RecursoService } from './services/recurso.service';
import { ServicioService } from './services/servicio.service';
import { TallerService } from './services/taller.service';
import { EquipoInformaticaGrupoService } from './services/equipo-informatica-grupo.service';
import { EquipoInformaticaTipoService } from './services/equipo-informatica-tipo.service';
import { EquipoInformaticaService } from './services/equipo-informatica.service';
import { ServicioRequisicionService } from './services/servicio-requisicion.service';
//import { DispositivosService } from './services/dispositivos.service';
import { ConfigDispositivosService } from './services/configdispositivos.service';
import { CausaBajaService } from './services/causa-baja.service';
import { LlantaPosicionService } from './services/llanta-posicion.service';
import { LlantaService } from './services/llanta.service';
import { LlantaModeloService } from './services/llanta-modelo.service';
import { SistemaService } from './services/sistema.service';
import { PropietarioService } from './services/propietario.service';
import { TipoLicenciaService } from './services/tipo-licencia.service';
import { LicenciaService } from './services/licencia.service';
import { SoftwareService } from './services/software.service';
import { ComplementoService } from './services/complemento.service';
import { SoftwareContactoService } from './services/software-contacto.service';
import { PaqueteriaService } from './services/paqueteria.service';
import { LocalizacionTipoService } from './services/localizacion-tipo.service';

import { AplicacionService } from './services/aplicacion.service';
import { DispositivoGrupoService } from './services/dispositivo-grupo.service';
import { DispositivoService } from './services/dispositivo.service';
import { SistemaOperativoService } from './services/sistema-operativo.service';
import { ConfiguracionService } from './services/configuracion.service';
import { PoliticaService } from './services/politica.service';
import { RedTelefonicaService } from './services/red-telefonica.service';
import { EquipoGrupoService } from './services/equipo-grupo.service';

//////////////////////////// Catalogos ////////////////////////////////
import { MarcasManager } from './catalogs/marcas.manager';
import { MarcasEditor } from './catalogs/marcas.editor';
import { VehiculosGruposManager } from './catalogs/vehiculos-grupos.manager';
import { VehiculosGruposEditor } from './catalogs/vehiculos-grupos.editor';
import { VehiculosManager } from './catalogs/vehiculos.manager';
import { VehiculosEditor } from './catalogs/vehiculos.editor';
import { TiposMotorManager } from './catalogs/tipos-motor.manager';
import { TiposMotorEditor } from './catalogs/tipos-motor.editor';
import { TiposCombustibleManager } from './catalogs/tipos-combustible.manager';
import { TiposCombustibleEditor } from './catalogs/tipos-combustible.editor';

import { TiposTransmisionManager } from './catalogs/tipos-transmision.manager';
import { TiposTransmisionEditor } from './catalogs/tipos-transmision.editor';
import { LocalizacionesManager } from './catalogs/localizaciones.manager';
import { TiposDocumentoEditor } from './catalogs/tipos-documento.editor';
import { TiposDocumentoManager } from './catalogs/tipos-documento.manager';
import { RefaccionesEditor } from './catalogs/refacciones.editor';
import { RefaccionesManager } from './catalogs/refacciones.manager';
import { EquiposIndustrialesGruposEditor } from './catalogs/equipos-industriales-grupos.editor';
import { EquiposIndustrialesGruposManager } from './catalogs/equipos-industriales-grupos.manager';
import { EquiposIndustrialesEditor } from './catalogs/equipos-industriales.editor';
import { EquiposIndustrialesManager } from './catalogs/equipos-industriales.manager';
import { RefrigeradoresGruposEditor } from './catalogs/refrigeradores-grupos.editor';
import { RefrigeradoresGruposManager } from './catalogs/refrigeradores-grupos.manager';
import { RefrigeradoresEditor } from './catalogs/refrigeradores.editor';
import { RefrigeradoresManager } from './catalogs/refrigeradores.manager';
import { DespieceManager } from './catalogs/despiece.manager';
import { TiposOrdenesEditor } from './catalogs/tipos-ordenes.editor';
import { TiposOrdenesManager } from './catalogs/tipos-ordenes.manager';
import { RecursosEditor } from './catalogs/recursos.editor';
import { RecursosManager } from './catalogs/recursos.manager';
import { ServiciosEditor } from './catalogs/servicios.editor';
import { ServiciosManager } from './catalogs/servicios.manager';
import { TalleresEditor } from './catalogs/talleres.editor';
import { TalleresManager } from './catalogs/talleres.manager';
import { EquiposInformaticaGruposEditor } from './catalogs/equipos-informatica-grupos.editor';
import { EquiposInformaticaGruposManager } from './catalogs/equipos-informatica-grupos.manager';
import { EquiposInformaticaTiposEditor } from './catalogs/equipos-informatica-tipos.editor';
import { EquiposInformaticaTiposManager } from './catalogs/equipos-informatica-tipos.manager';
import { EquiposInformaticaEditor } from './catalogs/equipos-informatica.editor';
import { EquiposInformaticaManager } from './catalogs/equipos-informatica.manager';
//import { DispositivosEditor } from './catalogs/dispositivos.editor';
//import { DispositivosManager } from './catalogs/dispositivos.manager';
import { ConfiguracionesDispositivos } from './catalogs/configuraciones-dispositivos';
import { ServiciosTiposEditor } from './catalogs/servicios-tipos.editor';
import { ServiciosTiposManager } from './catalogs/servicios-tipos.manager';
import { CausasBajasEditor } from './catalogs/causas-bajas.editor';
import { CausasBajasManager } from './catalogs/causas-bajas.manager';
import { LlantasPosicionesEditor } from './catalogs/llantas-posiciones.editor';
import { LlantasPosicionesManager } from './catalogs/llantas-posiciones.manager';
import { LlantasEditor } from './catalogs/llantas.editor';
import { LlantasManager } from './catalogs/llantas.manager';
import { LlantasModelosEditor } from './catalogs/llantas-modelos.editor';
import { LlantasModelosManager } from './catalogs/llantas-modelos.manager';
import { SistemasEditor } from './catalogs/sistemas.editor';
import { SistemasManager } from './catalogs/sistemas.manager';
import { PropietariosEditor } from './catalogs/propietarios.editor';
import { PropietariosManager } from './catalogs/propietarios.manager';
import { TiposLicenciasEditor } from './catalogs/tipos-licencias.editor';
import { TiposLicenciasManager } from './catalogs/tipos-licencias.manager';
import { SoftwaresEditor } from './catalogs/softwares.editor';
import { SoftwaresManager } from './catalogs/softwares.manager';
import { ComplementosEditor } from './catalogs/complementos.editor';
import { ComplementosManager } from './catalogs/complementos.manager';
import { SoftwaresContactosEditor } from './catalogs/softwares-contactos.editor';
import { SoftwaresContactosManager } from './catalogs/softwares-contactos.manager';
import { PaqueteriasManager } from './catalogs/paqueterias.manager';
import { AplicacionesEditor } from './catalogs/aplicaciones.editor';
import { AplicacionesManager } from './catalogs/aplicaciones.manager';
import { DispositivosGruposEditor } from './catalogs/dispositivos-grupos.editor';
import { DispositivosGruposManager } from './catalogs/dispositivos-grupos.manager';
import { DispositivosEditor } from './catalogs/dispositivos.editor';
import { DispositivosManager } from './catalogs/dispositivos.manager';
import { SistemasOperativosEditor } from './catalogs/sistemas-operativos.editor';
import { SistemasOperativosManager } from './catalogs/sistemas-operativos.manager';
import { ConfiguracionesEditor } from './catalogs/configuraciones.editor';
import { ConfiguracionesManager } from './catalogs/configuraciones.manager';
import { PoliticasEditor } from './catalogs/politicas.editor';
import { PoliticasManager } from './catalogs/politicas.manager';
import { RedesTelefonicasEditor } from './catalogs/redes-telefonicas.editor';
import { RedesTelefonicasManager } from './catalogs/redes-telefonicas.manager';

// Catalogs parts
import { AplicacionVersionEditor } from './catalogs/parts/aplicacion-version.editor';

import { LocalizacionesTiposEditor } from './catalogs/localizaciones-tipos.editor';
import { LocalizacionesTiposManager } from './catalogs/localizaciones-tipos.manager';
import { AplicacionConfiguracionesQr } from './catalogs/aplicacion-configuraciones-qr.component';

//////////////////////////// Documentos ////////////////////////////////
import { RequisicionesServiciosManager } from './documents/requisiciones-servicios.manager';
import { RequisicionesServiciosEditor } from './documents/requisiciones-servicios.editor';
import { RequisicionServicioDetailEditor } from './documents/parts/requisiciones-servicios-detail.editor';
import { OrdenesManager } from './documents/ordenes.manager';
import { OrdenesEditor } from './documents/ordenes.editor';
import { OrdenDetailEditor } from './documents/parts/ordenes-detail.editor';
import { OrdenesServiciosManager } from './documents/ordenes-servicios.manager';
import { OrdenesServiciosEditor } from './documents/ordenes-servicios.editor';
import { OrdenServicioDetailEditor } from './documents/parts/ordenes-servicios-detail.editor';
import { ServiciosRequisicionesTitManager } from './documents/servicios-requisiciones-tit.manager';
import { ServiciosRequisicionesTitEditor } from './documents/servicios-requisiciones-tit.editor';
import { ServicioRequisicionDetailEditor } from './documents/parts/servicios-requisiciones-tit-detail.editor';


///////////////////////////// Componentes /////////////////////////////////
import { MarcaSelectorComponent } from './components/marca-selector.component';
import { LocalizacionSelectorComponent } from './components/localizacion-selector.component';
import { Documentos } from './components/documentos.component';
import { DocumentosLicencias } from './components/documentos-licencias.component';
import { Fotografias } from './components/fotografias.component';
import { RefaccionSelectorComponent } from './components/refaccion-selector.component';
import { EquipoSelectorComponent } from './components/equipo-selector.component';
import { RecursoSelectorComponent } from './components/recurso-selector.component';
import { EquipoInformaticaSelectorComponent } from './components/equipo-informatica-selector.component';
import { DispositivoSelectorComponent } from './controls/dispositivo-selector.component';
import { VehiculosSelectorComponent } from './components/vehiculo-selector.component';
import { LlantasSelectorComponent } from './components/llanta-selector.component';
import { ConfiguracionSelectorComponent } from './controls/configuracion-selector.component';
import { PoliticaSelectorComponent } from './controls/politica-selector.component';
import { AplicacionSelectorComponent } from './controls/aplicacion-selector.component';

///////////////////////////// Document /////////////////////////////////

//////////////////////////// Parts /////////////////////////////////////
import { TiposServiciosUsuariosComponent } from './parts/servicio-tipo-usuarios.component';
import { SubMarcaEditor } from './parts/submarca.editor';

/////////////////////////////////////////////////////////////////////////////////
let COMPONENTES = [MarcasManager, MarcasEditor, SubMarcaEditor, VehiculosGruposManager, VehiculosGruposEditor, MarcaSelectorComponent,
    TiposMotorManager, TiposMotorEditor, TiposTransmisionManager, TiposTransmisionEditor, VehiculosManager, VehiculosEditor, LocalizacionesManager,
    LocalizacionSelectorComponent, TiposDocumentoEditor, TiposDocumentoManager, Documentos, Fotografias, RefaccionesManager, RefaccionesEditor,
    EquiposIndustrialesGruposManager, EquiposIndustrialesGruposEditor, EquiposIndustrialesManager, EquiposIndustrialesEditor,
    RefrigeradoresGruposManager, RefrigeradoresGruposEditor, RefrigeradoresManager, RefrigeradoresEditor, DespieceManager,
    RefaccionSelectorComponent, OrdenesEditor, OrdenesManager, OrdenDetailEditor,
    RequisicionesServiciosEditor, RequisicionesServiciosManager, RequisicionServicioDetailEditor, EquipoSelectorComponent,
    OrdenesServiciosEditor, OrdenesServiciosManager, OrdenServicioDetailEditor,
    TiposOrdenesEditor, TiposOrdenesManager, RecursosEditor, RecursosManager, RecursoSelectorComponent,
    ServiciosEditor, ServiciosManager,
    TalleresEditor, TalleresManager,
    EquiposInformaticaGruposEditor, EquiposInformaticaGruposManager,
    EquiposInformaticaTiposEditor, EquiposInformaticaTiposManager,
    EquiposInformaticaEditor, EquiposInformaticaManager,/* DispositivosEditor, DispositivosManager,*/ ConfiguracionesDispositivos,
    ServiciosRequisicionesTitEditor, ServiciosRequisicionesTitManager, ServicioRequisicionDetailEditor, EquipoInformaticaSelectorComponent,
    DispositivoSelectorComponent, VehiculosSelectorComponent,
    ServiciosTiposEditor, ServiciosTiposManager, TiposServiciosUsuariosComponent,
    CausasBajasEditor, CausasBajasManager,
    LlantasPosicionesEditor, LlantasPosicionesManager,
    LlantasEditor, LlantasManager,
    LlantasModelosEditor, LlantasModelosManager, LlantasSelectorComponent,
    SistemasEditor, SistemasManager,
    PropietariosEditor, PropietariosManager,
    TiposLicenciasEditor, TiposLicenciasManager,
    SoftwaresEditor, SoftwaresManager,
    ComplementosEditor, ComplementosManager,
    SoftwaresContactosEditor, SoftwaresContactosManager,
    PaqueteriasManager, DocumentosLicencias,
    TiposCombustibleEditor, TiposCombustibleManager,
    LocalizacionesTiposEditor, LocalizacionesTiposManager,
    AplicacionesEditor, AplicacionesManager, AplicacionVersionEditor, AplicacionSelectorComponent, AplicacionConfiguracionesQr,
    DispositivosGruposEditor, DispositivosGruposManager,
    DispositivosEditor, DispositivosManager,
    SistemasOperativosEditor, SistemasOperativosManager,
    ConfiguracionesEditor, ConfiguracionesManager, ConfiguracionSelectorComponent,
    PoliticasEditor, PoliticasManager, PoliticaSelectorComponent,
    RedesTelefonicasEditor, RedesTelefonicasManager];

let SERVICIOS = [MarcaService, TipoServicioService, GrupoVehiculosService, TipoMotorService, TipoTransmisionService, VehiculoService,
    LocalizacionService, DocumentoTipoService, EquipoService, RefaccionService, GrupoEquiposIndustrialesService, EquipoIndustrialService,
    GrupoRefrigeradoresService, RefrigeradorService, DespieceService,
    RequisicionServicioService, OrdenService, OrdenServicioService, TipoOrdenService, RecursoService, ServicioService,
    TallerService, EquipoInformaticaGrupoService, EquipoInformaticaTipoService, EquipoInformaticaService, ServicioRequisicionService,
    /*DispositivosService,*/ ConfigDispositivosService,
    CausaBajaService, LlantaPosicionService,
    PiezaService, LlantaService, LlantaModeloService,
    SistemaService, PropietarioService, TipoLicenciaService, LicenciaService, SoftwareService, ComplementoService,
    SoftwareContactoService, PaqueteriaService, TipoCombustibleService, LocalizacionTipoService, AplicacionService,
    DispositivoGrupoService, DispositivoService, SistemaOperativoService,
    ConfiguracionService, PoliticaService,
    RedTelefonicaService, EquipoGrupoService];

@NgModule({
    imports: [
        FormsModule, ReactiveFormsModule, CommonModule,
        TabsModule.forRoot(), ModalModule.forRoot(), CarouselModule.forRoot(),
        CoreModule, EditorsModule, SearchModule, GeneralModule, ControlsModule, SecurityModule,
        MaintenanceRoutingModule, InventoryModule, RhModule, PurchasingModule,
        WjCoreModule, WjInputModule, WjGridModule, WjGridFilterModule
    ],
    declarations: COMPONENTES,
    providers: SERVICIOS,
    exports: COMPONENTES
})
export class MaintenanceModule {

}
