﻿import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

//////////////////////////// Guards //////////////////////////////////
import { AuthGuard } from 'framework3/core';
import { EditorDeactivateGuard } from 'framework3/editors';

//////////////////////////// Catalogos /////////////////////////////////
import { MarcasManager } from './catalogs/marcas.manager';
import { MarcasEditor } from './catalogs/marcas.editor';
import { VehiculosGruposManager } from './catalogs/vehiculos-grupos.manager';
import { VehiculosGruposEditor } from './catalogs/vehiculos-grupos.editor';
import { TiposMotorManager } from './catalogs/tipos-motor.manager';
import { TiposMotorEditor } from './catalogs/tipos-motor.editor';
import { TiposCombustibleManager } from './catalogs/tipos-combustible.manager';
import { TiposCombustibleEditor } from './catalogs/tipos-combustible.editor';
import { TiposTransmisionManager } from './catalogs/tipos-transmision.manager';
import { TiposTransmisionEditor } from './catalogs/tipos-transmision.editor';
import { VehiculosManager } from './catalogs/vehiculos.manager';
import { VehiculosEditor } from './catalogs/vehiculos.editor';
import { LocalizacionesManager } from './catalogs/localizaciones.manager';
import { TiposDocumentoEditor } from './catalogs/tipos-documento.editor';
import { TiposDocumentoManager } from './catalogs/tipos-documento.manager';
import { Documentos } from './components/documentos.component';
import { DocumentosLicencias } from './components/documentos-licencias.component';
import { Fotografias } from './components/fotografias.component';
import { RefaccionesEditor } from './catalogs/refacciones.editor';
import { RefaccionesManager } from './catalogs/refacciones.manager';
import { EquiposIndustrialesGruposEditor } from './catalogs/equipos-industriales-grupos.editor';
import { EquiposIndustrialesGruposManager } from './catalogs/equipos-industriales-grupos.manager';
import { EquiposIndustrialesEditor } from './catalogs/equipos-industriales.editor';
import { EquiposIndustrialesManager } from './catalogs/equipos-industriales.manager';
import { RefrigeradoresGruposEditor } from './catalogs/refrigeradores-grupos.editor';
import { RefrigeradoresGruposManager } from './catalogs/refrigeradores-grupos.manager';
import { RefrigeradoresEditor } from './catalogs/refrigeradores.editor';
import { RefrigeradoresManager } from './catalogs/refrigeradores.manager';
import { DespieceManager } from './catalogs/despiece.manager';
import { TiposOrdenesEditor } from './catalogs/tipos-ordenes.editor';
import { TiposOrdenesManager } from './catalogs/tipos-ordenes.manager';
import { RecursosEditor } from './catalogs/recursos.editor';
import { RecursosManager } from './catalogs/recursos.manager';
import { ServiciosEditor } from './catalogs/servicios.editor';
import { ServiciosManager } from './catalogs/servicios.manager';
import { TalleresEditor } from './catalogs/talleres.editor';
import { TalleresManager } from './catalogs/talleres.manager';
import { EquiposInformaticaGruposEditor } from './catalogs/equipos-informatica-grupos.editor';
import { EquiposInformaticaGruposManager } from './catalogs/equipos-informatica-grupos.manager';
import { EquiposInformaticaTiposEditor } from './catalogs/equipos-informatica-tipos.editor';
import { EquiposInformaticaTiposManager } from './catalogs/equipos-informatica-tipos.manager';
import { EquiposInformaticaEditor } from './catalogs/equipos-informatica.editor';
import { EquiposInformaticaManager } from './catalogs/equipos-informatica.manager';
//import { DispositivosEditor } from './catalogs/dispositivos.editor';
//import { DispositivosManager } from './catalogs/dispositivos.manager';
import { ConfiguracionesDispositivos } from './catalogs/configuraciones-dispositivos';
import { ServiciosTiposEditor } from './catalogs/servicios-tipos.editor';
import { ServiciosTiposManager } from './catalogs/servicios-tipos.manager';
import { TiposServiciosUsuariosComponent } from './parts/servicio-tipo-usuarios.component';
import { CausasBajasEditor } from './catalogs/causas-bajas.editor';
import { CausasBajasManager } from './catalogs/causas-bajas.manager';
import { LlantasPosicionesEditor } from './catalogs/llantas-posiciones.editor';
import { LlantasPosicionesManager } from './catalogs/llantas-posiciones.manager';
import { LlantasEditor } from './catalogs/llantas.editor';
import { LlantasManager } from './catalogs/llantas.manager';
import { LlantasModelosEditor } from './catalogs/llantas-modelos.editor';
import { LlantasModelosManager } from './catalogs/llantas-modelos.manager';
import { SistemasEditor } from './catalogs/sistemas.editor';
import { SistemasManager } from './catalogs/sistemas.manager';
import { PropietariosEditor } from './catalogs/propietarios.editor';
import { PropietariosManager } from './catalogs/propietarios.manager';
import { TiposLicenciasEditor } from './catalogs/tipos-licencias.editor';
import { TiposLicenciasManager } from './catalogs/tipos-licencias.manager';
import { SoftwaresEditor } from './catalogs/softwares.editor';
import { SoftwaresManager } from './catalogs/softwares.manager';
import { ComplementosEditor } from './catalogs/complementos.editor';
import { ComplementosManager } from './catalogs/complementos.manager';
import { SoftwaresContactosEditor } from './catalogs/softwares-contactos.editor';
import { SoftwaresContactosManager } from './catalogs/softwares-contactos.manager';
import { PaqueteriasManager } from './catalogs/paqueterias.manager';
import { LocalizacionesTiposEditor } from './catalogs/localizaciones-tipos.editor';
import { LocalizacionesTiposManager } from './catalogs/localizaciones-tipos.manager';
import { AplicacionesEditor } from './catalogs/aplicaciones.editor';
import { AplicacionesManager } from './catalogs/aplicaciones.manager';
import { AplicacionConfiguracionesQr } from './catalogs/aplicacion-configuraciones-qr.component';
import { DispositivosGruposEditor } from './catalogs/dispositivos-grupos.editor';
import { DispositivosGruposManager } from './catalogs/dispositivos-grupos.manager';
import { DispositivosEditor } from './catalogs/dispositivos.editor';
import { DispositivosManager } from './catalogs/dispositivos.manager';
import { SistemasOperativosEditor } from './catalogs/sistemas-operativos.editor';
import { SistemasOperativosManager } from './catalogs/sistemas-operativos.manager';
import { ConfiguracionesEditor } from './catalogs/configuraciones.editor';
import { ConfiguracionesManager } from './catalogs/configuraciones.manager';
import { PoliticasEditor } from './catalogs/politicas.editor';
import { PoliticasManager } from './catalogs/politicas.manager';
import { RedesTelefonicasEditor } from './catalogs/redes-telefonicas.editor';
import { RedesTelefonicasManager } from './catalogs/redes-telefonicas.manager';


///////////////////////////// Document /////////////////////////////////
import { RequisicionesServiciosManager } from './documents/requisiciones-servicios.manager';
import { RequisicionesServiciosEditor } from './documents/requisiciones-servicios.editor';
import { RequisicionServicioDetailEditor } from './documents/parts/requisiciones-servicios-detail.editor';
import { OrdenesManager } from './documents/ordenes.manager';
import { OrdenesEditor } from './documents/ordenes.editor';
import { OrdenDetailEditor } from './documents/parts/ordenes-detail.editor';
import { OrdenesServiciosManager } from './documents/ordenes-servicios.manager';
import { OrdenesServiciosEditor } from './documents/ordenes-servicios.editor';
import { OrdenServicioDetailEditor } from './documents/parts/ordenes-servicios-detail.editor';
import { ServiciosRequisicionesTitManager } from './documents/servicios-requisiciones-tit.manager';
import { ServiciosRequisicionesTitEditor } from './documents/servicios-requisiciones-tit.editor';
import { ServicioRequisicionDetailEditor } from './documents/parts/servicios-requisiciones-tit-detail.editor';

///////////////////////////// Rutas ////////////////////////////////////
const routes: Routes = [
    {
        path: '',
        canActivateChild: [AuthGuard],
        children: [
            { path: 'marcas/:proceso', component: MarcasManager },
            { path: 'marcas/:proceso/:id', component: MarcasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'vehiculos-grupos/:proceso', component: VehiculosGruposManager },
            { path: 'vehiculos-grupos/:proceso/:id', component: VehiculosGruposEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'tiposmotor/:proceso', component: TiposMotorManager },
            { path: 'tiposmotor/:proceso/:id', component: TiposMotorEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'tipostransmision/:proceso', component: TiposTransmisionManager },
            { path: 'tipostransmision/:proceso/:id', component: TiposTransmisionEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'vehiculos/:proceso/:idGrupo/:idVehiculoGrupo/:idEquipoGrupo', component: VehiculosManager },
            { path: 'vehiculos/:proceso/:idGrupo/:idVehiculoGrupo/:idEquipoGrupo/:id', component: VehiculosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'localizaciones/:proceso', component: LocalizacionesManager },
            { path: 'tipos-documento/:proceso', component: TiposDocumentoManager },
            { path: 'tipos-documento/:proceso/:id', component: TiposDocumentoEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'documentos/:idEquipo/:proceso', component: Documentos },
            { path: 'documentos-licencias/:idLicencia/:proceso', component: DocumentosLicencias },
            { path: 'fotografias/:idEquipo/:proceso', component: Fotografias },
            { path: 'refacciones/:proceso', component: RefaccionesManager },
            { path: 'refacciones/:proceso/:id', component: RefaccionesEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'grupos-equipos-industriales/:proceso', component: EquiposIndustrialesGruposManager },
            { path: 'grupos-equipos-industriales/:proceso/:id', component: EquiposIndustrialesGruposEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'equipos-industriales/:proceso/:idGrupo/:idEquipoIndustrialGrupo/:idEquipoGrupo', component: EquiposIndustrialesManager },
            { path: 'equipos-industriales/:proceso/:idGrupo/:idEquipoIndustrialGrupo/:idEquipoGrupo/:id', component: EquiposIndustrialesEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'grupos-refrigeradores/:proceso', component: RefrigeradoresGruposManager },
            { path: 'grupos-refrigeradores/:proceso/:id', component: RefrigeradoresGruposEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'refrigeradores/:proceso/:idGrupo/:idGrupoRefrigeradores/:idEquipoGrupo', component: RefrigeradoresManager },
            { path: 'refrigeradores/:proceso/:idGrupo/:idGrupoRefrigeradores/:idEquipoGrupo/:id', component: RefrigeradoresEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'despiece/:proceso/:idEquipoGrupo', component: DespieceManager },
            { path: 'requisiciones-servicios/:proceso', component: RequisicionesServiciosManager },
            { path: 'requisiciones-servicios/:proceso/:id', component: RequisicionesServiciosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'ordenes/:proceso', component: OrdenesManager },
            { path: 'ordenes/:proceso/:id', component: OrdenesEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'ordenes-servicios/:proceso', component: OrdenesServiciosManager },
            { path: 'ordenes-servicios/:proceso/:idOrden/:id', component: OrdenesServiciosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'tipos-ordenes/:proceso', component: TiposOrdenesManager },
            { path: 'tipos-ordenes/:proceso/:id', component: TiposOrdenesEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'recursos/:proceso', component: RecursosManager },
            { path: 'recursos/:proceso/:id', component: RecursosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'servicios/:proceso', component: ServiciosManager },
            { path: 'servicios/:proceso/:id', component: ServiciosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'talleres/:proceso', component: TalleresManager },
            { path: 'talleres/:proceso/:id', component: TalleresEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'equipos-informatica-tipos/:proceso', component: EquiposInformaticaTiposManager },
            { path: 'equipos-informatica-tipos/:proceso/:id', component: EquiposInformaticaTiposEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'equipos-informatica-grupos/:proceso', component: EquiposInformaticaGruposManager },
            { path: 'equipos-informatica-grupos/:proceso/:id', component: EquiposInformaticaGruposEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'equipos-informatica/:proceso/:idGrupo/:idEquipoInformaticaGrupo/:idEquipoGrupo', component: EquiposInformaticaManager },
            { path: 'equipos-informatica/:proceso/:idGrupo/:idEquipoInformaticaGrupo/:idEquipoGrupo/:id', component: EquiposInformaticaEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'servicios-requisiciones/:proceso', component: ServiciosRequisicionesTitManager },
            { path: 'servicios-requisiciones/:proceso/:id', component: ServiciosRequisicionesTitEditor, canDeactivate: [EditorDeactivateGuard] },
            //{ path: 'dispositivos/:proceso', component: DispositivosManager },
            { path: 'configuraciones-dispositivos/:proceso', component: ConfiguracionesDispositivos },
            //{ path: 'dispositivos/:proceso/:id', component: DispositivosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'servicios-tipos/:proceso', component: ServiciosTiposManager },
            { path: 'servicios-tipos/:proceso/:id', component: ServiciosTiposEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'servicio-tipo-usuarios/:proceso/:idTipoServicio', component: TiposServiciosUsuariosComponent },
            { path: 'causas-bajas/:proceso', component: CausasBajasManager },
            { path: 'causas-bajas/:proceso/:id', component: CausasBajasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'llantas-posiciones/:proceso', component: LlantasPosicionesManager },
            { path: 'llantas-posiciones/:proceso/:id', component: LlantasPosicionesEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'llantas/:proceso/:idGrupo/:idLlantaGrupo/:idEquipoGrupo/:idMarca', component: LlantasManager },
            { path: 'llantas/:proceso/:idGrupo/:idLlantaGrupo/:idEquipoGrupo/:idMarca/:id', component: LlantasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'llantas-modelos/:proceso', component: LlantasModelosManager },
            { path: 'llantas-modelos/:proceso/:id', component: LlantasModelosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'sistemas/:proceso', component: SistemasManager },
            { path: 'sistemas/:proceso/:id', component: SistemasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'propietarios/:proceso', component: PropietariosManager },
            { path: 'propietarios/:proceso/:id', component: PropietariosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'tipos-licencias/:proceso', component: TiposLicenciasManager },
            { path: 'tipos-licencias/:proceso/:id', component: TiposLicenciasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'softwares/:proceso/:idSistema', component: SoftwaresManager },
            { path: 'softwares/:proceso/:idSistema/:id', component: SoftwaresEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'complementos/:proceso/:idSistema/:idSoftware', component: ComplementosManager },
            { path: 'complementos/:proceso/:idSistema/:idSoftware/:id', component: ComplementosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'softwares-contactos/:proceso', component: SoftwaresContactosManager },
            { path: 'softwares-contactos/:proceso/:id', component: SoftwaresContactosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'paqueterias/:proceso', component: PaqueteriasManager },
            { path: 'aplicaciones/:proceso', component: AplicacionesManager },
            { path: 'aplicaciones/:proceso/:id', component: AplicacionesEditor, canDeactivate: [EditorDeactivateGuard] },

            { path: 'aplicacion-configuraciones-qr/:proceso/:id', component: AplicacionConfiguracionesQr, canDeactivate: [EditorDeactivateGuard] },


            { path: 'localizaciones-tipos/:proceso', component: LocalizacionesTiposManager },
            { path: 'localizaciones-tipos/:proceso/:id', component: LocalizacionesTiposEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'dispositivos-grupos/:proceso', component: DispositivosGruposManager },
            { path: 'dispositivos-grupos/:proceso/:id', component: DispositivosGruposEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'dispositivos/:proceso/:idGrupo/:idDispositivoGrupo/:idEquipoGrupo', component: DispositivosManager },
            { path: 'dispositivos/:proceso/:idGrupo/:idDispositivoGrupo/:idEquipoGrupo/:id', component: DispositivosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'sistemas-operativos/:proceso', component: SistemasOperativosManager },
            { path: 'sistemas-operativos/:proceso/:id', component: SistemasOperativosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'configuraciones/:proceso', component: ConfiguracionesManager },
            { path: 'configuraciones/:proceso/:id', component: ConfiguracionesEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'politicas/:proceso', component: PoliticasManager },
            { path: 'politicas/:proceso/:id', component: PoliticasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'redes-telefonicas/:proceso', component: RedesTelefonicasManager },
            { path: 'redes-telefonicas/:proceso/:id', component: RedesTelefonicasEditor , canDeactivate: [EditorDeactivateGuard] },

        ]
    },
];

@NgModule({
    imports: [
        RouterModule.forChild(routes)
    ],
    exports: [
        RouterModule
    ]
})
export class MaintenanceRoutingModule { }

