﻿import { Context, CatalogInfo, CatalogItem, TrackableItem } from 'framework3/core';
import { FileInfo } from 'framework3/general';
import { ConfiguracionInfo } from './configuracion';
import { PoliticaInfo } from './politica';

export class AplicacionInfo extends CatalogInfo {
	nombre: string;
	package: string;
    idSistemaOperativo: number;
    versiones: VersionItem[] = [];
    configuraciones: AplicacionConfiguracionItem[];
    politicas: AplicacionPoliticaItem[];


    constructor() {
        super();
        this.configuraciones = [];
        this.politicas = [];
    }
}

export class AplicacionItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
	selected?:boolean = false;
}

export class VersionItem extends TrackableItem {

    versionAplicacion: string;
    aplicacion: FileInfo;
    lanzamiento: Date;


    constructor() {
        super();
    }

}

export class AplicacionConfiguracionItem extends TrackableItem {
    idConfiguracion: number;
    configuracion: ConfiguracionInfo;
    enviarQr: boolean;
    constructor() {
        super();
        this.configuracion = new ConfiguracionInfo();
        this.enviarQr = true;
    }
}


export class AplicacionPoliticaItem extends TrackableItem {
    idPolitica: number;
    politica: PoliticaInfo;
    constructor() {
        super();
        this.politica = new PoliticaInfo();
    }
}
