﻿import { Context, CatalogInfo, CatalogItem } from 'framework3/core';
import { GrupoEquiposInfo } from './grupo-equipos';
import { TrackableItem } from 'framework3/core';
import { ConfiguracionInfo } from './configuracion';
import { PoliticaInfo } from './politica';

export class DispositivoGrupoInfo extends CatalogInfo {
	idEquipoGrupo: number;
	idSubMarca: number;
	modelo: string;
	idSistemaOperativo: number;
	versionOS: string;
	memoria: number;
	almacenamiento: number;
	alto: number;
	ancho: number;
	espesor: number;
	idCuenta: number;

    grupoEquipos: GrupoEquiposInfo;
    configuraciones: DispositivoGrupoConfiguracionItem[];
    politicas: DispositivoGrupoPoliticaItem[];

    constructor() {
        super();
        this.grupoEquipos = new GrupoEquiposInfo();
        this.configuraciones = [];
        this.politicas = [];
    }
}

export class DispositivoGrupoItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
	selected?:boolean = false;
}

export class DispositivoGrupoConfiguracionItem extends TrackableItem {
    idConfiguracion: number;
    configuracion: ConfiguracionInfo;
    constructor() {
        super();
        this.configuracion = new ConfiguracionInfo();
    }
}

export class DispositivoGrupoPoliticaItem extends TrackableItem {
    idPolitica: number;
    politica: PoliticaInfo;
    constructor() {
        super();
        this.politica = new PoliticaInfo();
    }
}