﻿import { Context, CatalogInfo, CatalogItem } from 'framework3/core';
import { EquipoInfo } from './equipo';
import { TrackableItem } from 'framework3/core';
import { ConfiguracionInfo } from './configuracion';
import { PoliticaInfo } from './politica';
import { AplicacionInfo } from './aplicacion';


export class DispositivoInfo extends CatalogInfo {
	idEquipo: number;
	iMEI: string;
    idRedTelefonica: number;
    noLinea: string;
	idCuenta: number;

    equipo: EquipoInfo;
    configuraciones: DispositivoConfiguracionItem[];
    politicas: DispositivoPoliticaItem[];
    aplicaciones: DispositivoAplicacionItem[];
    
    constructor() {
        super();
        this.equipo = new EquipoInfo;
        this.configuraciones = [];
        this.politicas = [];
        this.aplicaciones = [];
    }
}

export class DispositivoItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
	selected?:boolean = false;
}

export class DispositivoConfiguracionItem extends TrackableItem {
    idConfiguracion: number;
    configuracionValue: string;
    configuracion: ConfiguracionInfo;
    constructor() {
        super();
        this.configuracionValue = '';
        this.configuracion = new ConfiguracionInfo();
    }
}

export class DispositivoPoliticaItem extends TrackableItem {
    idPolitica: number;
    politicaValue: boolean;
    politica: PoliticaInfo;
    constructor() {
        super();
        this.politicaValue = false;
        this.politica = new PoliticaInfo();
    }
}

export class DispositivoAplicacionItem extends TrackableItem {
    idDispositivo: number;
    idAplicacion: number;
    nombre: string;
    package: string;
    version: string;
    visible: boolean;
    firebaseToken: string;
    activo: boolean;
    aplicacion: AplicacionInfo;

    constructor() {
        super();
        this.aplicacion = new AplicacionInfo();
    }
}