﻿import { Context, CatalogInfo, CatalogItem } from 'framework3/core';
import { TrackableItem } from 'framework3/core';
import { SistemaInfo } from '../models/sistema';
import { TipoLicenciaInfo } from '../models/tipo-licencia';

export class LicenciaInfo extends CatalogInfo {
	idSistema: number;
	idTipoLicencia: number;
	adquisicion: Date;
	activacion: Date;
	vencimiento: Date;
	idSubMarca: number;
	numSerie: string;
	clabe: string;
	cantActivacion: number;
	idPropietario: number;
	idComprobante: string;
	fechaComprobante: Date;

    documentos: LicenciaDocumento[];

    sistema: SistemaInfo;

    tipoLicencia: TipoLicenciaInfo;

    constructor() {
        super();
        this.documentos = [];
        this.sistema = new SistemaInfo;
        this.tipoLicencia = new TipoLicenciaInfo;
    }
}

export class LicenciaItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
	selected?:boolean = false;
}

export class LicenciaDocumento extends TrackableItem {

    idTipoDocumeno: number;
    documento: string;

    constructor() {
        super();
        this.idTipoDocumeno = 0;
        this.documento = "";

    }

}