﻿import { Context, CatalogInfo, CatalogItem } from 'framework3/core';
import { PiezaInfo } from '../models/pieza';
import { LlantaPosicionInfo } from '../models/llanta-posicion';

export class LlantaInfo extends CatalogInfo {
	idLlantaPosicion: number;
	idVehiculo: number;
	idPieza: number;
	dOT: string;
	profundidad: number;
	refaccion: boolean;
	idCuenta: number;

    pieza: PiezaInfo;

    posicion: LlantaPosicionInfo;

    constructor() {
      
        super();

        this.pieza = new PiezaInfo;
        this.posicion = new LlantaPosicionInfo;
        this.idVehiculo = 0;
    }
}

export class LlantaItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
    selected?: boolean = false;
    idVehiculo: number;
}