﻿import { Context, CatalogInfo, CatalogItem } from 'framework3/core';
import { LicenciaInfo } from '../models/licencia';
import { TrackableItem } from 'framework3/core';

export class SoftwareInfo extends CatalogInfo {
	idLicencia: number;
	plataforma: string;
	noVersion: string;
	linkDescarga: string;
	linkSoporte: string;
	idSoftwarePrececesor: number;

    licencia: LicenciaInfo;

    activaciones: Activacion[];

    requerimientos: Requerimiento[];

    constructor() {
        super();
        this.licencia = new LicenciaInfo;
        this.activaciones = [];
        this.requerimientos = [];
    }
}

export class SoftwareItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
	selected?:boolean = false;
}

export class Activacion extends TrackableItem {
    idDestinatario: number;
    tipoDestino: string;
    nombreDestinatario: string;
    nombreTipoDestino: string;

    constructor() {
        super();
        this.idDestinatario = 0;
        this.tipoDestino = '';
        this.nombreDestinatario = '';
        this.nombreTipoDestino = '';
    }
}

export class Requerimiento extends TrackableItem {
    idRequerimiento: number;
    idSoftware: number;
    nombre: string;
    descripcion: string;
    orden: number;

    constructor() {
        super();
        this.idRequerimiento = 0;
        this.idSoftware = 0;
        this.nombre = '';
        this.descripcion = '';
        this.orden = 0;
    }
}