﻿import { Context, CatalogInfo, CatalogItem, TrackableItem } from 'framework3/core';
import { ClasificacionValor, IClasificable } from 'framework3/general';
import { EquipoInfo } from './equipo';

export class VehiculoInfo extends CatalogInfo {
	idEquipo: number;
	placas: string;
	color: string;
	numSerieMotor: string;
	idCuenta: number;

    equipo: EquipoInfo;

    clasificaciones: ClasificacionValor[];
    llantas: VehiculoLlantaItem[];

    constructor() {
        super();

        this.equipo = new EquipoInfo;
        this.clasificaciones = [];
        this.llantas = [];
    }
}

export class VehiculoItem implements CatalogItem {    
    id: number;
    codigo: string;
    numEconomico: string;
    placas: string;
    color: string;
    activo: boolean;
    estatus?: string;
	selected?:boolean = false;
}

export class VehiculoLlantaItem extends TrackableItem {
    idLlanta: number;
    nombre: string;
    modelo: string;
    numEconomico: string;
    numSerie: string;
    idLlantaPosicion: number;
    posicion: string;
}