﻿//Frameworks
import { Component, ViewChild, Input, Output, EventEmitter } from '@angular/core';
import { FormBuilder, FormGroup, Validators } from '@angular/forms';
//Bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//Azteca Kernel
import { Context } from 'framework3/core';
import { AztecaValidators } from 'framework3/controls';
//Features
import { SubMarca } from '../models/submarca';

@Component({
    selector: 'maintenance-marca-submarca-editor',
    templateUrl:'./submarca.editor.html'
})
export class SubMarcaEditor {
    editorForm: FormGroup;
    //
    @Input() data: SubMarca;
    //
    @Output() dataUpdated: EventEmitter<SubMarca> = new EventEmitter<SubMarca>();
    //
    @ViewChild('dialog') dialog: ModalDirective;

    constructor(private formBuilder: FormBuilder) {

        this.editorForm = formBuilder.group({
            'nombre': ['', Validators.required]
        });
    }

    show() {
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(_ => this.editorForm.reset());
    }

    onUpdate() {
        this.dataUpdated.emit(this.data);
        this.dialog.hide();
    }
}
