﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService, FileLink } from 'framework3/core';
//Locales
import { AplicacionInfo, AplicacionConfiguracionItem } from '../models/aplicacion'

@Injectable()
export class AplicacionService extends CatalogService<AplicacionInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/aplicaciones');
    }

    create(): Promise<AplicacionInfo> {
        return Promise.resolve(new AplicacionInfo());
    }

    getLinkDescarga(id: number): Promise<string> {
        let params = new HttpParams()
            .set("idVersion", id.toString());
        return this.apiService.getText("get-link-version", params).toPromise();
    }

    getLinkDescargaQr(id: number): Promise<string> {
        let params = new HttpParams()
            .set("idVersion", id.toString());
        return this.apiService.getText("get-link-version-qr", params).toPromise();
    }

    getFileConfiguracionesQr(key: string, configuraciones: AplicacionConfiguracionItem[]): Promise<FileLink> {
        let params = new HttpParams()
            .set("key", key);

        return this.apiService.post<FileLink>("get-file-configuraciones-qr", params, configuraciones).toPromise();

    }

}

