﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import * as moment from 'moment';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
import { SearchResult, SearchRequest } from 'framework3/search';
//Local
import { getDispositivosConfiguracionModelos } from '../models/DispositivosConfiguracionModelo';


@Injectable()
export class ConfigDispositivosService extends CatalogService<getDispositivosConfiguracionModelos> {
    arrayTit: any[] = [];
    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/maintenance/configuraciones-dispositivos");
    }

    create(): Promise<getDispositivosConfiguracionModelos> {
        return Promise.resolve(new getDispositivosConfiguracionModelos());
    }

    //obtener las clasificaciones
    getClasificacionesDispositivos(dispositivo: string): Promise<getDispositivosConfiguracionModelos[]> {
        let params = new HttpParams()
            .append("dispositivo", dispositivo);
        return this.apiService.get<getDispositivosConfiguracionModelos[]>("get-clasificacionesgrupos", params).toPromise();
    }

    //enviar notificaciones
    sendNotificaciones(dispositivo: string): Promise<boolean> {
        let params = new HttpParams()
            .append("dispositivo", dispositivo);
        return this.apiService.get<boolean>("send-notificaciones", params).toPromise();
    }


}