﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, HierarchyInfo, HierarchyService } from 'framework3/core';
//Locales
import { DespieceInfo } from '../models/despiece';

@Injectable()
export class DespieceService extends HierarchyService<DespieceInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/mantenimiento/despiece");
    }

    create(): Promise<DespieceInfo> {
        return Promise.resolve(new DespieceInfo());
    }


    LoadPiezas(idEquipoGrupo: number, idEmpresa: number): Promise<DespieceInfo[]> {
        let params = new HttpParams()
            .set("idEquipoGrupo", idEquipoGrupo.toString())
            .set("idEmpresa", idEquipoGrupo.toString());
        return this.apiService.get<DespieceInfo[]>("load-piezas", params)
            .toPromise();
    }


}
