﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { EquipoInformaticaTipoInfo, EquipoInformaticaTipoItem } from '../models/equipo-informatica-tipo'

@Injectable()
export class EquipoInformaticaTipoService extends CatalogService<EquipoInformaticaTipoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/equipos-informatica-tipos');
    }

    create(): Promise<EquipoInformaticaTipoInfo> {
        return Promise.resolve(new EquipoInformaticaTipoInfo());
    }

    LoadList(): Promise<EquipoInformaticaTipoItem[]> {
        let params = new HttpParams()
        return this.apiService.get<EquipoInformaticaTipoItem[]>("load-tipos",params)
            .toPromise();
    }


}

