﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { LicenciaInfo } from '../models/licencia'
import { Documento } from '../models/documento'
import { FileInfo } from 'framework3/general';

@Injectable()
export class LicenciaService extends CatalogService<LicenciaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/licencias');
    }

    create(): Promise<LicenciaInfo> {
        return Promise.resolve(new LicenciaInfo());
    }

    LoadDocumentos(idLicencia: number): Promise<Documento[]> {
        let params = new HttpParams()
            .set("idLicencia", idLicencia.toString());
        return this.apiService.get<Documento[]>("load-documentos", params)
            .toPromise();
    }

    AgregarDocumento(idLicencia: number, idTipoDocumento: number, fileInfo: FileInfo): Promise<any> {
        let params = new HttpParams()
            .set("idLicencia", idLicencia.toString())
            .set("idTipoDocumento", idTipoDocumento.toString());
        return this.apiService.post<any>("agregar-documento", params, fileInfo)
            .toPromise();
    }

    EliminarDocumento(idLicencia: number, idTipoDocumento: number, idArchivo: string): Promise<any> {
        let params = new HttpParams()
            .set("idLicencia", idLicencia.toString())
            .set("idTipoDocumento", idTipoDocumento.toString())
            .set("idArchivo", idArchivo);
        return this.apiService.delete<any>("eliminar-documento", params)
            .toPromise();

    }

	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<LicenciaInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<LicenciaInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

