﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { LlantaPosicionInfo, LlantaPosicionItem } from '../models/llanta-posicion'


@Injectable()
export class LlantaPosicionService extends CatalogService<LlantaPosicionInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/llantas-posiciones');
    }

    create(): Promise<LlantaPosicionInfo> {
        return Promise.resolve(new LlantaPosicionInfo());
    }

    loadList(idSucursal: number): Promise<LlantaPosicionItem[]> {
        let params = new HttpParams()
            .append("idSucursal", idSucursal.toString());
        return this.apiService.get<LlantaPosicionItem[]>("load-list", params)
            .toPromise();
    }


}

