﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { LlantaInfo, LlantaItem } from '../models/llanta'

@Injectable()
export class LlantaService extends CatalogService<LlantaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/llantas');
    }

    create(): Promise<LlantaInfo> {
        return Promise.resolve(new LlantaInfo());
    }

    //Metodos del selector customizados
    searchKeywordLlantas(idBranch: number, keyword: string, sinVehiculo: boolean): Observable<LlantaItem[]> {
        let params = new HttpParams()
            .append('idBranch', idBranch.toString())
            .append('keyword', keyword)
            .append('sinVehiculo', sinVehiculo.toString())
            ;
        return this.apiService.get<LlantaItem[]>('search-llantas', params);
    }


	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<LlantaInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<LlantaInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

