﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { LocalizacionTipoInfo, LocalizacionTipoItem } from '../models/localizacion-tipo'

@Injectable()
export class LocalizacionTipoService extends CatalogService<LocalizacionTipoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/localizaciones-tipos');
    }

    create(): Promise<LocalizacionTipoInfo> {
        return Promise.resolve(new LocalizacionTipoInfo());
    }

    loadList(idSucursal: number): Promise<LocalizacionTipoItem[]> {
        let params = new HttpParams()
            .append("idSucursal", idSucursal.toString());
        return this.apiService.get<LocalizacionTipoItem[]>("load-list", params)
            .toPromise();
    }


	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<LocalizacionTipoInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<LocalizacionTipoInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

