﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, HierarchyInfo, HierarchyService } from 'framework3/core';
//Locales
import { LocalizacionInfo } from '../models/localizacion';

@Injectable()
export class LocalizacionService extends HierarchyService<LocalizacionInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/mantenimiento/localizaciones");
    }

    create(): Promise<LocalizacionInfo> {
        return Promise.resolve(new LocalizacionInfo());
    }

	/*
	//Sample method
    sampleMethod(param1: number): Promise<LocalizacionInfo> {
        let params: URLSearchParams = new URLSearchParams();
        params.set('param1', param1.toString());
        return this.apiService.getData('sample-method', params)
            .map(response => response.json() as LocalizacionInfo)
            .toPromise();
    }
	*/

}
