﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import {Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogInfo, CatalogItem, CatalogService} from 'framework3/core';
//Locales
import { MarcaInfo } from '../models/marcas';

@Injectable()
export class MarcaService extends CatalogService<MarcaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/maintenance/marcas");
    }

    create(): Promise<MarcaInfo> {
        return Promise.resolve(new MarcaInfo());
    }

	


    deleteSubMarca(idSubMarca: number): Promise<void> {
        let params = new HttpParams()
            .set("idSubMarca", idSubMarca.toString());
        return this.apiService.get<void>("delete-submarca", params)
            .toPromise();
    }

    searchKeyword2(idBranch: number, keyword: string, idServicioTipo: number): Observable<CatalogItem[]> {
        let params = new HttpParams()
            .set("idBranch", idBranch.toString())
            .set("keyword", keyword)
            .set("idServicioTipo", idServicioTipo.toString());
        return this.apiService.get<CatalogItem[]>("search-marca", params)

    }


}