﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Framework
import { Context, DocumentInfo, DocumentItem, DocumentService } from 'framework3/core';
//Locales
import { OrdenInfo, OrdenItem } from '../models/orden';
import { OrdenDetail } from '../models/orden-detail';

import { RecursoItem } from '../models/recurso'

@Injectable()
export class OrdenService extends DocumentService<OrdenDetail, OrdenInfo> {

    constructor(protected http: HttpClient, protected context: Context ) {
        super(http, context, 'api/mantenimiento/ordenes');
    }

    create(): Promise<OrdenInfo> {
        let newDoc = new OrdenInfo();
        return Promise.resolve(newDoc);
    }



    AsignarRecurso(idOrden: string, idRecurso: number, Req: string): Promise<any> {
        let params = new HttpParams()
            .set("idOrden", idOrden)
            .set("idRecurso", idRecurso.toString());
        return this.apiService.post<any>("asignar-recurso", params, Req)
            .toPromise();
    }

    ListRecursos(idOrden: string): Promise<RecursoItem[]> {
        let params = new HttpParams()
            .set("idOrden", idOrden);
        return this.apiService.get<RecursoItem[]>("list-recursos", params)
            .toPromise();
    }

    DesasignarRecurso(idOrden: string, idRecurso: number): Promise<any> {
        let params = new HttpParams()
            .set("idOrden", idOrden)
            .set("idRecurso", idRecurso.toString());
        return this.apiService.delete<any>("desasignar-recurso", params)
            .toPromise();
    }
    
	/*
    sampleMethod(param: string): Promise<MovimientoInfo> {
        let params: URLSearchParams = new URLSearchParams();
        params.set('param', param);                
        return this.apiService.getData('sample-method', params)
            .map(response => response.json() as MovimientoInfo)
            .toPromise();
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) en los resultados de búsquedas. Eliminar si no es necesario
	protected mapSearchResult(row: any) {
        
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) al cargar un documento. Eliminar si no es necesario
    protected mapDocument(document: OrdenInfo) {

    }
	*/



}