﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService, CatalogItem } from 'framework3/core';
//Locales
import { PoliticaInfo } from '../models/politica'

@Injectable()
export class PoliticaService extends CatalogService<PoliticaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/politicas');
    }

    create(): Promise<PoliticaInfo> {
        return Promise.resolve(new PoliticaInfo());
    }


    searchKeyword2(idBranch: number, keyword: string, tipo: string): Observable<CatalogItem[]> {
        let params = new HttpParams()
            .set("idBranch", idBranch.toString())
            .set("keyword", keyword)
            .set("tipo", tipo);
        return this.apiService.get<CatalogItem[]>("search-politica", params)

    }


	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<PoliticaInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<PoliticaInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

