﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { PropietarioInfo, PropietarioItem } from '../models/propietario'

@Injectable()
export class PropietarioService extends CatalogService<PropietarioInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/propietarios');
    }

    create(): Promise<PropietarioInfo> {
        return Promise.resolve(new PropietarioInfo());
    }

    loadList(idSucursal: number): Promise<PropietarioItem[]> {
        let params = new HttpParams()
            .append("idSucursal", idSucursal.toString());
        return this.apiService.get<PropietarioItem[]>("load-list", params)
            .toPromise();
    }


	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<PropietarioInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<PropietarioInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

