﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService, CatalogItem } from 'framework3/core';
//Locales
import { RecursoInfo, RecursoItem } from '../models/recurso'

@Injectable()
export class RecursoService extends CatalogService<RecursoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/recursos');
    }

    create(): Promise<RecursoInfo> {
        return Promise.resolve(new RecursoInfo());
    }

    searchKeyword2(idBranch: number, keyword: string, idServicioTipo: number): Observable<RecursoItem[]> {
        let params = new HttpParams()
            .set("idBranch", idBranch.toString())
            .set("keyword", keyword)
            .set("idServicioTipo", idServicioTipo.toString());
        return this.apiService.get<RecursoItem[]>("search-recurso", params)

    }

}

