﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { RedTelefonicaInfo, RedTelefonicaItem } from '../models/red-telefonica'

@Injectable()
export class RedTelefonicaService extends CatalogService<RedTelefonicaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/redes-telefonicas');
    }

    create(): Promise<RedTelefonicaInfo> {
        return Promise.resolve(new RedTelefonicaInfo());
    }

    loadList(idSucursal: number): Promise<RedTelefonicaItem[]> {
        let params = new HttpParams()
            .append("idSucursal", idSucursal.toString());
        return this.apiService.get<RedTelefonicaItem[]>("load-list", params)
            .toPromise();
    }


	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<RedTelefonicaInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<RedTelefonicaInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

