﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { ServicioInfo, ServicioItem } from '../models/servicio'

@Injectable()
export class ServicioService extends CatalogService<ServicioInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/servicios');
    }

    create(): Promise<ServicioInfo> {
        return Promise.resolve(new ServicioInfo());
    }


    LoadList(idOrden: string): Promise<ServicioItem[]> {
        let params = new HttpParams()
            .set("idOrden", idOrden);
        return this.apiService.get<ServicioItem[]>("load-servicios", params)
            .toPromise();
    }

}

