﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { SistemaOperativoInfo, SistemaOperativoItem } from '../models/sistema-operativo'

@Injectable()
export class SistemaOperativoService extends CatalogService<SistemaOperativoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/sistemas-operativos');
    }

    create(): Promise<SistemaOperativoInfo> {
        return Promise.resolve(new SistemaOperativoInfo());
    }

    loadList(idSucursal: number): Promise<SistemaOperativoItem[]> {
        let params = new HttpParams()
            .append("idSucursal", idSucursal.toString());
        return this.apiService.get<SistemaOperativoItem[]>("load-list", params)
            .toPromise();
    }


	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<SistemaOperativoInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<SistemaOperativoInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

