﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { SoftwareInfo, SoftwareItem } from '../models/software'

@Injectable()
export class SoftwareService extends CatalogService<SoftwareInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/softwares');
    }

    create(): Promise<SoftwareInfo> {
        return Promise.resolve(new SoftwareInfo());
    }

    loadList(idSucursal: number): Promise<SoftwareItem[]> {
        let params = new HttpParams()
            .append("idSucursal", idSucursal.toString());
        return this.apiService.get<SoftwareItem[]>("load-list", params)
            .toPromise();
    }


	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<SoftwareInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<SoftwareInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

