﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { TallerInfo, TallerItem } from '../models/taller'

@Injectable()
export class TallerService extends CatalogService<TallerInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/talleres');
    }

    create(): Promise<TallerInfo> {
        return Promise.resolve(new TallerInfo());
    }

    loadList(idSucursal:number, idTipoServicio:number): Promise<TallerItem[]> {
        let params = new HttpParams()
            .set("idSucursal", idSucursal.toString())
            .set("idTipoServicio", idTipoServicio.toString());

        return this.apiService.get<TallerItem[]>("load-list", params)
            .toPromise();
    }



}

