﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { TipoCombustibleInfo, TipoCombustibleItem } from '../models/tipo-combustible'

@Injectable()
export class TipoCombustibleService extends CatalogService<TipoCombustibleInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/tipos-combustible');
    }

    create(): Promise<TipoCombustibleInfo> {
        return Promise.resolve(new TipoCombustibleInfo());
    }

    loadList(): Promise<TipoCombustibleItem[]> {
        let params = new HttpParams();
        return this.apiService.get<TipoCombustibleItem[]>("load-list", params)
            .toPromise();
    }


	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<TipoCombustibleInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<TipoCombustibleInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

