﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { TipoLicenciaInfo, TipoLicenciaItem } from '../models/tipo-licencia';

@Injectable()
export class TipoLicenciaService extends CatalogService<TipoLicenciaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/tipos-licencias');
    }

    create(): Promise<TipoLicenciaInfo> {
        return Promise.resolve(new TipoLicenciaInfo());
    }

    loadList(idSucursal: number): Promise<TipoLicenciaItem[]> {
        let params = new HttpParams()
            .append("idSucursal", idSucursal.toString());
        return this.apiService.get<TipoLicenciaItem[]>("load-list", params)
            .toPromise();
    }

	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<TipoLicenciaInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<TipoLicenciaInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

