﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { TipoMotorInfo, TipoMotorItem } from '../models/tipo-motor'

@Injectable()
export class TipoMotorService extends CatalogService<TipoMotorInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/mantenimiento/tiposmotor");
    }

    create(): Promise<TipoMotorInfo> {
        return Promise.resolve(new TipoMotorInfo());
    }


	//Sample method
    loadList(): Promise<TipoMotorItem[]> {
        let params = new HttpParams()
        return this.apiService.get<TipoMotorItem[]>("load-list", params)
            .toPromise();
    }


}

