﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { TipoOrdenInfo, TipoOrdenItem } from '../models/tipo-orden'

@Injectable()
export class TipoOrdenService extends CatalogService<TipoOrdenInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/mantenimiento/tipos-ordenes');
    }

    create(): Promise<TipoOrdenInfo> {
        return Promise.resolve(new TipoOrdenInfo());
    }


    loadList(): Promise<TipoOrdenItem[]> {
        let params = new HttpParams()
        return this.apiService.get<TipoOrdenItem[]>("load-list", params)
            .toPromise();
    }


}

