﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { TipoTransmisionInfo, TipoTransmisionItem } from '../models/tipo-transmision'

@Injectable()
export class TipoTransmisionService extends CatalogService<TipoTransmisionInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/mantenimiento/tipostransmision");
    }

    create(): Promise<TipoTransmisionInfo> {
        return Promise.resolve(new TipoTransmisionInfo());
    }

    //Sample method
    loadList(idEmpresa: number): Promise<TipoTransmisionItem[]> {
        let params = new HttpParams()
            .set("idEmpresa", idEmpresa.toString());
        return this.apiService.get<TipoTransmisionItem[]>("load-list", params)
            .toPromise();
    }

}

