﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { VehiculoInfo, VehiculoLlantaItem } from '../models/vehiculo'

@Injectable()
export class VehiculoService extends CatalogService<VehiculoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/mantenimiento/vehiculos");
    }

    create(): Promise<VehiculoInfo> {
        return this.apiService.get<VehiculoInfo>('create', null)
            .toPromise();
    }


	/*
	//Sample method
    sampleMethod(param1: number): Promise<VehiculoInfo> {
        let params: URLSearchParams = new URLSearchParams();
        params.set("param1", param1.toString());
        return this.apiService.getData("sample-method", params)
            .map(response => response.json() as VehiculoInfo)
            .toPromise();
    }
	*/
}

