﻿import { Context, CatalogInfo, CatalogItem } from 'framework3/core';
import { ArticuloStockInfo } from '../../inventory'
import { ProductoInsumo } from './producto-insumo';
import { ProductoSubproducto } from './producto-subproducto';

export class ProductoInfo extends CatalogInfo {
    nombre: string;
    idArticuloStock: number;
    idUnidadMedidaTipo: number;
	idUnidadMedida: number;
	produccionMinima: number;
	multiplosProduccion: number;
    idCuenta: number;
    insumos: ProductoInsumo[];
    subProductos: ProductoSubproducto[];
    articulo: ArticuloStockInfo;

    constructor() {
        super();

        this.insumos = [];
        this.subProductos = [];
        this.articulo = new ArticuloStockInfo();
    }
}

export class ProductoItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
	selected?:boolean = false;
}