﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { ProductoInfo } from '../models/producto'
import { ProductoInsumo } from '../models/producto-insumo'

@Injectable()
export class ProductoService extends CatalogService<ProductoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/produccion/productos");
    }

    create(): Promise<ProductoInfo> {
        return Promise.resolve(new ProductoInfo());
    }
    	
    explosionar(idProducto: number, cantidad: number): Promise<ProductoInsumo[]> {
        let params = new HttpParams()
            .append("IdProducto",idProducto.toString())
            .append("Cantidad", cantidad.toString());
        return this.apiService.get<ProductoInsumo[]>("explosionar", params)
            .toPromise();
    }
}

