﻿import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

//////////////////////////// Guards //////////////////////////////////
import { AuthGuard } from './services/auth-guard.service';

/////////////////////////// Componentes //////////////////////////////
import { LoginComponent } from './components/login.component';
import { RegistroComponent } from './components/registro.component';
import { PreRegistroComponent } from './components/pre-registro.component';
import { UploadInvoiceComponent } from './components/upload-invoice.component';
import { ValidacionCFDComponent } from './parts/validacion-cfd.component';

const routes: Routes = [
    { path: 'login', component: LoginComponent },
    { path: 'registro/:proveedor/:expira', component: RegistroComponent },
    { path: 'pre-registro', component: PreRegistroComponent },
    {
        path: '',
        canActivateChild: [AuthGuard],
        children: [
            { path: 'upload', component: UploadInvoiceComponent },
            //PARTS
            { path: 'upload/validacion', component: ValidacionCFDComponent },
        ]
    },
];

@NgModule({
    imports: [
        RouterModule.forChild(routes)
    ],
    exports: [
        RouterModule
    ]
})
export class ProveedoresRoutingModule { }

