﻿import { Injectable } from '@angular/core';
//
import { EmpresaItem } from 'framework3/core';
//
import { ProveedorInfo } from '../../purchasing/models/proveedor';

@Injectable()
export class PortalContext {

    private _companies: EmpresaItem[] = [];
    private _proveedor: ProveedorInfo

    get companies(): EmpresaItem[] {
        if (this._companies.length > 0) {
            return this._companies;
        }
        else {
            let storedCompanies: string = sessionStorage.getItem('proveedores-companies');
            if (storedCompanies != null) {
                this._companies = JSON.parse(storedCompanies);
                return this._companies;
            }
            else {
                return [];
            }
        }
    }

    get proveedor(): ProveedorInfo {
        if (this._proveedor) {
            return this._proveedor;
        }
        else {
            let storedProvider: string = sessionStorage.getItem('proveedores-proveedor');
            if (storedProvider != null) {
                this._proveedor = JSON.parse(storedProvider);
                return this._proveedor;
            }
            else {
                return null;
            }
        }
    }

    setCompanies(companies: EmpresaItem[]) {
        this._companies = companies;
        sessionStorage.setItem('proveedores-companies', JSON.stringify(companies));
    }

    setProveedor(proveedor: ProveedorInfo) {
        this._proveedor = proveedor;
        sessionStorage.setItem('proveedores-proveedor', JSON.stringify(proveedor));
    }

}