﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

import { ArticuloService } from '../services/articulo.service';
import { ArticuloItem } from '../models/articulo';

//

@Component({
    selector: 'purchasing-articulo-list',
    templateUrl: './articulo-list.component.html'
})
export class ArticuloListComponent extends CatalogListDialog {

    articulos: ArticuloItem[];

    constructor(protected context: Context, private articuloSvc: ArticuloService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.articuloSvc.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.articulos = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedItems: ArticuloItem[]) {
        this.selectedItemsChanged.emit(selectedItems);
    }

    onSelectedItemChanged(item: ArticuloItem) {
        this.selectedItemChanged.emit(item);
    }

}