﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

import { CategoriasPresupuestalesService } from '../services/categorias-presupuestales.service';
import { ArticuloItem } from '../models/articulo';

//

@Component({
    selector: 'purchasing-categoria-presupuestal-articulos-list',
    templateUrl: './categorias-presupuestal-articulos-list.component.html'
})
export class CategoriaPresupuestalArticulosListComponent extends CatalogListDialog {

    articulos: ArticuloItem[];    
    idCategoriaPresupuestal: number;
    @Output() multiSelect: boolean=false;
    

    constructor(protected context: Context, private categoriaSvc: CategoriasPresupuestalesService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.categoriaSvc.searchArticuloCategoriaPresupuestal(this.idCategoriaPresupuestal, this.context.app.defaultSite.identity, request)
            .then(result => {
                this.articulos = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedItems: ArticuloItem[]) {
        this.selectedItemsChanged.emit(selectedItems);
    }

    onSelectedItemChanged(item: ArticuloItem) {
        this.selectedItemChanged.emit(item);
    }

}