﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

import { CategoriasPresupuestalesService } from '../services/categorias-presupuestales.service';
import { CategoriasPresupuestalesItem } from '../models/categorias-presupuestales';

//

@Component({
    selector: 'purchasing-categoria-presupuestal-list',
    templateUrl: './categorias-presupuestal-list.component.html'
})
export class CategoriaPresupuestalListComponent extends CatalogListDialog {

    categoriasPresupuestales: CategoriasPresupuestalesItem[];

    constructor(protected context: Context, private categoriaSvc: CategoriasPresupuestalesService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.categoriaSvc.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.categoriasPresupuestales = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedItems: CategoriasPresupuestalesItem[]) {
        this.selectedItemsChanged.emit(selectedItems);
    }

    onSelectedItemChanged(item: CategoriasPresupuestalesItem) {
        this.selectedItemChanged.emit(item);
    }

}