﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

import { CategoriasPresupuestalesService } from '../services/categorias-presupuestales.service';
import { ServicioItem } from '../models/servicio';

//

@Component({
    selector: 'purchasing-categoria-presupuestal-servicios-list',
    templateUrl: './categorias-presupuestal-servicios-list.component.html'
})
export class CategoriaPresupuestalServiciosListComponent extends CatalogListDialog {

    servicios: ServicioItem[];
    idCategoriaPresupuestal: number;
    @Output() multiSelect: boolean = false;


    constructor(protected context: Context, private categoriaSvc: CategoriasPresupuestalesService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.categoriaSvc.searchServicioCategoriaPresupuestal(this.idCategoriaPresupuestal, this.context.app.defaultSite.identity, request)
            .then(result => {
                this.servicios = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedItems: ServicioItem[]) {
        this.selectedItemsChanged.emit(selectedItems);
    }

    onSelectedItemChanged(item: ServicioItem) {
        this.selectedItemChanged.emit(item);
    }

}