﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

import { CentroRecepcionService } from '../services/centro-recepcion.service';
import { CentroRecepcionItem } from '../models/centro-recepcion';

//

@Component({
    selector: 'purchasing-centros-recepcion-list',
    templateUrl: './centros-recepcion-list.component.html'
})
export class CentrosRecepcionListComponent extends CatalogListDialog {
    centrosRecepcion: CentroRecepcionItem[];

    constructor(protected context: Context, private centroRecepcionService: CentroRecepcionService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.centroRecepcionService.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.centrosRecepcion = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedItems: CentroRecepcionItem[]) {
        this.selectedItemsChanged.emit(selectedItems);
    }

    onSelectedItemChanged(item: CentroRecepcionItem) {
        this.selectedItemChanged.emit(item);
    }

}