﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context} from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

import { DepartamentoService } from '../services/departamento.service';
import { DepartamentoInfo, DepartamentoItem } from '../models/departamento';

//

@Component({
    selector: 'purchasing-departamentos-list',
    templateUrl: './departamentos-list.component.html'
})
export class DepartamentosListComponent extends CatalogListDialog {
    departamentos: DepartamentoItem[];

    constructor(protected context: Context, private departamentoService: DepartamentoService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.departamentoService.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.departamentos = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedItems: DepartamentoItem[]) {
        this.selectedItemsChanged.emit(selectedItems);
    }

    onSelectedItemChanged(item: DepartamentoItem) {
        this.selectedItemChanged.emit(item);
    }

}