﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

import { ServicioService } from '../services/servicio.service';
import { ServicioItem } from '../models/servicio';

//

@Component({
    selector: 'purchasing-servicio-list',
    templateUrl: './servicio-list.component.html'
})
export class ServicioListComponent extends CatalogListDialog {

    servicios: ServicioItem[];

    constructor(protected context: Context, private servicioSvc: ServicioService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.servicioSvc.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.servicios = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedItems: ServicioItem[]) {
        this.selectedItemsChanged.emit(selectedItems);
    }

    onSelectedItemChanged(item: ServicioItem) {
        this.selectedItemChanged.emit(item);
    }

}