﻿import { Component, Input, Output, EventEmitter } from '@angular/core';
import { FormGroup, FormBuilder, AbstractControl, Validators } from '@angular/forms';

//Kernel
import { Context } from 'framework3/core';
import { BasicEditor, ChangeState } from 'framework3/editors';
//Locales
import { GastoDetail } from '../../models/gasto-detail';

@Component({
    selector: 'compras-gasto-detail-editor',
    templateUrl: './gastos-detail.editor.html'
})
export class GastoDetailEditor extends BasicEditor {    
    //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
    detailCopy = new GastoDetail();
    //Objeto original que se editará
    @Input() detail: GastoDetail = new GastoDetail();

    constructor(protected context: Context, private builder: FormBuilder) {
        super(context);

        this.form = builder.group({
            'sample': ['', Validators.required],
        });
    }

    /////////////////// METODOS ///////////////////////////////


    /////////////////// HANDLERS //////////////////////////////

    onCreatingItem() {
        this.detailCopy = this.detail;
		this.form.reset({ sample: '' });
        this.form.markAsPristine();
    }

    onLoadingItem(detail: GastoDetail ) {
        this.detailCopy = <GastoDetail>this.copyItem(this.detail);
    }

    onUpdatingItem(detail: GastoDetail ) {
        if (this.detailCopy._clientID == 0) {
            this.detailCopy._clientID = this.createClientID();
        }
        else {
            this.detailCopy.state = ChangeState.MODIFIED;
        }
        this.savingItem.emit(this.detailCopy);
    }
}
