﻿import { Component, Input, Output, EventEmitter } from '@angular/core';
import { FormGroup, FormBuilder, AbstractControl, Validators } from '@angular/forms';

//Kernel
import { Context } from 'framework3/core';
import { BasicEditor, ChangeState } from 'framework3/editors';
//Locales
import { RecepcionServicioDetail } from '../../models/recepcion-servicio-detail';
//Inventario
import { ArticuloStockInfo, UnidadMedidaInfo, UnidadMedidaItem, StockInfo, LoteInfo, SerieInfo, UnidadMedidaService, AlmacenService, MetodoValuacion } from '../../../inventory';
import { setTimeout } from 'timers';

@Component({
    selector: 'compras-recepcion-servicios-detail-editor',
    templateUrl: './recepcion-servicios-detail.editor.html'
})
export class RecepcionServiciosDetailEditor extends BasicEditor {
    unidadesMedida: UnidadMedidaItem[] = [];
    validInput: boolean = false;
    //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
    detailCopy = new RecepcionServicioDetail();
    //Objeto original que se editará
    @Input() detail: RecepcionServicioDetail = new RecepcionServicioDetail();

    @Input() idAlmacen: number;

    costoUnitario: number;
    //

    constructor(protected context: Context, private builder: FormBuilder, private unidadMedidaService: UnidadMedidaService, private almacenService: AlmacenService) {
        super(context);

        this.form = builder.group({
            'cantidad': [0],
        });
    }

    /////////////////// METODOS ///////////////////////////////

    //loadUnidadesMedida(idTipoUnidad: number) {
    //    //Si el articulo esta controlado por series, no se puede cambiar la unidad de medida, por lo tanto solo se debe utilizar la unidad de medida el articulo,
    //    //en caso contrario, cargar lista de unidades de medida del mismo tipo
    //    if (this.stockConfig.manejaSeries) {
    //        let unidadArticulo = this.detailCopy.articulo.articuloStock.unidadMedida;
    //        let newUnidad: UnidadMedidaItem = {
    //            id: unidadArticulo.identity, codigo: unidadArticulo.code, idUnidadMedidaTipo: unidadArticulo.idUnidadMedidaTipo, base: unidadArticulo.base,
    //            factor: unidadArticulo.factor, fraccionable: unidadArticulo.fraccionable, paquete: unidadArticulo.paquete, activo: true
    //        };
    //        let newUnidades = [];
    //        newUnidades.push(newUnidad);
    //        this.unidadesMedida = newUnidades;
    //        this.detailCopy.idUnidadMedida = unidadArticulo.identity;
    //    }
    //    else {
    //        this.unidadMedidaService.loadList(idTipoUnidad)
    //            .then(unidadesMedida => {
    //                this.unidadesMedida = unidadesMedida;
    //                this.detailCopy.idUnidadMedida = this.detailCopy.articulo.idUnidadMedida;
    //            })
    //            .catch(error => this.handleError(error));
    //    }
    //}

    //loadStock(idArticulo: number) {
    //    this.almacenService.loadStock(this.idAlmacen, idArticulo)
    //        .then(stock => {
    //            this.stockConfig = stock;
    //            this.loadUnidadesMedida(this.detailCopy.articulo.articuloStock.unidadMedida.idUnidadMedidaTipo);
    //        })
    //        .catch(error => this.handleError(error));
    //}
    /////////////////// HANDLERS //////////////////////////////

    onCreatingItem() {
        this.detailCopy = this.detail;
        this.form.reset({ cantidad: 0 });
        this.form.markAsPristine();
    }

    onLoadingItem(detail: RecepcionServicioDetail) {
        this.detailCopy = <RecepcionServicioDetail>this.copyItem(this.detail);        
        this.costoUnitario = this.detailCopy.costoUnitario;        
        //this.form.updateValueAndValidity();

        //setTimeout(_ => this.loadStock(this.detailCopy.articulo.articuloStock.identity), 3000);
    }

    ngAfterViewInit() {
        //setTimeout(_ => this.loadStock(this.detailCopy.articulo.articuloStock.identity));            
        this.form.controls['cantidad'].updateValueAndValidity();
        this.form.controls['cantidad']
        this.form.updateValueAndValidity();

        this.form.markAsPristine();     
    }

    onUpdatingItem(detail: RecepcionServicioDetail) {
        //this.unidadMedidaService.getDetailFromCache(this.detailCopy.idUnidadMedida)
        //    .then(unidad => {
        //        this.detailCopy.unidadMedida = unidad;
                if (this.detailCopy._clientID == 0) {
                    this.detailCopy._clientID = this.createClientID();
                }
                else {
                    this.detailCopy.state = ChangeState.MODIFIED;
                }
                this.savingItem.emit(this.detailCopy);
                this.detailCopy = new RecepcionServicioDetail();
         //   })
         //   .catch(error => this.handleError(error));
    }

    cantidadChanged(monto: number) {
        this.detailCopy.importe = this.detailCopy.costoUnitario * this.detailCopy.cantidad;
        
        //this.form.valueChanges;
                   
        this.form.controls['cantidad'].updateValueAndValidity();
        this.form.controls['cantidad']
        this.form.updateValueAndValidity();

        this.form.markAsPristine();     
    }

    onInputValidChange(valid: boolean) {
        this.validInput = valid;
    }


}
