﻿import { Component, Input, Output, EventEmitter } from '@angular/core';
import { FormGroup, FormBuilder, AbstractControl, Validators } from '@angular/forms';

//Kernel
import { Context } from 'framework3/core';
import { BasicEditor, ChangeState } from 'framework3/editors';
//Locales
import { RecepcionDetail } from '../../models/recepcion-detail';
//Inventario
import { ArticuloStockInfo, UnidadMedidaInfo, UnidadMedidaItem, StockInfo, LoteInfo, SerieInfo, UnidadMedidaService, AlmacenService, MetodoValuacion } from '../../../inventory';
import { setTimeout } from 'timers';

@Component({
    selector: 'compras-recepcion-detail-editor',
    templateUrl: './recepciones-detail.editor.html'
})
export class RecepcionDetailEditor extends BasicEditor {
    unidadesMedida: UnidadMedidaItem[] = [];
    validInput: boolean = false;
    stockConfig: StockInfo;
    //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
    detailCopy = new RecepcionDetail();
    //Objeto original que se editará
    @Input() detail: RecepcionDetail = new RecepcionDetail();

    @Input() idAlmacen: number;

    //

    constructor(protected context: Context, private builder: FormBuilder, private unidadMedidaService: UnidadMedidaService, private almacenService: AlmacenService) {
        super(context);

        this.form = builder.group({
            'sample': [''],
        });
    }

    //  /////////////////// METODOS ///////////////////////////////

    //  loadUnidadesMedida(idTipoUnidad: number) {
    //      //Si el articulo esta controlado por series, no se puede cambiar la unidad de medida, por lo tanto solo se debe utilizar la unidad de medida el articulo,
    //      //en caso contrario, cargar lista de unidades de medida del mismo tipo
    //      if (this.stockConfig.manejaSeries) {
    //          let unidadArticulo = this.detailCopy.articulo.articuloStock.unidadMedida;
    //          let newUnidad: UnidadMedidaItem = {
    //              id: unidadArticulo.identity, codigo: unidadArticulo.code, idUnidadMedidaTipo: unidadArticulo.idUnidadMedidaTipo, base: unidadArticulo.base,
    //              factor: unidadArticulo.factor, fraccionable: unidadArticulo.fraccionable, paquete: unidadArticulo.paquete, activo: true
    //          };
    //          let newUnidades = [];
    //          newUnidades.push(newUnidad);
    //          this.unidadesMedida = newUnidades;
    //          this.detailCopy.idUnidadMedida = unidadArticulo.identity;
    //      }
    //      else {
    //          this.unidadMedidaService.loadList(idTipoUnidad)
    //              .then(unidadesMedida => {
    //                  this.unidadesMedida = unidadesMedida;
    //                  this.detailCopy.idUnidadMedida = this.detailCopy.articulo.idUnidadMedida;
    //              })
    //              .catch(error => this.handleError(error));
    //      }
    //  }

    //  loadStock(idArticulo: number) {
    //      this.almacenService.loadStock(this.idAlmacen, idArticulo)
    //          .then(stock => {
    //              this.stockConfig = stock;
    //              this.loadUnidadesMedida(this.detailCopy.articulo.articuloStock.unidadMedida.idUnidadMedidaTipo);
    //          })
    //          .catch(error => this.handleError(error));
    //  }
    //  /////////////////// HANDLERS //////////////////////////////

    //  onCreatingItem() {
    //      this.detailCopy = this.detail;
    //this.form.reset({ sample: '' });
    //      this.form.markAsPristine();
    //  }

    //  onLoadingItem(detail: RecepcionDetail ) {
    //      this.detailCopy = <RecepcionDetail>this.copyItem(this.detail);

    //      this.form.updateValueAndValidity();

    //      if (this.detailCopy.idArticulo > 0)
    //          setTimeout (_ => this.loadStock(this.detailCopy.articulo.articuloStock.identity), 3000 );            
    //  }

    //  ngAfterViewInit() {
    //      //setTimeout(_ => this.loadStock(this.detailCopy.articulo.articuloStock.identity));            
    //  }

    //  onUpdatingItem(detail: RecepcionDetail ) {
    //      this.unidadMedidaService.getDetailFromCache(this.detailCopy.idUnidadMedida)
    //          .then(unidad => {
    //              this.detailCopy.unidadMedida = unidad;
    //              if (this.detailCopy._clientID == 0) {
    //                  this.detailCopy._clientID = this.createClientID();
    //              }
    //              else {
    //                  this.detailCopy.state = ChangeState.MODIFIED;
    //              }
    //              this.savingItem.emit(this.detailCopy);
    //              this.detailCopy = new RecepcionDetail();
    //          })
    //          .catch(error => this.handleError(error));
    //  }

    onInputValidChange(valid: boolean) {
        this.validInput = valid;
    }

}
