﻿import { Context, CatalogInfo, CatalogItem } from 'framework3/core';
import { ArticuloStockInfo } from '../../inventory';
import { ImpuestoAsignacionInfo } from '../../accounting/models/impuesto-asignacion';
import { ImpuestoInfo } from '../../accounting/models/impuesto';

export class ArticuloInfo extends CatalogInfo {
	nombre: string;
	idFlujo: number;
	idArticuloStock: number;
	
    idCuenta: number;
    articuloStock: ArticuloStockInfo;
    impuestos: ImpuestoAsignacionInfo[] = [];

    constructor() {
        super();
        this.articuloStock = new ArticuloStockInfo();
    }
}

export class ArticuloItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
	selected?:boolean = false;
}

export class ArticuloImpuesto {

    idArticuloImpuesto: number;
    idArticulo: number;
    idImpuesto: number;
    ordenCalculo: number;
    tipoCalculo: string;
    impuesto: ImpuestoInfo;

    constructor() {
        this.impuesto = new ImpuestoInfo();
    }

}