﻿import { Context, CatalogInfo, CatalogItem, TrackableItem } from 'framework3/core';

export class CategoriasPresupuestalesInfo extends CatalogInfo {
    nombre: string;
    idCuenta: number;
    articulos: Articulo[];
    servicios: Servicio[];

    constructor() {
        super();
        this.articulos = [];
        this.servicios = [];
    }
}

export class CategoriasPresupuestalesItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
    selected?: boolean = false;
}

export class Articulo extends TrackableItem {
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus: string;
    selected: boolean;
}

export class Servicio extends TrackableItem {
    id: number;
    codigo: string;
    nombre: string;
    ultimoCosto: number;
    activo: boolean;
    estatus: string;
    selected: boolean;
}