﻿import { DocumentInfo, DocumentItem } from 'framework3/core';
import { ComprobanteFiscalInfo as ComprobanteBase, ComprobanteFiscalDetail } from '../../accounting';
import { ProveedorInfo, ProveedorItem } from './proveedor';

export class ComprobanteFiscalInfo extends DocumentInfo<ComprobanteFiscalDetail> {
    comprobanteBase: ComprobanteBase;
	idComprobanteFiscal: string;
	fechaComprobanteFiscal: Date;
	idProveedor: number;
	idRecepcionTit: string;
    fechaRecepcion: Date;

    subTotal: number;
    descuentos: number;
    impuestosTrasladados: number;
    impuestosRetenidos: number;
    total: number;

    proveedor: ProveedorInfo;

    constructor() {
        super();
        this.comprobanteBase = new ComprobanteBase();
        this.proveedor = new ProveedorInfo();
    }
}

export class ComprobanteFiscalItem extends DocumentItem {
    proveedor: string;
    rfcEmisor: string;
    nombreEmisor: string;
    uuid: string;
    serie: string;
    folio: string;
    fechaComprobante: Date;    
    subtotal: number;
    descuentos: number;
    impuestosTrasladados: number;
    impuestosRetenidos: number;
    total: number;
    idProveedor: number;
}