﻿import { DocumentInfo, DocumentItem } from 'framework3/core';
import { NotaDetail } from './nota-detail';
//import { ComprobanteFiscalInfo } from '../../accounting/models/comprobante-fiscal';
import { ComprobanteFiscalInfo } from '../models/comprobante-fiscal'
import { ProveedorInfo } from '../models/proveedor';

export class NotaInfo extends DocumentInfo<NotaDetail> {
	fechaAfectacion: Date;
    idProveedor: number;
    idComprobante: string;
    fechaComprobante: Date;
	subTotal: number;
	impuestosTrasladados: number;
	impuestosRetenidos: number;
	total: number;
	idDivisa: number;
	tipoCambio: number;

    proveedor: ProveedorInfo;

    comprobante: ComprobanteFiscalInfo;

    constructor() {
        super();
        this.comprobante = new ComprobanteFiscalInfo();
        this.proveedor = new ProveedorInfo();
        this.subTotal = 0;
        this.total = 0;
        this.idDivisa = 0;
    }
}

export class NotaItem extends DocumentItem {

}