﻿import { DocumentDetail } from 'framework3/core';
import { ImpuestoDetailInfo } from '../../accounting';
import { DescuentosInfo } from './descuentos';
import { ArticuloInfo } from '../models/articulo';
import { ServicioInfo } from '../models/servicio';
import { UnidadMedidaInfo } from '../../inventory/models/unidad-medida';

export class OrdenDetail extends DocumentDetail {
	idArticulo: number;
	idServicio: number;
	idRequisicion: string;
	fechaRequisicion: Date;
	saldo: number;
    cantidad: number;    
	idUnidadMedida: number;
    costoUnitario: number;
    costoNeto: number;
    importe: number;
    idDepartamento: number;
    departamento: string;
	idCentroCosto: number;
	idPresupuesto: string;
    idCategoriaPresupuestal: number;
        
    descuentos: DescuentosInfo;
    impuestos: ImpuestoDetailInfo[];
    unidadMedida: UnidadMedidaInfo;

    constructor() {
        super();
        this.idPresupuesto = "";
        this.idDepartamento = 0;
        this.departamento = "";
        this.cantidad = 0;
        this.costoUnitario = 0;
        this.descuentos = new DescuentosInfo();
        this.impuestos = [];
        this.unidadMedida = new UnidadMedidaInfo();
    }
}


export class OrdenRequisicionDetail extends OrdenDetail {
    selected: boolean = false;    
    key: string;
    group: boolean;

    codigo: string;
    articuloServicio: string;
    idProveedor: number;
    proveedor: string;
    presupuesto: string;
    idCentroRecepcion: number;
    centroRecepcion: string;
    categoriaPresupuestal: string;
    idDivisa: number;
    unidadMedida: UnidadMedidaInfo;
}

