﻿import { DocumentInfo, DocumentItem } from 'framework3/core';
import { OrdenDetail } from './orden-detail';
import { ImpuestoResumenInfo, DivisaInfo } from '../../accounting';
import { ProveedorInfo } from './proveedor';
import { UnidadMedidaInfo } from '../../inventory';

export class OrdenInfo extends DocumentInfo<OrdenDetail> {
	fecha: Date;
	fechaAfectacion: Date;
	idDepartamento: number;
	idProveedor: number;
	idCentroRecepcion: number;
	idCentralCompras: number;
	fechaEntrega: Date;
	idDocumentoRef: string;
	fechaDocumentoRef: Date;
	idAnticipo: string;
	fechaAnticipo: Date;
	idRecepcionSinOC: string;
	fechaRecepcionSinOC: Date;
	idDivisa: number;
	tipoCambio: number;
	subtotal: number=0;
	impuestosTrasladados: number=0;
	impuestosRetenidos: number=0;
	descuentos: number=0;
	flete: number=0;
	total: number=0;
	observaciones: string;

    articulos: OrdenDetail[] = [];
    servicios: OrdenDetail[] = [];   
    impuestos: ImpuestoResumenInfo[];
    divisa: DivisaInfo;
    proveedor: ProveedorInfo;
    
    constructor() {
        super();
        this.articulos = [];
        this.servicios = [];
        this.impuestos = [];
        this.divisa = new DivisaInfo();
        this.proveedor = new ProveedorInfo();
        
    }
}

export class OrdenItem extends DocumentItem {
    idAnticipo: string = "";
}