﻿import { NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
//Modulos Azteca
import { CoreModule } from 'framework3/core';
import { EditorsModule } from 'framework3/editors';
import { SearchModule } from 'framework3/search';
import { GeneralModule } from 'framework3/general';
import { ControlsModule } from 'framework3/controls';
import { SecurityModule } from 'framework3/security';
import { NotificationModule } from 'framework3/notification';
import { PurchasingRoutingModule } from './purchasing.routing.module';
//
import { InventoryModule } from '../inventory/inventory.module';
import { AccountingModule } from '../accounting/accounting.module';
import { TreasuryModule } from '../treasury/treasury.module'
//Bootstrap
import { TabsModule, ModalModule } from 'ngx-bootstrap';
//Wijmo
import { WjCoreModule } from 'wijmo/wijmo.angular2.core';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridDetailModule } from 'wijmo/wijmo.angular2.grid.detail';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';


///////////////////////////// Servicios //////////////////////////////
import * as fromServices from './services';
const SERVICIOS = Object.keys(fromServices).map(key => fromServices[key]);

///////////////////////////// Catalogos //////////////////////////////
import * as fromCatalogs from './catalogs';
const CATALOGOS = Object.keys(fromCatalogs).map(key => fromCatalogs[key]);

///////////////////////////// Components //////////////////////////////
import * as fromComponents from './components';
const COMPONENTS = Object.keys(fromComponents).map(key => fromComponents[key]);

///////////////////////////// Controls //////////////////////////////
import * as fromControls from './controls';
const CONTROLS = Object.keys(fromControls).map(key => fromControls[key]);

///////////////////////////// Dialogs //////////////////////////////
import * as fromDialogs from './dialogs';
const DIALOGS = Object.keys(fromDialogs).map(key => fromDialogs[key]);

///////////////////////////// Maintenances //////////////////////////////
import { ProveedoresRegistrar } from './maintenances/proveedores-registrar.maintenance';
import { ProveedoresRegistrarEditor } from './maintenances/proveedores-registrar-editor.maintenance';
import { Confirmacion } from './maintenances/parts/confirmacion.component';

/*
import * as fromMaintenances from './maintenances';
const MAINTENANCES = Object.keys(fromMaintenances).map(key => fromMaintenances[key]);
*/


///////////////////////////// Documents //////////////////////////////
import * as fromDocumentsParts from './documents/parts';
const DOCUMENTS_PARTS = Object.keys(fromDocumentsParts).map(key => fromDocumentsParts[key]);
//
import * as fromDocuments from './documents';
import { DOCUMENT } from '@angular/platform-browser';
const DOCUMENTS = Object.keys(fromDocuments).map(key => fromDocuments[key]);


///////////////////////////// Parts //////////////////////////////
import * as fromParts from './parts';

const PARTS = Object.keys(fromParts).map(key => fromParts[key]);

/////////////////////////////////////////////////////////////////////////////////
const COMPONENTES = [...CATALOGOS, ...COMPONENTS, ...CONTROLS, ...DIALOGS, ...DOCUMENTS_PARTS, ...DOCUMENTS, ...PARTS, ProveedoresRegistrar, ProveedoresRegistrarEditor, Confirmacion]

@NgModule({
    imports: [
        CommonModule, FormsModule, ReactiveFormsModule,
        TabsModule.forRoot(), ModalModule.forRoot(),
        CoreModule, EditorsModule, SearchModule, GeneralModule, ControlsModule, SecurityModule, NotificationModule, PurchasingRoutingModule,
        AccountingModule, TreasuryModule, InventoryModule,
        WjCoreModule, WjInputModule, WjGridModule, WjGridFilterModule, WjGridDetailModule
    ],
    declarations: COMPONENTES,
    providers: SERVICIOS,
    exports: COMPONENTES
})
export class PurchasingModule {

}
