﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { CategoriasPresupuestalesInfo } from '../models/categorias-presupuestales'
import { SearchRequest, SearchResult } from 'framework3/search';

@Injectable()
export class CategoriasPresupuestalesService extends CatalogService<CategoriasPresupuestalesInfo>{


    constructor(protected http: HttpClient, protected context: Context) {
        super(http, context, 'api/compras/categorias-presupuestales');
    }

    create(): Promise<CategoriasPresupuestalesInfo> {
        return Promise.resolve(new CategoriasPresupuestalesInfo());
    }

    searchArticuloCategoriaPresupuestal(IdCategoriaPresupuestal: number, idBranch: number, request: SearchRequest): Promise<SearchResult> {
        let params: HttpParams = new HttpParams()
            .set('idCategoriaPresupuestal', IdCategoriaPresupuestal.toString())
            .set('idBranch', idBranch.toString());
        return this.apiService.post<any>('search-articulo-categoria-presupuestal', params, request)
            .toPromise();
    }

    deleteCategoriaPresupuestalArticulo(IdArticulo: number, IdCategoriaPresupuestal: number): Promise<boolean> {
        let params: HttpParams = new HttpParams()
            .set('idCategoriaPresupuestal', IdCategoriaPresupuestal.toString())
            .set('idArticulo', IdArticulo.toString());
        return this.apiService.post<any>('delete-articulo-categoria-presupuestal', params)
            .toPromise();
    }


    searchServicioCategoriaPresupuestal(IdCategoriaPresupuestal: number, idBranch: number, request: SearchRequest): Promise<SearchResult> {
        let params: HttpParams = new HttpParams()
            .set('idCategoriaPresupuestal', IdCategoriaPresupuestal.toString())
            .set('idBranch', idBranch.toString());
        return this.apiService.post<any>('search-servicio-categoria-presupuestal', params, request)
            .toPromise();
    }

    deleteCategoriaPresupuestalServicio(IdServicio: number, IdCategoriaPresupuestal: number): Promise<boolean> {
        let params: HttpParams = new HttpParams()
            .set('idCategoriaPresupuestal', IdCategoriaPresupuestal.toString())
            .set('idServicio', IdServicio.toString());
        return this.apiService.post<any>('delete-servicio-categoria-presupuestal', params)
            .toPromise();
    }

    
    //updateCategoria(): Promise<CategoriasPresupuestalesInfo> {

    //}
	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<CategoriasPresupuestalesInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<CategoriasPresupuestalesInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

