﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Framework
import { Context, DocumentInfo, DocumentItem, DocumentService } from 'framework3/core';
//Locales
import { CostoPresupuestoInfo, CostoPresupuestoItem } from '../models/costo-presupuesto';
import { CostoPresupuestoDetail } from '../models/costo-presupuesto-detail';

@Injectable()
export class CostoPresupuestoService extends DocumentService<CostoPresupuestoDetail, CostoPresupuestoInfo> {

    constructor(protected http: HttpClient, protected context: Context ) {
        super(http, context, 'api/compras/costos-presupuestos');
    }

    create(): Promise<CostoPresupuestoInfo> {
        let newDoc = new CostoPresupuestoInfo();
        return Promise.resolve(newDoc);
    }

    loadDetalleNew(idPresupuesto: string): Promise<CostoPresupuestoDetail[]> {
        let params = new HttpParams()
            .set("idPresupuesto", idPresupuesto);
        return this.apiService.get<CostoPresupuestoDetail[]>("detalle-new", params).toPromise();

    }


	/*
    sampleMethod(param1: number, param2: string): Promise<CostoPresupuestoInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<CostoPresupuestoInfo>('sample-method', params)
            .toPromise();
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) en los resultados de búsquedas. Eliminar si no es necesario
	protected mapSearchResult(row: any) {
        
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) al cargar un documento. Eliminar si no es necesario
    protected mapDocument(document: CostoPresupuestoInfo) {

    }
	*/



}