﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { GastoTipoInfo, GastoTipoItem } from '../models/gasto-tipo'


@Injectable()
export class GastoTipoService extends CatalogService<GastoTipoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/compras/gastos-tipos');
    }

    create(): Promise<GastoTipoInfo> {
        return Promise.resolve(new GastoTipoInfo());
    }

    loadListByUser(idSucursal: number): Promise<GastoTipoItem[]> {
        let params: HttpParams = new HttpParams()
            .set('idSucursal', idSucursal.toString());
        return this.apiService.get<GastoTipoItem[]>('load-list', params)
            .toPromise();
    }


	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<GastoTipoInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<GastoTipoInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

