﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Framework
import { Context, DocumentInfo, DocumentItem, DocumentService } from 'framework3/core';
//Locales
import { GastoInfo, GastoItem } from '../models/gasto';
import { GastoDetail } from '../models/gasto-detail';
import { GastoComprobarItem } from '../models/gasto-comprobar-item';
import { GastoComprobanteItem } from '../models/gasto-comprobante-item';

@Injectable()
export class GastoService extends DocumentService<GastoDetail, GastoInfo> {

    constructor(protected http: HttpClient, protected context: Context ) {
        super(http, context, 'api/compras/gastos');
    }

    create(): Promise<GastoInfo> {
        let newDoc = new GastoInfo();
        return Promise.resolve(newDoc);
    }

    loadDetalleNew(idPresupuesto: string): Promise<GastoDetail[]> {
        let params = new HttpParams()
            .set("idPresupuesto", idPresupuesto);
        return this.apiService.get<GastoDetail[]>("detalle-new", params).toPromise();

    }

    updateComprobantes(gasto: GastoInfo): Promise<boolean> {
        let params = new HttpParams();
        return this.apiService.post<boolean>("comprobantes-update", params, gasto)
            .toPromise();
    }


	/*
    sampleMethod(param1: number, param2: string): Promise<GastoInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<GastoInfo>('sample-method', params)
            .toPromise();
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) en los resultados de búsquedas. Eliminar si no es necesario
	protected mapSearchResult(row: any) {
        
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) al cargar un documento. Eliminar si no es necesario
    protected mapDocument(document: GastoInfo) {

    }
	*/



}