﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Framework
import { Context, DocumentInfo, DocumentItem, DocumentService } from 'framework3/core';
//Locales
import { NotaInfo, NotaItem } from '../models/nota';
import { NotaDetail } from '../models/nota-detail';
import { NotaDetailCategoriaPresupuestal } from '../models/nota-detail-categoria-presupuestal';

@Injectable()
export class NotaService extends DocumentService<NotaDetail, NotaInfo> {

    constructor(protected http: HttpClient, protected context: Context ) {
        super(http, context, 'api/compras/notas');
    }

    create(): Promise<NotaInfo> {
        let newDoc = new NotaInfo();
        return Promise.resolve(newDoc);
    }

    loadDetalleNew(idProveedor: number): Promise<NotaDetail[]> {
        let params = new HttpParams()
            .set("idProveedor", idProveedor.toString());
        return this.apiService.get<NotaDetail[]>("detalle-new", params).toPromise();
    }



	/*
    sampleMethod(param1: number, param2: string): Promise<NotaInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<NotaInfo>('sample-method', params)
            .toPromise();
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) en los resultados de búsquedas. Eliminar si no es necesario
	protected mapSearchResult(row: any) {
        
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) al cargar un documento. Eliminar si no es necesario
    protected mapDocument(document: NotaInfo) {

    }
	*/



}