﻿import { Injectable } from "@angular/core";
import { ProveedorTipoInfo } from "../models/proveedor-tipo";
import { CatalogService, Context } from "framework3/core";
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';

@Injectable()
export class ProveedorTipoService extends CatalogService<ProveedorTipoInfo>{

    create(): Promise<ProveedorTipoInfo> {
        return Promise.resolve(new ProveedorTipoInfo());
    }

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/compras/proveedores-tipos');
    }

   
    loadList(idSucursal:number) {
        let params = new HttpParams()
            .append("idSucursal", idSucursal.toString());
        return this.apiService.get<ProveedorTipoInfo[]>("load-list", params)
            .toPromise();
    }

    

}
