﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs';
import 'rxjs/add/operator/toPromise';
//Azteca Framework
import { Context, DocumentInfo, DocumentItem, DocumentService } from 'framework3/core';
//Locales
import { RecepcionSinOCInfo, RecepcionSinOCItem } from '../models/recepcion-sin-oc';
import { RecepcionSinOCDetail } from '../models/recepcion-sin-oc-detail';

@Injectable()
export class RecepcionSinOCService extends DocumentService<RecepcionSinOCDetail, RecepcionSinOCInfo> {

    constructor(protected http: HttpClient, protected context: Context ) {
        super(http, context, 'api/compras/recepciones-sin-o-c');
    }

    create(): Promise<RecepcionSinOCInfo> {
        let newDoc = new RecepcionSinOCInfo();
        return Promise.resolve(newDoc);
    }

    save(info: RecepcionSinOCInfo): Promise<RecepcionSinOCInfo> {
        //Si no tiene asignado la empresa y sucursal, asignar la actual
        if (info.idSucursal == 0) info.idSucursal = this.context.app.defaultSite.identity;
        //Actualizar campo de cantidad basado en las propiedades auxiliares (solo para articulos)
        //info.details.filter(detail => detail.idArticulo > 0).map(detail => <RecepcionArticuloDetail>detail).forEach(detail => {
        //    if (detail.unidadMedida.paquete && detail.unidadMedida.factor > 1) {
        //        let cantidad = new Empaquetado(detail.cantidad, detail.unidadMedida.factor, detail.unidades);
        //        detail.cantidad = cantidad.toDecimal();
        //    }
        //});
        //
        let params = new HttpParams();
        return this.apiService.post<RecepcionSinOCInfo>('save', params, info)
            .toPromise();
    }

	/*
    sampleMethod(param1: number, param2: string): Promise<RecepcionSinOCInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<RecepcionSinOCInfo>('sample-method', params)
            .toPromise();
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) en los resultados de búsquedas. Eliminar si no es necesario
	protected mapSearchResult(row: any) {
        
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) al cargar un documento. Eliminar si no es necesario
    protected mapDocument(document: RecepcionSinOCInfo) {

    }
	*/



}