﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
import { SearchResult, SearchRequest } from 'framework3/search';

//Locales
import { ServicioInfo } from '../models/servicio'
import { CostoInfo } from '../models/costo'


@Injectable()
export class ServicioService extends CatalogService<ServicioInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/compras/servicios');
    }

    create(): Promise<ServicioInfo> {
        return Promise.resolve(new ServicioInfo());
    }

    searchServicioProveedor(idProveedor: number, idBranch: number, request: SearchRequest): Promise<SearchResult> {
        let params: HttpParams = new HttpParams()
            .set('idProveedor', idProveedor.toString())
            .set('idBranch', idBranch.toString());
        return this.apiService.post<any>('search-servicio-proveedor', params, request)
            .toPromise();
    }


    calcularCostoProveedor(idServicio: number, idProveedor: number, idEmpresa: number, costoBruto: number): Promise<CostoInfo> {
        let params = new HttpParams()
            .set("idServicio", idServicio.toString())
            .set("idProveedor", idProveedor.toString())
            .set("idEmpresa", idEmpresa.toString())
            .set("costoBruto", costoBruto.toString());
        return this.apiService.get<CostoInfo>('costo-proveedor', params)
            .toPromise();
    }

}

