﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { TipoRequisicionInfo,TipoRequisicionItem } from '../models/tipo-requisicion'

@Injectable()
export class TipoRequisicionService extends CatalogService<TipoRequisicionInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/compras/tipos-requisicion');
    }

    create(): Promise<TipoRequisicionInfo> {
        return Promise.resolve(new TipoRequisicionInfo());
    }

    loadListByUser(idSucursal: number): Promise<TipoRequisicionItem[]> {
        let params: HttpParams = new HttpParams()
            .set('idSucursal', idSucursal.toString());
        return this.apiService.get<TipoRequisicionItem[]>('load-list', params)
            .toPromise();
    }
	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<TipoRequisicionInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<TipoRequisicionInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

