﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

import { ConceptoAdamService } from '../services/concepto-adam.service';
import { ConceptoAdamItem } from '../models/concepto-adam';

//

@Component({
    selector: 'rh-conceptos-list',
    templateUrl: './conceptos-list.component.html'
})
export class ConceptosListComponent extends CatalogListDialog {
    items: ConceptoAdamItem[];

    @Input() titleDialog: string = 'RH - Conceptos';

    constructor(protected context: Context, private service: ConceptoAdamService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.service.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.items = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedItem: ConceptoAdamItem[]) {
        this.selectedItemsChanged.emit(selectedItem);
    }

    onSelectedItemChanged(item: ConceptoAdamItem) {
        this.selectedItemChanged.emit(item);
    }

}