﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

import { EmpleadoService } from '../services/empleado.service';
import { EmpleadoItem } from '../models/empleado';

//

@Component({
    selector: 'rh-empleado-list',
    templateUrl: './empleado-list.component.html'
})
export class EmpleadoListComponent extends CatalogListDialog {
    items: EmpleadoItem[];

    @Input() titleDialog: string = 'RH - Empleados';

    constructor(protected context: Context, private service: EmpleadoService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.service.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.items = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedItem: EmpleadoItem[]) {
        this.selectedItemsChanged.emit(selectedItem);
    }

    onSelectedItemChanged(item: EmpleadoItem) {
        this.selectedItemChanged.emit(item);
    }

}