﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

import { HorarioService } from '../services/horario.service';
import { HorarioItem } from '../models/horario';

//

@Component({
    selector: 'rh-horario-list',
    templateUrl: './horario-list.component.html'
})
export class HorarioListComponent extends CatalogListDialog {
    items: HorarioItem[];

    @Input() titleDialog: string = 'Horarios';

    constructor(protected context: Context, private service: HorarioService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.service.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.items = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedItem: HorarioItem[]) {
        this.selectedItemsChanged.emit(selectedItem);
    }

    onSelectedItemChanged(item: HorarioItem) {
        this.selectedItemChanged.emit(item);
    }

}