﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

import { IncidenciaService } from '../services/incidencia.service';
import { IncidenciaItem } from '../models/incidencia';

//

@Component({
    selector: 'rh-incidencia-list',
    templateUrl: './incidencia-list.component.html'
})
export class IncidenciaListComponent extends CatalogListDialog {
    items: IncidenciaItem[];

    @Input() titleDialog: string = 'Incidencias';

    constructor(protected context: Context, private service: IncidenciaService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.service.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.items = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedItem: IncidenciaItem[]) {
        this.selectedItemsChanged.emit(selectedItem);
    }

    onSelectedItemChanged(item: IncidenciaItem) {
        this.selectedItemChanged.emit(item);
    }

}