﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

import { TipoPerDedService } from '../services/tipo-per-ded.service';
import { TipoPerDedItem } from '../models/tipo-per-ded';

//

@Component({
    selector: 'rh-tipos-per-ded-list',
    templateUrl: './tipos-per-ded-list.component.html'
})
export class TiposPerDedListComponent extends CatalogListDialog {
    items: TipoPerDedItem[];

    @Input() tipoPerDedSelector: string = '';
    @Input() titleDialog: string = '';

    constructor(protected context: Context, private clienteService: TipoPerDedService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        if (this.tipoPerDedSelector != '') {
            var exist = false;
            request.conditions.forEach(r => {
                if (!exist && r.field == "tipoTransaccion") {
                    exist = true;
                    r.value = this.tipoPerDedSelector;
                }
            });

            if (!exist) {
                let condition = { field: "tipoTransaccion", operator: "=", valueType: "string", value: this.tipoPerDedSelector };
                request.conditions.push(condition);
            }
        }
        this.clienteService.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.items = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedItem: TipoPerDedItem[]) {
        this.selectedItemsChanged.emit(selectedItem);
    }

    onSelectedItemChanged(item: TipoPerDedItem) {
        this.selectedItemChanged.emit(item);
    }

}