﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context } from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

import { TurnoService } from '../services/turno.service';
import { TurnoItem } from '../models/turno';

//

@Component({
    selector: 'rh-turno-list',
    templateUrl: './turno-list.component.html'
})
export class TurnoListComponent extends CatalogListDialog {
    items: TurnoItem[];

    @Input() titleDialog: string = 'Turnos';

    constructor(protected context: Context, private service: TurnoService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.service.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.items = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedItem: TurnoItem[]) {
        this.selectedItemsChanged.emit(selectedItem);
    }

    onSelectedItemChanged(item: TurnoItem) {
        this.selectedItemChanged.emit(item);
    }

}