﻿import { Context, CatalogInfo, CatalogItem } from 'framework3/core';
import { EmpleadoInfo } from './empleado'
import { CLASS_NAME } from 'ngx-bootstrap/modal/modal-options.class';

export class CedulaFiniquitoInfo extends CatalogInfo {
    idEmpleado: number = 0;
	departamento: string;
	bodega: string;
	puesto: string;
	sindicalizado: boolean;
    idRescicionLaboral: number = 0;
	fechaAntiguedad: Date;
	ultimoDiaLaborado: Date;
	fechaBaja: Date;
	fechaUltimoAguinaldo: Date;
	diasAguinaldoContrato: number = 0;
	disfrutePrevioAguinaldo: boolean;
	primaVacacionalPendiente: boolean;
	pirmaVacExentaPagada: number = 0;
	porcentajePrimaVacacional: number = 0;
	diasVacacionesPendiente: number = 0;
	diasVacacionesGeneradas: number = 0;
    totalDiasVacaciones: number = 0;
	porcentajePrimaAntiguedad: number= 0;
    porcentajeVeinteDiasAnio: number = 0;
    sueldoDiario: number = 0;
    sueldoPromedio: number = 0;
    sueldoDiarioIntegrado: number = 0;
    ausentismo: number = 0;
    sueldoDias: number = 0;
    sueldoImporte: number = 0;
    comisiones: number = 0;
    incentivos: number = 0;
    horasExtraImporte: number = 0;
    primaVacacionalPendienteEntrega: number = 0;
    primaDominicalNumDomingos: number = 0;
    primaDominicalImporte: number = 0;
    repartoUtilidades: number = 0;
    diasNegociadoIndemnizacion: number = 0;
    indemnnizacionAdicional: number = 0;
    otros: number = 0;
    salarioMinimoZona: number = 0;
    uma: number = 0;
    aguinaldoSindicato: number = 0;
    idTaskComision: number = 0;
    infonavit: number = 0;
    fonacot: number = 0;
    autoriza: string;
    periodoPago: number = 0;
    adeudo: number = 0;
    importeNetoFiniquito: number = 0;
    infonavitOrFonacot: boolean;
    primaVacacionalExento: number = 0;
    empleado: EmpleadoInfo;
    clase: ClaseNomina;
    conceptosNegociacion: Array<CedulaConcepto>;
    conceptosApoyo: Array<CedulaConcepto>;
    conceptosIsr: Array<CedulaConcepto>;
    seguros: Array<SeguroIMSS>;
    conceptosPrevio: Array<CedulaConcepto>;
    tarifasPagosProvicionales: Array<TarifaPagoProvicional>;
    subsidiosEmpleo: Array<SubsidioEmpleo>;
    comisionPeriodos: Array<ComisionPeriodo>;
    variables: Array<Variable>;
    eliminar: Array<CedulaConcepto>;
    acumuladosBajas: Array<AcumuladoBajaTit>;

    
    constructor() {
        super();
        this.empleado = new EmpleadoInfo();
        this.clase = new ClaseNomina();
        this.fechaAntiguedad = new Date();
        this.ultimoDiaLaborado = new Date();
        this.fechaBaja = new Date();
        this.fechaUltimoAguinaldo = new Date();

        this.conceptosNegociacion = new Array<CedulaConcepto>();
        this.conceptosApoyo = new Array<CedulaConcepto>();
        this.conceptosIsr = new Array<CedulaConcepto>();
        this.seguros = new Array<SeguroIMSS>();
        this.conceptosPrevio = new Array<CedulaConcepto>();
        this.tarifasPagosProvicionales = new Array<TarifaPagoProvicional>();
        this.subsidiosEmpleo = new Array<SubsidioEmpleo>();
        this.comisionPeriodos = new Array<ComisionPeriodo>();
        this.variables = new Array<Variable>();
        this.eliminar = new Array<CedulaConcepto>();
        this.acumuladosBajas = new Array<AcumuladoBajaTit>();
    }
}

export class CedulaFiniquitoItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
	selected?:boolean = false;
}

export class CedulaConcepto {

    idCedulaConcepto: number = 0;
    idCedulaFiniquito: number = 0;
    idConcepto: number = 0;
    concepto: string = "";
    idClasificacionConcepto: number = 0;
    cantidad: number = 0;
    importeGravado: number = 0;
    importeExento: number = 0;
    importeTotal: number = 0;
    idParent: number = 0;
    acumula: string;
    conceptoFiniquito: ConceptoFiniquito;

    clasificacionConcepto: ClasificacionConcepto;

    constructor() {
        this.clasificacionConcepto = new ClasificacionConcepto();
        this.conceptoFiniquito = new ConceptoFiniquito();
    }
}

export class ConceptoFiniquito {

    idConceptoFiniquito: number;
    concepto: string;
    idClasificacionConcepto: number;
    cantidadManual: boolean;
    totalManual: boolean;
    gravadoManual: boolean;
    exentoManual: boolean;
    orden: number;
    observable: string;
    procesos: Array<FiniquitoProceso>;

    constructor() {
        this.procesos = new Array<FiniquitoProceso>();
    }

}

export class FiniquitoProceso {

    idProceso: number;
    nombre: string;
    descripcion: string;
    proceso: string;

    constructor() {
    }
}

export class ClasificacionConcepto {
    idClasificacionConcepto: number;
    descripcion: string;
    tipo: string;

    constructor() {
    }
}

export class RescisionLaboral {
    idRescisionLaboral: number;
    descripcion: string;

    constructor() {
    }
}

export class TarifaPagoProvicional {

    idTarifaPAgoProvicional: number;
    idCompania: number;
    limiteInferior: number = 0;
    limiteSuperior: number = 0;
    cuotaFija: number = 0;
    porcentaje: number = 0;

    constructor() {
    }
}

export class SubsidioEmpleo {

    idSubsidioEmpleo: number;
    idCompania: number;
    limiteInferior: number = 0;
    limiteSuperior: number = 0;
    subsidio: number = 0;
    subsidioDiario: SubsidioEmpleo;

    constructor() {
    }
}

export class SeguroIMSS {

    idSeguro: number;
    seguro: string;
    dias: number;
    porcentaje: number;
    calculo: number;

    constructor() {
    }

}

export class ComisionPeriodo {

    idCedulaFiniquito: number;
    anio: number;
    periodo: number;
    fechaInicio: Date;
    fechaTermino: Date;
    fechaPago: Date;
    importe: number;
    pagado: boolean;
    
    constructor() {
    }

}

export class ClaseNomina {

    idClaseNomina: number;
    clase: string;
    descripcion: string;
    idCompania: number;
    porcPrimaVacacional: number;
    porcPrimaAntiguedad: number;
    porcVeinteDiasAnio: number;
    aguinaldo: number;
    aguinaldoSindicato: number;

    constructor() {
    }

}

export class AsyncTaskInfo {

    idTask: number;
    fecha: Date;
    horaInicio: Date;
    horaFin: Date;
    referencia: string;
    completo: boolean;
    ejecutando: boolean;
    error: boolean;
    errorEjecucion: string;
    result: string;

    constructor() {
    }

}

export class Variable {

    compania: string;
    trabajador: string;
    secuencia: number;
    variableTrabajador: number;

    constructor() {
    }
}


export class AcumuladoBajaTit {
    idAcumulado: number;
    claseNomina: number;
    tipoNomina: string;
    periodo: number;
    percepciones: number;
    deducciones: number;
    neto: number;
    acumuladoDet: Array<AcumuladoDet>;

    constructor() {
        this.acumuladoDet = new Array<AcumuladoDet>();
    }
}

export class AcumuladoDet {
    clave: string;
    concepto: string;
    percepciones: number;
    deducciones: number;
    tiempo: number;
}