﻿import { Context, CatalogInfo, CatalogItem, TrackableItem } from 'framework3/core';

export class CompaniaInfo extends CatalogInfo {

	nombre: string;
	idEmpresaAdam: number;
    registroPatronal: string;
    rfcEmisor?: string;
    regimenFiscal?: string;
    razonSocial?: string;

    parametros: CompaniaParametroItem[];

    constructor() {
        super();
        this.parametros = [];
    }
}

export class CompaniaItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
	selected?:boolean = false;
}

export class CompaniaParametroItem extends TrackableItem {

    path: string;
    key: string;
    value: string;

    constructor() {
        super();
    }
}