﻿import { Context, CatalogInfo, CatalogItem, TrackableItem } from 'framework3/core';

export class ConceptoAdamInfo extends CatalogInfo {
	concepto: number;
	descripcion: string;
	abreviatura: string;
	tipoTransaccion: number;
	idTipoPerDed: number;
    idCompania: number;
    indemnizacion: boolean;
    deudorInterno: boolean;
    acumulable: boolean = true;
    expresiones: ConceptoExpresionItem[];

    constructor() {
        super();
        this.expresiones = [];
    }
}

export class ConceptoAdamItem implements CatalogItem {    
    id: number;
    codigo: string;
    descripcion: string;
    activo: boolean;
    estatus?: string;
	selected?:boolean = false;
}


export class ConceptoExpresionItem extends TrackableItem {

    codigo: string;
    nombre: string;
    tipoExpresion: string;
    expresion: string;
    orden: number;
    grupo: string;

    constructor() {
        super();
        this.tipoExpresion = "C";
        this.orden = 1;
        this.grupo = "G";
    }

}