﻿import { Context, CatalogInfo, CatalogItem, TrackableItem } from 'framework3/core';

export class PeriodicidadPagoInfo extends CatalogInfo {
	nombre: string;
	descripcion: string;
	dias: number;
    periodos: PeriodoItem[];

    constructor() {
        super();
        this.periodos = [];
    }
}

export class PeriodicidadPagoItem implements CatalogItem {    
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
	selected?:boolean = false;
}

export class PeriodoItem extends TrackableItem {

    codigo: string;
    nombre: string;
    fechaIniPago: Date;
    fechaFinPago: Date;
    fechaIniIncidencia: Date;
    fechaFinIncidencia: Date;
    periodoDias: PeriodoDiaItem[];

    constructor() {
        super();
        this.periodoDias = [];
        this.fechaIniPago = new Date();
        this.fechaFinPago = new Date();
        this.fechaIniIncidencia = new Date();
        this.fechaFinIncidencia = new Date();
    }

}

export class PeriodoDiaItem extends TrackableItem {

    fechaIncidencia: Date;
    feriado: boolean;
    formaPago: number;

    constructor() {
        super();
    }

}