﻿import { Context, CatalogInfo, CatalogItem, TrackableItem } from 'framework3/core';
import { HorarioInfo } from './horario';

export class TurnoInfo extends CatalogInfo {

    nombre: string;
    tipo: string;
    tipoPeriodo: string;
    ciclo: number;
    retardos: number;
    periodoDias: number;
    accion: string;
    diasAccion: number;
    nocturno: boolean;
    idJornada: number;
    idCuenta: number;
    dom: boolean;
    lun: boolean;
    mar: boolean;
    mie: boolean;
    jue: boolean;
    vie: boolean;
    sab: boolean;
    horarios: TurnoHorarioInfo[] = [];

    constructor() {
        super();
    }

}

export class TurnoItem implements CatalogItem {

    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
    selected?: boolean = false;

}

export class TurnoHorarioInfo extends TrackableItem {

    dia: number;
    ciclo: number;
    idHorario: number;
    horario?: HorarioInfo;

    constructor() {
        super();
    }

}