﻿import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
//Modulos Azteca
import { CoreModule } from 'framework3/core';
import { EditorsModule } from 'framework3/editors';
import { SearchModule } from 'framework3/search';
import { GeneralModule } from 'framework3/general';
import { ControlsModule } from 'framework3/controls';
import { SecurityModule } from 'framework3/security';
import { RhRoutingModule } from './rh.routing.module';

import { AccountingModule } from '../accounting/accounting.module';
import { TreasuryModule } from '../treasury/treasury.module';
import { PurchasingModule } from '../purchasing/purchasing.module';

//Bootstrap
import { TabsModule, ModalModule } from 'ngx-bootstrap';
//Wijmo
import { WjCoreModule } from 'wijmo/wijmo.angular2.core';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjGridDetailModule } from 'wijmo/wijmo.angular2.grid.detail';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';

/////////////////////////////// Servicios ////////////////////////////
import { EmpresaAdamService } from './services/empresaadam.service';
import { EmpleadoService } from './services/empleado.service';
import { SucursalService } from './services/sucursal.service';
import { CedulaFiniquitoService } from './services/cedulafiniquito.service';
import { AdamService } from './services/adam.service';
import { PolizasNominaService } from './services/polizas-nomina.service';
import { ReciboAdamService } from './services/recibo-adam.service';
import { PuestoService } from './services/puesto.service';
import { TurnoService } from './services/turno.service';
import { DepartamentoService } from './services/departamento.service';
import { CompaniaService } from './services/compania.service';
import { TipoPerDedService } from './services/tipo-per-ded.service';
import { ConceptoAdamService } from './services/concepto-adam.service';
import { DispositivoNixtlaService } from './services/dispositivo-nixtla.service';
import { ProgramacionReciboAdamService } from './services/programacion-recibo-adam.service';
import { PlazaService } from './services/plaza.service';
import { FiniquitoAutorizacionService } from './services/finiquito-autorizacion.service';
import { HorarioService } from './services/horario.service';
import { ChecadorService } from './services/checador.service';
import { ReciboNominaService } from './services/recibo-nomina.service';
import { ClaseNominaService } from './services/clase-nomina.service';
import { NominaService } from './services/nomina.service';
import { PeriodicidadPagoService } from './services/periodicidad-pago.service';
import { TipoNominaService } from './services/tipo-nomina.service';
import { FirmwareService } from './services/firmware.service';
import { IncidenciaService } from './services/incidencia.service';
import { EvaluacionKardexService } from './services/evaluacion-kardex.service';
import { KardexAsistenciaService } from './services/kardex-asistencia.service';
import { EmpresaService } from './services/empresa.service';
import { DocumentoTipoService } from './services/documento-tipo.service';
import { PeriodoTrabajoService } from './services/periodo-trabajo.service';
import { MotivoService } from './services/motivo.service';
import { SolicitudVacacionalService } from './services/solicitud-vacacional.service';
import { PeriodoVacacionalService } from './services/periodo-vacacional.service';
import { ConceptosFichasService } from './services/conceptos-fichas.service';
import { TiposDescuentosService } from './services/tipos-descuentos.service';
import { FichasTitService } from './services/fichas-tit.service';
import { TipoIncidenciaService } from './services/tipo-incidencia.service';
import { TipoEventoService } from './services/tipo-evento.service';
import { InterfazAdamService } from './services/interfaz-adam.service';
import { AdminChecadoresManager } from './catalogs/administrador-checadores.manager';
import { AdminChecadoresEditor } from './catalogs/administrador-checadores.editor';
import { LockerService} from './services/locker.service';


//////////////////////////// Catalogos ////////////////////////////////
import { EmpresasAdamManager } from './catalogs/empresasadam.manager';
import { EmpresasAdamEditor } from './catalogs/empresasadam.editor';
import { EmpleadosManager } from './catalogs/empleados.manager';
import { EmpleadosEditor } from './catalogs/empleados.editor';
import { CedulasFiniquitosManager } from './catalogs/cedulasfiniquitos.manager';
import { CedulasFiniquitosEditor } from './catalogs/cedulasfiniquitos.editor';
import { PolizasNomina } from './interfases/polizas-nomina';
import { TurnosManager } from './catalogs/turnos.manager';
import { TurnosEditor } from './catalogs/turnos.editor';
import { DepartamentosManager } from  './catalogs/departamentos.manager';
import { CompaniasManager } from './catalogs/companias.manager';
import { CompaniasEditor } from './catalogs/companias.editor';
import { TiposPerDedManager } from './catalogs/tipos-per-ded.manager';
import { TiposPerDedEditor } from './catalogs/tipos-per-ded.editor';
import { ConceptosAdamManager } from './catalogs/conceptos-adam.manager';
import { ConceptosAdamEditor } from './catalogs/conceptos-adam.editor';
import { PuestosManager } from './catalogs/puestos.manager';
import { DispositivosNixtlaEditor } from './catalogs/dispositivos-nixtla.editor';
import { DispositivosNixtlaManager } from './catalogs/dispositivos-nixtla.manager';
import { PlazasManager } from './catalogs/plazas.manager';
import { PlazasEditor } from './catalogs/plazas.editor';
import { ChecadoresManager } from './catalogs/checadores.manager';
import { ChecadoresEditor } from './catalogs/checadores.editor';
import { HorariosManager } from './catalogs/horarios.manager';
import { HorariosEditor } from './catalogs/horarios.editor';
import { ClasesNominasManager } from './catalogs/clases-nominas.manager';
import { ClasesNominasEditor } from './catalogs/clases-nominas.editor';
import { FirmwaresManager } from './catalogs/firmwares.manager';
import { FirmwaresEditor } from './catalogs/firmwares.editor';
import { IncidenciasManager } from './catalogs/incidencias.manager';
import { IncidenciasEditor } from './catalogs/incidencias.editor';
import { EmpresasManager } from './catalogs/empresas.manager';
import { EmpresasEditor } from './catalogs/empresas.editor';
import { SucursalesManager } from './catalogs/sucursales.manager';
import { SucursalesEditor } from './catalogs/sucursales.editor';

import { PeriodicidadPagoManager } from './catalogs/periodicidad-pago.manager';
import { PeriodicidadPagoEditor } from './catalogs/periodicidad-pago.editor';
import { ParametrosEditorComponent } from './catalogs/parts/parametros-editor.component';
import { TiposNominasManager } from './catalogs/tipos-nominas.manager';
import { TiposNominasEditor } from './catalogs/tipos-nominas.editor';
import { DocumentosTiposManager } from './catalogs/documentos-tipos.manager';
import { DocumentosTiposEditor } from './catalogs/documentos-tipos.editor';
import { MotivosManager } from './catalogs/motivos.manager';
import { MotivosEditor } from './catalogs/motivos.editor';
import { ConceptosFichasManager } from './catalogs/conceptos-fichas.manager';
import { ConceptosFichasEditor } from './catalogs/conceptos-fichas.editor';
import { TiposDescuentosEditor } from './catalogs/tipos-descuentos.editor';
import { TiposDescuentosManager } from './catalogs/tipos-descuentos.manager';
import { TiposIncidenciasEditor } from './catalogs/tipos-incidencias.editor';
import { TiposIncidenciasManager } from './catalogs/tipos-incidencias.manager';
import { TiposEventosEditor } from './catalogs/tipos-eventos.editor';
import { TiposEventosManager } from './catalogs/tipos-eventos.manager';
import { LockersEditor} from './catalogs/lockers.editor';
import { LockersManager} from './catalogs/lockers.manager';

//////////////////////////// Componentes /////////////////////////////
import { EmpleadoSelectorComponent } from './components/empleado-selector.component';
import { AdamNominaComponent } from './components/adam-nomina.component';
import { TurnoSelectorComponent } from './components/turno-selector.component';
import { EmpresaAdamSelectorComponent } from './components/empresa-adam-selector.component';
import { TiposPerDedSelectorComponent } from './components/tipos-per-ded-selector.component';
import { CompaniaSelectorComponent } from './components/compania-selector.component';
import { DepartamentoSelectorComponent } from './components/departamento-selector.component';
import { PuestoSelectorComponent } from './components/puesto-selector.component';
import { PlazaSelectorComponent } from './components/plaza-selector.component';
import { HorarioSelectorComponent } from './components/horario-selector.component';
import { PeriodicidadPagoSelectorComponent } from './components/periodicidad-selector.component';
import { ClaseNominaSelectorComponent } from './components/clase-nomina-selector.component';
import { TipoNominaSelectorComponent } from './components/tipo-nomina-selector.component';
import { ChecadorSelectorComponent } from './components/checador-selector.component';
import { IncidenciaSelectorComponent } from './components/incidencia-selector.component';
import { DocumentoTipoSelectorComponent } from './components/documento-tipo-selector.component';
import { ConceptoFichasSelector } from './components/conceptos-fichas-selector.component';
import { TipoDescuentoSelector } from './components/tipo-descuento-selector.component';
import { FichaComponent } from './components/ficha.component';
import { TipoIncidenciaSelector } from './components/tipo-incidencia-selector.component';
import { TipoEventoSelector } from './components/tipo-evento-selector.component';
///////////////////////////// Controls /////////////////////////////////
import { TiposPerDedListComponent } from './controls/tipos-per-ded-list.component';
import { IncidenciaListComponent } from './controls/incidencia-list.component';
import { EmpleadoListComponent } from './controls/empleado-list.component';
import { ConceptosListComponent } from './controls/conceptos-list.component';
import { DocumentoTipoListComponent } from './controls/documentos-tipo-list.component';
import { TurnoListComponent } from './controls/turno-list.component';
import { HorarioListComponent } from './controls/horario-list.component';
import { ChecadorListComponent } from './controls/checadores-list.component';

///////////////////////////// Document /////////////////////////////////

import { ReciboNominaDetailEditor } from './documents/parts/recibos-nominas-detail.editor';
import { RecibosNominasEditor } from './documents/recibos-nominas.editor';
import { RecibosNominasManager } from './documents/recibos-nominas.manager';

import { NominaDetailEditor } from './documents/parts/nominas-detail.editor';
import { NominasEditor } from './documents/nominas.editor';
import { NominasManager } from './documents/nominas.manager';

import { SolicitudVacacionalDetailEditor } from './documents/parts/solicitudes-vacacionales-detail.editor';
import { SolicitudesVacacionalesEditor } from './documents/solicitudes-vacacionales.editor';
import { SolicitudesVacacionalesManager } from './documents/solicitudes-vacacionales.manager';

import { FichasTitEditor } from './documents/fichas-tit.editor';
import { FichasTitManager } from './documents/fichas-tit.manager';
import { FichasTitDetailEditor } from './documents/parts';

//////////////////////////// Parts /////////////////////////////////////
import { DocumentoEmpleadoComponent } from './parts/documento-empleado.component';

//////////////////////////// Mnatenimientos ///////////////////////////
import { ReciboAdamMaintenance } from './maintenances/recibos-adam.maintenance';
import { AutorizacionFiniquitoMaintenance } from './maintenances/autorizacion-finiquito.maintenance';
import { EvaluacionKardexMaintenance } from './maintenances/evaluacion-kardex.maintenance';
import { AutorizacionFiniquitoEditor } from './maintenances/parts/autorizacion-finiquito.editor';
import { EvaluacionKardexEditorComponent } from './maintenances/parts/evaluacion-kardex.editor';
import { EvaluacionKardexDet } from './maintenances/parts/evaluacion-kardex-det';

import { IncidenciaEmpleadoMaintenance } from './maintenances/incidencias-empleado.maintenance';
import { IncidenciaEmpleadoEditorComponent } from './maintenances/parts/incidencias-empleado.editor';
import { ChecadorUsuarioMaintenance } from './maintenances/checador-usuario.maintenance';
import { KardexEmpleadoMaintenance } from './maintenances/kardex-empleado.maintenance';
import { PeriodoTrabajoEmpleadoMaintenance } from './maintenances/periodo-trabajo-empleado.maintenance';
import { ChecadaEmpleadoMaintenance } from './maintenances/checada-empleado.maintenance';
import { EventosUsuarioMaintenance } from './maintenances/eventos-usuario.maintenance';
import { EventosUsuarioEditor } from './maintenances/parts/eventos-usuario.editor';
import { RangosVacacionalesMaintenance } from './maintenances/rangos-vacacionales.maintenance'
import { InterfazAdamMaintenance } from './maintenances/interfaz-adam.maintenance';
import { InterfazAdamEditor } from './maintenances/parts/interfaz-adam.editor';
import { InterfazAdamDetail } from './maintenances/parts/interfaz-adam-det';
import { PlancharChecadasMaintenance } from './maintenances/planchar-checadas.maintenance';
import { DepartamentosAccesosMaintenance } from './maintenances/departamentos-accesos.maintenance';
import { ExportarHuellasChecadoresMaintenance } from './maintenances/exportar-huellas-checadores.maintenance';

//////////////////////////// Reports /////////////////////////////////
import { TarjetaAsistenciaReportComponent } from './reports/tarjeta-asistencia-report.component';
import { TransaccionesReportComponent } from './reports/transacciones-report.component';







/////////////////////////////////////////////////////////////////////////////////
let COMPONENTES = [EmpresasAdamManager, EmpresasAdamEditor, EmpleadosManager, EmpleadosEditor, CedulasFiniquitosManager, CedulasFiniquitosEditor, EmpleadoSelectorComponent, AdamNominaComponent, PolizasNomina, ReciboAdamMaintenance, TurnosManager, TurnosEditor,
    TurnoSelectorComponent, DepartamentosManager, EmpresaAdamSelectorComponent, TiposPerDedManager, TiposPerDedEditor, CompaniasManager, CompaniasEditor, TiposPerDedSelectorComponent, CompaniaSelectorComponent, ConceptosAdamManager, ConceptosAdamEditor, PuestosManager,
    DepartamentoSelectorComponent, DispositivosNixtlaEditor, DispositivosNixtlaManager, PuestoSelectorComponent, PlazasEditor, PlazasManager, PlazaSelectorComponent, AutorizacionFiniquitoMaintenance, AutorizacionFiniquitoEditor,
    HorariosManager, HorariosEditor, ChecadoresManager, ChecadoresEditor, HorarioSelectorComponent, RecibosNominasEditor, ReciboNominaDetailEditor, RecibosNominasManager, TiposPerDedListComponent,
    ClasesNominasManager, ClasesNominasEditor, NominaDetailEditor, NominasEditor, NominasManager, PeriodicidadPagoSelectorComponent, ClaseNominaSelectorComponent, TipoNominaSelectorComponent, HorarioListComponent, FirmwaresManager, FirmwaresEditor,
    IncidenciasManager, IncidenciasEditor, IncidenciaListComponent, EvaluacionKardexMaintenance, ChecadorSelectorComponent, EvaluacionKardexEditorComponent, IncidenciaEmpleadoMaintenance, IncidenciaSelectorComponent, IncidenciaEmpleadoEditorComponent,
    EmpleadoListComponent, ChecadorUsuarioMaintenance, TarjetaAsistenciaReportComponent, TransaccionesReportComponent, EmpresasManager, EmpresasEditor,
    ParametrosEditorComponent, PeriodicidadPagoEditor, PeriodicidadPagoManager, TiposNominasManager, TiposNominasEditor, ConceptosListComponent, DocumentoTipoSelectorComponent, DocumentoTipoListComponent, DocumentosTiposManager, DocumentosTiposEditor,
    KardexEmpleadoMaintenance, PeriodoTrabajoEmpleadoMaintenance, DocumentoEmpleadoComponent, TurnoListComponent, HorarioListComponent, MotivosEditor, MotivosManager, ChecadaEmpleadoMaintenance,
    ChecadorListComponent, SolicitudesVacacionalesManager, SolicitudesVacacionalesEditor, SolicitudVacacionalDetailEditor, ConceptosFichasManager, ConceptosFichasEditor, TiposDescuentosEditor, TiposDescuentosManager,
    FichasTitManager, FichasTitEditor, FichasTitDetailEditor, ConceptoFichasSelector, TipoDescuentoSelector, FichaComponent, EvaluacionKardexDet, EventosUsuarioMaintenance, EventosUsuarioEditor,
    TiposIncidenciasEditor, TiposIncidenciasManager, TiposEventosManager, TiposEventosEditor, TipoIncidenciaSelector, TipoEventoSelector, RangosVacacionalesMaintenance, SucursalesManager, SucursalesEditor,
    InterfazAdamMaintenance, InterfazAdamEditor, InterfazAdamDetail, AdminChecadoresManager, AdminChecadoresEditor, PlancharChecadasMaintenance, 
    DepartamentosAccesosMaintenance, ExportarHuellasChecadoresMaintenance, LockersEditor,LockersManager
];

let SERVICIOS = [EmpresaAdamService, EmpleadoService, CedulaFiniquitoService, PolizasNominaService, ReciboAdamService, TurnoService, DepartamentoService, PuestoService, CompaniaService, TipoPerDedService, ConceptoAdamService, DispositivoNixtlaService,
    ProgramacionReciboAdamService, PlazaService, FiniquitoAutorizacionService, HorarioService, ChecadorService, ReciboNominaService, ClaseNominaService, NominaService, PeriodicidadPagoService, TipoNominaService, FirmwareService,
    IncidenciaService, EvaluacionKardexService, KardexAsistenciaService, EmpresaService, DocumentoTipoService, PeriodoTrabajoService, MotivoService, SolicitudVacacionalService, PeriodoVacacionalService,
    ConceptosFichasService, TiposDescuentosService, FichasTitService, TipoIncidenciaService, TipoEventoService, SucursalService, InterfazAdamService, LockerService
];

@NgModule({
    imports: [
        CommonModule, FormsModule, ReactiveFormsModule,
        TabsModule.forRoot(), ModalModule.forRoot(),
        CoreModule, EditorsModule, SearchModule, GeneralModule, ControlsModule, SecurityModule, WjCoreModule, WjInputModule,
        WjGridModule, WjGridFilterModule, RhRoutingModule, AccountingModule, TreasuryModule, PurchasingModule, WjGridDetailModule
    ],
    declarations: COMPONENTES,
    providers: SERVICIOS,
    exports: COMPONENTES
})
export class RhModule {

}
