﻿import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

//////////////////////////// Guards //////////////////////////////////
import { AuthGuard } from 'framework3/core';
import { EditorDeactivateGuard } from 'framework3/editors';

//////////////////////////// Catalogos ////////////////////////////////
import { EmpresasAdamManager } from './catalogs/empresasadam.manager';
import { EmpresasAdamEditor } from './catalogs/empresasadam.editor';
import { EmpleadosManager } from './catalogs/empleados.manager';
import { EmpleadosEditor } from './catalogs/empleados.editor';
import { CedulasFiniquitosManager } from './catalogs/cedulasfiniquitos.manager';
import { CedulasFiniquitosEditor } from './catalogs/cedulasfiniquitos.editor';
import { TurnosManager } from './catalogs/turnos.manager'
import { TurnosEditor } from './catalogs/turnos.editor'
import { DepartamentosManager } from './catalogs/departamentos.manager';
import { CompaniasManager } from './catalogs/companias.manager';
import { CompaniasEditor } from './catalogs/companias.editor'
import { TiposPerDedManager } from './catalogs/tipos-per-ded.manager';
import { TiposPerDedEditor } from './catalogs/tipos-per-ded.editor';
import { PuestosManager } from './catalogs/puestos.manager';
import { DispositivosNixtlaManager } from './catalogs/dispositivos-nixtla.manager';
import { DispositivosNixtlaEditor } from './catalogs/dispositivos-nixtla.editor';
import { ConceptosAdamManager } from './catalogs/conceptos-adam.manager';
import { ConceptosAdamEditor } from './catalogs/conceptos-adam.editor';
import { PlazasManager } from './catalogs/plazas.manager';
import { PlazasEditor } from './catalogs/plazas.editor';
import { HorariosManager } from './catalogs/horarios.manager';
import { HorariosEditor } from './catalogs/horarios.editor';
import { ChecadoresManager } from './catalogs/checadores.manager';
import { ChecadoresEditor } from './catalogs/checadores.editor';
import { ClasesNominasManager } from './catalogs/clases-nominas.manager';
import { ClasesNominasEditor } from './catalogs/clases-nominas.editor';
import { FirmwaresManager } from './catalogs/firmwares.manager';
import { FirmwaresEditor } from './catalogs/firmwares.editor';
import { IncidenciasManager } from './catalogs/incidencias.manager';
import { IncidenciasEditor } from './catalogs/incidencias.editor';
import { EmpresasManager } from './catalogs/empresas.manager';
import { EmpresasEditor } from './catalogs/empresas.editor';
import { PeriodicidadPagoManager } from './catalogs/periodicidad-pago.manager';
import { PeriodicidadPagoEditor } from './catalogs/periodicidad-pago.editor';
import { TiposNominasManager } from './catalogs/tipos-nominas.manager';
import { TiposNominasEditor } from './catalogs/tipos-nominas.editor';
import { DocumentosTiposManager } from './catalogs/documentos-tipos.manager';
import { DocumentosTiposEditor } from './catalogs/documentos-tipos.editor';
import { MotivosManager } from './catalogs/motivos.manager';
import { MotivosEditor } from './catalogs/motivos.editor';
import { TiposIncidenciasEditor } from './catalogs/tipos-incidencias.editor';
import { TiposIncidenciasManager } from './catalogs/tipos-incidencias.manager';
import { TiposEventosEditor } from './catalogs/tipos-eventos.editor';
import { TiposEventosManager } from './catalogs/tipos-eventos.manager';

import { SucursalesManager } from './catalogs/sucursales.manager';
import { SucursalesEditor } from './catalogs/sucursales.editor';
import { AdminChecadoresManager } from './catalogs/administrador-checadores.manager';
import { AdminChecadoresEditor } from './catalogs/administrador-checadores.editor';
import { LockersEditor} from './catalogs/lockers.editor';
import {LockersManager} from './catalogs/lockers.manager';



///////////////////////////// Interfases /////////////////////////////////
import { PolizasNomina } from './interfases/polizas-nomina';

///////////////////////////// Document /////////////////////////////////

import { RecibosNominasEditor } from './documents/recibos-nominas.editor';
import { RecibosNominasManager } from './documents/recibos-nominas.manager';

import { NominasEditor } from './documents/nominas.editor';
import { NominasManager } from './documents/nominas.manager';

import { SolicitudesVacacionalesEditor } from './documents/solicitudes-vacacionales.editor';
import { SolicitudesVacacionalesManager } from './documents/solicitudes-vacacionales.manager';
///////////////////////////// Rutas /////////////////////////////////

///////////////////////////// Mantenimientos /////////////////////////////////
import { ReciboAdamMaintenance } from './maintenances/recibos-adam.maintenance';
import { AutorizacionFiniquitoMaintenance } from './maintenances/autorizacion-finiquito.maintenance';
import { EvaluacionKardexMaintenance } from './maintenances/evaluacion-kardex.maintenance';
import { AutorizacionFiniquitoEditor } from './maintenances/parts/autorizacion-finiquito.editor';
import { EvaluacionKardexEditorComponent } from './maintenances/parts/evaluacion-kardex.editor';
import { IncidenciaEmpleadoMaintenance } from './maintenances/incidencias-empleado.maintenance';
import { IncidenciaEmpleadoEditorComponent } from './maintenances/parts/incidencias-empleado.editor';
import { ChecadorUsuarioMaintenance } from './maintenances/checador-usuario.maintenance';
import { KardexEmpleadoMaintenance } from './maintenances/kardex-empleado.maintenance';
import { PeriodoTrabajoEmpleadoMaintenance } from './maintenances/periodo-trabajo-empleado.maintenance';
import { ChecadaEmpleadoMaintenance } from './maintenances/checada-empleado.maintenance';
import { EvaluacionKardexDet } from './maintenances/parts/evaluacion-kardex-det';
import { EventosUsuarioMaintenance } from './maintenances/eventos-usuario.maintenance';
import { EventosUsuarioEditor } from './maintenances/parts/eventos-usuario.editor';
import { RangosVacacionalesMaintenance } from './maintenances/rangos-vacacionales.maintenance'
import { InterfazAdamMaintenance } from './maintenances/interfaz-adam.maintenance';
import { InterfazAdamEditor } from './maintenances/parts/interfaz-adam.editor';
import { InterfazAdamDetail } from './maintenances/parts/interfaz-adam-det';
import { PlancharChecadasMaintenance } from './maintenances/planchar-checadas.maintenance';
import { DepartamentosAccesosMaintenance } from './maintenances/departamentos-accesos.maintenance';
import { ExportarHuellasChecadoresMaintenance } from './maintenances/exportar-huellas-checadores.maintenance';

//////////////////////////// Parts /////////////////////////////////
import { DocumentoEmpleadoComponent } from './parts/documento-empleado.component';

//////////////////////////// Reports /////////////////////////////////
import { TarjetaAsistenciaReportComponent } from './reports/tarjeta-asistencia-report.component';
import { TransaccionesReportComponent } from './reports/transacciones-report.component';
import { ConceptosFichasManager } from './catalogs/conceptos-fichas.manager';
import { ConceptosFichasEditor } from './catalogs/conceptos-fichas.editor';
import { TiposDescuentosManager } from './catalogs/tipos-descuentos.manager';
import { TiposDescuentosEditor } from './catalogs/tipos-descuentos.editor';
import { FichasTitManager, FichasTitEditor } from './documents';



const routes: Routes = [
    {
        path: '',
        canActivateChild: [AuthGuard],
        children: [
            { path: 'empresa-adam/:proceso', component: EmpresasAdamManager },
            { path: 'empresa-adam/:proceso/:id', component: EmpresasAdamEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'empleados/:proceso', component: EmpleadosManager },
            { path: 'empleados/:proceso/:id', component: EmpleadosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'cedulas-finiquitos/:proceso', component: CedulasFiniquitosManager },
            { path: 'cedulas-finiquitos/:proceso/:id', component: CedulasFiniquitosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'polizas-nomina/:proceso', component: PolizasNomina, canDeactivate: [EditorDeactivateGuard] },
            { path: 'turnos/:proceso', component: TurnosManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'turnos/:proceso/:id', component: TurnosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'departamentos/:proceso', component: DepartamentosManager },
            { path: 'companias/:proceso', component: CompaniasManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'companias/:proceso/:id', component: CompaniasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'tipos-per-ded/:proceso', component: TiposPerDedManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'tipos-per-ded/:proceso/:id', component: TiposPerDedEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'departamentos/:proceso', component: DepartamentosManager },
            { path: 'puestos/:proceso', component: PuestosManager },
            { path: 'conceptos-adam/:proceso', component: ConceptosAdamManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'conceptos-adam/:proceso/:id', component: ConceptosAdamEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'dispositivos-nixtla/:proceso', component: DispositivosNixtlaManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'dispositivos-nixtla/:proceso/:id', component: DispositivosNixtlaEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'plazas/:proceso', component: PlazasManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'plazas/:proceso/:id', component: PlazasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'finiquito-autorizacion/autorizacion/:proceso/:id', component: AutorizacionFiniquitoEditor },
            { path: 'checadores/:proceso', component: ChecadoresManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'checadores/:proceso/:id', component: ChecadoresEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'horarios/:proceso', component: HorariosManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'horarios/:proceso/:id', component: HorariosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'recibos-nomina/:proceso', component: RecibosNominasManager },
            { path: 'recibos-nomina/:proceso/:id', component: RecibosNominasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'clases-nomina/:proceso', component: ClasesNominasManager },
            { path: 'clases-nomina/:proceso/:id', component: ClasesNominasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'firmwares/:proceso', component: FirmwaresManager },
            { path: 'firmwares/:proceso/:id', component: FirmwaresEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'incidencias/:proceso', component: IncidenciasManager },
            { path: 'incidencias/:proceso/:id', component: IncidenciasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'empresas-rh/:proceso', component: EmpresasManager },
            { path: 'empresas-rh/:proceso/:id', component: EmpresasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'sucursales-rh/:proceso', component: SucursalesManager },
            { path: 'sucursales-rh/:proceso/:idEmpresa/:id', component: SucursalesEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'periodicidad-pago/:proceso', component: PeriodicidadPagoManager },
            { path: 'periodicidad-pago/:proceso/:id', component: PeriodicidadPagoEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'tipos-nomina/:proceso', component: TiposNominasManager },
            { path: 'tipos-nomina/:proceso/:id', component: TiposNominasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'documentos-tipo/:proceso', component: DocumentosTiposManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'documentos-tipo/:proceso/:id', component: DocumentosTiposEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'motivos/:proceso', component: MotivosManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'motivos/:proceso/:id', component: MotivosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'conceptos-fichas/:proceso', component: ConceptosFichasManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'conceptos-fichas/:proceso/:id', component: ConceptosFichasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'tipos-descuentos/:proceso', component: TiposDescuentosManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'tipos-descuentos/:proceso/:id', component: TiposDescuentosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'fichas/:proceso', component: FichasTitManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'fichas/:proceso/:id', component: FichasTitEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'tipos-incidencias/:proceso', component: TiposIncidenciasManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'tipos-incidencias/:proceso/:id', component: TiposIncidenciasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'tipos-eventos/:proceso', component: TiposEventosManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'tipos-eventos/:proceso/:id', component: TiposEventosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'admin-checadores/:proceso', component: AdminChecadoresManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'admin-checadores/:proceso/:id', component: AdminChecadoresEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'lockerM/:proceso',component: LockersManager},
            
            
            // Maintenance
            { path: 'recibos-adam/:proceso', component: ReciboAdamMaintenance, canDeactivate: [EditorDeactivateGuard] },
            { path: 'finiquito-autorizacion/:proceso', component: AutorizacionFiniquitoMaintenance },
            { path: 'evaluacion-kardex/:proceso', component: EvaluacionKardexMaintenance },
            { path: 'evaluacion-kardex/:proceso/new', component: EvaluacionKardexEditorComponent },
            { path: 'evaluacion-kardex/:proceso/:id', component: EvaluacionKardexDet },

            { path: 'incidencias-empleado/:proceso', component: IncidenciaEmpleadoMaintenance },
            { path: 'incidencias-empleado/:proceso/:id', component: IncidenciaEmpleadoEditorComponent },
            { path: 'checador-usuarios/:proceso/:id', component: ChecadorUsuarioMaintenance },
            { path: 'kardex-empleado/:proceso', component: KardexEmpleadoMaintenance },
            { path: 'periodo-trabajo-empleado/:proceso', component: PeriodoTrabajoEmpleadoMaintenance },
            { path: 'checada-empleado/:proceso', component: ChecadaEmpleadoMaintenance },
            { path: 'eventos-usuario/:proceso', component: EventosUsuarioMaintenance },
            { path: 'eventos-usuario/eventos/:proceso/:id', component: EventosUsuarioEditor },
            { path: 'rangos-vacacionales/:proceso/:idClaseNomina', component: RangosVacacionalesMaintenance },
            { path: 'interfaz-adam/:proceso', component: InterfazAdamMaintenance },
            { path: 'interfaz-adam/:proceso/new', component: InterfazAdamEditor },
            { path: 'interfaz-adam/:proceso/:id', component: InterfazAdamDetail },
            { path: 'planchar-checadas/:proceso', component: PlancharChecadasMaintenance },

            { path: 'departamentos-accesos/:proceso', component: DepartamentosAccesosMaintenance },
            { path: 'exportar-huellas/:proceso', component: ExportarHuellasChecadoresMaintenance },
            

            // Reports
            { path: 'tarjeta-asistencias/:proceso', component: TarjetaAsistenciaReportComponent },
            { path: 'transacciones/:proceso', component: TransaccionesReportComponent },

            // Parts
            { path: 'documento-empleado/:proceso/:id', component: DocumentoEmpleadoComponent },

            //
            { path: 'nominas/:proceso', component: NominasManager },
            { path: 'nominas/:proceso/:id', component: NominasEditor, canDeactivate: [EditorDeactivateGuard] },

            { path: 'solicitudes-vacacionales/:proceso', component: SolicitudesVacacionalesManager },
            { path: 'solicitudes-vacacionales/:proceso/:id', component: SolicitudesVacacionalesEditor, canDeactivate: [EditorDeactivateGuard] },


        ]
    },
];



@NgModule({
    imports: [
        RouterModule.forChild(routes)
    ],
    exports: [
        RouterModule
    ]
})
export class RhRoutingModule { }

