﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService, BaseService } from 'framework3/core';
//Locales
import { AdamNominaInfo } from '../models/adamnomina'
import { EmpresaAdamInfo } from '../models/empresaadam'

@Injectable()
export class AdamService extends BaseService {

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/rh/adam");
    }

    create(): Promise<AdamNominaInfo> {
        return Promise.resolve(new AdamNominaInfo());
    }

    loadCompaniasAdam(idEmpresaAdam: number): Promise<any> {
        let params = new HttpParams()
            .set('idEmpresaAdam', idEmpresaAdam.toString());
        return this.apiService.get<any>('load-compania', params)
            .toPromise();
    }

    loadClaseNomina(idEmpresaAdam: number): Promise<any> {
        let params = new HttpParams()
            .set('idEmpresaAdam', idEmpresaAdam.toString());
        return this.apiService.get<any>('load-clase-nomina', params)
            .toPromise();
    }

    loadTipoNomina(idEmpresaAdam: number, claseNomina: string): Promise<any> {
        let params = new HttpParams()
            .set('idEmpresaAdam', idEmpresaAdam.toString())
            .set('claseNomina', claseNomina);
        return this.apiService.get<any>('load-tipo-nomina', params)
            .toPromise();
    }

    loadAnio(idEmpresaAdam: number, compania: string, tipoNomina: string): Promise<any> {
        let params = new HttpParams()
            .set('idEmpresaAdam', idEmpresaAdam.toString())
            .set('compania', compania)
            .set('tipoNomina', tipoNomina);
        return this.apiService.get<any>('load-anio', params)
            .toPromise();
    }

    loadPeriodo(idEmpresaAdam: number, compania: string, tipoNomina: string, anio: number): Promise<any> {
        let params = new HttpParams()
            .set('idEmpresaAdam', idEmpresaAdam.toString())
            .set('compania', compania)
            .set('tipoNomina', tipoNomina)
            .set('anio', anio.toString());
        return this.apiService.get<any>('load-periodo', params)
            .toPromise();
    }


}

