﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { ClaseNominaInfo } from '../models/clase-nomina'
import { RangoVacacionalInfo } from '../models/rango-vacacional'

@Injectable()
export class ClaseNominaService extends CatalogService<ClaseNominaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/rh/clases-nominas');
    }

    create(): Promise<ClaseNominaInfo> {
        return Promise.resolve(new ClaseNominaInfo());
    }

    getRangosVacacionales(idClaseNomina: number): Promise<RangoVacacionalInfo[]> {
        let params = new HttpParams()
            .set('IdClaseNomina', idClaseNomina.toString());
        
        return this.apiService.get<RangoVacacionalInfo[]>('get-rangos-vacacionales', params)        
            .toPromise();
    }

    saveRangosVacacionales(rangos: RangoVacacionalInfo[]) {
        let params = new HttpParams();
        return this.apiService.post<boolean>('save-rangos-vacacionales', params, rangos).toPromise();
    }

}

