﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { ConceptosFichasInfo } from '../models/concepto-ficha'

@Injectable()
export class ConceptosFichasService extends CatalogService<ConceptosFichasInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/azteca.business.rh/conceptos-fichas');
    }

    create(): Promise<ConceptosFichasInfo> {
        return Promise.resolve(new ConceptosFichasInfo());
    }

	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<ConceptosFichasInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<ConceptosFichasInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

