﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { DispositivoNixtlaInfo } from '../models/dispositivo-nixtla'

@Injectable()
export class DispositivoNixtlaService extends CatalogService<DispositivoNixtlaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/rh/dispositivos-nixtla');
    }

    create(): Promise<DispositivoNixtlaInfo> {
        return Promise.resolve(new DispositivoNixtlaInfo());
    }

	/*
	//Sample method
    sampleMethod(param1: number): Promise<DispositivoNixtlaInfo> {
        let params: URLSearchParams = new URLSearchParams();
        params.set('param1', param1.toString());
        return this.apiService.getData('sample-method', params)
            .map(response => response.json() as DispositivoNixtlaInfo)
            .toPromise();
    }
	*/
}

