﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService, CatalogItem } from 'framework3/core';
//Locales
import { DocumentoTipoInfo } from '../models/documento-tipo'

@Injectable()
export class DocumentoTipoService extends CatalogService<DocumentoTipoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/rh/documentos-tipos');
    }

    create(): Promise<DocumentoTipoInfo> {
        return Promise.resolve(new DocumentoTipoInfo());
    }

     searchKeyword2(proceso:string,idBranch:number,keyword:string): Observable<CatalogItem[]> {
        let params = new HttpParams()
            .set("idBranch", idBranch.toString())
            .set("proceso", proceso)
            .set("keyWord",keyword);
        return this.apiService.get<CatalogItem[]>("search-tipo-documento", params);

    }
}

