﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { EmpresaAdamInfo } from '../models/empresaadam'

@Injectable()
export class EmpresaAdamService extends CatalogService<EmpresaAdamInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/rh/empresas-adam");
    }

    create(): Promise<EmpresaAdamInfo> {
        return Promise.resolve(new EmpresaAdamInfo());
    }

    loadEmpresasAdamCBO(idSucursal: number): Promise<any> {
        let params = new HttpParams()
            .set('idSucursal', idSucursal.toString());
        return this.apiService.get<any>('load-cbo', params).toPromise();
    }
}

