﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Framework
import { Context, DocumentInfo, DocumentItem, DocumentService } from 'framework3/core';
//Locales
import { FichasTitInfo, FichasTitItem } from '../models/fichas-tit';
import { FichasTitDetail } from '../models/fichas-tit-detail';

@Injectable()
export class FichasTitService extends DocumentService<FichasTitDetail, FichasTitInfo> {

    constructor(protected http: HttpClient, protected context: Context ) {
        super(http, context, 'api/rh/fichas-tit');
    }

    create(): Promise<FichasTitInfo> {
        let newDoc = new FichasTitInfo();
        return Promise.resolve(newDoc);
    }

	
    loadInfoEmpleadoAdam(idSucursal: number, codigoEmpleado: string): Promise<any> {
        let params = new HttpParams()
            .set('idSucursal', idSucursal.toString())
            .set('codigoEmpleado', codigoEmpleado);
		//
        return this.apiService.get<any>('empleado-info-ADAM', params)
            .toPromise();
    }

    deactivate(idFichaTit: string): Promise<any> {
        let params = new HttpParams()
            .set('idFichaTit', idFichaTit);
        return this.apiService.post<any>('deactivate', params)
            .toPromise();
    }

    getCuentaEmpleado(idFichaTit: string): Promise<any> {
        let params = new HttpParams()
            .set('idFichaTit', idFichaTit);
        return this.apiService.get<any>('get-cuenta-empleado', params)
            .toPromise();
    }
	
    armarCuentas(idFichaTit: string): Promise<any> {
        let params = new HttpParams()
            .set('IdFichaTit', idFichaTit);
        return this.apiService.post<any>('armar-cuentas', params)
            .toPromise();
    }


}