﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http'; import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, BaseService } from 'framework3/core';
import { SearchResult, SearchRequest } from 'framework3/search';
//Locales
import * as moment from 'moment';

// Features
import { FiniquitoAutorizacionInfo } from '../models/finiquito-autorizacion'


@Injectable()
export class FiniquitoAutorizacionService extends BaseService {

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/rh/autorizacion");
    }

    searchFiniquitAutorizacion(idBranch: number, request: SearchRequest): Promise<SearchResult> {
        let params: HttpParams = new HttpParams()
            .set('idBranch', idBranch.toString());
        return this.apiService.post<any>('search', params, request)
            .toPromise();
    }

    getDetail(idFiniquitoAutorizacion: number): Promise<FiniquitoAutorizacionInfo> {
        let params = new HttpParams()
            .set("idFiniquitoAutorizacion", idFiniquitoAutorizacion.toString());
        return this.apiService.get<FiniquitoAutorizacionInfo>('get-detail', params).toPromise();
    }

    update(finiquitoAutorizacion: FiniquitoAutorizacionInfo): Promise<boolean> {
        let params: HttpParams = new HttpParams();
        return this.apiService.post<boolean>('update', params, finiquitoAutorizacion)
            .toPromise();
    }

    delete(idFiniquitoAutorizacion: number): Promise<boolean> {
        let params: HttpParams = new HttpParams()
            .set("idFiniquitoAutorizacion", idFiniquitoAutorizacion.toString());
        return this.apiService.post<boolean>('delete', params, null)
            .toPromise();
    }

    loadClasesNominas(): Promise<any> {
        let params = new HttpParams();
        return this.apiService.get<any>('load-clases-nominas', params).toPromise();
    }

    loadPersonasAutorizan(): Promise<any> {
        let params = new HttpParams();
        return this.apiService.get<any>('load-personas-autorizan', params).toPromise();
    }

}