﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { FirmwareInfo, FirmwareItem } from '../models/firmware';

@Injectable()
export class FirmwareService extends CatalogService<FirmwareInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/rh/firmwares');
    }

    create(): Promise<FirmwareInfo> {
        return Promise.resolve(new FirmwareInfo());
    }

    loadCbo(idBranch: number): Promise<FirmwareItem[]> {
        let params = new HttpParams()
            .set('idBranch', idBranch.toString());
		//
        return this.apiService.get<FirmwareItem[]>('load-cbo', params)
            .toPromise();
    }
	
}

