﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { MotivoInfo } from '../models/motivo'

@Injectable()
export class MotivoService extends CatalogService<MotivoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/rh/motivos');
    }

    create(): Promise<MotivoInfo> {
        return Promise.resolve(new MotivoInfo());
    }

    loadCbo(idSucursal: number) : Promise<any[]>  {
        let params: HttpParams = new HttpParams()
            .set("idSucursal", idSucursal.toString());
        return this.apiService.get<any[]>('load-cbo', params).toPromise();
    }

}

