﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Framework
import { Context, DocumentInfo, DocumentItem, DocumentService } from 'framework3/core';
//Locales
import { NominaInfo, NominaItem } from '../models/nomina';
import { NominaDetail } from '../models/nomina-detail';

@Injectable()
export class NominaService extends DocumentService<NominaDetail, NominaInfo> {

    constructor(protected http: HttpClient, protected context: Context ) {
        super(http, context, 'api/rh/nominas');
    }

    create(): Promise<NominaInfo> {
        let newDoc = new NominaInfo();
        return Promise.resolve(newDoc);
    }

    calcularNomina(idNomina: string): Promise<boolean> {
        let params = new HttpParams()
            .set('idNomina', idNomina);
        //
        return this.apiService.post<boolean>('calcular-nomina', params)
            .toPromise();
    }

    timbrarNomina(idNomina: string): Promise<boolean> {
        let params = new HttpParams()
            .set('idNomina', idNomina);
        //
        return this.apiService.post<boolean>('timbrar-nomina', params)
            .toPromise();
    }

}