﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';

//Azteca Kernel
import { Context, CatalogService, BaseService } from 'framework3/core';
//Locales
import { CuentaFaltante } from '../models/cuenta-faltante'
import { AdamNominaInfo } from '../models/adamnomina';



@Injectable()
export class PolizasNominaService extends BaseService{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/rh/adam");
    }

    importarPolizaAdam(numeroLiquidacion: number, tipoPoliza: string, adamNomina: AdamNominaInfo): Promise<any> {
        let params = new HttpParams()
            .set("numero_liquidacion", numeroLiquidacion.toString())
            .set("tipoPoliza", tipoPoliza);
        return this.apiService.post<any>("interfas-poliza-adam", params, adamNomina).toPromise();
    }

    loadCuentasFaltantes(idEmpresaAdam: number, compania: string, claseNomina: string, tipoNomina: string, anio: number, periodo: number): Promise<CuentaFaltante[]> {
        let params = new HttpParams()
            .set("idEmpresaAdam", idEmpresaAdam.toString())
            .set("compania", compania)
            .set("claseNomina", claseNomina)
            .set("tipoNomina", tipoNomina)
            .set("anio", anio.toString())
            .set("periodo", periodo.toString());
        return this.apiService.get<CuentaFaltante[]>("load-cuentas-faltantes", params).toPromise();
    }


}