﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs';
import 'rxjs/add/operator/toPromise';
//Azteca Framework
import { Context, DocumentInfo, DocumentItem, DocumentService } from 'framework3/core';
//Locales
import { SolicitudVacacionalInfo, SolicitudVacacionalItem } from '../models/solicitud-vacacional';
import { SolicitudVacacionalDetail } from '../models/solicitud-vacacional-detail';

@Injectable()
export class SolicitudVacacionalService extends DocumentService<SolicitudVacacionalDetail, SolicitudVacacionalInfo> {

    constructor(protected http: HttpClient, protected context: Context ) {
        super(http, context, 'api/rh/solicitudes-vacacionales');
    }

    create(): Promise<SolicitudVacacionalInfo> {
        let newDoc = new SolicitudVacacionalInfo();
        return Promise.resolve(newDoc);
    }

    calcularRango(idEmpleado: number, fechaIni: Date, fechaFin: Date, idSucursal:number): Promise<SolicitudVacacionalDetail[]> {
        let params = new HttpParams()
            .set('IdEmpleado', idEmpleado.toString())
            .set('FechaIni', fechaIni.toLocaleDateString('en-US'))
            .set('FechaFin', fechaFin.toLocaleDateString('en-US'))
            .set('IdSucursal', idSucursal.toString());

        return this.apiService.get<SolicitudVacacionalDetail[]>('calcular-rango-vacacional', params)
            .toPromise()
    }


	/*
    sampleMethod(param1: number, param2: string): Promise<SolicitudVacacionalInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<SolicitudVacacionalInfo>('sample-method', params)
            .toPromise();
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) en los resultados de búsquedas. Eliminar si no es necesario
	protected mapSearchResult(row: any) {
        
    }
	*/

	/*
	//Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) al cargar un documento. Eliminar si no es necesario
    protected mapDocument(document: SolicitudVacacionalInfo) {

    }
	*/



}