﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { TipoNominaInfo } from '../models/tipo-nomina'

@Injectable()
export class TipoNominaService extends CatalogService<TipoNominaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/rh/tipos-nominas');
    }

    create(): Promise<TipoNominaInfo> {
        return Promise.resolve(new TipoNominaInfo());
    }

	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<TipoNominaInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<TipoNominaInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

