﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService, CatalogItem } from 'framework3/core';
//Locales
import { TiposDescuentosInfo, DescuentosEmpleado } from '../models/tipo-descuento'

@Injectable()
export class TiposDescuentosService extends CatalogService<TiposDescuentosInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/rh/tipos-descuentos');
    }

    create(): Promise<TiposDescuentosInfo> {
        return Promise.resolve(new TiposDescuentosInfo());
    }

    searchKeyword2(tipo:string,idBranch:number,keyword:string): Observable<CatalogItem[]> {
        let params = new HttpParams()
            .set("idBranch", idBranch.toString())
            .set("tipo", tipo)
            .set("keyWord",keyword);
        return this.apiService.get<CatalogItem[]>("search-descuento", params);

    }

    infoDescuentosEmpleadoADAM(idEmpleado: number, idBranch: number): Promise<DescuentosEmpleado[]> {
        let params = new HttpParams()
            .set("idSucursal", idBranch.toString())
            .set("idEmpleado", idEmpleado.toString())
        return this.apiService.get<DescuentosEmpleado[]>("descuento-empleado", params).toPromise();
    }

	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<TiposDescuentosInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<TiposDescuentosInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

