﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
import { SearchResult, SearchRequest } from 'framework3/search';
//Locales
import { TurnoInfo } from '../models/turno'
import { EmpleadoItem } from '../models/empleado';

@Injectable()
export class TurnoService extends CatalogService<TurnoInfo> {

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/rh/turno");
    }

    create(): Promise<TurnoInfo> {
        return Promise.resolve(new TurnoInfo());
    }

    getEmpleadosByTurno(idTurno: number,idSucursal: number): Promise<EmpleadoItem[]> {
        let params = new HttpParams()
            .set('idTurno', idTurno.toString())
            .set('idSucursal', idSucursal.toString());
        return this.apiService.get<EmpleadoItem[]>('get-empleados-by-turno', params).toPromise();
    }

    addTurnoEmpleado(idTurno: number, empleados: EmpleadoItem[]):Promise<any> {
        let params = new HttpParams()
            .set('idTurno', idTurno.toString());
        return this.apiService.post<any>('add-turno-empleados', params, empleados).toPromise();
    }

    removeTurnoEmpleado(idEmpleado: number): Promise<any> {
        let params = new HttpParams()
            .set('idEmpleado', idEmpleado.toString());
        return this.apiService.post<any>('remove-turno-empleado', params).toPromise();
    }

}