﻿import { Component, EventEmitter, Input, Output, ViewChild, forwardRef } from '@angular/core';
//
import { Context} from 'framework3/core';
import { CatalogListDialog, SearchRequest } from 'framework3/search';

import { ClienteService } from '../services/cliente.service';
import { ClienteItem } from '../models/cliente';

//

@Component({
    selector: 'sales-clientes-list',
    templateUrl: './clientes-list.component.html'
})
export class ClientesListComponent extends CatalogListDialog {
    clientes: ClienteItem[];

    constructor(protected context: Context, private clienteService: ClienteService) {
        super(context);
    }

    onSearchRequested(request: SearchRequest) {
        this.clienteService.search(this.context.app.defaultSite.identity, request)
            .then(result => {
                this.clientes = result.rows;
                this.totalRows = result.totalRows;
                this.pageIndex = request.pageIndex;
                this.context.app.hideSpinner();
            })
            .catch(error => this.handleError(error));
    }

    onSelectedItemsChanged(selectedGroups: ClienteItem[]) {
        this.selectedItemsChanged.emit(selectedGroups);
    }

    onSelectedItemChanged(cliente: ClienteItem) {
        this.selectedItemChanged.emit(cliente);
    }

}