﻿//Frameworks
import { Component, ViewChild, Input, Output, EventEmitter, ChangeDetectorRef, forwardRef } from '@angular/core';
import { Router, ActivatedRoute, Params } from '@angular/router';
import { FormBuilder, Validators, FormGroup } from '@angular/forms';
import { Location } from '@angular/common';
//Wijmo
import { Control } from 'wijmo/wijmo';
//Bootstrap
import { ModalDirective } from 'ngx-bootstrap';


@Component({
    selector: 'confirmacion',
    templateUrl: './confirmacion.component.html'
})

export class Confirmacion {
    editorForm: FormGroup;
    idEliminar: number = 0;
    mensaje: string = '';

    @ViewChild('dialog') dialog: ModalDirective;

    //outputs
    @Output() aceptado: EventEmitter<number> = new EventEmitter<number>();

    constructor(private formBuilder: FormBuilder) {
        this.editorForm = formBuilder.group({});
    }

    show(idPreRegistro: number, mensaje: string) {
        this.idEliminar = idPreRegistro;
        this.mensaje = mensaje;
        this.dialog.config.backdrop = false;
        this.dialog.show();
        Control.invalidateAll();
    }

    onAceptar() {
        this.aceptado.emit(this.idEliminar);
        this.dialog.hide();
    }

    onCancelar() {
        this.aceptado.emit(0);
        this.dialog.hide();
    }


}