﻿//Features
import { Context, CatalogInfo, CatalogItem } from 'framework3/core';
import { ArticuloStockInfo, UnidadMedidaInfo } from '../../inventory';
//import { ImpuestoAsignacionInfo } from '../../accounting/models/impuesto-asignacion';
import { ImpuestoAsignacionZonaInfo } from '../models/impuesto-asignacion-zona';

export class ArticuloInfo extends CatalogInfo {
    nombre: string;
    idArticuloStock: number;
    idUnidadMedida: number;    
    idMarca: number;
    modelo: string;
    idEstCom: number;
    idFlujo: number;
    idCuenta: number;
    impuestoIncluido: boolean;

    articuloStock: ArticuloStockInfo;
    impuestos: ImpuestoAsignacionZonaInfo[] = [];
    unidadMedida: UnidadMedidaInfo;

    constructor() {
        super();
        this.articuloStock = new ArticuloStockInfo();
        this.unidadMedida = new UnidadMedidaInfo();
    }
}

export class ArticuloItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;            
    activo: boolean;
    estatus?: string;
    selected?: boolean = false;
}

export class ArticuloImpuestoItem {
    id: number;
    idImpuesto: number;
    codigo: string;
    impuesto: string;
    idArticulo: number;
    tasa: number;
    cuota: number;
    ordenCalculo: number;
    tipoCalculo: string;

    constructor() {
        this.id = 0;
        this.idImpuesto = 0;
        this.codigo = '';
        this.impuesto = '';
        this.idArticulo = 0;
        this.tasa = 0;
        this.cuota = 0;
        this.ordenCalculo = 0;
        this.tipoCalculo = '';
    }
}