﻿import { DocumentDetail } from 'framework3/core';
import { ImpuestoDetailInfo } from '../../accounting';
import { DescuentosInfo } from './descuentos';
import { UnidadMedidaInfo } from '../../inventory';

export class VentaDetail extends DocumentDetail {		
    idArticulo: number;
    idServicio: number;
    idUnidadMedida: number;
    codigo: string;
	descripcion: string;
    cantidad: number;
    cantidadDevolucion: number;
    precioUnitario: number;    
    precioNeto: number;
    importe: number;
	idPromocion: number;
	porcComision: number;
	montoComision: number;
    idEstructuraComercial: number;
    
    descuentos: DescuentosInfo;
    impuestos: ImpuestoDetailInfo[];
    unidadMedida: UnidadMedidaInfo;

    constructor() {
        super();
        this.codigo = '';
        this.descripcion = '';
        this.cantidad = 0;
        this.precioUnitario = 0;
        this.descuentos = new DescuentosInfo();
        this.impuestos = [];
        this.unidadMedida = new UnidadMedidaInfo();
        this.idUnidadMedida = 0;        
    }
}