﻿import { DocumentInfo, DocumentItem } from 'framework3/core';
import { ImpuestoResumenInfo, DivisaInfo } from '../../accounting';
import { VentaDetail } from './venta-detail';
import { AlmacenInfo } from '../../inventory';
import { UnidadNegocioInfo } from './unidad-negocio';
import { ClienteInfo } from './cliente';


export class VentaInfo extends DocumentInfo<VentaDetail> {
	idReferencia: string;
	idCliente: number;
	idVendedor: number;
	idTerminal: number;
	condicionesPago: string;
	fechaPago: Date;
	idListaPrecio: number;
	observaciones: string;
	ordenCompra: string;
	totalCantidad: number;
	idDivisa: number;
	tipoCambio: number;
	subTotal: number;
	impuestosTrasladados: number;
	impuestosRetenidos: number;
	descuentos: number;
	flete: number;
	comision: number;
	total: number;
	idOrigen: number;
	idAlmacen: number;
	idSalida: string;
	fechaSalida: Date;
	idCuentaPorCobrarTit: string;
	fechaCuentaPorCobrar: Date;
    idUnidadNegocio: number;
    idCaja: number;

    impuestos: ImpuestoResumenInfo[] = [];
    almacen: AlmacenInfo;
    unidadNegocio: UnidadNegocioInfo;
    divisa: DivisaInfo;
    cliente: ClienteInfo;

    constructor() {
        super();
        this.idVendedor = 0;
        this.idTerminal = 0;
        this.condicionesPago = 'C';
        this.idListaPrecio = 0;
        this.observaciones = '';
        this.tipoCambio = 1;
        this.subTotal = 0;
        this.almacen = new AlmacenInfo();
        this.unidadNegocio = new UnidadNegocioInfo();
        this.divisa = new DivisaInfo();
        this.cliente = new ClienteInfo();
    }
}

export class VentaItem extends DocumentItem {
    id: string;
    nombre: string;
    codigoCliente: string;
    nombreCliente: string;
    total: number;
    condicionesPago: string;
    idDeudor: number;
}