﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, HierarchyInfo, HierarchyService } from 'framework3/core';
//Locales
import { EstructuraComercialInfo } from '../models/estructura-comercial';

@Injectable()
export class EstructuraComercialService extends HierarchyService<EstructuraComercialInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, "api/ventas/est-com");
    }

    create(): Promise<EstructuraComercialInfo> {
        return Promise.resolve(new EstructuraComercialInfo());
    }

	/*
	//Sample method
    sampleMethod(param1: number): Promise<EstructuraComercialInfo> {
        let params: URLSearchParams = new URLSearchParams();
        params.set('param1', param1.toString());
        return this.apiService.getData('sample-method', params)
            .map(response => response.json() as EstructuraComercialInfo)
            .toPromise();
    }
	*/

}
