﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { RegionInfo, RegionItem } from '../models/region'

@Injectable()
export class RegionService extends CatalogService<RegionInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/ventas/regiones');
    }

    create(): Promise<RegionInfo> {
        return Promise.resolve(new RegionInfo());
    }

    loadList(idEmpresa: number): Promise<RegionItem[]> {
        let params = new HttpParams()
            .set("idEmpresa", idEmpresa.toString());
        return this.apiService.get<RegionItem[]>("load-list", params)
            .toPromise();
    }

}

