﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { ZonaVentaInfo, ZonaVentaItem } from '../models/zona-venta'

@Injectable()
export class ZonaVentaService extends CatalogService<ZonaVentaInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/ventas/zonasventa');
    }

    create(): Promise<ZonaVentaInfo> {
        return Promise.resolve(new ZonaVentaInfo());
    }

    loadList(idEmpresa: string): Promise<ZonaVentaItem[]> {
        let params = new HttpParams()
            .set("idEmpresa", idEmpresa);
        return this.apiService.get<ZonaVentaItem[]>("load-list", params)
            .toPromise();
    }

}

