﻿import { Context, CatalogInfo, CatalogItem, TrackableItem } from 'framework3/core';

export class DatasetInfo extends CatalogInfo {
	nombre: string;
	idDriver: number;
	allowSentence: boolean;
	sentence: string;

    parameters: ParameterItem[];
    fields: FieldItem[];

    constructor() {
        super();
        this.parameters = [];
        this.fields = [];
    }
}

export class DatasetItem implements CatalogItem {

    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
	selected?:boolean = false;
}

export class ParameterItem extends TrackableItem {

    field: string;
    label: string;
    defaultValue: string;
    regexp: string;
    hidden: boolean;
    type: string;
    value: string;

    constructor() {
        super();
    }

}

export class FieldItem extends TrackableItem {

    name: string;
    field: string;
    defaultValue: string;
    orderColumn: number;
    startRow: number;
    type: string;

    constructor() {
        super();
    }
}
