﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { TranspilerInfo, TranspilerHistItem } from '../models/transpiler'

@Injectable()
export class TranspilerService extends CatalogService<TranspilerInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/translator/transpilers');
    }

    create(): Promise<TranspilerInfo> {
        return Promise.resolve(new TranspilerInfo());
    }

    getLastHist(referencia: string): Promise<TranspilerHistItem> {
        let params = new HttpParams()
            .set('referencia', referencia);
        //
        return this.apiService.get<TranspilerHistItem>('get-last-hist', params)
            .toPromise();
    }
}

