﻿import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
//Modulos Azteca
import { CoreModule } from 'framework3/core';
import { EditorsModule } from 'framework3/editors';
import { SearchModule } from 'framework3/search';
import { GeneralModule } from 'framework3/general';
import { ControlsModule } from 'framework3/controls';
import { SecurityModule } from 'framework3/security';

import { TranslatorRoutingModule } from './translator.routing';

//Bootstrap
import { TabsModule, ModalModule } from 'ngx-bootstrap';
//Wijmo
import { WjCoreModule } from 'wijmo/wijmo.angular2.core';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';

/////////////////////////////// Servicios ////////////////////////////
import { DatasetService } from './services/dataset.service';
import { TranspilerService } from './services/transpiler.service';

//////////////////////////// Catalogos ////////////////////////////////
import { DatasetsEditor } from './catalogs/datasets.editor';
import { DatasetsManager } from './catalogs/datasets.manager';

import { TranspilersEditor } from './catalogs/transpilers.editor';
import { TranspilersManager } from './catalogs/transpilers.manager';

//////////////////////////// Componentes /////////////////////////////
import { DatasetSelectorComponent } from './components/datasets-selector.component';
import { TranspilerSelectorComponent } from './components/transpiler-selector.component';

/////////////////////////////////////////////////////////////////////////////////
let COMPONENTES = [
    DatasetsEditor, DatasetsManager, DatasetSelectorComponent, TranspilersEditor, TranspilersManager, TranspilerSelectorComponent
];

let SERVICIOS = [
    DatasetService, TranspilerService
];

@NgModule({
    imports: [
        CommonModule, FormsModule, ReactiveFormsModule,
        TabsModule.forRoot(), ModalModule.forRoot(),
        CoreModule, EditorsModule, SearchModule, GeneralModule, ControlsModule, SecurityModule, WjCoreModule, WjInputModule,
        WjGridModule, WjGridFilterModule, TranslatorRoutingModule
    ],
    declarations: COMPONENTES,
    providers: SERVICIOS,
    exports: COMPONENTES
})
export class TranslatorModule {

}
