﻿import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

//////////////////////////// Guards //////////////////////////////////
import { AuthGuard } from 'framework3/core';
import { EditorDeactivateGuard } from 'framework3/editors';

//////////////////////////// Catalogos ////////////////////////////////
import { DatasetsEditor } from './catalogs/datasets.editor';
import { DatasetsManager } from './catalogs/datasets.manager';
import { TranspilersEditor } from './catalogs/transpilers.editor';
import { TranspilersManager } from './catalogs/transpilers.manager';



const routes: Routes = [
    {
        path: '',
        canActivateChild: [AuthGuard],
        children: [
            { path: 'datasets/:proceso', component: DatasetsManager },
            { path: 'datasets/:proceso/:id', component: DatasetsEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'transpiler/:proceso', component: TranspilersManager },
            { path: 'transpiler/:proceso/:id', component: TranspilersEditor, canDeactivate: [EditorDeactivateGuard] }
        ]
    },
];

@NgModule({
    imports: [
        RouterModule.forChild(routes)
    ],
    exports: [
        RouterModule
    ]
})
export class TranslatorRoutingModule {

}