﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { BeneficiarioInfo, BeneficiarioItem } from '../models/beneficiario'

@Injectable()
export class BeneficiarioService extends CatalogService<BeneficiarioInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/tesoreria/beneficiarios');
    }

    create(): Promise<BeneficiarioInfo> {
        return Promise.resolve(new BeneficiarioInfo());
    }

    searchKeywordBeneficiarios(idBranch: number, keyword: string): Observable<BeneficiarioItem[]> {
        let params: HttpParams = new HttpParams()
            .set('idBranch', idBranch.toString())
            .set('keyword', keyword);
        return this.apiService.get<BeneficiarioItem[]>('search-keyword', params)

    }


	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<BeneficiarioInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<BeneficiarioInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

