﻿//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpRequest, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from 'framework3/core';
//Locales
import { PagoTipoInfo, PagoTipoItem } from '../models/pago-tipo'

@Injectable()
export class PagoTipoService extends CatalogService<PagoTipoInfo>{

    constructor(http: HttpClient, context: Context) {
        super(http, context, 'api/tesoreria/pagos-tipo');
    }

    create(): Promise<PagoTipoInfo> {
        return Promise.resolve(new PagoTipoInfo());
    }

    loadList(idSucursal: number): Promise<PagoTipoItem[] > {
        let params: HttpParams = new HttpParams()
            .set('idSucursal', idSucursal.toString());
        return this.apiService.get<PagoTipoItem[]>('load-list', params)
            .toPromise();
    }


	/*
	//Sample method
    sampleMethod(param1: number, param2: string): Promise<PagoTipoInfo> {
        let params = new HttpParams()
			.set('param1', param1.toString())
			.set('param2', param2);
		//
        return this.apiService.get<PagoTipoInfo>('sample-method', params)
            .toPromise();
    }
	*/
}

