﻿import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

import { FormsModule, ReactiveFormsModule } from '@angular/forms';
//Modulos Azteca
import { CoreModule } from 'framework3/core';
import { EditorsModule } from 'framework3/editors';
import { SearchModule } from 'framework3/search';
import { GeneralModule } from 'framework3/general';
import { ControlsModule } from 'framework3/controls';
import { SecurityModule } from 'framework3/security';

import { TreasuryRoutingModule } from './treasury.routing.module';
import { AccountingModule } from '../accounting/accounting.module';

import { TranslatorModule } from '../translator/index';

//Bootstrap
import { TabsModule, ModalModule } from 'ngx-bootstrap';
//Wijmo
import { WjCoreModule } from 'wijmo/wijmo.angular2.core';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';

////////////////////////////// Controls /////////////////////////////
//import { GrupoBeneficiariosSelectorComponent } from './controls/grupo-beneficiarios-selector.component';

///////////////////////////////// Servicios ////////////////////////////
//import { BeneficiarioService } from './services/beneficiario.service';
//import { GrupoBeneficiariosService } from './services/grupo-beneficiarios.service';
//import { CajaService } from './services/caja.service';

////////////////////////////// Catalogos ////////////////////////////////
//import { BeneficiariosManager } from './catalogs/beneficiarios.manager';
//import { BeneficiariosEditor } from './catalogs/beneficiarios.editor';
//import { GruposBeneficiarioManager } from './catalogs/grupos-beneficiario.manager';
//import { GruposBeneficiarioEditor } from './catalogs/grupos-beneficiario.editor';
//import { CajasManager } from './catalogs/cajas.manager';
//import { CajasEditor } from './catalogs/cajas.editor';



///////////////////////////// Servicios //////////////////////////////
import * as fromServices from './services';
const SERVICIOS = Object.keys(fromServices).map(key => fromServices[key]);

///////////////////////////// Catalogos //////////////////////////////
import * as fromCatalogs from './catalogs';
const CATALOGOS = Object.keys(fromCatalogs).map(key => fromCatalogs[key]);

///////////////////////////// Controls //////////////////////////////
import * as fromControls from './controls';
const CONTROLS = Object.keys(fromControls).map(key => fromControls[key]);

///////////////////////////// Dialogs //////////////////////////////
import * as fromDialogs from './dialogs';
const DIALOGS = Object.keys(fromDialogs).map(key => fromDialogs[key]);

//////////////////////////// Componentes /////////////////////////////


///////////////////////////// Document /////////////////////////////////
import * as fromDocuments from './documents';
const DOCUMENTS = Object.keys(fromDocuments).map(key => fromDocuments[key]);

///////////////////////////// Document Part /////////////////////////////////
import * as fromDocumentsPart from './documents/parts';
const DOCUMENTS_PARTS = Object.keys(fromDocumentsPart).map(key => fromDocumentsPart[key]);

//////////////////////////// Parts /////////////////////////////////////
import * as fromParts from './parts';
const PARTS = Object.keys(fromParts).map(key => fromParts[key]);

const COMPONENTES = [...CATALOGOS, ...CONTROLS, ...DIALOGS, ...DOCUMENTS_PARTS, ...DOCUMENTS, ...PARTS]

@NgModule({
    imports: [
        CommonModule, FormsModule, ReactiveFormsModule,
        TabsModule.forRoot(), ModalModule.forRoot(),
        CoreModule, EditorsModule, SearchModule, GeneralModule, ControlsModule, SecurityModule, WjCoreModule, WjInputModule,
        WjGridModule, WjGridFilterModule, TreasuryRoutingModule, AccountingModule, TranslatorModule
    ],
    declarations: COMPONENTES,
    providers: SERVICIOS,
    exports: COMPONENTES
})

export class TreasuryModule {

}
