"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var poliza_1 = require("../models/poliza");
var poliza_detail_1 = require("../models/poliza-detail");
var poliza_service_1 = require("../services/poliza.service");
var polizas_detail_editor_1 = require("./parts/polizas-detail.editor");
var poliza_tipo_1 = require("../models/poliza-tipo");
var divisa_service_1 = require("../services/divisa.service");
var polizas_asociaciones_component_1 = require("./parts/polizas-asociaciones.component");
var PolizasEditor = /** @class */ (function (_super) {
    __extends(PolizasEditor, _super);
    function PolizasEditor(context, router, route, location, formBuilder, documentTypeService, polizaService, divisaService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.polizaService = polizaService;
        _this.divisaService = divisaService;
        _this.poliza = new poliza_1.PolizaInfo();
        _this.polizaT = new poliza_tipo_1.PolizaTipo();
        //
        _this.divisas = [];
        _this.polizasPerfiles = [];
        _this.polizasTipos = [];
        _this.documentForm = formBuilder.group({
            'concepto': [''],
            'divisa': [''],
            'idPolizaPerfil': [0],
            'afectacion': ['', forms_1.Validators.required],
            'cargos': [''],
            'abonos': [''],
            'idPolizaType': [''],
        });
        return _this;
    }
    PolizasEditor_1 = PolizasEditor;
    PolizasEditor.prototype.validatePerfil = function (identity, control) {
        if (identity != "")
            return null;
        else
            return 'Asigne el perfil';
    };
    PolizasEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
        this.loadPerfilesManuales();
        this.loadPolizaTipo();
    };
    PolizasEditor.prototype.onCreatingDocument = function () {
        var _this = this;
        this.polizaService.create().then(function (doc) {
            _this.poliza = doc;
            _this.poliza.idSucursal = _this.context.app.defaultSite.identity;
            console.log("Creandon documebti");
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PolizasEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.polizaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.poliza = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PolizasEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.polizaService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.poliza = doc;
            _this.detailsEditor.clientIndexStart = _this.poliza.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PolizasEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.polizaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.poliza = doc;
            _this.detailsEditor.clientIndexStart = _this.poliza.details.length;
            if (_this.poliza.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
            _this.sumarizacion();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PolizasEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.poliza.idPolizaTipo = this.polizaT.idPolizaTipo;
        this.context.app.showSpinner();
        if (this.poliza.idDivisa == 0 || this.poliza.idDivisa == undefined)
            this.poliza.idDivisa = 100;
        if (this.polizaT.idPolizaTipo == 0 || this.polizaT.idPolizaTipo == undefined) {
            this.context.app.hideSpinner();
            this.showAlert("No se ha seleccionado un tipo de poliza", 'danger');
        }
        if (this.poliza.idPolizaOrigen == 0 || this.poliza.idPolizaOrigen == undefined)
            this.poliza.idPolizaOrigen = 1; //Manual
        if (this.poliza.idPolizaPerfil == 0 || this.poliza.idPolizaPerfil == undefined) {
            this.context.app.hideSpinner();
            this.showAlert("No se ha establecido el perfil de poliza", 'danger');
        }
        else
            this.polizaService.update(this.poliza)
                .then(function (updatedDoc) {
                _this.context.app.hideSpinner();
                //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
                _this.reset();
                if (!args.closeEditor && _this.poliza.identity == '') {
                    _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
                }
                else {
                    if (args.closeEditor)
                        _this.router.navigate(['../'], { relativeTo: _this.route });
                    else
                        _this.showAlert('La información ha sido actualizada con éxito', 'success');
                }
                _this.poliza = updatedDoc;
            })
                .catch(function (error) { return _this.handleError(error); });
    };
    PolizasEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.polizaService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PolizasEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.polizaService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PolizasEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.poliza.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    PolizasEditor.prototype.onAddingDetail = function () {
        //let updatedDetails: PolizaDetail[]
        //updatedDetails = this.poliza.details;        
        //let detail: PolizaDetail = new PolizaDetail();        
        //this.poliza.details.push(detail)
        //this.poliza.details = updatedDetails;
        this.detailsEditor.detail = new poliza_detail_1.PolizaDetail();
        this.detailsEditor.detail.consecutivo = this.poliza.details.length + 1;
        this.detailsEditor.show();
    };
    PolizasEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    PolizasEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    PolizasEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.poliza.details = updatedDetails;
        this.sumarizacion();
    };
    PolizasEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    PolizasEditor.prototype.sumarizacion = function () {
        var _this = this;
        this.cargos = 0;
        this.abonos = 0;
        this.poliza.details.forEach(function (detail) {
            if (detail.afectador == "C")
                _this.cargos += detail.importe;
            else
                _this.abonos += detail.importe;
        });
    };
    PolizasEditor.prototype.onMenuItemClick = function (item) {
        if (item.name == "ASOC") {
            var itemDetail = this.detailsList.currentItem;
            this.dlgAsociaciones.show(this.poliza.identity, this.poliza.fechaSys, itemDetail.idCuenta, itemDetail.consecutivo);
        }
    };
    PolizasEditor.prototype.loadPerfilesManuales = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.polizaService.loadPerfiles(this.context.app.defaultSite.identity, this.context.session.user.identity)
            .then(function (items) {
            _this.context.app.hideSpinner();
            _this.polizasPerfiles = items.filter(function (filter) { return filter.modalidad == 'M'; });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PolizasEditor.prototype.loadPolizaTipo = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.polizaService.loadPolizaTipo()
            .then(function (result) {
            _this.context.app.hideSpinner();
            _this.polizasTipos = result;
        });
    };
    var PolizasEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], PolizasEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", polizas_detail_editor_1.PolizaDetailEditor)
    ], PolizasEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild('dlgAsociaciones'),
        __metadata("design:type", polizas_asociaciones_component_1.PolizasAsociacionesComponent)
    ], PolizasEditor.prototype, "dlgAsociaciones", void 0);
    PolizasEditor = PolizasEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-polizas-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'Editor de Poliza'\"\n                                         [document]=\"poliza\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-5 col-md-3\">\n                                      <azteca-form-field [label]=\"'Fecha Afectaci\u00F3n:'\">\n                                          <az-input-date formControlName=\"afectacion\" [(ngModel)]=\"poliza.fechaAfectacion\"></az-input-date>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-5 col-md-3\">\n                                      <azteca-form-field [label]=\"'Divisa:'\">\n                                          <accounting-divisas-selector formControlName=\"divisa\" [(ngModel)]=\"poliza.idDivisa\"></accounting-divisas-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Perfil Manual:'\" *ngIf=\"poliza.identity==''\">\n                                          <az-combobox formControlName=\"idPolizaPerfil\"\n                                                       [(ngModel)]=\"poliza.idPolizaPerfil\"\n                                                       [items]=\"polizasPerfiles\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                              <!------------------- Pruebas --------------------->\n                              <div class=\"row\">\n                                  <div class=\"col-6 col-md-6\">\n                                      <azteca-form-field [label]=\"'Tipo Poliza:'\" >\n                                          <az-combobox formControlName=\"idPolizaType\"\n                                                       [(ngModel)]=\"polizaT.idPolizaTipo\"\n                                                       [items]=\"polizasTipos\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Concepto:'\">\n                                          <az-textbox formControlName=\"concepto\" [(ngModel)]=\"poliza.concepto\"></az-textbox>\n                                       </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-5 col-md-3\">\n                                      <azteca-form-field [label]=\"'Cargos:'\">\n                                          <az-input-number formControlName=\"cargos\" [(ngModel)]=\"cargos\" format=\"N2\" [enabled]=\"false\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-5 col-md-3\">\n                                      <azteca-form-field [label]=\"'Abonos:'\">\n                                          <az-input-number formControlName=\"abonos\" [(ngModel)]=\"abonos\" format=\"N2\" [enabled]=\"false\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <azteca-editable-list #detailsList\n                                                    (addingItem)=\"onAddingDetail()\"\n                                                    (editingItem)=\"onEditingDetail($event)\"\n                                                    (deletingItem)=\"onDeletingDetail($event)\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    [listItems]=\"poliza.details\"\n                                                    (menuItemClick)=\"onMenuItemClick($event)\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'ASOC'\" [icon]=\"'glyphicon glyphicon-list'\" [text]=\"'Asociaciones'\" [smallText]=\"'comprobantes asociados'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'Cuenta'\" [binding]=\"'cuentaText'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'conceptoText'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Concepto'\" [binding]=\"'notas'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Afectador'\" [binding]=\"'afectadorText'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Segmento'\" [binding]=\"'segmentoNegocioText'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Referencia'\" [binding]=\"'referencia'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                              </azteca-editable-list>\n                          </tab>\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <contabilidad-poliza-detail-editor #detailsEditor                                     \n                                           (savingItem)=\"onSavingDetail($event)\">\n\n      </contabilidad-poliza-detail-editor>\n\n      <accounting-polizas-asociaciones-component #dlgAsociaciones [idPoliza]=\"idPolizaCurrent\" [idCuenta]=\"0\">\n\n      </accounting-polizas-asociaciones-component>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return PolizasEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: poliza_service_1.PolizaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            poliza_service_1.PolizaService,
            divisa_service_1.DivisaService])
    ], PolizasEditor);
    return PolizasEditor;
}(editors_1.DocumentEditor));
exports.PolizasEditor = PolizasEditor;
